#include "tree_sitter/parser.h"

#if defined(__GNUC__) || defined(__clang__)
#pragma GCC diagnostic ignored "-Wmissing-field-initializers"
#endif

#ifdef _MSC_VER
#pragma optimize("", off)
#elif defined(__clang__)
#pragma clang optimize off
#elif defined(__GNUC__)
#pragma GCC optimize ("O0")
#endif

#define LANGUAGE_VERSION 14
#define STATE_COUNT 7125
#define LARGE_STATE_COUNT 1345
#define SYMBOL_COUNT 247
#define ALIAS_COUNT 14
#define TOKEN_COUNT 95
#define EXTERNAL_TOKEN_COUNT 21
#define FIELD_COUNT 5
#define MAX_ALIAS_SEQUENCE_LENGTH 11
#define PRODUCTION_ID_COUNT 50

enum ts_symbol_identifiers {
  anon_sym_DASH_GT = 1,
  anon_sym_LPAREN_RPAREN = 2,
  sym_nat = 3,
  sym_int = 4,
  sym_float = 5,
  anon_sym_DQUOTE = 6,
  aux_sym_literal_text_token1 = 7,
  aux_sym_literal_text_token2 = 8,
  aux_sym_literal_text_token3 = 9,
  anon_sym_DQUOTE_DQUOTE_DQUOTE = 10,
  aux_sym_literal_char_token1 = 11,
  aux_sym_literal_char_token2 = 12,
  anon_sym_true = 13,
  anon_sym_false = 14,
  sym_literal_byte = 15,
  sym_literal_hex = 16,
  anon_sym_LPAREN = 17,
  anon_sym_COMMA = 18,
  anon_sym_RPAREN = 19,
  anon_sym_SEMI = 20,
  anon_sym_PLUS_PLUS = 21,
  anon_sym_PLUS_COLON = 22,
  anon_sym_COLON_PLUS = 23,
  anon_sym_AT = 24,
  anon_sym_LBRACK = 25,
  anon_sym_RBRACK = 26,
  anon_sym_LBRACE = 27,
  anon_sym_RBRACE = 28,
  anon_sym__ = 29,
  anon_sym_if = 30,
  anon_sym_then = 31,
  anon_sym_else = 32,
  anon_sym_SQUOTE = 33,
  anon_sym_BANG = 34,
  anon_sym_DOT = 35,
  sym_type_argument = 36,
  anon_sym_COLON = 37,
  aux_sym_immediate_hash_token1 = 38,
  anon_sym_use = 39,
  sym_do = 40,
  sym_kw_let = 41,
  sym_type_kw = 42,
  sym_pipe = 43,
  sym_match = 44,
  sym_cases = 45,
  sym_otherwise = 46,
  sym_structural = 47,
  sym_unique = 48,
  sym_ability = 49,
  sym_where = 50,
  sym_or = 51,
  sym_and = 52,
  anon_sym_forall = 53,
  anon_sym_u2200 = 54,
  sym_kw_equals = 55,
  sym_kw_termlink = 56,
  sym_kw_typelink = 57,
  sym_handle = 58,
  sym_with = 59,
  sym_rewrite = 60,
  sym_term = 61,
  sym_case = 62,
  sym_signature = 63,
  sym_rewrite_arrow = 64,
  aux_sym_wordy_id_token1 = 65,
  sym_imm_wordy_id = 66,
  sym_symboly_id = 67,
  sym_imm_symboly_id = 68,
  sym_path = 69,
  aux_sym_hash_qualifier_token1 = 70,
  sym_built_in_hash = 71,
  anon_sym_test_GT = 72,
  anon_sym_test_DOTio_GT = 73,
  sym__layout_semicolon = 74,
  sym__layout_start = 75,
  sym__layout_end = 76,
  sym__dot = 77,
  sym__where = 78,
  sym__varsym = 79,
  sym_comment = 80,
  sym_fold = 81,
  sym__comma = 82,
  sym__in = 83,
  sym__indent = 84,
  sym__empty = 85,
  sym_DEPRECATED_operator = 86,
  sym__parenthesized_operator = 87,
  sym__watch_start = 88,
  sym__start_before_arrow = 89,
  sym_hash_cid = 90,
  sym_doc_block = 91,
  sym__guard_layout_start = 92,
  sym__destructuring_bind_start = 93,
  sym_DUMMY = 94,
  sym_unison = 95,
  sym__statement = 96,
  sym_term_definition2 = 97,
  sym___block = 98,
  sym___layout_block = 99,
  sym_binding = 100,
  sym__binding = 101,
  sym_destructuring_bind = 102,
  sym__block_term = 103,
  sym_literal_function = 104,
  sym_literal_function2 = 105,
  sym__term = 106,
  sym__term2 = 107,
  sym__term3 = 108,
  aux_sym__term4 = 109,
  sym__infix_app_or_boolean_op = 110,
  sym__generic_infix_app = 111,
  sym__infix = 112,
  sym_unit = 113,
  sym_literal_text = 114,
  sym_literal_char = 115,
  sym_literal_boolean = 116,
  sym_tuple_or_parenthesized = 117,
  sym_literal_termlink = 118,
  sym_literal_typelink = 119,
  sym__lhs = 120,
  sym__infix_lhs = 121,
  sym__prefix_lhs = 122,
  sym__pattern_matching = 123,
  sym__match_with = 124,
  sym__lam_case = 125,
  sym__match_cases = 126,
  sym_pattern = 127,
  sym__pattern_rhs = 128,
  sym__literal_pattern = 129,
  sym_guard = 130,
  sym_guarded_block = 131,
  sym__pattern_root = 132,
  sym__pattern_infix_app = 133,
  sym__pattern_constructor = 134,
  sym__pattern_candidates = 135,
  sym_var_or_as = 136,
  sym_literal_list_pattern = 137,
  sym_parenthesized_or_tuple_pattern = 138,
  sym_effect_pure = 139,
  sym_effect_bind = 140,
  sym_effect_pattern = 141,
  sym__pattern_leaf = 142,
  sym_kw_if = 143,
  sym_kw_then = 144,
  sym_kw_else = 145,
  sym_delay_quote = 146,
  sym_delay_block = 147,
  sym_bang = 148,
  sym__number = 149,
  sym__link = 150,
  sym__term_leaf = 151,
  sym_literal_list = 152,
  sym__keyword_block = 153,
  sym_exp_if = 154,
  sym_force = 155,
  sym__block = 156,
  sym_exp_let = 157,
  sym_handler = 158,
  sym_rewrite_block = 159,
  sym__rewrite_type = 160,
  sym__rewrite_term_like = 161,
  sym_rewrite_term = 162,
  sym_rewrite_case = 163,
  sym_rewrite_type = 164,
  sym_type_signature = 165,
  sym_type_declaration = 166,
  sym_type_name = 167,
  sym_type_constructor = 168,
  sym__type_lhs = 169,
  sym__type_rhs = 170,
  sym_record = 171,
  sym_record_field = 172,
  sym__record_fields_inline = 173,
  sym__record_fields_block = 174,
  sym__effect_inline = 175,
  sym__effect_list = 176,
  sym_forall = 177,
  sym__value_type = 178,
  sym_tuple_or_parenthesized_type = 179,
  sym__value_type_leaf = 180,
  sym__type_atom = 181,
  sym_sequence_type = 182,
  sym__type1 = 183,
  sym__type2a = 184,
  sym__type2 = 185,
  sym_delayed = 186,
  sym_arrow_symbol = 187,
  sym__effect = 188,
  sym__computation_type = 189,
  sym__arrow = 190,
  sym__ebody = 191,
  sym_constructor = 192,
  sym_effect_declaration = 193,
  sym_use = 194,
  sym_use_clause = 195,
  sym_kw_forall = 196,
  sym_type_signature_colon = 197,
  sym_open_parens = 198,
  sym_close_parens = 199,
  sym_wordy_id = 200,
  sym__identifier = 201,
  sym_hash_qualifier = 202,
  sym_imm_hash_qualifier = 203,
  sym__hash_qualified = 204,
  sym__hq_qualified_wordy_id = 205,
  sym__hq_qualified_symboly_id = 206,
  sym__hq_qualified_prefix_term = 207,
  sym__hq_qualified_infix_term = 208,
  sym__prefix_definition_name = 209,
  sym__wordy_definition_name = 210,
  sym__symboly_definition_name = 211,
  sym__watch_expression = 212,
  sym_watch_expression = 213,
  sym_test_watch_expression = 214,
  aux_sym_unison_repeat1 = 215,
  aux_sym___block_repeat1 = 216,
  aux_sym___block_repeat2 = 217,
  aux_sym___layout_block_repeat1 = 218,
  aux_sym__infix_app_or_boolean_op_repeat1 = 219,
  aux_sym_literal_text_repeat1 = 220,
  aux_sym_literal_text_repeat2 = 221,
  aux_sym_tuple_or_parenthesized_repeat1 = 222,
  aux_sym__prefix_lhs_repeat1 = 223,
  aux_sym__match_cases_repeat1 = 224,
  aux_sym__pattern_rhs_repeat1 = 225,
  aux_sym_guarded_block_repeat1 = 226,
  aux_sym_guarded_block_repeat2 = 227,
  aux_sym__pattern_root_repeat1 = 228,
  aux_sym__pattern_constructor_repeat1 = 229,
  aux_sym_literal_list_pattern_repeat1 = 230,
  aux_sym_parenthesized_or_tuple_pattern_repeat1 = 231,
  aux_sym_effect_bind_repeat1 = 232,
  aux_sym_rewrite_block_repeat1 = 233,
  aux_sym_rewrite_type_repeat1 = 234,
  aux_sym_type_constructor_repeat1 = 235,
  aux_sym__type_rhs_repeat1 = 236,
  aux_sym__record_fields_inline_repeat1 = 237,
  aux_sym__record_fields_block_repeat1 = 238,
  aux_sym__effect_block_repeat1 = 239,
  aux_sym_forall_repeat1 = 240,
  aux_sym_tuple_or_parenthesized_type_repeat1 = 241,
  aux_sym__type2_repeat1 = 242,
  aux_sym__ebody_repeat1 = 243,
  aux_sym__ebody_repeat2 = 244,
  aux_sym__ebody_repeat3 = 245,
  aux_sym_use_clause_repeat1 = 246,
  alias_sym_ability_name = 247,
  alias_sym_at_token = 248,
  alias_sym_close_bracket = 249,
  alias_sym_colon = 250,
  alias_sym_comma = 251,
  alias_sym_constructor_name = 252,
  alias_sym_ctor = 253,
  alias_sym_dot = 254,
  alias_sym_effect = 255,
  alias_sym_field_name = 256,
  alias_sym_namespace = 257,
  alias_sym_open_bracket = 258,
  alias_sym_term_type = 259,
  alias_sym_var_or_nullary_ctor = 260,
};

static const char * const ts_symbol_names[] = {
  [ts_builtin_sym_end] = "end",
  [anon_sym_DASH_GT] = "->",
  [anon_sym_LPAREN_RPAREN] = "()",
  [sym_nat] = "nat",
  [sym_int] = "int",
  [sym_float] = "float",
  [anon_sym_DQUOTE] = "\"",
  [aux_sym_literal_text_token1] = "literal_text_token1",
  [aux_sym_literal_text_token2] = "literal_text_token2",
  [aux_sym_literal_text_token3] = "literal_text_token3",
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = "\"\"\"",
  [aux_sym_literal_char_token1] = "literal_char_token1",
  [aux_sym_literal_char_token2] = "literal_char_token2",
  [anon_sym_true] = "true",
  [anon_sym_false] = "false",
  [sym_literal_byte] = "literal_byte",
  [sym_literal_hex] = "literal_hex",
  [anon_sym_LPAREN] = "(",
  [anon_sym_COMMA] = ",",
  [anon_sym_RPAREN] = ")",
  [anon_sym_SEMI] = ";",
  [anon_sym_PLUS_PLUS] = "concat",
  [anon_sym_PLUS_COLON] = "cons",
  [anon_sym_COLON_PLUS] = "snoc",
  [anon_sym_AT] = "@",
  [anon_sym_LBRACK] = "[",
  [anon_sym_RBRACK] = "]",
  [anon_sym_LBRACE] = "{",
  [anon_sym_RBRACE] = "}",
  [anon_sym__] = "blank_pattern",
  [anon_sym_if] = "if",
  [anon_sym_then] = "then",
  [anon_sym_else] = "else",
  [anon_sym_SQUOTE] = "'",
  [anon_sym_BANG] = "!",
  [anon_sym_DOT] = ".",
  [sym_type_argument] = "type_argument",
  [anon_sym_COLON] = ":",
  [aux_sym_immediate_hash_token1] = "immediate_hash_token1",
  [anon_sym_use] = "use",
  [sym_do] = "do",
  [sym_kw_let] = "kw_let",
  [sym_type_kw] = "type_kw",
  [sym_pipe] = "pipe",
  [sym_match] = "match",
  [sym_cases] = "cases",
  [sym_otherwise] = "otherwise",
  [sym_structural] = "structural",
  [sym_unique] = "unique",
  [sym_ability] = "ability",
  [sym_where] = "where",
  [sym_or] = "or",
  [sym_and] = "and",
  [anon_sym_forall] = "forall",
  [anon_sym_u2200] = "\u2200",
  [sym_kw_equals] = "kw_equals",
  [sym_kw_termlink] = "kw_termlink",
  [sym_kw_typelink] = "kw_typelink",
  [sym_handle] = "handle",
  [sym_with] = "with",
  [sym_rewrite] = "rewrite",
  [sym_term] = "term",
  [sym_case] = "case",
  [sym_signature] = "signature",
  [sym_rewrite_arrow] = "rewrite_arrow",
  [aux_sym_wordy_id_token1] = "wordy_id_token1",
  [sym_imm_wordy_id] = "regular_identifier",
  [sym_symboly_id] = "operator",
  [sym_imm_symboly_id] = "operator",
  [sym_path] = "path",
  [aux_sym_hash_qualifier_token1] = "hash_prefix",
  [sym_built_in_hash] = "built_in_hash",
  [anon_sym_test_GT] = "test>",
  [anon_sym_test_DOTio_GT] = "test.io>",
  [sym__layout_semicolon] = "_layout_semicolon",
  [sym__layout_start] = "_layout_start",
  [sym__layout_end] = "_layout_end",
  [sym__dot] = "cyclic_index",
  [sym__where] = "_where",
  [sym__varsym] = "_varsym",
  [sym_comment] = "comment",
  [sym_fold] = "fold",
  [sym__comma] = "_comma",
  [sym__in] = "_in",
  [sym__indent] = "_indent",
  [sym__empty] = "_empty",
  [sym_DEPRECATED_operator] = "DEPRECATED_operator",
  [sym__parenthesized_operator] = "prefix_operator",
  [sym__watch_start] = "_watch_start",
  [sym__start_before_arrow] = "_start_before_arrow",
  [sym_hash_cid] = "hash_cid",
  [sym_doc_block] = "doc_block",
  [sym__guard_layout_start] = "_guard_layout_start",
  [sym__destructuring_bind_start] = "_destructuring_bind_start",
  [sym_DUMMY] = "DUMMY",
  [sym_unison] = "unison",
  [sym__statement] = "_statement",
  [sym_term_definition2] = "term_definition",
  [sym___block] = "__block",
  [sym___layout_block] = "__layout_block",
  [sym_binding] = "term_declaration",
  [sym__binding] = "_binding",
  [sym_destructuring_bind] = "destructuring_bind",
  [sym__block_term] = "_block_term",
  [sym_literal_function] = "literal_function",
  [sym_literal_function2] = "literal_function",
  [sym__term] = "_term",
  [sym__term2] = "_term2",
  [sym__term3] = "_term3",
  [aux_sym__term4] = "_term4",
  [sym__infix_app_or_boolean_op] = "_infix_app_or_boolean_op",
  [sym__generic_infix_app] = "_generic_infix_app",
  [sym__infix] = "_infix",
  [sym_unit] = "unit",
  [sym_literal_text] = "literal_text",
  [sym_literal_char] = "literal_char",
  [sym_literal_boolean] = "literal_boolean",
  [sym_tuple_or_parenthesized] = "tuple_or_parenthesized",
  [sym_literal_termlink] = "literal_termlink",
  [sym_literal_typelink] = "literal_typelink",
  [sym__lhs] = "_lhs",
  [sym__infix_lhs] = "_infix_lhs",
  [sym__prefix_lhs] = "_prefix_lhs",
  [sym__pattern_matching] = "_pattern_matching",
  [sym__match_with] = "_match_with",
  [sym__lam_case] = "_lam_case",
  [sym__match_cases] = "_match_cases",
  [sym_pattern] = "pattern",
  [sym__pattern_rhs] = "_pattern_rhs",
  [sym__literal_pattern] = "_literal_pattern",
  [sym_guard] = "guard",
  [sym_guarded_block] = "guarded_block",
  [sym__pattern_root] = "_pattern_root",
  [sym__pattern_infix_app] = "_pattern_infix_app",
  [sym__pattern_constructor] = "_pattern_constructor",
  [sym__pattern_candidates] = "_pattern_candidates",
  [sym_var_or_as] = "var_or_as",
  [sym_literal_list_pattern] = "literal_list_pattern",
  [sym_parenthesized_or_tuple_pattern] = "parenthesized_or_tuple_pattern",
  [sym_effect_pure] = "effect_pure",
  [sym_effect_bind] = "effect_bind",
  [sym_effect_pattern] = "effect_pattern",
  [sym__pattern_leaf] = "_pattern_leaf",
  [sym_kw_if] = "kw_if",
  [sym_kw_then] = "kw_then",
  [sym_kw_else] = "kw_else",
  [sym_delay_quote] = "delay_quote",
  [sym_delay_block] = "delay_block",
  [sym_bang] = "bang",
  [sym__number] = "_number",
  [sym__link] = "_link",
  [sym__term_leaf] = "_term_leaf",
  [sym_literal_list] = "literal_list",
  [sym__keyword_block] = "_keyword_block",
  [sym_exp_if] = "exp_if",
  [sym_force] = "force",
  [sym__block] = "_block",
  [sym_exp_let] = "exp_let",
  [sym_handler] = "handler",
  [sym_rewrite_block] = "rewrite_block",
  [sym__rewrite_type] = "_rewrite_type",
  [sym__rewrite_term_like] = "_rewrite_term_like",
  [sym_rewrite_term] = "rewrite_term",
  [sym_rewrite_case] = "rewrite_case",
  [sym_rewrite_type] = "rewrite_type",
  [sym_type_signature] = "type_signature",
  [sym_type_declaration] = "type_declaration",
  [sym_type_name] = "type_name",
  [sym_type_constructor] = "type_constructor",
  [sym__type_lhs] = "_type_lhs",
  [sym__type_rhs] = "_type_rhs",
  [sym_record] = "record",
  [sym_record_field] = "record_field",
  [sym__record_fields_inline] = "_record_fields_inline",
  [sym__record_fields_block] = "_record_fields_block",
  [sym__effect_inline] = "_effect_inline",
  [sym__effect_list] = "_effect_list",
  [sym_forall] = "forall",
  [sym__value_type] = "_value_type",
  [sym_tuple_or_parenthesized_type] = "tuple_or_parenthesized_type",
  [sym__value_type_leaf] = "_value_type_leaf",
  [sym__type_atom] = "_type_atom",
  [sym_sequence_type] = "sequence_type",
  [sym__type1] = "_type1",
  [sym__type2a] = "_type2a",
  [sym__type2] = "_type2",
  [sym_delayed] = "delayed",
  [sym_arrow_symbol] = "arrow_symbol",
  [sym__effect] = "_effect",
  [sym__computation_type] = "_computation_type",
  [sym__arrow] = "_arrow",
  [sym__ebody] = "_ebody",
  [sym_constructor] = "constructor",
  [sym_effect_declaration] = "ability_declaration",
  [sym_use] = "use",
  [sym_use_clause] = "use_clause",
  [sym_kw_forall] = "kw_forall",
  [sym_type_signature_colon] = "type_signature_colon",
  [sym_open_parens] = "open_parens",
  [sym_close_parens] = "close_parens",
  [sym_wordy_id] = "regular_identifier",
  [sym__identifier] = "_identifier",
  [sym_hash_qualifier] = "hash_qualifier",
  [sym_imm_hash_qualifier] = "hash_qualifier",
  [sym__hash_qualified] = "_hash_qualified",
  [sym__hq_qualified_wordy_id] = "_hq_qualified_wordy_id",
  [sym__hq_qualified_symboly_id] = "_hq_qualified_symboly_id",
  [sym__hq_qualified_prefix_term] = "_hq_qualified_prefix_term",
  [sym__hq_qualified_infix_term] = "_hq_qualified_infix_term",
  [sym__prefix_definition_name] = "_prefix_definition_name",
  [sym__wordy_definition_name] = "_wordy_definition_name",
  [sym__symboly_definition_name] = "_symboly_definition_name",
  [sym__watch_expression] = "_watch_expression",
  [sym_watch_expression] = "watch_expression",
  [sym_test_watch_expression] = "test_watch_expression",
  [aux_sym_unison_repeat1] = "unison_repeat1",
  [aux_sym___block_repeat1] = "__block_repeat1",
  [aux_sym___block_repeat2] = "__block_repeat2",
  [aux_sym___layout_block_repeat1] = "__layout_block_repeat1",
  [aux_sym__infix_app_or_boolean_op_repeat1] = "_infix_app_or_boolean_op_repeat1",
  [aux_sym_literal_text_repeat1] = "literal_text_repeat1",
  [aux_sym_literal_text_repeat2] = "literal_text_repeat2",
  [aux_sym_tuple_or_parenthesized_repeat1] = "tuple_or_parenthesized_repeat1",
  [aux_sym__prefix_lhs_repeat1] = "_prefix_lhs_repeat1",
  [aux_sym__match_cases_repeat1] = "_match_cases_repeat1",
  [aux_sym__pattern_rhs_repeat1] = "_pattern_rhs_repeat1",
  [aux_sym_guarded_block_repeat1] = "guarded_block_repeat1",
  [aux_sym_guarded_block_repeat2] = "guarded_block_repeat2",
  [aux_sym__pattern_root_repeat1] = "_pattern_root_repeat1",
  [aux_sym__pattern_constructor_repeat1] = "_pattern_constructor_repeat1",
  [aux_sym_literal_list_pattern_repeat1] = "literal_list_pattern_repeat1",
  [aux_sym_parenthesized_or_tuple_pattern_repeat1] = "parenthesized_or_tuple_pattern_repeat1",
  [aux_sym_effect_bind_repeat1] = "effect_bind_repeat1",
  [aux_sym_rewrite_block_repeat1] = "rewrite_block_repeat1",
  [aux_sym_rewrite_type_repeat1] = "rewrite_type_repeat1",
  [aux_sym_type_constructor_repeat1] = "type_constructor_repeat1",
  [aux_sym__type_rhs_repeat1] = "_type_rhs_repeat1",
  [aux_sym__record_fields_inline_repeat1] = "_record_fields_inline_repeat1",
  [aux_sym__record_fields_block_repeat1] = "_record_fields_block_repeat1",
  [aux_sym__effect_block_repeat1] = "_effect_block_repeat1",
  [aux_sym_forall_repeat1] = "forall_repeat1",
  [aux_sym_tuple_or_parenthesized_type_repeat1] = "tuple_or_parenthesized_type_repeat1",
  [aux_sym__type2_repeat1] = "_type2_repeat1",
  [aux_sym__ebody_repeat1] = "_ebody_repeat1",
  [aux_sym__ebody_repeat2] = "_ebody_repeat2",
  [aux_sym__ebody_repeat3] = "_ebody_repeat3",
  [aux_sym_use_clause_repeat1] = "use_clause_repeat1",
  [alias_sym_ability_name] = "ability_name",
  [alias_sym_at_token] = "at_token",
  [alias_sym_close_bracket] = "close_bracket",
  [alias_sym_colon] = "colon",
  [alias_sym_comma] = "comma",
  [alias_sym_constructor_name] = "constructor_name",
  [alias_sym_ctor] = "ctor",
  [alias_sym_dot] = "dot",
  [alias_sym_effect] = "effect",
  [alias_sym_field_name] = "field_name",
  [alias_sym_namespace] = "namespace",
  [alias_sym_open_bracket] = "open_bracket",
  [alias_sym_term_type] = "term_type",
  [alias_sym_var_or_nullary_ctor] = "var_or_nullary_ctor",
};

static const TSSymbol ts_symbol_map[] = {
  [ts_builtin_sym_end] = ts_builtin_sym_end,
  [anon_sym_DASH_GT] = anon_sym_DASH_GT,
  [anon_sym_LPAREN_RPAREN] = anon_sym_LPAREN_RPAREN,
  [sym_nat] = sym_nat,
  [sym_int] = sym_int,
  [sym_float] = sym_float,
  [anon_sym_DQUOTE] = anon_sym_DQUOTE,
  [aux_sym_literal_text_token1] = aux_sym_literal_text_token1,
  [aux_sym_literal_text_token2] = aux_sym_literal_text_token2,
  [aux_sym_literal_text_token3] = aux_sym_literal_text_token3,
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = anon_sym_DQUOTE_DQUOTE_DQUOTE,
  [aux_sym_literal_char_token1] = aux_sym_literal_char_token1,
  [aux_sym_literal_char_token2] = aux_sym_literal_char_token2,
  [anon_sym_true] = anon_sym_true,
  [anon_sym_false] = anon_sym_false,
  [sym_literal_byte] = sym_literal_byte,
  [sym_literal_hex] = sym_literal_hex,
  [anon_sym_LPAREN] = anon_sym_LPAREN,
  [anon_sym_COMMA] = anon_sym_COMMA,
  [anon_sym_RPAREN] = anon_sym_RPAREN,
  [anon_sym_SEMI] = anon_sym_SEMI,
  [anon_sym_PLUS_PLUS] = anon_sym_PLUS_PLUS,
  [anon_sym_PLUS_COLON] = anon_sym_PLUS_COLON,
  [anon_sym_COLON_PLUS] = anon_sym_COLON_PLUS,
  [anon_sym_AT] = anon_sym_AT,
  [anon_sym_LBRACK] = anon_sym_LBRACK,
  [anon_sym_RBRACK] = anon_sym_RBRACK,
  [anon_sym_LBRACE] = anon_sym_LBRACE,
  [anon_sym_RBRACE] = anon_sym_RBRACE,
  [anon_sym__] = anon_sym__,
  [anon_sym_if] = anon_sym_if,
  [anon_sym_then] = anon_sym_then,
  [anon_sym_else] = anon_sym_else,
  [anon_sym_SQUOTE] = anon_sym_SQUOTE,
  [anon_sym_BANG] = anon_sym_BANG,
  [anon_sym_DOT] = anon_sym_DOT,
  [sym_type_argument] = sym_type_argument,
  [anon_sym_COLON] = anon_sym_COLON,
  [aux_sym_immediate_hash_token1] = aux_sym_immediate_hash_token1,
  [anon_sym_use] = anon_sym_use,
  [sym_do] = sym_do,
  [sym_kw_let] = sym_kw_let,
  [sym_type_kw] = sym_type_kw,
  [sym_pipe] = sym_pipe,
  [sym_match] = sym_match,
  [sym_cases] = sym_cases,
  [sym_otherwise] = sym_otherwise,
  [sym_structural] = sym_structural,
  [sym_unique] = sym_unique,
  [sym_ability] = sym_ability,
  [sym_where] = sym_where,
  [sym_or] = sym_or,
  [sym_and] = sym_and,
  [anon_sym_forall] = anon_sym_forall,
  [anon_sym_u2200] = anon_sym_u2200,
  [sym_kw_equals] = sym_kw_equals,
  [sym_kw_termlink] = sym_kw_termlink,
  [sym_kw_typelink] = sym_kw_typelink,
  [sym_handle] = sym_handle,
  [sym_with] = sym_with,
  [sym_rewrite] = sym_rewrite,
  [sym_term] = sym_term,
  [sym_case] = sym_case,
  [sym_signature] = sym_signature,
  [sym_rewrite_arrow] = sym_rewrite_arrow,
  [aux_sym_wordy_id_token1] = aux_sym_wordy_id_token1,
  [sym_imm_wordy_id] = sym_imm_wordy_id,
  [sym_symboly_id] = sym_symboly_id,
  [sym_imm_symboly_id] = sym_symboly_id,
  [sym_path] = sym_path,
  [aux_sym_hash_qualifier_token1] = aux_sym_hash_qualifier_token1,
  [sym_built_in_hash] = sym_built_in_hash,
  [anon_sym_test_GT] = anon_sym_test_GT,
  [anon_sym_test_DOTio_GT] = anon_sym_test_DOTio_GT,
  [sym__layout_semicolon] = sym__layout_semicolon,
  [sym__layout_start] = sym__layout_start,
  [sym__layout_end] = sym__layout_end,
  [sym__dot] = sym__dot,
  [sym__where] = sym__where,
  [sym__varsym] = sym__varsym,
  [sym_comment] = sym_comment,
  [sym_fold] = sym_fold,
  [sym__comma] = sym__comma,
  [sym__in] = sym__in,
  [sym__indent] = sym__indent,
  [sym__empty] = sym__empty,
  [sym_DEPRECATED_operator] = sym_DEPRECATED_operator,
  [sym__parenthesized_operator] = sym__parenthesized_operator,
  [sym__watch_start] = sym__watch_start,
  [sym__start_before_arrow] = sym__start_before_arrow,
  [sym_hash_cid] = sym_hash_cid,
  [sym_doc_block] = sym_doc_block,
  [sym__guard_layout_start] = sym__guard_layout_start,
  [sym__destructuring_bind_start] = sym__destructuring_bind_start,
  [sym_DUMMY] = sym_DUMMY,
  [sym_unison] = sym_unison,
  [sym__statement] = sym__statement,
  [sym_term_definition2] = sym_term_definition2,
  [sym___block] = sym___block,
  [sym___layout_block] = sym___layout_block,
  [sym_binding] = sym_binding,
  [sym__binding] = sym__binding,
  [sym_destructuring_bind] = sym_destructuring_bind,
  [sym__block_term] = sym__block_term,
  [sym_literal_function] = sym_literal_function,
  [sym_literal_function2] = sym_literal_function,
  [sym__term] = sym__term,
  [sym__term2] = sym__term2,
  [sym__term3] = sym__term3,
  [aux_sym__term4] = aux_sym__term4,
  [sym__infix_app_or_boolean_op] = sym__infix_app_or_boolean_op,
  [sym__generic_infix_app] = sym__generic_infix_app,
  [sym__infix] = sym__infix,
  [sym_unit] = sym_unit,
  [sym_literal_text] = sym_literal_text,
  [sym_literal_char] = sym_literal_char,
  [sym_literal_boolean] = sym_literal_boolean,
  [sym_tuple_or_parenthesized] = sym_tuple_or_parenthesized,
  [sym_literal_termlink] = sym_literal_termlink,
  [sym_literal_typelink] = sym_literal_typelink,
  [sym__lhs] = sym__lhs,
  [sym__infix_lhs] = sym__infix_lhs,
  [sym__prefix_lhs] = sym__prefix_lhs,
  [sym__pattern_matching] = sym__pattern_matching,
  [sym__match_with] = sym__match_with,
  [sym__lam_case] = sym__lam_case,
  [sym__match_cases] = sym__match_cases,
  [sym_pattern] = sym_pattern,
  [sym__pattern_rhs] = sym__pattern_rhs,
  [sym__literal_pattern] = sym__literal_pattern,
  [sym_guard] = sym_guard,
  [sym_guarded_block] = sym_guarded_block,
  [sym__pattern_root] = sym__pattern_root,
  [sym__pattern_infix_app] = sym__pattern_infix_app,
  [sym__pattern_constructor] = sym__pattern_constructor,
  [sym__pattern_candidates] = sym__pattern_candidates,
  [sym_var_or_as] = sym_var_or_as,
  [sym_literal_list_pattern] = sym_literal_list_pattern,
  [sym_parenthesized_or_tuple_pattern] = sym_parenthesized_or_tuple_pattern,
  [sym_effect_pure] = sym_effect_pure,
  [sym_effect_bind] = sym_effect_bind,
  [sym_effect_pattern] = sym_effect_pattern,
  [sym__pattern_leaf] = sym__pattern_leaf,
  [sym_kw_if] = sym_kw_if,
  [sym_kw_then] = sym_kw_then,
  [sym_kw_else] = sym_kw_else,
  [sym_delay_quote] = sym_delay_quote,
  [sym_delay_block] = sym_delay_block,
  [sym_bang] = sym_bang,
  [sym__number] = sym__number,
  [sym__link] = sym__link,
  [sym__term_leaf] = sym__term_leaf,
  [sym_literal_list] = sym_literal_list,
  [sym__keyword_block] = sym__keyword_block,
  [sym_exp_if] = sym_exp_if,
  [sym_force] = sym_force,
  [sym__block] = sym__block,
  [sym_exp_let] = sym_exp_let,
  [sym_handler] = sym_handler,
  [sym_rewrite_block] = sym_rewrite_block,
  [sym__rewrite_type] = sym__rewrite_type,
  [sym__rewrite_term_like] = sym__rewrite_term_like,
  [sym_rewrite_term] = sym_rewrite_term,
  [sym_rewrite_case] = sym_rewrite_case,
  [sym_rewrite_type] = sym_rewrite_type,
  [sym_type_signature] = sym_type_signature,
  [sym_type_declaration] = sym_type_declaration,
  [sym_type_name] = sym_type_name,
  [sym_type_constructor] = sym_type_constructor,
  [sym__type_lhs] = sym__type_lhs,
  [sym__type_rhs] = sym__type_rhs,
  [sym_record] = sym_record,
  [sym_record_field] = sym_record_field,
  [sym__record_fields_inline] = sym__record_fields_inline,
  [sym__record_fields_block] = sym__record_fields_block,
  [sym__effect_inline] = sym__effect_inline,
  [sym__effect_list] = sym__effect_list,
  [sym_forall] = sym_forall,
  [sym__value_type] = sym__value_type,
  [sym_tuple_or_parenthesized_type] = sym_tuple_or_parenthesized_type,
  [sym__value_type_leaf] = sym__value_type_leaf,
  [sym__type_atom] = sym__type_atom,
  [sym_sequence_type] = sym_sequence_type,
  [sym__type1] = sym__type1,
  [sym__type2a] = sym__type2a,
  [sym__type2] = sym__type2,
  [sym_delayed] = sym_delayed,
  [sym_arrow_symbol] = sym_arrow_symbol,
  [sym__effect] = sym__effect,
  [sym__computation_type] = sym__computation_type,
  [sym__arrow] = sym__arrow,
  [sym__ebody] = sym__ebody,
  [sym_constructor] = sym_constructor,
  [sym_effect_declaration] = sym_effect_declaration,
  [sym_use] = sym_use,
  [sym_use_clause] = sym_use_clause,
  [sym_kw_forall] = sym_kw_forall,
  [sym_type_signature_colon] = sym_type_signature_colon,
  [sym_open_parens] = sym_open_parens,
  [sym_close_parens] = sym_close_parens,
  [sym_wordy_id] = sym_imm_wordy_id,
  [sym__identifier] = sym__identifier,
  [sym_hash_qualifier] = sym_hash_qualifier,
  [sym_imm_hash_qualifier] = sym_hash_qualifier,
  [sym__hash_qualified] = sym__hash_qualified,
  [sym__hq_qualified_wordy_id] = sym__hq_qualified_wordy_id,
  [sym__hq_qualified_symboly_id] = sym__hq_qualified_symboly_id,
  [sym__hq_qualified_prefix_term] = sym__hq_qualified_prefix_term,
  [sym__hq_qualified_infix_term] = sym__hq_qualified_infix_term,
  [sym__prefix_definition_name] = sym__prefix_definition_name,
  [sym__wordy_definition_name] = sym__wordy_definition_name,
  [sym__symboly_definition_name] = sym__symboly_definition_name,
  [sym__watch_expression] = sym__watch_expression,
  [sym_watch_expression] = sym_watch_expression,
  [sym_test_watch_expression] = sym_test_watch_expression,
  [aux_sym_unison_repeat1] = aux_sym_unison_repeat1,
  [aux_sym___block_repeat1] = aux_sym___block_repeat1,
  [aux_sym___block_repeat2] = aux_sym___block_repeat2,
  [aux_sym___layout_block_repeat1] = aux_sym___layout_block_repeat1,
  [aux_sym__infix_app_or_boolean_op_repeat1] = aux_sym__infix_app_or_boolean_op_repeat1,
  [aux_sym_literal_text_repeat1] = aux_sym_literal_text_repeat1,
  [aux_sym_literal_text_repeat2] = aux_sym_literal_text_repeat2,
  [aux_sym_tuple_or_parenthesized_repeat1] = aux_sym_tuple_or_parenthesized_repeat1,
  [aux_sym__prefix_lhs_repeat1] = aux_sym__prefix_lhs_repeat1,
  [aux_sym__match_cases_repeat1] = aux_sym__match_cases_repeat1,
  [aux_sym__pattern_rhs_repeat1] = aux_sym__pattern_rhs_repeat1,
  [aux_sym_guarded_block_repeat1] = aux_sym_guarded_block_repeat1,
  [aux_sym_guarded_block_repeat2] = aux_sym_guarded_block_repeat2,
  [aux_sym__pattern_root_repeat1] = aux_sym__pattern_root_repeat1,
  [aux_sym__pattern_constructor_repeat1] = aux_sym__pattern_constructor_repeat1,
  [aux_sym_literal_list_pattern_repeat1] = aux_sym_literal_list_pattern_repeat1,
  [aux_sym_parenthesized_or_tuple_pattern_repeat1] = aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [aux_sym_effect_bind_repeat1] = aux_sym_effect_bind_repeat1,
  [aux_sym_rewrite_block_repeat1] = aux_sym_rewrite_block_repeat1,
  [aux_sym_rewrite_type_repeat1] = aux_sym_rewrite_type_repeat1,
  [aux_sym_type_constructor_repeat1] = aux_sym_type_constructor_repeat1,
  [aux_sym__type_rhs_repeat1] = aux_sym__type_rhs_repeat1,
  [aux_sym__record_fields_inline_repeat1] = aux_sym__record_fields_inline_repeat1,
  [aux_sym__record_fields_block_repeat1] = aux_sym__record_fields_block_repeat1,
  [aux_sym__effect_block_repeat1] = aux_sym__effect_block_repeat1,
  [aux_sym_forall_repeat1] = aux_sym_forall_repeat1,
  [aux_sym_tuple_or_parenthesized_type_repeat1] = aux_sym_tuple_or_parenthesized_type_repeat1,
  [aux_sym__type2_repeat1] = aux_sym__type2_repeat1,
  [aux_sym__ebody_repeat1] = aux_sym__ebody_repeat1,
  [aux_sym__ebody_repeat2] = aux_sym__ebody_repeat2,
  [aux_sym__ebody_repeat3] = aux_sym__ebody_repeat3,
  [aux_sym_use_clause_repeat1] = aux_sym_use_clause_repeat1,
  [alias_sym_ability_name] = alias_sym_ability_name,
  [alias_sym_at_token] = alias_sym_at_token,
  [alias_sym_close_bracket] = alias_sym_close_bracket,
  [alias_sym_colon] = alias_sym_colon,
  [alias_sym_comma] = alias_sym_comma,
  [alias_sym_constructor_name] = alias_sym_constructor_name,
  [alias_sym_ctor] = alias_sym_ctor,
  [alias_sym_dot] = alias_sym_dot,
  [alias_sym_effect] = alias_sym_effect,
  [alias_sym_field_name] = alias_sym_field_name,
  [alias_sym_namespace] = alias_sym_namespace,
  [alias_sym_open_bracket] = alias_sym_open_bracket,
  [alias_sym_term_type] = alias_sym_term_type,
  [alias_sym_var_or_nullary_ctor] = alias_sym_var_or_nullary_ctor,
};

static const TSSymbolMetadata ts_symbol_metadata[] = {
  [ts_builtin_sym_end] = {
    .visible = false,
    .named = true,
  },
  [anon_sym_DASH_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LPAREN_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [sym_nat] = {
    .visible = true,
    .named = true,
  },
  [sym_int] = {
    .visible = true,
    .named = true,
  },
  [sym_float] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_literal_text_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_text_token2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_text_token3] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_DQUOTE_DQUOTE_DQUOTE] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_literal_char_token1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_char_token2] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_true] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_false] = {
    .visible = true,
    .named = false,
  },
  [sym_literal_byte] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_hex] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_LPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_COMMA] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RPAREN] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SEMI] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_PLUS_PLUS] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_PLUS_COLON] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON_PLUS] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_AT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACK] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_LBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_RBRACE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym__] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_if] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_then] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_else] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_SQUOTE] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_BANG] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_DOT] = {
    .visible = true,
    .named = false,
  },
  [sym_type_argument] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_COLON] = {
    .visible = true,
    .named = false,
  },
  [aux_sym_immediate_hash_token1] = {
    .visible = false,
    .named = false,
  },
  [anon_sym_use] = {
    .visible = true,
    .named = false,
  },
  [sym_do] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_let] = {
    .visible = true,
    .named = true,
  },
  [sym_type_kw] = {
    .visible = true,
    .named = true,
  },
  [sym_pipe] = {
    .visible = true,
    .named = true,
  },
  [sym_match] = {
    .visible = true,
    .named = true,
  },
  [sym_cases] = {
    .visible = true,
    .named = true,
  },
  [sym_otherwise] = {
    .visible = true,
    .named = true,
  },
  [sym_structural] = {
    .visible = true,
    .named = true,
  },
  [sym_unique] = {
    .visible = true,
    .named = true,
  },
  [sym_ability] = {
    .visible = true,
    .named = true,
  },
  [sym_where] = {
    .visible = true,
    .named = true,
  },
  [sym_or] = {
    .visible = true,
    .named = true,
  },
  [sym_and] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_forall] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_u2200] = {
    .visible = true,
    .named = false,
  },
  [sym_kw_equals] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_termlink] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_typelink] = {
    .visible = true,
    .named = true,
  },
  [sym_handle] = {
    .visible = true,
    .named = true,
  },
  [sym_with] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite] = {
    .visible = true,
    .named = true,
  },
  [sym_term] = {
    .visible = true,
    .named = true,
  },
  [sym_case] = {
    .visible = true,
    .named = true,
  },
  [sym_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite_arrow] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_wordy_id_token1] = {
    .visible = false,
    .named = false,
  },
  [sym_imm_wordy_id] = {
    .visible = true,
    .named = true,
  },
  [sym_symboly_id] = {
    .visible = true,
    .named = true,
  },
  [sym_imm_symboly_id] = {
    .visible = true,
    .named = true,
  },
  [sym_path] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_hash_qualifier_token1] = {
    .visible = true,
    .named = true,
  },
  [sym_built_in_hash] = {
    .visible = true,
    .named = true,
  },
  [anon_sym_test_GT] = {
    .visible = true,
    .named = false,
  },
  [anon_sym_test_DOTio_GT] = {
    .visible = true,
    .named = false,
  },
  [sym__layout_semicolon] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__layout_end] = {
    .visible = false,
    .named = true,
  },
  [sym__dot] = {
    .visible = true,
    .named = true,
  },
  [sym__where] = {
    .visible = false,
    .named = true,
  },
  [sym__varsym] = {
    .visible = false,
    .named = true,
  },
  [sym_comment] = {
    .visible = true,
    .named = true,
  },
  [sym_fold] = {
    .visible = true,
    .named = true,
  },
  [sym__comma] = {
    .visible = false,
    .named = true,
  },
  [sym__in] = {
    .visible = false,
    .named = true,
  },
  [sym__indent] = {
    .visible = false,
    .named = true,
  },
  [sym__empty] = {
    .visible = false,
    .named = true,
  },
  [sym_DEPRECATED_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__parenthesized_operator] = {
    .visible = true,
    .named = true,
  },
  [sym__watch_start] = {
    .visible = false,
    .named = true,
  },
  [sym__start_before_arrow] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_cid] = {
    .visible = true,
    .named = true,
  },
  [sym_doc_block] = {
    .visible = true,
    .named = true,
  },
  [sym__guard_layout_start] = {
    .visible = false,
    .named = true,
  },
  [sym__destructuring_bind_start] = {
    .visible = false,
    .named = true,
  },
  [sym_DUMMY] = {
    .visible = true,
    .named = true,
  },
  [sym_unison] = {
    .visible = true,
    .named = true,
  },
  [sym__statement] = {
    .visible = false,
    .named = true,
  },
  [sym_term_definition2] = {
    .visible = true,
    .named = true,
  },
  [sym___block] = {
    .visible = false,
    .named = true,
  },
  [sym___layout_block] = {
    .visible = false,
    .named = true,
  },
  [sym_binding] = {
    .visible = true,
    .named = true,
  },
  [sym__binding] = {
    .visible = false,
    .named = true,
  },
  [sym_destructuring_bind] = {
    .visible = true,
    .named = true,
  },
  [sym__block_term] = {
    .visible = false,
    .named = true,
  },
  [sym_literal_function] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_function2] = {
    .visible = true,
    .named = true,
  },
  [sym__term] = {
    .visible = false,
    .named = true,
  },
  [sym__term2] = {
    .visible = false,
    .named = true,
  },
  [sym__term3] = {
    .visible = false,
    .named = true,
  },
  [aux_sym__term4] = {
    .visible = false,
    .named = false,
  },
  [sym__infix_app_or_boolean_op] = {
    .visible = false,
    .named = true,
  },
  [sym__generic_infix_app] = {
    .visible = false,
    .named = true,
  },
  [sym__infix] = {
    .visible = false,
    .named = true,
  },
  [sym_unit] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_text] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_char] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_boolean] = {
    .visible = true,
    .named = true,
  },
  [sym_tuple_or_parenthesized] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_termlink] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_typelink] = {
    .visible = true,
    .named = true,
  },
  [sym__lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__infix_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_matching] = {
    .visible = false,
    .named = true,
  },
  [sym__match_with] = {
    .visible = false,
    .named = true,
  },
  [sym__lam_case] = {
    .visible = false,
    .named = true,
  },
  [sym__match_cases] = {
    .visible = false,
    .named = true,
  },
  [sym_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym__literal_pattern] = {
    .visible = false,
    .named = true,
  },
  [sym_guard] = {
    .visible = true,
    .named = true,
  },
  [sym_guarded_block] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_root] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_infix_app] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_constructor] = {
    .visible = false,
    .named = true,
  },
  [sym__pattern_candidates] = {
    .visible = false,
    .named = true,
  },
  [sym_var_or_as] = {
    .visible = true,
    .named = true,
  },
  [sym_literal_list_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_parenthesized_or_tuple_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym_effect_pure] = {
    .visible = true,
    .named = true,
  },
  [sym_effect_bind] = {
    .visible = true,
    .named = true,
  },
  [sym_effect_pattern] = {
    .visible = true,
    .named = true,
  },
  [sym__pattern_leaf] = {
    .visible = false,
    .named = true,
  },
  [sym_kw_if] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_then] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_else] = {
    .visible = true,
    .named = true,
  },
  [sym_delay_quote] = {
    .visible = true,
    .named = true,
  },
  [sym_delay_block] = {
    .visible = true,
    .named = true,
  },
  [sym_bang] = {
    .visible = true,
    .named = true,
  },
  [sym__number] = {
    .visible = false,
    .named = true,
  },
  [sym__link] = {
    .visible = false,
    .named = true,
  },
  [sym__term_leaf] = {
    .visible = false,
    .named = true,
  },
  [sym_literal_list] = {
    .visible = true,
    .named = true,
  },
  [sym__keyword_block] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_if] = {
    .visible = true,
    .named = true,
  },
  [sym_force] = {
    .visible = true,
    .named = true,
  },
  [sym__block] = {
    .visible = false,
    .named = true,
  },
  [sym_exp_let] = {
    .visible = true,
    .named = true,
  },
  [sym_handler] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite_block] = {
    .visible = true,
    .named = true,
  },
  [sym__rewrite_type] = {
    .visible = false,
    .named = true,
  },
  [sym__rewrite_term_like] = {
    .visible = false,
    .named = true,
  },
  [sym_rewrite_term] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite_case] = {
    .visible = true,
    .named = true,
  },
  [sym_rewrite_type] = {
    .visible = true,
    .named = true,
  },
  [sym_type_signature] = {
    .visible = true,
    .named = true,
  },
  [sym_type_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_type_name] = {
    .visible = true,
    .named = true,
  },
  [sym_type_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym__type_lhs] = {
    .visible = false,
    .named = true,
  },
  [sym__type_rhs] = {
    .visible = false,
    .named = true,
  },
  [sym_record] = {
    .visible = true,
    .named = true,
  },
  [sym_record_field] = {
    .visible = true,
    .named = true,
  },
  [sym__record_fields_inline] = {
    .visible = false,
    .named = true,
  },
  [sym__record_fields_block] = {
    .visible = false,
    .named = true,
  },
  [sym__effect_inline] = {
    .visible = false,
    .named = true,
  },
  [sym__effect_list] = {
    .visible = false,
    .named = true,
  },
  [sym_forall] = {
    .visible = true,
    .named = true,
  },
  [sym__value_type] = {
    .visible = false,
    .named = true,
  },
  [sym_tuple_or_parenthesized_type] = {
    .visible = true,
    .named = true,
  },
  [sym__value_type_leaf] = {
    .visible = false,
    .named = true,
  },
  [sym__type_atom] = {
    .visible = false,
    .named = true,
  },
  [sym_sequence_type] = {
    .visible = true,
    .named = true,
  },
  [sym__type1] = {
    .visible = false,
    .named = true,
  },
  [sym__type2a] = {
    .visible = false,
    .named = true,
  },
  [sym__type2] = {
    .visible = false,
    .named = true,
  },
  [sym_delayed] = {
    .visible = true,
    .named = true,
  },
  [sym_arrow_symbol] = {
    .visible = true,
    .named = true,
  },
  [sym__effect] = {
    .visible = false,
    .named = true,
  },
  [sym__computation_type] = {
    .visible = false,
    .named = true,
  },
  [sym__arrow] = {
    .visible = false,
    .named = true,
  },
  [sym__ebody] = {
    .visible = false,
    .named = true,
  },
  [sym_constructor] = {
    .visible = true,
    .named = true,
  },
  [sym_effect_declaration] = {
    .visible = true,
    .named = true,
  },
  [sym_use] = {
    .visible = true,
    .named = true,
  },
  [sym_use_clause] = {
    .visible = true,
    .named = true,
  },
  [sym_kw_forall] = {
    .visible = true,
    .named = true,
  },
  [sym_type_signature_colon] = {
    .visible = true,
    .named = true,
  },
  [sym_open_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_close_parens] = {
    .visible = true,
    .named = true,
  },
  [sym_wordy_id] = {
    .visible = true,
    .named = true,
  },
  [sym__identifier] = {
    .visible = false,
    .named = true,
  },
  [sym_hash_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym_imm_hash_qualifier] = {
    .visible = true,
    .named = true,
  },
  [sym__hash_qualified] = {
    .visible = false,
    .named = true,
  },
  [sym__hq_qualified_wordy_id] = {
    .visible = false,
    .named = true,
  },
  [sym__hq_qualified_symboly_id] = {
    .visible = false,
    .named = true,
  },
  [sym__hq_qualified_prefix_term] = {
    .visible = false,
    .named = true,
  },
  [sym__hq_qualified_infix_term] = {
    .visible = false,
    .named = true,
  },
  [sym__prefix_definition_name] = {
    .visible = false,
    .named = true,
  },
  [sym__wordy_definition_name] = {
    .visible = false,
    .named = true,
  },
  [sym__symboly_definition_name] = {
    .visible = false,
    .named = true,
  },
  [sym__watch_expression] = {
    .visible = false,
    .named = true,
  },
  [sym_watch_expression] = {
    .visible = true,
    .named = true,
  },
  [sym_test_watch_expression] = {
    .visible = true,
    .named = true,
  },
  [aux_sym_unison_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym___block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym___block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym___layout_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__infix_app_or_boolean_op_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_text_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_text_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_or_parenthesized_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__prefix_lhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__match_cases_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guarded_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_guarded_block_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_root_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__pattern_constructor_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_literal_list_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_parenthesized_or_tuple_pattern_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_effect_bind_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rewrite_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_rewrite_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_type_constructor_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type_rhs_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_fields_inline_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__record_fields_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__effect_block_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_forall_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_tuple_or_parenthesized_type_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__type2_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ebody_repeat1] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ebody_repeat2] = {
    .visible = false,
    .named = false,
  },
  [aux_sym__ebody_repeat3] = {
    .visible = false,
    .named = false,
  },
  [aux_sym_use_clause_repeat1] = {
    .visible = false,
    .named = false,
  },
  [alias_sym_ability_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_at_token] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_close_bracket] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_colon] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_comma] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_constructor_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_ctor] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_dot] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_effect] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_field_name] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_namespace] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_open_bracket] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_term_type] = {
    .visible = true,
    .named = true,
  },
  [alias_sym_var_or_nullary_ctor] = {
    .visible = true,
    .named = true,
  },
};

enum ts_field_identifiers {
  field_name = 1,
  field_param = 2,
  field_scrutinee = 3,
  field_term_name = 4,
  field_type = 5,
};

static const char * const ts_field_names[] = {
  [0] = NULL,
  [field_name] = "name",
  [field_param] = "param",
  [field_scrutinee] = "scrutinee",
  [field_term_name] = "term_name",
  [field_type] = "type",
};

static const TSFieldMapSlice ts_field_map_slices[PRODUCTION_ID_COUNT] = {
  [1] = {.index = 0, .length = 2},
  [2] = {.index = 2, .length = 1},
  [4] = {.index = 3, .length = 1},
  [5] = {.index = 4, .length = 1},
  [7] = {.index = 5, .length = 1},
  [8] = {.index = 6, .length = 2},
  [10] = {.index = 8, .length = 2},
  [14] = {.index = 10, .length = 1},
  [15] = {.index = 11, .length = 3},
  [16] = {.index = 14, .length = 2},
  [17] = {.index = 4, .length = 1},
  [18] = {.index = 16, .length = 1},
  [20] = {.index = 16, .length = 1},
  [22] = {.index = 17, .length = 3},
  [23] = {.index = 20, .length = 2},
  [24] = {.index = 22, .length = 2},
  [25] = {.index = 24, .length = 1},
  [27] = {.index = 25, .length = 2},
  [29] = {.index = 27, .length = 1},
  [30] = {.index = 28, .length = 2},
  [32] = {.index = 20, .length = 2},
  [33] = {.index = 30, .length = 1},
  [34] = {.index = 30, .length = 1},
  [35] = {.index = 31, .length = 2},
  [36] = {.index = 33, .length = 1},
  [37] = {.index = 34, .length = 2},
  [41] = {.index = 36, .length = 2},
  [43] = {.index = 38, .length = 2},
  [44] = {.index = 40, .length = 3},
  [46] = {.index = 43, .length = 1},
  [47] = {.index = 44, .length = 2},
  [48] = {.index = 46, .length = 1},
  [49] = {.index = 47, .length = 2},
};

static const TSFieldMapEntry ts_field_map_entries[] = {
  [0] =
    {field_name, 0, .inherited = true},
    {field_param, 0, .inherited = true},
  [2] =
    {field_name, 0},
  [3] =
    {field_scrutinee, 0, .inherited = true},
  [4] =
    {field_scrutinee, 1, .inherited = true},
  [5] =
    {field_param, 0},
  [6] =
    {field_name, 0},
    {field_param, 1, .inherited = true},
  [8] =
    {field_scrutinee, 0, .inherited = true},
    {field_scrutinee, 1, .inherited = true},
  [10] =
    {field_term_name, 0},
  [11] =
    {field_name, 1},
    {field_param, 0},
    {field_param, 2},
  [14] =
    {field_param, 0, .inherited = true},
    {field_param, 1, .inherited = true},
  [16] =
    {field_scrutinee, 2, .inherited = true},
  [17] =
    {field_name, 0, .inherited = true},
    {field_param, 0, .inherited = true},
    {field_scrutinee, 3, .inherited = true},
  [20] =
    {field_scrutinee, 1, .inherited = true},
    {field_scrutinee, 2, .inherited = true},
  [22] =
    {field_scrutinee, 2, .inherited = true},
    {field_scrutinee, 3, .inherited = true},
  [24] =
    {field_scrutinee, 3, .inherited = true},
  [25] =
    {field_scrutinee, 1, .inherited = true},
    {field_scrutinee, 3, .inherited = true},
  [27] =
    {field_scrutinee, 4, .inherited = true},
  [28] =
    {field_scrutinee, 3, .inherited = true},
    {field_scrutinee, 4, .inherited = true},
  [30] =
    {field_type, 2},
  [31] =
    {field_scrutinee, 4, .inherited = true},
    {field_scrutinee, 5, .inherited = true},
  [33] =
    {field_scrutinee, 5, .inherited = true},
  [34] =
    {field_scrutinee, 2},
    {field_scrutinee, 2, .inherited = true},
  [36] =
    {field_scrutinee, 5, .inherited = true},
    {field_scrutinee, 6, .inherited = true},
  [38] =
    {field_scrutinee, 0, .inherited = true},
    {field_scrutinee, 3, .inherited = true},
  [40] =
    {field_scrutinee, 2, .inherited = true},
    {field_scrutinee, 5, .inherited = true},
    {field_scrutinee, 8, .inherited = true},
  [43] =
    {field_scrutinee, 6, .inherited = true},
  [44] =
    {field_scrutinee, 6, .inherited = true},
    {field_scrutinee, 7, .inherited = true},
  [46] =
    {field_scrutinee, 7, .inherited = true},
  [47] =
    {field_scrutinee, 7, .inherited = true},
    {field_scrutinee, 8, .inherited = true},
};

static const TSSymbol ts_alias_sequences[PRODUCTION_ID_COUNT][MAX_ALIAS_SEQUENCE_LENGTH] = {
  [0] = {0},
  [3] = {
    [0] = sym_binding,
  },
  [6] = {
    [1] = alias_sym_namespace,
  },
  [9] = {
    [0] = alias_sym_open_bracket,
    [1] = alias_sym_close_bracket,
  },
  [11] = {
    [0] = aux_sym_hash_qualifier_token1,
  },
  [12] = {
    [1] = sym_unit,
  },
  [13] = {
    [0] = sym_type_argument,
  },
  [14] = {
    [2] = alias_sym_term_type,
  },
  [17] = {
    [0] = alias_sym_open_bracket,
    [2] = alias_sym_close_bracket,
  },
  [19] = {
    [0] = alias_sym_var_or_nullary_ctor,
  },
  [20] = {
    [1] = sym_arrow_symbol,
  },
  [21] = {
    [0] = alias_sym_ability_name,
  },
  [23] = {
    [0] = alias_sym_open_bracket,
    [3] = alias_sym_close_bracket,
  },
  [26] = {
    [0] = alias_sym_ctor,
  },
  [28] = {
    [0] = alias_sym_effect,
  },
  [31] = {
    [1] = alias_sym_at_token,
  },
  [33] = {
    [0] = alias_sym_constructor_name,
    [1] = alias_sym_colon,
  },
  [34] = {
    [0] = alias_sym_field_name,
  },
  [38] = {
    [0] = alias_sym_comma,
  },
  [39] = {
    [0] = sym_open_parens,
    [4] = sym_close_parens,
  },
  [40] = {
    [1] = alias_sym_effect,
  },
  [42] = {
    [0] = sym_open_parens,
    [5] = sym_close_parens,
  },
  [45] = {
    [2] = alias_sym_dot,
  },
};

static const uint16_t ts_non_terminal_alias_map[] = {
  sym__binding, 2,
    sym__binding,
    sym_binding,
  sym__value_type, 3,
    sym__value_type,
    alias_sym_effect,
    alias_sym_term_type,
  sym_wordy_id, 5,
    sym_imm_wordy_id,
    alias_sym_constructor_name,
    alias_sym_field_name,
    alias_sym_var_or_nullary_ctor,
    sym_type_argument,
  sym__identifier, 3,
    sym__identifier,
    alias_sym_ability_name,
    alias_sym_namespace,
  sym__hq_qualified_prefix_term, 2,
    sym__hq_qualified_prefix_term,
    alias_sym_ctor,
  0,
};

static const TSStateId ts_primary_state_ids[STATE_COUNT] = {
  [0] = 0,
  [1] = 1,
  [2] = 2,
  [3] = 3,
  [4] = 4,
  [5] = 5,
  [6] = 6,
  [7] = 7,
  [8] = 8,
  [9] = 9,
  [10] = 10,
  [11] = 11,
  [12] = 12,
  [13] = 13,
  [14] = 14,
  [15] = 15,
  [16] = 16,
  [17] = 17,
  [18] = 18,
  [19] = 19,
  [20] = 20,
  [21] = 21,
  [22] = 22,
  [23] = 23,
  [24] = 24,
  [25] = 25,
  [26] = 26,
  [27] = 27,
  [28] = 11,
  [29] = 12,
  [30] = 17,
  [31] = 16,
  [32] = 3,
  [33] = 14,
  [34] = 10,
  [35] = 18,
  [36] = 5,
  [37] = 23,
  [38] = 2,
  [39] = 25,
  [40] = 6,
  [41] = 9,
  [42] = 21,
  [43] = 4,
  [44] = 20,
  [45] = 7,
  [46] = 19,
  [47] = 22,
  [48] = 27,
  [49] = 26,
  [50] = 24,
  [51] = 13,
  [52] = 15,
  [53] = 8,
  [54] = 8,
  [55] = 2,
  [56] = 11,
  [57] = 26,
  [58] = 4,
  [59] = 27,
  [60] = 14,
  [61] = 5,
  [62] = 20,
  [63] = 3,
  [64] = 16,
  [65] = 6,
  [66] = 13,
  [67] = 22,
  [68] = 7,
  [69] = 21,
  [70] = 12,
  [71] = 9,
  [72] = 10,
  [73] = 18,
  [74] = 15,
  [75] = 17,
  [76] = 25,
  [77] = 23,
  [78] = 24,
  [79] = 19,
  [80] = 18,
  [81] = 12,
  [82] = 14,
  [83] = 25,
  [84] = 13,
  [85] = 8,
  [86] = 7,
  [87] = 24,
  [88] = 6,
  [89] = 9,
  [90] = 10,
  [91] = 2,
  [92] = 23,
  [93] = 4,
  [94] = 16,
  [95] = 3,
  [96] = 26,
  [97] = 27,
  [98] = 15,
  [99] = 22,
  [100] = 17,
  [101] = 19,
  [102] = 11,
  [103] = 21,
  [104] = 20,
  [105] = 5,
  [106] = 12,
  [107] = 10,
  [108] = 19,
  [109] = 17,
  [110] = 15,
  [111] = 27,
  [112] = 16,
  [113] = 3,
  [114] = 24,
  [115] = 13,
  [116] = 23,
  [117] = 2,
  [118] = 20,
  [119] = 21,
  [120] = 6,
  [121] = 26,
  [122] = 4,
  [123] = 5,
  [124] = 22,
  [125] = 7,
  [126] = 8,
  [127] = 9,
  [128] = 11,
  [129] = 14,
  [130] = 18,
  [131] = 25,
  [132] = 20,
  [133] = 25,
  [134] = 21,
  [135] = 20,
  [136] = 19,
  [137] = 17,
  [138] = 15,
  [139] = 27,
  [140] = 13,
  [141] = 24,
  [142] = 12,
  [143] = 11,
  [144] = 3,
  [145] = 22,
  [146] = 26,
  [147] = 4,
  [148] = 2,
  [149] = 14,
  [150] = 5,
  [151] = 21,
  [152] = 6,
  [153] = 24,
  [154] = 23,
  [155] = 7,
  [156] = 19,
  [157] = 8,
  [158] = 9,
  [159] = 18,
  [160] = 16,
  [161] = 3,
  [162] = 14,
  [163] = 2,
  [164] = 25,
  [165] = 10,
  [166] = 17,
  [167] = 21,
  [168] = 23,
  [169] = 15,
  [170] = 20,
  [171] = 19,
  [172] = 17,
  [173] = 15,
  [174] = 27,
  [175] = 13,
  [176] = 25,
  [177] = 2,
  [178] = 27,
  [179] = 12,
  [180] = 11,
  [181] = 22,
  [182] = 18,
  [183] = 26,
  [184] = 10,
  [185] = 9,
  [186] = 4,
  [187] = 8,
  [188] = 7,
  [189] = 5,
  [190] = 6,
  [191] = 7,
  [192] = 6,
  [193] = 5,
  [194] = 4,
  [195] = 8,
  [196] = 26,
  [197] = 22,
  [198] = 14,
  [199] = 9,
  [200] = 10,
  [201] = 3,
  [202] = 16,
  [203] = 11,
  [204] = 16,
  [205] = 18,
  [206] = 23,
  [207] = 24,
  [208] = 12,
  [209] = 13,
  [210] = 19,
  [211] = 211,
  [212] = 10,
  [213] = 9,
  [214] = 8,
  [215] = 7,
  [216] = 6,
  [217] = 211,
  [218] = 5,
  [219] = 4,
  [220] = 26,
  [221] = 22,
  [222] = 11,
  [223] = 211,
  [224] = 14,
  [225] = 12,
  [226] = 14,
  [227] = 211,
  [228] = 12,
  [229] = 13,
  [230] = 27,
  [231] = 211,
  [232] = 211,
  [233] = 15,
  [234] = 3,
  [235] = 17,
  [236] = 19,
  [237] = 20,
  [238] = 21,
  [239] = 211,
  [240] = 3,
  [241] = 25,
  [242] = 2,
  [243] = 16,
  [244] = 18,
  [245] = 23,
  [246] = 2,
  [247] = 25,
  [248] = 21,
  [249] = 20,
  [250] = 17,
  [251] = 15,
  [252] = 16,
  [253] = 18,
  [254] = 27,
  [255] = 13,
  [256] = 23,
  [257] = 24,
  [258] = 12,
  [259] = 211,
  [260] = 11,
  [261] = 24,
  [262] = 211,
  [263] = 22,
  [264] = 26,
  [265] = 4,
  [266] = 2,
  [267] = 5,
  [268] = 6,
  [269] = 211,
  [270] = 7,
  [271] = 8,
  [272] = 9,
  [273] = 10,
  [274] = 25,
  [275] = 211,
  [276] = 10,
  [277] = 277,
  [278] = 211,
  [279] = 8,
  [280] = 211,
  [281] = 21,
  [282] = 20,
  [283] = 7,
  [284] = 6,
  [285] = 14,
  [286] = 211,
  [287] = 5,
  [288] = 211,
  [289] = 19,
  [290] = 9,
  [291] = 17,
  [292] = 3,
  [293] = 211,
  [294] = 211,
  [295] = 15,
  [296] = 211,
  [297] = 16,
  [298] = 18,
  [299] = 27,
  [300] = 23,
  [301] = 13,
  [302] = 24,
  [303] = 11,
  [304] = 22,
  [305] = 4,
  [306] = 26,
  [307] = 24,
  [308] = 14,
  [309] = 22,
  [310] = 18,
  [311] = 23,
  [312] = 14,
  [313] = 24,
  [314] = 27,
  [315] = 3,
  [316] = 16,
  [317] = 18,
  [318] = 23,
  [319] = 18,
  [320] = 12,
  [321] = 26,
  [322] = 13,
  [323] = 27,
  [324] = 4,
  [325] = 16,
  [326] = 15,
  [327] = 10,
  [328] = 9,
  [329] = 17,
  [330] = 19,
  [331] = 20,
  [332] = 21,
  [333] = 16,
  [334] = 8,
  [335] = 7,
  [336] = 25,
  [337] = 17,
  [338] = 2,
  [339] = 3,
  [340] = 5,
  [341] = 23,
  [342] = 22,
  [343] = 2,
  [344] = 12,
  [345] = 14,
  [346] = 6,
  [347] = 6,
  [348] = 7,
  [349] = 5,
  [350] = 15,
  [351] = 4,
  [352] = 14,
  [353] = 25,
  [354] = 24,
  [355] = 8,
  [356] = 11,
  [357] = 26,
  [358] = 26,
  [359] = 22,
  [360] = 11,
  [361] = 3,
  [362] = 12,
  [363] = 21,
  [364] = 4,
  [365] = 3,
  [366] = 13,
  [367] = 20,
  [368] = 19,
  [369] = 10,
  [370] = 9,
  [371] = 27,
  [372] = 21,
  [373] = 17,
  [374] = 9,
  [375] = 10,
  [376] = 19,
  [377] = 8,
  [378] = 7,
  [379] = 6,
  [380] = 10,
  [381] = 15,
  [382] = 5,
  [383] = 17,
  [384] = 9,
  [385] = 8,
  [386] = 7,
  [387] = 6,
  [388] = 5,
  [389] = 16,
  [390] = 4,
  [391] = 26,
  [392] = 22,
  [393] = 11,
  [394] = 12,
  [395] = 19,
  [396] = 20,
  [397] = 13,
  [398] = 21,
  [399] = 25,
  [400] = 2,
  [401] = 18,
  [402] = 23,
  [403] = 24,
  [404] = 15,
  [405] = 14,
  [406] = 5,
  [407] = 6,
  [408] = 25,
  [409] = 13,
  [410] = 27,
  [411] = 2,
  [412] = 27,
  [413] = 15,
  [414] = 17,
  [415] = 19,
  [416] = 14,
  [417] = 3,
  [418] = 16,
  [419] = 20,
  [420] = 7,
  [421] = 18,
  [422] = 13,
  [423] = 8,
  [424] = 21,
  [425] = 13,
  [426] = 23,
  [427] = 12,
  [428] = 11,
  [429] = 24,
  [430] = 277,
  [431] = 22,
  [432] = 27,
  [433] = 15,
  [434] = 17,
  [435] = 20,
  [436] = 26,
  [437] = 4,
  [438] = 19,
  [439] = 4,
  [440] = 5,
  [441] = 25,
  [442] = 26,
  [443] = 6,
  [444] = 20,
  [445] = 7,
  [446] = 21,
  [447] = 8,
  [448] = 9,
  [449] = 22,
  [450] = 10,
  [451] = 16,
  [452] = 12,
  [453] = 2,
  [454] = 2,
  [455] = 10,
  [456] = 3,
  [457] = 9,
  [458] = 25,
  [459] = 24,
  [460] = 18,
  [461] = 11,
  [462] = 23,
  [463] = 11,
  [464] = 464,
  [465] = 8,
  [466] = 13,
  [467] = 12,
  [468] = 11,
  [469] = 6,
  [470] = 5,
  [471] = 14,
  [472] = 3,
  [473] = 16,
  [474] = 18,
  [475] = 23,
  [476] = 24,
  [477] = 22,
  [478] = 26,
  [479] = 9,
  [480] = 10,
  [481] = 24,
  [482] = 4,
  [483] = 5,
  [484] = 6,
  [485] = 20,
  [486] = 7,
  [487] = 19,
  [488] = 8,
  [489] = 9,
  [490] = 21,
  [491] = 23,
  [492] = 18,
  [493] = 16,
  [494] = 10,
  [495] = 3,
  [496] = 27,
  [497] = 7,
  [498] = 17,
  [499] = 464,
  [500] = 2,
  [501] = 4,
  [502] = 26,
  [503] = 2,
  [504] = 19,
  [505] = 22,
  [506] = 11,
  [507] = 20,
  [508] = 25,
  [509] = 21,
  [510] = 12,
  [511] = 15,
  [512] = 13,
  [513] = 14,
  [514] = 27,
  [515] = 15,
  [516] = 17,
  [517] = 25,
  [518] = 518,
  [519] = 519,
  [520] = 518,
  [521] = 521,
  [522] = 518,
  [523] = 523,
  [524] = 518,
  [525] = 525,
  [526] = 521,
  [527] = 518,
  [528] = 525,
  [529] = 518,
  [530] = 523,
  [531] = 523,
  [532] = 521,
  [533] = 519,
  [534] = 519,
  [535] = 521,
  [536] = 521,
  [537] = 521,
  [538] = 518,
  [539] = 519,
  [540] = 525,
  [541] = 518,
  [542] = 519,
  [543] = 518,
  [544] = 521,
  [545] = 518,
  [546] = 518,
  [547] = 525,
  [548] = 525,
  [549] = 523,
  [550] = 519,
  [551] = 521,
  [552] = 519,
  [553] = 525,
  [554] = 518,
  [555] = 523,
  [556] = 518,
  [557] = 557,
  [558] = 557,
  [559] = 557,
  [560] = 557,
  [561] = 521,
  [562] = 519,
  [563] = 563,
  [564] = 519,
  [565] = 521,
  [566] = 521,
  [567] = 521,
  [568] = 521,
  [569] = 521,
  [570] = 521,
  [571] = 525,
  [572] = 525,
  [573] = 518,
  [574] = 519,
  [575] = 523,
  [576] = 518,
  [577] = 557,
  [578] = 557,
  [579] = 277,
  [580] = 518,
  [581] = 557,
  [582] = 525,
  [583] = 519,
  [584] = 523,
  [585] = 525,
  [586] = 525,
  [587] = 521,
  [588] = 557,
  [589] = 525,
  [590] = 519,
  [591] = 521,
  [592] = 519,
  [593] = 521,
  [594] = 525,
  [595] = 519,
  [596] = 519,
  [597] = 557,
  [598] = 521,
  [599] = 557,
  [600] = 557,
  [601] = 557,
  [602] = 521,
  [603] = 557,
  [604] = 525,
  [605] = 525,
  [606] = 557,
  [607] = 519,
  [608] = 521,
  [609] = 557,
  [610] = 519,
  [611] = 557,
  [612] = 277,
  [613] = 525,
  [614] = 519,
  [615] = 519,
  [616] = 521,
  [617] = 18,
  [618] = 618,
  [619] = 277,
  [620] = 620,
  [621] = 621,
  [622] = 622,
  [623] = 620,
  [624] = 624,
  [625] = 625,
  [626] = 624,
  [627] = 622,
  [628] = 628,
  [629] = 629,
  [630] = 625,
  [631] = 628,
  [632] = 624,
  [633] = 633,
  [634] = 634,
  [635] = 634,
  [636] = 622,
  [637] = 629,
  [638] = 625,
  [639] = 620,
  [640] = 620,
  [641] = 622,
  [642] = 642,
  [643] = 634,
  [644] = 634,
  [645] = 624,
  [646] = 628,
  [647] = 628,
  [648] = 622,
  [649] = 620,
  [650] = 629,
  [651] = 629,
  [652] = 625,
  [653] = 625,
  [654] = 621,
  [655] = 633,
  [656] = 625,
  [657] = 621,
  [658] = 633,
  [659] = 620,
  [660] = 621,
  [661] = 620,
  [662] = 634,
  [663] = 622,
  [664] = 664,
  [665] = 665,
  [666] = 624,
  [667] = 622,
  [668] = 633,
  [669] = 628,
  [670] = 618,
  [671] = 629,
  [672] = 628,
  [673] = 628,
  [674] = 674,
  [675] = 624,
  [676] = 676,
  [677] = 642,
  [678] = 634,
  [679] = 624,
  [680] = 628,
  [681] = 625,
  [682] = 620,
  [683] = 620,
  [684] = 634,
  [685] = 625,
  [686] = 621,
  [687] = 664,
  [688] = 622,
  [689] = 277,
  [690] = 633,
  [691] = 622,
  [692] = 674,
  [693] = 676,
  [694] = 629,
  [695] = 642,
  [696] = 620,
  [697] = 621,
  [698] = 664,
  [699] = 633,
  [700] = 618,
  [701] = 620,
  [702] = 674,
  [703] = 622,
  [704] = 676,
  [705] = 642,
  [706] = 624,
  [707] = 629,
  [708] = 621,
  [709] = 634,
  [710] = 664,
  [711] = 633,
  [712] = 634,
  [713] = 624,
  [714] = 618,
  [715] = 674,
  [716] = 622,
  [717] = 628,
  [718] = 628,
  [719] = 629,
  [720] = 720,
  [721] = 676,
  [722] = 634,
  [723] = 676,
  [724] = 642,
  [725] = 625,
  [726] = 622,
  [727] = 621,
  [728] = 664,
  [729] = 633,
  [730] = 618,
  [731] = 674,
  [732] = 624,
  [733] = 676,
  [734] = 620,
  [735] = 642,
  [736] = 622,
  [737] = 629,
  [738] = 621,
  [739] = 664,
  [740] = 629,
  [741] = 633,
  [742] = 742,
  [743] = 618,
  [744] = 674,
  [745] = 676,
  [746] = 634,
  [747] = 622,
  [748] = 624,
  [749] = 628,
  [750] = 642,
  [751] = 625,
  [752] = 628,
  [753] = 621,
  [754] = 664,
  [755] = 633,
  [756] = 620,
  [757] = 618,
  [758] = 625,
  [759] = 674,
  [760] = 676,
  [761] = 622,
  [762] = 642,
  [763] = 620,
  [764] = 621,
  [765] = 664,
  [766] = 633,
  [767] = 618,
  [768] = 674,
  [769] = 620,
  [770] = 676,
  [771] = 642,
  [772] = 622,
  [773] = 625,
  [774] = 621,
  [775] = 664,
  [776] = 633,
  [777] = 629,
  [778] = 618,
  [779] = 674,
  [780] = 676,
  [781] = 624,
  [782] = 634,
  [783] = 642,
  [784] = 634,
  [785] = 624,
  [786] = 628,
  [787] = 674,
  [788] = 629,
  [789] = 642,
  [790] = 14,
  [791] = 621,
  [792] = 664,
  [793] = 618,
  [794] = 629,
  [795] = 618,
  [796] = 674,
  [797] = 797,
  [798] = 625,
  [799] = 625,
  [800] = 676,
  [801] = 642,
  [802] = 628,
  [803] = 621,
  [804] = 664,
  [805] = 633,
  [806] = 618,
  [807] = 620,
  [808] = 628,
  [809] = 674,
  [810] = 676,
  [811] = 642,
  [812] = 676,
  [813] = 621,
  [814] = 664,
  [815] = 622,
  [816] = 633,
  [817] = 618,
  [818] = 674,
  [819] = 676,
  [820] = 629,
  [821] = 642,
  [822] = 624,
  [823] = 633,
  [824] = 624,
  [825] = 621,
  [826] = 634,
  [827] = 624,
  [828] = 634,
  [829] = 628,
  [830] = 634,
  [831] = 621,
  [832] = 664,
  [833] = 24,
  [834] = 834,
  [835] = 633,
  [836] = 674,
  [837] = 618,
  [838] = 14,
  [839] = 625,
  [840] = 629,
  [841] = 674,
  [842] = 676,
  [843] = 625,
  [844] = 642,
  [845] = 628,
  [846] = 624,
  [847] = 634,
  [848] = 625,
  [849] = 618,
  [850] = 622,
  [851] = 621,
  [852] = 664,
  [853] = 629,
  [854] = 620,
  [855] = 620,
  [856] = 633,
  [857] = 622,
  [858] = 618,
  [859] = 674,
  [860] = 622,
  [861] = 620,
  [862] = 676,
  [863] = 642,
  [864] = 629,
  [865] = 620,
  [866] = 633,
  [867] = 24,
  [868] = 625,
  [869] = 622,
  [870] = 633,
  [871] = 23,
  [872] = 629,
  [873] = 629,
  [874] = 23,
  [875] = 634,
  [876] = 624,
  [877] = 3,
  [878] = 628,
  [879] = 620,
  [880] = 16,
  [881] = 628,
  [882] = 624,
  [883] = 634,
  [884] = 664,
  [885] = 18,
  [886] = 620,
  [887] = 625,
  [888] = 622,
  [889] = 3,
  [890] = 16,
  [891] = 621,
  [892] = 664,
  [893] = 893,
  [894] = 894,
  [895] = 895,
  [896] = 895,
  [897] = 3,
  [898] = 898,
  [899] = 898,
  [900] = 895,
  [901] = 16,
  [902] = 895,
  [903] = 898,
  [904] = 895,
  [905] = 898,
  [906] = 898,
  [907] = 895,
  [908] = 18,
  [909] = 23,
  [910] = 898,
  [911] = 898,
  [912] = 898,
  [913] = 898,
  [914] = 895,
  [915] = 915,
  [916] = 895,
  [917] = 898,
  [918] = 918,
  [919] = 898,
  [920] = 895,
  [921] = 898,
  [922] = 895,
  [923] = 895,
  [924] = 895,
  [925] = 895,
  [926] = 24,
  [927] = 898,
  [928] = 898,
  [929] = 929,
  [930] = 930,
  [931] = 898,
  [932] = 932,
  [933] = 933,
  [934] = 895,
  [935] = 898,
  [936] = 14,
  [937] = 898,
  [938] = 938,
  [939] = 895,
  [940] = 940,
  [941] = 898,
  [942] = 942,
  [943] = 943,
  [944] = 895,
  [945] = 945,
  [946] = 946,
  [947] = 947,
  [948] = 895,
  [949] = 949,
  [950] = 950,
  [951] = 951,
  [952] = 952,
  [953] = 895,
  [954] = 954,
  [955] = 895,
  [956] = 956,
  [957] = 898,
  [958] = 958,
  [959] = 959,
  [960] = 960,
  [961] = 960,
  [962] = 962,
  [963] = 963,
  [964] = 964,
  [965] = 959,
  [966] = 966,
  [967] = 964,
  [968] = 968,
  [969] = 969,
  [970] = 970,
  [971] = 971,
  [972] = 960,
  [973] = 970,
  [974] = 962,
  [975] = 962,
  [976] = 969,
  [977] = 963,
  [978] = 963,
  [979] = 971,
  [980] = 959,
  [981] = 960,
  [982] = 962,
  [983] = 971,
  [984] = 963,
  [985] = 960,
  [986] = 962,
  [987] = 963,
  [988] = 966,
  [989] = 968,
  [990] = 959,
  [991] = 966,
  [992] = 964,
  [993] = 960,
  [994] = 964,
  [995] = 963,
  [996] = 968,
  [997] = 970,
  [998] = 969,
  [999] = 968,
  [1000] = 970,
  [1001] = 969,
  [1002] = 963,
  [1003] = 959,
  [1004] = 968,
  [1005] = 962,
  [1006] = 959,
  [1007] = 960,
  [1008] = 971,
  [1009] = 966,
  [1010] = 964,
  [1011] = 968,
  [1012] = 962,
  [1013] = 971,
  [1014] = 960,
  [1015] = 970,
  [1016] = 962,
  [1017] = 969,
  [1018] = 964,
  [1019] = 966,
  [1020] = 959,
  [1021] = 959,
  [1022] = 963,
  [1023] = 968,
  [1024] = 894,
  [1025] = 963,
  [1026] = 959,
  [1027] = 962,
  [1028] = 966,
  [1029] = 964,
  [1030] = 968,
  [1031] = 971,
  [1032] = 971,
  [1033] = 960,
  [1034] = 970,
  [1035] = 962,
  [1036] = 969,
  [1037] = 962,
  [1038] = 963,
  [1039] = 968,
  [1040] = 959,
  [1041] = 893,
  [1042] = 963,
  [1043] = 963,
  [1044] = 971,
  [1045] = 962,
  [1046] = 960,
  [1047] = 971,
  [1048] = 969,
  [1049] = 970,
  [1050] = 966,
  [1051] = 959,
  [1052] = 966,
  [1053] = 963,
  [1054] = 964,
  [1055] = 968,
  [1056] = 960,
  [1057] = 968,
  [1058] = 960,
  [1059] = 970,
  [1060] = 969,
  [1061] = 962,
  [1062] = 960,
  [1063] = 969,
  [1064] = 959,
  [1065] = 962,
  [1066] = 966,
  [1067] = 964,
  [1068] = 959,
  [1069] = 966,
  [1070] = 971,
  [1071] = 964,
  [1072] = 964,
  [1073] = 966,
  [1074] = 970,
  [1075] = 971,
  [1076] = 968,
  [1077] = 970,
  [1078] = 968,
  [1079] = 969,
  [1080] = 964,
  [1081] = 966,
  [1082] = 971,
  [1083] = 971,
  [1084] = 959,
  [1085] = 960,
  [1086] = 962,
  [1087] = 963,
  [1088] = 968,
  [1089] = 959,
  [1090] = 971,
  [1091] = 966,
  [1092] = 964,
  [1093] = 968,
  [1094] = 970,
  [1095] = 969,
  [1096] = 960,
  [1097] = 963,
  [1098] = 970,
  [1099] = 963,
  [1100] = 968,
  [1101] = 970,
  [1102] = 971,
  [1103] = 969,
  [1104] = 969,
  [1105] = 960,
  [1106] = 962,
  [1107] = 963,
  [1108] = 964,
  [1109] = 970,
  [1110] = 966,
  [1111] = 969,
  [1112] = 968,
  [1113] = 959,
  [1114] = 966,
  [1115] = 964,
  [1116] = 960,
  [1117] = 968,
  [1118] = 970,
  [1119] = 969,
  [1120] = 959,
  [1121] = 959,
  [1122] = 968,
  [1123] = 963,
  [1124] = 962,
  [1125] = 964,
  [1126] = 960,
  [1127] = 971,
  [1128] = 966,
  [1129] = 971,
  [1130] = 959,
  [1131] = 962,
  [1132] = 960,
  [1133] = 966,
  [1134] = 964,
  [1135] = 971,
  [1136] = 971,
  [1137] = 963,
  [1138] = 969,
  [1139] = 962,
  [1140] = 969,
  [1141] = 970,
  [1142] = 970,
  [1143] = 1143,
  [1144] = 1144,
  [1145] = 1143,
  [1146] = 1146,
  [1147] = 1146,
  [1148] = 1144,
  [1149] = 1144,
  [1150] = 1144,
  [1151] = 1143,
  [1152] = 1146,
  [1153] = 1144,
  [1154] = 1146,
  [1155] = 1143,
  [1156] = 1146,
  [1157] = 1143,
  [1158] = 1143,
  [1159] = 1144,
  [1160] = 1160,
  [1161] = 1143,
  [1162] = 1144,
  [1163] = 1143,
  [1164] = 1143,
  [1165] = 1144,
  [1166] = 1146,
  [1167] = 1143,
  [1168] = 1143,
  [1169] = 1143,
  [1170] = 1146,
  [1171] = 1143,
  [1172] = 1146,
  [1173] = 1143,
  [1174] = 1143,
  [1175] = 1144,
  [1176] = 1143,
  [1177] = 1144,
  [1178] = 1143,
  [1179] = 1146,
  [1180] = 1144,
  [1181] = 1146,
  [1182] = 894,
  [1183] = 894,
  [1184] = 893,
  [1185] = 277,
  [1186] = 893,
  [1187] = 1187,
  [1188] = 277,
  [1189] = 894,
  [1190] = 894,
  [1191] = 277,
  [1192] = 1192,
  [1193] = 277,
  [1194] = 277,
  [1195] = 277,
  [1196] = 277,
  [1197] = 277,
  [1198] = 1198,
  [1199] = 1198,
  [1200] = 1198,
  [1201] = 277,
  [1202] = 277,
  [1203] = 277,
  [1204] = 1198,
  [1205] = 1198,
  [1206] = 1198,
  [1207] = 1198,
  [1208] = 1198,
  [1209] = 1198,
  [1210] = 1198,
  [1211] = 277,
  [1212] = 1198,
  [1213] = 1198,
  [1214] = 277,
  [1215] = 1198,
  [1216] = 1198,
  [1217] = 277,
  [1218] = 1198,
  [1219] = 277,
  [1220] = 277,
  [1221] = 1198,
  [1222] = 277,
  [1223] = 277,
  [1224] = 277,
  [1225] = 277,
  [1226] = 277,
  [1227] = 277,
  [1228] = 1228,
  [1229] = 1228,
  [1230] = 1228,
  [1231] = 1228,
  [1232] = 277,
  [1233] = 277,
  [1234] = 1228,
  [1235] = 1228,
  [1236] = 893,
  [1237] = 1228,
  [1238] = 1228,
  [1239] = 1228,
  [1240] = 1228,
  [1241] = 1228,
  [1242] = 277,
  [1243] = 1228,
  [1244] = 1228,
  [1245] = 277,
  [1246] = 1228,
  [1247] = 894,
  [1248] = 1228,
  [1249] = 1249,
  [1250] = 1250,
  [1251] = 1228,
  [1252] = 1252,
  [1253] = 1253,
  [1254] = 894,
  [1255] = 1253,
  [1256] = 1256,
  [1257] = 1252,
  [1258] = 893,
  [1259] = 1253,
  [1260] = 894,
  [1261] = 1252,
  [1262] = 1252,
  [1263] = 1253,
  [1264] = 1253,
  [1265] = 1253,
  [1266] = 1253,
  [1267] = 1252,
  [1268] = 1252,
  [1269] = 1253,
  [1270] = 1252,
  [1271] = 1253,
  [1272] = 1252,
  [1273] = 1252,
  [1274] = 1253,
  [1275] = 1252,
  [1276] = 1253,
  [1277] = 1252,
  [1278] = 893,
  [1279] = 1253,
  [1280] = 893,
  [1281] = 1253,
  [1282] = 1253,
  [1283] = 1253,
  [1284] = 1253,
  [1285] = 1253,
  [1286] = 894,
  [1287] = 1252,
  [1288] = 1252,
  [1289] = 1253,
  [1290] = 1252,
  [1291] = 1252,
  [1292] = 1252,
  [1293] = 1253,
  [1294] = 1253,
  [1295] = 1253,
  [1296] = 1253,
  [1297] = 1253,
  [1298] = 1256,
  [1299] = 1299,
  [1300] = 1299,
  [1301] = 1299,
  [1302] = 1299,
  [1303] = 1299,
  [1304] = 894,
  [1305] = 1299,
  [1306] = 1299,
  [1307] = 894,
  [1308] = 1299,
  [1309] = 1299,
  [1310] = 1299,
  [1311] = 894,
  [1312] = 1299,
  [1313] = 1299,
  [1314] = 1299,
  [1315] = 893,
  [1316] = 1299,
  [1317] = 1299,
  [1318] = 1299,
  [1319] = 893,
  [1320] = 1299,
  [1321] = 1299,
  [1322] = 1299,
  [1323] = 1299,
  [1324] = 1299,
  [1325] = 1299,
  [1326] = 1299,
  [1327] = 1299,
  [1328] = 894,
  [1329] = 1299,
  [1330] = 1299,
  [1331] = 1299,
  [1332] = 894,
  [1333] = 894,
  [1334] = 894,
  [1335] = 894,
  [1336] = 893,
  [1337] = 894,
  [1338] = 893,
  [1339] = 894,
  [1340] = 894,
  [1341] = 894,
  [1342] = 894,
  [1343] = 893,
  [1344] = 893,
  [1345] = 894,
  [1346] = 893,
  [1347] = 894,
  [1348] = 894,
  [1349] = 893,
  [1350] = 894,
  [1351] = 894,
  [1352] = 893,
  [1353] = 893,
  [1354] = 894,
  [1355] = 894,
  [1356] = 894,
  [1357] = 893,
  [1358] = 894,
  [1359] = 1359,
  [1360] = 1360,
  [1361] = 1361,
  [1362] = 1362,
  [1363] = 1359,
  [1364] = 1362,
  [1365] = 1361,
  [1366] = 1366,
  [1367] = 1366,
  [1368] = 1366,
  [1369] = 1366,
  [1370] = 1366,
  [1371] = 1366,
  [1372] = 1361,
  [1373] = 1366,
  [1374] = 1366,
  [1375] = 1366,
  [1376] = 1366,
  [1377] = 1366,
  [1378] = 1366,
  [1379] = 1366,
  [1380] = 1366,
  [1381] = 1366,
  [1382] = 1366,
  [1383] = 1366,
  [1384] = 1366,
  [1385] = 1366,
  [1386] = 1366,
  [1387] = 1366,
  [1388] = 1362,
  [1389] = 1366,
  [1390] = 1366,
  [1391] = 1366,
  [1392] = 1366,
  [1393] = 1366,
  [1394] = 1366,
  [1395] = 1359,
  [1396] = 1366,
  [1397] = 1366,
  [1398] = 1366,
  [1399] = 1366,
  [1400] = 1366,
  [1401] = 1401,
  [1402] = 1401,
  [1403] = 1403,
  [1404] = 1403,
  [1405] = 1401,
  [1406] = 1403,
  [1407] = 1362,
  [1408] = 1403,
  [1409] = 1401,
  [1410] = 1401,
  [1411] = 1361,
  [1412] = 1403,
  [1413] = 1403,
  [1414] = 1403,
  [1415] = 1401,
  [1416] = 1401,
  [1417] = 1401,
  [1418] = 1403,
  [1419] = 1401,
  [1420] = 1401,
  [1421] = 1401,
  [1422] = 1403,
  [1423] = 1403,
  [1424] = 1401,
  [1425] = 1403,
  [1426] = 1401,
  [1427] = 1403,
  [1428] = 1401,
  [1429] = 1403,
  [1430] = 1403,
  [1431] = 1359,
  [1432] = 1401,
  [1433] = 1401,
  [1434] = 1401,
  [1435] = 1403,
  [1436] = 1403,
  [1437] = 1401,
  [1438] = 1403,
  [1439] = 1403,
  [1440] = 1401,
  [1441] = 1403,
  [1442] = 1361,
  [1443] = 1359,
  [1444] = 1362,
  [1445] = 1362,
  [1446] = 1446,
  [1447] = 1447,
  [1448] = 1448,
  [1449] = 1449,
  [1450] = 1446,
  [1451] = 1362,
  [1452] = 1452,
  [1453] = 1359,
  [1454] = 1454,
  [1455] = 1455,
  [1456] = 1359,
  [1457] = 1361,
  [1458] = 1458,
  [1459] = 1447,
  [1460] = 1361,
  [1461] = 1446,
  [1462] = 1449,
  [1463] = 1463,
  [1464] = 1452,
  [1465] = 1361,
  [1466] = 1455,
  [1467] = 1467,
  [1468] = 1447,
  [1469] = 1469,
  [1470] = 1454,
  [1471] = 1362,
  [1472] = 1472,
  [1473] = 1458,
  [1474] = 1359,
  [1475] = 1361,
  [1476] = 1359,
  [1477] = 1477,
  [1478] = 1359,
  [1479] = 1479,
  [1480] = 1361,
  [1481] = 1481,
  [1482] = 1472,
  [1483] = 1362,
  [1484] = 1469,
  [1485] = 1485,
  [1486] = 1362,
  [1487] = 1463,
  [1488] = 1488,
  [1489] = 1489,
  [1490] = 1490,
  [1491] = 1491,
  [1492] = 1362,
  [1493] = 1359,
  [1494] = 1448,
  [1495] = 1495,
  [1496] = 1496,
  [1497] = 1362,
  [1498] = 1359,
  [1499] = 1499,
  [1500] = 1500,
  [1501] = 1501,
  [1502] = 1467,
  [1503] = 1503,
  [1504] = 1481,
  [1505] = 1505,
  [1506] = 1361,
  [1507] = 1361,
  [1508] = 1446,
  [1509] = 1362,
  [1510] = 1449,
  [1511] = 1503,
  [1512] = 1458,
  [1513] = 1485,
  [1514] = 1514,
  [1515] = 1499,
  [1516] = 1359,
  [1517] = 1361,
  [1518] = 1447,
  [1519] = 1361,
  [1520] = 1489,
  [1521] = 1477,
  [1522] = 1359,
  [1523] = 1447,
  [1524] = 1449,
  [1525] = 1452,
  [1526] = 1455,
  [1527] = 1362,
  [1528] = 1454,
  [1529] = 1495,
  [1530] = 1501,
  [1531] = 1455,
  [1532] = 1490,
  [1533] = 1491,
  [1534] = 1496,
  [1535] = 1488,
  [1536] = 1448,
  [1537] = 1446,
  [1538] = 1505,
  [1539] = 1479,
  [1540] = 1500,
  [1541] = 1458,
  [1542] = 1542,
  [1543] = 1543,
  [1544] = 1454,
  [1545] = 1452,
  [1546] = 1514,
  [1547] = 1458,
  [1548] = 1542,
  [1549] = 1549,
  [1550] = 1550,
  [1551] = 1455,
  [1552] = 1463,
  [1553] = 1553,
  [1554] = 1361,
  [1555] = 1472,
  [1556] = 1556,
  [1557] = 1557,
  [1558] = 1558,
  [1559] = 1469,
  [1560] = 1448,
  [1561] = 1561,
  [1562] = 1562,
  [1563] = 1467,
  [1564] = 1564,
  [1565] = 1565,
  [1566] = 1566,
  [1567] = 1567,
  [1568] = 1568,
  [1569] = 1569,
  [1570] = 1570,
  [1571] = 1568,
  [1572] = 1567,
  [1573] = 1570,
  [1574] = 1574,
  [1575] = 1575,
  [1576] = 1561,
  [1577] = 1463,
  [1578] = 1558,
  [1579] = 1472,
  [1580] = 1449,
  [1581] = 1581,
  [1582] = 1449,
  [1583] = 1458,
  [1584] = 1584,
  [1585] = 1585,
  [1586] = 1469,
  [1587] = 1574,
  [1588] = 1588,
  [1589] = 1447,
  [1590] = 1565,
  [1591] = 1467,
  [1592] = 1359,
  [1593] = 1593,
  [1594] = 1455,
  [1595] = 1553,
  [1596] = 1562,
  [1597] = 1597,
  [1598] = 1598,
  [1599] = 1362,
  [1600] = 1600,
  [1601] = 1601,
  [1602] = 1602,
  [1603] = 1564,
  [1604] = 1604,
  [1605] = 1605,
  [1606] = 1446,
  [1607] = 1607,
  [1608] = 1564,
  [1609] = 1609,
  [1610] = 1610,
  [1611] = 1611,
  [1612] = 1612,
  [1613] = 1613,
  [1614] = 1614,
  [1615] = 1615,
  [1616] = 1616,
  [1617] = 1617,
  [1618] = 1618,
  [1619] = 1619,
  [1620] = 1620,
  [1621] = 1621,
  [1622] = 1361,
  [1623] = 1623,
  [1624] = 1624,
  [1625] = 1625,
  [1626] = 1626,
  [1627] = 1362,
  [1628] = 1553,
  [1629] = 1629,
  [1630] = 1630,
  [1631] = 1489,
  [1632] = 1485,
  [1633] = 1359,
  [1634] = 1634,
  [1635] = 1635,
  [1636] = 1500,
  [1637] = 1593,
  [1638] = 1597,
  [1639] = 1495,
  [1640] = 1598,
  [1641] = 1467,
  [1642] = 1607,
  [1643] = 1604,
  [1644] = 1499,
  [1645] = 1588,
  [1646] = 1646,
  [1647] = 1647,
  [1648] = 1562,
  [1649] = 1564,
  [1650] = 1650,
  [1651] = 1651,
  [1652] = 1652,
  [1653] = 1565,
  [1654] = 1654,
  [1655] = 1542,
  [1656] = 1602,
  [1657] = 1601,
  [1658] = 1658,
  [1659] = 1659,
  [1660] = 1660,
  [1661] = 1469,
  [1662] = 1662,
  [1663] = 1663,
  [1664] = 1664,
  [1665] = 1665,
  [1666] = 1666,
  [1667] = 1556,
  [1668] = 1668,
  [1669] = 1553,
  [1670] = 1670,
  [1671] = 1581,
  [1672] = 1543,
  [1673] = 1673,
  [1674] = 1562,
  [1675] = 1675,
  [1676] = 1565,
  [1677] = 1677,
  [1678] = 1678,
  [1679] = 1679,
  [1680] = 1680,
  [1681] = 1681,
  [1682] = 1467,
  [1683] = 1683,
  [1684] = 1684,
  [1685] = 1685,
  [1686] = 1686,
  [1687] = 1687,
  [1688] = 1688,
  [1689] = 1463,
  [1690] = 1690,
  [1691] = 1570,
  [1692] = 1558,
  [1693] = 1568,
  [1694] = 1567,
  [1695] = 1695,
  [1696] = 1585,
  [1697] = 1584,
  [1698] = 1698,
  [1699] = 1699,
  [1700] = 1700,
  [1701] = 1448,
  [1702] = 1702,
  [1703] = 1703,
  [1704] = 1561,
  [1705] = 1705,
  [1706] = 1706,
  [1707] = 1707,
  [1708] = 1708,
  [1709] = 1605,
  [1710] = 1710,
  [1711] = 1472,
  [1712] = 1550,
  [1713] = 1448,
  [1714] = 1714,
  [1715] = 1715,
  [1716] = 1561,
  [1717] = 1575,
  [1718] = 1718,
  [1719] = 1719,
  [1720] = 1720,
  [1721] = 1721,
  [1722] = 1569,
  [1723] = 1588,
  [1724] = 1724,
  [1725] = 1725,
  [1726] = 1558,
  [1727] = 1727,
  [1728] = 1728,
  [1729] = 1542,
  [1730] = 1730,
  [1731] = 1731,
  [1732] = 1732,
  [1733] = 1733,
  [1734] = 1496,
  [1735] = 1735,
  [1736] = 1736,
  [1737] = 1604,
  [1738] = 1549,
  [1739] = 1739,
  [1740] = 1740,
  [1741] = 1741,
  [1742] = 1742,
  [1743] = 1488,
  [1744] = 1607,
  [1745] = 1745,
  [1746] = 1746,
  [1747] = 1598,
  [1748] = 1499,
  [1749] = 1597,
  [1750] = 1469,
  [1751] = 1751,
  [1752] = 1752,
  [1753] = 1753,
  [1754] = 1754,
  [1755] = 1500,
  [1756] = 1593,
  [1757] = 1495,
  [1758] = 1472,
  [1759] = 1503,
  [1760] = 1760,
  [1761] = 1761,
  [1762] = 1762,
  [1763] = 1763,
  [1764] = 1463,
  [1765] = 1765,
  [1766] = 1766,
  [1767] = 1767,
  [1768] = 1501,
  [1769] = 1566,
  [1770] = 1770,
  [1771] = 1490,
  [1772] = 1491,
  [1773] = 1773,
  [1774] = 1774,
  [1775] = 1489,
  [1776] = 1505,
  [1777] = 1777,
  [1778] = 1778,
  [1779] = 1779,
  [1780] = 1477,
  [1781] = 1781,
  [1782] = 1782,
  [1783] = 1783,
  [1784] = 1784,
  [1785] = 1570,
  [1786] = 1568,
  [1787] = 1787,
  [1788] = 1788,
  [1789] = 1789,
  [1790] = 1790,
  [1791] = 1791,
  [1792] = 1792,
  [1793] = 1567,
  [1794] = 1794,
  [1795] = 1600,
  [1796] = 1479,
  [1797] = 1797,
  [1798] = 1798,
  [1799] = 1496,
  [1800] = 1557,
  [1801] = 1801,
  [1802] = 1802,
  [1803] = 1803,
  [1804] = 1804,
  [1805] = 1805,
  [1806] = 1806,
  [1807] = 1479,
  [1808] = 1695,
  [1809] = 1746,
  [1810] = 1624,
  [1811] = 1745,
  [1812] = 1735,
  [1813] = 1731,
  [1814] = 1730,
  [1815] = 1728,
  [1816] = 1724,
  [1817] = 1651,
  [1818] = 1652,
  [1819] = 1718,
  [1820] = 1635,
  [1821] = 1634,
  [1822] = 1630,
  [1823] = 1629,
  [1824] = 1626,
  [1825] = 1625,
  [1826] = 1489,
  [1827] = 1623,
  [1828] = 1754,
  [1829] = 1680,
  [1830] = 1665,
  [1831] = 1621,
  [1832] = 1715,
  [1833] = 1663,
  [1834] = 1620,
  [1835] = 1619,
  [1836] = 1495,
  [1837] = 1710,
  [1838] = 1708,
  [1839] = 1618,
  [1840] = 1658,
  [1841] = 1609,
  [1842] = 1617,
  [1843] = 1616,
  [1844] = 1706,
  [1845] = 1660,
  [1846] = 1846,
  [1847] = 1615,
  [1848] = 1613,
  [1849] = 1798,
  [1850] = 1611,
  [1851] = 1707,
  [1852] = 1702,
  [1853] = 1700,
  [1854] = 1662,
  [1855] = 1455,
  [1856] = 1727,
  [1857] = 1732,
  [1858] = 1699,
  [1859] = 1733,
  [1860] = 1668,
  [1861] = 1654,
  [1862] = 1489,
  [1863] = 1685,
  [1864] = 1736,
  [1865] = 1784,
  [1866] = 1781,
  [1867] = 1846,
  [1868] = 1503,
  [1869] = 1679,
  [1870] = 1500,
  [1871] = 1670,
  [1872] = 1681,
  [1873] = 1684,
  [1874] = 1741,
  [1875] = 1742,
  [1876] = 1501,
  [1877] = 1751,
  [1878] = 1496,
  [1879] = 1805,
  [1880] = 1490,
  [1881] = 1777,
  [1882] = 1491,
  [1883] = 1725,
  [1884] = 1647,
  [1885] = 1499,
  [1886] = 1678,
  [1887] = 1686,
  [1888] = 1779,
  [1889] = 1687,
  [1890] = 1688,
  [1891] = 1690,
  [1892] = 1698,
  [1893] = 1677,
  [1894] = 1719,
  [1895] = 1673,
  [1896] = 1505,
  [1897] = 1721,
  [1898] = 1720,
  [1899] = 1714,
  [1900] = 1646,
  [1901] = 1705,
  [1902] = 1703,
  [1903] = 1787,
  [1904] = 1739,
  [1905] = 1790,
  [1906] = 1794,
  [1907] = 1477,
  [1908] = 1797,
  [1909] = 1675,
  [1910] = 1740,
  [1911] = 1666,
  [1912] = 1783,
  [1913] = 1664,
  [1914] = 1683,
  [1915] = 1761,
  [1916] = 1762,
  [1917] = 1593,
  [1918] = 1597,
  [1919] = 1614,
  [1920] = 1598,
  [1921] = 1806,
  [1922] = 1791,
  [1923] = 1659,
  [1924] = 1449,
  [1925] = 1792,
  [1926] = 1763,
  [1927] = 1804,
  [1928] = 1765,
  [1929] = 1803,
  [1930] = 1607,
  [1931] = 1802,
  [1932] = 1766,
  [1933] = 1767,
  [1934] = 1495,
  [1935] = 1801,
  [1936] = 1770,
  [1937] = 1773,
  [1938] = 1500,
  [1939] = 1774,
  [1940] = 1778,
  [1941] = 1514,
  [1942] = 1604,
  [1943] = 1485,
  [1944] = 1458,
  [1945] = 1782,
  [1946] = 1496,
  [1947] = 1499,
  [1948] = 1753,
  [1949] = 1760,
  [1950] = 1588,
  [1951] = 1752,
  [1952] = 1650,
  [1953] = 1610,
  [1954] = 1788,
  [1955] = 1789,
  [1956] = 1488,
  [1957] = 1612,
  [1958] = 1612,
  [1959] = 1467,
  [1960] = 1574,
  [1961] = 1448,
  [1962] = 1566,
  [1963] = 1463,
  [1964] = 1448,
  [1965] = 1574,
  [1966] = 1514,
  [1967] = 1455,
  [1968] = 1469,
  [1969] = 1584,
  [1970] = 1610,
  [1971] = 1458,
  [1972] = 1585,
  [1973] = 1556,
  [1974] = 1549,
  [1975] = 1448,
  [1976] = 1449,
  [1977] = 1472,
  [1978] = 1543,
  [1979] = 1581,
  [1980] = 1683,
  [1981] = 1557,
  [1982] = 1550,
  [1983] = 1601,
  [1984] = 1611,
  [1985] = 1762,
  [1986] = 1557,
  [1987] = 1467,
  [1988] = 1584,
  [1989] = 1585,
  [1990] = 1686,
  [1991] = 1614,
  [1992] = 1543,
  [1993] = 1581,
  [1994] = 1556,
  [1995] = 1647,
  [1996] = 1601,
  [1997] = 1630,
  [1998] = 1446,
  [1999] = 1650,
  [2000] = 1458,
  [2001] = 1654,
  [2002] = 1447,
  [2003] = 1663,
  [2004] = 1665,
  [2005] = 1610,
  [2006] = 1707,
  [2007] = 1659,
  [2008] = 1549,
  [2009] = 1496,
  [2010] = 1664,
  [2011] = 1666,
  [2012] = 1792,
  [2013] = 1791,
  [2014] = 1673,
  [2015] = 1677,
  [2016] = 1678,
  [2017] = 1489,
  [2018] = 1679,
  [2019] = 1495,
  [2020] = 1685,
  [2021] = 1695,
  [2022] = 1699,
  [2023] = 1634,
  [2024] = 1700,
  [2025] = 1683,
  [2026] = 1702,
  [2027] = 1550,
  [2028] = 1706,
  [2029] = 1740,
  [2030] = 1714,
  [2031] = 1609,
  [2032] = 1635,
  [2033] = 1708,
  [2034] = 1710,
  [2035] = 1739,
  [2036] = 1715,
  [2037] = 1718,
  [2038] = 1724,
  [2039] = 1660,
  [2040] = 1728,
  [2041] = 1720,
  [2042] = 1721,
  [2043] = 1730,
  [2044] = 1731,
  [2045] = 1613,
  [2046] = 1735,
  [2047] = 1745,
  [2048] = 1746,
  [2049] = 1615,
  [2050] = 1703,
  [2051] = 1760,
  [2052] = 1761,
  [2053] = 1469,
  [2054] = 1725,
  [2055] = 1727,
  [2056] = 1732,
  [2057] = 1733,
  [2058] = 1705,
  [2059] = 1781,
  [2060] = 1616,
  [2061] = 1763,
  [2062] = 1698,
  [2063] = 1736,
  [2064] = 1765,
  [2065] = 1690,
  [2066] = 1784,
  [2067] = 1741,
  [2068] = 1766,
  [2069] = 1742,
  [2070] = 1646,
  [2071] = 1751,
  [2072] = 1754,
  [2073] = 1767,
  [2074] = 1651,
  [2075] = 1770,
  [2076] = 1629,
  [2077] = 1652,
  [2078] = 1500,
  [2079] = 1449,
  [2080] = 1688,
  [2081] = 1454,
  [2082] = 1773,
  [2083] = 1626,
  [2084] = 1777,
  [2085] = 1774,
  [2086] = 1778,
  [2087] = 1499,
  [2088] = 1448,
  [2089] = 1463,
  [2090] = 1617,
  [2091] = 1455,
  [2092] = 1779,
  [2093] = 1782,
  [2094] = 1788,
  [2095] = 1789,
  [2096] = 1448,
  [2097] = 1625,
  [2098] = 1566,
  [2099] = 1798,
  [2100] = 1452,
  [2101] = 1684,
  [2102] = 1681,
  [2103] = 1801,
  [2104] = 1670,
  [2105] = 1802,
  [2106] = 1803,
  [2107] = 1624,
  [2108] = 1804,
  [2109] = 1658,
  [2110] = 1787,
  [2111] = 1790,
  [2112] = 1618,
  [2113] = 1619,
  [2114] = 1623,
  [2115] = 1794,
  [2116] = 1621,
  [2117] = 1797,
  [2118] = 1675,
  [2119] = 1612,
  [2120] = 1806,
  [2121] = 1805,
  [2122] = 1472,
  [2123] = 1620,
  [2124] = 1659,
  [2125] = 1652,
  [2126] = 1792,
  [2127] = 1706,
  [2128] = 1710,
  [2129] = 1452,
  [2130] = 1654,
  [2131] = 1663,
  [2132] = 1609,
  [2133] = 1700,
  [2134] = 1708,
  [2135] = 1725,
  [2136] = 1699,
  [2137] = 1778,
  [2138] = 1454,
  [2139] = 1695,
  [2140] = 1616,
  [2141] = 1794,
  [2142] = 1624,
  [2143] = 1685,
  [2144] = 1790,
  [2145] = 1679,
  [2146] = 1766,
  [2147] = 1678,
  [2148] = 1646,
  [2149] = 1677,
  [2150] = 1625,
  [2151] = 1449,
  [2152] = 1715,
  [2153] = 1673,
  [2154] = 1666,
  [2155] = 1658,
  [2156] = 1787,
  [2157] = 1660,
  [2158] = 1718,
  [2159] = 1724,
  [2160] = 1626,
  [2161] = 1496,
  [2162] = 1774,
  [2163] = 1736,
  [2164] = 1618,
  [2165] = 1458,
  [2166] = 1740,
  [2167] = 1739,
  [2168] = 1664,
  [2169] = 1447,
  [2170] = 1728,
  [2171] = 1730,
  [2172] = 1447,
  [2173] = 1619,
  [2174] = 1448,
  [2175] = 1702,
  [2176] = 1731,
  [2177] = 1650,
  [2178] = 1797,
  [2179] = 1452,
  [2180] = 1675,
  [2181] = 1735,
  [2182] = 1707,
  [2183] = 1745,
  [2184] = 1629,
  [2185] = 1803,
  [2186] = 1798,
  [2187] = 1617,
  [2188] = 1741,
  [2189] = 1454,
  [2190] = 1791,
  [2191] = 1489,
  [2192] = 1454,
  [2193] = 1746,
  [2194] = 1703,
  [2195] = 1635,
  [2196] = 1773,
  [2197] = 1647,
  [2198] = 1742,
  [2199] = 1447,
  [2200] = 1732,
  [2201] = 1630,
  [2202] = 1615,
  [2203] = 1446,
  [2204] = 1634,
  [2205] = 1727,
  [2206] = 1620,
  [2207] = 1447,
  [2208] = 1698,
  [2209] = 1733,
  [2210] = 1690,
  [2211] = 1688,
  [2212] = 1751,
  [2213] = 1801,
  [2214] = 1651,
  [2215] = 1754,
  [2216] = 1765,
  [2217] = 1488,
  [2218] = 1767,
  [2219] = 1472,
  [2220] = 1458,
  [2221] = 1770,
  [2222] = 1802,
  [2223] = 1789,
  [2224] = 1448,
  [2225] = 1621,
  [2226] = 1763,
  [2227] = 1613,
  [2228] = 1623,
  [2229] = 1788,
  [2230] = 1684,
  [2231] = 1806,
  [2232] = 1779,
  [2233] = 1449,
  [2234] = 1614,
  [2235] = 1681,
  [2236] = 1784,
  [2237] = 1670,
  [2238] = 1805,
  [2239] = 1762,
  [2240] = 1446,
  [2241] = 1446,
  [2242] = 1611,
  [2243] = 1781,
  [2244] = 1446,
  [2245] = 1495,
  [2246] = 1455,
  [2247] = 1452,
  [2248] = 1686,
  [2249] = 1777,
  [2250] = 1761,
  [2251] = 1469,
  [2252] = 1500,
  [2253] = 1455,
  [2254] = 1714,
  [2255] = 1720,
  [2256] = 1467,
  [2257] = 1499,
  [2258] = 1782,
  [2259] = 1705,
  [2260] = 1721,
  [2261] = 1485,
  [2262] = 1463,
  [2263] = 1665,
  [2264] = 1804,
  [2265] = 1760,
  [2266] = 1452,
  [2267] = 1446,
  [2268] = 1463,
  [2269] = 1495,
  [2270] = 1472,
  [2271] = 1458,
  [2272] = 1446,
  [2273] = 1452,
  [2274] = 1489,
  [2275] = 1454,
  [2276] = 1472,
  [2277] = 1454,
  [2278] = 1503,
  [2279] = 1458,
  [2280] = 1446,
  [2281] = 1505,
  [2282] = 1479,
  [2283] = 1469,
  [2284] = 1463,
  [2285] = 1449,
  [2286] = 1499,
  [2287] = 1446,
  [2288] = 1455,
  [2289] = 1446,
  [2290] = 1447,
  [2291] = 1449,
  [2292] = 1467,
  [2293] = 1455,
  [2294] = 1477,
  [2295] = 1469,
  [2296] = 1447,
  [2297] = 1467,
  [2298] = 1496,
  [2299] = 1500,
  [2300] = 2300,
  [2301] = 1446,
  [2302] = 1447,
  [2303] = 1501,
  [2304] = 1490,
  [2305] = 1491,
  [2306] = 1447,
  [2307] = 1446,
  [2308] = 1447,
  [2309] = 1452,
  [2310] = 1452,
  [2311] = 1448,
  [2312] = 1489,
  [2313] = 1495,
  [2314] = 1454,
  [2315] = 1488,
  [2316] = 1449,
  [2317] = 1500,
  [2318] = 1446,
  [2319] = 1505,
  [2320] = 1455,
  [2321] = 1452,
  [2322] = 1496,
  [2323] = 1469,
  [2324] = 1449,
  [2325] = 1454,
  [2326] = 1472,
  [2327] = 1458,
  [2328] = 1499,
  [2329] = 1485,
  [2330] = 1447,
  [2331] = 1479,
  [2332] = 1449,
  [2333] = 1499,
  [2334] = 1446,
  [2335] = 1556,
  [2336] = 1566,
  [2337] = 1501,
  [2338] = 1503,
  [2339] = 1463,
  [2340] = 1447,
  [2341] = 1569,
  [2342] = 1448,
  [2343] = 1500,
  [2344] = 1458,
  [2345] = 1446,
  [2346] = 1514,
  [2347] = 1501,
  [2348] = 1449,
  [2349] = 1458,
  [2350] = 1575,
  [2351] = 1455,
  [2352] = 1490,
  [2353] = 1491,
  [2354] = 1447,
  [2355] = 1505,
  [2356] = 1479,
  [2357] = 1602,
  [2358] = 1550,
  [2359] = 1477,
  [2360] = 1455,
  [2361] = 1488,
  [2362] = 1503,
  [2363] = 1496,
  [2364] = 1469,
  [2365] = 1447,
  [2366] = 1446,
  [2367] = 1549,
  [2368] = 1455,
  [2369] = 1458,
  [2370] = 1485,
  [2371] = 1467,
  [2372] = 1495,
  [2373] = 1467,
  [2374] = 1489,
  [2375] = 1448,
  [2376] = 1452,
  [2377] = 1448,
  [2378] = 1448,
  [2379] = 1458,
  [2380] = 1454,
  [2381] = 1449,
  [2382] = 1477,
  [2383] = 1449,
  [2384] = 1557,
  [2385] = 1491,
  [2386] = 1463,
  [2387] = 1490,
  [2388] = 1454,
  [2389] = 1458,
  [2390] = 1472,
  [2391] = 1469,
  [2392] = 1732,
  [2393] = 1728,
  [2394] = 1658,
  [2395] = 1724,
  [2396] = 1718,
  [2397] = 1600,
  [2398] = 1715,
  [2399] = 1668,
  [2400] = 1710,
  [2401] = 1708,
  [2402] = 1609,
  [2403] = 1706,
  [2404] = 1660,
  [2405] = 1680,
  [2406] = 1670,
  [2407] = 1681,
  [2408] = 1684,
  [2409] = 1449,
  [2410] = 1702,
  [2411] = 1700,
  [2412] = 1699,
  [2413] = 1695,
  [2414] = 1452,
  [2415] = 1685,
  [2416] = 1454,
  [2417] = 1679,
  [2418] = 1678,
  [2419] = 1677,
  [2420] = 1673,
  [2421] = 1688,
  [2422] = 1690,
  [2423] = 1698,
  [2424] = 1703,
  [2425] = 1666,
  [2426] = 1664,
  [2427] = 1652,
  [2428] = 1651,
  [2429] = 1739,
  [2430] = 1659,
  [2431] = 1740,
  [2432] = 1574,
  [2433] = 1485,
  [2434] = 1791,
  [2435] = 1792,
  [2436] = 1646,
  [2437] = 1665,
  [2438] = 1663,
  [2439] = 1635,
  [2440] = 1634,
  [2441] = 1806,
  [2442] = 1630,
  [2443] = 1458,
  [2444] = 1449,
  [2445] = 1730,
  [2446] = 1731,
  [2447] = 1629,
  [2448] = 1735,
  [2449] = 1472,
  [2450] = 1662,
  [2451] = 1463,
  [2452] = 1654,
  [2453] = 1472,
  [2454] = 1745,
  [2455] = 1455,
  [2456] = 1500,
  [2457] = 1463,
  [2458] = 1485,
  [2459] = 1626,
  [2460] = 1746,
  [2461] = 1625,
  [2462] = 1624,
  [2463] = 1650,
  [2464] = 1499,
  [2465] = 1623,
  [2466] = 1455,
  [2467] = 1467,
  [2468] = 1621,
  [2469] = 1620,
  [2470] = 1619,
  [2471] = 1454,
  [2472] = 1447,
  [2473] = 1760,
  [2474] = 1761,
  [2475] = 1762,
  [2476] = 1503,
  [2477] = 1458,
  [2478] = 1469,
  [2479] = 1496,
  [2480] = 1763,
  [2481] = 1647,
  [2482] = 1449,
  [2483] = 1588,
  [2484] = 1446,
  [2485] = 1765,
  [2486] = 1467,
  [2487] = 1766,
  [2488] = 1618,
  [2489] = 1601,
  [2490] = 1767,
  [2491] = 1488,
  [2492] = 1617,
  [2493] = 1472,
  [2494] = 1463,
  [2495] = 1770,
  [2496] = 1581,
  [2497] = 1773,
  [2498] = 1774,
  [2499] = 1778,
  [2500] = 1543,
  [2501] = 1616,
  [2502] = 1782,
  [2503] = 1472,
  [2504] = 1463,
  [2505] = 1788,
  [2506] = 1789,
  [2507] = 1469,
  [2508] = 1585,
  [2509] = 1584,
  [2510] = 1614,
  [2511] = 1467,
  [2512] = 1798,
  [2513] = 1615,
  [2514] = 1448,
  [2515] = 1501,
  [2516] = 1490,
  [2517] = 1491,
  [2518] = 1613,
  [2519] = 1611,
  [2520] = 1489,
  [2521] = 1495,
  [2522] = 1801,
  [2523] = 1467,
  [2524] = 1500,
  [2525] = 1446,
  [2526] = 1707,
  [2527] = 1802,
  [2528] = 1447,
  [2529] = 1803,
  [2530] = 1804,
  [2531] = 1499,
  [2532] = 1447,
  [2533] = 1714,
  [2534] = 1720,
  [2535] = 1721,
  [2536] = 1496,
  [2537] = 1446,
  [2538] = 1514,
  [2539] = 1458,
  [2540] = 1505,
  [2541] = 1479,
  [2542] = 1446,
  [2543] = 1683,
  [2544] = 1448,
  [2545] = 1446,
  [2546] = 1686,
  [2547] = 1805,
  [2548] = 1458,
  [2549] = 1705,
  [2550] = 1568,
  [2551] = 1675,
  [2552] = 1797,
  [2553] = 1455,
  [2554] = 1794,
  [2555] = 1447,
  [2556] = 1542,
  [2557] = 1558,
  [2558] = 1790,
  [2559] = 1787,
  [2560] = 1781,
  [2561] = 1784,
  [2562] = 1604,
  [2563] = 1561,
  [2564] = 1610,
  [2565] = 1447,
  [2566] = 1477,
  [2567] = 1485,
  [2568] = 1567,
  [2569] = 1452,
  [2570] = 1469,
  [2571] = 1593,
  [2572] = 1568,
  [2573] = 1597,
  [2574] = 1598,
  [2575] = 1469,
  [2576] = 1612,
  [2577] = 1446,
  [2578] = 1605,
  [2579] = 1783,
  [2580] = 1455,
  [2581] = 1565,
  [2582] = 1467,
  [2583] = 1489,
  [2584] = 1564,
  [2585] = 1488,
  [2586] = 1495,
  [2587] = 1562,
  [2588] = 1553,
  [2589] = 1452,
  [2590] = 1542,
  [2591] = 1514,
  [2592] = 1607,
  [2593] = 1469,
  [2594] = 1558,
  [2595] = 1561,
  [2596] = 1779,
  [2597] = 1553,
  [2598] = 1570,
  [2599] = 1454,
  [2600] = 1488,
  [2601] = 1567,
  [2602] = 1467,
  [2603] = 1447,
  [2604] = 1777,
  [2605] = 1449,
  [2606] = 1753,
  [2607] = 1687,
  [2608] = 1448,
  [2609] = 1736,
  [2610] = 1727,
  [2611] = 1742,
  [2612] = 1741,
  [2613] = 1752,
  [2614] = 1725,
  [2615] = 1733,
  [2616] = 1719,
  [2617] = 1562,
  [2618] = 1570,
  [2619] = 1754,
  [2620] = 1751,
  [2621] = 1564,
  [2622] = 1565,
  [2623] = 1490,
  [2624] = 2624,
  [2625] = 1553,
  [2626] = 1561,
  [2627] = 1558,
  [2628] = 1588,
  [2629] = 1542,
  [2630] = 1558,
  [2631] = 1561,
  [2632] = 1567,
  [2633] = 1503,
  [2634] = 1607,
  [2635] = 1557,
  [2636] = 1568,
  [2637] = 1542,
  [2638] = 1570,
  [2639] = 2639,
  [2640] = 1562,
  [2641] = 1564,
  [2642] = 1553,
  [2643] = 1447,
  [2644] = 1449,
  [2645] = 1565,
  [2646] = 1598,
  [2647] = 1597,
  [2648] = 1562,
  [2649] = 1564,
  [2650] = 1593,
  [2651] = 1565,
  [2652] = 1565,
  [2653] = 1570,
  [2654] = 1568,
  [2655] = 1569,
  [2656] = 1567,
  [2657] = 1501,
  [2658] = 1499,
  [2659] = 1490,
  [2660] = 1567,
  [2661] = 1489,
  [2662] = 1566,
  [2663] = 1549,
  [2664] = 1561,
  [2665] = 1558,
  [2666] = 1467,
  [2667] = 1570,
  [2668] = 1556,
  [2669] = 2669,
  [2670] = 2624,
  [2671] = 1584,
  [2672] = 1585,
  [2673] = 1491,
  [2674] = 1568,
  [2675] = 1593,
  [2676] = 1565,
  [2677] = 1550,
  [2678] = 1500,
  [2679] = 1604,
  [2680] = 1489,
  [2681] = 1568,
  [2682] = 1505,
  [2683] = 1495,
  [2684] = 1479,
  [2685] = 1567,
  [2686] = 1542,
  [2687] = 1477,
  [2688] = 1564,
  [2689] = 1500,
  [2690] = 1543,
  [2691] = 1581,
  [2692] = 1514,
  [2693] = 1575,
  [2694] = 1561,
  [2695] = 1558,
  [2696] = 1452,
  [2697] = 1542,
  [2698] = 1558,
  [2699] = 1597,
  [2700] = 1550,
  [2701] = 1598,
  [2702] = 1561,
  [2703] = 1601,
  [2704] = 1562,
  [2705] = 1600,
  [2706] = 1553,
  [2707] = 1557,
  [2708] = 1665,
  [2709] = 1549,
  [2710] = 1567,
  [2711] = 1605,
  [2712] = 1556,
  [2713] = 1454,
  [2714] = 1663,
  [2715] = 1607,
  [2716] = 1568,
  [2717] = 1499,
  [2718] = 1588,
  [2719] = 1654,
  [2720] = 1602,
  [2721] = 1570,
  [2722] = 1542,
  [2723] = 1565,
  [2724] = 1488,
  [2725] = 1564,
  [2726] = 1495,
  [2727] = 1469,
  [2728] = 1564,
  [2729] = 2669,
  [2730] = 1549,
  [2731] = 1562,
  [2732] = 1557,
  [2733] = 1448,
  [2734] = 1604,
  [2735] = 1503,
  [2736] = 1495,
  [2737] = 1647,
  [2738] = 1553,
  [2739] = 1448,
  [2740] = 1477,
  [2741] = 1472,
  [2742] = 1604,
  [2743] = 1463,
  [2744] = 1472,
  [2745] = 1463,
  [2746] = 1574,
  [2747] = 1469,
  [2748] = 1550,
  [2749] = 1570,
  [2750] = 1449,
  [2751] = 1574,
  [2752] = 1574,
  [2753] = 1562,
  [2754] = 1467,
  [2755] = 1479,
  [2756] = 1463,
  [2757] = 1505,
  [2758] = 1607,
  [2759] = 1588,
  [2760] = 1597,
  [2761] = 1553,
  [2762] = 1467,
  [2763] = 1593,
  [2764] = 1454,
  [2765] = 1455,
  [2766] = 1605,
  [2767] = 1491,
  [2768] = 1501,
  [2769] = 1485,
  [2770] = 1600,
  [2771] = 1455,
  [2772] = 1489,
  [2773] = 1499,
  [2774] = 1458,
  [2775] = 1469,
  [2776] = 1574,
  [2777] = 1598,
  [2778] = 1501,
  [2779] = 1495,
  [2780] = 1485,
  [2781] = 1467,
  [2782] = 1503,
  [2783] = 1500,
  [2784] = 1499,
  [2785] = 1446,
  [2786] = 1496,
  [2787] = 1542,
  [2788] = 1602,
  [2789] = 1490,
  [2790] = 1574,
  [2791] = 1500,
  [2792] = 1496,
  [2793] = 1446,
  [2794] = 1458,
  [2795] = 1472,
  [2796] = 1558,
  [2797] = 1561,
  [2798] = 1458,
  [2799] = 1593,
  [2800] = 1597,
  [2801] = 1575,
  [2802] = 1452,
  [2803] = 1449,
  [2804] = 1489,
  [2805] = 1598,
  [2806] = 1495,
  [2807] = 1607,
  [2808] = 1604,
  [2809] = 1500,
  [2810] = 1588,
  [2811] = 1605,
  [2812] = 1491,
  [2813] = 1488,
  [2814] = 1500,
  [2815] = 1600,
  [2816] = 1499,
  [2817] = 1665,
  [2818] = 1663,
  [2819] = 1489,
  [2820] = 1565,
  [2821] = 1455,
  [2822] = 1556,
  [2823] = 2639,
  [2824] = 1557,
  [2825] = 1568,
  [2826] = 1553,
  [2827] = 1562,
  [2828] = 1447,
  [2829] = 1564,
  [2830] = 1565,
  [2831] = 1570,
  [2832] = 1654,
  [2833] = 1570,
  [2834] = 1568,
  [2835] = 1567,
  [2836] = 1447,
  [2837] = 1561,
  [2838] = 1558,
  [2839] = 1477,
  [2840] = 1569,
  [2841] = 1458,
  [2842] = 1556,
  [2843] = 1542,
  [2844] = 1469,
  [2845] = 1566,
  [2846] = 1446,
  [2847] = 1565,
  [2848] = 1567,
  [2849] = 1455,
  [2850] = 1562,
  [2851] = 1564,
  [2852] = 1496,
  [2853] = 1479,
  [2854] = 1505,
  [2855] = 1472,
  [2856] = 1503,
  [2857] = 1446,
  [2858] = 1542,
  [2859] = 1463,
  [2860] = 1601,
  [2861] = 1647,
  [2862] = 1549,
  [2863] = 1558,
  [2864] = 1561,
  [2865] = 1553,
  [2866] = 1449,
  [2867] = 1499,
  [2868] = 1567,
  [2869] = 1568,
  [2870] = 1584,
  [2871] = 1585,
  [2872] = 1495,
  [2873] = 1491,
  [2874] = 1505,
  [2875] = 1490,
  [2876] = 1581,
  [2877] = 1543,
  [2878] = 1501,
  [2879] = 1489,
  [2880] = 1447,
  [2881] = 1479,
  [2882] = 1570,
  [2883] = 1477,
  [2884] = 1496,
  [2885] = 1550,
  [2886] = 1553,
  [2887] = 1562,
  [2888] = 1564,
  [2889] = 1629,
  [2890] = 1575,
  [2891] = 1463,
  [2892] = 1607,
  [2893] = 1588,
  [2894] = 1605,
  [2895] = 1787,
  [2896] = 1790,
  [2897] = 1651,
  [2898] = 1553,
  [2899] = 1600,
  [2900] = 1588,
  [2901] = 1779,
  [2902] = 1556,
  [2903] = 1514,
  [2904] = 1593,
  [2905] = 1550,
  [2906] = 1791,
  [2907] = 1683,
  [2908] = 1488,
  [2909] = 1777,
  [2910] = 1447,
  [2911] = 1792,
  [2912] = 1604,
  [2913] = 1794,
  [2914] = 1797,
  [2915] = 1593,
  [2916] = 1597,
  [2917] = 1472,
  [2918] = 1753,
  [2919] = 1752,
  [2920] = 1675,
  [2921] = 1549,
  [2922] = 1448,
  [2923] = 1754,
  [2924] = 1751,
  [2925] = 1604,
  [2926] = 1742,
  [2927] = 1652,
  [2928] = 1597,
  [2929] = 1741,
  [2930] = 1598,
  [2931] = 1740,
  [2932] = 1607,
  [2933] = 1604,
  [2934] = 1739,
  [2935] = 1806,
  [2936] = 1736,
  [2937] = 1604,
  [2938] = 1805,
  [2939] = 1610,
  [2940] = 1593,
  [2941] = 1495,
  [2942] = 1804,
  [2943] = 1803,
  [2944] = 1802,
  [2945] = 1719,
  [2946] = 1801,
  [2947] = 1733,
  [2948] = 1732,
  [2949] = 1485,
  [2950] = 1727,
  [2951] = 1798,
  [2952] = 1725,
  [2953] = 1789,
  [2954] = 1788,
  [2955] = 1782,
  [2956] = 1607,
  [2957] = 1467,
  [2958] = 1463,
  [2959] = 1575,
  [2960] = 1778,
  [2961] = 1774,
  [2962] = 1773,
  [2963] = 1472,
  [2964] = 1770,
  [2965] = 1612,
  [2966] = 1607,
  [2967] = 1499,
  [2968] = 1598,
  [2969] = 1767,
  [2970] = 1597,
  [2971] = 1446,
  [2972] = 1646,
  [2973] = 1557,
  [2974] = 1601,
  [2975] = 1562,
  [2976] = 1766,
  [2977] = 1598,
  [2978] = 1703,
  [2979] = 1489,
  [2980] = 1593,
  [2981] = 1765,
  [2982] = 1542,
  [2983] = 1763,
  [2984] = 1495,
  [2985] = 1489,
  [2986] = 1698,
  [2987] = 1581,
  [2988] = 1543,
  [2989] = 1687,
  [2990] = 1690,
  [2991] = 1688,
  [2992] = 1762,
  [2993] = 1761,
  [2994] = 1760,
  [2995] = 1467,
  [2996] = 1469,
  [2997] = 1684,
  [2998] = 1602,
  [2999] = 1681,
  [3000] = 1670,
  [3001] = 1496,
  [3002] = 1469,
  [3003] = 1602,
  [3004] = 1467,
  [3005] = 1469,
  [3006] = 1660,
  [3007] = 1658,
  [3008] = 1707,
  [3009] = 1542,
  [3010] = 1558,
  [3011] = 1561,
  [3012] = 1567,
  [3013] = 1784,
  [3014] = 1514,
  [3015] = 1503,
  [3016] = 1564,
  [3017] = 1635,
  [3018] = 1746,
  [3019] = 1634,
  [3020] = 1781,
  [3021] = 1652,
  [3022] = 1651,
  [3023] = 1745,
  [3024] = 1598,
  [3025] = 1597,
  [3026] = 1735,
  [3027] = 1731,
  [3028] = 1568,
  [3029] = 1585,
  [3030] = 1565,
  [3031] = 1469,
  [3032] = 1472,
  [3033] = 1730,
  [3034] = 1721,
  [3035] = 1720,
  [3036] = 1728,
  [3037] = 1714,
  [3038] = 1558,
  [3039] = 1570,
  [3040] = 1565,
  [3041] = 1564,
  [3042] = 1724,
  [3043] = 1718,
  [3044] = 1561,
  [3045] = 1646,
  [3046] = 1715,
  [3047] = 1614,
  [3048] = 1562,
  [3049] = 1553,
  [3050] = 1635,
  [3051] = 1634,
  [3052] = 1665,
  [3053] = 1488,
  [3054] = 1463,
  [3055] = 1663,
  [3056] = 1600,
  [3057] = 1710,
  [3058] = 1605,
  [3059] = 1708,
  [3060] = 1588,
  [3061] = 1624,
  [3062] = 1584,
  [3063] = 1500,
  [3064] = 1609,
  [3065] = 1569,
  [3066] = 1472,
  [3067] = 1500,
  [3068] = 1463,
  [3069] = 1607,
  [3070] = 1680,
  [3071] = 1654,
  [3072] = 1495,
  [3073] = 1489,
  [3074] = 1449,
  [3075] = 1706,
  [3076] = 1679,
  [3077] = 1593,
  [3078] = 1458,
  [3079] = 1597,
  [3080] = 1668,
  [3081] = 1611,
  [3082] = 1499,
  [3083] = 1588,
  [3084] = 1662,
  [3085] = 1568,
  [3086] = 1702,
  [3087] = 1650,
  [3088] = 1700,
  [3089] = 1496,
  [3090] = 1699,
  [3091] = 1630,
  [3092] = 1695,
  [3093] = 1458,
  [3094] = 1598,
  [3095] = 1647,
  [3096] = 1685,
  [3097] = 1553,
  [3098] = 1607,
  [3099] = 1496,
  [3100] = 1604,
  [3101] = 1455,
  [3102] = 1630,
  [3103] = 1569,
  [3104] = 1783,
  [3105] = 1449,
  [3106] = 1566,
  [3107] = 1598,
  [3108] = 1588,
  [3109] = 1678,
  [3110] = 1677,
  [3111] = 1448,
  [3112] = 1570,
  [3113] = 1673,
  [3114] = 1597,
  [3115] = 1499,
  [3116] = 1593,
  [3117] = 1588,
  [3118] = 1500,
  [3119] = 1574,
  [3120] = 1629,
  [3121] = 1477,
  [3122] = 1588,
  [3123] = 1658,
  [3124] = 1666,
  [3125] = 1495,
  [3126] = 1489,
  [3127] = 1660,
  [3128] = 1664,
  [3129] = 1626,
  [3130] = 1479,
  [3131] = 1557,
  [3132] = 1625,
  [3133] = 1624,
  [3134] = 1505,
  [3135] = 1496,
  [3136] = 1566,
  [3137] = 1659,
  [3138] = 1491,
  [3139] = 1490,
  [3140] = 1665,
  [3141] = 1663,
  [3142] = 1654,
  [3143] = 1690,
  [3144] = 1501,
  [3145] = 1650,
  [3146] = 1612,
  [3147] = 1514,
  [3148] = 1449,
  [3149] = 1458,
  [3150] = 1662,
  [3151] = 1549,
  [3152] = 1448,
  [3153] = 1670,
  [3154] = 1623,
  [3155] = 1681,
  [3156] = 1621,
  [3157] = 1647,
  [3158] = 1659,
  [3159] = 1620,
  [3160] = 1683,
  [3161] = 1619,
  [3162] = 1668,
  [3163] = 1680,
  [3164] = 1556,
  [3165] = 1500,
  [3166] = 1550,
  [3167] = 1792,
  [3168] = 1791,
  [3169] = 1687,
  [3170] = 1684,
  [3171] = 1626,
  [3172] = 1625,
  [3173] = 1503,
  [3174] = 1562,
  [3175] = 1618,
  [3176] = 1664,
  [3177] = 1666,
  [3178] = 1617,
  [3179] = 1564,
  [3180] = 1565,
  [3181] = 1550,
  [3182] = 1570,
  [3183] = 1616,
  [3184] = 1568,
  [3185] = 1673,
  [3186] = 1614,
  [3187] = 1677,
  [3188] = 1678,
  [3189] = 1679,
  [3190] = 1501,
  [3191] = 1604,
  [3192] = 1685,
  [3193] = 1448,
  [3194] = 1499,
  [3195] = 1695,
  [3196] = 1699,
  [3197] = 1700,
  [3198] = 1714,
  [3199] = 1720,
  [3200] = 1721,
  [3201] = 1567,
  [3202] = 1702,
  [3203] = 1725,
  [3204] = 1727,
  [3205] = 1732,
  [3206] = 1733,
  [3207] = 1549,
  [3208] = 1604,
  [3209] = 1615,
  [3210] = 1556,
  [3211] = 1613,
  [3212] = 1736,
  [3213] = 1706,
  [3214] = 1612,
  [3215] = 1609,
  [3216] = 1741,
  [3217] = 1561,
  [3218] = 1742,
  [3219] = 1708,
  [3220] = 1751,
  [3221] = 1754,
  [3222] = 1719,
  [3223] = 1705,
  [3224] = 1686,
  [3225] = 1688,
  [3226] = 1607,
  [3227] = 1490,
  [3228] = 1455,
  [3229] = 1558,
  [3230] = 1567,
  [3231] = 1710,
  [3232] = 1542,
  [3233] = 1777,
  [3234] = 1715,
  [3235] = 1781,
  [3236] = 1623,
  [3237] = 1718,
  [3238] = 1621,
  [3239] = 1784,
  [3240] = 1724,
  [3241] = 1779,
  [3242] = 1598,
  [3243] = 1683,
  [3244] = 1485,
  [3245] = 1566,
  [3246] = 1728,
  [3247] = 1620,
  [3248] = 1619,
  [3249] = 1597,
  [3250] = 1593,
  [3251] = 1730,
  [3252] = 1731,
  [3253] = 1740,
  [3254] = 1735,
  [3255] = 1739,
  [3256] = 1557,
  [3257] = 1477,
  [3258] = 1479,
  [3259] = 1787,
  [3260] = 1790,
  [3261] = 1514,
  [3262] = 1745,
  [3263] = 1746,
  [3264] = 1618,
  [3265] = 1794,
  [3266] = 1467,
  [3267] = 1797,
  [3268] = 1675,
  [3269] = 1505,
  [3270] = 1806,
  [3271] = 1805,
  [3272] = 1617,
  [3273] = 1491,
  [3274] = 1542,
  [3275] = 1558,
  [3276] = 1455,
  [3277] = 1616,
  [3278] = 1804,
  [3279] = 1803,
  [3280] = 1802,
  [3281] = 1703,
  [3282] = 1801,
  [3283] = 1561,
  [3284] = 1752,
  [3285] = 1798,
  [3286] = 1753,
  [3287] = 1789,
  [3288] = 1788,
  [3289] = 1705,
  [3290] = 1610,
  [3291] = 1686,
  [3292] = 1707,
  [3293] = 1782,
  [3294] = 1567,
  [3295] = 1568,
  [3296] = 1778,
  [3297] = 1774,
  [3298] = 1773,
  [3299] = 1570,
  [3300] = 1770,
  [3301] = 1783,
  [3302] = 1767,
  [3303] = 1766,
  [3304] = 1553,
  [3305] = 1765,
  [3306] = 1698,
  [3307] = 1565,
  [3308] = 1763,
  [3309] = 1615,
  [3310] = 1762,
  [3311] = 1761,
  [3312] = 1760,
  [3313] = 1610,
  [3314] = 1613,
  [3315] = 1564,
  [3316] = 1562,
  [3317] = 1611,
  [3318] = 1706,
  [3319] = 1549,
  [3320] = 1724,
  [3321] = 1718,
  [3322] = 1715,
  [3323] = 1710,
  [3324] = 1708,
  [3325] = 1731,
  [3326] = 1782,
  [3327] = 1730,
  [3328] = 1735,
  [3329] = 1609,
  [3330] = 1745,
  [3331] = 1670,
  [3332] = 1746,
  [3333] = 1660,
  [3334] = 1789,
  [3335] = 1658,
  [3336] = 1798,
  [3337] = 1681,
  [3338] = 1778,
  [3339] = 1801,
  [3340] = 1774,
  [3341] = 1463,
  [3342] = 1773,
  [3343] = 1770,
  [3344] = 1472,
  [3345] = 1684,
  [3346] = 1702,
  [3347] = 1760,
  [3348] = 1700,
  [3349] = 1699,
  [3350] = 1695,
  [3351] = 1761,
  [3352] = 1679,
  [3353] = 1678,
  [3354] = 1677,
  [3355] = 1673,
  [3356] = 1688,
  [3357] = 1690,
  [3358] = 1698,
  [3359] = 1666,
  [3360] = 1664,
  [3361] = 1659,
  [3362] = 1448,
  [3363] = 1762,
  [3364] = 1763,
  [3365] = 1703,
  [3366] = 1765,
  [3367] = 1766,
  [3368] = 1767,
  [3369] = 1557,
  [3370] = 1770,
  [3371] = 1773,
  [3372] = 1469,
  [3373] = 1774,
  [3374] = 1467,
  [3375] = 1778,
  [3376] = 1652,
  [3377] = 1566,
  [3378] = 1739,
  [3379] = 1740,
  [3380] = 1650,
  [3381] = 1705,
  [3382] = 1686,
  [3383] = 1651,
  [3384] = 1782,
  [3385] = 1549,
  [3386] = 1788,
  [3387] = 1789,
  [3388] = 1798,
  [3389] = 1801,
  [3390] = 1550,
  [3391] = 1802,
  [3392] = 1803,
  [3393] = 1802,
  [3394] = 1803,
  [3395] = 1804,
  [3396] = 1804,
  [3397] = 1685,
  [3398] = 1458,
  [3399] = 1449,
  [3400] = 1458,
  [3401] = 1646,
  [3402] = 1767,
  [3403] = 1791,
  [3404] = 1792,
  [3405] = 1766,
  [3406] = 1485,
  [3407] = 1765,
  [3408] = 1449,
  [3409] = 1763,
  [3410] = 1805,
  [3411] = 1805,
  [3412] = 1489,
  [3413] = 1514,
  [3414] = 1495,
  [3415] = 1467,
  [3416] = 1500,
  [3417] = 1806,
  [3418] = 1806,
  [3419] = 1499,
  [3420] = 1614,
  [3421] = 1675,
  [3422] = 1762,
  [3423] = 1761,
  [3424] = 1503,
  [3425] = 1760,
  [3426] = 1797,
  [3427] = 1746,
  [3428] = 1601,
  [3429] = 1794,
  [3430] = 1790,
  [3431] = 1514,
  [3432] = 1496,
  [3433] = 1787,
  [3434] = 1675,
  [3435] = 1496,
  [3436] = 1556,
  [3437] = 1745,
  [3438] = 1714,
  [3439] = 1735,
  [3440] = 1720,
  [3441] = 1647,
  [3442] = 1731,
  [3443] = 1581,
  [3444] = 1543,
  [3445] = 1730,
  [3446] = 1721,
  [3447] = 1707,
  [3448] = 1797,
  [3449] = 1635,
  [3450] = 1634,
  [3451] = 1794,
  [3452] = 1790,
  [3453] = 1728,
  [3454] = 1787,
  [3455] = 1779,
  [3456] = 1781,
  [3457] = 1724,
  [3458] = 1718,
  [3459] = 1501,
  [3460] = 1490,
  [3461] = 1491,
  [3462] = 1585,
  [3463] = 1584,
  [3464] = 1472,
  [3465] = 1784,
  [3466] = 1611,
  [3467] = 1715,
  [3468] = 1710,
  [3469] = 1708,
  [3470] = 1609,
  [3471] = 1788,
  [3472] = 1611,
  [3473] = 1613,
  [3474] = 1615,
  [3475] = 1647,
  [3476] = 1616,
  [3477] = 1779,
  [3478] = 1617,
  [3479] = 1654,
  [3480] = 1505,
  [3481] = 1479,
  [3482] = 1647,
  [3483] = 1618,
  [3484] = 1619,
  [3485] = 1702,
  [3486] = 1700,
  [3487] = 1699,
  [3488] = 1620,
  [3489] = 1695,
  [3490] = 1685,
  [3491] = 1679,
  [3492] = 1777,
  [3493] = 1621,
  [3494] = 1463,
  [3495] = 1623,
  [3496] = 1624,
  [3497] = 1663,
  [3498] = 1665,
  [3499] = 1477,
  [3500] = 1678,
  [3501] = 1677,
  [3502] = 1448,
  [3503] = 1754,
  [3504] = 1706,
  [3505] = 1751,
  [3506] = 1666,
  [3507] = 1777,
  [3508] = 1625,
  [3509] = 1664,
  [3510] = 1742,
  [3511] = 1741,
  [3512] = 1659,
  [3513] = 1754,
  [3514] = 1751,
  [3515] = 1626,
  [3516] = 1742,
  [3517] = 1741,
  [3518] = 1736,
  [3519] = 1736,
  [3520] = 1654,
  [3521] = 1654,
  [3522] = 1630,
  [3523] = 1733,
  [3524] = 1733,
  [3525] = 1732,
  [3526] = 1727,
  [3527] = 1732,
  [3528] = 1727,
  [3529] = 1725,
  [3530] = 1630,
  [3531] = 1629,
  [3532] = 1705,
  [3533] = 1686,
  [3534] = 1725,
  [3535] = 1663,
  [3536] = 1499,
  [3537] = 1663,
  [3538] = 1665,
  [3539] = 1626,
  [3540] = 1625,
  [3541] = 1665,
  [3542] = 1624,
  [3543] = 1623,
  [3544] = 1496,
  [3545] = 1621,
  [3546] = 1593,
  [3547] = 1500,
  [3548] = 1620,
  [3549] = 1619,
  [3550] = 1634,
  [3551] = 1635,
  [3552] = 1618,
  [3553] = 1597,
  [3554] = 1598,
  [3555] = 1617,
  [3556] = 1616,
  [3557] = 1607,
  [3558] = 1646,
  [3559] = 1615,
  [3560] = 1613,
  [3561] = 1612,
  [3562] = 1604,
  [3563] = 1707,
  [3564] = 1651,
  [3565] = 1652,
  [3566] = 1610,
  [3567] = 1611,
  [3568] = 1629,
  [3569] = 1660,
  [3570] = 1613,
  [3571] = 1615,
  [3572] = 1670,
  [3573] = 1455,
  [3574] = 1681,
  [3575] = 1707,
  [3576] = 1588,
  [3577] = 1684,
  [3578] = 1616,
  [3579] = 1617,
  [3580] = 1688,
  [3581] = 1690,
  [3582] = 1698,
  [3583] = 1618,
  [3584] = 1619,
  [3585] = 1620,
  [3586] = 1703,
  [3587] = 1621,
  [3588] = 1623,
  [3589] = 1624,
  [3590] = 1625,
  [3591] = 1626,
  [3592] = 1629,
  [3593] = 1601,
  [3594] = 1463,
  [3595] = 1630,
  [3596] = 1488,
  [3597] = 1739,
  [3598] = 1740,
  [3599] = 1574,
  [3600] = 1472,
  [3601] = 1605,
  [3602] = 1662,
  [3603] = 1683,
  [3604] = 1634,
  [3605] = 1600,
  [3606] = 1588,
  [3607] = 1635,
  [3608] = 1581,
  [3609] = 1543,
  [3610] = 1668,
  [3611] = 1658,
  [3612] = 1791,
  [3613] = 1485,
  [3614] = 1673,
  [3615] = 1792,
  [3616] = 1646,
  [3617] = 1651,
  [3618] = 1650,
  [3619] = 1680,
  [3620] = 1604,
  [3621] = 1652,
  [3622] = 1610,
  [3623] = 1658,
  [3624] = 1660,
  [3625] = 1612,
  [3626] = 1670,
  [3627] = 1681,
  [3628] = 1585,
  [3629] = 1584,
  [3630] = 1684,
  [3631] = 1688,
  [3632] = 1690,
  [3633] = 1698,
  [3634] = 1703,
  [3635] = 1607,
  [3636] = 1727,
  [3637] = 1598,
  [3638] = 1574,
  [3639] = 1597,
  [3640] = 1732,
  [3641] = 1687,
  [3642] = 1725,
  [3643] = 1614,
  [3644] = 1736,
  [3645] = 1739,
  [3646] = 1593,
  [3647] = 1588,
  [3648] = 1683,
  [3649] = 1469,
  [3650] = 1740,
  [3651] = 1741,
  [3652] = 1604,
  [3653] = 1742,
  [3654] = 1686,
  [3655] = 1719,
  [3656] = 1705,
  [3657] = 1607,
  [3658] = 1751,
  [3659] = 1754,
  [3660] = 1598,
  [3661] = 1714,
  [3662] = 1597,
  [3663] = 1720,
  [3664] = 1721,
  [3665] = 1777,
  [3666] = 1593,
  [3667] = 1601,
  [3668] = 1779,
  [3669] = 1448,
  [3670] = 1495,
  [3671] = 1581,
  [3672] = 1543,
  [3673] = 1787,
  [3674] = 1790,
  [3675] = 1489,
  [3676] = 1752,
  [3677] = 1753,
  [3678] = 1791,
  [3679] = 1792,
  [3680] = 1495,
  [3681] = 1794,
  [3682] = 1797,
  [3683] = 1675,
  [3684] = 1806,
  [3685] = 1805,
  [3686] = 1489,
  [3687] = 1585,
  [3688] = 1584,
  [3689] = 1804,
  [3690] = 1803,
  [3691] = 1802,
  [3692] = 1801,
  [3693] = 1781,
  [3694] = 1783,
  [3695] = 1784,
  [3696] = 1798,
  [3697] = 1784,
  [3698] = 1781,
  [3699] = 1789,
  [3700] = 1788,
  [3701] = 1553,
  [3702] = 1782,
  [3703] = 1778,
  [3704] = 1753,
  [3705] = 1774,
  [3706] = 1773,
  [3707] = 1770,
  [3708] = 1767,
  [3709] = 1766,
  [3710] = 1765,
  [3711] = 1752,
  [3712] = 1763,
  [3713] = 1762,
  [3714] = 1562,
  [3715] = 1761,
  [3716] = 1760,
  [3717] = 1733,
  [3718] = 1746,
  [3719] = 1783,
  [3720] = 1745,
  [3721] = 1735,
  [3722] = 1731,
  [3723] = 1564,
  [3724] = 1721,
  [3725] = 1720,
  [3726] = 1714,
  [3727] = 1455,
  [3728] = 1730,
  [3729] = 1728,
  [3730] = 1718,
  [3731] = 1467,
  [3732] = 1715,
  [3733] = 1710,
  [3734] = 1708,
  [3735] = 1565,
  [3736] = 1609,
  [3737] = 1706,
  [3738] = 1584,
  [3739] = 1557,
  [3740] = 1702,
  [3741] = 1719,
  [3742] = 1585,
  [3743] = 1662,
  [3744] = 1570,
  [3745] = 1568,
  [3746] = 1567,
  [3747] = 1614,
  [3748] = 1668,
  [3749] = 1700,
  [3750] = 1469,
  [3751] = 1699,
  [3752] = 1695,
  [3753] = 1680,
  [3754] = 1685,
  [3755] = 1679,
  [3756] = 1678,
  [3757] = 1677,
  [3758] = 1673,
  [3759] = 1728,
  [3760] = 1566,
  [3761] = 1543,
  [3762] = 1581,
  [3763] = 1556,
  [3764] = 1666,
  [3765] = 1664,
  [3766] = 1489,
  [3767] = 1659,
  [3768] = 1687,
  [3769] = 1500,
  [3770] = 1561,
  [3771] = 1601,
  [3772] = 1558,
  [3773] = 1495,
  [3774] = 1488,
  [3775] = 1574,
  [3776] = 1550,
  [3777] = 1500,
  [3778] = 1499,
  [3779] = 1499,
  [3780] = 1650,
  [3781] = 1542,
  [3782] = 1724,
  [3783] = 1496,
  [3784] = 1803,
  [3785] = 1721,
  [3786] = 1556,
  [3787] = 1651,
  [3788] = 1658,
  [3789] = 1660,
  [3790] = 1652,
  [3791] = 1448,
  [3792] = 1792,
  [3793] = 1791,
  [3794] = 1458,
  [3795] = 1635,
  [3796] = 1612,
  [3797] = 1449,
  [3798] = 1634,
  [3799] = 1448,
  [3800] = 1550,
  [3801] = 1496,
  [3802] = 1549,
  [3803] = 1610,
  [3804] = 1574,
  [3805] = 1740,
  [3806] = 1739,
  [3807] = 1630,
  [3808] = 1670,
  [3809] = 3809,
  [3810] = 1681,
  [3811] = 1684,
  [3812] = 1629,
  [3813] = 1557,
  [3814] = 1626,
  [3815] = 1625,
  [3816] = 1777,
  [3817] = 1624,
  [3818] = 1623,
  [3819] = 1621,
  [3820] = 1647,
  [3821] = 1779,
  [3822] = 1703,
  [3823] = 1566,
  [3824] = 1620,
  [3825] = 1619,
  [3826] = 1618,
  [3827] = 1688,
  [3828] = 1690,
  [3829] = 1698,
  [3830] = 1698,
  [3831] = 1690,
  [3832] = 1665,
  [3833] = 1787,
  [3834] = 1790,
  [3835] = 1794,
  [3836] = 1751,
  [3837] = 1742,
  [3838] = 1797,
  [3839] = 1675,
  [3840] = 1688,
  [3841] = 1617,
  [3842] = 1489,
  [3843] = 1741,
  [3844] = 1806,
  [3845] = 1805,
  [3846] = 1495,
  [3847] = 1616,
  [3848] = 1500,
  [3849] = 1736,
  [3850] = 1654,
  [3851] = 1804,
  [3852] = 1663,
  [3853] = 1514,
  [3854] = 1684,
  [3855] = 1725,
  [3856] = 1499,
  [3857] = 1489,
  [3858] = 1681,
  [3859] = 1727,
  [3860] = 1733,
  [3861] = 1732,
  [3862] = 1670,
  [3863] = 1732,
  [3864] = 1703,
  [3865] = 1727,
  [3866] = 1733,
  [3867] = 1615,
  [3868] = 1654,
  [3869] = 1736,
  [3870] = 1802,
  [3871] = 1613,
  [3872] = 1741,
  [3873] = 1495,
  [3874] = 1742,
  [3875] = 1801,
  [3876] = 1751,
  [3877] = 1754,
  [3878] = 1660,
  [3879] = 1658,
  [3880] = 1798,
  [3881] = 1611,
  [3882] = 1777,
  [3883] = 1652,
  [3884] = 1651,
  [3885] = 1647,
  [3886] = 1779,
  [3887] = 1707,
  [3888] = 1789,
  [3889] = 1788,
  [3890] = 1725,
  [3891] = 1782,
  [3892] = 1663,
  [3893] = 1778,
  [3894] = 1774,
  [3895] = 1773,
  [3896] = 1665,
  [3897] = 1612,
  [3898] = 1770,
  [3899] = 1469,
  [3900] = 1467,
  [3901] = 1767,
  [3902] = 1469,
  [3903] = 1787,
  [3904] = 1790,
  [3905] = 1467,
  [3906] = 1739,
  [3907] = 1740,
  [3908] = 1499,
  [3909] = 1556,
  [3910] = 1766,
  [3911] = 1646,
  [3912] = 1765,
  [3913] = 1499,
  [3914] = 1794,
  [3915] = 1763,
  [3916] = 1646,
  [3917] = 1601,
  [3918] = 1797,
  [3919] = 1675,
  [3920] = 1458,
  [3921] = 1500,
  [3922] = 1806,
  [3923] = 1610,
  [3924] = 1805,
  [3925] = 1635,
  [3926] = 1634,
  [3927] = 1762,
  [3928] = 1761,
  [3929] = 1581,
  [3930] = 1543,
  [3931] = 1760,
  [3932] = 1500,
  [3933] = 1550,
  [3934] = 1804,
  [3935] = 1803,
  [3936] = 1802,
  [3937] = 1798,
  [3938] = 1789,
  [3939] = 1788,
  [3940] = 1782,
  [3941] = 1585,
  [3942] = 1584,
  [3943] = 1792,
  [3944] = 3944,
  [3945] = 1778,
  [3946] = 1746,
  [3947] = 1496,
  [3948] = 1683,
  [3949] = 1745,
  [3950] = 1735,
  [3951] = 1612,
  [3952] = 1731,
  [3953] = 1730,
  [3954] = 1728,
  [3955] = 1774,
  [3956] = 1724,
  [3957] = 1718,
  [3958] = 1715,
  [3959] = 1773,
  [3960] = 1710,
  [3961] = 1610,
  [3962] = 1770,
  [3963] = 1767,
  [3964] = 1683,
  [3965] = 1708,
  [3966] = 1609,
  [3967] = 1706,
  [3968] = 1766,
  [3969] = 1765,
  [3970] = 1763,
  [3971] = 1762,
  [3972] = 1761,
  [3973] = 1760,
  [3974] = 1549,
  [3975] = 1746,
  [3976] = 1702,
  [3977] = 1700,
  [3978] = 1745,
  [3979] = 1601,
  [3980] = 1699,
  [3981] = 1695,
  [3982] = 1735,
  [3983] = 1731,
  [3984] = 1730,
  [3985] = 1728,
  [3986] = 1724,
  [3987] = 1685,
  [3988] = 1581,
  [3989] = 1543,
  [3990] = 1679,
  [3991] = 1718,
  [3992] = 1715,
  [3993] = 1678,
  [3994] = 1677,
  [3995] = 1710,
  [3996] = 1708,
  [3997] = 1609,
  [3998] = 1673,
  [3999] = 1585,
  [4000] = 1584,
  [4001] = 1706,
  [4002] = 1686,
  [4003] = 1666,
  [4004] = 1702,
  [4005] = 1700,
  [4006] = 1664,
  [4007] = 1683,
  [4008] = 1699,
  [4009] = 1695,
  [4010] = 1463,
  [4011] = 1659,
  [4012] = 1683,
  [4013] = 1685,
  [4014] = 1705,
  [4015] = 1679,
  [4016] = 1678,
  [4017] = 1574,
  [4018] = 1472,
  [4019] = 1677,
  [4020] = 1673,
  [4021] = 1650,
  [4022] = 4022,
  [4023] = 1666,
  [4024] = 1664,
  [4025] = 1630,
  [4026] = 1659,
  [4027] = 1574,
  [4028] = 1629,
  [4029] = 1449,
  [4030] = 1495,
  [4031] = 1557,
  [4032] = 1566,
  [4033] = 1614,
  [4034] = 1574,
  [4035] = 1574,
  [4036] = 1489,
  [4037] = 1626,
  [4038] = 1625,
  [4039] = 1624,
  [4040] = 1623,
  [4041] = 1621,
  [4042] = 4042,
  [4043] = 1801,
  [4044] = 1610,
  [4045] = 1620,
  [4046] = 1619,
  [4047] = 1618,
  [4048] = 1705,
  [4049] = 1463,
  [4050] = 1650,
  [4051] = 1617,
  [4052] = 1616,
  [4053] = 1612,
  [4054] = 1686,
  [4055] = 1615,
  [4056] = 1472,
  [4057] = 1613,
  [4058] = 1477,
  [4059] = 1479,
  [4060] = 1505,
  [4061] = 1791,
  [4062] = 1455,
  [4063] = 1784,
  [4064] = 1455,
  [4065] = 1720,
  [4066] = 1714,
  [4067] = 1611,
  [4068] = 1754,
  [4069] = 1503,
  [4070] = 1496,
  [4071] = 1714,
  [4072] = 1720,
  [4073] = 1784,
  [4074] = 1721,
  [4075] = 1707,
  [4076] = 1781,
  [4077] = 1490,
  [4078] = 1781,
  [4079] = 1614,
  [4080] = 1491,
  [4081] = 1501,
  [4082] = 1714,
  [4083] = 1766,
  [4084] = 4084,
  [4085] = 1787,
  [4086] = 1790,
  [4087] = 4087,
  [4088] = 4087,
  [4089] = 4084,
  [4090] = 4090,
  [4091] = 1794,
  [4092] = 1797,
  [4093] = 1675,
  [4094] = 1614,
  [4095] = 1806,
  [4096] = 1805,
  [4097] = 1804,
  [4098] = 1496,
  [4099] = 1803,
  [4100] = 1802,
  [4101] = 1801,
  [4102] = 4087,
  [4103] = 4084,
  [4104] = 4090,
  [4105] = 1798,
  [4106] = 1789,
  [4107] = 1788,
  [4108] = 1720,
  [4109] = 1721,
  [4110] = 1782,
  [4111] = 1778,
  [4112] = 1774,
  [4113] = 1686,
  [4114] = 1705,
  [4115] = 1706,
  [4116] = 1773,
  [4117] = 1770,
  [4118] = 1767,
  [4119] = 1766,
  [4120] = 1765,
  [4121] = 1763,
  [4122] = 1762,
  [4123] = 1761,
  [4124] = 1760,
  [4125] = 1781,
  [4126] = 1784,
  [4127] = 4090,
  [4128] = 1745,
  [4129] = 1735,
  [4130] = 1731,
  [4131] = 1730,
  [4132] = 1728,
  [4133] = 1724,
  [4134] = 1718,
  [4135] = 1715,
  [4136] = 1710,
  [4137] = 1708,
  [4138] = 1609,
  [4139] = 1741,
  [4140] = 1779,
  [4141] = 4084,
  [4142] = 4087,
  [4143] = 1777,
  [4144] = 1549,
  [4145] = 1702,
  [4146] = 1700,
  [4147] = 1699,
  [4148] = 1695,
  [4149] = 1685,
  [4150] = 1679,
  [4151] = 4090,
  [4152] = 1678,
  [4153] = 1472,
  [4154] = 1677,
  [4155] = 1673,
  [4156] = 4087,
  [4157] = 1683,
  [4158] = 1666,
  [4159] = 4087,
  [4160] = 1664,
  [4161] = 1550,
  [4162] = 1463,
  [4163] = 1650,
  [4164] = 1754,
  [4165] = 1751,
  [4166] = 4084,
  [4167] = 1746,
  [4168] = 4087,
  [4169] = 4084,
  [4170] = 1557,
  [4171] = 1742,
  [4172] = 4172,
  [4173] = 4090,
  [4174] = 4084,
  [4175] = 1707,
  [4176] = 1556,
  [4177] = 1736,
  [4178] = 4090,
  [4179] = 4084,
  [4180] = 4087,
  [4181] = 1733,
  [4182] = 1732,
  [4183] = 1727,
  [4184] = 1725,
  [4185] = 4087,
  [4186] = 4084,
  [4187] = 4087,
  [4188] = 1790,
  [4189] = 1659,
  [4190] = 1650,
  [4191] = 1664,
  [4192] = 1666,
  [4193] = 4084,
  [4194] = 1611,
  [4195] = 4090,
  [4196] = 1673,
  [4197] = 1566,
  [4198] = 1463,
  [4199] = 1678,
  [4200] = 1679,
  [4201] = 1685,
  [4202] = 1695,
  [4203] = 1467,
  [4204] = 1472,
  [4205] = 1699,
  [4206] = 1700,
  [4207] = 1702,
  [4208] = 1610,
  [4209] = 1706,
  [4210] = 1613,
  [4211] = 1609,
  [4212] = 1615,
  [4213] = 1708,
  [4214] = 1710,
  [4215] = 1715,
  [4216] = 1718,
  [4217] = 1724,
  [4218] = 4090,
  [4219] = 4090,
  [4220] = 1728,
  [4221] = 4087,
  [4222] = 1730,
  [4223] = 1731,
  [4224] = 1735,
  [4225] = 1745,
  [4226] = 1746,
  [4227] = 1616,
  [4228] = 1617,
  [4229] = 1760,
  [4230] = 1761,
  [4231] = 1762,
  [4232] = 1448,
  [4233] = 1618,
  [4234] = 1763,
  [4235] = 1677,
  [4236] = 1765,
  [4237] = 4084,
  [4238] = 1620,
  [4239] = 4090,
  [4240] = 4090,
  [4241] = 4084,
  [4242] = 1601,
  [4243] = 1683,
  [4244] = 1767,
  [4245] = 1621,
  [4246] = 1623,
  [4247] = 4087,
  [4248] = 1770,
  [4249] = 1624,
  [4250] = 1469,
  [4251] = 1792,
  [4252] = 1791,
  [4253] = 4253,
  [4254] = 4172,
  [4255] = 1625,
  [4256] = 1773,
  [4257] = 1626,
  [4258] = 4087,
  [4259] = 1647,
  [4260] = 1774,
  [4261] = 4090,
  [4262] = 1778,
  [4263] = 1581,
  [4264] = 1612,
  [4265] = 1629,
  [4266] = 1782,
  [4267] = 1788,
  [4268] = 1543,
  [4269] = 1630,
  [4270] = 1707,
  [4271] = 1659,
  [4272] = 1705,
  [4273] = 1585,
  [4274] = 1584,
  [4275] = 1686,
  [4276] = 1789,
  [4277] = 1798,
  [4278] = 1801,
  [4279] = 1499,
  [4280] = 1654,
  [4281] = 1802,
  [4282] = 1740,
  [4283] = 1500,
  [4284] = 1739,
  [4285] = 1495,
  [4286] = 1489,
  [4287] = 4084,
  [4288] = 1614,
  [4289] = 4253,
  [4290] = 4172,
  [4291] = 1803,
  [4292] = 1499,
  [4293] = 4087,
  [4294] = 1566,
  [4295] = 1720,
  [4296] = 1500,
  [4297] = 1804,
  [4298] = 1495,
  [4299] = 1489,
  [4300] = 4084,
  [4301] = 1721,
  [4302] = 4253,
  [4303] = 1703,
  [4304] = 1805,
  [4305] = 1496,
  [4306] = 1619,
  [4307] = 1610,
  [4308] = 1663,
  [4309] = 1698,
  [4310] = 1665,
  [4311] = 1781,
  [4312] = 1784,
  [4313] = 1690,
  [4314] = 1688,
  [4315] = 1675,
  [4316] = 1684,
  [4317] = 1681,
  [4318] = 1670,
  [4319] = 1797,
  [4320] = 1612,
  [4321] = 1660,
  [4322] = 1658,
  [4323] = 1634,
  [4324] = 1635,
  [4325] = 1652,
  [4326] = 1651,
  [4327] = 1556,
  [4328] = 1794,
  [4329] = 1751,
  [4330] = 1787,
  [4331] = 1646,
  [4332] = 1646,
  [4333] = 1792,
  [4334] = 1791,
  [4335] = 4087,
  [4336] = 4090,
  [4337] = 1635,
  [4338] = 1634,
  [4339] = 1779,
  [4340] = 4084,
  [4341] = 1550,
  [4342] = 1806,
  [4343] = 1549,
  [4344] = 4090,
  [4345] = 1725,
  [4346] = 1727,
  [4347] = 1732,
  [4348] = 1740,
  [4349] = 1739,
  [4350] = 1448,
  [4351] = 1630,
  [4352] = 1733,
  [4353] = 1629,
  [4354] = 4090,
  [4355] = 1557,
  [4356] = 1626,
  [4357] = 1625,
  [4358] = 1624,
  [4359] = 1665,
  [4360] = 1663,
  [4361] = 1623,
  [4362] = 1714,
  [4363] = 1621,
  [4364] = 1703,
  [4365] = 1620,
  [4366] = 1619,
  [4367] = 1654,
  [4368] = 1736,
  [4369] = 1618,
  [4370] = 1698,
  [4371] = 1690,
  [4372] = 1688,
  [4373] = 1617,
  [4374] = 1647,
  [4375] = 1616,
  [4376] = 4090,
  [4377] = 1684,
  [4378] = 1681,
  [4379] = 1670,
  [4380] = 1615,
  [4381] = 1467,
  [4382] = 1741,
  [4383] = 1613,
  [4384] = 4087,
  [4385] = 4084,
  [4386] = 1469,
  [4387] = 1742,
  [4388] = 1660,
  [4389] = 1658,
  [4390] = 1611,
  [4391] = 1754,
  [4392] = 1777,
  [4393] = 1652,
  [4394] = 1651,
  [4395] = 1620,
  [4396] = 1664,
  [4397] = 1489,
  [4398] = 1725,
  [4399] = 1500,
  [4400] = 1499,
  [4401] = 1727,
  [4402] = 1732,
  [4403] = 1733,
  [4404] = 1736,
  [4405] = 1741,
  [4406] = 1742,
  [4407] = 1751,
  [4408] = 1754,
  [4409] = 1777,
  [4410] = 1779,
  [4411] = 1500,
  [4412] = 1495,
  [4413] = 1787,
  [4414] = 1790,
  [4415] = 1794,
  [4416] = 1797,
  [4417] = 1675,
  [4418] = 1806,
  [4419] = 1805,
  [4420] = 1489,
  [4421] = 1804,
  [4422] = 1803,
  [4423] = 1802,
  [4424] = 1801,
  [4425] = 1798,
  [4426] = 1789,
  [4427] = 1788,
  [4428] = 1499,
  [4429] = 1782,
  [4430] = 1778,
  [4431] = 1774,
  [4432] = 1773,
  [4433] = 1770,
  [4434] = 1766,
  [4435] = 1765,
  [4436] = 1763,
  [4437] = 1762,
  [4438] = 1761,
  [4439] = 1760,
  [4440] = 1746,
  [4441] = 1745,
  [4442] = 1735,
  [4443] = 1731,
  [4444] = 1730,
  [4445] = 1728,
  [4446] = 1724,
  [4447] = 1718,
  [4448] = 1715,
  [4449] = 1710,
  [4450] = 1708,
  [4451] = 1609,
  [4452] = 1706,
  [4453] = 1702,
  [4454] = 1700,
  [4455] = 1699,
  [4456] = 1695,
  [4457] = 1685,
  [4458] = 4458,
  [4459] = 1679,
  [4460] = 1678,
  [4461] = 4461,
  [4462] = 1665,
  [4463] = 1663,
  [4464] = 1725,
  [4465] = 1677,
  [4466] = 1673,
  [4467] = 1666,
  [4468] = 1664,
  [4469] = 1659,
  [4470] = 1727,
  [4471] = 1732,
  [4472] = 1650,
  [4473] = 1733,
  [4474] = 1767,
  [4475] = 1792,
  [4476] = 1654,
  [4477] = 1736,
  [4478] = 1791,
  [4479] = 1741,
  [4480] = 1742,
  [4481] = 1754,
  [4482] = 1614,
  [4483] = 4458,
  [4484] = 4458,
  [4485] = 1777,
  [4486] = 1647,
  [4487] = 1779,
  [4488] = 1714,
  [4489] = 4458,
  [4490] = 1787,
  [4491] = 1790,
  [4492] = 1794,
  [4493] = 1797,
  [4494] = 1720,
  [4495] = 1751,
  [4496] = 1721,
  [4497] = 1675,
  [4498] = 1740,
  [4499] = 1806,
  [4500] = 1805,
  [4501] = 1804,
  [4502] = 1803,
  [4503] = 1802,
  [4504] = 1801,
  [4505] = 1798,
  [4506] = 1361,
  [4507] = 1789,
  [4508] = 1788,
  [4509] = 1703,
  [4510] = 1781,
  [4511] = 1784,
  [4512] = 1698,
  [4513] = 1690,
  [4514] = 1688,
  [4515] = 4458,
  [4516] = 1782,
  [4517] = 1778,
  [4518] = 1774,
  [4519] = 1773,
  [4520] = 1770,
  [4521] = 1684,
  [4522] = 1767,
  [4523] = 1766,
  [4524] = 1765,
  [4525] = 1763,
  [4526] = 1762,
  [4527] = 1761,
  [4528] = 1760,
  [4529] = 1681,
  [4530] = 1670,
  [4531] = 1660,
  [4532] = 1658,
  [4533] = 1739,
  [4534] = 1746,
  [4535] = 1745,
  [4536] = 1735,
  [4537] = 1731,
  [4538] = 1730,
  [4539] = 1728,
  [4540] = 1724,
  [4541] = 1718,
  [4542] = 1710,
  [4543] = 1708,
  [4544] = 1609,
  [4545] = 1651,
  [4546] = 1706,
  [4547] = 1702,
  [4548] = 1700,
  [4549] = 1699,
  [4550] = 1695,
  [4551] = 1496,
  [4552] = 1685,
  [4553] = 1679,
  [4554] = 1678,
  [4555] = 1677,
  [4556] = 1673,
  [4557] = 4458,
  [4558] = 1652,
  [4559] = 1666,
  [4560] = 1495,
  [4561] = 1715,
  [4562] = 1659,
  [4563] = 1646,
  [4564] = 1359,
  [4565] = 1635,
  [4566] = 1634,
  [4567] = 1650,
  [4568] = 4458,
  [4569] = 1630,
  [4570] = 4461,
  [4571] = 4461,
  [4572] = 1362,
  [4573] = 1705,
  [4574] = 1686,
  [4575] = 1629,
  [4576] = 1626,
  [4577] = 1625,
  [4578] = 1624,
  [4579] = 1623,
  [4580] = 1621,
  [4581] = 1614,
  [4582] = 1619,
  [4583] = 1618,
  [4584] = 1617,
  [4585] = 1616,
  [4586] = 1707,
  [4587] = 1611,
  [4588] = 1613,
  [4589] = 1615,
  [4590] = 1616,
  [4591] = 1617,
  [4592] = 1618,
  [4593] = 1619,
  [4594] = 1620,
  [4595] = 1621,
  [4596] = 1623,
  [4597] = 1624,
  [4598] = 1625,
  [4599] = 1720,
  [4600] = 1721,
  [4601] = 1626,
  [4602] = 1615,
  [4603] = 1613,
  [4604] = 1629,
  [4605] = 1630,
  [4606] = 1611,
  [4607] = 1634,
  [4608] = 1635,
  [4609] = 1646,
  [4610] = 1651,
  [4611] = 1652,
  [4612] = 1781,
  [4613] = 1784,
  [4614] = 1658,
  [4615] = 1660,
  [4616] = 1707,
  [4617] = 1670,
  [4618] = 1681,
  [4619] = 1684,
  [4620] = 1688,
  [4621] = 1543,
  [4622] = 1690,
  [4623] = 1698,
  [4624] = 1703,
  [4625] = 1665,
  [4626] = 1663,
  [4627] = 1654,
  [4628] = 1740,
  [4629] = 1647,
  [4630] = 1791,
  [4631] = 1792,
  [4632] = 1714,
  [4633] = 1686,
  [4634] = 1705,
  [4635] = 1601,
  [4636] = 1581,
  [4637] = 1584,
  [4638] = 1739,
  [4639] = 1496,
  [4640] = 1585,
  [4641] = 4641,
  [4642] = 4642,
  [4643] = 4643,
  [4644] = 4644,
  [4645] = 4645,
  [4646] = 4646,
  [4647] = 1448,
  [4648] = 4645,
  [4649] = 4649,
  [4650] = 4650,
  [4651] = 4645,
  [4652] = 1463,
  [4653] = 1472,
  [4654] = 1458,
  [4655] = 4655,
  [4656] = 4656,
  [4657] = 4657,
  [4658] = 4658,
  [4659] = 4658,
  [4660] = 4656,
  [4661] = 4657,
  [4662] = 4658,
  [4663] = 4658,
  [4664] = 4658,
  [4665] = 4657,
  [4666] = 4657,
  [4667] = 4667,
  [4668] = 4657,
  [4669] = 4657,
  [4670] = 4658,
  [4671] = 4657,
  [4672] = 4658,
  [4673] = 4658,
  [4674] = 4657,
  [4675] = 4657,
  [4676] = 4658,
  [4677] = 4657,
  [4678] = 4658,
  [4679] = 4658,
  [4680] = 4658,
  [4681] = 4658,
  [4682] = 4658,
  [4683] = 4683,
  [4684] = 4684,
  [4685] = 4657,
  [4686] = 4658,
  [4687] = 1469,
  [4688] = 4658,
  [4689] = 4683,
  [4690] = 4657,
  [4691] = 4658,
  [4692] = 4657,
  [4693] = 4693,
  [4694] = 4658,
  [4695] = 4657,
  [4696] = 4657,
  [4697] = 4657,
  [4698] = 4657,
  [4699] = 4657,
  [4700] = 4658,
  [4701] = 4656,
  [4702] = 4657,
  [4703] = 4658,
  [4704] = 4657,
  [4705] = 4658,
  [4706] = 4657,
  [4707] = 4658,
  [4708] = 4658,
  [4709] = 4657,
  [4710] = 4657,
  [4711] = 4658,
  [4712] = 4657,
  [4713] = 4658,
  [4714] = 4657,
  [4715] = 4715,
  [4716] = 4657,
  [4717] = 4657,
  [4718] = 4718,
  [4719] = 1495,
  [4720] = 4720,
  [4721] = 1489,
  [4722] = 4722,
  [4723] = 4723,
  [4724] = 4723,
  [4725] = 4723,
  [4726] = 4723,
  [4727] = 4723,
  [4728] = 4723,
  [4729] = 4723,
  [4730] = 4723,
  [4731] = 4723,
  [4732] = 4723,
  [4733] = 4723,
  [4734] = 4723,
  [4735] = 4723,
  [4736] = 4723,
  [4737] = 4737,
  [4738] = 4723,
  [4739] = 4723,
  [4740] = 4723,
  [4741] = 4723,
  [4742] = 4742,
  [4743] = 4723,
  [4744] = 4723,
  [4745] = 4723,
  [4746] = 4723,
  [4747] = 4723,
  [4748] = 4723,
  [4749] = 4749,
  [4750] = 4749,
  [4751] = 4749,
  [4752] = 4749,
  [4753] = 4749,
  [4754] = 4754,
  [4755] = 4749,
  [4756] = 4749,
  [4757] = 4749,
  [4758] = 4749,
  [4759] = 4749,
  [4760] = 4760,
  [4761] = 4749,
  [4762] = 4749,
  [4763] = 4749,
  [4764] = 4749,
  [4765] = 4749,
  [4766] = 4749,
  [4767] = 4749,
  [4768] = 4749,
  [4769] = 4754,
  [4770] = 4749,
  [4771] = 4760,
  [4772] = 4749,
  [4773] = 4760,
  [4774] = 4754,
  [4775] = 4749,
  [4776] = 4749,
  [4777] = 4749,
  [4778] = 4749,
  [4779] = 4779,
  [4780] = 4780,
  [4781] = 4779,
  [4782] = 4780,
  [4783] = 4783,
  [4784] = 4784,
  [4785] = 4780,
  [4786] = 4786,
  [4787] = 4779,
  [4788] = 4780,
  [4789] = 4779,
  [4790] = 4784,
  [4791] = 4780,
  [4792] = 4779,
  [4793] = 4793,
  [4794] = 4779,
  [4795] = 4779,
  [4796] = 4780,
  [4797] = 4780,
  [4798] = 4779,
  [4799] = 4780,
  [4800] = 4779,
  [4801] = 4779,
  [4802] = 4780,
  [4803] = 4784,
  [4804] = 4780,
  [4805] = 4780,
  [4806] = 4784,
  [4807] = 4807,
  [4808] = 4779,
  [4809] = 4779,
  [4810] = 4784,
  [4811] = 4779,
  [4812] = 4780,
  [4813] = 4780,
  [4814] = 4784,
  [4815] = 4779,
  [4816] = 4780,
  [4817] = 4780,
  [4818] = 4779,
  [4819] = 4779,
  [4820] = 4780,
  [4821] = 4780,
  [4822] = 4780,
  [4823] = 4780,
  [4824] = 4784,
  [4825] = 4779,
  [4826] = 4784,
  [4827] = 4784,
  [4828] = 4779,
  [4829] = 4780,
  [4830] = 4830,
  [4831] = 4784,
  [4832] = 4784,
  [4833] = 4784,
  [4834] = 4780,
  [4835] = 4780,
  [4836] = 4784,
  [4837] = 4786,
  [4838] = 4784,
  [4839] = 4784,
  [4840] = 4780,
  [4841] = 4784,
  [4842] = 4784,
  [4843] = 4779,
  [4844] = 4779,
  [4845] = 4784,
  [4846] = 4784,
  [4847] = 4779,
  [4848] = 4784,
  [4849] = 4784,
  [4850] = 4780,
  [4851] = 4779,
  [4852] = 4784,
  [4853] = 4779,
  [4854] = 4784,
  [4855] = 4784,
  [4856] = 4780,
  [4857] = 4779,
  [4858] = 4858,
  [4859] = 4859,
  [4860] = 1359,
  [4861] = 1455,
  [4862] = 1362,
  [4863] = 1361,
  [4864] = 1359,
  [4865] = 1449,
  [4866] = 4866,
  [4867] = 1458,
  [4868] = 1362,
  [4869] = 1361,
  [4870] = 4870,
  [4871] = 4870,
  [4872] = 4870,
  [4873] = 4870,
  [4874] = 4870,
  [4875] = 4870,
  [4876] = 1472,
  [4877] = 4877,
  [4878] = 4870,
  [4879] = 1463,
  [4880] = 4877,
  [4881] = 4870,
  [4882] = 4870,
  [4883] = 4870,
  [4884] = 1469,
  [4885] = 4870,
  [4886] = 4877,
  [4887] = 4870,
  [4888] = 4870,
  [4889] = 4870,
  [4890] = 1359,
  [4891] = 1361,
  [4892] = 4870,
  [4893] = 1467,
  [4894] = 4870,
  [4895] = 4870,
  [4896] = 4870,
  [4897] = 4870,
  [4898] = 1362,
  [4899] = 4870,
  [4900] = 4870,
  [4901] = 4870,
  [4902] = 4870,
  [4903] = 4870,
  [4904] = 1448,
  [4905] = 4870,
  [4906] = 1359,
  [4907] = 4907,
  [4908] = 1452,
  [4909] = 1361,
  [4910] = 1501,
  [4911] = 1489,
  [4912] = 4907,
  [4913] = 1496,
  [4914] = 1479,
  [4915] = 1362,
  [4916] = 1503,
  [4917] = 1359,
  [4918] = 1362,
  [4919] = 1499,
  [4920] = 1477,
  [4921] = 1495,
  [4922] = 1361,
  [4923] = 1505,
  [4924] = 4907,
  [4925] = 1500,
  [4926] = 1490,
  [4927] = 1454,
  [4928] = 1491,
  [4929] = 4907,
  [4930] = 1362,
  [4931] = 1454,
  [4932] = 1361,
  [4933] = 1362,
  [4934] = 1361,
  [4935] = 1359,
  [4936] = 1452,
  [4937] = 1359,
  [4938] = 4938,
  [4939] = 4938,
  [4940] = 1359,
  [4941] = 4938,
  [4942] = 1448,
  [4943] = 1362,
  [4944] = 1448,
  [4945] = 1448,
  [4946] = 4946,
  [4947] = 4947,
  [4948] = 4946,
  [4949] = 4949,
  [4950] = 4950,
  [4951] = 4949,
  [4952] = 4952,
  [4953] = 1654,
  [4954] = 4947,
  [4955] = 4952,
  [4956] = 1663,
  [4957] = 1665,
  [4958] = 4958,
  [4959] = 4950,
  [4960] = 1654,
  [4961] = 1647,
  [4962] = 4962,
  [4963] = 4962,
  [4964] = 1663,
  [4965] = 4965,
  [4966] = 4946,
  [4967] = 4965,
  [4968] = 1647,
  [4969] = 1665,
  [4970] = 4958,
  [4971] = 4949,
  [4972] = 4972,
  [4973] = 1654,
  [4974] = 4972,
  [4975] = 1665,
  [4976] = 4972,
  [4977] = 1647,
  [4978] = 4952,
  [4979] = 4958,
  [4980] = 4972,
  [4981] = 4972,
  [4982] = 4972,
  [4983] = 4972,
  [4984] = 4972,
  [4985] = 4965,
  [4986] = 4972,
  [4987] = 4962,
  [4988] = 4972,
  [4989] = 4972,
  [4990] = 4972,
  [4991] = 4972,
  [4992] = 4972,
  [4993] = 4972,
  [4994] = 4972,
  [4995] = 4972,
  [4996] = 4972,
  [4997] = 4972,
  [4998] = 4972,
  [4999] = 4972,
  [5000] = 5000,
  [5001] = 5001,
  [5002] = 4972,
  [5003] = 4972,
  [5004] = 4950,
  [5005] = 4947,
  [5006] = 4042,
  [5007] = 4022,
  [5008] = 4972,
  [5009] = 4972,
  [5010] = 4972,
  [5011] = 1663,
  [5012] = 3944,
  [5013] = 4972,
  [5014] = 1585,
  [5015] = 1514,
  [5016] = 1601,
  [5017] = 1584,
  [5018] = 5018,
  [5019] = 1543,
  [5020] = 1581,
  [5021] = 5021,
  [5022] = 1455,
  [5023] = 1448,
  [5024] = 1449,
  [5025] = 5025,
  [5026] = 1449,
  [5027] = 5027,
  [5028] = 5028,
  [5029] = 5029,
  [5030] = 5030,
  [5031] = 1455,
  [5032] = 5032,
  [5033] = 1574,
  [5034] = 1458,
  [5035] = 5035,
  [5036] = 5036,
  [5037] = 1458,
  [5038] = 5038,
  [5039] = 1455,
  [5040] = 5040,
  [5041] = 1449,
  [5042] = 5042,
  [5043] = 1463,
  [5044] = 1467,
  [5045] = 1469,
  [5046] = 1463,
  [5047] = 1448,
  [5048] = 1448,
  [5049] = 1449,
  [5050] = 1472,
  [5051] = 1467,
  [5052] = 1472,
  [5053] = 1458,
  [5054] = 1488,
  [5055] = 1469,
  [5056] = 5056,
  [5057] = 1463,
  [5058] = 1458,
  [5059] = 1472,
  [5060] = 1629,
  [5061] = 1489,
  [5062] = 1467,
  [5063] = 1479,
  [5064] = 1495,
  [5065] = 1703,
  [5066] = 5066,
  [5067] = 1500,
  [5068] = 5068,
  [5069] = 1472,
  [5070] = 1463,
  [5071] = 1630,
  [5072] = 1477,
  [5073] = 1500,
  [5074] = 1660,
  [5075] = 1792,
  [5076] = 1791,
  [5077] = 1505,
  [5078] = 1505,
  [5079] = 1458,
  [5080] = 5080,
  [5081] = 1658,
  [5082] = 5082,
  [5083] = 1449,
  [5084] = 1458,
  [5085] = 1499,
  [5086] = 1635,
  [5087] = 1477,
  [5088] = 5088,
  [5089] = 1499,
  [5090] = 1634,
  [5091] = 1495,
  [5092] = 1698,
  [5093] = 1448,
  [5094] = 5094,
  [5095] = 1469,
  [5096] = 1690,
  [5097] = 5097,
  [5098] = 1491,
  [5099] = 5099,
  [5100] = 1626,
  [5101] = 1646,
  [5102] = 1501,
  [5103] = 1688,
  [5104] = 1651,
  [5105] = 1490,
  [5106] = 1490,
  [5107] = 5107,
  [5108] = 1652,
  [5109] = 1491,
  [5110] = 1501,
  [5111] = 1455,
  [5112] = 1496,
  [5113] = 5113,
  [5114] = 1449,
  [5115] = 1479,
  [5116] = 1467,
  [5117] = 1496,
  [5118] = 5118,
  [5119] = 1670,
  [5120] = 1503,
  [5121] = 1503,
  [5122] = 1740,
  [5123] = 1739,
  [5124] = 1455,
  [5125] = 1681,
  [5126] = 1489,
  [5127] = 5127,
  [5128] = 1469,
  [5129] = 1684,
  [5130] = 1495,
  [5131] = 1463,
  [5132] = 1477,
  [5133] = 1491,
  [5134] = 1489,
  [5135] = 1448,
  [5136] = 1455,
  [5137] = 1472,
  [5138] = 1448,
  [5139] = 1496,
  [5140] = 1557,
  [5141] = 5141,
  [5142] = 1495,
  [5143] = 1499,
  [5144] = 1448,
  [5145] = 1499,
  [5146] = 1501,
  [5147] = 1458,
  [5148] = 1479,
  [5149] = 1500,
  [5150] = 1490,
  [5151] = 1500,
  [5152] = 1454,
  [5153] = 5153,
  [5154] = 1505,
  [5155] = 1452,
  [5156] = 1454,
  [5157] = 1449,
  [5158] = 1467,
  [5159] = 1467,
  [5160] = 1458,
  [5161] = 1549,
  [5162] = 5162,
  [5163] = 1550,
  [5164] = 1449,
  [5165] = 1469,
  [5166] = 1489,
  [5167] = 1452,
  [5168] = 1556,
  [5169] = 1472,
  [5170] = 1455,
  [5171] = 1469,
  [5172] = 1463,
  [5173] = 1503,
  [5174] = 1500,
  [5175] = 1452,
  [5176] = 1499,
  [5177] = 1452,
  [5178] = 1452,
  [5179] = 1495,
  [5180] = 1489,
  [5181] = 1463,
  [5182] = 1495,
  [5183] = 1448,
  [5184] = 1452,
  [5185] = 1452,
  [5186] = 1505,
  [5187] = 1496,
  [5188] = 1479,
  [5189] = 1490,
  [5190] = 1499,
  [5191] = 1503,
  [5192] = 1469,
  [5193] = 1454,
  [5194] = 5194,
  [5195] = 1496,
  [5196] = 1503,
  [5197] = 1477,
  [5198] = 1472,
  [5199] = 1454,
  [5200] = 1500,
  [5201] = 5201,
  [5202] = 1472,
  [5203] = 1489,
  [5204] = 1467,
  [5205] = 1454,
  [5206] = 1463,
  [5207] = 1469,
  [5208] = 1479,
  [5209] = 1467,
  [5210] = 1454,
  [5211] = 1490,
  [5212] = 1501,
  [5213] = 1477,
  [5214] = 1491,
  [5215] = 1491,
  [5216] = 1454,
  [5217] = 1505,
  [5218] = 1501,
  [5219] = 5219,
  [5220] = 5220,
  [5221] = 1503,
  [5222] = 1495,
  [5223] = 5219,
  [5224] = 5219,
  [5225] = 1477,
  [5226] = 1491,
  [5227] = 1477,
  [5228] = 5219,
  [5229] = 5219,
  [5230] = 1489,
  [5231] = 1454,
  [5232] = 5219,
  [5233] = 5219,
  [5234] = 5219,
  [5235] = 1489,
  [5236] = 5219,
  [5237] = 1500,
  [5238] = 5219,
  [5239] = 1503,
  [5240] = 1479,
  [5241] = 5219,
  [5242] = 5219,
  [5243] = 1505,
  [5244] = 1454,
  [5245] = 1500,
  [5246] = 5219,
  [5247] = 1491,
  [5248] = 1499,
  [5249] = 1452,
  [5250] = 1505,
  [5251] = 1479,
  [5252] = 5252,
  [5253] = 1490,
  [5254] = 1452,
  [5255] = 5219,
  [5256] = 1501,
  [5257] = 5219,
  [5258] = 1501,
  [5259] = 1490,
  [5260] = 1496,
  [5261] = 5219,
  [5262] = 1495,
  [5263] = 1499,
  [5264] = 1496,
  [5265] = 5219,
  [5266] = 5219,
  [5267] = 5219,
  [5268] = 5268,
  [5269] = 5268,
  [5270] = 5268,
  [5271] = 5268,
  [5272] = 1454,
  [5273] = 5268,
  [5274] = 5268,
  [5275] = 5268,
  [5276] = 5268,
  [5277] = 5268,
  [5278] = 5268,
  [5279] = 1454,
  [5280] = 5268,
  [5281] = 5268,
  [5282] = 5268,
  [5283] = 5268,
  [5284] = 5268,
  [5285] = 1452,
  [5286] = 1452,
  [5287] = 5268,
  [5288] = 5268,
  [5289] = 5268,
  [5290] = 5268,
  [5291] = 5268,
  [5292] = 5268,
  [5293] = 5268,
  [5294] = 5268,
  [5295] = 5295,
  [5296] = 5295,
  [5297] = 5297,
  [5298] = 5295,
  [5299] = 5295,
  [5300] = 5295,
  [5301] = 5297,
  [5302] = 5302,
  [5303] = 5295,
  [5304] = 5297,
  [5305] = 5305,
  [5306] = 5297,
  [5307] = 5297,
  [5308] = 5295,
  [5309] = 5297,
  [5310] = 5297,
  [5311] = 5297,
  [5312] = 5295,
  [5313] = 5295,
  [5314] = 5297,
  [5315] = 5295,
  [5316] = 5295,
  [5317] = 5297,
  [5318] = 5297,
  [5319] = 5297,
  [5320] = 5295,
  [5321] = 5297,
  [5322] = 5297,
  [5323] = 5295,
  [5324] = 5297,
  [5325] = 5325,
  [5326] = 5295,
  [5327] = 5295,
  [5328] = 5297,
  [5329] = 5295,
  [5330] = 1448,
  [5331] = 5331,
  [5332] = 1543,
  [5333] = 5331,
  [5334] = 5331,
  [5335] = 1584,
  [5336] = 5331,
  [5337] = 5331,
  [5338] = 5338,
  [5339] = 5339,
  [5340] = 1601,
  [5341] = 5341,
  [5342] = 5342,
  [5343] = 5331,
  [5344] = 4022,
  [5345] = 5331,
  [5346] = 5331,
  [5347] = 1585,
  [5348] = 5348,
  [5349] = 5331,
  [5350] = 5350,
  [5351] = 5331,
  [5352] = 5341,
  [5353] = 5342,
  [5354] = 5331,
  [5355] = 5331,
  [5356] = 5338,
  [5357] = 4042,
  [5358] = 5358,
  [5359] = 5359,
  [5360] = 5342,
  [5361] = 1585,
  [5362] = 5331,
  [5363] = 1581,
  [5364] = 5338,
  [5365] = 5331,
  [5366] = 3944,
  [5367] = 5331,
  [5368] = 5331,
  [5369] = 5341,
  [5370] = 5370,
  [5371] = 5370,
  [5372] = 5372,
  [5373] = 5370,
  [5374] = 5372,
  [5375] = 5372,
  [5376] = 1601,
  [5377] = 5377,
  [5378] = 5370,
  [5379] = 5372,
  [5380] = 5380,
  [5381] = 5372,
  [5382] = 5372,
  [5383] = 5372,
  [5384] = 5372,
  [5385] = 5370,
  [5386] = 5370,
  [5387] = 5370,
  [5388] = 5370,
  [5389] = 5372,
  [5390] = 5372,
  [5391] = 5372,
  [5392] = 4946,
  [5393] = 5372,
  [5394] = 5370,
  [5395] = 5370,
  [5396] = 5370,
  [5397] = 5397,
  [5398] = 1585,
  [5399] = 5372,
  [5400] = 5370,
  [5401] = 1581,
  [5402] = 5372,
  [5403] = 5372,
  [5404] = 5404,
  [5405] = 1543,
  [5406] = 5406,
  [5407] = 5370,
  [5408] = 5370,
  [5409] = 5372,
  [5410] = 5372,
  [5411] = 5372,
  [5412] = 5370,
  [5413] = 5372,
  [5414] = 1584,
  [5415] = 5372,
  [5416] = 5372,
  [5417] = 5370,
  [5418] = 5370,
  [5419] = 5370,
  [5420] = 5370,
  [5421] = 5370,
  [5422] = 5370,
  [5423] = 5423,
  [5424] = 5424,
  [5425] = 5425,
  [5426] = 5424,
  [5427] = 5427,
  [5428] = 5428,
  [5429] = 1448,
  [5430] = 1514,
  [5431] = 5428,
  [5432] = 5432,
  [5433] = 5433,
  [5434] = 5433,
  [5435] = 5432,
  [5436] = 5432,
  [5437] = 5424,
  [5438] = 5432,
  [5439] = 5439,
  [5440] = 5424,
  [5441] = 5428,
  [5442] = 5428,
  [5443] = 5443,
  [5444] = 5432,
  [5445] = 5432,
  [5446] = 5432,
  [5447] = 5424,
  [5448] = 5424,
  [5449] = 5432,
  [5450] = 5424,
  [5451] = 5428,
  [5452] = 5424,
  [5453] = 5432,
  [5454] = 5424,
  [5455] = 5428,
  [5456] = 5432,
  [5457] = 5424,
  [5458] = 5428,
  [5459] = 5459,
  [5460] = 5428,
  [5461] = 5428,
  [5462] = 5432,
  [5463] = 5424,
  [5464] = 5428,
  [5465] = 5432,
  [5466] = 5428,
  [5467] = 1574,
  [5468] = 5424,
  [5469] = 5428,
  [5470] = 5428,
  [5471] = 5424,
  [5472] = 5432,
  [5473] = 5424,
  [5474] = 5424,
  [5475] = 5432,
  [5476] = 5428,
  [5477] = 5432,
  [5478] = 5428,
  [5479] = 5424,
  [5480] = 1514,
  [5481] = 5428,
  [5482] = 5432,
  [5483] = 5428,
  [5484] = 5428,
  [5485] = 5428,
  [5486] = 5443,
  [5487] = 5424,
  [5488] = 1574,
  [5489] = 5432,
  [5490] = 5443,
  [5491] = 5428,
  [5492] = 5492,
  [5493] = 5428,
  [5494] = 5494,
  [5495] = 5424,
  [5496] = 5432,
  [5497] = 5497,
  [5498] = 5433,
  [5499] = 5432,
  [5500] = 5428,
  [5501] = 5428,
  [5502] = 5424,
  [5503] = 5428,
  [5504] = 5432,
  [5505] = 5424,
  [5506] = 5506,
  [5507] = 5424,
  [5508] = 5432,
  [5509] = 1584,
  [5510] = 1584,
  [5511] = 1703,
  [5512] = 5512,
  [5513] = 1601,
  [5514] = 5514,
  [5515] = 5515,
  [5516] = 5516,
  [5517] = 5517,
  [5518] = 5512,
  [5519] = 5519,
  [5520] = 1619,
  [5521] = 5516,
  [5522] = 5512,
  [5523] = 5523,
  [5524] = 1588,
  [5525] = 5525,
  [5526] = 1630,
  [5527] = 5527,
  [5528] = 5439,
  [5529] = 1604,
  [5530] = 1607,
  [5531] = 1598,
  [5532] = 1597,
  [5533] = 5533,
  [5534] = 1593,
  [5535] = 1626,
  [5536] = 1514,
  [5537] = 1791,
  [5538] = 5512,
  [5539] = 1792,
  [5540] = 1625,
  [5541] = 1624,
  [5542] = 1623,
  [5543] = 1621,
  [5544] = 1620,
  [5545] = 1618,
  [5546] = 1617,
  [5547] = 1616,
  [5548] = 1615,
  [5549] = 1613,
  [5550] = 1629,
  [5551] = 1472,
  [5552] = 1634,
  [5553] = 5523,
  [5554] = 5523,
  [5555] = 5516,
  [5556] = 5512,
  [5557] = 1635,
  [5558] = 1611,
  [5559] = 1707,
  [5560] = 5523,
  [5561] = 5494,
  [5562] = 5562,
  [5563] = 1581,
  [5564] = 1543,
  [5565] = 5565,
  [5566] = 1662,
  [5567] = 1605,
  [5568] = 5568,
  [5569] = 1514,
  [5570] = 1646,
  [5571] = 5516,
  [5572] = 1588,
  [5573] = 5512,
  [5574] = 1574,
  [5575] = 5523,
  [5576] = 1543,
  [5577] = 5577,
  [5578] = 1585,
  [5579] = 1574,
  [5580] = 1581,
  [5581] = 5523,
  [5582] = 5582,
  [5583] = 5583,
  [5584] = 5406,
  [5585] = 5427,
  [5586] = 5459,
  [5587] = 1651,
  [5588] = 5404,
  [5589] = 1652,
  [5590] = 5523,
  [5591] = 1658,
  [5592] = 1660,
  [5593] = 1670,
  [5594] = 1681,
  [5595] = 1684,
  [5596] = 1688,
  [5597] = 1690,
  [5598] = 1698,
  [5599] = 1514,
  [5600] = 1739,
  [5601] = 1740,
  [5602] = 1604,
  [5603] = 5516,
  [5604] = 1791,
  [5605] = 5512,
  [5606] = 1792,
  [5607] = 5512,
  [5608] = 5512,
  [5609] = 1593,
  [5610] = 5512,
  [5611] = 5611,
  [5612] = 5523,
  [5613] = 5523,
  [5614] = 1600,
  [5615] = 5512,
  [5616] = 5523,
  [5617] = 1607,
  [5618] = 1597,
  [5619] = 1705,
  [5620] = 1598,
  [5621] = 5523,
  [5622] = 1598,
  [5623] = 1597,
  [5624] = 1607,
  [5625] = 5523,
  [5626] = 5404,
  [5627] = 5512,
  [5628] = 5406,
  [5629] = 5629,
  [5630] = 1686,
  [5631] = 5631,
  [5632] = 1604,
  [5633] = 1593,
  [5634] = 5634,
  [5635] = 5635,
  [5636] = 5523,
  [5637] = 1574,
  [5638] = 1601,
  [5639] = 5639,
  [5640] = 1740,
  [5641] = 5512,
  [5642] = 5642,
  [5643] = 1739,
  [5644] = 5644,
  [5645] = 5645,
  [5646] = 1588,
  [5647] = 1605,
  [5648] = 5648,
  [5649] = 5649,
  [5650] = 5650,
  [5651] = 5523,
  [5652] = 5652,
  [5653] = 5523,
  [5654] = 5512,
  [5655] = 5512,
  [5656] = 5516,
  [5657] = 5512,
  [5658] = 5516,
  [5659] = 5659,
  [5660] = 1448,
  [5661] = 5439,
  [5662] = 5523,
  [5663] = 5523,
  [5664] = 1448,
  [5665] = 5512,
  [5666] = 1463,
  [5667] = 5667,
  [5668] = 5668,
  [5669] = 5668,
  [5670] = 5670,
  [5671] = 5671,
  [5672] = 5667,
  [5673] = 5673,
  [5674] = 5667,
  [5675] = 5673,
  [5676] = 5671,
  [5677] = 5677,
  [5678] = 5678,
  [5679] = 5032,
  [5680] = 1740,
  [5681] = 5681,
  [5682] = 5682,
  [5683] = 5683,
  [5684] = 5684,
  [5685] = 5685,
  [5686] = 5686,
  [5687] = 5687,
  [5688] = 1448,
  [5689] = 5689,
  [5690] = 5690,
  [5691] = 1739,
  [5692] = 5692,
  [5693] = 5693,
  [5694] = 5694,
  [5695] = 5695,
  [5696] = 5696,
  [5697] = 5682,
  [5698] = 5698,
  [5699] = 5695,
  [5700] = 5682,
  [5701] = 5692,
  [5702] = 5687,
  [5703] = 5668,
  [5704] = 5704,
  [5705] = 5678,
  [5706] = 5673,
  [5707] = 5667,
  [5708] = 5671,
  [5709] = 5709,
  [5710] = 5694,
  [5711] = 5693,
  [5712] = 5712,
  [5713] = 5682,
  [5714] = 5709,
  [5715] = 5689,
  [5716] = 5690,
  [5717] = 5698,
  [5718] = 5681,
  [5719] = 5719,
  [5720] = 5720,
  [5721] = 5712,
  [5722] = 5709,
  [5723] = 5719,
  [5724] = 5686,
  [5725] = 5689,
  [5726] = 5683,
  [5727] = 5720,
  [5728] = 5684,
  [5729] = 5686,
  [5730] = 5684,
  [5731] = 5690,
  [5732] = 5683,
  [5733] = 5733,
  [5734] = 5698,
  [5735] = 5735,
  [5736] = 5733,
  [5737] = 5733,
  [5738] = 4641,
  [5739] = 5681,
  [5740] = 5668,
  [5741] = 1514,
  [5742] = 5733,
  [5743] = 5678,
  [5744] = 5693,
  [5745] = 5733,
  [5746] = 5694,
  [5747] = 5733,
  [5748] = 5748,
  [5749] = 5678,
  [5750] = 5733,
  [5751] = 5696,
  [5752] = 5733,
  [5753] = 5681,
  [5754] = 5720,
  [5755] = 5683,
  [5756] = 5684,
  [5757] = 5712,
  [5758] = 5686,
  [5759] = 5696,
  [5760] = 5695,
  [5761] = 5733,
  [5762] = 5696,
  [5763] = 5692,
  [5764] = 5733,
  [5765] = 5693,
  [5766] = 5694,
  [5767] = 5709,
  [5768] = 5696,
  [5769] = 5687,
  [5770] = 5719,
  [5771] = 5695,
  [5772] = 5733,
  [5773] = 5692,
  [5774] = 5687,
  [5775] = 5696,
  [5776] = 5733,
  [5777] = 5696,
  [5778] = 5673,
  [5779] = 5667,
  [5780] = 5671,
  [5781] = 5733,
  [5782] = 5696,
  [5783] = 5695,
  [5784] = 5733,
  [5785] = 5682,
  [5786] = 5696,
  [5787] = 5689,
  [5788] = 5690,
  [5789] = 5698,
  [5790] = 5673,
  [5791] = 5667,
  [5792] = 5709,
  [5793] = 5712,
  [5794] = 5709,
  [5795] = 5719,
  [5796] = 5671,
  [5797] = 5712,
  [5798] = 5733,
  [5799] = 5720,
  [5800] = 5696,
  [5801] = 5801,
  [5802] = 5668,
  [5803] = 5719,
  [5804] = 5804,
  [5805] = 5720,
  [5806] = 5668,
  [5807] = 5682,
  [5808] = 5687,
  [5809] = 5689,
  [5810] = 5698,
  [5811] = 5690,
  [5812] = 5668,
  [5813] = 5668,
  [5814] = 5692,
  [5815] = 5720,
  [5816] = 5690,
  [5817] = 5698,
  [5818] = 5735,
  [5819] = 5733,
  [5820] = 5696,
  [5821] = 5678,
  [5822] = 5719,
  [5823] = 5823,
  [5824] = 5689,
  [5825] = 5681,
  [5826] = 5695,
  [5827] = 5683,
  [5828] = 5684,
  [5829] = 5823,
  [5830] = 5686,
  [5831] = 5682,
  [5832] = 5712,
  [5833] = 5709,
  [5834] = 5834,
  [5835] = 5823,
  [5836] = 5719,
  [5837] = 5693,
  [5838] = 5694,
  [5839] = 5720,
  [5840] = 5823,
  [5841] = 5678,
  [5842] = 5681,
  [5843] = 5695,
  [5844] = 5683,
  [5845] = 5692,
  [5846] = 5687,
  [5847] = 5823,
  [5848] = 5684,
  [5849] = 5686,
  [5850] = 5673,
  [5851] = 5823,
  [5852] = 5671,
  [5853] = 5712,
  [5854] = 5694,
  [5855] = 5733,
  [5856] = 5823,
  [5857] = 5682,
  [5858] = 1668,
  [5859] = 5689,
  [5860] = 5690,
  [5861] = 5698,
  [5862] = 5735,
  [5863] = 5671,
  [5864] = 5667,
  [5865] = 5712,
  [5866] = 5709,
  [5867] = 5719,
  [5868] = 5693,
  [5869] = 1703,
  [5870] = 1680,
  [5871] = 5720,
  [5872] = 5673,
  [5873] = 5823,
  [5874] = 5698,
  [5875] = 5668,
  [5876] = 5690,
  [5877] = 5693,
  [5878] = 5689,
  [5879] = 5694,
  [5880] = 5695,
  [5881] = 5692,
  [5882] = 5823,
  [5883] = 5687,
  [5884] = 5668,
  [5885] = 5885,
  [5886] = 5886,
  [5887] = 5804,
  [5888] = 5888,
  [5889] = 5686,
  [5890] = 5687,
  [5891] = 1698,
  [5892] = 5673,
  [5893] = 5678,
  [5894] = 5671,
  [5895] = 1690,
  [5896] = 1688,
  [5897] = 5681,
  [5898] = 5692,
  [5899] = 5683,
  [5900] = 5684,
  [5901] = 5695,
  [5902] = 5686,
  [5903] = 5667,
  [5904] = 5667,
  [5905] = 5671,
  [5906] = 5684,
  [5907] = 5673,
  [5908] = 5682,
  [5909] = 5693,
  [5910] = 5694,
  [5911] = 5683,
  [5912] = 5823,
  [5913] = 5694,
  [5914] = 5689,
  [5915] = 5695,
  [5916] = 5886,
  [5917] = 5692,
  [5918] = 5687,
  [5919] = 5690,
  [5920] = 5698,
  [5921] = 5888,
  [5922] = 5673,
  [5923] = 5667,
  [5924] = 5671,
  [5925] = 5681,
  [5926] = 5668,
  [5927] = 5720,
  [5928] = 1684,
  [5929] = 5682,
  [5930] = 5712,
  [5931] = 5689,
  [5932] = 5690,
  [5933] = 5698,
  [5934] = 5687,
  [5935] = 1681,
  [5936] = 1670,
  [5937] = 5712,
  [5938] = 5709,
  [5939] = 5719,
  [5940] = 5709,
  [5941] = 5823,
  [5942] = 5719,
  [5943] = 5720,
  [5944] = 5886,
  [5945] = 5678,
  [5946] = 5692,
  [5947] = 5693,
  [5948] = 5888,
  [5949] = 5678,
  [5950] = 5681,
  [5951] = 5720,
  [5952] = 5695,
  [5953] = 5683,
  [5954] = 5888,
  [5955] = 5823,
  [5956] = 5678,
  [5957] = 5886,
  [5958] = 5719,
  [5959] = 5709,
  [5960] = 5681,
  [5961] = 5961,
  [5962] = 5888,
  [5963] = 5684,
  [5964] = 5678,
  [5965] = 5686,
  [5966] = 5694,
  [5967] = 5668,
  [5968] = 5686,
  [5969] = 1514,
  [5970] = 5693,
  [5971] = 5693,
  [5972] = 5823,
  [5973] = 5686,
  [5974] = 5694,
  [5975] = 5689,
  [5976] = 5692,
  [5977] = 5687,
  [5978] = 5886,
  [5979] = 5979,
  [5980] = 5684,
  [5981] = 5834,
  [5982] = 5982,
  [5983] = 5682,
  [5984] = 5748,
  [5985] = 5683,
  [5986] = 5888,
  [5987] = 5712,
  [5988] = 5709,
  [5989] = 5695,
  [5990] = 5990,
  [5991] = 5991,
  [5992] = 5720,
  [5993] = 5686,
  [5994] = 5683,
  [5995] = 5681,
  [5996] = 5684,
  [5997] = 5692,
  [5998] = 5687,
  [5999] = 5681,
  [6000] = 5683,
  [6001] = 5673,
  [6002] = 5667,
  [6003] = 6003,
  [6004] = 5709,
  [6005] = 5683,
  [6006] = 5712,
  [6007] = 1660,
  [6008] = 5684,
  [6009] = 5678,
  [6010] = 5686,
  [6011] = 5684,
  [6012] = 5823,
  [6013] = 5671,
  [6014] = 5886,
  [6015] = 1658,
  [6016] = 6016,
  [6017] = 5681,
  [6018] = 5692,
  [6019] = 5687,
  [6020] = 6020,
  [6021] = 5888,
  [6022] = 5684,
  [6023] = 5682,
  [6024] = 5801,
  [6025] = 5804,
  [6026] = 6026,
  [6027] = 5712,
  [6028] = 5709,
  [6029] = 5668,
  [6030] = 5720,
  [6031] = 5678,
  [6032] = 5720,
  [6033] = 5682,
  [6034] = 5719,
  [6035] = 5823,
  [6036] = 5686,
  [6037] = 5886,
  [6038] = 5582,
  [6039] = 5888,
  [6040] = 5689,
  [6041] = 5690,
  [6042] = 5698,
  [6043] = 5735,
  [6044] = 5735,
  [6045] = 5709,
  [6046] = 5684,
  [6047] = 5712,
  [6048] = 5686,
  [6049] = 5668,
  [6050] = 5823,
  [6051] = 5709,
  [6052] = 5719,
  [6053] = 5886,
  [6054] = 5692,
  [6055] = 5687,
  [6056] = 5712,
  [6057] = 5720,
  [6058] = 5682,
  [6059] = 5888,
  [6060] = 4642,
  [6061] = 5678,
  [6062] = 5712,
  [6063] = 5709,
  [6064] = 5684,
  [6065] = 6065,
  [6066] = 5690,
  [6067] = 5720,
  [6068] = 5689,
  [6069] = 5886,
  [6070] = 5823,
  [6071] = 6071,
  [6072] = 5681,
  [6073] = 5668,
  [6074] = 1448,
  [6075] = 5886,
  [6076] = 5720,
  [6077] = 5698,
  [6078] = 5683,
  [6079] = 5686,
  [6080] = 5719,
  [6081] = 5684,
  [6082] = 5690,
  [6083] = 5687,
  [6084] = 5888,
  [6085] = 5686,
  [6086] = 1651,
  [6087] = 6087,
  [6088] = 5693,
  [6089] = 5694,
  [6090] = 5682,
  [6091] = 5823,
  [6092] = 5671,
  [6093] = 5712,
  [6094] = 6094,
  [6095] = 5735,
  [6096] = 5698,
  [6097] = 1792,
  [6098] = 5686,
  [6099] = 5690,
  [6100] = 5693,
  [6101] = 5689,
  [6102] = 5687,
  [6103] = 5886,
  [6104] = 5888,
  [6105] = 5693,
  [6106] = 5631,
  [6107] = 5694,
  [6108] = 1791,
  [6109] = 5694,
  [6110] = 6071,
  [6111] = 5698,
  [6112] = 5804,
  [6113] = 5686,
  [6114] = 5682,
  [6115] = 5823,
  [6116] = 6116,
  [6117] = 5687,
  [6118] = 5695,
  [6119] = 6119,
  [6120] = 5886,
  [6121] = 5888,
  [6122] = 5678,
  [6123] = 5804,
  [6124] = 5681,
  [6125] = 5720,
  [6126] = 5686,
  [6127] = 5671,
  [6128] = 5823,
  [6129] = 5687,
  [6130] = 5692,
  [6131] = 5695,
  [6132] = 5683,
  [6133] = 5886,
  [6134] = 5667,
  [6135] = 1646,
  [6136] = 5719,
  [6137] = 5686,
  [6138] = 5673,
  [6139] = 5692,
  [6140] = 5687,
  [6141] = 5888,
  [6142] = 5684,
  [6143] = 5687,
  [6144] = 5686,
  [6145] = 5667,
  [6146] = 6146,
  [6147] = 5748,
  [6148] = 6148,
  [6149] = 5823,
  [6150] = 6150,
  [6151] = 5693,
  [6152] = 5694,
  [6153] = 5709,
  [6154] = 5886,
  [6155] = 5687,
  [6156] = 5888,
  [6157] = 5673,
  [6158] = 5695,
  [6159] = 5692,
  [6160] = 5823,
  [6161] = 5687,
  [6162] = 6162,
  [6163] = 5685,
  [6164] = 5673,
  [6165] = 5562,
  [6166] = 6166,
  [6167] = 5673,
  [6168] = 5823,
  [6169] = 5667,
  [6170] = 6119,
  [6171] = 5671,
  [6172] = 5886,
  [6173] = 5667,
  [6174] = 5804,
  [6175] = 5888,
  [6176] = 5671,
  [6177] = 5685,
  [6178] = 5682,
  [6179] = 5689,
  [6180] = 5687,
  [6181] = 5692,
  [6182] = 5690,
  [6183] = 6183,
  [6184] = 1574,
  [6185] = 1574,
  [6186] = 5698,
  [6187] = 5695,
  [6188] = 5712,
  [6189] = 5694,
  [6190] = 5733,
  [6191] = 5693,
  [6192] = 5735,
  [6193] = 5712,
  [6194] = 5888,
  [6195] = 5685,
  [6196] = 5709,
  [6197] = 6197,
  [6198] = 5686,
  [6199] = 5719,
  [6200] = 5720,
  [6201] = 5886,
  [6202] = 6202,
  [6203] = 5687,
  [6204] = 5692,
  [6205] = 5682,
  [6206] = 5673,
  [6207] = 5667,
  [6208] = 5682,
  [6209] = 6119,
  [6210] = 6210,
  [6211] = 5823,
  [6212] = 1652,
  [6213] = 5671,
  [6214] = 5801,
  [6215] = 5804,
  [6216] = 5668,
  [6217] = 6166,
  [6218] = 5689,
  [6219] = 6166,
  [6220] = 6220,
  [6221] = 5678,
  [6222] = 5681,
  [6223] = 5690,
  [6224] = 6224,
  [6225] = 5684,
  [6226] = 5683,
  [6227] = 5698,
  [6228] = 5686,
  [6229] = 6229,
  [6230] = 6230,
  [6231] = 6231,
  [6232] = 6232,
  [6233] = 6233,
  [6234] = 6234,
  [6235] = 6234,
  [6236] = 6234,
  [6237] = 6234,
  [6238] = 6234,
  [6239] = 6239,
  [6240] = 6240,
  [6241] = 6234,
  [6242] = 6233,
  [6243] = 6230,
  [6244] = 6234,
  [6245] = 6234,
  [6246] = 6234,
  [6247] = 6234,
  [6248] = 6234,
  [6249] = 6234,
  [6250] = 6229,
  [6251] = 6234,
  [6252] = 6234,
  [6253] = 6253,
  [6254] = 6234,
  [6255] = 6255,
  [6256] = 6256,
  [6257] = 6229,
  [6258] = 6258,
  [6259] = 6256,
  [6260] = 5042,
  [6261] = 6256,
  [6262] = 6262,
  [6263] = 6233,
  [6264] = 1463,
  [6265] = 6256,
  [6266] = 6229,
  [6267] = 6267,
  [6268] = 6268,
  [6269] = 6269,
  [6270] = 6229,
  [6271] = 6271,
  [6272] = 6272,
  [6273] = 6273,
  [6274] = 6272,
  [6275] = 6275,
  [6276] = 6273,
  [6277] = 6272,
  [6278] = 6229,
  [6279] = 6273,
  [6280] = 6280,
  [6281] = 6256,
  [6282] = 6256,
  [6283] = 6283,
  [6284] = 6256,
  [6285] = 6256,
  [6286] = 6272,
  [6287] = 6256,
  [6288] = 6273,
  [6289] = 6256,
  [6290] = 6290,
  [6291] = 6255,
  [6292] = 6283,
  [6293] = 6256,
  [6294] = 6256,
  [6295] = 6256,
  [6296] = 6256,
  [6297] = 6272,
  [6298] = 6273,
  [6299] = 6256,
  [6300] = 6230,
  [6301] = 6256,
  [6302] = 6240,
  [6303] = 6290,
  [6304] = 6256,
  [6305] = 6256,
  [6306] = 6256,
  [6307] = 6283,
  [6308] = 6272,
  [6309] = 6273,
  [6310] = 6290,
  [6311] = 6311,
  [6312] = 6283,
  [6313] = 6272,
  [6314] = 6273,
  [6315] = 6256,
  [6316] = 6290,
  [6317] = 6256,
  [6318] = 6233,
  [6319] = 6256,
  [6320] = 6283,
  [6321] = 6272,
  [6322] = 6256,
  [6323] = 6323,
  [6324] = 6273,
  [6325] = 6290,
  [6326] = 6256,
  [6327] = 6327,
  [6328] = 6283,
  [6329] = 6255,
  [6330] = 6272,
  [6331] = 6273,
  [6332] = 6256,
  [6333] = 6290,
  [6334] = 6334,
  [6335] = 6230,
  [6336] = 6283,
  [6337] = 6240,
  [6338] = 6272,
  [6339] = 6273,
  [6340] = 6290,
  [6341] = 6341,
  [6342] = 6229,
  [6343] = 6233,
  [6344] = 6283,
  [6345] = 6272,
  [6346] = 6272,
  [6347] = 6229,
  [6348] = 6273,
  [6349] = 6256,
  [6350] = 6290,
  [6351] = 6283,
  [6352] = 6272,
  [6353] = 6353,
  [6354] = 6229,
  [6355] = 6273,
  [6356] = 6290,
  [6357] = 6256,
  [6358] = 6358,
  [6359] = 6359,
  [6360] = 6283,
  [6361] = 6255,
  [6362] = 6272,
  [6363] = 1472,
  [6364] = 6229,
  [6365] = 6365,
  [6366] = 6273,
  [6367] = 6230,
  [6368] = 6290,
  [6369] = 6240,
  [6370] = 6370,
  [6371] = 6283,
  [6372] = 6272,
  [6373] = 6273,
  [6374] = 6290,
  [6375] = 6375,
  [6376] = 6376,
  [6377] = 6283,
  [6378] = 6272,
  [6379] = 6379,
  [6380] = 6233,
  [6381] = 6273,
  [6382] = 6290,
  [6383] = 6256,
  [6384] = 6384,
  [6385] = 6385,
  [6386] = 6283,
  [6387] = 6272,
  [6388] = 6388,
  [6389] = 6273,
  [6390] = 6290,
  [6391] = 6391,
  [6392] = 6255,
  [6393] = 6283,
  [6394] = 6272,
  [6395] = 6229,
  [6396] = 6396,
  [6397] = 6397,
  [6398] = 6230,
  [6399] = 5677,
  [6400] = 6240,
  [6401] = 6273,
  [6402] = 6290,
  [6403] = 6403,
  [6404] = 6404,
  [6405] = 6262,
  [6406] = 6406,
  [6407] = 6256,
  [6408] = 6256,
  [6409] = 6262,
  [6410] = 6410,
  [6411] = 6256,
  [6412] = 6256,
  [6413] = 6413,
  [6414] = 6233,
  [6415] = 6283,
  [6416] = 6240,
  [6417] = 6255,
  [6418] = 6230,
  [6419] = 6272,
  [6420] = 6229,
  [6421] = 6233,
  [6422] = 6422,
  [6423] = 6255,
  [6424] = 6273,
  [6425] = 6290,
  [6426] = 6256,
  [6427] = 6427,
  [6428] = 6229,
  [6429] = 6230,
  [6430] = 6430,
  [6431] = 6240,
  [6432] = 6240,
  [6433] = 6230,
  [6434] = 6434,
  [6435] = 6256,
  [6436] = 6436,
  [6437] = 6437,
  [6438] = 6240,
  [6439] = 6230,
  [6440] = 6229,
  [6441] = 1463,
  [6442] = 6229,
  [6443] = 6443,
  [6444] = 6240,
  [6445] = 6230,
  [6446] = 6229,
  [6447] = 6229,
  [6448] = 6256,
  [6449] = 6256,
  [6450] = 5404,
  [6451] = 6256,
  [6452] = 6240,
  [6453] = 6230,
  [6454] = 6365,
  [6455] = 5406,
  [6456] = 6456,
  [6457] = 6240,
  [6458] = 6230,
  [6459] = 6230,
  [6460] = 6240,
  [6461] = 6229,
  [6462] = 6233,
  [6463] = 6240,
  [6464] = 6230,
  [6465] = 6465,
  [6466] = 6256,
  [6467] = 1472,
  [6468] = 6233,
  [6469] = 6229,
  [6470] = 6470,
  [6471] = 6471,
  [6472] = 6256,
  [6473] = 6240,
  [6474] = 6230,
  [6475] = 6475,
  [6476] = 6256,
  [6477] = 6262,
  [6478] = 6240,
  [6479] = 6230,
  [6480] = 6480,
  [6481] = 6233,
  [6482] = 6482,
  [6483] = 6229,
  [6484] = 6229,
  [6485] = 6233,
  [6486] = 6256,
  [6487] = 6230,
  [6488] = 6488,
  [6489] = 6240,
  [6490] = 6233,
  [6491] = 6240,
  [6492] = 6268,
  [6493] = 6230,
  [6494] = 6494,
  [6495] = 6229,
  [6496] = 6230,
  [6497] = 6229,
  [6498] = 6240,
  [6499] = 6499,
  [6500] = 6256,
  [6501] = 6256,
  [6502] = 6233,
  [6503] = 6233,
  [6504] = 6233,
  [6505] = 6229,
  [6506] = 6256,
  [6507] = 6240,
  [6508] = 6508,
  [6509] = 6230,
  [6510] = 6233,
  [6511] = 6511,
  [6512] = 6240,
  [6513] = 6283,
  [6514] = 6290,
  [6515] = 6273,
  [6516] = 6230,
  [6517] = 6256,
  [6518] = 6240,
  [6519] = 6234,
  [6520] = 6229,
  [6521] = 6521,
  [6522] = 1614,
  [6523] = 6523,
  [6524] = 6524,
  [6525] = 6525,
  [6526] = 1781,
  [6527] = 6527,
  [6528] = 6521,
  [6529] = 6521,
  [6530] = 6530,
  [6531] = 6531,
  [6532] = 6532,
  [6533] = 6533,
  [6534] = 6521,
  [6535] = 6535,
  [6536] = 6536,
  [6537] = 4722,
  [6538] = 6538,
  [6539] = 6539,
  [6540] = 1784,
  [6541] = 6541,
  [6542] = 6542,
  [6543] = 6543,
  [6544] = 6544,
  [6545] = 6523,
  [6546] = 6546,
  [6547] = 6525,
  [6548] = 6548,
  [6549] = 6549,
  [6550] = 1611,
  [6551] = 6536,
  [6552] = 6530,
  [6553] = 6553,
  [6554] = 6554,
  [6555] = 6532,
  [6556] = 6556,
  [6557] = 6535,
  [6558] = 6538,
  [6559] = 6539,
  [6560] = 6521,
  [6561] = 6541,
  [6562] = 6542,
  [6563] = 6543,
  [6564] = 6564,
  [6565] = 6523,
  [6566] = 6566,
  [6567] = 6525,
  [6568] = 6553,
  [6569] = 6533,
  [6570] = 6533,
  [6571] = 6530,
  [6572] = 6572,
  [6573] = 6536,
  [6574] = 6532,
  [6575] = 6553,
  [6576] = 6532,
  [6577] = 6533,
  [6578] = 6535,
  [6579] = 6579,
  [6580] = 6556,
  [6581] = 6581,
  [6582] = 6539,
  [6583] = 6541,
  [6584] = 6542,
  [6585] = 6543,
  [6586] = 6556,
  [6587] = 6523,
  [6588] = 6588,
  [6589] = 6525,
  [6590] = 6579,
  [6591] = 6591,
  [6592] = 6556,
  [6593] = 6530,
  [6594] = 6533,
  [6595] = 6532,
  [6596] = 1615,
  [6597] = 6556,
  [6598] = 6535,
  [6599] = 6521,
  [6600] = 6521,
  [6601] = 6556,
  [6602] = 6539,
  [6603] = 6541,
  [6604] = 6546,
  [6605] = 6543,
  [6606] = 6541,
  [6607] = 6542,
  [6608] = 6543,
  [6609] = 6538,
  [6610] = 6544,
  [6611] = 6523,
  [6612] = 6542,
  [6613] = 6525,
  [6614] = 6538,
  [6615] = 6538,
  [6616] = 4720,
  [6617] = 6532,
  [6618] = 6533,
  [6619] = 6539,
  [6620] = 6530,
  [6621] = 6621,
  [6622] = 6521,
  [6623] = 6532,
  [6624] = 6624,
  [6625] = 6538,
  [6626] = 6535,
  [6627] = 6535,
  [6628] = 6628,
  [6629] = 6629,
  [6630] = 6521,
  [6631] = 6539,
  [6632] = 6556,
  [6633] = 6541,
  [6634] = 6634,
  [6635] = 6541,
  [6636] = 6542,
  [6637] = 6543,
  [6638] = 6536,
  [6639] = 6544,
  [6640] = 6523,
  [6641] = 6553,
  [6642] = 6525,
  [6643] = 5201,
  [6644] = 6532,
  [6645] = 6553,
  [6646] = 6533,
  [6647] = 6566,
  [6648] = 6648,
  [6649] = 6530,
  [6650] = 6566,
  [6651] = 6553,
  [6652] = 6532,
  [6653] = 1616,
  [6654] = 6654,
  [6655] = 6655,
  [6656] = 6535,
  [6657] = 1617,
  [6658] = 6521,
  [6659] = 6544,
  [6660] = 6539,
  [6661] = 6530,
  [6662] = 6536,
  [6663] = 6536,
  [6664] = 6541,
  [6665] = 6542,
  [6666] = 6543,
  [6667] = 6538,
  [6668] = 6556,
  [6669] = 6523,
  [6670] = 6579,
  [6671] = 6525,
  [6672] = 6524,
  [6673] = 6530,
  [6674] = 6538,
  [6675] = 6544,
  [6676] = 6566,
  [6677] = 6677,
  [6678] = 6530,
  [6679] = 6553,
  [6680] = 6680,
  [6681] = 6532,
  [6682] = 1618,
  [6683] = 6544,
  [6684] = 6525,
  [6685] = 6535,
  [6686] = 6553,
  [6687] = 6566,
  [6688] = 6533,
  [6689] = 6539,
  [6690] = 6523,
  [6691] = 6533,
  [6692] = 6579,
  [6693] = 6541,
  [6694] = 6542,
  [6695] = 6543,
  [6696] = 6542,
  [6697] = 6523,
  [6698] = 6525,
  [6699] = 6579,
  [6700] = 6556,
  [6701] = 6536,
  [6702] = 6530,
  [6703] = 1619,
  [6704] = 6532,
  [6705] = 6521,
  [6706] = 1620,
  [6707] = 6541,
  [6708] = 6708,
  [6709] = 6544,
  [6710] = 6542,
  [6711] = 1686,
  [6712] = 6712,
  [6713] = 6523,
  [6714] = 6525,
  [6715] = 6539,
  [6716] = 6536,
  [6717] = 6530,
  [6718] = 6532,
  [6719] = 1705,
  [6720] = 1621,
  [6721] = 6556,
  [6722] = 1650,
  [6723] = 6535,
  [6724] = 1623,
  [6725] = 6533,
  [6726] = 6523,
  [6727] = 6525,
  [6728] = 6579,
  [6729] = 6523,
  [6730] = 6530,
  [6731] = 6532,
  [6732] = 1624,
  [6733] = 6553,
  [6734] = 6530,
  [6735] = 6544,
  [6736] = 6553,
  [6737] = 6536,
  [6738] = 6525,
  [6739] = 6566,
  [6740] = 6553,
  [6741] = 6532,
  [6742] = 6553,
  [6743] = 6536,
  [6744] = 6525,
  [6745] = 6745,
  [6746] = 6525,
  [6747] = 6523,
  [6748] = 6579,
  [6749] = 6532,
  [6750] = 6535,
  [6751] = 6543,
  [6752] = 6542,
  [6753] = 6533,
  [6754] = 6525,
  [6755] = 6538,
  [6756] = 6541,
  [6757] = 6532,
  [6758] = 1613,
  [6759] = 6556,
  [6760] = 6525,
  [6761] = 6579,
  [6762] = 6556,
  [6763] = 6579,
  [6764] = 6525,
  [6765] = 6536,
  [6766] = 6546,
  [6767] = 1625,
  [6768] = 6525,
  [6769] = 6525,
  [6770] = 6525,
  [6771] = 6771,
  [6772] = 6538,
  [6773] = 6542,
  [6774] = 6774,
  [6775] = 6775,
  [6776] = 6539,
  [6777] = 6708,
  [6778] = 6533,
  [6779] = 6579,
  [6780] = 6780,
  [6781] = 6745,
  [6782] = 6524,
  [6783] = 6535,
  [6784] = 6784,
  [6785] = 6556,
  [6786] = 6521,
  [6787] = 6553,
  [6788] = 6532,
  [6789] = 6780,
  [6790] = 6790,
  [6791] = 6525,
  [6792] = 6530,
  [6793] = 6521,
  [6794] = 6536,
  [6795] = 6544,
  [6796] = 6533,
  [6797] = 6533,
  [6798] = 6536,
  [6799] = 6544,
  [6800] = 5439,
  [6801] = 6655,
  [6802] = 6533,
  [6803] = 6549,
  [6804] = 6536,
  [6805] = 6805,
  [6806] = 6533,
  [6807] = 6525,
  [6808] = 6790,
  [6809] = 6771,
  [6810] = 6523,
  [6811] = 6774,
  [6812] = 6775,
  [6813] = 6784,
  [6814] = 6708,
  [6815] = 6543,
  [6816] = 6542,
  [6817] = 6541,
  [6818] = 6745,
  [6819] = 6539,
  [6820] = 6544,
  [6821] = 1634,
  [6822] = 6544,
  [6823] = 6790,
  [6824] = 6771,
  [6825] = 6536,
  [6826] = 6774,
  [6827] = 6775,
  [6828] = 6780,
  [6829] = 6708,
  [6830] = 6535,
  [6831] = 6553,
  [6832] = 6536,
  [6833] = 6745,
  [6834] = 6533,
  [6835] = 6532,
  [6836] = 6790,
  [6837] = 6771,
  [6838] = 6838,
  [6839] = 6774,
  [6840] = 6775,
  [6841] = 6521,
  [6842] = 6708,
  [6843] = 6530,
  [6844] = 6544,
  [6845] = 6566,
  [6846] = 6745,
  [6847] = 6521,
  [6848] = 6538,
  [6849] = 6790,
  [6850] = 6771,
  [6851] = 6525,
  [6852] = 6774,
  [6853] = 6775,
  [6854] = 6566,
  [6855] = 6708,
  [6856] = 6536,
  [6857] = 6857,
  [6858] = 6579,
  [6859] = 6745,
  [6860] = 6860,
  [6861] = 6543,
  [6862] = 6790,
  [6863] = 6771,
  [6864] = 6553,
  [6865] = 6774,
  [6866] = 6775,
  [6867] = 6542,
  [6868] = 6708,
  [6869] = 6541,
  [6870] = 1635,
  [6871] = 6539,
  [6872] = 6745,
  [6873] = 6553,
  [6874] = 6780,
  [6875] = 6790,
  [6876] = 6771,
  [6877] = 6535,
  [6878] = 6774,
  [6879] = 6775,
  [6880] = 6553,
  [6881] = 6708,
  [6882] = 6533,
  [6883] = 6532,
  [6884] = 6536,
  [6885] = 6745,
  [6886] = 6530,
  [6887] = 6553,
  [6888] = 6790,
  [6889] = 6771,
  [6890] = 6556,
  [6891] = 6774,
  [6892] = 6775,
  [6893] = 6579,
  [6894] = 6708,
  [6895] = 6536,
  [6896] = 6533,
  [6897] = 6897,
  [6898] = 6745,
  [6899] = 6899,
  [6900] = 6525,
  [6901] = 6790,
  [6902] = 6771,
  [6903] = 6523,
  [6904] = 6774,
  [6905] = 6775,
  [6906] = 6566,
  [6907] = 6708,
  [6908] = 6543,
  [6909] = 6542,
  [6910] = 6533,
  [6911] = 6745,
  [6912] = 6533,
  [6913] = 6541,
  [6914] = 6790,
  [6915] = 6771,
  [6916] = 6579,
  [6917] = 6774,
  [6918] = 6775,
  [6919] = 6538,
  [6920] = 6708,
  [6921] = 6539,
  [6922] = 6556,
  [6923] = 6538,
  [6924] = 6745,
  [6925] = 6553,
  [6926] = 6780,
  [6927] = 6790,
  [6928] = 6771,
  [6929] = 6774,
  [6930] = 6775,
  [6931] = 6535,
  [6932] = 6708,
  [6933] = 6533,
  [6934] = 6533,
  [6935] = 6532,
  [6936] = 6745,
  [6937] = 6566,
  [6938] = 6530,
  [6939] = 6790,
  [6940] = 6771,
  [6941] = 6774,
  [6942] = 6775,
  [6943] = 6533,
  [6944] = 6708,
  [6945] = 6533,
  [6946] = 6533,
  [6947] = 6521,
  [6948] = 6745,
  [6949] = 6790,
  [6950] = 6525,
  [6951] = 6790,
  [6952] = 6771,
  [6953] = 6774,
  [6954] = 6775,
  [6955] = 6955,
  [6956] = 6708,
  [6957] = 6523,
  [6958] = 6553,
  [6959] = 6544,
  [6960] = 6745,
  [6961] = 6533,
  [6962] = 6543,
  [6963] = 6771,
  [6964] = 6774,
  [6965] = 6775,
  [6966] = 6542,
  [6967] = 6708,
  [6968] = 6566,
  [6969] = 6541,
  [6970] = 6556,
  [6971] = 6745,
  [6972] = 6972,
  [6973] = 6539,
  [6974] = 6771,
  [6975] = 6774,
  [6976] = 6775,
  [6977] = 6533,
  [6978] = 6708,
  [6979] = 6780,
  [6980] = 6535,
  [6981] = 6655,
  [6982] = 6745,
  [6983] = 1707,
  [6984] = 6532,
  [6985] = 6771,
  [6986] = 6530,
  [6987] = 6708,
  [6988] = 6542,
  [6989] = 6536,
  [6990] = 6543,
  [6991] = 6771,
  [6992] = 6708,
  [6993] = 6523,
  [6994] = 6790,
  [6995] = 6525,
  [6996] = 6771,
  [6997] = 6708,
  [6998] = 6525,
  [6999] = 6566,
  [7000] = 6790,
  [7001] = 6708,
  [7002] = 6548,
  [7003] = 6708,
  [7004] = 6523,
  [7005] = 6708,
  [7006] = 1626,
  [7007] = 1629,
  [7008] = 6556,
  [7009] = 7009,
  [7010] = 6591,
  [7011] = 6588,
  [7012] = 6784,
  [7013] = 6523,
  [7014] = 6579,
  [7015] = 6536,
  [7016] = 6556,
  [7017] = 6579,
  [7018] = 6543,
  [7019] = 6538,
  [7020] = 6542,
  [7021] = 6591,
  [7022] = 6588,
  [7023] = 7023,
  [7024] = 6566,
  [7025] = 6530,
  [7026] = 6532,
  [7027] = 6527,
  [7028] = 6521,
  [7029] = 6544,
  [7030] = 7030,
  [7031] = 6553,
  [7032] = 1630,
  [7033] = 6566,
  [7034] = 6533,
  [7035] = 6775,
  [7036] = 6553,
  [7037] = 6533,
  [7038] = 6543,
  [7039] = 7039,
  [7040] = 6774,
  [7041] = 6542,
  [7042] = 7042,
  [7043] = 6533,
  [7044] = 6556,
  [7045] = 6579,
  [7046] = 6566,
  [7047] = 6533,
  [7048] = 7048,
  [7049] = 6536,
  [7050] = 7039,
  [7051] = 6899,
  [7052] = 7039,
  [7053] = 6899,
  [7054] = 7039,
  [7055] = 6899,
  [7056] = 7039,
  [7057] = 6899,
  [7058] = 7039,
  [7059] = 6899,
  [7060] = 7039,
  [7061] = 6899,
  [7062] = 7039,
  [7063] = 6899,
  [7064] = 7039,
  [7065] = 6899,
  [7066] = 7039,
  [7067] = 6899,
  [7068] = 7039,
  [7069] = 6899,
  [7070] = 7039,
  [7071] = 6899,
  [7072] = 7039,
  [7073] = 6899,
  [7074] = 7039,
  [7075] = 6899,
  [7076] = 7039,
  [7077] = 6899,
  [7078] = 7039,
  [7079] = 6899,
  [7080] = 6535,
  [7081] = 6780,
  [7082] = 6539,
  [7083] = 6536,
  [7084] = 6544,
  [7085] = 6539,
  [7086] = 7086,
  [7087] = 6972,
  [7088] = 6521,
  [7089] = 6972,
  [7090] = 6538,
  [7091] = 1714,
  [7092] = 1720,
  [7093] = 1721,
  [7094] = 6549,
  [7095] = 7095,
  [7096] = 6536,
  [7097] = 7097,
  [7098] = 7098,
  [7099] = 6771,
  [7100] = 6553,
  [7101] = 6538,
  [7102] = 7102,
  [7103] = 6655,
  [7104] = 6566,
  [7105] = 6541,
  [7106] = 6553,
  [7107] = 6521,
  [7108] = 6544,
  [7109] = 7109,
  [7110] = 7030,
  [7111] = 7030,
  [7112] = 7030,
  [7113] = 7030,
  [7114] = 7030,
  [7115] = 7030,
  [7116] = 7030,
  [7117] = 7030,
  [7118] = 7030,
  [7119] = 7030,
  [7120] = 7030,
  [7121] = 7030,
  [7122] = 7030,
  [7123] = 7030,
  [7124] = 7030,
};

static TSCharacterRange sym_symboly_id_character_set_1[] = {
  {'!', '!'}, {'$', '&'}, {'*', '+'}, {'-', '-'}, {'/', '/'}, {':', ':'}, {'<', '>'}, {'\\', '\\'},
  {'^', '^'}, {'|', '|'}, {'~', '~'},
};

static TSCharacterRange sym_path_character_set_2[] = {
  {'!', '!'}, {'$', '&'}, {'*', '+'}, {'-', '/'}, {':', ':'}, {'<', '>'}, {'\\', '\\'}, {'^', '^'},
  {'|', '|'}, {'~', '~'},
};

static bool ts_lex(TSLexer *lexer, TSStateId state) {
  START_LEXER();
  eof = lexer->eof(lexer);
  switch (state) {
    case 0:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 320,
        '"', 271,
        '#', 62,
        '&', 66,
        '\'', 319,
        '(', 296,
        ')', 298,
        '+', 76,
        ',', 297,
        '-', 86,
        '.', 325,
        '0', 263,
        ':', 328,
        ';', 299,
        '=', 369,
        '?', 118,
        '@', 307,
        '[', 308,
      );
      if (lookahead == '\\') SKIP(257);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == '_') ADVANCE(312);
      if (lookahead == 'a') ADVANCE(126);
      if (lookahead == 'c') ADVANCE(119);
      if (lookahead == 'd') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(171);
      if (lookahead == 'f') ADVANCE(125);
      if (lookahead == 'h') ADVANCE(120);
      if (lookahead == 'i') ADVANCE(149);
      if (lookahead == 'l') ADVANCE(145);
      if (lookahead == 'm') ADVANCE(122);
      if (lookahead == 'o') ADVANCE(199);
      if (lookahead == 's') ADVANCE(155);
      if (lookahead == 't') ADVANCE(130);
      if (lookahead == 'u') ADVANCE(177);
      if (lookahead == 'w') ADVANCE(153);
      if (lookahead == '{') ADVANCE(310);
      if (lookahead == '|') ADVANCE(344);
      if (lookahead == '}') ADVANCE(311);
      if (lookahead == 0x2200) ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 1:
      if (lookahead == '\n') SKIP(1);
      if (lookahead == '"') ADVANCE(271);
      if (lookahead == '\\') ADVANCE(3);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(275);
      if (lookahead != 0) ADVANCE(272);
      END_STATE();
    case 2:
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == '"') ADVANCE(271);
      if (lookahead == '\\') ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(273);
      if (lookahead != 0) ADVANCE(272);
      END_STATE();
    case 3:
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == '^') ADVANCE(280);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(278);
      if (lookahead != 0) ADVANCE(277);
      END_STATE();
    case 4:
      if (lookahead == '\n') SKIP(4);
      if (lookahead == '"') ADVANCE(270);
      if (lookahead == '\\') ADVANCE(6);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(276);
      if (lookahead != 0) ADVANCE(272);
      END_STATE();
    case 5:
      if (lookahead == '\n') ADVANCE(5);
      if (lookahead == '"') ADVANCE(270);
      if (lookahead == '\\') ADVANCE(282);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(274);
      if (lookahead != 0) ADVANCE(272);
      END_STATE();
    case 6:
      if (lookahead == '\n') ADVANCE(5);
      if (lookahead == '^') ADVANCE(280);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(279);
      if (lookahead != 0) ADVANCE(277);
      END_STATE();
    case 7:
      ADVANCE_MAP(
        '!', 223,
        '&', 70,
        '(', 295,
        ')', 298,
        ',', 297,
        '-', 91,
        '.', 324,
        '=', 114,
        '\\', 102,
        ']', 309,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 8:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 9:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 10:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 11:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 367,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 12:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 13:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 14:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 488,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 329,
        '=', 83,
        '?', 118,
        '@', 307,
        '[', 308,
        '\\', 492,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 15:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 16:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 17:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 18:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 82,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 19:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 20:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(20);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 21:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(21);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 22:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(22);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 23:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        ',', 297,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(23);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 24:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(24);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 25:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 82,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(25);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 26:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(26);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 27:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 367,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(27);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 28:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(28);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 29:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(29);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 30:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 488,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 329,
        '=', 83,
        '?', 118,
        '@', 307,
        '[', 308,
        '\\', 492,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(30);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 31:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        ',', 297,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(31);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 32:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(32);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 33:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 82,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(33);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 34:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(34);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 35:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(35);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 36:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(36);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 37:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 82,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(37);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 38:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(38);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 39:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 488,
        ',', 297,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 329,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(39);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 40:
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 486,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(40);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 41:
      ADVANCE_MAP(
        '!', 83,
        '#', 62,
        '&', 486,
        '(', 296,
        ')', 298,
        ',', 297,
        '-', 498,
        '.', 69,
        ';', 299,
        '=', 368,
        '[', 308,
        '\\', 492,
        ']', 309,
        '{', 310,
        '|', 219,
        '}', 311,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 42:
      ADVANCE_MAP(
        '!', 83,
        '#', 62,
        '&', 486,
        '(', 296,
        '-', 498,
        '.', 324,
        '=', 82,
        '[', 308,
        '\\', 492,
        '{', 310,
        '|', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 43:
      ADVANCE_MAP(
        '!', 83,
        '#', 63,
        '&', 486,
        '\'', 319,
        '(', 296,
        ')', 298,
        ',', 297,
        '-', 498,
        '.', 69,
        ';', 299,
        '=', 368,
        '[', 308,
        '\\', 492,
        ']', 309,
        '{', 310,
        '|', 219,
        '}', 311,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(43);
      if (('$' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 44:
      ADVANCE_MAP(
        '!', 83,
        '#', 63,
        '&', 486,
        '(', 296,
        ')', 298,
        ',', 297,
        '-', 498,
        '.', 69,
        ';', 299,
        '=', 368,
        '[', 308,
        '\\', 492,
        ']', 309,
        '{', 310,
        '|', 219,
        '}', 311,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(44);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 45:
      ADVANCE_MAP(
        '!', 83,
        '#', 63,
        '&', 486,
        '(', 296,
        '-', 498,
        '.', 69,
        '=', 82,
        '[', 308,
        '\\', 492,
        '{', 310,
        '|', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(45);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 46:
      ADVANCE_MAP(
        '!', 83,
        '#', 63,
        '&', 486,
        '(', 296,
        '-', 498,
        '.', 324,
        '=', 82,
        '[', 308,
        '\\', 492,
        '{', 310,
        '|', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(46);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 47:
      ADVANCE_MAP(
        '!', 83,
        '&', 485,
        '-', 497,
        '.', 69,
        ':', 330,
        '=', 82,
        '\\', 492,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(47);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 48:
      ADVANCE_MAP(
        '!', 83,
        '&', 486,
        '-', 498,
        '.', 69,
        ':', 330,
        '=', 368,
        '\\', 492,
        '|', 219,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(48);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 49:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 62,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 103,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 50:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 98,
        ']', 309,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= '_') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 51:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 96,
        ']', 309,
        '_', 313,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '{', 310,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 52:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 97,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'u', 476,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 53:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 99,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        'w', 468,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 54:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 100,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        'o', 479,
        't', 464,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 55:
      ADVANCE_MAP(
        '!', 322,
        '"', 271,
        '#', 63,
        '&', 70,
        '\'', 319,
        '(', 295,
        '+', 109,
        '-', 108,
        '.', 68,
        '0', 263,
        '=', 223,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 103,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        't', 464,
        '|', 217,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 56:
      ADVANCE_MAP(
        '"', 271,
        '#', 63,
        '&', 70,
        '(', 295,
        '+', 104,
        '-', 89,
        '.', 69,
        '?', 118,
        '[', 308,
        '\\', 101,
        ']', 309,
        '_', 313,
        'f', 455,
        't', 475,
        '{', 310,
        '|', 217,
        '!', 223,
        '=', 223,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 57:
      ADVANCE_MAP(
        '"', 271,
        '#', 63,
        '&', 486,
        '(', 295,
        '+', 489,
        '-', 496,
        '.', 69,
        '?', 118,
        '[', 308,
        '\\', 492,
        '_', 313,
        'f', 455,
        't', 475,
        '{', 310,
        '|', 219,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(57);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 58:
      ADVANCE_MAP(
        '"', 271,
        '#', 236,
        '(', 295,
        '+', 78,
        ',', 297,
        '-', 115,
        ':', 79,
        '=', 366,
        '?', 118,
        '@', 306,
        '[', 308,
      );
      if (lookahead == '\\') SKIP(224);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == '_') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(453);
      if (lookahead == 't') ADVANCE(473);
      if (lookahead == '{') ADVANCE(310);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 59:
      ADVANCE_MAP(
        '"', 271,
        '(', 295,
        '+', 78,
        ',', 297,
        '-', 115,
        ':', 79,
        '=', 366,
        '?', 118,
        '@', 306,
        '[', 308,
      );
      if (lookahead == '\\') SKIP(224);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == '_') ADVANCE(314);
      if (lookahead == 'f') ADVANCE(453);
      if (lookahead == 't') ADVANCE(473);
      if (lookahead == '{') ADVANCE(310);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 60:
      if (lookahead == '"') ADVANCE(283);
      END_STATE();
    case 61:
      ADVANCE_MAP(
        '#', 62,
        '&', 486,
        '(', 296,
        '-', 498,
        '.', 69,
        '[', 308,
        '\\', 492,
        'w', 468,
        '{', 310,
        '|', 219,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 62:
      if (lookahead == '#') ADVANCE(238);
      if (('W' <= lookahead && lookahead <= 'Z') ||
          ('w' <= lookahead && lookahead <= 'z')) ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'V') ||
          ('a' <= lookahead && lookahead <= 'v')) ADVANCE(332);
      END_STATE();
    case 63:
      if (lookahead == '#') ADVANCE(238);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'V') ||
          ('a' <= lookahead && lookahead <= 'v')) ADVANCE(513);
      END_STATE();
    case 64:
      ADVANCE_MAP(
        '#', 63,
        '&', 486,
        '\'', 319,
        '(', 296,
        '-', 497,
        '.', 69,
        '[', 308,
        '\\', 492,
        'f', 472,
        '{', 310,
        '|', 219,
        '}', 311,
        0x2200, 365,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(64);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 65:
      ADVANCE_MAP(
        '#', 63,
        '&', 486,
        '(', 296,
        '-', 498,
        '.', 69,
        '[', 308,
        '\\', 492,
        'w', 468,
        '{', 310,
        '|', 219,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(65);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 66:
      if (lookahead == '&') ADVANCE(361);
      END_STATE();
    case 67:
      ADVANCE_MAP(
        '&', 70,
        '(', 295,
        ',', 297,
        '-', 91,
        '.', 69,
        ':', 331,
        '\\', 95,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '|', 345,
        '!', 223,
        '=', 223,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 68:
      if (lookahead == '&') ADVANCE(70);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '|') ADVANCE(217);
      if (lookahead == '!' ||
          lookahead == '=') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(268);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= ':') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '\\' ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 69:
      ADVANCE_MAP(
        '&', 70,
        '-', 90,
        '|', 217,
        '!', 223,
        '=', 223,
        '$', 105,
        '%', 105,
        '*', 105,
        '+', 105,
        '/', 105,
        ':', 105,
        '<', 105,
        '>', 105,
        '\\', 105,
        '^', 105,
        '~', 105,
      );
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 70:
      if (lookahead == '&') ADVANCE(231);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 71:
      ADVANCE_MAP(
        '&', 485,
        '-', 497,
        '.', 69,
        ':', 330,
        '\\', 492,
        'w', 157,
        '|', 218,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(71);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 72:
      ADVANCE_MAP(
        '&', 485,
        '-', 497,
        '.', 69,
        '\\', 492,
        'w', 157,
        '|', 218,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(72);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 73:
      if (lookahead == '&') ADVANCE(487);
      if (lookahead == '-') ADVANCE(502);
      if (lookahead == '\\') ADVANCE(493);
      if (lookahead == '|') ADVANCE(220);
      if (lookahead == '!' ||
          lookahead == '=') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(493);
      END_STATE();
    case 74:
      if (lookahead == '&') ADVANCE(487);
      if (lookahead == '-') ADVANCE(502);
      if (lookahead == '\\') ADVANCE(493);
      if (lookahead == '|') ADVANCE(220);
      if (lookahead == '!' ||
          lookahead == '=') ADVANCE(84);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(73);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(493);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(483);
      END_STATE();
    case 75:
      ADVANCE_MAP(
        '&', 506,
        '-', 508,
        '|', 221,
        '!', 85,
        '=', 85,
        '$', 507,
        '%', 507,
        '*', 507,
        '+', 507,
        '/', 507,
        ':', 507,
        '<', 507,
        '>', 507,
        '\\', 507,
        '^', 507,
        '~', 507,
      );
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(483);
      END_STATE();
    case 76:
      if (lookahead == '+') ADVANCE(300);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == ':') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      END_STATE();
    case 77:
      if (lookahead == '+') ADVANCE(300);
      if (lookahead == ':') ADVANCE(302);
      END_STATE();
    case 78:
      if (lookahead == '+') ADVANCE(300);
      if (lookahead == ':') ADVANCE(302);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      END_STATE();
    case 79:
      if (lookahead == '+') ADVANCE(304);
      END_STATE();
    case 80:
      if (lookahead == '+') ADVANCE(77);
      if (lookahead == ',') ADVANCE(297);
      if (lookahead == ':') ADVANCE(79);
      if (lookahead == '@') ADVANCE(306);
      if (lookahead == '\\') SKIP(225);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == 'w') ADVANCE(467);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 81:
      if (lookahead == ',') ADVANCE(297);
      if (lookahead == '.') ADVANCE(323);
      if (lookahead == ':') ADVANCE(327);
      if (lookahead == ';') ADVANCE(299);
      if (lookahead == '=') ADVANCE(366);
      if (lookahead == '\\') SKIP(226);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == '}') ADVANCE(311);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 82:
      ADVANCE_MAP(
        '-', 232,
        '=', 495,
        '&', 503,
        '|', 503,
        '!', 499,
        '$', 499,
        '%', 499,
        '*', 499,
        '+', 499,
        '/', 499,
        ':', 499,
        '<', 499,
        '>', 499,
        '\\', 499,
        '^', 499,
        '~', 499,
      );
      END_STATE();
    case 83:
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 84:
      if (lookahead == '-') ADVANCE(233);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(504);
      END_STATE();
    case 85:
      if (lookahead == '-') ADVANCE(234);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(509);
      END_STATE();
    case 86:
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == '>') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      END_STATE();
    case 87:
      if (lookahead == '.') ADVANCE(512);
      END_STATE();
    case 88:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(516);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 89:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 90:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(231);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 91:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(260);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 92:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(383);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(87);
      END_STATE();
    case 93:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'h') ADVANCE(377);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 94:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(93);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 95:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(67);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 96:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(51);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 97:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(52);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 98:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(50);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 99:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(53);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 100:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(54);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 101:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(56);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 102:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(7);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 103:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(55);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 104:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 105:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 106:
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(87);
      END_STATE();
    case 107:
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 108:
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == '>') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 109:
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 110:
      if (lookahead == '.') ADVANCE(158);
      if (lookahead == '>') ADVANCE(515);
      END_STATE();
    case 111:
      if (lookahead == ':') ADVANCE(327);
      if (lookahead == '=') ADVANCE(366);
      if (lookahead == '\\') SKIP(228);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(111);
      if (lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(326);
      END_STATE();
    case 112:
      if (lookahead == ':') ADVANCE(327);
      if (lookahead == '=') ADVANCE(113);
      if (lookahead == '\\') SKIP(227);
      if (lookahead == 'a') ADVANCE(126);
      if (lookahead == 't') ADVANCE(216);
      if (lookahead == 'w') ADVANCE(163);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      END_STATE();
    case 113:
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 114:
      ADVANCE_MAP(
        '=', 92,
        '&', 231,
        '-', 231,
        '|', 231,
        '!', 106,
        '$', 106,
        '%', 106,
        '*', 106,
        '+', 106,
        '/', 106,
        ':', 106,
        '<', 106,
        '>', 106,
        '\\', 106,
        '^', 106,
        '~', 106,
      );
      END_STATE();
    case 115:
      if (lookahead == '>') ADVANCE(259);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      END_STATE();
    case 116:
      if (lookahead == '>') ADVANCE(382);
      END_STATE();
    case 117:
      if (lookahead == '>') ADVANCE(516);
      END_STATE();
    case 118:
      if (lookahead == '\\') ADVANCE(285);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(284);
      END_STATE();
    case 119:
      if (lookahead == 'a') ADVANCE(195);
      END_STATE();
    case 120:
      if (lookahead == 'a') ADVANCE(174);
      END_STATE();
    case 121:
      if (lookahead == 'a') ADVANCE(169);
      END_STATE();
    case 122:
      if (lookahead == 'a') ADVANCE(201);
      END_STATE();
    case 123:
      if (lookahead == 'a') ADVANCE(167);
      END_STATE();
    case 124:
      if (lookahead == 'a') ADVANCE(205);
      END_STATE();
    case 125:
      if (lookahead == 'a') ADVANCE(172);
      if (lookahead == 'o') ADVANCE(189);
      END_STATE();
    case 126:
      if (lookahead == 'b') ADVANCE(159);
      END_STATE();
    case 127:
      if (lookahead == 'c') ADVANCE(152);
      END_STATE();
    case 128:
      if (lookahead == 'c') ADVANCE(206);
      END_STATE();
    case 129:
      if (lookahead == 'd') ADVANCE(170);
      END_STATE();
    case 130:
      if (lookahead == 'e') ADVANCE(185);
      if (lookahead == 'h') ADVANCE(147);
      if (lookahead == 'r') ADVANCE(209);
      if (lookahead == 'y') ADVANCE(182);
      END_STATE();
    case 131:
      if (lookahead == 'e') ADVANCE(213);
      END_STATE();
    case 132:
      if (lookahead == 'e') ADVANCE(334);
      END_STATE();
    case 133:
      if (lookahead == 'e') ADVANCE(380);
      END_STATE();
    case 134:
      if (lookahead == 'e') ADVANCE(318);
      END_STATE();
    case 135:
      if (lookahead == 'e') ADVANCE(287);
      END_STATE();
    case 136:
      if (lookahead == 'e') ADVANCE(343);
      END_STATE();
    case 137:
      if (lookahead == 'e') ADVANCE(290);
      END_STATE();
    case 138:
      if (lookahead == 'e') ADVANCE(358);
      END_STATE();
    case 139:
      if (lookahead == 'e') ADVANCE(373);
      END_STATE();
    case 140:
      if (lookahead == 'e') ADVANCE(354);
      END_STATE();
    case 141:
      if (lookahead == 'e') ADVANCE(378);
      END_STATE();
    case 142:
      if (lookahead == 'e') ADVANCE(350);
      END_STATE();
    case 143:
      if (lookahead == 'e') ADVANCE(381);
      END_STATE();
    case 144:
      if (lookahead == 'e') ADVANCE(340);
      END_STATE();
    case 145:
      if (lookahead == 'e') ADVANCE(200);
      END_STATE();
    case 146:
      if (lookahead == 'e') ADVANCE(191);
      END_STATE();
    case 147:
      if (lookahead == 'e') ADVANCE(175);
      END_STATE();
    case 148:
      if (lookahead == 'e') ADVANCE(188);
      END_STATE();
    case 149:
      if (lookahead == 'f') ADVANCE(315);
      END_STATE();
    case 150:
      if (lookahead == 'g') ADVANCE(178);
      END_STATE();
    case 151:
      if (lookahead == 'h') ADVANCE(375);
      END_STATE();
    case 152:
      if (lookahead == 'h') ADVANCE(347);
      END_STATE();
    case 153:
      if (lookahead == 'h') ADVANCE(146);
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 154:
      if (lookahead == 'h') ADVANCE(148);
      END_STATE();
    case 155:
      if (lookahead == 'i') ADVANCE(150);
      if (lookahead == 't') ADVANCE(187);
      END_STATE();
    case 156:
      if (lookahead == 'i') ADVANCE(184);
      END_STATE();
    case 157:
      if (lookahead == 'i') ADVANCE(94);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 158:
      if (lookahead == 'i') ADVANCE(181);
      END_STATE();
    case 159:
      if (lookahead == 'i') ADVANCE(168);
      END_STATE();
    case 160:
      if (lookahead == 'i') ADVANCE(176);
      END_STATE();
    case 161:
      if (lookahead == 'i') ADVANCE(203);
      END_STATE();
    case 162:
      if (lookahead == 'i') ADVANCE(207);
      END_STATE();
    case 163:
      if (lookahead == 'i') ADVANCE(204);
      END_STATE();
    case 164:
      if (lookahead == 'i') ADVANCE(198);
      END_STATE();
    case 165:
      if (lookahead == 'k') ADVANCE(371);
      END_STATE();
    case 166:
      if (lookahead == 'l') ADVANCE(363);
      END_STATE();
    case 167:
      if (lookahead == 'l') ADVANCE(352);
      END_STATE();
    case 168:
      if (lookahead == 'l') ADVANCE(161);
      END_STATE();
    case 169:
      if (lookahead == 'l') ADVANCE(166);
      END_STATE();
    case 170:
      if (lookahead == 'l') ADVANCE(139);
      END_STATE();
    case 171:
      if (lookahead == 'l') ADVANCE(196);
      END_STATE();
    case 172:
      if (lookahead == 'l') ADVANCE(197);
      END_STATE();
    case 173:
      if (lookahead == 'm') ADVANCE(379);
      END_STATE();
    case 174:
      if (lookahead == 'n') ADVANCE(129);
      END_STATE();
    case 175:
      if (lookahead == 'n') ADVANCE(317);
      END_STATE();
    case 176:
      if (lookahead == 'n') ADVANCE(165);
      END_STATE();
    case 177:
      if (lookahead == 'n') ADVANCE(156);
      if (lookahead == 's') ADVANCE(132);
      END_STATE();
    case 178:
      if (lookahead == 'n') ADVANCE(124);
      END_STATE();
    case 179:
      if (lookahead == 'o') ADVANCE(336);
      END_STATE();
    case 180:
      if (lookahead == 'o') ADVANCE(88);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 181:
      if (lookahead == 'o') ADVANCE(117);
      END_STATE();
    case 182:
      if (lookahead == 'p') ADVANCE(136);
      END_STATE();
    case 183:
      if (lookahead == 'p') ADVANCE(144);
      END_STATE();
    case 184:
      if (lookahead == 'q') ADVANCE(210);
      END_STATE();
    case 185:
      if (lookahead == 'r') ADVANCE(173);
      if (lookahead == 's') ADVANCE(202);
      END_STATE();
    case 186:
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 187:
      if (lookahead == 'r') ADVANCE(208);
      END_STATE();
    case 188:
      if (lookahead == 'r') ADVANCE(214);
      END_STATE();
    case 189:
      if (lookahead == 'r') ADVANCE(121);
      END_STATE();
    case 190:
      if (lookahead == 'r') ADVANCE(123);
      END_STATE();
    case 191:
      if (lookahead == 'r') ADVANCE(138);
      END_STATE();
    case 192:
      if (lookahead == 'r') ADVANCE(143);
      END_STATE();
    case 193:
      if (lookahead == 'r') ADVANCE(162);
      END_STATE();
    case 194:
      if (lookahead == 's') ADVANCE(235);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 195:
      if (lookahead == 's') ADVANCE(133);
      END_STATE();
    case 196:
      if (lookahead == 's') ADVANCE(134);
      END_STATE();
    case 197:
      if (lookahead == 's') ADVANCE(137);
      END_STATE();
    case 198:
      if (lookahead == 's') ADVANCE(142);
      END_STATE();
    case 199:
      if (lookahead == 't') ADVANCE(154);
      END_STATE();
    case 200:
      if (lookahead == 't') ADVANCE(338);
      END_STATE();
    case 201:
      if (lookahead == 't') ADVANCE(127);
      END_STATE();
    case 202:
      if (lookahead == 't') ADVANCE(110);
      END_STATE();
    case 203:
      if (lookahead == 't') ADVANCE(215);
      END_STATE();
    case 204:
      if (lookahead == 't') ADVANCE(151);
      END_STATE();
    case 205:
      if (lookahead == 't') ADVANCE(212);
      END_STATE();
    case 206:
      if (lookahead == 't') ADVANCE(211);
      END_STATE();
    case 207:
      if (lookahead == 't') ADVANCE(141);
      END_STATE();
    case 208:
      if (lookahead == 'u') ADVANCE(128);
      END_STATE();
    case 209:
      if (lookahead == 'u') ADVANCE(135);
      END_STATE();
    case 210:
      if (lookahead == 'u') ADVANCE(140);
      END_STATE();
    case 211:
      if (lookahead == 'u') ADVANCE(190);
      END_STATE();
    case 212:
      if (lookahead == 'u') ADVANCE(192);
      END_STATE();
    case 213:
      if (lookahead == 'w') ADVANCE(193);
      END_STATE();
    case 214:
      if (lookahead == 'w') ADVANCE(164);
      END_STATE();
    case 215:
      if (lookahead == 'y') ADVANCE(356);
      END_STATE();
    case 216:
      if (lookahead == 'y') ADVANCE(183);
      END_STATE();
    case 217:
      if (lookahead == '|') ADVANCE(231);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(106);
      END_STATE();
    case 218:
      if (lookahead == '|') ADVANCE(360);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 219:
      if (lookahead == '|') ADVANCE(232);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 220:
      if (lookahead == '|') ADVANCE(233);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(504);
      END_STATE();
    case 221:
      if (lookahead == '|') ADVANCE(234);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(509);
      END_STATE();
    case 222:
      if (lookahead == '+' ||
          lookahead == '-') ADVANCE(230);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 223:
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(106);
      END_STATE();
    case 224:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(59);
      END_STATE();
    case 225:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(80);
      END_STATE();
    case 226:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(81);
      END_STATE();
    case 227:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(112);
      END_STATE();
    case 228:
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(111);
      END_STATE();
    case 229:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(268);
      END_STATE();
    case 230:
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 231:
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(87);
      END_STATE();
    case 232:
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(494);
      END_STATE();
    case 233:
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(484);
      END_STATE();
    case 234:
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(505);
      END_STATE();
    case 235:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      END_STATE();
    case 236:
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(333);
      END_STATE();
    case 237:
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 238:
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(514);
      END_STATE();
    case 239:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 320,
        '"', 271,
        '#', 63,
        '&', 66,
        '\'', 319,
        '(', 296,
        ')', 298,
        '+', 76,
        ',', 297,
        '-', 86,
        '.', 325,
        '0', 263,
        ':', 328,
        ';', 299,
        '=', 369,
        '?', 118,
        '@', 307,
        '[', 308,
      );
      if (lookahead == '\\') SKIP(257);
      if (lookahead == ']') ADVANCE(309);
      if (lookahead == '_') ADVANCE(312);
      if (lookahead == 'a') ADVANCE(126);
      if (lookahead == 'c') ADVANCE(119);
      if (lookahead == 'd') ADVANCE(179);
      if (lookahead == 'e') ADVANCE(171);
      if (lookahead == 'f') ADVANCE(125);
      if (lookahead == 'h') ADVANCE(120);
      if (lookahead == 'i') ADVANCE(149);
      if (lookahead == 'l') ADVANCE(145);
      if (lookahead == 'm') ADVANCE(122);
      if (lookahead == 'o') ADVANCE(199);
      if (lookahead == 's') ADVANCE(155);
      if (lookahead == 't') ADVANCE(130);
      if (lookahead == 'u') ADVANCE(177);
      if (lookahead == 'w') ADVANCE(153);
      if (lookahead == '{') ADVANCE(310);
      if (lookahead == '|') ADVANCE(344);
      if (lookahead == '}') ADVANCE(311);
      if (lookahead == 0x2200) ADVANCE(365);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 240:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 241:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 242:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 243:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 62,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 244:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(244);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 245:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 368,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(245);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 246:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '{', 310,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(246);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 247:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(247);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 248:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 501,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(248);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 249:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ':', 330,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(249);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 250:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '!', 321,
        '"', 271,
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 295,
        '+', 491,
        '-', 500,
        '.', 68,
        '0', 263,
        ';', 299,
        '=', 83,
        '?', 118,
        '@', 186,
        '[', 308,
        '\\', 492,
        'a', 457,
        'c', 454,
        'd', 471,
        'f', 455,
        'h', 452,
        'i', 466,
        'l', 465,
        'm', 456,
        's', 478,
        't', 459,
        'u', 470,
        '|', 218,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(250);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('1' <= lookahead && lookahead <= '9')) ADVANCE(264);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 251:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '#', 62,
        '&', 486,
        '(', 296,
        ',', 297,
        '-', 498,
        '.', 69,
        '[', 308,
        '\\', 492,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '{', 310,
        '|', 346,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 252:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '#', 63,
        '&', 485,
        '\'', 319,
        '(', 296,
        '-', 498,
        '.', 69,
        ';', 299,
        '[', 308,
        '\\', 492,
        'a', 457,
        'f', 472,
        's', 478,
        't', 458,
        'u', 470,
        '{', 310,
        '|', 218,
        0x2200, 365,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(252);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          (':' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 253:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '#', 63,
        '&', 486,
        '(', 296,
        ',', 297,
        '-', 498,
        '.', 69,
        '[', 308,
        '\\', 492,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '{', 310,
        '|', 346,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(253);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 254:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '&', 70,
        '(', 295,
        ',', 297,
        '-', 91,
        '.', 69,
        ':', 331,
        '\\', 95,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '|', 345,
        '!', 223,
        '=', 223,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(254);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 255:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '&', 485,
        '(', 295,
        ',', 297,
        '-', 497,
        '.', 69,
        ':', 330,
        ';', 299,
        '\\', 492,
        ']', 309,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '|', 218,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(255);
      if (lookahead == '$' ||
          lookahead == '%' ||
          ('*' <= lookahead && lookahead <= '/') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 256:
      if (eof) ADVANCE(258);
      ADVANCE_MAP(
        '&', 485,
        '(', 295,
        '-', 497,
        '.', 69,
        '\\', 492,
        'a', 457,
        's', 478,
        't', 458,
        'u', 470,
        '|', 218,
        '!', 83,
        '=', 83,
      );
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(256);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          lookahead == '/' ||
          lookahead == ':' ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(490);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(481);
      END_STATE();
    case 257:
      if (eof) ADVANCE(258);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') SKIP(239);
      END_STATE();
    case 258:
      ACCEPT_TOKEN(ts_builtin_sym_end);
      END_STATE();
    case 259:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      END_STATE();
    case 260:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(87);
      END_STATE();
    case 261:
      ACCEPT_TOKEN(anon_sym_DASH_GT);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(494);
      END_STATE();
    case 262:
      ACCEPT_TOKEN(anon_sym_LPAREN_RPAREN);
      END_STATE();
    case 263:
      ACCEPT_TOKEN(sym_nat);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == 'x') ADVANCE(194);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 264:
      ACCEPT_TOKEN(sym_nat);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(264);
      END_STATE();
    case 265:
      ACCEPT_TOKEN(sym_nat);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(265);
      END_STATE();
    case 266:
      ACCEPT_TOKEN(sym_int);
      if (lookahead == '.') ADVANCE(229);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      END_STATE();
    case 267:
      ACCEPT_TOKEN(sym_int);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      END_STATE();
    case 268:
      ACCEPT_TOKEN(sym_float);
      if (lookahead == 'E' ||
          lookahead == 'e') ADVANCE(222);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(268);
      END_STATE();
    case 269:
      ACCEPT_TOKEN(sym_float);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(269);
      END_STATE();
    case 270:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      END_STATE();
    case 271:
      ACCEPT_TOKEN(anon_sym_DQUOTE);
      if (lookahead == '"') ADVANCE(60);
      END_STATE();
    case 272:
      ACCEPT_TOKEN(aux_sym_literal_text_token1);
      END_STATE();
    case 273:
      ACCEPT_TOKEN(aux_sym_literal_text_token1);
      if (lookahead == '\n') ADVANCE(2);
      if (lookahead == '\\') ADVANCE(281);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(273);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(272);
      END_STATE();
    case 274:
      ACCEPT_TOKEN(aux_sym_literal_text_token1);
      if (lookahead == '\n') ADVANCE(5);
      if (lookahead == '\\') ADVANCE(282);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(274);
      if (lookahead != 0 &&
          lookahead != '"') ADVANCE(272);
      END_STATE();
    case 275:
      ACCEPT_TOKEN(aux_sym_literal_text_token1);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(275);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"') ADVANCE(272);
      END_STATE();
    case 276:
      ACCEPT_TOKEN(aux_sym_literal_text_token1);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(276);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != '"') ADVANCE(272);
      END_STATE();
    case 277:
      ACCEPT_TOKEN(aux_sym_literal_text_token2);
      END_STATE();
    case 278:
      ACCEPT_TOKEN(aux_sym_literal_text_token2);
      if (lookahead == '\\') ADVANCE(3);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(275);
      END_STATE();
    case 279:
      ACCEPT_TOKEN(aux_sym_literal_text_token2);
      if (lookahead == '\\') ADVANCE(6);
      if (lookahead == '\t' ||
          (0x0b <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(276);
      END_STATE();
    case 280:
      ACCEPT_TOKEN(aux_sym_literal_text_token2);
      if (lookahead != 0 &&
          lookahead != '\n') ADVANCE(277);
      END_STATE();
    case 281:
      ACCEPT_TOKEN(aux_sym_literal_text_token3);
      if (lookahead == '\n') ADVANCE(2);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(278);
      END_STATE();
    case 282:
      ACCEPT_TOKEN(aux_sym_literal_text_token3);
      if (lookahead == '\n') ADVANCE(5);
      if (('\t' <= lookahead && lookahead <= '\r') ||
          lookahead == ' ') ADVANCE(279);
      END_STATE();
    case 283:
      ACCEPT_TOKEN(anon_sym_DQUOTE_DQUOTE_DQUOTE);
      END_STATE();
    case 284:
      ACCEPT_TOKEN(aux_sym_literal_char_token1);
      END_STATE();
    case 285:
      ACCEPT_TOKEN(aux_sym_literal_char_token1);
      if (lookahead == '"' ||
          lookahead == '\'' ||
          lookahead == '0' ||
          lookahead == 'a' ||
          lookahead == 'b' ||
          lookahead == 'f' ||
          lookahead == 'n' ||
          ('r' <= lookahead && lookahead <= 't') ||
          lookahead == 'v') ADVANCE(286);
      END_STATE();
    case 286:
      ACCEPT_TOKEN(aux_sym_literal_char_token2);
      END_STATE();
    case 287:
      ACCEPT_TOKEN(anon_sym_true);
      END_STATE();
    case 288:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 289:
      ACCEPT_TOKEN(anon_sym_true);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 290:
      ACCEPT_TOKEN(anon_sym_false);
      END_STATE();
    case 291:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 292:
      ACCEPT_TOKEN(anon_sym_false);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 293:
      ACCEPT_TOKEN(sym_literal_byte);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(293);
      END_STATE();
    case 294:
      ACCEPT_TOKEN(sym_literal_hex);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'F') ||
          ('a' <= lookahead && lookahead <= 'f')) ADVANCE(294);
      END_STATE();
    case 295:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      END_STATE();
    case 296:
      ACCEPT_TOKEN(anon_sym_LPAREN);
      if (lookahead == ')') ADVANCE(262);
      END_STATE();
    case 297:
      ACCEPT_TOKEN(anon_sym_COMMA);
      END_STATE();
    case 298:
      ACCEPT_TOKEN(anon_sym_RPAREN);
      END_STATE();
    case 299:
      ACCEPT_TOKEN(anon_sym_SEMI);
      END_STATE();
    case 300:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      END_STATE();
    case 301:
      ACCEPT_TOKEN(anon_sym_PLUS_PLUS);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(494);
      END_STATE();
    case 302:
      ACCEPT_TOKEN(anon_sym_PLUS_COLON);
      END_STATE();
    case 303:
      ACCEPT_TOKEN(anon_sym_PLUS_COLON);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(494);
      END_STATE();
    case 304:
      ACCEPT_TOKEN(anon_sym_COLON_PLUS);
      END_STATE();
    case 305:
      ACCEPT_TOKEN(anon_sym_COLON_PLUS);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(494);
      END_STATE();
    case 306:
      ACCEPT_TOKEN(anon_sym_AT);
      END_STATE();
    case 307:
      ACCEPT_TOKEN(anon_sym_AT);
      if (lookahead == 'r') ADVANCE(131);
      END_STATE();
    case 308:
      ACCEPT_TOKEN(anon_sym_LBRACK);
      END_STATE();
    case 309:
      ACCEPT_TOKEN(anon_sym_RBRACK);
      END_STATE();
    case 310:
      ACCEPT_TOKEN(anon_sym_LBRACE);
      END_STATE();
    case 311:
      ACCEPT_TOKEN(anon_sym_RBRACE);
      END_STATE();
    case 312:
      ACCEPT_TOKEN(anon_sym__);
      END_STATE();
    case 313:
      ACCEPT_TOKEN(anon_sym__);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 314:
      ACCEPT_TOKEN(anon_sym__);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 315:
      ACCEPT_TOKEN(anon_sym_if);
      END_STATE();
    case 316:
      ACCEPT_TOKEN(anon_sym_if);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 317:
      ACCEPT_TOKEN(anon_sym_then);
      END_STATE();
    case 318:
      ACCEPT_TOKEN(anon_sym_else);
      END_STATE();
    case 319:
      ACCEPT_TOKEN(anon_sym_SQUOTE);
      END_STATE();
    case 320:
      ACCEPT_TOKEN(anon_sym_BANG);
      END_STATE();
    case 321:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 322:
      ACCEPT_TOKEN(anon_sym_BANG);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(106);
      END_STATE();
    case 323:
      ACCEPT_TOKEN(anon_sym_DOT);
      END_STATE();
    case 324:
      ACCEPT_TOKEN(anon_sym_DOT);
      ADVANCE_MAP(
        '&', 70,
        '-', 90,
        '|', 217,
        '!', 223,
        '=', 223,
        '$', 105,
        '%', 105,
        '*', 105,
        '+', 105,
        '/', 105,
        ':', 105,
        '<', 105,
        '>', 105,
        '\\', 105,
        '^', 105,
        '~', 105,
      );
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 325:
      ACCEPT_TOKEN(anon_sym_DOT);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(268);
      END_STATE();
    case 326:
      ACCEPT_TOKEN(sym_type_argument);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(326);
      END_STATE();
    case 327:
      ACCEPT_TOKEN(anon_sym_COLON);
      END_STATE();
    case 328:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '+') ADVANCE(304);
      END_STATE();
    case 329:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '+') ADVANCE(305);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 330:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 331:
      ACCEPT_TOKEN(anon_sym_COLON);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '-' ||
          lookahead == '|') ADVANCE(231);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(106);
      END_STATE();
    case 332:
      ACCEPT_TOKEN(aux_sym_immediate_hash_token1);
      if (('W' <= lookahead && lookahead <= 'Z') ||
          ('w' <= lookahead && lookahead <= 'z')) ADVANCE(333);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'V') ||
          ('a' <= lookahead && lookahead <= 'v')) ADVANCE(332);
      END_STATE();
    case 333:
      ACCEPT_TOKEN(aux_sym_immediate_hash_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          ('a' <= lookahead && lookahead <= 'z')) ADVANCE(333);
      END_STATE();
    case 334:
      ACCEPT_TOKEN(anon_sym_use);
      END_STATE();
    case 335:
      ACCEPT_TOKEN(anon_sym_use);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 336:
      ACCEPT_TOKEN(sym_do);
      END_STATE();
    case 337:
      ACCEPT_TOKEN(sym_do);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 338:
      ACCEPT_TOKEN(sym_kw_let);
      END_STATE();
    case 339:
      ACCEPT_TOKEN(sym_kw_let);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 340:
      ACCEPT_TOKEN(sym_type_kw);
      END_STATE();
    case 341:
      ACCEPT_TOKEN(sym_type_kw);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'L') ADVANCE(409);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 342:
      ACCEPT_TOKEN(sym_type_kw);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 343:
      ACCEPT_TOKEN(sym_type_kw);
      if (lookahead == 'L') ADVANCE(160);
      END_STATE();
    case 344:
      ACCEPT_TOKEN(sym_pipe);
      END_STATE();
    case 345:
      ACCEPT_TOKEN(sym_pipe);
      if (lookahead == '|') ADVANCE(231);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(106);
      END_STATE();
    case 346:
      ACCEPT_TOKEN(sym_pipe);
      if (lookahead == '|') ADVANCE(232);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 347:
      ACCEPT_TOKEN(sym_match);
      END_STATE();
    case 348:
      ACCEPT_TOKEN(sym_match);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 349:
      ACCEPT_TOKEN(sym_cases);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 350:
      ACCEPT_TOKEN(sym_otherwise);
      END_STATE();
    case 351:
      ACCEPT_TOKEN(sym_otherwise);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 352:
      ACCEPT_TOKEN(sym_structural);
      END_STATE();
    case 353:
      ACCEPT_TOKEN(sym_structural);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 354:
      ACCEPT_TOKEN(sym_unique);
      END_STATE();
    case 355:
      ACCEPT_TOKEN(sym_unique);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 356:
      ACCEPT_TOKEN(sym_ability);
      END_STATE();
    case 357:
      ACCEPT_TOKEN(sym_ability);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 358:
      ACCEPT_TOKEN(sym_where);
      END_STATE();
    case 359:
      ACCEPT_TOKEN(sym_where);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 360:
      ACCEPT_TOKEN(sym_or);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(494);
      END_STATE();
    case 361:
      ACCEPT_TOKEN(sym_and);
      END_STATE();
    case 362:
      ACCEPT_TOKEN(sym_and);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(494);
      END_STATE();
    case 363:
      ACCEPT_TOKEN(anon_sym_forall);
      END_STATE();
    case 364:
      ACCEPT_TOKEN(anon_sym_forall);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 365:
      ACCEPT_TOKEN(anon_sym_u2200);
      END_STATE();
    case 366:
      ACCEPT_TOKEN(sym_kw_equals);
      END_STATE();
    case 367:
      ACCEPT_TOKEN(sym_kw_equals);
      ADVANCE_MAP(
        '-', 232,
        '=', 495,
        '&', 503,
        '|', 503,
        '!', 499,
        '$', 499,
        '%', 499,
        '*', 499,
        '+', 499,
        '/', 499,
        ':', 499,
        '<', 499,
        '>', 499,
        '\\', 499,
        '^', 499,
        '~', 499,
      );
      END_STATE();
    case 368:
      ACCEPT_TOKEN(sym_kw_equals);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 369:
      ACCEPT_TOKEN(sym_kw_equals);
      if (lookahead == '=') ADVANCE(116);
      END_STATE();
    case 370:
      ACCEPT_TOKEN(sym_kw_termlink);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 371:
      ACCEPT_TOKEN(sym_kw_typelink);
      END_STATE();
    case 372:
      ACCEPT_TOKEN(sym_kw_typelink);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 373:
      ACCEPT_TOKEN(sym_handle);
      END_STATE();
    case 374:
      ACCEPT_TOKEN(sym_handle);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 375:
      ACCEPT_TOKEN(sym_with);
      END_STATE();
    case 376:
      ACCEPT_TOKEN(sym_with);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 377:
      ACCEPT_TOKEN(sym_with);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(107);
      END_STATE();
    case 378:
      ACCEPT_TOKEN(sym_rewrite);
      END_STATE();
    case 379:
      ACCEPT_TOKEN(sym_term);
      END_STATE();
    case 380:
      ACCEPT_TOKEN(sym_case);
      END_STATE();
    case 381:
      ACCEPT_TOKEN(sym_signature);
      END_STATE();
    case 382:
      ACCEPT_TOKEN(sym_rewrite_arrow);
      END_STATE();
    case 383:
      ACCEPT_TOKEN(sym_rewrite_arrow);
      if (lookahead == '.') ADVANCE(512);
      END_STATE();
    case 384:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'L') ADVANCE(408);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 385:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'L') ADVANCE(409);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 386:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'a') ADVANCE(413);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 387:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'a') ADVANCE(416);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 388:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'c') ADVANCE(402);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 389:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'c') ADVANCE(443);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 390:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'd') ADVANCE(417);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 391:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(335);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 392:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(342);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 393:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(355);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 394:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(288);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 395:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(341);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 396:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(291);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 397:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(374);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 398:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(351);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 399:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(434);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 400:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(431);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 401:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'e') ADVANCE(385);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 402:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'h') ADVANCE(348);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 403:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'h') ADVANCE(376);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 404:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'h') ADVANCE(400);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 405:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(415);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 406:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(426);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 407:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(439);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 408:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(421);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 409:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(422);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 410:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'i') ADVANCE(437);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 411:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'k') ADVANCE(370);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 412:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'k') ADVANCE(372);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 413:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(353);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 414:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(364);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 415:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(407);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 416:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(414);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 417:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(397);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 418:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'l') ADVANCE(436);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 419:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'm') ADVANCE(384);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 420:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'n') ADVANCE(390);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 421:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'n') ADVANCE(411);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 422:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'n') ADVANCE(412);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 423:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'p') ADVANCE(392);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 424:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'p') ADVANCE(395);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 425:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'p') ADVANCE(401);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 426:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'q') ADVANCE(446);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 427:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(444);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 428:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(386);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 429:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(419);
      if (lookahead == 's') ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 430:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(419);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 431:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(448);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 432:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'r') ADVANCE(387);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 433:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 's') ADVANCE(438);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 434:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 's') ADVANCE(349);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 435:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 's') ADVANCE(399);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 436:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 's') ADVANCE(396);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 437:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 's') ADVANCE(398);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 438:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(451);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 439:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(449);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 440:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(339);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 441:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(388);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 442:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(403);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 443:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 't') ADVANCE(445);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 444:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(389);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 445:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(428);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 446:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(393);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 447:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'u') ADVANCE(394);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 448:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'w') ADVANCE(410);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 449:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == 'y') ADVANCE(357);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 450:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(512);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 451:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '.') ADVANCE(510);
      if (lookahead == '>') ADVANCE(515);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 452:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'a') ADVANCE(420);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 453:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'a') ADVANCE(469);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 454:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'a') ADVANCE(435);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 455:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'a') ADVANCE(418);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 456:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'a') ADVANCE(441);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('b' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 457:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'b') ADVANCE(405);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 458:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(433);
      if (lookahead == 'y') ADVANCE(423);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 459:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(429);
      if (lookahead == 'r') ADVANCE(447);
      if (lookahead == 'y') ADVANCE(424);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 460:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(289);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 461:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(292);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 462:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(359);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 463:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(474);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 464:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(430);
      if (lookahead == 'r') ADVANCE(447);
      if (lookahead == 'y') ADVANCE(425);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 465:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'e') ADVANCE(440);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 466:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'f') ADVANCE(316);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 467:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'h') ADVANCE(463);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 468:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'i') ADVANCE(442);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 469:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'l') ADVANCE(477);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 470:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'n') ADVANCE(406);
      if (lookahead == 's') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 471:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'o') ADVANCE(337);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 472:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'o') ADVANCE(432);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 473:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'r') ADVANCE(480);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 474:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'r') ADVANCE(462);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 475:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'r') ADVANCE(447);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 476:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 's') ADVANCE(391);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 477:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 's') ADVANCE(461);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 478:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 't') ADVANCE(427);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 479:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 't') ADVANCE(404);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 480:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == 'u') ADVANCE(460);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 481:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(482);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(450);
      END_STATE();
    case 482:
      ACCEPT_TOKEN(aux_sym_wordy_id_token1);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(482);
      END_STATE();
    case 483:
      ACCEPT_TOKEN(sym_imm_wordy_id);
      if (lookahead == '!' ||
          lookahead == '\'' ||
          ('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(483);
      END_STATE();
    case 484:
      ACCEPT_TOKEN(sym_symboly_id);
      END_STATE();
    case 485:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '&') ADVANCE(362);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 486:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '&') ADVANCE(232);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 487:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '&') ADVANCE(233);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(504);
      END_STATE();
    case 488:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '+') ADVANCE(301);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == ':') ADVANCE(303);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 489:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 490:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 491:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 492:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '-') ADVANCE(232);
      if (lookahead == '&' ||
          lookahead == '|') ADVANCE(503);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(499);
      END_STATE();
    case 493:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '-') ADVANCE(233);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(504);
      END_STATE();
    case 494:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      END_STATE();
    case 495:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(383);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(494);
      END_STATE();
    case 496:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(267);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 497:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(232);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 498:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      if (lookahead == '>') ADVANCE(261);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 499:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(512);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(494);
      END_STATE();
    case 500:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == '>') ADVANCE(232);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 501:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '.') ADVANCE(511);
      if (lookahead == '>') ADVANCE(261);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(266);
      if (set_contains(sym_path_character_set_2, 10, lookahead)) ADVANCE(499);
      END_STATE();
    case 502:
      ACCEPT_TOKEN(sym_symboly_id);
      if (lookahead == '>') ADVANCE(233);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(504);
      END_STATE();
    case 503:
      ACCEPT_TOKEN(sym_symboly_id);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(494);
      END_STATE();
    case 504:
      ACCEPT_TOKEN(sym_symboly_id);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(484);
      END_STATE();
    case 505:
      ACCEPT_TOKEN(sym_imm_symboly_id);
      END_STATE();
    case 506:
      ACCEPT_TOKEN(sym_imm_symboly_id);
      if (lookahead == '&') ADVANCE(234);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(509);
      END_STATE();
    case 507:
      ACCEPT_TOKEN(sym_imm_symboly_id);
      if (lookahead == '-') ADVANCE(234);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(509);
      END_STATE();
    case 508:
      ACCEPT_TOKEN(sym_imm_symboly_id);
      if (lookahead == '>') ADVANCE(234);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(509);
      END_STATE();
    case 509:
      ACCEPT_TOKEN(sym_imm_symboly_id);
      if (set_contains(sym_symboly_id_character_set_1, 11, lookahead)) ADVANCE(505);
      END_STATE();
    case 510:
      ACCEPT_TOKEN(sym_path);
      ADVANCE_MAP(
        '&', 70,
        '-', 90,
        'i', 180,
        '|', 217,
        '!', 223,
        '=', 223,
        '$', 105,
        '%', 105,
        '*', 105,
        '+', 105,
        '/', 105,
        ':', 105,
        '<', 105,
        '>', 105,
        '\\', 105,
        '^', 105,
        '~', 105,
      );
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 511:
      ACCEPT_TOKEN(sym_path);
      if (lookahead == '&') ADVANCE(70);
      if (lookahead == '-') ADVANCE(90);
      if (lookahead == '|') ADVANCE(217);
      if (lookahead == '!' ||
          lookahead == '=') ADVANCE(223);
      if (('0' <= lookahead && lookahead <= '9')) ADVANCE(268);
      if (lookahead == '$' ||
          lookahead == '%' ||
          lookahead == '*' ||
          lookahead == '+' ||
          ('/' <= lookahead && lookahead <= ':') ||
          ('<' <= lookahead && lookahead <= '>') ||
          lookahead == '\\' ||
          lookahead == '^' ||
          lookahead == '~') ADVANCE(105);
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 512:
      ACCEPT_TOKEN(sym_path);
      ADVANCE_MAP(
        '&', 70,
        '-', 90,
        '|', 217,
        '!', 223,
        '=', 223,
        '$', 105,
        '%', 105,
        '*', 105,
        '+', 105,
        '/', 105,
        ':', 105,
        '<', 105,
        '>', 105,
        '\\', 105,
        '^', 105,
        '~', 105,
      );
      if (('A' <= lookahead && lookahead <= 'Z') ||
          lookahead == '_' ||
          ('a' <= lookahead && lookahead <= 'z') ||
          (0x1f400 <= lookahead && lookahead <= 0x1faff)) ADVANCE(237);
      END_STATE();
    case 513:
      ACCEPT_TOKEN(aux_sym_hash_qualifier_token1);
      if (('0' <= lookahead && lookahead <= '9') ||
          ('A' <= lookahead && lookahead <= 'V') ||
          ('a' <= lookahead && lookahead <= 'v')) ADVANCE(513);
      END_STATE();
    case 514:
      ACCEPT_TOKEN(sym_built_in_hash);
      if (lookahead != 0 &&
          (lookahead < '\t' || '\r' < lookahead) &&
          lookahead != ' ') ADVANCE(514);
      END_STATE();
    case 515:
      ACCEPT_TOKEN(anon_sym_test_GT);
      END_STATE();
    case 516:
      ACCEPT_TOKEN(anon_sym_test_DOTio_GT);
      END_STATE();
    default:
      return false;
  }
}

static const TSLexMode ts_lex_modes[STATE_COUNT] = {
  [0] = {.lex_state = 0, .external_lex_state = 1},
  [1] = {.lex_state = 254, .external_lex_state = 2},
  [2] = {.lex_state = 247, .external_lex_state = 3},
  [3] = {.lex_state = 247, .external_lex_state = 3},
  [4] = {.lex_state = 247, .external_lex_state = 3},
  [5] = {.lex_state = 247, .external_lex_state = 3},
  [6] = {.lex_state = 247, .external_lex_state = 3},
  [7] = {.lex_state = 247, .external_lex_state = 3},
  [8] = {.lex_state = 247, .external_lex_state = 3},
  [9] = {.lex_state = 247, .external_lex_state = 3},
  [10] = {.lex_state = 247, .external_lex_state = 3},
  [11] = {.lex_state = 247, .external_lex_state = 3},
  [12] = {.lex_state = 247, .external_lex_state = 3},
  [13] = {.lex_state = 247, .external_lex_state = 3},
  [14] = {.lex_state = 247, .external_lex_state = 3},
  [15] = {.lex_state = 247, .external_lex_state = 3},
  [16] = {.lex_state = 247, .external_lex_state = 3},
  [17] = {.lex_state = 247, .external_lex_state = 3},
  [18] = {.lex_state = 247, .external_lex_state = 3},
  [19] = {.lex_state = 247, .external_lex_state = 3},
  [20] = {.lex_state = 247, .external_lex_state = 3},
  [21] = {.lex_state = 247, .external_lex_state = 3},
  [22] = {.lex_state = 247, .external_lex_state = 3},
  [23] = {.lex_state = 247, .external_lex_state = 3},
  [24] = {.lex_state = 247, .external_lex_state = 3},
  [25] = {.lex_state = 247, .external_lex_state = 3},
  [26] = {.lex_state = 247, .external_lex_state = 3},
  [27] = {.lex_state = 247, .external_lex_state = 3},
  [28] = {.lex_state = 248, .external_lex_state = 3},
  [29] = {.lex_state = 248, .external_lex_state = 3},
  [30] = {.lex_state = 248, .external_lex_state = 3},
  [31] = {.lex_state = 248, .external_lex_state = 3},
  [32] = {.lex_state = 248, .external_lex_state = 3},
  [33] = {.lex_state = 248, .external_lex_state = 3},
  [34] = {.lex_state = 248, .external_lex_state = 3},
  [35] = {.lex_state = 248, .external_lex_state = 3},
  [36] = {.lex_state = 248, .external_lex_state = 3},
  [37] = {.lex_state = 248, .external_lex_state = 3},
  [38] = {.lex_state = 248, .external_lex_state = 3},
  [39] = {.lex_state = 248, .external_lex_state = 3},
  [40] = {.lex_state = 248, .external_lex_state = 3},
  [41] = {.lex_state = 248, .external_lex_state = 3},
  [42] = {.lex_state = 248, .external_lex_state = 3},
  [43] = {.lex_state = 248, .external_lex_state = 3},
  [44] = {.lex_state = 248, .external_lex_state = 3},
  [45] = {.lex_state = 248, .external_lex_state = 3},
  [46] = {.lex_state = 248, .external_lex_state = 3},
  [47] = {.lex_state = 248, .external_lex_state = 3},
  [48] = {.lex_state = 248, .external_lex_state = 3},
  [49] = {.lex_state = 248, .external_lex_state = 3},
  [50] = {.lex_state = 248, .external_lex_state = 3},
  [51] = {.lex_state = 248, .external_lex_state = 3},
  [52] = {.lex_state = 248, .external_lex_state = 3},
  [53] = {.lex_state = 248, .external_lex_state = 3},
  [54] = {.lex_state = 247, .external_lex_state = 4},
  [55] = {.lex_state = 247, .external_lex_state = 4},
  [56] = {.lex_state = 247, .external_lex_state = 4},
  [57] = {.lex_state = 247, .external_lex_state = 4},
  [58] = {.lex_state = 247, .external_lex_state = 4},
  [59] = {.lex_state = 247, .external_lex_state = 4},
  [60] = {.lex_state = 247, .external_lex_state = 4},
  [61] = {.lex_state = 247, .external_lex_state = 4},
  [62] = {.lex_state = 247, .external_lex_state = 4},
  [63] = {.lex_state = 247, .external_lex_state = 4},
  [64] = {.lex_state = 247, .external_lex_state = 4},
  [65] = {.lex_state = 247, .external_lex_state = 4},
  [66] = {.lex_state = 247, .external_lex_state = 4},
  [67] = {.lex_state = 247, .external_lex_state = 4},
  [68] = {.lex_state = 247, .external_lex_state = 4},
  [69] = {.lex_state = 247, .external_lex_state = 4},
  [70] = {.lex_state = 247, .external_lex_state = 4},
  [71] = {.lex_state = 247, .external_lex_state = 4},
  [72] = {.lex_state = 247, .external_lex_state = 4},
  [73] = {.lex_state = 247, .external_lex_state = 4},
  [74] = {.lex_state = 247, .external_lex_state = 4},
  [75] = {.lex_state = 247, .external_lex_state = 4},
  [76] = {.lex_state = 247, .external_lex_state = 4},
  [77] = {.lex_state = 247, .external_lex_state = 4},
  [78] = {.lex_state = 247, .external_lex_state = 4},
  [79] = {.lex_state = 247, .external_lex_state = 4},
  [80] = {.lex_state = 248, .external_lex_state = 4},
  [81] = {.lex_state = 248, .external_lex_state = 4},
  [82] = {.lex_state = 248, .external_lex_state = 4},
  [83] = {.lex_state = 248, .external_lex_state = 4},
  [84] = {.lex_state = 248, .external_lex_state = 4},
  [85] = {.lex_state = 248, .external_lex_state = 4},
  [86] = {.lex_state = 248, .external_lex_state = 4},
  [87] = {.lex_state = 248, .external_lex_state = 4},
  [88] = {.lex_state = 248, .external_lex_state = 4},
  [89] = {.lex_state = 248, .external_lex_state = 4},
  [90] = {.lex_state = 248, .external_lex_state = 4},
  [91] = {.lex_state = 248, .external_lex_state = 4},
  [92] = {.lex_state = 248, .external_lex_state = 4},
  [93] = {.lex_state = 248, .external_lex_state = 4},
  [94] = {.lex_state = 248, .external_lex_state = 4},
  [95] = {.lex_state = 248, .external_lex_state = 4},
  [96] = {.lex_state = 248, .external_lex_state = 4},
  [97] = {.lex_state = 248, .external_lex_state = 4},
  [98] = {.lex_state = 248, .external_lex_state = 4},
  [99] = {.lex_state = 248, .external_lex_state = 4},
  [100] = {.lex_state = 248, .external_lex_state = 4},
  [101] = {.lex_state = 248, .external_lex_state = 4},
  [102] = {.lex_state = 248, .external_lex_state = 4},
  [103] = {.lex_state = 248, .external_lex_state = 4},
  [104] = {.lex_state = 248, .external_lex_state = 4},
  [105] = {.lex_state = 248, .external_lex_state = 4},
  [106] = {.lex_state = 31, .external_lex_state = 5},
  [107] = {.lex_state = 31, .external_lex_state = 5},
  [108] = {.lex_state = 31, .external_lex_state = 5},
  [109] = {.lex_state = 31, .external_lex_state = 5},
  [110] = {.lex_state = 31, .external_lex_state = 5},
  [111] = {.lex_state = 31, .external_lex_state = 5},
  [112] = {.lex_state = 31, .external_lex_state = 5},
  [113] = {.lex_state = 31, .external_lex_state = 5},
  [114] = {.lex_state = 31, .external_lex_state = 5},
  [115] = {.lex_state = 31, .external_lex_state = 5},
  [116] = {.lex_state = 31, .external_lex_state = 5},
  [117] = {.lex_state = 31, .external_lex_state = 5},
  [118] = {.lex_state = 31, .external_lex_state = 5},
  [119] = {.lex_state = 31, .external_lex_state = 5},
  [120] = {.lex_state = 31, .external_lex_state = 5},
  [121] = {.lex_state = 31, .external_lex_state = 5},
  [122] = {.lex_state = 31, .external_lex_state = 5},
  [123] = {.lex_state = 31, .external_lex_state = 5},
  [124] = {.lex_state = 31, .external_lex_state = 5},
  [125] = {.lex_state = 31, .external_lex_state = 5},
  [126] = {.lex_state = 31, .external_lex_state = 5},
  [127] = {.lex_state = 31, .external_lex_state = 5},
  [128] = {.lex_state = 31, .external_lex_state = 5},
  [129] = {.lex_state = 31, .external_lex_state = 5},
  [130] = {.lex_state = 31, .external_lex_state = 5},
  [131] = {.lex_state = 31, .external_lex_state = 5},
  [132] = {.lex_state = 33, .external_lex_state = 5},
  [133] = {.lex_state = 31, .external_lex_state = 5},
  [134] = {.lex_state = 31, .external_lex_state = 5},
  [135] = {.lex_state = 31, .external_lex_state = 5},
  [136] = {.lex_state = 31, .external_lex_state = 5},
  [137] = {.lex_state = 31, .external_lex_state = 5},
  [138] = {.lex_state = 31, .external_lex_state = 5},
  [139] = {.lex_state = 31, .external_lex_state = 5},
  [140] = {.lex_state = 31, .external_lex_state = 5},
  [141] = {.lex_state = 33, .external_lex_state = 5},
  [142] = {.lex_state = 31, .external_lex_state = 5},
  [143] = {.lex_state = 31, .external_lex_state = 5},
  [144] = {.lex_state = 33, .external_lex_state = 5},
  [145] = {.lex_state = 31, .external_lex_state = 5},
  [146] = {.lex_state = 31, .external_lex_state = 5},
  [147] = {.lex_state = 31, .external_lex_state = 5},
  [148] = {.lex_state = 31, .external_lex_state = 5},
  [149] = {.lex_state = 33, .external_lex_state = 5},
  [150] = {.lex_state = 31, .external_lex_state = 5},
  [151] = {.lex_state = 33, .external_lex_state = 5},
  [152] = {.lex_state = 31, .external_lex_state = 5},
  [153] = {.lex_state = 31, .external_lex_state = 5},
  [154] = {.lex_state = 31, .external_lex_state = 5},
  [155] = {.lex_state = 31, .external_lex_state = 5},
  [156] = {.lex_state = 33, .external_lex_state = 5},
  [157] = {.lex_state = 31, .external_lex_state = 5},
  [158] = {.lex_state = 31, .external_lex_state = 5},
  [159] = {.lex_state = 31, .external_lex_state = 5},
  [160] = {.lex_state = 31, .external_lex_state = 5},
  [161] = {.lex_state = 31, .external_lex_state = 5},
  [162] = {.lex_state = 31, .external_lex_state = 5},
  [163] = {.lex_state = 32, .external_lex_state = 5},
  [164] = {.lex_state = 32, .external_lex_state = 5},
  [165] = {.lex_state = 31, .external_lex_state = 5},
  [166] = {.lex_state = 33, .external_lex_state = 5},
  [167] = {.lex_state = 32, .external_lex_state = 5},
  [168] = {.lex_state = 33, .external_lex_state = 5},
  [169] = {.lex_state = 33, .external_lex_state = 5},
  [170] = {.lex_state = 32, .external_lex_state = 5},
  [171] = {.lex_state = 32, .external_lex_state = 5},
  [172] = {.lex_state = 32, .external_lex_state = 5},
  [173] = {.lex_state = 32, .external_lex_state = 5},
  [174] = {.lex_state = 32, .external_lex_state = 5},
  [175] = {.lex_state = 32, .external_lex_state = 5},
  [176] = {.lex_state = 33, .external_lex_state = 5},
  [177] = {.lex_state = 33, .external_lex_state = 5},
  [178] = {.lex_state = 33, .external_lex_state = 5},
  [179] = {.lex_state = 32, .external_lex_state = 5},
  [180] = {.lex_state = 32, .external_lex_state = 5},
  [181] = {.lex_state = 32, .external_lex_state = 5},
  [182] = {.lex_state = 33, .external_lex_state = 5},
  [183] = {.lex_state = 32, .external_lex_state = 5},
  [184] = {.lex_state = 33, .external_lex_state = 5},
  [185] = {.lex_state = 33, .external_lex_state = 5},
  [186] = {.lex_state = 32, .external_lex_state = 5},
  [187] = {.lex_state = 33, .external_lex_state = 5},
  [188] = {.lex_state = 33, .external_lex_state = 5},
  [189] = {.lex_state = 32, .external_lex_state = 5},
  [190] = {.lex_state = 32, .external_lex_state = 5},
  [191] = {.lex_state = 32, .external_lex_state = 5},
  [192] = {.lex_state = 33, .external_lex_state = 5},
  [193] = {.lex_state = 33, .external_lex_state = 5},
  [194] = {.lex_state = 33, .external_lex_state = 5},
  [195] = {.lex_state = 32, .external_lex_state = 5},
  [196] = {.lex_state = 33, .external_lex_state = 5},
  [197] = {.lex_state = 33, .external_lex_state = 5},
  [198] = {.lex_state = 32, .external_lex_state = 5},
  [199] = {.lex_state = 32, .external_lex_state = 5},
  [200] = {.lex_state = 32, .external_lex_state = 5},
  [201] = {.lex_state = 32, .external_lex_state = 5},
  [202] = {.lex_state = 33, .external_lex_state = 5},
  [203] = {.lex_state = 33, .external_lex_state = 5},
  [204] = {.lex_state = 32, .external_lex_state = 5},
  [205] = {.lex_state = 32, .external_lex_state = 5},
  [206] = {.lex_state = 32, .external_lex_state = 5},
  [207] = {.lex_state = 32, .external_lex_state = 5},
  [208] = {.lex_state = 33, .external_lex_state = 5},
  [209] = {.lex_state = 33, .external_lex_state = 5},
  [210] = {.lex_state = 34, .external_lex_state = 5},
  [211] = {.lex_state = 40, .external_lex_state = 6},
  [212] = {.lex_state = 31, .external_lex_state = 6},
  [213] = {.lex_state = 31, .external_lex_state = 6},
  [214] = {.lex_state = 31, .external_lex_state = 6},
  [215] = {.lex_state = 31, .external_lex_state = 6},
  [216] = {.lex_state = 31, .external_lex_state = 6},
  [217] = {.lex_state = 40, .external_lex_state = 6},
  [218] = {.lex_state = 31, .external_lex_state = 6},
  [219] = {.lex_state = 31, .external_lex_state = 6},
  [220] = {.lex_state = 31, .external_lex_state = 6},
  [221] = {.lex_state = 31, .external_lex_state = 6},
  [222] = {.lex_state = 31, .external_lex_state = 6},
  [223] = {.lex_state = 40, .external_lex_state = 6},
  [224] = {.lex_state = 34, .external_lex_state = 5},
  [225] = {.lex_state = 31, .external_lex_state = 6},
  [226] = {.lex_state = 31, .external_lex_state = 6},
  [227] = {.lex_state = 40, .external_lex_state = 6},
  [228] = {.lex_state = 35, .external_lex_state = 5},
  [229] = {.lex_state = 31, .external_lex_state = 6},
  [230] = {.lex_state = 31, .external_lex_state = 6},
  [231] = {.lex_state = 40, .external_lex_state = 6},
  [232] = {.lex_state = 40, .external_lex_state = 6},
  [233] = {.lex_state = 31, .external_lex_state = 6},
  [234] = {.lex_state = 31, .external_lex_state = 6},
  [235] = {.lex_state = 31, .external_lex_state = 6},
  [236] = {.lex_state = 31, .external_lex_state = 6},
  [237] = {.lex_state = 31, .external_lex_state = 6},
  [238] = {.lex_state = 31, .external_lex_state = 6},
  [239] = {.lex_state = 40, .external_lex_state = 6},
  [240] = {.lex_state = 34, .external_lex_state = 5},
  [241] = {.lex_state = 31, .external_lex_state = 6},
  [242] = {.lex_state = 31, .external_lex_state = 6},
  [243] = {.lex_state = 34, .external_lex_state = 5},
  [244] = {.lex_state = 34, .external_lex_state = 5},
  [245] = {.lex_state = 34, .external_lex_state = 5},
  [246] = {.lex_state = 34, .external_lex_state = 5},
  [247] = {.lex_state = 34, .external_lex_state = 5},
  [248] = {.lex_state = 34, .external_lex_state = 5},
  [249] = {.lex_state = 34, .external_lex_state = 5},
  [250] = {.lex_state = 34, .external_lex_state = 5},
  [251] = {.lex_state = 34, .external_lex_state = 5},
  [252] = {.lex_state = 31, .external_lex_state = 6},
  [253] = {.lex_state = 31, .external_lex_state = 6},
  [254] = {.lex_state = 34, .external_lex_state = 5},
  [255] = {.lex_state = 34, .external_lex_state = 5},
  [256] = {.lex_state = 31, .external_lex_state = 6},
  [257] = {.lex_state = 31, .external_lex_state = 6},
  [258] = {.lex_state = 34, .external_lex_state = 5},
  [259] = {.lex_state = 40, .external_lex_state = 6},
  [260] = {.lex_state = 34, .external_lex_state = 5},
  [261] = {.lex_state = 34, .external_lex_state = 5},
  [262] = {.lex_state = 40, .external_lex_state = 6},
  [263] = {.lex_state = 34, .external_lex_state = 5},
  [264] = {.lex_state = 34, .external_lex_state = 5},
  [265] = {.lex_state = 34, .external_lex_state = 5},
  [266] = {.lex_state = 35, .external_lex_state = 5},
  [267] = {.lex_state = 34, .external_lex_state = 5},
  [268] = {.lex_state = 34, .external_lex_state = 5},
  [269] = {.lex_state = 40, .external_lex_state = 6},
  [270] = {.lex_state = 34, .external_lex_state = 5},
  [271] = {.lex_state = 34, .external_lex_state = 5},
  [272] = {.lex_state = 34, .external_lex_state = 5},
  [273] = {.lex_state = 34, .external_lex_state = 5},
  [274] = {.lex_state = 35, .external_lex_state = 5},
  [275] = {.lex_state = 40, .external_lex_state = 6},
  [276] = {.lex_state = 35, .external_lex_state = 5},
  [277] = {.lex_state = 247, .external_lex_state = 3},
  [278] = {.lex_state = 40, .external_lex_state = 6},
  [279] = {.lex_state = 35, .external_lex_state = 5},
  [280] = {.lex_state = 40, .external_lex_state = 6},
  [281] = {.lex_state = 35, .external_lex_state = 5},
  [282] = {.lex_state = 35, .external_lex_state = 5},
  [283] = {.lex_state = 35, .external_lex_state = 5},
  [284] = {.lex_state = 35, .external_lex_state = 5},
  [285] = {.lex_state = 35, .external_lex_state = 5},
  [286] = {.lex_state = 40, .external_lex_state = 6},
  [287] = {.lex_state = 35, .external_lex_state = 5},
  [288] = {.lex_state = 40, .external_lex_state = 6},
  [289] = {.lex_state = 35, .external_lex_state = 5},
  [290] = {.lex_state = 35, .external_lex_state = 5},
  [291] = {.lex_state = 35, .external_lex_state = 5},
  [292] = {.lex_state = 35, .external_lex_state = 5},
  [293] = {.lex_state = 40, .external_lex_state = 6},
  [294] = {.lex_state = 40, .external_lex_state = 6},
  [295] = {.lex_state = 35, .external_lex_state = 5},
  [296] = {.lex_state = 40, .external_lex_state = 6},
  [297] = {.lex_state = 35, .external_lex_state = 5},
  [298] = {.lex_state = 35, .external_lex_state = 5},
  [299] = {.lex_state = 35, .external_lex_state = 5},
  [300] = {.lex_state = 35, .external_lex_state = 5},
  [301] = {.lex_state = 35, .external_lex_state = 5},
  [302] = {.lex_state = 35, .external_lex_state = 5},
  [303] = {.lex_state = 35, .external_lex_state = 5},
  [304] = {.lex_state = 35, .external_lex_state = 5},
  [305] = {.lex_state = 35, .external_lex_state = 5},
  [306] = {.lex_state = 35, .external_lex_state = 5},
  [307] = {.lex_state = 32, .external_lex_state = 6},
  [308] = {.lex_state = 31, .external_lex_state = 6},
  [309] = {.lex_state = 32, .external_lex_state = 6},
  [310] = {.lex_state = 33, .external_lex_state = 6},
  [311] = {.lex_state = 33, .external_lex_state = 6},
  [312] = {.lex_state = 32, .external_lex_state = 6},
  [313] = {.lex_state = 33, .external_lex_state = 6},
  [314] = {.lex_state = 35, .external_lex_state = 5},
  [315] = {.lex_state = 32, .external_lex_state = 6},
  [316] = {.lex_state = 32, .external_lex_state = 6},
  [317] = {.lex_state = 32, .external_lex_state = 6},
  [318] = {.lex_state = 32, .external_lex_state = 6},
  [319] = {.lex_state = 32, .external_lex_state = 6},
  [320] = {.lex_state = 32, .external_lex_state = 6},
  [321] = {.lex_state = 32, .external_lex_state = 6},
  [322] = {.lex_state = 32, .external_lex_state = 6},
  [323] = {.lex_state = 32, .external_lex_state = 6},
  [324] = {.lex_state = 32, .external_lex_state = 6},
  [325] = {.lex_state = 32, .external_lex_state = 6},
  [326] = {.lex_state = 32, .external_lex_state = 6},
  [327] = {.lex_state = 31, .external_lex_state = 6},
  [328] = {.lex_state = 31, .external_lex_state = 6},
  [329] = {.lex_state = 32, .external_lex_state = 6},
  [330] = {.lex_state = 32, .external_lex_state = 6},
  [331] = {.lex_state = 32, .external_lex_state = 6},
  [332] = {.lex_state = 32, .external_lex_state = 6},
  [333] = {.lex_state = 33, .external_lex_state = 6},
  [334] = {.lex_state = 31, .external_lex_state = 6},
  [335] = {.lex_state = 31, .external_lex_state = 6},
  [336] = {.lex_state = 32, .external_lex_state = 6},
  [337] = {.lex_state = 35, .external_lex_state = 5},
  [338] = {.lex_state = 32, .external_lex_state = 6},
  [339] = {.lex_state = 33, .external_lex_state = 6},
  [340] = {.lex_state = 32, .external_lex_state = 6},
  [341] = {.lex_state = 32, .external_lex_state = 6},
  [342] = {.lex_state = 32, .external_lex_state = 6},
  [343] = {.lex_state = 33, .external_lex_state = 6},
  [344] = {.lex_state = 32, .external_lex_state = 6},
  [345] = {.lex_state = 35, .external_lex_state = 5},
  [346] = {.lex_state = 32, .external_lex_state = 6},
  [347] = {.lex_state = 31, .external_lex_state = 6},
  [348] = {.lex_state = 32, .external_lex_state = 6},
  [349] = {.lex_state = 31, .external_lex_state = 6},
  [350] = {.lex_state = 35, .external_lex_state = 5},
  [351] = {.lex_state = 31, .external_lex_state = 6},
  [352] = {.lex_state = 32, .external_lex_state = 6},
  [353] = {.lex_state = 33, .external_lex_state = 6},
  [354] = {.lex_state = 32, .external_lex_state = 6},
  [355] = {.lex_state = 32, .external_lex_state = 6},
  [356] = {.lex_state = 32, .external_lex_state = 6},
  [357] = {.lex_state = 31, .external_lex_state = 6},
  [358] = {.lex_state = 32, .external_lex_state = 6},
  [359] = {.lex_state = 31, .external_lex_state = 6},
  [360] = {.lex_state = 31, .external_lex_state = 6},
  [361] = {.lex_state = 35, .external_lex_state = 5},
  [362] = {.lex_state = 31, .external_lex_state = 6},
  [363] = {.lex_state = 33, .external_lex_state = 6},
  [364] = {.lex_state = 32, .external_lex_state = 6},
  [365] = {.lex_state = 31, .external_lex_state = 6},
  [366] = {.lex_state = 31, .external_lex_state = 6},
  [367] = {.lex_state = 33, .external_lex_state = 6},
  [368] = {.lex_state = 33, .external_lex_state = 6},
  [369] = {.lex_state = 35, .external_lex_state = 5},
  [370] = {.lex_state = 35, .external_lex_state = 5},
  [371] = {.lex_state = 31, .external_lex_state = 6},
  [372] = {.lex_state = 35, .external_lex_state = 5},
  [373] = {.lex_state = 33, .external_lex_state = 6},
  [374] = {.lex_state = 32, .external_lex_state = 6},
  [375] = {.lex_state = 32, .external_lex_state = 6},
  [376] = {.lex_state = 35, .external_lex_state = 5},
  [377] = {.lex_state = 35, .external_lex_state = 5},
  [378] = {.lex_state = 35, .external_lex_state = 5},
  [379] = {.lex_state = 35, .external_lex_state = 5},
  [380] = {.lex_state = 31, .external_lex_state = 6},
  [381] = {.lex_state = 31, .external_lex_state = 6},
  [382] = {.lex_state = 35, .external_lex_state = 5},
  [383] = {.lex_state = 31, .external_lex_state = 6},
  [384] = {.lex_state = 31, .external_lex_state = 6},
  [385] = {.lex_state = 31, .external_lex_state = 6},
  [386] = {.lex_state = 31, .external_lex_state = 6},
  [387] = {.lex_state = 31, .external_lex_state = 6},
  [388] = {.lex_state = 31, .external_lex_state = 6},
  [389] = {.lex_state = 35, .external_lex_state = 5},
  [390] = {.lex_state = 31, .external_lex_state = 6},
  [391] = {.lex_state = 31, .external_lex_state = 6},
  [392] = {.lex_state = 31, .external_lex_state = 6},
  [393] = {.lex_state = 31, .external_lex_state = 6},
  [394] = {.lex_state = 31, .external_lex_state = 6},
  [395] = {.lex_state = 31, .external_lex_state = 6},
  [396] = {.lex_state = 31, .external_lex_state = 6},
  [397] = {.lex_state = 31, .external_lex_state = 6},
  [398] = {.lex_state = 31, .external_lex_state = 6},
  [399] = {.lex_state = 31, .external_lex_state = 6},
  [400] = {.lex_state = 31, .external_lex_state = 6},
  [401] = {.lex_state = 35, .external_lex_state = 5},
  [402] = {.lex_state = 35, .external_lex_state = 5},
  [403] = {.lex_state = 35, .external_lex_state = 5},
  [404] = {.lex_state = 33, .external_lex_state = 6},
  [405] = {.lex_state = 33, .external_lex_state = 6},
  [406] = {.lex_state = 32, .external_lex_state = 6},
  [407] = {.lex_state = 32, .external_lex_state = 6},
  [408] = {.lex_state = 35, .external_lex_state = 5},
  [409] = {.lex_state = 32, .external_lex_state = 6},
  [410] = {.lex_state = 33, .external_lex_state = 6},
  [411] = {.lex_state = 35, .external_lex_state = 5},
  [412] = {.lex_state = 32, .external_lex_state = 6},
  [413] = {.lex_state = 32, .external_lex_state = 6},
  [414] = {.lex_state = 32, .external_lex_state = 6},
  [415] = {.lex_state = 32, .external_lex_state = 6},
  [416] = {.lex_state = 31, .external_lex_state = 6},
  [417] = {.lex_state = 31, .external_lex_state = 6},
  [418] = {.lex_state = 31, .external_lex_state = 6},
  [419] = {.lex_state = 32, .external_lex_state = 6},
  [420] = {.lex_state = 32, .external_lex_state = 6},
  [421] = {.lex_state = 31, .external_lex_state = 6},
  [422] = {.lex_state = 33, .external_lex_state = 6},
  [423] = {.lex_state = 32, .external_lex_state = 6},
  [424] = {.lex_state = 32, .external_lex_state = 6},
  [425] = {.lex_state = 35, .external_lex_state = 5},
  [426] = {.lex_state = 31, .external_lex_state = 6},
  [427] = {.lex_state = 33, .external_lex_state = 6},
  [428] = {.lex_state = 33, .external_lex_state = 6},
  [429] = {.lex_state = 31, .external_lex_state = 6},
  [430] = {.lex_state = 248, .external_lex_state = 3},
  [431] = {.lex_state = 33, .external_lex_state = 6},
  [432] = {.lex_state = 31, .external_lex_state = 6},
  [433] = {.lex_state = 31, .external_lex_state = 6},
  [434] = {.lex_state = 31, .external_lex_state = 6},
  [435] = {.lex_state = 35, .external_lex_state = 5},
  [436] = {.lex_state = 33, .external_lex_state = 6},
  [437] = {.lex_state = 35, .external_lex_state = 5},
  [438] = {.lex_state = 31, .external_lex_state = 6},
  [439] = {.lex_state = 33, .external_lex_state = 6},
  [440] = {.lex_state = 33, .external_lex_state = 6},
  [441] = {.lex_state = 32, .external_lex_state = 6},
  [442] = {.lex_state = 35, .external_lex_state = 5},
  [443] = {.lex_state = 33, .external_lex_state = 6},
  [444] = {.lex_state = 31, .external_lex_state = 6},
  [445] = {.lex_state = 33, .external_lex_state = 6},
  [446] = {.lex_state = 31, .external_lex_state = 6},
  [447] = {.lex_state = 33, .external_lex_state = 6},
  [448] = {.lex_state = 33, .external_lex_state = 6},
  [449] = {.lex_state = 35, .external_lex_state = 5},
  [450] = {.lex_state = 33, .external_lex_state = 6},
  [451] = {.lex_state = 31, .external_lex_state = 6},
  [452] = {.lex_state = 35, .external_lex_state = 5},
  [453] = {.lex_state = 31, .external_lex_state = 6},
  [454] = {.lex_state = 32, .external_lex_state = 6},
  [455] = {.lex_state = 32, .external_lex_state = 6},
  [456] = {.lex_state = 32, .external_lex_state = 6},
  [457] = {.lex_state = 32, .external_lex_state = 6},
  [458] = {.lex_state = 31, .external_lex_state = 6},
  [459] = {.lex_state = 31, .external_lex_state = 6},
  [460] = {.lex_state = 31, .external_lex_state = 6},
  [461] = {.lex_state = 35, .external_lex_state = 5},
  [462] = {.lex_state = 31, .external_lex_state = 6},
  [463] = {.lex_state = 32, .external_lex_state = 6},
  [464] = {.lex_state = 51, .external_lex_state = 7},
  [465] = {.lex_state = 34, .external_lex_state = 6},
  [466] = {.lex_state = 35, .external_lex_state = 6},
  [467] = {.lex_state = 35, .external_lex_state = 6},
  [468] = {.lex_state = 35, .external_lex_state = 6},
  [469] = {.lex_state = 34, .external_lex_state = 6},
  [470] = {.lex_state = 34, .external_lex_state = 6},
  [471] = {.lex_state = 35, .external_lex_state = 6},
  [472] = {.lex_state = 35, .external_lex_state = 6},
  [473] = {.lex_state = 35, .external_lex_state = 6},
  [474] = {.lex_state = 35, .external_lex_state = 6},
  [475] = {.lex_state = 35, .external_lex_state = 6},
  [476] = {.lex_state = 35, .external_lex_state = 6},
  [477] = {.lex_state = 35, .external_lex_state = 6},
  [478] = {.lex_state = 35, .external_lex_state = 6},
  [479] = {.lex_state = 34, .external_lex_state = 6},
  [480] = {.lex_state = 34, .external_lex_state = 6},
  [481] = {.lex_state = 34, .external_lex_state = 6},
  [482] = {.lex_state = 35, .external_lex_state = 6},
  [483] = {.lex_state = 35, .external_lex_state = 6},
  [484] = {.lex_state = 35, .external_lex_state = 6},
  [485] = {.lex_state = 35, .external_lex_state = 6},
  [486] = {.lex_state = 35, .external_lex_state = 6},
  [487] = {.lex_state = 35, .external_lex_state = 6},
  [488] = {.lex_state = 35, .external_lex_state = 6},
  [489] = {.lex_state = 35, .external_lex_state = 6},
  [490] = {.lex_state = 35, .external_lex_state = 6},
  [491] = {.lex_state = 34, .external_lex_state = 6},
  [492] = {.lex_state = 34, .external_lex_state = 6},
  [493] = {.lex_state = 34, .external_lex_state = 6},
  [494] = {.lex_state = 35, .external_lex_state = 6},
  [495] = {.lex_state = 34, .external_lex_state = 6},
  [496] = {.lex_state = 35, .external_lex_state = 6},
  [497] = {.lex_state = 34, .external_lex_state = 6},
  [498] = {.lex_state = 35, .external_lex_state = 6},
  [499] = {.lex_state = 51, .external_lex_state = 7},
  [500] = {.lex_state = 35, .external_lex_state = 6},
  [501] = {.lex_state = 34, .external_lex_state = 6},
  [502] = {.lex_state = 34, .external_lex_state = 6},
  [503] = {.lex_state = 34, .external_lex_state = 6},
  [504] = {.lex_state = 34, .external_lex_state = 6},
  [505] = {.lex_state = 34, .external_lex_state = 6},
  [506] = {.lex_state = 34, .external_lex_state = 6},
  [507] = {.lex_state = 34, .external_lex_state = 6},
  [508] = {.lex_state = 34, .external_lex_state = 6},
  [509] = {.lex_state = 34, .external_lex_state = 6},
  [510] = {.lex_state = 34, .external_lex_state = 6},
  [511] = {.lex_state = 35, .external_lex_state = 6},
  [512] = {.lex_state = 34, .external_lex_state = 6},
  [513] = {.lex_state = 34, .external_lex_state = 6},
  [514] = {.lex_state = 34, .external_lex_state = 6},
  [515] = {.lex_state = 34, .external_lex_state = 6},
  [516] = {.lex_state = 34, .external_lex_state = 6},
  [517] = {.lex_state = 35, .external_lex_state = 6},
  [518] = {.lex_state = 52, .external_lex_state = 7},
  [519] = {.lex_state = 52, .external_lex_state = 7},
  [520] = {.lex_state = 52, .external_lex_state = 7},
  [521] = {.lex_state = 52, .external_lex_state = 7},
  [522] = {.lex_state = 52, .external_lex_state = 7},
  [523] = {.lex_state = 52, .external_lex_state = 7},
  [524] = {.lex_state = 52, .external_lex_state = 7},
  [525] = {.lex_state = 52, .external_lex_state = 7},
  [526] = {.lex_state = 52, .external_lex_state = 7},
  [527] = {.lex_state = 52, .external_lex_state = 7},
  [528] = {.lex_state = 52, .external_lex_state = 7},
  [529] = {.lex_state = 52, .external_lex_state = 7},
  [530] = {.lex_state = 52, .external_lex_state = 7},
  [531] = {.lex_state = 52, .external_lex_state = 7},
  [532] = {.lex_state = 52, .external_lex_state = 7},
  [533] = {.lex_state = 52, .external_lex_state = 7},
  [534] = {.lex_state = 52, .external_lex_state = 7},
  [535] = {.lex_state = 52, .external_lex_state = 7},
  [536] = {.lex_state = 52, .external_lex_state = 7},
  [537] = {.lex_state = 52, .external_lex_state = 7},
  [538] = {.lex_state = 52, .external_lex_state = 7},
  [539] = {.lex_state = 52, .external_lex_state = 7},
  [540] = {.lex_state = 52, .external_lex_state = 7},
  [541] = {.lex_state = 52, .external_lex_state = 7},
  [542] = {.lex_state = 52, .external_lex_state = 7},
  [543] = {.lex_state = 52, .external_lex_state = 7},
  [544] = {.lex_state = 52, .external_lex_state = 7},
  [545] = {.lex_state = 52, .external_lex_state = 7},
  [546] = {.lex_state = 52, .external_lex_state = 7},
  [547] = {.lex_state = 52, .external_lex_state = 7},
  [548] = {.lex_state = 52, .external_lex_state = 7},
  [549] = {.lex_state = 52, .external_lex_state = 7},
  [550] = {.lex_state = 52, .external_lex_state = 7},
  [551] = {.lex_state = 52, .external_lex_state = 7},
  [552] = {.lex_state = 52, .external_lex_state = 7},
  [553] = {.lex_state = 52, .external_lex_state = 7},
  [554] = {.lex_state = 52, .external_lex_state = 7},
  [555] = {.lex_state = 52, .external_lex_state = 7},
  [556] = {.lex_state = 52, .external_lex_state = 7},
  [557] = {.lex_state = 52, .external_lex_state = 7},
  [558] = {.lex_state = 52, .external_lex_state = 7},
  [559] = {.lex_state = 52, .external_lex_state = 7},
  [560] = {.lex_state = 52, .external_lex_state = 7},
  [561] = {.lex_state = 52, .external_lex_state = 7},
  [562] = {.lex_state = 52, .external_lex_state = 7},
  [563] = {.lex_state = 52, .external_lex_state = 7},
  [564] = {.lex_state = 52, .external_lex_state = 7},
  [565] = {.lex_state = 52, .external_lex_state = 7},
  [566] = {.lex_state = 52, .external_lex_state = 7},
  [567] = {.lex_state = 52, .external_lex_state = 7},
  [568] = {.lex_state = 52, .external_lex_state = 7},
  [569] = {.lex_state = 52, .external_lex_state = 7},
  [570] = {.lex_state = 52, .external_lex_state = 7},
  [571] = {.lex_state = 52, .external_lex_state = 7},
  [572] = {.lex_state = 52, .external_lex_state = 7},
  [573] = {.lex_state = 52, .external_lex_state = 7},
  [574] = {.lex_state = 52, .external_lex_state = 7},
  [575] = {.lex_state = 52, .external_lex_state = 7},
  [576] = {.lex_state = 52, .external_lex_state = 7},
  [577] = {.lex_state = 52, .external_lex_state = 7},
  [578] = {.lex_state = 52, .external_lex_state = 7},
  [579] = {.lex_state = 247, .external_lex_state = 8},
  [580] = {.lex_state = 52, .external_lex_state = 7},
  [581] = {.lex_state = 52, .external_lex_state = 7},
  [582] = {.lex_state = 52, .external_lex_state = 7},
  [583] = {.lex_state = 52, .external_lex_state = 7},
  [584] = {.lex_state = 52, .external_lex_state = 7},
  [585] = {.lex_state = 52, .external_lex_state = 7},
  [586] = {.lex_state = 52, .external_lex_state = 7},
  [587] = {.lex_state = 52, .external_lex_state = 7},
  [588] = {.lex_state = 52, .external_lex_state = 7},
  [589] = {.lex_state = 52, .external_lex_state = 7},
  [590] = {.lex_state = 52, .external_lex_state = 7},
  [591] = {.lex_state = 52, .external_lex_state = 7},
  [592] = {.lex_state = 52, .external_lex_state = 7},
  [593] = {.lex_state = 52, .external_lex_state = 7},
  [594] = {.lex_state = 52, .external_lex_state = 7},
  [595] = {.lex_state = 52, .external_lex_state = 7},
  [596] = {.lex_state = 52, .external_lex_state = 7},
  [597] = {.lex_state = 52, .external_lex_state = 7},
  [598] = {.lex_state = 52, .external_lex_state = 7},
  [599] = {.lex_state = 52, .external_lex_state = 7},
  [600] = {.lex_state = 52, .external_lex_state = 7},
  [601] = {.lex_state = 52, .external_lex_state = 7},
  [602] = {.lex_state = 52, .external_lex_state = 7},
  [603] = {.lex_state = 52, .external_lex_state = 7},
  [604] = {.lex_state = 52, .external_lex_state = 7},
  [605] = {.lex_state = 52, .external_lex_state = 7},
  [606] = {.lex_state = 52, .external_lex_state = 7},
  [607] = {.lex_state = 52, .external_lex_state = 7},
  [608] = {.lex_state = 52, .external_lex_state = 7},
  [609] = {.lex_state = 52, .external_lex_state = 7},
  [610] = {.lex_state = 52, .external_lex_state = 7},
  [611] = {.lex_state = 52, .external_lex_state = 7},
  [612] = {.lex_state = 247, .external_lex_state = 8},
  [613] = {.lex_state = 52, .external_lex_state = 7},
  [614] = {.lex_state = 52, .external_lex_state = 7},
  [615] = {.lex_state = 52, .external_lex_state = 7},
  [616] = {.lex_state = 52, .external_lex_state = 7},
  [617] = {.lex_state = 50, .external_lex_state = 5},
  [618] = {.lex_state = 50, .external_lex_state = 9},
  [619] = {.lex_state = 248, .external_lex_state = 8},
  [620] = {.lex_state = 52, .external_lex_state = 7},
  [621] = {.lex_state = 52, .external_lex_state = 7},
  [622] = {.lex_state = 52, .external_lex_state = 7},
  [623] = {.lex_state = 52, .external_lex_state = 7},
  [624] = {.lex_state = 52, .external_lex_state = 7},
  [625] = {.lex_state = 52, .external_lex_state = 7},
  [626] = {.lex_state = 52, .external_lex_state = 7},
  [627] = {.lex_state = 52, .external_lex_state = 7},
  [628] = {.lex_state = 50, .external_lex_state = 9},
  [629] = {.lex_state = 52, .external_lex_state = 7},
  [630] = {.lex_state = 52, .external_lex_state = 7},
  [631] = {.lex_state = 50, .external_lex_state = 9},
  [632] = {.lex_state = 52, .external_lex_state = 7},
  [633] = {.lex_state = 52, .external_lex_state = 7},
  [634] = {.lex_state = 50, .external_lex_state = 9},
  [635] = {.lex_state = 50, .external_lex_state = 9},
  [636] = {.lex_state = 52, .external_lex_state = 7},
  [637] = {.lex_state = 52, .external_lex_state = 7},
  [638] = {.lex_state = 52, .external_lex_state = 7},
  [639] = {.lex_state = 52, .external_lex_state = 7},
  [640] = {.lex_state = 52, .external_lex_state = 7},
  [641] = {.lex_state = 52, .external_lex_state = 7},
  [642] = {.lex_state = 52, .external_lex_state = 7},
  [643] = {.lex_state = 50, .external_lex_state = 9},
  [644] = {.lex_state = 50, .external_lex_state = 9},
  [645] = {.lex_state = 52, .external_lex_state = 7},
  [646] = {.lex_state = 50, .external_lex_state = 9},
  [647] = {.lex_state = 50, .external_lex_state = 9},
  [648] = {.lex_state = 52, .external_lex_state = 7},
  [649] = {.lex_state = 52, .external_lex_state = 7},
  [650] = {.lex_state = 52, .external_lex_state = 7},
  [651] = {.lex_state = 52, .external_lex_state = 7},
  [652] = {.lex_state = 52, .external_lex_state = 7},
  [653] = {.lex_state = 52, .external_lex_state = 7},
  [654] = {.lex_state = 52, .external_lex_state = 7},
  [655] = {.lex_state = 52, .external_lex_state = 7},
  [656] = {.lex_state = 52, .external_lex_state = 7},
  [657] = {.lex_state = 52, .external_lex_state = 7},
  [658] = {.lex_state = 52, .external_lex_state = 7},
  [659] = {.lex_state = 52, .external_lex_state = 7},
  [660] = {.lex_state = 52, .external_lex_state = 7},
  [661] = {.lex_state = 52, .external_lex_state = 7},
  [662] = {.lex_state = 50, .external_lex_state = 9},
  [663] = {.lex_state = 52, .external_lex_state = 7},
  [664] = {.lex_state = 52, .external_lex_state = 7},
  [665] = {.lex_state = 52, .external_lex_state = 7},
  [666] = {.lex_state = 52, .external_lex_state = 7},
  [667] = {.lex_state = 52, .external_lex_state = 7},
  [668] = {.lex_state = 52, .external_lex_state = 7},
  [669] = {.lex_state = 50, .external_lex_state = 9},
  [670] = {.lex_state = 50, .external_lex_state = 9},
  [671] = {.lex_state = 52, .external_lex_state = 7},
  [672] = {.lex_state = 50, .external_lex_state = 9},
  [673] = {.lex_state = 50, .external_lex_state = 9},
  [674] = {.lex_state = 52, .external_lex_state = 7},
  [675] = {.lex_state = 52, .external_lex_state = 7},
  [676] = {.lex_state = 50, .external_lex_state = 9},
  [677] = {.lex_state = 52, .external_lex_state = 7},
  [678] = {.lex_state = 50, .external_lex_state = 9},
  [679] = {.lex_state = 52, .external_lex_state = 7},
  [680] = {.lex_state = 50, .external_lex_state = 9},
  [681] = {.lex_state = 52, .external_lex_state = 7},
  [682] = {.lex_state = 52, .external_lex_state = 7},
  [683] = {.lex_state = 52, .external_lex_state = 7},
  [684] = {.lex_state = 50, .external_lex_state = 9},
  [685] = {.lex_state = 52, .external_lex_state = 7},
  [686] = {.lex_state = 52, .external_lex_state = 7},
  [687] = {.lex_state = 52, .external_lex_state = 7},
  [688] = {.lex_state = 52, .external_lex_state = 7},
  [689] = {.lex_state = 248, .external_lex_state = 8},
  [690] = {.lex_state = 52, .external_lex_state = 7},
  [691] = {.lex_state = 52, .external_lex_state = 7},
  [692] = {.lex_state = 52, .external_lex_state = 7},
  [693] = {.lex_state = 50, .external_lex_state = 9},
  [694] = {.lex_state = 52, .external_lex_state = 7},
  [695] = {.lex_state = 52, .external_lex_state = 7},
  [696] = {.lex_state = 52, .external_lex_state = 7},
  [697] = {.lex_state = 52, .external_lex_state = 7},
  [698] = {.lex_state = 52, .external_lex_state = 7},
  [699] = {.lex_state = 52, .external_lex_state = 7},
  [700] = {.lex_state = 50, .external_lex_state = 9},
  [701] = {.lex_state = 52, .external_lex_state = 7},
  [702] = {.lex_state = 52, .external_lex_state = 7},
  [703] = {.lex_state = 52, .external_lex_state = 7},
  [704] = {.lex_state = 50, .external_lex_state = 9},
  [705] = {.lex_state = 52, .external_lex_state = 7},
  [706] = {.lex_state = 52, .external_lex_state = 7},
  [707] = {.lex_state = 52, .external_lex_state = 7},
  [708] = {.lex_state = 52, .external_lex_state = 7},
  [709] = {.lex_state = 50, .external_lex_state = 9},
  [710] = {.lex_state = 52, .external_lex_state = 7},
  [711] = {.lex_state = 52, .external_lex_state = 7},
  [712] = {.lex_state = 50, .external_lex_state = 9},
  [713] = {.lex_state = 52, .external_lex_state = 7},
  [714] = {.lex_state = 50, .external_lex_state = 9},
  [715] = {.lex_state = 52, .external_lex_state = 7},
  [716] = {.lex_state = 52, .external_lex_state = 7},
  [717] = {.lex_state = 50, .external_lex_state = 9},
  [718] = {.lex_state = 50, .external_lex_state = 9},
  [719] = {.lex_state = 52, .external_lex_state = 7},
  [720] = {.lex_state = 50, .external_lex_state = 9},
  [721] = {.lex_state = 50, .external_lex_state = 9},
  [722] = {.lex_state = 50, .external_lex_state = 9},
  [723] = {.lex_state = 50, .external_lex_state = 9},
  [724] = {.lex_state = 52, .external_lex_state = 7},
  [725] = {.lex_state = 52, .external_lex_state = 7},
  [726] = {.lex_state = 52, .external_lex_state = 7},
  [727] = {.lex_state = 52, .external_lex_state = 7},
  [728] = {.lex_state = 52, .external_lex_state = 7},
  [729] = {.lex_state = 52, .external_lex_state = 7},
  [730] = {.lex_state = 50, .external_lex_state = 9},
  [731] = {.lex_state = 52, .external_lex_state = 7},
  [732] = {.lex_state = 52, .external_lex_state = 7},
  [733] = {.lex_state = 50, .external_lex_state = 9},
  [734] = {.lex_state = 52, .external_lex_state = 7},
  [735] = {.lex_state = 52, .external_lex_state = 7},
  [736] = {.lex_state = 52, .external_lex_state = 7},
  [737] = {.lex_state = 52, .external_lex_state = 7},
  [738] = {.lex_state = 52, .external_lex_state = 7},
  [739] = {.lex_state = 52, .external_lex_state = 7},
  [740] = {.lex_state = 52, .external_lex_state = 7},
  [741] = {.lex_state = 52, .external_lex_state = 7},
  [742] = {.lex_state = 52, .external_lex_state = 7},
  [743] = {.lex_state = 50, .external_lex_state = 9},
  [744] = {.lex_state = 52, .external_lex_state = 7},
  [745] = {.lex_state = 50, .external_lex_state = 9},
  [746] = {.lex_state = 50, .external_lex_state = 9},
  [747] = {.lex_state = 52, .external_lex_state = 7},
  [748] = {.lex_state = 52, .external_lex_state = 7},
  [749] = {.lex_state = 50, .external_lex_state = 9},
  [750] = {.lex_state = 52, .external_lex_state = 7},
  [751] = {.lex_state = 52, .external_lex_state = 7},
  [752] = {.lex_state = 50, .external_lex_state = 9},
  [753] = {.lex_state = 52, .external_lex_state = 7},
  [754] = {.lex_state = 52, .external_lex_state = 7},
  [755] = {.lex_state = 52, .external_lex_state = 7},
  [756] = {.lex_state = 52, .external_lex_state = 7},
  [757] = {.lex_state = 50, .external_lex_state = 9},
  [758] = {.lex_state = 52, .external_lex_state = 7},
  [759] = {.lex_state = 52, .external_lex_state = 7},
  [760] = {.lex_state = 50, .external_lex_state = 9},
  [761] = {.lex_state = 52, .external_lex_state = 7},
  [762] = {.lex_state = 52, .external_lex_state = 7},
  [763] = {.lex_state = 52, .external_lex_state = 7},
  [764] = {.lex_state = 52, .external_lex_state = 7},
  [765] = {.lex_state = 52, .external_lex_state = 7},
  [766] = {.lex_state = 52, .external_lex_state = 7},
  [767] = {.lex_state = 50, .external_lex_state = 9},
  [768] = {.lex_state = 52, .external_lex_state = 7},
  [769] = {.lex_state = 52, .external_lex_state = 7},
  [770] = {.lex_state = 50, .external_lex_state = 9},
  [771] = {.lex_state = 52, .external_lex_state = 7},
  [772] = {.lex_state = 52, .external_lex_state = 7},
  [773] = {.lex_state = 52, .external_lex_state = 7},
  [774] = {.lex_state = 52, .external_lex_state = 7},
  [775] = {.lex_state = 52, .external_lex_state = 7},
  [776] = {.lex_state = 52, .external_lex_state = 7},
  [777] = {.lex_state = 52, .external_lex_state = 7},
  [778] = {.lex_state = 50, .external_lex_state = 9},
  [779] = {.lex_state = 52, .external_lex_state = 7},
  [780] = {.lex_state = 50, .external_lex_state = 9},
  [781] = {.lex_state = 52, .external_lex_state = 7},
  [782] = {.lex_state = 50, .external_lex_state = 9},
  [783] = {.lex_state = 52, .external_lex_state = 7},
  [784] = {.lex_state = 50, .external_lex_state = 9},
  [785] = {.lex_state = 52, .external_lex_state = 7},
  [786] = {.lex_state = 50, .external_lex_state = 9},
  [787] = {.lex_state = 52, .external_lex_state = 7},
  [788] = {.lex_state = 52, .external_lex_state = 7},
  [789] = {.lex_state = 52, .external_lex_state = 7},
  [790] = {.lex_state = 50, .external_lex_state = 5},
  [791] = {.lex_state = 52, .external_lex_state = 7},
  [792] = {.lex_state = 52, .external_lex_state = 7},
  [793] = {.lex_state = 50, .external_lex_state = 9},
  [794] = {.lex_state = 52, .external_lex_state = 7},
  [795] = {.lex_state = 50, .external_lex_state = 9},
  [796] = {.lex_state = 52, .external_lex_state = 7},
  [797] = {.lex_state = 50, .external_lex_state = 9},
  [798] = {.lex_state = 52, .external_lex_state = 7},
  [799] = {.lex_state = 52, .external_lex_state = 7},
  [800] = {.lex_state = 50, .external_lex_state = 9},
  [801] = {.lex_state = 52, .external_lex_state = 7},
  [802] = {.lex_state = 50, .external_lex_state = 9},
  [803] = {.lex_state = 52, .external_lex_state = 7},
  [804] = {.lex_state = 52, .external_lex_state = 7},
  [805] = {.lex_state = 52, .external_lex_state = 7},
  [806] = {.lex_state = 50, .external_lex_state = 9},
  [807] = {.lex_state = 52, .external_lex_state = 7},
  [808] = {.lex_state = 50, .external_lex_state = 9},
  [809] = {.lex_state = 52, .external_lex_state = 7},
  [810] = {.lex_state = 50, .external_lex_state = 9},
  [811] = {.lex_state = 52, .external_lex_state = 7},
  [812] = {.lex_state = 50, .external_lex_state = 9},
  [813] = {.lex_state = 52, .external_lex_state = 7},
  [814] = {.lex_state = 52, .external_lex_state = 7},
  [815] = {.lex_state = 52, .external_lex_state = 7},
  [816] = {.lex_state = 52, .external_lex_state = 7},
  [817] = {.lex_state = 50, .external_lex_state = 9},
  [818] = {.lex_state = 52, .external_lex_state = 7},
  [819] = {.lex_state = 50, .external_lex_state = 9},
  [820] = {.lex_state = 52, .external_lex_state = 7},
  [821] = {.lex_state = 52, .external_lex_state = 7},
  [822] = {.lex_state = 52, .external_lex_state = 7},
  [823] = {.lex_state = 52, .external_lex_state = 7},
  [824] = {.lex_state = 52, .external_lex_state = 7},
  [825] = {.lex_state = 52, .external_lex_state = 7},
  [826] = {.lex_state = 50, .external_lex_state = 9},
  [827] = {.lex_state = 52, .external_lex_state = 7},
  [828] = {.lex_state = 50, .external_lex_state = 9},
  [829] = {.lex_state = 50, .external_lex_state = 9},
  [830] = {.lex_state = 50, .external_lex_state = 9},
  [831] = {.lex_state = 52, .external_lex_state = 7},
  [832] = {.lex_state = 52, .external_lex_state = 7},
  [833] = {.lex_state = 53, .external_lex_state = 5},
  [834] = {.lex_state = 52, .external_lex_state = 7},
  [835] = {.lex_state = 52, .external_lex_state = 7},
  [836] = {.lex_state = 52, .external_lex_state = 7},
  [837] = {.lex_state = 50, .external_lex_state = 9},
  [838] = {.lex_state = 53, .external_lex_state = 5},
  [839] = {.lex_state = 52, .external_lex_state = 7},
  [840] = {.lex_state = 52, .external_lex_state = 7},
  [841] = {.lex_state = 52, .external_lex_state = 7},
  [842] = {.lex_state = 50, .external_lex_state = 9},
  [843] = {.lex_state = 52, .external_lex_state = 7},
  [844] = {.lex_state = 52, .external_lex_state = 7},
  [845] = {.lex_state = 50, .external_lex_state = 9},
  [846] = {.lex_state = 52, .external_lex_state = 7},
  [847] = {.lex_state = 50, .external_lex_state = 9},
  [848] = {.lex_state = 52, .external_lex_state = 7},
  [849] = {.lex_state = 50, .external_lex_state = 9},
  [850] = {.lex_state = 52, .external_lex_state = 7},
  [851] = {.lex_state = 52, .external_lex_state = 7},
  [852] = {.lex_state = 52, .external_lex_state = 7},
  [853] = {.lex_state = 52, .external_lex_state = 7},
  [854] = {.lex_state = 52, .external_lex_state = 7},
  [855] = {.lex_state = 52, .external_lex_state = 7},
  [856] = {.lex_state = 52, .external_lex_state = 7},
  [857] = {.lex_state = 52, .external_lex_state = 7},
  [858] = {.lex_state = 50, .external_lex_state = 9},
  [859] = {.lex_state = 52, .external_lex_state = 7},
  [860] = {.lex_state = 52, .external_lex_state = 7},
  [861] = {.lex_state = 52, .external_lex_state = 7},
  [862] = {.lex_state = 50, .external_lex_state = 9},
  [863] = {.lex_state = 52, .external_lex_state = 7},
  [864] = {.lex_state = 52, .external_lex_state = 7},
  [865] = {.lex_state = 52, .external_lex_state = 7},
  [866] = {.lex_state = 52, .external_lex_state = 7},
  [867] = {.lex_state = 50, .external_lex_state = 5},
  [868] = {.lex_state = 52, .external_lex_state = 7},
  [869] = {.lex_state = 52, .external_lex_state = 7},
  [870] = {.lex_state = 52, .external_lex_state = 7},
  [871] = {.lex_state = 50, .external_lex_state = 5},
  [872] = {.lex_state = 52, .external_lex_state = 7},
  [873] = {.lex_state = 52, .external_lex_state = 7},
  [874] = {.lex_state = 53, .external_lex_state = 5},
  [875] = {.lex_state = 50, .external_lex_state = 9},
  [876] = {.lex_state = 52, .external_lex_state = 7},
  [877] = {.lex_state = 53, .external_lex_state = 5},
  [878] = {.lex_state = 50, .external_lex_state = 9},
  [879] = {.lex_state = 52, .external_lex_state = 7},
  [880] = {.lex_state = 50, .external_lex_state = 5},
  [881] = {.lex_state = 50, .external_lex_state = 9},
  [882] = {.lex_state = 52, .external_lex_state = 7},
  [883] = {.lex_state = 50, .external_lex_state = 9},
  [884] = {.lex_state = 52, .external_lex_state = 7},
  [885] = {.lex_state = 53, .external_lex_state = 5},
  [886] = {.lex_state = 52, .external_lex_state = 7},
  [887] = {.lex_state = 52, .external_lex_state = 7},
  [888] = {.lex_state = 52, .external_lex_state = 7},
  [889] = {.lex_state = 50, .external_lex_state = 5},
  [890] = {.lex_state = 53, .external_lex_state = 5},
  [891] = {.lex_state = 52, .external_lex_state = 7},
  [892] = {.lex_state = 52, .external_lex_state = 7},
  [893] = {.lex_state = 247, .external_lex_state = 3},
  [894] = {.lex_state = 247, .external_lex_state = 3},
  [895] = {.lex_state = 50, .external_lex_state = 10},
  [896] = {.lex_state = 50, .external_lex_state = 10},
  [897] = {.lex_state = 53, .external_lex_state = 6},
  [898] = {.lex_state = 50, .external_lex_state = 10},
  [899] = {.lex_state = 50, .external_lex_state = 10},
  [900] = {.lex_state = 50, .external_lex_state = 10},
  [901] = {.lex_state = 53, .external_lex_state = 6},
  [902] = {.lex_state = 50, .external_lex_state = 10},
  [903] = {.lex_state = 50, .external_lex_state = 10},
  [904] = {.lex_state = 50, .external_lex_state = 10},
  [905] = {.lex_state = 50, .external_lex_state = 10},
  [906] = {.lex_state = 50, .external_lex_state = 10},
  [907] = {.lex_state = 50, .external_lex_state = 10},
  [908] = {.lex_state = 53, .external_lex_state = 6},
  [909] = {.lex_state = 53, .external_lex_state = 6},
  [910] = {.lex_state = 50, .external_lex_state = 10},
  [911] = {.lex_state = 50, .external_lex_state = 10},
  [912] = {.lex_state = 50, .external_lex_state = 10},
  [913] = {.lex_state = 50, .external_lex_state = 10},
  [914] = {.lex_state = 50, .external_lex_state = 10},
  [915] = {.lex_state = 50, .external_lex_state = 5},
  [916] = {.lex_state = 50, .external_lex_state = 10},
  [917] = {.lex_state = 50, .external_lex_state = 10},
  [918] = {.lex_state = 50, .external_lex_state = 5},
  [919] = {.lex_state = 50, .external_lex_state = 10},
  [920] = {.lex_state = 50, .external_lex_state = 10},
  [921] = {.lex_state = 50, .external_lex_state = 10},
  [922] = {.lex_state = 50, .external_lex_state = 10},
  [923] = {.lex_state = 50, .external_lex_state = 10},
  [924] = {.lex_state = 50, .external_lex_state = 10},
  [925] = {.lex_state = 50, .external_lex_state = 10},
  [926] = {.lex_state = 53, .external_lex_state = 6},
  [927] = {.lex_state = 50, .external_lex_state = 10},
  [928] = {.lex_state = 50, .external_lex_state = 10},
  [929] = {.lex_state = 50, .external_lex_state = 5},
  [930] = {.lex_state = 50, .external_lex_state = 5},
  [931] = {.lex_state = 50, .external_lex_state = 10},
  [932] = {.lex_state = 50, .external_lex_state = 5},
  [933] = {.lex_state = 50, .external_lex_state = 5},
  [934] = {.lex_state = 50, .external_lex_state = 10},
  [935] = {.lex_state = 50, .external_lex_state = 10},
  [936] = {.lex_state = 53, .external_lex_state = 6},
  [937] = {.lex_state = 50, .external_lex_state = 10},
  [938] = {.lex_state = 50, .external_lex_state = 5},
  [939] = {.lex_state = 50, .external_lex_state = 10},
  [940] = {.lex_state = 50, .external_lex_state = 5},
  [941] = {.lex_state = 50, .external_lex_state = 10},
  [942] = {.lex_state = 50, .external_lex_state = 5},
  [943] = {.lex_state = 50, .external_lex_state = 5},
  [944] = {.lex_state = 50, .external_lex_state = 10},
  [945] = {.lex_state = 50, .external_lex_state = 5},
  [946] = {.lex_state = 50, .external_lex_state = 5},
  [947] = {.lex_state = 50, .external_lex_state = 5},
  [948] = {.lex_state = 50, .external_lex_state = 10},
  [949] = {.lex_state = 50, .external_lex_state = 5},
  [950] = {.lex_state = 50, .external_lex_state = 5},
  [951] = {.lex_state = 50, .external_lex_state = 5},
  [952] = {.lex_state = 50, .external_lex_state = 5},
  [953] = {.lex_state = 50, .external_lex_state = 10},
  [954] = {.lex_state = 50, .external_lex_state = 5},
  [955] = {.lex_state = 50, .external_lex_state = 10},
  [956] = {.lex_state = 50, .external_lex_state = 5},
  [957] = {.lex_state = 50, .external_lex_state = 10},
  [958] = {.lex_state = 50, .external_lex_state = 5},
  [959] = {.lex_state = 50, .external_lex_state = 6},
  [960] = {.lex_state = 50, .external_lex_state = 6},
  [961] = {.lex_state = 50, .external_lex_state = 6},
  [962] = {.lex_state = 50, .external_lex_state = 6},
  [963] = {.lex_state = 50, .external_lex_state = 6},
  [964] = {.lex_state = 50, .external_lex_state = 6},
  [965] = {.lex_state = 50, .external_lex_state = 6},
  [966] = {.lex_state = 50, .external_lex_state = 6},
  [967] = {.lex_state = 50, .external_lex_state = 6},
  [968] = {.lex_state = 50, .external_lex_state = 6},
  [969] = {.lex_state = 50, .external_lex_state = 6},
  [970] = {.lex_state = 50, .external_lex_state = 6},
  [971] = {.lex_state = 50, .external_lex_state = 6},
  [972] = {.lex_state = 50, .external_lex_state = 6},
  [973] = {.lex_state = 50, .external_lex_state = 6},
  [974] = {.lex_state = 50, .external_lex_state = 6},
  [975] = {.lex_state = 50, .external_lex_state = 6},
  [976] = {.lex_state = 50, .external_lex_state = 6},
  [977] = {.lex_state = 50, .external_lex_state = 6},
  [978] = {.lex_state = 50, .external_lex_state = 6},
  [979] = {.lex_state = 50, .external_lex_state = 6},
  [980] = {.lex_state = 50, .external_lex_state = 6},
  [981] = {.lex_state = 50, .external_lex_state = 6},
  [982] = {.lex_state = 50, .external_lex_state = 6},
  [983] = {.lex_state = 50, .external_lex_state = 6},
  [984] = {.lex_state = 50, .external_lex_state = 6},
  [985] = {.lex_state = 50, .external_lex_state = 6},
  [986] = {.lex_state = 50, .external_lex_state = 6},
  [987] = {.lex_state = 50, .external_lex_state = 6},
  [988] = {.lex_state = 50, .external_lex_state = 6},
  [989] = {.lex_state = 50, .external_lex_state = 6},
  [990] = {.lex_state = 50, .external_lex_state = 6},
  [991] = {.lex_state = 50, .external_lex_state = 6},
  [992] = {.lex_state = 50, .external_lex_state = 6},
  [993] = {.lex_state = 50, .external_lex_state = 6},
  [994] = {.lex_state = 50, .external_lex_state = 6},
  [995] = {.lex_state = 50, .external_lex_state = 6},
  [996] = {.lex_state = 50, .external_lex_state = 6},
  [997] = {.lex_state = 50, .external_lex_state = 6},
  [998] = {.lex_state = 50, .external_lex_state = 6},
  [999] = {.lex_state = 50, .external_lex_state = 6},
  [1000] = {.lex_state = 50, .external_lex_state = 6},
  [1001] = {.lex_state = 50, .external_lex_state = 6},
  [1002] = {.lex_state = 50, .external_lex_state = 6},
  [1003] = {.lex_state = 50, .external_lex_state = 6},
  [1004] = {.lex_state = 50, .external_lex_state = 6},
  [1005] = {.lex_state = 50, .external_lex_state = 6},
  [1006] = {.lex_state = 50, .external_lex_state = 6},
  [1007] = {.lex_state = 50, .external_lex_state = 6},
  [1008] = {.lex_state = 50, .external_lex_state = 6},
  [1009] = {.lex_state = 50, .external_lex_state = 6},
  [1010] = {.lex_state = 50, .external_lex_state = 6},
  [1011] = {.lex_state = 50, .external_lex_state = 6},
  [1012] = {.lex_state = 50, .external_lex_state = 6},
  [1013] = {.lex_state = 50, .external_lex_state = 6},
  [1014] = {.lex_state = 50, .external_lex_state = 6},
  [1015] = {.lex_state = 50, .external_lex_state = 6},
  [1016] = {.lex_state = 50, .external_lex_state = 6},
  [1017] = {.lex_state = 50, .external_lex_state = 6},
  [1018] = {.lex_state = 50, .external_lex_state = 6},
  [1019] = {.lex_state = 50, .external_lex_state = 6},
  [1020] = {.lex_state = 50, .external_lex_state = 6},
  [1021] = {.lex_state = 50, .external_lex_state = 6},
  [1022] = {.lex_state = 50, .external_lex_state = 6},
  [1023] = {.lex_state = 50, .external_lex_state = 6},
  [1024] = {.lex_state = 248, .external_lex_state = 3},
  [1025] = {.lex_state = 50, .external_lex_state = 6},
  [1026] = {.lex_state = 50, .external_lex_state = 6},
  [1027] = {.lex_state = 50, .external_lex_state = 6},
  [1028] = {.lex_state = 50, .external_lex_state = 6},
  [1029] = {.lex_state = 50, .external_lex_state = 6},
  [1030] = {.lex_state = 50, .external_lex_state = 6},
  [1031] = {.lex_state = 50, .external_lex_state = 6},
  [1032] = {.lex_state = 50, .external_lex_state = 6},
  [1033] = {.lex_state = 50, .external_lex_state = 6},
  [1034] = {.lex_state = 50, .external_lex_state = 6},
  [1035] = {.lex_state = 50, .external_lex_state = 6},
  [1036] = {.lex_state = 50, .external_lex_state = 6},
  [1037] = {.lex_state = 50, .external_lex_state = 6},
  [1038] = {.lex_state = 50, .external_lex_state = 6},
  [1039] = {.lex_state = 50, .external_lex_state = 6},
  [1040] = {.lex_state = 50, .external_lex_state = 6},
  [1041] = {.lex_state = 248, .external_lex_state = 3},
  [1042] = {.lex_state = 50, .external_lex_state = 6},
  [1043] = {.lex_state = 50, .external_lex_state = 6},
  [1044] = {.lex_state = 50, .external_lex_state = 6},
  [1045] = {.lex_state = 50, .external_lex_state = 6},
  [1046] = {.lex_state = 50, .external_lex_state = 6},
  [1047] = {.lex_state = 50, .external_lex_state = 6},
  [1048] = {.lex_state = 50, .external_lex_state = 6},
  [1049] = {.lex_state = 50, .external_lex_state = 6},
  [1050] = {.lex_state = 50, .external_lex_state = 6},
  [1051] = {.lex_state = 50, .external_lex_state = 6},
  [1052] = {.lex_state = 50, .external_lex_state = 6},
  [1053] = {.lex_state = 50, .external_lex_state = 6},
  [1054] = {.lex_state = 50, .external_lex_state = 6},
  [1055] = {.lex_state = 50, .external_lex_state = 6},
  [1056] = {.lex_state = 50, .external_lex_state = 6},
  [1057] = {.lex_state = 50, .external_lex_state = 6},
  [1058] = {.lex_state = 50, .external_lex_state = 6},
  [1059] = {.lex_state = 50, .external_lex_state = 6},
  [1060] = {.lex_state = 50, .external_lex_state = 6},
  [1061] = {.lex_state = 50, .external_lex_state = 6},
  [1062] = {.lex_state = 50, .external_lex_state = 6},
  [1063] = {.lex_state = 50, .external_lex_state = 6},
  [1064] = {.lex_state = 50, .external_lex_state = 6},
  [1065] = {.lex_state = 50, .external_lex_state = 6},
  [1066] = {.lex_state = 50, .external_lex_state = 6},
  [1067] = {.lex_state = 50, .external_lex_state = 6},
  [1068] = {.lex_state = 50, .external_lex_state = 6},
  [1069] = {.lex_state = 50, .external_lex_state = 6},
  [1070] = {.lex_state = 50, .external_lex_state = 6},
  [1071] = {.lex_state = 50, .external_lex_state = 6},
  [1072] = {.lex_state = 50, .external_lex_state = 6},
  [1073] = {.lex_state = 50, .external_lex_state = 6},
  [1074] = {.lex_state = 50, .external_lex_state = 6},
  [1075] = {.lex_state = 50, .external_lex_state = 6},
  [1076] = {.lex_state = 50, .external_lex_state = 6},
  [1077] = {.lex_state = 50, .external_lex_state = 6},
  [1078] = {.lex_state = 50, .external_lex_state = 6},
  [1079] = {.lex_state = 50, .external_lex_state = 6},
  [1080] = {.lex_state = 50, .external_lex_state = 6},
  [1081] = {.lex_state = 50, .external_lex_state = 6},
  [1082] = {.lex_state = 50, .external_lex_state = 6},
  [1083] = {.lex_state = 50, .external_lex_state = 6},
  [1084] = {.lex_state = 50, .external_lex_state = 6},
  [1085] = {.lex_state = 50, .external_lex_state = 6},
  [1086] = {.lex_state = 50, .external_lex_state = 6},
  [1087] = {.lex_state = 50, .external_lex_state = 6},
  [1088] = {.lex_state = 50, .external_lex_state = 6},
  [1089] = {.lex_state = 50, .external_lex_state = 6},
  [1090] = {.lex_state = 50, .external_lex_state = 6},
  [1091] = {.lex_state = 50, .external_lex_state = 6},
  [1092] = {.lex_state = 50, .external_lex_state = 6},
  [1093] = {.lex_state = 50, .external_lex_state = 6},
  [1094] = {.lex_state = 50, .external_lex_state = 6},
  [1095] = {.lex_state = 50, .external_lex_state = 6},
  [1096] = {.lex_state = 50, .external_lex_state = 6},
  [1097] = {.lex_state = 50, .external_lex_state = 6},
  [1098] = {.lex_state = 50, .external_lex_state = 6},
  [1099] = {.lex_state = 50, .external_lex_state = 6},
  [1100] = {.lex_state = 50, .external_lex_state = 6},
  [1101] = {.lex_state = 50, .external_lex_state = 6},
  [1102] = {.lex_state = 50, .external_lex_state = 6},
  [1103] = {.lex_state = 50, .external_lex_state = 6},
  [1104] = {.lex_state = 50, .external_lex_state = 6},
  [1105] = {.lex_state = 50, .external_lex_state = 6},
  [1106] = {.lex_state = 50, .external_lex_state = 6},
  [1107] = {.lex_state = 50, .external_lex_state = 6},
  [1108] = {.lex_state = 50, .external_lex_state = 6},
  [1109] = {.lex_state = 50, .external_lex_state = 6},
  [1110] = {.lex_state = 50, .external_lex_state = 6},
  [1111] = {.lex_state = 50, .external_lex_state = 6},
  [1112] = {.lex_state = 50, .external_lex_state = 6},
  [1113] = {.lex_state = 50, .external_lex_state = 6},
  [1114] = {.lex_state = 50, .external_lex_state = 6},
  [1115] = {.lex_state = 50, .external_lex_state = 6},
  [1116] = {.lex_state = 50, .external_lex_state = 6},
  [1117] = {.lex_state = 50, .external_lex_state = 6},
  [1118] = {.lex_state = 50, .external_lex_state = 6},
  [1119] = {.lex_state = 50, .external_lex_state = 6},
  [1120] = {.lex_state = 50, .external_lex_state = 6},
  [1121] = {.lex_state = 50, .external_lex_state = 6},
  [1122] = {.lex_state = 50, .external_lex_state = 6},
  [1123] = {.lex_state = 50, .external_lex_state = 6},
  [1124] = {.lex_state = 50, .external_lex_state = 6},
  [1125] = {.lex_state = 50, .external_lex_state = 6},
  [1126] = {.lex_state = 50, .external_lex_state = 6},
  [1127] = {.lex_state = 50, .external_lex_state = 6},
  [1128] = {.lex_state = 50, .external_lex_state = 6},
  [1129] = {.lex_state = 50, .external_lex_state = 6},
  [1130] = {.lex_state = 50, .external_lex_state = 6},
  [1131] = {.lex_state = 50, .external_lex_state = 6},
  [1132] = {.lex_state = 50, .external_lex_state = 6},
  [1133] = {.lex_state = 50, .external_lex_state = 6},
  [1134] = {.lex_state = 50, .external_lex_state = 6},
  [1135] = {.lex_state = 50, .external_lex_state = 6},
  [1136] = {.lex_state = 50, .external_lex_state = 6},
  [1137] = {.lex_state = 50, .external_lex_state = 6},
  [1138] = {.lex_state = 50, .external_lex_state = 6},
  [1139] = {.lex_state = 50, .external_lex_state = 6},
  [1140] = {.lex_state = 50, .external_lex_state = 6},
  [1141] = {.lex_state = 50, .external_lex_state = 6},
  [1142] = {.lex_state = 50, .external_lex_state = 6},
  [1143] = {.lex_state = 50, .external_lex_state = 7},
  [1144] = {.lex_state = 50, .external_lex_state = 7},
  [1145] = {.lex_state = 50, .external_lex_state = 7},
  [1146] = {.lex_state = 50, .external_lex_state = 7},
  [1147] = {.lex_state = 50, .external_lex_state = 7},
  [1148] = {.lex_state = 50, .external_lex_state = 7},
  [1149] = {.lex_state = 50, .external_lex_state = 7},
  [1150] = {.lex_state = 50, .external_lex_state = 7},
  [1151] = {.lex_state = 50, .external_lex_state = 7},
  [1152] = {.lex_state = 50, .external_lex_state = 7},
  [1153] = {.lex_state = 50, .external_lex_state = 7},
  [1154] = {.lex_state = 50, .external_lex_state = 7},
  [1155] = {.lex_state = 50, .external_lex_state = 7},
  [1156] = {.lex_state = 50, .external_lex_state = 7},
  [1157] = {.lex_state = 50, .external_lex_state = 7},
  [1158] = {.lex_state = 50, .external_lex_state = 7},
  [1159] = {.lex_state = 50, .external_lex_state = 7},
  [1160] = {.lex_state = 50, .external_lex_state = 7},
  [1161] = {.lex_state = 50, .external_lex_state = 7},
  [1162] = {.lex_state = 50, .external_lex_state = 7},
  [1163] = {.lex_state = 50, .external_lex_state = 7},
  [1164] = {.lex_state = 50, .external_lex_state = 7},
  [1165] = {.lex_state = 50, .external_lex_state = 7},
  [1166] = {.lex_state = 50, .external_lex_state = 7},
  [1167] = {.lex_state = 50, .external_lex_state = 7},
  [1168] = {.lex_state = 50, .external_lex_state = 7},
  [1169] = {.lex_state = 50, .external_lex_state = 7},
  [1170] = {.lex_state = 50, .external_lex_state = 7},
  [1171] = {.lex_state = 50, .external_lex_state = 7},
  [1172] = {.lex_state = 50, .external_lex_state = 7},
  [1173] = {.lex_state = 50, .external_lex_state = 7},
  [1174] = {.lex_state = 50, .external_lex_state = 7},
  [1175] = {.lex_state = 50, .external_lex_state = 7},
  [1176] = {.lex_state = 50, .external_lex_state = 7},
  [1177] = {.lex_state = 50, .external_lex_state = 7},
  [1178] = {.lex_state = 50, .external_lex_state = 7},
  [1179] = {.lex_state = 50, .external_lex_state = 7},
  [1180] = {.lex_state = 50, .external_lex_state = 7},
  [1181] = {.lex_state = 50, .external_lex_state = 7},
  [1182] = {.lex_state = 247, .external_lex_state = 8},
  [1183] = {.lex_state = 247, .external_lex_state = 8},
  [1184] = {.lex_state = 247, .external_lex_state = 8},
  [1185] = {.lex_state = 31, .external_lex_state = 5},
  [1186] = {.lex_state = 248, .external_lex_state = 8},
  [1187] = {.lex_state = 50, .external_lex_state = 7},
  [1188] = {.lex_state = 32, .external_lex_state = 5},
  [1189] = {.lex_state = 248, .external_lex_state = 8},
  [1190] = {.lex_state = 248, .external_lex_state = 8},
  [1191] = {.lex_state = 31, .external_lex_state = 5},
  [1192] = {.lex_state = 50, .external_lex_state = 7},
  [1193] = {.lex_state = 33, .external_lex_state = 5},
  [1194] = {.lex_state = 34, .external_lex_state = 5},
  [1195] = {.lex_state = 32, .external_lex_state = 5},
  [1196] = {.lex_state = 31, .external_lex_state = 5},
  [1197] = {.lex_state = 35, .external_lex_state = 5},
  [1198] = {.lex_state = 35, .external_lex_state = 6},
  [1199] = {.lex_state = 35, .external_lex_state = 6},
  [1200] = {.lex_state = 35, .external_lex_state = 6},
  [1201] = {.lex_state = 35, .external_lex_state = 5},
  [1202] = {.lex_state = 32, .external_lex_state = 6},
  [1203] = {.lex_state = 31, .external_lex_state = 6},
  [1204] = {.lex_state = 35, .external_lex_state = 6},
  [1205] = {.lex_state = 35, .external_lex_state = 6},
  [1206] = {.lex_state = 35, .external_lex_state = 6},
  [1207] = {.lex_state = 35, .external_lex_state = 6},
  [1208] = {.lex_state = 35, .external_lex_state = 6},
  [1209] = {.lex_state = 35, .external_lex_state = 6},
  [1210] = {.lex_state = 35, .external_lex_state = 6},
  [1211] = {.lex_state = 32, .external_lex_state = 6},
  [1212] = {.lex_state = 35, .external_lex_state = 6},
  [1213] = {.lex_state = 35, .external_lex_state = 6},
  [1214] = {.lex_state = 31, .external_lex_state = 7},
  [1215] = {.lex_state = 35, .external_lex_state = 6},
  [1216] = {.lex_state = 35, .external_lex_state = 6},
  [1217] = {.lex_state = 31, .external_lex_state = 6},
  [1218] = {.lex_state = 35, .external_lex_state = 6},
  [1219] = {.lex_state = 31, .external_lex_state = 7},
  [1220] = {.lex_state = 35, .external_lex_state = 5},
  [1221] = {.lex_state = 35, .external_lex_state = 6},
  [1222] = {.lex_state = 34, .external_lex_state = 5},
  [1223] = {.lex_state = 32, .external_lex_state = 7},
  [1224] = {.lex_state = 32, .external_lex_state = 7},
  [1225] = {.lex_state = 31, .external_lex_state = 7},
  [1226] = {.lex_state = 33, .external_lex_state = 7},
  [1227] = {.lex_state = 33, .external_lex_state = 7},
  [1228] = {.lex_state = 50, .external_lex_state = 7},
  [1229] = {.lex_state = 50, .external_lex_state = 7},
  [1230] = {.lex_state = 50, .external_lex_state = 7},
  [1231] = {.lex_state = 50, .external_lex_state = 7},
  [1232] = {.lex_state = 34, .external_lex_state = 7},
  [1233] = {.lex_state = 35, .external_lex_state = 7},
  [1234] = {.lex_state = 50, .external_lex_state = 7},
  [1235] = {.lex_state = 50, .external_lex_state = 7},
  [1236] = {.lex_state = 31, .external_lex_state = 5},
  [1237] = {.lex_state = 50, .external_lex_state = 7},
  [1238] = {.lex_state = 50, .external_lex_state = 7},
  [1239] = {.lex_state = 50, .external_lex_state = 7},
  [1240] = {.lex_state = 50, .external_lex_state = 7},
  [1241] = {.lex_state = 50, .external_lex_state = 7},
  [1242] = {.lex_state = 34, .external_lex_state = 7},
  [1243] = {.lex_state = 50, .external_lex_state = 7},
  [1244] = {.lex_state = 50, .external_lex_state = 7},
  [1245] = {.lex_state = 35, .external_lex_state = 7},
  [1246] = {.lex_state = 50, .external_lex_state = 7},
  [1247] = {.lex_state = 31, .external_lex_state = 5},
  [1248] = {.lex_state = 50, .external_lex_state = 7},
  [1249] = {.lex_state = 50, .external_lex_state = 7},
  [1250] = {.lex_state = 50, .external_lex_state = 7},
  [1251] = {.lex_state = 50, .external_lex_state = 7},
  [1252] = {.lex_state = 50, .external_lex_state = 7},
  [1253] = {.lex_state = 50, .external_lex_state = 7},
  [1254] = {.lex_state = 33, .external_lex_state = 5},
  [1255] = {.lex_state = 50, .external_lex_state = 7},
  [1256] = {.lex_state = 50, .external_lex_state = 7},
  [1257] = {.lex_state = 50, .external_lex_state = 7},
  [1258] = {.lex_state = 31, .external_lex_state = 5},
  [1259] = {.lex_state = 50, .external_lex_state = 7},
  [1260] = {.lex_state = 31, .external_lex_state = 5},
  [1261] = {.lex_state = 50, .external_lex_state = 7},
  [1262] = {.lex_state = 50, .external_lex_state = 7},
  [1263] = {.lex_state = 50, .external_lex_state = 7},
  [1264] = {.lex_state = 50, .external_lex_state = 7},
  [1265] = {.lex_state = 50, .external_lex_state = 7},
  [1266] = {.lex_state = 50, .external_lex_state = 7},
  [1267] = {.lex_state = 50, .external_lex_state = 7},
  [1268] = {.lex_state = 50, .external_lex_state = 7},
  [1269] = {.lex_state = 50, .external_lex_state = 7},
  [1270] = {.lex_state = 50, .external_lex_state = 7},
  [1271] = {.lex_state = 50, .external_lex_state = 7},
  [1272] = {.lex_state = 50, .external_lex_state = 7},
  [1273] = {.lex_state = 50, .external_lex_state = 7},
  [1274] = {.lex_state = 50, .external_lex_state = 7},
  [1275] = {.lex_state = 50, .external_lex_state = 7},
  [1276] = {.lex_state = 50, .external_lex_state = 7},
  [1277] = {.lex_state = 50, .external_lex_state = 7},
  [1278] = {.lex_state = 33, .external_lex_state = 5},
  [1279] = {.lex_state = 50, .external_lex_state = 7},
  [1280] = {.lex_state = 32, .external_lex_state = 5},
  [1281] = {.lex_state = 50, .external_lex_state = 7},
  [1282] = {.lex_state = 50, .external_lex_state = 7},
  [1283] = {.lex_state = 50, .external_lex_state = 7},
  [1284] = {.lex_state = 50, .external_lex_state = 7},
  [1285] = {.lex_state = 50, .external_lex_state = 7},
  [1286] = {.lex_state = 32, .external_lex_state = 5},
  [1287] = {.lex_state = 50, .external_lex_state = 7},
  [1288] = {.lex_state = 50, .external_lex_state = 7},
  [1289] = {.lex_state = 50, .external_lex_state = 7},
  [1290] = {.lex_state = 50, .external_lex_state = 7},
  [1291] = {.lex_state = 50, .external_lex_state = 7},
  [1292] = {.lex_state = 50, .external_lex_state = 7},
  [1293] = {.lex_state = 50, .external_lex_state = 7},
  [1294] = {.lex_state = 50, .external_lex_state = 7},
  [1295] = {.lex_state = 50, .external_lex_state = 7},
  [1296] = {.lex_state = 50, .external_lex_state = 7},
  [1297] = {.lex_state = 50, .external_lex_state = 7},
  [1298] = {.lex_state = 50, .external_lex_state = 7},
  [1299] = {.lex_state = 50, .external_lex_state = 7},
  [1300] = {.lex_state = 50, .external_lex_state = 7},
  [1301] = {.lex_state = 50, .external_lex_state = 7},
  [1302] = {.lex_state = 50, .external_lex_state = 7},
  [1303] = {.lex_state = 50, .external_lex_state = 7},
  [1304] = {.lex_state = 35, .external_lex_state = 5},
  [1305] = {.lex_state = 50, .external_lex_state = 7},
  [1306] = {.lex_state = 50, .external_lex_state = 7},
  [1307] = {.lex_state = 31, .external_lex_state = 5},
  [1308] = {.lex_state = 50, .external_lex_state = 7},
  [1309] = {.lex_state = 50, .external_lex_state = 7},
  [1310] = {.lex_state = 50, .external_lex_state = 7},
  [1311] = {.lex_state = 32, .external_lex_state = 5},
  [1312] = {.lex_state = 50, .external_lex_state = 7},
  [1313] = {.lex_state = 50, .external_lex_state = 7},
  [1314] = {.lex_state = 50, .external_lex_state = 7},
  [1315] = {.lex_state = 35, .external_lex_state = 5},
  [1316] = {.lex_state = 50, .external_lex_state = 7},
  [1317] = {.lex_state = 50, .external_lex_state = 7},
  [1318] = {.lex_state = 50, .external_lex_state = 7},
  [1319] = {.lex_state = 34, .external_lex_state = 5},
  [1320] = {.lex_state = 50, .external_lex_state = 7},
  [1321] = {.lex_state = 50, .external_lex_state = 7},
  [1322] = {.lex_state = 50, .external_lex_state = 7},
  [1323] = {.lex_state = 50, .external_lex_state = 7},
  [1324] = {.lex_state = 50, .external_lex_state = 7},
  [1325] = {.lex_state = 50, .external_lex_state = 7},
  [1326] = {.lex_state = 50, .external_lex_state = 7},
  [1327] = {.lex_state = 50, .external_lex_state = 7},
  [1328] = {.lex_state = 34, .external_lex_state = 5},
  [1329] = {.lex_state = 50, .external_lex_state = 7},
  [1330] = {.lex_state = 50, .external_lex_state = 7},
  [1331] = {.lex_state = 50, .external_lex_state = 7},
  [1332] = {.lex_state = 32, .external_lex_state = 6},
  [1333] = {.lex_state = 35, .external_lex_state = 5},
  [1334] = {.lex_state = 31, .external_lex_state = 6},
  [1335] = {.lex_state = 35, .external_lex_state = 5},
  [1336] = {.lex_state = 35, .external_lex_state = 5},
  [1337] = {.lex_state = 31, .external_lex_state = 7},
  [1338] = {.lex_state = 31, .external_lex_state = 7},
  [1339] = {.lex_state = 31, .external_lex_state = 7},
  [1340] = {.lex_state = 31, .external_lex_state = 6},
  [1341] = {.lex_state = 32, .external_lex_state = 6},
  [1342] = {.lex_state = 34, .external_lex_state = 5},
  [1343] = {.lex_state = 32, .external_lex_state = 6},
  [1344] = {.lex_state = 31, .external_lex_state = 6},
  [1345] = {.lex_state = 33, .external_lex_state = 7},
  [1346] = {.lex_state = 33, .external_lex_state = 7},
  [1347] = {.lex_state = 32, .external_lex_state = 7},
  [1348] = {.lex_state = 31, .external_lex_state = 7},
  [1349] = {.lex_state = 32, .external_lex_state = 7},
  [1350] = {.lex_state = 32, .external_lex_state = 7},
  [1351] = {.lex_state = 33, .external_lex_state = 7},
  [1352] = {.lex_state = 31, .external_lex_state = 7},
  [1353] = {.lex_state = 35, .external_lex_state = 7},
  [1354] = {.lex_state = 34, .external_lex_state = 7},
  [1355] = {.lex_state = 35, .external_lex_state = 7},
  [1356] = {.lex_state = 34, .external_lex_state = 7},
  [1357] = {.lex_state = 34, .external_lex_state = 7},
  [1358] = {.lex_state = 35, .external_lex_state = 7},
  [1359] = {.lex_state = 244, .external_lex_state = 3},
  [1360] = {.lex_state = 54, .external_lex_state = 7},
  [1361] = {.lex_state = 244, .external_lex_state = 3},
  [1362] = {.lex_state = 244, .external_lex_state = 3},
  [1363] = {.lex_state = 246, .external_lex_state = 3},
  [1364] = {.lex_state = 246, .external_lex_state = 3},
  [1365] = {.lex_state = 246, .external_lex_state = 3},
  [1366] = {.lex_state = 50, .external_lex_state = 7},
  [1367] = {.lex_state = 50, .external_lex_state = 7},
  [1368] = {.lex_state = 50, .external_lex_state = 7},
  [1369] = {.lex_state = 50, .external_lex_state = 7},
  [1370] = {.lex_state = 50, .external_lex_state = 7},
  [1371] = {.lex_state = 50, .external_lex_state = 7},
  [1372] = {.lex_state = 244, .external_lex_state = 8},
  [1373] = {.lex_state = 50, .external_lex_state = 7},
  [1374] = {.lex_state = 50, .external_lex_state = 7},
  [1375] = {.lex_state = 50, .external_lex_state = 7},
  [1376] = {.lex_state = 50, .external_lex_state = 7},
  [1377] = {.lex_state = 50, .external_lex_state = 7},
  [1378] = {.lex_state = 50, .external_lex_state = 7},
  [1379] = {.lex_state = 50, .external_lex_state = 7},
  [1380] = {.lex_state = 50, .external_lex_state = 7},
  [1381] = {.lex_state = 50, .external_lex_state = 7},
  [1382] = {.lex_state = 50, .external_lex_state = 7},
  [1383] = {.lex_state = 50, .external_lex_state = 7},
  [1384] = {.lex_state = 50, .external_lex_state = 7},
  [1385] = {.lex_state = 50, .external_lex_state = 7},
  [1386] = {.lex_state = 50, .external_lex_state = 7},
  [1387] = {.lex_state = 50, .external_lex_state = 7},
  [1388] = {.lex_state = 244, .external_lex_state = 8},
  [1389] = {.lex_state = 50, .external_lex_state = 7},
  [1390] = {.lex_state = 50, .external_lex_state = 7},
  [1391] = {.lex_state = 50, .external_lex_state = 7},
  [1392] = {.lex_state = 50, .external_lex_state = 7},
  [1393] = {.lex_state = 50, .external_lex_state = 7},
  [1394] = {.lex_state = 50, .external_lex_state = 7},
  [1395] = {.lex_state = 244, .external_lex_state = 8},
  [1396] = {.lex_state = 50, .external_lex_state = 7},
  [1397] = {.lex_state = 50, .external_lex_state = 7},
  [1398] = {.lex_state = 50, .external_lex_state = 7},
  [1399] = {.lex_state = 50, .external_lex_state = 7},
  [1400] = {.lex_state = 50, .external_lex_state = 7},
  [1401] = {.lex_state = 50, .external_lex_state = 7},
  [1402] = {.lex_state = 50, .external_lex_state = 7},
  [1403] = {.lex_state = 50, .external_lex_state = 7},
  [1404] = {.lex_state = 50, .external_lex_state = 7},
  [1405] = {.lex_state = 50, .external_lex_state = 7},
  [1406] = {.lex_state = 50, .external_lex_state = 7},
  [1407] = {.lex_state = 246, .external_lex_state = 8},
  [1408] = {.lex_state = 50, .external_lex_state = 7},
  [1409] = {.lex_state = 50, .external_lex_state = 7},
  [1410] = {.lex_state = 50, .external_lex_state = 7},
  [1411] = {.lex_state = 246, .external_lex_state = 8},
  [1412] = {.lex_state = 50, .external_lex_state = 7},
  [1413] = {.lex_state = 50, .external_lex_state = 7},
  [1414] = {.lex_state = 50, .external_lex_state = 7},
  [1415] = {.lex_state = 50, .external_lex_state = 7},
  [1416] = {.lex_state = 50, .external_lex_state = 7},
  [1417] = {.lex_state = 50, .external_lex_state = 7},
  [1418] = {.lex_state = 50, .external_lex_state = 7},
  [1419] = {.lex_state = 50, .external_lex_state = 7},
  [1420] = {.lex_state = 50, .external_lex_state = 7},
  [1421] = {.lex_state = 50, .external_lex_state = 7},
  [1422] = {.lex_state = 50, .external_lex_state = 7},
  [1423] = {.lex_state = 50, .external_lex_state = 7},
  [1424] = {.lex_state = 50, .external_lex_state = 7},
  [1425] = {.lex_state = 50, .external_lex_state = 7},
  [1426] = {.lex_state = 50, .external_lex_state = 7},
  [1427] = {.lex_state = 50, .external_lex_state = 7},
  [1428] = {.lex_state = 50, .external_lex_state = 7},
  [1429] = {.lex_state = 50, .external_lex_state = 7},
  [1430] = {.lex_state = 50, .external_lex_state = 7},
  [1431] = {.lex_state = 246, .external_lex_state = 8},
  [1432] = {.lex_state = 50, .external_lex_state = 7},
  [1433] = {.lex_state = 50, .external_lex_state = 7},
  [1434] = {.lex_state = 50, .external_lex_state = 7},
  [1435] = {.lex_state = 50, .external_lex_state = 7},
  [1436] = {.lex_state = 50, .external_lex_state = 7},
  [1437] = {.lex_state = 50, .external_lex_state = 7},
  [1438] = {.lex_state = 50, .external_lex_state = 7},
  [1439] = {.lex_state = 50, .external_lex_state = 7},
  [1440] = {.lex_state = 50, .external_lex_state = 7},
  [1441] = {.lex_state = 50, .external_lex_state = 7},
  [1442] = {.lex_state = 20, .external_lex_state = 5},
  [1443] = {.lex_state = 20, .external_lex_state = 5},
  [1444] = {.lex_state = 20, .external_lex_state = 5},
  [1445] = {.lex_state = 25, .external_lex_state = 5},
  [1446] = {.lex_state = 240, .external_lex_state = 3},
  [1447] = {.lex_state = 240, .external_lex_state = 3},
  [1448] = {.lex_state = 240, .external_lex_state = 3},
  [1449] = {.lex_state = 244, .external_lex_state = 11},
  [1450] = {.lex_state = 240, .external_lex_state = 3},
  [1451] = {.lex_state = 24, .external_lex_state = 5},
  [1452] = {.lex_state = 247, .external_lex_state = 3},
  [1453] = {.lex_state = 24, .external_lex_state = 5},
  [1454] = {.lex_state = 247, .external_lex_state = 3},
  [1455] = {.lex_state = 240, .external_lex_state = 3},
  [1456] = {.lex_state = 25, .external_lex_state = 5},
  [1457] = {.lex_state = 25, .external_lex_state = 5},
  [1458] = {.lex_state = 244, .external_lex_state = 11},
  [1459] = {.lex_state = 240, .external_lex_state = 3},
  [1460] = {.lex_state = 24, .external_lex_state = 5},
  [1461] = {.lex_state = 240, .external_lex_state = 3},
  [1462] = {.lex_state = 246, .external_lex_state = 11},
  [1463] = {.lex_state = 240, .external_lex_state = 3},
  [1464] = {.lex_state = 248, .external_lex_state = 3},
  [1465] = {.lex_state = 28, .external_lex_state = 5},
  [1466] = {.lex_state = 241, .external_lex_state = 3},
  [1467] = {.lex_state = 244, .external_lex_state = 12},
  [1468] = {.lex_state = 240, .external_lex_state = 3},
  [1469] = {.lex_state = 244, .external_lex_state = 12},
  [1470] = {.lex_state = 248, .external_lex_state = 3},
  [1471] = {.lex_state = 28, .external_lex_state = 5},
  [1472] = {.lex_state = 240, .external_lex_state = 3},
  [1473] = {.lex_state = 246, .external_lex_state = 11},
  [1474] = {.lex_state = 28, .external_lex_state = 5},
  [1475] = {.lex_state = 24, .external_lex_state = 6},
  [1476] = {.lex_state = 20, .external_lex_state = 7},
  [1477] = {.lex_state = 244, .external_lex_state = 3},
  [1478] = {.lex_state = 24, .external_lex_state = 6},
  [1479] = {.lex_state = 244, .external_lex_state = 3},
  [1480] = {.lex_state = 20, .external_lex_state = 6},
  [1481] = {.lex_state = 23, .external_lex_state = 6},
  [1482] = {.lex_state = 241, .external_lex_state = 3},
  [1483] = {.lex_state = 29, .external_lex_state = 5},
  [1484] = {.lex_state = 246, .external_lex_state = 12},
  [1485] = {.lex_state = 240, .external_lex_state = 3},
  [1486] = {.lex_state = 20, .external_lex_state = 7},
  [1487] = {.lex_state = 241, .external_lex_state = 3},
  [1488] = {.lex_state = 240, .external_lex_state = 3},
  [1489] = {.lex_state = 244, .external_lex_state = 3},
  [1490] = {.lex_state = 244, .external_lex_state = 3},
  [1491] = {.lex_state = 244, .external_lex_state = 3},
  [1492] = {.lex_state = 24, .external_lex_state = 6},
  [1493] = {.lex_state = 20, .external_lex_state = 6},
  [1494] = {.lex_state = 241, .external_lex_state = 3},
  [1495] = {.lex_state = 244, .external_lex_state = 3},
  [1496] = {.lex_state = 244, .external_lex_state = 3},
  [1497] = {.lex_state = 20, .external_lex_state = 6},
  [1498] = {.lex_state = 29, .external_lex_state = 5},
  [1499] = {.lex_state = 244, .external_lex_state = 3},
  [1500] = {.lex_state = 244, .external_lex_state = 3},
  [1501] = {.lex_state = 244, .external_lex_state = 3},
  [1502] = {.lex_state = 246, .external_lex_state = 12},
  [1503] = {.lex_state = 244, .external_lex_state = 3},
  [1504] = {.lex_state = 23, .external_lex_state = 7},
  [1505] = {.lex_state = 244, .external_lex_state = 3},
  [1506] = {.lex_state = 20, .external_lex_state = 7},
  [1507] = {.lex_state = 29, .external_lex_state = 5},
  [1508] = {.lex_state = 240, .external_lex_state = 8},
  [1509] = {.lex_state = 24, .external_lex_state = 7},
  [1510] = {.lex_state = 247, .external_lex_state = 11},
  [1511] = {.lex_state = 246, .external_lex_state = 3},
  [1512] = {.lex_state = 244, .external_lex_state = 13},
  [1513] = {.lex_state = 241, .external_lex_state = 3},
  [1514] = {.lex_state = 247, .external_lex_state = 3},
  [1515] = {.lex_state = 246, .external_lex_state = 3},
  [1516] = {.lex_state = 24, .external_lex_state = 7},
  [1517] = {.lex_state = 24, .external_lex_state = 7},
  [1518] = {.lex_state = 240, .external_lex_state = 8},
  [1519] = {.lex_state = 25, .external_lex_state = 7},
  [1520] = {.lex_state = 246, .external_lex_state = 3},
  [1521] = {.lex_state = 246, .external_lex_state = 3},
  [1522] = {.lex_state = 25, .external_lex_state = 7},
  [1523] = {.lex_state = 240, .external_lex_state = 8},
  [1524] = {.lex_state = 244, .external_lex_state = 13},
  [1525] = {.lex_state = 247, .external_lex_state = 8},
  [1526] = {.lex_state = 242, .external_lex_state = 3},
  [1527] = {.lex_state = 25, .external_lex_state = 7},
  [1528] = {.lex_state = 247, .external_lex_state = 8},
  [1529] = {.lex_state = 246, .external_lex_state = 3},
  [1530] = {.lex_state = 246, .external_lex_state = 3},
  [1531] = {.lex_state = 240, .external_lex_state = 8},
  [1532] = {.lex_state = 246, .external_lex_state = 3},
  [1533] = {.lex_state = 246, .external_lex_state = 3},
  [1534] = {.lex_state = 246, .external_lex_state = 3},
  [1535] = {.lex_state = 241, .external_lex_state = 3},
  [1536] = {.lex_state = 240, .external_lex_state = 8},
  [1537] = {.lex_state = 240, .external_lex_state = 8},
  [1538] = {.lex_state = 246, .external_lex_state = 3},
  [1539] = {.lex_state = 246, .external_lex_state = 3},
  [1540] = {.lex_state = 246, .external_lex_state = 3},
  [1541] = {.lex_state = 247, .external_lex_state = 11},
  [1542] = {.lex_state = 247, .external_lex_state = 3},
  [1543] = {.lex_state = 247, .external_lex_state = 3},
  [1544] = {.lex_state = 248, .external_lex_state = 8},
  [1545] = {.lex_state = 248, .external_lex_state = 8},
  [1546] = {.lex_state = 248, .external_lex_state = 3},
  [1547] = {.lex_state = 248, .external_lex_state = 11},
  [1548] = {.lex_state = 247, .external_lex_state = 3},
  [1549] = {.lex_state = 244, .external_lex_state = 3},
  [1550] = {.lex_state = 244, .external_lex_state = 3},
  [1551] = {.lex_state = 243, .external_lex_state = 3},
  [1552] = {.lex_state = 240, .external_lex_state = 8},
  [1553] = {.lex_state = 247, .external_lex_state = 3},
  [1554] = {.lex_state = 28, .external_lex_state = 7},
  [1555] = {.lex_state = 240, .external_lex_state = 8},
  [1556] = {.lex_state = 244, .external_lex_state = 3},
  [1557] = {.lex_state = 244, .external_lex_state = 3},
  [1558] = {.lex_state = 247, .external_lex_state = 3},
  [1559] = {.lex_state = 247, .external_lex_state = 12},
  [1560] = {.lex_state = 242, .external_lex_state = 3},
  [1561] = {.lex_state = 247, .external_lex_state = 3},
  [1562] = {.lex_state = 247, .external_lex_state = 3},
  [1563] = {.lex_state = 247, .external_lex_state = 12},
  [1564] = {.lex_state = 247, .external_lex_state = 3},
  [1565] = {.lex_state = 247, .external_lex_state = 3},
  [1566] = {.lex_state = 244, .external_lex_state = 3},
  [1567] = {.lex_state = 247, .external_lex_state = 3},
  [1568] = {.lex_state = 247, .external_lex_state = 3},
  [1569] = {.lex_state = 247, .external_lex_state = 3},
  [1570] = {.lex_state = 247, .external_lex_state = 3},
  [1571] = {.lex_state = 247, .external_lex_state = 3},
  [1572] = {.lex_state = 247, .external_lex_state = 3},
  [1573] = {.lex_state = 247, .external_lex_state = 3},
  [1574] = {.lex_state = 247, .external_lex_state = 3},
  [1575] = {.lex_state = 247, .external_lex_state = 3},
  [1576] = {.lex_state = 247, .external_lex_state = 3},
  [1577] = {.lex_state = 242, .external_lex_state = 3},
  [1578] = {.lex_state = 247, .external_lex_state = 3},
  [1579] = {.lex_state = 242, .external_lex_state = 3},
  [1580] = {.lex_state = 246, .external_lex_state = 13},
  [1581] = {.lex_state = 247, .external_lex_state = 3},
  [1582] = {.lex_state = 248, .external_lex_state = 11},
  [1583] = {.lex_state = 246, .external_lex_state = 13},
  [1584] = {.lex_state = 247, .external_lex_state = 3},
  [1585] = {.lex_state = 247, .external_lex_state = 3},
  [1586] = {.lex_state = 244, .external_lex_state = 14},
  [1587] = {.lex_state = 247, .external_lex_state = 3},
  [1588] = {.lex_state = 247, .external_lex_state = 3},
  [1589] = {.lex_state = 240, .external_lex_state = 8},
  [1590] = {.lex_state = 247, .external_lex_state = 3},
  [1591] = {.lex_state = 244, .external_lex_state = 14},
  [1592] = {.lex_state = 28, .external_lex_state = 7},
  [1593] = {.lex_state = 247, .external_lex_state = 3},
  [1594] = {.lex_state = 241, .external_lex_state = 8},
  [1595] = {.lex_state = 247, .external_lex_state = 3},
  [1596] = {.lex_state = 247, .external_lex_state = 3},
  [1597] = {.lex_state = 247, .external_lex_state = 3},
  [1598] = {.lex_state = 247, .external_lex_state = 3},
  [1599] = {.lex_state = 28, .external_lex_state = 7},
  [1600] = {.lex_state = 247, .external_lex_state = 3},
  [1601] = {.lex_state = 247, .external_lex_state = 3},
  [1602] = {.lex_state = 247, .external_lex_state = 3},
  [1603] = {.lex_state = 247, .external_lex_state = 3},
  [1604] = {.lex_state = 247, .external_lex_state = 3},
  [1605] = {.lex_state = 247, .external_lex_state = 3},
  [1606] = {.lex_state = 240, .external_lex_state = 8},
  [1607] = {.lex_state = 247, .external_lex_state = 3},
  [1608] = {.lex_state = 248, .external_lex_state = 3},
  [1609] = {.lex_state = 247, .external_lex_state = 3},
  [1610] = {.lex_state = 247, .external_lex_state = 3},
  [1611] = {.lex_state = 247, .external_lex_state = 3},
  [1612] = {.lex_state = 247, .external_lex_state = 3},
  [1613] = {.lex_state = 247, .external_lex_state = 3},
  [1614] = {.lex_state = 247, .external_lex_state = 3},
  [1615] = {.lex_state = 247, .external_lex_state = 3},
  [1616] = {.lex_state = 247, .external_lex_state = 3},
  [1617] = {.lex_state = 247, .external_lex_state = 3},
  [1618] = {.lex_state = 247, .external_lex_state = 3},
  [1619] = {.lex_state = 247, .external_lex_state = 3},
  [1620] = {.lex_state = 247, .external_lex_state = 3},
  [1621] = {.lex_state = 247, .external_lex_state = 3},
  [1622] = {.lex_state = 29, .external_lex_state = 7},
  [1623] = {.lex_state = 247, .external_lex_state = 3},
  [1624] = {.lex_state = 247, .external_lex_state = 3},
  [1625] = {.lex_state = 247, .external_lex_state = 3},
  [1626] = {.lex_state = 247, .external_lex_state = 3},
  [1627] = {.lex_state = 29, .external_lex_state = 7},
  [1628] = {.lex_state = 248, .external_lex_state = 3},
  [1629] = {.lex_state = 247, .external_lex_state = 3},
  [1630] = {.lex_state = 247, .external_lex_state = 3},
  [1631] = {.lex_state = 244, .external_lex_state = 8},
  [1632] = {.lex_state = 240, .external_lex_state = 8},
  [1633] = {.lex_state = 29, .external_lex_state = 7},
  [1634] = {.lex_state = 247, .external_lex_state = 3},
  [1635] = {.lex_state = 247, .external_lex_state = 3},
  [1636] = {.lex_state = 244, .external_lex_state = 8},
  [1637] = {.lex_state = 247, .external_lex_state = 3},
  [1638] = {.lex_state = 247, .external_lex_state = 3},
  [1639] = {.lex_state = 244, .external_lex_state = 8},
  [1640] = {.lex_state = 247, .external_lex_state = 3},
  [1641] = {.lex_state = 246, .external_lex_state = 14},
  [1642] = {.lex_state = 247, .external_lex_state = 3},
  [1643] = {.lex_state = 247, .external_lex_state = 3},
  [1644] = {.lex_state = 244, .external_lex_state = 8},
  [1645] = {.lex_state = 247, .external_lex_state = 3},
  [1646] = {.lex_state = 247, .external_lex_state = 3},
  [1647] = {.lex_state = 247, .external_lex_state = 3},
  [1648] = {.lex_state = 248, .external_lex_state = 3},
  [1649] = {.lex_state = 248, .external_lex_state = 3},
  [1650] = {.lex_state = 247, .external_lex_state = 3},
  [1651] = {.lex_state = 247, .external_lex_state = 3},
  [1652] = {.lex_state = 247, .external_lex_state = 3},
  [1653] = {.lex_state = 248, .external_lex_state = 3},
  [1654] = {.lex_state = 247, .external_lex_state = 3},
  [1655] = {.lex_state = 248, .external_lex_state = 3},
  [1656] = {.lex_state = 248, .external_lex_state = 3},
  [1657] = {.lex_state = 248, .external_lex_state = 3},
  [1658] = {.lex_state = 247, .external_lex_state = 3},
  [1659] = {.lex_state = 247, .external_lex_state = 3},
  [1660] = {.lex_state = 247, .external_lex_state = 3},
  [1661] = {.lex_state = 246, .external_lex_state = 14},
  [1662] = {.lex_state = 247, .external_lex_state = 3},
  [1663] = {.lex_state = 247, .external_lex_state = 3},
  [1664] = {.lex_state = 247, .external_lex_state = 3},
  [1665] = {.lex_state = 247, .external_lex_state = 3},
  [1666] = {.lex_state = 247, .external_lex_state = 3},
  [1667] = {.lex_state = 246, .external_lex_state = 3},
  [1668] = {.lex_state = 247, .external_lex_state = 3},
  [1669] = {.lex_state = 248, .external_lex_state = 3},
  [1670] = {.lex_state = 247, .external_lex_state = 3},
  [1671] = {.lex_state = 248, .external_lex_state = 3},
  [1672] = {.lex_state = 248, .external_lex_state = 3},
  [1673] = {.lex_state = 247, .external_lex_state = 3},
  [1674] = {.lex_state = 248, .external_lex_state = 3},
  [1675] = {.lex_state = 247, .external_lex_state = 3},
  [1676] = {.lex_state = 248, .external_lex_state = 3},
  [1677] = {.lex_state = 247, .external_lex_state = 3},
  [1678] = {.lex_state = 247, .external_lex_state = 3},
  [1679] = {.lex_state = 247, .external_lex_state = 3},
  [1680] = {.lex_state = 247, .external_lex_state = 3},
  [1681] = {.lex_state = 247, .external_lex_state = 3},
  [1682] = {.lex_state = 248, .external_lex_state = 12},
  [1683] = {.lex_state = 247, .external_lex_state = 3},
  [1684] = {.lex_state = 247, .external_lex_state = 3},
  [1685] = {.lex_state = 247, .external_lex_state = 3},
  [1686] = {.lex_state = 247, .external_lex_state = 3},
  [1687] = {.lex_state = 247, .external_lex_state = 3},
  [1688] = {.lex_state = 247, .external_lex_state = 3},
  [1689] = {.lex_state = 241, .external_lex_state = 8},
  [1690] = {.lex_state = 247, .external_lex_state = 3},
  [1691] = {.lex_state = 248, .external_lex_state = 3},
  [1692] = {.lex_state = 248, .external_lex_state = 3},
  [1693] = {.lex_state = 248, .external_lex_state = 3},
  [1694] = {.lex_state = 248, .external_lex_state = 3},
  [1695] = {.lex_state = 247, .external_lex_state = 3},
  [1696] = {.lex_state = 248, .external_lex_state = 3},
  [1697] = {.lex_state = 248, .external_lex_state = 3},
  [1698] = {.lex_state = 247, .external_lex_state = 3},
  [1699] = {.lex_state = 247, .external_lex_state = 3},
  [1700] = {.lex_state = 247, .external_lex_state = 3},
  [1701] = {.lex_state = 241, .external_lex_state = 8},
  [1702] = {.lex_state = 247, .external_lex_state = 3},
  [1703] = {.lex_state = 247, .external_lex_state = 3},
  [1704] = {.lex_state = 248, .external_lex_state = 3},
  [1705] = {.lex_state = 247, .external_lex_state = 3},
  [1706] = {.lex_state = 247, .external_lex_state = 3},
  [1707] = {.lex_state = 247, .external_lex_state = 3},
  [1708] = {.lex_state = 247, .external_lex_state = 3},
  [1709] = {.lex_state = 248, .external_lex_state = 3},
  [1710] = {.lex_state = 247, .external_lex_state = 3},
  [1711] = {.lex_state = 241, .external_lex_state = 8},
  [1712] = {.lex_state = 246, .external_lex_state = 3},
  [1713] = {.lex_state = 243, .external_lex_state = 3},
  [1714] = {.lex_state = 247, .external_lex_state = 3},
  [1715] = {.lex_state = 247, .external_lex_state = 3},
  [1716] = {.lex_state = 248, .external_lex_state = 3},
  [1717] = {.lex_state = 248, .external_lex_state = 3},
  [1718] = {.lex_state = 247, .external_lex_state = 3},
  [1719] = {.lex_state = 247, .external_lex_state = 3},
  [1720] = {.lex_state = 247, .external_lex_state = 3},
  [1721] = {.lex_state = 247, .external_lex_state = 3},
  [1722] = {.lex_state = 248, .external_lex_state = 3},
  [1723] = {.lex_state = 248, .external_lex_state = 3},
  [1724] = {.lex_state = 247, .external_lex_state = 3},
  [1725] = {.lex_state = 247, .external_lex_state = 3},
  [1726] = {.lex_state = 248, .external_lex_state = 3},
  [1727] = {.lex_state = 247, .external_lex_state = 3},
  [1728] = {.lex_state = 247, .external_lex_state = 3},
  [1729] = {.lex_state = 248, .external_lex_state = 3},
  [1730] = {.lex_state = 247, .external_lex_state = 3},
  [1731] = {.lex_state = 247, .external_lex_state = 3},
  [1732] = {.lex_state = 247, .external_lex_state = 3},
  [1733] = {.lex_state = 247, .external_lex_state = 3},
  [1734] = {.lex_state = 247, .external_lex_state = 3},
  [1735] = {.lex_state = 247, .external_lex_state = 3},
  [1736] = {.lex_state = 247, .external_lex_state = 3},
  [1737] = {.lex_state = 248, .external_lex_state = 3},
  [1738] = {.lex_state = 246, .external_lex_state = 3},
  [1739] = {.lex_state = 247, .external_lex_state = 3},
  [1740] = {.lex_state = 247, .external_lex_state = 3},
  [1741] = {.lex_state = 247, .external_lex_state = 3},
  [1742] = {.lex_state = 247, .external_lex_state = 3},
  [1743] = {.lex_state = 240, .external_lex_state = 8},
  [1744] = {.lex_state = 248, .external_lex_state = 3},
  [1745] = {.lex_state = 247, .external_lex_state = 3},
  [1746] = {.lex_state = 247, .external_lex_state = 3},
  [1747] = {.lex_state = 248, .external_lex_state = 3},
  [1748] = {.lex_state = 247, .external_lex_state = 3},
  [1749] = {.lex_state = 248, .external_lex_state = 3},
  [1750] = {.lex_state = 248, .external_lex_state = 12},
  [1751] = {.lex_state = 247, .external_lex_state = 3},
  [1752] = {.lex_state = 247, .external_lex_state = 3},
  [1753] = {.lex_state = 247, .external_lex_state = 3},
  [1754] = {.lex_state = 247, .external_lex_state = 3},
  [1755] = {.lex_state = 247, .external_lex_state = 3},
  [1756] = {.lex_state = 248, .external_lex_state = 3},
  [1757] = {.lex_state = 247, .external_lex_state = 3},
  [1758] = {.lex_state = 243, .external_lex_state = 3},
  [1759] = {.lex_state = 244, .external_lex_state = 8},
  [1760] = {.lex_state = 247, .external_lex_state = 3},
  [1761] = {.lex_state = 247, .external_lex_state = 3},
  [1762] = {.lex_state = 247, .external_lex_state = 3},
  [1763] = {.lex_state = 247, .external_lex_state = 3},
  [1764] = {.lex_state = 243, .external_lex_state = 3},
  [1765] = {.lex_state = 247, .external_lex_state = 3},
  [1766] = {.lex_state = 247, .external_lex_state = 3},
  [1767] = {.lex_state = 247, .external_lex_state = 3},
  [1768] = {.lex_state = 244, .external_lex_state = 8},
  [1769] = {.lex_state = 246, .external_lex_state = 3},
  [1770] = {.lex_state = 247, .external_lex_state = 3},
  [1771] = {.lex_state = 244, .external_lex_state = 8},
  [1772] = {.lex_state = 244, .external_lex_state = 8},
  [1773] = {.lex_state = 247, .external_lex_state = 3},
  [1774] = {.lex_state = 247, .external_lex_state = 3},
  [1775] = {.lex_state = 247, .external_lex_state = 3},
  [1776] = {.lex_state = 244, .external_lex_state = 8},
  [1777] = {.lex_state = 247, .external_lex_state = 3},
  [1778] = {.lex_state = 247, .external_lex_state = 3},
  [1779] = {.lex_state = 247, .external_lex_state = 3},
  [1780] = {.lex_state = 244, .external_lex_state = 8},
  [1781] = {.lex_state = 247, .external_lex_state = 3},
  [1782] = {.lex_state = 247, .external_lex_state = 3},
  [1783] = {.lex_state = 247, .external_lex_state = 3},
  [1784] = {.lex_state = 247, .external_lex_state = 3},
  [1785] = {.lex_state = 248, .external_lex_state = 3},
  [1786] = {.lex_state = 248, .external_lex_state = 3},
  [1787] = {.lex_state = 247, .external_lex_state = 3},
  [1788] = {.lex_state = 247, .external_lex_state = 3},
  [1789] = {.lex_state = 247, .external_lex_state = 3},
  [1790] = {.lex_state = 247, .external_lex_state = 3},
  [1791] = {.lex_state = 247, .external_lex_state = 3},
  [1792] = {.lex_state = 247, .external_lex_state = 3},
  [1793] = {.lex_state = 248, .external_lex_state = 3},
  [1794] = {.lex_state = 247, .external_lex_state = 3},
  [1795] = {.lex_state = 248, .external_lex_state = 3},
  [1796] = {.lex_state = 244, .external_lex_state = 8},
  [1797] = {.lex_state = 247, .external_lex_state = 3},
  [1798] = {.lex_state = 247, .external_lex_state = 3},
  [1799] = {.lex_state = 244, .external_lex_state = 8},
  [1800] = {.lex_state = 246, .external_lex_state = 3},
  [1801] = {.lex_state = 247, .external_lex_state = 3},
  [1802] = {.lex_state = 247, .external_lex_state = 3},
  [1803] = {.lex_state = 247, .external_lex_state = 3},
  [1804] = {.lex_state = 247, .external_lex_state = 3},
  [1805] = {.lex_state = 247, .external_lex_state = 3},
  [1806] = {.lex_state = 247, .external_lex_state = 3},
  [1807] = {.lex_state = 246, .external_lex_state = 8},
  [1808] = {.lex_state = 248, .external_lex_state = 3},
  [1809] = {.lex_state = 248, .external_lex_state = 3},
  [1810] = {.lex_state = 248, .external_lex_state = 3},
  [1811] = {.lex_state = 248, .external_lex_state = 3},
  [1812] = {.lex_state = 248, .external_lex_state = 3},
  [1813] = {.lex_state = 248, .external_lex_state = 3},
  [1814] = {.lex_state = 248, .external_lex_state = 3},
  [1815] = {.lex_state = 248, .external_lex_state = 3},
  [1816] = {.lex_state = 248, .external_lex_state = 3},
  [1817] = {.lex_state = 248, .external_lex_state = 3},
  [1818] = {.lex_state = 248, .external_lex_state = 3},
  [1819] = {.lex_state = 248, .external_lex_state = 3},
  [1820] = {.lex_state = 248, .external_lex_state = 3},
  [1821] = {.lex_state = 248, .external_lex_state = 3},
  [1822] = {.lex_state = 248, .external_lex_state = 3},
  [1823] = {.lex_state = 248, .external_lex_state = 3},
  [1824] = {.lex_state = 248, .external_lex_state = 3},
  [1825] = {.lex_state = 248, .external_lex_state = 3},
  [1826] = {.lex_state = 248, .external_lex_state = 3},
  [1827] = {.lex_state = 248, .external_lex_state = 3},
  [1828] = {.lex_state = 248, .external_lex_state = 3},
  [1829] = {.lex_state = 248, .external_lex_state = 3},
  [1830] = {.lex_state = 248, .external_lex_state = 3},
  [1831] = {.lex_state = 248, .external_lex_state = 3},
  [1832] = {.lex_state = 248, .external_lex_state = 3},
  [1833] = {.lex_state = 248, .external_lex_state = 3},
  [1834] = {.lex_state = 248, .external_lex_state = 3},
  [1835] = {.lex_state = 248, .external_lex_state = 3},
  [1836] = {.lex_state = 248, .external_lex_state = 3},
  [1837] = {.lex_state = 248, .external_lex_state = 3},
  [1838] = {.lex_state = 248, .external_lex_state = 3},
  [1839] = {.lex_state = 248, .external_lex_state = 3},
  [1840] = {.lex_state = 248, .external_lex_state = 3},
  [1841] = {.lex_state = 248, .external_lex_state = 3},
  [1842] = {.lex_state = 248, .external_lex_state = 3},
  [1843] = {.lex_state = 248, .external_lex_state = 3},
  [1844] = {.lex_state = 248, .external_lex_state = 3},
  [1845] = {.lex_state = 248, .external_lex_state = 3},
  [1846] = {.lex_state = 14, .external_lex_state = 6},
  [1847] = {.lex_state = 248, .external_lex_state = 3},
  [1848] = {.lex_state = 248, .external_lex_state = 3},
  [1849] = {.lex_state = 248, .external_lex_state = 3},
  [1850] = {.lex_state = 248, .external_lex_state = 3},
  [1851] = {.lex_state = 248, .external_lex_state = 3},
  [1852] = {.lex_state = 248, .external_lex_state = 3},
  [1853] = {.lex_state = 248, .external_lex_state = 3},
  [1854] = {.lex_state = 248, .external_lex_state = 3},
  [1855] = {.lex_state = 242, .external_lex_state = 8},
  [1856] = {.lex_state = 248, .external_lex_state = 3},
  [1857] = {.lex_state = 248, .external_lex_state = 3},
  [1858] = {.lex_state = 248, .external_lex_state = 3},
  [1859] = {.lex_state = 248, .external_lex_state = 3},
  [1860] = {.lex_state = 248, .external_lex_state = 3},
  [1861] = {.lex_state = 248, .external_lex_state = 3},
  [1862] = {.lex_state = 246, .external_lex_state = 8},
  [1863] = {.lex_state = 248, .external_lex_state = 3},
  [1864] = {.lex_state = 248, .external_lex_state = 3},
  [1865] = {.lex_state = 248, .external_lex_state = 3},
  [1866] = {.lex_state = 248, .external_lex_state = 3},
  [1867] = {.lex_state = 14, .external_lex_state = 7},
  [1868] = {.lex_state = 246, .external_lex_state = 8},
  [1869] = {.lex_state = 248, .external_lex_state = 3},
  [1870] = {.lex_state = 248, .external_lex_state = 3},
  [1871] = {.lex_state = 248, .external_lex_state = 3},
  [1872] = {.lex_state = 248, .external_lex_state = 3},
  [1873] = {.lex_state = 248, .external_lex_state = 3},
  [1874] = {.lex_state = 248, .external_lex_state = 3},
  [1875] = {.lex_state = 248, .external_lex_state = 3},
  [1876] = {.lex_state = 246, .external_lex_state = 8},
  [1877] = {.lex_state = 248, .external_lex_state = 3},
  [1878] = {.lex_state = 248, .external_lex_state = 3},
  [1879] = {.lex_state = 248, .external_lex_state = 3},
  [1880] = {.lex_state = 246, .external_lex_state = 8},
  [1881] = {.lex_state = 248, .external_lex_state = 3},
  [1882] = {.lex_state = 246, .external_lex_state = 8},
  [1883] = {.lex_state = 248, .external_lex_state = 3},
  [1884] = {.lex_state = 248, .external_lex_state = 3},
  [1885] = {.lex_state = 248, .external_lex_state = 3},
  [1886] = {.lex_state = 248, .external_lex_state = 3},
  [1887] = {.lex_state = 248, .external_lex_state = 3},
  [1888] = {.lex_state = 248, .external_lex_state = 3},
  [1889] = {.lex_state = 248, .external_lex_state = 3},
  [1890] = {.lex_state = 248, .external_lex_state = 3},
  [1891] = {.lex_state = 248, .external_lex_state = 3},
  [1892] = {.lex_state = 248, .external_lex_state = 3},
  [1893] = {.lex_state = 248, .external_lex_state = 3},
  [1894] = {.lex_state = 248, .external_lex_state = 3},
  [1895] = {.lex_state = 248, .external_lex_state = 3},
  [1896] = {.lex_state = 246, .external_lex_state = 8},
  [1897] = {.lex_state = 248, .external_lex_state = 3},
  [1898] = {.lex_state = 248, .external_lex_state = 3},
  [1899] = {.lex_state = 248, .external_lex_state = 3},
  [1900] = {.lex_state = 248, .external_lex_state = 3},
  [1901] = {.lex_state = 248, .external_lex_state = 3},
  [1902] = {.lex_state = 248, .external_lex_state = 3},
  [1903] = {.lex_state = 248, .external_lex_state = 3},
  [1904] = {.lex_state = 248, .external_lex_state = 3},
  [1905] = {.lex_state = 248, .external_lex_state = 3},
  [1906] = {.lex_state = 248, .external_lex_state = 3},
  [1907] = {.lex_state = 246, .external_lex_state = 8},
  [1908] = {.lex_state = 248, .external_lex_state = 3},
  [1909] = {.lex_state = 248, .external_lex_state = 3},
  [1910] = {.lex_state = 248, .external_lex_state = 3},
  [1911] = {.lex_state = 248, .external_lex_state = 3},
  [1912] = {.lex_state = 248, .external_lex_state = 3},
  [1913] = {.lex_state = 248, .external_lex_state = 3},
  [1914] = {.lex_state = 248, .external_lex_state = 3},
  [1915] = {.lex_state = 248, .external_lex_state = 3},
  [1916] = {.lex_state = 248, .external_lex_state = 3},
  [1917] = {.lex_state = 248, .external_lex_state = 3},
  [1918] = {.lex_state = 248, .external_lex_state = 3},
  [1919] = {.lex_state = 248, .external_lex_state = 3},
  [1920] = {.lex_state = 248, .external_lex_state = 3},
  [1921] = {.lex_state = 248, .external_lex_state = 3},
  [1922] = {.lex_state = 248, .external_lex_state = 3},
  [1923] = {.lex_state = 248, .external_lex_state = 3},
  [1924] = {.lex_state = 247, .external_lex_state = 13},
  [1925] = {.lex_state = 248, .external_lex_state = 3},
  [1926] = {.lex_state = 248, .external_lex_state = 3},
  [1927] = {.lex_state = 248, .external_lex_state = 3},
  [1928] = {.lex_state = 248, .external_lex_state = 3},
  [1929] = {.lex_state = 248, .external_lex_state = 3},
  [1930] = {.lex_state = 248, .external_lex_state = 3},
  [1931] = {.lex_state = 248, .external_lex_state = 3},
  [1932] = {.lex_state = 248, .external_lex_state = 3},
  [1933] = {.lex_state = 248, .external_lex_state = 3},
  [1934] = {.lex_state = 246, .external_lex_state = 8},
  [1935] = {.lex_state = 248, .external_lex_state = 3},
  [1936] = {.lex_state = 248, .external_lex_state = 3},
  [1937] = {.lex_state = 248, .external_lex_state = 3},
  [1938] = {.lex_state = 246, .external_lex_state = 8},
  [1939] = {.lex_state = 248, .external_lex_state = 3},
  [1940] = {.lex_state = 248, .external_lex_state = 3},
  [1941] = {.lex_state = 247, .external_lex_state = 8},
  [1942] = {.lex_state = 248, .external_lex_state = 3},
  [1943] = {.lex_state = 241, .external_lex_state = 8},
  [1944] = {.lex_state = 247, .external_lex_state = 13},
  [1945] = {.lex_state = 248, .external_lex_state = 3},
  [1946] = {.lex_state = 246, .external_lex_state = 8},
  [1947] = {.lex_state = 246, .external_lex_state = 8},
  [1948] = {.lex_state = 248, .external_lex_state = 3},
  [1949] = {.lex_state = 248, .external_lex_state = 3},
  [1950] = {.lex_state = 248, .external_lex_state = 3},
  [1951] = {.lex_state = 248, .external_lex_state = 3},
  [1952] = {.lex_state = 248, .external_lex_state = 3},
  [1953] = {.lex_state = 248, .external_lex_state = 3},
  [1954] = {.lex_state = 248, .external_lex_state = 3},
  [1955] = {.lex_state = 248, .external_lex_state = 3},
  [1956] = {.lex_state = 241, .external_lex_state = 8},
  [1957] = {.lex_state = 248, .external_lex_state = 3},
  [1958] = {.lex_state = 247, .external_lex_state = 4},
  [1959] = {.lex_state = 247, .external_lex_state = 14},
  [1960] = {.lex_state = 247, .external_lex_state = 8},
  [1961] = {.lex_state = 14, .external_lex_state = 7},
  [1962] = {.lex_state = 244, .external_lex_state = 8},
  [1963] = {.lex_state = 242, .external_lex_state = 8},
  [1964] = {.lex_state = 242, .external_lex_state = 8},
  [1965] = {.lex_state = 247, .external_lex_state = 8},
  [1966] = {.lex_state = 248, .external_lex_state = 8},
  [1967] = {.lex_state = 243, .external_lex_state = 8},
  [1968] = {.lex_state = 247, .external_lex_state = 14},
  [1969] = {.lex_state = 247, .external_lex_state = 8},
  [1970] = {.lex_state = 247, .external_lex_state = 4},
  [1971] = {.lex_state = 248, .external_lex_state = 13},
  [1972] = {.lex_state = 247, .external_lex_state = 8},
  [1973] = {.lex_state = 244, .external_lex_state = 8},
  [1974] = {.lex_state = 244, .external_lex_state = 8},
  [1975] = {.lex_state = 14, .external_lex_state = 6},
  [1976] = {.lex_state = 248, .external_lex_state = 13},
  [1977] = {.lex_state = 242, .external_lex_state = 8},
  [1978] = {.lex_state = 247, .external_lex_state = 8},
  [1979] = {.lex_state = 247, .external_lex_state = 8},
  [1980] = {.lex_state = 247, .external_lex_state = 4},
  [1981] = {.lex_state = 244, .external_lex_state = 8},
  [1982] = {.lex_state = 244, .external_lex_state = 8},
  [1983] = {.lex_state = 247, .external_lex_state = 8},
  [1984] = {.lex_state = 247, .external_lex_state = 8},
  [1985] = {.lex_state = 247, .external_lex_state = 8},
  [1986] = {.lex_state = 246, .external_lex_state = 8},
  [1987] = {.lex_state = 248, .external_lex_state = 14},
  [1988] = {.lex_state = 248, .external_lex_state = 8},
  [1989] = {.lex_state = 248, .external_lex_state = 8},
  [1990] = {.lex_state = 247, .external_lex_state = 8},
  [1991] = {.lex_state = 247, .external_lex_state = 8},
  [1992] = {.lex_state = 248, .external_lex_state = 8},
  [1993] = {.lex_state = 248, .external_lex_state = 8},
  [1994] = {.lex_state = 246, .external_lex_state = 8},
  [1995] = {.lex_state = 247, .external_lex_state = 8},
  [1996] = {.lex_state = 248, .external_lex_state = 8},
  [1997] = {.lex_state = 247, .external_lex_state = 8},
  [1998] = {.lex_state = 8, .external_lex_state = 5},
  [1999] = {.lex_state = 247, .external_lex_state = 8},
  [2000] = {.lex_state = 20, .external_lex_state = 15},
  [2001] = {.lex_state = 247, .external_lex_state = 8},
  [2002] = {.lex_state = 8, .external_lex_state = 5},
  [2003] = {.lex_state = 247, .external_lex_state = 8},
  [2004] = {.lex_state = 247, .external_lex_state = 8},
  [2005] = {.lex_state = 248, .external_lex_state = 4},
  [2006] = {.lex_state = 247, .external_lex_state = 8},
  [2007] = {.lex_state = 247, .external_lex_state = 8},
  [2008] = {.lex_state = 246, .external_lex_state = 8},
  [2009] = {.lex_state = 247, .external_lex_state = 8},
  [2010] = {.lex_state = 247, .external_lex_state = 8},
  [2011] = {.lex_state = 247, .external_lex_state = 8},
  [2012] = {.lex_state = 247, .external_lex_state = 8},
  [2013] = {.lex_state = 247, .external_lex_state = 8},
  [2014] = {.lex_state = 247, .external_lex_state = 8},
  [2015] = {.lex_state = 247, .external_lex_state = 8},
  [2016] = {.lex_state = 247, .external_lex_state = 8},
  [2017] = {.lex_state = 247, .external_lex_state = 8},
  [2018] = {.lex_state = 247, .external_lex_state = 8},
  [2019] = {.lex_state = 247, .external_lex_state = 8},
  [2020] = {.lex_state = 247, .external_lex_state = 8},
  [2021] = {.lex_state = 247, .external_lex_state = 8},
  [2022] = {.lex_state = 247, .external_lex_state = 8},
  [2023] = {.lex_state = 247, .external_lex_state = 8},
  [2024] = {.lex_state = 247, .external_lex_state = 8},
  [2025] = {.lex_state = 248, .external_lex_state = 4},
  [2026] = {.lex_state = 247, .external_lex_state = 8},
  [2027] = {.lex_state = 246, .external_lex_state = 8},
  [2028] = {.lex_state = 247, .external_lex_state = 8},
  [2029] = {.lex_state = 247, .external_lex_state = 8},
  [2030] = {.lex_state = 247, .external_lex_state = 8},
  [2031] = {.lex_state = 247, .external_lex_state = 8},
  [2032] = {.lex_state = 247, .external_lex_state = 8},
  [2033] = {.lex_state = 247, .external_lex_state = 8},
  [2034] = {.lex_state = 247, .external_lex_state = 8},
  [2035] = {.lex_state = 247, .external_lex_state = 8},
  [2036] = {.lex_state = 247, .external_lex_state = 8},
  [2037] = {.lex_state = 247, .external_lex_state = 8},
  [2038] = {.lex_state = 247, .external_lex_state = 8},
  [2039] = {.lex_state = 247, .external_lex_state = 8},
  [2040] = {.lex_state = 247, .external_lex_state = 8},
  [2041] = {.lex_state = 247, .external_lex_state = 8},
  [2042] = {.lex_state = 247, .external_lex_state = 8},
  [2043] = {.lex_state = 247, .external_lex_state = 8},
  [2044] = {.lex_state = 247, .external_lex_state = 8},
  [2045] = {.lex_state = 247, .external_lex_state = 8},
  [2046] = {.lex_state = 247, .external_lex_state = 8},
  [2047] = {.lex_state = 247, .external_lex_state = 8},
  [2048] = {.lex_state = 247, .external_lex_state = 8},
  [2049] = {.lex_state = 247, .external_lex_state = 8},
  [2050] = {.lex_state = 247, .external_lex_state = 8},
  [2051] = {.lex_state = 247, .external_lex_state = 8},
  [2052] = {.lex_state = 247, .external_lex_state = 8},
  [2053] = {.lex_state = 248, .external_lex_state = 14},
  [2054] = {.lex_state = 247, .external_lex_state = 8},
  [2055] = {.lex_state = 247, .external_lex_state = 8},
  [2056] = {.lex_state = 247, .external_lex_state = 8},
  [2057] = {.lex_state = 247, .external_lex_state = 8},
  [2058] = {.lex_state = 247, .external_lex_state = 8},
  [2059] = {.lex_state = 247, .external_lex_state = 8},
  [2060] = {.lex_state = 247, .external_lex_state = 8},
  [2061] = {.lex_state = 247, .external_lex_state = 8},
  [2062] = {.lex_state = 247, .external_lex_state = 8},
  [2063] = {.lex_state = 247, .external_lex_state = 8},
  [2064] = {.lex_state = 247, .external_lex_state = 8},
  [2065] = {.lex_state = 247, .external_lex_state = 8},
  [2066] = {.lex_state = 247, .external_lex_state = 8},
  [2067] = {.lex_state = 247, .external_lex_state = 8},
  [2068] = {.lex_state = 247, .external_lex_state = 8},
  [2069] = {.lex_state = 247, .external_lex_state = 8},
  [2070] = {.lex_state = 247, .external_lex_state = 8},
  [2071] = {.lex_state = 247, .external_lex_state = 8},
  [2072] = {.lex_state = 247, .external_lex_state = 8},
  [2073] = {.lex_state = 247, .external_lex_state = 8},
  [2074] = {.lex_state = 247, .external_lex_state = 8},
  [2075] = {.lex_state = 247, .external_lex_state = 8},
  [2076] = {.lex_state = 247, .external_lex_state = 8},
  [2077] = {.lex_state = 247, .external_lex_state = 8},
  [2078] = {.lex_state = 247, .external_lex_state = 8},
  [2079] = {.lex_state = 20, .external_lex_state = 15},
  [2080] = {.lex_state = 247, .external_lex_state = 8},
  [2081] = {.lex_state = 31, .external_lex_state = 5},
  [2082] = {.lex_state = 247, .external_lex_state = 8},
  [2083] = {.lex_state = 247, .external_lex_state = 8},
  [2084] = {.lex_state = 247, .external_lex_state = 8},
  [2085] = {.lex_state = 247, .external_lex_state = 8},
  [2086] = {.lex_state = 247, .external_lex_state = 8},
  [2087] = {.lex_state = 247, .external_lex_state = 8},
  [2088] = {.lex_state = 243, .external_lex_state = 8},
  [2089] = {.lex_state = 243, .external_lex_state = 8},
  [2090] = {.lex_state = 247, .external_lex_state = 8},
  [2091] = {.lex_state = 8, .external_lex_state = 5},
  [2092] = {.lex_state = 247, .external_lex_state = 8},
  [2093] = {.lex_state = 247, .external_lex_state = 8},
  [2094] = {.lex_state = 247, .external_lex_state = 8},
  [2095] = {.lex_state = 247, .external_lex_state = 8},
  [2096] = {.lex_state = 8, .external_lex_state = 5},
  [2097] = {.lex_state = 247, .external_lex_state = 8},
  [2098] = {.lex_state = 246, .external_lex_state = 8},
  [2099] = {.lex_state = 247, .external_lex_state = 8},
  [2100] = {.lex_state = 31, .external_lex_state = 5},
  [2101] = {.lex_state = 247, .external_lex_state = 8},
  [2102] = {.lex_state = 247, .external_lex_state = 8},
  [2103] = {.lex_state = 247, .external_lex_state = 8},
  [2104] = {.lex_state = 247, .external_lex_state = 8},
  [2105] = {.lex_state = 247, .external_lex_state = 8},
  [2106] = {.lex_state = 247, .external_lex_state = 8},
  [2107] = {.lex_state = 247, .external_lex_state = 8},
  [2108] = {.lex_state = 247, .external_lex_state = 8},
  [2109] = {.lex_state = 247, .external_lex_state = 8},
  [2110] = {.lex_state = 247, .external_lex_state = 8},
  [2111] = {.lex_state = 247, .external_lex_state = 8},
  [2112] = {.lex_state = 247, .external_lex_state = 8},
  [2113] = {.lex_state = 247, .external_lex_state = 8},
  [2114] = {.lex_state = 247, .external_lex_state = 8},
  [2115] = {.lex_state = 247, .external_lex_state = 8},
  [2116] = {.lex_state = 247, .external_lex_state = 8},
  [2117] = {.lex_state = 247, .external_lex_state = 8},
  [2118] = {.lex_state = 247, .external_lex_state = 8},
  [2119] = {.lex_state = 248, .external_lex_state = 4},
  [2120] = {.lex_state = 247, .external_lex_state = 8},
  [2121] = {.lex_state = 247, .external_lex_state = 8},
  [2122] = {.lex_state = 243, .external_lex_state = 8},
  [2123] = {.lex_state = 247, .external_lex_state = 8},
  [2124] = {.lex_state = 248, .external_lex_state = 8},
  [2125] = {.lex_state = 248, .external_lex_state = 8},
  [2126] = {.lex_state = 248, .external_lex_state = 8},
  [2127] = {.lex_state = 248, .external_lex_state = 8},
  [2128] = {.lex_state = 248, .external_lex_state = 8},
  [2129] = {.lex_state = 31, .external_lex_state = 5},
  [2130] = {.lex_state = 248, .external_lex_state = 8},
  [2131] = {.lex_state = 248, .external_lex_state = 8},
  [2132] = {.lex_state = 248, .external_lex_state = 8},
  [2133] = {.lex_state = 248, .external_lex_state = 8},
  [2134] = {.lex_state = 248, .external_lex_state = 8},
  [2135] = {.lex_state = 248, .external_lex_state = 8},
  [2136] = {.lex_state = 248, .external_lex_state = 8},
  [2137] = {.lex_state = 248, .external_lex_state = 8},
  [2138] = {.lex_state = 31, .external_lex_state = 5},
  [2139] = {.lex_state = 248, .external_lex_state = 8},
  [2140] = {.lex_state = 248, .external_lex_state = 8},
  [2141] = {.lex_state = 248, .external_lex_state = 8},
  [2142] = {.lex_state = 248, .external_lex_state = 8},
  [2143] = {.lex_state = 248, .external_lex_state = 8},
  [2144] = {.lex_state = 248, .external_lex_state = 8},
  [2145] = {.lex_state = 248, .external_lex_state = 8},
  [2146] = {.lex_state = 248, .external_lex_state = 8},
  [2147] = {.lex_state = 248, .external_lex_state = 8},
  [2148] = {.lex_state = 248, .external_lex_state = 8},
  [2149] = {.lex_state = 248, .external_lex_state = 8},
  [2150] = {.lex_state = 248, .external_lex_state = 8},
  [2151] = {.lex_state = 25, .external_lex_state = 15},
  [2152] = {.lex_state = 248, .external_lex_state = 8},
  [2153] = {.lex_state = 248, .external_lex_state = 8},
  [2154] = {.lex_state = 248, .external_lex_state = 8},
  [2155] = {.lex_state = 248, .external_lex_state = 8},
  [2156] = {.lex_state = 248, .external_lex_state = 8},
  [2157] = {.lex_state = 248, .external_lex_state = 8},
  [2158] = {.lex_state = 248, .external_lex_state = 8},
  [2159] = {.lex_state = 248, .external_lex_state = 8},
  [2160] = {.lex_state = 248, .external_lex_state = 8},
  [2161] = {.lex_state = 248, .external_lex_state = 8},
  [2162] = {.lex_state = 248, .external_lex_state = 8},
  [2163] = {.lex_state = 248, .external_lex_state = 8},
  [2164] = {.lex_state = 248, .external_lex_state = 8},
  [2165] = {.lex_state = 25, .external_lex_state = 15},
  [2166] = {.lex_state = 248, .external_lex_state = 8},
  [2167] = {.lex_state = 248, .external_lex_state = 8},
  [2168] = {.lex_state = 248, .external_lex_state = 8},
  [2169] = {.lex_state = 10, .external_lex_state = 5},
  [2170] = {.lex_state = 248, .external_lex_state = 8},
  [2171] = {.lex_state = 248, .external_lex_state = 8},
  [2172] = {.lex_state = 10, .external_lex_state = 5},
  [2173] = {.lex_state = 248, .external_lex_state = 8},
  [2174] = {.lex_state = 10, .external_lex_state = 5},
  [2175] = {.lex_state = 248, .external_lex_state = 8},
  [2176] = {.lex_state = 248, .external_lex_state = 8},
  [2177] = {.lex_state = 248, .external_lex_state = 8},
  [2178] = {.lex_state = 248, .external_lex_state = 8},
  [2179] = {.lex_state = 33, .external_lex_state = 5},
  [2180] = {.lex_state = 248, .external_lex_state = 8},
  [2181] = {.lex_state = 248, .external_lex_state = 8},
  [2182] = {.lex_state = 248, .external_lex_state = 8},
  [2183] = {.lex_state = 248, .external_lex_state = 8},
  [2184] = {.lex_state = 248, .external_lex_state = 8},
  [2185] = {.lex_state = 248, .external_lex_state = 8},
  [2186] = {.lex_state = 248, .external_lex_state = 8},
  [2187] = {.lex_state = 248, .external_lex_state = 8},
  [2188] = {.lex_state = 248, .external_lex_state = 8},
  [2189] = {.lex_state = 33, .external_lex_state = 5},
  [2190] = {.lex_state = 248, .external_lex_state = 8},
  [2191] = {.lex_state = 248, .external_lex_state = 8},
  [2192] = {.lex_state = 32, .external_lex_state = 5},
  [2193] = {.lex_state = 248, .external_lex_state = 8},
  [2194] = {.lex_state = 248, .external_lex_state = 8},
  [2195] = {.lex_state = 248, .external_lex_state = 8},
  [2196] = {.lex_state = 248, .external_lex_state = 8},
  [2197] = {.lex_state = 248, .external_lex_state = 8},
  [2198] = {.lex_state = 248, .external_lex_state = 8},
  [2199] = {.lex_state = 8, .external_lex_state = 5},
  [2200] = {.lex_state = 248, .external_lex_state = 8},
  [2201] = {.lex_state = 248, .external_lex_state = 8},
  [2202] = {.lex_state = 248, .external_lex_state = 8},
  [2203] = {.lex_state = 10, .external_lex_state = 5},
  [2204] = {.lex_state = 248, .external_lex_state = 8},
  [2205] = {.lex_state = 248, .external_lex_state = 8},
  [2206] = {.lex_state = 248, .external_lex_state = 8},
  [2207] = {.lex_state = 11, .external_lex_state = 5},
  [2208] = {.lex_state = 248, .external_lex_state = 8},
  [2209] = {.lex_state = 248, .external_lex_state = 8},
  [2210] = {.lex_state = 248, .external_lex_state = 8},
  [2211] = {.lex_state = 248, .external_lex_state = 8},
  [2212] = {.lex_state = 248, .external_lex_state = 8},
  [2213] = {.lex_state = 248, .external_lex_state = 8},
  [2214] = {.lex_state = 248, .external_lex_state = 8},
  [2215] = {.lex_state = 248, .external_lex_state = 8},
  [2216] = {.lex_state = 248, .external_lex_state = 8},
  [2217] = {.lex_state = 8, .external_lex_state = 5},
  [2218] = {.lex_state = 248, .external_lex_state = 8},
  [2219] = {.lex_state = 8, .external_lex_state = 5},
  [2220] = {.lex_state = 24, .external_lex_state = 15},
  [2221] = {.lex_state = 248, .external_lex_state = 8},
  [2222] = {.lex_state = 248, .external_lex_state = 8},
  [2223] = {.lex_state = 248, .external_lex_state = 8},
  [2224] = {.lex_state = 11, .external_lex_state = 5},
  [2225] = {.lex_state = 248, .external_lex_state = 8},
  [2226] = {.lex_state = 248, .external_lex_state = 8},
  [2227] = {.lex_state = 248, .external_lex_state = 8},
  [2228] = {.lex_state = 248, .external_lex_state = 8},
  [2229] = {.lex_state = 248, .external_lex_state = 8},
  [2230] = {.lex_state = 248, .external_lex_state = 8},
  [2231] = {.lex_state = 248, .external_lex_state = 8},
  [2232] = {.lex_state = 248, .external_lex_state = 8},
  [2233] = {.lex_state = 24, .external_lex_state = 15},
  [2234] = {.lex_state = 248, .external_lex_state = 8},
  [2235] = {.lex_state = 248, .external_lex_state = 8},
  [2236] = {.lex_state = 248, .external_lex_state = 8},
  [2237] = {.lex_state = 248, .external_lex_state = 8},
  [2238] = {.lex_state = 248, .external_lex_state = 8},
  [2239] = {.lex_state = 248, .external_lex_state = 8},
  [2240] = {.lex_state = 11, .external_lex_state = 5},
  [2241] = {.lex_state = 10, .external_lex_state = 5},
  [2242] = {.lex_state = 248, .external_lex_state = 8},
  [2243] = {.lex_state = 248, .external_lex_state = 8},
  [2244] = {.lex_state = 8, .external_lex_state = 5},
  [2245] = {.lex_state = 248, .external_lex_state = 8},
  [2246] = {.lex_state = 10, .external_lex_state = 5},
  [2247] = {.lex_state = 32, .external_lex_state = 5},
  [2248] = {.lex_state = 248, .external_lex_state = 8},
  [2249] = {.lex_state = 248, .external_lex_state = 8},
  [2250] = {.lex_state = 248, .external_lex_state = 8},
  [2251] = {.lex_state = 20, .external_lex_state = 16},
  [2252] = {.lex_state = 248, .external_lex_state = 8},
  [2253] = {.lex_state = 11, .external_lex_state = 5},
  [2254] = {.lex_state = 248, .external_lex_state = 8},
  [2255] = {.lex_state = 248, .external_lex_state = 8},
  [2256] = {.lex_state = 20, .external_lex_state = 16},
  [2257] = {.lex_state = 248, .external_lex_state = 8},
  [2258] = {.lex_state = 248, .external_lex_state = 8},
  [2259] = {.lex_state = 248, .external_lex_state = 8},
  [2260] = {.lex_state = 248, .external_lex_state = 8},
  [2261] = {.lex_state = 8, .external_lex_state = 5},
  [2262] = {.lex_state = 8, .external_lex_state = 5},
  [2263] = {.lex_state = 248, .external_lex_state = 8},
  [2264] = {.lex_state = 248, .external_lex_state = 8},
  [2265] = {.lex_state = 248, .external_lex_state = 8},
  [2266] = {.lex_state = 34, .external_lex_state = 5},
  [2267] = {.lex_state = 9, .external_lex_state = 6},
  [2268] = {.lex_state = 11, .external_lex_state = 5},
  [2269] = {.lex_state = 20, .external_lex_state = 5},
  [2270] = {.lex_state = 11, .external_lex_state = 5},
  [2271] = {.lex_state = 31, .external_lex_state = 15},
  [2272] = {.lex_state = 8, .external_lex_state = 5},
  [2273] = {.lex_state = 35, .external_lex_state = 5},
  [2274] = {.lex_state = 20, .external_lex_state = 5},
  [2275] = {.lex_state = 34, .external_lex_state = 5},
  [2276] = {.lex_state = 10, .external_lex_state = 5},
  [2277] = {.lex_state = 35, .external_lex_state = 5},
  [2278] = {.lex_state = 20, .external_lex_state = 5},
  [2279] = {.lex_state = 28, .external_lex_state = 15},
  [2280] = {.lex_state = 11, .external_lex_state = 5},
  [2281] = {.lex_state = 20, .external_lex_state = 5},
  [2282] = {.lex_state = 20, .external_lex_state = 5},
  [2283] = {.lex_state = 24, .external_lex_state = 16},
  [2284] = {.lex_state = 10, .external_lex_state = 5},
  [2285] = {.lex_state = 28, .external_lex_state = 15},
  [2286] = {.lex_state = 20, .external_lex_state = 5},
  [2287] = {.lex_state = 9, .external_lex_state = 7},
  [2288] = {.lex_state = 15, .external_lex_state = 5},
  [2289] = {.lex_state = 8, .external_lex_state = 5},
  [2290] = {.lex_state = 8, .external_lex_state = 5},
  [2291] = {.lex_state = 31, .external_lex_state = 15},
  [2292] = {.lex_state = 24, .external_lex_state = 16},
  [2293] = {.lex_state = 12, .external_lex_state = 5},
  [2294] = {.lex_state = 20, .external_lex_state = 5},
  [2295] = {.lex_state = 25, .external_lex_state = 16},
  [2296] = {.lex_state = 11, .external_lex_state = 5},
  [2297] = {.lex_state = 25, .external_lex_state = 16},
  [2298] = {.lex_state = 20, .external_lex_state = 5},
  [2299] = {.lex_state = 20, .external_lex_state = 5},
  [2300] = {.lex_state = 252, .external_lex_state = 2},
  [2301] = {.lex_state = 8, .external_lex_state = 5},
  [2302] = {.lex_state = 8, .external_lex_state = 5},
  [2303] = {.lex_state = 20, .external_lex_state = 5},
  [2304] = {.lex_state = 20, .external_lex_state = 5},
  [2305] = {.lex_state = 20, .external_lex_state = 5},
  [2306] = {.lex_state = 8, .external_lex_state = 5},
  [2307] = {.lex_state = 10, .external_lex_state = 5},
  [2308] = {.lex_state = 10, .external_lex_state = 5},
  [2309] = {.lex_state = 35, .external_lex_state = 5},
  [2310] = {.lex_state = 32, .external_lex_state = 6},
  [2311] = {.lex_state = 12, .external_lex_state = 5},
  [2312] = {.lex_state = 25, .external_lex_state = 5},
  [2313] = {.lex_state = 25, .external_lex_state = 5},
  [2314] = {.lex_state = 32, .external_lex_state = 6},
  [2315] = {.lex_state = 10, .external_lex_state = 5},
  [2316] = {.lex_state = 20, .external_lex_state = 17},
  [2317] = {.lex_state = 25, .external_lex_state = 5},
  [2318] = {.lex_state = 8, .external_lex_state = 7},
  [2319] = {.lex_state = 24, .external_lex_state = 5},
  [2320] = {.lex_state = 13, .external_lex_state = 5},
  [2321] = {.lex_state = 31, .external_lex_state = 6},
  [2322] = {.lex_state = 25, .external_lex_state = 5},
  [2323] = {.lex_state = 31, .external_lex_state = 16},
  [2324] = {.lex_state = 23, .external_lex_state = 17},
  [2325] = {.lex_state = 31, .external_lex_state = 6},
  [2326] = {.lex_state = 15, .external_lex_state = 5},
  [2327] = {.lex_state = 20, .external_lex_state = 17},
  [2328] = {.lex_state = 24, .external_lex_state = 5},
  [2329] = {.lex_state = 10, .external_lex_state = 5},
  [2330] = {.lex_state = 10, .external_lex_state = 6},
  [2331] = {.lex_state = 24, .external_lex_state = 5},
  [2332] = {.lex_state = 24, .external_lex_state = 17},
  [2333] = {.lex_state = 25, .external_lex_state = 5},
  [2334] = {.lex_state = 8, .external_lex_state = 6},
  [2335] = {.lex_state = 20, .external_lex_state = 5},
  [2336] = {.lex_state = 20, .external_lex_state = 5},
  [2337] = {.lex_state = 24, .external_lex_state = 5},
  [2338] = {.lex_state = 25, .external_lex_state = 5},
  [2339] = {.lex_state = 15, .external_lex_state = 5},
  [2340] = {.lex_state = 8, .external_lex_state = 6},
  [2341] = {.lex_state = 31, .external_lex_state = 5},
  [2342] = {.lex_state = 15, .external_lex_state = 5},
  [2343] = {.lex_state = 24, .external_lex_state = 5},
  [2344] = {.lex_state = 24, .external_lex_state = 17},
  [2345] = {.lex_state = 8, .external_lex_state = 5},
  [2346] = {.lex_state = 31, .external_lex_state = 5},
  [2347] = {.lex_state = 25, .external_lex_state = 5},
  [2348] = {.lex_state = 20, .external_lex_state = 18},
  [2349] = {.lex_state = 23, .external_lex_state = 17},
  [2350] = {.lex_state = 31, .external_lex_state = 5},
  [2351] = {.lex_state = 8, .external_lex_state = 7},
  [2352] = {.lex_state = 25, .external_lex_state = 5},
  [2353] = {.lex_state = 25, .external_lex_state = 5},
  [2354] = {.lex_state = 8, .external_lex_state = 5},
  [2355] = {.lex_state = 25, .external_lex_state = 5},
  [2356] = {.lex_state = 25, .external_lex_state = 5},
  [2357] = {.lex_state = 31, .external_lex_state = 5},
  [2358] = {.lex_state = 20, .external_lex_state = 5},
  [2359] = {.lex_state = 25, .external_lex_state = 5},
  [2360] = {.lex_state = 10, .external_lex_state = 6},
  [2361] = {.lex_state = 11, .external_lex_state = 5},
  [2362] = {.lex_state = 24, .external_lex_state = 5},
  [2363] = {.lex_state = 24, .external_lex_state = 5},
  [2364] = {.lex_state = 28, .external_lex_state = 16},
  [2365] = {.lex_state = 8, .external_lex_state = 7},
  [2366] = {.lex_state = 10, .external_lex_state = 6},
  [2367] = {.lex_state = 20, .external_lex_state = 5},
  [2368] = {.lex_state = 8, .external_lex_state = 6},
  [2369] = {.lex_state = 20, .external_lex_state = 18},
  [2370] = {.lex_state = 11, .external_lex_state = 5},
  [2371] = {.lex_state = 31, .external_lex_state = 16},
  [2372] = {.lex_state = 24, .external_lex_state = 5},
  [2373] = {.lex_state = 28, .external_lex_state = 16},
  [2374] = {.lex_state = 24, .external_lex_state = 5},
  [2375] = {.lex_state = 8, .external_lex_state = 7},
  [2376] = {.lex_state = 31, .external_lex_state = 7},
  [2377] = {.lex_state = 8, .external_lex_state = 6},
  [2378] = {.lex_state = 10, .external_lex_state = 6},
  [2379] = {.lex_state = 29, .external_lex_state = 15},
  [2380] = {.lex_state = 31, .external_lex_state = 7},
  [2381] = {.lex_state = 23, .external_lex_state = 18},
  [2382] = {.lex_state = 24, .external_lex_state = 5},
  [2383] = {.lex_state = 29, .external_lex_state = 15},
  [2384] = {.lex_state = 20, .external_lex_state = 5},
  [2385] = {.lex_state = 24, .external_lex_state = 5},
  [2386] = {.lex_state = 12, .external_lex_state = 5},
  [2387] = {.lex_state = 24, .external_lex_state = 5},
  [2388] = {.lex_state = 35, .external_lex_state = 5},
  [2389] = {.lex_state = 23, .external_lex_state = 18},
  [2390] = {.lex_state = 12, .external_lex_state = 5},
  [2391] = {.lex_state = 29, .external_lex_state = 16},
  [2392] = {.lex_state = 31, .external_lex_state = 5},
  [2393] = {.lex_state = 31, .external_lex_state = 5},
  [2394] = {.lex_state = 31, .external_lex_state = 5},
  [2395] = {.lex_state = 31, .external_lex_state = 5},
  [2396] = {.lex_state = 31, .external_lex_state = 5},
  [2397] = {.lex_state = 31, .external_lex_state = 5},
  [2398] = {.lex_state = 31, .external_lex_state = 5},
  [2399] = {.lex_state = 31, .external_lex_state = 5},
  [2400] = {.lex_state = 31, .external_lex_state = 5},
  [2401] = {.lex_state = 31, .external_lex_state = 5},
  [2402] = {.lex_state = 31, .external_lex_state = 5},
  [2403] = {.lex_state = 31, .external_lex_state = 5},
  [2404] = {.lex_state = 31, .external_lex_state = 5},
  [2405] = {.lex_state = 31, .external_lex_state = 5},
  [2406] = {.lex_state = 31, .external_lex_state = 5},
  [2407] = {.lex_state = 31, .external_lex_state = 5},
  [2408] = {.lex_state = 31, .external_lex_state = 5},
  [2409] = {.lex_state = 24, .external_lex_state = 18},
  [2410] = {.lex_state = 31, .external_lex_state = 5},
  [2411] = {.lex_state = 31, .external_lex_state = 5},
  [2412] = {.lex_state = 31, .external_lex_state = 5},
  [2413] = {.lex_state = 31, .external_lex_state = 5},
  [2414] = {.lex_state = 31, .external_lex_state = 7},
  [2415] = {.lex_state = 31, .external_lex_state = 5},
  [2416] = {.lex_state = 31, .external_lex_state = 7},
  [2417] = {.lex_state = 31, .external_lex_state = 5},
  [2418] = {.lex_state = 31, .external_lex_state = 5},
  [2419] = {.lex_state = 31, .external_lex_state = 5},
  [2420] = {.lex_state = 31, .external_lex_state = 5},
  [2421] = {.lex_state = 31, .external_lex_state = 5},
  [2422] = {.lex_state = 31, .external_lex_state = 5},
  [2423] = {.lex_state = 31, .external_lex_state = 5},
  [2424] = {.lex_state = 31, .external_lex_state = 5},
  [2425] = {.lex_state = 31, .external_lex_state = 5},
  [2426] = {.lex_state = 31, .external_lex_state = 5},
  [2427] = {.lex_state = 31, .external_lex_state = 5},
  [2428] = {.lex_state = 31, .external_lex_state = 5},
  [2429] = {.lex_state = 31, .external_lex_state = 5},
  [2430] = {.lex_state = 31, .external_lex_state = 5},
  [2431] = {.lex_state = 31, .external_lex_state = 5},
  [2432] = {.lex_state = 31, .external_lex_state = 5},
  [2433] = {.lex_state = 13, .external_lex_state = 5},
  [2434] = {.lex_state = 31, .external_lex_state = 5},
  [2435] = {.lex_state = 31, .external_lex_state = 5},
  [2436] = {.lex_state = 31, .external_lex_state = 5},
  [2437] = {.lex_state = 31, .external_lex_state = 5},
  [2438] = {.lex_state = 31, .external_lex_state = 5},
  [2439] = {.lex_state = 31, .external_lex_state = 5},
  [2440] = {.lex_state = 31, .external_lex_state = 5},
  [2441] = {.lex_state = 31, .external_lex_state = 5},
  [2442] = {.lex_state = 31, .external_lex_state = 5},
  [2443] = {.lex_state = 33, .external_lex_state = 15},
  [2444] = {.lex_state = 33, .external_lex_state = 15},
  [2445] = {.lex_state = 31, .external_lex_state = 5},
  [2446] = {.lex_state = 31, .external_lex_state = 5},
  [2447] = {.lex_state = 31, .external_lex_state = 5},
  [2448] = {.lex_state = 31, .external_lex_state = 5},
  [2449] = {.lex_state = 10, .external_lex_state = 6},
  [2450] = {.lex_state = 31, .external_lex_state = 5},
  [2451] = {.lex_state = 10, .external_lex_state = 6},
  [2452] = {.lex_state = 31, .external_lex_state = 5},
  [2453] = {.lex_state = 8, .external_lex_state = 6},
  [2454] = {.lex_state = 31, .external_lex_state = 5},
  [2455] = {.lex_state = 11, .external_lex_state = 7},
  [2456] = {.lex_state = 28, .external_lex_state = 5},
  [2457] = {.lex_state = 8, .external_lex_state = 6},
  [2458] = {.lex_state = 12, .external_lex_state = 5},
  [2459] = {.lex_state = 31, .external_lex_state = 5},
  [2460] = {.lex_state = 31, .external_lex_state = 5},
  [2461] = {.lex_state = 31, .external_lex_state = 5},
  [2462] = {.lex_state = 31, .external_lex_state = 5},
  [2463] = {.lex_state = 31, .external_lex_state = 5},
  [2464] = {.lex_state = 28, .external_lex_state = 5},
  [2465] = {.lex_state = 31, .external_lex_state = 5},
  [2466] = {.lex_state = 10, .external_lex_state = 7},
  [2467] = {.lex_state = 29, .external_lex_state = 16},
  [2468] = {.lex_state = 31, .external_lex_state = 5},
  [2469] = {.lex_state = 31, .external_lex_state = 5},
  [2470] = {.lex_state = 31, .external_lex_state = 5},
  [2471] = {.lex_state = 32, .external_lex_state = 7},
  [2472] = {.lex_state = 10, .external_lex_state = 6},
  [2473] = {.lex_state = 31, .external_lex_state = 5},
  [2474] = {.lex_state = 31, .external_lex_state = 5},
  [2475] = {.lex_state = 31, .external_lex_state = 5},
  [2476] = {.lex_state = 28, .external_lex_state = 5},
  [2477] = {.lex_state = 32, .external_lex_state = 15},
  [2478] = {.lex_state = 24, .external_lex_state = 19},
  [2479] = {.lex_state = 31, .external_lex_state = 5},
  [2480] = {.lex_state = 31, .external_lex_state = 5},
  [2481] = {.lex_state = 31, .external_lex_state = 5},
  [2482] = {.lex_state = 32, .external_lex_state = 15},
  [2483] = {.lex_state = 31, .external_lex_state = 5},
  [2484] = {.lex_state = 10, .external_lex_state = 6},
  [2485] = {.lex_state = 31, .external_lex_state = 5},
  [2486] = {.lex_state = 20, .external_lex_state = 19},
  [2487] = {.lex_state = 31, .external_lex_state = 5},
  [2488] = {.lex_state = 31, .external_lex_state = 5},
  [2489] = {.lex_state = 31, .external_lex_state = 5},
  [2490] = {.lex_state = 31, .external_lex_state = 5},
  [2491] = {.lex_state = 13, .external_lex_state = 5},
  [2492] = {.lex_state = 31, .external_lex_state = 5},
  [2493] = {.lex_state = 13, .external_lex_state = 5},
  [2494] = {.lex_state = 13, .external_lex_state = 5},
  [2495] = {.lex_state = 31, .external_lex_state = 5},
  [2496] = {.lex_state = 31, .external_lex_state = 5},
  [2497] = {.lex_state = 31, .external_lex_state = 5},
  [2498] = {.lex_state = 31, .external_lex_state = 5},
  [2499] = {.lex_state = 31, .external_lex_state = 5},
  [2500] = {.lex_state = 31, .external_lex_state = 5},
  [2501] = {.lex_state = 31, .external_lex_state = 5},
  [2502] = {.lex_state = 31, .external_lex_state = 5},
  [2503] = {.lex_state = 8, .external_lex_state = 7},
  [2504] = {.lex_state = 8, .external_lex_state = 7},
  [2505] = {.lex_state = 31, .external_lex_state = 5},
  [2506] = {.lex_state = 31, .external_lex_state = 5},
  [2507] = {.lex_state = 23, .external_lex_state = 20},
  [2508] = {.lex_state = 31, .external_lex_state = 5},
  [2509] = {.lex_state = 31, .external_lex_state = 5},
  [2510] = {.lex_state = 31, .external_lex_state = 5},
  [2511] = {.lex_state = 23, .external_lex_state = 20},
  [2512] = {.lex_state = 31, .external_lex_state = 5},
  [2513] = {.lex_state = 31, .external_lex_state = 5},
  [2514] = {.lex_state = 11, .external_lex_state = 7},
  [2515] = {.lex_state = 28, .external_lex_state = 5},
  [2516] = {.lex_state = 28, .external_lex_state = 5},
  [2517] = {.lex_state = 28, .external_lex_state = 5},
  [2518] = {.lex_state = 31, .external_lex_state = 5},
  [2519] = {.lex_state = 31, .external_lex_state = 5},
  [2520] = {.lex_state = 31, .external_lex_state = 5},
  [2521] = {.lex_state = 31, .external_lex_state = 5},
  [2522] = {.lex_state = 31, .external_lex_state = 5},
  [2523] = {.lex_state = 23, .external_lex_state = 19},
  [2524] = {.lex_state = 31, .external_lex_state = 5},
  [2525] = {.lex_state = 10, .external_lex_state = 7},
  [2526] = {.lex_state = 31, .external_lex_state = 5},
  [2527] = {.lex_state = 31, .external_lex_state = 5},
  [2528] = {.lex_state = 10, .external_lex_state = 7},
  [2529] = {.lex_state = 31, .external_lex_state = 5},
  [2530] = {.lex_state = 31, .external_lex_state = 5},
  [2531] = {.lex_state = 31, .external_lex_state = 5},
  [2532] = {.lex_state = 8, .external_lex_state = 6},
  [2533] = {.lex_state = 31, .external_lex_state = 5},
  [2534] = {.lex_state = 31, .external_lex_state = 5},
  [2535] = {.lex_state = 31, .external_lex_state = 5},
  [2536] = {.lex_state = 28, .external_lex_state = 5},
  [2537] = {.lex_state = 11, .external_lex_state = 7},
  [2538] = {.lex_state = 33, .external_lex_state = 5},
  [2539] = {.lex_state = 25, .external_lex_state = 18},
  [2540] = {.lex_state = 28, .external_lex_state = 5},
  [2541] = {.lex_state = 28, .external_lex_state = 5},
  [2542] = {.lex_state = 10, .external_lex_state = 7},
  [2543] = {.lex_state = 31, .external_lex_state = 5},
  [2544] = {.lex_state = 13, .external_lex_state = 5},
  [2545] = {.lex_state = 8, .external_lex_state = 6},
  [2546] = {.lex_state = 31, .external_lex_state = 5},
  [2547] = {.lex_state = 31, .external_lex_state = 5},
  [2548] = {.lex_state = 24, .external_lex_state = 18},
  [2549] = {.lex_state = 31, .external_lex_state = 5},
  [2550] = {.lex_state = 31, .external_lex_state = 5},
  [2551] = {.lex_state = 31, .external_lex_state = 5},
  [2552] = {.lex_state = 31, .external_lex_state = 5},
  [2553] = {.lex_state = 18, .external_lex_state = 5},
  [2554] = {.lex_state = 31, .external_lex_state = 5},
  [2555] = {.lex_state = 11, .external_lex_state = 7},
  [2556] = {.lex_state = 31, .external_lex_state = 5},
  [2557] = {.lex_state = 31, .external_lex_state = 5},
  [2558] = {.lex_state = 31, .external_lex_state = 5},
  [2559] = {.lex_state = 31, .external_lex_state = 5},
  [2560] = {.lex_state = 31, .external_lex_state = 5},
  [2561] = {.lex_state = 31, .external_lex_state = 5},
  [2562] = {.lex_state = 31, .external_lex_state = 5},
  [2563] = {.lex_state = 31, .external_lex_state = 5},
  [2564] = {.lex_state = 31, .external_lex_state = 5},
  [2565] = {.lex_state = 8, .external_lex_state = 7},
  [2566] = {.lex_state = 28, .external_lex_state = 5},
  [2567] = {.lex_state = 8, .external_lex_state = 7},
  [2568] = {.lex_state = 31, .external_lex_state = 5},
  [2569] = {.lex_state = 32, .external_lex_state = 7},
  [2570] = {.lex_state = 23, .external_lex_state = 19},
  [2571] = {.lex_state = 31, .external_lex_state = 5},
  [2572] = {.lex_state = 31, .external_lex_state = 5},
  [2573] = {.lex_state = 31, .external_lex_state = 5},
  [2574] = {.lex_state = 31, .external_lex_state = 5},
  [2575] = {.lex_state = 20, .external_lex_state = 19},
  [2576] = {.lex_state = 31, .external_lex_state = 5},
  [2577] = {.lex_state = 8, .external_lex_state = 7},
  [2578] = {.lex_state = 31, .external_lex_state = 5},
  [2579] = {.lex_state = 31, .external_lex_state = 5},
  [2580] = {.lex_state = 17, .external_lex_state = 5},
  [2581] = {.lex_state = 31, .external_lex_state = 5},
  [2582] = {.lex_state = 20, .external_lex_state = 20},
  [2583] = {.lex_state = 28, .external_lex_state = 5},
  [2584] = {.lex_state = 31, .external_lex_state = 5},
  [2585] = {.lex_state = 8, .external_lex_state = 7},
  [2586] = {.lex_state = 28, .external_lex_state = 5},
  [2587] = {.lex_state = 31, .external_lex_state = 5},
  [2588] = {.lex_state = 31, .external_lex_state = 5},
  [2589] = {.lex_state = 33, .external_lex_state = 7},
  [2590] = {.lex_state = 31, .external_lex_state = 5},
  [2591] = {.lex_state = 32, .external_lex_state = 5},
  [2592] = {.lex_state = 31, .external_lex_state = 5},
  [2593] = {.lex_state = 20, .external_lex_state = 20},
  [2594] = {.lex_state = 31, .external_lex_state = 5},
  [2595] = {.lex_state = 31, .external_lex_state = 5},
  [2596] = {.lex_state = 31, .external_lex_state = 5},
  [2597] = {.lex_state = 31, .external_lex_state = 5},
  [2598] = {.lex_state = 31, .external_lex_state = 5},
  [2599] = {.lex_state = 33, .external_lex_state = 7},
  [2600] = {.lex_state = 12, .external_lex_state = 5},
  [2601] = {.lex_state = 31, .external_lex_state = 5},
  [2602] = {.lex_state = 24, .external_lex_state = 19},
  [2603] = {.lex_state = 10, .external_lex_state = 7},
  [2604] = {.lex_state = 31, .external_lex_state = 5},
  [2605] = {.lex_state = 25, .external_lex_state = 18},
  [2606] = {.lex_state = 31, .external_lex_state = 5},
  [2607] = {.lex_state = 31, .external_lex_state = 5},
  [2608] = {.lex_state = 10, .external_lex_state = 7},
  [2609] = {.lex_state = 31, .external_lex_state = 5},
  [2610] = {.lex_state = 31, .external_lex_state = 5},
  [2611] = {.lex_state = 31, .external_lex_state = 5},
  [2612] = {.lex_state = 31, .external_lex_state = 5},
  [2613] = {.lex_state = 31, .external_lex_state = 5},
  [2614] = {.lex_state = 31, .external_lex_state = 5},
  [2615] = {.lex_state = 31, .external_lex_state = 5},
  [2616] = {.lex_state = 31, .external_lex_state = 5},
  [2617] = {.lex_state = 31, .external_lex_state = 5},
  [2618] = {.lex_state = 31, .external_lex_state = 5},
  [2619] = {.lex_state = 31, .external_lex_state = 5},
  [2620] = {.lex_state = 31, .external_lex_state = 5},
  [2621] = {.lex_state = 31, .external_lex_state = 5},
  [2622] = {.lex_state = 31, .external_lex_state = 5},
  [2623] = {.lex_state = 29, .external_lex_state = 5},
  [2624] = {.lex_state = 39, .external_lex_state = 6},
  [2625] = {.lex_state = 32, .external_lex_state = 5},
  [2626] = {.lex_state = 32, .external_lex_state = 5},
  [2627] = {.lex_state = 32, .external_lex_state = 5},
  [2628] = {.lex_state = 31, .external_lex_state = 5},
  [2629] = {.lex_state = 31, .external_lex_state = 5},
  [2630] = {.lex_state = 31, .external_lex_state = 5},
  [2631] = {.lex_state = 31, .external_lex_state = 5},
  [2632] = {.lex_state = 31, .external_lex_state = 5},
  [2633] = {.lex_state = 20, .external_lex_state = 6},
  [2634] = {.lex_state = 31, .external_lex_state = 5},
  [2635] = {.lex_state = 23, .external_lex_state = 6},
  [2636] = {.lex_state = 31, .external_lex_state = 5},
  [2637] = {.lex_state = 32, .external_lex_state = 5},
  [2638] = {.lex_state = 31, .external_lex_state = 5},
  [2639] = {.lex_state = 39, .external_lex_state = 7},
  [2640] = {.lex_state = 32, .external_lex_state = 5},
  [2641] = {.lex_state = 32, .external_lex_state = 5},
  [2642] = {.lex_state = 31, .external_lex_state = 5},
  [2643] = {.lex_state = 10, .external_lex_state = 7},
  [2644] = {.lex_state = 35, .external_lex_state = 15},
  [2645] = {.lex_state = 32, .external_lex_state = 5},
  [2646] = {.lex_state = 31, .external_lex_state = 5},
  [2647] = {.lex_state = 31, .external_lex_state = 5},
  [2648] = {.lex_state = 31, .external_lex_state = 5},
  [2649] = {.lex_state = 31, .external_lex_state = 5},
  [2650] = {.lex_state = 31, .external_lex_state = 5},
  [2651] = {.lex_state = 31, .external_lex_state = 5},
  [2652] = {.lex_state = 31, .external_lex_state = 5},
  [2653] = {.lex_state = 31, .external_lex_state = 5},
  [2654] = {.lex_state = 31, .external_lex_state = 5},
  [2655] = {.lex_state = 32, .external_lex_state = 5},
  [2656] = {.lex_state = 32, .external_lex_state = 5},
  [2657] = {.lex_state = 20, .external_lex_state = 6},
  [2658] = {.lex_state = 24, .external_lex_state = 6},
  [2659] = {.lex_state = 20, .external_lex_state = 6},
  [2660] = {.lex_state = 31, .external_lex_state = 5},
  [2661] = {.lex_state = 20, .external_lex_state = 7},
  [2662] = {.lex_state = 24, .external_lex_state = 5},
  [2663] = {.lex_state = 23, .external_lex_state = 6},
  [2664] = {.lex_state = 31, .external_lex_state = 5},
  [2665] = {.lex_state = 31, .external_lex_state = 5},
  [2666] = {.lex_state = 25, .external_lex_state = 20},
  [2667] = {.lex_state = 32, .external_lex_state = 5},
  [2668] = {.lex_state = 23, .external_lex_state = 7},
  [2669] = {.lex_state = 39, .external_lex_state = 7},
  [2670] = {.lex_state = 39, .external_lex_state = 7},
  [2671] = {.lex_state = 33, .external_lex_state = 5},
  [2672] = {.lex_state = 33, .external_lex_state = 5},
  [2673] = {.lex_state = 20, .external_lex_state = 6},
  [2674] = {.lex_state = 32, .external_lex_state = 5},
  [2675] = {.lex_state = 33, .external_lex_state = 5},
  [2676] = {.lex_state = 32, .external_lex_state = 5},
  [2677] = {.lex_state = 23, .external_lex_state = 6},
  [2678] = {.lex_state = 24, .external_lex_state = 6},
  [2679] = {.lex_state = 31, .external_lex_state = 5},
  [2680] = {.lex_state = 23, .external_lex_state = 6},
  [2681] = {.lex_state = 32, .external_lex_state = 5},
  [2682] = {.lex_state = 20, .external_lex_state = 6},
  [2683] = {.lex_state = 20, .external_lex_state = 7},
  [2684] = {.lex_state = 20, .external_lex_state = 6},
  [2685] = {.lex_state = 32, .external_lex_state = 5},
  [2686] = {.lex_state = 31, .external_lex_state = 5},
  [2687] = {.lex_state = 20, .external_lex_state = 6},
  [2688] = {.lex_state = 31, .external_lex_state = 5},
  [2689] = {.lex_state = 20, .external_lex_state = 7},
  [2690] = {.lex_state = 33, .external_lex_state = 5},
  [2691] = {.lex_state = 33, .external_lex_state = 5},
  [2692] = {.lex_state = 34, .external_lex_state = 5},
  [2693] = {.lex_state = 32, .external_lex_state = 5},
  [2694] = {.lex_state = 32, .external_lex_state = 5},
  [2695] = {.lex_state = 32, .external_lex_state = 5},
  [2696] = {.lex_state = 34, .external_lex_state = 7},
  [2697] = {.lex_state = 32, .external_lex_state = 5},
  [2698] = {.lex_state = 32, .external_lex_state = 5},
  [2699] = {.lex_state = 33, .external_lex_state = 5},
  [2700] = {.lex_state = 23, .external_lex_state = 7},
  [2701] = {.lex_state = 33, .external_lex_state = 5},
  [2702] = {.lex_state = 32, .external_lex_state = 5},
  [2703] = {.lex_state = 33, .external_lex_state = 5},
  [2704] = {.lex_state = 31, .external_lex_state = 5},
  [2705] = {.lex_state = 32, .external_lex_state = 5},
  [2706] = {.lex_state = 31, .external_lex_state = 5},
  [2707] = {.lex_state = 25, .external_lex_state = 5},
  [2708] = {.lex_state = 39, .external_lex_state = 7},
  [2709] = {.lex_state = 23, .external_lex_state = 7},
  [2710] = {.lex_state = 32, .external_lex_state = 5},
  [2711] = {.lex_state = 32, .external_lex_state = 5},
  [2712] = {.lex_state = 23, .external_lex_state = 6},
  [2713] = {.lex_state = 34, .external_lex_state = 7},
  [2714] = {.lex_state = 39, .external_lex_state = 7},
  [2715] = {.lex_state = 33, .external_lex_state = 5},
  [2716] = {.lex_state = 32, .external_lex_state = 5},
  [2717] = {.lex_state = 20, .external_lex_state = 7},
  [2718] = {.lex_state = 32, .external_lex_state = 5},
  [2719] = {.lex_state = 39, .external_lex_state = 7},
  [2720] = {.lex_state = 32, .external_lex_state = 5},
  [2721] = {.lex_state = 32, .external_lex_state = 5},
  [2722] = {.lex_state = 32, .external_lex_state = 5},
  [2723] = {.lex_state = 32, .external_lex_state = 5},
  [2724] = {.lex_state = 8, .external_lex_state = 6},
  [2725] = {.lex_state = 32, .external_lex_state = 5},
  [2726] = {.lex_state = 20, .external_lex_state = 6},
  [2727] = {.lex_state = 24, .external_lex_state = 20},
  [2728] = {.lex_state = 32, .external_lex_state = 5},
  [2729] = {.lex_state = 39, .external_lex_state = 6},
  [2730] = {.lex_state = 25, .external_lex_state = 5},
  [2731] = {.lex_state = 32, .external_lex_state = 5},
  [2732] = {.lex_state = 23, .external_lex_state = 7},
  [2733] = {.lex_state = 18, .external_lex_state = 5},
  [2734] = {.lex_state = 33, .external_lex_state = 5},
  [2735] = {.lex_state = 24, .external_lex_state = 6},
  [2736] = {.lex_state = 23, .external_lex_state = 6},
  [2737] = {.lex_state = 39, .external_lex_state = 7},
  [2738] = {.lex_state = 32, .external_lex_state = 5},
  [2739] = {.lex_state = 17, .external_lex_state = 5},
  [2740] = {.lex_state = 29, .external_lex_state = 5},
  [2741] = {.lex_state = 11, .external_lex_state = 7},
  [2742] = {.lex_state = 32, .external_lex_state = 5},
  [2743] = {.lex_state = 11, .external_lex_state = 7},
  [2744] = {.lex_state = 10, .external_lex_state = 7},
  [2745] = {.lex_state = 10, .external_lex_state = 7},
  [2746] = {.lex_state = 31, .external_lex_state = 5},
  [2747] = {.lex_state = 33, .external_lex_state = 16},
  [2748] = {.lex_state = 25, .external_lex_state = 5},
  [2749] = {.lex_state = 32, .external_lex_state = 5},
  [2750] = {.lex_state = 28, .external_lex_state = 18},
  [2751] = {.lex_state = 31, .external_lex_state = 5},
  [2752] = {.lex_state = 32, .external_lex_state = 5},
  [2753] = {.lex_state = 32, .external_lex_state = 5},
  [2754] = {.lex_state = 33, .external_lex_state = 16},
  [2755] = {.lex_state = 29, .external_lex_state = 5},
  [2756] = {.lex_state = 17, .external_lex_state = 5},
  [2757] = {.lex_state = 29, .external_lex_state = 5},
  [2758] = {.lex_state = 32, .external_lex_state = 5},
  [2759] = {.lex_state = 33, .external_lex_state = 5},
  [2760] = {.lex_state = 32, .external_lex_state = 5},
  [2761] = {.lex_state = 32, .external_lex_state = 5},
  [2762] = {.lex_state = 24, .external_lex_state = 20},
  [2763] = {.lex_state = 32, .external_lex_state = 5},
  [2764] = {.lex_state = 35, .external_lex_state = 7},
  [2765] = {.lex_state = 19, .external_lex_state = 5},
  [2766] = {.lex_state = 33, .external_lex_state = 5},
  [2767] = {.lex_state = 29, .external_lex_state = 5},
  [2768] = {.lex_state = 29, .external_lex_state = 5},
  [2769] = {.lex_state = 8, .external_lex_state = 6},
  [2770] = {.lex_state = 33, .external_lex_state = 5},
  [2771] = {.lex_state = 15, .external_lex_state = 7},
  [2772] = {.lex_state = 24, .external_lex_state = 6},
  [2773] = {.lex_state = 29, .external_lex_state = 5},
  [2774] = {.lex_state = 31, .external_lex_state = 18},
  [2775] = {.lex_state = 32, .external_lex_state = 16},
  [2776] = {.lex_state = 32, .external_lex_state = 5},
  [2777] = {.lex_state = 32, .external_lex_state = 5},
  [2778] = {.lex_state = 24, .external_lex_state = 6},
  [2779] = {.lex_state = 24, .external_lex_state = 6},
  [2780] = {.lex_state = 10, .external_lex_state = 6},
  [2781] = {.lex_state = 32, .external_lex_state = 16},
  [2782] = {.lex_state = 29, .external_lex_state = 5},
  [2783] = {.lex_state = 29, .external_lex_state = 5},
  [2784] = {.lex_state = 20, .external_lex_state = 6},
  [2785] = {.lex_state = 11, .external_lex_state = 7},
  [2786] = {.lex_state = 24, .external_lex_state = 6},
  [2787] = {.lex_state = 33, .external_lex_state = 5},
  [2788] = {.lex_state = 33, .external_lex_state = 5},
  [2789] = {.lex_state = 24, .external_lex_state = 6},
  [2790] = {.lex_state = 33, .external_lex_state = 5},
  [2791] = {.lex_state = 20, .external_lex_state = 6},
  [2792] = {.lex_state = 20, .external_lex_state = 6},
  [2793] = {.lex_state = 8, .external_lex_state = 7},
  [2794] = {.lex_state = 28, .external_lex_state = 18},
  [2795] = {.lex_state = 17, .external_lex_state = 5},
  [2796] = {.lex_state = 33, .external_lex_state = 5},
  [2797] = {.lex_state = 33, .external_lex_state = 5},
  [2798] = {.lex_state = 34, .external_lex_state = 15},
  [2799] = {.lex_state = 31, .external_lex_state = 5},
  [2800] = {.lex_state = 31, .external_lex_state = 5},
  [2801] = {.lex_state = 33, .external_lex_state = 5},
  [2802] = {.lex_state = 35, .external_lex_state = 7},
  [2803] = {.lex_state = 34, .external_lex_state = 15},
  [2804] = {.lex_state = 23, .external_lex_state = 7},
  [2805] = {.lex_state = 31, .external_lex_state = 5},
  [2806] = {.lex_state = 23, .external_lex_state = 7},
  [2807] = {.lex_state = 31, .external_lex_state = 5},
  [2808] = {.lex_state = 31, .external_lex_state = 5},
  [2809] = {.lex_state = 23, .external_lex_state = 7},
  [2810] = {.lex_state = 31, .external_lex_state = 5},
  [2811] = {.lex_state = 31, .external_lex_state = 5},
  [2812] = {.lex_state = 24, .external_lex_state = 6},
  [2813] = {.lex_state = 10, .external_lex_state = 6},
  [2814] = {.lex_state = 23, .external_lex_state = 6},
  [2815] = {.lex_state = 31, .external_lex_state = 5},
  [2816] = {.lex_state = 23, .external_lex_state = 7},
  [2817] = {.lex_state = 39, .external_lex_state = 6},
  [2818] = {.lex_state = 39, .external_lex_state = 6},
  [2819] = {.lex_state = 20, .external_lex_state = 6},
  [2820] = {.lex_state = 33, .external_lex_state = 5},
  [2821] = {.lex_state = 12, .external_lex_state = 7},
  [2822] = {.lex_state = 25, .external_lex_state = 5},
  [2823] = {.lex_state = 39, .external_lex_state = 6},
  [2824] = {.lex_state = 24, .external_lex_state = 5},
  [2825] = {.lex_state = 33, .external_lex_state = 5},
  [2826] = {.lex_state = 31, .external_lex_state = 5},
  [2827] = {.lex_state = 31, .external_lex_state = 5},
  [2828] = {.lex_state = 11, .external_lex_state = 7},
  [2829] = {.lex_state = 31, .external_lex_state = 5},
  [2830] = {.lex_state = 31, .external_lex_state = 5},
  [2831] = {.lex_state = 33, .external_lex_state = 5},
  [2832] = {.lex_state = 39, .external_lex_state = 6},
  [2833] = {.lex_state = 31, .external_lex_state = 5},
  [2834] = {.lex_state = 31, .external_lex_state = 5},
  [2835] = {.lex_state = 31, .external_lex_state = 5},
  [2836] = {.lex_state = 8, .external_lex_state = 7},
  [2837] = {.lex_state = 31, .external_lex_state = 5},
  [2838] = {.lex_state = 31, .external_lex_state = 5},
  [2839] = {.lex_state = 20, .external_lex_state = 7},
  [2840] = {.lex_state = 33, .external_lex_state = 5},
  [2841] = {.lex_state = 35, .external_lex_state = 15},
  [2842] = {.lex_state = 24, .external_lex_state = 5},
  [2843] = {.lex_state = 31, .external_lex_state = 5},
  [2844] = {.lex_state = 25, .external_lex_state = 20},
  [2845] = {.lex_state = 25, .external_lex_state = 5},
  [2846] = {.lex_state = 10, .external_lex_state = 7},
  [2847] = {.lex_state = 33, .external_lex_state = 5},
  [2848] = {.lex_state = 33, .external_lex_state = 5},
  [2849] = {.lex_state = 16, .external_lex_state = 5},
  [2850] = {.lex_state = 33, .external_lex_state = 5},
  [2851] = {.lex_state = 33, .external_lex_state = 5},
  [2852] = {.lex_state = 29, .external_lex_state = 5},
  [2853] = {.lex_state = 20, .external_lex_state = 7},
  [2854] = {.lex_state = 20, .external_lex_state = 7},
  [2855] = {.lex_state = 18, .external_lex_state = 5},
  [2856] = {.lex_state = 20, .external_lex_state = 7},
  [2857] = {.lex_state = 8, .external_lex_state = 7},
  [2858] = {.lex_state = 33, .external_lex_state = 5},
  [2859] = {.lex_state = 18, .external_lex_state = 5},
  [2860] = {.lex_state = 32, .external_lex_state = 5},
  [2861] = {.lex_state = 39, .external_lex_state = 6},
  [2862] = {.lex_state = 24, .external_lex_state = 5},
  [2863] = {.lex_state = 33, .external_lex_state = 5},
  [2864] = {.lex_state = 33, .external_lex_state = 5},
  [2865] = {.lex_state = 33, .external_lex_state = 5},
  [2866] = {.lex_state = 31, .external_lex_state = 18},
  [2867] = {.lex_state = 23, .external_lex_state = 6},
  [2868] = {.lex_state = 33, .external_lex_state = 5},
  [2869] = {.lex_state = 33, .external_lex_state = 5},
  [2870] = {.lex_state = 32, .external_lex_state = 5},
  [2871] = {.lex_state = 32, .external_lex_state = 5},
  [2872] = {.lex_state = 29, .external_lex_state = 5},
  [2873] = {.lex_state = 20, .external_lex_state = 7},
  [2874] = {.lex_state = 24, .external_lex_state = 6},
  [2875] = {.lex_state = 20, .external_lex_state = 7},
  [2876] = {.lex_state = 32, .external_lex_state = 5},
  [2877] = {.lex_state = 32, .external_lex_state = 5},
  [2878] = {.lex_state = 20, .external_lex_state = 7},
  [2879] = {.lex_state = 29, .external_lex_state = 5},
  [2880] = {.lex_state = 8, .external_lex_state = 7},
  [2881] = {.lex_state = 24, .external_lex_state = 6},
  [2882] = {.lex_state = 33, .external_lex_state = 5},
  [2883] = {.lex_state = 24, .external_lex_state = 6},
  [2884] = {.lex_state = 20, .external_lex_state = 7},
  [2885] = {.lex_state = 24, .external_lex_state = 5},
  [2886] = {.lex_state = 33, .external_lex_state = 5},
  [2887] = {.lex_state = 33, .external_lex_state = 5},
  [2888] = {.lex_state = 33, .external_lex_state = 5},
  [2889] = {.lex_state = 33, .external_lex_state = 5},
  [2890] = {.lex_state = 34, .external_lex_state = 5},
  [2891] = {.lex_state = 19, .external_lex_state = 5},
  [2892] = {.lex_state = 32, .external_lex_state = 5},
  [2893] = {.lex_state = 34, .external_lex_state = 5},
  [2894] = {.lex_state = 34, .external_lex_state = 5},
  [2895] = {.lex_state = 33, .external_lex_state = 5},
  [2896] = {.lex_state = 33, .external_lex_state = 5},
  [2897] = {.lex_state = 32, .external_lex_state = 5},
  [2898] = {.lex_state = 34, .external_lex_state = 5},
  [2899] = {.lex_state = 34, .external_lex_state = 5},
  [2900] = {.lex_state = 33, .external_lex_state = 5},
  [2901] = {.lex_state = 33, .external_lex_state = 5},
  [2902] = {.lex_state = 28, .external_lex_state = 5},
  [2903] = {.lex_state = 35, .external_lex_state = 5},
  [2904] = {.lex_state = 32, .external_lex_state = 5},
  [2905] = {.lex_state = 28, .external_lex_state = 5},
  [2906] = {.lex_state = 33, .external_lex_state = 5},
  [2907] = {.lex_state = 32, .external_lex_state = 5},
  [2908] = {.lex_state = 10, .external_lex_state = 7},
  [2909] = {.lex_state = 33, .external_lex_state = 5},
  [2910] = {.lex_state = 8, .external_lex_state = 7},
  [2911] = {.lex_state = 33, .external_lex_state = 5},
  [2912] = {.lex_state = 33, .external_lex_state = 5},
  [2913] = {.lex_state = 33, .external_lex_state = 5},
  [2914] = {.lex_state = 33, .external_lex_state = 5},
  [2915] = {.lex_state = 32, .external_lex_state = 5},
  [2916] = {.lex_state = 32, .external_lex_state = 5},
  [2917] = {.lex_state = 16, .external_lex_state = 5},
  [2918] = {.lex_state = 33, .external_lex_state = 5},
  [2919] = {.lex_state = 33, .external_lex_state = 5},
  [2920] = {.lex_state = 33, .external_lex_state = 5},
  [2921] = {.lex_state = 28, .external_lex_state = 5},
  [2922] = {.lex_state = 16, .external_lex_state = 5},
  [2923] = {.lex_state = 33, .external_lex_state = 5},
  [2924] = {.lex_state = 33, .external_lex_state = 5},
  [2925] = {.lex_state = 34, .external_lex_state = 5},
  [2926] = {.lex_state = 33, .external_lex_state = 5},
  [2927] = {.lex_state = 32, .external_lex_state = 5},
  [2928] = {.lex_state = 32, .external_lex_state = 5},
  [2929] = {.lex_state = 33, .external_lex_state = 5},
  [2930] = {.lex_state = 32, .external_lex_state = 5},
  [2931] = {.lex_state = 33, .external_lex_state = 5},
  [2932] = {.lex_state = 32, .external_lex_state = 5},
  [2933] = {.lex_state = 35, .external_lex_state = 5},
  [2934] = {.lex_state = 33, .external_lex_state = 5},
  [2935] = {.lex_state = 33, .external_lex_state = 5},
  [2936] = {.lex_state = 33, .external_lex_state = 5},
  [2937] = {.lex_state = 32, .external_lex_state = 5},
  [2938] = {.lex_state = 33, .external_lex_state = 5},
  [2939] = {.lex_state = 32, .external_lex_state = 5},
  [2940] = {.lex_state = 31, .external_lex_state = 5},
  [2941] = {.lex_state = 25, .external_lex_state = 7},
  [2942] = {.lex_state = 33, .external_lex_state = 5},
  [2943] = {.lex_state = 33, .external_lex_state = 5},
  [2944] = {.lex_state = 33, .external_lex_state = 5},
  [2945] = {.lex_state = 33, .external_lex_state = 5},
  [2946] = {.lex_state = 33, .external_lex_state = 5},
  [2947] = {.lex_state = 33, .external_lex_state = 5},
  [2948] = {.lex_state = 33, .external_lex_state = 5},
  [2949] = {.lex_state = 11, .external_lex_state = 7},
  [2950] = {.lex_state = 33, .external_lex_state = 5},
  [2951] = {.lex_state = 33, .external_lex_state = 5},
  [2952] = {.lex_state = 33, .external_lex_state = 5},
  [2953] = {.lex_state = 33, .external_lex_state = 5},
  [2954] = {.lex_state = 33, .external_lex_state = 5},
  [2955] = {.lex_state = 33, .external_lex_state = 5},
  [2956] = {.lex_state = 33, .external_lex_state = 5},
  [2957] = {.lex_state = 31, .external_lex_state = 20},
  [2958] = {.lex_state = 16, .external_lex_state = 5},
  [2959] = {.lex_state = 35, .external_lex_state = 5},
  [2960] = {.lex_state = 33, .external_lex_state = 5},
  [2961] = {.lex_state = 33, .external_lex_state = 5},
  [2962] = {.lex_state = 33, .external_lex_state = 5},
  [2963] = {.lex_state = 19, .external_lex_state = 5},
  [2964] = {.lex_state = 33, .external_lex_state = 5},
  [2965] = {.lex_state = 32, .external_lex_state = 5},
  [2966] = {.lex_state = 34, .external_lex_state = 5},
  [2967] = {.lex_state = 32, .external_lex_state = 5},
  [2968] = {.lex_state = 33, .external_lex_state = 5},
  [2969] = {.lex_state = 33, .external_lex_state = 5},
  [2970] = {.lex_state = 33, .external_lex_state = 5},
  [2971] = {.lex_state = 8, .external_lex_state = 7},
  [2972] = {.lex_state = 32, .external_lex_state = 5},
  [2973] = {.lex_state = 28, .external_lex_state = 5},
  [2974] = {.lex_state = 34, .external_lex_state = 5},
  [2975] = {.lex_state = 34, .external_lex_state = 5},
  [2976] = {.lex_state = 33, .external_lex_state = 5},
  [2977] = {.lex_state = 32, .external_lex_state = 5},
  [2978] = {.lex_state = 33, .external_lex_state = 5},
  [2979] = {.lex_state = 24, .external_lex_state = 7},
  [2980] = {.lex_state = 33, .external_lex_state = 5},
  [2981] = {.lex_state = 33, .external_lex_state = 5},
  [2982] = {.lex_state = 34, .external_lex_state = 5},
  [2983] = {.lex_state = 33, .external_lex_state = 5},
  [2984] = {.lex_state = 24, .external_lex_state = 7},
  [2985] = {.lex_state = 25, .external_lex_state = 7},
  [2986] = {.lex_state = 33, .external_lex_state = 5},
  [2987] = {.lex_state = 34, .external_lex_state = 5},
  [2988] = {.lex_state = 34, .external_lex_state = 5},
  [2989] = {.lex_state = 33, .external_lex_state = 5},
  [2990] = {.lex_state = 33, .external_lex_state = 5},
  [2991] = {.lex_state = 33, .external_lex_state = 5},
  [2992] = {.lex_state = 33, .external_lex_state = 5},
  [2993] = {.lex_state = 33, .external_lex_state = 5},
  [2994] = {.lex_state = 33, .external_lex_state = 5},
  [2995] = {.lex_state = 34, .external_lex_state = 16},
  [2996] = {.lex_state = 28, .external_lex_state = 20},
  [2997] = {.lex_state = 33, .external_lex_state = 5},
  [2998] = {.lex_state = 35, .external_lex_state = 5},
  [2999] = {.lex_state = 33, .external_lex_state = 5},
  [3000] = {.lex_state = 33, .external_lex_state = 5},
  [3001] = {.lex_state = 33, .external_lex_state = 5},
  [3002] = {.lex_state = 34, .external_lex_state = 16},
  [3003] = {.lex_state = 34, .external_lex_state = 5},
  [3004] = {.lex_state = 28, .external_lex_state = 20},
  [3005] = {.lex_state = 35, .external_lex_state = 16},
  [3006] = {.lex_state = 33, .external_lex_state = 5},
  [3007] = {.lex_state = 33, .external_lex_state = 5},
  [3008] = {.lex_state = 32, .external_lex_state = 5},
  [3009] = {.lex_state = 35, .external_lex_state = 5},
  [3010] = {.lex_state = 35, .external_lex_state = 5},
  [3011] = {.lex_state = 35, .external_lex_state = 5},
  [3012] = {.lex_state = 35, .external_lex_state = 5},
  [3013] = {.lex_state = 32, .external_lex_state = 5},
  [3014] = {.lex_state = 31, .external_lex_state = 6},
  [3015] = {.lex_state = 24, .external_lex_state = 7},
  [3016] = {.lex_state = 34, .external_lex_state = 5},
  [3017] = {.lex_state = 32, .external_lex_state = 5},
  [3018] = {.lex_state = 33, .external_lex_state = 5},
  [3019] = {.lex_state = 32, .external_lex_state = 5},
  [3020] = {.lex_state = 32, .external_lex_state = 5},
  [3021] = {.lex_state = 33, .external_lex_state = 5},
  [3022] = {.lex_state = 33, .external_lex_state = 5},
  [3023] = {.lex_state = 33, .external_lex_state = 5},
  [3024] = {.lex_state = 34, .external_lex_state = 5},
  [3025] = {.lex_state = 34, .external_lex_state = 5},
  [3026] = {.lex_state = 33, .external_lex_state = 5},
  [3027] = {.lex_state = 33, .external_lex_state = 5},
  [3028] = {.lex_state = 35, .external_lex_state = 5},
  [3029] = {.lex_state = 34, .external_lex_state = 5},
  [3030] = {.lex_state = 34, .external_lex_state = 5},
  [3031] = {.lex_state = 31, .external_lex_state = 20},
  [3032] = {.lex_state = 15, .external_lex_state = 7},
  [3033] = {.lex_state = 33, .external_lex_state = 5},
  [3034] = {.lex_state = 32, .external_lex_state = 5},
  [3035] = {.lex_state = 32, .external_lex_state = 5},
  [3036] = {.lex_state = 33, .external_lex_state = 5},
  [3037] = {.lex_state = 32, .external_lex_state = 5},
  [3038] = {.lex_state = 34, .external_lex_state = 5},
  [3039] = {.lex_state = 35, .external_lex_state = 5},
  [3040] = {.lex_state = 35, .external_lex_state = 5},
  [3041] = {.lex_state = 35, .external_lex_state = 5},
  [3042] = {.lex_state = 33, .external_lex_state = 5},
  [3043] = {.lex_state = 33, .external_lex_state = 5},
  [3044] = {.lex_state = 34, .external_lex_state = 5},
  [3045] = {.lex_state = 33, .external_lex_state = 5},
  [3046] = {.lex_state = 33, .external_lex_state = 5},
  [3047] = {.lex_state = 32, .external_lex_state = 5},
  [3048] = {.lex_state = 35, .external_lex_state = 5},
  [3049] = {.lex_state = 35, .external_lex_state = 5},
  [3050] = {.lex_state = 33, .external_lex_state = 5},
  [3051] = {.lex_state = 33, .external_lex_state = 5},
  [3052] = {.lex_state = 33, .external_lex_state = 5},
  [3053] = {.lex_state = 11, .external_lex_state = 7},
  [3054] = {.lex_state = 12, .external_lex_state = 7},
  [3055] = {.lex_state = 33, .external_lex_state = 5},
  [3056] = {.lex_state = 35, .external_lex_state = 5},
  [3057] = {.lex_state = 33, .external_lex_state = 5},
  [3058] = {.lex_state = 35, .external_lex_state = 5},
  [3059] = {.lex_state = 33, .external_lex_state = 5},
  [3060] = {.lex_state = 35, .external_lex_state = 5},
  [3061] = {.lex_state = 32, .external_lex_state = 5},
  [3062] = {.lex_state = 34, .external_lex_state = 5},
  [3063] = {.lex_state = 24, .external_lex_state = 7},
  [3064] = {.lex_state = 33, .external_lex_state = 5},
  [3065] = {.lex_state = 35, .external_lex_state = 5},
  [3066] = {.lex_state = 12, .external_lex_state = 7},
  [3067] = {.lex_state = 32, .external_lex_state = 5},
  [3068] = {.lex_state = 15, .external_lex_state = 7},
  [3069] = {.lex_state = 35, .external_lex_state = 5},
  [3070] = {.lex_state = 33, .external_lex_state = 5},
  [3071] = {.lex_state = 33, .external_lex_state = 5},
  [3072] = {.lex_state = 32, .external_lex_state = 5},
  [3073] = {.lex_state = 32, .external_lex_state = 5},
  [3074] = {.lex_state = 29, .external_lex_state = 18},
  [3075] = {.lex_state = 33, .external_lex_state = 5},
  [3076] = {.lex_state = 33, .external_lex_state = 5},
  [3077] = {.lex_state = 34, .external_lex_state = 5},
  [3078] = {.lex_state = 29, .external_lex_state = 18},
  [3079] = {.lex_state = 31, .external_lex_state = 5},
  [3080] = {.lex_state = 33, .external_lex_state = 5},
  [3081] = {.lex_state = 32, .external_lex_state = 5},
  [3082] = {.lex_state = 24, .external_lex_state = 7},
  [3083] = {.lex_state = 32, .external_lex_state = 5},
  [3084] = {.lex_state = 33, .external_lex_state = 5},
  [3085] = {.lex_state = 34, .external_lex_state = 5},
  [3086] = {.lex_state = 33, .external_lex_state = 5},
  [3087] = {.lex_state = 32, .external_lex_state = 5},
  [3088] = {.lex_state = 33, .external_lex_state = 5},
  [3089] = {.lex_state = 24, .external_lex_state = 7},
  [3090] = {.lex_state = 33, .external_lex_state = 5},
  [3091] = {.lex_state = 33, .external_lex_state = 5},
  [3092] = {.lex_state = 33, .external_lex_state = 5},
  [3093] = {.lex_state = 32, .external_lex_state = 17},
  [3094] = {.lex_state = 31, .external_lex_state = 5},
  [3095] = {.lex_state = 33, .external_lex_state = 5},
  [3096] = {.lex_state = 33, .external_lex_state = 5},
  [3097] = {.lex_state = 35, .external_lex_state = 5},
  [3098] = {.lex_state = 31, .external_lex_state = 5},
  [3099] = {.lex_state = 25, .external_lex_state = 7},
  [3100] = {.lex_state = 31, .external_lex_state = 5},
  [3101] = {.lex_state = 13, .external_lex_state = 7},
  [3102] = {.lex_state = 32, .external_lex_state = 5},
  [3103] = {.lex_state = 34, .external_lex_state = 5},
  [3104] = {.lex_state = 33, .external_lex_state = 5},
  [3105] = {.lex_state = 31, .external_lex_state = 17},
  [3106] = {.lex_state = 28, .external_lex_state = 5},
  [3107] = {.lex_state = 35, .external_lex_state = 5},
  [3108] = {.lex_state = 32, .external_lex_state = 5},
  [3109] = {.lex_state = 33, .external_lex_state = 5},
  [3110] = {.lex_state = 33, .external_lex_state = 5},
  [3111] = {.lex_state = 19, .external_lex_state = 5},
  [3112] = {.lex_state = 34, .external_lex_state = 5},
  [3113] = {.lex_state = 33, .external_lex_state = 5},
  [3114] = {.lex_state = 35, .external_lex_state = 5},
  [3115] = {.lex_state = 33, .external_lex_state = 5},
  [3116] = {.lex_state = 35, .external_lex_state = 5},
  [3117] = {.lex_state = 31, .external_lex_state = 5},
  [3118] = {.lex_state = 33, .external_lex_state = 5},
  [3119] = {.lex_state = 31, .external_lex_state = 5},
  [3120] = {.lex_state = 32, .external_lex_state = 5},
  [3121] = {.lex_state = 25, .external_lex_state = 7},
  [3122] = {.lex_state = 31, .external_lex_state = 5},
  [3123] = {.lex_state = 32, .external_lex_state = 5},
  [3124] = {.lex_state = 33, .external_lex_state = 5},
  [3125] = {.lex_state = 33, .external_lex_state = 5},
  [3126] = {.lex_state = 33, .external_lex_state = 5},
  [3127] = {.lex_state = 32, .external_lex_state = 5},
  [3128] = {.lex_state = 33, .external_lex_state = 5},
  [3129] = {.lex_state = 33, .external_lex_state = 5},
  [3130] = {.lex_state = 25, .external_lex_state = 7},
  [3131] = {.lex_state = 20, .external_lex_state = 7},
  [3132] = {.lex_state = 33, .external_lex_state = 5},
  [3133] = {.lex_state = 33, .external_lex_state = 5},
  [3134] = {.lex_state = 25, .external_lex_state = 7},
  [3135] = {.lex_state = 32, .external_lex_state = 5},
  [3136] = {.lex_state = 20, .external_lex_state = 7},
  [3137] = {.lex_state = 33, .external_lex_state = 5},
  [3138] = {.lex_state = 25, .external_lex_state = 7},
  [3139] = {.lex_state = 25, .external_lex_state = 7},
  [3140] = {.lex_state = 32, .external_lex_state = 5},
  [3141] = {.lex_state = 32, .external_lex_state = 5},
  [3142] = {.lex_state = 32, .external_lex_state = 5},
  [3143] = {.lex_state = 32, .external_lex_state = 5},
  [3144] = {.lex_state = 25, .external_lex_state = 7},
  [3145] = {.lex_state = 33, .external_lex_state = 5},
  [3146] = {.lex_state = 31, .external_lex_state = 6},
  [3147] = {.lex_state = 32, .external_lex_state = 6},
  [3148] = {.lex_state = 32, .external_lex_state = 17},
  [3149] = {.lex_state = 31, .external_lex_state = 17},
  [3150] = {.lex_state = 32, .external_lex_state = 5},
  [3151] = {.lex_state = 20, .external_lex_state = 7},
  [3152] = {.lex_state = 12, .external_lex_state = 7},
  [3153] = {.lex_state = 32, .external_lex_state = 5},
  [3154] = {.lex_state = 33, .external_lex_state = 5},
  [3155] = {.lex_state = 32, .external_lex_state = 5},
  [3156] = {.lex_state = 33, .external_lex_state = 5},
  [3157] = {.lex_state = 32, .external_lex_state = 5},
  [3158] = {.lex_state = 32, .external_lex_state = 5},
  [3159] = {.lex_state = 33, .external_lex_state = 5},
  [3160] = {.lex_state = 31, .external_lex_state = 6},
  [3161] = {.lex_state = 33, .external_lex_state = 5},
  [3162] = {.lex_state = 32, .external_lex_state = 5},
  [3163] = {.lex_state = 32, .external_lex_state = 5},
  [3164] = {.lex_state = 29, .external_lex_state = 5},
  [3165] = {.lex_state = 25, .external_lex_state = 7},
  [3166] = {.lex_state = 20, .external_lex_state = 7},
  [3167] = {.lex_state = 32, .external_lex_state = 5},
  [3168] = {.lex_state = 32, .external_lex_state = 5},
  [3169] = {.lex_state = 32, .external_lex_state = 5},
  [3170] = {.lex_state = 32, .external_lex_state = 5},
  [3171] = {.lex_state = 32, .external_lex_state = 5},
  [3172] = {.lex_state = 32, .external_lex_state = 5},
  [3173] = {.lex_state = 25, .external_lex_state = 7},
  [3174] = {.lex_state = 35, .external_lex_state = 5},
  [3175] = {.lex_state = 33, .external_lex_state = 5},
  [3176] = {.lex_state = 32, .external_lex_state = 5},
  [3177] = {.lex_state = 32, .external_lex_state = 5},
  [3178] = {.lex_state = 33, .external_lex_state = 5},
  [3179] = {.lex_state = 35, .external_lex_state = 5},
  [3180] = {.lex_state = 35, .external_lex_state = 5},
  [3181] = {.lex_state = 29, .external_lex_state = 5},
  [3182] = {.lex_state = 35, .external_lex_state = 5},
  [3183] = {.lex_state = 33, .external_lex_state = 5},
  [3184] = {.lex_state = 35, .external_lex_state = 5},
  [3185] = {.lex_state = 32, .external_lex_state = 5},
  [3186] = {.lex_state = 33, .external_lex_state = 5},
  [3187] = {.lex_state = 32, .external_lex_state = 5},
  [3188] = {.lex_state = 32, .external_lex_state = 5},
  [3189] = {.lex_state = 32, .external_lex_state = 5},
  [3190] = {.lex_state = 24, .external_lex_state = 7},
  [3191] = {.lex_state = 32, .external_lex_state = 5},
  [3192] = {.lex_state = 32, .external_lex_state = 5},
  [3193] = {.lex_state = 15, .external_lex_state = 7},
  [3194] = {.lex_state = 25, .external_lex_state = 7},
  [3195] = {.lex_state = 32, .external_lex_state = 5},
  [3196] = {.lex_state = 32, .external_lex_state = 5},
  [3197] = {.lex_state = 32, .external_lex_state = 5},
  [3198] = {.lex_state = 33, .external_lex_state = 5},
  [3199] = {.lex_state = 33, .external_lex_state = 5},
  [3200] = {.lex_state = 33, .external_lex_state = 5},
  [3201] = {.lex_state = 35, .external_lex_state = 5},
  [3202] = {.lex_state = 32, .external_lex_state = 5},
  [3203] = {.lex_state = 32, .external_lex_state = 5},
  [3204] = {.lex_state = 32, .external_lex_state = 5},
  [3205] = {.lex_state = 32, .external_lex_state = 5},
  [3206] = {.lex_state = 32, .external_lex_state = 5},
  [3207] = {.lex_state = 29, .external_lex_state = 5},
  [3208] = {.lex_state = 31, .external_lex_state = 5},
  [3209] = {.lex_state = 33, .external_lex_state = 5},
  [3210] = {.lex_state = 20, .external_lex_state = 7},
  [3211] = {.lex_state = 33, .external_lex_state = 5},
  [3212] = {.lex_state = 32, .external_lex_state = 5},
  [3213] = {.lex_state = 32, .external_lex_state = 5},
  [3214] = {.lex_state = 33, .external_lex_state = 5},
  [3215] = {.lex_state = 32, .external_lex_state = 5},
  [3216] = {.lex_state = 32, .external_lex_state = 5},
  [3217] = {.lex_state = 35, .external_lex_state = 5},
  [3218] = {.lex_state = 32, .external_lex_state = 5},
  [3219] = {.lex_state = 32, .external_lex_state = 5},
  [3220] = {.lex_state = 32, .external_lex_state = 5},
  [3221] = {.lex_state = 32, .external_lex_state = 5},
  [3222] = {.lex_state = 32, .external_lex_state = 5},
  [3223] = {.lex_state = 33, .external_lex_state = 5},
  [3224] = {.lex_state = 33, .external_lex_state = 5},
  [3225] = {.lex_state = 32, .external_lex_state = 5},
  [3226] = {.lex_state = 31, .external_lex_state = 5},
  [3227] = {.lex_state = 24, .external_lex_state = 7},
  [3228] = {.lex_state = 15, .external_lex_state = 6},
  [3229] = {.lex_state = 35, .external_lex_state = 5},
  [3230] = {.lex_state = 34, .external_lex_state = 5},
  [3231] = {.lex_state = 32, .external_lex_state = 5},
  [3232] = {.lex_state = 35, .external_lex_state = 5},
  [3233] = {.lex_state = 32, .external_lex_state = 5},
  [3234] = {.lex_state = 32, .external_lex_state = 5},
  [3235] = {.lex_state = 33, .external_lex_state = 5},
  [3236] = {.lex_state = 32, .external_lex_state = 5},
  [3237] = {.lex_state = 32, .external_lex_state = 5},
  [3238] = {.lex_state = 32, .external_lex_state = 5},
  [3239] = {.lex_state = 33, .external_lex_state = 5},
  [3240] = {.lex_state = 32, .external_lex_state = 5},
  [3241] = {.lex_state = 32, .external_lex_state = 5},
  [3242] = {.lex_state = 31, .external_lex_state = 5},
  [3243] = {.lex_state = 33, .external_lex_state = 5},
  [3244] = {.lex_state = 10, .external_lex_state = 7},
  [3245] = {.lex_state = 29, .external_lex_state = 5},
  [3246] = {.lex_state = 32, .external_lex_state = 5},
  [3247] = {.lex_state = 32, .external_lex_state = 5},
  [3248] = {.lex_state = 32, .external_lex_state = 5},
  [3249] = {.lex_state = 31, .external_lex_state = 5},
  [3250] = {.lex_state = 31, .external_lex_state = 5},
  [3251] = {.lex_state = 32, .external_lex_state = 5},
  [3252] = {.lex_state = 32, .external_lex_state = 5},
  [3253] = {.lex_state = 32, .external_lex_state = 5},
  [3254] = {.lex_state = 32, .external_lex_state = 5},
  [3255] = {.lex_state = 32, .external_lex_state = 5},
  [3256] = {.lex_state = 29, .external_lex_state = 5},
  [3257] = {.lex_state = 24, .external_lex_state = 7},
  [3258] = {.lex_state = 24, .external_lex_state = 7},
  [3259] = {.lex_state = 32, .external_lex_state = 5},
  [3260] = {.lex_state = 32, .external_lex_state = 5},
  [3261] = {.lex_state = 31, .external_lex_state = 7},
  [3262] = {.lex_state = 32, .external_lex_state = 5},
  [3263] = {.lex_state = 32, .external_lex_state = 5},
  [3264] = {.lex_state = 32, .external_lex_state = 5},
  [3265] = {.lex_state = 32, .external_lex_state = 5},
  [3266] = {.lex_state = 35, .external_lex_state = 16},
  [3267] = {.lex_state = 32, .external_lex_state = 5},
  [3268] = {.lex_state = 32, .external_lex_state = 5},
  [3269] = {.lex_state = 24, .external_lex_state = 7},
  [3270] = {.lex_state = 32, .external_lex_state = 5},
  [3271] = {.lex_state = 32, .external_lex_state = 5},
  [3272] = {.lex_state = 32, .external_lex_state = 5},
  [3273] = {.lex_state = 24, .external_lex_state = 7},
  [3274] = {.lex_state = 34, .external_lex_state = 5},
  [3275] = {.lex_state = 34, .external_lex_state = 5},
  [3276] = {.lex_state = 17, .external_lex_state = 6},
  [3277] = {.lex_state = 32, .external_lex_state = 5},
  [3278] = {.lex_state = 32, .external_lex_state = 5},
  [3279] = {.lex_state = 32, .external_lex_state = 5},
  [3280] = {.lex_state = 32, .external_lex_state = 5},
  [3281] = {.lex_state = 32, .external_lex_state = 5},
  [3282] = {.lex_state = 32, .external_lex_state = 5},
  [3283] = {.lex_state = 34, .external_lex_state = 5},
  [3284] = {.lex_state = 32, .external_lex_state = 5},
  [3285] = {.lex_state = 32, .external_lex_state = 5},
  [3286] = {.lex_state = 32, .external_lex_state = 5},
  [3287] = {.lex_state = 32, .external_lex_state = 5},
  [3288] = {.lex_state = 32, .external_lex_state = 5},
  [3289] = {.lex_state = 32, .external_lex_state = 5},
  [3290] = {.lex_state = 31, .external_lex_state = 6},
  [3291] = {.lex_state = 32, .external_lex_state = 5},
  [3292] = {.lex_state = 33, .external_lex_state = 5},
  [3293] = {.lex_state = 32, .external_lex_state = 5},
  [3294] = {.lex_state = 34, .external_lex_state = 5},
  [3295] = {.lex_state = 34, .external_lex_state = 5},
  [3296] = {.lex_state = 32, .external_lex_state = 5},
  [3297] = {.lex_state = 32, .external_lex_state = 5},
  [3298] = {.lex_state = 32, .external_lex_state = 5},
  [3299] = {.lex_state = 34, .external_lex_state = 5},
  [3300] = {.lex_state = 32, .external_lex_state = 5},
  [3301] = {.lex_state = 32, .external_lex_state = 5},
  [3302] = {.lex_state = 32, .external_lex_state = 5},
  [3303] = {.lex_state = 32, .external_lex_state = 5},
  [3304] = {.lex_state = 34, .external_lex_state = 5},
  [3305] = {.lex_state = 32, .external_lex_state = 5},
  [3306] = {.lex_state = 32, .external_lex_state = 5},
  [3307] = {.lex_state = 34, .external_lex_state = 5},
  [3308] = {.lex_state = 32, .external_lex_state = 5},
  [3309] = {.lex_state = 32, .external_lex_state = 5},
  [3310] = {.lex_state = 32, .external_lex_state = 5},
  [3311] = {.lex_state = 32, .external_lex_state = 5},
  [3312] = {.lex_state = 32, .external_lex_state = 5},
  [3313] = {.lex_state = 33, .external_lex_state = 5},
  [3314] = {.lex_state = 32, .external_lex_state = 5},
  [3315] = {.lex_state = 34, .external_lex_state = 5},
  [3316] = {.lex_state = 34, .external_lex_state = 5},
  [3317] = {.lex_state = 33, .external_lex_state = 5},
  [3318] = {.lex_state = 35, .external_lex_state = 5},
  [3319] = {.lex_state = 20, .external_lex_state = 6},
  [3320] = {.lex_state = 35, .external_lex_state = 5},
  [3321] = {.lex_state = 35, .external_lex_state = 5},
  [3322] = {.lex_state = 35, .external_lex_state = 5},
  [3323] = {.lex_state = 35, .external_lex_state = 5},
  [3324] = {.lex_state = 35, .external_lex_state = 5},
  [3325] = {.lex_state = 35, .external_lex_state = 5},
  [3326] = {.lex_state = 31, .external_lex_state = 7},
  [3327] = {.lex_state = 35, .external_lex_state = 5},
  [3328] = {.lex_state = 35, .external_lex_state = 5},
  [3329] = {.lex_state = 35, .external_lex_state = 5},
  [3330] = {.lex_state = 35, .external_lex_state = 5},
  [3331] = {.lex_state = 34, .external_lex_state = 5},
  [3332] = {.lex_state = 35, .external_lex_state = 5},
  [3333] = {.lex_state = 34, .external_lex_state = 5},
  [3334] = {.lex_state = 31, .external_lex_state = 7},
  [3335] = {.lex_state = 34, .external_lex_state = 5},
  [3336] = {.lex_state = 31, .external_lex_state = 7},
  [3337] = {.lex_state = 34, .external_lex_state = 5},
  [3338] = {.lex_state = 31, .external_lex_state = 7},
  [3339] = {.lex_state = 31, .external_lex_state = 7},
  [3340] = {.lex_state = 31, .external_lex_state = 7},
  [3341] = {.lex_state = 13, .external_lex_state = 7},
  [3342] = {.lex_state = 31, .external_lex_state = 7},
  [3343] = {.lex_state = 31, .external_lex_state = 7},
  [3344] = {.lex_state = 13, .external_lex_state = 7},
  [3345] = {.lex_state = 34, .external_lex_state = 5},
  [3346] = {.lex_state = 35, .external_lex_state = 5},
  [3347] = {.lex_state = 35, .external_lex_state = 5},
  [3348] = {.lex_state = 35, .external_lex_state = 5},
  [3349] = {.lex_state = 35, .external_lex_state = 5},
  [3350] = {.lex_state = 35, .external_lex_state = 5},
  [3351] = {.lex_state = 35, .external_lex_state = 5},
  [3352] = {.lex_state = 35, .external_lex_state = 5},
  [3353] = {.lex_state = 35, .external_lex_state = 5},
  [3354] = {.lex_state = 35, .external_lex_state = 5},
  [3355] = {.lex_state = 35, .external_lex_state = 5},
  [3356] = {.lex_state = 34, .external_lex_state = 5},
  [3357] = {.lex_state = 34, .external_lex_state = 5},
  [3358] = {.lex_state = 34, .external_lex_state = 5},
  [3359] = {.lex_state = 35, .external_lex_state = 5},
  [3360] = {.lex_state = 35, .external_lex_state = 5},
  [3361] = {.lex_state = 35, .external_lex_state = 5},
  [3362] = {.lex_state = 13, .external_lex_state = 7},
  [3363] = {.lex_state = 35, .external_lex_state = 5},
  [3364] = {.lex_state = 35, .external_lex_state = 5},
  [3365] = {.lex_state = 34, .external_lex_state = 5},
  [3366] = {.lex_state = 35, .external_lex_state = 5},
  [3367] = {.lex_state = 35, .external_lex_state = 5},
  [3368] = {.lex_state = 35, .external_lex_state = 5},
  [3369] = {.lex_state = 24, .external_lex_state = 6},
  [3370] = {.lex_state = 35, .external_lex_state = 5},
  [3371] = {.lex_state = 35, .external_lex_state = 5},
  [3372] = {.lex_state = 29, .external_lex_state = 20},
  [3373] = {.lex_state = 35, .external_lex_state = 5},
  [3374] = {.lex_state = 29, .external_lex_state = 20},
  [3375] = {.lex_state = 35, .external_lex_state = 5},
  [3376] = {.lex_state = 34, .external_lex_state = 5},
  [3377] = {.lex_state = 24, .external_lex_state = 6},
  [3378] = {.lex_state = 34, .external_lex_state = 5},
  [3379] = {.lex_state = 34, .external_lex_state = 5},
  [3380] = {.lex_state = 35, .external_lex_state = 5},
  [3381] = {.lex_state = 31, .external_lex_state = 7},
  [3382] = {.lex_state = 31, .external_lex_state = 7},
  [3383] = {.lex_state = 34, .external_lex_state = 5},
  [3384] = {.lex_state = 35, .external_lex_state = 5},
  [3385] = {.lex_state = 24, .external_lex_state = 6},
  [3386] = {.lex_state = 35, .external_lex_state = 5},
  [3387] = {.lex_state = 35, .external_lex_state = 5},
  [3388] = {.lex_state = 35, .external_lex_state = 5},
  [3389] = {.lex_state = 35, .external_lex_state = 5},
  [3390] = {.lex_state = 24, .external_lex_state = 6},
  [3391] = {.lex_state = 35, .external_lex_state = 5},
  [3392] = {.lex_state = 35, .external_lex_state = 5},
  [3393] = {.lex_state = 31, .external_lex_state = 7},
  [3394] = {.lex_state = 31, .external_lex_state = 7},
  [3395] = {.lex_state = 31, .external_lex_state = 7},
  [3396] = {.lex_state = 35, .external_lex_state = 5},
  [3397] = {.lex_state = 35, .external_lex_state = 5},
  [3398] = {.lex_state = 33, .external_lex_state = 18},
  [3399] = {.lex_state = 33, .external_lex_state = 18},
  [3400] = {.lex_state = 32, .external_lex_state = 18},
  [3401] = {.lex_state = 34, .external_lex_state = 5},
  [3402] = {.lex_state = 31, .external_lex_state = 7},
  [3403] = {.lex_state = 34, .external_lex_state = 5},
  [3404] = {.lex_state = 34, .external_lex_state = 5},
  [3405] = {.lex_state = 31, .external_lex_state = 7},
  [3406] = {.lex_state = 13, .external_lex_state = 7},
  [3407] = {.lex_state = 31, .external_lex_state = 7},
  [3408] = {.lex_state = 32, .external_lex_state = 18},
  [3409] = {.lex_state = 31, .external_lex_state = 7},
  [3410] = {.lex_state = 31, .external_lex_state = 7},
  [3411] = {.lex_state = 35, .external_lex_state = 5},
  [3412] = {.lex_state = 34, .external_lex_state = 5},
  [3413] = {.lex_state = 33, .external_lex_state = 7},
  [3414] = {.lex_state = 34, .external_lex_state = 5},
  [3415] = {.lex_state = 31, .external_lex_state = 19},
  [3416] = {.lex_state = 34, .external_lex_state = 5},
  [3417] = {.lex_state = 31, .external_lex_state = 7},
  [3418] = {.lex_state = 35, .external_lex_state = 5},
  [3419] = {.lex_state = 34, .external_lex_state = 5},
  [3420] = {.lex_state = 35, .external_lex_state = 5},
  [3421] = {.lex_state = 35, .external_lex_state = 5},
  [3422] = {.lex_state = 31, .external_lex_state = 7},
  [3423] = {.lex_state = 31, .external_lex_state = 7},
  [3424] = {.lex_state = 28, .external_lex_state = 7},
  [3425] = {.lex_state = 31, .external_lex_state = 7},
  [3426] = {.lex_state = 35, .external_lex_state = 5},
  [3427] = {.lex_state = 31, .external_lex_state = 7},
  [3428] = {.lex_state = 31, .external_lex_state = 6},
  [3429] = {.lex_state = 35, .external_lex_state = 5},
  [3430] = {.lex_state = 35, .external_lex_state = 5},
  [3431] = {.lex_state = 32, .external_lex_state = 7},
  [3432] = {.lex_state = 34, .external_lex_state = 5},
  [3433] = {.lex_state = 35, .external_lex_state = 5},
  [3434] = {.lex_state = 31, .external_lex_state = 7},
  [3435] = {.lex_state = 28, .external_lex_state = 7},
  [3436] = {.lex_state = 24, .external_lex_state = 6},
  [3437] = {.lex_state = 31, .external_lex_state = 7},
  [3438] = {.lex_state = 35, .external_lex_state = 5},
  [3439] = {.lex_state = 31, .external_lex_state = 7},
  [3440] = {.lex_state = 35, .external_lex_state = 5},
  [3441] = {.lex_state = 34, .external_lex_state = 5},
  [3442] = {.lex_state = 31, .external_lex_state = 7},
  [3443] = {.lex_state = 31, .external_lex_state = 6},
  [3444] = {.lex_state = 31, .external_lex_state = 6},
  [3445] = {.lex_state = 31, .external_lex_state = 7},
  [3446] = {.lex_state = 35, .external_lex_state = 5},
  [3447] = {.lex_state = 31, .external_lex_state = 7},
  [3448] = {.lex_state = 31, .external_lex_state = 7},
  [3449] = {.lex_state = 34, .external_lex_state = 5},
  [3450] = {.lex_state = 34, .external_lex_state = 5},
  [3451] = {.lex_state = 31, .external_lex_state = 7},
  [3452] = {.lex_state = 31, .external_lex_state = 7},
  [3453] = {.lex_state = 31, .external_lex_state = 7},
  [3454] = {.lex_state = 31, .external_lex_state = 7},
  [3455] = {.lex_state = 35, .external_lex_state = 5},
  [3456] = {.lex_state = 35, .external_lex_state = 5},
  [3457] = {.lex_state = 31, .external_lex_state = 7},
  [3458] = {.lex_state = 31, .external_lex_state = 7},
  [3459] = {.lex_state = 28, .external_lex_state = 7},
  [3460] = {.lex_state = 28, .external_lex_state = 7},
  [3461] = {.lex_state = 28, .external_lex_state = 7},
  [3462] = {.lex_state = 31, .external_lex_state = 6},
  [3463] = {.lex_state = 31, .external_lex_state = 6},
  [3464] = {.lex_state = 17, .external_lex_state = 6},
  [3465] = {.lex_state = 35, .external_lex_state = 5},
  [3466] = {.lex_state = 31, .external_lex_state = 7},
  [3467] = {.lex_state = 31, .external_lex_state = 7},
  [3468] = {.lex_state = 31, .external_lex_state = 7},
  [3469] = {.lex_state = 31, .external_lex_state = 7},
  [3470] = {.lex_state = 31, .external_lex_state = 7},
  [3471] = {.lex_state = 31, .external_lex_state = 7},
  [3472] = {.lex_state = 34, .external_lex_state = 5},
  [3473] = {.lex_state = 31, .external_lex_state = 7},
  [3474] = {.lex_state = 31, .external_lex_state = 7},
  [3475] = {.lex_state = 35, .external_lex_state = 5},
  [3476] = {.lex_state = 31, .external_lex_state = 7},
  [3477] = {.lex_state = 31, .external_lex_state = 7},
  [3478] = {.lex_state = 31, .external_lex_state = 7},
  [3479] = {.lex_state = 34, .external_lex_state = 5},
  [3480] = {.lex_state = 28, .external_lex_state = 7},
  [3481] = {.lex_state = 28, .external_lex_state = 7},
  [3482] = {.lex_state = 31, .external_lex_state = 7},
  [3483] = {.lex_state = 31, .external_lex_state = 7},
  [3484] = {.lex_state = 31, .external_lex_state = 7},
  [3485] = {.lex_state = 31, .external_lex_state = 7},
  [3486] = {.lex_state = 31, .external_lex_state = 7},
  [3487] = {.lex_state = 31, .external_lex_state = 7},
  [3488] = {.lex_state = 31, .external_lex_state = 7},
  [3489] = {.lex_state = 31, .external_lex_state = 7},
  [3490] = {.lex_state = 31, .external_lex_state = 7},
  [3491] = {.lex_state = 31, .external_lex_state = 7},
  [3492] = {.lex_state = 31, .external_lex_state = 7},
  [3493] = {.lex_state = 31, .external_lex_state = 7},
  [3494] = {.lex_state = 17, .external_lex_state = 6},
  [3495] = {.lex_state = 31, .external_lex_state = 7},
  [3496] = {.lex_state = 31, .external_lex_state = 7},
  [3497] = {.lex_state = 34, .external_lex_state = 5},
  [3498] = {.lex_state = 34, .external_lex_state = 5},
  [3499] = {.lex_state = 28, .external_lex_state = 7},
  [3500] = {.lex_state = 31, .external_lex_state = 7},
  [3501] = {.lex_state = 31, .external_lex_state = 7},
  [3502] = {.lex_state = 17, .external_lex_state = 6},
  [3503] = {.lex_state = 31, .external_lex_state = 7},
  [3504] = {.lex_state = 31, .external_lex_state = 7},
  [3505] = {.lex_state = 31, .external_lex_state = 7},
  [3506] = {.lex_state = 31, .external_lex_state = 7},
  [3507] = {.lex_state = 35, .external_lex_state = 5},
  [3508] = {.lex_state = 31, .external_lex_state = 7},
  [3509] = {.lex_state = 31, .external_lex_state = 7},
  [3510] = {.lex_state = 31, .external_lex_state = 7},
  [3511] = {.lex_state = 31, .external_lex_state = 7},
  [3512] = {.lex_state = 31, .external_lex_state = 7},
  [3513] = {.lex_state = 35, .external_lex_state = 5},
  [3514] = {.lex_state = 35, .external_lex_state = 5},
  [3515] = {.lex_state = 31, .external_lex_state = 7},
  [3516] = {.lex_state = 35, .external_lex_state = 5},
  [3517] = {.lex_state = 35, .external_lex_state = 5},
  [3518] = {.lex_state = 35, .external_lex_state = 5},
  [3519] = {.lex_state = 31, .external_lex_state = 7},
  [3520] = {.lex_state = 31, .external_lex_state = 7},
  [3521] = {.lex_state = 35, .external_lex_state = 5},
  [3522] = {.lex_state = 34, .external_lex_state = 5},
  [3523] = {.lex_state = 35, .external_lex_state = 5},
  [3524] = {.lex_state = 31, .external_lex_state = 7},
  [3525] = {.lex_state = 31, .external_lex_state = 7},
  [3526] = {.lex_state = 31, .external_lex_state = 7},
  [3527] = {.lex_state = 35, .external_lex_state = 5},
  [3528] = {.lex_state = 35, .external_lex_state = 5},
  [3529] = {.lex_state = 35, .external_lex_state = 5},
  [3530] = {.lex_state = 31, .external_lex_state = 7},
  [3531] = {.lex_state = 34, .external_lex_state = 5},
  [3532] = {.lex_state = 35, .external_lex_state = 5},
  [3533] = {.lex_state = 35, .external_lex_state = 5},
  [3534] = {.lex_state = 31, .external_lex_state = 7},
  [3535] = {.lex_state = 31, .external_lex_state = 7},
  [3536] = {.lex_state = 31, .external_lex_state = 7},
  [3537] = {.lex_state = 35, .external_lex_state = 5},
  [3538] = {.lex_state = 35, .external_lex_state = 5},
  [3539] = {.lex_state = 34, .external_lex_state = 5},
  [3540] = {.lex_state = 34, .external_lex_state = 5},
  [3541] = {.lex_state = 31, .external_lex_state = 7},
  [3542] = {.lex_state = 34, .external_lex_state = 5},
  [3543] = {.lex_state = 34, .external_lex_state = 5},
  [3544] = {.lex_state = 35, .external_lex_state = 5},
  [3545] = {.lex_state = 34, .external_lex_state = 5},
  [3546] = {.lex_state = 35, .external_lex_state = 5},
  [3547] = {.lex_state = 31, .external_lex_state = 7},
  [3548] = {.lex_state = 34, .external_lex_state = 5},
  [3549] = {.lex_state = 34, .external_lex_state = 5},
  [3550] = {.lex_state = 31, .external_lex_state = 7},
  [3551] = {.lex_state = 31, .external_lex_state = 7},
  [3552] = {.lex_state = 34, .external_lex_state = 5},
  [3553] = {.lex_state = 35, .external_lex_state = 5},
  [3554] = {.lex_state = 35, .external_lex_state = 5},
  [3555] = {.lex_state = 34, .external_lex_state = 5},
  [3556] = {.lex_state = 34, .external_lex_state = 5},
  [3557] = {.lex_state = 35, .external_lex_state = 5},
  [3558] = {.lex_state = 31, .external_lex_state = 7},
  [3559] = {.lex_state = 34, .external_lex_state = 5},
  [3560] = {.lex_state = 34, .external_lex_state = 5},
  [3561] = {.lex_state = 35, .external_lex_state = 5},
  [3562] = {.lex_state = 35, .external_lex_state = 5},
  [3563] = {.lex_state = 35, .external_lex_state = 5},
  [3564] = {.lex_state = 31, .external_lex_state = 7},
  [3565] = {.lex_state = 31, .external_lex_state = 7},
  [3566] = {.lex_state = 35, .external_lex_state = 5},
  [3567] = {.lex_state = 35, .external_lex_state = 5},
  [3568] = {.lex_state = 31, .external_lex_state = 7},
  [3569] = {.lex_state = 31, .external_lex_state = 7},
  [3570] = {.lex_state = 35, .external_lex_state = 5},
  [3571] = {.lex_state = 35, .external_lex_state = 5},
  [3572] = {.lex_state = 31, .external_lex_state = 7},
  [3573] = {.lex_state = 17, .external_lex_state = 7},
  [3574] = {.lex_state = 31, .external_lex_state = 7},
  [3575] = {.lex_state = 34, .external_lex_state = 5},
  [3576] = {.lex_state = 35, .external_lex_state = 5},
  [3577] = {.lex_state = 31, .external_lex_state = 7},
  [3578] = {.lex_state = 35, .external_lex_state = 5},
  [3579] = {.lex_state = 35, .external_lex_state = 5},
  [3580] = {.lex_state = 31, .external_lex_state = 7},
  [3581] = {.lex_state = 31, .external_lex_state = 7},
  [3582] = {.lex_state = 31, .external_lex_state = 7},
  [3583] = {.lex_state = 35, .external_lex_state = 5},
  [3584] = {.lex_state = 35, .external_lex_state = 5},
  [3585] = {.lex_state = 35, .external_lex_state = 5},
  [3586] = {.lex_state = 31, .external_lex_state = 7},
  [3587] = {.lex_state = 35, .external_lex_state = 5},
  [3588] = {.lex_state = 35, .external_lex_state = 5},
  [3589] = {.lex_state = 35, .external_lex_state = 5},
  [3590] = {.lex_state = 35, .external_lex_state = 5},
  [3591] = {.lex_state = 35, .external_lex_state = 5},
  [3592] = {.lex_state = 35, .external_lex_state = 5},
  [3593] = {.lex_state = 32, .external_lex_state = 6},
  [3594] = {.lex_state = 15, .external_lex_state = 6},
  [3595] = {.lex_state = 35, .external_lex_state = 5},
  [3596] = {.lex_state = 13, .external_lex_state = 7},
  [3597] = {.lex_state = 31, .external_lex_state = 7},
  [3598] = {.lex_state = 31, .external_lex_state = 7},
  [3599] = {.lex_state = 31, .external_lex_state = 7},
  [3600] = {.lex_state = 15, .external_lex_state = 6},
  [3601] = {.lex_state = 35, .external_lex_state = 5},
  [3602] = {.lex_state = 35, .external_lex_state = 5},
  [3603] = {.lex_state = 34, .external_lex_state = 5},
  [3604] = {.lex_state = 35, .external_lex_state = 5},
  [3605] = {.lex_state = 35, .external_lex_state = 5},
  [3606] = {.lex_state = 34, .external_lex_state = 5},
  [3607] = {.lex_state = 35, .external_lex_state = 5},
  [3608] = {.lex_state = 32, .external_lex_state = 6},
  [3609] = {.lex_state = 32, .external_lex_state = 6},
  [3610] = {.lex_state = 35, .external_lex_state = 5},
  [3611] = {.lex_state = 31, .external_lex_state = 7},
  [3612] = {.lex_state = 31, .external_lex_state = 7},
  [3613] = {.lex_state = 12, .external_lex_state = 7},
  [3614] = {.lex_state = 31, .external_lex_state = 7},
  [3615] = {.lex_state = 31, .external_lex_state = 7},
  [3616] = {.lex_state = 35, .external_lex_state = 5},
  [3617] = {.lex_state = 35, .external_lex_state = 5},
  [3618] = {.lex_state = 31, .external_lex_state = 7},
  [3619] = {.lex_state = 35, .external_lex_state = 5},
  [3620] = {.lex_state = 34, .external_lex_state = 5},
  [3621] = {.lex_state = 35, .external_lex_state = 5},
  [3622] = {.lex_state = 34, .external_lex_state = 5},
  [3623] = {.lex_state = 35, .external_lex_state = 5},
  [3624] = {.lex_state = 35, .external_lex_state = 5},
  [3625] = {.lex_state = 34, .external_lex_state = 5},
  [3626] = {.lex_state = 35, .external_lex_state = 5},
  [3627] = {.lex_state = 35, .external_lex_state = 5},
  [3628] = {.lex_state = 32, .external_lex_state = 6},
  [3629] = {.lex_state = 32, .external_lex_state = 6},
  [3630] = {.lex_state = 35, .external_lex_state = 5},
  [3631] = {.lex_state = 35, .external_lex_state = 5},
  [3632] = {.lex_state = 35, .external_lex_state = 5},
  [3633] = {.lex_state = 35, .external_lex_state = 5},
  [3634] = {.lex_state = 35, .external_lex_state = 5},
  [3635] = {.lex_state = 34, .external_lex_state = 5},
  [3636] = {.lex_state = 34, .external_lex_state = 5},
  [3637] = {.lex_state = 34, .external_lex_state = 5},
  [3638] = {.lex_state = 32, .external_lex_state = 6},
  [3639] = {.lex_state = 34, .external_lex_state = 5},
  [3640] = {.lex_state = 34, .external_lex_state = 5},
  [3641] = {.lex_state = 34, .external_lex_state = 5},
  [3642] = {.lex_state = 34, .external_lex_state = 5},
  [3643] = {.lex_state = 31, .external_lex_state = 7},
  [3644] = {.lex_state = 34, .external_lex_state = 5},
  [3645] = {.lex_state = 35, .external_lex_state = 5},
  [3646] = {.lex_state = 34, .external_lex_state = 5},
  [3647] = {.lex_state = 35, .external_lex_state = 5},
  [3648] = {.lex_state = 35, .external_lex_state = 5},
  [3649] = {.lex_state = 32, .external_lex_state = 19},
  [3650] = {.lex_state = 35, .external_lex_state = 5},
  [3651] = {.lex_state = 34, .external_lex_state = 5},
  [3652] = {.lex_state = 35, .external_lex_state = 5},
  [3653] = {.lex_state = 34, .external_lex_state = 5},
  [3654] = {.lex_state = 34, .external_lex_state = 5},
  [3655] = {.lex_state = 34, .external_lex_state = 5},
  [3656] = {.lex_state = 34, .external_lex_state = 5},
  [3657] = {.lex_state = 35, .external_lex_state = 5},
  [3658] = {.lex_state = 34, .external_lex_state = 5},
  [3659] = {.lex_state = 34, .external_lex_state = 5},
  [3660] = {.lex_state = 35, .external_lex_state = 5},
  [3661] = {.lex_state = 31, .external_lex_state = 7},
  [3662] = {.lex_state = 35, .external_lex_state = 5},
  [3663] = {.lex_state = 31, .external_lex_state = 7},
  [3664] = {.lex_state = 31, .external_lex_state = 7},
  [3665] = {.lex_state = 34, .external_lex_state = 5},
  [3666] = {.lex_state = 35, .external_lex_state = 5},
  [3667] = {.lex_state = 31, .external_lex_state = 7},
  [3668] = {.lex_state = 34, .external_lex_state = 5},
  [3669] = {.lex_state = 15, .external_lex_state = 6},
  [3670] = {.lex_state = 31, .external_lex_state = 7},
  [3671] = {.lex_state = 31, .external_lex_state = 7},
  [3672] = {.lex_state = 31, .external_lex_state = 7},
  [3673] = {.lex_state = 34, .external_lex_state = 5},
  [3674] = {.lex_state = 34, .external_lex_state = 5},
  [3675] = {.lex_state = 35, .external_lex_state = 5},
  [3676] = {.lex_state = 34, .external_lex_state = 5},
  [3677] = {.lex_state = 34, .external_lex_state = 5},
  [3678] = {.lex_state = 35, .external_lex_state = 5},
  [3679] = {.lex_state = 35, .external_lex_state = 5},
  [3680] = {.lex_state = 35, .external_lex_state = 5},
  [3681] = {.lex_state = 34, .external_lex_state = 5},
  [3682] = {.lex_state = 34, .external_lex_state = 5},
  [3683] = {.lex_state = 34, .external_lex_state = 5},
  [3684] = {.lex_state = 34, .external_lex_state = 5},
  [3685] = {.lex_state = 34, .external_lex_state = 5},
  [3686] = {.lex_state = 31, .external_lex_state = 7},
  [3687] = {.lex_state = 31, .external_lex_state = 7},
  [3688] = {.lex_state = 31, .external_lex_state = 7},
  [3689] = {.lex_state = 34, .external_lex_state = 5},
  [3690] = {.lex_state = 34, .external_lex_state = 5},
  [3691] = {.lex_state = 34, .external_lex_state = 5},
  [3692] = {.lex_state = 34, .external_lex_state = 5},
  [3693] = {.lex_state = 31, .external_lex_state = 7},
  [3694] = {.lex_state = 35, .external_lex_state = 5},
  [3695] = {.lex_state = 31, .external_lex_state = 7},
  [3696] = {.lex_state = 34, .external_lex_state = 5},
  [3697] = {.lex_state = 34, .external_lex_state = 5},
  [3698] = {.lex_state = 34, .external_lex_state = 5},
  [3699] = {.lex_state = 34, .external_lex_state = 5},
  [3700] = {.lex_state = 34, .external_lex_state = 5},
  [3701] = {.lex_state = 35, .external_lex_state = 5},
  [3702] = {.lex_state = 34, .external_lex_state = 5},
  [3703] = {.lex_state = 34, .external_lex_state = 5},
  [3704] = {.lex_state = 35, .external_lex_state = 5},
  [3705] = {.lex_state = 34, .external_lex_state = 5},
  [3706] = {.lex_state = 34, .external_lex_state = 5},
  [3707] = {.lex_state = 34, .external_lex_state = 5},
  [3708] = {.lex_state = 34, .external_lex_state = 5},
  [3709] = {.lex_state = 34, .external_lex_state = 5},
  [3710] = {.lex_state = 34, .external_lex_state = 5},
  [3711] = {.lex_state = 35, .external_lex_state = 5},
  [3712] = {.lex_state = 34, .external_lex_state = 5},
  [3713] = {.lex_state = 34, .external_lex_state = 5},
  [3714] = {.lex_state = 35, .external_lex_state = 5},
  [3715] = {.lex_state = 34, .external_lex_state = 5},
  [3716] = {.lex_state = 34, .external_lex_state = 5},
  [3717] = {.lex_state = 34, .external_lex_state = 5},
  [3718] = {.lex_state = 34, .external_lex_state = 5},
  [3719] = {.lex_state = 34, .external_lex_state = 5},
  [3720] = {.lex_state = 34, .external_lex_state = 5},
  [3721] = {.lex_state = 34, .external_lex_state = 5},
  [3722] = {.lex_state = 34, .external_lex_state = 5},
  [3723] = {.lex_state = 35, .external_lex_state = 5},
  [3724] = {.lex_state = 34, .external_lex_state = 5},
  [3725] = {.lex_state = 34, .external_lex_state = 5},
  [3726] = {.lex_state = 34, .external_lex_state = 5},
  [3727] = {.lex_state = 18, .external_lex_state = 7},
  [3728] = {.lex_state = 34, .external_lex_state = 5},
  [3729] = {.lex_state = 34, .external_lex_state = 5},
  [3730] = {.lex_state = 34, .external_lex_state = 5},
  [3731] = {.lex_state = 32, .external_lex_state = 19},
  [3732] = {.lex_state = 34, .external_lex_state = 5},
  [3733] = {.lex_state = 34, .external_lex_state = 5},
  [3734] = {.lex_state = 34, .external_lex_state = 5},
  [3735] = {.lex_state = 35, .external_lex_state = 5},
  [3736] = {.lex_state = 34, .external_lex_state = 5},
  [3737] = {.lex_state = 34, .external_lex_state = 5},
  [3738] = {.lex_state = 35, .external_lex_state = 5},
  [3739] = {.lex_state = 20, .external_lex_state = 6},
  [3740] = {.lex_state = 34, .external_lex_state = 5},
  [3741] = {.lex_state = 35, .external_lex_state = 5},
  [3742] = {.lex_state = 35, .external_lex_state = 5},
  [3743] = {.lex_state = 34, .external_lex_state = 5},
  [3744] = {.lex_state = 35, .external_lex_state = 5},
  [3745] = {.lex_state = 35, .external_lex_state = 5},
  [3746] = {.lex_state = 35, .external_lex_state = 5},
  [3747] = {.lex_state = 34, .external_lex_state = 5},
  [3748] = {.lex_state = 34, .external_lex_state = 5},
  [3749] = {.lex_state = 34, .external_lex_state = 5},
  [3750] = {.lex_state = 31, .external_lex_state = 19},
  [3751] = {.lex_state = 34, .external_lex_state = 5},
  [3752] = {.lex_state = 34, .external_lex_state = 5},
  [3753] = {.lex_state = 34, .external_lex_state = 5},
  [3754] = {.lex_state = 34, .external_lex_state = 5},
  [3755] = {.lex_state = 34, .external_lex_state = 5},
  [3756] = {.lex_state = 34, .external_lex_state = 5},
  [3757] = {.lex_state = 34, .external_lex_state = 5},
  [3758] = {.lex_state = 34, .external_lex_state = 5},
  [3759] = {.lex_state = 35, .external_lex_state = 5},
  [3760] = {.lex_state = 20, .external_lex_state = 6},
  [3761] = {.lex_state = 35, .external_lex_state = 5},
  [3762] = {.lex_state = 35, .external_lex_state = 5},
  [3763] = {.lex_state = 20, .external_lex_state = 6},
  [3764] = {.lex_state = 34, .external_lex_state = 5},
  [3765] = {.lex_state = 34, .external_lex_state = 5},
  [3766] = {.lex_state = 28, .external_lex_state = 7},
  [3767] = {.lex_state = 34, .external_lex_state = 5},
  [3768] = {.lex_state = 35, .external_lex_state = 5},
  [3769] = {.lex_state = 35, .external_lex_state = 5},
  [3770] = {.lex_state = 35, .external_lex_state = 5},
  [3771] = {.lex_state = 35, .external_lex_state = 5},
  [3772] = {.lex_state = 35, .external_lex_state = 5},
  [3773] = {.lex_state = 28, .external_lex_state = 7},
  [3774] = {.lex_state = 12, .external_lex_state = 7},
  [3775] = {.lex_state = 31, .external_lex_state = 6},
  [3776] = {.lex_state = 20, .external_lex_state = 6},
  [3777] = {.lex_state = 28, .external_lex_state = 7},
  [3778] = {.lex_state = 35, .external_lex_state = 5},
  [3779] = {.lex_state = 28, .external_lex_state = 7},
  [3780] = {.lex_state = 34, .external_lex_state = 5},
  [3781] = {.lex_state = 35, .external_lex_state = 5},
  [3782] = {.lex_state = 34, .external_lex_state = 5},
  [3783] = {.lex_state = 31, .external_lex_state = 7},
  [3784] = {.lex_state = 31, .external_lex_state = 6},
  [3785] = {.lex_state = 32, .external_lex_state = 6},
  [3786] = {.lex_state = 25, .external_lex_state = 7},
  [3787] = {.lex_state = 32, .external_lex_state = 6},
  [3788] = {.lex_state = 32, .external_lex_state = 6},
  [3789] = {.lex_state = 32, .external_lex_state = 6},
  [3790] = {.lex_state = 32, .external_lex_state = 6},
  [3791] = {.lex_state = 17, .external_lex_state = 7},
  [3792] = {.lex_state = 31, .external_lex_state = 6},
  [3793] = {.lex_state = 31, .external_lex_state = 6},
  [3794] = {.lex_state = 35, .external_lex_state = 18},
  [3795] = {.lex_state = 32, .external_lex_state = 6},
  [3796] = {.lex_state = 32, .external_lex_state = 6},
  [3797] = {.lex_state = 35, .external_lex_state = 18},
  [3798] = {.lex_state = 32, .external_lex_state = 6},
  [3799] = {.lex_state = 18, .external_lex_state = 7},
  [3800] = {.lex_state = 25, .external_lex_state = 7},
  [3801] = {.lex_state = 29, .external_lex_state = 7},
  [3802] = {.lex_state = 25, .external_lex_state = 7},
  [3803] = {.lex_state = 32, .external_lex_state = 6},
  [3804] = {.lex_state = 33, .external_lex_state = 7},
  [3805] = {.lex_state = 31, .external_lex_state = 6},
  [3806] = {.lex_state = 31, .external_lex_state = 6},
  [3807] = {.lex_state = 32, .external_lex_state = 6},
  [3808] = {.lex_state = 32, .external_lex_state = 6},
  [3809] = {.lex_state = 64, .external_lex_state = 21},
  [3810] = {.lex_state = 32, .external_lex_state = 6},
  [3811] = {.lex_state = 32, .external_lex_state = 6},
  [3812] = {.lex_state = 32, .external_lex_state = 6},
  [3813] = {.lex_state = 25, .external_lex_state = 7},
  [3814] = {.lex_state = 32, .external_lex_state = 6},
  [3815] = {.lex_state = 32, .external_lex_state = 6},
  [3816] = {.lex_state = 31, .external_lex_state = 6},
  [3817] = {.lex_state = 32, .external_lex_state = 6},
  [3818] = {.lex_state = 32, .external_lex_state = 6},
  [3819] = {.lex_state = 32, .external_lex_state = 6},
  [3820] = {.lex_state = 31, .external_lex_state = 6},
  [3821] = {.lex_state = 31, .external_lex_state = 6},
  [3822] = {.lex_state = 31, .external_lex_state = 6},
  [3823] = {.lex_state = 24, .external_lex_state = 7},
  [3824] = {.lex_state = 32, .external_lex_state = 6},
  [3825] = {.lex_state = 32, .external_lex_state = 6},
  [3826] = {.lex_state = 32, .external_lex_state = 6},
  [3827] = {.lex_state = 32, .external_lex_state = 6},
  [3828] = {.lex_state = 32, .external_lex_state = 6},
  [3829] = {.lex_state = 32, .external_lex_state = 6},
  [3830] = {.lex_state = 31, .external_lex_state = 6},
  [3831] = {.lex_state = 31, .external_lex_state = 6},
  [3832] = {.lex_state = 32, .external_lex_state = 6},
  [3833] = {.lex_state = 31, .external_lex_state = 6},
  [3834] = {.lex_state = 31, .external_lex_state = 6},
  [3835] = {.lex_state = 31, .external_lex_state = 6},
  [3836] = {.lex_state = 31, .external_lex_state = 6},
  [3837] = {.lex_state = 31, .external_lex_state = 6},
  [3838] = {.lex_state = 31, .external_lex_state = 6},
  [3839] = {.lex_state = 31, .external_lex_state = 6},
  [3840] = {.lex_state = 31, .external_lex_state = 6},
  [3841] = {.lex_state = 32, .external_lex_state = 6},
  [3842] = {.lex_state = 29, .external_lex_state = 7},
  [3843] = {.lex_state = 31, .external_lex_state = 6},
  [3844] = {.lex_state = 31, .external_lex_state = 6},
  [3845] = {.lex_state = 31, .external_lex_state = 6},
  [3846] = {.lex_state = 29, .external_lex_state = 7},
  [3847] = {.lex_state = 32, .external_lex_state = 6},
  [3848] = {.lex_state = 29, .external_lex_state = 7},
  [3849] = {.lex_state = 31, .external_lex_state = 6},
  [3850] = {.lex_state = 31, .external_lex_state = 6},
  [3851] = {.lex_state = 31, .external_lex_state = 6},
  [3852] = {.lex_state = 32, .external_lex_state = 6},
  [3853] = {.lex_state = 34, .external_lex_state = 7},
  [3854] = {.lex_state = 31, .external_lex_state = 6},
  [3855] = {.lex_state = 32, .external_lex_state = 6},
  [3856] = {.lex_state = 29, .external_lex_state = 7},
  [3857] = {.lex_state = 31, .external_lex_state = 6},
  [3858] = {.lex_state = 31, .external_lex_state = 6},
  [3859] = {.lex_state = 32, .external_lex_state = 6},
  [3860] = {.lex_state = 31, .external_lex_state = 6},
  [3861] = {.lex_state = 31, .external_lex_state = 6},
  [3862] = {.lex_state = 31, .external_lex_state = 6},
  [3863] = {.lex_state = 32, .external_lex_state = 6},
  [3864] = {.lex_state = 32, .external_lex_state = 6},
  [3865] = {.lex_state = 31, .external_lex_state = 6},
  [3866] = {.lex_state = 32, .external_lex_state = 6},
  [3867] = {.lex_state = 32, .external_lex_state = 6},
  [3868] = {.lex_state = 32, .external_lex_state = 6},
  [3869] = {.lex_state = 32, .external_lex_state = 6},
  [3870] = {.lex_state = 31, .external_lex_state = 6},
  [3871] = {.lex_state = 32, .external_lex_state = 6},
  [3872] = {.lex_state = 32, .external_lex_state = 6},
  [3873] = {.lex_state = 31, .external_lex_state = 6},
  [3874] = {.lex_state = 32, .external_lex_state = 6},
  [3875] = {.lex_state = 31, .external_lex_state = 6},
  [3876] = {.lex_state = 32, .external_lex_state = 6},
  [3877] = {.lex_state = 32, .external_lex_state = 6},
  [3878] = {.lex_state = 31, .external_lex_state = 6},
  [3879] = {.lex_state = 31, .external_lex_state = 6},
  [3880] = {.lex_state = 31, .external_lex_state = 6},
  [3881] = {.lex_state = 32, .external_lex_state = 6},
  [3882] = {.lex_state = 32, .external_lex_state = 6},
  [3883] = {.lex_state = 31, .external_lex_state = 6},
  [3884] = {.lex_state = 31, .external_lex_state = 6},
  [3885] = {.lex_state = 32, .external_lex_state = 6},
  [3886] = {.lex_state = 32, .external_lex_state = 6},
  [3887] = {.lex_state = 32, .external_lex_state = 6},
  [3888] = {.lex_state = 31, .external_lex_state = 6},
  [3889] = {.lex_state = 31, .external_lex_state = 6},
  [3890] = {.lex_state = 31, .external_lex_state = 6},
  [3891] = {.lex_state = 31, .external_lex_state = 6},
  [3892] = {.lex_state = 31, .external_lex_state = 6},
  [3893] = {.lex_state = 31, .external_lex_state = 6},
  [3894] = {.lex_state = 31, .external_lex_state = 6},
  [3895] = {.lex_state = 31, .external_lex_state = 6},
  [3896] = {.lex_state = 31, .external_lex_state = 6},
  [3897] = {.lex_state = 33, .external_lex_state = 6},
  [3898] = {.lex_state = 31, .external_lex_state = 6},
  [3899] = {.lex_state = 33, .external_lex_state = 20},
  [3900] = {.lex_state = 33, .external_lex_state = 20},
  [3901] = {.lex_state = 31, .external_lex_state = 6},
  [3902] = {.lex_state = 32, .external_lex_state = 20},
  [3903] = {.lex_state = 32, .external_lex_state = 6},
  [3904] = {.lex_state = 32, .external_lex_state = 6},
  [3905] = {.lex_state = 32, .external_lex_state = 20},
  [3906] = {.lex_state = 32, .external_lex_state = 6},
  [3907] = {.lex_state = 32, .external_lex_state = 6},
  [3908] = {.lex_state = 32, .external_lex_state = 6},
  [3909] = {.lex_state = 24, .external_lex_state = 7},
  [3910] = {.lex_state = 31, .external_lex_state = 6},
  [3911] = {.lex_state = 31, .external_lex_state = 6},
  [3912] = {.lex_state = 31, .external_lex_state = 6},
  [3913] = {.lex_state = 31, .external_lex_state = 6},
  [3914] = {.lex_state = 32, .external_lex_state = 6},
  [3915] = {.lex_state = 31, .external_lex_state = 6},
  [3916] = {.lex_state = 32, .external_lex_state = 6},
  [3917] = {.lex_state = 32, .external_lex_state = 7},
  [3918] = {.lex_state = 32, .external_lex_state = 6},
  [3919] = {.lex_state = 32, .external_lex_state = 6},
  [3920] = {.lex_state = 34, .external_lex_state = 18},
  [3921] = {.lex_state = 32, .external_lex_state = 6},
  [3922] = {.lex_state = 32, .external_lex_state = 6},
  [3923] = {.lex_state = 33, .external_lex_state = 6},
  [3924] = {.lex_state = 32, .external_lex_state = 6},
  [3925] = {.lex_state = 31, .external_lex_state = 6},
  [3926] = {.lex_state = 31, .external_lex_state = 6},
  [3927] = {.lex_state = 31, .external_lex_state = 6},
  [3928] = {.lex_state = 31, .external_lex_state = 6},
  [3929] = {.lex_state = 32, .external_lex_state = 7},
  [3930] = {.lex_state = 32, .external_lex_state = 7},
  [3931] = {.lex_state = 31, .external_lex_state = 6},
  [3932] = {.lex_state = 31, .external_lex_state = 6},
  [3933] = {.lex_state = 24, .external_lex_state = 7},
  [3934] = {.lex_state = 32, .external_lex_state = 6},
  [3935] = {.lex_state = 32, .external_lex_state = 6},
  [3936] = {.lex_state = 32, .external_lex_state = 6},
  [3937] = {.lex_state = 32, .external_lex_state = 6},
  [3938] = {.lex_state = 32, .external_lex_state = 6},
  [3939] = {.lex_state = 32, .external_lex_state = 6},
  [3940] = {.lex_state = 32, .external_lex_state = 6},
  [3941] = {.lex_state = 32, .external_lex_state = 7},
  [3942] = {.lex_state = 32, .external_lex_state = 7},
  [3943] = {.lex_state = 32, .external_lex_state = 6},
  [3944] = {.lex_state = 35, .external_lex_state = 9},
  [3945] = {.lex_state = 32, .external_lex_state = 6},
  [3946] = {.lex_state = 31, .external_lex_state = 6},
  [3947] = {.lex_state = 31, .external_lex_state = 6},
  [3948] = {.lex_state = 32, .external_lex_state = 6},
  [3949] = {.lex_state = 31, .external_lex_state = 6},
  [3950] = {.lex_state = 31, .external_lex_state = 6},
  [3951] = {.lex_state = 32, .external_lex_state = 6},
  [3952] = {.lex_state = 31, .external_lex_state = 6},
  [3953] = {.lex_state = 31, .external_lex_state = 6},
  [3954] = {.lex_state = 31, .external_lex_state = 6},
  [3955] = {.lex_state = 32, .external_lex_state = 6},
  [3956] = {.lex_state = 31, .external_lex_state = 6},
  [3957] = {.lex_state = 31, .external_lex_state = 6},
  [3958] = {.lex_state = 31, .external_lex_state = 6},
  [3959] = {.lex_state = 32, .external_lex_state = 6},
  [3960] = {.lex_state = 31, .external_lex_state = 6},
  [3961] = {.lex_state = 32, .external_lex_state = 6},
  [3962] = {.lex_state = 32, .external_lex_state = 6},
  [3963] = {.lex_state = 32, .external_lex_state = 6},
  [3964] = {.lex_state = 31, .external_lex_state = 6},
  [3965] = {.lex_state = 31, .external_lex_state = 6},
  [3966] = {.lex_state = 31, .external_lex_state = 6},
  [3967] = {.lex_state = 31, .external_lex_state = 6},
  [3968] = {.lex_state = 32, .external_lex_state = 6},
  [3969] = {.lex_state = 32, .external_lex_state = 6},
  [3970] = {.lex_state = 32, .external_lex_state = 6},
  [3971] = {.lex_state = 32, .external_lex_state = 6},
  [3972] = {.lex_state = 32, .external_lex_state = 6},
  [3973] = {.lex_state = 32, .external_lex_state = 6},
  [3974] = {.lex_state = 24, .external_lex_state = 7},
  [3975] = {.lex_state = 32, .external_lex_state = 6},
  [3976] = {.lex_state = 31, .external_lex_state = 6},
  [3977] = {.lex_state = 31, .external_lex_state = 6},
  [3978] = {.lex_state = 32, .external_lex_state = 6},
  [3979] = {.lex_state = 33, .external_lex_state = 7},
  [3980] = {.lex_state = 31, .external_lex_state = 6},
  [3981] = {.lex_state = 31, .external_lex_state = 6},
  [3982] = {.lex_state = 32, .external_lex_state = 6},
  [3983] = {.lex_state = 32, .external_lex_state = 6},
  [3984] = {.lex_state = 32, .external_lex_state = 6},
  [3985] = {.lex_state = 32, .external_lex_state = 6},
  [3986] = {.lex_state = 32, .external_lex_state = 6},
  [3987] = {.lex_state = 31, .external_lex_state = 6},
  [3988] = {.lex_state = 33, .external_lex_state = 7},
  [3989] = {.lex_state = 33, .external_lex_state = 7},
  [3990] = {.lex_state = 31, .external_lex_state = 6},
  [3991] = {.lex_state = 32, .external_lex_state = 6},
  [3992] = {.lex_state = 32, .external_lex_state = 6},
  [3993] = {.lex_state = 31, .external_lex_state = 6},
  [3994] = {.lex_state = 31, .external_lex_state = 6},
  [3995] = {.lex_state = 32, .external_lex_state = 6},
  [3996] = {.lex_state = 32, .external_lex_state = 6},
  [3997] = {.lex_state = 32, .external_lex_state = 6},
  [3998] = {.lex_state = 31, .external_lex_state = 6},
  [3999] = {.lex_state = 33, .external_lex_state = 7},
  [4000] = {.lex_state = 33, .external_lex_state = 7},
  [4001] = {.lex_state = 32, .external_lex_state = 6},
  [4002] = {.lex_state = 32, .external_lex_state = 6},
  [4003] = {.lex_state = 31, .external_lex_state = 6},
  [4004] = {.lex_state = 32, .external_lex_state = 6},
  [4005] = {.lex_state = 32, .external_lex_state = 6},
  [4006] = {.lex_state = 31, .external_lex_state = 6},
  [4007] = {.lex_state = 33, .external_lex_state = 6},
  [4008] = {.lex_state = 32, .external_lex_state = 6},
  [4009] = {.lex_state = 32, .external_lex_state = 6},
  [4010] = {.lex_state = 17, .external_lex_state = 7},
  [4011] = {.lex_state = 31, .external_lex_state = 6},
  [4012] = {.lex_state = 32, .external_lex_state = 6},
  [4013] = {.lex_state = 32, .external_lex_state = 6},
  [4014] = {.lex_state = 32, .external_lex_state = 6},
  [4015] = {.lex_state = 32, .external_lex_state = 6},
  [4016] = {.lex_state = 32, .external_lex_state = 6},
  [4017] = {.lex_state = 31, .external_lex_state = 7},
  [4018] = {.lex_state = 17, .external_lex_state = 7},
  [4019] = {.lex_state = 32, .external_lex_state = 6},
  [4020] = {.lex_state = 32, .external_lex_state = 6},
  [4021] = {.lex_state = 31, .external_lex_state = 6},
  [4022] = {.lex_state = 35, .external_lex_state = 9},
  [4023] = {.lex_state = 32, .external_lex_state = 6},
  [4024] = {.lex_state = 32, .external_lex_state = 6},
  [4025] = {.lex_state = 31, .external_lex_state = 6},
  [4026] = {.lex_state = 32, .external_lex_state = 6},
  [4027] = {.lex_state = 32, .external_lex_state = 7},
  [4028] = {.lex_state = 31, .external_lex_state = 6},
  [4029] = {.lex_state = 34, .external_lex_state = 18},
  [4030] = {.lex_state = 32, .external_lex_state = 6},
  [4031] = {.lex_state = 24, .external_lex_state = 7},
  [4032] = {.lex_state = 25, .external_lex_state = 7},
  [4033] = {.lex_state = 31, .external_lex_state = 6},
  [4034] = {.lex_state = 32, .external_lex_state = 7},
  [4035] = {.lex_state = 31, .external_lex_state = 7},
  [4036] = {.lex_state = 32, .external_lex_state = 6},
  [4037] = {.lex_state = 31, .external_lex_state = 6},
  [4038] = {.lex_state = 31, .external_lex_state = 6},
  [4039] = {.lex_state = 31, .external_lex_state = 6},
  [4040] = {.lex_state = 31, .external_lex_state = 6},
  [4041] = {.lex_state = 31, .external_lex_state = 6},
  [4042] = {.lex_state = 35, .external_lex_state = 9},
  [4043] = {.lex_state = 32, .external_lex_state = 6},
  [4044] = {.lex_state = 31, .external_lex_state = 6},
  [4045] = {.lex_state = 31, .external_lex_state = 6},
  [4046] = {.lex_state = 31, .external_lex_state = 6},
  [4047] = {.lex_state = 31, .external_lex_state = 6},
  [4048] = {.lex_state = 31, .external_lex_state = 6},
  [4049] = {.lex_state = 18, .external_lex_state = 7},
  [4050] = {.lex_state = 32, .external_lex_state = 6},
  [4051] = {.lex_state = 31, .external_lex_state = 6},
  [4052] = {.lex_state = 31, .external_lex_state = 6},
  [4053] = {.lex_state = 31, .external_lex_state = 6},
  [4054] = {.lex_state = 31, .external_lex_state = 6},
  [4055] = {.lex_state = 31, .external_lex_state = 6},
  [4056] = {.lex_state = 18, .external_lex_state = 7},
  [4057] = {.lex_state = 31, .external_lex_state = 6},
  [4058] = {.lex_state = 29, .external_lex_state = 7},
  [4059] = {.lex_state = 29, .external_lex_state = 7},
  [4060] = {.lex_state = 29, .external_lex_state = 7},
  [4061] = {.lex_state = 32, .external_lex_state = 6},
  [4062] = {.lex_state = 16, .external_lex_state = 7},
  [4063] = {.lex_state = 31, .external_lex_state = 6},
  [4064] = {.lex_state = 19, .external_lex_state = 7},
  [4065] = {.lex_state = 32, .external_lex_state = 6},
  [4066] = {.lex_state = 32, .external_lex_state = 6},
  [4067] = {.lex_state = 31, .external_lex_state = 6},
  [4068] = {.lex_state = 31, .external_lex_state = 6},
  [4069] = {.lex_state = 29, .external_lex_state = 7},
  [4070] = {.lex_state = 32, .external_lex_state = 6},
  [4071] = {.lex_state = 31, .external_lex_state = 6},
  [4072] = {.lex_state = 31, .external_lex_state = 6},
  [4073] = {.lex_state = 32, .external_lex_state = 6},
  [4074] = {.lex_state = 31, .external_lex_state = 6},
  [4075] = {.lex_state = 31, .external_lex_state = 6},
  [4076] = {.lex_state = 32, .external_lex_state = 6},
  [4077] = {.lex_state = 29, .external_lex_state = 7},
  [4078] = {.lex_state = 31, .external_lex_state = 6},
  [4079] = {.lex_state = 32, .external_lex_state = 6},
  [4080] = {.lex_state = 29, .external_lex_state = 7},
  [4081] = {.lex_state = 29, .external_lex_state = 7},
  [4082] = {.lex_state = 32, .external_lex_state = 7},
  [4083] = {.lex_state = 32, .external_lex_state = 7},
  [4084] = {.lex_state = 56, .external_lex_state = 22},
  [4085] = {.lex_state = 33, .external_lex_state = 7},
  [4086] = {.lex_state = 33, .external_lex_state = 7},
  [4087] = {.lex_state = 56, .external_lex_state = 22},
  [4088] = {.lex_state = 56, .external_lex_state = 22},
  [4089] = {.lex_state = 56, .external_lex_state = 22},
  [4090] = {.lex_state = 56, .external_lex_state = 22},
  [4091] = {.lex_state = 33, .external_lex_state = 7},
  [4092] = {.lex_state = 33, .external_lex_state = 7},
  [4093] = {.lex_state = 33, .external_lex_state = 7},
  [4094] = {.lex_state = 32, .external_lex_state = 7},
  [4095] = {.lex_state = 33, .external_lex_state = 7},
  [4096] = {.lex_state = 33, .external_lex_state = 7},
  [4097] = {.lex_state = 33, .external_lex_state = 7},
  [4098] = {.lex_state = 32, .external_lex_state = 7},
  [4099] = {.lex_state = 33, .external_lex_state = 7},
  [4100] = {.lex_state = 33, .external_lex_state = 7},
  [4101] = {.lex_state = 33, .external_lex_state = 7},
  [4102] = {.lex_state = 56, .external_lex_state = 22},
  [4103] = {.lex_state = 56, .external_lex_state = 22},
  [4104] = {.lex_state = 56, .external_lex_state = 22},
  [4105] = {.lex_state = 33, .external_lex_state = 7},
  [4106] = {.lex_state = 33, .external_lex_state = 7},
  [4107] = {.lex_state = 33, .external_lex_state = 7},
  [4108] = {.lex_state = 32, .external_lex_state = 7},
  [4109] = {.lex_state = 32, .external_lex_state = 7},
  [4110] = {.lex_state = 33, .external_lex_state = 7},
  [4111] = {.lex_state = 33, .external_lex_state = 7},
  [4112] = {.lex_state = 33, .external_lex_state = 7},
  [4113] = {.lex_state = 32, .external_lex_state = 7},
  [4114] = {.lex_state = 32, .external_lex_state = 7},
  [4115] = {.lex_state = 33, .external_lex_state = 7},
  [4116] = {.lex_state = 33, .external_lex_state = 7},
  [4117] = {.lex_state = 33, .external_lex_state = 7},
  [4118] = {.lex_state = 33, .external_lex_state = 7},
  [4119] = {.lex_state = 33, .external_lex_state = 7},
  [4120] = {.lex_state = 33, .external_lex_state = 7},
  [4121] = {.lex_state = 33, .external_lex_state = 7},
  [4122] = {.lex_state = 33, .external_lex_state = 7},
  [4123] = {.lex_state = 33, .external_lex_state = 7},
  [4124] = {.lex_state = 33, .external_lex_state = 7},
  [4125] = {.lex_state = 32, .external_lex_state = 7},
  [4126] = {.lex_state = 32, .external_lex_state = 7},
  [4127] = {.lex_state = 56, .external_lex_state = 22},
  [4128] = {.lex_state = 33, .external_lex_state = 7},
  [4129] = {.lex_state = 33, .external_lex_state = 7},
  [4130] = {.lex_state = 33, .external_lex_state = 7},
  [4131] = {.lex_state = 33, .external_lex_state = 7},
  [4132] = {.lex_state = 33, .external_lex_state = 7},
  [4133] = {.lex_state = 33, .external_lex_state = 7},
  [4134] = {.lex_state = 33, .external_lex_state = 7},
  [4135] = {.lex_state = 33, .external_lex_state = 7},
  [4136] = {.lex_state = 33, .external_lex_state = 7},
  [4137] = {.lex_state = 33, .external_lex_state = 7},
  [4138] = {.lex_state = 33, .external_lex_state = 7},
  [4139] = {.lex_state = 33, .external_lex_state = 7},
  [4140] = {.lex_state = 33, .external_lex_state = 7},
  [4141] = {.lex_state = 56, .external_lex_state = 22},
  [4142] = {.lex_state = 56, .external_lex_state = 22},
  [4143] = {.lex_state = 33, .external_lex_state = 7},
  [4144] = {.lex_state = 28, .external_lex_state = 7},
  [4145] = {.lex_state = 33, .external_lex_state = 7},
  [4146] = {.lex_state = 33, .external_lex_state = 7},
  [4147] = {.lex_state = 33, .external_lex_state = 7},
  [4148] = {.lex_state = 33, .external_lex_state = 7},
  [4149] = {.lex_state = 33, .external_lex_state = 7},
  [4150] = {.lex_state = 33, .external_lex_state = 7},
  [4151] = {.lex_state = 56, .external_lex_state = 22},
  [4152] = {.lex_state = 33, .external_lex_state = 7},
  [4153] = {.lex_state = 19, .external_lex_state = 7},
  [4154] = {.lex_state = 33, .external_lex_state = 7},
  [4155] = {.lex_state = 33, .external_lex_state = 7},
  [4156] = {.lex_state = 56, .external_lex_state = 22},
  [4157] = {.lex_state = 34, .external_lex_state = 6},
  [4158] = {.lex_state = 33, .external_lex_state = 7},
  [4159] = {.lex_state = 56, .external_lex_state = 22},
  [4160] = {.lex_state = 33, .external_lex_state = 7},
  [4161] = {.lex_state = 28, .external_lex_state = 7},
  [4162] = {.lex_state = 19, .external_lex_state = 7},
  [4163] = {.lex_state = 32, .external_lex_state = 7},
  [4164] = {.lex_state = 33, .external_lex_state = 7},
  [4165] = {.lex_state = 33, .external_lex_state = 7},
  [4166] = {.lex_state = 56, .external_lex_state = 22},
  [4167] = {.lex_state = 33, .external_lex_state = 7},
  [4168] = {.lex_state = 56, .external_lex_state = 22},
  [4169] = {.lex_state = 56, .external_lex_state = 22},
  [4170] = {.lex_state = 28, .external_lex_state = 7},
  [4171] = {.lex_state = 33, .external_lex_state = 7},
  [4172] = {.lex_state = 56, .external_lex_state = 22},
  [4173] = {.lex_state = 56, .external_lex_state = 22},
  [4174] = {.lex_state = 56, .external_lex_state = 22},
  [4175] = {.lex_state = 32, .external_lex_state = 7},
  [4176] = {.lex_state = 28, .external_lex_state = 7},
  [4177] = {.lex_state = 33, .external_lex_state = 7},
  [4178] = {.lex_state = 56, .external_lex_state = 22},
  [4179] = {.lex_state = 56, .external_lex_state = 22},
  [4180] = {.lex_state = 56, .external_lex_state = 22},
  [4181] = {.lex_state = 33, .external_lex_state = 7},
  [4182] = {.lex_state = 33, .external_lex_state = 7},
  [4183] = {.lex_state = 33, .external_lex_state = 7},
  [4184] = {.lex_state = 33, .external_lex_state = 7},
  [4185] = {.lex_state = 56, .external_lex_state = 22},
  [4186] = {.lex_state = 56, .external_lex_state = 22},
  [4187] = {.lex_state = 56, .external_lex_state = 22},
  [4188] = {.lex_state = 32, .external_lex_state = 7},
  [4189] = {.lex_state = 32, .external_lex_state = 7},
  [4190] = {.lex_state = 33, .external_lex_state = 7},
  [4191] = {.lex_state = 32, .external_lex_state = 7},
  [4192] = {.lex_state = 32, .external_lex_state = 7},
  [4193] = {.lex_state = 56, .external_lex_state = 22},
  [4194] = {.lex_state = 32, .external_lex_state = 7},
  [4195] = {.lex_state = 56, .external_lex_state = 22},
  [4196] = {.lex_state = 32, .external_lex_state = 7},
  [4197] = {.lex_state = 28, .external_lex_state = 7},
  [4198] = {.lex_state = 16, .external_lex_state = 7},
  [4199] = {.lex_state = 32, .external_lex_state = 7},
  [4200] = {.lex_state = 32, .external_lex_state = 7},
  [4201] = {.lex_state = 32, .external_lex_state = 7},
  [4202] = {.lex_state = 32, .external_lex_state = 7},
  [4203] = {.lex_state = 34, .external_lex_state = 20},
  [4204] = {.lex_state = 16, .external_lex_state = 7},
  [4205] = {.lex_state = 32, .external_lex_state = 7},
  [4206] = {.lex_state = 32, .external_lex_state = 7},
  [4207] = {.lex_state = 32, .external_lex_state = 7},
  [4208] = {.lex_state = 34, .external_lex_state = 6},
  [4209] = {.lex_state = 32, .external_lex_state = 7},
  [4210] = {.lex_state = 32, .external_lex_state = 7},
  [4211] = {.lex_state = 32, .external_lex_state = 7},
  [4212] = {.lex_state = 32, .external_lex_state = 7},
  [4213] = {.lex_state = 32, .external_lex_state = 7},
  [4214] = {.lex_state = 32, .external_lex_state = 7},
  [4215] = {.lex_state = 32, .external_lex_state = 7},
  [4216] = {.lex_state = 32, .external_lex_state = 7},
  [4217] = {.lex_state = 32, .external_lex_state = 7},
  [4218] = {.lex_state = 56, .external_lex_state = 22},
  [4219] = {.lex_state = 56, .external_lex_state = 22},
  [4220] = {.lex_state = 32, .external_lex_state = 7},
  [4221] = {.lex_state = 56, .external_lex_state = 22},
  [4222] = {.lex_state = 32, .external_lex_state = 7},
  [4223] = {.lex_state = 32, .external_lex_state = 7},
  [4224] = {.lex_state = 32, .external_lex_state = 7},
  [4225] = {.lex_state = 32, .external_lex_state = 7},
  [4226] = {.lex_state = 32, .external_lex_state = 7},
  [4227] = {.lex_state = 32, .external_lex_state = 7},
  [4228] = {.lex_state = 32, .external_lex_state = 7},
  [4229] = {.lex_state = 32, .external_lex_state = 7},
  [4230] = {.lex_state = 32, .external_lex_state = 7},
  [4231] = {.lex_state = 32, .external_lex_state = 7},
  [4232] = {.lex_state = 19, .external_lex_state = 7},
  [4233] = {.lex_state = 32, .external_lex_state = 7},
  [4234] = {.lex_state = 32, .external_lex_state = 7},
  [4235] = {.lex_state = 32, .external_lex_state = 7},
  [4236] = {.lex_state = 32, .external_lex_state = 7},
  [4237] = {.lex_state = 56, .external_lex_state = 22},
  [4238] = {.lex_state = 32, .external_lex_state = 7},
  [4239] = {.lex_state = 56, .external_lex_state = 22},
  [4240] = {.lex_state = 56, .external_lex_state = 22},
  [4241] = {.lex_state = 56, .external_lex_state = 22},
  [4242] = {.lex_state = 34, .external_lex_state = 7},
  [4243] = {.lex_state = 35, .external_lex_state = 6},
  [4244] = {.lex_state = 32, .external_lex_state = 7},
  [4245] = {.lex_state = 32, .external_lex_state = 7},
  [4246] = {.lex_state = 32, .external_lex_state = 7},
  [4247] = {.lex_state = 56, .external_lex_state = 22},
  [4248] = {.lex_state = 32, .external_lex_state = 7},
  [4249] = {.lex_state = 32, .external_lex_state = 7},
  [4250] = {.lex_state = 34, .external_lex_state = 20},
  [4251] = {.lex_state = 33, .external_lex_state = 7},
  [4252] = {.lex_state = 33, .external_lex_state = 7},
  [4253] = {.lex_state = 57, .external_lex_state = 22},
  [4254] = {.lex_state = 56, .external_lex_state = 22},
  [4255] = {.lex_state = 32, .external_lex_state = 7},
  [4256] = {.lex_state = 32, .external_lex_state = 7},
  [4257] = {.lex_state = 32, .external_lex_state = 7},
  [4258] = {.lex_state = 56, .external_lex_state = 22},
  [4259] = {.lex_state = 33, .external_lex_state = 7},
  [4260] = {.lex_state = 32, .external_lex_state = 7},
  [4261] = {.lex_state = 56, .external_lex_state = 22},
  [4262] = {.lex_state = 32, .external_lex_state = 7},
  [4263] = {.lex_state = 34, .external_lex_state = 7},
  [4264] = {.lex_state = 34, .external_lex_state = 6},
  [4265] = {.lex_state = 32, .external_lex_state = 7},
  [4266] = {.lex_state = 32, .external_lex_state = 7},
  [4267] = {.lex_state = 32, .external_lex_state = 7},
  [4268] = {.lex_state = 34, .external_lex_state = 7},
  [4269] = {.lex_state = 32, .external_lex_state = 7},
  [4270] = {.lex_state = 33, .external_lex_state = 7},
  [4271] = {.lex_state = 33, .external_lex_state = 7},
  [4272] = {.lex_state = 33, .external_lex_state = 7},
  [4273] = {.lex_state = 34, .external_lex_state = 7},
  [4274] = {.lex_state = 34, .external_lex_state = 7},
  [4275] = {.lex_state = 33, .external_lex_state = 7},
  [4276] = {.lex_state = 32, .external_lex_state = 7},
  [4277] = {.lex_state = 32, .external_lex_state = 7},
  [4278] = {.lex_state = 32, .external_lex_state = 7},
  [4279] = {.lex_state = 32, .external_lex_state = 7},
  [4280] = {.lex_state = 33, .external_lex_state = 7},
  [4281] = {.lex_state = 32, .external_lex_state = 7},
  [4282] = {.lex_state = 33, .external_lex_state = 7},
  [4283] = {.lex_state = 32, .external_lex_state = 7},
  [4284] = {.lex_state = 33, .external_lex_state = 7},
  [4285] = {.lex_state = 32, .external_lex_state = 7},
  [4286] = {.lex_state = 32, .external_lex_state = 7},
  [4287] = {.lex_state = 56, .external_lex_state = 22},
  [4288] = {.lex_state = 33, .external_lex_state = 7},
  [4289] = {.lex_state = 57, .external_lex_state = 22},
  [4290] = {.lex_state = 56, .external_lex_state = 22},
  [4291] = {.lex_state = 32, .external_lex_state = 7},
  [4292] = {.lex_state = 33, .external_lex_state = 7},
  [4293] = {.lex_state = 56, .external_lex_state = 22},
  [4294] = {.lex_state = 29, .external_lex_state = 7},
  [4295] = {.lex_state = 33, .external_lex_state = 7},
  [4296] = {.lex_state = 33, .external_lex_state = 7},
  [4297] = {.lex_state = 32, .external_lex_state = 7},
  [4298] = {.lex_state = 33, .external_lex_state = 7},
  [4299] = {.lex_state = 33, .external_lex_state = 7},
  [4300] = {.lex_state = 56, .external_lex_state = 22},
  [4301] = {.lex_state = 33, .external_lex_state = 7},
  [4302] = {.lex_state = 57, .external_lex_state = 22},
  [4303] = {.lex_state = 33, .external_lex_state = 7},
  [4304] = {.lex_state = 32, .external_lex_state = 7},
  [4305] = {.lex_state = 33, .external_lex_state = 7},
  [4306] = {.lex_state = 32, .external_lex_state = 7},
  [4307] = {.lex_state = 35, .external_lex_state = 6},
  [4308] = {.lex_state = 33, .external_lex_state = 7},
  [4309] = {.lex_state = 33, .external_lex_state = 7},
  [4310] = {.lex_state = 33, .external_lex_state = 7},
  [4311] = {.lex_state = 33, .external_lex_state = 7},
  [4312] = {.lex_state = 33, .external_lex_state = 7},
  [4313] = {.lex_state = 33, .external_lex_state = 7},
  [4314] = {.lex_state = 33, .external_lex_state = 7},
  [4315] = {.lex_state = 32, .external_lex_state = 7},
  [4316] = {.lex_state = 33, .external_lex_state = 7},
  [4317] = {.lex_state = 33, .external_lex_state = 7},
  [4318] = {.lex_state = 33, .external_lex_state = 7},
  [4319] = {.lex_state = 32, .external_lex_state = 7},
  [4320] = {.lex_state = 35, .external_lex_state = 6},
  [4321] = {.lex_state = 33, .external_lex_state = 7},
  [4322] = {.lex_state = 33, .external_lex_state = 7},
  [4323] = {.lex_state = 32, .external_lex_state = 7},
  [4324] = {.lex_state = 32, .external_lex_state = 7},
  [4325] = {.lex_state = 33, .external_lex_state = 7},
  [4326] = {.lex_state = 33, .external_lex_state = 7},
  [4327] = {.lex_state = 29, .external_lex_state = 7},
  [4328] = {.lex_state = 32, .external_lex_state = 7},
  [4329] = {.lex_state = 32, .external_lex_state = 7},
  [4330] = {.lex_state = 32, .external_lex_state = 7},
  [4331] = {.lex_state = 32, .external_lex_state = 7},
  [4332] = {.lex_state = 33, .external_lex_state = 7},
  [4333] = {.lex_state = 32, .external_lex_state = 7},
  [4334] = {.lex_state = 32, .external_lex_state = 7},
  [4335] = {.lex_state = 56, .external_lex_state = 22},
  [4336] = {.lex_state = 56, .external_lex_state = 22},
  [4337] = {.lex_state = 33, .external_lex_state = 7},
  [4338] = {.lex_state = 33, .external_lex_state = 7},
  [4339] = {.lex_state = 32, .external_lex_state = 7},
  [4340] = {.lex_state = 56, .external_lex_state = 22},
  [4341] = {.lex_state = 29, .external_lex_state = 7},
  [4342] = {.lex_state = 32, .external_lex_state = 7},
  [4343] = {.lex_state = 29, .external_lex_state = 7},
  [4344] = {.lex_state = 56, .external_lex_state = 22},
  [4345] = {.lex_state = 32, .external_lex_state = 7},
  [4346] = {.lex_state = 32, .external_lex_state = 7},
  [4347] = {.lex_state = 32, .external_lex_state = 7},
  [4348] = {.lex_state = 32, .external_lex_state = 7},
  [4349] = {.lex_state = 32, .external_lex_state = 7},
  [4350] = {.lex_state = 16, .external_lex_state = 7},
  [4351] = {.lex_state = 33, .external_lex_state = 7},
  [4352] = {.lex_state = 32, .external_lex_state = 7},
  [4353] = {.lex_state = 33, .external_lex_state = 7},
  [4354] = {.lex_state = 56, .external_lex_state = 22},
  [4355] = {.lex_state = 29, .external_lex_state = 7},
  [4356] = {.lex_state = 33, .external_lex_state = 7},
  [4357] = {.lex_state = 33, .external_lex_state = 7},
  [4358] = {.lex_state = 33, .external_lex_state = 7},
  [4359] = {.lex_state = 32, .external_lex_state = 7},
  [4360] = {.lex_state = 32, .external_lex_state = 7},
  [4361] = {.lex_state = 33, .external_lex_state = 7},
  [4362] = {.lex_state = 33, .external_lex_state = 7},
  [4363] = {.lex_state = 33, .external_lex_state = 7},
  [4364] = {.lex_state = 32, .external_lex_state = 7},
  [4365] = {.lex_state = 33, .external_lex_state = 7},
  [4366] = {.lex_state = 33, .external_lex_state = 7},
  [4367] = {.lex_state = 32, .external_lex_state = 7},
  [4368] = {.lex_state = 32, .external_lex_state = 7},
  [4369] = {.lex_state = 33, .external_lex_state = 7},
  [4370] = {.lex_state = 32, .external_lex_state = 7},
  [4371] = {.lex_state = 32, .external_lex_state = 7},
  [4372] = {.lex_state = 32, .external_lex_state = 7},
  [4373] = {.lex_state = 33, .external_lex_state = 7},
  [4374] = {.lex_state = 32, .external_lex_state = 7},
  [4375] = {.lex_state = 33, .external_lex_state = 7},
  [4376] = {.lex_state = 56, .external_lex_state = 22},
  [4377] = {.lex_state = 32, .external_lex_state = 7},
  [4378] = {.lex_state = 32, .external_lex_state = 7},
  [4379] = {.lex_state = 32, .external_lex_state = 7},
  [4380] = {.lex_state = 33, .external_lex_state = 7},
  [4381] = {.lex_state = 35, .external_lex_state = 20},
  [4382] = {.lex_state = 32, .external_lex_state = 7},
  [4383] = {.lex_state = 33, .external_lex_state = 7},
  [4384] = {.lex_state = 56, .external_lex_state = 22},
  [4385] = {.lex_state = 56, .external_lex_state = 22},
  [4386] = {.lex_state = 35, .external_lex_state = 20},
  [4387] = {.lex_state = 32, .external_lex_state = 7},
  [4388] = {.lex_state = 32, .external_lex_state = 7},
  [4389] = {.lex_state = 32, .external_lex_state = 7},
  [4390] = {.lex_state = 33, .external_lex_state = 7},
  [4391] = {.lex_state = 32, .external_lex_state = 7},
  [4392] = {.lex_state = 32, .external_lex_state = 7},
  [4393] = {.lex_state = 32, .external_lex_state = 7},
  [4394] = {.lex_state = 32, .external_lex_state = 7},
  [4395] = {.lex_state = 34, .external_lex_state = 7},
  [4396] = {.lex_state = 34, .external_lex_state = 7},
  [4397] = {.lex_state = 35, .external_lex_state = 7},
  [4398] = {.lex_state = 35, .external_lex_state = 7},
  [4399] = {.lex_state = 35, .external_lex_state = 7},
  [4400] = {.lex_state = 35, .external_lex_state = 7},
  [4401] = {.lex_state = 35, .external_lex_state = 7},
  [4402] = {.lex_state = 35, .external_lex_state = 7},
  [4403] = {.lex_state = 35, .external_lex_state = 7},
  [4404] = {.lex_state = 35, .external_lex_state = 7},
  [4405] = {.lex_state = 35, .external_lex_state = 7},
  [4406] = {.lex_state = 35, .external_lex_state = 7},
  [4407] = {.lex_state = 35, .external_lex_state = 7},
  [4408] = {.lex_state = 35, .external_lex_state = 7},
  [4409] = {.lex_state = 35, .external_lex_state = 7},
  [4410] = {.lex_state = 35, .external_lex_state = 7},
  [4411] = {.lex_state = 34, .external_lex_state = 7},
  [4412] = {.lex_state = 34, .external_lex_state = 7},
  [4413] = {.lex_state = 35, .external_lex_state = 7},
  [4414] = {.lex_state = 35, .external_lex_state = 7},
  [4415] = {.lex_state = 35, .external_lex_state = 7},
  [4416] = {.lex_state = 35, .external_lex_state = 7},
  [4417] = {.lex_state = 35, .external_lex_state = 7},
  [4418] = {.lex_state = 35, .external_lex_state = 7},
  [4419] = {.lex_state = 35, .external_lex_state = 7},
  [4420] = {.lex_state = 34, .external_lex_state = 7},
  [4421] = {.lex_state = 35, .external_lex_state = 7},
  [4422] = {.lex_state = 35, .external_lex_state = 7},
  [4423] = {.lex_state = 35, .external_lex_state = 7},
  [4424] = {.lex_state = 35, .external_lex_state = 7},
  [4425] = {.lex_state = 35, .external_lex_state = 7},
  [4426] = {.lex_state = 35, .external_lex_state = 7},
  [4427] = {.lex_state = 35, .external_lex_state = 7},
  [4428] = {.lex_state = 34, .external_lex_state = 7},
  [4429] = {.lex_state = 35, .external_lex_state = 7},
  [4430] = {.lex_state = 35, .external_lex_state = 7},
  [4431] = {.lex_state = 35, .external_lex_state = 7},
  [4432] = {.lex_state = 35, .external_lex_state = 7},
  [4433] = {.lex_state = 35, .external_lex_state = 7},
  [4434] = {.lex_state = 35, .external_lex_state = 7},
  [4435] = {.lex_state = 35, .external_lex_state = 7},
  [4436] = {.lex_state = 35, .external_lex_state = 7},
  [4437] = {.lex_state = 35, .external_lex_state = 7},
  [4438] = {.lex_state = 35, .external_lex_state = 7},
  [4439] = {.lex_state = 35, .external_lex_state = 7},
  [4440] = {.lex_state = 35, .external_lex_state = 7},
  [4441] = {.lex_state = 35, .external_lex_state = 7},
  [4442] = {.lex_state = 35, .external_lex_state = 7},
  [4443] = {.lex_state = 35, .external_lex_state = 7},
  [4444] = {.lex_state = 35, .external_lex_state = 7},
  [4445] = {.lex_state = 35, .external_lex_state = 7},
  [4446] = {.lex_state = 35, .external_lex_state = 7},
  [4447] = {.lex_state = 35, .external_lex_state = 7},
  [4448] = {.lex_state = 35, .external_lex_state = 7},
  [4449] = {.lex_state = 35, .external_lex_state = 7},
  [4450] = {.lex_state = 35, .external_lex_state = 7},
  [4451] = {.lex_state = 35, .external_lex_state = 7},
  [4452] = {.lex_state = 35, .external_lex_state = 7},
  [4453] = {.lex_state = 35, .external_lex_state = 7},
  [4454] = {.lex_state = 35, .external_lex_state = 7},
  [4455] = {.lex_state = 35, .external_lex_state = 7},
  [4456] = {.lex_state = 35, .external_lex_state = 7},
  [4457] = {.lex_state = 35, .external_lex_state = 7},
  [4458] = {.lex_state = 56, .external_lex_state = 22},
  [4459] = {.lex_state = 35, .external_lex_state = 7},
  [4460] = {.lex_state = 35, .external_lex_state = 7},
  [4461] = {.lex_state = 56, .external_lex_state = 22},
  [4462] = {.lex_state = 34, .external_lex_state = 7},
  [4463] = {.lex_state = 34, .external_lex_state = 7},
  [4464] = {.lex_state = 34, .external_lex_state = 7},
  [4465] = {.lex_state = 35, .external_lex_state = 7},
  [4466] = {.lex_state = 35, .external_lex_state = 7},
  [4467] = {.lex_state = 35, .external_lex_state = 7},
  [4468] = {.lex_state = 35, .external_lex_state = 7},
  [4469] = {.lex_state = 35, .external_lex_state = 7},
  [4470] = {.lex_state = 34, .external_lex_state = 7},
  [4471] = {.lex_state = 34, .external_lex_state = 7},
  [4472] = {.lex_state = 35, .external_lex_state = 7},
  [4473] = {.lex_state = 34, .external_lex_state = 7},
  [4474] = {.lex_state = 35, .external_lex_state = 7},
  [4475] = {.lex_state = 34, .external_lex_state = 7},
  [4476] = {.lex_state = 34, .external_lex_state = 7},
  [4477] = {.lex_state = 34, .external_lex_state = 7},
  [4478] = {.lex_state = 34, .external_lex_state = 7},
  [4479] = {.lex_state = 34, .external_lex_state = 7},
  [4480] = {.lex_state = 34, .external_lex_state = 7},
  [4481] = {.lex_state = 34, .external_lex_state = 7},
  [4482] = {.lex_state = 35, .external_lex_state = 7},
  [4483] = {.lex_state = 56, .external_lex_state = 22},
  [4484] = {.lex_state = 56, .external_lex_state = 22},
  [4485] = {.lex_state = 34, .external_lex_state = 7},
  [4486] = {.lex_state = 34, .external_lex_state = 7},
  [4487] = {.lex_state = 34, .external_lex_state = 7},
  [4488] = {.lex_state = 35, .external_lex_state = 7},
  [4489] = {.lex_state = 56, .external_lex_state = 22},
  [4490] = {.lex_state = 34, .external_lex_state = 7},
  [4491] = {.lex_state = 34, .external_lex_state = 7},
  [4492] = {.lex_state = 34, .external_lex_state = 7},
  [4493] = {.lex_state = 34, .external_lex_state = 7},
  [4494] = {.lex_state = 35, .external_lex_state = 7},
  [4495] = {.lex_state = 34, .external_lex_state = 7},
  [4496] = {.lex_state = 35, .external_lex_state = 7},
  [4497] = {.lex_state = 34, .external_lex_state = 7},
  [4498] = {.lex_state = 34, .external_lex_state = 7},
  [4499] = {.lex_state = 34, .external_lex_state = 7},
  [4500] = {.lex_state = 34, .external_lex_state = 7},
  [4501] = {.lex_state = 34, .external_lex_state = 7},
  [4502] = {.lex_state = 34, .external_lex_state = 7},
  [4503] = {.lex_state = 34, .external_lex_state = 7},
  [4504] = {.lex_state = 34, .external_lex_state = 7},
  [4505] = {.lex_state = 34, .external_lex_state = 7},
  [4506] = {.lex_state = 253, .external_lex_state = 2},
  [4507] = {.lex_state = 34, .external_lex_state = 7},
  [4508] = {.lex_state = 34, .external_lex_state = 7},
  [4509] = {.lex_state = 34, .external_lex_state = 7},
  [4510] = {.lex_state = 35, .external_lex_state = 7},
  [4511] = {.lex_state = 35, .external_lex_state = 7},
  [4512] = {.lex_state = 34, .external_lex_state = 7},
  [4513] = {.lex_state = 34, .external_lex_state = 7},
  [4514] = {.lex_state = 34, .external_lex_state = 7},
  [4515] = {.lex_state = 56, .external_lex_state = 22},
  [4516] = {.lex_state = 34, .external_lex_state = 7},
  [4517] = {.lex_state = 34, .external_lex_state = 7},
  [4518] = {.lex_state = 34, .external_lex_state = 7},
  [4519] = {.lex_state = 34, .external_lex_state = 7},
  [4520] = {.lex_state = 34, .external_lex_state = 7},
  [4521] = {.lex_state = 34, .external_lex_state = 7},
  [4522] = {.lex_state = 34, .external_lex_state = 7},
  [4523] = {.lex_state = 34, .external_lex_state = 7},
  [4524] = {.lex_state = 34, .external_lex_state = 7},
  [4525] = {.lex_state = 34, .external_lex_state = 7},
  [4526] = {.lex_state = 34, .external_lex_state = 7},
  [4527] = {.lex_state = 34, .external_lex_state = 7},
  [4528] = {.lex_state = 34, .external_lex_state = 7},
  [4529] = {.lex_state = 34, .external_lex_state = 7},
  [4530] = {.lex_state = 34, .external_lex_state = 7},
  [4531] = {.lex_state = 34, .external_lex_state = 7},
  [4532] = {.lex_state = 34, .external_lex_state = 7},
  [4533] = {.lex_state = 34, .external_lex_state = 7},
  [4534] = {.lex_state = 34, .external_lex_state = 7},
  [4535] = {.lex_state = 34, .external_lex_state = 7},
  [4536] = {.lex_state = 34, .external_lex_state = 7},
  [4537] = {.lex_state = 34, .external_lex_state = 7},
  [4538] = {.lex_state = 34, .external_lex_state = 7},
  [4539] = {.lex_state = 34, .external_lex_state = 7},
  [4540] = {.lex_state = 34, .external_lex_state = 7},
  [4541] = {.lex_state = 34, .external_lex_state = 7},
  [4542] = {.lex_state = 34, .external_lex_state = 7},
  [4543] = {.lex_state = 34, .external_lex_state = 7},
  [4544] = {.lex_state = 34, .external_lex_state = 7},
  [4545] = {.lex_state = 34, .external_lex_state = 7},
  [4546] = {.lex_state = 34, .external_lex_state = 7},
  [4547] = {.lex_state = 34, .external_lex_state = 7},
  [4548] = {.lex_state = 34, .external_lex_state = 7},
  [4549] = {.lex_state = 34, .external_lex_state = 7},
  [4550] = {.lex_state = 34, .external_lex_state = 7},
  [4551] = {.lex_state = 35, .external_lex_state = 7},
  [4552] = {.lex_state = 34, .external_lex_state = 7},
  [4553] = {.lex_state = 34, .external_lex_state = 7},
  [4554] = {.lex_state = 34, .external_lex_state = 7},
  [4555] = {.lex_state = 34, .external_lex_state = 7},
  [4556] = {.lex_state = 34, .external_lex_state = 7},
  [4557] = {.lex_state = 56, .external_lex_state = 22},
  [4558] = {.lex_state = 34, .external_lex_state = 7},
  [4559] = {.lex_state = 34, .external_lex_state = 7},
  [4560] = {.lex_state = 35, .external_lex_state = 7},
  [4561] = {.lex_state = 34, .external_lex_state = 7},
  [4562] = {.lex_state = 34, .external_lex_state = 7},
  [4563] = {.lex_state = 34, .external_lex_state = 7},
  [4564] = {.lex_state = 253, .external_lex_state = 2},
  [4565] = {.lex_state = 34, .external_lex_state = 7},
  [4566] = {.lex_state = 34, .external_lex_state = 7},
  [4567] = {.lex_state = 34, .external_lex_state = 7},
  [4568] = {.lex_state = 56, .external_lex_state = 22},
  [4569] = {.lex_state = 34, .external_lex_state = 7},
  [4570] = {.lex_state = 56, .external_lex_state = 22},
  [4571] = {.lex_state = 56, .external_lex_state = 22},
  [4572] = {.lex_state = 253, .external_lex_state = 2},
  [4573] = {.lex_state = 35, .external_lex_state = 7},
  [4574] = {.lex_state = 35, .external_lex_state = 7},
  [4575] = {.lex_state = 34, .external_lex_state = 7},
  [4576] = {.lex_state = 34, .external_lex_state = 7},
  [4577] = {.lex_state = 34, .external_lex_state = 7},
  [4578] = {.lex_state = 34, .external_lex_state = 7},
  [4579] = {.lex_state = 34, .external_lex_state = 7},
  [4580] = {.lex_state = 34, .external_lex_state = 7},
  [4581] = {.lex_state = 34, .external_lex_state = 7},
  [4582] = {.lex_state = 34, .external_lex_state = 7},
  [4583] = {.lex_state = 34, .external_lex_state = 7},
  [4584] = {.lex_state = 34, .external_lex_state = 7},
  [4585] = {.lex_state = 34, .external_lex_state = 7},
  [4586] = {.lex_state = 35, .external_lex_state = 7},
  [4587] = {.lex_state = 35, .external_lex_state = 7},
  [4588] = {.lex_state = 35, .external_lex_state = 7},
  [4589] = {.lex_state = 35, .external_lex_state = 7},
  [4590] = {.lex_state = 35, .external_lex_state = 7},
  [4591] = {.lex_state = 35, .external_lex_state = 7},
  [4592] = {.lex_state = 35, .external_lex_state = 7},
  [4593] = {.lex_state = 35, .external_lex_state = 7},
  [4594] = {.lex_state = 35, .external_lex_state = 7},
  [4595] = {.lex_state = 35, .external_lex_state = 7},
  [4596] = {.lex_state = 35, .external_lex_state = 7},
  [4597] = {.lex_state = 35, .external_lex_state = 7},
  [4598] = {.lex_state = 35, .external_lex_state = 7},
  [4599] = {.lex_state = 34, .external_lex_state = 7},
  [4600] = {.lex_state = 34, .external_lex_state = 7},
  [4601] = {.lex_state = 35, .external_lex_state = 7},
  [4602] = {.lex_state = 34, .external_lex_state = 7},
  [4603] = {.lex_state = 34, .external_lex_state = 7},
  [4604] = {.lex_state = 35, .external_lex_state = 7},
  [4605] = {.lex_state = 35, .external_lex_state = 7},
  [4606] = {.lex_state = 34, .external_lex_state = 7},
  [4607] = {.lex_state = 35, .external_lex_state = 7},
  [4608] = {.lex_state = 35, .external_lex_state = 7},
  [4609] = {.lex_state = 35, .external_lex_state = 7},
  [4610] = {.lex_state = 35, .external_lex_state = 7},
  [4611] = {.lex_state = 35, .external_lex_state = 7},
  [4612] = {.lex_state = 34, .external_lex_state = 7},
  [4613] = {.lex_state = 34, .external_lex_state = 7},
  [4614] = {.lex_state = 35, .external_lex_state = 7},
  [4615] = {.lex_state = 35, .external_lex_state = 7},
  [4616] = {.lex_state = 34, .external_lex_state = 7},
  [4617] = {.lex_state = 35, .external_lex_state = 7},
  [4618] = {.lex_state = 35, .external_lex_state = 7},
  [4619] = {.lex_state = 35, .external_lex_state = 7},
  [4620] = {.lex_state = 35, .external_lex_state = 7},
  [4621] = {.lex_state = 35, .external_lex_state = 7},
  [4622] = {.lex_state = 35, .external_lex_state = 7},
  [4623] = {.lex_state = 35, .external_lex_state = 7},
  [4624] = {.lex_state = 35, .external_lex_state = 7},
  [4625] = {.lex_state = 35, .external_lex_state = 7},
  [4626] = {.lex_state = 35, .external_lex_state = 7},
  [4627] = {.lex_state = 35, .external_lex_state = 7},
  [4628] = {.lex_state = 35, .external_lex_state = 7},
  [4629] = {.lex_state = 35, .external_lex_state = 7},
  [4630] = {.lex_state = 35, .external_lex_state = 7},
  [4631] = {.lex_state = 35, .external_lex_state = 7},
  [4632] = {.lex_state = 34, .external_lex_state = 7},
  [4633] = {.lex_state = 34, .external_lex_state = 7},
  [4634] = {.lex_state = 34, .external_lex_state = 7},
  [4635] = {.lex_state = 35, .external_lex_state = 7},
  [4636] = {.lex_state = 35, .external_lex_state = 7},
  [4637] = {.lex_state = 35, .external_lex_state = 7},
  [4638] = {.lex_state = 35, .external_lex_state = 7},
  [4639] = {.lex_state = 34, .external_lex_state = 7},
  [4640] = {.lex_state = 35, .external_lex_state = 7},
  [4641] = {.lex_state = 49, .external_lex_state = 9},
  [4642] = {.lex_state = 49, .external_lex_state = 9},
  [4643] = {.lex_state = 50, .external_lex_state = 9},
  [4644] = {.lex_state = 56, .external_lex_state = 22},
  [4645] = {.lex_state = 56, .external_lex_state = 22},
  [4646] = {.lex_state = 56, .external_lex_state = 22},
  [4647] = {.lex_state = 35, .external_lex_state = 9},
  [4648] = {.lex_state = 56, .external_lex_state = 22},
  [4649] = {.lex_state = 254, .external_lex_state = 2},
  [4650] = {.lex_state = 56, .external_lex_state = 22},
  [4651] = {.lex_state = 56, .external_lex_state = 22},
  [4652] = {.lex_state = 35, .external_lex_state = 9},
  [4653] = {.lex_state = 35, .external_lex_state = 9},
  [4654] = {.lex_state = 50, .external_lex_state = 23},
  [4655] = {.lex_state = 254, .external_lex_state = 2},
  [4656] = {.lex_state = 56, .external_lex_state = 22},
  [4657] = {.lex_state = 64, .external_lex_state = 21},
  [4658] = {.lex_state = 64, .external_lex_state = 21},
  [4659] = {.lex_state = 64, .external_lex_state = 21},
  [4660] = {.lex_state = 56, .external_lex_state = 22},
  [4661] = {.lex_state = 64, .external_lex_state = 21},
  [4662] = {.lex_state = 64, .external_lex_state = 21},
  [4663] = {.lex_state = 64, .external_lex_state = 21},
  [4664] = {.lex_state = 64, .external_lex_state = 21},
  [4665] = {.lex_state = 64, .external_lex_state = 21},
  [4666] = {.lex_state = 64, .external_lex_state = 21},
  [4667] = {.lex_state = 50, .external_lex_state = 9},
  [4668] = {.lex_state = 64, .external_lex_state = 21},
  [4669] = {.lex_state = 64, .external_lex_state = 21},
  [4670] = {.lex_state = 64, .external_lex_state = 21},
  [4671] = {.lex_state = 64, .external_lex_state = 21},
  [4672] = {.lex_state = 64, .external_lex_state = 21},
  [4673] = {.lex_state = 64, .external_lex_state = 21},
  [4674] = {.lex_state = 64, .external_lex_state = 21},
  [4675] = {.lex_state = 64, .external_lex_state = 21},
  [4676] = {.lex_state = 64, .external_lex_state = 21},
  [4677] = {.lex_state = 64, .external_lex_state = 21},
  [4678] = {.lex_state = 64, .external_lex_state = 21},
  [4679] = {.lex_state = 64, .external_lex_state = 21},
  [4680] = {.lex_state = 64, .external_lex_state = 21},
  [4681] = {.lex_state = 64, .external_lex_state = 21},
  [4682] = {.lex_state = 64, .external_lex_state = 21},
  [4683] = {.lex_state = 64, .external_lex_state = 21},
  [4684] = {.lex_state = 64, .external_lex_state = 21},
  [4685] = {.lex_state = 64, .external_lex_state = 21},
  [4686] = {.lex_state = 64, .external_lex_state = 21},
  [4687] = {.lex_state = 50, .external_lex_state = 24},
  [4688] = {.lex_state = 64, .external_lex_state = 21},
  [4689] = {.lex_state = 64, .external_lex_state = 21},
  [4690] = {.lex_state = 64, .external_lex_state = 21},
  [4691] = {.lex_state = 64, .external_lex_state = 21},
  [4692] = {.lex_state = 64, .external_lex_state = 21},
  [4693] = {.lex_state = 64, .external_lex_state = 21},
  [4694] = {.lex_state = 64, .external_lex_state = 21},
  [4695] = {.lex_state = 64, .external_lex_state = 21},
  [4696] = {.lex_state = 64, .external_lex_state = 21},
  [4697] = {.lex_state = 64, .external_lex_state = 21},
  [4698] = {.lex_state = 64, .external_lex_state = 21},
  [4699] = {.lex_state = 64, .external_lex_state = 21},
  [4700] = {.lex_state = 64, .external_lex_state = 21},
  [4701] = {.lex_state = 56, .external_lex_state = 22},
  [4702] = {.lex_state = 64, .external_lex_state = 21},
  [4703] = {.lex_state = 64, .external_lex_state = 21},
  [4704] = {.lex_state = 64, .external_lex_state = 21},
  [4705] = {.lex_state = 64, .external_lex_state = 21},
  [4706] = {.lex_state = 64, .external_lex_state = 21},
  [4707] = {.lex_state = 64, .external_lex_state = 21},
  [4708] = {.lex_state = 64, .external_lex_state = 21},
  [4709] = {.lex_state = 64, .external_lex_state = 21},
  [4710] = {.lex_state = 64, .external_lex_state = 21},
  [4711] = {.lex_state = 64, .external_lex_state = 21},
  [4712] = {.lex_state = 64, .external_lex_state = 21},
  [4713] = {.lex_state = 64, .external_lex_state = 21},
  [4714] = {.lex_state = 64, .external_lex_state = 21},
  [4715] = {.lex_state = 64, .external_lex_state = 21},
  [4716] = {.lex_state = 64, .external_lex_state = 21},
  [4717] = {.lex_state = 64, .external_lex_state = 21},
  [4718] = {.lex_state = 50, .external_lex_state = 9},
  [4719] = {.lex_state = 50, .external_lex_state = 9},
  [4720] = {.lex_state = 50, .external_lex_state = 9},
  [4721] = {.lex_state = 50, .external_lex_state = 9},
  [4722] = {.lex_state = 50, .external_lex_state = 9},
  [4723] = {.lex_state = 64, .external_lex_state = 21},
  [4724] = {.lex_state = 64, .external_lex_state = 21},
  [4725] = {.lex_state = 64, .external_lex_state = 21},
  [4726] = {.lex_state = 64, .external_lex_state = 21},
  [4727] = {.lex_state = 64, .external_lex_state = 21},
  [4728] = {.lex_state = 64, .external_lex_state = 21},
  [4729] = {.lex_state = 64, .external_lex_state = 21},
  [4730] = {.lex_state = 64, .external_lex_state = 21},
  [4731] = {.lex_state = 64, .external_lex_state = 21},
  [4732] = {.lex_state = 64, .external_lex_state = 21},
  [4733] = {.lex_state = 64, .external_lex_state = 21},
  [4734] = {.lex_state = 64, .external_lex_state = 21},
  [4735] = {.lex_state = 64, .external_lex_state = 21},
  [4736] = {.lex_state = 64, .external_lex_state = 21},
  [4737] = {.lex_state = 50, .external_lex_state = 7},
  [4738] = {.lex_state = 64, .external_lex_state = 21},
  [4739] = {.lex_state = 64, .external_lex_state = 21},
  [4740] = {.lex_state = 64, .external_lex_state = 21},
  [4741] = {.lex_state = 64, .external_lex_state = 21},
  [4742] = {.lex_state = 64, .external_lex_state = 21},
  [4743] = {.lex_state = 64, .external_lex_state = 21},
  [4744] = {.lex_state = 64, .external_lex_state = 21},
  [4745] = {.lex_state = 64, .external_lex_state = 21},
  [4746] = {.lex_state = 64, .external_lex_state = 21},
  [4747] = {.lex_state = 64, .external_lex_state = 21},
  [4748] = {.lex_state = 64, .external_lex_state = 21},
  [4749] = {.lex_state = 64, .external_lex_state = 25},
  [4750] = {.lex_state = 64, .external_lex_state = 25},
  [4751] = {.lex_state = 64, .external_lex_state = 25},
  [4752] = {.lex_state = 64, .external_lex_state = 25},
  [4753] = {.lex_state = 64, .external_lex_state = 25},
  [4754] = {.lex_state = 58, .external_lex_state = 26},
  [4755] = {.lex_state = 64, .external_lex_state = 25},
  [4756] = {.lex_state = 64, .external_lex_state = 25},
  [4757] = {.lex_state = 64, .external_lex_state = 25},
  [4758] = {.lex_state = 64, .external_lex_state = 25},
  [4759] = {.lex_state = 64, .external_lex_state = 25},
  [4760] = {.lex_state = 58, .external_lex_state = 26},
  [4761] = {.lex_state = 64, .external_lex_state = 25},
  [4762] = {.lex_state = 64, .external_lex_state = 25},
  [4763] = {.lex_state = 64, .external_lex_state = 25},
  [4764] = {.lex_state = 64, .external_lex_state = 25},
  [4765] = {.lex_state = 64, .external_lex_state = 25},
  [4766] = {.lex_state = 64, .external_lex_state = 25},
  [4767] = {.lex_state = 64, .external_lex_state = 25},
  [4768] = {.lex_state = 64, .external_lex_state = 25},
  [4769] = {.lex_state = 58, .external_lex_state = 27},
  [4770] = {.lex_state = 64, .external_lex_state = 25},
  [4771] = {.lex_state = 58, .external_lex_state = 27},
  [4772] = {.lex_state = 64, .external_lex_state = 25},
  [4773] = {.lex_state = 58, .external_lex_state = 21},
  [4774] = {.lex_state = 58, .external_lex_state = 21},
  [4775] = {.lex_state = 64, .external_lex_state = 25},
  [4776] = {.lex_state = 64, .external_lex_state = 25},
  [4777] = {.lex_state = 64, .external_lex_state = 25},
  [4778] = {.lex_state = 64, .external_lex_state = 25},
  [4779] = {.lex_state = 64, .external_lex_state = 21},
  [4780] = {.lex_state = 64, .external_lex_state = 21},
  [4781] = {.lex_state = 64, .external_lex_state = 21},
  [4782] = {.lex_state = 64, .external_lex_state = 21},
  [4783] = {.lex_state = 64, .external_lex_state = 21},
  [4784] = {.lex_state = 64, .external_lex_state = 21},
  [4785] = {.lex_state = 64, .external_lex_state = 21},
  [4786] = {.lex_state = 64, .external_lex_state = 21},
  [4787] = {.lex_state = 64, .external_lex_state = 21},
  [4788] = {.lex_state = 64, .external_lex_state = 21},
  [4789] = {.lex_state = 64, .external_lex_state = 21},
  [4790] = {.lex_state = 64, .external_lex_state = 21},
  [4791] = {.lex_state = 64, .external_lex_state = 21},
  [4792] = {.lex_state = 64, .external_lex_state = 21},
  [4793] = {.lex_state = 64, .external_lex_state = 21},
  [4794] = {.lex_state = 64, .external_lex_state = 21},
  [4795] = {.lex_state = 64, .external_lex_state = 21},
  [4796] = {.lex_state = 64, .external_lex_state = 21},
  [4797] = {.lex_state = 64, .external_lex_state = 21},
  [4798] = {.lex_state = 64, .external_lex_state = 21},
  [4799] = {.lex_state = 64, .external_lex_state = 21},
  [4800] = {.lex_state = 64, .external_lex_state = 21},
  [4801] = {.lex_state = 64, .external_lex_state = 21},
  [4802] = {.lex_state = 64, .external_lex_state = 21},
  [4803] = {.lex_state = 64, .external_lex_state = 21},
  [4804] = {.lex_state = 64, .external_lex_state = 21},
  [4805] = {.lex_state = 64, .external_lex_state = 21},
  [4806] = {.lex_state = 64, .external_lex_state = 21},
  [4807] = {.lex_state = 64, .external_lex_state = 21},
  [4808] = {.lex_state = 64, .external_lex_state = 21},
  [4809] = {.lex_state = 64, .external_lex_state = 21},
  [4810] = {.lex_state = 64, .external_lex_state = 21},
  [4811] = {.lex_state = 64, .external_lex_state = 21},
  [4812] = {.lex_state = 64, .external_lex_state = 21},
  [4813] = {.lex_state = 64, .external_lex_state = 21},
  [4814] = {.lex_state = 64, .external_lex_state = 21},
  [4815] = {.lex_state = 64, .external_lex_state = 21},
  [4816] = {.lex_state = 64, .external_lex_state = 21},
  [4817] = {.lex_state = 64, .external_lex_state = 21},
  [4818] = {.lex_state = 64, .external_lex_state = 21},
  [4819] = {.lex_state = 64, .external_lex_state = 21},
  [4820] = {.lex_state = 64, .external_lex_state = 21},
  [4821] = {.lex_state = 64, .external_lex_state = 21},
  [4822] = {.lex_state = 64, .external_lex_state = 21},
  [4823] = {.lex_state = 64, .external_lex_state = 21},
  [4824] = {.lex_state = 64, .external_lex_state = 21},
  [4825] = {.lex_state = 64, .external_lex_state = 21},
  [4826] = {.lex_state = 64, .external_lex_state = 21},
  [4827] = {.lex_state = 64, .external_lex_state = 21},
  [4828] = {.lex_state = 64, .external_lex_state = 21},
  [4829] = {.lex_state = 64, .external_lex_state = 21},
  [4830] = {.lex_state = 64, .external_lex_state = 21},
  [4831] = {.lex_state = 64, .external_lex_state = 21},
  [4832] = {.lex_state = 64, .external_lex_state = 21},
  [4833] = {.lex_state = 64, .external_lex_state = 21},
  [4834] = {.lex_state = 64, .external_lex_state = 21},
  [4835] = {.lex_state = 64, .external_lex_state = 21},
  [4836] = {.lex_state = 64, .external_lex_state = 21},
  [4837] = {.lex_state = 64, .external_lex_state = 21},
  [4838] = {.lex_state = 64, .external_lex_state = 21},
  [4839] = {.lex_state = 64, .external_lex_state = 21},
  [4840] = {.lex_state = 64, .external_lex_state = 21},
  [4841] = {.lex_state = 64, .external_lex_state = 21},
  [4842] = {.lex_state = 64, .external_lex_state = 21},
  [4843] = {.lex_state = 64, .external_lex_state = 21},
  [4844] = {.lex_state = 64, .external_lex_state = 21},
  [4845] = {.lex_state = 64, .external_lex_state = 21},
  [4846] = {.lex_state = 64, .external_lex_state = 21},
  [4847] = {.lex_state = 64, .external_lex_state = 21},
  [4848] = {.lex_state = 64, .external_lex_state = 21},
  [4849] = {.lex_state = 64, .external_lex_state = 21},
  [4850] = {.lex_state = 64, .external_lex_state = 21},
  [4851] = {.lex_state = 64, .external_lex_state = 21},
  [4852] = {.lex_state = 64, .external_lex_state = 21},
  [4853] = {.lex_state = 64, .external_lex_state = 21},
  [4854] = {.lex_state = 64, .external_lex_state = 21},
  [4855] = {.lex_state = 64, .external_lex_state = 21},
  [4856] = {.lex_state = 64, .external_lex_state = 21},
  [4857] = {.lex_state = 64, .external_lex_state = 21},
  [4858] = {.lex_state = 58, .external_lex_state = 21},
  [4859] = {.lex_state = 58, .external_lex_state = 21},
  [4860] = {.lex_state = 43, .external_lex_state = 28},
  [4861] = {.lex_state = 251, .external_lex_state = 2},
  [4862] = {.lex_state = 43, .external_lex_state = 21},
  [4863] = {.lex_state = 43, .external_lex_state = 28},
  [4864] = {.lex_state = 43, .external_lex_state = 21},
  [4865] = {.lex_state = 253, .external_lex_state = 29},
  [4866] = {.lex_state = 58, .external_lex_state = 21},
  [4867] = {.lex_state = 253, .external_lex_state = 29},
  [4868] = {.lex_state = 43, .external_lex_state = 28},
  [4869] = {.lex_state = 43, .external_lex_state = 21},
  [4870] = {.lex_state = 43, .external_lex_state = 21},
  [4871] = {.lex_state = 43, .external_lex_state = 21},
  [4872] = {.lex_state = 43, .external_lex_state = 21},
  [4873] = {.lex_state = 43, .external_lex_state = 21},
  [4874] = {.lex_state = 43, .external_lex_state = 21},
  [4875] = {.lex_state = 43, .external_lex_state = 21},
  [4876] = {.lex_state = 251, .external_lex_state = 2},
  [4877] = {.lex_state = 58, .external_lex_state = 21},
  [4878] = {.lex_state = 43, .external_lex_state = 21},
  [4879] = {.lex_state = 251, .external_lex_state = 2},
  [4880] = {.lex_state = 58, .external_lex_state = 21},
  [4881] = {.lex_state = 43, .external_lex_state = 21},
  [4882] = {.lex_state = 43, .external_lex_state = 21},
  [4883] = {.lex_state = 43, .external_lex_state = 21},
  [4884] = {.lex_state = 253, .external_lex_state = 30},
  [4885] = {.lex_state = 43, .external_lex_state = 21},
  [4886] = {.lex_state = 58, .external_lex_state = 21},
  [4887] = {.lex_state = 43, .external_lex_state = 21},
  [4888] = {.lex_state = 43, .external_lex_state = 21},
  [4889] = {.lex_state = 43, .external_lex_state = 21},
  [4890] = {.lex_state = 65, .external_lex_state = 28},
  [4891] = {.lex_state = 65, .external_lex_state = 28},
  [4892] = {.lex_state = 43, .external_lex_state = 21},
  [4893] = {.lex_state = 253, .external_lex_state = 30},
  [4894] = {.lex_state = 43, .external_lex_state = 21},
  [4895] = {.lex_state = 43, .external_lex_state = 21},
  [4896] = {.lex_state = 43, .external_lex_state = 21},
  [4897] = {.lex_state = 43, .external_lex_state = 21},
  [4898] = {.lex_state = 65, .external_lex_state = 28},
  [4899] = {.lex_state = 43, .external_lex_state = 21},
  [4900] = {.lex_state = 43, .external_lex_state = 21},
  [4901] = {.lex_state = 43, .external_lex_state = 21},
  [4902] = {.lex_state = 43, .external_lex_state = 21},
  [4903] = {.lex_state = 43, .external_lex_state = 21},
  [4904] = {.lex_state = 251, .external_lex_state = 2},
  [4905] = {.lex_state = 43, .external_lex_state = 21},
  [4906] = {.lex_state = 65, .external_lex_state = 27},
  [4907] = {.lex_state = 58, .external_lex_state = 21},
  [4908] = {.lex_state = 255, .external_lex_state = 2},
  [4909] = {.lex_state = 65, .external_lex_state = 27},
  [4910] = {.lex_state = 253, .external_lex_state = 2},
  [4911] = {.lex_state = 253, .external_lex_state = 2},
  [4912] = {.lex_state = 58, .external_lex_state = 21},
  [4913] = {.lex_state = 253, .external_lex_state = 2},
  [4914] = {.lex_state = 253, .external_lex_state = 2},
  [4915] = {.lex_state = 65, .external_lex_state = 27},
  [4916] = {.lex_state = 253, .external_lex_state = 2},
  [4917] = {.lex_state = 43, .external_lex_state = 27},
  [4918] = {.lex_state = 43, .external_lex_state = 27},
  [4919] = {.lex_state = 253, .external_lex_state = 2},
  [4920] = {.lex_state = 253, .external_lex_state = 2},
  [4921] = {.lex_state = 253, .external_lex_state = 2},
  [4922] = {.lex_state = 43, .external_lex_state = 27},
  [4923] = {.lex_state = 253, .external_lex_state = 2},
  [4924] = {.lex_state = 58, .external_lex_state = 21},
  [4925] = {.lex_state = 253, .external_lex_state = 2},
  [4926] = {.lex_state = 253, .external_lex_state = 2},
  [4927] = {.lex_state = 255, .external_lex_state = 2},
  [4928] = {.lex_state = 253, .external_lex_state = 2},
  [4929] = {.lex_state = 58, .external_lex_state = 21},
  [4930] = {.lex_state = 45, .external_lex_state = 21},
  [4931] = {.lex_state = 256, .external_lex_state = 2},
  [4932] = {.lex_state = 65, .external_lex_state = 21},
  [4933] = {.lex_state = 65, .external_lex_state = 21},
  [4934] = {.lex_state = 45, .external_lex_state = 21},
  [4935] = {.lex_state = 65, .external_lex_state = 21},
  [4936] = {.lex_state = 256, .external_lex_state = 2},
  [4937] = {.lex_state = 45, .external_lex_state = 21},
  [4938] = {.lex_state = 58, .external_lex_state = 21},
  [4939] = {.lex_state = 58, .external_lex_state = 26},
  [4940] = {.lex_state = 43, .external_lex_state = 21},
  [4941] = {.lex_state = 58, .external_lex_state = 27},
  [4942] = {.lex_state = 58, .external_lex_state = 21},
  [4943] = {.lex_state = 43, .external_lex_state = 21},
  [4944] = {.lex_state = 58, .external_lex_state = 27},
  [4945] = {.lex_state = 58, .external_lex_state = 26},
  [4946] = {.lex_state = 58, .external_lex_state = 27},
  [4947] = {.lex_state = 58, .external_lex_state = 21},
  [4948] = {.lex_state = 58, .external_lex_state = 21},
  [4949] = {.lex_state = 58, .external_lex_state = 21},
  [4950] = {.lex_state = 58, .external_lex_state = 21},
  [4951] = {.lex_state = 58, .external_lex_state = 27},
  [4952] = {.lex_state = 58, .external_lex_state = 21},
  [4953] = {.lex_state = 58, .external_lex_state = 27},
  [4954] = {.lex_state = 58, .external_lex_state = 27},
  [4955] = {.lex_state = 58, .external_lex_state = 27},
  [4956] = {.lex_state = 58, .external_lex_state = 21},
  [4957] = {.lex_state = 58, .external_lex_state = 21},
  [4958] = {.lex_state = 58, .external_lex_state = 27},
  [4959] = {.lex_state = 58, .external_lex_state = 27},
  [4960] = {.lex_state = 58, .external_lex_state = 21},
  [4961] = {.lex_state = 58, .external_lex_state = 21},
  [4962] = {.lex_state = 58, .external_lex_state = 27},
  [4963] = {.lex_state = 58, .external_lex_state = 21},
  [4964] = {.lex_state = 58, .external_lex_state = 27},
  [4965] = {.lex_state = 58, .external_lex_state = 27},
  [4966] = {.lex_state = 58, .external_lex_state = 26},
  [4967] = {.lex_state = 58, .external_lex_state = 21},
  [4968] = {.lex_state = 58, .external_lex_state = 27},
  [4969] = {.lex_state = 58, .external_lex_state = 27},
  [4970] = {.lex_state = 58, .external_lex_state = 21},
  [4971] = {.lex_state = 58, .external_lex_state = 26},
  [4972] = {.lex_state = 43, .external_lex_state = 21},
  [4973] = {.lex_state = 58, .external_lex_state = 26},
  [4974] = {.lex_state = 43, .external_lex_state = 21},
  [4975] = {.lex_state = 58, .external_lex_state = 26},
  [4976] = {.lex_state = 43, .external_lex_state = 21},
  [4977] = {.lex_state = 58, .external_lex_state = 26},
  [4978] = {.lex_state = 58, .external_lex_state = 26},
  [4979] = {.lex_state = 58, .external_lex_state = 26},
  [4980] = {.lex_state = 43, .external_lex_state = 21},
  [4981] = {.lex_state = 43, .external_lex_state = 21},
  [4982] = {.lex_state = 43, .external_lex_state = 21},
  [4983] = {.lex_state = 43, .external_lex_state = 21},
  [4984] = {.lex_state = 43, .external_lex_state = 21},
  [4985] = {.lex_state = 58, .external_lex_state = 26},
  [4986] = {.lex_state = 43, .external_lex_state = 21},
  [4987] = {.lex_state = 58, .external_lex_state = 26},
  [4988] = {.lex_state = 43, .external_lex_state = 21},
  [4989] = {.lex_state = 43, .external_lex_state = 21},
  [4990] = {.lex_state = 43, .external_lex_state = 21},
  [4991] = {.lex_state = 43, .external_lex_state = 21},
  [4992] = {.lex_state = 43, .external_lex_state = 21},
  [4993] = {.lex_state = 43, .external_lex_state = 21},
  [4994] = {.lex_state = 43, .external_lex_state = 21},
  [4995] = {.lex_state = 43, .external_lex_state = 21},
  [4996] = {.lex_state = 43, .external_lex_state = 21},
  [4997] = {.lex_state = 43, .external_lex_state = 21},
  [4998] = {.lex_state = 43, .external_lex_state = 21},
  [4999] = {.lex_state = 43, .external_lex_state = 21},
  [5000] = {.lex_state = 254, .external_lex_state = 2},
  [5001] = {.lex_state = 58, .external_lex_state = 27},
  [5002] = {.lex_state = 43, .external_lex_state = 21},
  [5003] = {.lex_state = 43, .external_lex_state = 21},
  [5004] = {.lex_state = 58, .external_lex_state = 26},
  [5005] = {.lex_state = 58, .external_lex_state = 26},
  [5006] = {.lex_state = 256, .external_lex_state = 2},
  [5007] = {.lex_state = 256, .external_lex_state = 2},
  [5008] = {.lex_state = 43, .external_lex_state = 21},
  [5009] = {.lex_state = 43, .external_lex_state = 21},
  [5010] = {.lex_state = 43, .external_lex_state = 21},
  [5011] = {.lex_state = 58, .external_lex_state = 26},
  [5012] = {.lex_state = 256, .external_lex_state = 2},
  [5013] = {.lex_state = 43, .external_lex_state = 21},
  [5014] = {.lex_state = 254, .external_lex_state = 2},
  [5015] = {.lex_state = 254, .external_lex_state = 2},
  [5016] = {.lex_state = 254, .external_lex_state = 2},
  [5017] = {.lex_state = 254, .external_lex_state = 2},
  [5018] = {.lex_state = 254, .external_lex_state = 2},
  [5019] = {.lex_state = 254, .external_lex_state = 2},
  [5020] = {.lex_state = 254, .external_lex_state = 2},
  [5021] = {.lex_state = 254, .external_lex_state = 2},
  [5022] = {.lex_state = 41, .external_lex_state = 28},
  [5023] = {.lex_state = 41, .external_lex_state = 21},
  [5024] = {.lex_state = 43, .external_lex_state = 31},
  [5025] = {.lex_state = 254, .external_lex_state = 2},
  [5026] = {.lex_state = 43, .external_lex_state = 32},
  [5027] = {.lex_state = 254, .external_lex_state = 2},
  [5028] = {.lex_state = 254, .external_lex_state = 2},
  [5029] = {.lex_state = 254, .external_lex_state = 2},
  [5030] = {.lex_state = 254, .external_lex_state = 2},
  [5031] = {.lex_state = 41, .external_lex_state = 21},
  [5032] = {.lex_state = 254, .external_lex_state = 2},
  [5033] = {.lex_state = 254, .external_lex_state = 2},
  [5034] = {.lex_state = 43, .external_lex_state = 31},
  [5035] = {.lex_state = 254, .external_lex_state = 2},
  [5036] = {.lex_state = 254, .external_lex_state = 2},
  [5037] = {.lex_state = 43, .external_lex_state = 32},
  [5038] = {.lex_state = 254, .external_lex_state = 2},
  [5039] = {.lex_state = 61, .external_lex_state = 28},
  [5040] = {.lex_state = 254, .external_lex_state = 2},
  [5041] = {.lex_state = 58, .external_lex_state = 32},
  [5042] = {.lex_state = 254, .external_lex_state = 2},
  [5043] = {.lex_state = 41, .external_lex_state = 28},
  [5044] = {.lex_state = 43, .external_lex_state = 33},
  [5045] = {.lex_state = 43, .external_lex_state = 33},
  [5046] = {.lex_state = 256, .external_lex_state = 2},
  [5047] = {.lex_state = 256, .external_lex_state = 2},
  [5048] = {.lex_state = 41, .external_lex_state = 28},
  [5049] = {.lex_state = 65, .external_lex_state = 31},
  [5050] = {.lex_state = 41, .external_lex_state = 21},
  [5051] = {.lex_state = 43, .external_lex_state = 34},
  [5052] = {.lex_state = 41, .external_lex_state = 28},
  [5053] = {.lex_state = 65, .external_lex_state = 31},
  [5054] = {.lex_state = 58, .external_lex_state = 21},
  [5055] = {.lex_state = 43, .external_lex_state = 34},
  [5056] = {.lex_state = 254, .external_lex_state = 2},
  [5057] = {.lex_state = 41, .external_lex_state = 21},
  [5058] = {.lex_state = 58, .external_lex_state = 32},
  [5059] = {.lex_state = 256, .external_lex_state = 2},
  [5060] = {.lex_state = 254, .external_lex_state = 2},
  [5061] = {.lex_state = 43, .external_lex_state = 28},
  [5062] = {.lex_state = 58, .external_lex_state = 33},
  [5063] = {.lex_state = 43, .external_lex_state = 28},
  [5064] = {.lex_state = 43, .external_lex_state = 28},
  [5065] = {.lex_state = 254, .external_lex_state = 2},
  [5066] = {.lex_state = 254, .external_lex_state = 2},
  [5067] = {.lex_state = 43, .external_lex_state = 21},
  [5068] = {.lex_state = 254, .external_lex_state = 2},
  [5069] = {.lex_state = 61, .external_lex_state = 28},
  [5070] = {.lex_state = 61, .external_lex_state = 28},
  [5071] = {.lex_state = 254, .external_lex_state = 2},
  [5072] = {.lex_state = 43, .external_lex_state = 21},
  [5073] = {.lex_state = 43, .external_lex_state = 28},
  [5074] = {.lex_state = 254, .external_lex_state = 2},
  [5075] = {.lex_state = 254, .external_lex_state = 2},
  [5076] = {.lex_state = 254, .external_lex_state = 2},
  [5077] = {.lex_state = 43, .external_lex_state = 21},
  [5078] = {.lex_state = 43, .external_lex_state = 28},
  [5079] = {.lex_state = 65, .external_lex_state = 35},
  [5080] = {.lex_state = 254, .external_lex_state = 2},
  [5081] = {.lex_state = 254, .external_lex_state = 2},
  [5082] = {.lex_state = 254, .external_lex_state = 2},
  [5083] = {.lex_state = 65, .external_lex_state = 35},
  [5084] = {.lex_state = 43, .external_lex_state = 35},
  [5085] = {.lex_state = 43, .external_lex_state = 28},
  [5086] = {.lex_state = 254, .external_lex_state = 2},
  [5087] = {.lex_state = 43, .external_lex_state = 28},
  [5088] = {.lex_state = 254, .external_lex_state = 2},
  [5089] = {.lex_state = 43, .external_lex_state = 21},
  [5090] = {.lex_state = 254, .external_lex_state = 2},
  [5091] = {.lex_state = 43, .external_lex_state = 21},
  [5092] = {.lex_state = 254, .external_lex_state = 2},
  [5093] = {.lex_state = 61, .external_lex_state = 28},
  [5094] = {.lex_state = 254, .external_lex_state = 2},
  [5095] = {.lex_state = 65, .external_lex_state = 34},
  [5096] = {.lex_state = 254, .external_lex_state = 2},
  [5097] = {.lex_state = 254, .external_lex_state = 2},
  [5098] = {.lex_state = 43, .external_lex_state = 28},
  [5099] = {.lex_state = 254, .external_lex_state = 2},
  [5100] = {.lex_state = 254, .external_lex_state = 2},
  [5101] = {.lex_state = 254, .external_lex_state = 2},
  [5102] = {.lex_state = 43, .external_lex_state = 21},
  [5103] = {.lex_state = 254, .external_lex_state = 2},
  [5104] = {.lex_state = 254, .external_lex_state = 2},
  [5105] = {.lex_state = 43, .external_lex_state = 28},
  [5106] = {.lex_state = 43, .external_lex_state = 21},
  [5107] = {.lex_state = 254, .external_lex_state = 2},
  [5108] = {.lex_state = 254, .external_lex_state = 2},
  [5109] = {.lex_state = 43, .external_lex_state = 21},
  [5110] = {.lex_state = 43, .external_lex_state = 28},
  [5111] = {.lex_state = 41, .external_lex_state = 27},
  [5112] = {.lex_state = 43, .external_lex_state = 21},
  [5113] = {.lex_state = 254, .external_lex_state = 2},
  [5114] = {.lex_state = 43, .external_lex_state = 35},
  [5115] = {.lex_state = 43, .external_lex_state = 21},
  [5116] = {.lex_state = 65, .external_lex_state = 34},
  [5117] = {.lex_state = 43, .external_lex_state = 28},
  [5118] = {.lex_state = 254, .external_lex_state = 2},
  [5119] = {.lex_state = 254, .external_lex_state = 2},
  [5120] = {.lex_state = 43, .external_lex_state = 21},
  [5121] = {.lex_state = 43, .external_lex_state = 28},
  [5122] = {.lex_state = 254, .external_lex_state = 2},
  [5123] = {.lex_state = 254, .external_lex_state = 2},
  [5124] = {.lex_state = 61, .external_lex_state = 27},
  [5125] = {.lex_state = 254, .external_lex_state = 2},
  [5126] = {.lex_state = 43, .external_lex_state = 21},
  [5127] = {.lex_state = 254, .external_lex_state = 2},
  [5128] = {.lex_state = 58, .external_lex_state = 33},
  [5129] = {.lex_state = 254, .external_lex_state = 2},
  [5130] = {.lex_state = 65, .external_lex_state = 28},
  [5131] = {.lex_state = 61, .external_lex_state = 27},
  [5132] = {.lex_state = 65, .external_lex_state = 28},
  [5133] = {.lex_state = 65, .external_lex_state = 28},
  [5134] = {.lex_state = 58, .external_lex_state = 21},
  [5135] = {.lex_state = 61, .external_lex_state = 27},
  [5136] = {.lex_state = 61, .external_lex_state = 21},
  [5137] = {.lex_state = 61, .external_lex_state = 27},
  [5138] = {.lex_state = 42, .external_lex_state = 21},
  [5139] = {.lex_state = 65, .external_lex_state = 28},
  [5140] = {.lex_state = 58, .external_lex_state = 21},
  [5141] = {.lex_state = 42, .external_lex_state = 21},
  [5142] = {.lex_state = 58, .external_lex_state = 21},
  [5143] = {.lex_state = 58, .external_lex_state = 21},
  [5144] = {.lex_state = 41, .external_lex_state = 27},
  [5145] = {.lex_state = 65, .external_lex_state = 28},
  [5146] = {.lex_state = 65, .external_lex_state = 28},
  [5147] = {.lex_state = 65, .external_lex_state = 32},
  [5148] = {.lex_state = 65, .external_lex_state = 28},
  [5149] = {.lex_state = 58, .external_lex_state = 21},
  [5150] = {.lex_state = 65, .external_lex_state = 28},
  [5151] = {.lex_state = 65, .external_lex_state = 28},
  [5152] = {.lex_state = 255, .external_lex_state = 28},
  [5153] = {.lex_state = 7, .external_lex_state = 21},
  [5154] = {.lex_state = 65, .external_lex_state = 28},
  [5155] = {.lex_state = 71, .external_lex_state = 28},
  [5156] = {.lex_state = 71, .external_lex_state = 28},
  [5157] = {.lex_state = 65, .external_lex_state = 32},
  [5158] = {.lex_state = 65, .external_lex_state = 36},
  [5159] = {.lex_state = 43, .external_lex_state = 36},
  [5160] = {.lex_state = 45, .external_lex_state = 32},
  [5161] = {.lex_state = 58, .external_lex_state = 21},
  [5162] = {.lex_state = 42, .external_lex_state = 21},
  [5163] = {.lex_state = 58, .external_lex_state = 21},
  [5164] = {.lex_state = 45, .external_lex_state = 32},
  [5165] = {.lex_state = 43, .external_lex_state = 36},
  [5166] = {.lex_state = 65, .external_lex_state = 28},
  [5167] = {.lex_state = 255, .external_lex_state = 28},
  [5168] = {.lex_state = 58, .external_lex_state = 21},
  [5169] = {.lex_state = 41, .external_lex_state = 27},
  [5170] = {.lex_state = 42, .external_lex_state = 21},
  [5171] = {.lex_state = 65, .external_lex_state = 36},
  [5172] = {.lex_state = 41, .external_lex_state = 27},
  [5173] = {.lex_state = 65, .external_lex_state = 28},
  [5174] = {.lex_state = 65, .external_lex_state = 27},
  [5175] = {.lex_state = 71, .external_lex_state = 27},
  [5176] = {.lex_state = 43, .external_lex_state = 27},
  [5177] = {.lex_state = 255, .external_lex_state = 27},
  [5178] = {.lex_state = 252, .external_lex_state = 28},
  [5179] = {.lex_state = 65, .external_lex_state = 27},
  [5180] = {.lex_state = 65, .external_lex_state = 27},
  [5181] = {.lex_state = 42, .external_lex_state = 21},
  [5182] = {.lex_state = 43, .external_lex_state = 27},
  [5183] = {.lex_state = 61, .external_lex_state = 21},
  [5184] = {.lex_state = 72, .external_lex_state = 28},
  [5185] = {.lex_state = 255, .external_lex_state = 21},
  [5186] = {.lex_state = 43, .external_lex_state = 27},
  [5187] = {.lex_state = 43, .external_lex_state = 27},
  [5188] = {.lex_state = 43, .external_lex_state = 27},
  [5189] = {.lex_state = 65, .external_lex_state = 27},
  [5190] = {.lex_state = 65, .external_lex_state = 27},
  [5191] = {.lex_state = 65, .external_lex_state = 27},
  [5192] = {.lex_state = 65, .external_lex_state = 33},
  [5193] = {.lex_state = 255, .external_lex_state = 21},
  [5194] = {.lex_state = 64, .external_lex_state = 21},
  [5195] = {.lex_state = 65, .external_lex_state = 27},
  [5196] = {.lex_state = 43, .external_lex_state = 27},
  [5197] = {.lex_state = 65, .external_lex_state = 27},
  [5198] = {.lex_state = 42, .external_lex_state = 21},
  [5199] = {.lex_state = 72, .external_lex_state = 28},
  [5200] = {.lex_state = 43, .external_lex_state = 27},
  [5201] = {.lex_state = 64, .external_lex_state = 21},
  [5202] = {.lex_state = 61, .external_lex_state = 21},
  [5203] = {.lex_state = 43, .external_lex_state = 27},
  [5204] = {.lex_state = 65, .external_lex_state = 33},
  [5205] = {.lex_state = 252, .external_lex_state = 28},
  [5206] = {.lex_state = 61, .external_lex_state = 21},
  [5207] = {.lex_state = 45, .external_lex_state = 33},
  [5208] = {.lex_state = 65, .external_lex_state = 27},
  [5209] = {.lex_state = 45, .external_lex_state = 33},
  [5210] = {.lex_state = 255, .external_lex_state = 27},
  [5211] = {.lex_state = 43, .external_lex_state = 27},
  [5212] = {.lex_state = 65, .external_lex_state = 27},
  [5213] = {.lex_state = 43, .external_lex_state = 27},
  [5214] = {.lex_state = 43, .external_lex_state = 27},
  [5215] = {.lex_state = 65, .external_lex_state = 27},
  [5216] = {.lex_state = 71, .external_lex_state = 27},
  [5217] = {.lex_state = 65, .external_lex_state = 27},
  [5218] = {.lex_state = 43, .external_lex_state = 27},
  [5219] = {.lex_state = 7, .external_lex_state = 21},
  [5220] = {.lex_state = 64, .external_lex_state = 21},
  [5221] = {.lex_state = 45, .external_lex_state = 21},
  [5222] = {.lex_state = 45, .external_lex_state = 21},
  [5223] = {.lex_state = 7, .external_lex_state = 21},
  [5224] = {.lex_state = 7, .external_lex_state = 21},
  [5225] = {.lex_state = 65, .external_lex_state = 21},
  [5226] = {.lex_state = 45, .external_lex_state = 21},
  [5227] = {.lex_state = 45, .external_lex_state = 21},
  [5228] = {.lex_state = 7, .external_lex_state = 21},
  [5229] = {.lex_state = 7, .external_lex_state = 21},
  [5230] = {.lex_state = 45, .external_lex_state = 21},
  [5231] = {.lex_state = 47, .external_lex_state = 21},
  [5232] = {.lex_state = 7, .external_lex_state = 21},
  [5233] = {.lex_state = 7, .external_lex_state = 21},
  [5234] = {.lex_state = 7, .external_lex_state = 21},
  [5235] = {.lex_state = 65, .external_lex_state = 21},
  [5236] = {.lex_state = 7, .external_lex_state = 21},
  [5237] = {.lex_state = 45, .external_lex_state = 21},
  [5238] = {.lex_state = 7, .external_lex_state = 21},
  [5239] = {.lex_state = 65, .external_lex_state = 21},
  [5240] = {.lex_state = 45, .external_lex_state = 21},
  [5241] = {.lex_state = 7, .external_lex_state = 21},
  [5242] = {.lex_state = 7, .external_lex_state = 21},
  [5243] = {.lex_state = 45, .external_lex_state = 21},
  [5244] = {.lex_state = 71, .external_lex_state = 21},
  [5245] = {.lex_state = 65, .external_lex_state = 21},
  [5246] = {.lex_state = 7, .external_lex_state = 21},
  [5247] = {.lex_state = 65, .external_lex_state = 21},
  [5248] = {.lex_state = 45, .external_lex_state = 21},
  [5249] = {.lex_state = 71, .external_lex_state = 21},
  [5250] = {.lex_state = 65, .external_lex_state = 21},
  [5251] = {.lex_state = 65, .external_lex_state = 21},
  [5252] = {.lex_state = 64, .external_lex_state = 21},
  [5253] = {.lex_state = 65, .external_lex_state = 21},
  [5254] = {.lex_state = 47, .external_lex_state = 21},
  [5255] = {.lex_state = 7, .external_lex_state = 21},
  [5256] = {.lex_state = 65, .external_lex_state = 21},
  [5257] = {.lex_state = 7, .external_lex_state = 21},
  [5258] = {.lex_state = 45, .external_lex_state = 21},
  [5259] = {.lex_state = 45, .external_lex_state = 21},
  [5260] = {.lex_state = 45, .external_lex_state = 21},
  [5261] = {.lex_state = 7, .external_lex_state = 21},
  [5262] = {.lex_state = 65, .external_lex_state = 21},
  [5263] = {.lex_state = 65, .external_lex_state = 21},
  [5264] = {.lex_state = 65, .external_lex_state = 21},
  [5265] = {.lex_state = 7, .external_lex_state = 21},
  [5266] = {.lex_state = 7, .external_lex_state = 21},
  [5267] = {.lex_state = 7, .external_lex_state = 21},
  [5268] = {.lex_state = 48, .external_lex_state = 21},
  [5269] = {.lex_state = 48, .external_lex_state = 21},
  [5270] = {.lex_state = 48, .external_lex_state = 21},
  [5271] = {.lex_state = 48, .external_lex_state = 21},
  [5272] = {.lex_state = 72, .external_lex_state = 21},
  [5273] = {.lex_state = 48, .external_lex_state = 21},
  [5274] = {.lex_state = 48, .external_lex_state = 21},
  [5275] = {.lex_state = 48, .external_lex_state = 21},
  [5276] = {.lex_state = 48, .external_lex_state = 21},
  [5277] = {.lex_state = 48, .external_lex_state = 21},
  [5278] = {.lex_state = 48, .external_lex_state = 21},
  [5279] = {.lex_state = 252, .external_lex_state = 21},
  [5280] = {.lex_state = 48, .external_lex_state = 21},
  [5281] = {.lex_state = 48, .external_lex_state = 21},
  [5282] = {.lex_state = 48, .external_lex_state = 21},
  [5283] = {.lex_state = 48, .external_lex_state = 21},
  [5284] = {.lex_state = 48, .external_lex_state = 21},
  [5285] = {.lex_state = 72, .external_lex_state = 21},
  [5286] = {.lex_state = 252, .external_lex_state = 21},
  [5287] = {.lex_state = 48, .external_lex_state = 21},
  [5288] = {.lex_state = 48, .external_lex_state = 21},
  [5289] = {.lex_state = 48, .external_lex_state = 21},
  [5290] = {.lex_state = 48, .external_lex_state = 21},
  [5291] = {.lex_state = 48, .external_lex_state = 21},
  [5292] = {.lex_state = 48, .external_lex_state = 21},
  [5293] = {.lex_state = 48, .external_lex_state = 21},
  [5294] = {.lex_state = 48, .external_lex_state = 21},
  [5295] = {.lex_state = 43, .external_lex_state = 21},
  [5296] = {.lex_state = 43, .external_lex_state = 21},
  [5297] = {.lex_state = 43, .external_lex_state = 21},
  [5298] = {.lex_state = 43, .external_lex_state = 21},
  [5299] = {.lex_state = 43, .external_lex_state = 21},
  [5300] = {.lex_state = 43, .external_lex_state = 21},
  [5301] = {.lex_state = 43, .external_lex_state = 21},
  [5302] = {.lex_state = 7, .external_lex_state = 21},
  [5303] = {.lex_state = 43, .external_lex_state = 21},
  [5304] = {.lex_state = 43, .external_lex_state = 21},
  [5305] = {.lex_state = 7, .external_lex_state = 21},
  [5306] = {.lex_state = 43, .external_lex_state = 21},
  [5307] = {.lex_state = 43, .external_lex_state = 21},
  [5308] = {.lex_state = 43, .external_lex_state = 21},
  [5309] = {.lex_state = 43, .external_lex_state = 21},
  [5310] = {.lex_state = 43, .external_lex_state = 21},
  [5311] = {.lex_state = 43, .external_lex_state = 21},
  [5312] = {.lex_state = 43, .external_lex_state = 21},
  [5313] = {.lex_state = 43, .external_lex_state = 21},
  [5314] = {.lex_state = 43, .external_lex_state = 21},
  [5315] = {.lex_state = 43, .external_lex_state = 21},
  [5316] = {.lex_state = 43, .external_lex_state = 21},
  [5317] = {.lex_state = 43, .external_lex_state = 21},
  [5318] = {.lex_state = 43, .external_lex_state = 21},
  [5319] = {.lex_state = 43, .external_lex_state = 21},
  [5320] = {.lex_state = 43, .external_lex_state = 21},
  [5321] = {.lex_state = 43, .external_lex_state = 21},
  [5322] = {.lex_state = 43, .external_lex_state = 21},
  [5323] = {.lex_state = 43, .external_lex_state = 21},
  [5324] = {.lex_state = 43, .external_lex_state = 21},
  [5325] = {.lex_state = 48, .external_lex_state = 21},
  [5326] = {.lex_state = 43, .external_lex_state = 21},
  [5327] = {.lex_state = 43, .external_lex_state = 21},
  [5328] = {.lex_state = 43, .external_lex_state = 21},
  [5329] = {.lex_state = 43, .external_lex_state = 21},
  [5330] = {.lex_state = 80, .external_lex_state = 21},
  [5331] = {.lex_state = 0, .external_lex_state = 21},
  [5332] = {.lex_state = 0, .external_lex_state = 21},
  [5333] = {.lex_state = 0, .external_lex_state = 21},
  [5334] = {.lex_state = 0, .external_lex_state = 21},
  [5335] = {.lex_state = 0, .external_lex_state = 21},
  [5336] = {.lex_state = 0, .external_lex_state = 21},
  [5337] = {.lex_state = 0, .external_lex_state = 21},
  [5338] = {.lex_state = 0, .external_lex_state = 26},
  [5339] = {.lex_state = 0, .external_lex_state = 21},
  [5340] = {.lex_state = 0, .external_lex_state = 21},
  [5341] = {.lex_state = 0, .external_lex_state = 21},
  [5342] = {.lex_state = 0, .external_lex_state = 21},
  [5343] = {.lex_state = 0, .external_lex_state = 21},
  [5344] = {.lex_state = 43, .external_lex_state = 37},
  [5345] = {.lex_state = 0, .external_lex_state = 21},
  [5346] = {.lex_state = 0, .external_lex_state = 21},
  [5347] = {.lex_state = 7, .external_lex_state = 21},
  [5348] = {.lex_state = 43, .external_lex_state = 21},
  [5349] = {.lex_state = 0, .external_lex_state = 21},
  [5350] = {.lex_state = 7, .external_lex_state = 21},
  [5351] = {.lex_state = 0, .external_lex_state = 21},
  [5352] = {.lex_state = 0, .external_lex_state = 27},
  [5353] = {.lex_state = 0, .external_lex_state = 26},
  [5354] = {.lex_state = 0, .external_lex_state = 21},
  [5355] = {.lex_state = 0, .external_lex_state = 21},
  [5356] = {.lex_state = 0, .external_lex_state = 21},
  [5357] = {.lex_state = 43, .external_lex_state = 37},
  [5358] = {.lex_state = 43, .external_lex_state = 21},
  [5359] = {.lex_state = 43, .external_lex_state = 21},
  [5360] = {.lex_state = 0, .external_lex_state = 27},
  [5361] = {.lex_state = 0, .external_lex_state = 21},
  [5362] = {.lex_state = 0, .external_lex_state = 21},
  [5363] = {.lex_state = 0, .external_lex_state = 21},
  [5364] = {.lex_state = 0, .external_lex_state = 27},
  [5365] = {.lex_state = 0, .external_lex_state = 21},
  [5366] = {.lex_state = 43, .external_lex_state = 37},
  [5367] = {.lex_state = 0, .external_lex_state = 21},
  [5368] = {.lex_state = 0, .external_lex_state = 21},
  [5369] = {.lex_state = 0, .external_lex_state = 26},
  [5370] = {.lex_state = 1, .external_lex_state = 21},
  [5371] = {.lex_state = 1, .external_lex_state = 21},
  [5372] = {.lex_state = 1, .external_lex_state = 21},
  [5373] = {.lex_state = 1, .external_lex_state = 21},
  [5374] = {.lex_state = 1, .external_lex_state = 21},
  [5375] = {.lex_state = 1, .external_lex_state = 21},
  [5376] = {.lex_state = 0, .external_lex_state = 28},
  [5377] = {.lex_state = 43, .external_lex_state = 21},
  [5378] = {.lex_state = 1, .external_lex_state = 21},
  [5379] = {.lex_state = 1, .external_lex_state = 21},
  [5380] = {.lex_state = 43, .external_lex_state = 21},
  [5381] = {.lex_state = 1, .external_lex_state = 21},
  [5382] = {.lex_state = 1, .external_lex_state = 21},
  [5383] = {.lex_state = 1, .external_lex_state = 21},
  [5384] = {.lex_state = 1, .external_lex_state = 21},
  [5385] = {.lex_state = 1, .external_lex_state = 21},
  [5386] = {.lex_state = 1, .external_lex_state = 21},
  [5387] = {.lex_state = 1, .external_lex_state = 21},
  [5388] = {.lex_state = 1, .external_lex_state = 21},
  [5389] = {.lex_state = 1, .external_lex_state = 21},
  [5390] = {.lex_state = 1, .external_lex_state = 21},
  [5391] = {.lex_state = 1, .external_lex_state = 21},
  [5392] = {.lex_state = 58, .external_lex_state = 21},
  [5393] = {.lex_state = 1, .external_lex_state = 21},
  [5394] = {.lex_state = 1, .external_lex_state = 21},
  [5395] = {.lex_state = 1, .external_lex_state = 21},
  [5396] = {.lex_state = 1, .external_lex_state = 21},
  [5397] = {.lex_state = 1, .external_lex_state = 21},
  [5398] = {.lex_state = 0, .external_lex_state = 28},
  [5399] = {.lex_state = 1, .external_lex_state = 21},
  [5400] = {.lex_state = 1, .external_lex_state = 21},
  [5401] = {.lex_state = 0, .external_lex_state = 28},
  [5402] = {.lex_state = 1, .external_lex_state = 21},
  [5403] = {.lex_state = 1, .external_lex_state = 21},
  [5404] = {.lex_state = 48, .external_lex_state = 21},
  [5405] = {.lex_state = 0, .external_lex_state = 28},
  [5406] = {.lex_state = 48, .external_lex_state = 21},
  [5407] = {.lex_state = 1, .external_lex_state = 21},
  [5408] = {.lex_state = 1, .external_lex_state = 21},
  [5409] = {.lex_state = 1, .external_lex_state = 21},
  [5410] = {.lex_state = 1, .external_lex_state = 21},
  [5411] = {.lex_state = 1, .external_lex_state = 21},
  [5412] = {.lex_state = 1, .external_lex_state = 21},
  [5413] = {.lex_state = 1, .external_lex_state = 21},
  [5414] = {.lex_state = 0, .external_lex_state = 28},
  [5415] = {.lex_state = 1, .external_lex_state = 21},
  [5416] = {.lex_state = 1, .external_lex_state = 21},
  [5417] = {.lex_state = 1, .external_lex_state = 21},
  [5418] = {.lex_state = 1, .external_lex_state = 21},
  [5419] = {.lex_state = 1, .external_lex_state = 21},
  [5420] = {.lex_state = 1, .external_lex_state = 21},
  [5421] = {.lex_state = 1, .external_lex_state = 21},
  [5422] = {.lex_state = 1, .external_lex_state = 21},
  [5423] = {.lex_state = 81, .external_lex_state = 25},
  [5424] = {.lex_state = 4, .external_lex_state = 21},
  [5425] = {.lex_state = 4, .external_lex_state = 21},
  [5426] = {.lex_state = 4, .external_lex_state = 21},
  [5427] = {.lex_state = 81, .external_lex_state = 28},
  [5428] = {.lex_state = 0, .external_lex_state = 21},
  [5429] = {.lex_state = 48, .external_lex_state = 21},
  [5430] = {.lex_state = 0, .external_lex_state = 28},
  [5431] = {.lex_state = 0, .external_lex_state = 21},
  [5432] = {.lex_state = 4, .external_lex_state = 21},
  [5433] = {.lex_state = 43, .external_lex_state = 21},
  [5434] = {.lex_state = 43, .external_lex_state = 21},
  [5435] = {.lex_state = 4, .external_lex_state = 21},
  [5436] = {.lex_state = 4, .external_lex_state = 21},
  [5437] = {.lex_state = 4, .external_lex_state = 21},
  [5438] = {.lex_state = 4, .external_lex_state = 21},
  [5439] = {.lex_state = 48, .external_lex_state = 21},
  [5440] = {.lex_state = 4, .external_lex_state = 21},
  [5441] = {.lex_state = 0, .external_lex_state = 21},
  [5442] = {.lex_state = 0, .external_lex_state = 21},
  [5443] = {.lex_state = 0, .external_lex_state = 21},
  [5444] = {.lex_state = 4, .external_lex_state = 21},
  [5445] = {.lex_state = 4, .external_lex_state = 21},
  [5446] = {.lex_state = 4, .external_lex_state = 21},
  [5447] = {.lex_state = 4, .external_lex_state = 21},
  [5448] = {.lex_state = 4, .external_lex_state = 21},
  [5449] = {.lex_state = 4, .external_lex_state = 21},
  [5450] = {.lex_state = 4, .external_lex_state = 21},
  [5451] = {.lex_state = 0, .external_lex_state = 21},
  [5452] = {.lex_state = 4, .external_lex_state = 21},
  [5453] = {.lex_state = 4, .external_lex_state = 21},
  [5454] = {.lex_state = 4, .external_lex_state = 21},
  [5455] = {.lex_state = 0, .external_lex_state = 21},
  [5456] = {.lex_state = 4, .external_lex_state = 21},
  [5457] = {.lex_state = 4, .external_lex_state = 21},
  [5458] = {.lex_state = 0, .external_lex_state = 21},
  [5459] = {.lex_state = 0, .external_lex_state = 28},
  [5460] = {.lex_state = 0, .external_lex_state = 21},
  [5461] = {.lex_state = 0, .external_lex_state = 21},
  [5462] = {.lex_state = 4, .external_lex_state = 21},
  [5463] = {.lex_state = 4, .external_lex_state = 21},
  [5464] = {.lex_state = 0, .external_lex_state = 21},
  [5465] = {.lex_state = 4, .external_lex_state = 21},
  [5466] = {.lex_state = 0, .external_lex_state = 21},
  [5467] = {.lex_state = 81, .external_lex_state = 28},
  [5468] = {.lex_state = 4, .external_lex_state = 21},
  [5469] = {.lex_state = 0, .external_lex_state = 21},
  [5470] = {.lex_state = 0, .external_lex_state = 21},
  [5471] = {.lex_state = 4, .external_lex_state = 21},
  [5472] = {.lex_state = 4, .external_lex_state = 21},
  [5473] = {.lex_state = 4, .external_lex_state = 21},
  [5474] = {.lex_state = 4, .external_lex_state = 21},
  [5475] = {.lex_state = 4, .external_lex_state = 21},
  [5476] = {.lex_state = 0, .external_lex_state = 21},
  [5477] = {.lex_state = 4, .external_lex_state = 21},
  [5478] = {.lex_state = 0, .external_lex_state = 21},
  [5479] = {.lex_state = 4, .external_lex_state = 21},
  [5480] = {.lex_state = 0, .external_lex_state = 28},
  [5481] = {.lex_state = 0, .external_lex_state = 21},
  [5482] = {.lex_state = 4, .external_lex_state = 21},
  [5483] = {.lex_state = 0, .external_lex_state = 21},
  [5484] = {.lex_state = 0, .external_lex_state = 21},
  [5485] = {.lex_state = 0, .external_lex_state = 21},
  [5486] = {.lex_state = 0, .external_lex_state = 26},
  [5487] = {.lex_state = 4, .external_lex_state = 21},
  [5488] = {.lex_state = 112, .external_lex_state = 28},
  [5489] = {.lex_state = 4, .external_lex_state = 21},
  [5490] = {.lex_state = 0, .external_lex_state = 27},
  [5491] = {.lex_state = 0, .external_lex_state = 21},
  [5492] = {.lex_state = 0, .external_lex_state = 21},
  [5493] = {.lex_state = 0, .external_lex_state = 21},
  [5494] = {.lex_state = 81, .external_lex_state = 28},
  [5495] = {.lex_state = 4, .external_lex_state = 21},
  [5496] = {.lex_state = 4, .external_lex_state = 21},
  [5497] = {.lex_state = 81, .external_lex_state = 27},
  [5498] = {.lex_state = 43, .external_lex_state = 21},
  [5499] = {.lex_state = 4, .external_lex_state = 21},
  [5500] = {.lex_state = 0, .external_lex_state = 21},
  [5501] = {.lex_state = 0, .external_lex_state = 21},
  [5502] = {.lex_state = 4, .external_lex_state = 21},
  [5503] = {.lex_state = 0, .external_lex_state = 21},
  [5504] = {.lex_state = 4, .external_lex_state = 21},
  [5505] = {.lex_state = 4, .external_lex_state = 21},
  [5506] = {.lex_state = 7, .external_lex_state = 21},
  [5507] = {.lex_state = 4, .external_lex_state = 21},
  [5508] = {.lex_state = 4, .external_lex_state = 21},
  [5509] = {.lex_state = 0, .external_lex_state = 27},
  [5510] = {.lex_state = 7, .external_lex_state = 21},
  [5511] = {.lex_state = 0, .external_lex_state = 28},
  [5512] = {.lex_state = 0, .external_lex_state = 28},
  [5513] = {.lex_state = 0, .external_lex_state = 27},
  [5514] = {.lex_state = 81, .external_lex_state = 21},
  [5515] = {.lex_state = 7, .external_lex_state = 21},
  [5516] = {.lex_state = 0, .external_lex_state = 26},
  [5517] = {.lex_state = 81, .external_lex_state = 21},
  [5518] = {.lex_state = 0, .external_lex_state = 28},
  [5519] = {.lex_state = 81, .external_lex_state = 25},
  [5520] = {.lex_state = 0, .external_lex_state = 28},
  [5521] = {.lex_state = 0, .external_lex_state = 26},
  [5522] = {.lex_state = 0, .external_lex_state = 28},
  [5523] = {.lex_state = 0, .external_lex_state = 28},
  [5524] = {.lex_state = 0, .external_lex_state = 28},
  [5525] = {.lex_state = 81, .external_lex_state = 25},
  [5526] = {.lex_state = 0, .external_lex_state = 28},
  [5527] = {.lex_state = 80, .external_lex_state = 21},
  [5528] = {.lex_state = 7, .external_lex_state = 21},
  [5529] = {.lex_state = 0, .external_lex_state = 28},
  [5530] = {.lex_state = 0, .external_lex_state = 28},
  [5531] = {.lex_state = 0, .external_lex_state = 28},
  [5532] = {.lex_state = 0, .external_lex_state = 28},
  [5533] = {.lex_state = 81, .external_lex_state = 21},
  [5534] = {.lex_state = 0, .external_lex_state = 28},
  [5535] = {.lex_state = 0, .external_lex_state = 28},
  [5536] = {.lex_state = 0, .external_lex_state = 21},
  [5537] = {.lex_state = 0, .external_lex_state = 21},
  [5538] = {.lex_state = 0, .external_lex_state = 28},
  [5539] = {.lex_state = 0, .external_lex_state = 21},
  [5540] = {.lex_state = 0, .external_lex_state = 28},
  [5541] = {.lex_state = 0, .external_lex_state = 28},
  [5542] = {.lex_state = 0, .external_lex_state = 28},
  [5543] = {.lex_state = 0, .external_lex_state = 28},
  [5544] = {.lex_state = 0, .external_lex_state = 28},
  [5545] = {.lex_state = 0, .external_lex_state = 28},
  [5546] = {.lex_state = 0, .external_lex_state = 28},
  [5547] = {.lex_state = 0, .external_lex_state = 28},
  [5548] = {.lex_state = 0, .external_lex_state = 28},
  [5549] = {.lex_state = 0, .external_lex_state = 28},
  [5550] = {.lex_state = 0, .external_lex_state = 28},
  [5551] = {.lex_state = 43, .external_lex_state = 37},
  [5552] = {.lex_state = 0, .external_lex_state = 28},
  [5553] = {.lex_state = 0, .external_lex_state = 28},
  [5554] = {.lex_state = 0, .external_lex_state = 28},
  [5555] = {.lex_state = 0, .external_lex_state = 26},
  [5556] = {.lex_state = 0, .external_lex_state = 28},
  [5557] = {.lex_state = 0, .external_lex_state = 28},
  [5558] = {.lex_state = 0, .external_lex_state = 28},
  [5559] = {.lex_state = 0, .external_lex_state = 28},
  [5560] = {.lex_state = 0, .external_lex_state = 28},
  [5561] = {.lex_state = 81, .external_lex_state = 21},
  [5562] = {.lex_state = 0, .external_lex_state = 28},
  [5563] = {.lex_state = 0, .external_lex_state = 27},
  [5564] = {.lex_state = 0, .external_lex_state = 27},
  [5565] = {.lex_state = 81, .external_lex_state = 21},
  [5566] = {.lex_state = 0, .external_lex_state = 28},
  [5567] = {.lex_state = 0, .external_lex_state = 28},
  [5568] = {.lex_state = 80, .external_lex_state = 21},
  [5569] = {.lex_state = 0, .external_lex_state = 27},
  [5570] = {.lex_state = 0, .external_lex_state = 28},
  [5571] = {.lex_state = 0, .external_lex_state = 26},
  [5572] = {.lex_state = 0, .external_lex_state = 28},
  [5573] = {.lex_state = 0, .external_lex_state = 28},
  [5574] = {.lex_state = 112, .external_lex_state = 27},
  [5575] = {.lex_state = 0, .external_lex_state = 28},
  [5576] = {.lex_state = 7, .external_lex_state = 21},
  [5577] = {.lex_state = 0, .external_lex_state = 21},
  [5578] = {.lex_state = 0, .external_lex_state = 27},
  [5579] = {.lex_state = 81, .external_lex_state = 27},
  [5580] = {.lex_state = 7, .external_lex_state = 21},
  [5581] = {.lex_state = 0, .external_lex_state = 28},
  [5582] = {.lex_state = 0, .external_lex_state = 28},
  [5583] = {.lex_state = 81, .external_lex_state = 21},
  [5584] = {.lex_state = 7, .external_lex_state = 21},
  [5585] = {.lex_state = 81, .external_lex_state = 21},
  [5586] = {.lex_state = 0, .external_lex_state = 21},
  [5587] = {.lex_state = 0, .external_lex_state = 28},
  [5588] = {.lex_state = 7, .external_lex_state = 21},
  [5589] = {.lex_state = 0, .external_lex_state = 28},
  [5590] = {.lex_state = 0, .external_lex_state = 28},
  [5591] = {.lex_state = 0, .external_lex_state = 28},
  [5592] = {.lex_state = 0, .external_lex_state = 28},
  [5593] = {.lex_state = 0, .external_lex_state = 28},
  [5594] = {.lex_state = 0, .external_lex_state = 28},
  [5595] = {.lex_state = 0, .external_lex_state = 28},
  [5596] = {.lex_state = 0, .external_lex_state = 28},
  [5597] = {.lex_state = 0, .external_lex_state = 28},
  [5598] = {.lex_state = 0, .external_lex_state = 28},
  [5599] = {.lex_state = 0, .external_lex_state = 27},
  [5600] = {.lex_state = 0, .external_lex_state = 28},
  [5601] = {.lex_state = 0, .external_lex_state = 28},
  [5602] = {.lex_state = 0, .external_lex_state = 28},
  [5603] = {.lex_state = 0, .external_lex_state = 26},
  [5604] = {.lex_state = 0, .external_lex_state = 28},
  [5605] = {.lex_state = 0, .external_lex_state = 28},
  [5606] = {.lex_state = 0, .external_lex_state = 28},
  [5607] = {.lex_state = 0, .external_lex_state = 28},
  [5608] = {.lex_state = 0, .external_lex_state = 28},
  [5609] = {.lex_state = 0, .external_lex_state = 28},
  [5610] = {.lex_state = 0, .external_lex_state = 28},
  [5611] = {.lex_state = 0, .external_lex_state = 21},
  [5612] = {.lex_state = 0, .external_lex_state = 28},
  [5613] = {.lex_state = 0, .external_lex_state = 28},
  [5614] = {.lex_state = 0, .external_lex_state = 28},
  [5615] = {.lex_state = 0, .external_lex_state = 28},
  [5616] = {.lex_state = 0, .external_lex_state = 28},
  [5617] = {.lex_state = 0, .external_lex_state = 28},
  [5618] = {.lex_state = 0, .external_lex_state = 28},
  [5619] = {.lex_state = 0, .external_lex_state = 28},
  [5620] = {.lex_state = 0, .external_lex_state = 28},
  [5621] = {.lex_state = 0, .external_lex_state = 28},
  [5622] = {.lex_state = 0, .external_lex_state = 28},
  [5623] = {.lex_state = 0, .external_lex_state = 28},
  [5624] = {.lex_state = 0, .external_lex_state = 28},
  [5625] = {.lex_state = 0, .external_lex_state = 28},
  [5626] = {.lex_state = 43, .external_lex_state = 21},
  [5627] = {.lex_state = 0, .external_lex_state = 28},
  [5628] = {.lex_state = 43, .external_lex_state = 21},
  [5629] = {.lex_state = 0, .external_lex_state = 28},
  [5630] = {.lex_state = 0, .external_lex_state = 28},
  [5631] = {.lex_state = 0, .external_lex_state = 28},
  [5632] = {.lex_state = 0, .external_lex_state = 28},
  [5633] = {.lex_state = 0, .external_lex_state = 28},
  [5634] = {.lex_state = 0, .external_lex_state = 28},
  [5635] = {.lex_state = 0, .external_lex_state = 28},
  [5636] = {.lex_state = 0, .external_lex_state = 28},
  [5637] = {.lex_state = 81, .external_lex_state = 21},
  [5638] = {.lex_state = 7, .external_lex_state = 21},
  [5639] = {.lex_state = 0, .external_lex_state = 28},
  [5640] = {.lex_state = 0, .external_lex_state = 21},
  [5641] = {.lex_state = 0, .external_lex_state = 28},
  [5642] = {.lex_state = 0, .external_lex_state = 28},
  [5643] = {.lex_state = 0, .external_lex_state = 21},
  [5644] = {.lex_state = 81, .external_lex_state = 21},
  [5645] = {.lex_state = 0, .external_lex_state = 28},
  [5646] = {.lex_state = 0, .external_lex_state = 28},
  [5647] = {.lex_state = 0, .external_lex_state = 28},
  [5648] = {.lex_state = 0, .external_lex_state = 28},
  [5649] = {.lex_state = 0, .external_lex_state = 28},
  [5650] = {.lex_state = 0, .external_lex_state = 28},
  [5651] = {.lex_state = 0, .external_lex_state = 28},
  [5652] = {.lex_state = 0, .external_lex_state = 28},
  [5653] = {.lex_state = 0, .external_lex_state = 28},
  [5654] = {.lex_state = 0, .external_lex_state = 28},
  [5655] = {.lex_state = 0, .external_lex_state = 28},
  [5656] = {.lex_state = 0, .external_lex_state = 26},
  [5657] = {.lex_state = 0, .external_lex_state = 28},
  [5658] = {.lex_state = 0, .external_lex_state = 26},
  [5659] = {.lex_state = 80, .external_lex_state = 21},
  [5660] = {.lex_state = 7, .external_lex_state = 21},
  [5661] = {.lex_state = 43, .external_lex_state = 21},
  [5662] = {.lex_state = 0, .external_lex_state = 28},
  [5663] = {.lex_state = 0, .external_lex_state = 28},
  [5664] = {.lex_state = 43, .external_lex_state = 37},
  [5665] = {.lex_state = 0, .external_lex_state = 28},
  [5666] = {.lex_state = 43, .external_lex_state = 37},
  [5667] = {.lex_state = 0, .external_lex_state = 28},
  [5668] = {.lex_state = 0, .external_lex_state = 21},
  [5669] = {.lex_state = 0, .external_lex_state = 21},
  [5670] = {.lex_state = 43, .external_lex_state = 21},
  [5671] = {.lex_state = 0, .external_lex_state = 28},
  [5672] = {.lex_state = 0, .external_lex_state = 28},
  [5673] = {.lex_state = 0, .external_lex_state = 28},
  [5674] = {.lex_state = 0, .external_lex_state = 28},
  [5675] = {.lex_state = 0, .external_lex_state = 28},
  [5676] = {.lex_state = 0, .external_lex_state = 28},
  [5677] = {.lex_state = 0, .external_lex_state = 28},
  [5678] = {.lex_state = 0, .external_lex_state = 21},
  [5679] = {.lex_state = 0, .external_lex_state = 28},
  [5680] = {.lex_state = 0, .external_lex_state = 27},
  [5681] = {.lex_state = 0, .external_lex_state = 28},
  [5682] = {.lex_state = 0, .external_lex_state = 28},
  [5683] = {.lex_state = 0, .external_lex_state = 28},
  [5684] = {.lex_state = 0, .external_lex_state = 28},
  [5685] = {.lex_state = 252, .external_lex_state = 21},
  [5686] = {.lex_state = 0, .external_lex_state = 21},
  [5687] = {.lex_state = 0, .external_lex_state = 21},
  [5688] = {.lex_state = 81, .external_lex_state = 21},
  [5689] = {.lex_state = 0, .external_lex_state = 28},
  [5690] = {.lex_state = 0, .external_lex_state = 28},
  [5691] = {.lex_state = 0, .external_lex_state = 27},
  [5692] = {.lex_state = 0, .external_lex_state = 28},
  [5693] = {.lex_state = 0, .external_lex_state = 28},
  [5694] = {.lex_state = 0, .external_lex_state = 28},
  [5695] = {.lex_state = 0, .external_lex_state = 28},
  [5696] = {.lex_state = 252, .external_lex_state = 25},
  [5697] = {.lex_state = 0, .external_lex_state = 28},
  [5698] = {.lex_state = 0, .external_lex_state = 28},
  [5699] = {.lex_state = 0, .external_lex_state = 28},
  [5700] = {.lex_state = 0, .external_lex_state = 28},
  [5701] = {.lex_state = 0, .external_lex_state = 28},
  [5702] = {.lex_state = 0, .external_lex_state = 21},
  [5703] = {.lex_state = 0, .external_lex_state = 21},
  [5704] = {.lex_state = 111, .external_lex_state = 21},
  [5705] = {.lex_state = 0, .external_lex_state = 21},
  [5706] = {.lex_state = 0, .external_lex_state = 28},
  [5707] = {.lex_state = 0, .external_lex_state = 28},
  [5708] = {.lex_state = 0, .external_lex_state = 28},
  [5709] = {.lex_state = 0, .external_lex_state = 28},
  [5710] = {.lex_state = 0, .external_lex_state = 28},
  [5711] = {.lex_state = 0, .external_lex_state = 28},
  [5712] = {.lex_state = 0, .external_lex_state = 28},
  [5713] = {.lex_state = 0, .external_lex_state = 28},
  [5714] = {.lex_state = 0, .external_lex_state = 28},
  [5715] = {.lex_state = 0, .external_lex_state = 28},
  [5716] = {.lex_state = 0, .external_lex_state = 28},
  [5717] = {.lex_state = 0, .external_lex_state = 28},
  [5718] = {.lex_state = 0, .external_lex_state = 28},
  [5719] = {.lex_state = 0, .external_lex_state = 28},
  [5720] = {.lex_state = 0, .external_lex_state = 28},
  [5721] = {.lex_state = 0, .external_lex_state = 28},
  [5722] = {.lex_state = 0, .external_lex_state = 28},
  [5723] = {.lex_state = 0, .external_lex_state = 28},
  [5724] = {.lex_state = 0, .external_lex_state = 21},
  [5725] = {.lex_state = 0, .external_lex_state = 28},
  [5726] = {.lex_state = 0, .external_lex_state = 28},
  [5727] = {.lex_state = 0, .external_lex_state = 28},
  [5728] = {.lex_state = 0, .external_lex_state = 28},
  [5729] = {.lex_state = 0, .external_lex_state = 21},
  [5730] = {.lex_state = 0, .external_lex_state = 28},
  [5731] = {.lex_state = 0, .external_lex_state = 28},
  [5732] = {.lex_state = 0, .external_lex_state = 28},
  [5733] = {.lex_state = 252, .external_lex_state = 25},
  [5734] = {.lex_state = 0, .external_lex_state = 28},
  [5735] = {.lex_state = 0, .external_lex_state = 28},
  [5736] = {.lex_state = 252, .external_lex_state = 25},
  [5737] = {.lex_state = 252, .external_lex_state = 25},
  [5738] = {.lex_state = 0, .external_lex_state = 27},
  [5739] = {.lex_state = 0, .external_lex_state = 28},
  [5740] = {.lex_state = 0, .external_lex_state = 21},
  [5741] = {.lex_state = 0, .external_lex_state = 21},
  [5742] = {.lex_state = 252, .external_lex_state = 25},
  [5743] = {.lex_state = 0, .external_lex_state = 21},
  [5744] = {.lex_state = 0, .external_lex_state = 28},
  [5745] = {.lex_state = 252, .external_lex_state = 25},
  [5746] = {.lex_state = 0, .external_lex_state = 28},
  [5747] = {.lex_state = 252, .external_lex_state = 25},
  [5748] = {.lex_state = 0, .external_lex_state = 21},
  [5749] = {.lex_state = 0, .external_lex_state = 21},
  [5750] = {.lex_state = 252, .external_lex_state = 25},
  [5751] = {.lex_state = 252, .external_lex_state = 25},
  [5752] = {.lex_state = 252, .external_lex_state = 25},
  [5753] = {.lex_state = 0, .external_lex_state = 28},
  [5754] = {.lex_state = 0, .external_lex_state = 28},
  [5755] = {.lex_state = 0, .external_lex_state = 28},
  [5756] = {.lex_state = 0, .external_lex_state = 28},
  [5757] = {.lex_state = 0, .external_lex_state = 28},
  [5758] = {.lex_state = 0, .external_lex_state = 21},
  [5759] = {.lex_state = 252, .external_lex_state = 25},
  [5760] = {.lex_state = 0, .external_lex_state = 28},
  [5761] = {.lex_state = 252, .external_lex_state = 25},
  [5762] = {.lex_state = 252, .external_lex_state = 25},
  [5763] = {.lex_state = 0, .external_lex_state = 28},
  [5764] = {.lex_state = 252, .external_lex_state = 25},
  [5765] = {.lex_state = 0, .external_lex_state = 28},
  [5766] = {.lex_state = 0, .external_lex_state = 28},
  [5767] = {.lex_state = 0, .external_lex_state = 28},
  [5768] = {.lex_state = 252, .external_lex_state = 25},
  [5769] = {.lex_state = 0, .external_lex_state = 21},
  [5770] = {.lex_state = 0, .external_lex_state = 28},
  [5771] = {.lex_state = 0, .external_lex_state = 28},
  [5772] = {.lex_state = 252, .external_lex_state = 25},
  [5773] = {.lex_state = 0, .external_lex_state = 28},
  [5774] = {.lex_state = 0, .external_lex_state = 21},
  [5775] = {.lex_state = 252, .external_lex_state = 25},
  [5776] = {.lex_state = 252, .external_lex_state = 25},
  [5777] = {.lex_state = 252, .external_lex_state = 25},
  [5778] = {.lex_state = 0, .external_lex_state = 28},
  [5779] = {.lex_state = 0, .external_lex_state = 28},
  [5780] = {.lex_state = 0, .external_lex_state = 28},
  [5781] = {.lex_state = 252, .external_lex_state = 25},
  [5782] = {.lex_state = 252, .external_lex_state = 25},
  [5783] = {.lex_state = 0, .external_lex_state = 28},
  [5784] = {.lex_state = 252, .external_lex_state = 25},
  [5785] = {.lex_state = 0, .external_lex_state = 28},
  [5786] = {.lex_state = 252, .external_lex_state = 25},
  [5787] = {.lex_state = 0, .external_lex_state = 28},
  [5788] = {.lex_state = 0, .external_lex_state = 28},
  [5789] = {.lex_state = 0, .external_lex_state = 28},
  [5790] = {.lex_state = 0, .external_lex_state = 28},
  [5791] = {.lex_state = 0, .external_lex_state = 28},
  [5792] = {.lex_state = 0, .external_lex_state = 28},
  [5793] = {.lex_state = 0, .external_lex_state = 28},
  [5794] = {.lex_state = 0, .external_lex_state = 28},
  [5795] = {.lex_state = 0, .external_lex_state = 28},
  [5796] = {.lex_state = 0, .external_lex_state = 28},
  [5797] = {.lex_state = 0, .external_lex_state = 28},
  [5798] = {.lex_state = 252, .external_lex_state = 25},
  [5799] = {.lex_state = 0, .external_lex_state = 28},
  [5800] = {.lex_state = 252, .external_lex_state = 25},
  [5801] = {.lex_state = 0, .external_lex_state = 21},
  [5802] = {.lex_state = 0, .external_lex_state = 21},
  [5803] = {.lex_state = 0, .external_lex_state = 28},
  [5804] = {.lex_state = 0, .external_lex_state = 28},
  [5805] = {.lex_state = 0, .external_lex_state = 28},
  [5806] = {.lex_state = 0, .external_lex_state = 21},
  [5807] = {.lex_state = 0, .external_lex_state = 28},
  [5808] = {.lex_state = 0, .external_lex_state = 21},
  [5809] = {.lex_state = 0, .external_lex_state = 28},
  [5810] = {.lex_state = 0, .external_lex_state = 28},
  [5811] = {.lex_state = 0, .external_lex_state = 28},
  [5812] = {.lex_state = 0, .external_lex_state = 21},
  [5813] = {.lex_state = 0, .external_lex_state = 21},
  [5814] = {.lex_state = 0, .external_lex_state = 28},
  [5815] = {.lex_state = 0, .external_lex_state = 28},
  [5816] = {.lex_state = 0, .external_lex_state = 28},
  [5817] = {.lex_state = 0, .external_lex_state = 28},
  [5818] = {.lex_state = 0, .external_lex_state = 28},
  [5819] = {.lex_state = 252, .external_lex_state = 25},
  [5820] = {.lex_state = 252, .external_lex_state = 25},
  [5821] = {.lex_state = 0, .external_lex_state = 21},
  [5822] = {.lex_state = 0, .external_lex_state = 28},
  [5823] = {.lex_state = 0, .external_lex_state = 27},
  [5824] = {.lex_state = 0, .external_lex_state = 28},
  [5825] = {.lex_state = 0, .external_lex_state = 28},
  [5826] = {.lex_state = 0, .external_lex_state = 28},
  [5827] = {.lex_state = 0, .external_lex_state = 28},
  [5828] = {.lex_state = 0, .external_lex_state = 28},
  [5829] = {.lex_state = 0, .external_lex_state = 27},
  [5830] = {.lex_state = 0, .external_lex_state = 21},
  [5831] = {.lex_state = 0, .external_lex_state = 28},
  [5832] = {.lex_state = 0, .external_lex_state = 28},
  [5833] = {.lex_state = 0, .external_lex_state = 28},
  [5834] = {.lex_state = 81, .external_lex_state = 21},
  [5835] = {.lex_state = 0, .external_lex_state = 27},
  [5836] = {.lex_state = 0, .external_lex_state = 28},
  [5837] = {.lex_state = 0, .external_lex_state = 28},
  [5838] = {.lex_state = 0, .external_lex_state = 28},
  [5839] = {.lex_state = 0, .external_lex_state = 28},
  [5840] = {.lex_state = 0, .external_lex_state = 27},
  [5841] = {.lex_state = 0, .external_lex_state = 21},
  [5842] = {.lex_state = 0, .external_lex_state = 28},
  [5843] = {.lex_state = 0, .external_lex_state = 28},
  [5844] = {.lex_state = 0, .external_lex_state = 28},
  [5845] = {.lex_state = 0, .external_lex_state = 28},
  [5846] = {.lex_state = 0, .external_lex_state = 21},
  [5847] = {.lex_state = 0, .external_lex_state = 27},
  [5848] = {.lex_state = 0, .external_lex_state = 28},
  [5849] = {.lex_state = 0, .external_lex_state = 21},
  [5850] = {.lex_state = 0, .external_lex_state = 28},
  [5851] = {.lex_state = 0, .external_lex_state = 27},
  [5852] = {.lex_state = 0, .external_lex_state = 28},
  [5853] = {.lex_state = 0, .external_lex_state = 28},
  [5854] = {.lex_state = 0, .external_lex_state = 28},
  [5855] = {.lex_state = 252, .external_lex_state = 25},
  [5856] = {.lex_state = 0, .external_lex_state = 27},
  [5857] = {.lex_state = 0, .external_lex_state = 28},
  [5858] = {.lex_state = 0, .external_lex_state = 28},
  [5859] = {.lex_state = 0, .external_lex_state = 28},
  [5860] = {.lex_state = 0, .external_lex_state = 28},
  [5861] = {.lex_state = 0, .external_lex_state = 28},
  [5862] = {.lex_state = 0, .external_lex_state = 28},
  [5863] = {.lex_state = 0, .external_lex_state = 28},
  [5864] = {.lex_state = 0, .external_lex_state = 28},
  [5865] = {.lex_state = 0, .external_lex_state = 28},
  [5866] = {.lex_state = 0, .external_lex_state = 28},
  [5867] = {.lex_state = 0, .external_lex_state = 28},
  [5868] = {.lex_state = 0, .external_lex_state = 28},
  [5869] = {.lex_state = 0, .external_lex_state = 21},
  [5870] = {.lex_state = 0, .external_lex_state = 28},
  [5871] = {.lex_state = 0, .external_lex_state = 28},
  [5872] = {.lex_state = 0, .external_lex_state = 28},
  [5873] = {.lex_state = 0, .external_lex_state = 27},
  [5874] = {.lex_state = 0, .external_lex_state = 28},
  [5875] = {.lex_state = 0, .external_lex_state = 21},
  [5876] = {.lex_state = 0, .external_lex_state = 28},
  [5877] = {.lex_state = 0, .external_lex_state = 28},
  [5878] = {.lex_state = 0, .external_lex_state = 28},
  [5879] = {.lex_state = 0, .external_lex_state = 28},
  [5880] = {.lex_state = 0, .external_lex_state = 28},
  [5881] = {.lex_state = 0, .external_lex_state = 28},
  [5882] = {.lex_state = 0, .external_lex_state = 27},
  [5883] = {.lex_state = 0, .external_lex_state = 21},
  [5884] = {.lex_state = 0, .external_lex_state = 21},
  [5885] = {.lex_state = 111, .external_lex_state = 21},
  [5886] = {.lex_state = 0, .external_lex_state = 27},
  [5887] = {.lex_state = 0, .external_lex_state = 28},
  [5888] = {.lex_state = 0, .external_lex_state = 27},
  [5889] = {.lex_state = 0, .external_lex_state = 21},
  [5890] = {.lex_state = 0, .external_lex_state = 21},
  [5891] = {.lex_state = 0, .external_lex_state = 21},
  [5892] = {.lex_state = 0, .external_lex_state = 28},
  [5893] = {.lex_state = 0, .external_lex_state = 21},
  [5894] = {.lex_state = 0, .external_lex_state = 28},
  [5895] = {.lex_state = 0, .external_lex_state = 21},
  [5896] = {.lex_state = 0, .external_lex_state = 21},
  [5897] = {.lex_state = 0, .external_lex_state = 28},
  [5898] = {.lex_state = 0, .external_lex_state = 28},
  [5899] = {.lex_state = 0, .external_lex_state = 28},
  [5900] = {.lex_state = 0, .external_lex_state = 28},
  [5901] = {.lex_state = 0, .external_lex_state = 28},
  [5902] = {.lex_state = 0, .external_lex_state = 21},
  [5903] = {.lex_state = 0, .external_lex_state = 28},
  [5904] = {.lex_state = 0, .external_lex_state = 28},
  [5905] = {.lex_state = 0, .external_lex_state = 28},
  [5906] = {.lex_state = 0, .external_lex_state = 28},
  [5907] = {.lex_state = 0, .external_lex_state = 28},
  [5908] = {.lex_state = 0, .external_lex_state = 28},
  [5909] = {.lex_state = 0, .external_lex_state = 28},
  [5910] = {.lex_state = 0, .external_lex_state = 28},
  [5911] = {.lex_state = 0, .external_lex_state = 28},
  [5912] = {.lex_state = 0, .external_lex_state = 27},
  [5913] = {.lex_state = 0, .external_lex_state = 28},
  [5914] = {.lex_state = 0, .external_lex_state = 28},
  [5915] = {.lex_state = 0, .external_lex_state = 28},
  [5916] = {.lex_state = 0, .external_lex_state = 27},
  [5917] = {.lex_state = 0, .external_lex_state = 28},
  [5918] = {.lex_state = 0, .external_lex_state = 21},
  [5919] = {.lex_state = 0, .external_lex_state = 28},
  [5920] = {.lex_state = 0, .external_lex_state = 28},
  [5921] = {.lex_state = 0, .external_lex_state = 27},
  [5922] = {.lex_state = 0, .external_lex_state = 28},
  [5923] = {.lex_state = 0, .external_lex_state = 28},
  [5924] = {.lex_state = 0, .external_lex_state = 28},
  [5925] = {.lex_state = 0, .external_lex_state = 28},
  [5926] = {.lex_state = 0, .external_lex_state = 21},
  [5927] = {.lex_state = 0, .external_lex_state = 28},
  [5928] = {.lex_state = 0, .external_lex_state = 21},
  [5929] = {.lex_state = 0, .external_lex_state = 28},
  [5930] = {.lex_state = 0, .external_lex_state = 28},
  [5931] = {.lex_state = 0, .external_lex_state = 28},
  [5932] = {.lex_state = 0, .external_lex_state = 28},
  [5933] = {.lex_state = 0, .external_lex_state = 28},
  [5934] = {.lex_state = 0, .external_lex_state = 21},
  [5935] = {.lex_state = 0, .external_lex_state = 21},
  [5936] = {.lex_state = 0, .external_lex_state = 21},
  [5937] = {.lex_state = 0, .external_lex_state = 28},
  [5938] = {.lex_state = 0, .external_lex_state = 28},
  [5939] = {.lex_state = 0, .external_lex_state = 28},
  [5940] = {.lex_state = 0, .external_lex_state = 28},
  [5941] = {.lex_state = 0, .external_lex_state = 27},
  [5942] = {.lex_state = 0, .external_lex_state = 28},
  [5943] = {.lex_state = 0, .external_lex_state = 28},
  [5944] = {.lex_state = 0, .external_lex_state = 27},
  [5945] = {.lex_state = 0, .external_lex_state = 21},
  [5946] = {.lex_state = 0, .external_lex_state = 28},
  [5947] = {.lex_state = 0, .external_lex_state = 28},
  [5948] = {.lex_state = 0, .external_lex_state = 27},
  [5949] = {.lex_state = 0, .external_lex_state = 21},
  [5950] = {.lex_state = 0, .external_lex_state = 28},
  [5951] = {.lex_state = 0, .external_lex_state = 28},
  [5952] = {.lex_state = 0, .external_lex_state = 28},
  [5953] = {.lex_state = 0, .external_lex_state = 28},
  [5954] = {.lex_state = 0, .external_lex_state = 27},
  [5955] = {.lex_state = 0, .external_lex_state = 27},
  [5956] = {.lex_state = 0, .external_lex_state = 21},
  [5957] = {.lex_state = 0, .external_lex_state = 27},
  [5958] = {.lex_state = 0, .external_lex_state = 28},
  [5959] = {.lex_state = 0, .external_lex_state = 28},
  [5960] = {.lex_state = 0, .external_lex_state = 28},
  [5961] = {.lex_state = 0, .external_lex_state = 28},
  [5962] = {.lex_state = 0, .external_lex_state = 27},
  [5963] = {.lex_state = 0, .external_lex_state = 28},
  [5964] = {.lex_state = 0, .external_lex_state = 21},
  [5965] = {.lex_state = 0, .external_lex_state = 21},
  [5966] = {.lex_state = 0, .external_lex_state = 28},
  [5967] = {.lex_state = 0, .external_lex_state = 21},
  [5968] = {.lex_state = 0, .external_lex_state = 21},
  [5969] = {.lex_state = 0, .external_lex_state = 21},
  [5970] = {.lex_state = 0, .external_lex_state = 28},
  [5971] = {.lex_state = 0, .external_lex_state = 28},
  [5972] = {.lex_state = 0, .external_lex_state = 27},
  [5973] = {.lex_state = 0, .external_lex_state = 21},
  [5974] = {.lex_state = 0, .external_lex_state = 28},
  [5975] = {.lex_state = 0, .external_lex_state = 28},
  [5976] = {.lex_state = 0, .external_lex_state = 28},
  [5977] = {.lex_state = 0, .external_lex_state = 21},
  [5978] = {.lex_state = 0, .external_lex_state = 27},
  [5979] = {.lex_state = 0, .external_lex_state = 21},
  [5980] = {.lex_state = 0, .external_lex_state = 28},
  [5981] = {.lex_state = 81, .external_lex_state = 21},
  [5982] = {.lex_state = 0, .external_lex_state = 28},
  [5983] = {.lex_state = 0, .external_lex_state = 28},
  [5984] = {.lex_state = 0, .external_lex_state = 21},
  [5985] = {.lex_state = 0, .external_lex_state = 28},
  [5986] = {.lex_state = 0, .external_lex_state = 27},
  [5987] = {.lex_state = 0, .external_lex_state = 28},
  [5988] = {.lex_state = 0, .external_lex_state = 28},
  [5989] = {.lex_state = 0, .external_lex_state = 28},
  [5990] = {.lex_state = 0, .external_lex_state = 28},
  [5991] = {.lex_state = 0, .external_lex_state = 28},
  [5992] = {.lex_state = 0, .external_lex_state = 28},
  [5993] = {.lex_state = 0, .external_lex_state = 21},
  [5994] = {.lex_state = 0, .external_lex_state = 28},
  [5995] = {.lex_state = 0, .external_lex_state = 28},
  [5996] = {.lex_state = 0, .external_lex_state = 28},
  [5997] = {.lex_state = 0, .external_lex_state = 28},
  [5998] = {.lex_state = 0, .external_lex_state = 21},
  [5999] = {.lex_state = 0, .external_lex_state = 28},
  [6000] = {.lex_state = 0, .external_lex_state = 28},
  [6001] = {.lex_state = 0, .external_lex_state = 28},
  [6002] = {.lex_state = 0, .external_lex_state = 28},
  [6003] = {.lex_state = 0, .external_lex_state = 21},
  [6004] = {.lex_state = 0, .external_lex_state = 28},
  [6005] = {.lex_state = 0, .external_lex_state = 28},
  [6006] = {.lex_state = 0, .external_lex_state = 28},
  [6007] = {.lex_state = 0, .external_lex_state = 21},
  [6008] = {.lex_state = 0, .external_lex_state = 28},
  [6009] = {.lex_state = 0, .external_lex_state = 21},
  [6010] = {.lex_state = 0, .external_lex_state = 21},
  [6011] = {.lex_state = 0, .external_lex_state = 28},
  [6012] = {.lex_state = 0, .external_lex_state = 27},
  [6013] = {.lex_state = 0, .external_lex_state = 28},
  [6014] = {.lex_state = 0, .external_lex_state = 27},
  [6015] = {.lex_state = 0, .external_lex_state = 21},
  [6016] = {.lex_state = 111, .external_lex_state = 21},
  [6017] = {.lex_state = 0, .external_lex_state = 28},
  [6018] = {.lex_state = 0, .external_lex_state = 28},
  [6019] = {.lex_state = 0, .external_lex_state = 21},
  [6020] = {.lex_state = 81, .external_lex_state = 21},
  [6021] = {.lex_state = 0, .external_lex_state = 27},
  [6022] = {.lex_state = 0, .external_lex_state = 28},
  [6023] = {.lex_state = 0, .external_lex_state = 28},
  [6024] = {.lex_state = 0, .external_lex_state = 21},
  [6025] = {.lex_state = 0, .external_lex_state = 28},
  [6026] = {.lex_state = 0, .external_lex_state = 27},
  [6027] = {.lex_state = 0, .external_lex_state = 28},
  [6028] = {.lex_state = 0, .external_lex_state = 28},
  [6029] = {.lex_state = 0, .external_lex_state = 21},
  [6030] = {.lex_state = 0, .external_lex_state = 28},
  [6031] = {.lex_state = 0, .external_lex_state = 21},
  [6032] = {.lex_state = 0, .external_lex_state = 28},
  [6033] = {.lex_state = 0, .external_lex_state = 28},
  [6034] = {.lex_state = 0, .external_lex_state = 28},
  [6035] = {.lex_state = 0, .external_lex_state = 27},
  [6036] = {.lex_state = 0, .external_lex_state = 21},
  [6037] = {.lex_state = 0, .external_lex_state = 27},
  [6038] = {.lex_state = 0, .external_lex_state = 21},
  [6039] = {.lex_state = 0, .external_lex_state = 27},
  [6040] = {.lex_state = 0, .external_lex_state = 28},
  [6041] = {.lex_state = 0, .external_lex_state = 28},
  [6042] = {.lex_state = 0, .external_lex_state = 28},
  [6043] = {.lex_state = 0, .external_lex_state = 28},
  [6044] = {.lex_state = 0, .external_lex_state = 28},
  [6045] = {.lex_state = 0, .external_lex_state = 28},
  [6046] = {.lex_state = 0, .external_lex_state = 28},
  [6047] = {.lex_state = 0, .external_lex_state = 28},
  [6048] = {.lex_state = 0, .external_lex_state = 21},
  [6049] = {.lex_state = 0, .external_lex_state = 21},
  [6050] = {.lex_state = 0, .external_lex_state = 27},
  [6051] = {.lex_state = 0, .external_lex_state = 28},
  [6052] = {.lex_state = 0, .external_lex_state = 28},
  [6053] = {.lex_state = 0, .external_lex_state = 27},
  [6054] = {.lex_state = 0, .external_lex_state = 28},
  [6055] = {.lex_state = 0, .external_lex_state = 21},
  [6056] = {.lex_state = 0, .external_lex_state = 28},
  [6057] = {.lex_state = 0, .external_lex_state = 28},
  [6058] = {.lex_state = 0, .external_lex_state = 28},
  [6059] = {.lex_state = 0, .external_lex_state = 27},
  [6060] = {.lex_state = 0, .external_lex_state = 27},
  [6061] = {.lex_state = 0, .external_lex_state = 21},
  [6062] = {.lex_state = 0, .external_lex_state = 28},
  [6063] = {.lex_state = 0, .external_lex_state = 28},
  [6064] = {.lex_state = 0, .external_lex_state = 28},
  [6065] = {.lex_state = 0, .external_lex_state = 21},
  [6066] = {.lex_state = 0, .external_lex_state = 28},
  [6067] = {.lex_state = 0, .external_lex_state = 28},
  [6068] = {.lex_state = 0, .external_lex_state = 28},
  [6069] = {.lex_state = 0, .external_lex_state = 27},
  [6070] = {.lex_state = 0, .external_lex_state = 27},
  [6071] = {.lex_state = 0, .external_lex_state = 21},
  [6072] = {.lex_state = 0, .external_lex_state = 28},
  [6073] = {.lex_state = 0, .external_lex_state = 21},
  [6074] = {.lex_state = 111, .external_lex_state = 21},
  [6075] = {.lex_state = 0, .external_lex_state = 27},
  [6076] = {.lex_state = 0, .external_lex_state = 28},
  [6077] = {.lex_state = 0, .external_lex_state = 28},
  [6078] = {.lex_state = 0, .external_lex_state = 28},
  [6079] = {.lex_state = 0, .external_lex_state = 21},
  [6080] = {.lex_state = 0, .external_lex_state = 28},
  [6081] = {.lex_state = 0, .external_lex_state = 28},
  [6082] = {.lex_state = 0, .external_lex_state = 28},
  [6083] = {.lex_state = 0, .external_lex_state = 21},
  [6084] = {.lex_state = 0, .external_lex_state = 27},
  [6085] = {.lex_state = 0, .external_lex_state = 21},
  [6086] = {.lex_state = 0, .external_lex_state = 21},
  [6087] = {.lex_state = 0, .external_lex_state = 21},
  [6088] = {.lex_state = 0, .external_lex_state = 28},
  [6089] = {.lex_state = 0, .external_lex_state = 28},
  [6090] = {.lex_state = 0, .external_lex_state = 28},
  [6091] = {.lex_state = 0, .external_lex_state = 27},
  [6092] = {.lex_state = 0, .external_lex_state = 28},
  [6093] = {.lex_state = 0, .external_lex_state = 28},
  [6094] = {.lex_state = 0, .external_lex_state = 21},
  [6095] = {.lex_state = 0, .external_lex_state = 28},
  [6096] = {.lex_state = 0, .external_lex_state = 28},
  [6097] = {.lex_state = 0, .external_lex_state = 27},
  [6098] = {.lex_state = 0, .external_lex_state = 21},
  [6099] = {.lex_state = 0, .external_lex_state = 28},
  [6100] = {.lex_state = 0, .external_lex_state = 28},
  [6101] = {.lex_state = 0, .external_lex_state = 28},
  [6102] = {.lex_state = 0, .external_lex_state = 21},
  [6103] = {.lex_state = 0, .external_lex_state = 27},
  [6104] = {.lex_state = 0, .external_lex_state = 27},
  [6105] = {.lex_state = 0, .external_lex_state = 28},
  [6106] = {.lex_state = 0, .external_lex_state = 21},
  [6107] = {.lex_state = 0, .external_lex_state = 28},
  [6108] = {.lex_state = 0, .external_lex_state = 27},
  [6109] = {.lex_state = 0, .external_lex_state = 28},
  [6110] = {.lex_state = 0, .external_lex_state = 27},
  [6111] = {.lex_state = 0, .external_lex_state = 28},
  [6112] = {.lex_state = 0, .external_lex_state = 28},
  [6113] = {.lex_state = 0, .external_lex_state = 21},
  [6114] = {.lex_state = 0, .external_lex_state = 28},
  [6115] = {.lex_state = 0, .external_lex_state = 27},
  [6116] = {.lex_state = 0, .external_lex_state = 28},
  [6117] = {.lex_state = 0, .external_lex_state = 21},
  [6118] = {.lex_state = 0, .external_lex_state = 28},
  [6119] = {.lex_state = 0, .external_lex_state = 27},
  [6120] = {.lex_state = 0, .external_lex_state = 27},
  [6121] = {.lex_state = 0, .external_lex_state = 27},
  [6122] = {.lex_state = 0, .external_lex_state = 21},
  [6123] = {.lex_state = 0, .external_lex_state = 28},
  [6124] = {.lex_state = 0, .external_lex_state = 28},
  [6125] = {.lex_state = 0, .external_lex_state = 28},
  [6126] = {.lex_state = 0, .external_lex_state = 21},
  [6127] = {.lex_state = 0, .external_lex_state = 28},
  [6128] = {.lex_state = 0, .external_lex_state = 27},
  [6129] = {.lex_state = 0, .external_lex_state = 21},
  [6130] = {.lex_state = 0, .external_lex_state = 28},
  [6131] = {.lex_state = 0, .external_lex_state = 28},
  [6132] = {.lex_state = 0, .external_lex_state = 28},
  [6133] = {.lex_state = 0, .external_lex_state = 27},
  [6134] = {.lex_state = 0, .external_lex_state = 28},
  [6135] = {.lex_state = 0, .external_lex_state = 21},
  [6136] = {.lex_state = 0, .external_lex_state = 28},
  [6137] = {.lex_state = 0, .external_lex_state = 21},
  [6138] = {.lex_state = 0, .external_lex_state = 28},
  [6139] = {.lex_state = 0, .external_lex_state = 28},
  [6140] = {.lex_state = 0, .external_lex_state = 21},
  [6141] = {.lex_state = 0, .external_lex_state = 27},
  [6142] = {.lex_state = 0, .external_lex_state = 28},
  [6143] = {.lex_state = 0, .external_lex_state = 21},
  [6144] = {.lex_state = 0, .external_lex_state = 21},
  [6145] = {.lex_state = 0, .external_lex_state = 28},
  [6146] = {.lex_state = 0, .external_lex_state = 21},
  [6147] = {.lex_state = 0, .external_lex_state = 21},
  [6148] = {.lex_state = 81, .external_lex_state = 21},
  [6149] = {.lex_state = 0, .external_lex_state = 27},
  [6150] = {.lex_state = 81, .external_lex_state = 21},
  [6151] = {.lex_state = 0, .external_lex_state = 28},
  [6152] = {.lex_state = 0, .external_lex_state = 28},
  [6153] = {.lex_state = 0, .external_lex_state = 28},
  [6154] = {.lex_state = 0, .external_lex_state = 27},
  [6155] = {.lex_state = 0, .external_lex_state = 21},
  [6156] = {.lex_state = 0, .external_lex_state = 27},
  [6157] = {.lex_state = 0, .external_lex_state = 28},
  [6158] = {.lex_state = 0, .external_lex_state = 28},
  [6159] = {.lex_state = 0, .external_lex_state = 28},
  [6160] = {.lex_state = 0, .external_lex_state = 27},
  [6161] = {.lex_state = 0, .external_lex_state = 21},
  [6162] = {.lex_state = 0, .external_lex_state = 28},
  [6163] = {.lex_state = 252, .external_lex_state = 21},
  [6164] = {.lex_state = 0, .external_lex_state = 28},
  [6165] = {.lex_state = 0, .external_lex_state = 21},
  [6166] = {.lex_state = 0, .external_lex_state = 27},
  [6167] = {.lex_state = 0, .external_lex_state = 28},
  [6168] = {.lex_state = 0, .external_lex_state = 27},
  [6169] = {.lex_state = 0, .external_lex_state = 28},
  [6170] = {.lex_state = 0, .external_lex_state = 27},
  [6171] = {.lex_state = 0, .external_lex_state = 28},
  [6172] = {.lex_state = 0, .external_lex_state = 27},
  [6173] = {.lex_state = 0, .external_lex_state = 28},
  [6174] = {.lex_state = 0, .external_lex_state = 28},
  [6175] = {.lex_state = 0, .external_lex_state = 27},
  [6176] = {.lex_state = 0, .external_lex_state = 28},
  [6177] = {.lex_state = 252, .external_lex_state = 21},
  [6178] = {.lex_state = 0, .external_lex_state = 28},
  [6179] = {.lex_state = 0, .external_lex_state = 28},
  [6180] = {.lex_state = 0, .external_lex_state = 21},
  [6181] = {.lex_state = 0, .external_lex_state = 28},
  [6182] = {.lex_state = 0, .external_lex_state = 28},
  [6183] = {.lex_state = 0, .external_lex_state = 28},
  [6184] = {.lex_state = 112, .external_lex_state = 21},
  [6185] = {.lex_state = 112, .external_lex_state = 21},
  [6186] = {.lex_state = 0, .external_lex_state = 28},
  [6187] = {.lex_state = 0, .external_lex_state = 28},
  [6188] = {.lex_state = 0, .external_lex_state = 28},
  [6189] = {.lex_state = 0, .external_lex_state = 28},
  [6190] = {.lex_state = 252, .external_lex_state = 25},
  [6191] = {.lex_state = 0, .external_lex_state = 28},
  [6192] = {.lex_state = 0, .external_lex_state = 28},
  [6193] = {.lex_state = 0, .external_lex_state = 28},
  [6194] = {.lex_state = 0, .external_lex_state = 27},
  [6195] = {.lex_state = 252, .external_lex_state = 21},
  [6196] = {.lex_state = 0, .external_lex_state = 28},
  [6197] = {.lex_state = 0, .external_lex_state = 28},
  [6198] = {.lex_state = 0, .external_lex_state = 21},
  [6199] = {.lex_state = 0, .external_lex_state = 28},
  [6200] = {.lex_state = 0, .external_lex_state = 28},
  [6201] = {.lex_state = 0, .external_lex_state = 27},
  [6202] = {.lex_state = 81, .external_lex_state = 21},
  [6203] = {.lex_state = 0, .external_lex_state = 21},
  [6204] = {.lex_state = 0, .external_lex_state = 28},
  [6205] = {.lex_state = 0, .external_lex_state = 28},
  [6206] = {.lex_state = 0, .external_lex_state = 28},
  [6207] = {.lex_state = 0, .external_lex_state = 28},
  [6208] = {.lex_state = 0, .external_lex_state = 28},
  [6209] = {.lex_state = 0, .external_lex_state = 27},
  [6210] = {.lex_state = 0, .external_lex_state = 28},
  [6211] = {.lex_state = 0, .external_lex_state = 27},
  [6212] = {.lex_state = 0, .external_lex_state = 21},
  [6213] = {.lex_state = 0, .external_lex_state = 28},
  [6214] = {.lex_state = 0, .external_lex_state = 21},
  [6215] = {.lex_state = 0, .external_lex_state = 28},
  [6216] = {.lex_state = 0, .external_lex_state = 21},
  [6217] = {.lex_state = 0, .external_lex_state = 27},
  [6218] = {.lex_state = 0, .external_lex_state = 28},
  [6219] = {.lex_state = 0, .external_lex_state = 27},
  [6220] = {.lex_state = 0, .external_lex_state = 28},
  [6221] = {.lex_state = 0, .external_lex_state = 21},
  [6222] = {.lex_state = 0, .external_lex_state = 28},
  [6223] = {.lex_state = 0, .external_lex_state = 28},
  [6224] = {.lex_state = 0, .external_lex_state = 28},
  [6225] = {.lex_state = 0, .external_lex_state = 28},
  [6226] = {.lex_state = 0, .external_lex_state = 28},
  [6227] = {.lex_state = 0, .external_lex_state = 28},
  [6228] = {.lex_state = 0, .external_lex_state = 21},
  [6229] = {.lex_state = 0, .external_lex_state = 21},
  [6230] = {.lex_state = 0, .external_lex_state = 37},
  [6231] = {.lex_state = 252, .external_lex_state = 21},
  [6232] = {.lex_state = 112, .external_lex_state = 21},
  [6233] = {.lex_state = 74, .external_lex_state = 21},
  [6234] = {.lex_state = 0, .external_lex_state = 21},
  [6235] = {.lex_state = 0, .external_lex_state = 21},
  [6236] = {.lex_state = 0, .external_lex_state = 21},
  [6237] = {.lex_state = 0, .external_lex_state = 21},
  [6238] = {.lex_state = 0, .external_lex_state = 21},
  [6239] = {.lex_state = 0, .external_lex_state = 28},
  [6240] = {.lex_state = 0, .external_lex_state = 37},
  [6241] = {.lex_state = 0, .external_lex_state = 21},
  [6242] = {.lex_state = 74, .external_lex_state = 21},
  [6243] = {.lex_state = 0, .external_lex_state = 37},
  [6244] = {.lex_state = 0, .external_lex_state = 21},
  [6245] = {.lex_state = 0, .external_lex_state = 21},
  [6246] = {.lex_state = 0, .external_lex_state = 21},
  [6247] = {.lex_state = 0, .external_lex_state = 21},
  [6248] = {.lex_state = 0, .external_lex_state = 21},
  [6249] = {.lex_state = 0, .external_lex_state = 21},
  [6250] = {.lex_state = 0, .external_lex_state = 21},
  [6251] = {.lex_state = 0, .external_lex_state = 21},
  [6252] = {.lex_state = 0, .external_lex_state = 21},
  [6253] = {.lex_state = 0, .external_lex_state = 28},
  [6254] = {.lex_state = 0, .external_lex_state = 21},
  [6255] = {.lex_state = 0, .external_lex_state = 21},
  [6256] = {.lex_state = 75, .external_lex_state = 21},
  [6257] = {.lex_state = 0, .external_lex_state = 21},
  [6258] = {.lex_state = 0, .external_lex_state = 37},
  [6259] = {.lex_state = 75, .external_lex_state = 21},
  [6260] = {.lex_state = 0, .external_lex_state = 28},
  [6261] = {.lex_state = 75, .external_lex_state = 21},
  [6262] = {.lex_state = 0, .external_lex_state = 21},
  [6263] = {.lex_state = 74, .external_lex_state = 21},
  [6264] = {.lex_state = 111, .external_lex_state = 21},
  [6265] = {.lex_state = 75, .external_lex_state = 21},
  [6266] = {.lex_state = 0, .external_lex_state = 21},
  [6267] = {.lex_state = 111, .external_lex_state = 21},
  [6268] = {.lex_state = 74, .external_lex_state = 21},
  [6269] = {.lex_state = 0, .external_lex_state = 28},
  [6270] = {.lex_state = 0, .external_lex_state = 21},
  [6271] = {.lex_state = 0, .external_lex_state = 28},
  [6272] = {.lex_state = 0, .external_lex_state = 37},
  [6273] = {.lex_state = 0, .external_lex_state = 37},
  [6274] = {.lex_state = 0, .external_lex_state = 37},
  [6275] = {.lex_state = 0, .external_lex_state = 28},
  [6276] = {.lex_state = 0, .external_lex_state = 37},
  [6277] = {.lex_state = 0, .external_lex_state = 37},
  [6278] = {.lex_state = 0, .external_lex_state = 21},
  [6279] = {.lex_state = 0, .external_lex_state = 37},
  [6280] = {.lex_state = 0, .external_lex_state = 28},
  [6281] = {.lex_state = 75, .external_lex_state = 21},
  [6282] = {.lex_state = 75, .external_lex_state = 21},
  [6283] = {.lex_state = 0, .external_lex_state = 21},
  [6284] = {.lex_state = 75, .external_lex_state = 21},
  [6285] = {.lex_state = 75, .external_lex_state = 21},
  [6286] = {.lex_state = 0, .external_lex_state = 37},
  [6287] = {.lex_state = 75, .external_lex_state = 21},
  [6288] = {.lex_state = 0, .external_lex_state = 37},
  [6289] = {.lex_state = 75, .external_lex_state = 21},
  [6290] = {.lex_state = 0, .external_lex_state = 27},
  [6291] = {.lex_state = 0, .external_lex_state = 21},
  [6292] = {.lex_state = 0, .external_lex_state = 21},
  [6293] = {.lex_state = 75, .external_lex_state = 21},
  [6294] = {.lex_state = 75, .external_lex_state = 21},
  [6295] = {.lex_state = 75, .external_lex_state = 21},
  [6296] = {.lex_state = 75, .external_lex_state = 21},
  [6297] = {.lex_state = 0, .external_lex_state = 37},
  [6298] = {.lex_state = 0, .external_lex_state = 37},
  [6299] = {.lex_state = 75, .external_lex_state = 21},
  [6300] = {.lex_state = 0, .external_lex_state = 37},
  [6301] = {.lex_state = 75, .external_lex_state = 21},
  [6302] = {.lex_state = 0, .external_lex_state = 37},
  [6303] = {.lex_state = 0, .external_lex_state = 27},
  [6304] = {.lex_state = 75, .external_lex_state = 21},
  [6305] = {.lex_state = 75, .external_lex_state = 21},
  [6306] = {.lex_state = 75, .external_lex_state = 21},
  [6307] = {.lex_state = 0, .external_lex_state = 21},
  [6308] = {.lex_state = 0, .external_lex_state = 37},
  [6309] = {.lex_state = 0, .external_lex_state = 37},
  [6310] = {.lex_state = 0, .external_lex_state = 27},
  [6311] = {.lex_state = 0, .external_lex_state = 28},
  [6312] = {.lex_state = 0, .external_lex_state = 21},
  [6313] = {.lex_state = 0, .external_lex_state = 37},
  [6314] = {.lex_state = 0, .external_lex_state = 37},
  [6315] = {.lex_state = 75, .external_lex_state = 21},
  [6316] = {.lex_state = 0, .external_lex_state = 27},
  [6317] = {.lex_state = 75, .external_lex_state = 21},
  [6318] = {.lex_state = 74, .external_lex_state = 21},
  [6319] = {.lex_state = 75, .external_lex_state = 21},
  [6320] = {.lex_state = 0, .external_lex_state = 21},
  [6321] = {.lex_state = 0, .external_lex_state = 37},
  [6322] = {.lex_state = 75, .external_lex_state = 21},
  [6323] = {.lex_state = 0, .external_lex_state = 28},
  [6324] = {.lex_state = 0, .external_lex_state = 37},
  [6325] = {.lex_state = 0, .external_lex_state = 27},
  [6326] = {.lex_state = 75, .external_lex_state = 21},
  [6327] = {.lex_state = 0, .external_lex_state = 28},
  [6328] = {.lex_state = 0, .external_lex_state = 21},
  [6329] = {.lex_state = 0, .external_lex_state = 21},
  [6330] = {.lex_state = 0, .external_lex_state = 37},
  [6331] = {.lex_state = 0, .external_lex_state = 37},
  [6332] = {.lex_state = 75, .external_lex_state = 21},
  [6333] = {.lex_state = 0, .external_lex_state = 27},
  [6334] = {.lex_state = 0, .external_lex_state = 28},
  [6335] = {.lex_state = 0, .external_lex_state = 37},
  [6336] = {.lex_state = 0, .external_lex_state = 21},
  [6337] = {.lex_state = 0, .external_lex_state = 37},
  [6338] = {.lex_state = 0, .external_lex_state = 37},
  [6339] = {.lex_state = 0, .external_lex_state = 37},
  [6340] = {.lex_state = 0, .external_lex_state = 27},
  [6341] = {.lex_state = 0, .external_lex_state = 28},
  [6342] = {.lex_state = 0, .external_lex_state = 21},
  [6343] = {.lex_state = 74, .external_lex_state = 21},
  [6344] = {.lex_state = 0, .external_lex_state = 21},
  [6345] = {.lex_state = 0, .external_lex_state = 37},
  [6346] = {.lex_state = 0, .external_lex_state = 37},
  [6347] = {.lex_state = 0, .external_lex_state = 21},
  [6348] = {.lex_state = 0, .external_lex_state = 37},
  [6349] = {.lex_state = 75, .external_lex_state = 21},
  [6350] = {.lex_state = 0, .external_lex_state = 27},
  [6351] = {.lex_state = 0, .external_lex_state = 21},
  [6352] = {.lex_state = 0, .external_lex_state = 37},
  [6353] = {.lex_state = 0, .external_lex_state = 28},
  [6354] = {.lex_state = 0, .external_lex_state = 21},
  [6355] = {.lex_state = 0, .external_lex_state = 37},
  [6356] = {.lex_state = 0, .external_lex_state = 27},
  [6357] = {.lex_state = 75, .external_lex_state = 21},
  [6358] = {.lex_state = 0, .external_lex_state = 28},
  [6359] = {.lex_state = 0, .external_lex_state = 28},
  [6360] = {.lex_state = 0, .external_lex_state = 21},
  [6361] = {.lex_state = 0, .external_lex_state = 21},
  [6362] = {.lex_state = 0, .external_lex_state = 37},
  [6363] = {.lex_state = 80, .external_lex_state = 21},
  [6364] = {.lex_state = 0, .external_lex_state = 21},
  [6365] = {.lex_state = 0, .external_lex_state = 27},
  [6366] = {.lex_state = 0, .external_lex_state = 37},
  [6367] = {.lex_state = 0, .external_lex_state = 37},
  [6368] = {.lex_state = 0, .external_lex_state = 27},
  [6369] = {.lex_state = 0, .external_lex_state = 37},
  [6370] = {.lex_state = 0, .external_lex_state = 28},
  [6371] = {.lex_state = 0, .external_lex_state = 21},
  [6372] = {.lex_state = 0, .external_lex_state = 37},
  [6373] = {.lex_state = 0, .external_lex_state = 37},
  [6374] = {.lex_state = 0, .external_lex_state = 27},
  [6375] = {.lex_state = 0, .external_lex_state = 28},
  [6376] = {.lex_state = 75, .external_lex_state = 21},
  [6377] = {.lex_state = 0, .external_lex_state = 21},
  [6378] = {.lex_state = 0, .external_lex_state = 37},
  [6379] = {.lex_state = 0, .external_lex_state = 28},
  [6380] = {.lex_state = 74, .external_lex_state = 21},
  [6381] = {.lex_state = 0, .external_lex_state = 37},
  [6382] = {.lex_state = 0, .external_lex_state = 27},
  [6383] = {.lex_state = 75, .external_lex_state = 21},
  [6384] = {.lex_state = 0, .external_lex_state = 28},
  [6385] = {.lex_state = 0, .external_lex_state = 28},
  [6386] = {.lex_state = 0, .external_lex_state = 21},
  [6387] = {.lex_state = 0, .external_lex_state = 37},
  [6388] = {.lex_state = 0, .external_lex_state = 28},
  [6389] = {.lex_state = 0, .external_lex_state = 37},
  [6390] = {.lex_state = 0, .external_lex_state = 27},
  [6391] = {.lex_state = 0, .external_lex_state = 28},
  [6392] = {.lex_state = 0, .external_lex_state = 21},
  [6393] = {.lex_state = 0, .external_lex_state = 21},
  [6394] = {.lex_state = 0, .external_lex_state = 37},
  [6395] = {.lex_state = 0, .external_lex_state = 21},
  [6396] = {.lex_state = 0, .external_lex_state = 28},
  [6397] = {.lex_state = 0, .external_lex_state = 28},
  [6398] = {.lex_state = 0, .external_lex_state = 37},
  [6399] = {.lex_state = 0, .external_lex_state = 21},
  [6400] = {.lex_state = 0, .external_lex_state = 37},
  [6401] = {.lex_state = 0, .external_lex_state = 37},
  [6402] = {.lex_state = 0, .external_lex_state = 27},
  [6403] = {.lex_state = 0, .external_lex_state = 28},
  [6404] = {.lex_state = 0, .external_lex_state = 28},
  [6405] = {.lex_state = 0, .external_lex_state = 21},
  [6406] = {.lex_state = 0, .external_lex_state = 28},
  [6407] = {.lex_state = 75, .external_lex_state = 21},
  [6408] = {.lex_state = 75, .external_lex_state = 21},
  [6409] = {.lex_state = 0, .external_lex_state = 21},
  [6410] = {.lex_state = 81, .external_lex_state = 21},
  [6411] = {.lex_state = 75, .external_lex_state = 21},
  [6412] = {.lex_state = 75, .external_lex_state = 21},
  [6413] = {.lex_state = 0, .external_lex_state = 28},
  [6414] = {.lex_state = 74, .external_lex_state = 21},
  [6415] = {.lex_state = 0, .external_lex_state = 21},
  [6416] = {.lex_state = 0, .external_lex_state = 37},
  [6417] = {.lex_state = 0, .external_lex_state = 21},
  [6418] = {.lex_state = 0, .external_lex_state = 37},
  [6419] = {.lex_state = 0, .external_lex_state = 37},
  [6420] = {.lex_state = 0, .external_lex_state = 21},
  [6421] = {.lex_state = 74, .external_lex_state = 21},
  [6422] = {.lex_state = 0, .external_lex_state = 28},
  [6423] = {.lex_state = 0, .external_lex_state = 21},
  [6424] = {.lex_state = 0, .external_lex_state = 37},
  [6425] = {.lex_state = 0, .external_lex_state = 27},
  [6426] = {.lex_state = 75, .external_lex_state = 21},
  [6427] = {.lex_state = 0, .external_lex_state = 28},
  [6428] = {.lex_state = 0, .external_lex_state = 21},
  [6429] = {.lex_state = 0, .external_lex_state = 37},
  [6430] = {.lex_state = 0, .external_lex_state = 28},
  [6431] = {.lex_state = 0, .external_lex_state = 37},
  [6432] = {.lex_state = 0, .external_lex_state = 37},
  [6433] = {.lex_state = 0, .external_lex_state = 37},
  [6434] = {.lex_state = 0, .external_lex_state = 28},
  [6435] = {.lex_state = 75, .external_lex_state = 21},
  [6436] = {.lex_state = 0, .external_lex_state = 28},
  [6437] = {.lex_state = 0, .external_lex_state = 28},
  [6438] = {.lex_state = 0, .external_lex_state = 37},
  [6439] = {.lex_state = 0, .external_lex_state = 37},
  [6440] = {.lex_state = 0, .external_lex_state = 21},
  [6441] = {.lex_state = 80, .external_lex_state = 21},
  [6442] = {.lex_state = 0, .external_lex_state = 21},
  [6443] = {.lex_state = 0, .external_lex_state = 28},
  [6444] = {.lex_state = 0, .external_lex_state = 37},
  [6445] = {.lex_state = 0, .external_lex_state = 37},
  [6446] = {.lex_state = 0, .external_lex_state = 21},
  [6447] = {.lex_state = 0, .external_lex_state = 21},
  [6448] = {.lex_state = 75, .external_lex_state = 21},
  [6449] = {.lex_state = 75, .external_lex_state = 21},
  [6450] = {.lex_state = 58, .external_lex_state = 21},
  [6451] = {.lex_state = 75, .external_lex_state = 21},
  [6452] = {.lex_state = 0, .external_lex_state = 37},
  [6453] = {.lex_state = 0, .external_lex_state = 37},
  [6454] = {.lex_state = 0, .external_lex_state = 21},
  [6455] = {.lex_state = 58, .external_lex_state = 21},
  [6456] = {.lex_state = 0, .external_lex_state = 28},
  [6457] = {.lex_state = 0, .external_lex_state = 37},
  [6458] = {.lex_state = 0, .external_lex_state = 37},
  [6459] = {.lex_state = 0, .external_lex_state = 37},
  [6460] = {.lex_state = 0, .external_lex_state = 37},
  [6461] = {.lex_state = 0, .external_lex_state = 21},
  [6462] = {.lex_state = 74, .external_lex_state = 21},
  [6463] = {.lex_state = 0, .external_lex_state = 37},
  [6464] = {.lex_state = 0, .external_lex_state = 37},
  [6465] = {.lex_state = 0, .external_lex_state = 21},
  [6466] = {.lex_state = 75, .external_lex_state = 21},
  [6467] = {.lex_state = 111, .external_lex_state = 21},
  [6468] = {.lex_state = 74, .external_lex_state = 21},
  [6469] = {.lex_state = 0, .external_lex_state = 21},
  [6470] = {.lex_state = 80, .external_lex_state = 21},
  [6471] = {.lex_state = 0, .external_lex_state = 28},
  [6472] = {.lex_state = 75, .external_lex_state = 21},
  [6473] = {.lex_state = 0, .external_lex_state = 37},
  [6474] = {.lex_state = 0, .external_lex_state = 37},
  [6475] = {.lex_state = 81, .external_lex_state = 21},
  [6476] = {.lex_state = 75, .external_lex_state = 21},
  [6477] = {.lex_state = 0, .external_lex_state = 21},
  [6478] = {.lex_state = 0, .external_lex_state = 37},
  [6479] = {.lex_state = 0, .external_lex_state = 37},
  [6480] = {.lex_state = 0, .external_lex_state = 21},
  [6481] = {.lex_state = 74, .external_lex_state = 21},
  [6482] = {.lex_state = 0, .external_lex_state = 28},
  [6483] = {.lex_state = 0, .external_lex_state = 21},
  [6484] = {.lex_state = 0, .external_lex_state = 21},
  [6485] = {.lex_state = 74, .external_lex_state = 21},
  [6486] = {.lex_state = 75, .external_lex_state = 21},
  [6487] = {.lex_state = 0, .external_lex_state = 37},
  [6488] = {.lex_state = 0, .external_lex_state = 21},
  [6489] = {.lex_state = 0, .external_lex_state = 37},
  [6490] = {.lex_state = 74, .external_lex_state = 21},
  [6491] = {.lex_state = 0, .external_lex_state = 37},
  [6492] = {.lex_state = 74, .external_lex_state = 21},
  [6493] = {.lex_state = 0, .external_lex_state = 37},
  [6494] = {.lex_state = 0, .external_lex_state = 27},
  [6495] = {.lex_state = 0, .external_lex_state = 21},
  [6496] = {.lex_state = 0, .external_lex_state = 37},
  [6497] = {.lex_state = 0, .external_lex_state = 21},
  [6498] = {.lex_state = 0, .external_lex_state = 37},
  [6499] = {.lex_state = 0, .external_lex_state = 28},
  [6500] = {.lex_state = 75, .external_lex_state = 21},
  [6501] = {.lex_state = 75, .external_lex_state = 21},
  [6502] = {.lex_state = 74, .external_lex_state = 21},
  [6503] = {.lex_state = 74, .external_lex_state = 21},
  [6504] = {.lex_state = 74, .external_lex_state = 21},
  [6505] = {.lex_state = 0, .external_lex_state = 21},
  [6506] = {.lex_state = 75, .external_lex_state = 21},
  [6507] = {.lex_state = 0, .external_lex_state = 37},
  [6508] = {.lex_state = 0, .external_lex_state = 28},
  [6509] = {.lex_state = 0, .external_lex_state = 37},
  [6510] = {.lex_state = 74, .external_lex_state = 21},
  [6511] = {.lex_state = 0, .external_lex_state = 28},
  [6512] = {.lex_state = 0, .external_lex_state = 37},
  [6513] = {.lex_state = 0, .external_lex_state = 21},
  [6514] = {.lex_state = 0, .external_lex_state = 27},
  [6515] = {.lex_state = 0, .external_lex_state = 37},
  [6516] = {.lex_state = 0, .external_lex_state = 37},
  [6517] = {.lex_state = 75, .external_lex_state = 21},
  [6518] = {.lex_state = 0, .external_lex_state = 37},
  [6519] = {.lex_state = 0, .external_lex_state = 21},
  [6520] = {.lex_state = 0, .external_lex_state = 21},
  [6521] = {.lex_state = 0, .external_lex_state = 21},
  [6522] = {.lex_state = 0, .external_lex_state = 21},
  [6523] = {.lex_state = 0, .external_lex_state = 25},
  [6524] = {.lex_state = 0, .external_lex_state = 21},
  [6525] = {.lex_state = 0, .external_lex_state = 21},
  [6526] = {.lex_state = 0, .external_lex_state = 21},
  [6527] = {.lex_state = 81, .external_lex_state = 21},
  [6528] = {.lex_state = 0, .external_lex_state = 21},
  [6529] = {.lex_state = 0, .external_lex_state = 21},
  [6530] = {.lex_state = 0, .external_lex_state = 27},
  [6531] = {.lex_state = 0, .external_lex_state = 21},
  [6532] = {.lex_state = 0, .external_lex_state = 25},
  [6533] = {.lex_state = 74, .external_lex_state = 21},
  [6534] = {.lex_state = 0, .external_lex_state = 21},
  [6535] = {.lex_state = 0, .external_lex_state = 25},
  [6536] = {.lex_state = 0, .external_lex_state = 21},
  [6537] = {.lex_state = 0, .external_lex_state = 27},
  [6538] = {.lex_state = 0, .external_lex_state = 21},
  [6539] = {.lex_state = 0, .external_lex_state = 25},
  [6540] = {.lex_state = 0, .external_lex_state = 21},
  [6541] = {.lex_state = 0, .external_lex_state = 25},
  [6542] = {.lex_state = 0, .external_lex_state = 25},
  [6543] = {.lex_state = 0, .external_lex_state = 25},
  [6544] = {.lex_state = 74, .external_lex_state = 21},
  [6545] = {.lex_state = 0, .external_lex_state = 25},
  [6546] = {.lex_state = 0, .external_lex_state = 21},
  [6547] = {.lex_state = 0, .external_lex_state = 21},
  [6548] = {.lex_state = 81, .external_lex_state = 21},
  [6549] = {.lex_state = 0, .external_lex_state = 21},
  [6550] = {.lex_state = 0, .external_lex_state = 21},
  [6551] = {.lex_state = 0, .external_lex_state = 21},
  [6552] = {.lex_state = 0, .external_lex_state = 27},
  [6553] = {.lex_state = 0, .external_lex_state = 21},
  [6554] = {.lex_state = 0, .external_lex_state = 21},
  [6555] = {.lex_state = 0, .external_lex_state = 25},
  [6556] = {.lex_state = 0, .external_lex_state = 21},
  [6557] = {.lex_state = 0, .external_lex_state = 25},
  [6558] = {.lex_state = 0, .external_lex_state = 21},
  [6559] = {.lex_state = 0, .external_lex_state = 25},
  [6560] = {.lex_state = 0, .external_lex_state = 21},
  [6561] = {.lex_state = 0, .external_lex_state = 25},
  [6562] = {.lex_state = 0, .external_lex_state = 25},
  [6563] = {.lex_state = 0, .external_lex_state = 25},
  [6564] = {.lex_state = 74, .external_lex_state = 21},
  [6565] = {.lex_state = 0, .external_lex_state = 25},
  [6566] = {.lex_state = 0, .external_lex_state = 21},
  [6567] = {.lex_state = 0, .external_lex_state = 21},
  [6568] = {.lex_state = 0, .external_lex_state = 21},
  [6569] = {.lex_state = 74, .external_lex_state = 21},
  [6570] = {.lex_state = 74, .external_lex_state = 21},
  [6571] = {.lex_state = 0, .external_lex_state = 27},
  [6572] = {.lex_state = 0, .external_lex_state = 21},
  [6573] = {.lex_state = 0, .external_lex_state = 21},
  [6574] = {.lex_state = 0, .external_lex_state = 25},
  [6575] = {.lex_state = 0, .external_lex_state = 21},
  [6576] = {.lex_state = 0, .external_lex_state = 25},
  [6577] = {.lex_state = 74, .external_lex_state = 21},
  [6578] = {.lex_state = 0, .external_lex_state = 25},
  [6579] = {.lex_state = 0, .external_lex_state = 21},
  [6580] = {.lex_state = 0, .external_lex_state = 21},
  [6581] = {.lex_state = 0, .external_lex_state = 25},
  [6582] = {.lex_state = 0, .external_lex_state = 25},
  [6583] = {.lex_state = 0, .external_lex_state = 25},
  [6584] = {.lex_state = 0, .external_lex_state = 25},
  [6585] = {.lex_state = 0, .external_lex_state = 25},
  [6586] = {.lex_state = 0, .external_lex_state = 21},
  [6587] = {.lex_state = 0, .external_lex_state = 25},
  [6588] = {.lex_state = 0, .external_lex_state = 25},
  [6589] = {.lex_state = 0, .external_lex_state = 21},
  [6590] = {.lex_state = 0, .external_lex_state = 21},
  [6591] = {.lex_state = 0, .external_lex_state = 25},
  [6592] = {.lex_state = 0, .external_lex_state = 21},
  [6593] = {.lex_state = 0, .external_lex_state = 27},
  [6594] = {.lex_state = 74, .external_lex_state = 21},
  [6595] = {.lex_state = 0, .external_lex_state = 25},
  [6596] = {.lex_state = 0, .external_lex_state = 21},
  [6597] = {.lex_state = 0, .external_lex_state = 21},
  [6598] = {.lex_state = 0, .external_lex_state = 25},
  [6599] = {.lex_state = 0, .external_lex_state = 21},
  [6600] = {.lex_state = 0, .external_lex_state = 21},
  [6601] = {.lex_state = 0, .external_lex_state = 21},
  [6602] = {.lex_state = 0, .external_lex_state = 25},
  [6603] = {.lex_state = 0, .external_lex_state = 25},
  [6604] = {.lex_state = 0, .external_lex_state = 21},
  [6605] = {.lex_state = 0, .external_lex_state = 25},
  [6606] = {.lex_state = 0, .external_lex_state = 25},
  [6607] = {.lex_state = 0, .external_lex_state = 25},
  [6608] = {.lex_state = 0, .external_lex_state = 25},
  [6609] = {.lex_state = 0, .external_lex_state = 21},
  [6610] = {.lex_state = 74, .external_lex_state = 21},
  [6611] = {.lex_state = 0, .external_lex_state = 25},
  [6612] = {.lex_state = 0, .external_lex_state = 25},
  [6613] = {.lex_state = 0, .external_lex_state = 21},
  [6614] = {.lex_state = 0, .external_lex_state = 21},
  [6615] = {.lex_state = 0, .external_lex_state = 21},
  [6616] = {.lex_state = 0, .external_lex_state = 27},
  [6617] = {.lex_state = 0, .external_lex_state = 25},
  [6618] = {.lex_state = 74, .external_lex_state = 21},
  [6619] = {.lex_state = 0, .external_lex_state = 25},
  [6620] = {.lex_state = 0, .external_lex_state = 27},
  [6621] = {.lex_state = 58, .external_lex_state = 21},
  [6622] = {.lex_state = 0, .external_lex_state = 21},
  [6623] = {.lex_state = 0, .external_lex_state = 25},
  [6624] = {.lex_state = 0, .external_lex_state = 27},
  [6625] = {.lex_state = 0, .external_lex_state = 21},
  [6626] = {.lex_state = 0, .external_lex_state = 25},
  [6627] = {.lex_state = 0, .external_lex_state = 25},
  [6628] = {.lex_state = 0, .external_lex_state = 25},
  [6629] = {.lex_state = 0, .external_lex_state = 25},
  [6630] = {.lex_state = 0, .external_lex_state = 21},
  [6631] = {.lex_state = 0, .external_lex_state = 25},
  [6632] = {.lex_state = 0, .external_lex_state = 21},
  [6633] = {.lex_state = 0, .external_lex_state = 25},
  [6634] = {.lex_state = 0, .external_lex_state = 21},
  [6635] = {.lex_state = 0, .external_lex_state = 25},
  [6636] = {.lex_state = 0, .external_lex_state = 25},
  [6637] = {.lex_state = 0, .external_lex_state = 25},
  [6638] = {.lex_state = 0, .external_lex_state = 21},
  [6639] = {.lex_state = 74, .external_lex_state = 21},
  [6640] = {.lex_state = 0, .external_lex_state = 25},
  [6641] = {.lex_state = 0, .external_lex_state = 21},
  [6642] = {.lex_state = 0, .external_lex_state = 21},
  [6643] = {.lex_state = 0, .external_lex_state = 25},
  [6644] = {.lex_state = 0, .external_lex_state = 25},
  [6645] = {.lex_state = 0, .external_lex_state = 21},
  [6646] = {.lex_state = 74, .external_lex_state = 21},
  [6647] = {.lex_state = 0, .external_lex_state = 21},
  [6648] = {.lex_state = 0, .external_lex_state = 27},
  [6649] = {.lex_state = 0, .external_lex_state = 27},
  [6650] = {.lex_state = 0, .external_lex_state = 21},
  [6651] = {.lex_state = 0, .external_lex_state = 21},
  [6652] = {.lex_state = 0, .external_lex_state = 25},
  [6653] = {.lex_state = 0, .external_lex_state = 21},
  [6654] = {.lex_state = 0, .external_lex_state = 21},
  [6655] = {.lex_state = 74, .external_lex_state = 21},
  [6656] = {.lex_state = 0, .external_lex_state = 25},
  [6657] = {.lex_state = 0, .external_lex_state = 21},
  [6658] = {.lex_state = 0, .external_lex_state = 21},
  [6659] = {.lex_state = 74, .external_lex_state = 21},
  [6660] = {.lex_state = 0, .external_lex_state = 25},
  [6661] = {.lex_state = 0, .external_lex_state = 27},
  [6662] = {.lex_state = 0, .external_lex_state = 21},
  [6663] = {.lex_state = 0, .external_lex_state = 21},
  [6664] = {.lex_state = 0, .external_lex_state = 25},
  [6665] = {.lex_state = 0, .external_lex_state = 25},
  [6666] = {.lex_state = 0, .external_lex_state = 25},
  [6667] = {.lex_state = 0, .external_lex_state = 21},
  [6668] = {.lex_state = 0, .external_lex_state = 21},
  [6669] = {.lex_state = 0, .external_lex_state = 25},
  [6670] = {.lex_state = 0, .external_lex_state = 21},
  [6671] = {.lex_state = 0, .external_lex_state = 21},
  [6672] = {.lex_state = 0, .external_lex_state = 21},
  [6673] = {.lex_state = 0, .external_lex_state = 27},
  [6674] = {.lex_state = 0, .external_lex_state = 21},
  [6675] = {.lex_state = 74, .external_lex_state = 21},
  [6676] = {.lex_state = 0, .external_lex_state = 21},
  [6677] = {.lex_state = 0, .external_lex_state = 25},
  [6678] = {.lex_state = 0, .external_lex_state = 27},
  [6679] = {.lex_state = 0, .external_lex_state = 21},
  [6680] = {.lex_state = 58, .external_lex_state = 21},
  [6681] = {.lex_state = 0, .external_lex_state = 25},
  [6682] = {.lex_state = 0, .external_lex_state = 21},
  [6683] = {.lex_state = 74, .external_lex_state = 21},
  [6684] = {.lex_state = 0, .external_lex_state = 21},
  [6685] = {.lex_state = 0, .external_lex_state = 25},
  [6686] = {.lex_state = 0, .external_lex_state = 21},
  [6687] = {.lex_state = 0, .external_lex_state = 21},
  [6688] = {.lex_state = 74, .external_lex_state = 21},
  [6689] = {.lex_state = 0, .external_lex_state = 25},
  [6690] = {.lex_state = 0, .external_lex_state = 25},
  [6691] = {.lex_state = 74, .external_lex_state = 21},
  [6692] = {.lex_state = 0, .external_lex_state = 21},
  [6693] = {.lex_state = 0, .external_lex_state = 25},
  [6694] = {.lex_state = 0, .external_lex_state = 25},
  [6695] = {.lex_state = 0, .external_lex_state = 25},
  [6696] = {.lex_state = 0, .external_lex_state = 25},
  [6697] = {.lex_state = 0, .external_lex_state = 25},
  [6698] = {.lex_state = 0, .external_lex_state = 21},
  [6699] = {.lex_state = 0, .external_lex_state = 21},
  [6700] = {.lex_state = 0, .external_lex_state = 21},
  [6701] = {.lex_state = 0, .external_lex_state = 21},
  [6702] = {.lex_state = 0, .external_lex_state = 27},
  [6703] = {.lex_state = 0, .external_lex_state = 21},
  [6704] = {.lex_state = 0, .external_lex_state = 25},
  [6705] = {.lex_state = 0, .external_lex_state = 21},
  [6706] = {.lex_state = 0, .external_lex_state = 21},
  [6707] = {.lex_state = 0, .external_lex_state = 25},
  [6708] = {.lex_state = 58, .external_lex_state = 21},
  [6709] = {.lex_state = 74, .external_lex_state = 21},
  [6710] = {.lex_state = 0, .external_lex_state = 25},
  [6711] = {.lex_state = 0, .external_lex_state = 21},
  [6712] = {.lex_state = 0, .external_lex_state = 27},
  [6713] = {.lex_state = 0, .external_lex_state = 25},
  [6714] = {.lex_state = 0, .external_lex_state = 21},
  [6715] = {.lex_state = 0, .external_lex_state = 25},
  [6716] = {.lex_state = 0, .external_lex_state = 21},
  [6717] = {.lex_state = 0, .external_lex_state = 27},
  [6718] = {.lex_state = 0, .external_lex_state = 25},
  [6719] = {.lex_state = 0, .external_lex_state = 21},
  [6720] = {.lex_state = 0, .external_lex_state = 21},
  [6721] = {.lex_state = 0, .external_lex_state = 21},
  [6722] = {.lex_state = 0, .external_lex_state = 21},
  [6723] = {.lex_state = 0, .external_lex_state = 25},
  [6724] = {.lex_state = 0, .external_lex_state = 21},
  [6725] = {.lex_state = 74, .external_lex_state = 21},
  [6726] = {.lex_state = 0, .external_lex_state = 25},
  [6727] = {.lex_state = 0, .external_lex_state = 21},
  [6728] = {.lex_state = 0, .external_lex_state = 21},
  [6729] = {.lex_state = 0, .external_lex_state = 25},
  [6730] = {.lex_state = 0, .external_lex_state = 27},
  [6731] = {.lex_state = 0, .external_lex_state = 25},
  [6732] = {.lex_state = 0, .external_lex_state = 21},
  [6733] = {.lex_state = 0, .external_lex_state = 21},
  [6734] = {.lex_state = 0, .external_lex_state = 27},
  [6735] = {.lex_state = 74, .external_lex_state = 21},
  [6736] = {.lex_state = 0, .external_lex_state = 21},
  [6737] = {.lex_state = 0, .external_lex_state = 21},
  [6738] = {.lex_state = 0, .external_lex_state = 21},
  [6739] = {.lex_state = 0, .external_lex_state = 21},
  [6740] = {.lex_state = 0, .external_lex_state = 21},
  [6741] = {.lex_state = 0, .external_lex_state = 25},
  [6742] = {.lex_state = 0, .external_lex_state = 21},
  [6743] = {.lex_state = 0, .external_lex_state = 21},
  [6744] = {.lex_state = 0, .external_lex_state = 21},
  [6745] = {.lex_state = 0, .external_lex_state = 21},
  [6746] = {.lex_state = 0, .external_lex_state = 21},
  [6747] = {.lex_state = 0, .external_lex_state = 25},
  [6748] = {.lex_state = 0, .external_lex_state = 21},
  [6749] = {.lex_state = 0, .external_lex_state = 25},
  [6750] = {.lex_state = 0, .external_lex_state = 25},
  [6751] = {.lex_state = 0, .external_lex_state = 25},
  [6752] = {.lex_state = 0, .external_lex_state = 25},
  [6753] = {.lex_state = 74, .external_lex_state = 21},
  [6754] = {.lex_state = 0, .external_lex_state = 21},
  [6755] = {.lex_state = 0, .external_lex_state = 21},
  [6756] = {.lex_state = 0, .external_lex_state = 25},
  [6757] = {.lex_state = 0, .external_lex_state = 25},
  [6758] = {.lex_state = 0, .external_lex_state = 21},
  [6759] = {.lex_state = 0, .external_lex_state = 21},
  [6760] = {.lex_state = 0, .external_lex_state = 21},
  [6761] = {.lex_state = 0, .external_lex_state = 21},
  [6762] = {.lex_state = 0, .external_lex_state = 21},
  [6763] = {.lex_state = 0, .external_lex_state = 21},
  [6764] = {.lex_state = 0, .external_lex_state = 21},
  [6765] = {.lex_state = 0, .external_lex_state = 21},
  [6766] = {.lex_state = 0, .external_lex_state = 21},
  [6767] = {.lex_state = 0, .external_lex_state = 21},
  [6768] = {.lex_state = 0, .external_lex_state = 21},
  [6769] = {.lex_state = 0, .external_lex_state = 21},
  [6770] = {.lex_state = 0, .external_lex_state = 21},
  [6771] = {.lex_state = 58, .external_lex_state = 21},
  [6772] = {.lex_state = 0, .external_lex_state = 21},
  [6773] = {.lex_state = 0, .external_lex_state = 25},
  [6774] = {.lex_state = 0, .external_lex_state = 25},
  [6775] = {.lex_state = 0, .external_lex_state = 25},
  [6776] = {.lex_state = 0, .external_lex_state = 25},
  [6777] = {.lex_state = 58, .external_lex_state = 21},
  [6778] = {.lex_state = 74, .external_lex_state = 21},
  [6779] = {.lex_state = 0, .external_lex_state = 21},
  [6780] = {.lex_state = 0, .external_lex_state = 25},
  [6781] = {.lex_state = 0, .external_lex_state = 21},
  [6782] = {.lex_state = 0, .external_lex_state = 21},
  [6783] = {.lex_state = 0, .external_lex_state = 25},
  [6784] = {.lex_state = 0, .external_lex_state = 25},
  [6785] = {.lex_state = 0, .external_lex_state = 21},
  [6786] = {.lex_state = 0, .external_lex_state = 21},
  [6787] = {.lex_state = 0, .external_lex_state = 21},
  [6788] = {.lex_state = 0, .external_lex_state = 25},
  [6789] = {.lex_state = 0, .external_lex_state = 25},
  [6790] = {.lex_state = 0, .external_lex_state = 25},
  [6791] = {.lex_state = 0, .external_lex_state = 21},
  [6792] = {.lex_state = 0, .external_lex_state = 27},
  [6793] = {.lex_state = 0, .external_lex_state = 21},
  [6794] = {.lex_state = 0, .external_lex_state = 21},
  [6795] = {.lex_state = 74, .external_lex_state = 21},
  [6796] = {.lex_state = 74, .external_lex_state = 21},
  [6797] = {.lex_state = 74, .external_lex_state = 21},
  [6798] = {.lex_state = 0, .external_lex_state = 21},
  [6799] = {.lex_state = 74, .external_lex_state = 21},
  [6800] = {.lex_state = 58, .external_lex_state = 21},
  [6801] = {.lex_state = 74, .external_lex_state = 21},
  [6802] = {.lex_state = 74, .external_lex_state = 21},
  [6803] = {.lex_state = 0, .external_lex_state = 21},
  [6804] = {.lex_state = 0, .external_lex_state = 21},
  [6805] = {.lex_state = 75, .external_lex_state = 21},
  [6806] = {.lex_state = 74, .external_lex_state = 21},
  [6807] = {.lex_state = 0, .external_lex_state = 21},
  [6808] = {.lex_state = 0, .external_lex_state = 25},
  [6809] = {.lex_state = 58, .external_lex_state = 21},
  [6810] = {.lex_state = 0, .external_lex_state = 25},
  [6811] = {.lex_state = 0, .external_lex_state = 25},
  [6812] = {.lex_state = 0, .external_lex_state = 25},
  [6813] = {.lex_state = 0, .external_lex_state = 25},
  [6814] = {.lex_state = 58, .external_lex_state = 21},
  [6815] = {.lex_state = 0, .external_lex_state = 25},
  [6816] = {.lex_state = 0, .external_lex_state = 25},
  [6817] = {.lex_state = 0, .external_lex_state = 25},
  [6818] = {.lex_state = 0, .external_lex_state = 21},
  [6819] = {.lex_state = 0, .external_lex_state = 25},
  [6820] = {.lex_state = 74, .external_lex_state = 21},
  [6821] = {.lex_state = 0, .external_lex_state = 21},
  [6822] = {.lex_state = 74, .external_lex_state = 21},
  [6823] = {.lex_state = 0, .external_lex_state = 25},
  [6824] = {.lex_state = 58, .external_lex_state = 21},
  [6825] = {.lex_state = 0, .external_lex_state = 21},
  [6826] = {.lex_state = 0, .external_lex_state = 25},
  [6827] = {.lex_state = 0, .external_lex_state = 25},
  [6828] = {.lex_state = 0, .external_lex_state = 25},
  [6829] = {.lex_state = 58, .external_lex_state = 21},
  [6830] = {.lex_state = 0, .external_lex_state = 25},
  [6831] = {.lex_state = 0, .external_lex_state = 21},
  [6832] = {.lex_state = 0, .external_lex_state = 21},
  [6833] = {.lex_state = 0, .external_lex_state = 21},
  [6834] = {.lex_state = 74, .external_lex_state = 21},
  [6835] = {.lex_state = 0, .external_lex_state = 25},
  [6836] = {.lex_state = 0, .external_lex_state = 25},
  [6837] = {.lex_state = 58, .external_lex_state = 21},
  [6838] = {.lex_state = 0, .external_lex_state = 21},
  [6839] = {.lex_state = 0, .external_lex_state = 25},
  [6840] = {.lex_state = 0, .external_lex_state = 25},
  [6841] = {.lex_state = 0, .external_lex_state = 21},
  [6842] = {.lex_state = 58, .external_lex_state = 21},
  [6843] = {.lex_state = 0, .external_lex_state = 27},
  [6844] = {.lex_state = 74, .external_lex_state = 21},
  [6845] = {.lex_state = 0, .external_lex_state = 21},
  [6846] = {.lex_state = 0, .external_lex_state = 21},
  [6847] = {.lex_state = 0, .external_lex_state = 21},
  [6848] = {.lex_state = 0, .external_lex_state = 21},
  [6849] = {.lex_state = 0, .external_lex_state = 25},
  [6850] = {.lex_state = 58, .external_lex_state = 21},
  [6851] = {.lex_state = 0, .external_lex_state = 21},
  [6852] = {.lex_state = 0, .external_lex_state = 25},
  [6853] = {.lex_state = 0, .external_lex_state = 25},
  [6854] = {.lex_state = 0, .external_lex_state = 21},
  [6855] = {.lex_state = 58, .external_lex_state = 21},
  [6856] = {.lex_state = 0, .external_lex_state = 21},
  [6857] = {.lex_state = 0, .external_lex_state = 21},
  [6858] = {.lex_state = 0, .external_lex_state = 21},
  [6859] = {.lex_state = 0, .external_lex_state = 21},
  [6860] = {.lex_state = 0, .external_lex_state = 21},
  [6861] = {.lex_state = 0, .external_lex_state = 25},
  [6862] = {.lex_state = 0, .external_lex_state = 25},
  [6863] = {.lex_state = 58, .external_lex_state = 21},
  [6864] = {.lex_state = 0, .external_lex_state = 21},
  [6865] = {.lex_state = 0, .external_lex_state = 25},
  [6866] = {.lex_state = 0, .external_lex_state = 25},
  [6867] = {.lex_state = 0, .external_lex_state = 25},
  [6868] = {.lex_state = 58, .external_lex_state = 21},
  [6869] = {.lex_state = 0, .external_lex_state = 25},
  [6870] = {.lex_state = 0, .external_lex_state = 21},
  [6871] = {.lex_state = 0, .external_lex_state = 25},
  [6872] = {.lex_state = 0, .external_lex_state = 21},
  [6873] = {.lex_state = 0, .external_lex_state = 21},
  [6874] = {.lex_state = 0, .external_lex_state = 25},
  [6875] = {.lex_state = 0, .external_lex_state = 25},
  [6876] = {.lex_state = 58, .external_lex_state = 21},
  [6877] = {.lex_state = 0, .external_lex_state = 25},
  [6878] = {.lex_state = 0, .external_lex_state = 25},
  [6879] = {.lex_state = 0, .external_lex_state = 25},
  [6880] = {.lex_state = 0, .external_lex_state = 21},
  [6881] = {.lex_state = 58, .external_lex_state = 21},
  [6882] = {.lex_state = 74, .external_lex_state = 21},
  [6883] = {.lex_state = 0, .external_lex_state = 25},
  [6884] = {.lex_state = 0, .external_lex_state = 21},
  [6885] = {.lex_state = 0, .external_lex_state = 21},
  [6886] = {.lex_state = 0, .external_lex_state = 27},
  [6887] = {.lex_state = 0, .external_lex_state = 21},
  [6888] = {.lex_state = 0, .external_lex_state = 25},
  [6889] = {.lex_state = 58, .external_lex_state = 21},
  [6890] = {.lex_state = 0, .external_lex_state = 21},
  [6891] = {.lex_state = 0, .external_lex_state = 25},
  [6892] = {.lex_state = 0, .external_lex_state = 25},
  [6893] = {.lex_state = 0, .external_lex_state = 21},
  [6894] = {.lex_state = 58, .external_lex_state = 21},
  [6895] = {.lex_state = 0, .external_lex_state = 21},
  [6896] = {.lex_state = 74, .external_lex_state = 21},
  [6897] = {.lex_state = 0, .external_lex_state = 25},
  [6898] = {.lex_state = 0, .external_lex_state = 21},
  [6899] = {.lex_state = 0, .external_lex_state = 25},
  [6900] = {.lex_state = 0, .external_lex_state = 21},
  [6901] = {.lex_state = 0, .external_lex_state = 25},
  [6902] = {.lex_state = 58, .external_lex_state = 21},
  [6903] = {.lex_state = 0, .external_lex_state = 25},
  [6904] = {.lex_state = 0, .external_lex_state = 25},
  [6905] = {.lex_state = 0, .external_lex_state = 25},
  [6906] = {.lex_state = 0, .external_lex_state = 21},
  [6907] = {.lex_state = 58, .external_lex_state = 21},
  [6908] = {.lex_state = 0, .external_lex_state = 25},
  [6909] = {.lex_state = 0, .external_lex_state = 25},
  [6910] = {.lex_state = 74, .external_lex_state = 21},
  [6911] = {.lex_state = 0, .external_lex_state = 21},
  [6912] = {.lex_state = 74, .external_lex_state = 21},
  [6913] = {.lex_state = 0, .external_lex_state = 25},
  [6914] = {.lex_state = 0, .external_lex_state = 25},
  [6915] = {.lex_state = 58, .external_lex_state = 21},
  [6916] = {.lex_state = 0, .external_lex_state = 21},
  [6917] = {.lex_state = 0, .external_lex_state = 25},
  [6918] = {.lex_state = 0, .external_lex_state = 25},
  [6919] = {.lex_state = 0, .external_lex_state = 21},
  [6920] = {.lex_state = 58, .external_lex_state = 21},
  [6921] = {.lex_state = 0, .external_lex_state = 25},
  [6922] = {.lex_state = 0, .external_lex_state = 21},
  [6923] = {.lex_state = 0, .external_lex_state = 21},
  [6924] = {.lex_state = 0, .external_lex_state = 21},
  [6925] = {.lex_state = 0, .external_lex_state = 21},
  [6926] = {.lex_state = 0, .external_lex_state = 25},
  [6927] = {.lex_state = 0, .external_lex_state = 25},
  [6928] = {.lex_state = 58, .external_lex_state = 21},
  [6929] = {.lex_state = 0, .external_lex_state = 25},
  [6930] = {.lex_state = 0, .external_lex_state = 25},
  [6931] = {.lex_state = 0, .external_lex_state = 25},
  [6932] = {.lex_state = 58, .external_lex_state = 21},
  [6933] = {.lex_state = 74, .external_lex_state = 21},
  [6934] = {.lex_state = 74, .external_lex_state = 21},
  [6935] = {.lex_state = 0, .external_lex_state = 25},
  [6936] = {.lex_state = 0, .external_lex_state = 21},
  [6937] = {.lex_state = 0, .external_lex_state = 21},
  [6938] = {.lex_state = 0, .external_lex_state = 27},
  [6939] = {.lex_state = 0, .external_lex_state = 25},
  [6940] = {.lex_state = 58, .external_lex_state = 21},
  [6941] = {.lex_state = 0, .external_lex_state = 25},
  [6942] = {.lex_state = 0, .external_lex_state = 25},
  [6943] = {.lex_state = 74, .external_lex_state = 21},
  [6944] = {.lex_state = 58, .external_lex_state = 21},
  [6945] = {.lex_state = 74, .external_lex_state = 21},
  [6946] = {.lex_state = 74, .external_lex_state = 21},
  [6947] = {.lex_state = 0, .external_lex_state = 21},
  [6948] = {.lex_state = 0, .external_lex_state = 21},
  [6949] = {.lex_state = 0, .external_lex_state = 25},
  [6950] = {.lex_state = 0, .external_lex_state = 21},
  [6951] = {.lex_state = 0, .external_lex_state = 25},
  [6952] = {.lex_state = 58, .external_lex_state = 21},
  [6953] = {.lex_state = 0, .external_lex_state = 25},
  [6954] = {.lex_state = 0, .external_lex_state = 25},
  [6955] = {.lex_state = 0, .external_lex_state = 21},
  [6956] = {.lex_state = 58, .external_lex_state = 21},
  [6957] = {.lex_state = 0, .external_lex_state = 25},
  [6958] = {.lex_state = 0, .external_lex_state = 21},
  [6959] = {.lex_state = 74, .external_lex_state = 21},
  [6960] = {.lex_state = 0, .external_lex_state = 21},
  [6961] = {.lex_state = 74, .external_lex_state = 21},
  [6962] = {.lex_state = 0, .external_lex_state = 25},
  [6963] = {.lex_state = 58, .external_lex_state = 21},
  [6964] = {.lex_state = 0, .external_lex_state = 25},
  [6965] = {.lex_state = 0, .external_lex_state = 25},
  [6966] = {.lex_state = 0, .external_lex_state = 25},
  [6967] = {.lex_state = 58, .external_lex_state = 21},
  [6968] = {.lex_state = 0, .external_lex_state = 21},
  [6969] = {.lex_state = 0, .external_lex_state = 25},
  [6970] = {.lex_state = 0, .external_lex_state = 21},
  [6971] = {.lex_state = 0, .external_lex_state = 21},
  [6972] = {.lex_state = 0, .external_lex_state = 27},
  [6973] = {.lex_state = 0, .external_lex_state = 25},
  [6974] = {.lex_state = 58, .external_lex_state = 21},
  [6975] = {.lex_state = 0, .external_lex_state = 25},
  [6976] = {.lex_state = 0, .external_lex_state = 25},
  [6977] = {.lex_state = 74, .external_lex_state = 21},
  [6978] = {.lex_state = 58, .external_lex_state = 21},
  [6979] = {.lex_state = 0, .external_lex_state = 25},
  [6980] = {.lex_state = 0, .external_lex_state = 25},
  [6981] = {.lex_state = 74, .external_lex_state = 21},
  [6982] = {.lex_state = 0, .external_lex_state = 21},
  [6983] = {.lex_state = 0, .external_lex_state = 21},
  [6984] = {.lex_state = 0, .external_lex_state = 25},
  [6985] = {.lex_state = 58, .external_lex_state = 21},
  [6986] = {.lex_state = 0, .external_lex_state = 27},
  [6987] = {.lex_state = 58, .external_lex_state = 21},
  [6988] = {.lex_state = 0, .external_lex_state = 25},
  [6989] = {.lex_state = 0, .external_lex_state = 21},
  [6990] = {.lex_state = 0, .external_lex_state = 25},
  [6991] = {.lex_state = 58, .external_lex_state = 21},
  [6992] = {.lex_state = 58, .external_lex_state = 21},
  [6993] = {.lex_state = 0, .external_lex_state = 25},
  [6994] = {.lex_state = 0, .external_lex_state = 25},
  [6995] = {.lex_state = 0, .external_lex_state = 21},
  [6996] = {.lex_state = 58, .external_lex_state = 21},
  [6997] = {.lex_state = 58, .external_lex_state = 21},
  [6998] = {.lex_state = 0, .external_lex_state = 21},
  [6999] = {.lex_state = 0, .external_lex_state = 21},
  [7000] = {.lex_state = 0, .external_lex_state = 25},
  [7001] = {.lex_state = 58, .external_lex_state = 21},
  [7002] = {.lex_state = 81, .external_lex_state = 21},
  [7003] = {.lex_state = 58, .external_lex_state = 21},
  [7004] = {.lex_state = 0, .external_lex_state = 25},
  [7005] = {.lex_state = 58, .external_lex_state = 21},
  [7006] = {.lex_state = 0, .external_lex_state = 21},
  [7007] = {.lex_state = 0, .external_lex_state = 21},
  [7008] = {.lex_state = 0, .external_lex_state = 21},
  [7009] = {.lex_state = 0, .external_lex_state = 37},
  [7010] = {.lex_state = 0, .external_lex_state = 25},
  [7011] = {.lex_state = 0, .external_lex_state = 25},
  [7012] = {.lex_state = 0, .external_lex_state = 25},
  [7013] = {.lex_state = 0, .external_lex_state = 25},
  [7014] = {.lex_state = 0, .external_lex_state = 21},
  [7015] = {.lex_state = 0, .external_lex_state = 21},
  [7016] = {.lex_state = 0, .external_lex_state = 21},
  [7017] = {.lex_state = 0, .external_lex_state = 21},
  [7018] = {.lex_state = 0, .external_lex_state = 25},
  [7019] = {.lex_state = 0, .external_lex_state = 21},
  [7020] = {.lex_state = 0, .external_lex_state = 25},
  [7021] = {.lex_state = 0, .external_lex_state = 25},
  [7022] = {.lex_state = 0, .external_lex_state = 25},
  [7023] = {.lex_state = 58, .external_lex_state = 21},
  [7024] = {.lex_state = 0, .external_lex_state = 21},
  [7025] = {.lex_state = 0, .external_lex_state = 27},
  [7026] = {.lex_state = 0, .external_lex_state = 25},
  [7027] = {.lex_state = 81, .external_lex_state = 21},
  [7028] = {.lex_state = 0, .external_lex_state = 21},
  [7029] = {.lex_state = 74, .external_lex_state = 21},
  [7030] = {.lex_state = 0, .external_lex_state = 25},
  [7031] = {.lex_state = 0, .external_lex_state = 21},
  [7032] = {.lex_state = 0, .external_lex_state = 21},
  [7033] = {.lex_state = 0, .external_lex_state = 21},
  [7034] = {.lex_state = 74, .external_lex_state = 21},
  [7035] = {.lex_state = 0, .external_lex_state = 25},
  [7036] = {.lex_state = 0, .external_lex_state = 21},
  [7037] = {.lex_state = 74, .external_lex_state = 21},
  [7038] = {.lex_state = 0, .external_lex_state = 25},
  [7039] = {.lex_state = 0, .external_lex_state = 25},
  [7040] = {.lex_state = 0, .external_lex_state = 25},
  [7041] = {.lex_state = 0, .external_lex_state = 25},
  [7042] = {.lex_state = 0, .external_lex_state = 25},
  [7043] = {.lex_state = 74, .external_lex_state = 21},
  [7044] = {.lex_state = 0, .external_lex_state = 21},
  [7045] = {.lex_state = 0, .external_lex_state = 21},
  [7046] = {.lex_state = 0, .external_lex_state = 21},
  [7047] = {.lex_state = 74, .external_lex_state = 21},
  [7048] = {.lex_state = 0, .external_lex_state = 37},
  [7049] = {.lex_state = 0, .external_lex_state = 21},
  [7050] = {.lex_state = 0, .external_lex_state = 25},
  [7051] = {.lex_state = 0, .external_lex_state = 25},
  [7052] = {.lex_state = 0, .external_lex_state = 25},
  [7053] = {.lex_state = 0, .external_lex_state = 25},
  [7054] = {.lex_state = 0, .external_lex_state = 25},
  [7055] = {.lex_state = 0, .external_lex_state = 25},
  [7056] = {.lex_state = 0, .external_lex_state = 25},
  [7057] = {.lex_state = 0, .external_lex_state = 25},
  [7058] = {.lex_state = 0, .external_lex_state = 25},
  [7059] = {.lex_state = 0, .external_lex_state = 25},
  [7060] = {.lex_state = 0, .external_lex_state = 25},
  [7061] = {.lex_state = 0, .external_lex_state = 25},
  [7062] = {.lex_state = 0, .external_lex_state = 25},
  [7063] = {.lex_state = 0, .external_lex_state = 25},
  [7064] = {.lex_state = 0, .external_lex_state = 25},
  [7065] = {.lex_state = 0, .external_lex_state = 25},
  [7066] = {.lex_state = 0, .external_lex_state = 25},
  [7067] = {.lex_state = 0, .external_lex_state = 25},
  [7068] = {.lex_state = 0, .external_lex_state = 25},
  [7069] = {.lex_state = 0, .external_lex_state = 25},
  [7070] = {.lex_state = 0, .external_lex_state = 25},
  [7071] = {.lex_state = 0, .external_lex_state = 25},
  [7072] = {.lex_state = 0, .external_lex_state = 25},
  [7073] = {.lex_state = 0, .external_lex_state = 25},
  [7074] = {.lex_state = 0, .external_lex_state = 25},
  [7075] = {.lex_state = 0, .external_lex_state = 25},
  [7076] = {.lex_state = 0, .external_lex_state = 25},
  [7077] = {.lex_state = 0, .external_lex_state = 25},
  [7078] = {.lex_state = 0, .external_lex_state = 25},
  [7079] = {.lex_state = 0, .external_lex_state = 25},
  [7080] = {.lex_state = 0, .external_lex_state = 25},
  [7081] = {.lex_state = 0, .external_lex_state = 25},
  [7082] = {.lex_state = 0, .external_lex_state = 25},
  [7083] = {.lex_state = 0, .external_lex_state = 21},
  [7084] = {.lex_state = 74, .external_lex_state = 21},
  [7085] = {.lex_state = 0, .external_lex_state = 25},
  [7086] = {.lex_state = 0, .external_lex_state = 27},
  [7087] = {.lex_state = 0, .external_lex_state = 27},
  [7088] = {.lex_state = 0, .external_lex_state = 21},
  [7089] = {.lex_state = 0, .external_lex_state = 27},
  [7090] = {.lex_state = 0, .external_lex_state = 21},
  [7091] = {.lex_state = 0, .external_lex_state = 21},
  [7092] = {.lex_state = 0, .external_lex_state = 21},
  [7093] = {.lex_state = 0, .external_lex_state = 21},
  [7094] = {.lex_state = 0, .external_lex_state = 21},
  [7095] = {.lex_state = 58, .external_lex_state = 21},
  [7096] = {.lex_state = 0, .external_lex_state = 21},
  [7097] = {.lex_state = 58, .external_lex_state = 21},
  [7098] = {.lex_state = 58, .external_lex_state = 21},
  [7099] = {.lex_state = 58, .external_lex_state = 21},
  [7100] = {.lex_state = 0, .external_lex_state = 21},
  [7101] = {.lex_state = 0, .external_lex_state = 21},
  [7102] = {.lex_state = 0, .external_lex_state = 21},
  [7103] = {.lex_state = 74, .external_lex_state = 21},
  [7104] = {.lex_state = 0, .external_lex_state = 21},
  [7105] = {.lex_state = 0, .external_lex_state = 25},
  [7106] = {.lex_state = 0, .external_lex_state = 21},
  [7107] = {.lex_state = 0, .external_lex_state = 21},
  [7108] = {.lex_state = 74, .external_lex_state = 21},
  [7109] = {.lex_state = 0, .external_lex_state = 25},
  [7110] = {.lex_state = 0, .external_lex_state = 25},
  [7111] = {.lex_state = 0, .external_lex_state = 25},
  [7112] = {.lex_state = 0, .external_lex_state = 25},
  [7113] = {.lex_state = 0, .external_lex_state = 25},
  [7114] = {.lex_state = 0, .external_lex_state = 25},
  [7115] = {.lex_state = 0, .external_lex_state = 25},
  [7116] = {.lex_state = 0, .external_lex_state = 25},
  [7117] = {.lex_state = 0, .external_lex_state = 25},
  [7118] = {.lex_state = 0, .external_lex_state = 25},
  [7119] = {.lex_state = 0, .external_lex_state = 25},
  [7120] = {.lex_state = 0, .external_lex_state = 25},
  [7121] = {.lex_state = 0, .external_lex_state = 25},
  [7122] = {.lex_state = 0, .external_lex_state = 25},
  [7123] = {.lex_state = 0, .external_lex_state = 25},
  [7124] = {.lex_state = 0, .external_lex_state = 25},
};

static const uint16_t ts_parse_table[LARGE_STATE_COUNT][SYMBOL_COUNT] = {
  [0] = {
    [ts_builtin_sym_end] = ACTIONS(1),
    [anon_sym_DASH_GT] = ACTIONS(1),
    [anon_sym_LPAREN_RPAREN] = ACTIONS(1),
    [sym_nat] = ACTIONS(1),
    [sym_int] = ACTIONS(1),
    [sym_float] = ACTIONS(1),
    [anon_sym_DQUOTE] = ACTIONS(1),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1),
    [aux_sym_literal_char_token1] = ACTIONS(1),
    [aux_sym_literal_char_token2] = ACTIONS(1),
    [anon_sym_true] = ACTIONS(1),
    [anon_sym_false] = ACTIONS(1),
    [sym_literal_byte] = ACTIONS(1),
    [sym_literal_hex] = ACTIONS(1),
    [anon_sym_LPAREN] = ACTIONS(1),
    [anon_sym_COMMA] = ACTIONS(1),
    [anon_sym_RPAREN] = ACTIONS(1),
    [anon_sym_SEMI] = ACTIONS(1),
    [anon_sym_PLUS_PLUS] = ACTIONS(1),
    [anon_sym_PLUS_COLON] = ACTIONS(1),
    [anon_sym_COLON_PLUS] = ACTIONS(1),
    [anon_sym_AT] = ACTIONS(1),
    [anon_sym_LBRACK] = ACTIONS(1),
    [anon_sym_RBRACK] = ACTIONS(1),
    [anon_sym_LBRACE] = ACTIONS(1),
    [anon_sym_RBRACE] = ACTIONS(1),
    [anon_sym__] = ACTIONS(1),
    [anon_sym_if] = ACTIONS(1),
    [anon_sym_then] = ACTIONS(1),
    [anon_sym_else] = ACTIONS(1),
    [anon_sym_SQUOTE] = ACTIONS(1),
    [anon_sym_BANG] = ACTIONS(1),
    [anon_sym_DOT] = ACTIONS(1),
    [anon_sym_COLON] = ACTIONS(1),
    [aux_sym_immediate_hash_token1] = ACTIONS(1),
    [anon_sym_use] = ACTIONS(1),
    [sym_do] = ACTIONS(1),
    [sym_kw_let] = ACTIONS(1),
    [sym_type_kw] = ACTIONS(1),
    [sym_pipe] = ACTIONS(1),
    [sym_match] = ACTIONS(1),
    [sym_otherwise] = ACTIONS(1),
    [sym_structural] = ACTIONS(1),
    [sym_unique] = ACTIONS(1),
    [sym_ability] = ACTIONS(1),
    [sym_where] = ACTIONS(1),
    [sym_and] = ACTIONS(1),
    [anon_sym_forall] = ACTIONS(1),
    [anon_sym_u2200] = ACTIONS(1),
    [sym_kw_equals] = ACTIONS(1),
    [sym_kw_typelink] = ACTIONS(1),
    [sym_handle] = ACTIONS(1),
    [sym_with] = ACTIONS(1),
    [sym_rewrite] = ACTIONS(1),
    [sym_term] = ACTIONS(1),
    [sym_case] = ACTIONS(1),
    [sym_signature] = ACTIONS(1),
    [sym_rewrite_arrow] = ACTIONS(1),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1),
    [sym_built_in_hash] = ACTIONS(1),
    [anon_sym_test_GT] = ACTIONS(1),
    [anon_sym_test_DOTio_GT] = ACTIONS(1),
    [sym__layout_semicolon] = ACTIONS(1),
    [sym__layout_start] = ACTIONS(1),
    [sym__layout_end] = ACTIONS(1),
    [sym__dot] = ACTIONS(1),
    [sym__where] = ACTIONS(1),
    [sym__varsym] = ACTIONS(1),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1),
    [sym__comma] = ACTIONS(1),
    [sym__in] = ACTIONS(1),
    [sym__indent] = ACTIONS(1),
    [sym__empty] = ACTIONS(1),
    [sym_DEPRECATED_operator] = ACTIONS(1),
    [sym__parenthesized_operator] = ACTIONS(1),
    [sym__watch_start] = ACTIONS(1),
    [sym__start_before_arrow] = ACTIONS(1),
    [sym_hash_cid] = ACTIONS(1),
    [sym_doc_block] = ACTIONS(1),
    [sym__guard_layout_start] = ACTIONS(1),
    [sym__destructuring_bind_start] = ACTIONS(1),
    [sym_DUMMY] = ACTIONS(1),
  },
  [1] = {
    [sym_unison] = STATE(7102),
    [sym_term_definition2] = STATE(5100),
    [sym_binding] = STATE(4655),
    [sym__binding] = STATE(5099),
    [sym__lhs] = STATE(7099),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym_type_signature] = STATE(5266),
    [sym_type_declaration] = STATE(4655),
    [sym__type_lhs] = STATE(7095),
    [sym_effect_declaration] = STATE(4655),
    [sym_use] = STATE(5433),
    [sym_use_clause] = STATE(4655),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(5325),
    [sym__prefix_definition_name] = STATE(5325),
    [sym__wordy_definition_name] = STATE(5325),
    [sym_watch_expression] = STATE(4655),
    [sym_test_watch_expression] = STATE(4655),
    [aux_sym_unison_repeat1] = STATE(4655),
    [ts_builtin_sym_end] = ACTIONS(5),
    [anon_sym_LPAREN] = ACTIONS(7),
    [anon_sym_use] = ACTIONS(9),
    [sym_type_kw] = ACTIONS(11),
    [sym_structural] = ACTIONS(13),
    [sym_unique] = ACTIONS(13),
    [sym_ability] = ACTIONS(15),
    [aux_sym_wordy_id_token1] = ACTIONS(17),
    [sym_path] = ACTIONS(19),
    [anon_sym_test_GT] = ACTIONS(21),
    [anon_sym_test_DOTio_GT] = ACTIONS(21),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(23),
    [sym__watch_start] = ACTIONS(25),
    [sym_doc_block] = ACTIONS(27),
  },
  [2] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(43),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(77),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(81),
  },
  [3] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(83),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(85),
    [anon_sym_use] = ACTIONS(85),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(85),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(85),
    [sym_unique] = ACTIONS(85),
    [sym_ability] = ACTIONS(85),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(85),
    [anon_sym_test_DOTio_GT] = ACTIONS(85),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(87),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(83),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(83),
    [sym_doc_block] = ACTIONS(81),
  },
  [4] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(93),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [5] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(99),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(81),
  },
  [6] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(101),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(81),
  },
  [7] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(105),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(107),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(81),
  },
  [8] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(105),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(109),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(81),
  },
  [9] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(115),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(81),
  },
  [10] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(117),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(81),
  },
  [11] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(123),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(81),
  },
  [12] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(125),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [13] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(127),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [14] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(131),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(131),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(131),
    [sym_unique] = ACTIONS(131),
    [sym_ability] = ACTIONS(131),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(131),
    [anon_sym_test_DOTio_GT] = ACTIONS(131),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(133),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(129),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(129),
    [sym_doc_block] = ACTIONS(81),
  },
  [15] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(139),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [16] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(143),
    [anon_sym_use] = ACTIONS(143),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(143),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(143),
    [sym_unique] = ACTIONS(143),
    [sym_ability] = ACTIONS(143),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(143),
    [anon_sym_test_DOTio_GT] = ACTIONS(143),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(145),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(141),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(141),
    [sym_doc_block] = ACTIONS(81),
  },
  [17] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(151),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(81),
  },
  [18] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(153),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_use] = ACTIONS(155),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(155),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(155),
    [sym_unique] = ACTIONS(155),
    [sym_ability] = ACTIONS(155),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(155),
    [anon_sym_test_DOTio_GT] = ACTIONS(155),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(157),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(153),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(153),
    [sym_doc_block] = ACTIONS(81),
  },
  [19] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(159),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(81),
  },
  [20] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(161),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [21] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(163),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [22] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(165),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(81),
  },
  [23] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(169),
    [anon_sym_use] = ACTIONS(169),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(169),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(169),
    [sym_unique] = ACTIONS(169),
    [sym_ability] = ACTIONS(169),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(169),
    [anon_sym_test_DOTio_GT] = ACTIONS(169),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(171),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(167),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(167),
    [sym_doc_block] = ACTIONS(81),
  },
  [24] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(173),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(175),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(175),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(175),
    [sym_unique] = ACTIONS(175),
    [sym_ability] = ACTIONS(175),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(175),
    [anon_sym_test_DOTio_GT] = ACTIONS(175),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(177),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(173),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(173),
    [sym_doc_block] = ACTIONS(81),
  },
  [25] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(43),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(179),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(81),
  },
  [26] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(181),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [27] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(183),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [28] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(225),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(229),
  },
  [29] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(231),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [30] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(233),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(229),
  },
  [31] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(143),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(143),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(143),
    [sym_unique] = ACTIONS(143),
    [sym_ability] = ACTIONS(143),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(143),
    [anon_sym_test_DOTio_GT] = ACTIONS(143),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(235),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(141),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(141),
    [sym_doc_block] = ACTIONS(229),
  },
  [32] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(83),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(85),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(85),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(85),
    [sym_unique] = ACTIONS(85),
    [sym_ability] = ACTIONS(85),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(85),
    [anon_sym_test_DOTio_GT] = ACTIONS(85),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(237),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(83),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(83),
    [sym_doc_block] = ACTIONS(229),
  },
  [33] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(131),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(131),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(131),
    [sym_unique] = ACTIONS(131),
    [sym_ability] = ACTIONS(131),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(131),
    [anon_sym_test_DOTio_GT] = ACTIONS(131),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(239),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(129),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(129),
    [sym_doc_block] = ACTIONS(229),
  },
  [34] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(241),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(229),
  },
  [35] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(153),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(155),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(155),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(155),
    [sym_unique] = ACTIONS(155),
    [sym_ability] = ACTIONS(155),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(155),
    [anon_sym_test_DOTio_GT] = ACTIONS(155),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(243),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(153),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(153),
    [sym_doc_block] = ACTIONS(229),
  },
  [36] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(245),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(229),
  },
  [37] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(169),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(169),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(169),
    [sym_unique] = ACTIONS(169),
    [sym_ability] = ACTIONS(169),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(169),
    [anon_sym_test_DOTio_GT] = ACTIONS(169),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(247),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(167),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(167),
    [sym_doc_block] = ACTIONS(229),
  },
  [38] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(249),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(229),
  },
  [39] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(251),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(229),
  },
  [40] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(253),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(229),
  },
  [41] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(255),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(229),
  },
  [42] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(257),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [43] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(259),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [44] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(261),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [45] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(263),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(229),
  },
  [46] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(265),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(229),
  },
  [47] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(267),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(229),
  },
  [48] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(269),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [49] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(271),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [50] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(173),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(175),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(175),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(175),
    [sym_unique] = ACTIONS(175),
    [sym_ability] = ACTIONS(175),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(175),
    [anon_sym_test_DOTio_GT] = ACTIONS(175),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(273),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(173),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(173),
    [sym_doc_block] = ACTIONS(229),
  },
  [51] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(275),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [52] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(277),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [53] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(279),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(229),
  },
  [54] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(105),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_end] = ACTIONS(281),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(81),
  },
  [55] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(43),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_end] = ACTIONS(283),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(81),
  },
  [56] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_end] = ACTIONS(285),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(81),
  },
  [57] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(287),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [58] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(289),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [59] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(291),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [60] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(131),
    [anon_sym_use] = ACTIONS(131),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(131),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(131),
    [sym_unique] = ACTIONS(131),
    [sym_ability] = ACTIONS(131),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(131),
    [anon_sym_test_DOTio_GT] = ACTIONS(131),
    [sym__layout_end] = ACTIONS(293),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(129),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(129),
    [sym_doc_block] = ACTIONS(81),
  },
  [61] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_end] = ACTIONS(295),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(81),
  },
  [62] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(297),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [63] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(83),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(85),
    [anon_sym_use] = ACTIONS(85),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(85),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(85),
    [sym_unique] = ACTIONS(85),
    [sym_ability] = ACTIONS(85),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(85),
    [anon_sym_test_DOTio_GT] = ACTIONS(85),
    [sym__layout_end] = ACTIONS(299),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(83),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(83),
    [sym_doc_block] = ACTIONS(81),
  },
  [64] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(143),
    [anon_sym_use] = ACTIONS(143),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(143),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(143),
    [sym_unique] = ACTIONS(143),
    [sym_ability] = ACTIONS(143),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(143),
    [anon_sym_test_DOTio_GT] = ACTIONS(143),
    [sym__layout_end] = ACTIONS(301),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(141),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(141),
    [sym_doc_block] = ACTIONS(81),
  },
  [65] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(97),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_end] = ACTIONS(303),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(81),
  },
  [66] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(305),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [67] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(121),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_end] = ACTIONS(307),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(81),
  },
  [68] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(105),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_end] = ACTIONS(309),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(81),
  },
  [69] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(311),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [70] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(91),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(313),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(81),
  },
  [71] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_end] = ACTIONS(315),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(81),
  },
  [72] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(113),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_end] = ACTIONS(317),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(81),
  },
  [73] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(153),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(155),
    [anon_sym_use] = ACTIONS(155),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(155),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(155),
    [sym_unique] = ACTIONS(155),
    [sym_ability] = ACTIONS(155),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(155),
    [anon_sym_test_DOTio_GT] = ACTIONS(155),
    [sym__layout_end] = ACTIONS(319),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(153),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(153),
    [sym_doc_block] = ACTIONS(81),
  },
  [74] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(137),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(321),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(81),
  },
  [75] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_end] = ACTIONS(323),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(81),
  },
  [76] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(43),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_end] = ACTIONS(325),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(81),
  },
  [77] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(169),
    [anon_sym_use] = ACTIONS(169),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(169),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(169),
    [sym_unique] = ACTIONS(169),
    [sym_ability] = ACTIONS(169),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(169),
    [anon_sym_test_DOTio_GT] = ACTIONS(169),
    [sym__layout_end] = ACTIONS(327),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(167),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(167),
    [sym_doc_block] = ACTIONS(81),
  },
  [78] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(173),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(175),
    [anon_sym_use] = ACTIONS(175),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(175),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(175),
    [sym_unique] = ACTIONS(175),
    [sym_ability] = ACTIONS(175),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(175),
    [anon_sym_test_DOTio_GT] = ACTIONS(175),
    [sym__layout_end] = ACTIONS(329),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(173),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(173),
    [sym_doc_block] = ACTIONS(81),
  },
  [79] = {
    [sym__statement] = STATE(1668),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1668),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(41),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(149),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_end] = ACTIONS(331),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(81),
  },
  [80] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(153),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(155),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(155),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(155),
    [sym_unique] = ACTIONS(155),
    [sym_ability] = ACTIONS(155),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(155),
    [anon_sym_test_DOTio_GT] = ACTIONS(155),
    [sym__layout_end] = ACTIONS(333),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(153),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(153),
    [sym_doc_block] = ACTIONS(229),
  },
  [81] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(335),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [82] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(129),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(131),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(131),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(131),
    [sym_unique] = ACTIONS(131),
    [sym_ability] = ACTIONS(131),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(131),
    [anon_sym_test_DOTio_GT] = ACTIONS(131),
    [sym__layout_end] = ACTIONS(337),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(129),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(129),
    [sym_doc_block] = ACTIONS(229),
  },
  [83] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_end] = ACTIONS(339),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(229),
  },
  [84] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(341),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [85] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_end] = ACTIONS(343),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(229),
  },
  [86] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(103),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(105),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(105),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(105),
    [sym_unique] = ACTIONS(105),
    [sym_ability] = ACTIONS(105),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(105),
    [anon_sym_test_DOTio_GT] = ACTIONS(105),
    [sym__layout_end] = ACTIONS(345),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(103),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(103),
    [sym_doc_block] = ACTIONS(229),
  },
  [87] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(173),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(175),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(175),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(175),
    [sym_unique] = ACTIONS(175),
    [sym_ability] = ACTIONS(175),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(175),
    [anon_sym_test_DOTio_GT] = ACTIONS(175),
    [sym__layout_end] = ACTIONS(347),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(173),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(173),
    [sym_doc_block] = ACTIONS(229),
  },
  [88] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_end] = ACTIONS(349),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(229),
  },
  [89] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_end] = ACTIONS(351),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(229),
  },
  [90] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(111),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(113),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(113),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(113),
    [sym_unique] = ACTIONS(113),
    [sym_ability] = ACTIONS(113),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(113),
    [anon_sym_test_DOTio_GT] = ACTIONS(113),
    [sym__layout_end] = ACTIONS(353),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(111),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(111),
    [sym_doc_block] = ACTIONS(229),
  },
  [91] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(29),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(43),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(43),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(43),
    [sym_unique] = ACTIONS(43),
    [sym_ability] = ACTIONS(43),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(43),
    [anon_sym_test_DOTio_GT] = ACTIONS(43),
    [sym__layout_end] = ACTIONS(355),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(29),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(29),
    [sym_doc_block] = ACTIONS(229),
  },
  [92] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(167),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(169),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(169),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(169),
    [sym_unique] = ACTIONS(169),
    [sym_ability] = ACTIONS(169),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(169),
    [anon_sym_test_DOTio_GT] = ACTIONS(169),
    [sym__layout_end] = ACTIONS(357),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(167),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(167),
    [sym_doc_block] = ACTIONS(229),
  },
  [93] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(359),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [94] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(141),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(143),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(143),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(143),
    [sym_unique] = ACTIONS(143),
    [sym_ability] = ACTIONS(143),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(143),
    [anon_sym_test_DOTio_GT] = ACTIONS(143),
    [sym__layout_end] = ACTIONS(361),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(141),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(141),
    [sym_doc_block] = ACTIONS(229),
  },
  [95] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(83),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(85),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(85),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(85),
    [sym_unique] = ACTIONS(85),
    [sym_ability] = ACTIONS(85),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(85),
    [anon_sym_test_DOTio_GT] = ACTIONS(85),
    [sym__layout_end] = ACTIONS(363),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(83),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(83),
    [sym_doc_block] = ACTIONS(229),
  },
  [96] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(89),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(91),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(91),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(91),
    [sym_unique] = ACTIONS(91),
    [sym_ability] = ACTIONS(91),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(91),
    [anon_sym_test_DOTio_GT] = ACTIONS(91),
    [sym__layout_end] = ACTIONS(365),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(89),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(89),
    [sym_doc_block] = ACTIONS(229),
  },
  [97] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(367),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [98] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(369),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [99] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_end] = ACTIONS(371),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(229),
  },
  [100] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_end] = ACTIONS(373),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(229),
  },
  [101] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(147),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(149),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(149),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(149),
    [sym_unique] = ACTIONS(149),
    [sym_ability] = ACTIONS(149),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(149),
    [anon_sym_test_DOTio_GT] = ACTIONS(149),
    [sym__layout_end] = ACTIONS(375),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(147),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(147),
    [sym_doc_block] = ACTIONS(229),
  },
  [102] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(119),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(121),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(121),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(121),
    [sym_unique] = ACTIONS(121),
    [sym_ability] = ACTIONS(121),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(121),
    [anon_sym_test_DOTio_GT] = ACTIONS(121),
    [sym__layout_end] = ACTIONS(377),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(119),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(119),
    [sym_doc_block] = ACTIONS(229),
  },
  [103] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(379),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [104] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(135),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(137),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(137),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(137),
    [sym_unique] = ACTIONS(137),
    [sym_ability] = ACTIONS(137),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(137),
    [anon_sym_test_DOTio_GT] = ACTIONS(137),
    [sym__layout_end] = ACTIONS(381),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(135),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(135),
    [sym_doc_block] = ACTIONS(229),
  },
  [105] = {
    [sym__statement] = STATE(1860),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1860),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [ts_builtin_sym_end] = ACTIONS(95),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(195),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(97),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(97),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(97),
    [sym_unique] = ACTIONS(97),
    [sym_ability] = ACTIONS(97),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(97),
    [anon_sym_test_DOTio_GT] = ACTIONS(97),
    [sym__layout_end] = ACTIONS(383),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(95),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(95),
    [sym_doc_block] = ACTIONS(229),
  },
  [106] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(427),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [107] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [108] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(435),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [109] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [110] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [111] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [112] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(143),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(443),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [113] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [114] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(175),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(175),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [115] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [116] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(169),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [117] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [118] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [119] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [120] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [121] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [122] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(463),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [123] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [124] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [125] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [126] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(471),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [127] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(473),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [128] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [129] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [130] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [131] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [132] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(525),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [133] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(481),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [134] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(457),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [135] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(455),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [136] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(435),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [137] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(437),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [138] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(439),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [139] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(441),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [140] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(449),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [141] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(175),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(541),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [142] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(427),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [143] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(475),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [144] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(85),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(543),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [145] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(467),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [146] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(461),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [147] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(463),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [148] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(453),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [149] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(131),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(545),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [150] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(465),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [151] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(547),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [152] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(459),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [153] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(175),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(447),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [154] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(451),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [155] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(469),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [156] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(149),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(549),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [157] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(471),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [158] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(473),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [159] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(479),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [160] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(143),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(443),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [161] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(445),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [162] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(131),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(477),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [163] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(593),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [164] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(599),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [165] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(433),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [166] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(149),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(601),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [167] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(603),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [168] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(169),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(605),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [169] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(607),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [170] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(609),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [171] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(611),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [172] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(613),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [173] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(615),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [174] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(617),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [175] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(619),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [176] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(43),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(621),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [177] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(43),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(623),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [178] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(625),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [179] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(627),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [180] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(629),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [181] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(631),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [182] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(155),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(633),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [183] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(635),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [184] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(113),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(637),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [185] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(113),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(639),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [186] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(641),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [187] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(105),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(643),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [188] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(105),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(645),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [189] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(647),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [190] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(649),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [191] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(651),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [192] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(97),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(653),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [193] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(97),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(655),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [194] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(657),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [195] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(659),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [196] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(661),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [197] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(121),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(663),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [198] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(665),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [199] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(667),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [200] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(669),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [201] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(671),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [202] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(143),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(673),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [203] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(121),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(675),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [204] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(677),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [205] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(679),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [206] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(681),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [207] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(683),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [208] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(685),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [209] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(687),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [210] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(729),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [211] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5986),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6620),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [212] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [213] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(113),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [214] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [215] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(105),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [216] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [217] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6156),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6938),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [218] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(97),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(803),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [219] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [220] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(807),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [221] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [222] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(121),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [223] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5962),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6649),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [224] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(815),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [225] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(817),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [226] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(131),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [227] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6194),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6702),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [228] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [229] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(91),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [230] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(871),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [231] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6104),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6792),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [232] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6175),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6986),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [233] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(877),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [234] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(85),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [235] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [236] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [237] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [238] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(137),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [239] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5948),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6678),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(889),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [240] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(891),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [241] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [242] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(43),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [243] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(897),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [244] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(899),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [245] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(901),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [246] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(903),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [247] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(905),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [248] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(907),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [249] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(909),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [250] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(911),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [251] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(913),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [252] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(143),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [253] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(155),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [254] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(919),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [255] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(921),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [256] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [257] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(175),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(925),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [258] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(927),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [259] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5888),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6730),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [260] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(931),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [261] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(933),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [262] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6194),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(7025),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [263] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(935),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [264] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(937),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [265] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(939),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [266] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [267] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(943),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [268] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(945),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [269] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6084),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6661),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [270] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(949),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [271] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(951),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [272] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(953),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [273] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(955),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [274] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(957),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [275] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6141),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6886),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(959),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [276] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [277] = {
    [aux_sym__term4] = STATE(893),
    [sym__generic_infix_app] = STATE(1369),
    [sym__infix] = STATE(1369),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_wordy_id] = STATE(1485),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(1454),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(35),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(37),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(31),
    [sym_literal_hex] = ACTIONS(31),
    [anon_sym_LPAREN] = ACTIONS(965),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(45),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(49),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(969),
    [sym_and] = ACTIONS(969),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(67),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(973),
    [aux_sym_hash_qualifier_token1] = ACTIONS(73),
    [sym_built_in_hash] = ACTIONS(75),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(81),
  },
  [278] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5921),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6717),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [279] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [280] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6039),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6571),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [281] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [282] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [283] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [284] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [285] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(131),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [286] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6021),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6593),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [287] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [288] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6121),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6843),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [289] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [290] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [291] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [292] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [293] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5954),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6673),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [294] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6059),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6119),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6530),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [295] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [296] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6156),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(2729),
    [sym_literal_char] = STATE(2729),
    [sym_literal_boolean] = STATE(2729),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym__literal_pattern] = STATE(5360),
    [sym__pattern_root] = STATE(6170),
    [sym__pattern_constructor] = STATE(5360),
    [sym__pattern_candidates] = STATE(5360),
    [sym_var_or_as] = STATE(5360),
    [sym_literal_list_pattern] = STATE(5360),
    [sym_parenthesized_or_tuple_pattern] = STATE(5360),
    [sym_effect_pattern] = STATE(5360),
    [sym__pattern_leaf] = STATE(5360),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1846),
    [sym_hash_qualifier] = STATE(2635),
    [sym__hq_qualified_wordy_id] = STATE(2635),
    [sym__hq_qualified_symboly_id] = STATE(6552),
    [sym__hq_qualified_prefix_term] = STATE(1481),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(735),
    [sym_int] = ACTIONS(735),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(739),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(741),
    [aux_sym_literal_char_token1] = ACTIONS(743),
    [aux_sym_literal_char_token2] = ACTIONS(743),
    [anon_sym_true] = ACTIONS(745),
    [anon_sym_false] = ACTIONS(745),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(747),
    [anon_sym_LBRACK] = ACTIONS(749),
    [anon_sym_LBRACE] = ACTIONS(751),
    [anon_sym__] = ACTIONS(753),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(775),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(779),
    [aux_sym_hash_qualifier_token1] = ACTIONS(781),
    [sym_built_in_hash] = ACTIONS(783),
    [sym__layout_end] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(787),
    [sym_doc_block] = ACTIONS(789),
  },
  [297] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(143),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(1011),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [298] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [299] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [300] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [301] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [302] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(175),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [303] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(1023),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [304] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [305] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [306] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [307] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1031),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [308] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1033),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [309] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1035),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [310] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(155),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1037),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [311] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(169),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1039),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [312] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1041),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [313] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(175),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1043),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [314] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(1015),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [315] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1055),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [316] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1057),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [317] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1059),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [318] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1061),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [319] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1063),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [320] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1065),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [321] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1067),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [322] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1069),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [323] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1071),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [324] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1073),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [325] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1075),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [326] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1077),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [327] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(791),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [328] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(793),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [329] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1079),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [330] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1081),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [331] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1083),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [332] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1085),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [333] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(143),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1087),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [334] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(795),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [335] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(797),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [336] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1089),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [337] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(1001),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [338] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1091),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [339] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(85),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1093),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [340] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1095),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [341] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1097),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [342] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1099),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [343] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(43),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1101),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [344] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1103),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [345] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(131),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(989),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [346] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1105),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [347] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(799),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [348] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1107),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [349] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(803),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [350] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(1009),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [351] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(805),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [352] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1109),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [353] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(43),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1111),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [354] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1113),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [355] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1115),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [356] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1117),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [357] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(807),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [358] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1119),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [359] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(809),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [360] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(811),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [361] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(1003),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [362] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(817),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [363] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1121),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [364] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1123),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [365] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(85),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [366] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(869),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [367] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1127),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [368] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(149),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1129),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [369] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(961),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [370] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(111),
    [sym__layout_end] = ACTIONS(999),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [371] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(871),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [372] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(981),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [373] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(149),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1131),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [374] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1133),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [375] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1135),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [376] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(147),
    [sym__layout_end] = ACTIONS(997),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [377] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(977),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [378] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(103),
    [sym__layout_end] = ACTIONS(985),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [379] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(987),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [380] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1137),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [381] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(877),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [382] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(95),
    [sym__layout_end] = ACTIONS(993),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [383] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(881),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [384] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(113),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1139),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [385] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1141),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [386] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(105),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1143),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [387] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1145),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [388] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(97),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1147),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [389] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(1011),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [390] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1149),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [391] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1151),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [392] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1153),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [393] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1155),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [394] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1157),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [395] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(883),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [396] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(885),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [397] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1159),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [398] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(887),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [399] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(893),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [400] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(895),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [401] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(1013),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [402] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(1017),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [403] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(1021),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [404] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1161),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [405] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(131),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1163),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [406] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1165),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [407] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1167),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [408] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(957),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [409] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1169),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [410] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(137),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1171),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [411] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(29),
    [sym__layout_end] = ACTIONS(941),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [412] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1173),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [413] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [414] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1177),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [415] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1179),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [416] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(131),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(131),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(819),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [417] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(879),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [418] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(143),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(915),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [419] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1181),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [420] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1183),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [421] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(917),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [422] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1185),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [423] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1187),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [424] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1189),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [425] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1019),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [426] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(923),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [427] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1191),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [428] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(121),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1193),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [429] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [anon_sym_DASH_GT] = ACTIONS(175),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(925),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [430] = {
    [aux_sym__term4] = STATE(1041),
    [sym__generic_infix_app] = STATE(1384),
    [sym__infix] = STATE(1384),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_wordy_id] = STATE(1513),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(1470),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(189),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(191),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(185),
    [sym_literal_hex] = ACTIONS(185),
    [anon_sym_LPAREN] = ACTIONS(1195),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(197),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(199),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(1197),
    [sym_and] = ACTIONS(1197),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(217),
    [aux_sym_wordy_id_token1] = ACTIONS(1199),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(1201),
    [aux_sym_hash_qualifier_token1] = ACTIONS(221),
    [sym_built_in_hash] = ACTIONS(223),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(229),
  },
  [431] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(121),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1203),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [432] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1205),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [433] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1207),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [434] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1209),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [435] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(135),
    [sym__layout_end] = ACTIONS(983),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [436] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1211),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [437] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1027),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [438] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(149),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(149),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1213),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [439] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(91),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(91),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1215),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [440] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(97),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [441] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1219),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [442] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(1029),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [443] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(97),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(97),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [444] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1223),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [445] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(105),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1225),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [446] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(137),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(137),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [447] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(105),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(105),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1229),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [448] = {
    [sym__statement] = STATE(3080),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3080),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(113),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1231),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [449] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(1025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [450] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(493),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(113),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_end] = ACTIONS(1233),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [451] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(143),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(143),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1235),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [452] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(91),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(89),
    [sym__layout_end] = ACTIONS(863),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [453] = {
    [sym__statement] = STATE(2399),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2399),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1237),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [454] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1239),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [455] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1241),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [456] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(85),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1243),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [457] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(113),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1245),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [458] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(43),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(43),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1247),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [459] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(175),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(175),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1249),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [460] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(155),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(155),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1251),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [461] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_SEMI] = ACTIONS(121),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(119),
    [sym__layout_end] = ACTIONS(1023),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [462] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(395),
    [anon_sym_COMMA] = ACTIONS(169),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(169),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_end] = ACTIONS(1253),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [463] = {
    [sym__statement] = STATE(3162),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3162),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(561),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(121),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_end] = ACTIONS(1255),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [464] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5668),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(2669),
    [sym_literal_char] = STATE(2669),
    [sym_literal_boolean] = STATE(2669),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym__literal_pattern] = STATE(5342),
    [sym__pattern_root] = STATE(5984),
    [sym__pattern_constructor] = STATE(5342),
    [sym__pattern_candidates] = STATE(5342),
    [sym_var_or_as] = STATE(5342),
    [sym_literal_list_pattern] = STATE(5342),
    [sym_parenthesized_or_tuple_pattern] = STATE(5342),
    [sym_effect_pattern] = STATE(5342),
    [sym__pattern_leaf] = STATE(5342),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1867),
    [sym_hash_qualifier] = STATE(2732),
    [sym__hq_qualified_wordy_id] = STATE(2732),
    [sym__hq_qualified_prefix_term] = STATE(1504),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1257),
    [sym_int] = ACTIONS(1257),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1263),
    [aux_sym_literal_char_token1] = ACTIONS(1265),
    [aux_sym_literal_char_token2] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(1269),
    [anon_sym_false] = ACTIONS(1269),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_RBRACK] = ACTIONS(1277),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym__] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1303),
    [sym_path] = ACTIONS(1305),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1307),
    [sym_built_in_hash] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1309),
    [sym_doc_block] = ACTIONS(1271),
  },
  [465] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1311),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [466] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1313),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [467] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1315),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [468] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1317),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [469] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1319),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [470] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(97),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1321),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [471] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(131),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1323),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [472] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(85),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1325),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [473] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(143),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1327),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [474] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(155),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1329),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [475] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(169),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1331),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [476] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(175),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1333),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [477] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(121),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1335),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [478] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1337),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [479] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1339),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [480] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(113),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1341),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [481] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(175),
    [sym_and] = ACTIONS(175),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(175),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1343),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [482] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(91),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1345),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [483] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1347),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [484] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(97),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(97),
    [sym_and] = ACTIONS(97),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(97),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1349),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [485] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1351),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [486] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1353),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [487] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1355),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [488] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(105),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1357),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [489] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1359),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [490] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1361),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [491] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(169),
    [sym_and] = ACTIONS(169),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(169),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1363),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [492] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(155),
    [sym_and] = ACTIONS(155),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(155),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1365),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [493] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(143),
    [sym_and] = ACTIONS(143),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(143),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1367),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [494] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(113),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(113),
    [sym_and] = ACTIONS(113),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(113),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1369),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [495] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(85),
    [sym_and] = ACTIONS(85),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(85),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1371),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [496] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1373),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [497] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(105),
    [sym_and] = ACTIONS(105),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(105),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(105),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1375),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [498] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(149),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1377),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [499] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5703),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(2669),
    [sym_literal_char] = STATE(2669),
    [sym_literal_boolean] = STATE(2669),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym__literal_pattern] = STATE(5342),
    [sym__pattern_root] = STATE(5748),
    [sym__pattern_constructor] = STATE(5342),
    [sym__pattern_candidates] = STATE(5342),
    [sym_var_or_as] = STATE(5342),
    [sym_literal_list_pattern] = STATE(5342),
    [sym_parenthesized_or_tuple_pattern] = STATE(5342),
    [sym_effect_pattern] = STATE(5342),
    [sym__pattern_leaf] = STATE(5342),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1867),
    [sym_hash_qualifier] = STATE(2732),
    [sym__hq_qualified_wordy_id] = STATE(2732),
    [sym__hq_qualified_prefix_term] = STATE(1504),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1257),
    [sym_int] = ACTIONS(1257),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(1261),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1263),
    [aux_sym_literal_char_token1] = ACTIONS(1265),
    [aux_sym_literal_char_token2] = ACTIONS(1267),
    [anon_sym_true] = ACTIONS(1269),
    [anon_sym_false] = ACTIONS(1269),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(1273),
    [anon_sym_LBRACK] = ACTIONS(1275),
    [anon_sym_RBRACK] = ACTIONS(1379),
    [anon_sym_LBRACE] = ACTIONS(1279),
    [anon_sym__] = ACTIONS(1281),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1303),
    [sym_path] = ACTIONS(1305),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1307),
    [sym_built_in_hash] = ACTIONS(1309),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1309),
    [sym_doc_block] = ACTIONS(1271),
  },
  [500] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1381),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [501] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1383),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [502] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1385),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [503] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1387),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [504] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1389),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [505] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1391),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [506] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(121),
    [sym_and] = ACTIONS(121),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(121),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(121),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1393),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [507] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1395),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [508] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(43),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1397),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [509] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1399),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [510] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1401),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [511] = {
    [sym__statement] = STATE(3610),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3610),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(137),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1403),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [512] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(91),
    [sym_and] = ACTIONS(91),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(91),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(91),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1405),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [513] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(131),
    [sym_and] = ACTIONS(131),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(131),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1407),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [514] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1409),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [515] = {
    [sym__statement] = STATE(3748),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3748),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(137),
    [sym_and] = ACTIONS(137),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(137),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(137),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1411),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [516] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(699),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(149),
    [sym_and] = ACTIONS(149),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(149),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(149),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_end] = ACTIONS(1413),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [517] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [anon_sym_DASH_GT] = ACTIONS(43),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(833),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(43),
    [sym_and] = ACTIONS(43),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(43),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_end] = ACTIONS(1415),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [518] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6344),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [519] = {
    [sym__statement] = STATE(6225),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2439),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6225),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6381),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [520] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6336),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [521] = {
    [sym__statement] = STATE(3117),
    [sym_term_definition2] = STATE(2459),
    [sym___layout_block] = STATE(3447),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3117),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6433),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [522] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6328),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [523] = {
    [sym__statement] = STATE(5828),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2918),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5828),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6298),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [524] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6320),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [525] = {
    [sym__statement] = STATE(5756),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4026),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5756),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6309),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [526] = {
    [sym__statement] = STATE(3083),
    [sym_term_definition2] = STATE(3171),
    [sym___layout_block] = STATE(4175),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3083),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6464),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [527] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6513),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [528] = {
    [sym__statement] = STATE(6022),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3512),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6022),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6355),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [529] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6312),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [530] = {
    [sym__statement] = STATE(6064),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1948),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6064),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6401),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [531] = {
    [sym__statement] = STATE(6225),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2606),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6225),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6381),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [532] = {
    [sym__statement] = STATE(1723),
    [sym_term_definition2] = STATE(1824),
    [sym___layout_block] = STATE(1851),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1723),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6243),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [533] = {
    [sym__statement] = STATE(6022),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3551),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6022),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6355),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [534] = {
    [sym__statement] = STATE(5963),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4324),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5963),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6279),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [535] = {
    [sym__statement] = STATE(3576),
    [sym_term_definition2] = STATE(3591),
    [sym___layout_block] = STATE(3563),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3576),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6458),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [536] = {
    [sym__statement] = STATE(3060),
    [sym_term_definition2] = STATE(3591),
    [sym___layout_block] = STATE(3563),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3060),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6453),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [537] = {
    [sym__statement] = STATE(2628),
    [sym_term_definition2] = STATE(2459),
    [sym___layout_block] = STATE(3447),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2628),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6429),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [538] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6415),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [539] = {
    [sym__statement] = STATE(6142),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(5557),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6142),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6389),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [540] = {
    [sym__statement] = STATE(5828),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3137),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5828),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6298),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [541] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6393),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [542] = {
    [sym__statement] = STATE(5730),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2195),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5730),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6366),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [543] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6307),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [544] = {
    [sym__statement] = STATE(5572),
    [sym_term_definition2] = STATE(5535),
    [sym___layout_block] = STATE(6983),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5572),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6230),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [545] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6386),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [546] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6377),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [547] = {
    [sym__statement] = STATE(5906),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3361),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5906),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6348),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [548] = {
    [sym__statement] = STATE(5900),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2007),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5900),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6288),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [549] = {
    [sym__statement] = STATE(5980),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1753),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5980),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6324),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [550] = {
    [sym__statement] = STATE(6008),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4337),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6008),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6276),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [551] = {
    [sym__statement] = STATE(1950),
    [sym_term_definition2] = STATE(1824),
    [sym___layout_block] = STATE(2182),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1950),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6398),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [552] = {
    [sym__statement] = STATE(5996),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3449),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5996),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6373),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [553] = {
    [sym__statement] = STATE(6064),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1923),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6064),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6401),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [554] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6292),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [555] = {
    [sym__statement] = STATE(5848),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3286),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5848),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6339),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [556] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6283),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [557] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6254),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [558] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6252),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [559] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6251),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [560] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6249),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [561] = {
    [sym__statement] = STATE(2900),
    [sym_term_definition2] = STATE(3129),
    [sym___layout_block] = STATE(4270),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2900),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6459),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [562] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6870),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [563] = {
    [sym__statement] = STATE(5646),
    [sym_term_definition2] = STATE(5535),
    [sym___layout_block] = STATE(6482),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5646),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6300),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [564] = {
    [sym__statement] = STATE(5906),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3607),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5906),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6348),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [565] = {
    [sym__statement] = STATE(1645),
    [sym_term_definition2] = STATE(1626),
    [sym___layout_block] = STATE(2006),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1645),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6474),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [566] = {
    [sym__statement] = STATE(2893),
    [sym_term_definition2] = STATE(3539),
    [sym___layout_block] = STATE(3575),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(2893),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6367),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [567] = {
    [sym__statement] = STATE(2810),
    [sym_term_definition2] = STATE(2459),
    [sym___layout_block] = STATE(2526),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2810),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6439),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [568] = {
    [sym__statement] = STATE(2483),
    [sym_term_definition2] = STATE(2459),
    [sym___layout_block] = STATE(2526),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2483),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6335),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [569] = {
    [sym__statement] = STATE(2718),
    [sym_term_definition2] = STATE(3171),
    [sym___layout_block] = STATE(3008),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2718),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6487),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [570] = {
    [sym__statement] = STATE(3647),
    [sym_term_definition2] = STATE(3591),
    [sym___layout_block] = STATE(4586),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3647),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6445),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [571] = {
    [sym__statement] = STATE(6225),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2430),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6225),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6381),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [572] = {
    [sym__statement] = STATE(5730),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2124),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5730),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6366),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [573] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6351),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [574] = {
    [sym__statement] = STATE(5900),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(2032),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5900),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6288),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [575] = {
    [sym__statement] = STATE(5906),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3704),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5906),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6348),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [576] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6371),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [577] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6248),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [578] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6247),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [579] = {
    [aux_sym__term4] = STATE(1184),
    [sym__generic_infix_app] = STATE(1370),
    [sym__infix] = STATE(1370),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_wordy_id] = STATE(1632),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(1528),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1523),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(1525),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1519),
    [sym_literal_hex] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(1545),
    [sym_and] = ACTIONS(1545),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(1553),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(1557),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1559),
    [sym_built_in_hash] = ACTIONS(1561),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(1565),
  },
  [580] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6360),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [581] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6519),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [582] = {
    [sym__statement] = STATE(6081),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4562),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6081),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6331),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [583] = {
    [sym__statement] = STATE(5848),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3017),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5848),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6339),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [584] = {
    [sym__statement] = STATE(5996),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3677),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5996),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6373),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [585] = {
    [sym__statement] = STATE(6046),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4469),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6046),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6273),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [586] = {
    [sym__statement] = STATE(5684),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4011),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5684),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6314),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [587] = {
    [sym__statement] = STATE(3606),
    [sym_term_definition2] = STATE(3539),
    [sym___layout_block] = STATE(4616),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3606),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6516),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [588] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6246),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [589] = {
    [sym__statement] = STATE(5996),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3767),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5996),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6373),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [590] = {
    [sym__statement] = STATE(6081),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4565),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6081),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6331),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [591] = {
    [sym__statement] = STATE(5646),
    [sym_term_definition2] = STATE(5535),
    [sym___layout_block] = STATE(5559),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5646),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6300),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [592] = {
    [sym__statement] = STATE(6064),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1820),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6064),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6401),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [593] = {
    [sym__statement] = STATE(5524),
    [sym_term_definition2] = STATE(5535),
    [sym___layout_block] = STATE(5559),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5524),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6418),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [594] = {
    [sym__statement] = STATE(5963),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4189),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5963),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6279),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [595] = {
    [sym__statement] = STATE(5980),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1635),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5980),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6324),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [596] = {
    [sym__statement] = STATE(6046),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4608),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6046),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6273),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [597] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6245),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [598] = {
    [sym__statement] = STATE(1588),
    [sym_term_definition2] = STATE(1626),
    [sym___layout_block] = STATE(1707),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1588),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6496),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [599] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6244),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [600] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6241),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [601] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6238),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [602] = {
    [sym__statement] = STATE(2759),
    [sym_term_definition2] = STATE(3129),
    [sym___layout_block] = STATE(3292),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2759),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6479),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [603] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6237),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [604] = {
    [sym__statement] = STATE(5848),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3158),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5848),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6339),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [605] = {
    [sym__statement] = STATE(6008),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(4271),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6008),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6276),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [606] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6236),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [607] = {
    [sym__statement] = STATE(5684),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3925),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5684),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6314),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [608] = {
    [sym__statement] = STATE(3122),
    [sym_term_definition2] = STATE(2459),
    [sym___layout_block] = STATE(4075),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3122),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6509),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [609] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6235),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [610] = {
    [sym__statement] = STATE(5728),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(5086),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5728),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6424),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [611] = {
    [sym__statement] = STATE(6011),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(6234),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6011),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6515),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [612] = {
    [aux_sym__term4] = STATE(1184),
    [sym__generic_infix_app] = STATE(1390),
    [sym__infix] = STATE(1390),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_wordy_id] = STATE(1632),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(4927),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1523),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(1525),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1519),
    [sym_literal_hex] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(1529),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_COLON] = ACTIONS(967),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(1567),
    [sym_and] = ACTIONS(1567),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(1553),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(1557),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1559),
    [sym_built_in_hash] = ACTIONS(1561),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(1565),
  },
  [613] = {
    [sym__statement] = STATE(5980),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(1659),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5980),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6324),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [614] = {
    [sym__statement] = STATE(5828),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3050),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5828),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6298),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [615] = {
    [sym__statement] = STATE(5756),
    [sym_term_definition2] = STATE(5535),
    [sym___block] = STATE(3795),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5756),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6309),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [616] = {
    [sym__statement] = STATE(3108),
    [sym_term_definition2] = STATE(3171),
    [sym___layout_block] = STATE(3887),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3108),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(6493),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [617] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(153),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [618] = {
    [sym__statement] = STATE(5852),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5852),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1571),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1571),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [619] = {
    [aux_sym__term4] = STATE(1186),
    [sym__generic_infix_app] = STATE(1376),
    [sym__infix] = STATE(1376),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_wordy_id] = STATE(1943),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(4931),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1577),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(1579),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1573),
    [sym_literal_hex] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(1599),
    [sym_and] = ACTIONS(1599),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(1607),
    [aux_sym_wordy_id_token1] = ACTIONS(1609),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(1611),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1613),
    [sym_built_in_hash] = ACTIONS(1615),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(1619),
  },
  [620] = {
    [sym__statement] = STATE(2699),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2699),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [621] = {
    [sym__statement] = STATE(6063),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6063),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [622] = {
    [sym__statement] = STATE(2715),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2715),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [623] = {
    [sym__statement] = STATE(1749),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1749),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [624] = {
    [sym__statement] = STATE(3746),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3746),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [625] = {
    [sym__statement] = STATE(2722),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2722),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(631),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [626] = {
    [sym__statement] = STATE(2835),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2835),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [627] = {
    [sym__statement] = STATE(2966),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(2966),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [628] = {
    [sym__statement] = STATE(2837),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2837),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [aux_sym_guarded_block_repeat1] = STATE(644),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1621),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1621),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [629] = {
    [sym__statement] = STATE(2641),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2641),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [630] = {
    [sym__statement] = STATE(2843),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2843),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(628),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [631] = {
    [sym__statement] = STATE(2694),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2694),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(634),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1623),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1623),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [632] = {
    [sym__statement] = STATE(2685),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2685),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [633] = {
    [sym__statement] = STATE(6058),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6058),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [634] = {
    [sym__statement] = STATE(2667),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2667),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1625),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1625),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [635] = {
    [sym__statement] = STATE(3744),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3744),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1627),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1627),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [636] = {
    [sym__statement] = STATE(1930),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1930),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [637] = {
    [sym__statement] = STATE(3179),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3179),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [638] = {
    [sym__statement] = STATE(1655),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1655),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(717),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [639] = {
    [sym__statement] = STATE(3025),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3025),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [640] = {
    [sym__statement] = STATE(1918),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1918),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [641] = {
    [sym__statement] = STATE(1744),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1744),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [642] = {
    [sym__statement] = STATE(5960),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5960),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(723),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [643] = {
    [sym__statement] = STATE(3182),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3182),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1629),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1629),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [644] = {
    [sym__statement] = STATE(2833),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2833),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1631),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1631),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [645] = {
    [sym__statement] = STATE(3201),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3201),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [646] = {
    [sym__statement] = STATE(3770),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3770),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [aux_sym_guarded_block_repeat1] = STATE(635),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1633),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1633),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [647] = {
    [sym__statement] = STATE(3217),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3217),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [aux_sym_guarded_block_repeat1] = STATE(643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1635),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1635),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [648] = {
    [sym__statement] = STATE(5617),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5617),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [649] = {
    [sym__statement] = STATE(1638),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1638),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [650] = {
    [sym__statement] = STATE(2621),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2621),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [651] = {
    [sym__statement] = STATE(2829),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2829),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [652] = {
    [sym__statement] = STATE(3232),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3232),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(647),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [653] = {
    [sym__statement] = STATE(1542),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1542),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(673),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [654] = {
    [sym__statement] = STATE(6028),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6028),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [655] = {
    [sym__statement] = STATE(6023),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6023),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [656] = {
    [sym__statement] = STATE(3781),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3781),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(646),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [657] = {
    [sym__statement] = STATE(5988),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5988),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [658] = {
    [sym__statement] = STATE(5983),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5983),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [659] = {
    [sym__statement] = STATE(2970),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2970),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [660] = {
    [sym__statement] = STATE(5938),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5938),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [661] = {
    [sym__statement] = STATE(2928),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2928),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [662] = {
    [sym__statement] = STATE(2618),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2618),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1637),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1637),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [663] = {
    [sym__statement] = STATE(3069),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3069),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [664] = {
    [sym__statement] = STATE(5932),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5932),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [665] = {
    [sym__statement] = STATE(5648),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5648),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [666] = {
    [sym__statement] = STATE(2601),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2601),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [667] = {
    [sym__statement] = STATE(2932),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2932),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [668] = {
    [sym__statement] = STATE(5929),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5929),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [669] = {
    [sym__statement] = STATE(2595),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2595),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(662),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1639),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1639),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [670] = {
    [sym__statement] = STATE(5924),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5924),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1641),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1641),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [671] = {
    [sym__statement] = STATE(2725),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2725),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [672] = {
    [sym__statement] = STATE(2864),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2864),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [aux_sym_guarded_block_repeat1] = STATE(684),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_SEMI] = ACTIONS(1643),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym__layout_semicolon] = ACTIONS(1643),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [673] = {
    [sym__statement] = STATE(1576),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1576),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [aux_sym_guarded_block_repeat1] = STATE(709),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1645),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym__layout_semicolon] = ACTIONS(1645),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [674] = {
    [sym__statement] = STATE(5922),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5922),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [675] = {
    [sym__statement] = STATE(2868),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2868),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [676] = {
    [sym__statement] = STATE(5910),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5910),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(670),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1647),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1647),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [677] = {
    [sym__statement] = STATE(5897),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5897),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(676),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [678] = {
    [sym__statement] = STATE(2749),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2749),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1649),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1649),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [679] = {
    [sym__statement] = STATE(2656),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2656),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [680] = {
    [sym__statement] = STATE(2626),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2626),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(678),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1651),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1651),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [681] = {
    [sym__statement] = STATE(2590),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2590),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(669),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [682] = {
    [sym__statement] = STATE(3114),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3114),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [683] = {
    [sym__statement] = STATE(2573),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2573),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [684] = {
    [sym__statement] = STATE(2882),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2882),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_SEMI] = ACTIONS(1653),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym__layout_semicolon] = ACTIONS(1653),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [685] = {
    [sym__statement] = STATE(2637),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2637),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(680),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [686] = {
    [sym__statement] = STATE(5866),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5866),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [687] = {
    [sym__statement] = STATE(5860),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5860),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [688] = {
    [sym__statement] = STATE(2956),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2956),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [689] = {
    [aux_sym__term4] = STATE(1186),
    [sym__generic_infix_app] = STATE(1380),
    [sym__infix] = STATE(1380),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_wordy_id] = STATE(1943),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(1544),
    [ts_builtin_sym_end] = ACTIONS(963),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1577),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(1579),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1573),
    [sym_literal_hex] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(1583),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_use] = ACTIONS(967),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_type_kw] = ACTIONS(967),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_structural] = ACTIONS(967),
    [sym_unique] = ACTIONS(967),
    [sym_ability] = ACTIONS(967),
    [sym_or] = ACTIONS(1655),
    [sym_and] = ACTIONS(1655),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(1607),
    [aux_sym_wordy_id_token1] = ACTIONS(1609),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(1611),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1613),
    [sym_built_in_hash] = ACTIONS(1615),
    [anon_sym_test_GT] = ACTIONS(967),
    [anon_sym_test_DOTio_GT] = ACTIONS(967),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(963),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym__watch_start] = ACTIONS(963),
    [sym_doc_block] = ACTIONS(1619),
  },
  [690] = {
    [sym__statement] = STATE(5857),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5857),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [691] = {
    [sym__statement] = STATE(3657),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3657),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [692] = {
    [sym__statement] = STATE(5850),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5850),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [693] = {
    [sym__statement] = STATE(5838),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5838),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(618),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1657),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1657),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [694] = {
    [sym__statement] = STATE(2888),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2888),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [695] = {
    [sym__statement] = STATE(5825),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5825),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(693),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [696] = {
    [sym__statement] = STATE(3662),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3662),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [697] = {
    [sym__statement] = STATE(5794),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5794),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [698] = {
    [sym__statement] = STATE(5788),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5788),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [699] = {
    [sym__statement] = STATE(5785),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5785),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [700] = {
    [sym__statement] = STATE(5780),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5780),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1659),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1659),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [701] = {
    [sym__statement] = STATE(3249),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3249),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [702] = {
    [sym__statement] = STATE(5778),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5778),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [703] = {
    [sym__statement] = STATE(3226),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3226),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [704] = {
    [sym__statement] = STATE(5766),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5766),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(700),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1661),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1661),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [705] = {
    [sym__statement] = STATE(5753),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5753),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(704),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [706] = {
    [sym__statement] = STATE(1572),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1572),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [707] = {
    [sym__statement] = STATE(1603),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1603),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [708] = {
    [sym__statement] = STATE(5722),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5722),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [709] = {
    [sym__statement] = STATE(1570),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1570),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1663),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym__layout_semicolon] = ACTIONS(1663),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [710] = {
    [sym__statement] = STATE(5716),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5716),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [711] = {
    [sym__statement] = STATE(5713),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5713),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [712] = {
    [sym__statement] = STATE(1573),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1573),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1665),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym__layout_semicolon] = ACTIONS(1665),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [713] = {
    [sym__statement] = STATE(1567),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1567),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [714] = {
    [sym__statement] = STATE(5708),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5708),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1667),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1667),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [715] = {
    [sym__statement] = STATE(5706),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5706),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [716] = {
    [sym__statement] = STATE(2592),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2592),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [717] = {
    [sym__statement] = STATE(1704),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1704),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [aux_sym_guarded_block_repeat1] = STATE(782),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1669),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym__layout_semicolon] = ACTIONS(1669),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [718] = {
    [sym__statement] = STATE(1561),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1561),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [aux_sym_guarded_block_repeat1] = STATE(712),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_SEMI] = ACTIONS(1671),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym__layout_semicolon] = ACTIONS(1671),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [719] = {
    [sym__statement] = STATE(2649),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2649),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [720] = {
    [sym__statement] = STATE(5642),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5642),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1673),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1673),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [721] = {
    [sym__statement] = STATE(5694),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5694),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(714),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1675),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1675),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [722] = {
    [sym__statement] = STATE(2653),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2653),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1677),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1677),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [723] = {
    [sym__statement] = STATE(6089),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6089),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(793),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1679),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1679),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [724] = {
    [sym__statement] = STATE(5681),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5681),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(721),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [725] = {
    [sym__statement] = STATE(1548),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1548),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(718),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [726] = {
    [sym__statement] = STATE(2807),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2807),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [727] = {
    [sym__statement] = STATE(5792),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5792),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [728] = {
    [sym__statement] = STATE(5811),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5811),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [729] = {
    [sym__statement] = STATE(5700),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5700),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [730] = {
    [sym__statement] = STATE(5863),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5863),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1681),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1681),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [731] = {
    [sym__statement] = STATE(5872),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5872),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [732] = {
    [sym__statement] = STATE(2660),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2660),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [733] = {
    [sym__statement] = STATE(5913),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5913),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(730),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1683),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1683),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [734] = {
    [sym__statement] = STATE(1597),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1597),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [735] = {
    [sym__statement] = STATE(5995),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5995),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(733),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [736] = {
    [sym__statement] = STATE(1607),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1607),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [737] = {
    [sym__statement] = STATE(2688),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2688),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [738] = {
    [sym__statement] = STATE(6153),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6153),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [739] = {
    [sym__statement] = STATE(6223),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6223),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [740] = {
    [sym__statement] = STATE(2851),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2851),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [741] = {
    [sym__statement] = STATE(6208),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6208),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [742] = {
    [sym__statement] = STATE(5639),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5639),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [743] = {
    [sym__statement] = STATE(6176),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6176),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1685),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1685),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [744] = {
    [sym__statement] = STATE(6164),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6164),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [745] = {
    [sym__statement] = STATE(6107),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6107),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(743),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1687),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1687),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [746] = {
    [sym__statement] = STATE(2831),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2831),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_SEMI] = ACTIONS(1689),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym__layout_semicolon] = ACTIONS(1689),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [747] = {
    [sym__statement] = STATE(1642),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1642),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [748] = {
    [sym__statement] = STATE(2848),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2848),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [749] = {
    [sym__statement] = STATE(2664),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2664),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(722),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1691),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1691),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [750] = {
    [sym__statement] = STATE(6072),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6072),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(745),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [751] = {
    [sym__statement] = STATE(2686),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2686),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(749),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [752] = {
    [sym__statement] = STATE(2797),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2797),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [aux_sym_guarded_block_repeat1] = STATE(746),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_SEMI] = ACTIONS(1693),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym__layout_semicolon] = ACTIONS(1693),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [753] = {
    [sym__statement] = STATE(5940),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5940),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [754] = {
    [sym__statement] = STATE(5919),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5919),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [755] = {
    [sym__statement] = STATE(5908),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5908),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [756] = {
    [sym__statement] = STATE(2800),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2800),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [757] = {
    [sym__statement] = STATE(5905),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5905),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1695),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1695),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [758] = {
    [sym__statement] = STATE(2787),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2787),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(752),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [759] = {
    [sym__statement] = STATE(5892),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5892),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [760] = {
    [sym__statement] = STATE(5879),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5879),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(757),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1697),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1697),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [761] = {
    [sym__statement] = STATE(3098),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3098),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [762] = {
    [sym__statement] = STATE(5842),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5842),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(760),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [763] = {
    [sym__statement] = STATE(3079),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(3079),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [764] = {
    [sym__statement] = STATE(5714),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5714),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [765] = {
    [sym__statement] = STATE(5690),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5690),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [766] = {
    [sym__statement] = STATE(5682),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5682),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [767] = {
    [sym__statement] = STATE(5676),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5676),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1699),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1699),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [768] = {
    [sym__statement] = STATE(5673),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5673),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [769] = {
    [sym__statement] = STATE(3639),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3639),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [770] = {
    [sym__statement] = STATE(5854),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5854),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(767),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1701),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1701),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [771] = {
    [sym__statement] = STATE(5925),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5925),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(770),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [772] = {
    [sym__statement] = STATE(3635),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3635),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [773] = {
    [sym__statement] = STATE(1729),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1729),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(802),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [774] = {
    [sym__statement] = STATE(6045),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6045),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [775] = {
    [sym__statement] = STATE(6066),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6066),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [776] = {
    [sym__statement] = STATE(6090),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6090),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [777] = {
    [sym__statement] = STATE(2728),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2728),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [778] = {
    [sym__statement] = STATE(6092),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6092),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1703),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1703),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [779] = {
    [sym__statement] = STATE(6157),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6157),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [780] = {
    [sym__statement] = STATE(6109),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6109),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(778),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1705),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1705),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [781] = {
    [sym__statement] = STATE(1793),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1793),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [782] = {
    [sym__statement] = STATE(1785),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1785),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1707),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym__layout_semicolon] = ACTIONS(1707),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [783] = {
    [sym__statement] = STATE(5999),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5999),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(780),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [784] = {
    [sym__statement] = STATE(2721),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2721),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1709),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1709),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [785] = {
    [sym__statement] = STATE(2710),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2710),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [786] = {
    [sym__statement] = STATE(2702),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2702),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [aux_sym_guarded_block_repeat1] = STATE(784),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_SEMI] = ACTIONS(1711),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_semicolon] = ACTIONS(1711),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [787] = {
    [sym__statement] = STATE(6206),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6206),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [788] = {
    [sym__statement] = STATE(3723),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3723),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [789] = {
    [sym__statement] = STATE(5718),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5718),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(812),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [790] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(129),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [791] = {
    [sym__statement] = STATE(5767),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5767),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [792] = {
    [sym__statement] = STATE(5731),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5731),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [793] = {
    [sym__statement] = STATE(6213),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6213),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1715),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1715),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [794] = {
    [sym__statement] = STATE(1564),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1564),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [795] = {
    [sym__statement] = STATE(5671),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5671),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1717),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1717),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [796] = {
    [sym__statement] = STATE(5675),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5675),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [797] = {
    [sym__statement] = STATE(5635),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5635),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(720),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1719),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1719),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [798] = {
    [sym__statement] = STATE(2697),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2697),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(786),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [799] = {
    [sym__statement] = STATE(3009),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3009),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(808),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [800] = {
    [sym__statement] = STATE(5710),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5710),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(795),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1721),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1721),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [801] = {
    [sym__statement] = STATE(5739),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5739),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(800),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [802] = {
    [sym__statement] = STATE(1716),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1716),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [aux_sym_guarded_block_repeat1] = STATE(830),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1723),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym__layout_semicolon] = ACTIONS(1723),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [803] = {
    [sym__statement] = STATE(5709),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5709),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [804] = {
    [sym__statement] = STATE(5876),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5876),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [805] = {
    [sym__statement] = STATE(5831),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5831),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [806] = {
    [sym__statement] = STATE(5894),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5894),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1725),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1725),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [807] = {
    [sym__statement] = STATE(2760),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2760),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [808] = {
    [sym__statement] = STATE(3011),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3011),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [aux_sym_guarded_block_repeat1] = STATE(828),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1727),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1727),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [809] = {
    [sym__statement] = STATE(5907),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5907),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [810] = {
    [sym__statement] = STATE(5966),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5966),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(806),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1729),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1729),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [811] = {
    [sym__statement] = STATE(6017),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6017),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(810),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [812] = {
    [sym__statement] = STATE(5746),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5746),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(849),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1731),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [813] = {
    [sym__statement] = STATE(5959),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5959),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [814] = {
    [sym__statement] = STATE(6099),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6099),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [815] = {
    [sym__statement] = STATE(2758),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2758),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [816] = {
    [sym__statement] = STATE(6114),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6114),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [817] = {
    [sym__statement] = STATE(6127),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6127),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1733),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1733),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [818] = {
    [sym__statement] = STATE(6138),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6138),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [819] = {
    [sym__statement] = STATE(6189),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6189),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(817),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1735),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1735),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [820] = {
    [sym__statement] = STATE(3315),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3315),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [821] = {
    [sym__statement] = STATE(6222),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6222),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(819),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [822] = {
    [sym__statement] = STATE(3012),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3012),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [823] = {
    [sym__statement] = STATE(6205),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6205),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [824] = {
    [sym__statement] = STATE(1694),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1694),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [825] = {
    [sym__statement] = STATE(6004),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6004),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [826] = {
    [sym__statement] = STATE(3299),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3299),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1737),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(1737),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [827] = {
    [sym__statement] = STATE(3294),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3294),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [828] = {
    [sym__statement] = STATE(3039),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3039),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1739),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1739),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [829] = {
    [sym__statement] = STATE(3283),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3283),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [aux_sym_guarded_block_repeat1] = STATE(826),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1741),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(1741),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [830] = {
    [sym__statement] = STATE(1691),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1691),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_SEMI] = ACTIONS(1743),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym__layout_semicolon] = ACTIONS(1743),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [831] = {
    [sym__statement] = STATE(6196),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6196),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [832] = {
    [sym__statement] = STATE(6182),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6182),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [833] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(1745),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [834] = {
    [sym__statement] = STATE(5629),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5629),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(797),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [835] = {
    [sym__statement] = STATE(6178),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6178),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [836] = {
    [sym__statement] = STATE(5790),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5790),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [837] = {
    [sym__statement] = STATE(6171),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6171),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1747),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1747),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [838] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(129),
    [sym__layout_end] = ACTIONS(1713),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [839] = {
    [sym__statement] = STATE(3274),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3274),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(829),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [840] = {
    [sym__statement] = STATE(3041),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3041),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [841] = {
    [sym__statement] = STATE(6167),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6167),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [842] = {
    [sym__statement] = STATE(6152),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6152),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(837),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1749),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1749),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [843] = {
    [sym__statement] = STATE(2982),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(2982),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(845),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [844] = {
    [sym__statement] = STATE(6124),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6124),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(842),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [845] = {
    [sym__statement] = STATE(3044),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3044),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [aux_sym_guarded_block_repeat1] = STATE(847),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1751),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(1751),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [846] = {
    [sym__statement] = STATE(3230),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3230),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [847] = {
    [sym__statement] = STATE(3112),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3112),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_SEMI] = ACTIONS(1753),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(1753),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [848] = {
    [sym__statement] = STATE(2858),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(2858),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(672),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [849] = {
    [sym__statement] = STATE(5796),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5796),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1755),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1755),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [850] = {
    [sym__statement] = STATE(2892),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2892),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [851] = {
    [sym__statement] = STATE(6051),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6051),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [852] = {
    [sym__statement] = STATE(6041),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6041),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [853] = {
    [sym__statement] = STATE(3016),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3016),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [854] = {
    [sym__statement] = STATE(2916),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(2916),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [855] = {
    [sym__statement] = STATE(3553),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3553),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [856] = {
    [sym__statement] = STATE(6033),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6033),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [857] = {
    [sym__statement] = STATE(3557),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3557),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [858] = {
    [sym__statement] = STATE(6013),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6013),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1757),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1757),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [859] = {
    [sym__statement] = STATE(6001),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6001),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [860] = {
    [sym__statement] = STATE(5624),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5624),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [861] = {
    [sym__statement] = STATE(5618),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5618),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [862] = {
    [sym__statement] = STATE(5974),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5974),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [aux_sym_guarded_block_repeat1] = STATE(858),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(1759),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(1759),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [863] = {
    [sym__statement] = STATE(5950),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5950),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(862),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [864] = {
    [sym__statement] = STATE(2584),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2584),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [865] = {
    [sym__statement] = STATE(5623),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5623),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [866] = {
    [sym__statement] = STATE(5807),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5807),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [867] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(173),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(173),
    [sym__layout_end] = ACTIONS(1745),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [868] = {
    [sym__statement] = STATE(2629),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2629),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(881),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [869] = {
    [sym__statement] = STATE(2634),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2634),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [870] = {
    [sym__statement] = STATE(5697),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5697),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [871] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(167),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [872] = {
    [sym__statement] = STATE(1649),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1649),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [873] = {
    [sym__statement] = STATE(1608),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1608),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [874] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(167),
    [sym__layout_end] = ACTIONS(1761),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [875] = {
    [sym__statement] = STATE(2598),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2598),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1763),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1763),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [876] = {
    [sym__statement] = STATE(2568),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2568),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [877] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(1765),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [878] = {
    [sym__statement] = STATE(2563),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2563),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [aux_sym_guarded_block_repeat1] = STATE(875),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1767),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1767),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [879] = {
    [sym__statement] = STATE(2647),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2647),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [880] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(141),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [881] = {
    [sym__statement] = STATE(2631),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2631),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [aux_sym_guarded_block_repeat1] = STATE(883),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1771),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1771),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [882] = {
    [sym__statement] = STATE(2632),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2632),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [883] = {
    [sym__statement] = STATE(2638),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2638),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [aux_sym_guarded_block_repeat1] = STATE(4643),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_SEMI] = ACTIONS(1773),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_semicolon] = ACTIONS(1773),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [884] = {
    [sym__statement] = STATE(6082),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6082),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [885] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(153),
    [sym__layout_end] = ACTIONS(1569),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [886] = {
    [sym__statement] = STATE(5532),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5532),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [887] = {
    [sym__statement] = STATE(2556),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2556),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(878),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [888] = {
    [sym__statement] = STATE(5530),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5530),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [889] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_SEMI] = ACTIONS(83),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(83),
    [sym__layout_end] = ACTIONS(1765),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [890] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_semicolon] = ACTIONS(141),
    [sym__layout_end] = ACTIONS(1769),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [891] = {
    [sym__statement] = STATE(5833),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5833),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5498),
    [sym_use_clause] = STATE(7048),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [892] = {
    [sym__statement] = STATE(5816),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5816),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_use] = STATE(5434),
    [sym_use_clause] = STATE(4667),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [anon_sym_use] = ACTIONS(9),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [893] = {
    [aux_sym__term4] = STATE(893),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_wordy_id] = STATE(1485),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_nat] = ACTIONS(1777),
    [sym_int] = ACTIONS(1777),
    [sym_float] = ACTIONS(1777),
    [anon_sym_DQUOTE] = ACTIONS(1780),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1783),
    [aux_sym_literal_char_token1] = ACTIONS(1786),
    [aux_sym_literal_char_token2] = ACTIONS(1786),
    [anon_sym_true] = ACTIONS(1789),
    [anon_sym_false] = ACTIONS(1789),
    [sym_literal_byte] = ACTIONS(1777),
    [sym_literal_hex] = ACTIONS(1777),
    [anon_sym_LPAREN] = ACTIONS(1792),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(1797),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(1803),
    [anon_sym_BANG] = ACTIONS(1806),
    [anon_sym_COLON] = ACTIONS(1795),
    [anon_sym_use] = ACTIONS(1795),
    [sym_do] = ACTIONS(1809),
    [sym_kw_let] = ACTIONS(1812),
    [sym_type_kw] = ACTIONS(1795),
    [sym_match] = ACTIONS(1815),
    [sym_cases] = ACTIONS(1818),
    [sym_structural] = ACTIONS(1795),
    [sym_unique] = ACTIONS(1795),
    [sym_ability] = ACTIONS(1795),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(1821),
    [sym_kw_typelink] = ACTIONS(1824),
    [sym_handle] = ACTIONS(1827),
    [sym_rewrite] = ACTIONS(1830),
    [aux_sym_wordy_id_token1] = ACTIONS(1833),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(1836),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1839),
    [sym_built_in_hash] = ACTIONS(1842),
    [anon_sym_test_GT] = ACTIONS(1795),
    [anon_sym_test_DOTio_GT] = ACTIONS(1795),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1775),
    [sym__parenthesized_operator] = ACTIONS(1845),
    [sym__watch_start] = ACTIONS(1775),
    [sym_doc_block] = ACTIONS(1848),
  },
  [894] = {
    [aux_sym__term4] = STATE(893),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_wordy_id] = STATE(1485),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(1853),
    [sym_int] = ACTIONS(1853),
    [sym_float] = ACTIONS(1853),
    [anon_sym_DQUOTE] = ACTIONS(1856),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1859),
    [aux_sym_literal_char_token1] = ACTIONS(1862),
    [aux_sym_literal_char_token2] = ACTIONS(1862),
    [anon_sym_true] = ACTIONS(1865),
    [anon_sym_false] = ACTIONS(1865),
    [sym_literal_byte] = ACTIONS(1853),
    [sym_literal_hex] = ACTIONS(1853),
    [anon_sym_LPAREN] = ACTIONS(1868),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(1873),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(1879),
    [anon_sym_BANG] = ACTIONS(1882),
    [anon_sym_COLON] = ACTIONS(1871),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(1885),
    [sym_kw_let] = ACTIONS(1888),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(1891),
    [sym_cases] = ACTIONS(1894),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(1897),
    [sym_kw_typelink] = ACTIONS(1900),
    [sym_handle] = ACTIONS(1903),
    [sym_rewrite] = ACTIONS(1906),
    [aux_sym_wordy_id_token1] = ACTIONS(1909),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(1912),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1915),
    [sym_built_in_hash] = ACTIONS(1918),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(1921),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(1924),
  },
  [895] = {
    [sym__statement] = STATE(1650),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1650),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym__block] = STATE(1806),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym__layout_start] = ACTIONS(1927),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [896] = {
    [sym__statement] = STATE(4472),
    [sym_term_definition2] = STATE(4601),
    [sym__binding] = STATE(4573),
    [sym_destructuring_bind] = STATE(4472),
    [sym__block_term] = STATE(4574),
    [sym_literal_function] = STATE(4574),
    [aux_sym__term4] = STATE(1233),
    [sym__infix_app_or_boolean_op] = STATE(4604),
    [sym_literal_text] = STATE(4402),
    [sym_literal_char] = STATE(4402),
    [sym_literal_boolean] = STATE(4402),
    [sym_tuple_or_parenthesized] = STATE(4402),
    [sym_literal_termlink] = STATE(4402),
    [sym_literal_typelink] = STATE(4402),
    [sym__lhs] = STATE(6996),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4398),
    [sym__match_with] = STATE(4401),
    [sym__lam_case] = STATE(4398),
    [sym_parenthesized_or_tuple_pattern] = STATE(7001),
    [sym_kw_if] = STATE(7123),
    [sym_delay_quote] = STATE(4402),
    [sym_delay_block] = STATE(4402),
    [sym_bang] = STATE(4402),
    [sym__number] = STATE(4402),
    [sym__link] = STATE(4402),
    [sym__term_leaf] = STATE(4402),
    [sym_literal_list] = STATE(4402),
    [sym__keyword_block] = STATE(4403),
    [sym_exp_if] = STATE(4403),
    [sym_force] = STATE(4402),
    [sym__block] = STATE(4418),
    [sym_exp_let] = STATE(4403),
    [sym_handler] = STATE(4403),
    [sym_rewrite_block] = STATE(4403),
    [sym_type_signature] = STATE(5242),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2880),
    [sym_hash_qualifier] = STATE(4355),
    [sym__hq_qualified_wordy_id] = STATE(4355),
    [sym__hq_qualified_prefix_term] = STATE(4294),
    [sym__prefix_definition_name] = STATE(5274),
    [sym__wordy_definition_name] = STATE(5274),
    [sym_nat] = ACTIONS(1929),
    [sym_int] = ACTIONS(1929),
    [sym_float] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1933),
    [aux_sym_literal_char_token1] = ACTIONS(1935),
    [aux_sym_literal_char_token2] = ACTIONS(1937),
    [anon_sym_true] = ACTIONS(1939),
    [anon_sym_false] = ACTIONS(1939),
    [sym_literal_byte] = ACTIONS(1941),
    [sym_literal_hex] = ACTIONS(1941),
    [anon_sym_LPAREN] = ACTIONS(1943),
    [anon_sym_LBRACK] = ACTIONS(1945),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1947),
    [anon_sym_BANG] = ACTIONS(1949),
    [sym_do] = ACTIONS(1951),
    [sym_kw_let] = ACTIONS(1953),
    [sym_match] = ACTIONS(1955),
    [sym_cases] = ACTIONS(1957),
    [sym_kw_termlink] = ACTIONS(1959),
    [sym_kw_typelink] = ACTIONS(1961),
    [sym_handle] = ACTIONS(1963),
    [sym_rewrite] = ACTIONS(1965),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(1969),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1971),
    [sym_built_in_hash] = ACTIONS(1973),
    [sym__layout_start] = ACTIONS(1975),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1973),
    [sym_doc_block] = ACTIONS(1941),
  },
  [897] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(85),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(1977),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [898] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6630),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [899] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6847),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [900] = {
    [sym__statement] = STATE(4021),
    [sym_term_definition2] = STATE(4037),
    [sym__binding] = STATE(4048),
    [sym_destructuring_bind] = STATE(4021),
    [sym__block_term] = STATE(4054),
    [sym_literal_function] = STATE(4054),
    [aux_sym__term4] = STATE(1217),
    [sym__infix_app_or_boolean_op] = STATE(4028),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__lhs] = STATE(6940),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_parenthesized_or_tuple_pattern] = STATE(6944),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym__block] = STATE(3844),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_type_signature] = STATE(5257),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2340),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(5270),
    [sym__wordy_definition_name] = STATE(5270),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2029),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(789),
    [sym_literal_hex] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(2037),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(2043),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_path] = ACTIONS(2047),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2049),
    [sym_built_in_hash] = ACTIONS(2051),
    [sym__layout_start] = ACTIONS(2053),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [901] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(143),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(2055),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [902] = {
    [sym__statement] = STATE(2463),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2463),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym__block] = STATE(2441),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_start] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [903] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(7088),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [904] = {
    [sym__statement] = STATE(1999),
    [sym_term_definition2] = STATE(2083),
    [sym__binding] = STATE(2058),
    [sym_destructuring_bind] = STATE(1999),
    [sym__block_term] = STATE(1990),
    [sym_literal_function] = STATE(1990),
    [aux_sym__term4] = STATE(579),
    [sym__infix_app_or_boolean_op] = STATE(2076),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__lhs] = STATE(6974),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_parenthesized_or_tuple_pattern] = STATE(6978),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym__block] = STATE(2120),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_type_signature] = STATE(5265),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1518),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(5293),
    [sym__wordy_definition_name] = STATE(5293),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(2063),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(2071),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym__layout_start] = ACTIONS(2075),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [905] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6529),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [906] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6841),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [907] = {
    [sym__statement] = STATE(2463),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2463),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym__block] = STATE(2441),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym__layout_start] = ACTIONS(2057),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [908] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(155),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(2077),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [909] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(169),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(2079),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [910] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6658),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [911] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6599),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [912] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(7028),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [913] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6793),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [914] = {
    [sym__statement] = STATE(4190),
    [sym_term_definition2] = STATE(4356),
    [sym__binding] = STATE(4272),
    [sym_destructuring_bind] = STATE(4190),
    [sym__block_term] = STATE(4275),
    [sym_literal_function] = STATE(4275),
    [aux_sym__term4] = STATE(1226),
    [sym__infix_app_or_boolean_op] = STATE(4353),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__lhs] = STATE(6991),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_parenthesized_or_tuple_pattern] = STATE(6992),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym__block] = STATE(4095),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_type_signature] = STATE(5228),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2555),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(5292),
    [sym__wordy_definition_name] = STATE(5292),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(2095),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(2121),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym__layout_start] = ACTIONS(2127),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [915] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2129),
    [sym__layout_end] = ACTIONS(2131),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [916] = {
    [sym__statement] = STATE(4163),
    [sym_term_definition2] = STATE(4257),
    [sym__binding] = STATE(4114),
    [sym_destructuring_bind] = STATE(4163),
    [sym__block_term] = STATE(4113),
    [sym_literal_function] = STATE(4113),
    [aux_sym__term4] = STATE(1224),
    [sym__infix_app_or_boolean_op] = STATE(4265),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__lhs] = STATE(6985),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_parenthesized_or_tuple_pattern] = STATE(6987),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym__block] = STATE(4342),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_type_signature] = STATE(5261),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2603),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(5273),
    [sym__wordy_definition_name] = STATE(5273),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(2147),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym__layout_start] = ACTIONS(2177),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [917] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6534),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [918] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2129),
    [sym__layout_end] = ACTIONS(2179),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [919] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6622),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [920] = {
    [sym__statement] = STATE(2177),
    [sym_term_definition2] = STATE(2160),
    [sym__binding] = STATE(2259),
    [sym_destructuring_bind] = STATE(2177),
    [sym__block_term] = STATE(2248),
    [sym_literal_function] = STATE(2248),
    [aux_sym__term4] = STATE(689),
    [sym__infix_app_or_boolean_op] = STATE(2184),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__lhs] = STATE(6863),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_parenthesized_or_tuple_pattern] = STATE(6855),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym__block] = STATE(2231),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_type_signature] = STATE(5223),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1523),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [sym__prefix_definition_name] = STATE(5289),
    [sym__wordy_definition_name] = STATE(5289),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2181),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1619),
    [sym_literal_hex] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(2185),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(1589),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(2191),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(2193),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2195),
    [sym_built_in_hash] = ACTIONS(1617),
    [sym__layout_start] = ACTIONS(2197),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym_doc_block] = ACTIONS(1619),
  },
  [921] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(7107),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [922] = {
    [sym__statement] = STATE(3618),
    [sym_term_definition2] = STATE(3515),
    [sym__binding] = STATE(3381),
    [sym_destructuring_bind] = STATE(3618),
    [sym__block_term] = STATE(3382),
    [sym_literal_function] = STATE(3382),
    [aux_sym__term4] = STATE(1219),
    [sym__infix_app_or_boolean_op] = STATE(3568),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__lhs] = STATE(6876),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_parenthesized_or_tuple_pattern] = STATE(6868),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym__block] = STATE(3417),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_type_signature] = STATE(5219),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2365),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(5281),
    [sym__wordy_definition_name] = STATE(5281),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(2213),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym__layout_start] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [923] = {
    [sym__statement] = STATE(3145),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3145),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym__block] = STATE(2935),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym__layout_start] = ACTIONS(2221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [924] = {
    [sym__statement] = STATE(4050),
    [sym_term_definition2] = STATE(3814),
    [sym__binding] = STATE(4014),
    [sym_destructuring_bind] = STATE(4050),
    [sym__block_term] = STATE(4002),
    [sym_literal_function] = STATE(4002),
    [aux_sym__term4] = STATE(1211),
    [sym__infix_app_or_boolean_op] = STATE(3812),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__lhs] = STATE(6952),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_parenthesized_or_tuple_pattern] = STATE(6956),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym__block] = STATE(3922),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_type_signature] = STATE(5241),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2330),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(5269),
    [sym__wordy_definition_name] = STATE(5269),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(2237),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(2263),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym__layout_start] = ACTIONS(2269),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [925] = {
    [sym__statement] = STATE(3380),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3380),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym__block] = STATE(3418),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_start] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [926] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(175),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(2273),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [927] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6947),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [928] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6786),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [929] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2275),
    [sym__layout_end] = ACTIONS(2277),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [930] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2275),
    [sym__layout_end] = ACTIONS(2279),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [931] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6521),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [932] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2281),
    [sym__layout_end] = ACTIONS(2283),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [933] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2281),
    [sym__layout_end] = ACTIONS(2285),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [934] = {
    [sym__statement] = STATE(1952),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1952),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym__block] = STATE(1921),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym__layout_start] = ACTIONS(2287),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [935] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6600),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [936] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(131),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_end] = ACTIONS(2289),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [937] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6560),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [938] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2291),
    [sym__layout_end] = ACTIONS(2293),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [939] = {
    [sym__statement] = STATE(3780),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3780),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym__block] = STATE(3684),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym__layout_start] = ACTIONS(2295),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [940] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2291),
    [sym__layout_end] = ACTIONS(2297),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [941] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6528),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [942] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2299),
    [sym__layout_end] = ACTIONS(2301),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [943] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2299),
    [sym__layout_end] = ACTIONS(2303),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [944] = {
    [sym__statement] = STATE(4567),
    [sym_term_definition2] = STATE(4576),
    [sym__binding] = STATE(4634),
    [sym_destructuring_bind] = STATE(4567),
    [sym__block_term] = STATE(4633),
    [sym_literal_function] = STATE(4633),
    [aux_sym__term4] = STATE(1242),
    [sym__infix_app_or_boolean_op] = STATE(4575),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6915),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6907),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(4499),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5234),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5284),
    [sym__wordy_definition_name] = STATE(5284),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2305),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [945] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2307),
    [sym__layout_end] = ACTIONS(2309),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [946] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2307),
    [sym__layout_end] = ACTIONS(2311),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [947] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2299),
    [sym__layout_end] = ACTIONS(2313),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [948] = {
    [sym__statement] = STATE(3087),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3087),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym__block] = STATE(3270),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym__layout_start] = ACTIONS(2315),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [949] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2299),
    [sym__layout_end] = ACTIONS(2317),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [950] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2319),
    [sym__layout_end] = ACTIONS(2321),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [951] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2319),
    [sym__layout_end] = ACTIONS(2323),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [952] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2325),
    [sym__layout_end] = ACTIONS(2327),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [953] = {
    [sym__statement] = STATE(3380),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3380),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym__block] = STATE(3418),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_start] = ACTIONS(2271),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [954] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2325),
    [sym__layout_end] = ACTIONS(2329),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [955] = {
    [sym__statement] = STATE(3618),
    [sym_term_definition2] = STATE(3515),
    [sym__binding] = STATE(3381),
    [sym_destructuring_bind] = STATE(3618),
    [sym__block_term] = STATE(3382),
    [sym_literal_function] = STATE(3382),
    [aux_sym__term4] = STATE(1225),
    [sym__infix_app_or_boolean_op] = STATE(3568),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__lhs] = STATE(6876),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_parenthesized_or_tuple_pattern] = STATE(7005),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym__block] = STATE(3417),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_type_signature] = STATE(5219),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2836),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(5280),
    [sym__wordy_definition_name] = STATE(5280),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(2209),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(2339),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym__layout_start] = ACTIONS(2219),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [956] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2319),
    [sym__layout_end] = ACTIONS(2341),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [957] = {
    [sym__statement] = STATE(6722),
    [sym_term_definition2] = STATE(7006),
    [sym__binding] = STATE(6719),
    [sym_destructuring_bind] = STATE(6722),
    [sym__block_term] = STATE(6711),
    [sym_literal_function] = STATE(6711),
    [aux_sym__term4] = STATE(1232),
    [sym__infix_app_or_boolean_op] = STATE(7007),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__lhs] = STATE(6771),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_parenthesized_or_tuple_pattern] = STATE(6708),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym__block] = STATE(6705),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_type_signature] = STATE(5238),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2528),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__prefix_definition_name] = STATE(5287),
    [sym__wordy_definition_name] = STATE(5287),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1983),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1987),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1991),
    [sym_literal_hex] = ACTIONS(1991),
    [anon_sym_LPAREN] = ACTIONS(1993),
    [anon_sym_LBRACK] = ACTIONS(1995),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1997),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_rewrite] = ACTIONS(2015),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(2019),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2021),
    [sym_built_in_hash] = ACTIONS(2023),
    [sym__layout_start] = ACTIONS(2025),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [958] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_semicolon] = ACTIONS(2319),
    [sym__layout_end] = ACTIONS(2343),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [959] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2345),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [960] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2347),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [961] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2349),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [962] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2351),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [963] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2353),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [964] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2355),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [965] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2357),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [966] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2359),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [967] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2361),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [968] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2363),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [969] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2365),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [970] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2367),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [971] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2369),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [972] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2371),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [973] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2373),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [974] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2375),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [975] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2377),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [976] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2379),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [977] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2381),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [978] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2383),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [979] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2385),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [980] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2387),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [981] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2389),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [982] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2391),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [983] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2393),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [984] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2395),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [985] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2397),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [986] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2399),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [987] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2401),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [988] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2403),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [989] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2405),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [990] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2407),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [991] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2409),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [992] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2411),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [993] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2413),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [994] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2415),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [995] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2417),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [996] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2419),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [997] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2421),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [998] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2423),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [999] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2425),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1000] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2427),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1001] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1002] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2431),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1003] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2433),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1004] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2435),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1005] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2437),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1006] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2439),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1007] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2441),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1008] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2443),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1009] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2445),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1010] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2447),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1011] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2449),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1012] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2451),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1013] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2453),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1014] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2455),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1015] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2457),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1016] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2459),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1017] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2461),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1018] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2463),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1019] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2465),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1020] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2467),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1021] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2469),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1022] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2471),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1023] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2473),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1024] = {
    [aux_sym__term4] = STATE(1041),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_wordy_id] = STATE(1513),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(2475),
    [sym_int] = ACTIONS(2475),
    [sym_float] = ACTIONS(2475),
    [anon_sym_DQUOTE] = ACTIONS(2478),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2481),
    [aux_sym_literal_char_token1] = ACTIONS(2484),
    [aux_sym_literal_char_token2] = ACTIONS(2484),
    [anon_sym_true] = ACTIONS(2487),
    [anon_sym_false] = ACTIONS(2487),
    [sym_literal_byte] = ACTIONS(2475),
    [sym_literal_hex] = ACTIONS(2475),
    [anon_sym_LPAREN] = ACTIONS(2490),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(2493),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(2496),
    [anon_sym_BANG] = ACTIONS(2499),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(2502),
    [sym_kw_let] = ACTIONS(2505),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(2508),
    [sym_cases] = ACTIONS(2511),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(2514),
    [sym_kw_typelink] = ACTIONS(2517),
    [sym_handle] = ACTIONS(2520),
    [sym_rewrite] = ACTIONS(2523),
    [aux_sym_wordy_id_token1] = ACTIONS(2526),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(2529),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2532),
    [sym_built_in_hash] = ACTIONS(2535),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(2538),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(2541),
  },
  [1025] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2544),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1026] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2546),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1027] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2548),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1028] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2550),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1029] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2552),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1030] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2554),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1031] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2556),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1032] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2558),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1033] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2560),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1034] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2562),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1035] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2564),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1036] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2566),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1037] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2568),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1038] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2570),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1039] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2572),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1040] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2574),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1041] = {
    [aux_sym__term4] = STATE(1041),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_wordy_id] = STATE(1513),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_nat] = ACTIONS(2576),
    [sym_int] = ACTIONS(2576),
    [sym_float] = ACTIONS(2576),
    [anon_sym_DQUOTE] = ACTIONS(2579),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2582),
    [aux_sym_literal_char_token1] = ACTIONS(2585),
    [aux_sym_literal_char_token2] = ACTIONS(2585),
    [anon_sym_true] = ACTIONS(2588),
    [anon_sym_false] = ACTIONS(2588),
    [sym_literal_byte] = ACTIONS(2576),
    [sym_literal_hex] = ACTIONS(2576),
    [anon_sym_LPAREN] = ACTIONS(2591),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(2594),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(2597),
    [anon_sym_BANG] = ACTIONS(2600),
    [anon_sym_use] = ACTIONS(1795),
    [sym_do] = ACTIONS(2603),
    [sym_kw_let] = ACTIONS(2606),
    [sym_type_kw] = ACTIONS(1795),
    [sym_match] = ACTIONS(2609),
    [sym_cases] = ACTIONS(2612),
    [sym_structural] = ACTIONS(1795),
    [sym_unique] = ACTIONS(1795),
    [sym_ability] = ACTIONS(1795),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(2615),
    [sym_kw_typelink] = ACTIONS(2618),
    [sym_handle] = ACTIONS(2621),
    [sym_rewrite] = ACTIONS(2624),
    [aux_sym_wordy_id_token1] = ACTIONS(2627),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(2630),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2633),
    [sym_built_in_hash] = ACTIONS(2636),
    [anon_sym_test_GT] = ACTIONS(1795),
    [anon_sym_test_DOTio_GT] = ACTIONS(1795),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1775),
    [sym__parenthesized_operator] = ACTIONS(2639),
    [sym__watch_start] = ACTIONS(1775),
    [sym_doc_block] = ACTIONS(2642),
  },
  [1042] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2645),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1043] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2647),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1044] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2649),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1045] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2651),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1046] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2653),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1047] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2655),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1048] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2657),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1049] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2659),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1050] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2661),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1051] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2663),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1052] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2665),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1053] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2667),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1054] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2669),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1055] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2671),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1056] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2673),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1057] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2675),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1058] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2677),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1059] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2679),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1060] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2681),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1061] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2683),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1062] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2685),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1063] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2687),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1064] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2689),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1065] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2691),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1066] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2693),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1067] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2695),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1068] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2697),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1069] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2699),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1070] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2701),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1071] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2703),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1072] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2705),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1073] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2707),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1074] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2709),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1075] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2711),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1076] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2713),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1077] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2715),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1078] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2717),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1079] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2719),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1080] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2721),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1081] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2723),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1082] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2725),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1083] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2727),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1084] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2729),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1085] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1086] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2733),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1087] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2735),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1088] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2737),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1089] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2739),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1090] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2741),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1091] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2743),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1092] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2745),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1093] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2747),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1094] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2749),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1095] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2751),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1096] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2753),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1097] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2755),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1098] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2757),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1099] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2759),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1100] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2761),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1101] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2763),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1102] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2765),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1103] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2767),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1104] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2769),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1105] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2771),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1106] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2773),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1107] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1108] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2777),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1109] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2779),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1110] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2781),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1111] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2783),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1112] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2785),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1113] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2787),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1114] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2789),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1115] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2791),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1116] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2793),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1117] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2795),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1118] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2797),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1119] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2799),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1120] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2801),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1121] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2803),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1122] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2805),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1123] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2807),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1124] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2809),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1125] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2811),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1126] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2813),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1127] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2815),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1128] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2817),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1129] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2819),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1130] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2821),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1131] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2823),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1132] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2825),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1133] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2827),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1134] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2829),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1135] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2831),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1136] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2833),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1137] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2835),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1138] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2837),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1139] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2839),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1140] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2841),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1141] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2843),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1142] = {
    [sym__statement] = STATE(5858),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5858),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym__layout_end] = ACTIONS(2845),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1143] = {
    [sym__statement] = STATE(5665),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5665),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1144] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1145] = {
    [sym__statement] = STATE(5657),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5657),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1146] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1197),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6997),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2306),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5291),
    [sym__wordy_definition_name] = STATE(5291),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1473),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(857),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1147] = {
    [sym__statement] = STATE(3163),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3163),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1148] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1149] = {
    [sym__statement] = STATE(1662),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1662),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1150] = {
    [sym__statement] = STATE(1854),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1854),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [1151] = {
    [sym__statement] = STATE(5607),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5607),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1152] = {
    [sym__statement] = STATE(1680),
    [sym_term_definition2] = STATE(1626),
    [sym__binding] = STATE(1705),
    [sym_destructuring_bind] = STATE(1680),
    [sym__block_term] = STATE(1686),
    [sym_literal_function] = STATE(1686),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1629),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__lhs] = STATE(6928),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_parenthesized_or_tuple_pattern] = STATE(6932),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_type_signature] = STATE(5233),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1459),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(5276),
    [sym__wordy_definition_name] = STATE(5276),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(1509),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(71),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1153] = {
    [sym__statement] = STATE(3602),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3602),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1154] = {
    [sym__statement] = STATE(3619),
    [sym_term_definition2] = STATE(3591),
    [sym__binding] = STATE(3532),
    [sym_destructuring_bind] = STATE(3619),
    [sym__block_term] = STATE(3533),
    [sym_literal_function] = STATE(3533),
    [aux_sym__term4] = STATE(1201),
    [sym__infix_app_or_boolean_op] = STATE(3592),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6889),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6881),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5246),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5275),
    [sym__wordy_definition_name] = STATE(5275),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1155] = {
    [sym__statement] = STATE(5573),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5573),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1156] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1157] = {
    [sym__statement] = STATE(5512),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5512),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1158] = {
    [sym__statement] = STATE(5608),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5608),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1159] = {
    [sym__statement] = STATE(3084),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3084),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [1160] = {
    [sym__statement] = STATE(6253),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(6253),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1161] = {
    [sym__statement] = STATE(5655),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5655),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1162] = {
    [sym__statement] = STATE(3743),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3743),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1163] = {
    [sym__statement] = STATE(5518),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5518),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1164] = {
    [sym__statement] = STATE(5538),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5538),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1165] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(7003),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2302),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5277),
    [sym__wordy_definition_name] = STATE(5277),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(539),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1166] = {
    [sym__statement] = STATE(5870),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5870),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1167] = {
    [sym__statement] = STATE(5556),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5556),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1168] = {
    [sym__statement] = STATE(5610),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5610),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1169] = {
    [sym__statement] = STATE(5522),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5522),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1170] = {
    [sym__statement] = STATE(3070),
    [sym_term_definition2] = STATE(3129),
    [sym__binding] = STATE(3223),
    [sym_destructuring_bind] = STATE(3070),
    [sym__block_term] = STATE(3224),
    [sym_literal_function] = STATE(3224),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2889),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__lhs] = STATE(6963),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_parenthesized_or_tuple_pattern] = STATE(6967),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_type_signature] = STATE(5229),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2207),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(5282),
    [sym__wordy_definition_name] = STATE(5282),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(1495),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(519),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [1171] = {
    [sym__statement] = STATE(5605),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5605),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1172] = {
    [sym__statement] = STATE(1829),
    [sym_term_definition2] = STATE(1824),
    [sym__binding] = STATE(1901),
    [sym_destructuring_bind] = STATE(1829),
    [sym__block_term] = STATE(1887),
    [sym_literal_function] = STATE(1887),
    [aux_sym__term4] = STATE(430),
    [sym__infix_app_or_boolean_op] = STATE(1823),
    [sym_literal_text] = STATE(1857),
    [sym_literal_char] = STATE(1857),
    [sym_literal_boolean] = STATE(1857),
    [sym_tuple_or_parenthesized] = STATE(1857),
    [sym_literal_termlink] = STATE(1857),
    [sym_literal_typelink] = STATE(1857),
    [sym__lhs] = STATE(6809),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(1883),
    [sym__match_with] = STATE(1856),
    [sym__lam_case] = STATE(1883),
    [sym_parenthesized_or_tuple_pattern] = STATE(6777),
    [sym_kw_if] = STATE(7113),
    [sym_delay_quote] = STATE(1857),
    [sym_delay_block] = STATE(1857),
    [sym_bang] = STATE(1857),
    [sym__number] = STATE(1857),
    [sym__link] = STATE(1857),
    [sym__term_leaf] = STATE(1857),
    [sym_literal_list] = STATE(1857),
    [sym__keyword_block] = STATE(1859),
    [sym_exp_if] = STATE(1859),
    [sym_force] = STATE(1857),
    [sym_exp_let] = STATE(1859),
    [sym_handler] = STATE(1859),
    [sym_rewrite_block] = STATE(1859),
    [sym_type_signature] = STATE(5224),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1447),
    [sym_hash_qualifier] = STATE(1800),
    [sym__hq_qualified_wordy_id] = STATE(1800),
    [sym__hq_qualified_prefix_term] = STATE(1769),
    [sym__prefix_definition_name] = STATE(5268),
    [sym__wordy_definition_name] = STATE(5268),
    [sym_nat] = ACTIONS(185),
    [sym_int] = ACTIONS(185),
    [sym_float] = ACTIONS(185),
    [anon_sym_DQUOTE] = ACTIONS(187),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1459),
    [aux_sym_literal_char_token1] = ACTIONS(191),
    [aux_sym_literal_char_token2] = ACTIONS(1461),
    [anon_sym_true] = ACTIONS(193),
    [anon_sym_false] = ACTIONS(193),
    [sym_literal_byte] = ACTIONS(229),
    [sym_literal_hex] = ACTIONS(229),
    [anon_sym_LPAREN] = ACTIONS(1463),
    [anon_sym_LBRACK] = ACTIONS(1465),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1467),
    [anon_sym_BANG] = ACTIONS(201),
    [sym_do] = ACTIONS(203),
    [sym_kw_let] = ACTIONS(205),
    [sym_match] = ACTIONS(207),
    [sym_cases] = ACTIONS(209),
    [sym_kw_termlink] = ACTIONS(211),
    [sym_kw_typelink] = ACTIONS(213),
    [sym_handle] = ACTIONS(215),
    [sym_rewrite] = ACTIONS(1469),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(219),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1471),
    [sym_built_in_hash] = ACTIONS(227),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(227),
    [sym_doc_block] = ACTIONS(229),
  },
  [1173] = {
    [sym__statement] = STATE(5615),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5615),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1174] = {
    [sym__statement] = STATE(5654),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5654),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1175] = {
    [sym__statement] = STATE(2450),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2450),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1176] = {
    [sym__statement] = STATE(5641),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5641),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1177] = {
    [sym__statement] = STATE(3150),
    [sym_term_definition2] = STATE(3171),
    [sym__binding] = STATE(3289),
    [sym_destructuring_bind] = STATE(3150),
    [sym__block_term] = STATE(3291),
    [sym_literal_function] = STATE(3291),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(3120),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__lhs] = STATE(6902),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_parenthesized_or_tuple_pattern] = STATE(6894),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_type_signature] = STATE(5236),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2169),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(5271),
    [sym__wordy_definition_name] = STATE(5271),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(1449),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(587),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1178] = {
    [sym__statement] = STATE(5627),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5627),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1220),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_parenthesized_or_tuple_pattern] = STATE(6814),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2290),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__prefix_definition_name] = STATE(5283),
    [sym__wordy_definition_name] = STATE(5283),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1417),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(1419),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(867),
    [sym_literal_hex] = ACTIONS(867),
    [anon_sym_LPAREN] = ACTIONS(1421),
    [anon_sym_LBRACK] = ACTIONS(1423),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1425),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(1427),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(1053),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1429),
    [sym_built_in_hash] = ACTIONS(865),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1179] = {
    [sym__statement] = STATE(3753),
    [sym_term_definition2] = STATE(3539),
    [sym__binding] = STATE(3656),
    [sym_destructuring_bind] = STATE(3753),
    [sym__block_term] = STATE(3654),
    [sym_literal_function] = STATE(3654),
    [aux_sym__term4] = STATE(1194),
    [sym__infix_app_or_boolean_op] = STATE(3531),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6850),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6842),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5267),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5290),
    [sym__wordy_definition_name] = STATE(5290),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1180] = {
    [sym__statement] = STATE(5566),
    [sym_term_definition2] = STATE(5535),
    [sym__binding] = STATE(5619),
    [sym_destructuring_bind] = STATE(5566),
    [sym__block_term] = STATE(5630),
    [sym_literal_function] = STATE(5630),
    [aux_sym__term4] = STATE(1222),
    [sym__infix_app_or_boolean_op] = STATE(5550),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__lhs] = STATE(6824),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_parenthesized_or_tuple_pattern] = STATE(6920),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_type_signature] = STATE(5232),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2172),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__prefix_definition_name] = STATE(5288),
    [sym__wordy_definition_name] = STATE(5288),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1477),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(1479),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(733),
    [sym_literal_hex] = ACTIONS(733),
    [anon_sym_LPAREN] = ACTIONS(1481),
    [anon_sym_LBRACK] = ACTIONS(1483),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1485),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_rewrite] = ACTIONS(1487),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(723),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1489),
    [sym_built_in_hash] = ACTIONS(731),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1181] = {
    [sym__statement] = STATE(2405),
    [sym_term_definition2] = STATE(2459),
    [sym__binding] = STATE(2549),
    [sym_destructuring_bind] = STATE(2405),
    [sym__block_term] = STATE(2546),
    [sym_literal_function] = STATE(2546),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2447),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__lhs] = STATE(6837),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_parenthesized_or_tuple_pattern] = STATE(6829),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_type_signature] = STATE(5255),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(2002),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(5294),
    [sym__wordy_definition_name] = STATE(5294),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(1435),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(421),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1182] = {
    [aux_sym__term4] = STATE(1184),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_wordy_id] = STATE(1632),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(2847),
    [sym_int] = ACTIONS(2847),
    [sym_float] = ACTIONS(2847),
    [anon_sym_DQUOTE] = ACTIONS(2850),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2853),
    [aux_sym_literal_char_token1] = ACTIONS(2856),
    [aux_sym_literal_char_token2] = ACTIONS(2856),
    [anon_sym_true] = ACTIONS(2859),
    [anon_sym_false] = ACTIONS(2859),
    [sym_literal_byte] = ACTIONS(2847),
    [sym_literal_hex] = ACTIONS(2847),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(2865),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(2868),
    [anon_sym_BANG] = ACTIONS(2871),
    [anon_sym_COLON] = ACTIONS(1871),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(2874),
    [sym_kw_let] = ACTIONS(2877),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(2880),
    [sym_cases] = ACTIONS(2883),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(2886),
    [sym_kw_typelink] = ACTIONS(2889),
    [sym_handle] = ACTIONS(2892),
    [sym_rewrite] = ACTIONS(2895),
    [aux_sym_wordy_id_token1] = ACTIONS(2898),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(2901),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2904),
    [sym_built_in_hash] = ACTIONS(2907),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(2910),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(2913),
  },
  [1183] = {
    [aux_sym__term4] = STATE(1184),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_wordy_id] = STATE(1632),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1523),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(1525),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1519),
    [sym_literal_hex] = ACTIONS(1519),
    [anon_sym_LPAREN] = ACTIONS(2862),
    [anon_sym_LBRACK] = ACTIONS(1531),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1533),
    [anon_sym_BANG] = ACTIONS(1535),
    [anon_sym_COLON] = ACTIONS(1871),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(1553),
    [aux_sym_wordy_id_token1] = ACTIONS(2898),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(2901),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1559),
    [sym_built_in_hash] = ACTIONS(1561),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(2913),
  },
  [1184] = {
    [aux_sym__term4] = STATE(1184),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_wordy_id] = STATE(1632),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_nat] = ACTIONS(2916),
    [sym_int] = ACTIONS(2916),
    [sym_float] = ACTIONS(2916),
    [anon_sym_DQUOTE] = ACTIONS(2919),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2922),
    [aux_sym_literal_char_token1] = ACTIONS(2925),
    [aux_sym_literal_char_token2] = ACTIONS(2925),
    [anon_sym_true] = ACTIONS(2928),
    [anon_sym_false] = ACTIONS(2928),
    [sym_literal_byte] = ACTIONS(2916),
    [sym_literal_hex] = ACTIONS(2916),
    [anon_sym_LPAREN] = ACTIONS(2931),
    [anon_sym_LBRACK] = ACTIONS(2934),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(2937),
    [anon_sym_BANG] = ACTIONS(2940),
    [anon_sym_COLON] = ACTIONS(1795),
    [anon_sym_use] = ACTIONS(1795),
    [sym_do] = ACTIONS(2943),
    [sym_kw_let] = ACTIONS(2946),
    [sym_type_kw] = ACTIONS(1795),
    [sym_match] = ACTIONS(2949),
    [sym_cases] = ACTIONS(2952),
    [sym_structural] = ACTIONS(1795),
    [sym_unique] = ACTIONS(1795),
    [sym_ability] = ACTIONS(1795),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(2955),
    [sym_kw_typelink] = ACTIONS(2958),
    [sym_handle] = ACTIONS(2961),
    [sym_rewrite] = ACTIONS(2964),
    [aux_sym_wordy_id_token1] = ACTIONS(2967),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(2970),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2973),
    [sym_built_in_hash] = ACTIONS(2976),
    [anon_sym_test_GT] = ACTIONS(1795),
    [anon_sym_test_DOTio_GT] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1775),
    [sym__parenthesized_operator] = ACTIONS(2979),
    [sym__watch_start] = ACTIONS(1775),
    [sym_doc_block] = ACTIONS(2982),
  },
  [1185] = {
    [aux_sym__term4] = STATE(1236),
    [sym__generic_infix_app] = STATE(1396),
    [sym__infix] = STATE(1396),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2081),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(2987),
    [sym_and] = ACTIONS(2987),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(2989),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1186] = {
    [aux_sym__term4] = STATE(1186),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_wordy_id] = STATE(1943),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [ts_builtin_sym_end] = ACTIONS(1775),
    [sym_nat] = ACTIONS(2991),
    [sym_int] = ACTIONS(2991),
    [sym_float] = ACTIONS(2991),
    [anon_sym_DQUOTE] = ACTIONS(2994),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2997),
    [aux_sym_literal_char_token1] = ACTIONS(3000),
    [aux_sym_literal_char_token2] = ACTIONS(3000),
    [anon_sym_true] = ACTIONS(3003),
    [anon_sym_false] = ACTIONS(3003),
    [sym_literal_byte] = ACTIONS(2991),
    [sym_literal_hex] = ACTIONS(2991),
    [anon_sym_LPAREN] = ACTIONS(3006),
    [anon_sym_LBRACK] = ACTIONS(3009),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3012),
    [anon_sym_BANG] = ACTIONS(3015),
    [anon_sym_use] = ACTIONS(1795),
    [sym_do] = ACTIONS(3018),
    [sym_kw_let] = ACTIONS(3021),
    [sym_type_kw] = ACTIONS(1795),
    [sym_match] = ACTIONS(3024),
    [sym_cases] = ACTIONS(3027),
    [sym_structural] = ACTIONS(1795),
    [sym_unique] = ACTIONS(1795),
    [sym_ability] = ACTIONS(1795),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3030),
    [sym_kw_typelink] = ACTIONS(3033),
    [sym_handle] = ACTIONS(3036),
    [sym_rewrite] = ACTIONS(3039),
    [aux_sym_wordy_id_token1] = ACTIONS(3042),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3045),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3048),
    [sym_built_in_hash] = ACTIONS(3051),
    [anon_sym_test_GT] = ACTIONS(1795),
    [anon_sym_test_DOTio_GT] = ACTIONS(1795),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1775),
    [sym__parenthesized_operator] = ACTIONS(3054),
    [sym__watch_start] = ACTIONS(1775),
    [sym_doc_block] = ACTIONS(3057),
  },
  [1187] = {
    [sym_term_definition2] = STATE(5100),
    [sym__binding] = STATE(5127),
    [sym__block_term] = STATE(5113),
    [sym_literal_function] = STATE(5113),
    [aux_sym__term4] = STATE(619),
    [sym__infix_app_or_boolean_op] = STATE(5060),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__lhs] = STATE(7099),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_type_signature] = STATE(5266),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1523),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [sym__prefix_definition_name] = STATE(5278),
    [sym__wordy_definition_name] = STATE(5278),
    [sym__watch_expression] = STATE(5107),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2181),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1619),
    [sym_literal_hex] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(1589),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(2191),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(2193),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2195),
    [sym_built_in_hash] = ACTIONS(1617),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym_doc_block] = ACTIONS(1619),
  },
  [1188] = {
    [aux_sym__term4] = STATE(1280),
    [sym__generic_infix_app] = STATE(1373),
    [sym__infix] = STATE(1373),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_wordy_id] = STATE(2329),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2192),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(3062),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(3064),
    [sym_and] = ACTIONS(3064),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3066),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1189] = {
    [aux_sym__term4] = STATE(1186),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_wordy_id] = STATE(1943),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1577),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(1579),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1573),
    [sym_literal_hex] = ACTIONS(1573),
    [anon_sym_LPAREN] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(1585),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1587),
    [anon_sym_BANG] = ACTIONS(1589),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(1607),
    [aux_sym_wordy_id_token1] = ACTIONS(3071),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3074),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1613),
    [sym_built_in_hash] = ACTIONS(1615),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(3077),
  },
  [1190] = {
    [aux_sym__term4] = STATE(1186),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_wordy_id] = STATE(1943),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [ts_builtin_sym_end] = ACTIONS(1851),
    [sym_nat] = ACTIONS(3080),
    [sym_int] = ACTIONS(3080),
    [sym_float] = ACTIONS(3080),
    [anon_sym_DQUOTE] = ACTIONS(3083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3086),
    [aux_sym_literal_char_token1] = ACTIONS(3089),
    [aux_sym_literal_char_token2] = ACTIONS(3089),
    [anon_sym_true] = ACTIONS(3092),
    [anon_sym_false] = ACTIONS(3092),
    [sym_literal_byte] = ACTIONS(3080),
    [sym_literal_hex] = ACTIONS(3080),
    [anon_sym_LPAREN] = ACTIONS(3068),
    [anon_sym_LBRACK] = ACTIONS(3095),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3098),
    [anon_sym_BANG] = ACTIONS(3101),
    [anon_sym_use] = ACTIONS(1871),
    [sym_do] = ACTIONS(3104),
    [sym_kw_let] = ACTIONS(3107),
    [sym_type_kw] = ACTIONS(1871),
    [sym_match] = ACTIONS(3110),
    [sym_cases] = ACTIONS(3113),
    [sym_structural] = ACTIONS(1871),
    [sym_unique] = ACTIONS(1871),
    [sym_ability] = ACTIONS(1871),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3116),
    [sym_kw_typelink] = ACTIONS(3119),
    [sym_handle] = ACTIONS(3122),
    [sym_rewrite] = ACTIONS(3125),
    [aux_sym_wordy_id_token1] = ACTIONS(3071),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3074),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3128),
    [sym_built_in_hash] = ACTIONS(3131),
    [anon_sym_test_GT] = ACTIONS(1871),
    [anon_sym_test_DOTio_GT] = ACTIONS(1871),
    [sym_comment] = ACTIONS(3),
    [sym_fold] = ACTIONS(1851),
    [sym__parenthesized_operator] = ACTIONS(3134),
    [sym__watch_start] = ACTIONS(1851),
    [sym_doc_block] = ACTIONS(3077),
  },
  [1191] = {
    [aux_sym__term4] = STATE(1258),
    [sym__generic_infix_app] = STATE(1399),
    [sym__infix] = STATE(1399),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2138),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(531),
    [anon_sym_BANG] = ACTIONS(533),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(3137),
    [sym_and] = ACTIONS(3137),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(2989),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1192] = {
    [sym_term_definition2] = STATE(5100),
    [sym__binding] = STATE(5127),
    [sym__block_term] = STATE(5113),
    [sym_literal_function] = STATE(5113),
    [aux_sym__term4] = STATE(619),
    [sym__infix_app_or_boolean_op] = STATE(5060),
    [sym_literal_text] = STATE(2200),
    [sym_literal_char] = STATE(2200),
    [sym_literal_boolean] = STATE(2200),
    [sym_tuple_or_parenthesized] = STATE(2200),
    [sym_literal_termlink] = STATE(2200),
    [sym_literal_typelink] = STATE(2200),
    [sym__lhs] = STATE(7099),
    [sym__infix_lhs] = STATE(7098),
    [sym__prefix_lhs] = STATE(7097),
    [sym__pattern_matching] = STATE(2135),
    [sym__match_with] = STATE(2205),
    [sym__lam_case] = STATE(2135),
    [sym_kw_if] = STATE(7030),
    [sym_delay_quote] = STATE(2200),
    [sym_delay_block] = STATE(2200),
    [sym_bang] = STATE(2200),
    [sym__number] = STATE(2200),
    [sym__link] = STATE(2200),
    [sym__term_leaf] = STATE(2200),
    [sym_literal_list] = STATE(2200),
    [sym__keyword_block] = STATE(2209),
    [sym_exp_if] = STATE(2209),
    [sym_force] = STATE(2200),
    [sym_exp_let] = STATE(2209),
    [sym_handler] = STATE(2209),
    [sym_rewrite_block] = STATE(2209),
    [sym_type_signature] = STATE(5266),
    [sym_open_parens] = STATE(5685),
    [sym_wordy_id] = STATE(1523),
    [sym_hash_qualifier] = STATE(1986),
    [sym__hq_qualified_wordy_id] = STATE(1986),
    [sym__hq_qualified_prefix_term] = STATE(2098),
    [sym__prefix_definition_name] = STATE(5278),
    [sym__wordy_definition_name] = STATE(5278),
    [sym__watch_expression] = STATE(5066),
    [sym_nat] = ACTIONS(1573),
    [sym_int] = ACTIONS(1573),
    [sym_float] = ACTIONS(1573),
    [anon_sym_DQUOTE] = ACTIONS(1575),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2181),
    [aux_sym_literal_char_token1] = ACTIONS(1579),
    [aux_sym_literal_char_token2] = ACTIONS(2183),
    [anon_sym_true] = ACTIONS(1581),
    [anon_sym_false] = ACTIONS(1581),
    [sym_literal_byte] = ACTIONS(1619),
    [sym_literal_hex] = ACTIONS(1619),
    [anon_sym_LPAREN] = ACTIONS(3060),
    [anon_sym_LBRACK] = ACTIONS(2187),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2189),
    [anon_sym_BANG] = ACTIONS(1589),
    [sym_do] = ACTIONS(1591),
    [sym_kw_let] = ACTIONS(1593),
    [sym_match] = ACTIONS(1595),
    [sym_cases] = ACTIONS(1597),
    [sym_kw_termlink] = ACTIONS(1601),
    [sym_kw_typelink] = ACTIONS(1603),
    [sym_handle] = ACTIONS(1605),
    [sym_rewrite] = ACTIONS(2191),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(2193),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2195),
    [sym_built_in_hash] = ACTIONS(1617),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1617),
    [sym_doc_block] = ACTIONS(1619),
  },
  [1193] = {
    [aux_sym__term4] = STATE(1278),
    [sym__generic_infix_app] = STATE(1400),
    [sym__infix] = STATE(1400),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_wordy_id] = STATE(2370),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2189),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(487),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(489),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(483),
    [sym_literal_hex] = ACTIONS(483),
    [anon_sym_LPAREN] = ACTIONS(3139),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(497),
    [anon_sym_BANG] = ACTIONS(499),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_or] = ACTIONS(3141),
    [sym_and] = ACTIONS(3141),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(515),
    [sym_rewrite_arrow] = ACTIONS(967),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3143),
    [aux_sym_hash_qualifier_token1] = ACTIONS(521),
    [sym_built_in_hash] = ACTIONS(523),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [1194] = {
    [aux_sym__term4] = STATE(1319),
    [sym__generic_infix_app] = STATE(1371),
    [sym__infix] = STATE(1371),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_wordy_id] = STATE(2458),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2275),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(3147),
    [sym_and] = ACTIONS(3147),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(3149),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3151),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1195] = {
    [aux_sym__term4] = STATE(1280),
    [sym__generic_infix_app] = STATE(1383),
    [sym__infix] = STATE(1383),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_wordy_id] = STATE(2329),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5156),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(3153),
    [sym_and] = ACTIONS(3153),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3066),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1196] = {
    [aux_sym__term4] = STATE(1236),
    [sym__generic_infix_app] = STATE(1393),
    [sym__infix] = STATE(1393),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5152),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(3155),
    [sym_and] = ACTIONS(3155),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(2989),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1197] = {
    [aux_sym__term4] = STATE(1315),
    [sym__generic_infix_app] = STATE(1392),
    [sym__infix] = STATE(1392),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2277),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(837),
    [anon_sym_BANG] = ACTIONS(839),
    [sym_do] = ACTIONS(841),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(3159),
    [sym_and] = ACTIONS(3159),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(853),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(3161),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3163),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1198] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5948),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6678),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(889),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1199] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6021),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6593),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(991),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1200] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6156),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6938),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(801),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1201] = {
    [aux_sym__term4] = STATE(1336),
    [sym__generic_infix_app] = STATE(1382),
    [sym__infix] = STATE(1382),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2388),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(3177),
    [sym_and] = ACTIONS(3177),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(3161),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3163),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1202] = {
    [aux_sym__term4] = STATE(1343),
    [sym__generic_infix_app] = STATE(1366),
    [sym__infix] = STATE(1366),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_wordy_id] = STATE(2780),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5216),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3179),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2229),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2223),
    [sym_literal_hex] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_or] = ACTIONS(3187),
    [sym_and] = ACTIONS(3187),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3189),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3191),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3193),
    [sym_built_in_hash] = ACTIONS(3195),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1203] = {
    [aux_sym__term4] = STATE(1344),
    [sym__generic_infix_app] = STATE(1375),
    [sym__infix] = STATE(1375),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_wordy_id] = STATE(2769),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5210),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_or] = ACTIONS(3199),
    [sym_and] = ACTIONS(3199),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3201),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1204] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6039),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6571),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(979),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1205] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6194),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(7025),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(821),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1206] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5962),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6649),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(813),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1207] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6059),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6530),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(1007),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1208] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6084),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6661),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(947),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1209] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5986),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6620),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(785),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1210] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5921),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6717),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(975),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1211] = {
    [aux_sym__term4] = STATE(1343),
    [sym__generic_infix_app] = STATE(1394),
    [sym__infix] = STATE(1394),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_wordy_id] = STATE(2780),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2314),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3179),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2229),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2223),
    [sym_literal_hex] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_or] = ACTIONS(3203),
    [sym_and] = ACTIONS(3203),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3189),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3191),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3193),
    [sym_built_in_hash] = ACTIONS(3195),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1212] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5888),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6730),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(929),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1213] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6141),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6886),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(959),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1214] = {
    [aux_sym__term4] = STATE(1338),
    [sym__generic_infix_app] = STATE(1397),
    [sym__infix] = STATE(1397),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5193),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3205),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1259),
    [sym_literal_hex] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_or] = ACTIONS(3213),
    [sym_and] = ACTIONS(3213),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(3215),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3217),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3219),
    [sym_built_in_hash] = ACTIONS(3221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1215] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6121),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6843),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(995),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1216] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6104),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6792),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(873),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1217] = {
    [aux_sym__term4] = STATE(1344),
    [sym__generic_infix_app] = STATE(1398),
    [sym__infix] = STATE(1398),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_wordy_id] = STATE(2769),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2325),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_or] = ACTIONS(3223),
    [sym_and] = ACTIONS(3223),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3201),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1218] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(5954),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6673),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(1005),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1219] = {
    [aux_sym__term4] = STATE(1338),
    [sym__generic_infix_app] = STATE(1368),
    [sym__infix] = STATE(1368),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2380),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3205),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1259),
    [sym_literal_hex] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_RBRACK] = ACTIONS(967),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_or] = ACTIONS(3225),
    [sym_and] = ACTIONS(3225),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(3215),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3217),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3219),
    [sym_built_in_hash] = ACTIONS(3221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1220] = {
    [aux_sym__term4] = STATE(1336),
    [sym__generic_infix_app] = STATE(1379),
    [sym__infix] = STATE(1379),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5205),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(967),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(3227),
    [sym_and] = ACTIONS(3227),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(3161),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3163),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1221] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6175),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_symboly_id] = STATE(6986),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3167),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(777),
    [sym_path] = ACTIONS(3171),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(875),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1222] = {
    [aux_sym__term4] = STATE(1319),
    [sym__generic_infix_app] = STATE(1389),
    [sym__infix] = STATE(1389),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_wordy_id] = STATE(2458),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5199),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(3229),
    [sym_and] = ACTIONS(3229),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(3149),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3151),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(963),
    [sym__layout_end] = ACTIONS(963),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1223] = {
    [aux_sym__term4] = STATE(1349),
    [sym__generic_infix_app] = STATE(1381),
    [sym__infix] = STATE(1381),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_wordy_id] = STATE(3244),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5244),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3231),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2139),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2133),
    [sym_literal_hex] = ACTIONS(2133),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_or] = ACTIONS(3239),
    [sym_and] = ACTIONS(3239),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3241),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3243),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3245),
    [sym_built_in_hash] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1224] = {
    [aux_sym__term4] = STATE(1349),
    [sym__generic_infix_app] = STATE(1387),
    [sym__infix] = STATE(1387),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_wordy_id] = STATE(3244),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2471),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3231),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2139),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2133),
    [sym_literal_hex] = ACTIONS(2133),
    [anon_sym_LPAREN] = ACTIONS(3233),
    [anon_sym_LBRACK] = ACTIONS(3235),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3237),
    [anon_sym_BANG] = ACTIONS(2153),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_or] = ACTIONS(3249),
    [sym_and] = ACTIONS(3249),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3241),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3243),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3245),
    [sym_built_in_hash] = ACTIONS(3247),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1225] = {
    [aux_sym__term4] = STATE(1352),
    [sym__generic_infix_app] = STATE(1391),
    [sym__infix] = STATE(1391),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2416),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3205),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1259),
    [sym_literal_hex] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3251),
    [anon_sym_BANG] = ACTIONS(2333),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_or] = ACTIONS(3253),
    [sym_and] = ACTIONS(3253),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(3215),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3217),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3219),
    [sym_built_in_hash] = ACTIONS(3221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1226] = {
    [aux_sym__term4] = STATE(1346),
    [sym__generic_infix_app] = STATE(1385),
    [sym__infix] = STATE(1385),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_wordy_id] = STATE(2949),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2599),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3255),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2087),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2081),
    [sym_literal_hex] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_or] = ACTIONS(3263),
    [sym_and] = ACTIONS(3263),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(3265),
    [sym_rewrite_arrow] = ACTIONS(967),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3267),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3269),
    [sym_built_in_hash] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1227] = {
    [aux_sym__term4] = STATE(1346),
    [sym__generic_infix_app] = STATE(1377),
    [sym__infix] = STATE(1377),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_wordy_id] = STATE(2949),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5231),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3255),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2087),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2081),
    [sym_literal_hex] = ACTIONS(2081),
    [anon_sym_LPAREN] = ACTIONS(3257),
    [anon_sym_LBRACK] = ACTIONS(3259),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3261),
    [anon_sym_BANG] = ACTIONS(2101),
    [anon_sym_COLON] = ACTIONS(967),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_or] = ACTIONS(3273),
    [sym_and] = ACTIONS(3273),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(3265),
    [sym_rewrite_arrow] = ACTIONS(967),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3267),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3269),
    [sym_built_in_hash] = ACTIONS(3271),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1228] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5740),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3277),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1229] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5884),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3281),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1230] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5875),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3283),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1231] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5926),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3285),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1232] = {
    [aux_sym__term4] = STATE(1357),
    [sym__generic_infix_app] = STATE(1386),
    [sym__infix] = STATE(1386),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_wordy_id] = STATE(3613),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5272),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1979),
    [sym_literal_hex] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_or] = ACTIONS(3295),
    [sym_and] = ACTIONS(3295),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3297),
    [aux_sym_wordy_id_token1] = ACTIONS(3299),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3301),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3303),
    [sym_built_in_hash] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [1233] = {
    [aux_sym__term4] = STATE(1353),
    [sym__generic_infix_app] = STATE(1378),
    [sym__infix] = STATE(1378),
    [sym_literal_text] = STATE(4402),
    [sym_literal_char] = STATE(4402),
    [sym_literal_boolean] = STATE(4402),
    [sym_tuple_or_parenthesized] = STATE(4402),
    [sym_literal_termlink] = STATE(4402),
    [sym_literal_typelink] = STATE(4402),
    [sym__pattern_matching] = STATE(4398),
    [sym__match_with] = STATE(4401),
    [sym__lam_case] = STATE(4398),
    [sym_kw_if] = STATE(7123),
    [sym_delay_quote] = STATE(4402),
    [sym_delay_block] = STATE(4402),
    [sym_bang] = STATE(4402),
    [sym__number] = STATE(4402),
    [sym__link] = STATE(4402),
    [sym__term_leaf] = STATE(4402),
    [sym_literal_list] = STATE(4402),
    [sym__keyword_block] = STATE(4403),
    [sym_exp_if] = STATE(4403),
    [sym_force] = STATE(4402),
    [sym_exp_let] = STATE(4403),
    [sym_handler] = STATE(4403),
    [sym_rewrite_block] = STATE(4403),
    [sym_wordy_id] = STATE(3406),
    [sym_hash_qualifier] = STATE(4355),
    [sym__hq_qualified_wordy_id] = STATE(4355),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4294),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2764),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [sym_nat] = ACTIONS(1929),
    [sym_int] = ACTIONS(1929),
    [sym_float] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3307),
    [aux_sym_literal_char_token1] = ACTIONS(1935),
    [aux_sym_literal_char_token2] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1939),
    [anon_sym_false] = ACTIONS(1939),
    [sym_literal_byte] = ACTIONS(1929),
    [sym_literal_hex] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(1949),
    [sym_do] = ACTIONS(1951),
    [sym_kw_let] = ACTIONS(1953),
    [sym_match] = ACTIONS(1955),
    [sym_cases] = ACTIONS(1957),
    [sym_or] = ACTIONS(3315),
    [sym_and] = ACTIONS(3315),
    [sym_kw_termlink] = ACTIONS(1959),
    [sym_kw_typelink] = ACTIONS(1961),
    [sym_handle] = ACTIONS(1963),
    [sym_rewrite] = ACTIONS(3317),
    [aux_sym_wordy_id_token1] = ACTIONS(3319),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3321),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3323),
    [sym_built_in_hash] = ACTIONS(3325),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1973),
    [sym_doc_block] = ACTIONS(1941),
  },
  [1234] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5669),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3327),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1235] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5967),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3329),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1236] = {
    [aux_sym__term4] = STATE(1236),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym_nat] = ACTIONS(3331),
    [sym_int] = ACTIONS(3331),
    [sym_float] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3337),
    [aux_sym_literal_char_token1] = ACTIONS(3340),
    [aux_sym_literal_char_token2] = ACTIONS(3340),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [sym_literal_byte] = ACTIONS(3331),
    [sym_literal_hex] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_COMMA] = ACTIONS(1795),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_RBRACK] = ACTIONS(1795),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3352),
    [anon_sym_BANG] = ACTIONS(3355),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(3358),
    [sym_kw_let] = ACTIONS(3361),
    [sym_match] = ACTIONS(3364),
    [sym_cases] = ACTIONS(3367),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3370),
    [sym_kw_typelink] = ACTIONS(3373),
    [sym_handle] = ACTIONS(3376),
    [sym_rewrite] = ACTIONS(3379),
    [aux_sym_wordy_id_token1] = ACTIONS(3382),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3385),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3388),
    [sym_built_in_hash] = ACTIONS(3391),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3394),
    [sym_doc_block] = ACTIONS(3397),
  },
  [1237] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6216),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3400),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1238] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5806),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3402),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1239] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5668),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3404),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1240] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5802),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3406),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1241] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5703),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3408),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1242] = {
    [aux_sym__term4] = STATE(1357),
    [sym__generic_infix_app] = STATE(1374),
    [sym__infix] = STATE(1374),
    [sym_literal_text] = STATE(4471),
    [sym_literal_char] = STATE(4471),
    [sym_literal_boolean] = STATE(4471),
    [sym_tuple_or_parenthesized] = STATE(4471),
    [sym_literal_termlink] = STATE(4471),
    [sym_literal_typelink] = STATE(4471),
    [sym__pattern_matching] = STATE(4464),
    [sym__match_with] = STATE(4470),
    [sym__lam_case] = STATE(4464),
    [sym_kw_if] = STATE(7111),
    [sym_delay_quote] = STATE(4471),
    [sym_delay_block] = STATE(4471),
    [sym_bang] = STATE(4471),
    [sym__number] = STATE(4471),
    [sym__link] = STATE(4471),
    [sym__term_leaf] = STATE(4471),
    [sym_literal_list] = STATE(4471),
    [sym__keyword_block] = STATE(4473),
    [sym_exp_if] = STATE(4473),
    [sym_force] = STATE(4471),
    [sym_exp_let] = STATE(4473),
    [sym_handler] = STATE(4473),
    [sym_rewrite_block] = STATE(4473),
    [sym_wordy_id] = STATE(3613),
    [sym_hash_qualifier] = STATE(4170),
    [sym__hq_qualified_wordy_id] = STATE(4170),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4197),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(2713),
    [sym_nat] = ACTIONS(1979),
    [sym_int] = ACTIONS(1979),
    [sym_float] = ACTIONS(1979),
    [anon_sym_DQUOTE] = ACTIONS(1981),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3287),
    [aux_sym_literal_char_token1] = ACTIONS(1985),
    [aux_sym_literal_char_token2] = ACTIONS(1985),
    [anon_sym_true] = ACTIONS(1989),
    [anon_sym_false] = ACTIONS(1989),
    [sym_literal_byte] = ACTIONS(1979),
    [sym_literal_hex] = ACTIONS(1979),
    [anon_sym_LPAREN] = ACTIONS(3289),
    [anon_sym_LBRACK] = ACTIONS(3291),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3293),
    [anon_sym_BANG] = ACTIONS(1999),
    [sym_do] = ACTIONS(2001),
    [sym_kw_let] = ACTIONS(2003),
    [sym_match] = ACTIONS(2005),
    [sym_cases] = ACTIONS(2007),
    [sym_or] = ACTIONS(3410),
    [sym_and] = ACTIONS(3410),
    [sym_kw_termlink] = ACTIONS(2009),
    [sym_kw_typelink] = ACTIONS(2011),
    [sym_handle] = ACTIONS(2013),
    [sym_with] = ACTIONS(967),
    [sym_rewrite] = ACTIONS(3297),
    [aux_sym_wordy_id_token1] = ACTIONS(3299),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3301),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3303),
    [sym_built_in_hash] = ACTIONS(3305),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2023),
    [sym_doc_block] = ACTIONS(1991),
  },
  [1243] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5812),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3412),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1244] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6029),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3414),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1245] = {
    [aux_sym__term4] = STATE(1353),
    [sym__generic_infix_app] = STATE(1367),
    [sym__infix] = STATE(1367),
    [sym_literal_text] = STATE(4402),
    [sym_literal_char] = STATE(4402),
    [sym_literal_boolean] = STATE(4402),
    [sym_tuple_or_parenthesized] = STATE(4402),
    [sym_literal_termlink] = STATE(4402),
    [sym_literal_typelink] = STATE(4402),
    [sym__pattern_matching] = STATE(4398),
    [sym__match_with] = STATE(4401),
    [sym__lam_case] = STATE(4398),
    [sym_kw_if] = STATE(7123),
    [sym_delay_quote] = STATE(4402),
    [sym_delay_block] = STATE(4402),
    [sym_bang] = STATE(4402),
    [sym__number] = STATE(4402),
    [sym__link] = STATE(4402),
    [sym__term_leaf] = STATE(4402),
    [sym_literal_list] = STATE(4402),
    [sym__keyword_block] = STATE(4403),
    [sym_exp_if] = STATE(4403),
    [sym_force] = STATE(4402),
    [sym_exp_let] = STATE(4403),
    [sym_handler] = STATE(4403),
    [sym_rewrite_block] = STATE(4403),
    [sym_wordy_id] = STATE(3406),
    [sym_hash_qualifier] = STATE(4355),
    [sym__hq_qualified_wordy_id] = STATE(4355),
    [sym__hq_qualified_symboly_id] = STATE(4718),
    [sym__hq_qualified_prefix_term] = STATE(4294),
    [sym__hq_qualified_infix_term] = STATE(4718),
    [aux_sym__infix_app_or_boolean_op_repeat1] = STATE(5279),
    [anon_sym_DASH_GT] = ACTIONS(967),
    [sym_nat] = ACTIONS(1929),
    [sym_int] = ACTIONS(1929),
    [sym_float] = ACTIONS(1929),
    [anon_sym_DQUOTE] = ACTIONS(1931),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3307),
    [aux_sym_literal_char_token1] = ACTIONS(1935),
    [aux_sym_literal_char_token2] = ACTIONS(1935),
    [anon_sym_true] = ACTIONS(1939),
    [anon_sym_false] = ACTIONS(1939),
    [sym_literal_byte] = ACTIONS(1929),
    [sym_literal_hex] = ACTIONS(1929),
    [anon_sym_LPAREN] = ACTIONS(3309),
    [anon_sym_LBRACK] = ACTIONS(3311),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3313),
    [anon_sym_BANG] = ACTIONS(1949),
    [sym_do] = ACTIONS(1951),
    [sym_kw_let] = ACTIONS(1953),
    [sym_match] = ACTIONS(1955),
    [sym_cases] = ACTIONS(1957),
    [sym_or] = ACTIONS(3416),
    [sym_and] = ACTIONS(3416),
    [sym_kw_termlink] = ACTIONS(1959),
    [sym_kw_typelink] = ACTIONS(1961),
    [sym_handle] = ACTIONS(1963),
    [sym_rewrite] = ACTIONS(3317),
    [aux_sym_wordy_id_token1] = ACTIONS(3319),
    [sym_symboly_id] = ACTIONS(971),
    [sym_path] = ACTIONS(3321),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3323),
    [sym_built_in_hash] = ACTIONS(3325),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1973),
    [sym_doc_block] = ACTIONS(1941),
  },
  [1246] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6049),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3418),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1247] = {
    [aux_sym__term4] = STATE(1236),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym_nat] = ACTIONS(3420),
    [sym_int] = ACTIONS(3420),
    [sym_float] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3426),
    [aux_sym_literal_char_token1] = ACTIONS(3429),
    [aux_sym_literal_char_token2] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3432),
    [anon_sym_false] = ACTIONS(3432),
    [sym_literal_byte] = ACTIONS(3420),
    [sym_literal_hex] = ACTIONS(3420),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_RBRACK] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3441),
    [anon_sym_BANG] = ACTIONS(3444),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(3447),
    [sym_kw_let] = ACTIONS(3450),
    [sym_match] = ACTIONS(3453),
    [sym_cases] = ACTIONS(3456),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3459),
    [sym_kw_typelink] = ACTIONS(3462),
    [sym_handle] = ACTIONS(3465),
    [sym_rewrite] = ACTIONS(3468),
    [aux_sym_wordy_id_token1] = ACTIONS(3471),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3474),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3477),
    [sym_built_in_hash] = ACTIONS(3480),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3483),
    [sym_doc_block] = ACTIONS(3486),
  },
  [1248] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(5813),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3489),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1249] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6838),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1227),
    [sym__infix_app_or_boolean_op] = STATE(6185),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym__rewrite_term_like] = STATE(6379),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2828),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(6851),
    [sym__wordy_definition_name] = STATE(6851),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(3493),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1250] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6838),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1227),
    [sym__infix_app_or_boolean_op] = STATE(6185),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym__rewrite_term_like] = STATE(6385),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2828),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(6851),
    [sym__wordy_definition_name] = STATE(6851),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(3493),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1251] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6073),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_RBRACK] = ACTIONS(3495),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1252] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6514),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1253] = {
    [sym_literal_function2] = STATE(2429),
    [sym__term] = STATE(2440),
    [sym__term2] = STATE(2429),
    [sym__term3] = STATE(2431),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2746),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2354),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6769),
    [sym__wordy_definition_name] = STATE(6769),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3503),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1254] = {
    [aux_sym__term4] = STATE(1278),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_wordy_id] = STATE(2370),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym_nat] = ACTIONS(3505),
    [sym_int] = ACTIONS(3505),
    [sym_float] = ACTIONS(3505),
    [anon_sym_DQUOTE] = ACTIONS(3508),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3511),
    [aux_sym_literal_char_token1] = ACTIONS(3514),
    [aux_sym_literal_char_token2] = ACTIONS(3514),
    [anon_sym_true] = ACTIONS(3517),
    [anon_sym_false] = ACTIONS(3517),
    [sym_literal_byte] = ACTIONS(3505),
    [sym_literal_hex] = ACTIONS(3505),
    [anon_sym_LPAREN] = ACTIONS(3520),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3523),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3526),
    [anon_sym_BANG] = ACTIONS(3529),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(3532),
    [sym_kw_let] = ACTIONS(3535),
    [sym_match] = ACTIONS(3538),
    [sym_cases] = ACTIONS(3541),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3544),
    [sym_kw_typelink] = ACTIONS(3547),
    [sym_handle] = ACTIONS(3550),
    [sym_rewrite] = ACTIONS(3553),
    [sym_rewrite_arrow] = ACTIONS(1871),
    [aux_sym_wordy_id_token1] = ACTIONS(3556),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3559),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3562),
    [sym_built_in_hash] = ACTIONS(3565),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3568),
    [sym_doc_block] = ACTIONS(3571),
  },
  [1255] = {
    [sym_literal_function2] = STATE(5600),
    [sym__term] = STATE(5552),
    [sym__term2] = STATE(5600),
    [sym__term3] = STATE(5601),
    [aux_sym__term4] = STATE(1195),
    [sym__infix_app_or_boolean_op] = STATE(5488),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6671),
    [sym__wordy_definition_name] = STATE(6671),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1256] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6454),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1257] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6316),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1258] = {
    [aux_sym__term4] = STATE(1258),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [anon_sym_DASH_GT] = ACTIONS(1795),
    [sym_nat] = ACTIONS(3331),
    [sym_int] = ACTIONS(3331),
    [sym_float] = ACTIONS(3331),
    [anon_sym_DQUOTE] = ACTIONS(3334),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3337),
    [aux_sym_literal_char_token1] = ACTIONS(3340),
    [aux_sym_literal_char_token2] = ACTIONS(3340),
    [anon_sym_true] = ACTIONS(3343),
    [anon_sym_false] = ACTIONS(3343),
    [sym_literal_byte] = ACTIONS(3331),
    [sym_literal_hex] = ACTIONS(3331),
    [anon_sym_LPAREN] = ACTIONS(3346),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3349),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3578),
    [anon_sym_BANG] = ACTIONS(3581),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(3584),
    [sym_kw_let] = ACTIONS(3361),
    [sym_match] = ACTIONS(3364),
    [sym_cases] = ACTIONS(3367),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3370),
    [sym_kw_typelink] = ACTIONS(3373),
    [sym_handle] = ACTIONS(3587),
    [sym_rewrite] = ACTIONS(3379),
    [aux_sym_wordy_id_token1] = ACTIONS(3382),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3385),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3388),
    [sym_built_in_hash] = ACTIONS(3391),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3394),
    [sym_doc_block] = ACTIONS(3397),
  },
  [1259] = {
    [sym_literal_function2] = STATE(2035),
    [sym__term] = STATE(2023),
    [sym__term2] = STATE(2035),
    [sym__term3] = STATE(2029),
    [aux_sym__term4] = STATE(579),
    [sym__infix_app_or_boolean_op] = STATE(1965),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6746),
    [sym__wordy_definition_name] = STATE(6746),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1260] = {
    [aux_sym__term4] = STATE(1258),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [anon_sym_DASH_GT] = ACTIONS(1871),
    [sym_nat] = ACTIONS(3420),
    [sym_int] = ACTIONS(3420),
    [sym_float] = ACTIONS(3420),
    [anon_sym_DQUOTE] = ACTIONS(3423),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3426),
    [aux_sym_literal_char_token1] = ACTIONS(3429),
    [aux_sym_literal_char_token2] = ACTIONS(3429),
    [anon_sym_true] = ACTIONS(3432),
    [anon_sym_false] = ACTIONS(3432),
    [sym_literal_byte] = ACTIONS(3420),
    [sym_literal_hex] = ACTIONS(3420),
    [anon_sym_LPAREN] = ACTIONS(3435),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3438),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3594),
    [anon_sym_BANG] = ACTIONS(3597),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(3600),
    [sym_kw_let] = ACTIONS(3450),
    [sym_match] = ACTIONS(3453),
    [sym_cases] = ACTIONS(3456),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3459),
    [sym_kw_typelink] = ACTIONS(3462),
    [sym_handle] = ACTIONS(3603),
    [sym_rewrite] = ACTIONS(3468),
    [aux_sym_wordy_id_token1] = ACTIONS(3471),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3474),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3477),
    [sym_built_in_hash] = ACTIONS(3480),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3483),
    [sym_doc_block] = ACTIONS(3486),
  },
  [1261] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6325),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1262] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6303),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1263] = {
    [sym_literal_function2] = STATE(3378),
    [sym__term] = STATE(3450),
    [sym__term2] = STATE(3378),
    [sym__term3] = STATE(3379),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(2776),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6525),
    [sym__wordy_definition_name] = STATE(6525),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1264] = {
    [sym_literal_function2] = STATE(2934),
    [sym__term] = STATE(3051),
    [sym__term2] = STATE(2934),
    [sym__term3] = STATE(2931),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2790),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2296),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(6738),
    [sym__wordy_definition_name] = STATE(6738),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(3608),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [1265] = {
    [sym_literal_function2] = STATE(4533),
    [sym__term] = STATE(4566),
    [sym__term2] = STATE(4533),
    [sym__term3] = STATE(4498),
    [aux_sym__term4] = STATE(1224),
    [sym__infix_app_or_boolean_op] = STATE(4027),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6642),
    [sym__wordy_definition_name] = STATE(6642),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1266] = {
    [sym_literal_function2] = STATE(4638),
    [sym__term] = STATE(4607),
    [sym__term2] = STATE(4638),
    [sym__term3] = STATE(4628),
    [aux_sym__term4] = STATE(1225),
    [sym__infix_app_or_boolean_op] = STATE(4035),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2910),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6768),
    [sym__wordy_definition_name] = STATE(6768),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3614),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1267] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6425),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1268] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6333),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1269] = {
    [sym_literal_function2] = STATE(3597),
    [sym__term] = STATE(3550),
    [sym__term2] = STATE(3597),
    [sym__term3] = STATE(3598),
    [aux_sym__term4] = STATE(1219),
    [sym__infix_app_or_boolean_op] = STATE(3599),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6567),
    [sym__wordy_definition_name] = STATE(6567),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1270] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6402),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1271] = {
    [sym_literal_function2] = STATE(2429),
    [sym__term] = STATE(2440),
    [sym__term2] = STATE(2429),
    [sym__term3] = STATE(2431),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2432),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6684),
    [sym__wordy_definition_name] = STATE(6684),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1272] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6340),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1273] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6390),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1274] = {
    [sym_literal_function2] = STATE(3597),
    [sym__term] = STATE(3550),
    [sym__term2] = STATE(3597),
    [sym__term3] = STATE(3598),
    [aux_sym__term4] = STATE(1225),
    [sym__infix_app_or_boolean_op] = STATE(4017),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2910),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6770),
    [sym__wordy_definition_name] = STATE(6770),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3614),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1275] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6310),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1276] = {
    [sym_literal_function2] = STATE(3255),
    [sym__term] = STATE(3019),
    [sym__term2] = STATE(3255),
    [sym__term3] = STATE(3253),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(2752),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6613),
    [sym__wordy_definition_name] = STATE(6613),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1277] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6382),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1278] = {
    [aux_sym__term4] = STATE(1278),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_wordy_id] = STATE(2370),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym_nat] = ACTIONS(3618),
    [sym_int] = ACTIONS(3618),
    [sym_float] = ACTIONS(3618),
    [anon_sym_DQUOTE] = ACTIONS(3621),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3624),
    [aux_sym_literal_char_token1] = ACTIONS(3627),
    [aux_sym_literal_char_token2] = ACTIONS(3627),
    [anon_sym_true] = ACTIONS(3630),
    [anon_sym_false] = ACTIONS(3630),
    [sym_literal_byte] = ACTIONS(3618),
    [sym_literal_hex] = ACTIONS(3618),
    [anon_sym_LPAREN] = ACTIONS(3633),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3636),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3639),
    [anon_sym_BANG] = ACTIONS(3642),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(3645),
    [sym_kw_let] = ACTIONS(3648),
    [sym_match] = ACTIONS(3651),
    [sym_cases] = ACTIONS(3654),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3657),
    [sym_kw_typelink] = ACTIONS(3660),
    [sym_handle] = ACTIONS(3663),
    [sym_rewrite] = ACTIONS(3666),
    [sym_rewrite_arrow] = ACTIONS(1795),
    [aux_sym_wordy_id_token1] = ACTIONS(3669),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3672),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3675),
    [sym_built_in_hash] = ACTIONS(3678),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3681),
    [sym_doc_block] = ACTIONS(3684),
  },
  [1279] = {
    [sym_literal_function2] = STATE(3645),
    [sym__term] = STATE(3604),
    [sym__term2] = STATE(3645),
    [sym__term3] = STATE(3650),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(3119),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6589),
    [sym__wordy_definition_name] = STATE(6589),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1280] = {
    [aux_sym__term4] = STATE(1280),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_wordy_id] = STATE(2329),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym_nat] = ACTIONS(3687),
    [sym_int] = ACTIONS(3687),
    [sym_float] = ACTIONS(3687),
    [anon_sym_DQUOTE] = ACTIONS(3690),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3693),
    [aux_sym_literal_char_token1] = ACTIONS(3696),
    [aux_sym_literal_char_token2] = ACTIONS(3696),
    [anon_sym_true] = ACTIONS(3699),
    [anon_sym_false] = ACTIONS(3699),
    [sym_literal_byte] = ACTIONS(3687),
    [sym_literal_hex] = ACTIONS(3687),
    [anon_sym_LPAREN] = ACTIONS(3702),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3705),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3708),
    [anon_sym_BANG] = ACTIONS(3711),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(3714),
    [sym_kw_let] = ACTIONS(3717),
    [sym_match] = ACTIONS(3720),
    [sym_cases] = ACTIONS(3723),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3726),
    [sym_kw_typelink] = ACTIONS(3729),
    [sym_handle] = ACTIONS(3732),
    [sym_with] = ACTIONS(1795),
    [sym_rewrite] = ACTIONS(3735),
    [aux_sym_wordy_id_token1] = ACTIONS(3738),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3741),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3744),
    [sym_built_in_hash] = ACTIONS(3747),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3750),
    [sym_doc_block] = ACTIONS(3753),
  },
  [1281] = {
    [sym_literal_function2] = STATE(5600),
    [sym__term] = STATE(5552),
    [sym__term2] = STATE(5600),
    [sym__term3] = STATE(5601),
    [aux_sym__term4] = STATE(1196),
    [sym__infix_app_or_boolean_op] = STATE(5467),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6744),
    [sym__wordy_definition_name] = STATE(6744),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1282] = {
    [sym_literal_function2] = STATE(4349),
    [sym__term] = STATE(4323),
    [sym__term2] = STATE(4349),
    [sym__term3] = STATE(4348),
    [aux_sym__term4] = STATE(1224),
    [sym__infix_app_or_boolean_op] = STATE(4034),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6754),
    [sym__wordy_definition_name] = STATE(6754),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1283] = {
    [sym_literal_function2] = STATE(3806),
    [sym__term] = STATE(3926),
    [sym__term2] = STATE(3806),
    [sym__term3] = STATE(3805),
    [aux_sym__term4] = STATE(1217),
    [sym__infix_app_or_boolean_op] = STATE(3775),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6714),
    [sym__wordy_definition_name] = STATE(6714),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2029),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(789),
    [sym_literal_hex] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(2043),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_path] = ACTIONS(3758),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2049),
    [sym_built_in_hash] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1284] = {
    [sym_literal_function2] = STATE(3645),
    [sym__term] = STATE(3604),
    [sym__term2] = STATE(3645),
    [sym__term3] = STATE(3650),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2751),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2354),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6764),
    [sym__wordy_definition_name] = STATE(6764),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3503),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1285] = {
    [sym_literal_function2] = STATE(3906),
    [sym__term] = STATE(3798),
    [sym__term2] = STATE(3906),
    [sym__term3] = STATE(3907),
    [aux_sym__term4] = STATE(1211),
    [sym__infix_app_or_boolean_op] = STATE(3638),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6727),
    [sym__wordy_definition_name] = STATE(6727),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1286] = {
    [aux_sym__term4] = STATE(1280),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_wordy_id] = STATE(2329),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym_nat] = ACTIONS(3760),
    [sym_int] = ACTIONS(3760),
    [sym_float] = ACTIONS(3760),
    [anon_sym_DQUOTE] = ACTIONS(3763),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3766),
    [aux_sym_literal_char_token1] = ACTIONS(3769),
    [aux_sym_literal_char_token2] = ACTIONS(3769),
    [anon_sym_true] = ACTIONS(3772),
    [anon_sym_false] = ACTIONS(3772),
    [sym_literal_byte] = ACTIONS(3760),
    [sym_literal_hex] = ACTIONS(3760),
    [anon_sym_LPAREN] = ACTIONS(3775),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3778),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3781),
    [anon_sym_BANG] = ACTIONS(3784),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(3787),
    [sym_kw_let] = ACTIONS(3790),
    [sym_match] = ACTIONS(3793),
    [sym_cases] = ACTIONS(3796),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3799),
    [sym_kw_typelink] = ACTIONS(3802),
    [sym_handle] = ACTIONS(3805),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(3808),
    [aux_sym_wordy_id_token1] = ACTIONS(3811),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3814),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3817),
    [sym_built_in_hash] = ACTIONS(3820),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3823),
    [sym_doc_block] = ACTIONS(3826),
  },
  [1287] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6374),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1288] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6290),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1289] = {
    [sym_literal_function2] = STATE(1739),
    [sym__term] = STATE(1634),
    [sym__term2] = STATE(1739),
    [sym__term3] = STATE(1740),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1574),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1468),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(6698),
    [sym__wordy_definition_name] = STATE(6698),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(3831),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1290] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6350),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1291] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6368),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1292] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6356),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1293] = {
    [sym_literal_function2] = STATE(1904),
    [sym__term] = STATE(1821),
    [sym__term2] = STATE(1904),
    [sym__term3] = STATE(1910),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1587),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1468),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(6807),
    [sym__wordy_definition_name] = STATE(6807),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(3831),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1294] = {
    [sym_literal_function2] = STATE(4284),
    [sym__term] = STATE(4338),
    [sym__term2] = STATE(4284),
    [sym__term3] = STATE(4282),
    [aux_sym__term4] = STATE(1226),
    [sym__infix_app_or_boolean_op] = STATE(3804),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2828),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(6760),
    [sym__wordy_definition_name] = STATE(6760),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(3493),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1295] = {
    [sym_literal_function2] = STATE(5643),
    [sym__term] = STATE(6821),
    [sym__term2] = STATE(5643),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1223),
    [sym__infix_app_or_boolean_op] = STATE(6184),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6900),
    [sym__wordy_definition_name] = STATE(6900),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1296] = {
    [sym_literal_function2] = STATE(2167),
    [sym__term] = STATE(2204),
    [sym__term2] = STATE(2167),
    [sym__term3] = STATE(2166),
    [aux_sym__term4] = STATE(579),
    [sym__infix_app_or_boolean_op] = STATE(1960),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6547),
    [sym__wordy_definition_name] = STATE(6547),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1297] = {
    [sym_literal_function2] = STATE(5123),
    [sym__term] = STATE(5090),
    [sym__term2] = STATE(5123),
    [sym__term3] = STATE(5122),
    [aux_sym__term4] = STATE(612),
    [sym__infix_app_or_boolean_op] = STATE(5033),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6950),
    [sym__wordy_definition_name] = STATE(6950),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1298] = {
    [sym_literal_function2] = STATE(5691),
    [sym__term] = STATE(6365),
    [sym__term2] = STATE(5691),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2029),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(789),
    [sym_literal_hex] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(2043),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_path] = ACTIONS(3758),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2049),
    [sym_built_in_hash] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1299] = {
    [sym_literal_function2] = STATE(1925),
    [sym__term2] = STATE(1925),
    [sym__term3] = STATE(1910),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1587),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1468),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(6807),
    [sym__wordy_definition_name] = STATE(6807),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(3831),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1300] = {
    [sym_literal_function2] = STATE(2911),
    [sym__term2] = STATE(2911),
    [sym__term3] = STATE(2931),
    [aux_sym__term4] = STATE(1193),
    [sym__infix_app_or_boolean_op] = STATE(2790),
    [sym_literal_text] = STATE(2948),
    [sym_literal_char] = STATE(2948),
    [sym_literal_boolean] = STATE(2948),
    [sym_tuple_or_parenthesized] = STATE(2948),
    [sym_literal_termlink] = STATE(2948),
    [sym_literal_typelink] = STATE(2948),
    [sym__pattern_matching] = STATE(2952),
    [sym__match_with] = STATE(2950),
    [sym__lam_case] = STATE(2952),
    [sym_kw_if] = STATE(7124),
    [sym_delay_quote] = STATE(2948),
    [sym_delay_block] = STATE(2948),
    [sym_bang] = STATE(2948),
    [sym__number] = STATE(2948),
    [sym__link] = STATE(2948),
    [sym__term_leaf] = STATE(2948),
    [sym_literal_list] = STATE(2948),
    [sym__keyword_block] = STATE(2947),
    [sym_exp_if] = STATE(2947),
    [sym_force] = STATE(2948),
    [sym_exp_let] = STATE(2947),
    [sym_handler] = STATE(2947),
    [sym_rewrite_block] = STATE(2947),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2296),
    [sym_hash_qualifier] = STATE(2707),
    [sym__hq_qualified_wordy_id] = STATE(2707),
    [sym__hq_qualified_prefix_term] = STATE(2845),
    [sym__prefix_definition_name] = STATE(6738),
    [sym__wordy_definition_name] = STATE(6738),
    [sym_nat] = ACTIONS(483),
    [sym_int] = ACTIONS(483),
    [sym_float] = ACTIONS(483),
    [anon_sym_DQUOTE] = ACTIONS(485),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1491),
    [aux_sym_literal_char_token1] = ACTIONS(489),
    [aux_sym_literal_char_token2] = ACTIONS(1493),
    [anon_sym_true] = ACTIONS(491),
    [anon_sym_false] = ACTIONS(491),
    [sym_literal_byte] = ACTIONS(529),
    [sym_literal_hex] = ACTIONS(529),
    [anon_sym_LPAREN] = ACTIONS(3606),
    [anon_sym_LBRACK] = ACTIONS(1497),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1499),
    [anon_sym_BANG] = ACTIONS(499),
    [sym_do] = ACTIONS(501),
    [sym_kw_let] = ACTIONS(503),
    [sym_match] = ACTIONS(505),
    [sym_cases] = ACTIONS(507),
    [sym_kw_termlink] = ACTIONS(509),
    [sym_kw_typelink] = ACTIONS(511),
    [sym_handle] = ACTIONS(513),
    [sym_rewrite] = ACTIONS(1501),
    [aux_sym_wordy_id_token1] = ACTIONS(517),
    [sym_path] = ACTIONS(3608),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1503),
    [sym_built_in_hash] = ACTIONS(527),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(527),
    [sym_doc_block] = ACTIONS(529),
  },
  [1301] = {
    [sym_literal_function2] = STATE(6097),
    [sym__term2] = STATE(6097),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1203),
    [sym__infix_app_or_boolean_op] = STATE(5579),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6998),
    [sym__wordy_definition_name] = STATE(6998),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2029),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(789),
    [sym_literal_hex] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(2043),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_path] = ACTIONS(3758),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2049),
    [sym_built_in_hash] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1302] = {
    [sym_literal_function2] = STATE(2435),
    [sym__term2] = STATE(2435),
    [sym__term3] = STATE(2431),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(2432),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6684),
    [sym__wordy_definition_name] = STATE(6684),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1303] = {
    [sym_literal_function2] = STATE(6097),
    [sym__term2] = STATE(6097),
    [sym__term3] = STATE(5680),
    [aux_sym__term4] = STATE(1202),
    [sym__infix_app_or_boolean_op] = STATE(5574),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6995),
    [sym__wordy_definition_name] = STATE(6995),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1304] = {
    [aux_sym__term4] = STATE(1315),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [anon_sym_DASH_GT] = ACTIONS(1871),
    [sym_nat] = ACTIONS(3833),
    [sym_int] = ACTIONS(3833),
    [sym_float] = ACTIONS(3833),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [aux_sym_literal_char_token1] = ACTIONS(3842),
    [aux_sym_literal_char_token2] = ACTIONS(3842),
    [anon_sym_true] = ACTIONS(3845),
    [anon_sym_false] = ACTIONS(3845),
    [sym_literal_byte] = ACTIONS(3833),
    [sym_literal_hex] = ACTIONS(3833),
    [anon_sym_LPAREN] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(3854),
    [anon_sym_BANG] = ACTIONS(3857),
    [sym_do] = ACTIONS(3860),
    [sym_kw_let] = ACTIONS(3863),
    [sym_match] = ACTIONS(3866),
    [sym_cases] = ACTIONS(3869),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3872),
    [sym_kw_typelink] = ACTIONS(3875),
    [sym_handle] = ACTIONS(3878),
    [sym_rewrite] = ACTIONS(3881),
    [aux_sym_wordy_id_token1] = ACTIONS(3884),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3887),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3890),
    [sym_built_in_hash] = ACTIONS(3893),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3896),
    [sym_doc_block] = ACTIONS(3899),
  },
  [1305] = {
    [sym_literal_function2] = STATE(3943),
    [sym__term2] = STATE(3943),
    [sym__term3] = STATE(3907),
    [aux_sym__term4] = STATE(1211),
    [sym__infix_app_or_boolean_op] = STATE(3638),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2472),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym__prefix_definition_name] = STATE(6727),
    [sym__wordy_definition_name] = STATE(6727),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2227),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2231),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2235),
    [sym_literal_hex] = ACTIONS(2235),
    [anon_sym_LPAREN] = ACTIONS(3497),
    [anon_sym_LBRACK] = ACTIONS(2239),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2241),
    [anon_sym_BANG] = ACTIONS(2243),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_rewrite] = ACTIONS(2259),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_path] = ACTIONS(3499),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2265),
    [sym_built_in_hash] = ACTIONS(2267),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1306] = {
    [sym_literal_function2] = STATE(2012),
    [sym__term2] = STATE(2012),
    [sym__term3] = STATE(2029),
    [aux_sym__term4] = STATE(579),
    [sym__infix_app_or_boolean_op] = STATE(1965),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6746),
    [sym__wordy_definition_name] = STATE(6746),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1307] = {
    [aux_sym__term4] = STATE(1236),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_wordy_id] = STATE(2261),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(389),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(391),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(385),
    [sym_literal_hex] = ACTIONS(385),
    [anon_sym_LPAREN] = ACTIONS(2985),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(397),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(399),
    [anon_sym_BANG] = ACTIONS(401),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(417),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3474),
    [aux_sym_hash_qualifier_token1] = ACTIONS(423),
    [sym_built_in_hash] = ACTIONS(425),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1308] = {
    [sym_literal_function2] = STATE(1792),
    [sym__term2] = STATE(1792),
    [sym__term3] = STATE(1740),
    [aux_sym__term4] = STATE(277),
    [sym__infix_app_or_boolean_op] = STATE(1574),
    [sym_literal_text] = STATE(1732),
    [sym_literal_char] = STATE(1732),
    [sym_literal_boolean] = STATE(1732),
    [sym_tuple_or_parenthesized] = STATE(1732),
    [sym_literal_termlink] = STATE(1732),
    [sym_literal_typelink] = STATE(1732),
    [sym__pattern_matching] = STATE(1725),
    [sym__match_with] = STATE(1727),
    [sym__lam_case] = STATE(1725),
    [sym_kw_if] = STATE(7121),
    [sym_delay_quote] = STATE(1732),
    [sym_delay_block] = STATE(1732),
    [sym_bang] = STATE(1732),
    [sym__number] = STATE(1732),
    [sym__link] = STATE(1732),
    [sym__term_leaf] = STATE(1732),
    [sym_literal_list] = STATE(1732),
    [sym__keyword_block] = STATE(1733),
    [sym_exp_if] = STATE(1733),
    [sym_force] = STATE(1732),
    [sym_exp_let] = STATE(1733),
    [sym_handler] = STATE(1733),
    [sym_rewrite_block] = STATE(1733),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1468),
    [sym_hash_qualifier] = STATE(1557),
    [sym__hq_qualified_wordy_id] = STATE(1557),
    [sym__hq_qualified_prefix_term] = STATE(1566),
    [sym__prefix_definition_name] = STATE(6698),
    [sym__wordy_definition_name] = STATE(6698),
    [sym_nat] = ACTIONS(31),
    [sym_int] = ACTIONS(31),
    [sym_float] = ACTIONS(31),
    [anon_sym_DQUOTE] = ACTIONS(33),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1505),
    [aux_sym_literal_char_token1] = ACTIONS(37),
    [aux_sym_literal_char_token2] = ACTIONS(1507),
    [anon_sym_true] = ACTIONS(39),
    [anon_sym_false] = ACTIONS(39),
    [sym_literal_byte] = ACTIONS(81),
    [sym_literal_hex] = ACTIONS(81),
    [anon_sym_LPAREN] = ACTIONS(3829),
    [anon_sym_LBRACK] = ACTIONS(1511),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1513),
    [anon_sym_BANG] = ACTIONS(51),
    [sym_do] = ACTIONS(53),
    [sym_kw_let] = ACTIONS(55),
    [sym_match] = ACTIONS(57),
    [sym_cases] = ACTIONS(59),
    [sym_kw_termlink] = ACTIONS(61),
    [sym_kw_typelink] = ACTIONS(63),
    [sym_handle] = ACTIONS(65),
    [sym_rewrite] = ACTIONS(1515),
    [aux_sym_wordy_id_token1] = ACTIONS(69),
    [sym_path] = ACTIONS(3831),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1517),
    [sym_built_in_hash] = ACTIONS(79),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(79),
    [sym_doc_block] = ACTIONS(81),
  },
  [1309] = {
    [sym_literal_function2] = STATE(4333),
    [sym__term2] = STATE(4333),
    [sym__term3] = STATE(4348),
    [aux_sym__term4] = STATE(1224),
    [sym__infix_app_or_boolean_op] = STATE(4034),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6754),
    [sym__wordy_definition_name] = STATE(6754),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1310] = {
    [sym_literal_function2] = STATE(3679),
    [sym__term2] = STATE(3679),
    [sym__term3] = STATE(3650),
    [aux_sym__term4] = STATE(1185),
    [sym__infix_app_or_boolean_op] = STATE(3119),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6589),
    [sym__wordy_definition_name] = STATE(6589),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1311] = {
    [aux_sym__term4] = STATE(1280),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_wordy_id] = STATE(2329),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(555),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(557),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(551),
    [sym_literal_hex] = ACTIONS(551),
    [anon_sym_LPAREN] = ACTIONS(3062),
    [anon_sym_LBRACK] = ACTIONS(563),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(565),
    [anon_sym_BANG] = ACTIONS(567),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(583),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3814),
    [aux_sym_hash_qualifier_token1] = ACTIONS(589),
    [sym_built_in_hash] = ACTIONS(591),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1312] = {
    [sym_literal_function2] = STATE(4475),
    [sym__term2] = STATE(4475),
    [sym__term3] = STATE(4498),
    [aux_sym__term4] = STATE(1224),
    [sym__infix_app_or_boolean_op] = STATE(4027),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6642),
    [sym__wordy_definition_name] = STATE(6642),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1313] = {
    [sym_literal_function2] = STATE(3404),
    [sym__term2] = STATE(3404),
    [sym__term3] = STATE(3379),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(2776),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6525),
    [sym__wordy_definition_name] = STATE(6525),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1314] = {
    [sym_literal_function2] = STATE(5539),
    [sym__term2] = STATE(5539),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1214),
    [sym__infix_app_or_boolean_op] = STATE(5637),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6791),
    [sym__wordy_definition_name] = STATE(6791),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1315] = {
    [aux_sym__term4] = STATE(1315),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [anon_sym_DASH_GT] = ACTIONS(1795),
    [sym_nat] = ACTIONS(3902),
    [sym_int] = ACTIONS(3902),
    [sym_float] = ACTIONS(3902),
    [anon_sym_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [aux_sym_literal_char_token1] = ACTIONS(3911),
    [aux_sym_literal_char_token2] = ACTIONS(3911),
    [anon_sym_true] = ACTIONS(3914),
    [anon_sym_false] = ACTIONS(3914),
    [sym_literal_byte] = ACTIONS(3902),
    [sym_literal_hex] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3920),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3923),
    [anon_sym_BANG] = ACTIONS(3926),
    [sym_do] = ACTIONS(3929),
    [sym_kw_let] = ACTIONS(3932),
    [sym_match] = ACTIONS(3935),
    [sym_cases] = ACTIONS(3938),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3941),
    [sym_kw_typelink] = ACTIONS(3944),
    [sym_handle] = ACTIONS(3947),
    [sym_rewrite] = ACTIONS(3950),
    [aux_sym_wordy_id_token1] = ACTIONS(3953),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3956),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3959),
    [sym_built_in_hash] = ACTIONS(3962),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3965),
    [sym_doc_block] = ACTIONS(3968),
  },
  [1316] = {
    [sym_literal_function2] = STATE(3615),
    [sym__term2] = STATE(3615),
    [sym__term3] = STATE(3598),
    [aux_sym__term4] = STATE(1219),
    [sym__infix_app_or_boolean_op] = STATE(3599),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2565),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6567),
    [sym__wordy_definition_name] = STATE(6567),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1283),
    [anon_sym_BANG] = ACTIONS(1285),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3279),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1317] = {
    [sym_literal_function2] = STATE(4251),
    [sym__term2] = STATE(4251),
    [sym__term3] = STATE(4282),
    [aux_sym__term4] = STATE(1226),
    [sym__infix_app_or_boolean_op] = STATE(3804),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2828),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(6760),
    [sym__wordy_definition_name] = STATE(6760),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(3493),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1318] = {
    [sym_literal_function2] = STATE(5606),
    [sym__term2] = STATE(5606),
    [sym__term3] = STATE(5601),
    [aux_sym__term4] = STATE(1196),
    [sym__infix_app_or_boolean_op] = STATE(5467),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2199),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6744),
    [sym__wordy_definition_name] = STATE(6744),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1475),
    [anon_sym_BANG] = ACTIONS(401),
    [sym_do] = ACTIONS(403),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(415),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3616),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1319] = {
    [aux_sym__term4] = STATE(1319),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_wordy_id] = STATE(2458),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym_nat] = ACTIONS(3971),
    [sym_int] = ACTIONS(3971),
    [sym_float] = ACTIONS(3971),
    [anon_sym_DQUOTE] = ACTIONS(3974),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3977),
    [aux_sym_literal_char_token1] = ACTIONS(3980),
    [aux_sym_literal_char_token2] = ACTIONS(3980),
    [anon_sym_true] = ACTIONS(3983),
    [anon_sym_false] = ACTIONS(3983),
    [sym_literal_byte] = ACTIONS(3971),
    [sym_literal_hex] = ACTIONS(3971),
    [anon_sym_LPAREN] = ACTIONS(3986),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3989),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(3992),
    [anon_sym_BANG] = ACTIONS(3995),
    [sym_do] = ACTIONS(3998),
    [sym_kw_let] = ACTIONS(4001),
    [sym_match] = ACTIONS(4004),
    [sym_cases] = ACTIONS(4007),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(4010),
    [sym_kw_typelink] = ACTIONS(4013),
    [sym_handle] = ACTIONS(4016),
    [sym_with] = ACTIONS(1795),
    [sym_rewrite] = ACTIONS(4019),
    [aux_sym_wordy_id_token1] = ACTIONS(4022),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(4025),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4028),
    [sym_built_in_hash] = ACTIONS(4031),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4034),
    [sym_doc_block] = ACTIONS(4037),
  },
  [1320] = {
    [sym_literal_function2] = STATE(3679),
    [sym__term2] = STATE(3679),
    [sym__term3] = STATE(3650),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2751),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2354),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6764),
    [sym__wordy_definition_name] = STATE(6764),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3503),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1321] = {
    [sym_literal_function2] = STATE(4631),
    [sym__term2] = STATE(4631),
    [sym__term3] = STATE(4628),
    [aux_sym__term4] = STATE(1225),
    [sym__infix_app_or_boolean_op] = STATE(4035),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2910),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6768),
    [sym__wordy_definition_name] = STATE(6768),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3614),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1322] = {
    [sym_literal_function2] = STATE(5606),
    [sym__term2] = STATE(5606),
    [sym__term3] = STATE(5601),
    [aux_sym__term4] = STATE(1195),
    [sym__infix_app_or_boolean_op] = STATE(5488),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6671),
    [sym__wordy_definition_name] = STATE(6671),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1323] = {
    [sym_literal_function2] = STATE(2435),
    [sym__term2] = STATE(2435),
    [sym__term3] = STATE(2431),
    [aux_sym__term4] = STATE(1191),
    [sym__infix_app_or_boolean_op] = STATE(2746),
    [sym_literal_text] = STATE(2392),
    [sym_literal_char] = STATE(2392),
    [sym_literal_boolean] = STATE(2392),
    [sym_tuple_or_parenthesized] = STATE(2392),
    [sym_literal_termlink] = STATE(2392),
    [sym_literal_typelink] = STATE(2392),
    [sym__pattern_matching] = STATE(2614),
    [sym__match_with] = STATE(2610),
    [sym__lam_case] = STATE(2614),
    [sym_kw_if] = STATE(7117),
    [sym_delay_quote] = STATE(2392),
    [sym_delay_block] = STATE(2392),
    [sym_bang] = STATE(2392),
    [sym__number] = STATE(2392),
    [sym__link] = STATE(2392),
    [sym__term_leaf] = STATE(2392),
    [sym_literal_list] = STATE(2392),
    [sym__keyword_block] = STATE(2615),
    [sym_exp_if] = STATE(2615),
    [sym_force] = STATE(2392),
    [sym_exp_let] = STATE(2615),
    [sym_handler] = STATE(2615),
    [sym_rewrite_block] = STATE(2615),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2354),
    [sym_hash_qualifier] = STATE(2384),
    [sym__hq_qualified_wordy_id] = STATE(2384),
    [sym__hq_qualified_prefix_term] = STATE(2336),
    [sym__prefix_definition_name] = STATE(6769),
    [sym__wordy_definition_name] = STATE(6769),
    [sym_nat] = ACTIONS(385),
    [sym_int] = ACTIONS(385),
    [sym_float] = ACTIONS(385),
    [anon_sym_DQUOTE] = ACTIONS(387),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1431),
    [aux_sym_literal_char_token1] = ACTIONS(391),
    [aux_sym_literal_char_token2] = ACTIONS(1433),
    [anon_sym_true] = ACTIONS(393),
    [anon_sym_false] = ACTIONS(393),
    [sym_literal_byte] = ACTIONS(431),
    [sym_literal_hex] = ACTIONS(431),
    [anon_sym_LPAREN] = ACTIONS(3501),
    [anon_sym_LBRACK] = ACTIONS(1437),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1439),
    [anon_sym_BANG] = ACTIONS(533),
    [sym_do] = ACTIONS(535),
    [sym_kw_let] = ACTIONS(405),
    [sym_match] = ACTIONS(407),
    [sym_cases] = ACTIONS(409),
    [sym_kw_termlink] = ACTIONS(411),
    [sym_kw_typelink] = ACTIONS(413),
    [sym_handle] = ACTIONS(537),
    [sym_rewrite] = ACTIONS(1441),
    [aux_sym_wordy_id_token1] = ACTIONS(419),
    [sym_path] = ACTIONS(3503),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1443),
    [sym_built_in_hash] = ACTIONS(429),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(429),
    [sym_doc_block] = ACTIONS(431),
  },
  [1324] = {
    [sym_literal_function2] = STATE(5075),
    [sym__term2] = STATE(5075),
    [sym__term3] = STATE(5122),
    [aux_sym__term4] = STATE(612),
    [sym__infix_app_or_boolean_op] = STATE(5033),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6950),
    [sym__wordy_definition_name] = STATE(6950),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1325] = {
    [sym_literal_function2] = STATE(3167),
    [sym__term2] = STATE(3167),
    [sym__term3] = STATE(3253),
    [aux_sym__term4] = STATE(1188),
    [sym__infix_app_or_boolean_op] = STATE(2752),
    [sym_literal_text] = STATE(3205),
    [sym_literal_char] = STATE(3205),
    [sym_literal_boolean] = STATE(3205),
    [sym_tuple_or_parenthesized] = STATE(3205),
    [sym_literal_termlink] = STATE(3205),
    [sym_literal_typelink] = STATE(3205),
    [sym__pattern_matching] = STATE(3203),
    [sym__match_with] = STATE(3204),
    [sym__lam_case] = STATE(3203),
    [sym_kw_if] = STATE(7122),
    [sym_delay_quote] = STATE(3205),
    [sym_delay_block] = STATE(3205),
    [sym_bang] = STATE(3205),
    [sym__number] = STATE(3205),
    [sym__link] = STATE(3205),
    [sym__term_leaf] = STATE(3205),
    [sym_literal_list] = STATE(3205),
    [sym__keyword_block] = STATE(3206),
    [sym_exp_if] = STATE(3206),
    [sym_force] = STATE(3205),
    [sym_exp_let] = STATE(3206),
    [sym_handler] = STATE(3206),
    [sym_rewrite_block] = STATE(3206),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2308),
    [sym_hash_qualifier] = STATE(2824),
    [sym__hq_qualified_wordy_id] = STATE(2824),
    [sym__hq_qualified_prefix_term] = STATE(2662),
    [sym__prefix_definition_name] = STATE(6613),
    [sym__wordy_definition_name] = STATE(6613),
    [sym_nat] = ACTIONS(551),
    [sym_int] = ACTIONS(551),
    [sym_float] = ACTIONS(551),
    [anon_sym_DQUOTE] = ACTIONS(553),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(1445),
    [aux_sym_literal_char_token1] = ACTIONS(557),
    [aux_sym_literal_char_token2] = ACTIONS(1447),
    [anon_sym_true] = ACTIONS(559),
    [anon_sym_false] = ACTIONS(559),
    [sym_literal_byte] = ACTIONS(597),
    [sym_literal_hex] = ACTIONS(597),
    [anon_sym_LPAREN] = ACTIONS(3574),
    [anon_sym_LBRACK] = ACTIONS(1451),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1453),
    [anon_sym_BANG] = ACTIONS(567),
    [sym_do] = ACTIONS(569),
    [sym_kw_let] = ACTIONS(571),
    [sym_match] = ACTIONS(573),
    [sym_cases] = ACTIONS(575),
    [sym_kw_termlink] = ACTIONS(577),
    [sym_kw_typelink] = ACTIONS(579),
    [sym_handle] = ACTIONS(581),
    [sym_rewrite] = ACTIONS(1455),
    [aux_sym_wordy_id_token1] = ACTIONS(585),
    [sym_path] = ACTIONS(3576),
    [aux_sym_hash_qualifier_token1] = ACTIONS(1457),
    [sym_built_in_hash] = ACTIONS(595),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(595),
    [sym_doc_block] = ACTIONS(597),
  },
  [1326] = {
    [sym_literal_function2] = STATE(3615),
    [sym__term2] = STATE(3615),
    [sym__term3] = STATE(3598),
    [aux_sym__term4] = STATE(1225),
    [sym__infix_app_or_boolean_op] = STATE(4017),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2910),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym__prefix_definition_name] = STATE(6770),
    [sym__wordy_definition_name] = STATE(6770),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2201),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2205),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1271),
    [sym_literal_hex] = ACTIONS(1271),
    [anon_sym_LPAREN] = ACTIONS(3275),
    [anon_sym_LBRACK] = ACTIONS(2211),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2331),
    [anon_sym_BANG] = ACTIONS(2333),
    [sym_do] = ACTIONS(2335),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(2337),
    [sym_rewrite] = ACTIONS(1301),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_path] = ACTIONS(3614),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2215),
    [sym_built_in_hash] = ACTIONS(2217),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1327] = {
    [sym_literal_function2] = STATE(5539),
    [sym__term2] = STATE(5539),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1223),
    [sym__infix_app_or_boolean_op] = STATE(6184),
    [sym_literal_text] = STATE(4347),
    [sym_literal_char] = STATE(4347),
    [sym_literal_boolean] = STATE(4347),
    [sym_tuple_or_parenthesized] = STATE(4347),
    [sym_literal_termlink] = STATE(4347),
    [sym_literal_typelink] = STATE(4347),
    [sym__pattern_matching] = STATE(4345),
    [sym__match_with] = STATE(4346),
    [sym__lam_case] = STATE(4345),
    [sym_kw_if] = STATE(7119),
    [sym_delay_quote] = STATE(4347),
    [sym_delay_block] = STATE(4347),
    [sym_bang] = STATE(4347),
    [sym__number] = STATE(4347),
    [sym__link] = STATE(4347),
    [sym__term_leaf] = STATE(4347),
    [sym_literal_list] = STATE(4347),
    [sym__keyword_block] = STATE(4352),
    [sym_exp_if] = STATE(4352),
    [sym_force] = STATE(4347),
    [sym_exp_let] = STATE(4352),
    [sym_handler] = STATE(4352),
    [sym_rewrite_block] = STATE(4352),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2643),
    [sym_hash_qualifier] = STATE(4031),
    [sym__hq_qualified_wordy_id] = STATE(4031),
    [sym__hq_qualified_prefix_term] = STATE(3823),
    [sym__prefix_definition_name] = STATE(6900),
    [sym__wordy_definition_name] = STATE(6900),
    [sym_nat] = ACTIONS(2133),
    [sym_int] = ACTIONS(2133),
    [sym_float] = ACTIONS(2133),
    [anon_sym_DQUOTE] = ACTIONS(2135),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2137),
    [aux_sym_literal_char_token1] = ACTIONS(2139),
    [aux_sym_literal_char_token2] = ACTIONS(2141),
    [anon_sym_true] = ACTIONS(2143),
    [anon_sym_false] = ACTIONS(2143),
    [sym_literal_byte] = ACTIONS(2145),
    [sym_literal_hex] = ACTIONS(2145),
    [anon_sym_LPAREN] = ACTIONS(3610),
    [anon_sym_LBRACK] = ACTIONS(2149),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2151),
    [anon_sym_BANG] = ACTIONS(2153),
    [sym_do] = ACTIONS(2155),
    [sym_kw_let] = ACTIONS(2157),
    [sym_match] = ACTIONS(2159),
    [sym_cases] = ACTIONS(2161),
    [sym_kw_termlink] = ACTIONS(2163),
    [sym_kw_typelink] = ACTIONS(2165),
    [sym_handle] = ACTIONS(2167),
    [sym_rewrite] = ACTIONS(2169),
    [aux_sym_wordy_id_token1] = ACTIONS(2017),
    [sym_path] = ACTIONS(3612),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2173),
    [sym_built_in_hash] = ACTIONS(2175),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2175),
    [sym_doc_block] = ACTIONS(2145),
  },
  [1328] = {
    [aux_sym__term4] = STATE(1319),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_wordy_id] = STATE(2458),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym_nat] = ACTIONS(4040),
    [sym_int] = ACTIONS(4040),
    [sym_float] = ACTIONS(4040),
    [anon_sym_DQUOTE] = ACTIONS(4043),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4046),
    [aux_sym_literal_char_token1] = ACTIONS(4049),
    [aux_sym_literal_char_token2] = ACTIONS(4049),
    [anon_sym_true] = ACTIONS(4052),
    [anon_sym_false] = ACTIONS(4052),
    [sym_literal_byte] = ACTIONS(4040),
    [sym_literal_hex] = ACTIONS(4040),
    [anon_sym_LPAREN] = ACTIONS(4055),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(4058),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(4061),
    [anon_sym_BANG] = ACTIONS(4064),
    [sym_do] = ACTIONS(4067),
    [sym_kw_let] = ACTIONS(4070),
    [sym_match] = ACTIONS(4073),
    [sym_cases] = ACTIONS(4076),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(4079),
    [sym_kw_typelink] = ACTIONS(4082),
    [sym_handle] = ACTIONS(4085),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(4088),
    [aux_sym_wordy_id_token1] = ACTIONS(4091),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4094),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4097),
    [sym_built_in_hash] = ACTIONS(4100),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4103),
    [sym_doc_block] = ACTIONS(4106),
  },
  [1329] = {
    [sym_literal_function2] = STATE(5539),
    [sym__term2] = STATE(5539),
    [sym__term3] = STATE(5640),
    [aux_sym__term4] = STATE(1227),
    [sym__infix_app_or_boolean_op] = STATE(6185),
    [sym_literal_text] = STATE(4182),
    [sym_literal_char] = STATE(4182),
    [sym_literal_boolean] = STATE(4182),
    [sym_tuple_or_parenthesized] = STATE(4182),
    [sym_literal_termlink] = STATE(4182),
    [sym_literal_typelink] = STATE(4182),
    [sym__pattern_matching] = STATE(4184),
    [sym__match_with] = STATE(4183),
    [sym__lam_case] = STATE(4184),
    [sym_kw_if] = STATE(7120),
    [sym_delay_quote] = STATE(4182),
    [sym_delay_block] = STATE(4182),
    [sym_bang] = STATE(4182),
    [sym__number] = STATE(4182),
    [sym__link] = STATE(4182),
    [sym__term_leaf] = STATE(4182),
    [sym_literal_list] = STATE(4182),
    [sym__keyword_block] = STATE(4181),
    [sym_exp_if] = STATE(4181),
    [sym_force] = STATE(4182),
    [sym_exp_let] = STATE(4181),
    [sym_handler] = STATE(4181),
    [sym_rewrite_block] = STATE(4181),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2828),
    [sym_hash_qualifier] = STATE(3813),
    [sym__hq_qualified_wordy_id] = STATE(3813),
    [sym__hq_qualified_prefix_term] = STATE(4032),
    [sym__prefix_definition_name] = STATE(6851),
    [sym__wordy_definition_name] = STATE(6851),
    [sym_nat] = ACTIONS(2081),
    [sym_int] = ACTIONS(2081),
    [sym_float] = ACTIONS(2081),
    [anon_sym_DQUOTE] = ACTIONS(2083),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2085),
    [aux_sym_literal_char_token1] = ACTIONS(2087),
    [aux_sym_literal_char_token2] = ACTIONS(2089),
    [anon_sym_true] = ACTIONS(2091),
    [anon_sym_false] = ACTIONS(2091),
    [sym_literal_byte] = ACTIONS(2093),
    [sym_literal_hex] = ACTIONS(2093),
    [anon_sym_LPAREN] = ACTIONS(3491),
    [anon_sym_LBRACK] = ACTIONS(2097),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2099),
    [anon_sym_BANG] = ACTIONS(2101),
    [sym_do] = ACTIONS(2103),
    [sym_kw_let] = ACTIONS(2105),
    [sym_match] = ACTIONS(2107),
    [sym_cases] = ACTIONS(2109),
    [sym_kw_termlink] = ACTIONS(2111),
    [sym_kw_typelink] = ACTIONS(2113),
    [sym_handle] = ACTIONS(2115),
    [sym_rewrite] = ACTIONS(2117),
    [aux_sym_wordy_id_token1] = ACTIONS(2119),
    [sym_path] = ACTIONS(3493),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2123),
    [sym_built_in_hash] = ACTIONS(2125),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2125),
    [sym_doc_block] = ACTIONS(2093),
  },
  [1330] = {
    [sym_literal_function2] = STATE(3792),
    [sym__term2] = STATE(3792),
    [sym__term3] = STATE(3805),
    [aux_sym__term4] = STATE(1217),
    [sym__infix_app_or_boolean_op] = STATE(3775),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(2532),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym__prefix_definition_name] = STATE(6714),
    [sym__wordy_definition_name] = STATE(6714),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2029),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2033),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(789),
    [sym_literal_hex] = ACTIONS(789),
    [anon_sym_LPAREN] = ACTIONS(3756),
    [anon_sym_LBRACK] = ACTIONS(2039),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2041),
    [anon_sym_BANG] = ACTIONS(757),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(2043),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_path] = ACTIONS(3758),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2049),
    [sym_built_in_hash] = ACTIONS(2051),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1331] = {
    [sym_literal_function2] = STATE(2126),
    [sym__term2] = STATE(2126),
    [sym__term3] = STATE(2166),
    [aux_sym__term4] = STATE(579),
    [sym__infix_app_or_boolean_op] = STATE(1960),
    [sym_literal_text] = STATE(2056),
    [sym_literal_char] = STATE(2056),
    [sym_literal_boolean] = STATE(2056),
    [sym_tuple_or_parenthesized] = STATE(2056),
    [sym_literal_termlink] = STATE(2056),
    [sym_literal_typelink] = STATE(2056),
    [sym__pattern_matching] = STATE(2054),
    [sym__match_with] = STATE(2055),
    [sym__lam_case] = STATE(2054),
    [sym_kw_if] = STATE(7116),
    [sym_delay_quote] = STATE(2056),
    [sym_delay_block] = STATE(2056),
    [sym_bang] = STATE(2056),
    [sym__number] = STATE(2056),
    [sym__link] = STATE(2056),
    [sym__term_leaf] = STATE(2056),
    [sym_literal_list] = STATE(2056),
    [sym__keyword_block] = STATE(2057),
    [sym_exp_if] = STATE(2057),
    [sym_force] = STATE(2056),
    [sym_exp_let] = STATE(2057),
    [sym_handler] = STATE(2057),
    [sym_rewrite_block] = STATE(2057),
    [sym_open_parens] = STATE(6195),
    [sym_wordy_id] = STATE(1589),
    [sym_hash_qualifier] = STATE(1981),
    [sym__hq_qualified_wordy_id] = STATE(1981),
    [sym__hq_qualified_prefix_term] = STATE(1962),
    [sym__prefix_definition_name] = STATE(6547),
    [sym__wordy_definition_name] = STATE(6547),
    [sym_nat] = ACTIONS(1519),
    [sym_int] = ACTIONS(1519),
    [sym_float] = ACTIONS(1519),
    [anon_sym_DQUOTE] = ACTIONS(1521),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(2059),
    [aux_sym_literal_char_token1] = ACTIONS(1525),
    [aux_sym_literal_char_token2] = ACTIONS(2061),
    [anon_sym_true] = ACTIONS(1527),
    [anon_sym_false] = ACTIONS(1527),
    [sym_literal_byte] = ACTIONS(1565),
    [sym_literal_hex] = ACTIONS(1565),
    [anon_sym_LPAREN] = ACTIONS(3590),
    [anon_sym_LBRACK] = ACTIONS(2065),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(2067),
    [anon_sym_BANG] = ACTIONS(1535),
    [sym_do] = ACTIONS(1537),
    [sym_kw_let] = ACTIONS(1539),
    [sym_match] = ACTIONS(1541),
    [sym_cases] = ACTIONS(1543),
    [sym_kw_termlink] = ACTIONS(1547),
    [sym_kw_typelink] = ACTIONS(1549),
    [sym_handle] = ACTIONS(1551),
    [sym_rewrite] = ACTIONS(2069),
    [aux_sym_wordy_id_token1] = ACTIONS(1555),
    [sym_path] = ACTIONS(3592),
    [aux_sym_hash_qualifier_token1] = ACTIONS(2073),
    [sym_built_in_hash] = ACTIONS(1563),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(1563),
    [sym_doc_block] = ACTIONS(1565),
  },
  [1332] = {
    [aux_sym__term4] = STATE(1343),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_wordy_id] = STATE(2780),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym_nat] = ACTIONS(2223),
    [sym_int] = ACTIONS(2223),
    [sym_float] = ACTIONS(2223),
    [anon_sym_DQUOTE] = ACTIONS(2225),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3179),
    [aux_sym_literal_char_token1] = ACTIONS(2229),
    [aux_sym_literal_char_token2] = ACTIONS(2229),
    [anon_sym_true] = ACTIONS(2233),
    [anon_sym_false] = ACTIONS(2233),
    [sym_literal_byte] = ACTIONS(2223),
    [sym_literal_hex] = ACTIONS(2223),
    [anon_sym_LPAREN] = ACTIONS(3181),
    [anon_sym_LBRACK] = ACTIONS(3183),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3185),
    [anon_sym_BANG] = ACTIONS(2243),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(2245),
    [sym_kw_let] = ACTIONS(2247),
    [sym_match] = ACTIONS(2249),
    [sym_cases] = ACTIONS(2251),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(2253),
    [sym_kw_typelink] = ACTIONS(2255),
    [sym_handle] = ACTIONS(2257),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(3189),
    [aux_sym_wordy_id_token1] = ACTIONS(2261),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4109),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3193),
    [sym_built_in_hash] = ACTIONS(3195),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2267),
    [sym_doc_block] = ACTIONS(2235),
  },
  [1333] = {
    [aux_sym__term4] = STATE(1336),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym_nat] = ACTIONS(3833),
    [sym_int] = ACTIONS(3833),
    [sym_float] = ACTIONS(3833),
    [anon_sym_DQUOTE] = ACTIONS(3836),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3839),
    [aux_sym_literal_char_token1] = ACTIONS(3842),
    [aux_sym_literal_char_token2] = ACTIONS(3842),
    [anon_sym_true] = ACTIONS(3845),
    [anon_sym_false] = ACTIONS(3845),
    [sym_literal_byte] = ACTIONS(3833),
    [sym_literal_hex] = ACTIONS(3833),
    [anon_sym_LPAREN] = ACTIONS(3848),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3851),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(4112),
    [anon_sym_BANG] = ACTIONS(4115),
    [sym_do] = ACTIONS(4118),
    [sym_kw_let] = ACTIONS(3863),
    [sym_match] = ACTIONS(3866),
    [sym_cases] = ACTIONS(3869),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(3872),
    [sym_kw_typelink] = ACTIONS(3875),
    [sym_handle] = ACTIONS(4121),
    [sym_rewrite] = ACTIONS(3881),
    [aux_sym_wordy_id_token1] = ACTIONS(3884),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3887),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3890),
    [sym_built_in_hash] = ACTIONS(3893),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3896),
    [sym_doc_block] = ACTIONS(3899),
  },
  [1334] = {
    [aux_sym__term4] = STATE(1344),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_wordy_id] = STATE(2769),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym_nat] = ACTIONS(737),
    [sym_int] = ACTIONS(737),
    [sym_float] = ACTIONS(737),
    [anon_sym_DQUOTE] = ACTIONS(2027),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3165),
    [aux_sym_literal_char_token1] = ACTIONS(2031),
    [aux_sym_literal_char_token2] = ACTIONS(2031),
    [anon_sym_true] = ACTIONS(2035),
    [anon_sym_false] = ACTIONS(2035),
    [sym_literal_byte] = ACTIONS(737),
    [sym_literal_hex] = ACTIONS(737),
    [anon_sym_LPAREN] = ACTIONS(3197),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3169),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(755),
    [anon_sym_BANG] = ACTIONS(757),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(759),
    [sym_kw_let] = ACTIONS(761),
    [sym_match] = ACTIONS(763),
    [sym_cases] = ACTIONS(765),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(767),
    [sym_kw_typelink] = ACTIONS(769),
    [sym_handle] = ACTIONS(771),
    [sym_rewrite] = ACTIONS(773),
    [aux_sym_wordy_id_token1] = ACTIONS(2045),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4124),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3173),
    [sym_built_in_hash] = ACTIONS(3175),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2051),
    [sym_doc_block] = ACTIONS(789),
  },
  [1335] = {
    [aux_sym__term4] = STATE(1336),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym_nat] = ACTIONS(823),
    [sym_int] = ACTIONS(823),
    [sym_float] = ACTIONS(823),
    [anon_sym_DQUOTE] = ACTIONS(825),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(827),
    [aux_sym_literal_char_token1] = ACTIONS(829),
    [aux_sym_literal_char_token2] = ACTIONS(829),
    [anon_sym_true] = ACTIONS(831),
    [anon_sym_false] = ACTIONS(831),
    [sym_literal_byte] = ACTIONS(823),
    [sym_literal_hex] = ACTIONS(823),
    [anon_sym_LPAREN] = ACTIONS(3157),
    [anon_sym_SEMI] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(835),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(1045),
    [anon_sym_BANG] = ACTIONS(1047),
    [sym_do] = ACTIONS(1049),
    [sym_kw_let] = ACTIONS(843),
    [sym_match] = ACTIONS(845),
    [sym_cases] = ACTIONS(847),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(849),
    [sym_kw_typelink] = ACTIONS(851),
    [sym_handle] = ACTIONS(1051),
    [sym_rewrite] = ACTIONS(855),
    [aux_sym_wordy_id_token1] = ACTIONS(3161),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(3887),
    [aux_sym_hash_qualifier_token1] = ACTIONS(859),
    [sym_built_in_hash] = ACTIONS(861),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(865),
    [sym_doc_block] = ACTIONS(867),
  },
  [1336] = {
    [aux_sym__term4] = STATE(1336),
    [sym_literal_text] = STATE(3527),
    [sym_literal_char] = STATE(3527),
    [sym_literal_boolean] = STATE(3527),
    [sym_tuple_or_parenthesized] = STATE(3527),
    [sym_literal_termlink] = STATE(3527),
    [sym_literal_typelink] = STATE(3527),
    [sym__pattern_matching] = STATE(3529),
    [sym__match_with] = STATE(3528),
    [sym__lam_case] = STATE(3529),
    [sym_kw_if] = STATE(7114),
    [sym_delay_quote] = STATE(3527),
    [sym_delay_block] = STATE(3527),
    [sym_bang] = STATE(3527),
    [sym__number] = STATE(3527),
    [sym__link] = STATE(3527),
    [sym__term_leaf] = STATE(3527),
    [sym_literal_list] = STATE(3527),
    [sym__keyword_block] = STATE(3523),
    [sym_exp_if] = STATE(3523),
    [sym_force] = STATE(3527),
    [sym_exp_let] = STATE(3523),
    [sym_handler] = STATE(3523),
    [sym_rewrite_block] = STATE(3523),
    [sym_wordy_id] = STATE(2433),
    [sym_hash_qualifier] = STATE(3256),
    [sym__hq_qualified_wordy_id] = STATE(3256),
    [sym__hq_qualified_prefix_term] = STATE(3245),
    [sym_nat] = ACTIONS(3902),
    [sym_int] = ACTIONS(3902),
    [sym_float] = ACTIONS(3902),
    [anon_sym_DQUOTE] = ACTIONS(3905),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3908),
    [aux_sym_literal_char_token1] = ACTIONS(3911),
    [aux_sym_literal_char_token2] = ACTIONS(3911),
    [anon_sym_true] = ACTIONS(3914),
    [anon_sym_false] = ACTIONS(3914),
    [sym_literal_byte] = ACTIONS(3902),
    [sym_literal_hex] = ACTIONS(3902),
    [anon_sym_LPAREN] = ACTIONS(3917),
    [anon_sym_SEMI] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(3920),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(4127),
    [anon_sym_BANG] = ACTIONS(4130),
    [sym_do] = ACTIONS(4133),
    [sym_kw_let] = ACTIONS(3932),
    [sym_match] = ACTIONS(3935),
    [sym_cases] = ACTIONS(3938),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(3941),
    [sym_kw_typelink] = ACTIONS(3944),
    [sym_handle] = ACTIONS(4136),
    [sym_rewrite] = ACTIONS(3950),
    [aux_sym_wordy_id_token1] = ACTIONS(3953),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(3956),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3959),
    [sym_built_in_hash] = ACTIONS(3962),
    [sym__layout_semicolon] = ACTIONS(1775),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(3965),
    [sym_doc_block] = ACTIONS(3968),
  },
  [1337] = {
    [aux_sym__term4] = STATE(1338),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym_nat] = ACTIONS(4139),
    [sym_int] = ACTIONS(4139),
    [sym_float] = ACTIONS(4139),
    [anon_sym_DQUOTE] = ACTIONS(4142),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4145),
    [aux_sym_literal_char_token1] = ACTIONS(4148),
    [aux_sym_literal_char_token2] = ACTIONS(4148),
    [anon_sym_true] = ACTIONS(4151),
    [anon_sym_false] = ACTIONS(4151),
    [sym_literal_byte] = ACTIONS(4139),
    [sym_literal_hex] = ACTIONS(4139),
    [anon_sym_LPAREN] = ACTIONS(4154),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(4157),
    [anon_sym_RBRACK] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(4160),
    [anon_sym_BANG] = ACTIONS(4163),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(4166),
    [sym_kw_let] = ACTIONS(4169),
    [sym_match] = ACTIONS(4172),
    [sym_cases] = ACTIONS(4175),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(4178),
    [sym_kw_typelink] = ACTIONS(4181),
    [sym_handle] = ACTIONS(4184),
    [sym_rewrite] = ACTIONS(4187),
    [aux_sym_wordy_id_token1] = ACTIONS(4190),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4193),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4196),
    [sym_built_in_hash] = ACTIONS(4199),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4202),
    [sym_doc_block] = ACTIONS(4205),
  },
  [1338] = {
    [aux_sym__term4] = STATE(1338),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym_nat] = ACTIONS(4208),
    [sym_int] = ACTIONS(4208),
    [sym_float] = ACTIONS(4208),
    [anon_sym_DQUOTE] = ACTIONS(4211),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4214),
    [aux_sym_literal_char_token1] = ACTIONS(4217),
    [aux_sym_literal_char_token2] = ACTIONS(4217),
    [anon_sym_true] = ACTIONS(4220),
    [anon_sym_false] = ACTIONS(4220),
    [sym_literal_byte] = ACTIONS(4208),
    [sym_literal_hex] = ACTIONS(4208),
    [anon_sym_LPAREN] = ACTIONS(4223),
    [anon_sym_COMMA] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(4226),
    [anon_sym_RBRACK] = ACTIONS(1795),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(4229),
    [anon_sym_BANG] = ACTIONS(4232),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(4235),
    [sym_kw_let] = ACTIONS(4238),
    [sym_match] = ACTIONS(4241),
    [sym_cases] = ACTIONS(4244),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(4247),
    [sym_kw_typelink] = ACTIONS(4250),
    [sym_handle] = ACTIONS(4253),
    [sym_rewrite] = ACTIONS(4256),
    [aux_sym_wordy_id_token1] = ACTIONS(4259),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(4262),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4265),
    [sym_built_in_hash] = ACTIONS(4268),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4271),
    [sym_doc_block] = ACTIONS(4274),
  },
  [1339] = {
    [aux_sym__term4] = STATE(1338),
    [sym_literal_text] = STATE(3525),
    [sym_literal_char] = STATE(3525),
    [sym_literal_boolean] = STATE(3525),
    [sym_tuple_or_parenthesized] = STATE(3525),
    [sym_literal_termlink] = STATE(3525),
    [sym_literal_typelink] = STATE(3525),
    [sym__pattern_matching] = STATE(3534),
    [sym__match_with] = STATE(3526),
    [sym__lam_case] = STATE(3534),
    [sym_kw_if] = STATE(7110),
    [sym_delay_quote] = STATE(3525),
    [sym_delay_block] = STATE(3525),
    [sym_bang] = STATE(3525),
    [sym__number] = STATE(3525),
    [sym__link] = STATE(3525),
    [sym__term_leaf] = STATE(3525),
    [sym_literal_list] = STATE(3525),
    [sym__keyword_block] = STATE(3524),
    [sym_exp_if] = STATE(3524),
    [sym_force] = STATE(3525),
    [sym_exp_let] = STATE(3524),
    [sym_handler] = STATE(3524),
    [sym_rewrite_block] = STATE(3524),
    [sym_wordy_id] = STATE(2567),
    [sym_hash_qualifier] = STATE(3131),
    [sym__hq_qualified_wordy_id] = STATE(3131),
    [sym__hq_qualified_prefix_term] = STATE(3136),
    [sym_nat] = ACTIONS(1259),
    [sym_int] = ACTIONS(1259),
    [sym_float] = ACTIONS(1259),
    [anon_sym_DQUOTE] = ACTIONS(2199),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(3205),
    [aux_sym_literal_char_token1] = ACTIONS(2203),
    [aux_sym_literal_char_token2] = ACTIONS(2203),
    [anon_sym_true] = ACTIONS(2207),
    [anon_sym_false] = ACTIONS(2207),
    [sym_literal_byte] = ACTIONS(1259),
    [sym_literal_hex] = ACTIONS(1259),
    [anon_sym_LPAREN] = ACTIONS(3207),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(3209),
    [anon_sym_RBRACK] = ACTIONS(1871),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(3211),
    [anon_sym_BANG] = ACTIONS(1285),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(1287),
    [sym_kw_let] = ACTIONS(1289),
    [sym_match] = ACTIONS(1291),
    [sym_cases] = ACTIONS(1293),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(1295),
    [sym_kw_typelink] = ACTIONS(1297),
    [sym_handle] = ACTIONS(1299),
    [sym_rewrite] = ACTIONS(3215),
    [aux_sym_wordy_id_token1] = ACTIONS(1967),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4193),
    [aux_sym_hash_qualifier_token1] = ACTIONS(3219),
    [sym_built_in_hash] = ACTIONS(3221),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(2217),
    [sym_doc_block] = ACTIONS(1271),
  },
  [1340] = {
    [aux_sym__term4] = STATE(1344),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_wordy_id] = STATE(2769),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym_nat] = ACTIONS(4277),
    [sym_int] = ACTIONS(4277),
    [sym_float] = ACTIONS(4277),
    [anon_sym_DQUOTE] = ACTIONS(4280),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4283),
    [aux_sym_literal_char_token1] = ACTIONS(4286),
    [aux_sym_literal_char_token2] = ACTIONS(4286),
    [anon_sym_true] = ACTIONS(4289),
    [anon_sym_false] = ACTIONS(4289),
    [sym_literal_byte] = ACTIONS(4277),
    [sym_literal_hex] = ACTIONS(4277),
    [anon_sym_LPAREN] = ACTIONS(4292),
    [anon_sym_COMMA] = ACTIONS(1871),
    [anon_sym_LBRACK] = ACTIONS(4295),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(4298),
    [anon_sym_BANG] = ACTIONS(4301),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(4304),
    [sym_kw_let] = ACTIONS(4307),
    [sym_match] = ACTIONS(4310),
    [sym_cases] = ACTIONS(4313),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(4316),
    [sym_kw_typelink] = ACTIONS(4319),
    [sym_handle] = ACTIONS(4322),
    [sym_rewrite] = ACTIONS(4325),
    [aux_sym_wordy_id_token1] = ACTIONS(4328),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4124),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4331),
    [sym_built_in_hash] = ACTIONS(4334),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4337),
    [sym_doc_block] = ACTIONS(4340),
  },
  [1341] = {
    [aux_sym__term4] = STATE(1343),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_wordy_id] = STATE(2780),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym_nat] = ACTIONS(4343),
    [sym_int] = ACTIONS(4343),
    [sym_float] = ACTIONS(4343),
    [anon_sym_DQUOTE] = ACTIONS(4346),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4349),
    [aux_sym_literal_char_token1] = ACTIONS(4352),
    [aux_sym_literal_char_token2] = ACTIONS(4352),
    [anon_sym_true] = ACTIONS(4355),
    [anon_sym_false] = ACTIONS(4355),
    [sym_literal_byte] = ACTIONS(4343),
    [sym_literal_hex] = ACTIONS(4343),
    [anon_sym_LPAREN] = ACTIONS(4358),
    [anon_sym_LBRACK] = ACTIONS(4361),
    [anon_sym_if] = ACTIONS(1876),
    [anon_sym_SQUOTE] = ACTIONS(4364),
    [anon_sym_BANG] = ACTIONS(4367),
    [anon_sym_COLON] = ACTIONS(1871),
    [sym_do] = ACTIONS(4370),
    [sym_kw_let] = ACTIONS(4373),
    [sym_match] = ACTIONS(4376),
    [sym_cases] = ACTIONS(4379),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(4382),
    [sym_kw_typelink] = ACTIONS(4385),
    [sym_handle] = ACTIONS(4388),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(4391),
    [aux_sym_wordy_id_token1] = ACTIONS(4394),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4109),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4397),
    [sym_built_in_hash] = ACTIONS(4400),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4403),
    [sym_doc_block] = ACTIONS(4406),
  },
  [1342] = {
    [aux_sym__term4] = STATE(1319),
    [sym_literal_text] = STATE(3640),
    [sym_literal_char] = STATE(3640),
    [sym_literal_boolean] = STATE(3640),
    [sym_tuple_or_parenthesized] = STATE(3640),
    [sym_literal_termlink] = STATE(3640),
    [sym_literal_typelink] = STATE(3640),
    [sym__pattern_matching] = STATE(3642),
    [sym__match_with] = STATE(3636),
    [sym__lam_case] = STATE(3642),
    [sym_kw_if] = STATE(7118),
    [sym_delay_quote] = STATE(3640),
    [sym_delay_block] = STATE(3640),
    [sym_bang] = STATE(3640),
    [sym__number] = STATE(3640),
    [sym__link] = STATE(3640),
    [sym__term_leaf] = STATE(3640),
    [sym_literal_list] = STATE(3640),
    [sym__keyword_block] = STATE(3717),
    [sym_exp_if] = STATE(3717),
    [sym_force] = STATE(3640),
    [sym_exp_let] = STATE(3717),
    [sym_handler] = STATE(3717),
    [sym_rewrite_block] = STATE(3717),
    [sym_wordy_id] = STATE(2458),
    [sym_hash_qualifier] = STATE(2973),
    [sym__hq_qualified_wordy_id] = STATE(2973),
    [sym__hq_qualified_prefix_term] = STATE(3106),
    [sym_nat] = ACTIONS(689),
    [sym_int] = ACTIONS(689),
    [sym_float] = ACTIONS(689),
    [anon_sym_DQUOTE] = ACTIONS(691),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(693),
    [aux_sym_literal_char_token1] = ACTIONS(695),
    [aux_sym_literal_char_token2] = ACTIONS(695),
    [anon_sym_true] = ACTIONS(697),
    [anon_sym_false] = ACTIONS(697),
    [sym_literal_byte] = ACTIONS(689),
    [sym_literal_hex] = ACTIONS(689),
    [anon_sym_LPAREN] = ACTIONS(3145),
    [anon_sym_LBRACK] = ACTIONS(701),
    [anon_sym_if] = ACTIONS(47),
    [anon_sym_SQUOTE] = ACTIONS(703),
    [anon_sym_BANG] = ACTIONS(705),
    [sym_do] = ACTIONS(707),
    [sym_kw_let] = ACTIONS(709),
    [sym_match] = ACTIONS(711),
    [sym_cases] = ACTIONS(713),
    [sym_or] = ACTIONS(1871),
    [sym_and] = ACTIONS(1871),
    [sym_kw_termlink] = ACTIONS(715),
    [sym_kw_typelink] = ACTIONS(717),
    [sym_handle] = ACTIONS(719),
    [sym_with] = ACTIONS(1871),
    [sym_rewrite] = ACTIONS(721),
    [aux_sym_wordy_id_token1] = ACTIONS(3149),
    [sym_symboly_id] = ACTIONS(1871),
    [sym_path] = ACTIONS(4094),
    [aux_sym_hash_qualifier_token1] = ACTIONS(725),
    [sym_built_in_hash] = ACTIONS(727),
    [sym__layout_semicolon] = ACTIONS(1851),
    [sym__layout_end] = ACTIONS(1851),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(731),
    [sym_doc_block] = ACTIONS(733),
  },
  [1343] = {
    [aux_sym__term4] = STATE(1343),
    [sym_literal_text] = STATE(3863),
    [sym_literal_char] = STATE(3863),
    [sym_literal_boolean] = STATE(3863),
    [sym_tuple_or_parenthesized] = STATE(3863),
    [sym_literal_termlink] = STATE(3863),
    [sym_literal_typelink] = STATE(3863),
    [sym__pattern_matching] = STATE(3855),
    [sym__match_with] = STATE(3859),
    [sym__lam_case] = STATE(3855),
    [sym_kw_if] = STATE(7115),
    [sym_delay_quote] = STATE(3863),
    [sym_delay_block] = STATE(3863),
    [sym_bang] = STATE(3863),
    [sym__number] = STATE(3863),
    [sym__link] = STATE(3863),
    [sym__term_leaf] = STATE(3863),
    [sym_literal_list] = STATE(3863),
    [sym__keyword_block] = STATE(3866),
    [sym_exp_if] = STATE(3866),
    [sym_force] = STATE(3863),
    [sym_exp_let] = STATE(3866),
    [sym_handler] = STATE(3866),
    [sym_rewrite_block] = STATE(3866),
    [sym_wordy_id] = STATE(2780),
    [sym_hash_qualifier] = STATE(3369),
    [sym__hq_qualified_wordy_id] = STATE(3369),
    [sym__hq_qualified_prefix_term] = STATE(3377),
    [sym_nat] = ACTIONS(4409),
    [sym_int] = ACTIONS(4409),
    [sym_float] = ACTIONS(4409),
    [anon_sym_DQUOTE] = ACTIONS(4412),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4415),
    [aux_sym_literal_char_token1] = ACTIONS(4418),
    [aux_sym_literal_char_token2] = ACTIONS(4418),
    [anon_sym_true] = ACTIONS(4421),
    [anon_sym_false] = ACTIONS(4421),
    [sym_literal_byte] = ACTIONS(4409),
    [sym_literal_hex] = ACTIONS(4409),
    [anon_sym_LPAREN] = ACTIONS(4424),
    [anon_sym_LBRACK] = ACTIONS(4427),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(4430),
    [anon_sym_BANG] = ACTIONS(4433),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(4436),
    [sym_kw_let] = ACTIONS(4439),
    [sym_match] = ACTIONS(4442),
    [sym_cases] = ACTIONS(4445),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(4448),
    [sym_kw_typelink] = ACTIONS(4451),
    [sym_handle] = ACTIONS(4454),
    [sym_with] = ACTIONS(1795),
    [sym_rewrite] = ACTIONS(4457),
    [aux_sym_wordy_id_token1] = ACTIONS(4460),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(4463),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4466),
    [sym_built_in_hash] = ACTIONS(4469),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4472),
    [sym_doc_block] = ACTIONS(4475),
  },
  [1344] = {
    [aux_sym__term4] = STATE(1344),
    [sym_literal_text] = STATE(3861),
    [sym_literal_char] = STATE(3861),
    [sym_literal_boolean] = STATE(3861),
    [sym_tuple_or_parenthesized] = STATE(3861),
    [sym_literal_termlink] = STATE(3861),
    [sym_literal_typelink] = STATE(3861),
    [sym__pattern_matching] = STATE(3890),
    [sym__match_with] = STATE(3865),
    [sym__lam_case] = STATE(3890),
    [sym_kw_if] = STATE(7112),
    [sym_delay_quote] = STATE(3861),
    [sym_delay_block] = STATE(3861),
    [sym_bang] = STATE(3861),
    [sym__number] = STATE(3861),
    [sym__link] = STATE(3861),
    [sym__term_leaf] = STATE(3861),
    [sym_literal_list] = STATE(3861),
    [sym__keyword_block] = STATE(3860),
    [sym_exp_if] = STATE(3860),
    [sym_force] = STATE(3861),
    [sym_exp_let] = STATE(3860),
    [sym_handler] = STATE(3860),
    [sym_rewrite_block] = STATE(3860),
    [sym_wordy_id] = STATE(2769),
    [sym_hash_qualifier] = STATE(3739),
    [sym__hq_qualified_wordy_id] = STATE(3739),
    [sym__hq_qualified_prefix_term] = STATE(3760),
    [sym_nat] = ACTIONS(4478),
    [sym_int] = ACTIONS(4478),
    [sym_float] = ACTIONS(4478),
    [anon_sym_DQUOTE] = ACTIONS(4481),
    [anon_sym_DQUOTE_DQUOTE_DQUOTE] = ACTIONS(4484),
    [aux_sym_literal_char_token1] = ACTIONS(4487),
    [aux_sym_literal_char_token2] = ACTIONS(4487),
    [anon_sym_true] = ACTIONS(4490),
    [anon_sym_false] = ACTIONS(4490),
    [sym_literal_byte] = ACTIONS(4478),
    [sym_literal_hex] = ACTIONS(4478),
    [anon_sym_LPAREN] = ACTIONS(4493),
    [anon_sym_COMMA] = ACTIONS(1795),
    [anon_sym_LBRACK] = ACTIONS(4496),
    [anon_sym_if] = ACTIONS(1800),
    [anon_sym_SQUOTE] = ACTIONS(4499),
    [anon_sym_BANG] = ACTIONS(4502),
    [anon_sym_COLON] = ACTIONS(1795),
    [sym_do] = ACTIONS(4505),
    [sym_kw_let] = ACTIONS(4508),
    [sym_match] = ACTIONS(4511),
    [sym_cases] = ACTIONS(4514),
    [sym_or] = ACTIONS(1795),
    [sym_and] = ACTIONS(1795),
    [sym_kw_termlink] = ACTIONS(4517),
    [sym_kw_typelink] = ACTIONS(4520),
    [sym_handle] = ACTIONS(4523),
    [sym_rewrite] = ACTIONS(4526),
    [aux_sym_wordy_id_token1] = ACTIONS(4529),
    [sym_symboly_id] = ACTIONS(1795),
    [sym_path] = ACTIONS(4532),
    [aux_sym_hash_qualifier_token1] = ACTIONS(4535),
    [sym_built_in_hash] = ACTIONS(4538),
    [sym__layout_end] = ACTIONS(1775),
    [sym_comment] = ACTIONS(3),
    [sym__parenthesized_operator] = ACTIONS(4541),
    [sym_doc_block] = ACTIONS(4544),
  },
};

static const uint16_t ts_small_parse_table[] = {
  [0] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_if,
    ACTIONS(4550), 1,
      anon_sym_DQUOTE,
    ACTIONS(4553), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4562), 1,
      anon_sym_LPAREN,
    ACTIONS(4565), 1,
      anon_sym_LBRACK,
    ACTIONS(4568), 1,
      anon_sym_SQUOTE,
    ACTIONS(4571), 1,
      anon_sym_BANG,
    ACTIONS(4574), 1,
      sym_do,
    ACTIONS(4577), 1,
      sym_kw_let,
    ACTIONS(4580), 1,
      sym_match,
    ACTIONS(4583), 1,
      sym_cases,
    ACTIONS(4586), 1,
      sym_kw_termlink,
    ACTIONS(4589), 1,
      sym_kw_typelink,
    ACTIONS(4592), 1,
      sym_handle,
    ACTIONS(4595), 1,
      sym_rewrite,
    ACTIONS(4598), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4601), 1,
      sym_path,
    ACTIONS(4604), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4607), 1,
      sym_built_in_hash,
    ACTIONS(4610), 1,
      sym__parenthesized_operator,
    ACTIONS(4613), 1,
      sym_doc_block,
    STATE(1346), 1,
      aux_sym__term4,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(4556), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4559), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_rewrite_arrow,
      sym_symboly_id,
    ACTIONS(4547), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4182), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [135] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_if,
    ACTIONS(4619), 1,
      anon_sym_DQUOTE,
    ACTIONS(4622), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4631), 1,
      anon_sym_LPAREN,
    ACTIONS(4634), 1,
      anon_sym_LBRACK,
    ACTIONS(4637), 1,
      anon_sym_SQUOTE,
    ACTIONS(4640), 1,
      anon_sym_BANG,
    ACTIONS(4643), 1,
      sym_do,
    ACTIONS(4646), 1,
      sym_kw_let,
    ACTIONS(4649), 1,
      sym_match,
    ACTIONS(4652), 1,
      sym_cases,
    ACTIONS(4655), 1,
      sym_kw_termlink,
    ACTIONS(4658), 1,
      sym_kw_typelink,
    ACTIONS(4661), 1,
      sym_handle,
    ACTIONS(4664), 1,
      sym_rewrite,
    ACTIONS(4667), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4670), 1,
      sym_path,
    ACTIONS(4673), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4676), 1,
      sym_built_in_hash,
    ACTIONS(4679), 1,
      sym__parenthesized_operator,
    ACTIONS(4682), 1,
      sym_doc_block,
    STATE(1346), 1,
      aux_sym__term4,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(4625), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4628), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1795), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_rewrite_arrow,
      sym_symboly_id,
    ACTIONS(4616), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4182), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [270] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2135), 1,
      anon_sym_DQUOTE,
    ACTIONS(2145), 1,
      sym_doc_block,
    ACTIONS(2153), 1,
      anon_sym_BANG,
    ACTIONS(2155), 1,
      sym_do,
    ACTIONS(2157), 1,
      sym_kw_let,
    ACTIONS(2159), 1,
      sym_match,
    ACTIONS(2161), 1,
      sym_cases,
    ACTIONS(2163), 1,
      sym_kw_termlink,
    ACTIONS(2165), 1,
      sym_kw_typelink,
    ACTIONS(2167), 1,
      sym_handle,
    ACTIONS(2175), 1,
      sym__parenthesized_operator,
    ACTIONS(3231), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3233), 1,
      anon_sym_LPAREN,
    ACTIONS(3235), 1,
      anon_sym_LBRACK,
    ACTIONS(3237), 1,
      anon_sym_SQUOTE,
    ACTIONS(3241), 1,
      sym_rewrite,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3247), 1,
      sym_built_in_hash,
    ACTIONS(4685), 1,
      sym_path,
    STATE(1349), 1,
      aux_sym__term4,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(2139), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(2143), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(2133), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4347), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [405] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_if,
    ACTIONS(4142), 1,
      anon_sym_DQUOTE,
    ACTIONS(4145), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4154), 1,
      anon_sym_LPAREN,
    ACTIONS(4157), 1,
      anon_sym_LBRACK,
    ACTIONS(4169), 1,
      sym_kw_let,
    ACTIONS(4172), 1,
      sym_match,
    ACTIONS(4175), 1,
      sym_cases,
    ACTIONS(4178), 1,
      sym_kw_termlink,
    ACTIONS(4181), 1,
      sym_kw_typelink,
    ACTIONS(4187), 1,
      sym_rewrite,
    ACTIONS(4190), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4193), 1,
      sym_path,
    ACTIONS(4196), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4199), 1,
      sym_built_in_hash,
    ACTIONS(4202), 1,
      sym__parenthesized_operator,
    ACTIONS(4205), 1,
      sym_doc_block,
    ACTIONS(4688), 1,
      anon_sym_SQUOTE,
    ACTIONS(4691), 1,
      anon_sym_BANG,
    ACTIONS(4694), 1,
      sym_do,
    ACTIONS(4697), 1,
      sym_handle,
    STATE(1352), 1,
      aux_sym__term4,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(4148), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4151), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_symboly_id,
    ACTIONS(4139), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3525), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [540] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_if,
    ACTIONS(4703), 1,
      anon_sym_DQUOTE,
    ACTIONS(4706), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4715), 1,
      anon_sym_LPAREN,
    ACTIONS(4718), 1,
      anon_sym_LBRACK,
    ACTIONS(4721), 1,
      anon_sym_SQUOTE,
    ACTIONS(4724), 1,
      anon_sym_BANG,
    ACTIONS(4727), 1,
      sym_do,
    ACTIONS(4730), 1,
      sym_kw_let,
    ACTIONS(4733), 1,
      sym_match,
    ACTIONS(4736), 1,
      sym_cases,
    ACTIONS(4739), 1,
      sym_kw_termlink,
    ACTIONS(4742), 1,
      sym_kw_typelink,
    ACTIONS(4745), 1,
      sym_handle,
    ACTIONS(4748), 1,
      sym_rewrite,
    ACTIONS(4751), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4754), 1,
      sym_path,
    ACTIONS(4757), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4760), 1,
      sym_built_in_hash,
    ACTIONS(4763), 1,
      sym__parenthesized_operator,
    ACTIONS(4766), 1,
      sym_doc_block,
    STATE(1349), 1,
      aux_sym__term4,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(4709), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4712), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1795), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(4700), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4347), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [675] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_if,
    ACTIONS(4685), 1,
      sym_path,
    ACTIONS(4772), 1,
      anon_sym_DQUOTE,
    ACTIONS(4775), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4784), 1,
      anon_sym_LPAREN,
    ACTIONS(4787), 1,
      anon_sym_LBRACK,
    ACTIONS(4790), 1,
      anon_sym_SQUOTE,
    ACTIONS(4793), 1,
      anon_sym_BANG,
    ACTIONS(4796), 1,
      sym_do,
    ACTIONS(4799), 1,
      sym_kw_let,
    ACTIONS(4802), 1,
      sym_match,
    ACTIONS(4805), 1,
      sym_cases,
    ACTIONS(4808), 1,
      sym_kw_termlink,
    ACTIONS(4811), 1,
      sym_kw_typelink,
    ACTIONS(4814), 1,
      sym_handle,
    ACTIONS(4817), 1,
      sym_rewrite,
    ACTIONS(4820), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4823), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4826), 1,
      sym_built_in_hash,
    ACTIONS(4829), 1,
      sym__parenthesized_operator,
    ACTIONS(4832), 1,
      sym_doc_block,
    STATE(1349), 1,
      aux_sym__term4,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(4778), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4781), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(4769), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4347), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [810] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2083), 1,
      anon_sym_DQUOTE,
    ACTIONS(2093), 1,
      sym_doc_block,
    ACTIONS(2101), 1,
      anon_sym_BANG,
    ACTIONS(2103), 1,
      sym_do,
    ACTIONS(2105), 1,
      sym_kw_let,
    ACTIONS(2107), 1,
      sym_match,
    ACTIONS(2109), 1,
      sym_cases,
    ACTIONS(2111), 1,
      sym_kw_termlink,
    ACTIONS(2113), 1,
      sym_kw_typelink,
    ACTIONS(2115), 1,
      sym_handle,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2125), 1,
      sym__parenthesized_operator,
    ACTIONS(3255), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3257), 1,
      anon_sym_LPAREN,
    ACTIONS(3259), 1,
      anon_sym_LBRACK,
    ACTIONS(3261), 1,
      anon_sym_SQUOTE,
    ACTIONS(3265), 1,
      sym_rewrite,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3271), 1,
      sym_built_in_hash,
    ACTIONS(4601), 1,
      sym_path,
    STATE(1346), 1,
      aux_sym__term4,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(2087), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(2091), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 5,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_rewrite_arrow,
      sym_symboly_id,
    ACTIONS(2081), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4182), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [945] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_if,
    ACTIONS(4211), 1,
      anon_sym_DQUOTE,
    ACTIONS(4214), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4223), 1,
      anon_sym_LPAREN,
    ACTIONS(4226), 1,
      anon_sym_LBRACK,
    ACTIONS(4238), 1,
      sym_kw_let,
    ACTIONS(4241), 1,
      sym_match,
    ACTIONS(4244), 1,
      sym_cases,
    ACTIONS(4247), 1,
      sym_kw_termlink,
    ACTIONS(4250), 1,
      sym_kw_typelink,
    ACTIONS(4256), 1,
      sym_rewrite,
    ACTIONS(4259), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4262), 1,
      sym_path,
    ACTIONS(4265), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4268), 1,
      sym_built_in_hash,
    ACTIONS(4271), 1,
      sym__parenthesized_operator,
    ACTIONS(4274), 1,
      sym_doc_block,
    ACTIONS(4835), 1,
      anon_sym_SQUOTE,
    ACTIONS(4838), 1,
      anon_sym_BANG,
    ACTIONS(4841), 1,
      sym_do,
    ACTIONS(4844), 1,
      sym_handle,
    STATE(1352), 1,
      aux_sym__term4,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(4217), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4220), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1795), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_or,
      sym_and,
      sym_symboly_id,
    ACTIONS(4208), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3525), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1080] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_if,
    ACTIONS(4850), 1,
      anon_sym_DQUOTE,
    ACTIONS(4853), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4862), 1,
      anon_sym_LPAREN,
    ACTIONS(4865), 1,
      anon_sym_LBRACK,
    ACTIONS(4868), 1,
      anon_sym_SQUOTE,
    ACTIONS(4871), 1,
      anon_sym_BANG,
    ACTIONS(4874), 1,
      sym_do,
    ACTIONS(4877), 1,
      sym_kw_let,
    ACTIONS(4880), 1,
      sym_match,
    ACTIONS(4883), 1,
      sym_cases,
    ACTIONS(4886), 1,
      sym_kw_termlink,
    ACTIONS(4889), 1,
      sym_kw_typelink,
    ACTIONS(4892), 1,
      sym_handle,
    ACTIONS(4895), 1,
      sym_rewrite,
    ACTIONS(4898), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4901), 1,
      sym_path,
    ACTIONS(4904), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4907), 1,
      sym_built_in_hash,
    ACTIONS(4910), 1,
      sym__parenthesized_operator,
    ACTIONS(4913), 1,
      sym_doc_block,
    STATE(1353), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(4856), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4859), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1795), 4,
      anon_sym_DASH_GT,
      sym_or,
      sym_and,
      sym_symboly_id,
    ACTIONS(4847), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1214] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1981), 1,
      anon_sym_DQUOTE,
    ACTIONS(1991), 1,
      sym_doc_block,
    ACTIONS(1999), 1,
      anon_sym_BANG,
    ACTIONS(2001), 1,
      sym_do,
    ACTIONS(2003), 1,
      sym_kw_let,
    ACTIONS(2005), 1,
      sym_match,
    ACTIONS(2007), 1,
      sym_cases,
    ACTIONS(2009), 1,
      sym_kw_termlink,
    ACTIONS(2011), 1,
      sym_kw_typelink,
    ACTIONS(2013), 1,
      sym_handle,
    ACTIONS(2023), 1,
      sym__parenthesized_operator,
    ACTIONS(3287), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3289), 1,
      anon_sym_LPAREN,
    ACTIONS(3291), 1,
      anon_sym_LBRACK,
    ACTIONS(3293), 1,
      anon_sym_SQUOTE,
    ACTIONS(3297), 1,
      sym_rewrite,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3305), 1,
      sym_built_in_hash,
    ACTIONS(4916), 1,
      sym_path,
    STATE(1357), 1,
      aux_sym__term4,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(1985), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(1989), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 4,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(1979), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4471), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1348] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_if,
    ACTIONS(4922), 1,
      anon_sym_DQUOTE,
    ACTIONS(4925), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(4934), 1,
      anon_sym_LPAREN,
    ACTIONS(4937), 1,
      anon_sym_LBRACK,
    ACTIONS(4940), 1,
      anon_sym_SQUOTE,
    ACTIONS(4943), 1,
      anon_sym_BANG,
    ACTIONS(4946), 1,
      sym_do,
    ACTIONS(4949), 1,
      sym_kw_let,
    ACTIONS(4952), 1,
      sym_match,
    ACTIONS(4955), 1,
      sym_cases,
    ACTIONS(4958), 1,
      sym_kw_termlink,
    ACTIONS(4961), 1,
      sym_kw_typelink,
    ACTIONS(4964), 1,
      sym_handle,
    ACTIONS(4967), 1,
      sym_rewrite,
    ACTIONS(4970), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(4973), 1,
      sym_path,
    ACTIONS(4976), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(4979), 1,
      sym_built_in_hash,
    ACTIONS(4982), 1,
      sym__parenthesized_operator,
    ACTIONS(4985), 1,
      sym_doc_block,
    STATE(1353), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(4928), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(4931), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 4,
      anon_sym_DASH_GT,
      sym_or,
      sym_and,
      sym_symboly_id,
    ACTIONS(4919), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1482] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1876), 1,
      anon_sym_if,
    ACTIONS(4916), 1,
      sym_path,
    ACTIONS(4991), 1,
      anon_sym_DQUOTE,
    ACTIONS(4994), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5003), 1,
      anon_sym_LPAREN,
    ACTIONS(5006), 1,
      anon_sym_LBRACK,
    ACTIONS(5009), 1,
      anon_sym_SQUOTE,
    ACTIONS(5012), 1,
      anon_sym_BANG,
    ACTIONS(5015), 1,
      sym_do,
    ACTIONS(5018), 1,
      sym_kw_let,
    ACTIONS(5021), 1,
      sym_match,
    ACTIONS(5024), 1,
      sym_cases,
    ACTIONS(5027), 1,
      sym_kw_termlink,
    ACTIONS(5030), 1,
      sym_kw_typelink,
    ACTIONS(5033), 1,
      sym_handle,
    ACTIONS(5036), 1,
      sym_rewrite,
    ACTIONS(5039), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5042), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5045), 1,
      sym_built_in_hash,
    ACTIONS(5048), 1,
      sym__parenthesized_operator,
    ACTIONS(5051), 1,
      sym_doc_block,
    STATE(1357), 1,
      aux_sym__term4,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(4997), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(5000), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 4,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(4988), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4471), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1616] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1800), 1,
      anon_sym_if,
    ACTIONS(5057), 1,
      anon_sym_DQUOTE,
    ACTIONS(5060), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(5069), 1,
      anon_sym_LPAREN,
    ACTIONS(5072), 1,
      anon_sym_LBRACK,
    ACTIONS(5075), 1,
      anon_sym_SQUOTE,
    ACTIONS(5078), 1,
      anon_sym_BANG,
    ACTIONS(5081), 1,
      sym_do,
    ACTIONS(5084), 1,
      sym_kw_let,
    ACTIONS(5087), 1,
      sym_match,
    ACTIONS(5090), 1,
      sym_cases,
    ACTIONS(5093), 1,
      sym_kw_termlink,
    ACTIONS(5096), 1,
      sym_kw_typelink,
    ACTIONS(5099), 1,
      sym_handle,
    ACTIONS(5102), 1,
      sym_rewrite,
    ACTIONS(5105), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5108), 1,
      sym_path,
    ACTIONS(5111), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5114), 1,
      sym_built_in_hash,
    ACTIONS(5117), 1,
      sym__parenthesized_operator,
    ACTIONS(5120), 1,
      sym_doc_block,
    STATE(1357), 1,
      aux_sym__term4,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(5063), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(5066), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1795), 4,
      sym_or,
      sym_and,
      sym_with,
      sym_symboly_id,
    ACTIONS(5054), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4471), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1750] = 35,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1941), 1,
      sym_doc_block,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1973), 1,
      sym__parenthesized_operator,
    ACTIONS(3307), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(3309), 1,
      anon_sym_LPAREN,
    ACTIONS(3311), 1,
      anon_sym_LBRACK,
    ACTIONS(3313), 1,
      anon_sym_SQUOTE,
    ACTIONS(3317), 1,
      sym_rewrite,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3325), 1,
      sym_built_in_hash,
    ACTIONS(4973), 1,
      sym_path,
    STATE(1353), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1935), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1871), 4,
      anon_sym_DASH_GT,
      sym_or,
      sym_and,
      sym_symboly_id,
    ACTIONS(1929), 5,
      sym_nat,
      sym_int,
      sym_float,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [1884] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5129), 1,
      anon_sym_LPAREN,
    ACTIONS(5132), 1,
      anon_sym_LBRACK,
    ACTIONS(5135), 1,
      anon_sym_LBRACE,
    ACTIONS(5137), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5140), 1,
      sym_symboly_id,
    ACTIONS(5143), 1,
      sym_path,
    ACTIONS(5146), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5149), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    ACTIONS(5123), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1361), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [1977] = 37,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1935), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1937), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_SQUOTE,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1965), 1,
      sym_rewrite,
    ACTIONS(1971), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5152), 1,
      anon_sym_LPAREN,
    ACTIONS(5154), 1,
      sym_otherwise,
    ACTIONS(5156), 1,
      sym_path,
    STATE(1245), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(6480), 1,
      sym_guard,
    STATE(6634), 1,
      sym__infix_app_or_boolean_op,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1973), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1929), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1941), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [2114] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5162), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5165), 1,
      anon_sym_LPAREN,
    ACTIONS(5168), 1,
      anon_sym_LBRACK,
    ACTIONS(5171), 1,
      anon_sym_LBRACE,
    ACTIONS(5174), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5177), 1,
      sym_symboly_id,
    ACTIONS(5180), 1,
      sym_path,
    ACTIONS(5183), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5186), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    ACTIONS(5158), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1361), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [2207] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5135), 1,
      anon_sym_LBRACE,
    ACTIONS(5193), 1,
      anon_sym_LPAREN,
    ACTIONS(5196), 1,
      anon_sym_LBRACK,
    ACTIONS(5199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5202), 1,
      sym_symboly_id,
    ACTIONS(5205), 1,
      sym_path,
    ACTIONS(5208), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5211), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    ACTIONS(5189), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1359), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [2300] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5216), 1,
      anon_sym_LPAREN,
    ACTIONS(5219), 1,
      anon_sym_LBRACK,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(5224), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5227), 1,
      sym_symboly_id,
    ACTIONS(5230), 1,
      sym_path,
    ACTIONS(5233), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5236), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    ACTIONS(5123), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1365), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [2392] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5222), 1,
      anon_sym_LBRACE,
    ACTIONS(5239), 1,
      anon_sym_LPAREN,
    ACTIONS(5242), 1,
      anon_sym_LBRACK,
    ACTIONS(5245), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5248), 1,
      sym_symboly_id,
    ACTIONS(5251), 1,
      sym_path,
    ACTIONS(5254), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5257), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    ACTIONS(5189), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1363), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [2484] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5260), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5263), 1,
      anon_sym_LPAREN,
    ACTIONS(5266), 1,
      anon_sym_LBRACK,
    ACTIONS(5269), 1,
      anon_sym_LBRACE,
    ACTIONS(5272), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5275), 1,
      sym_symboly_id,
    ACTIONS(5278), 1,
      sym_path,
    ACTIONS(5281), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5284), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    ACTIONS(5158), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1365), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [2576] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2225), 1,
      anon_sym_DQUOTE,
    ACTIONS(2227), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2229), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2231), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2239), 1,
      anon_sym_LBRACK,
    ACTIONS(2241), 1,
      anon_sym_SQUOTE,
    ACTIONS(2243), 1,
      anon_sym_BANG,
    ACTIONS(2245), 1,
      sym_do,
    ACTIONS(2247), 1,
      sym_kw_let,
    ACTIONS(2249), 1,
      sym_match,
    ACTIONS(2251), 1,
      sym_cases,
    ACTIONS(2253), 1,
      sym_kw_termlink,
    ACTIONS(2255), 1,
      sym_kw_typelink,
    ACTIONS(2257), 1,
      sym_handle,
    ACTIONS(2259), 1,
      sym_rewrite,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2265), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5287), 1,
      anon_sym_LPAREN,
    ACTIONS(5289), 1,
      sym_path,
    STATE(1332), 1,
      aux_sym__term4,
    STATE(2780), 1,
      sym_wordy_id,
    STATE(3377), 1,
      sym__hq_qualified_prefix_term,
    STATE(3859), 1,
      sym__match_with,
    STATE(7115), 1,
      sym_kw_if,
    ACTIONS(2233), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2267), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3369), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3855), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2223), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2235), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3866), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3863), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [2704] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1935), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1937), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_SQUOTE,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1965), 1,
      sym_rewrite,
    ACTIONS(1971), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5152), 1,
      anon_sym_LPAREN,
    ACTIONS(5156), 1,
      sym_path,
    STATE(1358), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1973), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1929), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1941), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [2832] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    ACTIONS(1285), 1,
      anon_sym_BANG,
    ACTIONS(1287), 1,
      sym_do,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1299), 1,
      sym_handle,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(1337), 1,
      aux_sym__term4,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1259), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1271), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3525), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [2960] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(37), 1,
      aux_sym_literal_char_token1,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_BANG,
    ACTIONS(53), 1,
      sym_do,
    ACTIONS(55), 1,
      sym_kw_let,
    ACTIONS(57), 1,
      sym_match,
    ACTIONS(59), 1,
      sym_cases,
    ACTIONS(61), 1,
      sym_kw_termlink,
    ACTIONS(63), 1,
      sym_kw_typelink,
    ACTIONS(65), 1,
      sym_handle,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1505), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1507), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_SQUOTE,
    ACTIONS(1515), 1,
      sym_rewrite,
    ACTIONS(1517), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5295), 1,
      anon_sym_LPAREN,
    ACTIONS(5297), 1,
      sym_path,
    STATE(894), 1,
      aux_sym__term4,
    STATE(1485), 1,
      sym_wordy_id,
    STATE(1566), 1,
      sym__hq_qualified_prefix_term,
    STATE(1727), 1,
      sym__match_with,
    STATE(7121), 1,
      sym_kw_if,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(79), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1557), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1725), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(31), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(81), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1733), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1732), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3088] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1521), 1,
      anon_sym_DQUOTE,
    ACTIONS(1525), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1535), 1,
      anon_sym_BANG,
    ACTIONS(1537), 1,
      sym_do,
    ACTIONS(1539), 1,
      sym_kw_let,
    ACTIONS(1541), 1,
      sym_match,
    ACTIONS(1543), 1,
      sym_cases,
    ACTIONS(1547), 1,
      sym_kw_termlink,
    ACTIONS(1549), 1,
      sym_kw_typelink,
    ACTIONS(1551), 1,
      sym_handle,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2059), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2061), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2065), 1,
      anon_sym_LBRACK,
    ACTIONS(2067), 1,
      anon_sym_SQUOTE,
    ACTIONS(2069), 1,
      sym_rewrite,
    ACTIONS(2073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5299), 1,
      anon_sym_LPAREN,
    ACTIONS(5301), 1,
      sym_path,
    STATE(1182), 1,
      aux_sym__term4,
    STATE(1632), 1,
      sym_wordy_id,
    STATE(1962), 1,
      sym__hq_qualified_prefix_term,
    STATE(2055), 1,
      sym__match_with,
    STATE(7116), 1,
      sym_kw_if,
    ACTIONS(1527), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1563), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1981), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2054), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1519), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1565), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2057), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2056), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3216] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      aux_sym_literal_char_token1,
    ACTIONS(705), 1,
      anon_sym_BANG,
    ACTIONS(707), 1,
      sym_do,
    ACTIONS(709), 1,
      sym_kw_let,
    ACTIONS(711), 1,
      sym_match,
    ACTIONS(713), 1,
      sym_cases,
    ACTIONS(715), 1,
      sym_kw_termlink,
    ACTIONS(717), 1,
      sym_kw_typelink,
    ACTIONS(719), 1,
      sym_handle,
    ACTIONS(1477), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1479), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_SQUOTE,
    ACTIONS(1487), 1,
      sym_rewrite,
    ACTIONS(1489), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5303), 1,
      anon_sym_LPAREN,
    ACTIONS(5305), 1,
      sym_path,
    STATE(1328), 1,
      aux_sym__term4,
    STATE(2458), 1,
      sym_wordy_id,
    STATE(3106), 1,
      sym__hq_qualified_prefix_term,
    STATE(3636), 1,
      sym__match_with,
    STATE(7118), 1,
      sym_kw_if,
    ACTIONS(697), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(731), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2973), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3642), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(689), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(733), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3717), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3640), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3344] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5307), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5310), 1,
      anon_sym_LPAREN,
    ACTIONS(5313), 1,
      anon_sym_LBRACK,
    ACTIONS(5316), 1,
      anon_sym_LBRACE,
    ACTIONS(5319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5322), 1,
      sym_symboly_id,
    ACTIONS(5325), 1,
      sym_path,
    ACTIONS(5328), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5331), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    ACTIONS(5158), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1372), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [3434] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_literal_char_token1,
    ACTIONS(567), 1,
      anon_sym_BANG,
    ACTIONS(569), 1,
      sym_do,
    ACTIONS(571), 1,
      sym_kw_let,
    ACTIONS(573), 1,
      sym_match,
    ACTIONS(575), 1,
      sym_cases,
    ACTIONS(577), 1,
      sym_kw_termlink,
    ACTIONS(579), 1,
      sym_kw_typelink,
    ACTIONS(581), 1,
      sym_handle,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1445), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1447), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1451), 1,
      anon_sym_LBRACK,
    ACTIONS(1453), 1,
      anon_sym_SQUOTE,
    ACTIONS(1455), 1,
      sym_rewrite,
    ACTIONS(1457), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5334), 1,
      anon_sym_LPAREN,
    ACTIONS(5336), 1,
      sym_path,
    STATE(1286), 1,
      aux_sym__term4,
    STATE(2329), 1,
      sym_wordy_id,
    STATE(2662), 1,
      sym__hq_qualified_prefix_term,
    STATE(3204), 1,
      sym__match_with,
    STATE(7122), 1,
      sym_kw_if,
    ACTIONS(559), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(595), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2824), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3203), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(551), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(597), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3206), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3205), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3562] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1981), 1,
      anon_sym_DQUOTE,
    ACTIONS(1983), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1985), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1987), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1995), 1,
      anon_sym_LBRACK,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_BANG,
    ACTIONS(2001), 1,
      sym_do,
    ACTIONS(2003), 1,
      sym_kw_let,
    ACTIONS(2005), 1,
      sym_match,
    ACTIONS(2007), 1,
      sym_cases,
    ACTIONS(2009), 1,
      sym_kw_termlink,
    ACTIONS(2011), 1,
      sym_kw_typelink,
    ACTIONS(2013), 1,
      sym_handle,
    ACTIONS(2015), 1,
      sym_rewrite,
    ACTIONS(2021), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      sym_path,
    STATE(1356), 1,
      aux_sym__term4,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(1989), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2023), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1979), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1991), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4471), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3690] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(757), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym_do,
    ACTIONS(761), 1,
      sym_kw_let,
    ACTIONS(763), 1,
      sym_match,
    ACTIONS(765), 1,
      sym_cases,
    ACTIONS(767), 1,
      sym_kw_termlink,
    ACTIONS(769), 1,
      sym_kw_typelink,
    ACTIONS(771), 1,
      sym_handle,
    ACTIONS(2027), 1,
      anon_sym_DQUOTE,
    ACTIONS(2029), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2031), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2033), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2039), 1,
      anon_sym_LBRACK,
    ACTIONS(2041), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      sym_rewrite,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2049), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5342), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      sym_path,
    STATE(1334), 1,
      aux_sym__term4,
    STATE(2769), 1,
      sym_wordy_id,
    STATE(3760), 1,
      sym__hq_qualified_prefix_term,
    STATE(3865), 1,
      sym__match_with,
    STATE(7112), 1,
      sym_kw_if,
    ACTIONS(2035), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2051), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3739), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3890), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(737), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(789), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3860), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3861), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3818] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1575), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1589), 1,
      anon_sym_BANG,
    ACTIONS(1591), 1,
      sym_do,
    ACTIONS(1593), 1,
      sym_kw_let,
    ACTIONS(1595), 1,
      sym_match,
    ACTIONS(1597), 1,
      sym_cases,
    ACTIONS(1601), 1,
      sym_kw_termlink,
    ACTIONS(1603), 1,
      sym_kw_typelink,
    ACTIONS(1605), 1,
      sym_handle,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2181), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2183), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2187), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_SQUOTE,
    ACTIONS(2191), 1,
      sym_rewrite,
    ACTIONS(2195), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5346), 1,
      anon_sym_LPAREN,
    ACTIONS(5348), 1,
      sym_path,
    STATE(1189), 1,
      aux_sym__term4,
    STATE(1943), 1,
      sym_wordy_id,
    STATE(2098), 1,
      sym__hq_qualified_prefix_term,
    STATE(2205), 1,
      sym__match_with,
    STATE(7030), 1,
      sym_kw_if,
    ACTIONS(1581), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1617), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1986), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2135), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1573), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1619), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2209), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2200), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [3946] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2083), 1,
      anon_sym_DQUOTE,
    ACTIONS(2085), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2087), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2089), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2097), 1,
      anon_sym_LBRACK,
    ACTIONS(2099), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_BANG,
    ACTIONS(2103), 1,
      sym_do,
    ACTIONS(2105), 1,
      sym_kw_let,
    ACTIONS(2107), 1,
      sym_match,
    ACTIONS(2109), 1,
      sym_cases,
    ACTIONS(2111), 1,
      sym_kw_termlink,
    ACTIONS(2113), 1,
      sym_kw_typelink,
    ACTIONS(2115), 1,
      sym_handle,
    ACTIONS(2117), 1,
      sym_rewrite,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2123), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5350), 1,
      anon_sym_LPAREN,
    ACTIONS(5352), 1,
      sym_path,
    STATE(1351), 1,
      aux_sym__term4,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(2091), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2125), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2081), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2093), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4182), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4074] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1935), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1937), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_SQUOTE,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1965), 1,
      sym_rewrite,
    ACTIONS(1971), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5152), 1,
      anon_sym_LPAREN,
    ACTIONS(5156), 1,
      sym_path,
    STATE(1355), 1,
      aux_sym__term4,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1973), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1929), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1941), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4402), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4202] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(1047), 1,
      anon_sym_BANG,
    ACTIONS(1049), 1,
      sym_do,
    ACTIONS(1051), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1425), 1,
      anon_sym_SQUOTE,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(1335), 1,
      aux_sym__term4,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(823), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(867), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3527), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4330] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1575), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1589), 1,
      anon_sym_BANG,
    ACTIONS(1591), 1,
      sym_do,
    ACTIONS(1593), 1,
      sym_kw_let,
    ACTIONS(1595), 1,
      sym_match,
    ACTIONS(1597), 1,
      sym_cases,
    ACTIONS(1601), 1,
      sym_kw_termlink,
    ACTIONS(1603), 1,
      sym_kw_typelink,
    ACTIONS(1605), 1,
      sym_handle,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2181), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2183), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2187), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_SQUOTE,
    ACTIONS(2191), 1,
      sym_rewrite,
    ACTIONS(2195), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5346), 1,
      anon_sym_LPAREN,
    ACTIONS(5348), 1,
      sym_path,
    STATE(1190), 1,
      aux_sym__term4,
    STATE(1943), 1,
      sym_wordy_id,
    STATE(2098), 1,
      sym__hq_qualified_prefix_term,
    STATE(2205), 1,
      sym__match_with,
    STATE(7030), 1,
      sym_kw_if,
    ACTIONS(1581), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1617), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1986), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2135), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1573), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1619), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2209), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2200), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4458] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2135), 1,
      anon_sym_DQUOTE,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2139), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2141), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2149), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      anon_sym_SQUOTE,
    ACTIONS(2153), 1,
      anon_sym_BANG,
    ACTIONS(2155), 1,
      sym_do,
    ACTIONS(2157), 1,
      sym_kw_let,
    ACTIONS(2159), 1,
      sym_match,
    ACTIONS(2161), 1,
      sym_cases,
    ACTIONS(2163), 1,
      sym_kw_termlink,
    ACTIONS(2165), 1,
      sym_kw_typelink,
    ACTIONS(2167), 1,
      sym_handle,
    ACTIONS(2169), 1,
      sym_rewrite,
    ACTIONS(2173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5358), 1,
      anon_sym_LPAREN,
    ACTIONS(5360), 1,
      sym_path,
    STATE(1347), 1,
      aux_sym__term4,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(2143), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2175), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2133), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2145), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4347), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4586] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(1047), 1,
      anon_sym_BANG,
    ACTIONS(1049), 1,
      sym_do,
    ACTIONS(1051), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1425), 1,
      anon_sym_SQUOTE,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(1333), 1,
      aux_sym__term4,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(823), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(867), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3527), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4714] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_literal_char_token1,
    ACTIONS(567), 1,
      anon_sym_BANG,
    ACTIONS(569), 1,
      sym_do,
    ACTIONS(571), 1,
      sym_kw_let,
    ACTIONS(573), 1,
      sym_match,
    ACTIONS(575), 1,
      sym_cases,
    ACTIONS(577), 1,
      sym_kw_termlink,
    ACTIONS(579), 1,
      sym_kw_typelink,
    ACTIONS(581), 1,
      sym_handle,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1445), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1447), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1451), 1,
      anon_sym_LBRACK,
    ACTIONS(1453), 1,
      anon_sym_SQUOTE,
    ACTIONS(1455), 1,
      sym_rewrite,
    ACTIONS(1457), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5334), 1,
      anon_sym_LPAREN,
    ACTIONS(5336), 1,
      sym_path,
    STATE(1311), 1,
      aux_sym__term4,
    STATE(2329), 1,
      sym_wordy_id,
    STATE(2662), 1,
      sym__hq_qualified_prefix_term,
    STATE(3204), 1,
      sym__match_with,
    STATE(7122), 1,
      sym_kw_if,
    ACTIONS(559), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(595), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2824), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3203), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(551), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(597), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3206), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3205), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4842] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    ACTIONS(191), 1,
      aux_sym_literal_char_token1,
    ACTIONS(201), 1,
      anon_sym_BANG,
    ACTIONS(203), 1,
      sym_do,
    ACTIONS(205), 1,
      sym_kw_let,
    ACTIONS(207), 1,
      sym_match,
    ACTIONS(209), 1,
      sym_cases,
    ACTIONS(211), 1,
      sym_kw_termlink,
    ACTIONS(213), 1,
      sym_kw_typelink,
    ACTIONS(215), 1,
      sym_handle,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1459), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1461), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1465), 1,
      anon_sym_LBRACK,
    ACTIONS(1467), 1,
      anon_sym_SQUOTE,
    ACTIONS(1469), 1,
      sym_rewrite,
    ACTIONS(1471), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5362), 1,
      anon_sym_LPAREN,
    ACTIONS(5364), 1,
      sym_path,
    STATE(1024), 1,
      aux_sym__term4,
    STATE(1513), 1,
      sym_wordy_id,
    STATE(1769), 1,
      sym__hq_qualified_prefix_term,
    STATE(1856), 1,
      sym__match_with,
    STATE(7113), 1,
      sym_kw_if,
    ACTIONS(193), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(227), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1800), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1883), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(185), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(229), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1859), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1857), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [4970] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2083), 1,
      anon_sym_DQUOTE,
    ACTIONS(2085), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2087), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2089), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2097), 1,
      anon_sym_LBRACK,
    ACTIONS(2099), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_BANG,
    ACTIONS(2103), 1,
      sym_do,
    ACTIONS(2105), 1,
      sym_kw_let,
    ACTIONS(2107), 1,
      sym_match,
    ACTIONS(2109), 1,
      sym_cases,
    ACTIONS(2111), 1,
      sym_kw_termlink,
    ACTIONS(2113), 1,
      sym_kw_typelink,
    ACTIONS(2115), 1,
      sym_handle,
    ACTIONS(2117), 1,
      sym_rewrite,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2123), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5350), 1,
      anon_sym_LPAREN,
    ACTIONS(5352), 1,
      sym_path,
    STATE(1345), 1,
      aux_sym__term4,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(2091), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2125), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2081), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2093), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4182), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5098] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1981), 1,
      anon_sym_DQUOTE,
    ACTIONS(1983), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1985), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1987), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1995), 1,
      anon_sym_LBRACK,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_BANG,
    ACTIONS(2001), 1,
      sym_do,
    ACTIONS(2003), 1,
      sym_kw_let,
    ACTIONS(2005), 1,
      sym_match,
    ACTIONS(2007), 1,
      sym_cases,
    ACTIONS(2009), 1,
      sym_kw_termlink,
    ACTIONS(2011), 1,
      sym_kw_typelink,
    ACTIONS(2013), 1,
      sym_handle,
    ACTIONS(2015), 1,
      sym_rewrite,
    ACTIONS(2021), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      sym_path,
    STATE(1354), 1,
      aux_sym__term4,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(1989), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2023), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1979), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1991), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4471), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5226] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2135), 1,
      anon_sym_DQUOTE,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2139), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2141), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2149), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      anon_sym_SQUOTE,
    ACTIONS(2153), 1,
      anon_sym_BANG,
    ACTIONS(2155), 1,
      sym_do,
    ACTIONS(2157), 1,
      sym_kw_let,
    ACTIONS(2159), 1,
      sym_match,
    ACTIONS(2161), 1,
      sym_cases,
    ACTIONS(2163), 1,
      sym_kw_termlink,
    ACTIONS(2165), 1,
      sym_kw_typelink,
    ACTIONS(2167), 1,
      sym_handle,
    ACTIONS(2169), 1,
      sym_rewrite,
    ACTIONS(2173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5358), 1,
      anon_sym_LPAREN,
    ACTIONS(5360), 1,
      sym_path,
    STATE(1350), 1,
      aux_sym__term4,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(2143), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2175), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2133), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2145), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4347), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5354] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5368), 1,
      anon_sym_LPAREN,
    ACTIONS(5371), 1,
      anon_sym_LBRACK,
    ACTIONS(5374), 1,
      anon_sym_LBRACE,
    ACTIONS(5376), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5379), 1,
      sym_symboly_id,
    ACTIONS(5382), 1,
      sym_path,
    ACTIONS(5385), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5388), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    ACTIONS(5189), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1395), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [5444] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      aux_sym_literal_char_token1,
    ACTIONS(705), 1,
      anon_sym_BANG,
    ACTIONS(707), 1,
      sym_do,
    ACTIONS(709), 1,
      sym_kw_let,
    ACTIONS(711), 1,
      sym_match,
    ACTIONS(713), 1,
      sym_cases,
    ACTIONS(715), 1,
      sym_kw_termlink,
    ACTIONS(717), 1,
      sym_kw_typelink,
    ACTIONS(719), 1,
      sym_handle,
    ACTIONS(1477), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1479), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_SQUOTE,
    ACTIONS(1487), 1,
      sym_rewrite,
    ACTIONS(1489), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5303), 1,
      anon_sym_LPAREN,
    ACTIONS(5305), 1,
      sym_path,
    STATE(1342), 1,
      aux_sym__term4,
    STATE(2458), 1,
      sym_wordy_id,
    STATE(3106), 1,
      sym__hq_qualified_prefix_term,
    STATE(3636), 1,
      sym__match_with,
    STATE(7118), 1,
      sym_kw_if,
    ACTIONS(697), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(731), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2973), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3642), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(689), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(733), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3717), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3640), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5572] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1521), 1,
      anon_sym_DQUOTE,
    ACTIONS(1525), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1535), 1,
      anon_sym_BANG,
    ACTIONS(1537), 1,
      sym_do,
    ACTIONS(1539), 1,
      sym_kw_let,
    ACTIONS(1541), 1,
      sym_match,
    ACTIONS(1543), 1,
      sym_cases,
    ACTIONS(1547), 1,
      sym_kw_termlink,
    ACTIONS(1549), 1,
      sym_kw_typelink,
    ACTIONS(1551), 1,
      sym_handle,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2059), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2061), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2065), 1,
      anon_sym_LBRACK,
    ACTIONS(2067), 1,
      anon_sym_SQUOTE,
    ACTIONS(2069), 1,
      sym_rewrite,
    ACTIONS(2073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5299), 1,
      anon_sym_LPAREN,
    ACTIONS(5301), 1,
      sym_path,
    STATE(1183), 1,
      aux_sym__term4,
    STATE(1632), 1,
      sym_wordy_id,
    STATE(1962), 1,
      sym__hq_qualified_prefix_term,
    STATE(2055), 1,
      sym__match_with,
    STATE(7116), 1,
      sym_kw_if,
    ACTIONS(1527), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1563), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1981), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2054), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1519), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1565), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2057), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2056), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5700] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(2331), 1,
      anon_sym_SQUOTE,
    ACTIONS(2333), 1,
      anon_sym_BANG,
    ACTIONS(2335), 1,
      sym_do,
    ACTIONS(2337), 1,
      sym_handle,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(1348), 1,
      aux_sym__term4,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1259), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1271), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3525), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5828] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(839), 1,
      anon_sym_BANG,
    ACTIONS(841), 1,
      sym_do,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(853), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1473), 1,
      anon_sym_SQUOTE,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(1304), 1,
      aux_sym__term4,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(823), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(867), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3527), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [5956] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(401), 1,
      anon_sym_BANG,
    ACTIONS(403), 1,
      sym_do,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(415), 1,
      sym_handle,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1475), 1,
      anon_sym_SQUOTE,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(1307), 1,
      aux_sym__term4,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(385), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(431), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2392), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6084] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2225), 1,
      anon_sym_DQUOTE,
    ACTIONS(2227), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2229), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2231), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2239), 1,
      anon_sym_LBRACK,
    ACTIONS(2241), 1,
      anon_sym_SQUOTE,
    ACTIONS(2243), 1,
      anon_sym_BANG,
    ACTIONS(2245), 1,
      sym_do,
    ACTIONS(2247), 1,
      sym_kw_let,
    ACTIONS(2249), 1,
      sym_match,
    ACTIONS(2251), 1,
      sym_cases,
    ACTIONS(2253), 1,
      sym_kw_termlink,
    ACTIONS(2255), 1,
      sym_kw_typelink,
    ACTIONS(2257), 1,
      sym_handle,
    ACTIONS(2259), 1,
      sym_rewrite,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2265), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5287), 1,
      anon_sym_LPAREN,
    ACTIONS(5289), 1,
      sym_path,
    STATE(1341), 1,
      aux_sym__term4,
    STATE(2780), 1,
      sym_wordy_id,
    STATE(3377), 1,
      sym__hq_qualified_prefix_term,
    STATE(3859), 1,
      sym__match_with,
    STATE(7115), 1,
      sym_kw_if,
    ACTIONS(2233), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2267), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3369), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3855), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(2223), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(2235), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3866), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3863), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6212] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5374), 1,
      anon_sym_LBRACE,
    ACTIONS(5395), 1,
      anon_sym_LPAREN,
    ACTIONS(5398), 1,
      anon_sym_LBRACK,
    ACTIONS(5401), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5404), 1,
      sym_symboly_id,
    ACTIONS(5407), 1,
      sym_path,
    ACTIONS(5410), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5413), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    ACTIONS(5123), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1372), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [6302] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(401), 1,
      anon_sym_BANG,
    ACTIONS(403), 1,
      sym_do,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(415), 1,
      sym_handle,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1475), 1,
      anon_sym_SQUOTE,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(1247), 1,
      aux_sym__term4,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(385), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(431), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2392), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6430] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    ACTIONS(1285), 1,
      anon_sym_BANG,
    ACTIONS(1287), 1,
      sym_do,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1299), 1,
      sym_handle,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(1339), 1,
      aux_sym__term4,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(1259), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(1271), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3525), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6558] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(757), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym_do,
    ACTIONS(761), 1,
      sym_kw_let,
    ACTIONS(763), 1,
      sym_match,
    ACTIONS(765), 1,
      sym_cases,
    ACTIONS(767), 1,
      sym_kw_termlink,
    ACTIONS(769), 1,
      sym_kw_typelink,
    ACTIONS(771), 1,
      sym_handle,
    ACTIONS(2027), 1,
      anon_sym_DQUOTE,
    ACTIONS(2029), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2031), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2033), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2039), 1,
      anon_sym_LBRACK,
    ACTIONS(2041), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      sym_rewrite,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2049), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5342), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      sym_path,
    STATE(1340), 1,
      aux_sym__term4,
    STATE(2769), 1,
      sym_wordy_id,
    STATE(3760), 1,
      sym__hq_qualified_prefix_term,
    STATE(3865), 1,
      sym__match_with,
    STATE(7112), 1,
      sym_kw_if,
    ACTIONS(2035), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2051), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3739), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3890), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(737), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(789), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3860), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3861), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6686] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(533), 1,
      anon_sym_BANG,
    ACTIONS(535), 1,
      sym_do,
    ACTIONS(537), 1,
      sym_handle,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1439), 1,
      anon_sym_SQUOTE,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(1260), 1,
      aux_sym__term4,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(385), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(431), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2392), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6814] = 34,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(485), 1,
      anon_sym_DQUOTE,
    ACTIONS(489), 1,
      aux_sym_literal_char_token1,
    ACTIONS(499), 1,
      anon_sym_BANG,
    ACTIONS(501), 1,
      sym_do,
    ACTIONS(503), 1,
      sym_kw_let,
    ACTIONS(505), 1,
      sym_match,
    ACTIONS(507), 1,
      sym_cases,
    ACTIONS(509), 1,
      sym_kw_termlink,
    ACTIONS(511), 1,
      sym_kw_typelink,
    ACTIONS(513), 1,
      sym_handle,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1491), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1493), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_SQUOTE,
    ACTIONS(1501), 1,
      sym_rewrite,
    ACTIONS(1503), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5416), 1,
      anon_sym_LPAREN,
    ACTIONS(5418), 1,
      sym_path,
    STATE(1254), 1,
      aux_sym__term4,
    STATE(2370), 1,
      sym_wordy_id,
    STATE(2845), 1,
      sym__hq_qualified_prefix_term,
    STATE(2950), 1,
      sym__match_with,
    STATE(7124), 1,
      sym_kw_if,
    ACTIONS(491), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(527), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2707), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2952), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(483), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(529), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2947), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2948), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [6942] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    ACTIONS(191), 1,
      aux_sym_literal_char_token1,
    ACTIONS(201), 1,
      anon_sym_BANG,
    ACTIONS(203), 1,
      sym_do,
    ACTIONS(205), 1,
      sym_kw_let,
    ACTIONS(207), 1,
      sym_match,
    ACTIONS(209), 1,
      sym_cases,
    ACTIONS(211), 1,
      sym_kw_termlink,
    ACTIONS(213), 1,
      sym_kw_typelink,
    ACTIONS(215), 1,
      sym_handle,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1459), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1461), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1465), 1,
      anon_sym_LBRACK,
    ACTIONS(1467), 1,
      anon_sym_SQUOTE,
    ACTIONS(1469), 1,
      sym_rewrite,
    ACTIONS(1471), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5362), 1,
      anon_sym_LPAREN,
    ACTIONS(5364), 1,
      sym_path,
    STATE(1513), 1,
      sym_wordy_id,
    STATE(1769), 1,
      sym__hq_qualified_prefix_term,
    STATE(1856), 1,
      sym__match_with,
    STATE(7113), 1,
      sym_kw_if,
    ACTIONS(193), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(227), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1800), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1883), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5420), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5422), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1859), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1874), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7067] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(485), 1,
      anon_sym_DQUOTE,
    ACTIONS(489), 1,
      aux_sym_literal_char_token1,
    ACTIONS(499), 1,
      anon_sym_BANG,
    ACTIONS(501), 1,
      sym_do,
    ACTIONS(503), 1,
      sym_kw_let,
    ACTIONS(505), 1,
      sym_match,
    ACTIONS(507), 1,
      sym_cases,
    ACTIONS(509), 1,
      sym_kw_termlink,
    ACTIONS(511), 1,
      sym_kw_typelink,
    ACTIONS(513), 1,
      sym_handle,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1491), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1493), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_SQUOTE,
    ACTIONS(1501), 1,
      sym_rewrite,
    ACTIONS(1503), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5416), 1,
      anon_sym_LPAREN,
    ACTIONS(5418), 1,
      sym_path,
    STATE(2370), 1,
      sym_wordy_id,
    STATE(2845), 1,
      sym__hq_qualified_prefix_term,
    STATE(2950), 1,
      sym__match_with,
    STATE(7124), 1,
      sym_kw_if,
    ACTIONS(491), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(527), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2707), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2952), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5424), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5426), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2947), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2929), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7192] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(2331), 1,
      anon_sym_SQUOTE,
    ACTIONS(2333), 1,
      anon_sym_BANG,
    ACTIONS(2335), 1,
      sym_do,
    ACTIONS(2337), 1,
      sym_handle,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5428), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5430), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3510), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7317] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(187), 1,
      anon_sym_DQUOTE,
    ACTIONS(191), 1,
      aux_sym_literal_char_token1,
    ACTIONS(201), 1,
      anon_sym_BANG,
    ACTIONS(203), 1,
      sym_do,
    ACTIONS(205), 1,
      sym_kw_let,
    ACTIONS(207), 1,
      sym_match,
    ACTIONS(209), 1,
      sym_cases,
    ACTIONS(211), 1,
      sym_kw_termlink,
    ACTIONS(213), 1,
      sym_kw_typelink,
    ACTIONS(215), 1,
      sym_handle,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1459), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1461), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1465), 1,
      anon_sym_LBRACK,
    ACTIONS(1467), 1,
      anon_sym_SQUOTE,
    ACTIONS(1469), 1,
      sym_rewrite,
    ACTIONS(1471), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5362), 1,
      anon_sym_LPAREN,
    ACTIONS(5364), 1,
      sym_path,
    STATE(1513), 1,
      sym_wordy_id,
    STATE(1769), 1,
      sym__hq_qualified_prefix_term,
    STATE(1856), 1,
      sym__match_with,
    STATE(7113), 1,
      sym_kw_if,
    ACTIONS(193), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(227), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1800), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1883), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5432), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5434), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1859), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1875), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7442] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(1047), 1,
      anon_sym_BANG,
    ACTIONS(1049), 1,
      sym_do,
    ACTIONS(1051), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1425), 1,
      anon_sym_SQUOTE,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5436), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5438), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3517), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7567] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(1047), 1,
      anon_sym_BANG,
    ACTIONS(1049), 1,
      sym_do,
    ACTIONS(1051), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1425), 1,
      anon_sym_SQUOTE,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5440), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5442), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3516), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7692] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5446), 1,
      anon_sym_LPAREN,
    ACTIONS(5449), 1,
      anon_sym_LBRACK,
    ACTIONS(5452), 1,
      anon_sym_LBRACE,
    ACTIONS(5454), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5457), 1,
      sym_symboly_id,
    ACTIONS(5460), 1,
      sym_path,
    ACTIONS(5463), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5466), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    ACTIONS(5189), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1431), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [7781] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(757), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym_do,
    ACTIONS(761), 1,
      sym_kw_let,
    ACTIONS(763), 1,
      sym_match,
    ACTIONS(765), 1,
      sym_cases,
    ACTIONS(767), 1,
      sym_kw_termlink,
    ACTIONS(769), 1,
      sym_kw_typelink,
    ACTIONS(771), 1,
      sym_handle,
    ACTIONS(2027), 1,
      anon_sym_DQUOTE,
    ACTIONS(2029), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2031), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2033), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2039), 1,
      anon_sym_LBRACK,
    ACTIONS(2041), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      sym_rewrite,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2049), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5342), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      sym_path,
    STATE(2769), 1,
      sym_wordy_id,
    STATE(3760), 1,
      sym__hq_qualified_prefix_term,
    STATE(3865), 1,
      sym__match_with,
    STATE(7112), 1,
      sym_kw_if,
    ACTIONS(2035), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2051), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3739), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3890), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5469), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5471), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3860), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3837), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [7906] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(2331), 1,
      anon_sym_SQUOTE,
    ACTIONS(2333), 1,
      anon_sym_BANG,
    ACTIONS(2335), 1,
      sym_do,
    ACTIONS(2337), 1,
      sym_handle,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5473), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5475), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3511), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8031] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2135), 1,
      anon_sym_DQUOTE,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2139), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2141), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2149), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      anon_sym_SQUOTE,
    ACTIONS(2153), 1,
      anon_sym_BANG,
    ACTIONS(2155), 1,
      sym_do,
    ACTIONS(2157), 1,
      sym_kw_let,
    ACTIONS(2159), 1,
      sym_match,
    ACTIONS(2161), 1,
      sym_cases,
    ACTIONS(2163), 1,
      sym_kw_termlink,
    ACTIONS(2165), 1,
      sym_kw_typelink,
    ACTIONS(2167), 1,
      sym_handle,
    ACTIONS(2169), 1,
      sym_rewrite,
    ACTIONS(2173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5358), 1,
      anon_sym_LPAREN,
    ACTIONS(5360), 1,
      sym_path,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(2143), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2175), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5477), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5479), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4382), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8156] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5481), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5484), 1,
      anon_sym_LPAREN,
    ACTIONS(5487), 1,
      anon_sym_LBRACK,
    ACTIONS(5490), 1,
      anon_sym_LBRACE,
    ACTIONS(5493), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5496), 1,
      sym_symboly_id,
    ACTIONS(5499), 1,
      sym_path,
    ACTIONS(5502), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5505), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    ACTIONS(5158), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1411), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [8245] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1521), 1,
      anon_sym_DQUOTE,
    ACTIONS(1525), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1535), 1,
      anon_sym_BANG,
    ACTIONS(1537), 1,
      sym_do,
    ACTIONS(1539), 1,
      sym_kw_let,
    ACTIONS(1541), 1,
      sym_match,
    ACTIONS(1543), 1,
      sym_cases,
    ACTIONS(1547), 1,
      sym_kw_termlink,
    ACTIONS(1549), 1,
      sym_kw_typelink,
    ACTIONS(1551), 1,
      sym_handle,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2059), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2061), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2065), 1,
      anon_sym_LBRACK,
    ACTIONS(2067), 1,
      anon_sym_SQUOTE,
    ACTIONS(2069), 1,
      sym_rewrite,
    ACTIONS(2073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5299), 1,
      anon_sym_LPAREN,
    ACTIONS(5301), 1,
      sym_path,
    STATE(1632), 1,
      sym_wordy_id,
    STATE(1962), 1,
      sym__hq_qualified_prefix_term,
    STATE(2055), 1,
      sym__match_with,
    STATE(7116), 1,
      sym_kw_if,
    ACTIONS(1527), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1563), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1981), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2054), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5508), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5510), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2057), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2069), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8370] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2135), 1,
      anon_sym_DQUOTE,
    ACTIONS(2137), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2139), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2141), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2149), 1,
      anon_sym_LBRACK,
    ACTIONS(2151), 1,
      anon_sym_SQUOTE,
    ACTIONS(2153), 1,
      anon_sym_BANG,
    ACTIONS(2155), 1,
      sym_do,
    ACTIONS(2157), 1,
      sym_kw_let,
    ACTIONS(2159), 1,
      sym_match,
    ACTIONS(2161), 1,
      sym_cases,
    ACTIONS(2163), 1,
      sym_kw_termlink,
    ACTIONS(2165), 1,
      sym_kw_typelink,
    ACTIONS(2167), 1,
      sym_handle,
    ACTIONS(2169), 1,
      sym_rewrite,
    ACTIONS(2173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5358), 1,
      anon_sym_LPAREN,
    ACTIONS(5360), 1,
      sym_path,
    STATE(3244), 1,
      sym_wordy_id,
    STATE(3823), 1,
      sym__hq_qualified_prefix_term,
    STATE(4346), 1,
      sym__match_with,
    STATE(7119), 1,
      sym_kw_if,
    ACTIONS(2143), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2175), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4031), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4345), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5512), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5514), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4352), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4387), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8495] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1935), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1937), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_SQUOTE,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1965), 1,
      sym_rewrite,
    ACTIONS(1971), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5152), 1,
      anon_sym_LPAREN,
    ACTIONS(5156), 1,
      sym_path,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1973), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5516), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5518), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4406), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8620] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1931), 1,
      anon_sym_DQUOTE,
    ACTIONS(1933), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1935), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1937), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1945), 1,
      anon_sym_LBRACK,
    ACTIONS(1947), 1,
      anon_sym_SQUOTE,
    ACTIONS(1949), 1,
      anon_sym_BANG,
    ACTIONS(1951), 1,
      sym_do,
    ACTIONS(1953), 1,
      sym_kw_let,
    ACTIONS(1955), 1,
      sym_match,
    ACTIONS(1957), 1,
      sym_cases,
    ACTIONS(1959), 1,
      sym_kw_termlink,
    ACTIONS(1961), 1,
      sym_kw_typelink,
    ACTIONS(1963), 1,
      sym_handle,
    ACTIONS(1965), 1,
      sym_rewrite,
    ACTIONS(1971), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5152), 1,
      anon_sym_LPAREN,
    ACTIONS(5156), 1,
      sym_path,
    STATE(3406), 1,
      sym_wordy_id,
    STATE(4294), 1,
      sym__hq_qualified_prefix_term,
    STATE(4401), 1,
      sym__match_with,
    STATE(7123), 1,
      sym_kw_if,
    ACTIONS(1939), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1973), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4355), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4398), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5520), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5522), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4403), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4405), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8745] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(757), 1,
      anon_sym_BANG,
    ACTIONS(759), 1,
      sym_do,
    ACTIONS(761), 1,
      sym_kw_let,
    ACTIONS(763), 1,
      sym_match,
    ACTIONS(765), 1,
      sym_cases,
    ACTIONS(767), 1,
      sym_kw_termlink,
    ACTIONS(769), 1,
      sym_kw_typelink,
    ACTIONS(771), 1,
      sym_handle,
    ACTIONS(2027), 1,
      anon_sym_DQUOTE,
    ACTIONS(2029), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2031), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2033), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2039), 1,
      anon_sym_LBRACK,
    ACTIONS(2041), 1,
      anon_sym_SQUOTE,
    ACTIONS(2043), 1,
      sym_rewrite,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2049), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5342), 1,
      anon_sym_LPAREN,
    ACTIONS(5344), 1,
      sym_path,
    STATE(2769), 1,
      sym_wordy_id,
    STATE(3760), 1,
      sym__hq_qualified_prefix_term,
    STATE(3865), 1,
      sym__match_with,
    STATE(7112), 1,
      sym_kw_if,
    ACTIONS(2035), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2051), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3739), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3890), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5524), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5526), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3860), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3843), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8870] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1521), 1,
      anon_sym_DQUOTE,
    ACTIONS(1525), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1535), 1,
      anon_sym_BANG,
    ACTIONS(1537), 1,
      sym_do,
    ACTIONS(1539), 1,
      sym_kw_let,
    ACTIONS(1541), 1,
      sym_match,
    ACTIONS(1543), 1,
      sym_cases,
    ACTIONS(1547), 1,
      sym_kw_termlink,
    ACTIONS(1549), 1,
      sym_kw_typelink,
    ACTIONS(1551), 1,
      sym_handle,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2059), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2061), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2065), 1,
      anon_sym_LBRACK,
    ACTIONS(2067), 1,
      anon_sym_SQUOTE,
    ACTIONS(2069), 1,
      sym_rewrite,
    ACTIONS(2073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5299), 1,
      anon_sym_LPAREN,
    ACTIONS(5301), 1,
      sym_path,
    STATE(1632), 1,
      sym_wordy_id,
    STATE(1962), 1,
      sym__hq_qualified_prefix_term,
    STATE(2055), 1,
      sym__match_with,
    STATE(7116), 1,
      sym_kw_if,
    ACTIONS(1527), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1563), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1981), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2054), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5528), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5530), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2057), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2067), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [8995] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(37), 1,
      aux_sym_literal_char_token1,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_BANG,
    ACTIONS(53), 1,
      sym_do,
    ACTIONS(55), 1,
      sym_kw_let,
    ACTIONS(57), 1,
      sym_match,
    ACTIONS(59), 1,
      sym_cases,
    ACTIONS(61), 1,
      sym_kw_termlink,
    ACTIONS(63), 1,
      sym_kw_typelink,
    ACTIONS(65), 1,
      sym_handle,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1505), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1507), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_SQUOTE,
    ACTIONS(1515), 1,
      sym_rewrite,
    ACTIONS(1517), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5295), 1,
      anon_sym_LPAREN,
    ACTIONS(5297), 1,
      sym_path,
    STATE(1485), 1,
      sym_wordy_id,
    STATE(1566), 1,
      sym__hq_qualified_prefix_term,
    STATE(1727), 1,
      sym__match_with,
    STATE(7121), 1,
      sym_kw_if,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(79), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1557), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1725), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5532), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5534), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1733), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1742), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9120] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1981), 1,
      anon_sym_DQUOTE,
    ACTIONS(1983), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1985), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1987), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1995), 1,
      anon_sym_LBRACK,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_BANG,
    ACTIONS(2001), 1,
      sym_do,
    ACTIONS(2003), 1,
      sym_kw_let,
    ACTIONS(2005), 1,
      sym_match,
    ACTIONS(2007), 1,
      sym_cases,
    ACTIONS(2009), 1,
      sym_kw_termlink,
    ACTIONS(2011), 1,
      sym_kw_typelink,
    ACTIONS(2013), 1,
      sym_handle,
    ACTIONS(2015), 1,
      sym_rewrite,
    ACTIONS(2021), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      sym_path,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(1989), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2023), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5536), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5538), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4479), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9245] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(33), 1,
      anon_sym_DQUOTE,
    ACTIONS(37), 1,
      aux_sym_literal_char_token1,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(51), 1,
      anon_sym_BANG,
    ACTIONS(53), 1,
      sym_do,
    ACTIONS(55), 1,
      sym_kw_let,
    ACTIONS(57), 1,
      sym_match,
    ACTIONS(59), 1,
      sym_cases,
    ACTIONS(61), 1,
      sym_kw_termlink,
    ACTIONS(63), 1,
      sym_kw_typelink,
    ACTIONS(65), 1,
      sym_handle,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1505), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1507), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1511), 1,
      anon_sym_LBRACK,
    ACTIONS(1513), 1,
      anon_sym_SQUOTE,
    ACTIONS(1515), 1,
      sym_rewrite,
    ACTIONS(1517), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5295), 1,
      anon_sym_LPAREN,
    ACTIONS(5297), 1,
      sym_path,
    STATE(1485), 1,
      sym_wordy_id,
    STATE(1566), 1,
      sym__hq_qualified_prefix_term,
    STATE(1727), 1,
      sym__match_with,
    STATE(7121), 1,
      sym_kw_if,
    ACTIONS(39), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(79), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1557), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(1725), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5540), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5542), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(1733), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(1741), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9370] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1575), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1589), 1,
      anon_sym_BANG,
    ACTIONS(1591), 1,
      sym_do,
    ACTIONS(1593), 1,
      sym_kw_let,
    ACTIONS(1595), 1,
      sym_match,
    ACTIONS(1597), 1,
      sym_cases,
    ACTIONS(1601), 1,
      sym_kw_termlink,
    ACTIONS(1603), 1,
      sym_kw_typelink,
    ACTIONS(1605), 1,
      sym_handle,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2181), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2183), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2187), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_SQUOTE,
    ACTIONS(2191), 1,
      sym_rewrite,
    ACTIONS(2195), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5346), 1,
      anon_sym_LPAREN,
    ACTIONS(5348), 1,
      sym_path,
    STATE(1943), 1,
      sym_wordy_id,
    STATE(2098), 1,
      sym__hq_qualified_prefix_term,
    STATE(2205), 1,
      sym__match_with,
    STATE(7030), 1,
      sym_kw_if,
    ACTIONS(1581), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1617), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1986), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2135), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5544), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5546), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2209), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2188), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9495] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1575), 1,
      anon_sym_DQUOTE,
    ACTIONS(1579), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1589), 1,
      anon_sym_BANG,
    ACTIONS(1591), 1,
      sym_do,
    ACTIONS(1593), 1,
      sym_kw_let,
    ACTIONS(1595), 1,
      sym_match,
    ACTIONS(1597), 1,
      sym_cases,
    ACTIONS(1601), 1,
      sym_kw_termlink,
    ACTIONS(1603), 1,
      sym_kw_typelink,
    ACTIONS(1605), 1,
      sym_handle,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2181), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2183), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2187), 1,
      anon_sym_LBRACK,
    ACTIONS(2189), 1,
      anon_sym_SQUOTE,
    ACTIONS(2191), 1,
      sym_rewrite,
    ACTIONS(2195), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5346), 1,
      anon_sym_LPAREN,
    ACTIONS(5348), 1,
      sym_path,
    STATE(1943), 1,
      sym_wordy_id,
    STATE(2098), 1,
      sym__hq_qualified_prefix_term,
    STATE(2205), 1,
      sym__match_with,
    STATE(7030), 1,
      sym_kw_if,
    ACTIONS(1581), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(1617), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(1986), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2135), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5548), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5550), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2209), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2198), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9620] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1981), 1,
      anon_sym_DQUOTE,
    ACTIONS(1983), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1985), 1,
      aux_sym_literal_char_token1,
    ACTIONS(1987), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1995), 1,
      anon_sym_LBRACK,
    ACTIONS(1997), 1,
      anon_sym_SQUOTE,
    ACTIONS(1999), 1,
      anon_sym_BANG,
    ACTIONS(2001), 1,
      sym_do,
    ACTIONS(2003), 1,
      sym_kw_let,
    ACTIONS(2005), 1,
      sym_match,
    ACTIONS(2007), 1,
      sym_cases,
    ACTIONS(2009), 1,
      sym_kw_termlink,
    ACTIONS(2011), 1,
      sym_kw_typelink,
    ACTIONS(2013), 1,
      sym_handle,
    ACTIONS(2015), 1,
      sym_rewrite,
    ACTIONS(2021), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5338), 1,
      anon_sym_LPAREN,
    ACTIONS(5340), 1,
      sym_path,
    STATE(3613), 1,
      sym_wordy_id,
    STATE(4197), 1,
      sym__hq_qualified_prefix_term,
    STATE(4470), 1,
      sym__match_with,
    STATE(7111), 1,
      sym_kw_if,
    ACTIONS(1989), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2023), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(4170), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4464), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5552), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5554), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4473), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4480), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9745] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_literal_char_token1,
    ACTIONS(567), 1,
      anon_sym_BANG,
    ACTIONS(569), 1,
      sym_do,
    ACTIONS(571), 1,
      sym_kw_let,
    ACTIONS(573), 1,
      sym_match,
    ACTIONS(575), 1,
      sym_cases,
    ACTIONS(577), 1,
      sym_kw_termlink,
    ACTIONS(579), 1,
      sym_kw_typelink,
    ACTIONS(581), 1,
      sym_handle,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1445), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1447), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1451), 1,
      anon_sym_LBRACK,
    ACTIONS(1453), 1,
      anon_sym_SQUOTE,
    ACTIONS(1455), 1,
      sym_rewrite,
    ACTIONS(1457), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5334), 1,
      anon_sym_LPAREN,
    ACTIONS(5336), 1,
      sym_path,
    STATE(2329), 1,
      sym_wordy_id,
    STATE(2662), 1,
      sym__hq_qualified_prefix_term,
    STATE(3204), 1,
      sym__match_with,
    STATE(7122), 1,
      sym_kw_if,
    ACTIONS(559), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(595), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2824), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3203), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5556), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5558), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3206), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3216), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9870] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      aux_sym_literal_char_token1,
    ACTIONS(705), 1,
      anon_sym_BANG,
    ACTIONS(707), 1,
      sym_do,
    ACTIONS(709), 1,
      sym_kw_let,
    ACTIONS(711), 1,
      sym_match,
    ACTIONS(713), 1,
      sym_cases,
    ACTIONS(715), 1,
      sym_kw_termlink,
    ACTIONS(717), 1,
      sym_kw_typelink,
    ACTIONS(719), 1,
      sym_handle,
    ACTIONS(1477), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1479), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_SQUOTE,
    ACTIONS(1487), 1,
      sym_rewrite,
    ACTIONS(1489), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5303), 1,
      anon_sym_LPAREN,
    ACTIONS(5305), 1,
      sym_path,
    STATE(2458), 1,
      sym_wordy_id,
    STATE(3106), 1,
      sym__hq_qualified_prefix_term,
    STATE(3636), 1,
      sym__match_with,
    STATE(7118), 1,
      sym_kw_if,
    ACTIONS(697), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(731), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2973), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3642), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5560), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5562), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3717), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3653), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [9995] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(691), 1,
      anon_sym_DQUOTE,
    ACTIONS(695), 1,
      aux_sym_literal_char_token1,
    ACTIONS(705), 1,
      anon_sym_BANG,
    ACTIONS(707), 1,
      sym_do,
    ACTIONS(709), 1,
      sym_kw_let,
    ACTIONS(711), 1,
      sym_match,
    ACTIONS(713), 1,
      sym_cases,
    ACTIONS(715), 1,
      sym_kw_termlink,
    ACTIONS(717), 1,
      sym_kw_typelink,
    ACTIONS(719), 1,
      sym_handle,
    ACTIONS(1477), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1479), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1483), 1,
      anon_sym_LBRACK,
    ACTIONS(1485), 1,
      anon_sym_SQUOTE,
    ACTIONS(1487), 1,
      sym_rewrite,
    ACTIONS(1489), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5303), 1,
      anon_sym_LPAREN,
    ACTIONS(5305), 1,
      sym_path,
    STATE(2458), 1,
      sym_wordy_id,
    STATE(3106), 1,
      sym__hq_qualified_prefix_term,
    STATE(3636), 1,
      sym__match_with,
    STATE(7118), 1,
      sym_kw_if,
    ACTIONS(697), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(731), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2973), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3642), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5564), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5566), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3717), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3651), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10120] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(553), 1,
      anon_sym_DQUOTE,
    ACTIONS(557), 1,
      aux_sym_literal_char_token1,
    ACTIONS(567), 1,
      anon_sym_BANG,
    ACTIONS(569), 1,
      sym_do,
    ACTIONS(571), 1,
      sym_kw_let,
    ACTIONS(573), 1,
      sym_match,
    ACTIONS(575), 1,
      sym_cases,
    ACTIONS(577), 1,
      sym_kw_termlink,
    ACTIONS(579), 1,
      sym_kw_typelink,
    ACTIONS(581), 1,
      sym_handle,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1445), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1447), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1451), 1,
      anon_sym_LBRACK,
    ACTIONS(1453), 1,
      anon_sym_SQUOTE,
    ACTIONS(1455), 1,
      sym_rewrite,
    ACTIONS(1457), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5334), 1,
      anon_sym_LPAREN,
    ACTIONS(5336), 1,
      sym_path,
    STATE(2329), 1,
      sym_wordy_id,
    STATE(2662), 1,
      sym__hq_qualified_prefix_term,
    STATE(3204), 1,
      sym__match_with,
    STATE(7122), 1,
      sym_kw_if,
    ACTIONS(559), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(595), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2824), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3203), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5568), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5570), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3206), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3218), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10245] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(839), 1,
      anon_sym_BANG,
    ACTIONS(841), 1,
      sym_do,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(853), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1473), 1,
      anon_sym_SQUOTE,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5436), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5438), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3517), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10370] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2225), 1,
      anon_sym_DQUOTE,
    ACTIONS(2227), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2229), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2231), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2239), 1,
      anon_sym_LBRACK,
    ACTIONS(2241), 1,
      anon_sym_SQUOTE,
    ACTIONS(2243), 1,
      anon_sym_BANG,
    ACTIONS(2245), 1,
      sym_do,
    ACTIONS(2247), 1,
      sym_kw_let,
    ACTIONS(2249), 1,
      sym_match,
    ACTIONS(2251), 1,
      sym_cases,
    ACTIONS(2253), 1,
      sym_kw_termlink,
    ACTIONS(2255), 1,
      sym_kw_typelink,
    ACTIONS(2257), 1,
      sym_handle,
    ACTIONS(2259), 1,
      sym_rewrite,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2265), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5287), 1,
      anon_sym_LPAREN,
    ACTIONS(5289), 1,
      sym_path,
    STATE(2780), 1,
      sym_wordy_id,
    STATE(3377), 1,
      sym__hq_qualified_prefix_term,
    STATE(3859), 1,
      sym__match_with,
    STATE(7115), 1,
      sym_kw_if,
    ACTIONS(2233), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2267), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3369), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3855), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5572), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5574), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3866), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3874), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10495] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(401), 1,
      anon_sym_BANG,
    ACTIONS(403), 1,
      sym_do,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(415), 1,
      sym_handle,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1475), 1,
      anon_sym_SQUOTE,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5576), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5578), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2611), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10620] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5452), 1,
      anon_sym_LBRACE,
    ACTIONS(5580), 1,
      anon_sym_LPAREN,
    ACTIONS(5583), 1,
      anon_sym_LBRACK,
    ACTIONS(5586), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5589), 1,
      sym_symboly_id,
    ACTIONS(5592), 1,
      sym_path,
    ACTIONS(5595), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5598), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    ACTIONS(5123), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(1411), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [10709] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2225), 1,
      anon_sym_DQUOTE,
    ACTIONS(2227), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2229), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2231), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2239), 1,
      anon_sym_LBRACK,
    ACTIONS(2241), 1,
      anon_sym_SQUOTE,
    ACTIONS(2243), 1,
      anon_sym_BANG,
    ACTIONS(2245), 1,
      sym_do,
    ACTIONS(2247), 1,
      sym_kw_let,
    ACTIONS(2249), 1,
      sym_match,
    ACTIONS(2251), 1,
      sym_cases,
    ACTIONS(2253), 1,
      sym_kw_termlink,
    ACTIONS(2255), 1,
      sym_kw_typelink,
    ACTIONS(2257), 1,
      sym_handle,
    ACTIONS(2259), 1,
      sym_rewrite,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2265), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5287), 1,
      anon_sym_LPAREN,
    ACTIONS(5289), 1,
      sym_path,
    STATE(2780), 1,
      sym_wordy_id,
    STATE(3377), 1,
      sym__hq_qualified_prefix_term,
    STATE(3859), 1,
      sym__match_with,
    STATE(7115), 1,
      sym_kw_if,
    ACTIONS(2233), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2267), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3369), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3855), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5601), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5603), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3866), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3872), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10834] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(401), 1,
      anon_sym_BANG,
    ACTIONS(403), 1,
      sym_do,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(415), 1,
      sym_handle,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1475), 1,
      anon_sym_SQUOTE,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5605), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5607), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2612), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [10959] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    ACTIONS(1285), 1,
      anon_sym_BANG,
    ACTIONS(1287), 1,
      sym_do,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1299), 1,
      sym_handle,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5473), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5475), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3511), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11084] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(533), 1,
      anon_sym_BANG,
    ACTIONS(535), 1,
      sym_do,
    ACTIONS(537), 1,
      sym_handle,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1439), 1,
      anon_sym_SQUOTE,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5576), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5578), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2611), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11209] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2083), 1,
      anon_sym_DQUOTE,
    ACTIONS(2085), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2087), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2089), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2097), 1,
      anon_sym_LBRACK,
    ACTIONS(2099), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_BANG,
    ACTIONS(2103), 1,
      sym_do,
    ACTIONS(2105), 1,
      sym_kw_let,
    ACTIONS(2107), 1,
      sym_match,
    ACTIONS(2109), 1,
      sym_cases,
    ACTIONS(2111), 1,
      sym_kw_termlink,
    ACTIONS(2113), 1,
      sym_kw_typelink,
    ACTIONS(2115), 1,
      sym_handle,
    ACTIONS(2117), 1,
      sym_rewrite,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2123), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5350), 1,
      anon_sym_LPAREN,
    ACTIONS(5352), 1,
      sym_path,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(2091), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2125), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5609), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5611), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4171), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11334] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(2083), 1,
      anon_sym_DQUOTE,
    ACTIONS(2085), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2087), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2089), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2097), 1,
      anon_sym_LBRACK,
    ACTIONS(2099), 1,
      anon_sym_SQUOTE,
    ACTIONS(2101), 1,
      anon_sym_BANG,
    ACTIONS(2103), 1,
      sym_do,
    ACTIONS(2105), 1,
      sym_kw_let,
    ACTIONS(2107), 1,
      sym_match,
    ACTIONS(2109), 1,
      sym_cases,
    ACTIONS(2111), 1,
      sym_kw_termlink,
    ACTIONS(2113), 1,
      sym_kw_typelink,
    ACTIONS(2115), 1,
      sym_handle,
    ACTIONS(2117), 1,
      sym_rewrite,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2123), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5350), 1,
      anon_sym_LPAREN,
    ACTIONS(5352), 1,
      sym_path,
    STATE(2949), 1,
      sym_wordy_id,
    STATE(4032), 1,
      sym__hq_qualified_prefix_term,
    STATE(4183), 1,
      sym__match_with,
    STATE(7120), 1,
      sym_kw_if,
    ACTIONS(2091), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2125), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3813), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(4184), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5613), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5615), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(4181), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(4139), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11459] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(485), 1,
      anon_sym_DQUOTE,
    ACTIONS(489), 1,
      aux_sym_literal_char_token1,
    ACTIONS(499), 1,
      anon_sym_BANG,
    ACTIONS(501), 1,
      sym_do,
    ACTIONS(503), 1,
      sym_kw_let,
    ACTIONS(505), 1,
      sym_match,
    ACTIONS(507), 1,
      sym_cases,
    ACTIONS(509), 1,
      sym_kw_termlink,
    ACTIONS(511), 1,
      sym_kw_typelink,
    ACTIONS(513), 1,
      sym_handle,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1491), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1493), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1497), 1,
      anon_sym_LBRACK,
    ACTIONS(1499), 1,
      anon_sym_SQUOTE,
    ACTIONS(1501), 1,
      sym_rewrite,
    ACTIONS(1503), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5416), 1,
      anon_sym_LPAREN,
    ACTIONS(5418), 1,
      sym_path,
    STATE(2370), 1,
      sym_wordy_id,
    STATE(2845), 1,
      sym__hq_qualified_prefix_term,
    STATE(2950), 1,
      sym__match_with,
    STATE(7124), 1,
      sym_kw_if,
    ACTIONS(491), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(527), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2707), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2952), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5617), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5619), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2947), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2926), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11584] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(1283), 1,
      anon_sym_SQUOTE,
    ACTIONS(1285), 1,
      anon_sym_BANG,
    ACTIONS(1287), 1,
      sym_do,
    ACTIONS(1289), 1,
      sym_kw_let,
    ACTIONS(1291), 1,
      sym_match,
    ACTIONS(1293), 1,
      sym_cases,
    ACTIONS(1295), 1,
      sym_kw_termlink,
    ACTIONS(1297), 1,
      sym_kw_typelink,
    ACTIONS(1299), 1,
      sym_handle,
    ACTIONS(1301), 1,
      sym_rewrite,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(2199), 1,
      anon_sym_DQUOTE,
    ACTIONS(2201), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(2203), 1,
      aux_sym_literal_char_token1,
    ACTIONS(2205), 1,
      aux_sym_literal_char_token2,
    ACTIONS(2211), 1,
      anon_sym_LBRACK,
    ACTIONS(2215), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5291), 1,
      anon_sym_LPAREN,
    ACTIONS(5293), 1,
      sym_path,
    STATE(2567), 1,
      sym_wordy_id,
    STATE(3136), 1,
      sym__hq_qualified_prefix_term,
    STATE(3526), 1,
      sym__match_with,
    STATE(7110), 1,
      sym_kw_if,
    ACTIONS(2207), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(2217), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3131), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3534), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5428), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5430), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3524), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3510), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11709] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(387), 1,
      anon_sym_DQUOTE,
    ACTIONS(391), 1,
      aux_sym_literal_char_token1,
    ACTIONS(405), 1,
      sym_kw_let,
    ACTIONS(407), 1,
      sym_match,
    ACTIONS(409), 1,
      sym_cases,
    ACTIONS(411), 1,
      sym_kw_termlink,
    ACTIONS(413), 1,
      sym_kw_typelink,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(533), 1,
      anon_sym_BANG,
    ACTIONS(535), 1,
      sym_do,
    ACTIONS(537), 1,
      sym_handle,
    ACTIONS(1431), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1433), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1437), 1,
      anon_sym_LBRACK,
    ACTIONS(1439), 1,
      anon_sym_SQUOTE,
    ACTIONS(1441), 1,
      sym_rewrite,
    ACTIONS(1443), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5391), 1,
      anon_sym_LPAREN,
    ACTIONS(5393), 1,
      sym_path,
    STATE(2261), 1,
      sym_wordy_id,
    STATE(2336), 1,
      sym__hq_qualified_prefix_term,
    STATE(2610), 1,
      sym__match_with,
    STATE(7117), 1,
      sym_kw_if,
    ACTIONS(393), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(429), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(2384), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(2614), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5605), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5607), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(2615), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(2612), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11834] = 33,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(47), 1,
      anon_sym_if,
    ACTIONS(825), 1,
      anon_sym_DQUOTE,
    ACTIONS(829), 1,
      aux_sym_literal_char_token1,
    ACTIONS(839), 1,
      anon_sym_BANG,
    ACTIONS(841), 1,
      sym_do,
    ACTIONS(843), 1,
      sym_kw_let,
    ACTIONS(845), 1,
      sym_match,
    ACTIONS(847), 1,
      sym_cases,
    ACTIONS(849), 1,
      sym_kw_termlink,
    ACTIONS(851), 1,
      sym_kw_typelink,
    ACTIONS(853), 1,
      sym_handle,
    ACTIONS(1417), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(1419), 1,
      aux_sym_literal_char_token2,
    ACTIONS(1423), 1,
      anon_sym_LBRACK,
    ACTIONS(1427), 1,
      sym_rewrite,
    ACTIONS(1429), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1473), 1,
      anon_sym_SQUOTE,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5354), 1,
      anon_sym_LPAREN,
    ACTIONS(5356), 1,
      sym_path,
    STATE(2433), 1,
      sym_wordy_id,
    STATE(3245), 1,
      sym__hq_qualified_prefix_term,
    STATE(3528), 1,
      sym__match_with,
    STATE(7114), 1,
      sym_kw_if,
    ACTIONS(831), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(865), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(3256), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(3529), 2,
      sym__pattern_matching,
      sym__lam_case,
    ACTIONS(5440), 3,
      sym_nat,
      sym_int,
      sym_float,
    ACTIONS(5442), 3,
      sym_doc_block,
      sym_literal_byte,
      sym_literal_hex,
    STATE(3523), 5,
      sym__keyword_block,
      sym_exp_if,
      sym_exp_let,
      sym_handler,
      sym_rewrite_block,
    STATE(3516), 14,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym_tuple_or_parenthesized,
      sym_literal_termlink,
      sym_literal_typelink,
      sym_delay_quote,
      sym_delay_block,
      sym_bang,
      sym__number,
      sym__link,
      sym__term_leaf,
      sym_literal_list,
      sym_force,
  [11959] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5621), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5624), 1,
      anon_sym_LPAREN,
    ACTIONS(5627), 1,
      anon_sym_LBRACK,
    ACTIONS(5630), 1,
      anon_sym_LBRACE,
    ACTIONS(5633), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5636), 1,
      sym_symboly_id,
    ACTIONS(5639), 1,
      sym_path,
    ACTIONS(5642), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5645), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1442), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [12044] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5650), 1,
      anon_sym_LPAREN,
    ACTIONS(5653), 1,
      anon_sym_LBRACK,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    ACTIONS(5658), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5661), 1,
      sym_symboly_id,
    ACTIONS(5664), 1,
      sym_path,
    ACTIONS(5667), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5670), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1442), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [12129] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5656), 1,
      anon_sym_LBRACE,
    ACTIONS(5673), 1,
      anon_sym_LPAREN,
    ACTIONS(5676), 1,
      anon_sym_LBRACK,
    ACTIONS(5679), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5682), 1,
      sym_symboly_id,
    ACTIONS(5685), 1,
      sym_path,
    ACTIONS(5688), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5691), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1443), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [12214] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5696), 1,
      anon_sym_LPAREN,
    ACTIONS(5699), 1,
      anon_sym_LBRACK,
    ACTIONS(5702), 1,
      anon_sym_LBRACE,
    ACTIONS(5704), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5707), 1,
      sym_symboly_id,
    ACTIONS(5710), 1,
      sym_path,
    ACTIONS(5713), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5716), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1456), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [12298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      aux_sym_immediate_hash_token1,
    STATE(1712), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12366] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      aux_sym_immediate_hash_token1,
    STATE(1738), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 44,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12494] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5747), 1,
      sym__dot,
    ACTIONS(5749), 1,
      sym_hash_cid,
    ACTIONS(5743), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12558] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1550), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12626] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5755), 1,
      anon_sym_LPAREN,
    ACTIONS(5758), 1,
      anon_sym_LBRACK,
    ACTIONS(5761), 1,
      anon_sym_LBRACE,
    ACTIONS(5763), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5766), 1,
      sym_symboly_id,
    ACTIONS(5769), 1,
      sym_path,
    ACTIONS(5772), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5775), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1453), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [12710] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(1452), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5782), 2,
      sym_or,
      sym_and,
    STATE(1369), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12782] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5761), 1,
      anon_sym_LBRACE,
    ACTIONS(5791), 1,
      anon_sym_LPAREN,
    ACTIONS(5794), 1,
      anon_sym_LBRACK,
    ACTIONS(5797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5800), 1,
      sym_symboly_id,
    ACTIONS(5803), 1,
      sym_path,
    ACTIONS(5806), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5809), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1460), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [12866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(1452), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(969), 2,
      sym_or,
      sym_and,
    STATE(1369), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [12938] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1496), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13002] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5702), 1,
      anon_sym_LBRACE,
    ACTIONS(5822), 1,
      anon_sym_LPAREN,
    ACTIONS(5825), 1,
      anon_sym_LBRACK,
    ACTIONS(5828), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5831), 1,
      sym_symboly_id,
    ACTIONS(5834), 1,
      sym_path,
    ACTIONS(5837), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5840), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1457), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [13086] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5843), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5846), 1,
      anon_sym_LPAREN,
    ACTIONS(5849), 1,
      anon_sym_LBRACK,
    ACTIONS(5852), 1,
      anon_sym_LBRACE,
    ACTIONS(5855), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5858), 1,
      sym_symboly_id,
    ACTIONS(5861), 1,
      sym_path,
    ACTIONS(5864), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5867), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1457), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [13170] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5874), 1,
      sym__dot,
    ACTIONS(5876), 1,
      sym_hash_cid,
    ACTIONS(5870), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1549), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13302] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5878), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5881), 1,
      anon_sym_LPAREN,
    ACTIONS(5884), 1,
      anon_sym_LBRACK,
    ACTIONS(5887), 1,
      anon_sym_LBRACE,
    ACTIONS(5890), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5893), 1,
      sym_symboly_id,
    ACTIONS(5896), 1,
      sym_path,
    ACTIONS(5899), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5902), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1460), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [13386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1550), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13451] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5905), 1,
      sym__dot,
    ACTIONS(5907), 1,
      sym_hash_cid,
    ACTIONS(5743), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13514] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13573] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(1464), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5913), 2,
      sym_or,
      sym_and,
    STATE(1384), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13644] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5916), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5919), 1,
      anon_sym_LPAREN,
    ACTIONS(5922), 1,
      anon_sym_LBRACK,
    ACTIONS(5925), 1,
      anon_sym_LBRACE,
    ACTIONS(5928), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5931), 1,
      sym_symboly_id,
    ACTIONS(5934), 1,
      sym_path,
    ACTIONS(5937), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5940), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1465), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [13727] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      aux_sym_immediate_hash_token1,
    STATE(1534), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5947), 1,
      sym_hash_cid,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13851] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1549), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5953), 1,
      sym_hash_cid,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [13977] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(1464), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(1197), 2,
      sym_or,
      sym_and,
    STATE(1384), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14048] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5957), 1,
      anon_sym_LPAREN,
    ACTIONS(5960), 1,
      anon_sym_LBRACK,
    ACTIONS(5963), 1,
      anon_sym_LBRACE,
    ACTIONS(5965), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5968), 1,
      sym_symboly_id,
    ACTIONS(5971), 1,
      sym_path,
    ACTIONS(5974), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5977), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1474), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [14131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14190] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5984), 1,
      sym__dot,
    ACTIONS(5986), 1,
      sym_hash_cid,
    ACTIONS(5870), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14253] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(5963), 1,
      anon_sym_LBRACE,
    ACTIONS(5988), 1,
      anon_sym_LPAREN,
    ACTIONS(5991), 1,
      anon_sym_LBRACK,
    ACTIONS(5994), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5997), 1,
      sym_symboly_id,
    ACTIONS(6000), 1,
      sym_path,
    ACTIONS(6003), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6006), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1465), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [14336] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6009), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6012), 1,
      anon_sym_LPAREN,
    ACTIONS(6015), 1,
      anon_sym_LBRACK,
    ACTIONS(6018), 1,
      anon_sym_LBRACE,
    ACTIONS(6021), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6024), 1,
      sym_symboly_id,
    ACTIONS(6027), 1,
      sym_path,
    ACTIONS(6030), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6033), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    ACTIONS(5158), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1475), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [14418] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6038), 1,
      anon_sym_LPAREN,
    ACTIONS(6041), 1,
      anon_sym_LBRACK,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6046), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6049), 1,
      sym_symboly_id,
    ACTIONS(6052), 1,
      sym_path,
    ACTIONS(6055), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6058), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1506), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [14500] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6063), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14558] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6067), 1,
      anon_sym_LPAREN,
    ACTIONS(6070), 1,
      anon_sym_LBRACK,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(6075), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6078), 1,
      sym_symboly_id,
    ACTIONS(6081), 1,
      sym_path,
    ACTIONS(6084), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6087), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    ACTIONS(5123), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1475), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [14640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6092), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14698] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6094), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6097), 1,
      anon_sym_LPAREN,
    ACTIONS(6100), 1,
      anon_sym_LBRACK,
    ACTIONS(6103), 1,
      anon_sym_LBRACE,
    ACTIONS(6106), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6109), 1,
      sym_symboly_id,
    ACTIONS(6112), 1,
      sym_path,
    ACTIONS(6115), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6118), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    ACTIONS(5158), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1480), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [14780] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LBRACE,
    ACTIONS(6121), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6125), 1,
      anon_sym__,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(6127), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(4771), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [14848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [14906] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6131), 1,
      anon_sym_LPAREN,
    ACTIONS(6134), 1,
      anon_sym_LBRACK,
    ACTIONS(6137), 1,
      anon_sym_LBRACE,
    ACTIONS(6139), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6142), 1,
      sym_symboly_id,
    ACTIONS(6145), 1,
      sym_path,
    ACTIONS(6148), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6151), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1498), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [14988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6154), 1,
      sym_hash_cid,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15048] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1549), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15110] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6044), 1,
      anon_sym_LBRACE,
    ACTIONS(6156), 1,
      anon_sym_LPAREN,
    ACTIONS(6159), 1,
      anon_sym_LBRACK,
    ACTIONS(6162), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6165), 1,
      sym_symboly_id,
    ACTIONS(6168), 1,
      sym_path,
    ACTIONS(6171), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6174), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1476), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [15192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15250] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5751), 1,
      aux_sym_immediate_hash_token1,
    STATE(1550), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6183), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6187), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15486] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6073), 1,
      anon_sym_LBRACE,
    ACTIONS(6189), 1,
      anon_sym_LPAREN,
    ACTIONS(6192), 1,
      anon_sym_LBRACK,
    ACTIONS(6195), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6198), 1,
      sym_symboly_id,
    ACTIONS(6201), 1,
      sym_path,
    ACTIONS(6204), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6207), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    ACTIONS(5189), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1478), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [15568] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6212), 1,
      anon_sym_LPAREN,
    ACTIONS(6215), 1,
      anon_sym_LBRACK,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(6220), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6223), 1,
      sym_symboly_id,
    ACTIONS(6226), 1,
      sym_path,
    ACTIONS(6229), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6232), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    ACTIONS(5123), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1480), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [15650] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15708] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [15824] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6218), 1,
      anon_sym_LBRACE,
    ACTIONS(6239), 1,
      anon_sym_LPAREN,
    ACTIONS(6242), 1,
      anon_sym_LBRACK,
    ACTIONS(6245), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6248), 1,
      sym_symboly_id,
    ACTIONS(6251), 1,
      sym_path,
    ACTIONS(6254), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6257), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    ACTIONS(5189), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1493), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [15906] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6137), 1,
      anon_sym_LBRACE,
    ACTIONS(6260), 1,
      anon_sym_LPAREN,
    ACTIONS(6263), 1,
      anon_sym_LBRACK,
    ACTIONS(6266), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6269), 1,
      sym_symboly_id,
    ACTIONS(6272), 1,
      sym_path,
    ACTIONS(6275), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6278), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1507), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [15988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16104] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6287), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6289), 1,
      sym_hash_cid,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6293), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16280] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6297), 1,
      anon_sym_LBRACE,
    ACTIONS(6299), 1,
      anon_sym__,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(4773), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
    ACTIONS(6123), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [16348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6303), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16406] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6305), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6308), 1,
      anon_sym_LPAREN,
    ACTIONS(6311), 1,
      anon_sym_LBRACK,
    ACTIONS(6314), 1,
      anon_sym_LBRACE,
    ACTIONS(6317), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6320), 1,
      sym_symboly_id,
    ACTIONS(6323), 1,
      sym_path,
    ACTIONS(6326), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6329), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1506), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [16488] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6332), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6335), 1,
      anon_sym_LPAREN,
    ACTIONS(6338), 1,
      anon_sym_LBRACK,
    ACTIONS(6341), 1,
      anon_sym_LBRACE,
    ACTIONS(6344), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6347), 1,
      sym_symboly_id,
    ACTIONS(6350), 1,
      sym_path,
    ACTIONS(6353), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6356), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1507), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_SEMI,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [16570] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      aux_sym_immediate_hash_token1,
    STATE(2027), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16635] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6363), 1,
      anon_sym_LPAREN,
    ACTIONS(6366), 1,
      anon_sym_LBRACK,
    ACTIONS(6369), 1,
      anon_sym_LBRACE,
    ACTIONS(6371), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6374), 1,
      sym_symboly_id,
    ACTIONS(6377), 1,
      sym_path,
    ACTIONS(6380), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6383), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1516), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [16716] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6386), 1,
      sym__dot,
    ACTIONS(6388), 1,
      sym_hash_cid,
    ACTIONS(5743), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6293), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16834] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6390), 1,
      sym__dot,
    ACTIONS(6392), 1,
      sym_hash_cid,
    ACTIONS(5870), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      aux_sym_immediate_hash_token1,
    STATE(1738), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [16956] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4673), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6398), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17074] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6369), 1,
      anon_sym_LBRACE,
    ACTIONS(6400), 1,
      anon_sym_LPAREN,
    ACTIONS(6403), 1,
      anon_sym_LBRACK,
    ACTIONS(6406), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6409), 1,
      sym_symboly_id,
    ACTIONS(6412), 1,
      sym_path,
    ACTIONS(6415), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6418), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1517), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [17155] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6421), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6424), 1,
      anon_sym_LPAREN,
    ACTIONS(6427), 1,
      anon_sym_LBRACK,
    ACTIONS(6430), 1,
      anon_sym_LBRACE,
    ACTIONS(6433), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6436), 1,
      sym_symboly_id,
    ACTIONS(6439), 1,
      sym_path,
    ACTIONS(6442), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6445), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1517), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [17236] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17301] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6450), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6453), 1,
      anon_sym_LPAREN,
    ACTIONS(6456), 1,
      anon_sym_LBRACK,
    ACTIONS(6459), 1,
      anon_sym_LBRACE,
    ACTIONS(6462), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6465), 1,
      sym_symboly_id,
    ACTIONS(6468), 1,
      sym_path,
    ACTIONS(6471), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6474), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1519), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [17382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6063), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17496] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6479), 1,
      anon_sym_LPAREN,
    ACTIONS(6482), 1,
      anon_sym_LBRACK,
    ACTIONS(6485), 1,
      anon_sym_LBRACE,
    ACTIONS(6487), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6490), 1,
      sym_symboly_id,
    ACTIONS(6493), 1,
      sym_path,
    ACTIONS(6496), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6499), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1519), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [17577] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      aux_sym_immediate_hash_token1,
    STATE(2008), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17642] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6502), 1,
      sym__dot,
    ACTIONS(6504), 1,
      sym_hash_cid,
    ACTIONS(5743), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17703] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(1525), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(6506), 2,
      sym_or,
      sym_and,
    STATE(1370), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17772] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6509), 1,
      aux_sym_immediate_hash_token1,
    STATE(1734), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17833] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6485), 1,
      anon_sym_LBRACE,
    ACTIONS(6511), 1,
      anon_sym_LPAREN,
    ACTIONS(6514), 1,
      anon_sym_LBRACK,
    ACTIONS(6517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6520), 1,
      sym_symboly_id,
    ACTIONS(6523), 1,
      sym_path,
    ACTIONS(6526), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6529), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1522), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 27,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
  [17914] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(1525), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(1545), 2,
      sym_or,
      sym_and,
    STATE(1370), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [17983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6287), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18097] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1799), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6183), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6187), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5725), 1,
      aux_sym_immediate_hash_token1,
    STATE(1712), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 43,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18447] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1982), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6303), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6092), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18683] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6532), 1,
      sym__dot,
    ACTIONS(6534), 1,
      sym_hash_cid,
    ACTIONS(5870), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6540), 1,
      anon_sym_SEMI,
    ACTIONS(6542), 1,
      sym__layout_semicolon,
    ACTIONS(6544), 1,
      sym__layout_end,
    STATE(1578), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6538), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18808] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6551), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18866] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(1545), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(1655), 2,
      sym_or,
      sym_and,
    STATE(1380), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [18934] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(1545), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(6553), 2,
      sym_or,
      sym_and,
    STATE(1380), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19002] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4688), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6398), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19062] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6556), 1,
      sym__dot,
    ACTIONS(6558), 1,
      sym_hash_cid,
    ACTIONS(5870), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19122] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6560), 1,
      anon_sym_SEMI,
    ACTIONS(6562), 1,
      sym__layout_semicolon,
    ACTIONS(6564), 1,
      sym__layout_end,
    STATE(1558), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6538), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6568), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19298] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6570), 1,
      aux_sym_immediate_hash_token1,
    STATE(1878), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19414] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6576), 1,
      anon_sym_SEMI,
    ACTIONS(6578), 1,
      sym__layout_semicolon,
    ACTIONS(6580), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6574), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19478] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6582), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6585), 1,
      anon_sym_LPAREN,
    ACTIONS(6588), 1,
      anon_sym_LBRACK,
    ACTIONS(6591), 1,
      anon_sym_LBRACE,
    ACTIONS(6594), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6597), 1,
      sym_symboly_id,
    ACTIONS(6600), 1,
      sym_path,
    ACTIONS(6603), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6606), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1554), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [19558] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6611), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6615), 41,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19726] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6621), 1,
      anon_sym_SEMI,
    ACTIONS(6623), 1,
      sym__layout_semicolon,
    ACTIONS(6625), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6619), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19790] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6627), 1,
      sym_hash_cid,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19904] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6633), 1,
      anon_sym_SEMI,
    ACTIONS(6635), 1,
      sym__layout_semicolon,
    ACTIONS(6637), 1,
      sym__layout_end,
    STATE(1568), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6631), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [19968] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6643), 1,
      anon_sym_SEMI,
    ACTIONS(6645), 1,
      sym__layout_semicolon,
    ACTIONS(6647), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6649), 1,
      sym_hash_cid,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20090] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6655), 1,
      anon_sym_SEMI,
    ACTIONS(6657), 1,
      sym__layout_semicolon,
    ACTIONS(6659), 1,
      sym__layout_end,
    STATE(1553), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6653), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20154] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6661), 1,
      anon_sym_SEMI,
    ACTIONS(6663), 1,
      sym__layout_semicolon,
    ACTIONS(6665), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6667), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6123), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20276] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6673), 1,
      anon_sym_SEMI,
    ACTIONS(6675), 1,
      sym__layout_semicolon,
    ACTIONS(6677), 1,
      sym__layout_end,
    STATE(1590), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20340] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6683), 1,
      anon_sym_SEMI,
    ACTIONS(6685), 1,
      sym__layout_semicolon,
    ACTIONS(6687), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6681), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20404] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6693), 1,
      sym__layout_semicolon,
    STATE(1569), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6691), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20464] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6696), 1,
      anon_sym_SEMI,
    ACTIONS(6698), 1,
      sym__layout_semicolon,
    ACTIONS(6700), 1,
      sym__layout_end,
    STATE(1562), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20528] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6702), 1,
      anon_sym_SEMI,
    ACTIONS(6704), 1,
      sym__layout_semicolon,
    ACTIONS(6706), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6681), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20592] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6708), 1,
      anon_sym_SEMI,
    ACTIONS(6710), 1,
      sym__layout_semicolon,
    ACTIONS(6712), 1,
      sym__layout_end,
    STATE(1565), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20656] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6714), 1,
      anon_sym_SEMI,
    ACTIONS(6716), 1,
      sym__layout_semicolon,
    ACTIONS(6718), 1,
      sym__layout_end,
    STATE(1596), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20720] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4677), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6722), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20780] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      sym__layout_semicolon,
    STATE(1569), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6728), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20840] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6732), 1,
      anon_sym_SEMI,
    ACTIONS(6734), 1,
      sym__layout_semicolon,
    ACTIONS(6736), 1,
      sym__layout_end,
    STATE(1571), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6631), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [20960] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6738), 1,
      anon_sym_SEMI,
    ACTIONS(6740), 1,
      sym__layout_semicolon,
    ACTIONS(6742), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6619), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21080] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6744), 1,
      sym__dot,
    ACTIONS(6746), 1,
      sym_hash_cid,
    ACTIONS(5743), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6750), 41,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21196] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6752), 1,
      sym__dot,
    ACTIONS(6754), 1,
      sym_hash_cid,
    ACTIONS(5743), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21256] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6756), 1,
      sym__dot,
    ACTIONS(6758), 1,
      sym_hash_cid,
    ACTIONS(5870), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6762), 41,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6766), 41,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21428] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6768), 1,
      sym_hash_cid,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21486] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4692), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6722), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21546] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6774), 1,
      sym__layout_semicolon,
    ACTIONS(6776), 1,
      sym__layout_end,
    STATE(1604), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6772), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21608] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21670] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6778), 1,
      anon_sym_SEMI,
    ACTIONS(6780), 1,
      sym__layout_semicolon,
    ACTIONS(6782), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6784), 1,
      sym_hash_cid,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21792] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6788), 1,
      anon_sym_LPAREN,
    ACTIONS(6791), 1,
      anon_sym_LBRACK,
    ACTIONS(6794), 1,
      anon_sym_LBRACE,
    ACTIONS(6796), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6799), 1,
      sym_symboly_id,
    ACTIONS(6802), 1,
      sym_path,
    ACTIONS(6805), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6808), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1554), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [21872] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6815), 1,
      sym__layout_semicolon,
    ACTIONS(6817), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6813), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21934] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      aux_sym_immediate_hash_token1,
    STATE(1946), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [21994] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6819), 1,
      anon_sym_SEMI,
    ACTIONS(6821), 1,
      sym__layout_semicolon,
    ACTIONS(6823), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6574), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22058] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6825), 1,
      anon_sym_SEMI,
    ACTIONS(6827), 1,
      sym__layout_semicolon,
    ACTIONS(6829), 1,
      sym__layout_end,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22122] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6835), 1,
      sym__layout_semicolon,
    ACTIONS(6837), 1,
      sym__layout_end,
    STATE(1593), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6833), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22184] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6843), 1,
      sym__layout_semicolon,
    ACTIONS(6845), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6841), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22246] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6794), 1,
      anon_sym_LBRACE,
    ACTIONS(6847), 1,
      anon_sym_LPAREN,
    ACTIONS(6850), 1,
      anon_sym_LBRACK,
    ACTIONS(6853), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6856), 1,
      sym_symboly_id,
    ACTIONS(6859), 1,
      sym_path,
    ACTIONS(6862), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6865), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1592), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 26,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
  [22326] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6872), 1,
      anon_sym_SEMI,
    ACTIONS(6875), 1,
      sym__layout_semicolon,
    STATE(1600), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6870), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6880), 41,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22444] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6730), 1,
      sym__layout_semicolon,
    STATE(1575), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6884), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22504] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6886), 1,
      anon_sym_SEMI,
    ACTIONS(6888), 1,
      sym__layout_semicolon,
    ACTIONS(6890), 1,
      sym__layout_end,
    STATE(1595), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6653), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22568] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6896), 1,
      sym__layout_semicolon,
    ACTIONS(6898), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6894), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22630] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6904), 1,
      sym__layout_semicolon,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6902), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22690] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1982), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22752] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6911), 1,
      sym__layout_semicolon,
    ACTIONS(6913), 1,
      sym__layout_end,
    STATE(1598), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6909), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22814] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6915), 1,
      anon_sym_SEMI,
    ACTIONS(6917), 1,
      sym__layout_semicolon,
    ACTIONS(6919), 1,
      sym__layout_end,
    STATE(1669), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6653), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22932] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6929), 1,
      sym__layout_end,
    ACTIONS(6925), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6927), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [22989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(131), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6935), 1,
      sym__layout_end,
    ACTIONS(6931), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6939), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6943), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(85), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6947), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(143), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6951), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(155), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(169), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6955), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23596] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6957), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6960), 1,
      anon_sym_LPAREN,
    ACTIONS(6963), 1,
      anon_sym_LBRACK,
    ACTIONS(6966), 1,
      anon_sym_LBRACE,
    ACTIONS(6969), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6972), 1,
      sym_symboly_id,
    ACTIONS(6975), 1,
      sym_path,
    ACTIONS(6978), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6981), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1622), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 25,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [23675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6986), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23730] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(175), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6990), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6994), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [23895] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6998), 1,
      anon_sym_LPAREN,
    ACTIONS(7001), 1,
      anon_sym_LBRACK,
    ACTIONS(7004), 1,
      anon_sym_LBRACE,
    ACTIONS(7006), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7009), 1,
      sym_symboly_id,
    ACTIONS(7012), 1,
      sym_path,
    ACTIONS(7015), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7018), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1633), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 25,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [23974] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7021), 1,
      anon_sym_SEMI,
    ACTIONS(7023), 1,
      sym__layout_semicolon,
    ACTIONS(7025), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6574), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7029), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7033), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24261] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7004), 1,
      anon_sym_LBRACE,
    ACTIONS(7035), 1,
      anon_sym_LPAREN,
    ACTIONS(7038), 1,
      anon_sym_LBRACK,
    ACTIONS(7041), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7044), 1,
      sym_symboly_id,
    ACTIONS(7047), 1,
      sym_path,
    ACTIONS(7050), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7053), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1622), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 25,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
  [24340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7058), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7062), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24505] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7064), 1,
      sym__layout_semicolon,
    ACTIONS(7066), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6813), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24566] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7068), 1,
      sym__layout_semicolon,
    ACTIONS(7070), 1,
      sym__layout_end,
    STATE(1637), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6833), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24682] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7072), 1,
      sym__layout_semicolon,
    ACTIONS(7074), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6841), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24743] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7076), 1,
      sym_hash_cid,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24800] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7078), 1,
      sym__layout_semicolon,
    ACTIONS(7080), 1,
      sym__layout_end,
    STATE(1640), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6909), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24861] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7082), 1,
      sym__layout_semicolon,
    ACTIONS(7084), 1,
      sym__layout_end,
    STATE(1605), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6894), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [24977] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7086), 1,
      sym__layout_semicolon,
    ACTIONS(7088), 1,
      sym__layout_end,
    STATE(1643), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6772), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7092), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7096), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25148] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7098), 1,
      anon_sym_SEMI,
    ACTIONS(7100), 1,
      sym__layout_semicolon,
    ACTIONS(7102), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25211] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7104), 1,
      anon_sym_SEMI,
    ACTIONS(7106), 1,
      sym__layout_semicolon,
    ACTIONS(7108), 1,
      sym__layout_end,
    STATE(1628), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6653), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7112), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7116), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7120), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7122), 1,
      anon_sym_SEMI,
    ACTIONS(7124), 1,
      sym__layout_semicolon,
    ACTIONS(7126), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7130), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25557] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7132), 1,
      anon_sym_SEMI,
    ACTIONS(7134), 1,
      sym__layout_semicolon,
    ACTIONS(7136), 1,
      sym__layout_end,
    STATE(1692), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6538), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25620] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      sym__layout_semicolon,
    STATE(1717), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6884), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25679] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6880), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25734] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7142), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7146), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25844] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7150), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25899] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7152), 1,
      sym_hash_cid,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [25956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7156), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7160), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7168), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6611), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7172), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26341] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7174), 1,
      anon_sym_SEMI,
    ACTIONS(7176), 1,
      sym__layout_semicolon,
    ACTIONS(7178), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6574), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7182), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6750), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6551), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7186), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26626] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7188), 1,
      anon_sym_SEMI,
    ACTIONS(7190), 1,
      sym__layout_semicolon,
    ACTIONS(7192), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7196), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26744] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7198), 1,
      anon_sym_SEMI,
    ACTIONS(7200), 1,
      sym__layout_semicolon,
    ACTIONS(7202), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6641), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7206), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [26972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7172), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7214), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7216), 1,
      sym_hash_cid,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7222), 1,
      sym__layout_end,
    ACTIONS(7218), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7220), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7226), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(43), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7230), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7234), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7238), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7242), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27581] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7244), 1,
      anon_sym_SEMI,
    ACTIONS(7246), 1,
      sym__layout_semicolon,
    ACTIONS(7248), 1,
      sym__layout_end,
    STATE(1674), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27644] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7250), 1,
      anon_sym_SEMI,
    ACTIONS(7252), 1,
      sym__layout_semicolon,
    ACTIONS(7254), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6619), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27707] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7256), 1,
      anon_sym_SEMI,
    ACTIONS(7258), 1,
      sym__layout_semicolon,
    ACTIONS(7260), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6681), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27770] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7262), 1,
      anon_sym_SEMI,
    ACTIONS(7264), 1,
      sym__layout_semicolon,
    ACTIONS(7266), 1,
      sym__layout_end,
    STATE(1676), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6766), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6762), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [27998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7274), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7278), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28328] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7280), 1,
      anon_sym_SEMI,
    ACTIONS(7282), 1,
      sym__layout_semicolon,
    ACTIONS(7284), 1,
      sym__layout_end,
    STATE(1786), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6631), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7288), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7292), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7296), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7298), 1,
      sym__layout_semicolon,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6902), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28780] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6568), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [28945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29000] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7305), 1,
      anon_sym_SEMI,
    ACTIONS(7307), 1,
      sym__layout_semicolon,
    ACTIONS(7309), 1,
      sym__layout_end,
    STATE(1693), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6631), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29063] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7138), 1,
      sym__layout_semicolon,
    STATE(1722), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6728), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6691), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7317), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7319), 1,
      sym__layout_semicolon,
    STATE(1722), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6691), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29401] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7322), 1,
      sym__layout_semicolon,
    ACTIONS(7324), 1,
      sym__layout_end,
    STATE(1737), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6772), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7328), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29572] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7330), 1,
      anon_sym_SEMI,
    ACTIONS(7332), 1,
      sym__layout_semicolon,
    ACTIONS(7334), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6619), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7338), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(149), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7340), 1,
      anon_sym_SEMI,
    ACTIONS(7342), 1,
      sym__layout_semicolon,
    ACTIONS(7344), 1,
      sym__layout_end,
    STATE(1726), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6538), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29918] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7352), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [29973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7356), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30028] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7360), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30193] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7362), 1,
      sym__layout_semicolon,
    ACTIONS(7364), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6894), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30254] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7368), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7372), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7376), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7380), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30529] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6448), 1,
      aux_sym_immediate_hash_token1,
    STATE(1982), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30588] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7382), 1,
      sym__layout_semicolon,
    ACTIONS(7384), 1,
      sym__layout_end,
    STATE(1747), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6909), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30759] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7386), 1,
      sym__layout_semicolon,
    ACTIONS(7388), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6841), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30875] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7390), 1,
      sym__layout_semicolon,
    ACTIONS(7392), 1,
      sym__layout_end,
    STATE(1756), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6833), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7394), 1,
      sym_hash_cid,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [30993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7398), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7402), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7406), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31158] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7410), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31268] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7412), 1,
      sym__layout_semicolon,
    ACTIONS(7414), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6813), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6293), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7422), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 8,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(121), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6287), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [31989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7428), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6123), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32046] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6183), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6187), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6303), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7436), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7440), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7444), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6063), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7452), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7456), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32871] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7458), 1,
      anon_sym_SEMI,
    ACTIONS(7460), 1,
      sym__layout_semicolon,
    ACTIONS(7462), 1,
      sym__layout_end,
    STATE(1648), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32934] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7464), 1,
      anon_sym_SEMI,
    ACTIONS(7466), 1,
      sym__layout_semicolon,
    ACTIONS(7468), 1,
      sym__layout_end,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6681), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [32997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7472), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7476), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7480), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7484), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7488), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7492), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33327] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7494), 1,
      anon_sym_SEMI,
    ACTIONS(7496), 1,
      sym__layout_semicolon,
    ACTIONS(7498), 1,
      sym__layout_end,
    STATE(1653), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6671), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(113), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33445] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7500), 1,
      anon_sym_SEMI,
    ACTIONS(7503), 1,
      sym__layout_semicolon,
    STATE(1795), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 6,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6870), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33506] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6092), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7508), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33616] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(97), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6615), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(105), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [33946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7516), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7520), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7524), 40,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6092), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(175), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(149), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7116), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7120), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7062), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7058), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7033), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [34975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7029), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6994), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6990), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6986), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7410), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7172), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7168), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6955), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7160), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(169), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(155), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7296), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7142), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [35947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(143), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6947), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7150), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36217] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7528), 1,
      anon_sym_AT,
    ACTIONS(7530), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(7532), 1,
      sym__layout_end,
    STATE(2663), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7526), 4,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [36283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(85), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6939), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(97), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(131), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7292), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7156), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36715] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7534), 1,
      aux_sym_immediate_hash_token1,
    STATE(2009), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7338), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7352), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7356), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [36989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7172), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7130), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(43), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7360), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37367] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7536), 1,
      anon_sym_AT,
    ACTIONS(7538), 1,
      aux_sym_immediate_hash_token1,
    STATE(2709), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7526), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [37431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6293), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7182), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7214), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7226), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7376), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7380), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6287), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7398), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [37971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7520), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6183), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7436), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6187), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7328), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7096), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7230), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7444), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7234), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7238), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7242), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7274), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7206), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6691), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7186), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6303), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [38997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7317), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7092), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7288), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7278), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7472), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7368), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7484), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(113), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6063), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7508), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7196), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7372), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7456), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39915] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7540), 1,
      sym__layout_end,
    ACTIONS(7218), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7220), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [39971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7422), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40079] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7542), 1,
      sym__layout_semicolon,
    ACTIONS(7544), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6813), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40139] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7546), 1,
      sym__layout_semicolon,
    ACTIONS(7548), 1,
      sym__layout_end,
    STATE(1917), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6833), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6943), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40253] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7550), 1,
      sym__layout_semicolon,
    ACTIONS(7552), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6841), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7524), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7488), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7146), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7554), 1,
      sym__dot,
    ACTIONS(7556), 1,
      sym_hash_cid,
    ACTIONS(5743), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7492), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7516), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(121), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7558), 1,
      sym__layout_semicolon,
    ACTIONS(7560), 1,
      sym__layout_end,
    STATE(1920), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6909), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [40971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(105), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7440), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41403] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4658), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6398), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41461] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7562), 1,
      sym__layout_semicolon,
    ACTIONS(7564), 1,
      sym__layout_end,
    STATE(1709), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6894), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41521] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      aux_sym_immediate_hash_token1,
    STATE(2008), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5734), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7566), 1,
      sym__dot,
    ACTIONS(7568), 1,
      sym_hash_cid,
    ACTIONS(5870), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7452), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7406), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41907] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7570), 1,
      sym__layout_semicolon,
    ACTIONS(7572), 1,
      sym__layout_end,
    STATE(1942), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6772), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [41967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7402), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7112), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42075] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7574), 1,
      sym__layout_end,
    ACTIONS(6925), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6927), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7476), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 7,
      sym__layout_semicolon,
      sym__layout_end,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7480), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6359), 1,
      aux_sym_immediate_hash_token1,
    STATE(2027), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42297] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7576), 1,
      sym__layout_end,
    ACTIONS(6931), 6,
      sym__layout_semicolon,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7578), 1,
      sym__layout_end,
    ACTIONS(6931), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7580), 1,
      sym_hash_cid,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42463] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4697), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6722), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 42,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [42573] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7582), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6123), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42734] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4695), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6722), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42791] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4670), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6398), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42848] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7584), 1,
      aux_sym_immediate_hash_token1,
    STATE(2161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7586), 1,
      sym_hash_cid,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [42960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6762), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43013] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7588), 1,
      sym__layout_end,
    ACTIONS(6925), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6927), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43068] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7590), 1,
      sym__dot,
    ACTIONS(7592), 1,
      sym_hash_cid,
    ACTIONS(5870), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6766), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6611), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 41,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [43337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7594), 1,
      sym__dot,
    ACTIONS(7596), 1,
      sym_hash_cid,
    ACTIONS(5743), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6551), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43502] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6750), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43555] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7598), 1,
      sym__layout_end,
    ACTIONS(7218), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7220), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6615), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6568), 40,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6880), 40,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(131), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6615), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43925] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7600), 1,
      sym_hash_cid,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [43979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6762), 39,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6766), 39,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7230), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44135] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6943), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6551), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6750), 39,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6611), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7096), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6880), 39,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7033), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2358), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 32,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [44561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7112), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7604), 1,
      sym__dot,
    ACTIONS(7606), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [44669] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7130), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2367), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 32,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [44781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7160), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44833] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7168), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44885] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7608), 1,
      sym__layout_end,
    ACTIONS(6925), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6927), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7292), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [44991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7146), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5723), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7492), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7488), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7186), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7206), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(43), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7058), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45927] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7610), 1,
      sym__layout_end,
    ACTIONS(7218), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7220), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [45981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6568), 39,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7372), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7062), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7296), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7368), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46605] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46657] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7150), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(149), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7317), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [46969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6939), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(85), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7278), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7422), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7612), 1,
      sym_hash_cid,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7328), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7338), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7352), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7356), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7288), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6947), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7274), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7360), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [47959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(121), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7242), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7376), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7380), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7092), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7398), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7410), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48479] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7116), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7029), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7120), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48739] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7614), 1,
      sym__dot,
    ACTIONS(7616), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [48795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7238), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48847] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2100), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(2987), 2,
      sym_or,
      sym_and,
    STATE(1396), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [48911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [48963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6994), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7436), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7440), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(143), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49379] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2298), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [49435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7444), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7452), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7476), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7480), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 39,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [49695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6990), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7618), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6123), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(97), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49853] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2100), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7620), 2,
      sym_or,
      sym_and,
    STATE(1396), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [49917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7226), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [49969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7214), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(105), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7182), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(175), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7516), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7142), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50385] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7472), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7484), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6951), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(155), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6986), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(113), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6955), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7508), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7196), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7623), 1,
      sym__layout_end,
    ACTIONS(6931), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7524), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [50959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7520), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 6,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(169), 39,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7146), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51166] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7120), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7492), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6933), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51370] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2129), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7625), 2,
      sym_or,
      sym_and,
    STATE(1399), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 30,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [51433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7130), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7160), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6923), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7296), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7328), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51790] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7440), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51841] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2129), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3137), 2,
      sym_or,
      sym_and,
    STATE(1399), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 30,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [51904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7270), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [51955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6947), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(113), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(175), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(43), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7484), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52312] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7092), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7206), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6990), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52516] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7628), 1,
      sym__dot,
    ACTIONS(7630), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [52571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7186), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52724] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7142), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7472), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7150), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [52979] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6994), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7360), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6951), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53234] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7632), 1,
      sym__dot,
    ACTIONS(7634), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [53289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7372), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7368), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7164), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53442] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2862), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [53501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(149), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      aux_sym_immediate_hash_token1,
    STATE(2921), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [53662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(155), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [53764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7210), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7348), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53866] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7112), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7508), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [53968] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2179), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7640), 2,
      sym_or,
      sym_and,
    STATE(1400), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [54031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7196), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(137), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7292), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7029), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(97), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(143), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7376), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54490] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2179), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3141), 2,
      sym_or,
      sym_and,
    STATE(1400), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [54553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7488), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54655] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2247), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3064), 2,
      sym_or,
      sym_and,
    STATE(1373), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [54718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7313), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7278), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7062), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7432), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7096), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [54973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7380), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55024] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2367), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [55081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7352), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7033), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(85), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55234] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2885), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [55293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7058), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7338), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(169), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55446] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2730), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [55505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7274), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55556] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7356), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7242), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55658] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7238), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7398), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(105), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7116), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7410), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(121), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [55964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2358), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [56019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7426), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [56121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7645), 1,
      sym__dot,
    ACTIONS(7647), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [56176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7512), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7480), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [56380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6955), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(91), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6939), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6986), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7476), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7226), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7524), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56737] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7444), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56788] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7649), 1,
      sym__dot,
    ACTIONS(7651), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [56843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6943), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7214), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [56996] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7182), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7520), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57149] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2748), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57208] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      aux_sym_immediate_hash_token1,
    STATE(2905), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(131), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7448), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57369] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2358), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2363), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57532] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2247), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7653), 2,
      sym_or,
      sym_and,
    STATE(1373), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7230), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7436), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7422), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7656), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2322), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [57907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [57958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7303), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7658), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58062] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7452), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58164] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7288), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7317), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58266] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2367), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7168), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7516), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58474] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 5,
      sym_fold,
      sym__parenthesized_operator,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(7418), 38,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_use,
      sym_do,
      sym_kw_let,
      sym_type_kw,
      sym_match,
      sym_cases,
      sym_structural,
      sym_unique,
      sym_ability,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [58525] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2266), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7660), 2,
      sym_or,
      sym_and,
    STATE(1371), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58587] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7530), 1,
      aux_sym_immediate_hash_token1,
    STATE(2677), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58793] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7663), 1,
      sym__dot,
    ACTIONS(7665), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3181), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58905] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2273), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7669), 2,
      sym_or,
      sym_and,
    STATE(1392), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [58967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59017] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2266), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3147), 2,
      sym_or,
      sym_and,
    STATE(1371), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59129] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2273), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3159), 2,
      sym_or,
      sym_and,
    STATE(1392), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7672), 1,
      sym__dot,
    ACTIONS(7674), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59295] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2748), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59451] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7676), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59553] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7678), 1,
      sym__dot,
    ACTIONS(7680), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59657] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7538), 1,
      aux_sym_immediate_hash_token1,
    STATE(2700), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59713] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7682), 1,
      aux_sym_immediate_hash_token1,
    STATE(2479), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59767] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3181), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59825] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3207), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59883] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7684), 1,
      sym__dot,
    ACTIONS(7686), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59937] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7688), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [59989] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      aux_sym_immediate_hash_token1,
    STATE(2536), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60093] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7690), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60145] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2730), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7692), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60253] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60353] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    STATE(4812), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(5000), 1,
      sym__value_type,
    STATE(5025), 1,
      sym_record,
    STATE(5088), 1,
      sym__type_rhs,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    ACTIONS(7694), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(5016), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    ACTIONS(7706), 7,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [60443] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      sym_kw_equals,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2358), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60501] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      sym_kw_equals,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2367), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60709] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3207), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60767] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2885), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2862), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60879] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2309), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7720), 2,
      sym_or,
      sym_and,
    STATE(1382), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 28,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [60940] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2310), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7723), 2,
      sym_or,
      sym_and,
    STATE(1394), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61148] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2310), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3203), 2,
      sym_or,
      sym_and,
    STATE(1394), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2885), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61262] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7726), 1,
      sym__dot,
    ACTIONS(7728), 1,
      sym_hash_cid,
    ACTIONS(5743), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61364] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3166), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61470] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(2852), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61523] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2321), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(7732), 2,
      sym_or,
      sym_and,
    STATE(1398), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5780), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61633] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7735), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61684] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7737), 1,
      sym__dot,
    ACTIONS(7739), 1,
      sym_hash_cid,
    ACTIONS(5743), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2321), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3223), 2,
      sym_or,
      sym_and,
    STATE(1398), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7741), 1,
      sym__dot,
    ACTIONS(7743), 1,
      sym_hash_cid,
    ACTIONS(5870), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [61949] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7636), 1,
      aux_sym_immediate_hash_token1,
    STATE(2862), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62002] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3385), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62108] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7747), 1,
      sym__dot,
    ACTIONS(7749), 1,
      sym_hash_cid,
    ACTIONS(5743), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62210] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3776), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62316] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62416] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62514] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3319), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7755), 1,
      sym__layout_semicolon,
    STATE(2341), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62624] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62722] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7758), 1,
      sym__dot,
    ACTIONS(7760), 1,
      sym_hash_cid,
    ACTIONS(5870), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62775] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5727), 1,
      anon_sym_DASH_GT,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2358), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62830] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4659), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62932] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7762), 1,
      sym__dot,
    ACTIONS(7764), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [62985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7766), 1,
      sym__dot,
    ACTIONS(7768), 1,
      sym_hash_cid,
    ACTIONS(5870), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63038] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      sym__layout_semicolon,
    STATE(2341), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6728), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63091] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(2884), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63242] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_DASH_GT,
    ACTIONS(7602), 1,
      aux_sym_immediate_hash_token1,
    STATE(2367), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63346] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63395] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7770), 1,
      sym__layout_semicolon,
    STATE(2350), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6884), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63546] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(2786), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2748), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7772), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63801] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3151), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 31,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63858] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3390), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [63964] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(2792), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64017] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7774), 1,
      sym__dot,
    ACTIONS(7776), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64070] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7643), 1,
      aux_sym_immediate_hash_token1,
    STATE(2730), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7778), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64223] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7780), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 38,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64372] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2376), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7782), 2,
      sym_or,
      sym_and,
    STATE(1368), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7785), 1,
      sym__dot,
    ACTIONS(7787), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64584] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2376), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3225), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1368), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64645] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7789), 1,
      sym__dot,
    ACTIONS(7791), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64698] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64747] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7793), 1,
      sym__dot,
    ACTIONS(7795), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64800] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [64996] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2309), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3177), 2,
      sym_or,
      sym_and,
    STATE(1382), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5814), 28,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7797), 1,
      sym__dot,
    ACTIONS(7799), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7801), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65449] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7803), 1,
      anon_sym_SEMI,
    ACTIONS(7806), 1,
      sym__layout_semicolon,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65647] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [65983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7809), 1,
      sym__dot,
    ACTIONS(7811), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66275] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2414), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7813), 2,
      sym_or,
      sym_and,
    STATE(1391), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66383] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2414), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3253), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1391), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 29,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [66971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67163] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4666), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67215] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3207), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7816), 1,
      sym__dot,
    ACTIONS(7818), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67751] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7820), 1,
      sym__dot,
    ACTIONS(7822), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [67995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7156), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68283] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3099), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      aux_sym_immediate_hash_token1,
    STATE(2921), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68819] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3089), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7828), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [68969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69065] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2569), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3249), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1387), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69125] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3385), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69371] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7830), 1,
      sym__dot,
    ACTIONS(7832), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69423] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7834), 1,
      sym_hash_cid,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69569] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69617] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7836), 1,
      sym__dot,
    ACTIONS(7838), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7840), 1,
      sym__layout_semicolon,
    ACTIONS(7842), 1,
      sym__layout_end,
    STATE(2562), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3390), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7844), 1,
      sym_hash_cid,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [69971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70067] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7667), 1,
      aux_sym_immediate_hash_token1,
    STATE(3181), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70503] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70841] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7846), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [70987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71035] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7848), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71277] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71325] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7850), 1,
      sym_hash_cid,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71711] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      aux_sym_immediate_hash_token1,
    STATE(4161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5721), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71863] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      aux_sym_immediate_hash_token1,
    STATE(4144), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5732), 3,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [71967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72063] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3319), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72309] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3800), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4694), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72417] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7854), 1,
      sym__dot,
    ACTIONS(7856), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72565] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3933), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5721), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72621] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7858), 1,
      sym__layout_end,
    ACTIONS(7218), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3776), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72869] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7860), 1,
      sym__dot,
    ACTIONS(7862), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [72969] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7864), 1,
      anon_sym_SEMI,
    ACTIONS(7866), 1,
      sym__layout_semicolon,
    ACTIONS(7868), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73073] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7870), 1,
      aux_sym_immediate_hash_token1,
    STATE(3001), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73221] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3802), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73277] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7872), 1,
      anon_sym_SEMI,
    ACTIONS(7874), 1,
      sym__layout_semicolon,
    ACTIONS(7876), 1,
      sym__layout_end,
    STATE(2557), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73333] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7878), 1,
      anon_sym_SEMI,
    ACTIONS(7880), 1,
      sym__layout_semicolon,
    ACTIONS(7882), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73581] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7884), 1,
      sym__layout_semicolon,
    ACTIONS(7886), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73635] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7888), 1,
      anon_sym_SEMI,
    ACTIONS(7890), 1,
      sym__layout_semicolon,
    ACTIONS(7892), 1,
      sym__layout_end,
    STATE(2572), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73691] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7894), 1,
      sym__layout_end,
    ACTIONS(6925), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73741] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3151), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3151), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7896), 1,
      anon_sym_SEMI,
    ACTIONS(7898), 1,
      sym__layout_semicolon,
    ACTIONS(7900), 1,
      sym__layout_end,
    STATE(2581), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [73951] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2569), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7902), 2,
      sym_or,
      sym_and,
    STATE(1387), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74011] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7905), 1,
      sym_hash_cid,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74061] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7907), 1,
      sym__layout_semicolon,
    ACTIONS(7909), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74115] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7911), 1,
      anon_sym_SEMI,
    ACTIONS(7913), 1,
      sym__layout_semicolon,
    ACTIONS(7915), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74171] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7917), 1,
      sym__layout_semicolon,
    ACTIONS(7919), 1,
      sym__layout_end,
    STATE(2571), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74225] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7921), 1,
      sym__layout_semicolon,
    ACTIONS(7923), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7925), 1,
      sym_hash_cid,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74329] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7927), 1,
      sym__layout_end,
    ACTIONS(6931), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3166), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74433] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7929), 1,
      sym__layout_semicolon,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74485] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7456), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7932), 1,
      aux_sym_immediate_hash_token1,
    STATE(3135), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74585] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7934), 1,
      anon_sym_SEMI,
    ACTIONS(7936), 1,
      sym__layout_semicolon,
    ACTIONS(7938), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7940), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74739] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7942), 1,
      anon_sym_SEMI,
    ACTIONS(7944), 1,
      sym__layout_semicolon,
    ACTIONS(7946), 1,
      sym__layout_end,
    STATE(2597), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74795] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3166), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74895] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7948), 1,
      anon_sym_SEMI,
    ACTIONS(7950), 1,
      sym__layout_semicolon,
    ACTIONS(7952), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [74951] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7954), 1,
      anon_sym_SEMI,
    ACTIONS(7956), 1,
      sym__layout_semicolon,
    ACTIONS(7958), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75007] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2589), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7960), 2,
      sym_or,
      sym_and,
    STATE(1385), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75067] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7963), 1,
      anon_sym_SEMI,
    ACTIONS(7965), 1,
      sym__layout_semicolon,
    ACTIONS(7967), 1,
      sym__layout_end,
    STATE(2594), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75123] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4682), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7969), 1,
      sym__layout_semicolon,
    ACTIONS(7971), 1,
      sym__layout_end,
    STATE(2574), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 35,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7973), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75279] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7975), 1,
      anon_sym_SEMI,
    ACTIONS(7977), 1,
      sym__layout_semicolon,
    ACTIONS(7979), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75335] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7981), 1,
      anon_sym_SEMI,
    ACTIONS(7983), 1,
      sym__layout_semicolon,
    ACTIONS(7985), 1,
      sym__layout_end,
    STATE(2550), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75439] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7987), 1,
      anon_sym_SEMI,
    ACTIONS(7989), 1,
      sym__layout_semicolon,
    ACTIONS(7991), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75495] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7993), 1,
      anon_sym_SEMI,
    ACTIONS(7995), 1,
      sym__layout_semicolon,
    ACTIONS(7997), 1,
      sym__layout_end,
    STATE(2587), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75551] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2589), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3263), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1385), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 29,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75611] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7638), 1,
      aux_sym_immediate_hash_token1,
    STATE(2905), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7999), 1,
      anon_sym_SEMI,
    ACTIONS(8001), 1,
      sym__layout_semicolon,
    ACTIONS(8003), 1,
      sym__layout_end,
    STATE(2622), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8005), 1,
      sym_hash_cid,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5732), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 30,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8007), 1,
      sym__dot,
    ACTIONS(8009), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7406), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [75973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7234), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_equals,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7402), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8011), 1,
      anon_sym_SEMI,
    ACTIONS(8013), 1,
      sym__layout_semicolon,
    ACTIONS(8015), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8017), 1,
      anon_sym_SEMI,
    ACTIONS(8019), 1,
      sym__layout_semicolon,
    ACTIONS(8021), 1,
      sym__layout_end,
    STATE(2617), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 36,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76661] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8023), 1,
      anon_sym_SEMI,
    ACTIONS(8025), 1,
      sym__layout_semicolon,
    ACTIONS(8027), 1,
      sym__layout_end,
    STATE(2588), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8029), 1,
      anon_sym_SEMI,
    ACTIONS(8031), 1,
      sym__layout_semicolon,
    ACTIONS(8033), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76820] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 1,
      anon_sym_COMMA,
    ACTIONS(8042), 1,
      sym__layout_end,
    ACTIONS(8045), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8040), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(8035), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76873] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8047), 1,
      anon_sym_SEMI,
    ACTIONS(8049), 1,
      sym__layout_semicolon,
    ACTIONS(8051), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76928] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8053), 1,
      anon_sym_SEMI,
    ACTIONS(8055), 1,
      sym__layout_semicolon,
    ACTIONS(8057), 1,
      sym__layout_end,
    STATE(2681), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [76983] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8059), 1,
      anon_sym_SEMI,
    ACTIONS(8061), 1,
      sym__layout_semicolon,
    ACTIONS(8063), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77038] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8065), 1,
      sym__layout_semicolon,
    ACTIONS(8067), 1,
      sym__layout_end,
    STATE(2679), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7876), 1,
      sym__layout_end,
    ACTIONS(8069), 1,
      anon_sym_SEMI,
    ACTIONS(8071), 1,
      sym__layout_semicolon,
    STATE(2630), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77146] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7882), 1,
      sym__layout_end,
    ACTIONS(8073), 1,
      anon_sym_SEMI,
    ACTIONS(8075), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77201] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7892), 1,
      sym__layout_end,
    ACTIONS(8077), 1,
      anon_sym_SEMI,
    ACTIONS(8079), 1,
      sym__layout_semicolon,
    STATE(2636), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77256] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7900), 1,
      sym__layout_end,
    ACTIONS(8081), 1,
      anon_sym_SEMI,
    ACTIONS(8083), 1,
      sym__layout_semicolon,
    STATE(2652), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77358] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8085), 1,
      sym__layout_semicolon,
    ACTIONS(8087), 1,
      sym__layout_end,
    STATE(2646), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77458] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7915), 1,
      sym__layout_end,
    ACTIONS(8089), 1,
      anon_sym_SEMI,
    ACTIONS(8091), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77513] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8093), 1,
      anon_sym_SEMI,
    ACTIONS(8095), 1,
      sym__layout_semicolon,
    ACTIONS(8097), 1,
      sym__layout_end,
    STATE(2627), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77568] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7997), 1,
      sym__layout_end,
    ACTIONS(8099), 1,
      anon_sym_SEMI,
    ACTIONS(8101), 1,
      sym__layout_semicolon,
    STATE(2704), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77623] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8103), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8106), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(7360), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77674] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8108), 1,
      anon_sym_SEMI,
    ACTIONS(8110), 1,
      sym__layout_semicolon,
    ACTIONS(8112), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8114), 1,
      anon_sym_SEMI,
    ACTIONS(8116), 1,
      sym__layout_semicolon,
    ACTIONS(8118), 1,
      sym__layout_end,
    STATE(2625), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8120), 1,
      anon_sym_SEMI,
    ACTIONS(8122), 1,
      sym__layout_semicolon,
    ACTIONS(8124), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77839] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77892] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8126), 1,
      sym__dot,
    ACTIONS(8128), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77943] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8130), 1,
      anon_sym_SEMI,
    ACTIONS(8132), 1,
      sym__layout_semicolon,
    ACTIONS(8134), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [77998] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8136), 1,
      sym__layout_semicolon,
    ACTIONS(8138), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78051] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8140), 1,
      sym__layout_semicolon,
    ACTIONS(8142), 1,
      sym__layout_end,
    STATE(2650), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78104] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8144), 1,
      anon_sym_SEMI,
    ACTIONS(8146), 1,
      sym__layout_semicolon,
    ACTIONS(8148), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78159] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8150), 1,
      anon_sym_SEMI,
    ACTIONS(8152), 1,
      sym__layout_semicolon,
    ACTIONS(8154), 1,
      sym__layout_end,
    STATE(2642), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78214] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8156), 1,
      sym__layout_semicolon,
    ACTIONS(8158), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78267] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8160), 1,
      anon_sym_SEMI,
    ACTIONS(8162), 1,
      sym__layout_semicolon,
    ACTIONS(8164), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78322] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7938), 1,
      sym__layout_end,
    ACTIONS(8166), 1,
      anon_sym_SEMI,
    ACTIONS(8168), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78377] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8170), 1,
      anon_sym_SEMI,
    ACTIONS(8172), 1,
      sym__layout_semicolon,
    ACTIONS(8174), 1,
      sym__layout_end,
    STATE(2648), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78432] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8176), 1,
      anon_sym_SEMI,
    ACTIONS(8178), 1,
      sym__layout_semicolon,
    ACTIONS(8180), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8182), 1,
      sym__layout_semicolon,
    STATE(2655), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8185), 1,
      anon_sym_SEMI,
    ACTIONS(8187), 1,
      sym__layout_semicolon,
    ACTIONS(8189), 1,
      sym__layout_end,
    STATE(2723), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78640] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78734] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8191), 1,
      anon_sym_SEMI,
    ACTIONS(8193), 1,
      sym__layout_semicolon,
    ACTIONS(8195), 1,
      sym__layout_end,
    STATE(2651), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8197), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78932] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8199), 1,
      anon_sym_SEMI,
    ACTIONS(8201), 1,
      sym__layout_semicolon,
    ACTIONS(8203), 1,
      sym__layout_end,
    STATE(2654), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [78987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8205), 1,
      anon_sym_SEMI,
    ACTIONS(8207), 1,
      sym__layout_semicolon,
    ACTIONS(8209), 1,
      sym__layout_end,
    STATE(2397), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8211), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79091] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8213), 1,
      anon_sym_SEMI,
    ACTIONS(8215), 1,
      sym__layout_semicolon,
    ACTIONS(8217), 1,
      sym__layout_end,
    STATE(2640), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79193] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8040), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(6123), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79242] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8037), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(8045), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8040), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(8035), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79340] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79434] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8219), 1,
      anon_sym_SEMI,
    ACTIONS(8221), 1,
      sym__layout_semicolon,
    ACTIONS(8223), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8225), 1,
      sym__layout_semicolon,
    ACTIONS(8227), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79542] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8229), 1,
      anon_sym_SEMI,
    ACTIONS(8231), 1,
      sym__layout_semicolon,
    ACTIONS(8233), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79691] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8235), 1,
      sym__layout_semicolon,
    ACTIONS(8237), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79744] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79791] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8239), 1,
      anon_sym_SEMI,
    ACTIONS(8241), 1,
      sym__layout_semicolon,
    ACTIONS(8243), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [79987] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8245), 1,
      anon_sym_SEMI,
    ACTIONS(8247), 1,
      sym__layout_semicolon,
    ACTIONS(8249), 1,
      sym__layout_end,
    STATE(2645), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80042] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8251), 1,
      anon_sym_SEMI,
    ACTIONS(8253), 1,
      sym__layout_semicolon,
    ACTIONS(8255), 1,
      sym__layout_end,
    STATE(2665), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80097] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80144] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7946), 1,
      sym__layout_end,
    ACTIONS(8257), 1,
      anon_sym_SEMI,
    ACTIONS(8259), 1,
      sym__layout_semicolon,
    STATE(2706), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80246] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80342] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4691), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80393] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8261), 1,
      sym__layout_semicolon,
    STATE(2655), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6728), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80444] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8263), 1,
      anon_sym_SEMI,
    ACTIONS(8265), 1,
      sym__layout_semicolon,
    ACTIONS(8267), 1,
      sym__layout_end,
    STATE(2674), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80499] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8269), 1,
      anon_sym_SEMI,
    ACTIONS(8271), 1,
      sym__layout_semicolon,
    ACTIONS(8273), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80554] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2696), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8275), 2,
      sym_or,
      sym_and,
    STATE(1374), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 28,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80613] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8278), 1,
      anon_sym_SEMI,
    ACTIONS(8280), 1,
      sym__layout_semicolon,
    ACTIONS(8282), 1,
      sym__layout_end,
    STATE(2698), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80668] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8284), 1,
      anon_sym_SEMI,
    ACTIONS(8286), 1,
      sym__layout_semicolon,
    ACTIONS(8288), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80723] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8290), 1,
      sym__layout_semicolon,
    ACTIONS(8292), 1,
      sym__layout_end,
    STATE(2675), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80776] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80823] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8294), 1,
      sym__layout_semicolon,
    ACTIONS(8296), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80876] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8298), 1,
      anon_sym_SEMI,
    ACTIONS(8300), 1,
      sym__layout_semicolon,
    ACTIONS(8302), 1,
      sym__layout_end,
    STATE(2716), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [80978] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7952), 1,
      sym__layout_end,
    ACTIONS(8304), 1,
      anon_sym_SEMI,
    ACTIONS(8306), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81033] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8308), 1,
      anon_sym_SEMI,
    ACTIONS(8311), 1,
      sym__layout_semicolon,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81086] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7991), 1,
      sym__layout_end,
    ACTIONS(8314), 1,
      anon_sym_SEMI,
    ACTIONS(8316), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81188] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 37,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81282] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8318), 1,
      anon_sym_SEMI,
    ACTIONS(8320), 1,
      sym__layout_semicolon,
    ACTIONS(8322), 1,
      sym__layout_end,
    STATE(2676), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81337] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8324), 1,
      sym__layout_semicolon,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81435] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2696), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3410), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1374), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 28,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 37,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81541] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8327), 1,
      sym__layout_semicolon,
    ACTIONS(8329), 1,
      sym__layout_end,
    STATE(2701), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81594] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8331), 1,
      anon_sym_SEMI,
    ACTIONS(8333), 1,
      sym__layout_semicolon,
    ACTIONS(8335), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81696] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8337), 1,
      sym__layout_semicolon,
    ACTIONS(8339), 1,
      sym__layout_end,
    STATE(2742), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 37,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81796] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8261), 1,
      sym__layout_semicolon,
    STATE(2693), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6884), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81847] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8341), 1,
      anon_sym_SEMI,
    ACTIONS(8343), 1,
      sym__layout_semicolon,
    ACTIONS(8345), 1,
      sym__layout_end,
    STATE(2731), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81902] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8347), 1,
      anon_sym_SEMI,
    ACTIONS(8349), 1,
      sym__layout_semicolon,
    ACTIONS(8351), 1,
      sym__layout_end,
    STATE(2695), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [81957] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8353), 1,
      anon_sym_SEMI,
    ACTIONS(8355), 1,
      sym__layout_semicolon,
    ACTIONS(8357), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82012] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3776), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82063] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8359), 1,
      anon_sym_SEMI,
    ACTIONS(8361), 1,
      sym__layout_semicolon,
    ACTIONS(8363), 1,
      sym__layout_end,
    STATE(2761), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82165] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8365), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82214] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8367), 1,
      anon_sym_SEMI,
    ACTIONS(8369), 1,
      sym__layout_semicolon,
    ACTIONS(8371), 1,
      sym__layout_end,
    STATE(2738), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82269] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6127), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8040), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82365] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8373), 1,
      anon_sym_SEMI,
    ACTIONS(8375), 1,
      sym__layout_semicolon,
    ACTIONS(8377), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82514] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8379), 1,
      sym__layout_semicolon,
    ACTIONS(8381), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82661] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 37,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82708] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8383), 1,
      anon_sym_SEMI,
    ACTIONS(8385), 1,
      sym__layout_semicolon,
    ACTIONS(8387), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82810] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82904] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8389), 1,
      sym__layout_semicolon,
    ACTIONS(8391), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [82957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83004] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83098] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4709), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8393), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83245] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8395), 1,
      anon_sym_SEMI,
    ACTIONS(8397), 1,
      sym__layout_semicolon,
    ACTIONS(8399), 1,
      sym__layout_end,
    STATE(2753), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83300] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8401), 1,
      sym__dot,
    ACTIONS(8403), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4704), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83402] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4665), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83453] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8405), 1,
      anon_sym_SEMI,
    ACTIONS(8407), 1,
      sym__layout_semicolon,
    ACTIONS(8409), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83508] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8411), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83698] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8413), 1,
      sym__layout_semicolon,
    ACTIONS(8415), 1,
      sym__layout_end,
    STATE(2777), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83751] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8417), 1,
      sym__layout_semicolon,
    ACTIONS(8419), 1,
      sym__layout_end,
    STATE(2734), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83804] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8421), 1,
      sym__layout_semicolon,
    ACTIONS(8423), 1,
      sym__layout_end,
    STATE(2763), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83857] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8425), 1,
      anon_sym_SEMI,
    ACTIONS(8427), 1,
      sym__layout_semicolon,
    ACTIONS(8429), 1,
      sym__layout_end,
    STATE(2705), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83912] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8431), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [83961] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8433), 1,
      sym__layout_semicolon,
    ACTIONS(8435), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84014] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(2802), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3315), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    STATE(1378), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8437), 1,
      aux_sym_immediate_hash_token1,
    STATE(3432), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84124] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8439), 1,
      sym__layout_semicolon,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7751), 1,
      aux_sym_immediate_hash_token1,
    STATE(3319), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84320] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8442), 1,
      anon_sym_SEMI,
    ACTIONS(8445), 1,
      sym__layout_semicolon,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84373] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8448), 1,
      aux_sym_immediate_hash_token1,
    STATE(3783), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84424] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84518] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8450), 1,
      sym__dot,
    ACTIONS(8452), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84569] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8454), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84618] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4712), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8456), 1,
      sym__layout_semicolon,
    ACTIONS(8458), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84816] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3385), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84867] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8460), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [84963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85057] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3800), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85157] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8462), 1,
      anon_sym_SEMI,
    ACTIONS(8464), 1,
      sym__layout_semicolon,
    ACTIONS(8466), 1,
      sym__layout_end,
    STATE(2796), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85212] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      sym__layout_semicolon,
    STATE(2801), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6884), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85310] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4657), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85455] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      sym_kw_equals,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3166), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5727), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 29,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85510] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8470), 1,
      sym__dot,
    ACTIONS(8472), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85608] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8474), 1,
      anon_sym_SEMI,
    ACTIONS(8476), 1,
      sym__layout_semicolon,
    ACTIONS(8478), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85663] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8480), 1,
      anon_sym_SEMI,
    ACTIONS(8482), 1,
      sym__layout_semicolon,
    ACTIONS(8484), 1,
      sym__layout_end,
    STATE(2825), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85718] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8486), 1,
      sym__dot,
    ACTIONS(8488), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7909), 1,
      sym__layout_end,
    ACTIONS(8490), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85822] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7919), 1,
      sym__layout_end,
    ACTIONS(8492), 1,
      sym__layout_semicolon,
    STATE(2799), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85875] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8468), 1,
      sym__layout_semicolon,
    STATE(2840), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6728), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85926] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(2802), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8494), 2,
      sym_or,
      sym_and,
    STATE(1378), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 28,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [85985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8497), 1,
      sym__dot,
    ACTIONS(8499), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86036] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86083] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7923), 1,
      sym__layout_end,
    ACTIONS(8501), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86183] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7971), 1,
      sym__layout_end,
    ACTIONS(8503), 1,
      sym__layout_semicolon,
    STATE(2805), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86236] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7886), 1,
      sym__layout_end,
    ACTIONS(8505), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86336] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7842), 1,
      sym__layout_end,
    ACTIONS(8507), 1,
      sym__layout_semicolon,
    STATE(2808), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86389] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8509), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86440] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86487] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7745), 1,
      aux_sym_immediate_hash_token1,
    STATE(3390), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86585] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8512), 1,
      anon_sym_SEMI,
    ACTIONS(8515), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 37,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86779] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86826] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8518), 1,
      anon_sym_SEMI,
    ACTIONS(8520), 1,
      sym__layout_semicolon,
    ACTIONS(8522), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86881] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      aux_sym_immediate_hash_token1,
    STATE(3435), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [86979] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8103), 1,
      anon_sym_COMMA,
    ACTIONS(8524), 1,
      sym__layout_end,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(8106), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(7360), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87079] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8527), 1,
      anon_sym_SEMI,
    ACTIONS(8529), 1,
      sym__layout_semicolon,
    ACTIONS(8531), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87134] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7958), 1,
      sym__layout_end,
    ACTIONS(8533), 1,
      anon_sym_SEMI,
    ACTIONS(8535), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87189] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8015), 1,
      sym__layout_end,
    ACTIONS(8537), 1,
      anon_sym_SEMI,
    ACTIONS(8539), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87244] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DASH_GT,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3802), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8027), 1,
      sym__layout_end,
    ACTIONS(8541), 1,
      anon_sym_SEMI,
    ACTIONS(8543), 1,
      sym__layout_semicolon,
    STATE(2826), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87352] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8033), 1,
      sym__layout_end,
    ACTIONS(8545), 1,
      anon_sym_SEMI,
    ACTIONS(8547), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87407] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8549), 1,
      anon_sym_SEMI,
    ACTIONS(8551), 1,
      sym__layout_semicolon,
    ACTIONS(8553), 1,
      sym__layout_end,
    STATE(2850), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87509] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8021), 1,
      sym__layout_end,
    ACTIONS(8555), 1,
      anon_sym_SEMI,
    ACTIONS(8557), 1,
      sym__layout_semicolon,
    STATE(2827), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87564] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7868), 1,
      sym__layout_end,
    ACTIONS(8559), 1,
      anon_sym_SEMI,
    ACTIONS(8561), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87619] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8003), 1,
      sym__layout_end,
    ACTIONS(8563), 1,
      anon_sym_SEMI,
    ACTIONS(8565), 1,
      sym__layout_semicolon,
    STATE(2830), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87674] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      sym_kw_equals,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3151), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5736), 5,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 29,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7985), 1,
      sym__layout_end,
    ACTIONS(8567), 1,
      anon_sym_SEMI,
    ACTIONS(8569), 1,
      sym__layout_semicolon,
    STATE(2834), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87784] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7979), 1,
      sym__layout_end,
    ACTIONS(8571), 1,
      anon_sym_SEMI,
    ACTIONS(8573), 1,
      sym__layout_semicolon,
    STATE(2815), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87886] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8575), 1,
      sym__layout_semicolon,
    STATE(2840), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87937] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8578), 1,
      sym__dot,
    ACTIONS(8580), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [87988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88035] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7967), 1,
      sym__layout_end,
    ACTIONS(8582), 1,
      anon_sym_SEMI,
    ACTIONS(8584), 1,
      sym__layout_semicolon,
    STATE(2838), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88090] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8586), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88139] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8588), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88188] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DASH_GT,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3933), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88241] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8590), 1,
      anon_sym_SEMI,
    ACTIONS(8592), 1,
      sym__layout_semicolon,
    ACTIONS(8594), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88296] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8596), 1,
      anon_sym_SEMI,
    ACTIONS(8598), 1,
      sym__layout_semicolon,
    ACTIONS(8600), 1,
      sym__layout_end,
    STATE(2847), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88351] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8602), 1,
      aux_sym_immediate_hash_token1,
    STATE(3544), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88402] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8604), 1,
      anon_sym_SEMI,
    ACTIONS(8606), 1,
      sym__layout_semicolon,
    ACTIONS(8608), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88457] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8610), 1,
      anon_sym_SEMI,
    ACTIONS(8612), 1,
      sym__layout_semicolon,
    ACTIONS(8614), 1,
      sym__layout_end,
    STATE(2865), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88747] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      aux_sym_immediate_hash_token1,
    STATE(4341), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5721), 2,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5727), 4,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5723), 29,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88802] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8618), 1,
      anon_sym_SEMI,
    ACTIONS(8620), 1,
      sym__layout_semicolon,
    ACTIONS(8622), 1,
      sym__layout_end,
    STATE(2863), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 36,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [88998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89045] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8624), 1,
      anon_sym_SEMI,
    ACTIONS(8626), 1,
      sym__layout_semicolon,
    ACTIONS(8628), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89100] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8630), 1,
      anon_sym_SEMI,
    ACTIONS(8632), 1,
      sym__layout_semicolon,
    ACTIONS(8634), 1,
      sym__layout_end,
    STATE(2869), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89155] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8636), 1,
      anon_sym_SEMI,
    ACTIONS(8638), 1,
      sym__layout_semicolon,
    ACTIONS(8640), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89210] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8642), 1,
      sym__dot,
    ACTIONS(8644), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym__,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89308] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8646), 1,
      anon_sym_SEMI,
    ACTIONS(8648), 1,
      sym__layout_semicolon,
    ACTIONS(8650), 1,
      sym__layout_end,
    STATE(2820), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89363] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8652), 1,
      anon_sym_SEMI,
    ACTIONS(8654), 1,
      sym__layout_semicolon,
    ACTIONS(8656), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89418] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89700] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89890] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      aux_sym_immediate_hash_token1,
    STATE(4343), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5732), 2,
      anon_sym_COLON,
      sym_kw_equals,
    ACTIONS(5736), 4,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
    ACTIONS(5734), 29,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [89992] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8658), 1,
      anon_sym_SEMI,
    ACTIONS(8660), 1,
      sym__layout_semicolon,
    ACTIONS(8662), 1,
      sym__layout_end,
    STATE(2887), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 37,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 35,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90188] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8664), 1,
      anon_sym_SEMI,
    ACTIONS(8666), 1,
      sym__layout_semicolon,
    ACTIONS(8668), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90243] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8670), 1,
      anon_sym_SEMI,
    ACTIONS(8672), 1,
      sym__layout_semicolon,
    ACTIONS(8674), 1,
      sym__layout_end,
    STATE(2770), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90298] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8676), 1,
      anon_sym_SEMI,
    ACTIONS(8678), 1,
      sym__layout_semicolon,
    ACTIONS(8680), 1,
      sym__layout_end,
    STATE(2886), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90399] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8682), 1,
      sym__layout_semicolon,
    STATE(3103), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6728), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90495] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8684), 1,
      sym__layout_semicolon,
    ACTIONS(8686), 1,
      sym__layout_end,
    STATE(2977), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90547] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8688), 1,
      sym__layout_semicolon,
    ACTIONS(8690), 1,
      sym__layout_end,
    STATE(2925), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90599] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8692), 1,
      sym__layout_semicolon,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90649] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90787] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8695), 1,
      anon_sym_SEMI,
    ACTIONS(8697), 1,
      sym__layout_semicolon,
    ACTIONS(8699), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90841] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8701), 1,
      anon_sym_SEMI,
    ACTIONS(8704), 1,
      sym__layout_semicolon,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90893] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8707), 1,
      sym__layout_semicolon,
    ACTIONS(8709), 1,
      sym__layout_end,
    STATE(2912), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [90991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91037] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4686), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91087] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8711), 1,
      sym__layout_semicolon,
    ACTIONS(8713), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91185] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8715), 1,
      sym__layout_end,
    ACTIONS(7218), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91279] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3933), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91375] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5736), 1,
      anon_sym_DASH_GT,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3151), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91473] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8717), 1,
      sym__layout_semicolon,
    ACTIONS(8719), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91525] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91617] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8721), 1,
      sym__layout_semicolon,
    ACTIONS(8723), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91669] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8725), 1,
      sym__layout_semicolon,
    ACTIONS(8727), 1,
      sym__layout_end,
    STATE(2904), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7406), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7402), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [91997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92089] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8729), 1,
      sym__layout_semicolon,
    ACTIONS(8731), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8733), 1,
      sym__layout_semicolon,
    ACTIONS(8735), 1,
      sym__layout_end,
    STATE(2915), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92285] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92331] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8737), 1,
      sym__layout_semicolon,
    ACTIONS(8739), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92429] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8741), 1,
      sym__layout_semicolon,
    ACTIONS(8743), 1,
      sym__layout_end,
    STATE(2930), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8745), 1,
      sym__layout_semicolon,
    ACTIONS(8747), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92671] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8749), 1,
      sym__layout_semicolon,
    ACTIONS(8751), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92769] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8753), 1,
      sym__layout_end,
    ACTIONS(6925), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92817] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8158), 1,
      sym__layout_end,
    ACTIONS(8755), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [92961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3802), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93563] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8757), 1,
      sym__layout_semicolon,
    ACTIONS(8759), 1,
      sym__layout_end,
    STATE(2968), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8761), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93709] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8763), 1,
      sym__layout_semicolon,
    STATE(3065), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6726), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6728), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [93989] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8765), 1,
      sym__layout_end,
    ACTIONS(6931), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94037] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8767), 1,
      sym__layout_semicolon,
    ACTIONS(8769), 1,
      sym__layout_end,
    STATE(3024), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94135] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8771), 1,
      sym__layout_semicolon,
    ACTIONS(8773), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94233] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8775), 1,
      sym__layout_semicolon,
    ACTIONS(8777), 1,
      sym__layout_end,
    STATE(2980), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94285] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5727), 1,
      anon_sym_DASH_GT,
    ACTIONS(7730), 1,
      aux_sym_immediate_hash_token1,
    STATE(3166), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94475] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8779), 1,
      anon_sym_SEMI,
    ACTIONS(8781), 1,
      sym__layout_semicolon,
    ACTIONS(8783), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94575] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8785), 1,
      sym__layout_semicolon,
    ACTIONS(8787), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94719] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8789), 1,
      sym__layout_semicolon,
    ACTIONS(8791), 1,
      sym__layout_end,
    STATE(2766), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94817] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8793), 1,
      anon_sym_SEMI,
    ACTIONS(8795), 1,
      sym__layout_semicolon,
    ACTIONS(8797), 1,
      sym__layout_end,
    STATE(3038), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [94963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7234), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95425] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8799), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95473] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8801), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8763), 1,
      sym__layout_semicolon,
    STATE(2959), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6884), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95755] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8803), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95803] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8682), 1,
      sym__layout_semicolon,
    STATE(2890), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6882), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6884), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8805), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95901] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8807), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [95995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96087] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8809), 1,
      anon_sym_SEMI,
    ACTIONS(8811), 1,
      sym__layout_semicolon,
    ACTIONS(8813), 1,
      sym__layout_end,
    STATE(3010), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96141] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8815), 1,
      anon_sym_SEMI,
    ACTIONS(8817), 1,
      sym__layout_semicolon,
    ACTIONS(8819), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96195] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8821), 1,
      anon_sym_SEMI,
    ACTIONS(8823), 1,
      sym__layout_semicolon,
    ACTIONS(8825), 1,
      sym__layout_end,
    STATE(3028), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96249] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8827), 1,
      anon_sym_SEMI,
    ACTIONS(8829), 1,
      sym__layout_semicolon,
    ACTIONS(8831), 1,
      sym__layout_end,
    STATE(3040), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96349] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4662), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96445] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8833), 1,
      anon_sym_SEMI,
    ACTIONS(8835), 1,
      sym__layout_semicolon,
    ACTIONS(8837), 1,
      sym__layout_end,
    STATE(3304), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96821] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8839), 1,
      sym__layout_semicolon,
    ACTIONS(8841), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8843), 1,
      sym__layout_semicolon,
    ACTIONS(8845), 1,
      sym__layout_end,
    STATE(3077), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96925] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [96971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97017] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8847), 1,
      anon_sym_SEMI,
    ACTIONS(8849), 1,
      sym__layout_semicolon,
    ACTIONS(8851), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97117] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8853), 1,
      anon_sym_SEMI,
    ACTIONS(8855), 1,
      sym__layout_semicolon,
    ACTIONS(8857), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97171] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8859), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97495] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8861), 1,
      anon_sym_SEMI,
    ACTIONS(8863), 1,
      sym__layout_semicolon,
    ACTIONS(8865), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97549] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8867), 1,
      anon_sym_SEMI,
    ACTIONS(8869), 1,
      sym__layout_semicolon,
    ACTIONS(8871), 1,
      sym__layout_end,
    STATE(3048), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97603] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8873), 1,
      anon_sym_SEMI,
    ACTIONS(8875), 1,
      sym__layout_semicolon,
    ACTIONS(8877), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97657] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8879), 1,
      anon_sym_SEMI,
    ACTIONS(8881), 1,
      sym__layout_semicolon,
    ACTIONS(8883), 1,
      sym__layout_end,
    STATE(3049), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97803] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8885), 1,
      anon_sym_SEMI,
    ACTIONS(8887), 1,
      sym__layout_semicolon,
    ACTIONS(8889), 1,
      sym__layout_end,
    STATE(3085), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [97995] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8891), 1,
      anon_sym_SEMI,
    ACTIONS(8893), 1,
      sym__layout_semicolon,
    ACTIONS(8895), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98049] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8897), 1,
      anon_sym_SEMI,
    ACTIONS(8899), 1,
      sym__layout_semicolon,
    ACTIONS(8901), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98103] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98241] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7824), 1,
      aux_sym_immediate_hash_token1,
    STATE(3800), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98383] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8903), 1,
      anon_sym_SEMI,
    ACTIONS(8906), 1,
      sym__layout_semicolon,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98481] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8909), 1,
      sym__layout_semicolon,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98577] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8912), 1,
      sym__layout_semicolon,
    ACTIONS(8914), 1,
      sym__layout_end,
    STATE(2933), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98813] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8916), 1,
      sym__layout_semicolon,
    STATE(3065), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [98955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99001] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8919), 1,
      sym__layout_semicolon,
    ACTIONS(8921), 1,
      sym__layout_end,
    STATE(3107), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99145] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99237] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8923), 1,
      sym__dot,
    ACTIONS(8925), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99379] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8927), 1,
      sym__layout_semicolon,
    ACTIONS(8929), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99431] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8931), 1,
      sym__dot,
    ACTIONS(8933), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99481] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8142), 1,
      sym__layout_end,
    ACTIONS(8935), 1,
      sym__layout_semicolon,
    STATE(2940), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99671] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8937), 1,
      sym__layout_semicolon,
    ACTIONS(8939), 1,
      sym__layout_end,
    STATE(3191), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99723] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7156), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99769] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8941), 1,
      anon_sym_SEMI,
    ACTIONS(8943), 1,
      sym__layout_semicolon,
    ACTIONS(8945), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99823] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [99961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100145] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8947), 1,
      sym__dot,
    ACTIONS(8949), 1,
      sym_hash_cid,
    ACTIONS(5870), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100195] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8138), 1,
      sym__layout_end,
    ACTIONS(8951), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100339] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8953), 1,
      anon_sym_SEMI,
    ACTIONS(8955), 1,
      sym__layout_semicolon,
    ACTIONS(8957), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8087), 1,
      sym__layout_end,
    ACTIONS(8959), 1,
      sym__layout_semicolon,
    STATE(3094), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100491] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8237), 1,
      sym__layout_end,
    ACTIONS(8961), 1,
      sym__layout_semicolon,
    STATE(2811), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100543] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      aux_sym_immediate_hash_token1,
    STATE(3801), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100639] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8963), 1,
      sym__layout_semicolon,
    STATE(3103), 1,
      aux_sym__match_cases_repeat1,
    ACTIONS(6689), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7456), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100735] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8966), 1,
      sym__dot,
    ACTIONS(8968), 1,
      sym_hash_cid,
    ACTIONS(5743), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100785] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8970), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100833] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8972), 1,
      sym__layout_semicolon,
    ACTIONS(8974), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100885] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8976), 1,
      sym__layout_semicolon,
    ACTIONS(8978), 1,
      sym__layout_end,
    STATE(2937), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [100983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101075] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8980), 1,
      anon_sym_SEMI,
    ACTIONS(8982), 1,
      sym__layout_semicolon,
    ACTIONS(8984), 1,
      sym__layout_end,
    STATE(2975), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101175] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8986), 1,
      sym__layout_semicolon,
    ACTIONS(8988), 1,
      sym__layout_end,
    STATE(3116), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101273] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8990), 1,
      sym__layout_semicolon,
    ACTIONS(8992), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101325] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8067), 1,
      sym__layout_end,
    ACTIONS(8994), 1,
      sym__layout_semicolon,
    STATE(3100), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4661), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101519] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101565] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8996), 1,
      sym__layout_semicolon,
    ACTIONS(8998), 1,
      sym__layout_end,
    STATE(3208), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101847] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101893] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [101985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102031] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102215] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6295), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9000), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102725] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4705), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102775] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9002), 1,
      sym__dot,
    ACTIONS(9004), 1,
      sym_hash_cid,
    ACTIONS(5743), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9006), 1,
      sym__dot,
    ACTIONS(9008), 1,
      sym_hash_cid,
    ACTIONS(5870), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7156), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [102967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9010), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103429] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7234), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [103981] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9012), 1,
      anon_sym_SEMI,
    ACTIONS(9014), 1,
      sym__layout_semicolon,
    ACTIONS(9016), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104219] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9018), 1,
      anon_sym_SEMI,
    ACTIONS(9020), 1,
      sym__layout_semicolon,
    ACTIONS(9022), 1,
      sym__layout_end,
    STATE(3097), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104273] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9024), 1,
      anon_sym_SEMI,
    ACTIONS(9026), 1,
      sym__layout_semicolon,
    ACTIONS(9028), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104373] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9030), 1,
      anon_sym_SEMI,
    ACTIONS(9032), 1,
      sym__layout_semicolon,
    ACTIONS(9034), 1,
      sym__layout_end,
    STATE(3174), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104473] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9036), 1,
      anon_sym_SEMI,
    ACTIONS(9038), 1,
      sym__layout_semicolon,
    ACTIONS(9040), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104757] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9042), 1,
      sym__layout_semicolon,
    ACTIONS(9044), 1,
      sym__layout_end,
    STATE(2711), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [104993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105269] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9046), 1,
      anon_sym_SEMI,
    ACTIONS(9048), 1,
      sym__layout_semicolon,
    ACTIONS(9050), 1,
      sym__layout_end,
    STATE(3180), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105461] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105599] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9052), 1,
      sym__layout_semicolon,
    ACTIONS(9054), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105743] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9056), 1,
      sym__layout_end,
    ACTIONS(6931), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [105975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106021] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9058), 1,
      anon_sym_SEMI,
    ACTIONS(9060), 1,
      sym__layout_semicolon,
    ACTIONS(9062), 1,
      sym__layout_end,
    STATE(3184), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106443] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9064), 1,
      sym__layout_semicolon,
    ACTIONS(9066), 1,
      sym__layout_end,
    STATE(3242), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106495] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106541] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9068), 1,
      aux_sym_immediate_hash_token1,
    STATE(3947), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106591] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9070), 1,
      anon_sym_SEMI,
    ACTIONS(9072), 1,
      sym__layout_semicolon,
    ACTIONS(9074), 1,
      sym__layout_end,
    STATE(3056), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106645] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9076), 1,
      anon_sym_SEMI,
    ACTIONS(9078), 1,
      sym__layout_semicolon,
    ACTIONS(9080), 1,
      sym__layout_end,
    STATE(3030), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106745] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9082), 1,
      anon_sym_SEMI,
    ACTIONS(9084), 1,
      sym__layout_semicolon,
    ACTIONS(9086), 1,
      sym__layout_end,
    STATE(3229), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106891] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [106983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107213] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9088), 1,
      sym__layout_semicolon,
    ACTIONS(9090), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9092), 1,
      sym__layout_end,
    ACTIONS(7218), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107313] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7826), 1,
      aux_sym_immediate_hash_token1,
    STATE(3974), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107363] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9094), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107457] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107549] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9096), 1,
      sym__layout_semicolon,
    ACTIONS(9098), 1,
      sym__layout_end,
    STATE(3250), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107601] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9100), 1,
      sym__layout_semicolon,
    ACTIONS(9102), 1,
      sym__layout_end,
    STATE(2578), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [107975] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108113] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4680), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108209] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108347] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9104), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 36,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108717] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9106), 1,
      anon_sym_SEMI,
    ACTIONS(9108), 1,
      sym__layout_semicolon,
    ACTIONS(9110), 1,
      sym__layout_end,
    STATE(3275), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108771] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9112), 1,
      anon_sym_SEMI,
    ACTIONS(9114), 1,
      sym__layout_semicolon,
    ACTIONS(9116), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108825] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9118), 1,
      aux_sym_immediate_hash_token1,
    STATE(4070), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108875] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108921] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [108967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109151] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9120), 1,
      anon_sym_SEMI,
    ACTIONS(9122), 1,
      sym__layout_semicolon,
    ACTIONS(9124), 1,
      sym__layout_end,
    STATE(3295), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7402), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109297] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7406), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9126), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109667] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9128), 1,
      anon_sym_SEMI,
    ACTIONS(9130), 1,
      sym__layout_semicolon,
    ACTIONS(9132), 1,
      sym__layout_end,
    STATE(3307), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109721] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9134), 1,
      anon_sym_SEMI,
    ACTIONS(9136), 1,
      sym__layout_semicolon,
    ACTIONS(9138), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109913] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9140), 1,
      anon_sym_SEMI,
    ACTIONS(9142), 1,
      sym__layout_semicolon,
    ACTIONS(9144), 1,
      sym__layout_end,
    STATE(3316), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [109967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7456), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110151] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9146), 1,
      anon_sym_SEMI,
    ACTIONS(9148), 1,
      sym__layout_semicolon,
    ACTIONS(9150), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110297] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9152), 1,
      anon_sym_SEMI,
    ACTIONS(9154), 1,
      sym__layout_semicolon,
    ACTIONS(9156), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110581] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9158), 1,
      sym__layout_end,
    ACTIONS(6925), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110675] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9160), 1,
      anon_sym_SEMI,
    ACTIONS(9162), 1,
      sym__layout_semicolon,
    ACTIONS(9164), 1,
      sym__layout_end,
    STATE(2898), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110729] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9166), 1,
      anon_sym_SEMI,
    ACTIONS(9168), 1,
      sym__layout_semicolon,
    ACTIONS(9170), 1,
      sym__layout_end,
    STATE(2899), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110783] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110874] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110919] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [110964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111054] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111144] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111369] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111459] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111549] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111684] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111864] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [111999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112044] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112314] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112539] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112674] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112809] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [112989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113214] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113259] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9172), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113306] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113351] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9174), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9176), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113670] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113715] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113850] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [113985] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114075] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114435] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9178), 1,
      sym__dot,
    ACTIONS(9180), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114484] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9182), 1,
      sym__dot,
    ACTIONS(9184), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9186), 1,
      sym__dot,
    ACTIONS(9188), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114807] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      aux_sym_immediate_hash_token1,
    STATE(4343), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9190), 1,
      sym__dot,
    ACTIONS(9192), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114950] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [114995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115130] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4713), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9194), 1,
      sym_hash_cid,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115496] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115586] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115766] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115946] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4707), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [115995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116085] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116130] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116717] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116852] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [116987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117032] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117212] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117482] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [117977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118292] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118382] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118472] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118607] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118832] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [118967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119012] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119057] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119102] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119642] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119732] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119912] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [119957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120002] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120047] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120272] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120452] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120902] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [120992] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121082] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121127] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8992), 1,
      sym__layout_end,
    ACTIONS(9196), 1,
      sym__layout_semicolon,
    STATE(3601), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121448] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8988), 1,
      sym__layout_end,
    ACTIONS(9198), 1,
      sym__layout_semicolon,
    STATE(3546), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121499] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8974), 1,
      sym__layout_end,
    ACTIONS(9200), 1,
      sym__layout_semicolon,
    STATE(3601), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121550] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121640] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8921), 1,
      sym__layout_end,
    ACTIONS(9202), 1,
      sym__layout_semicolon,
    STATE(3554), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9204), 1,
      sym__layout_end,
    ACTIONS(6931), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121873] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8747), 1,
      sym__layout_end,
    ACTIONS(9206), 1,
      sym__layout_semicolon,
    STATE(3601), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [121969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9208), 1,
      sym__layout_end,
    ACTIONS(6925), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122376] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9210), 1,
      aux_sym_immediate_hash_token1,
    STATE(4098), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122515] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8914), 1,
      sym__layout_end,
    ACTIONS(9212), 1,
      sym__layout_semicolon,
    STATE(3562), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122746] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122881] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [122971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123016] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123196] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123286] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123376] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123421] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8616), 1,
      aux_sym_immediate_hash_token1,
    STATE(4341), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123515] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123560] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4696), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9214), 1,
      sym__layout_semicolon,
    STATE(3601), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6902), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7156), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9217), 1,
      sym__layout_end,
    ACTIONS(7218), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123840] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9219), 1,
      anon_sym_SEMI,
    ACTIONS(9222), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6868), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6870), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123891] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9225), 1,
      sym__layout_semicolon,
    ACTIONS(9227), 1,
      sym__layout_end,
    STATE(3620), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [123987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124124] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124214] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      aux_sym_immediate_hash_token1,
    STATE(4144), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5730), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5734), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124533] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9229), 1,
      sym__layout_semicolon,
    ACTIONS(9231), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124584] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124629] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9233), 1,
      sym__layout_end,
    ACTIONS(6925), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124676] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124721] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124766] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9235), 1,
      sym__layout_end,
    ACTIONS(6931), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [124993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125128] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125218] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9237), 1,
      sym__layout_semicolon,
    ACTIONS(9239), 1,
      sym__layout_end,
    STATE(3637), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125314] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9241), 1,
      sym__layout_semicolon,
    ACTIONS(9243), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125365] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4685), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125414] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9245), 1,
      sym__layout_semicolon,
    ACTIONS(9247), 1,
      sym__layout_end,
    STATE(3646), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7234), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125600] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125690] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125735] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9249), 1,
      sym__layout_semicolon,
    ACTIONS(9251), 1,
      sym__layout_end,
    STATE(2894), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125786] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9253), 1,
      sym__layout_semicolon,
    ACTIONS(9255), 1,
      sym__layout_end,
    STATE(3652), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6770), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6772), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9257), 1,
      sym__layout_end,
    ACTIONS(7218), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9259), 1,
      sym_hash_cid,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [125976] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126021] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9261), 1,
      sym__layout_semicolon,
    ACTIONS(9263), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6892), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6894), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126117] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126252] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9265), 1,
      sym__layout_semicolon,
    ACTIONS(9267), 1,
      sym__layout_end,
    STATE(3660), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6907), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6909), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126303] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126348] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126393] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9269), 1,
      sym__layout_semicolon,
    ACTIONS(9271), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6839), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6841), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126489] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9273), 1,
      sym__layout_semicolon,
    ACTIONS(9275), 1,
      sym__layout_end,
    STATE(3666), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6831), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6833), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126540] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126675] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9277), 1,
      sym__layout_semicolon,
    ACTIONS(9279), 1,
      sym__layout_end,
    STATE(3058), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6811), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6813), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126906] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126951] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 34,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [126998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127088] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7402), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7406), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127448] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127538] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127628] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127718] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127808] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7456), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [127988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128078] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128168] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128258] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8901), 1,
      sym__layout_end,
    ACTIONS(9281), 1,
      anon_sym_SEMI,
    ACTIONS(9283), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6572), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6574), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128356] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7404), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7406), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128491] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128626] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128671] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7400), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7402), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128851] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8895), 1,
      sym__layout_end,
    ACTIONS(9285), 1,
      anon_sym_SEMI,
    ACTIONS(9287), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [128994] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129084] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7454), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7456), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129264] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8883), 1,
      sym__layout_end,
    ACTIONS(9289), 1,
      anon_sym_SEMI,
    ACTIONS(9291), 1,
      sym__layout_semicolon,
    STATE(3701), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6651), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6653), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129452] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9293), 1,
      aux_sym_immediate_hash_token1,
    STATE(4305), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129501] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129591] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9295), 1,
      sym_hash_cid,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129818] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8877), 1,
      sym__layout_end,
    ACTIONS(9297), 1,
      anon_sym_SEMI,
    ACTIONS(9299), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6639), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6641), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129916] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [129961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6689), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6691), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130141] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130186] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7156), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130231] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8871), 1,
      sym__layout_end,
    ACTIONS(9301), 1,
      anon_sym_SEMI,
    ACTIONS(9303), 1,
      sym__layout_semicolon,
    STATE(3714), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130284] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8851), 1,
      sym__layout_end,
    ACTIONS(9305), 1,
      anon_sym_SEMI,
    ACTIONS(9307), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6679), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6681), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130337] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8831), 1,
      sym__layout_end,
    ACTIONS(9309), 1,
      anon_sym_SEMI,
    ACTIONS(9311), 1,
      sym__layout_semicolon,
    STATE(3735), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6669), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6671), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130390] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130435] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130525] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9313), 1,
      sym_hash_cid,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7172), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130707] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130752] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130842] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130932] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [130977] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6121), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131206] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131296] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131341] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7232), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7234), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131431] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8825), 1,
      sym__layout_end,
    ACTIONS(9315), 1,
      anon_sym_SEMI,
    ACTIONS(9317), 1,
      sym__layout_semicolon,
    STATE(3745), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6629), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6631), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131529] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8819), 1,
      sym__layout_end,
    ACTIONS(9319), 1,
      anon_sym_SEMI,
    ACTIONS(9321), 1,
      sym__layout_semicolon,
    STATE(3605), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6617), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6619), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131627] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7852), 1,
      aux_sym_immediate_hash_token1,
    STATE(4161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131676] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4699), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131860] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 35,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [131950] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8813), 1,
      sym__layout_end,
    ACTIONS(9323), 1,
      anon_sym_SEMI,
    ACTIONS(9325), 1,
      sym__layout_semicolon,
    STATE(3772), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(6536), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6538), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132003] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 4,
      sym__layout_semicolon,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 35,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132225] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132313] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132401] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132533] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9327), 1,
      sym__dot,
    ACTIONS(9329), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132625] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9331), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132671] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9333), 1,
      sym__dot,
    ACTIONS(9335), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132939] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9337), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [132985] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4702), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133121] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133209] = 23,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9341), 1,
      anon_sym_LPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9353), 1,
      sym_path,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    STATE(4802), 1,
      sym_forall,
    STATE(5008), 1,
      sym__effect_list,
    STATE(5141), 1,
      sym_wordy_id,
    STATE(5170), 1,
      sym__identifier,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5741), 1,
      sym__value_type,
    STATE(6163), 1,
      sym_open_parens,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6860), 2,
      sym__effect,
      sym__computation_type,
    STATE(5305), 3,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
      aux_sym_rewrite_type_repeat1,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [133293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133513] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133557] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133645] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133689] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133777] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9359), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [133999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134263] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134395] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134571] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [134967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135187] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4681), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6398), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135499] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135543] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135807] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135895] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135939] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [135983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136115] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136159] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136335] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136379] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136511] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136819] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136863] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [136995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137039] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9361), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137217] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9363), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137263] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9365), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137309] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9367), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137399] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9369), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137577] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137841] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137929] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [137973] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138017] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138105] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138149] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9371), 1,
      sym__dot,
    ACTIONS(9373), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5872), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138285] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9375), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138595] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138729] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138817] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138861] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [138993] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139125] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139213] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9379), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9382), 1,
      sym_symboly_id,
    ACTIONS(9385), 1,
      sym_path,
    STATE(4652), 1,
      sym_wordy_id,
    STATE(3944), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9388), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(9377), 27,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139355] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139399] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9390), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9392), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139799] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139931] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [139975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9394), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140021] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9396), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140287] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140375] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140419] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140463] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140595] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [140991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141079] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141211] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141257] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141345] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141389] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141433] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141477] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141521] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141697] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 34,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141873] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [141961] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9398), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142139] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142183] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9400), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142273] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142449] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4710), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142673] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9404), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9406), 1,
      sym_symboly_id,
    ACTIONS(9408), 1,
      sym_path,
    STATE(4652), 1,
      sym_wordy_id,
    STATE(3944), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9410), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(9402), 27,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142903] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4669), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [142995] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9412), 1,
      sym__dot,
    ACTIONS(9414), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5745), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143087] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 34,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9416), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143177] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143221] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4698), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143269] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4706), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6722), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143361] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143405] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143581] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9404), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9406), 1,
      sym_symboly_id,
    ACTIONS(9408), 1,
      sym_path,
    STATE(4652), 1,
      sym_wordy_id,
    STATE(4022), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9420), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(9418), 27,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143635] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9422), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143725] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143857] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143901] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143945] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [143989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144077] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9424), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144123] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144167] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144255] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6063), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6092), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6303), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144475] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9426), 1,
      aux_sym_immediate_hash_token1,
    STATE(4551), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9428), 1,
      aux_sym_immediate_hash_token1,
    STATE(4639), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5820), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144659] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144747] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6293), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144835] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [144967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6183), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145187] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 3,
      sym__layout_end,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145275] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6187), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6287), 34,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145406] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145449] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(3566), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [145530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145573] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145616] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(4320), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [145697] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(3561), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [145778] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(4307), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [145859] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(4243), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [145940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [145983] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146069] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146112] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146284] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(2965), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [146494] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(2939), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [146575] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(3948), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [146656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [146957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147000] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147043] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147086] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147129] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147172] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147215] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147430] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147473] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147559] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147602] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(2907), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [147683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147726] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147769] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147855] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [147984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148027] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148070] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148113] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148199] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148242] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(3313), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [148323] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(3214), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [148404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148447] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148490] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148533] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148576] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148619] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148662] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148705] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148748] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2998), 1,
      sym_pattern,
    STATE(3648), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [148829] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148872] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148915] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [148958] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149001] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(2119), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149082] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9458), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149170] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(1957), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149380] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149466] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149509] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(1953), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149590] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149633] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1612), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149714] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1610), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [149881] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4858), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(7086), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(7087), 2,
      sym_effect_pure,
      sym_effect_bind,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [149960] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(1914), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150041] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(2005), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150122] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150165] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 33,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150208] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150251] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1683), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150332] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(3803), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150413] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(3796), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150494] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150666] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(3897), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150747] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(3923), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150828] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(4053), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [150909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150952] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [150995] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151081] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151124] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(4044), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [151205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151248] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(3964), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [151329] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9480), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151460] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151503] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151589] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9482), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151677] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9484), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [151980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152023] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152195] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152238] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152281] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1980), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [152362] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(4007), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [152443] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152486] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(3951), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [152567] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152696] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152739] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152782] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152868] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152911] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152954] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [152997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153040] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153083] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153126] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153169] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153212] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(3961), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [153293] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153336] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2788), 1,
      sym_pattern,
    STATE(3243), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [153417] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(2543), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [153498] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1970), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [153579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153622] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9486), 1,
      sym__layout_end,
    ACTIONS(7218), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7220), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153667] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153753] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153796] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(3146), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [153877] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153920] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [153963] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9488), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154051] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154094] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LBRACE,
    ACTIONS(777), 1,
      sym_symboly_id,
    ACTIONS(9456), 1,
      sym__parenthesized_operator,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9490), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9492), 1,
      anon_sym_LPAREN,
    ACTIONS(9494), 1,
      anon_sym_LBRACK,
    ACTIONS(9496), 1,
      sym_path,
    ACTIONS(9498), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9500), 1,
      sym_built_in_hash,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6119), 1,
      sym__pattern_root,
    STATE(6734), 1,
      sym__hq_qualified_symboly_id,
    ACTIONS(9466), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    ACTIONS(753), 3,
      sym_nat,
      sym_int,
      anon_sym__,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [154173] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4858), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(7086), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(7089), 2,
      sym_effect_pure,
      sym_effect_bind,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [154252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154295] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154338] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154381] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1602), 1,
      sym_pattern,
    STATE(1958), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [154462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154505] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154548] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2720), 1,
      sym_pattern,
    STATE(4012), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [154629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9502), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154760] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154803] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154889] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154934] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [154977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155020] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155063] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155149] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 33,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155235] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155536] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155579] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155708] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(3290), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [155789] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [155832] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LBRACE,
    ACTIONS(777), 1,
      sym_symboly_id,
    ACTIONS(9456), 1,
      sym__parenthesized_operator,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9490), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9492), 1,
      anon_sym_LPAREN,
    ACTIONS(9494), 1,
      anon_sym_LBRACK,
    ACTIONS(9496), 1,
      sym_path,
    ACTIONS(9498), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9500), 1,
      sym_built_in_hash,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6170), 1,
      sym__pattern_root,
    STATE(6734), 1,
      sym__hq_qualified_symboly_id,
    ACTIONS(9466), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    ACTIONS(753), 3,
      sym_nat,
      sym_int,
      anon_sym__,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [155911] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4858), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(7086), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(6972), 2,
      sym_effect_pure,
      sym_effect_bind,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [155990] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156033] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156076] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(3625), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [156157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9504), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(6127), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6123), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156245] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156288] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156331] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156374] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156417] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(3622), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [156498] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156541] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(751), 1,
      anon_sym_LBRACE,
    ACTIONS(777), 1,
      sym_symboly_id,
    ACTIONS(9456), 1,
      sym__parenthesized_operator,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9490), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9492), 1,
      anon_sym_LPAREN,
    ACTIONS(9494), 1,
      anon_sym_LBRACK,
    ACTIONS(9496), 1,
      sym_path,
    ACTIONS(9498), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9500), 1,
      sym_built_in_hash,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6209), 1,
      sym__pattern_root,
    STATE(6734), 1,
      sym__hq_qualified_symboly_id,
    ACTIONS(9466), 2,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    ACTIONS(753), 3,
      sym_nat,
      sym_int,
      anon_sym__,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [156620] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156706] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156749] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9506), 1,
      sym__layout_end,
    ACTIONS(6925), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6927), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156923] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [156966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157138] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157267] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9508), 1,
      sym__layout_end,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157398] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157656] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6609), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6611), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157699] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157742] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157828] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157914] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [157957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158000] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(4264), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [158081] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1656), 1,
      sym_pattern,
    STATE(2025), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [158162] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158205] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158248] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158291] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(4208), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [158372] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6566), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6568), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158458] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5719), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5723), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158501] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(3160), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [158582] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158668] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158754] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158797] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__parenthesized_operator,
      sym_doc_block,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158883] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158926] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [158969] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(4157), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [159050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6613), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6615), 33,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159093] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159179] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159222] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159265] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159351] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159480] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159523] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159566] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159609] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159695] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159738] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159824] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159867] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159910] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [159953] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3003), 1,
      sym_pattern,
    STATE(3603), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [160034] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160077] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160120] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160206] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9510), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160251] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160337] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(2576), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [160418] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2357), 1,
      sym_pattern,
    STATE(2564), 1,
      sym__match_cases,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [160499] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9512), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160544] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160587] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160716] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160759] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160802] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160845] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 33,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      anon_sym_COLON,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [160972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6283), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6179), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [161980] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162022] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162106] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162148] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162232] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162274] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5945), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162358] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162400] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162442] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162484] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162526] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162568] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162610] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162652] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162736] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162778] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162820] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162862] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162904] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162946] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [162988] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163072] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163114] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163156] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163198] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163240] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163282] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163324] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163450] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163492] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163534] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2945), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5656), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [163612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163654] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163696] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(1281), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9526), 1,
      anon_sym_LPAREN,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9530), 1,
      anon_sym_RBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    STATE(4880), 1,
      sym__hq_qualified_prefix_term,
    STATE(4938), 1,
      sym_wordy_id,
    STATE(5748), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9514), 2,
      sym_nat,
      sym_int,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5342), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [163774] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7326), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7328), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163942] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [163984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164026] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164068] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164110] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7336), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7338), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164152] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7350), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7352), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164194] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164236] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7354), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7356), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164278] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164320] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164362] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7358), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7360), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164446] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164488] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7374), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7376), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164530] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7378), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7380), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164572] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7408), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7410), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164614] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164656] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(2616), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5658), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [164734] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1719), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5603), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [164812] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7434), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7436), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164854] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164896] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7442), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7444), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164938] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [164980] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3222), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5571), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [165058] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7470), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7472), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165100] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7482), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7484), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165142] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(111), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(113), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165184] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7506), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7508), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165226] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7396), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7398), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165352] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7194), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7196), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165394] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7522), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7524), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165478] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7518), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7520), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165520] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7514), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7516), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165604] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7510), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7512), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165646] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(103), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(105), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(95), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(97), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165730] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9534), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9537), 1,
      anon_sym_LPAREN,
    ACTIONS(9540), 1,
      anon_sym_LBRACK,
    ACTIONS(9543), 1,
      anon_sym_LBRACE,
    ACTIONS(9546), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9549), 1,
      sym_symboly_id,
    ACTIONS(9552), 1,
      sym_path,
    ACTIONS(9555), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9558), 1,
      sym_built_in_hash,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    ACTIONS(5158), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(4506), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5160), 10,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [165796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7478), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7480), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7474), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7476), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [165964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166132] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3741), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5555), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [166210] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7450), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7452), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166252] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7438), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7440), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166294] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7430), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7432), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166378] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166420] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166462] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166504] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7424), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7426), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166546] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(119), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(121), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166588] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(89), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(91), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166630] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166672] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7420), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7422), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166714] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7416), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7418), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166756] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166798] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166840] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [166966] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167008] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167050] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167134] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7346), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7348), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167176] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(147), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(149), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167218] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167260] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7311), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7313), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167302] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167344] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7294), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7296), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167386] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6921), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6923), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167428] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167470] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6931), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6933), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167512] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167554] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167596] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167638] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7268), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7270), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167680] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167722] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(29), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(43), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167764] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167806] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7208), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7210), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167848] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7204), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7206), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167890] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7184), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7186), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [167932] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(1894), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5521), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [168010] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168052] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7162), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7164), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168094] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5951), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168136] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(135), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(137), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168178] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7144), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7146), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168220] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168262] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9561), 1,
      anon_sym_LPAREN,
    ACTIONS(9564), 1,
      anon_sym_LBRACE,
    ACTIONS(9566), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9569), 1,
      sym_path,
    ACTIONS(9572), 1,
      sym_built_in_hash,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    ACTIONS(5123), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(4506), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5125), 10,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [168328] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168370] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168412] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7112), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168454] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9448), 1,
      anon_sym__,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    STATE(3655), 1,
      sym_pattern,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    STATE(5516), 1,
      sym__pattern_root,
    ACTIONS(9430), 2,
      sym_nat,
      sym_int,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5353), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [168532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168574] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(1281), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9526), 1,
      anon_sym_LPAREN,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9574), 1,
      anon_sym_RBRACK,
    STATE(4880), 1,
      sym__hq_qualified_prefix_term,
    STATE(4938), 1,
      sym_wordy_id,
    STATE(6147), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9514), 2,
      sym_nat,
      sym_int,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5342), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [168652] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(1281), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9526), 1,
      anon_sym_LPAREN,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9576), 1,
      anon_sym_RBRACK,
    STATE(4880), 1,
      sym__hq_qualified_prefix_term,
    STATE(4938), 1,
      sym_wordy_id,
    STATE(5984), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9514), 2,
      sym_nat,
      sym_int,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5342), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [168730] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9564), 1,
      anon_sym_LBRACE,
    ACTIONS(9578), 1,
      anon_sym_LPAREN,
    ACTIONS(9581), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9584), 1,
      sym_path,
    ACTIONS(9587), 1,
      sym_built_in_hash,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    ACTIONS(5189), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    STATE(4564), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
    ACTIONS(5191), 10,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [168796] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168838] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168880] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168922] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [168964] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169006] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169048] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169090] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169132] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6943), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169216] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169258] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169300] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169342] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169384] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169426] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169468] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6947), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169552] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(143), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6951), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169636] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(155), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169678] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(169), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6955), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169762] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6986), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169804] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(175), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169846] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6990), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7317), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [169972] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6994), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(85), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170056] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6939), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170098] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7029), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170140] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7033), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170182] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(131), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7058), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7062), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170308] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7092), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170350] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7116), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170392] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7120), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170434] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170476] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7448), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170518] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7142), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170560] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7150), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170602] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7292), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170644] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7182), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170686] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7214), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170728] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7226), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170770] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7238), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6551), 31,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170856] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7242), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170898] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7274), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170940] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7278), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [170982] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7166), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7168), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171024] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7158), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7160), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171066] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7128), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7130), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171108] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7372), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171150] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7094), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7096), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171192] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7488), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171234] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7492), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171276] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7303), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171318] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7230), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171360] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7288), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171402] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6880), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171444] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6750), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6762), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171528] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(7368), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171570] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6237), 32,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_with,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171612] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 2,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(6766), 32,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_or,
      sym_and,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [171654] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9593), 1,
      aux_sym_immediate_hash_token1,
    STATE(4722), 1,
      sym_imm_hash_qualifier,
    ACTIONS(9591), 12,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      sym_built_in_hash,
    ACTIONS(9589), 19,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
      aux_sym_hash_qualifier_token1,
  [171699] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9593), 1,
      aux_sym_immediate_hash_token1,
    STATE(4720), 1,
      sym_imm_hash_qualifier,
    ACTIONS(9597), 12,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      sym_built_in_hash,
    ACTIONS(9595), 19,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
      aux_sym_hash_qualifier_token1,
  [171744] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4643), 1,
      aux_sym_guarded_block_repeat1,
    ACTIONS(9603), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
    ACTIONS(9601), 12,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(9599), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [171789] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(1281), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9526), 1,
      anon_sym_LPAREN,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    STATE(4880), 1,
      sym__hq_qualified_prefix_term,
    STATE(4938), 1,
      sym_wordy_id,
    STATE(6465), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9514), 2,
      sym_nat,
      sym_int,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5342), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [171864] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6209), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [171939] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6494), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172014] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5741), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [172055] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6119), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172130] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9606), 1,
      ts_builtin_sym_end,
    ACTIONS(9608), 1,
      anon_sym_LPAREN,
    ACTIONS(9611), 1,
      anon_sym_use,
    ACTIONS(9614), 1,
      sym_type_kw,
    ACTIONS(9620), 1,
      sym_ability,
    ACTIONS(9623), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9626), 1,
      sym_path,
    ACTIONS(9632), 1,
      sym_fold,
    ACTIONS(9635), 1,
      sym__watch_start,
    ACTIONS(9638), 1,
      sym_doc_block,
    STATE(5099), 1,
      sym__binding,
    STATE(5100), 1,
      sym_term_definition2,
    STATE(5266), 1,
      sym_type_signature,
    STATE(5433), 1,
      sym_use,
    STATE(5685), 1,
      sym_open_parens,
    STATE(7095), 1,
      sym__type_lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(7099), 1,
      sym__lhs,
    ACTIONS(9617), 2,
      sym_structural,
      sym_unique,
    ACTIONS(9629), 2,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
    STATE(5325), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
    STATE(4649), 7,
      sym_binding,
      sym_type_declaration,
      sym_effect_declaration,
      sym_use_clause,
      sym_watch_expression,
      sym_test_watch_expression,
      aux_sym_unison_repeat1,
  [172213] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6648), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172288] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(753), 1,
      anon_sym__,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    STATE(6170), 1,
      sym__pattern_root,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9460), 2,
      sym_nat,
      sym_int,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5360), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5911), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [172404] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
    ACTIONS(5982), 30,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token1,
      aux_sym_literal_char_token2,
      anon_sym_true,
      anon_sym_false,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_if,
      anon_sym_SQUOTE,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      sym_rewrite,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [172445] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9641), 1,
      sym__dot,
    ACTIONS(9643), 1,
      sym_hash_cid,
    ACTIONS(5870), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(5872), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [172490] = 24,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9), 1,
      anon_sym_use,
    ACTIONS(11), 1,
      sym_type_kw,
    ACTIONS(15), 1,
      sym_ability,
    ACTIONS(17), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(19), 1,
      sym_path,
    ACTIONS(25), 1,
      sym__watch_start,
    ACTIONS(27), 1,
      sym_doc_block,
    ACTIONS(9645), 1,
      ts_builtin_sym_end,
    ACTIONS(9647), 1,
      sym_fold,
    STATE(5099), 1,
      sym__binding,
    STATE(5100), 1,
      sym_term_definition2,
    STATE(5266), 1,
      sym_type_signature,
    STATE(5433), 1,
      sym_use,
    STATE(5685), 1,
      sym_open_parens,
    STATE(7095), 1,
      sym__type_lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(7099), 1,
      sym__lhs,
    ACTIONS(13), 2,
      sym_structural,
      sym_unique,
    ACTIONS(21), 2,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
    STATE(5325), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
    STATE(4649), 7,
      sym_binding,
      sym_type_declaration,
      sym_effect_declaration,
      sym_use_clause,
      sym_watch_expression,
      sym_test_watch_expression,
      aux_sym_unison_repeat1,
  [172573] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9442), 1,
      anon_sym_LPAREN,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9651), 1,
      anon_sym__,
    STATE(4877), 1,
      sym__hq_qualified_prefix_term,
    STATE(4939), 1,
      sym_wordy_id,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9649), 2,
      sym_nat,
      sym_int,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5486), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172645] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(521), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9653), 1,
      anon_sym_LPAREN,
    ACTIONS(9655), 1,
      anon_sym_LBRACK,
    ACTIONS(9657), 1,
      anon_sym_SQUOTE,
    ACTIONS(9659), 1,
      sym_symboly_id,
    ACTIONS(9661), 1,
      sym_path,
    ACTIONS(9663), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    STATE(2538), 1,
      sym__value_type,
    STATE(4817), 1,
      sym_forall,
    STATE(4993), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2906), 2,
      sym__effect,
      sym__computation_type,
    STATE(2703), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1445), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [172721] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1559), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9665), 1,
      anon_sym_LPAREN,
    ACTIONS(9667), 1,
      anon_sym_LBRACK,
    ACTIONS(9669), 1,
      anon_sym_SQUOTE,
    ACTIONS(9671), 1,
      sym_symboly_id,
    ACTIONS(9673), 1,
      sym_path,
    ACTIONS(9675), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    STATE(4821), 1,
      sym_forall,
    STATE(4995), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1969), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(1983), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1388), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [172795] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 1,
      anon_sym_SQUOTE,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(4835), 1,
      sym_forall,
    STATE(5013), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2509), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(2489), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [172869] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9526), 1,
      anon_sym_LPAREN,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9691), 1,
      anon_sym__,
    STATE(4880), 1,
      sym__hq_qualified_prefix_term,
    STATE(4938), 1,
      sym_wordy_id,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9689), 2,
      sym_nat,
      sym_int,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5443), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [172941] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9697), 1,
      anon_sym_SQUOTE,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(2903), 1,
      sym__value_type,
    STATE(4788), 1,
      sym_forall,
    STATE(4981), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3678), 2,
      sym__effect,
      sym__computation_type,
    STATE(3771), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173017] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9705), 1,
      anon_sym_LPAREN,
    ACTIONS(9707), 1,
      anon_sym_LBRACK,
    ACTIONS(9709), 1,
      anon_sym_SQUOTE,
    ACTIONS(9711), 1,
      sym_symboly_id,
    ACTIONS(9713), 1,
      sym_path,
    ACTIONS(9715), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    STATE(4799), 1,
      sym_forall,
    STATE(4972), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3463), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3428), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1497), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173091] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9723), 1,
      anon_sym_SQUOTE,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9733), 1,
      sym_built_in_hash,
    STATE(4813), 1,
      sym_forall,
    STATE(4986), 1,
      sym__effect_list,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5335), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4933), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173165] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9741), 1,
      anon_sym_SQUOTE,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9751), 1,
      sym_built_in_hash,
    STATE(4785), 1,
      sym_forall,
    STATE(4988), 1,
      sym__effect_list,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5510), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5638), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4943), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173239] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(589), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9753), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9757), 1,
      anon_sym_SQUOTE,
    ACTIONS(9759), 1,
      sym_symboly_id,
    ACTIONS(9761), 1,
      sym_path,
    ACTIONS(9763), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    STATE(2591), 1,
      sym__value_type,
    STATE(4816), 1,
      sym_forall,
    STATE(4984), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3168), 2,
      sym__effect,
      sym__computation_type,
    STATE(2860), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1451), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173315] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 1,
      anon_sym_SQUOTE,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(2346), 1,
      sym__value_type,
    STATE(4835), 1,
      sym_forall,
    STATE(5013), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2434), 2,
      sym__effect,
      sym__computation_type,
    STATE(2489), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173391] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9601), 14,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(9599), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [173431] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    STATE(4812), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(4997), 1,
      sym__effect_list,
    STATE(5015), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5076), 2,
      sym__effect,
      sym__computation_type,
    STATE(5016), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173507] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9765), 1,
      anon_sym_LPAREN,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 1,
      anon_sym_SQUOTE,
    ACTIONS(9771), 1,
      sym_symboly_id,
    ACTIONS(9773), 1,
      sym_path,
    ACTIONS(9775), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    STATE(3853), 1,
      sym__value_type,
    STATE(4850), 1,
      sym_forall,
    STATE(4994), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4478), 2,
      sym__effect,
      sym__computation_type,
    STATE(4242), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1599), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173583] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1613), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9777), 1,
      anon_sym_LPAREN,
    ACTIONS(9779), 1,
      anon_sym_LBRACK,
    ACTIONS(9781), 1,
      anon_sym_SQUOTE,
    ACTIONS(9783), 1,
      sym_symboly_id,
    ACTIONS(9785), 1,
      sym_path,
    ACTIONS(9787), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    STATE(4856), 1,
      sym_forall,
    STATE(4980), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1988), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(1996), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1407), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173657] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(4974), 1,
      sym__effect_list,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5569), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6108), 2,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173733] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    STATE(4812), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(4997), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5017), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5016), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173807] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(73), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      anon_sym_LBRACK,
    ACTIONS(9811), 1,
      anon_sym_SQUOTE,
    ACTIONS(9813), 1,
      sym_symboly_id,
    ACTIONS(9815), 1,
      sym_path,
    ACTIONS(9817), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    STATE(4822), 1,
      sym_forall,
    STATE(4992), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1584), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(1601), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1362), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173881] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(4782), 1,
      sym_forall,
    STATE(5003), 1,
      sym__effect_list,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5430), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5604), 2,
      sym__effect,
      sym__computation_type,
    STATE(5376), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [173957] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9843), 1,
      anon_sym_SQUOTE,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9853), 1,
      sym_built_in_hash,
    STATE(4834), 1,
      sym_forall,
    STATE(4999), 1,
      sym__effect_list,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    STATE(5480), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5604), 2,
      sym__effect,
      sym__computation_type,
    STATE(5376), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4898), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174033] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(4976), 1,
      sym__effect_list,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5335), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174107] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(73), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      anon_sym_LBRACK,
    ACTIONS(9811), 1,
      anon_sym_SQUOTE,
    ACTIONS(9813), 1,
      sym_symboly_id,
    ACTIONS(9815), 1,
      sym_path,
    ACTIONS(9817), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    STATE(1514), 1,
      sym__value_type,
    STATE(4822), 1,
      sym_forall,
    STATE(4992), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1791), 2,
      sym__effect,
      sym__computation_type,
    STATE(1601), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1362), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174183] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    ACTIONS(9861), 1,
      anon_sym_LBRACK,
    ACTIONS(9863), 1,
      anon_sym_SQUOTE,
    ACTIONS(9865), 1,
      sym_symboly_id,
    ACTIONS(9867), 1,
      sym_path,
    ACTIONS(9869), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    STATE(4805), 1,
      sym_forall,
    STATE(4990), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4637), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(4635), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1627), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174257] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9843), 1,
      anon_sym_SQUOTE,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9853), 1,
      sym_built_in_hash,
    STATE(4834), 1,
      sym_forall,
    STATE(4999), 1,
      sym__effect_list,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5414), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5376), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4898), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174331] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(4796), 1,
      sym_forall,
    STATE(4998), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3688), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3667), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174405] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9765), 1,
      anon_sym_LPAREN,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 1,
      anon_sym_SQUOTE,
    ACTIONS(9771), 1,
      sym_symboly_id,
    ACTIONS(9773), 1,
      sym_path,
    ACTIONS(9775), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    STATE(4850), 1,
      sym_forall,
    STATE(4994), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4274), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(4242), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1599), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174479] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(589), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9753), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9757), 1,
      anon_sym_SQUOTE,
    ACTIONS(9759), 1,
      sym_symboly_id,
    ACTIONS(9761), 1,
      sym_path,
    ACTIONS(9763), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    STATE(4816), 1,
      sym_forall,
    STATE(4984), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2870), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(2860), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1451), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174553] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    STATE(4812), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(4997), 1,
      sym__effect_list,
    STATE(5015), 1,
      sym__value_type,
    STATE(5032), 1,
      sym__arrow,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5042), 2,
      sym__effect,
      sym__computation_type,
    STATE(5016), 4,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174631] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(4974), 1,
      sym__effect_list,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5569), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6712), 2,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174707] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3193), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9883), 1,
      anon_sym_LPAREN,
    ACTIONS(9885), 1,
      anon_sym_LBRACK,
    ACTIONS(9887), 1,
      anon_sym_SQUOTE,
    ACTIONS(9889), 1,
      sym_symboly_id,
    ACTIONS(9891), 1,
      sym_path,
    ACTIONS(9893), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    STATE(3147), 1,
      sym__value_type,
    STATE(4804), 1,
      sym_forall,
    STATE(4982), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4061), 2,
      sym__effect,
      sym__computation_type,
    STATE(3593), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1492), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174783] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9697), 1,
      anon_sym_SQUOTE,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(4788), 1,
      sym_forall,
    STATE(4981), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3738), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3771), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174857] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9895), 1,
      sym_hash_cid,
    ACTIONS(5949), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(5951), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [174899] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    ACTIONS(9899), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_SQUOTE,
    ACTIONS(9903), 1,
      sym_symboly_id,
    ACTIONS(9905), 1,
      sym_path,
    ACTIONS(9907), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    STATE(4829), 1,
      sym_forall,
    STATE(4991), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1697), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(1657), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1364), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [174973] = 22,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(4782), 1,
      sym_forall,
    STATE(5003), 1,
      sym__effect_list,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5430), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5679), 1,
      sym__arrow,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6260), 2,
      sym__effect,
      sym__computation_type,
    STATE(5376), 4,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175051] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9723), 1,
      anon_sym_SQUOTE,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9733), 1,
      sym_built_in_hash,
    STATE(4813), 1,
      sym_forall,
    STATE(4986), 1,
      sym__effect_list,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5969), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5537), 2,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4933), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175127] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9909), 1,
      anon_sym_LPAREN,
    ACTIONS(9911), 1,
      anon_sym_LBRACK,
    ACTIONS(9913), 1,
      anon_sym_SQUOTE,
    ACTIONS(9915), 1,
      sym_symboly_id,
    ACTIONS(9917), 1,
      sym_path,
    ACTIONS(9919), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    STATE(4791), 1,
      sym_forall,
    STATE(4983), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3062), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(2974), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1471), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175201] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    ACTIONS(9899), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_SQUOTE,
    ACTIONS(9903), 1,
      sym_symboly_id,
    ACTIONS(9905), 1,
      sym_path,
    ACTIONS(9907), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    STATE(1546), 1,
      sym__value_type,
    STATE(4829), 1,
      sym_forall,
    STATE(4991), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1922), 2,
      sym__effect,
      sym__computation_type,
    STATE(1657), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1364), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175277] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(4974), 1,
      sym__effect_list,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5569), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6624), 2,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175353] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(521), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9653), 1,
      anon_sym_LPAREN,
    ACTIONS(9655), 1,
      anon_sym_LBRACK,
    ACTIONS(9657), 1,
      anon_sym_SQUOTE,
    ACTIONS(9659), 1,
      sym_symboly_id,
    ACTIONS(9661), 1,
      sym_path,
    ACTIONS(9663), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    STATE(4817), 1,
      sym_forall,
    STATE(4993), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2671), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(2703), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1445), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175427] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1559), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9665), 1,
      anon_sym_LPAREN,
    ACTIONS(9667), 1,
      anon_sym_LBRACK,
    ACTIONS(9669), 1,
      anon_sym_SQUOTE,
    ACTIONS(9671), 1,
      sym_symboly_id,
    ACTIONS(9673), 1,
      sym_path,
    ACTIONS(9675), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    STATE(1941), 1,
      sym__value_type,
    STATE(4821), 1,
      sym_forall,
    STATE(4995), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2013), 2,
      sym__effect,
      sym__computation_type,
    STATE(1983), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1388), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175503] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(3261), 1,
      sym__value_type,
    STATE(4796), 1,
      sym_forall,
    STATE(4998), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3612), 2,
      sym__effect,
      sym__computation_type,
    STATE(3667), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175579] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1613), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9777), 1,
      anon_sym_LPAREN,
    ACTIONS(9779), 1,
      anon_sym_LBRACK,
    ACTIONS(9781), 1,
      anon_sym_SQUOTE,
    ACTIONS(9783), 1,
      sym_symboly_id,
    ACTIONS(9785), 1,
      sym_path,
    ACTIONS(9787), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    STATE(1966), 1,
      sym__value_type,
    STATE(4856), 1,
      sym_forall,
    STATE(4980), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2190), 2,
      sym__effect,
      sym__computation_type,
    STATE(1996), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1407), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175655] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9921), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACK,
    ACTIONS(9925), 1,
      anon_sym_SQUOTE,
    ACTIONS(9927), 1,
      sym_symboly_id,
    ACTIONS(9929), 1,
      sym_path,
    ACTIONS(9931), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    STATE(3431), 1,
      sym__value_type,
    STATE(4797), 1,
      sym_forall,
    STATE(5010), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4334), 2,
      sym__effect,
      sym__computation_type,
    STATE(3917), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1509), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175731] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9705), 1,
      anon_sym_LPAREN,
    ACTIONS(9707), 1,
      anon_sym_LBRACK,
    ACTIONS(9709), 1,
      anon_sym_SQUOTE,
    ACTIONS(9711), 1,
      sym_symboly_id,
    ACTIONS(9713), 1,
      sym_path,
    ACTIONS(9715), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    STATE(3014), 1,
      sym__value_type,
    STATE(4799), 1,
      sym_forall,
    STATE(4972), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3793), 2,
      sym__effect,
      sym__computation_type,
    STATE(3428), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1497), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175807] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9939), 1,
      anon_sym_SQUOTE,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9949), 1,
      sym_built_in_hash,
    STATE(4820), 1,
      sym_forall,
    STATE(5009), 1,
      sym__effect_list,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5509), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4915), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [175881] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9452), 1,
      sym_path,
    ACTIONS(9454), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9472), 1,
      anon_sym_LPAREN,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9953), 1,
      anon_sym__,
    STATE(4886), 1,
      sym__hq_qualified_prefix_term,
    STATE(4941), 1,
      sym_wordy_id,
    ACTIONS(9456), 2,
      sym__parenthesized_operator,
      sym_built_in_hash,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(9951), 2,
      sym_nat,
      sym_int,
    STATE(5140), 2,
      sym_hash_qualifier,
      sym__hq_qualified_wordy_id,
    STATE(5490), 11,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym__pattern_constructor,
      sym__pattern_candidates,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [175953] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9955), 1,
      anon_sym_LPAREN,
    ACTIONS(9957), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_SQUOTE,
    ACTIONS(9961), 1,
      sym_symboly_id,
    ACTIONS(9963), 1,
      sym_path,
    ACTIONS(9965), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    STATE(3413), 1,
      sym__value_type,
    STATE(4840), 1,
      sym_forall,
    STATE(5002), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4252), 2,
      sym__effect,
      sym__computation_type,
    STATE(3979), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1527), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176029] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(4782), 1,
      sym_forall,
    STATE(5003), 1,
      sym__effect_list,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5414), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5376), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176103] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9697), 1,
      anon_sym_SQUOTE,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(4788), 1,
      sym_forall,
    STATE(4981), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3678), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3771), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176177] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3193), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9883), 1,
      anon_sym_LPAREN,
    ACTIONS(9885), 1,
      anon_sym_LBRACK,
    ACTIONS(9887), 1,
      anon_sym_SQUOTE,
    ACTIONS(9889), 1,
      sym_symboly_id,
    ACTIONS(9891), 1,
      sym_path,
    ACTIONS(9893), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    STATE(4804), 1,
      sym_forall,
    STATE(4982), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3629), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3593), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1492), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176251] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    ACTIONS(9861), 1,
      anon_sym_LBRACK,
    ACTIONS(9863), 1,
      anon_sym_SQUOTE,
    ACTIONS(9865), 1,
      sym_symboly_id,
    ACTIONS(9867), 1,
      sym_path,
    ACTIONS(9869), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    STATE(4805), 1,
      sym_forall,
    STATE(4990), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4630), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(4635), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1627), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176325] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9921), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACK,
    ACTIONS(9925), 1,
      anon_sym_SQUOTE,
    ACTIONS(9927), 1,
      sym_symboly_id,
    ACTIONS(9929), 1,
      sym_path,
    ACTIONS(9931), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    STATE(4797), 1,
      sym_forall,
    STATE(5010), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3942), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3917), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1509), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176399] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(4974), 1,
      sym__effect_list,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5509), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176473] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 1,
      anon_sym_SQUOTE,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(4835), 1,
      sym_forall,
    STATE(5013), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2434), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(2489), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176547] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(4796), 1,
      sym_forall,
    STATE(4998), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3612), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3667), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176621] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(4802), 1,
      sym_forall,
    STATE(4989), 1,
      sym__effect_list,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5335), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176695] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9909), 1,
      anon_sym_LPAREN,
    ACTIONS(9911), 1,
      anon_sym_LBRACK,
    ACTIONS(9913), 1,
      anon_sym_SQUOTE,
    ACTIONS(9915), 1,
      sym_symboly_id,
    ACTIONS(9917), 1,
      sym_path,
    ACTIONS(9919), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    STATE(2692), 1,
      sym__value_type,
    STATE(4791), 1,
      sym_forall,
    STATE(4983), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3403), 2,
      sym__effect,
      sym__computation_type,
    STATE(2974), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1471), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176771] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9955), 1,
      anon_sym_LPAREN,
    ACTIONS(9957), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_SQUOTE,
    ACTIONS(9961), 1,
      sym_symboly_id,
    ACTIONS(9963), 1,
      sym_path,
    ACTIONS(9965), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    STATE(4840), 1,
      sym_forall,
    STATE(5002), 1,
      sym__effect_list,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4000), 3,
      sym__value_type,
      sym__effect,
      sym__computation_type,
    STATE(3979), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1527), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176845] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(4996), 1,
      sym__effect_list,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5536), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5537), 2,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176921] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(4802), 1,
      sym_forall,
    STATE(5008), 1,
      sym__effect_list,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5741), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6554), 2,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [176997] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9939), 1,
      anon_sym_SQUOTE,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9949), 1,
      sym_built_in_hash,
    STATE(4820), 1,
      sym_forall,
    STATE(5009), 1,
      sym__effect_list,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5599), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(6108), 2,
      sym__effect,
      sym__computation_type,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4915), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177073] = 21,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(4802), 1,
      sym_forall,
    STATE(5008), 1,
      sym__effect_list,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5741), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5537), 2,
      sym__effect,
      sym__computation_type,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9975), 1,
      sym__layout_semicolon,
    ACTIONS(9973), 12,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(9971), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [177190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(5951), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [177229] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9979), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(9977), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [177268] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(6179), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [177307] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9597), 13,
      sym__layout_semicolon,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(9595), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [177346] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9981), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6873), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177418] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9983), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6925), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177490] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9985), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6887), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177562] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9987), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6679), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177634] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9989), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6733), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177706] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9991), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(7106), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177778] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9993), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(7036), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177850] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9995), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6831), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177922] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9997), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6568), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [177994] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(9999), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6686), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178066] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10001), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6787), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178138] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10003), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(7031), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178210] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10005), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6736), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178282] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10007), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6958), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178354] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10011), 12,
      sym__parenthesized_operator,
      sym_doc_block,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      sym_literal_byte,
      sym_literal_hex,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      sym_rewrite,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
    ACTIONS(10009), 18,
      sym_nat,
      sym_int,
      sym_float,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym_if,
      anon_sym_BANG,
      sym_do,
      sym_kw_let,
      sym_match,
      sym_cases,
      sym_kw_termlink,
      sym_kw_typelink,
      sym_handle,
      aux_sym_wordy_id_token1,
      sym_path,
  [178392] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10013), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6880), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178464] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10015), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6645), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178536] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10017), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6553), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178608] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10019), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6641), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178680] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7702), 1,
      anon_sym_LBRACE,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    STATE(4812), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(5018), 1,
      sym__value_type,
    STATE(5038), 1,
      sym_record,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5016), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178752] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10021), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(7100), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178824] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10023), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6575), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178896] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10025), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6740), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [178968] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10027), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6864), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179040] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10029), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6651), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179112] = 20,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10031), 1,
      anon_sym_RBRACE,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5492), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6742), 1,
      sym__effect_inline,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179184] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10033), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6010), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179253] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10035), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5965), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179322] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10037), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6098), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179391] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10039), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6079), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179460] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10041), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5724), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179529] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10048), 1,
      anon_sym_DQUOTE,
    ACTIONS(10051), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(10054), 1,
      aux_sym_literal_char_token1,
    ACTIONS(10057), 1,
      aux_sym_literal_char_token2,
    ACTIONS(10063), 1,
      anon_sym_LPAREN,
    ACTIONS(10066), 1,
      anon_sym_LBRACK,
    ACTIONS(10069), 1,
      anon_sym_LBRACE,
    ACTIONS(10072), 1,
      anon_sym__,
    ACTIONS(10075), 1,
      aux_sym_wordy_id_token1,
    STATE(4966), 1,
      sym_wordy_id,
    ACTIONS(10045), 2,
      sym_nat,
      sym_int,
    ACTIONS(10060), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10043), 5,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    STATE(4754), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [179590] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10078), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6228), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179659] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10080), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5889), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179728] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10082), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5902), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179797] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10084), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6126), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179866] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10086), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6137), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [179935] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10092), 1,
      anon_sym_LPAREN,
    ACTIONS(10094), 1,
      anon_sym__,
    STATE(4966), 1,
      sym_wordy_id,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10090), 2,
      sym_nat,
      sym_int,
    ACTIONS(10088), 5,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    STATE(4754), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [179996] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10096), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5993), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180065] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10098), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5849), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180134] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10100), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6085), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180203] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10102), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6113), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180272] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10104), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6048), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180341] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10106), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6198), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180410] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10108), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6144), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180479] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10110), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5973), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180548] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10115), 1,
      anon_sym_DQUOTE,
    ACTIONS(10118), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(10121), 1,
      aux_sym_literal_char_token1,
    ACTIONS(10124), 1,
      aux_sym_literal_char_token2,
    ACTIONS(10130), 1,
      anon_sym_LPAREN,
    ACTIONS(10133), 1,
      anon_sym_LBRACK,
    ACTIONS(10136), 1,
      anon_sym_LBRACE,
    ACTIONS(10139), 1,
      anon_sym__,
    ACTIONS(10142), 1,
      aux_sym_wordy_id_token1,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(10112), 2,
      sym_nat,
      sym_int,
    ACTIONS(10127), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10043), 5,
      sym__layout_end,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    STATE(4769), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [180609] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10145), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5968), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180678] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10149), 1,
      anon_sym_LPAREN,
    ACTIONS(10151), 1,
      anon_sym__,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10147), 2,
      sym_nat,
      sym_int,
    ACTIONS(10088), 5,
      sym__layout_end,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    STATE(4769), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [180739] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10153), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5686), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180808] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10157), 1,
      anon_sym_LPAREN,
    ACTIONS(10159), 1,
      anon_sym__,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10155), 2,
      sym_nat,
      sym_int,
    ACTIONS(10088), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
    STATE(4774), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [180869] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10164), 1,
      anon_sym_DQUOTE,
    ACTIONS(10167), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(10170), 1,
      aux_sym_literal_char_token1,
    ACTIONS(10173), 1,
      aux_sym_literal_char_token2,
    ACTIONS(10179), 1,
      anon_sym_LPAREN,
    ACTIONS(10182), 1,
      anon_sym_LBRACK,
    ACTIONS(10185), 1,
      anon_sym_LBRACE,
    ACTIONS(10188), 1,
      anon_sym__,
    ACTIONS(10191), 1,
      aux_sym_wordy_id_token1,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(10161), 2,
      sym_nat,
      sym_int,
    ACTIONS(10176), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10043), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
    STATE(4774), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [180930] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10194), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5758), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [180999] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10196), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5830), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181068] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10198), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5729), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181137] = 19,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    ACTIONS(10200), 1,
      sym__layout_start,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6036), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181206] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5428), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181272] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6505), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5332), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181338] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5461), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181404] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6440), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5405), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181470] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5577), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181536] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6211), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181602] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9741), 1,
      anon_sym_SQUOTE,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9751), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6278), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5576), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4943), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181668] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5586), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181734] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5501), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181800] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9697), 1,
      anon_sym_SQUOTE,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6347), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3761), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181866] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5485), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181932] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6035), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [181998] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9909), 1,
      anon_sym_LPAREN,
    ACTIONS(9911), 1,
      anon_sym_LBRACK,
    ACTIONS(9913), 1,
      anon_sym_SQUOTE,
    ACTIONS(9915), 1,
      sym_symboly_id,
    ACTIONS(9917), 1,
      sym_path,
    ACTIONS(9919), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6442), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2988), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1471), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182064] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5484), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182130] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9741), 1,
      anon_sym_SQUOTE,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9751), 1,
      sym_built_in_hash,
    STATE(4785), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5506), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5638), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4943), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182196] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5503), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182262] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5483), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182328] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6257), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3672), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182394] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9921), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACK,
    ACTIONS(9925), 1,
      anon_sym_SQUOTE,
    ACTIONS(9927), 1,
      sym_symboly_id,
    ACTIONS(9929), 1,
      sym_path,
    ACTIONS(9931), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6364), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3930), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1509), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182460] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5493), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182526] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9705), 1,
      anon_sym_LPAREN,
    ACTIONS(9707), 1,
      anon_sym_LBRACK,
    ACTIONS(9709), 1,
      anon_sym_SQUOTE,
    ACTIONS(9711), 1,
      sym_symboly_id,
    ACTIONS(9713), 1,
      sym_path,
    ACTIONS(9715), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6484), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3444), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1497), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182592] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5481), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182658] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5478), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182724] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(4780), 1,
      sym_forall,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6250), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5332), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182790] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6012), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182856] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3193), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9883), 1,
      anon_sym_LPAREN,
    ACTIONS(9885), 1,
      anon_sym_LBRACK,
    ACTIONS(9887), 1,
      anon_sym_SQUOTE,
    ACTIONS(9889), 1,
      sym_symboly_id,
    ACTIONS(9891), 1,
      sym_path,
    ACTIONS(9893), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6447), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3609), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1492), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182922] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    ACTIONS(9861), 1,
      anon_sym_LBRACK,
    ACTIONS(9863), 1,
      anon_sym_SQUOTE,
    ACTIONS(9865), 1,
      sym_symboly_id,
    ACTIONS(9867), 1,
      sym_path,
    ACTIONS(9869), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6342), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4621), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1627), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [182988] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5972), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183054] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5503), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183120] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5451), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183186] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5431), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183252] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6168), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183318] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5470), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183384] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6483), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5019), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183450] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9723), 1,
      anon_sym_SQUOTE,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9733), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6270), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5332), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4933), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183516] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6050), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183582] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5464), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183648] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(589), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9753), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9757), 1,
      anon_sym_SQUOTE,
    ACTIONS(9759), 1,
      sym_symboly_id,
    ACTIONS(9761), 1,
      sym_path,
    ACTIONS(9763), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6428), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2877), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1451), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183714] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(521), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9653), 1,
      anon_sym_LPAREN,
    ACTIONS(9655), 1,
      anon_sym_LBRACK,
    ACTIONS(9657), 1,
      anon_sym_SQUOTE,
    ACTIONS(9659), 1,
      sym_symboly_id,
    ACTIONS(9661), 1,
      sym_path,
    ACTIONS(9663), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6420), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2690), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1445), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183780] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5458), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183846] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5469), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183912] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9939), 1,
      anon_sym_SQUOTE,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9949), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6495), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5564), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4915), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [183978] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1559), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9665), 1,
      anon_sym_LPAREN,
    ACTIONS(9667), 1,
      anon_sym_LBRACK,
    ACTIONS(9669), 1,
      anon_sym_SQUOTE,
    ACTIONS(9671), 1,
      sym_symboly_id,
    ACTIONS(9673), 1,
      sym_path,
    ACTIONS(9675), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6395), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1978), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1388), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184044] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(73), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      anon_sym_LBRACK,
    ACTIONS(9811), 1,
      anon_sym_SQUOTE,
    ACTIONS(9813), 1,
      sym_symboly_id,
    ACTIONS(9815), 1,
      sym_path,
    ACTIONS(9817), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6520), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1543), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1362), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184110] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6266), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5564), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184176] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5823), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184242] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5441), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184308] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5829), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184374] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5835), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184440] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5491), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184506] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    ACTIONS(9899), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_SQUOTE,
    ACTIONS(9903), 1,
      sym_symboly_id,
    ACTIONS(9905), 1,
      sym_path,
    ACTIONS(9907), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6461), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1672), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1364), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184572] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5611), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184638] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5840), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184704] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6149), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184770] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6128), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184836] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9843), 1,
      anon_sym_SQUOTE,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9853), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6229), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5405), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4898), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184902] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 1,
      anon_sym_SQUOTE,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6446), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(2500), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [184968] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5847), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185034] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(4782), 1,
      sym_forall,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5459), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5376), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185100] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6115), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185166] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5851), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185232] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9955), 1,
      anon_sym_LPAREN,
    ACTIONS(9957), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_SQUOTE,
    ACTIONS(9961), 1,
      sym_symboly_id,
    ACTIONS(9963), 1,
      sym_path,
    ACTIONS(9965), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6354), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(3989), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1527), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185298] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5856), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185364] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5873), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185430] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5466), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185496] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5476), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185562] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5882), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185628] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6160), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185694] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5442), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185760] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5912), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185826] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6091), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185892] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9765), 1,
      anon_sym_LPAREN,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 1,
      anon_sym_SQUOTE,
    ACTIONS(9771), 1,
      sym_symboly_id,
    ACTIONS(9773), 1,
      sym_path,
    ACTIONS(9775), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6469), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(4268), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1599), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [185958] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5460), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186024] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5955), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186090] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5500), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186156] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6070), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186222] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4823), 1,
      sym_forall,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(5941), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5513), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186288] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1613), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9777), 1,
      anon_sym_LPAREN,
    ACTIONS(9779), 1,
      anon_sym_LBRACK,
    ACTIONS(9781), 1,
      anon_sym_SQUOTE,
    ACTIONS(9783), 1,
      sym_symboly_id,
    ACTIONS(9785), 1,
      sym_path,
    ACTIONS(9787), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    STATE(4780), 1,
      sym_forall,
    STATE(5514), 1,
      sym_kw_forall,
    STATE(6497), 1,
      sym__value_type,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(1992), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(1407), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186354] = 18,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4780), 1,
      sym_forall,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5455), 1,
      sym__value_type,
    STATE(5514), 1,
      sym_kw_forall,
    ACTIONS(7708), 2,
      anon_sym_forall,
      anon_sym_u2200,
    STATE(5340), 5,
      sym__type1,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__arrow,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [186420] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10149), 1,
      anon_sym_LPAREN,
    ACTIONS(10204), 1,
      anon_sym__,
    STATE(4771), 1,
      aux_sym__pattern_constructor_repeat1,
    STATE(4866), 1,
      aux_sym_effect_bind_repeat1,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10202), 2,
      sym_nat,
      sym_int,
    STATE(5001), 9,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [186479] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10206), 1,
      anon_sym_DASH_GT,
    ACTIONS(10211), 1,
      anon_sym_DQUOTE,
    ACTIONS(10214), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(10217), 1,
      aux_sym_literal_char_token1,
    ACTIONS(10220), 1,
      aux_sym_literal_char_token2,
    ACTIONS(10226), 1,
      anon_sym_LPAREN,
    ACTIONS(10229), 1,
      anon_sym_LBRACK,
    ACTIONS(10232), 1,
      anon_sym_LBRACE,
    ACTIONS(10235), 1,
      anon_sym__,
    ACTIONS(10238), 1,
      aux_sym_wordy_id_token1,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(10208), 2,
      sym_nat,
      sym_int,
    ACTIONS(10223), 2,
      anon_sym_true,
      anon_sym_false,
    STATE(4859), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym_effect_bind_repeat1,
  [186536] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10241), 1,
      anon_sym_LBRACE,
    ACTIONS(10243), 1,
      sym_built_in_hash,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5125), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4863), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [186593] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10245), 1,
      aux_sym_immediate_hash_token1,
    STATE(4913), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5820), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [186630] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10247), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    ACTIONS(5191), 5,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(4864), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [186685] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10249), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10252), 1,
      anon_sym_LPAREN,
    ACTIONS(10255), 1,
      anon_sym_LBRACK,
    ACTIONS(10258), 1,
      anon_sym_LBRACE,
    ACTIONS(10261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10264), 1,
      sym_symboly_id,
    ACTIONS(10267), 1,
      sym_path,
    ACTIONS(10270), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10273), 1,
      sym_built_in_hash,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5160), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4863), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [186742] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10276), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    ACTIONS(5125), 5,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(4869), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [186797] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10278), 1,
      sym__dot,
    ACTIONS(10280), 1,
      sym_hash_cid,
    ACTIONS(5743), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5745), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [186834] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10157), 1,
      anon_sym_LPAREN,
    ACTIONS(10282), 1,
      anon_sym_DASH_GT,
    ACTIONS(10286), 1,
      anon_sym__,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10284), 2,
      sym_nat,
      sym_int,
    STATE(4859), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym_effect_bind_repeat1,
  [186891] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10288), 1,
      sym__dot,
    ACTIONS(10290), 1,
      sym_hash_cid,
    ACTIONS(5870), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5872), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [186928] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10241), 1,
      anon_sym_LBRACE,
    ACTIONS(10292), 1,
      sym_built_in_hash,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5191), 3,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
    STATE(4860), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [186985] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10294), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10297), 1,
      anon_sym_LPAREN,
    ACTIONS(10300), 1,
      anon_sym_LBRACK,
    ACTIONS(10303), 1,
      anon_sym_LBRACE,
    ACTIONS(10306), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10309), 1,
      sym_symboly_id,
    ACTIONS(10312), 1,
      sym_path,
    ACTIONS(10315), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10318), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    ACTIONS(5160), 5,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
    STATE(4869), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [187040] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9723), 1,
      anon_sym_SQUOTE,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9733), 1,
      sym_built_in_hash,
    STATE(4986), 1,
      sym__effect_list,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    STATE(5363), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4933), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187098] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9939), 1,
      anon_sym_SQUOTE,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9949), 1,
      sym_built_in_hash,
    STATE(5009), 1,
      sym__effect_list,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    STATE(5563), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4915), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187156] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3193), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9883), 1,
      anon_sym_LPAREN,
    ACTIONS(9885), 1,
      anon_sym_LBRACK,
    ACTIONS(9887), 1,
      anon_sym_SQUOTE,
    ACTIONS(9889), 1,
      sym_symboly_id,
    ACTIONS(9891), 1,
      sym_path,
    ACTIONS(9893), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    STATE(4982), 1,
      sym__effect_list,
    STATE(3608), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1492), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187214] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9843), 1,
      anon_sym_SQUOTE,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9853), 1,
      sym_built_in_hash,
    STATE(4999), 1,
      sym__effect_list,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    STATE(5401), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4898), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187272] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9875), 1,
      anon_sym_SQUOTE,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(4998), 1,
      sym__effect_list,
    STATE(3671), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187330] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1559), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9665), 1,
      anon_sym_LPAREN,
    ACTIONS(9667), 1,
      anon_sym_LBRACK,
    ACTIONS(9669), 1,
      anon_sym_SQUOTE,
    ACTIONS(9671), 1,
      sym_symboly_id,
    ACTIONS(9673), 1,
      sym_path,
    ACTIONS(9675), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    STATE(4995), 1,
      sym__effect_list,
    STATE(1979), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1388), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187388] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 5,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [187420] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10092), 1,
      anon_sym_LPAREN,
    ACTIONS(10323), 1,
      anon_sym__,
    STATE(4966), 1,
      sym_wordy_id,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10321), 2,
      sym_nat,
      sym_int,
    STATE(4760), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [187474] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9921), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACK,
    ACTIONS(9925), 1,
      anon_sym_SQUOTE,
    ACTIONS(9927), 1,
      sym_symboly_id,
    ACTIONS(9929), 1,
      sym_path,
    ACTIONS(9931), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    STATE(5010), 1,
      sym__effect_list,
    STATE(3929), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1509), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187532] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 5,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [187564] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(6299), 1,
      anon_sym__,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10157), 1,
      anon_sym_LPAREN,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10325), 2,
      sym_nat,
      sym_int,
    STATE(4773), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [187618] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7704), 1,
      anon_sym_SQUOTE,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(4997), 1,
      sym__effect_list,
    STATE(5020), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187676] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9955), 1,
      anon_sym_LPAREN,
    ACTIONS(9957), 1,
      anon_sym_LBRACK,
    ACTIONS(9959), 1,
      anon_sym_SQUOTE,
    ACTIONS(9961), 1,
      sym_symboly_id,
    ACTIONS(9963), 1,
      sym_path,
    ACTIONS(9965), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    STATE(5002), 1,
      sym__effect_list,
    STATE(3988), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1527), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187734] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9697), 1,
      anon_sym_SQUOTE,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(4981), 1,
      sym__effect_list,
    STATE(3762), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187792] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10327), 1,
      sym_hash_cid,
    ACTIONS(5949), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [187826] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9681), 1,
      anon_sym_SQUOTE,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(5013), 1,
      sym__effect_list,
    STATE(2496), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187884] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6125), 1,
      anon_sym__,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10149), 1,
      anon_sym_LPAREN,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10329), 2,
      sym_nat,
      sym_int,
    STATE(4771), 10,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
      aux_sym__pattern_constructor_repeat1,
  [187938] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9705), 1,
      anon_sym_LPAREN,
    ACTIONS(9707), 1,
      anon_sym_LBRACK,
    ACTIONS(9709), 1,
      anon_sym_SQUOTE,
    ACTIONS(9711), 1,
      sym_symboly_id,
    ACTIONS(9713), 1,
      sym_path,
    ACTIONS(9715), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    STATE(4972), 1,
      sym__effect_list,
    STATE(3443), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1497), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [187996] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9741), 1,
      anon_sym_SQUOTE,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9751), 1,
      sym_built_in_hash,
    STATE(4988), 1,
      sym__effect_list,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5580), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4943), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188054] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    ACTIONS(9899), 1,
      anon_sym_LBRACK,
    ACTIONS(9901), 1,
      anon_sym_SQUOTE,
    ACTIONS(9903), 1,
      sym_symboly_id,
    ACTIONS(9905), 1,
      sym_path,
    ACTIONS(9907), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    STATE(4991), 1,
      sym__effect_list,
    STATE(1671), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1364), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188112] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10331), 1,
      anon_sym_LBRACE,
    ACTIONS(10333), 1,
      sym_built_in_hash,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    ACTIONS(5123), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5125), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4891), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [188168] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10335), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10338), 1,
      anon_sym_LPAREN,
    ACTIONS(10341), 1,
      anon_sym_LBRACK,
    ACTIONS(10344), 1,
      anon_sym_LBRACE,
    ACTIONS(10347), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10350), 1,
      sym_symboly_id,
    ACTIONS(10353), 1,
      sym_path,
    ACTIONS(10356), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10359), 1,
      sym_built_in_hash,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    ACTIONS(5158), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5160), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4891), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [188224] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9347), 1,
      anon_sym_SQUOTE,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(4989), 1,
      sym__effect_list,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5363), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10362), 1,
      sym_hash_cid,
    ACTIONS(5943), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [188316] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9795), 1,
      anon_sym_SQUOTE,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(4974), 1,
      sym__effect_list,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5563), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188374] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9909), 1,
      anon_sym_LPAREN,
    ACTIONS(9911), 1,
      anon_sym_LBRACK,
    ACTIONS(9913), 1,
      anon_sym_SQUOTE,
    ACTIONS(9915), 1,
      sym_symboly_id,
    ACTIONS(9917), 1,
      sym_path,
    ACTIONS(9919), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    STATE(4983), 1,
      sym__effect_list,
    STATE(2987), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1471), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188432] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9825), 1,
      anon_sym_SQUOTE,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(5003), 1,
      sym__effect_list,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5401), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188490] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9855), 1,
      anon_sym_SQUOTE,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(4976), 1,
      sym__effect_list,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5363), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188548] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10331), 1,
      anon_sym_LBRACE,
    ACTIONS(10364), 1,
      sym_built_in_hash,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    ACTIONS(5189), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5191), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4890), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [188604] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(521), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9653), 1,
      anon_sym_LPAREN,
    ACTIONS(9655), 1,
      anon_sym_LBRACK,
    ACTIONS(9657), 1,
      anon_sym_SQUOTE,
    ACTIONS(9659), 1,
      sym_symboly_id,
    ACTIONS(9661), 1,
      sym_path,
    ACTIONS(9663), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    STATE(4993), 1,
      sym__effect_list,
    STATE(2691), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1445), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188662] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    ACTIONS(9861), 1,
      anon_sym_LBRACK,
    ACTIONS(9863), 1,
      anon_sym_SQUOTE,
    ACTIONS(9865), 1,
      sym_symboly_id,
    ACTIONS(9867), 1,
      sym_path,
    ACTIONS(9869), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    STATE(4990), 1,
      sym__effect_list,
    STATE(4636), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1627), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188720] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(589), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9753), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9757), 1,
      anon_sym_SQUOTE,
    ACTIONS(9759), 1,
      sym_symboly_id,
    ACTIONS(9761), 1,
      sym_path,
    ACTIONS(9763), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    STATE(4984), 1,
      sym__effect_list,
    STATE(2876), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1451), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188778] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1613), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9777), 1,
      anon_sym_LPAREN,
    ACTIONS(9779), 1,
      anon_sym_LBRACK,
    ACTIONS(9781), 1,
      anon_sym_SQUOTE,
    ACTIONS(9783), 1,
      sym_symboly_id,
    ACTIONS(9785), 1,
      sym_path,
    ACTIONS(9787), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    STATE(4980), 1,
      sym__effect_list,
    STATE(1993), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1407), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188836] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9765), 1,
      anon_sym_LPAREN,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9769), 1,
      anon_sym_SQUOTE,
    ACTIONS(9771), 1,
      sym_symboly_id,
    ACTIONS(9773), 1,
      sym_path,
    ACTIONS(9775), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    STATE(4994), 1,
      sym__effect_list,
    STATE(4263), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1599), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188894] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 5,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [188926] = 16,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(73), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      anon_sym_LBRACK,
    ACTIONS(9811), 1,
      anon_sym_SQUOTE,
    ACTIONS(9813), 1,
      sym_symboly_id,
    ACTIONS(9815), 1,
      sym_path,
    ACTIONS(9817), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    STATE(4992), 1,
      sym__effect_list,
    STATE(1581), 4,
      sym__type2a,
      sym__type2,
      sym_delayed,
      sym__effect,
    STATE(1362), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [188984] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      sym__layout_end,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10366), 1,
      anon_sym_LBRACE,
    ACTIONS(10368), 1,
      sym_built_in_hash,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    ACTIONS(5125), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4909), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189039] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(9532), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10157), 1,
      anon_sym_LPAREN,
    ACTIONS(10372), 1,
      anon_sym__,
    STATE(4948), 1,
      sym_wordy_id,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10370), 2,
      sym_nat,
      sym_int,
    STATE(4970), 9,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [189092] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(4908), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(10374), 2,
      sym_or,
      sym_and,
    STATE(1390), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 10,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189135] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 1,
      sym__layout_end,
    ACTIONS(10377), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10380), 1,
      anon_sym_LPAREN,
    ACTIONS(10383), 1,
      anon_sym_LBRACK,
    ACTIONS(10386), 1,
      anon_sym_LBRACE,
    ACTIONS(10389), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10392), 1,
      sym_symboly_id,
    ACTIONS(10395), 1,
      sym_path,
    ACTIONS(10398), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10401), 1,
      sym_built_in_hash,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    ACTIONS(5160), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4909), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189190] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6287), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6179), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189252] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9462), 1,
      anon_sym_DQUOTE,
    ACTIONS(9464), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9466), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9468), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9474), 1,
      anon_sym_LBRACK,
    ACTIONS(9476), 1,
      anon_sym_LBRACE,
    ACTIONS(9478), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10149), 1,
      anon_sym_LPAREN,
    ACTIONS(10406), 1,
      anon_sym__,
    STATE(4946), 1,
      sym_wordy_id,
    ACTIONS(9470), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10404), 2,
      sym_nat,
      sym_int,
    STATE(4958), 9,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [189305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6237), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189336] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6092), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189367] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5189), 1,
      sym__layout_end,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10366), 1,
      anon_sym_LBRACE,
    ACTIONS(10408), 1,
      sym_built_in_hash,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    ACTIONS(5191), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4906), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189422] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6293), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189453] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5123), 1,
      sym__layout_end,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10410), 1,
      anon_sym_LBRACE,
    ACTIONS(10412), 1,
      sym_built_in_hash,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    ACTIONS(5125), 2,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
    STATE(4922), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189508] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5189), 1,
      sym__layout_end,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10410), 1,
      anon_sym_LBRACE,
    ACTIONS(10414), 1,
      sym_built_in_hash,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    ACTIONS(5191), 2,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
    STATE(4917), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5945), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189594] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6063), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5951), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189656] = 15,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5158), 1,
      sym__layout_end,
    ACTIONS(10416), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10419), 1,
      anon_sym_LPAREN,
    ACTIONS(10422), 1,
      anon_sym_LBRACK,
    ACTIONS(10425), 1,
      anon_sym_LBRACE,
    ACTIONS(10428), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10431), 1,
      sym_symboly_id,
    ACTIONS(10434), 1,
      sym_path,
    ACTIONS(10437), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10440), 1,
      sym_built_in_hash,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    ACTIONS(5160), 2,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
    STATE(4922), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [189711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6303), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189742] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9432), 1,
      anon_sym_DQUOTE,
    ACTIONS(9434), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9436), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9438), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9444), 1,
      anon_sym_LBRACK,
    ACTIONS(9446), 1,
      anon_sym_LBRACE,
    ACTIONS(9450), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10092), 1,
      anon_sym_LPAREN,
    ACTIONS(10445), 1,
      anon_sym__,
    STATE(4966), 1,
      sym_wordy_id,
    ACTIONS(9440), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10443), 2,
      sym_nat,
      sym_int,
    STATE(4979), 9,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [189795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6283), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189826] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6183), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189857] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(4908), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(1567), 2,
      sym_or,
      sym_and,
    STATE(1390), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 10,
      anon_sym_LPAREN,
      anon_sym_COLON,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(6187), 19,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [189931] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1279), 1,
      anon_sym_LBRACE,
    ACTIONS(9516), 1,
      anon_sym_DQUOTE,
    ACTIONS(9518), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    ACTIONS(9520), 1,
      aux_sym_literal_char_token1,
    ACTIONS(9522), 1,
      aux_sym_literal_char_token2,
    ACTIONS(9528), 1,
      anon_sym_LBRACK,
    ACTIONS(10157), 1,
      anon_sym_LPAREN,
    ACTIONS(10372), 1,
      anon_sym__,
    ACTIONS(10447), 1,
      aux_sym_wordy_id_token1,
    STATE(5392), 1,
      sym_wordy_id,
    ACTIONS(9524), 2,
      anon_sym_true,
      anon_sym_false,
    ACTIONS(10370), 2,
      sym_nat,
      sym_int,
    STATE(4970), 9,
      sym_literal_text,
      sym_literal_char,
      sym_literal_boolean,
      sym__literal_pattern,
      sym_var_or_as,
      sym_literal_list_pattern,
      sym_parenthesized_or_tuple_pattern,
      sym_effect_pattern,
      sym__pattern_leaf,
  [189984] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    ACTIONS(10449), 1,
      anon_sym_LBRACE,
    ACTIONS(10451), 1,
      sym_built_in_hash,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    ACTIONS(5191), 2,
      anon_sym_DASH_GT,
      sym_rewrite_arrow,
    STATE(4937), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190036] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(4936), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(1599), 2,
      sym_or,
      sym_and,
    STATE(1376), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5812), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5814), 9,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [190078] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10453), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10456), 1,
      anon_sym_LPAREN,
    ACTIONS(10459), 1,
      anon_sym_LBRACK,
    ACTIONS(10462), 1,
      anon_sym_LBRACE,
    ACTIONS(10465), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10468), 1,
      sym_symboly_id,
    ACTIONS(10471), 1,
      sym_path,
    ACTIONS(10474), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10477), 1,
      sym_built_in_hash,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    ACTIONS(5160), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4932), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190130] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    ACTIONS(10482), 1,
      sym_built_in_hash,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    ACTIONS(5191), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4935), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190182] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10484), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(10487), 1,
      anon_sym_LPAREN,
    ACTIONS(10490), 1,
      anon_sym_LBRACK,
    ACTIONS(10493), 1,
      anon_sym_LBRACE,
    ACTIONS(10496), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10499), 1,
      sym_symboly_id,
    ACTIONS(10502), 1,
      sym_path,
    ACTIONS(10505), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10508), 1,
      sym_built_in_hash,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    ACTIONS(5160), 2,
      anon_sym_DASH_GT,
      sym_rewrite_arrow,
    STATE(4934), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190234] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10480), 1,
      anon_sym_LBRACE,
    ACTIONS(10511), 1,
      sym_built_in_hash,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    ACTIONS(5125), 2,
      anon_sym_DASH_GT,
      sym_with,
    STATE(4932), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190286] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(4936), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(10513), 2,
      sym_or,
      sym_and,
    STATE(1376), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5778), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5780), 9,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [190328] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    ACTIONS(10449), 1,
      anon_sym_LBRACE,
    ACTIONS(10516), 1,
      sym_built_in_hash,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    ACTIONS(5125), 2,
      anon_sym_DASH_GT,
      sym_rewrite_arrow,
    STATE(4934), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190380] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_AT,
    ACTIONS(10520), 1,
      aux_sym_immediate_hash_token1,
    STATE(5161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(7532), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
    ACTIONS(5734), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5730), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190417] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(10522), 1,
      anon_sym_AT,
    STATE(5161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(7532), 5,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(5734), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5730), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190454] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5125), 1,
      anon_sym_DASH_GT,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10276), 1,
      sym_built_in_hash,
    ACTIONS(10524), 1,
      anon_sym_LPAREN,
    ACTIONS(10527), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10530), 1,
      sym_path,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(4869), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190505] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(10533), 1,
      anon_sym_AT,
    STATE(5161), 1,
      sym_imm_hash_qualifier,
    ACTIONS(7532), 5,
      sym__layout_end,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(5734), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5730), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190542] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5739), 15,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      aux_sym_immediate_hash_token1,
  [190571] = 14,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5191), 1,
      anon_sym_DASH_GT,
    ACTIONS(9345), 1,
      anon_sym_LBRACE,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10535), 1,
      anon_sym_LPAREN,
    ACTIONS(10538), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10541), 1,
      sym_path,
    ACTIONS(10544), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(4940), 9,
      sym_unit,
      sym__effect_list,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
      aux_sym__type2_repeat1,
  [190622] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5739), 15,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_immediate_hash_token1,
  [190651] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5739), 14,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_immediate_hash_token1,
  [190679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10533), 1,
      anon_sym_AT,
    ACTIONS(7526), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7532), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10548), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10546), 14,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_kw_equals,
  [190737] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10550), 1,
      anon_sym_AT,
    ACTIONS(7526), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7532), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [190767] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10554), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10552), 14,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      sym_kw_equals,
  [190795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10558), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10556), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [190822] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10554), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10552), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10562), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10560), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [190876] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7128), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190903] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10548), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10546), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190930] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10562), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10560), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [190957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7158), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [190984] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7168), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7166), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191011] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10566), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10564), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191038] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10558), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10556), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7128), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191092] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7094), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191119] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8106), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10568), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191146] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8106), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10568), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191173] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7158), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191200] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10570), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10522), 1,
      anon_sym_AT,
    ACTIONS(7526), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7532), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191256] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10570), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7094), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191310] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7168), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7166), 13,
      sym__layout_end,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10566), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10564), 13,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
  [191364] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10554), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10552), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191390] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2045), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3173), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6210), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9705), 1,
      anon_sym_LPAREN,
    ACTIONS(9707), 1,
      anon_sym_LBRACK,
    ACTIONS(9711), 1,
      sym_symboly_id,
    ACTIONS(9713), 1,
      sym_path,
    ACTIONS(9715), 1,
      sym_built_in_hash,
    STATE(2368), 1,
      sym__identifier,
    STATE(2457), 1,
      sym_wordy_id,
    STATE(3462), 1,
      sym__type2,
    STATE(1497), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191436] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7130), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7128), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191462] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9789), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9791), 1,
      anon_sym_LPAREN,
    ACTIONS(9793), 1,
      anon_sym_LBRACK,
    ACTIONS(9797), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9799), 1,
      sym_symboly_id,
    ACTIONS(9801), 1,
      sym_path,
    ACTIONS(9803), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9805), 1,
      sym_built_in_hash,
    STATE(5111), 1,
      sym__identifier,
    STATE(5172), 1,
      sym_wordy_id,
    STATE(5578), 1,
      sym__type2,
    STATE(4918), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191508] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7168), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7166), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191534] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5361), 1,
      sym__type2,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191580] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7096), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7094), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191606] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10562), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10560), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191632] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10566), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10564), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191658] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1609), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1613), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5444), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9777), 1,
      anon_sym_LPAREN,
    ACTIONS(9779), 1,
      anon_sym_LBRACK,
    ACTIONS(9783), 1,
      sym_symboly_id,
    ACTIONS(9785), 1,
      sym_path,
    ACTIONS(9787), 1,
      sym_built_in_hash,
    STATE(1594), 1,
      sym__identifier,
    STATE(1689), 1,
      sym_wordy_id,
    STATE(1989), 1,
      sym__type2,
    STATE(1407), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191704] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(859), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3161), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6129), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9693), 1,
      anon_sym_LPAREN,
    ACTIONS(9695), 1,
      anon_sym_LBRACK,
    ACTIONS(9699), 1,
      sym_symboly_id,
    ACTIONS(9701), 1,
      sym_path,
    ACTIONS(9703), 1,
      sym_built_in_hash,
    STATE(2320), 1,
      sym__identifier,
    STATE(2494), 1,
      sym_wordy_id,
    STATE(3742), 1,
      sym__type2,
    STATE(1483), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191750] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2261), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3193), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6065), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9883), 1,
      anon_sym_LPAREN,
    ACTIONS(9885), 1,
      anon_sym_LBRACK,
    ACTIONS(9889), 1,
      sym_symboly_id,
    ACTIONS(9891), 1,
      sym_path,
    ACTIONS(9893), 1,
      sym_built_in_hash,
    STATE(2360), 1,
      sym__identifier,
    STATE(2451), 1,
      sym_wordy_id,
    STATE(3628), 1,
      sym__type2,
    STATE(1492), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191796] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(725), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(3149), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5955), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9909), 1,
      anon_sym_LPAREN,
    ACTIONS(9911), 1,
      anon_sym_LBRACK,
    ACTIONS(9915), 1,
      sym_symboly_id,
    ACTIONS(9917), 1,
      sym_path,
    ACTIONS(9919), 1,
      sym_built_in_hash,
    STATE(2293), 1,
      sym__identifier,
    STATE(2386), 1,
      sym_wordy_id,
    STATE(3029), 1,
      sym__type2,
    STATE(1471), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191842] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(585), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(589), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5753), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9753), 1,
      anon_sym_LPAREN,
    ACTIONS(9755), 1,
      anon_sym_LBRACK,
    ACTIONS(9759), 1,
      sym_symboly_id,
    ACTIONS(9761), 1,
      sym_path,
    ACTIONS(9763), 1,
      sym_built_in_hash,
    STATE(2246), 1,
      sym__identifier,
    STATE(2284), 1,
      sym_wordy_id,
    STATE(2871), 1,
      sym__type2,
    STATE(1451), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191888] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10572), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10570), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191914] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9717), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9719), 1,
      anon_sym_LPAREN,
    ACTIONS(9721), 1,
      anon_sym_LBRACK,
    ACTIONS(9725), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9727), 1,
      sym_symboly_id,
    ACTIONS(9729), 1,
      sym_path,
    ACTIONS(9731), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9733), 1,
      sym_built_in_hash,
    STATE(5136), 1,
      sym__identifier,
    STATE(5206), 1,
      sym_wordy_id,
    STATE(5361), 1,
      sym__type2,
    STATE(4933), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [191960] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(8106), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10568), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [191986] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9751), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5347), 1,
      sym__type2,
    STATE(4943), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192032] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5361), 1,
      sym__type2,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192078] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3319), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3323), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6996), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9859), 1,
      anon_sym_LPAREN,
    ACTIONS(9861), 1,
      anon_sym_LBRACK,
    ACTIONS(9865), 1,
      sym_symboly_id,
    ACTIONS(9867), 1,
      sym_path,
    ACTIONS(9869), 1,
      sym_built_in_hash,
    STATE(3101), 1,
      sym__identifier,
    STATE(3341), 1,
      sym_wordy_id,
    STATE(4640), 1,
      sym__type2,
    STATE(1627), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192124] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(221), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(1199), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(5214), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9897), 1,
      anon_sym_LPAREN,
    ACTIONS(9899), 1,
      anon_sym_LBRACK,
    ACTIONS(9903), 1,
      sym_symboly_id,
    ACTIONS(9905), 1,
      sym_path,
    ACTIONS(9907), 1,
      sym_built_in_hash,
    STATE(1466), 1,
      sym__identifier,
    STATE(1487), 1,
      sym_wordy_id,
    STATE(1696), 1,
      sym__type2,
    STATE(1364), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192170] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(69), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(73), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5127), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9807), 1,
      anon_sym_LPAREN,
    ACTIONS(9809), 1,
      anon_sym_LBRACK,
    ACTIONS(9813), 1,
      sym_symboly_id,
    ACTIONS(9815), 1,
      sym_path,
    ACTIONS(9817), 1,
      sym_built_in_hash,
    STATE(1455), 1,
      sym__identifier,
    STATE(1463), 1,
      sym_wordy_id,
    STATE(1585), 1,
      sym__type2,
    STATE(1362), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192216] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(517), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(521), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5694), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9653), 1,
      anon_sym_LPAREN,
    ACTIONS(9655), 1,
      anon_sym_LBRACK,
    ACTIONS(9659), 1,
      sym_symboly_id,
    ACTIONS(9661), 1,
      sym_path,
    ACTIONS(9663), 1,
      sym_built_in_hash,
    STATE(2253), 1,
      sym__identifier,
    STATE(2268), 1,
      sym_wordy_id,
    STATE(2672), 1,
      sym__type2,
    STATE(1445), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192262] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(3299), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3303), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6786), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9765), 1,
      anon_sym_LPAREN,
    ACTIONS(9767), 1,
      anon_sym_LBRACK,
    ACTIONS(9771), 1,
      sym_symboly_id,
    ACTIONS(9773), 1,
      sym_path,
    ACTIONS(9775), 1,
      sym_built_in_hash,
    STATE(2821), 1,
      sym__identifier,
    STATE(3054), 1,
      sym_wordy_id,
    STATE(4273), 1,
      sym__type2,
    STATE(1599), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192308] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1555), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(1559), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5366), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9665), 1,
      anon_sym_LPAREN,
    ACTIONS(9667), 1,
      anon_sym_LBRACK,
    ACTIONS(9671), 1,
      sym_symboly_id,
    ACTIONS(9673), 1,
      sym_path,
    ACTIONS(9675), 1,
      sym_built_in_hash,
    STATE(1531), 1,
      sym__identifier,
    STATE(1552), 1,
      sym_wordy_id,
    STATE(1972), 1,
      sym__type2,
    STATE(1388), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192354] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9735), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9737), 1,
      anon_sym_LPAREN,
    ACTIONS(9739), 1,
      anon_sym_LBRACK,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9745), 1,
      sym_symboly_id,
    ACTIONS(9747), 1,
      sym_path,
    ACTIONS(9749), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9857), 1,
      sym_built_in_hash,
    STATE(5031), 1,
      sym__identifier,
    STATE(5057), 1,
      sym_wordy_id,
    STATE(5347), 1,
      sym__type2,
    STATE(4862), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192400] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7696), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(7698), 1,
      anon_sym_LPAREN,
    ACTIONS(7700), 1,
      anon_sym_LBRACK,
    ACTIONS(7710), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(7712), 1,
      sym_symboly_id,
    ACTIONS(7714), 1,
      sym_path,
    ACTIONS(7716), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(7718), 1,
      sym_built_in_hash,
    STATE(4861), 1,
      sym__identifier,
    STATE(4879), 1,
      sym_wordy_id,
    STATE(5014), 1,
      sym__type2,
    STATE(4572), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192446] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(1967), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3219), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6036), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9871), 1,
      anon_sym_LPAREN,
    ACTIONS(9873), 1,
      anon_sym_LBRACK,
    ACTIONS(9877), 1,
      sym_symboly_id,
    ACTIONS(9879), 1,
      sym_path,
    ACTIONS(9881), 1,
      sym_built_in_hash,
    STATE(2351), 1,
      sym__identifier,
    STATE(2504), 1,
      sym_wordy_id,
    STATE(3687), 1,
      sym__type2,
    STATE(1486), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192492] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9837), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9839), 1,
      anon_sym_LPAREN,
    ACTIONS(9841), 1,
      anon_sym_LBRACK,
    ACTIONS(9845), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9847), 1,
      sym_symboly_id,
    ACTIONS(9849), 1,
      sym_path,
    ACTIONS(9851), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9853), 1,
      sym_built_in_hash,
    STATE(5039), 1,
      sym__identifier,
    STATE(5070), 1,
      sym_wordy_id,
    STATE(5398), 1,
      sym__type2,
    STATE(4898), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192538] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    ACTIONS(10578), 1,
      sym_pipe,
    STATE(4672), 1,
      sym_arrow_symbol,
    STATE(5029), 1,
      aux_sym__type_rhs_repeat1,
    ACTIONS(10576), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10574), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [192572] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10580), 1,
      anon_sym_DASH_GT,
    ACTIONS(10588), 4,
      sym__layout_end,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
    ACTIONS(10585), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10582), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [192602] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2119), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3269), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6477), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9955), 1,
      anon_sym_LPAREN,
    ACTIONS(9957), 1,
      anon_sym_LBRACK,
    ACTIONS(9961), 1,
      sym_symboly_id,
    ACTIONS(9963), 1,
      sym_path,
    ACTIONS(9965), 1,
      sym_built_in_hash,
    STATE(2455), 1,
      sym__identifier,
    STATE(2743), 1,
      sym_wordy_id,
    STATE(3999), 1,
      sym__type2,
    STATE(1527), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192648] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9819), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9821), 1,
      anon_sym_LPAREN,
    ACTIONS(9823), 1,
      anon_sym_LBRACK,
    ACTIONS(9827), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9829), 1,
      sym_symboly_id,
    ACTIONS(9831), 1,
      sym_path,
    ACTIONS(9833), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9835), 1,
      sym_built_in_hash,
    STATE(5022), 1,
      sym__identifier,
    STATE(5043), 1,
      sym_wordy_id,
    STATE(5398), 1,
      sym__type2,
    STATE(4868), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192694] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10558), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10556), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [192720] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10548), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(10546), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [192746] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10590), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10592), 1,
      sym_symboly_id,
    ACTIONS(10594), 1,
      sym_path,
    STATE(5046), 1,
      sym_wordy_id,
    STATE(5007), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9420), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(9418), 8,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [192782] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10590), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10592), 1,
      sym_symboly_id,
    ACTIONS(10594), 1,
      sym_path,
    STATE(5046), 1,
      sym_wordy_id,
    STATE(5012), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9410), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(9402), 8,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [192818] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9339), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9343), 1,
      anon_sym_LBRACK,
    ACTIONS(9349), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9351), 1,
      sym_symboly_id,
    ACTIONS(9355), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9357), 1,
      sym_built_in_hash,
    ACTIONS(9967), 1,
      anon_sym_LPAREN,
    ACTIONS(9969), 1,
      sym_path,
    STATE(5170), 1,
      sym__identifier,
    STATE(5181), 1,
      sym_wordy_id,
    STATE(5347), 1,
      sym__type2,
    STATE(4930), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192864] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9933), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9935), 1,
      anon_sym_LPAREN,
    ACTIONS(9937), 1,
      anon_sym_LBRACK,
    ACTIONS(9941), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9943), 1,
      sym_symboly_id,
    ACTIONS(9945), 1,
      sym_path,
    ACTIONS(9947), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(9949), 1,
      sym_built_in_hash,
    STATE(5124), 1,
      sym__identifier,
    STATE(5131), 1,
      sym_wordy_id,
    STATE(5578), 1,
      sym__type2,
    STATE(4915), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192910] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2017), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(3245), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(6361), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9921), 1,
      anon_sym_LPAREN,
    ACTIONS(9923), 1,
      anon_sym_LBRACK,
    ACTIONS(9927), 1,
      sym_symboly_id,
    ACTIONS(9929), 1,
      sym_path,
    ACTIONS(9931), 1,
      sym_built_in_hash,
    STATE(2466), 1,
      sym__identifier,
    STATE(2745), 1,
      sym_wordy_id,
    STATE(3941), 1,
      sym__type2,
    STATE(1509), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [192956] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7160), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(7158), 12,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [192982] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10596), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10599), 1,
      sym_symboly_id,
    ACTIONS(10602), 1,
      sym_path,
    STATE(5046), 1,
      sym_wordy_id,
    STATE(5012), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
    ACTIONS(9388), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(9377), 8,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193018] = 13,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(419), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(423), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(5648), 1,
      anon_sym_LPAREN_RPAREN,
    ACTIONS(9677), 1,
      anon_sym_LPAREN,
    ACTIONS(9679), 1,
      anon_sym_LBRACK,
    ACTIONS(9683), 1,
      sym_symboly_id,
    ACTIONS(9685), 1,
      sym_path,
    ACTIONS(9687), 1,
      sym_built_in_hash,
    STATE(2091), 1,
      sym__identifier,
    STATE(2262), 1,
      sym_wordy_id,
    STATE(2508), 1,
      sym__type2,
    STATE(1444), 7,
      sym_unit,
      sym_tuple_or_parenthesized_type,
      sym__value_type_leaf,
      sym__type_atom,
      sym_sequence_type,
      sym_hash_qualifier,
      sym__hash_qualified,
  [193064] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 8,
      anon_sym_DASH_GT,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6764), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4672), 1,
      sym_arrow_symbol,
    ACTIONS(6398), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6394), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6880), 8,
      anon_sym_DASH_GT,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6878), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193143] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6762), 8,
      anon_sym_DASH_GT,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6760), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193168] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    STATE(4672), 1,
      sym_arrow_symbol,
    ACTIONS(10607), 7,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10605), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193197] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6551), 7,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6546), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6750), 8,
      anon_sym_DASH_GT,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6748), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193249] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10611), 1,
      anon_sym_COMMA,
    STATE(5035), 1,
      aux_sym__ebody_repeat3,
    ACTIONS(10613), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10609), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193277] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10615), 1,
      aux_sym_immediate_hash_token1,
    STATE(5117), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5820), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 15,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193329] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10617), 1,
      sym__dot,
    ACTIONS(10619), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5745), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193357] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      sym_pipe,
    STATE(5029), 1,
      aux_sym__type_rhs_repeat1,
    ACTIONS(10576), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10574), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10621), 1,
      sym__dot,
    ACTIONS(10623), 1,
      sym_hash_cid,
    ACTIONS(5745), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193411] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10625), 1,
      sym_pipe,
    STATE(5027), 1,
      aux_sym__type_rhs_repeat1,
    ACTIONS(10607), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10605), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10611), 1,
      anon_sym_COMMA,
    STATE(5035), 1,
      aux_sym__ebody_repeat3,
    ACTIONS(10630), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10628), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193467] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10578), 1,
      sym_pipe,
    STATE(5027), 1,
      aux_sym__type_rhs_repeat1,
    ACTIONS(10634), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10632), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193495] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10611), 1,
      anon_sym_COMMA,
    STATE(5028), 1,
      aux_sym__ebody_repeat3,
    ACTIONS(10613), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10609), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10636), 1,
      aux_sym_immediate_hash_token1,
    STATE(5112), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5820), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10641), 1,
      anon_sym_DASH_GT,
    ACTIONS(10643), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10638), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193575] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    STATE(4668), 1,
      sym_type_signature_colon,
    ACTIONS(6722), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6720), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193603] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10646), 1,
      sym__dot,
    ACTIONS(10648), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5872), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193631] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10652), 1,
      anon_sym_COMMA,
    STATE(5035), 1,
      aux_sym__ebody_repeat3,
    ACTIONS(10655), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10650), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10611), 1,
      anon_sym_COMMA,
    STATE(5021), 1,
      aux_sym__ebody_repeat3,
    ACTIONS(10659), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10657), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10661), 1,
      sym__dot,
    ACTIONS(10663), 1,
      sym_hash_cid,
    ACTIONS(5872), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10607), 7,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10605), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193736] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10665), 1,
      aux_sym_immediate_hash_token1,
    STATE(5139), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5818), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5820), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10655), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10650), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193786] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10667), 1,
      sym__dot,
    ACTIONS(10669), 1,
      sym_hash_cid,
    ACTIONS(5745), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5743), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [193813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10673), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10671), 9,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193836] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10675), 1,
      sym_hash_cid,
    ACTIONS(5945), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193882] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10677), 1,
      sym_hash_cid,
    ACTIONS(5951), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193905] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5911), 11,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193928] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5741), 11,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [193951] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [193974] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10679), 1,
      sym__dot,
    ACTIONS(10681), 1,
      sym_hash_cid,
    ACTIONS(5743), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5745), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10683), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5945), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194049] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194072] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10685), 1,
      sym__dot,
    ACTIONS(10687), 1,
      sym_hash_cid,
    ACTIONS(5870), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5872), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194099] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10520), 1,
      aux_sym_immediate_hash_token1,
    STATE(5163), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5723), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5719), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [194126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10689), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5951), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10693), 7,
      anon_sym_use,
      sym_type_kw,
      sym_pipe,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10691), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194174] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194197] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10695), 1,
      sym__dot,
    ACTIONS(10697), 1,
      sym_hash_cid,
    ACTIONS(5872), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5870), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [194224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 4,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
    ACTIONS(5982), 11,
      anon_sym_LPAREN,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194247] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7029), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7027), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6179), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10699), 1,
      sym_hash_cid,
    ACTIONS(5945), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5943), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [194315] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6092), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5951), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7278), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7276), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194381] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10703), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10701), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194423] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10707), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10705), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194445] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194467] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7033), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7031), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6063), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194531] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6283), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194553] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7150), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7148), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7492), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7490), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194597] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7488), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7486), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194619] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6303), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194639] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6303), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      sym__layout_end,
    ACTIONS(10709), 1,
      sym__dot,
    ACTIONS(10711), 1,
      sym_hash_cid,
    ACTIONS(5872), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194687] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10715), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10713), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194709] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7142), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7140), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10630), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10628), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194753] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5743), 1,
      sym__layout_end,
    ACTIONS(10717), 1,
      sym__dot,
    ACTIONS(10719), 1,
      sym_hash_cid,
    ACTIONS(5745), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194779] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5870), 1,
      sym__layout_end,
    ACTIONS(10721), 1,
      sym__dot,
    ACTIONS(10723), 1,
      sym_hash_cid,
    ACTIONS(5872), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5945), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194827] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7062), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7060), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6063), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10727), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10725), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7058), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7056), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194955] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7274), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7272), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [194977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym__layout_semicolon,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [194999] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10731), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10729), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10733), 1,
      sym_hash_cid,
    ACTIONS(5949), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195045] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7242), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7240), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195067] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10737), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10735), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6187), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10741), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10739), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195133] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6994), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(6992), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195155] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7092), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7090), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195177] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6287), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195197] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7238), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7236), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195219] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7116), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7114), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195241] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6183), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195283] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10745), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10743), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195305] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7120), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7118), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6187), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6287), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195369] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      sym__layout_end,
    ACTIONS(10747), 1,
      aux_sym_immediate_hash_token1,
    STATE(5187), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5820), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195395] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195415] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10751), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10749), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195437] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5743), 1,
      sym__layout_end,
    ACTIONS(10753), 1,
      sym__dot,
    ACTIONS(10755), 1,
      sym_hash_cid,
    ACTIONS(5745), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195483] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10757), 1,
      sym_hash_cid,
    ACTIONS(5943), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6237), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195529] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10761), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10759), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195551] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7182), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7180), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6293), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_SEMI,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195615] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7372), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7370), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7368), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7366), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195659] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5818), 1,
      sym__layout_end,
    ACTIONS(10763), 1,
      aux_sym_immediate_hash_token1,
    STATE(5195), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5820), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7214), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7212), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 14,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_LBRACK,
      anon_sym_RBRACK,
      anon_sym_LBRACE,
      anon_sym_RBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195727] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10767), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(10765), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10769), 1,
      sym_hash_cid,
    ACTIONS(5951), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5949), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [195773] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7226), 6,
      anon_sym_use,
      sym_type_kw,
      sym_structural,
      sym_unique,
      sym_ability,
      aux_sym_wordy_id_token1,
    ACTIONS(7224), 8,
      sym_fold,
      sym__watch_start,
      sym_doc_block,
      ts_builtin_sym_end,
      anon_sym_LPAREN,
      sym_path,
      anon_sym_test_GT,
      anon_sym_test_DOTio_GT,
  [195795] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195816] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195837] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6063), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195858] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6187), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(6177), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [195900] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10771), 1,
      aux_sym_immediate_hash_token1,
    STATE(5264), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5820), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195944] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195965] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 12,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_DOT,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [195986] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6237), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196007] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6615), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(6613), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196028] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5732), 1,
      anon_sym_DOT,
    ACTIONS(5909), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(10773), 3,
      anon_sym_LPAREN,
      aux_sym_wordy_id_token1,
      sym_path,
    ACTIONS(5911), 8,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      sym_symboly_id,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196053] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5949), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196074] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5943), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196095] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196116] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6287), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196158] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10776), 1,
      sym__dot,
    ACTIONS(10778), 1,
      sym_hash_cid,
    ACTIONS(5872), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196181] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6092), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196202] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(6281), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6183), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196244] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6283), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196265] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5167), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3155), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5814), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    STATE(1393), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196298] = 12,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(17), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(19), 1,
      sym_path,
    STATE(5097), 1,
      sym__binding,
    STATE(5100), 1,
      sym_term_definition2,
    STATE(5266), 1,
      sym_type_signature,
    STATE(5685), 1,
      sym_open_parens,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(7099), 1,
      sym__lhs,
    STATE(5325), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [196337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6303), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196358] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5155), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5780), 2,
      anon_sym_COLON,
      sym_with,
    ACTIONS(10780), 2,
      sym_or,
      sym_and,
    STATE(1383), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196391] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5155), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3153), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5814), 2,
      anon_sym_COLON,
      sym_with,
    STATE(1383), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10783), 1,
      sym__dot,
    ACTIONS(10785), 1,
      sym_hash_cid,
    ACTIONS(5745), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196447] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym__layout_end,
    ACTIONS(10787), 1,
      sym_hash_cid,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym__layout_end,
    ACTIONS(10789), 1,
      sym_hash_cid,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10791), 1,
      sym__dot,
    ACTIONS(10793), 1,
      sym_hash_cid,
    ACTIONS(5872), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196516] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5723), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(5719), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196537] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 1,
      anon_sym_DOT,
    ACTIONS(5980), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(10795), 3,
      anon_sym_LPAREN,
      aux_sym_wordy_id_token1,
      sym_path,
    ACTIONS(5982), 8,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      sym_symboly_id,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196562] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6568), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(6566), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196583] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10798), 1,
      sym__dot,
    ACTIONS(10800), 1,
      sym_hash_cid,
    ACTIONS(5745), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__layout_end,
    ACTIONS(10802), 1,
      sym_hash_cid,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196629] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6179), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5167), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(5780), 2,
      anon_sym_SEMI,
      anon_sym_COLON,
    ACTIONS(10804), 2,
      sym_or,
      sym_and,
    STATE(1393), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196683] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6611), 6,
      anon_sym_DQUOTE,
      aux_sym_literal_char_token1,
      anon_sym_true,
      anon_sym_false,
      anon_sym__,
      aux_sym_wordy_id_token1,
    ACTIONS(6609), 7,
      sym_nat,
      sym_int,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
      aux_sym_literal_char_token2,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
  [196704] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196725] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10807), 1,
      aux_sym_immediate_hash_token1,
    STATE(5260), 1,
      sym_imm_hash_qualifier,
    ACTIONS(5820), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__layout_end,
    ACTIONS(10809), 1,
      sym_hash_cid,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196771] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 2,
      sym__layout_end,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196792] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(6293), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196813] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__layout_end,
    ACTIONS(6283), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196833] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__layout_end,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5175), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5780), 2,
      anon_sym_COLON,
      sym_with,
    ACTIONS(10811), 2,
      sym_or,
      sym_and,
    STATE(1366), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196865] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym__layout_end,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196885] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5778), 1,
      sym__layout_end,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5177), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5780), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    ACTIONS(10814), 2,
      sym_or,
      sym_and,
    STATE(1375), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196917] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      anon_sym_SEMI,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5178), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(10817), 2,
      sym_or,
      sym_and,
    STATE(1379), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [196949] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__layout_end,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196969] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      sym__layout_end,
    ACTIONS(6179), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [196989] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197009] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5949), 1,
      sym__layout_end,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197029] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5741), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197049] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      sym_with,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5184), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5778), 2,
      sym__layout_semicolon,
      sym__layout_end,
    ACTIONS(10820), 2,
      sym_or,
      sym_and,
    STATE(1389), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [197081] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5185), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(10823), 2,
      sym_or,
      sym_and,
    STATE(1397), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5780), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [197111] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      sym__layout_end,
    ACTIONS(6303), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197131] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      sym__layout_end,
    ACTIONS(6237), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 1,
      sym__layout_end,
    ACTIONS(6092), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      sym__layout_end,
    ACTIONS(6183), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197191] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5943), 1,
      sym__layout_end,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 1,
      sym__layout_end,
    ACTIONS(6293), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10826), 1,
      sym_hash_cid,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197251] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5185), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3213), 2,
      sym_or,
      sym_and,
    STATE(1397), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
    ACTIONS(5814), 3,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      anon_sym_COLON,
  [197281] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10828), 12,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_u2200,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6235), 1,
      sym__layout_end,
    ACTIONS(6237), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197319] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6291), 1,
      sym__layout_end,
    ACTIONS(6293), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      sym__layout_end,
    ACTIONS(6063), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197379] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5814), 1,
      sym_with,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5184), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3229), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__layout_semicolon,
      sym__layout_end,
    STATE(1389), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [197411] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6281), 1,
      sym__layout_end,
    ACTIONS(6283), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10830), 12,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_u2200,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197449] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5982), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6177), 1,
      sym__layout_end,
    ACTIONS(6179), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197489] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10832), 1,
      sym_hash_cid,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197509] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5814), 1,
      anon_sym_SEMI,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5178), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3227), 2,
      sym_or,
      sym_and,
    ACTIONS(5812), 2,
      sym__layout_semicolon,
      sym__layout_end,
    STATE(1379), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [197541] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      aux_sym_immediate_hash_token1,
    ACTIONS(5911), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197561] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10834), 1,
      sym_hash_cid,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6090), 1,
      sym__layout_end,
    ACTIONS(6092), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197601] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10836), 1,
      sym_hash_cid,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197621] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5812), 1,
      sym__layout_end,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5177), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3199), 2,
      sym_or,
      sym_and,
    ACTIONS(5814), 2,
      anon_sym_COMMA,
      anon_sym_COLON,
    STATE(1375), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [197653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6181), 1,
      sym__layout_end,
    ACTIONS(6183), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197673] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 1,
      sym__layout_end,
    ACTIONS(6287), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197693] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6061), 1,
      sym__layout_end,
    ACTIONS(6063), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 1,
      sym__layout_end,
    ACTIONS(6187), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197733] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6185), 1,
      sym__layout_end,
    ACTIONS(6187), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197753] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5812), 1,
      sym__layout_end,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5175), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3187), 2,
      sym_or,
      sym_and,
    ACTIONS(5814), 2,
      anon_sym_COLON,
      sym_with,
    STATE(1366), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [197785] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6301), 1,
      sym__layout_end,
    ACTIONS(6303), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6285), 1,
      sym__layout_end,
    ACTIONS(6287), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197825] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3530), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6876), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [197858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10840), 11,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_u2200,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197892] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197909] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(2201), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6863), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [197942] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(1822), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6809), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [197975] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6063), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [197992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6187), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6063), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198026] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(4351), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6991), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198059] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3091), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6963), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198109] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5254), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3273), 2,
      sym_or,
      sym_and,
    ACTIONS(5814), 2,
      anon_sym_COLON,
      sym_rewrite_arrow,
    STATE(1377), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [198138] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(5526), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6824), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198171] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(1630), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6928), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198204] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(4569), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6915), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6179), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198254] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3102), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6902), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198304] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6771), 1,
      sym__lhs,
    STATE(7032), 1,
      sym_term_definition2,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198337] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6293), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198371] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3807), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6952), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198404] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(4605), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6996), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198437] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6303), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198454] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5249), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3239), 2,
      sym_or,
      sym_and,
    ACTIONS(5814), 2,
      anon_sym_COLON,
      sym_with,
    STATE(1381), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [198483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6283), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198500] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3595), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6889), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198533] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6187), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198567] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5249), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5780), 2,
      anon_sym_COLON,
      sym_with,
    ACTIONS(10842), 2,
      sym_or,
      sym_and,
    STATE(1381), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [198596] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6303), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6092), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10845), 11,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_SQUOTE,
      anon_sym_forall,
      anon_sym_u2200,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198664] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5254), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(5780), 2,
      anon_sym_COLON,
      sym_rewrite_arrow,
    ACTIONS(10847), 2,
      sym_or,
      sym_and,
    STATE(1377), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [198693] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(2442), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6837), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6287), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198743] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(4025), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6940), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6287), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198793] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6183), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198827] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(4269), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6985), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5951), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5945), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6237), 11,
      anon_sym_DASH_GT,
      anon_sym_LPAREN_RPAREN,
      anon_sym_LPAREN,
      anon_sym_LBRACK,
      anon_sym_LBRACE,
      sym_with,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
      aux_sym_hash_qualifier_token1,
      sym_built_in_hash,
  [198911] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(1997), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6974), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198944] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(5071), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(7099), 1,
      sym__lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [198977] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(9743), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10838), 1,
      sym_path,
    STATE(3522), 1,
      sym_term_definition2,
    STATE(6177), 1,
      sym_open_parens,
    STATE(6850), 1,
      sym__lhs,
    STATE(7097), 1,
      sym__prefix_lhs,
    STATE(7098), 1,
      sym__infix_lhs,
    STATE(5358), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [199010] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10850), 1,
      anon_sym_DASH_GT,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199044] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10860), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199078] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10862), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199112] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10864), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199146] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5814), 1,
      sym_with,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5285), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3295), 2,
      sym_or,
      sym_and,
    STATE(1386), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [199174] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10866), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199208] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10868), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199242] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10870), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199276] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10872), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199310] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10874), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199344] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10876), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199378] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(971), 1,
      sym_symboly_id,
    ACTIONS(5814), 1,
      anon_sym_DASH_GT,
    ACTIONS(5816), 1,
      sym_path,
    STATE(5286), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(3416), 2,
      sym_or,
      sym_and,
    STATE(1367), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [199406] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10878), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199440] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10880), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199474] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10882), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199508] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10884), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199542] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10886), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199576] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      sym_with,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5285), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(10888), 2,
      sym_or,
      sym_and,
    STATE(1386), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [199604] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5780), 1,
      anon_sym_DASH_GT,
    ACTIONS(5785), 1,
      sym_symboly_id,
    ACTIONS(5788), 1,
      sym_path,
    STATE(5286), 1,
      aux_sym__infix_app_or_boolean_op_repeat1,
    ACTIONS(10891), 2,
      sym_or,
      sym_and,
    STATE(1367), 2,
      sym__generic_infix_app,
      sym__infix,
    STATE(4718), 2,
      sym__hq_qualified_symboly_id,
      sym__hq_qualified_infix_term,
  [199632] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10894), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199666] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10896), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199700] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10898), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199734] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10900), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199768] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10902), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199802] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10904), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199836] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10906), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199870] = 11,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(10908), 1,
      anon_sym_DASH_GT,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [199904] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10910), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10912), 1,
      sym_symboly_id,
    ACTIONS(10914), 1,
      sym_path,
    ACTIONS(10916), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10918), 1,
      sym_built_in_hash,
    STATE(1967), 1,
      sym__identifier,
    STATE(2089), 1,
      sym_wordy_id,
    STATE(2212), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [199933] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10920), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10922), 1,
      sym_symboly_id,
    ACTIONS(10924), 1,
      sym_path,
    ACTIONS(10926), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10928), 1,
      sym_built_in_hash,
    STATE(3228), 1,
      sym__identifier,
    STATE(3594), 1,
      sym_wordy_id,
    STATE(3836), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [199962] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10930), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10932), 1,
      sym_symboly_id,
    ACTIONS(10934), 1,
      sym_path,
    ACTIONS(10936), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10938), 1,
      sym_built_in_hash,
    STATE(1855), 1,
      sym__identifier,
    STATE(1963), 1,
      sym_wordy_id,
    STATE(2072), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [199991] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10940), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10942), 1,
      sym_symboly_id,
    ACTIONS(10944), 1,
      sym_path,
    ACTIONS(10946), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10948), 1,
      sym_built_in_hash,
    STATE(2288), 1,
      sym__identifier,
    STATE(2339), 1,
      sym_wordy_id,
    STATE(2620), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200020] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10950), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10952), 1,
      sym_symboly_id,
    ACTIONS(10954), 1,
      sym_path,
    ACTIONS(10956), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10958), 1,
      sym_built_in_hash,
    STATE(2849), 1,
      sym__identifier,
    STATE(2958), 1,
      sym_wordy_id,
    STATE(3514), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200049] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10960), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10962), 1,
      sym_symboly_id,
    ACTIONS(10964), 1,
      sym_path,
    ACTIONS(10966), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10968), 1,
      sym_built_in_hash,
    STATE(2580), 1,
      sym__identifier,
    STATE(2756), 1,
      sym_wordy_id,
    STATE(3220), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200078] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10950), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10952), 1,
      sym_symboly_id,
    ACTIONS(10954), 1,
      sym_path,
    ACTIONS(10956), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10970), 1,
      sym_built_in_hash,
    STATE(2849), 1,
      sym__identifier,
    STATE(2958), 1,
      sym_wordy_id,
    STATE(3513), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200107] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10972), 1,
      anon_sym_LPAREN,
    ACTIONS(10975), 1,
      anon_sym_DOT,
    ACTIONS(10977), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10980), 1,
      sym_path,
    STATE(6163), 1,
      sym_open_parens,
    STATE(5302), 4,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
      aux_sym_rewrite_type_repeat1,
  [200132] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10983), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10985), 1,
      sym_symboly_id,
    ACTIONS(10987), 1,
      sym_path,
    ACTIONS(10989), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10991), 1,
      sym_built_in_hash,
    STATE(2765), 1,
      sym__identifier,
    STATE(2891), 1,
      sym_wordy_id,
    STATE(3658), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200161] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10960), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10962), 1,
      sym_symboly_id,
    ACTIONS(10964), 1,
      sym_path,
    ACTIONS(10966), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(10993), 1,
      sym_built_in_hash,
    STATE(2580), 1,
      sym__identifier,
    STATE(2756), 1,
      sym_wordy_id,
    STATE(3221), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200190] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(10995), 1,
      anon_sym_DOT,
    ACTIONS(10997), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10999), 1,
      sym_path,
    STATE(6163), 1,
      sym_open_parens,
    STATE(5302), 4,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
      aux_sym_rewrite_type_repeat1,
  [200215] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11001), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11003), 1,
      sym_symboly_id,
    ACTIONS(11005), 1,
      sym_path,
    ACTIONS(11007), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11009), 1,
      sym_built_in_hash,
    STATE(4064), 1,
      sym__identifier,
    STATE(4162), 1,
      sym_wordy_id,
    STATE(4481), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200244] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11011), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11013), 1,
      sym_symboly_id,
    ACTIONS(11015), 1,
      sym_path,
    ACTIONS(11017), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11019), 1,
      sym_built_in_hash,
    STATE(3573), 1,
      sym__identifier,
    STATE(4010), 1,
      sym_wordy_id,
    STATE(4391), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200273] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11001), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11003), 1,
      sym_symboly_id,
    ACTIONS(11005), 1,
      sym_path,
    ACTIONS(11007), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11021), 1,
      sym_built_in_hash,
    STATE(4064), 1,
      sym__identifier,
    STATE(4162), 1,
      sym_wordy_id,
    STATE(4495), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200302] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11023), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11025), 1,
      sym_symboly_id,
    ACTIONS(11027), 1,
      sym_path,
    ACTIONS(11029), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11031), 1,
      sym_built_in_hash,
    STATE(2553), 1,
      sym__identifier,
    STATE(2859), 1,
      sym_wordy_id,
    STATE(2923), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200331] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10920), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10922), 1,
      sym_symboly_id,
    ACTIONS(10924), 1,
      sym_path,
    ACTIONS(10926), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11033), 1,
      sym_built_in_hash,
    STATE(3228), 1,
      sym__identifier,
    STATE(3594), 1,
      sym_wordy_id,
    STATE(4068), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200360] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11035), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11037), 1,
      sym_symboly_id,
    ACTIONS(11039), 1,
      sym_path,
    ACTIONS(11041), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11043), 1,
      sym_built_in_hash,
    STATE(3727), 1,
      sym__identifier,
    STATE(4049), 1,
      sym_wordy_id,
    STATE(4164), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200389] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10930), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10932), 1,
      sym_symboly_id,
    ACTIONS(10934), 1,
      sym_path,
    ACTIONS(10936), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11045), 1,
      sym_built_in_hash,
    STATE(1855), 1,
      sym__identifier,
    STATE(1963), 1,
      sym_wordy_id,
    STATE(2071), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200418] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11035), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11037), 1,
      sym_symboly_id,
    ACTIONS(11039), 1,
      sym_path,
    ACTIONS(11041), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11047), 1,
      sym_built_in_hash,
    STATE(3727), 1,
      sym__identifier,
    STATE(4049), 1,
      sym_wordy_id,
    STATE(4165), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200447] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10940), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10942), 1,
      sym_symboly_id,
    ACTIONS(10944), 1,
      sym_path,
    ACTIONS(10946), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11049), 1,
      sym_built_in_hash,
    STATE(2288), 1,
      sym__identifier,
    STATE(2339), 1,
      sym_wordy_id,
    STATE(2619), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200476] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11011), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11013), 1,
      sym_symboly_id,
    ACTIONS(11015), 1,
      sym_path,
    ACTIONS(11017), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11051), 1,
      sym_built_in_hash,
    STATE(3573), 1,
      sym__identifier,
    STATE(4010), 1,
      sym_wordy_id,
    STATE(4329), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200505] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11053), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11055), 1,
      sym_symboly_id,
    ACTIONS(11057), 1,
      sym_path,
    ACTIONS(11059), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11061), 1,
      sym_built_in_hash,
    STATE(2771), 1,
      sym__identifier,
    STATE(3068), 1,
      sym_wordy_id,
    STATE(3505), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200534] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11053), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11055), 1,
      sym_symboly_id,
    ACTIONS(11057), 1,
      sym_path,
    ACTIONS(11059), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11063), 1,
      sym_built_in_hash,
    STATE(2771), 1,
      sym__identifier,
    STATE(3068), 1,
      sym_wordy_id,
    STATE(3503), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200563] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10910), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10912), 1,
      sym_symboly_id,
    ACTIONS(10914), 1,
      sym_path,
    ACTIONS(10916), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11065), 1,
      sym_built_in_hash,
    STATE(1967), 1,
      sym__identifier,
    STATE(2089), 1,
      sym_wordy_id,
    STATE(2215), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200592] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11067), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11069), 1,
      sym_symboly_id,
    ACTIONS(11071), 1,
      sym_path,
    ACTIONS(11073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11075), 1,
      sym_built_in_hash,
    STATE(1551), 1,
      sym__identifier,
    STATE(1764), 1,
      sym_wordy_id,
    STATE(1828), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200621] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11067), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11069), 1,
      sym_symboly_id,
    ACTIONS(11071), 1,
      sym_path,
    ACTIONS(11073), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11077), 1,
      sym_built_in_hash,
    STATE(1551), 1,
      sym__identifier,
    STATE(1764), 1,
      sym_wordy_id,
    STATE(1877), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200650] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11079), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11081), 1,
      sym_symboly_id,
    ACTIONS(11083), 1,
      sym_path,
    ACTIONS(11085), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11087), 1,
      sym_built_in_hash,
    STATE(1526), 1,
      sym__identifier,
    STATE(1577), 1,
      sym_wordy_id,
    STATE(1754), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200679] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11089), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11091), 1,
      sym_symboly_id,
    ACTIONS(11093), 1,
      sym_path,
    ACTIONS(11095), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11097), 1,
      sym_built_in_hash,
    STATE(3276), 1,
      sym__identifier,
    STATE(3494), 1,
      sym_wordy_id,
    STATE(3877), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200708] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11023), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11025), 1,
      sym_symboly_id,
    ACTIONS(11027), 1,
      sym_path,
    ACTIONS(11029), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11099), 1,
      sym_built_in_hash,
    STATE(2553), 1,
      sym__identifier,
    STATE(2859), 1,
      sym_wordy_id,
    STATE(2924), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200737] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10983), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10985), 1,
      sym_symboly_id,
    ACTIONS(10987), 1,
      sym_path,
    ACTIONS(10989), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11101), 1,
      sym_built_in_hash,
    STATE(2765), 1,
      sym__identifier,
    STATE(2891), 1,
      sym_wordy_id,
    STATE(3659), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200766] = 10,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6724), 1,
      anon_sym_COLON,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    STATE(4793), 1,
      sym_type_signature_colon,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [200797] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11089), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11091), 1,
      sym_symboly_id,
    ACTIONS(11093), 1,
      sym_path,
    ACTIONS(11095), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11103), 1,
      sym_built_in_hash,
    STATE(3276), 1,
      sym__identifier,
    STATE(3494), 1,
      sym_wordy_id,
    STATE(3876), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200826] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11105), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11107), 1,
      sym_symboly_id,
    ACTIONS(11109), 1,
      sym_path,
    ACTIONS(11111), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11113), 1,
      sym_built_in_hash,
    STATE(4062), 1,
      sym__identifier,
    STATE(4198), 1,
      sym_wordy_id,
    STATE(4407), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200855] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11105), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11107), 1,
      sym_symboly_id,
    ACTIONS(11109), 1,
      sym_path,
    ACTIONS(11111), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11115), 1,
      sym_built_in_hash,
    STATE(4062), 1,
      sym__identifier,
    STATE(4198), 1,
      sym_wordy_id,
    STATE(4408), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200884] = 9,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11079), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11081), 1,
      sym_symboly_id,
    ACTIONS(11083), 1,
      sym_path,
    ACTIONS(11085), 1,
      aux_sym_hash_qualifier_token1,
    ACTIONS(11117), 1,
      sym_built_in_hash,
    STATE(1526), 1,
      sym__identifier,
    STATE(1577), 1,
      sym_wordy_id,
    STATE(1751), 2,
      sym_hash_qualifier,
      sym__hash_qualified,
  [200913] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 2,
      sym_where,
      aux_sym_wordy_id_token1,
    ACTIONS(5739), 6,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_AT,
      anon_sym_RBRACK,
  [200929] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5844), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [200948] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11125), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 6,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_with,
      sym_rewrite_arrow,
  [200963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5732), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [200982] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6000), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 7,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_with,
      sym_rewrite_arrow,
  [201014] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5985), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201033] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5827), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201052] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4656), 1,
      sym__pattern_infix_app,
    STATE(5369), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11128), 2,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
    ACTIONS(11130), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201071] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6239), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 7,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_with,
      sym_rewrite_arrow,
  [201103] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4660), 1,
      sym__pattern_infix_app,
    STATE(5341), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11132), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(11134), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201122] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4660), 1,
      sym__pattern_infix_app,
    STATE(5356), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11137), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(11139), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201141] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6226), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201160] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9410), 1,
      sym__layout_semicolon,
    ACTIONS(11141), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11143), 1,
      sym_symboly_id,
    ACTIONS(11145), 1,
      sym_path,
    STATE(5666), 1,
      sym_wordy_id,
    STATE(5366), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
  [201183] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5755), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201202] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5683), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6766), 3,
      anon_sym_DASH_GT,
      sym_rewrite_arrow,
      aux_sym_wordy_id_token1,
    ACTIONS(6764), 4,
      anon_sym_LPAREN,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_path,
  [201236] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11147), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11149), 1,
      sym_symboly_id,
    ACTIONS(11151), 1,
      sym_path,
    STATE(5704), 1,
      sym_type_name,
    STATE(6264), 1,
      sym_wordy_id,
    STATE(6267), 1,
      sym__identifier,
    STATE(7023), 1,
      sym_type_constructor,
  [201261] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6132), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201280] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7), 1,
      anon_sym_LPAREN,
    ACTIONS(11147), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11153), 1,
      sym_path,
    STATE(6195), 1,
      sym_open_parens,
    STATE(6621), 3,
      sym_wordy_id,
      sym__prefix_definition_name,
      sym__wordy_definition_name,
  [201301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6005), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201320] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4701), 1,
      sym__pattern_infix_app,
    STATE(5352), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11132), 2,
      sym__layout_end,
      anon_sym_COMMA,
    ACTIONS(11155), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201339] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4656), 1,
      sym__pattern_infix_app,
    STATE(5338), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11137), 2,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
    ACTIONS(11130), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201358] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5953), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201377] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5911), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201396] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4660), 1,
      sym__pattern_infix_app,
    STATE(5341), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11128), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
    ACTIONS(11139), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201415] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9420), 1,
      sym__layout_semicolon,
    ACTIONS(11141), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11143), 1,
      sym_symboly_id,
    ACTIONS(11145), 1,
      sym_path,
    STATE(5666), 1,
      sym_wordy_id,
    STATE(5344), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
  [201438] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10852), 1,
      sym_kw_equals,
    ACTIONS(10854), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10856), 1,
      sym_symboly_id,
    ACTIONS(10858), 1,
      sym_path,
    STATE(5350), 1,
      sym__symboly_definition_name,
    STATE(5644), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [201463] = 8,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11147), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11149), 1,
      sym_symboly_id,
    ACTIONS(11151), 1,
      sym_path,
    STATE(5704), 1,
      sym_type_name,
    STATE(6264), 1,
      sym_wordy_id,
    STATE(6267), 1,
      sym__identifier,
    STATE(6680), 1,
      sym_type_constructor,
  [201488] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4701), 1,
      sym__pattern_infix_app,
    STATE(5364), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11137), 2,
      sym__layout_end,
      anon_sym_COMMA,
    ACTIONS(11158), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 7,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_with,
      sym_rewrite_arrow,
  [201520] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5994), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 7,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_RPAREN,
      anon_sym_RBRACK,
      anon_sym_RBRACE,
      sym_with,
      sym_rewrite_arrow,
  [201552] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4701), 1,
      sym__pattern_infix_app,
    STATE(5352), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11128), 2,
      sym__layout_end,
      anon_sym_COMMA,
    ACTIONS(11158), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5899), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201590] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9388), 1,
      sym__layout_semicolon,
    ACTIONS(11160), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11163), 1,
      sym_symboly_id,
    ACTIONS(11166), 1,
      sym_path,
    STATE(5666), 1,
      sym_wordy_id,
    STATE(5366), 2,
      sym__identifier,
      aux_sym_use_clause_repeat1,
  [201613] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(5726), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201632] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11119), 1,
      sym_term,
    ACTIONS(11121), 1,
      sym_case,
    ACTIONS(11123), 1,
      sym_signature,
    STATE(6078), 4,
      sym__rewrite_type,
      sym_rewrite_term,
      sym_rewrite_case,
      sym_rewrite_type,
  [201651] = 5,
    ACTIONS(3), 1,
      sym_comment,
    STATE(4656), 1,
      sym__pattern_infix_app,
    STATE(5369), 1,
      aux_sym__pattern_root_repeat1,
    ACTIONS(11132), 2,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
    ACTIONS(11169), 3,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [201670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11174), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5372), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11172), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201686] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5374), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11176), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11182), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11186), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5382), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11184), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11188), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201750] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201766] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_with,
  [201778] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10447), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11192), 1,
      sym_symboly_id,
    ACTIONS(11194), 1,
      sym_path,
    STATE(5118), 1,
      sym__ebody,
    STATE(5659), 1,
      sym__identifier,
    STATE(6441), 1,
      sym_wordy_id,
  [201800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11198), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5375), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11196), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201816] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11200), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201832] = 7,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10447), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11192), 1,
      sym_symboly_id,
    ACTIONS(11194), 1,
      sym_path,
    STATE(5094), 1,
      sym__ebody,
    STATE(5659), 1,
      sym__identifier,
    STATE(6441), 1,
      sym_wordy_id,
  [201854] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11202), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201870] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11204), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201886] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11206), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201902] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11208), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11212), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5381), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11210), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11216), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5393), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11214), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201950] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11220), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5384), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11218), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201966] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11224), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5383), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11222), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11226), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [201998] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11230), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202030] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10518), 1,
      anon_sym_AT,
    ACTIONS(7532), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
  [202044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11232), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11236), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5390), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11234), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202076] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11240), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5379), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11238), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11244), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5399), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11242), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202108] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11249), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11246), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_with,
  [202136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11251), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202152] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11255), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5389), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11253), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_with,
  [202180] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11257), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11259), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11261), 6,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [202224] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11125), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 5,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_with,
  [202238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11263), 6,
      anon_sym_DASH_GT,
      anon_sym_COLON,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [202250] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11267), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5416), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11265), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11271), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5402), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11269), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202282] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11273), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202298] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11275), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202314] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11281), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5391), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11279), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11283), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 6,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      anon_sym_SEMI,
      sym_with,
  [202374] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5397), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11180), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202406] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11291), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5409), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11289), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11295), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5415), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11293), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202438] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11299), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5413), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11297), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11303), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5410), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11301), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202470] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11307), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5411), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11305), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202486] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11311), 1,
      anon_sym_DQUOTE_DQUOTE_DQUOTE,
    STATE(5403), 1,
      aux_sym_literal_text_repeat2,
    ACTIONS(11309), 4,
      anon_sym_DQUOTE,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202502] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11315), 1,
      sym__layout_start,
    STATE(6038), 1,
      sym_record_field,
    STATE(6527), 1,
      sym_wordy_id,
    STATE(6531), 2,
      sym__record_fields_inline,
      sym__record_fields_block,
  [202522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11208), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11319), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11321), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11206), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202567] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(5677), 1,
      sym_record_field,
    STATE(7027), 1,
      sym_wordy_id,
    ACTIONS(11324), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [202584] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11330), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5702), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [202603] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5741), 5,
      anon_sym_COLON,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [202614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4703), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [202629] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11332), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5687), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [202648] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11224), 1,
      anon_sym_DQUOTE,
    STATE(5426), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11334), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202663] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10590), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(10592), 1,
      sym_symboly_id,
    ACTIONS(10594), 1,
      sym_path,
    STATE(5006), 1,
      sym__identifier,
    STATE(5046), 1,
      sym_wordy_id,
  [202682] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9404), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(9406), 1,
      sym_symboly_id,
    ACTIONS(9408), 1,
      sym_path,
    STATE(4042), 1,
      sym__identifier,
    STATE(4652), 1,
      sym_wordy_id,
  [202701] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11281), 1,
      anon_sym_DQUOTE,
    STATE(5450), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11336), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202716] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11255), 1,
      anon_sym_DQUOTE,
    STATE(5437), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11338), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11226), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202746] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11174), 1,
      anon_sym_DQUOTE,
    STATE(5440), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11340), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 5,
      anon_sym_COLON,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [202772] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11182), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202787] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11342), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5774), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [202806] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11344), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5769), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [202825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 5,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
      anon_sym_RBRACK,
  [202836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11303), 1,
      anon_sym_DQUOTE,
    STATE(5447), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11346), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11216), 1,
      anon_sym_DQUOTE,
    STATE(5448), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11348), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11240), 1,
      anon_sym_DQUOTE,
    STATE(5452), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11350), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202881] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11275), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202896] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11232), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11220), 1,
      anon_sym_DQUOTE,
    STATE(5424), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11352), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202926] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11230), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202941] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11354), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5846), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [202960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11200), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11267), 1,
      anon_sym_DQUOTE,
    STATE(5454), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11356), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [202990] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11287), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203005] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11358), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5918), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203024] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11311), 1,
      anon_sym_DQUOTE,
    STATE(5457), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11360), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203039] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11259), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203054] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11362), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5977), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4703), 1,
      sym_arrow_symbol,
    ACTIONS(11364), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_COMMA,
  [203088] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11366), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5890), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203107] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11368), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5934), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203126] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11295), 1,
      anon_sym_DQUOTE,
    STATE(5463), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11370), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203141] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11285), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203156] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11372), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6019), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11271), 1,
      anon_sym_DQUOTE,
    STATE(5468), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11374), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203190] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11376), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5883), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4674), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [203224] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11257), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203239] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11380), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6203), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203258] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11382), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6055), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11251), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11236), 1,
      anon_sym_DQUOTE,
    STATE(5473), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11384), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11228), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11277), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203337] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11244), 1,
      anon_sym_DQUOTE,
    STATE(5471), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11386), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203352] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11388), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6083), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203371] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11212), 1,
      anon_sym_DQUOTE,
    STATE(5479), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11390), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203386] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11392), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6180), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11202), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4679), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 3,
      sym__layout_semicolon,
      sym__layout_end,
      sym_with,
  [203435] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11394), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6102), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203454] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11307), 1,
      anon_sym_DQUOTE,
    STATE(5474), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11396), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203469] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11398), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6117), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203488] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11400), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6129), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203507] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11402), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6140), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203526] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 5,
      sym__guard_layout_start,
      anon_sym_DASH_GT,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [203537] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11190), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203552] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4675), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 3,
      sym__layout_semicolon,
      sym__layout_end,
      sym_with,
  [203567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11198), 1,
      anon_sym_DQUOTE,
    STATE(5487), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11404), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203582] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11132), 5,
      sym__layout_end,
      anon_sym_COMMA,
      anon_sym_PLUS_PLUS,
      anon_sym_PLUS_COLON,
      anon_sym_COLON_PLUS,
  [203593] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11406), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5808), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203612] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11408), 1,
      anon_sym_COMMA,
    ACTIONS(11410), 1,
      anon_sym_RBRACE,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6094), 1,
      aux_sym__effect_block_repeat1,
  [203631] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11412), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6161), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203650] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(5677), 1,
      sym_record_field,
    STATE(7027), 1,
      sym_wordy_id,
    ACTIONS(11414), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [203667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11283), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203682] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11299), 1,
      anon_sym_DQUOTE,
    STATE(5495), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11416), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203697] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11418), 1,
      sym__layout_end,
    STATE(5582), 1,
      sym_record_field,
    STATE(6162), 1,
      sym__record_fields_inline,
    STATE(7027), 1,
      sym_wordy_id,
  [203716] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11141), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11143), 1,
      sym_symboly_id,
    ACTIONS(11145), 1,
      sym_path,
    STATE(5357), 1,
      sym__identifier,
    STATE(5666), 1,
      sym_wordy_id,
  [203735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11291), 1,
      anon_sym_DQUOTE,
    STATE(5502), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11420), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203750] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11422), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6143), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203769] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11424), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(6155), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11273), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203803] = 6,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11426), 1,
      anon_sym_RPAREN,
    STATE(4676), 1,
      sym_arrow_symbol,
    STATE(5998), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [203822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11186), 1,
      anon_sym_DQUOTE,
    STATE(5505), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11428), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203837] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11204), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203852] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6396), 1,
      anon_sym_DASH_GT,
    ACTIONS(11432), 1,
      aux_sym_wordy_id_token1,
    STATE(4664), 1,
      sym_arrow_symbol,
    ACTIONS(11430), 2,
      anon_sym_LPAREN,
      sym_path,
  [203869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11188), 1,
      anon_sym_DQUOTE,
    STATE(5425), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11317), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11178), 1,
      anon_sym_DQUOTE,
    STATE(5507), 1,
      aux_sym_literal_text_repeat1,
    ACTIONS(11434), 3,
      aux_sym_literal_text_token1,
      aux_sym_literal_text_token2,
      aux_sym_literal_text_token3,
  [203899] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 4,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      sym_with,
  [203909] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6760), 2,
      anon_sym_LPAREN,
      sym_path,
    ACTIONS(6762), 2,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
  [203921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [203931] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11436), 1,
      anon_sym_SEMI,
    ACTIONS(11438), 1,
      sym__layout_semicolon,
    ACTIONS(11440), 1,
      sym__layout_end,
    STATE(5613), 1,
      aux_sym_guarded_block_repeat2,
  [203947] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 4,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      sym_with,
  [203957] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11442), 1,
      anon_sym_DOT,
    ACTIONS(11444), 1,
      aux_sym_wordy_id_token1,
    STATE(5533), 2,
      sym_wordy_id,
      aux_sym_forall_repeat1,
  [203971] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11448), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11446), 3,
      anon_sym_LPAREN,
      anon_sym_RPAREN,
      sym_path,
  [203983] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11452), 1,
      sym__guard_layout_start,
    STATE(3641), 1,
      sym__pattern_rhs,
    STATE(6979), 1,
      sym_arrow_symbol,
  [203999] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11454), 1,
      sym_kw_equals,
    ACTIONS(11456), 1,
      aux_sym_wordy_id_token1,
    STATE(5517), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [204015] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11459), 1,
      anon_sym_SEMI,
    ACTIONS(11461), 1,
      sym__layout_semicolon,
    ACTIONS(11463), 1,
      sym__layout_end,
    STATE(5523), 1,
      aux_sym_guarded_block_repeat2,
  [204031] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11465), 1,
      sym__layout_start,
    STATE(5036), 1,
      sym_constructor,
    STATE(6548), 1,
      sym_wordy_id,
  [204047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204057] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11467), 1,
      sym__guard_layout_start,
    STATE(1889), 1,
      sym__pattern_rhs,
    STATE(6789), 1,
      sym_arrow_symbol,
  [204073] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11469), 1,
      anon_sym_SEMI,
    ACTIONS(11471), 1,
      sym__layout_semicolon,
    ACTIONS(11473), 1,
      sym__layout_end,
    STATE(5554), 1,
      aux_sym_guarded_block_repeat2,
  [204089] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11475), 1,
      anon_sym_SEMI,
    ACTIONS(11477), 1,
      sym__layout_semicolon,
    ACTIONS(11479), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204105] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 1,
      sym_with,
    ACTIONS(11481), 1,
      sym__layout_semicolon,
    ACTIONS(11483), 1,
      sym__layout_end,
    STATE(5529), 1,
      aux_sym___layout_block_repeat1,
  [204121] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11485), 1,
      sym__layout_start,
    STATE(5030), 1,
      sym_constructor,
    STATE(6548), 1,
      sym_wordy_id,
  [204137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204147] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11487), 1,
      sym_where,
    ACTIONS(11489), 1,
      aux_sym_wordy_id_token1,
    STATE(5527), 1,
      aux_sym__ebody_repeat1,
    STATE(6470), 1,
      sym_wordy_id,
  [204163] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 2,
      anon_sym_DOT,
      aux_sym_wordy_id_token1,
    ACTIONS(11492), 2,
      anon_sym_LPAREN,
      sym_path,
  [204175] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6892), 1,
      sym_with,
    ACTIONS(11494), 1,
      sym__layout_semicolon,
    ACTIONS(11496), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [204191] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      sym_with,
    ACTIONS(11498), 1,
      sym__layout_semicolon,
    ACTIONS(11500), 1,
      sym__layout_end,
    STATE(5531), 1,
      aux_sym___layout_block_repeat1,
  [204207] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      sym_with,
    ACTIONS(11502), 1,
      sym__layout_semicolon,
    ACTIONS(11504), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [204223] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      sym_with,
    ACTIONS(11506), 1,
      sym__layout_semicolon,
    ACTIONS(11508), 1,
      sym__layout_end,
    STATE(5534), 1,
      aux_sym___layout_block_repeat1,
  [204239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11444), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11510), 1,
      anon_sym_DOT,
    STATE(5565), 2,
      sym_wordy_id,
      aux_sym_forall_repeat1,
  [204253] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      sym_with,
    ACTIONS(11512), 1,
      sym__layout_semicolon,
    ACTIONS(11514), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [204269] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4676), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [204293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_with,
      sym_rewrite_arrow,
  [204303] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11516), 1,
      anon_sym_SEMI,
    ACTIONS(11518), 1,
      sym__layout_semicolon,
    ACTIONS(11520), 1,
      sym__layout_end,
    STATE(5553), 1,
      aux_sym_guarded_block_repeat2,
  [204319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_with,
      sym_rewrite_arrow,
  [204329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204339] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204379] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204409] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204429] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204439] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 1,
      sym__layout_semicolon,
    ACTIONS(5982), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [204451] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204461] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11522), 1,
      anon_sym_SEMI,
    ACTIONS(11524), 1,
      sym__layout_semicolon,
    ACTIONS(11526), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204477] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11528), 1,
      anon_sym_SEMI,
    ACTIONS(11530), 1,
      sym__layout_semicolon,
    ACTIONS(11532), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204493] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11534), 1,
      sym__guard_layout_start,
    STATE(3768), 1,
      sym__pattern_rhs,
    STATE(6926), 1,
      sym_arrow_symbol,
  [204509] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11536), 1,
      anon_sym_SEMI,
    ACTIONS(11538), 1,
      sym__layout_semicolon,
    ACTIONS(11540), 1,
      sym__layout_end,
    STATE(5560), 1,
      aux_sym_guarded_block_repeat2,
  [204525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204535] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204555] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11542), 1,
      anon_sym_SEMI,
    ACTIONS(11544), 1,
      sym__layout_semicolon,
    ACTIONS(11546), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204571] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11414), 1,
      anon_sym_RBRACE,
    STATE(6399), 1,
      sym_record_field,
    STATE(6527), 1,
      sym_wordy_id,
  [204587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11548), 1,
      anon_sym_COMMA,
    STATE(5631), 1,
      aux_sym__record_fields_inline_repeat1,
    ACTIONS(11414), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [204601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 4,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      sym_with,
  [204611] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11125), 1,
      anon_sym_DASH_GT,
    ACTIONS(6546), 3,
      sym__layout_end,
      anon_sym_COMMA,
      sym_with,
  [204623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11550), 1,
      anon_sym_DOT,
    ACTIONS(11552), 1,
      aux_sym_wordy_id_token1,
    STATE(5565), 2,
      sym_wordy_id,
      aux_sym_forall_repeat1,
  [204637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7154), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204647] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11555), 1,
      sym__layout_semicolon,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 2,
      sym__layout_end,
      anon_sym_SEMI,
  [204661] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10447), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11558), 1,
      sym_where,
    STATE(5527), 1,
      aux_sym__ebody_repeat1,
    STATE(6470), 1,
      sym_wordy_id,
  [204677] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4708), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__layout_end,
      anon_sym_COMMA,
  [204691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204701] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11560), 1,
      sym__guard_layout_start,
    STATE(3169), 1,
      sym__pattern_rhs,
    STATE(6874), 1,
      sym_arrow_symbol,
  [204717] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 1,
      sym_with,
    ACTIONS(11562), 1,
      sym__layout_semicolon,
    ACTIONS(11564), 1,
      sym__layout_end,
    STATE(5602), 1,
      aux_sym___layout_block_repeat1,
  [204733] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11566), 1,
      anon_sym_SEMI,
    ACTIONS(11568), 1,
      sym__layout_semicolon,
    ACTIONS(11570), 1,
      sym__layout_end,
    STATE(5575), 1,
      aux_sym_guarded_block_repeat2,
  [204749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4716), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__layout_end,
      sym_with,
  [204763] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11572), 1,
      anon_sym_SEMI,
    ACTIONS(11574), 1,
      sym__layout_semicolon,
    ACTIONS(11576), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204779] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6548), 1,
      anon_sym_DASH_GT,
    ACTIONS(6551), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(6546), 2,
      anon_sym_LPAREN,
      sym_path,
  [204793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4676), 1,
      sym_arrow_symbol,
    ACTIONS(11578), 2,
      anon_sym_COMMA,
      anon_sym_RPAREN,
  [204807] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6764), 4,
      sym__layout_end,
      anon_sym_DASH_GT,
      anon_sym_COMMA,
      sym_with,
  [204817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4671), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      sym__layout_end,
      anon_sym_COMMA,
  [204831] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6748), 2,
      anon_sym_LPAREN,
      sym_path,
    ACTIONS(6750), 2,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
  [204843] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11580), 1,
      anon_sym_SEMI,
    ACTIONS(11582), 1,
      sym__layout_semicolon,
    ACTIONS(11584), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204859] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11586), 1,
      anon_sym_COMMA,
    STATE(5562), 1,
      aux_sym__record_fields_inline_repeat1,
    ACTIONS(11588), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [204873] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(5582), 1,
      sym_record_field,
    STATE(6499), 1,
      sym__record_fields_inline,
    STATE(7027), 1,
      sym_wordy_id,
  [204889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11263), 2,
      anon_sym_DOT,
      aux_sym_wordy_id_token1,
    ACTIONS(11590), 2,
      anon_sym_LPAREN,
      sym_path,
  [204901] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11324), 1,
      anon_sym_RBRACE,
    STATE(6399), 1,
      sym_record_field,
    STATE(6527), 1,
      sym_wordy_id,
  [204917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4676), 1,
      sym_arrow_symbol,
    ACTIONS(11364), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [204931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204941] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11261), 2,
      anon_sym_DOT,
      aux_sym_wordy_id_token1,
    ACTIONS(11592), 2,
      anon_sym_LPAREN,
      sym_path,
  [204953] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204963] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11594), 1,
      anon_sym_SEMI,
    ACTIONS(11596), 1,
      sym__layout_semicolon,
    ACTIONS(11598), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [204979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204989] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [204999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205009] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205059] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4700), 1,
      sym_arrow_symbol,
    ACTIONS(6394), 2,
      sym__layout_end,
      sym_with,
  [205073] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205093] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6892), 1,
      sym_with,
    ACTIONS(11600), 1,
      sym__layout_semicolon,
    ACTIONS(11602), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [205109] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11604), 1,
      sym__guard_layout_start,
    STATE(1687), 1,
      sym__pattern_rhs,
    STATE(6828), 1,
      sym_arrow_symbol,
  [205125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205135] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11606), 1,
      anon_sym_SEMI,
    ACTIONS(11608), 1,
      sym__layout_semicolon,
    ACTIONS(11610), 1,
      sym__layout_end,
    STATE(5616), 1,
      aux_sym_guarded_block_repeat2,
  [205151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205161] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11612), 1,
      anon_sym_SEMI,
    ACTIONS(11614), 1,
      sym__layout_semicolon,
    ACTIONS(11616), 1,
      sym__layout_end,
    STATE(5581), 1,
      aux_sym_guarded_block_repeat2,
  [205177] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11618), 1,
      anon_sym_SEMI,
    ACTIONS(11620), 1,
      sym__layout_semicolon,
    ACTIONS(11622), 1,
      sym__layout_end,
    STATE(5590), 1,
      aux_sym_guarded_block_repeat2,
  [205193] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      anon_sym_SEMI,
    ACTIONS(11514), 1,
      sym__layout_end,
    ACTIONS(11624), 1,
      sym__layout_semicolon,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [205209] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11626), 1,
      anon_sym_SEMI,
    ACTIONS(11628), 1,
      sym__layout_semicolon,
    ACTIONS(11630), 1,
      sym__layout_end,
    STATE(5625), 1,
      aux_sym_guarded_block_repeat2,
  [205225] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4676), 1,
      sym_arrow_symbol,
    ACTIONS(11632), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [205239] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11634), 1,
      anon_sym_SEMI,
    ACTIONS(11636), 1,
      sym__layout_semicolon,
    ACTIONS(11638), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205255] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11640), 1,
      anon_sym_SEMI,
    ACTIONS(11642), 1,
      sym__layout_semicolon,
    ACTIONS(11644), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205271] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6868), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
    ACTIONS(11646), 2,
      sym__layout_semicolon,
      anon_sym_SEMI,
  [205285] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11649), 1,
      anon_sym_SEMI,
    ACTIONS(11651), 1,
      sym__layout_semicolon,
    ACTIONS(11653), 1,
      sym__layout_end,
    STATE(5612), 1,
      aux_sym_guarded_block_repeat2,
  [205301] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11655), 1,
      anon_sym_SEMI,
    ACTIONS(11657), 1,
      sym__layout_semicolon,
    ACTIONS(11659), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205317] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      sym_with,
    ACTIONS(11661), 1,
      sym__layout_semicolon,
    ACTIONS(11663), 1,
      sym__layout_end,
    STATE(5622), 1,
      aux_sym___layout_block_repeat1,
  [205333] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      anon_sym_SEMI,
    ACTIONS(11508), 1,
      sym__layout_end,
    ACTIONS(11665), 1,
      sym__layout_semicolon,
    STATE(5609), 1,
      aux_sym___layout_block_repeat1,
  [205349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205359] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      anon_sym_SEMI,
    ACTIONS(11504), 1,
      sym__layout_end,
    ACTIONS(11667), 1,
      sym__layout_semicolon,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [205375] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11669), 1,
      anon_sym_SEMI,
    ACTIONS(11671), 1,
      sym__layout_semicolon,
    ACTIONS(11673), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205391] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6839), 1,
      sym_with,
    ACTIONS(11675), 1,
      sym__layout_semicolon,
    ACTIONS(11677), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [205407] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6831), 1,
      sym_with,
    ACTIONS(11679), 1,
      sym__layout_semicolon,
    ACTIONS(11681), 1,
      sym__layout_end,
    STATE(5633), 1,
      aux_sym___layout_block_repeat1,
  [205423] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6907), 1,
      anon_sym_SEMI,
    ACTIONS(11500), 1,
      sym__layout_end,
    ACTIONS(11683), 1,
      sym__layout_semicolon,
    STATE(5620), 1,
      aux_sym___layout_block_repeat1,
  [205439] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11685), 1,
      anon_sym_SEMI,
    ACTIONS(11687), 1,
      sym__layout_semicolon,
    ACTIONS(11689), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11261), 4,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [205465] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11691), 1,
      anon_sym_SEMI,
    ACTIONS(11693), 1,
      sym__layout_semicolon,
    ACTIONS(11695), 1,
      sym__layout_end,
    STATE(5621), 1,
      aux_sym_guarded_block_repeat2,
  [205481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11263), 4,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [205491] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11697), 1,
      anon_sym_SEMI,
    ACTIONS(11699), 1,
      sym__layout_semicolon,
    ACTIONS(11701), 1,
      sym__layout_end,
    STATE(5634), 1,
      aux_sym_guarded_block_repeat2,
  [205507] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 4,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
      sym_with,
  [205517] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11703), 1,
      anon_sym_COMMA,
    STATE(5631), 1,
      aux_sym__record_fields_inline_repeat1,
    ACTIONS(11706), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [205531] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6892), 1,
      anon_sym_SEMI,
    ACTIONS(11496), 1,
      sym__layout_end,
    ACTIONS(11708), 1,
      sym__layout_semicolon,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [205547] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6811), 1,
      sym_with,
    ACTIONS(11710), 1,
      sym__layout_semicolon,
    ACTIONS(11712), 1,
      sym__layout_end,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
  [205563] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11714), 1,
      anon_sym_SEMI,
    ACTIONS(11716), 1,
      sym__layout_semicolon,
    ACTIONS(11718), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205579] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11720), 1,
      anon_sym_SEMI,
    ACTIONS(11722), 1,
      sym__layout_semicolon,
    ACTIONS(11724), 1,
      sym__layout_end,
    STATE(5652), 1,
      aux_sym_guarded_block_repeat2,
  [205595] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11726), 1,
      anon_sym_SEMI,
    ACTIONS(11728), 1,
      sym__layout_semicolon,
    ACTIONS(11730), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4714), 1,
      sym_type_signature_colon,
    ACTIONS(6720), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [205625] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6878), 2,
      anon_sym_LPAREN,
      sym_path,
    ACTIONS(6880), 2,
      anon_sym_DASH_GT,
      aux_sym_wordy_id_token1,
  [205637] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11732), 1,
      anon_sym_SEMI,
    ACTIONS(11734), 1,
      sym__layout_semicolon,
    ACTIONS(11736), 1,
      sym__layout_end,
    STATE(5645), 1,
      aux_sym_guarded_block_repeat2,
  [205653] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_with,
      sym_rewrite_arrow,
  [205663] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11738), 1,
      anon_sym_SEMI,
    ACTIONS(11740), 1,
      sym__layout_semicolon,
    ACTIONS(11742), 1,
      sym__layout_end,
    STATE(5636), 1,
      aux_sym_guarded_block_repeat2,
  [205679] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11744), 1,
      anon_sym_SEMI,
    ACTIONS(11746), 1,
      sym__layout_semicolon,
    ACTIONS(11748), 1,
      sym__layout_end,
    STATE(5649), 1,
      aux_sym_guarded_block_repeat2,
  [205695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 4,
      anon_sym_COMMA,
      anon_sym_RBRACK,
      sym_with,
      sym_rewrite_arrow,
  [205705] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11444), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11750), 1,
      sym_kw_equals,
    STATE(5517), 1,
      aux_sym__prefix_lhs_repeat1,
    STATE(6410), 1,
      sym_wordy_id,
  [205721] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11752), 1,
      anon_sym_SEMI,
    ACTIONS(11754), 1,
      sym__layout_semicolon,
    ACTIONS(11756), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205737] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6770), 1,
      anon_sym_SEMI,
    ACTIONS(11483), 1,
      sym__layout_end,
    ACTIONS(11758), 1,
      sym__layout_semicolon,
    STATE(5632), 1,
      aux_sym___layout_block_repeat1,
  [205753] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11760), 1,
      sym__layout_semicolon,
    STATE(5647), 1,
      aux_sym___layout_block_repeat1,
    ACTIONS(6900), 2,
      sym__layout_end,
      sym_with,
  [205767] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11763), 1,
      anon_sym_SEMI,
    ACTIONS(11765), 1,
      sym__layout_semicolon,
    ACTIONS(11767), 1,
      sym__layout_end,
    STATE(5650), 1,
      aux_sym_guarded_block_repeat2,
  [205783] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11769), 1,
      anon_sym_SEMI,
    ACTIONS(11771), 1,
      sym__layout_semicolon,
    ACTIONS(11773), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205799] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11775), 1,
      anon_sym_SEMI,
    ACTIONS(11777), 1,
      sym__layout_semicolon,
    ACTIONS(11779), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205815] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11781), 1,
      anon_sym_SEMI,
    ACTIONS(11783), 1,
      sym__layout_semicolon,
    ACTIONS(11785), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205831] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11787), 1,
      anon_sym_SEMI,
    ACTIONS(11789), 1,
      sym__layout_semicolon,
    ACTIONS(11791), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205847] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11793), 1,
      anon_sym_SEMI,
    ACTIONS(11795), 1,
      sym__layout_semicolon,
    ACTIONS(11797), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205863] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11799), 1,
      anon_sym_SEMI,
    ACTIONS(11801), 1,
      sym__layout_semicolon,
    ACTIONS(11803), 1,
      sym__layout_end,
    STATE(5651), 1,
      aux_sym_guarded_block_repeat2,
  [205879] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11805), 1,
      anon_sym_SEMI,
    ACTIONS(11807), 1,
      sym__layout_semicolon,
    ACTIONS(11809), 1,
      sym__layout_end,
    STATE(5653), 1,
      aux_sym_guarded_block_repeat2,
  [205895] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11811), 1,
      sym__guard_layout_start,
    STATE(2989), 1,
      sym__pattern_rhs,
    STATE(6780), 1,
      sym_arrow_symbol,
  [205911] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11813), 1,
      anon_sym_SEMI,
    ACTIONS(11815), 1,
      sym__layout_semicolon,
    ACTIONS(11817), 1,
      sym__layout_end,
    STATE(5663), 1,
      aux_sym_guarded_block_repeat2,
  [205927] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    ACTIONS(11819), 1,
      sym__guard_layout_start,
    STATE(2607), 1,
      sym__pattern_rhs,
    STATE(7081), 1,
      sym_arrow_symbol,
  [205943] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10447), 1,
      aux_sym_wordy_id_token1,
    ACTIONS(11821), 1,
      sym_where,
    STATE(5568), 1,
      aux_sym__ebody_repeat1,
    STATE(6470), 1,
      sym_wordy_id,
  [205959] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 2,
      anon_sym_LPAREN,
      sym_path,
    ACTIONS(5741), 2,
      anon_sym_DOT,
      aux_sym_wordy_id_token1,
  [205971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5721), 4,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [205981] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11823), 1,
      anon_sym_SEMI,
    ACTIONS(11825), 1,
      sym__layout_semicolon,
    ACTIONS(11827), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [205997] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11829), 1,
      anon_sym_SEMI,
    ACTIONS(11831), 1,
      sym__layout_semicolon,
    ACTIONS(11833), 1,
      sym__layout_end,
    STATE(5614), 1,
      aux_sym_guarded_block_repeat2,
  [206013] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 1,
      sym__layout_semicolon,
    ACTIONS(5741), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [206025] = 5,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11835), 1,
      anon_sym_SEMI,
    ACTIONS(11837), 1,
      sym__layout_semicolon,
    ACTIONS(11839), 1,
      sym__layout_end,
    STATE(5662), 1,
      aux_sym_guarded_block_repeat2,
  [206041] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 1,
      sym__layout_semicolon,
    ACTIONS(5911), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [206053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11843), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(11847), 1,
      anon_sym_RBRACK,
    STATE(6122), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(11849), 1,
      anon_sym_RBRACK,
    STATE(5678), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11851), 3,
      aux_sym_wordy_id_token1,
      sym_symboly_id,
      sym_path,
  [206101] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11853), 1,
      sym__layout_end,
    STATE(5734), 1,
      aux_sym___layout_block_repeat1,
  [206114] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11855), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206127] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11857), 1,
      sym__layout_end,
    STATE(5689), 1,
      aux_sym___layout_block_repeat1,
  [206140] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11859), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206153] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11861), 1,
      sym__layout_end,
    STATE(5725), 1,
      aux_sym___layout_block_repeat1,
  [206166] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11863), 1,
      sym__layout_end,
    STATE(5698), 1,
      aux_sym___layout_block_repeat1,
  [206179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11706), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_COMMA,
  [206188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(11865), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206201] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11867), 1,
      anon_sym_DASH_GT,
    ACTIONS(10638), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [206212] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7370), 3,
      sym__layout_end,
      anon_sym_COMMA,
      sym_with,
  [206221] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11869), 1,
      sym__layout_end,
    STATE(5693), 1,
      aux_sym___layout_block_repeat1,
  [206234] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11871), 1,
      sym__layout_semicolon,
    ACTIONS(11873), 1,
      sym__layout_end,
    STATE(5712), 1,
      aux_sym___block_repeat2,
  [206247] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(11877), 1,
      sym__layout_end,
    STATE(5699), 1,
      aux_sym_rewrite_block_repeat1,
  [206260] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11879), 1,
      sym__layout_semicolon,
    ACTIONS(11881), 1,
      sym__layout_end,
    STATE(5701), 1,
      aux_sym___block_repeat2,
  [206273] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(11883), 1,
      sym_symboly_id,
    STATE(6409), 1,
      sym__symboly_definition_name,
  [206286] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11885), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [206299] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11887), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [206312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      anon_sym_DOT,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
  [206321] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11889), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206334] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11891), 1,
      sym__layout_end,
    STATE(5719), 1,
      aux_sym___layout_block_repeat1,
  [206347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7366), 3,
      sym__layout_end,
      anon_sym_COMMA,
      sym_with,
  [206356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11893), 1,
      sym__layout_semicolon,
    ACTIONS(11895), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11897), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11899), 1,
      sym__layout_end,
    STATE(5707), 1,
      aux_sym___layout_block_repeat1,
  [206395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(11901), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [206408] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11905), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [206419] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11907), 1,
      sym__layout_semicolon,
    ACTIONS(11909), 1,
      sym__layout_end,
    STATE(5757), 1,
      aux_sym___block_repeat2,
  [206432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11911), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(11913), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [206458] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11915), 1,
      sym__layout_semicolon,
    ACTIONS(11917), 1,
      sym__layout_end,
    STATE(5797), 1,
      aux_sym___block_repeat2,
  [206471] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11919), 1,
      sym__layout_semicolon,
    ACTIONS(11921), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206484] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(11923), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [206497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(11925), 1,
      anon_sym_RBRACK,
    STATE(5705), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206510] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11927), 1,
      sym_type_argument,
    ACTIONS(11929), 1,
      sym_kw_equals,
    STATE(5885), 1,
      aux_sym_type_constructor_repeat1,
  [206523] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(11931), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206536] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11933), 1,
      sym__layout_end,
    STATE(5715), 1,
      aux_sym___layout_block_repeat1,
  [206549] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11935), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206562] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11937), 1,
      sym__layout_end,
    STATE(5717), 1,
      aux_sym___layout_block_repeat1,
  [206575] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11939), 1,
      sym__layout_semicolon,
    ACTIONS(11941), 1,
      sym__layout_end,
    STATE(5815), 1,
      aux_sym___block_repeat2,
  [206588] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11943), 1,
      sym__layout_end,
    STATE(5672), 1,
      aux_sym___layout_block_repeat1,
  [206601] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11945), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206614] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11947), 1,
      sym__layout_semicolon,
    ACTIONS(11949), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206627] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11951), 1,
      sym__layout_semicolon,
    ACTIONS(11953), 1,
      sym__layout_end,
    STATE(5721), 1,
      aux_sym___block_repeat2,
  [206640] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11955), 1,
      sym__layout_semicolon,
    ACTIONS(11957), 1,
      sym__layout_end,
    STATE(5720), 1,
      aux_sym___block_repeat2,
  [206653] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11959), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206666] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11961), 1,
      sym__layout_end,
    STATE(5723), 1,
      aux_sym___layout_block_repeat1,
  [206679] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11963), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206692] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11965), 1,
      sym__layout_end,
    STATE(5744), 1,
      aux_sym___layout_block_repeat1,
  [206705] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11967), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206718] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11969), 1,
      sym__layout_semicolon,
    ACTIONS(11971), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206731] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11973), 1,
      sym__layout_semicolon,
    ACTIONS(11975), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206744] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11977), 1,
      sym__layout_semicolon,
    ACTIONS(11979), 1,
      sym__layout_end,
    STATE(5727), 1,
      aux_sym___block_repeat2,
  [206757] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11981), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206770] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11983), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [206783] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(11985), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206796] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(11987), 1,
      sym__layout_end,
    STATE(5760), 1,
      aux_sym_rewrite_block_repeat1,
  [206809] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11989), 1,
      sym__layout_semicolon,
    ACTIONS(11991), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [206822] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11993), 1,
      sym__layout_semicolon,
    ACTIONS(11995), 1,
      sym__layout_end,
    STATE(5763), 1,
      aux_sym___block_repeat2,
  [206835] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(11997), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [206848] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11999), 1,
      sym__layout_semicolon,
    ACTIONS(12001), 1,
      sym__layout_end,
    STATE(5692), 1,
      aux_sym___block_repeat2,
  [206861] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12003), 1,
      sym__layout_end,
    STATE(5803), 1,
      aux_sym___layout_block_repeat1,
  [206874] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12005), 1,
      sym__layout_end,
    STATE(5695), 1,
      aux_sym_rewrite_block_repeat1,
  [206887] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12007), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [206898] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12009), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [206911] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12013), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [206924] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12015), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [206935] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12017), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [206946] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9591), 1,
      sym__layout_end,
    ACTIONS(10747), 1,
      aux_sym_immediate_hash_token1,
    STATE(6537), 1,
      sym_imm_hash_qualifier,
  [206959] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12019), 1,
      sym__layout_end,
    STATE(5711), 1,
      aux_sym___layout_block_repeat1,
  [206972] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12021), 1,
      anon_sym_RBRACK,
    STATE(5749), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [206985] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 1,
      sym_rewrite_arrow,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4711), 1,
      sym_arrow_symbol,
  [206998] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12023), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207009] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12025), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207022] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12027), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12029), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207046] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12031), 1,
      sym__layout_end,
    STATE(5791), 1,
      aux_sym___layout_block_repeat1,
  [207059] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12033), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(12037), 1,
      anon_sym_RBRACK,
    STATE(5801), 1,
      aux_sym_literal_list_pattern_repeat1,
  [207083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12039), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207096] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12041), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207107] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12043), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207118] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12045), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207129] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12047), 1,
      sym__layout_end,
    STATE(5765), 1,
      aux_sym___layout_block_repeat1,
  [207142] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12049), 1,
      sym__layout_semicolon,
    ACTIONS(12051), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207155] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12053), 1,
      sym__layout_end,
    STATE(5771), 1,
      aux_sym_rewrite_block_repeat1,
  [207168] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12055), 1,
      sym__layout_semicolon,
    ACTIONS(12057), 1,
      sym__layout_end,
    STATE(5773), 1,
      aux_sym___block_repeat2,
  [207181] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12059), 1,
      sym__layout_semicolon,
    ACTIONS(12061), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207194] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12063), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [207207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12065), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207218] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12067), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [207231] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12069), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207242] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12071), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12073), 1,
      sym__layout_semicolon,
    ACTIONS(12075), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207266] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12077), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207277] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12079), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207290] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12081), 1,
      sym__layout_end,
    STATE(5779), 1,
      aux_sym___layout_block_repeat1,
  [207303] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12083), 1,
      sym__layout_semicolon,
    ACTIONS(12085), 1,
      sym__layout_end,
    STATE(5805), 1,
      aux_sym___block_repeat2,
  [207316] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12087), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207327] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12089), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [207340] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12091), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12093), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [207366] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12095), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207377] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12097), 1,
      sym__layout_semicolon,
    ACTIONS(12099), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207390] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12101), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [207403] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12103), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207414] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12105), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207425] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12107), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207436] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12109), 1,
      sym__layout_end,
    STATE(5787), 1,
      aux_sym___layout_block_repeat1,
  [207449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12111), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12113), 1,
      sym__layout_end,
    STATE(5789), 1,
      aux_sym___layout_block_repeat1,
  [207475] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12115), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207486] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12117), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207497] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12119), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [207510] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12121), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207521] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12123), 1,
      sym__layout_semicolon,
    ACTIONS(12125), 1,
      sym__layout_end,
    STATE(5793), 1,
      aux_sym___block_repeat2,
  [207534] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12127), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12129), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12131), 1,
      sym__layout_end,
    STATE(5795), 1,
      aux_sym___layout_block_repeat1,
  [207571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12133), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12135), 1,
      sym__layout_end,
    STATE(5809), 1,
      aux_sym___layout_block_repeat1,
  [207597] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12137), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207610] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12139), 1,
      sym__layout_semicolon,
    ACTIONS(12141), 1,
      sym__layout_end,
    STATE(5754), 1,
      aux_sym___block_repeat2,
  [207623] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12143), 1,
      sym__layout_semicolon,
    ACTIONS(12145), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207636] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12147), 1,
      sym__layout_semicolon,
    ACTIONS(12149), 1,
      sym__layout_end,
    STATE(5799), 1,
      aux_sym___block_repeat2,
  [207649] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12151), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207662] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12153), 1,
      sym__layout_end,
    STATE(5817), 1,
      aux_sym___layout_block_repeat1,
  [207675] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12155), 1,
      sym__layout_semicolon,
    ACTIONS(12157), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207688] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12159), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207699] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12161), 1,
      sym__layout_semicolon,
    ACTIONS(12163), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207712] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12165), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207723] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(12167), 1,
      anon_sym_RBRACK,
    STATE(6065), 1,
      aux_sym_literal_list_pattern_repeat1,
  [207736] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12169), 1,
      anon_sym_RBRACK,
    STATE(5743), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207749] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12171), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207762] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12173), 1,
      sym__layout_end,
    STATE(5818), 1,
      aux_sym__pattern_rhs_repeat1,
  [207775] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12175), 1,
      sym__layout_semicolon,
    ACTIONS(12177), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207788] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12179), 1,
      anon_sym_RBRACK,
    STATE(5841), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207801] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12181), 1,
      sym__layout_semicolon,
    ACTIONS(12183), 1,
      sym__layout_end,
    STATE(5832), 1,
      aux_sym___block_repeat2,
  [207814] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12185), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [207827] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12187), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207840] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12189), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207853] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12191), 1,
      sym__layout_end,
    STATE(5770), 1,
      aux_sym___layout_block_repeat1,
  [207866] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12193), 1,
      anon_sym_RBRACK,
    STATE(5821), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207879] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12195), 1,
      anon_sym_RBRACK,
    STATE(5956), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207892] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12197), 1,
      sym__layout_semicolon,
    ACTIONS(12199), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207905] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12201), 1,
      sym__layout_semicolon,
    ACTIONS(12203), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [207918] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12205), 1,
      sym__layout_end,
    STATE(5836), 1,
      aux_sym___layout_block_repeat1,
  [207931] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12207), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [207944] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12209), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [207957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12211), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207968] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12213), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [207979] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12215), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [207992] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12217), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208005] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12219), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208018] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12221), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208031] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12223), 1,
      sym__layout_end,
    STATE(5837), 1,
      aux_sym___layout_block_repeat1,
  [208044] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12225), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [208057] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12227), 1,
      sym__layout_end,
    STATE(5843), 1,
      aux_sym_rewrite_block_repeat1,
  [208070] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12229), 1,
      sym__layout_semicolon,
    ACTIONS(12231), 1,
      sym__layout_end,
    STATE(5845), 1,
      aux_sym___block_repeat2,
  [208083] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12233), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208096] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12235), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [208109] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12237), 1,
      sym__layout_semicolon,
    ACTIONS(12239), 1,
      sym__layout_end,
    STATE(5853), 1,
      aux_sym___block_repeat2,
  [208122] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12241), 1,
      sym__layout_semicolon,
    ACTIONS(12243), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208135] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12245), 1,
      sym__layout_semicolon,
    ACTIONS(12247), 1,
      sym__layout_end,
    STATE(5839), 1,
      aux_sym___block_repeat2,
  [208148] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(5677), 1,
      sym_record_field,
    STATE(7027), 1,
      sym_wordy_id,
  [208161] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12249), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208174] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12251), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208187] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12253), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208200] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12255), 1,
      sym__layout_end,
    STATE(5667), 1,
      aux_sym___layout_block_repeat1,
  [208213] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12257), 1,
      sym__layout_semicolon,
    ACTIONS(12259), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208226] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12261), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208239] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12263), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208252] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12265), 1,
      sym__layout_end,
    STATE(5877), 1,
      aux_sym___layout_block_repeat1,
  [208265] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12267), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [208278] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12269), 1,
      sym__layout_end,
    STATE(5880), 1,
      aux_sym_rewrite_block_repeat1,
  [208291] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12271), 1,
      sym__layout_semicolon,
    ACTIONS(12273), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208304] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12275), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [208317] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12277), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208330] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12279), 1,
      sym__layout_semicolon,
    ACTIONS(12281), 1,
      sym__layout_end,
    STATE(5881), 1,
      aux_sym___block_repeat2,
  [208343] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12283), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [208356] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12285), 1,
      sym__layout_end,
    STATE(5859), 1,
      aux_sym___layout_block_repeat1,
  [208369] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12287), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208382] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12289), 1,
      sym__layout_end,
    STATE(5861), 1,
      aux_sym___layout_block_repeat1,
  [208395] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12291), 1,
      sym__layout_semicolon,
    ACTIONS(12293), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208408] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12295), 1,
      sym__layout_end,
    STATE(5674), 1,
      aux_sym___layout_block_repeat1,
  [208421] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12297), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [208432] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12299), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208445] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12301), 1,
      sym__layout_semicolon,
    ACTIONS(12303), 1,
      sym__layout_end,
    STATE(5865), 1,
      aux_sym___block_repeat2,
  [208458] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [208467] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12305), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208480] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12307), 1,
      sym__layout_end,
    STATE(5867), 1,
      aux_sym___layout_block_repeat1,
  [208493] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12309), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208506] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12311), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [208519] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12313), 1,
      sym__layout_end,
    STATE(5810), 1,
      aux_sym___layout_block_repeat1,
  [208532] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12315), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208545] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12317), 1,
      sym__layout_semicolon,
    ACTIONS(12319), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208558] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12321), 1,
      sym__layout_semicolon,
    ACTIONS(12323), 1,
      sym__layout_end,
    STATE(5871), 1,
      aux_sym___block_repeat2,
  [208571] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12325), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208584] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12327), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208597] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7276), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [208606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7170), 3,
      sym__layout_semicolon,
      sym__layout_end,
      anon_sym_SEMI,
  [208615] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12329), 1,
      sym__layout_semicolon,
    ACTIONS(12331), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208628] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12333), 1,
      sym__layout_end,
    STATE(5824), 1,
      aux_sym___layout_block_repeat1,
  [208641] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12335), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208654] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12337), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208667] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12339), 1,
      anon_sym_RBRACK,
    STATE(5964), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208680] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12341), 1,
      sym__layout_end,
    STATE(5822), 1,
      aux_sym___layout_block_repeat1,
  [208693] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12343), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208706] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12345), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [208719] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12347), 1,
      sym__layout_end,
    STATE(5904), 1,
      aux_sym___layout_block_repeat1,
  [208732] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12349), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [208745] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12351), 1,
      sym__layout_semicolon,
    ACTIONS(12353), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208758] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12355), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [208771] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12357), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [208784] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12359), 1,
      anon_sym_RBRACK,
    STATE(5893), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208797] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12361), 1,
      sym_type_argument,
    ACTIONS(12363), 1,
      sym_kw_equals,
    STATE(6016), 1,
      aux_sym_type_constructor_repeat1,
  [208810] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12367), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208823] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12369), 1,
      sym__layout_end,
    STATE(5862), 1,
      aux_sym__pattern_rhs_repeat1,
  [208836] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12371), 1,
      sym__layout_end,
    STATE(5886), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208849] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12373), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [208862] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12375), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [208875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7272), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [208884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12377), 1,
      sym__layout_end,
    STATE(5914), 1,
      aux_sym___layout_block_repeat1,
  [208897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12379), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [208910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12381), 1,
      sym__layout_end,
    STATE(5874), 1,
      aux_sym___layout_block_repeat1,
  [208923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7240), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [208932] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7236), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [208941] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12383), 1,
      sym__layout_end,
    STATE(5909), 1,
      aux_sym___layout_block_repeat1,
  [208954] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12385), 1,
      sym__layout_semicolon,
    ACTIONS(12387), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [208967] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12389), 1,
      sym__layout_end,
    STATE(5915), 1,
      aux_sym_rewrite_block_repeat1,
  [208980] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12391), 1,
      sym__layout_semicolon,
    ACTIONS(12393), 1,
      sym__layout_end,
    STATE(5917), 1,
      aux_sym___block_repeat2,
  [208993] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12395), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [209006] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12397), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [209019] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12399), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209032] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12401), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209045] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12403), 1,
      sym__layout_end,
    STATE(5920), 1,
      aux_sym___layout_block_repeat1,
  [209058] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12405), 1,
      sym__layout_semicolon,
    ACTIONS(12407), 1,
      sym__layout_end,
    STATE(5814), 1,
      aux_sym___block_repeat2,
  [209071] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12409), 1,
      sym__layout_end,
    STATE(5878), 1,
      aux_sym___layout_block_repeat1,
  [209084] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12411), 1,
      sym__layout_semicolon,
    ACTIONS(12413), 1,
      sym__layout_end,
    STATE(5930), 1,
      aux_sym___block_repeat2,
  [209097] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12415), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209110] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12417), 1,
      sym__layout_end,
    STATE(5923), 1,
      aux_sym___layout_block_repeat1,
  [209123] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12419), 1,
      sym__layout_end,
    STATE(5826), 1,
      aux_sym_rewrite_block_repeat1,
  [209136] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12421), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [209149] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12423), 1,
      sym__layout_end,
    STATE(5864), 1,
      aux_sym___layout_block_repeat1,
  [209162] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12425), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209175] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12427), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [209188] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12429), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209201] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12431), 1,
      sym__layout_semicolon,
    ACTIONS(12433), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209214] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12435), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [209227] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12437), 1,
      sym__layout_end,
    STATE(5942), 1,
      aux_sym___layout_block_repeat1,
  [209240] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12439), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209253] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12441), 1,
      sym__layout_end,
    STATE(5916), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209266] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12443), 1,
      sym__layout_end,
    STATE(5931), 1,
      aux_sym___layout_block_repeat1,
  [209279] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12445), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209292] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12447), 1,
      sym__layout_end,
    STATE(5933), 1,
      aux_sym___layout_block_repeat1,
  [209305] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12449), 1,
      sym__layout_end,
    STATE(5868), 1,
      aux_sym___layout_block_repeat1,
  [209318] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12451), 1,
      anon_sym_RBRACK,
    STATE(5949), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209331] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12453), 1,
      sym__layout_semicolon,
    ACTIONS(12455), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209344] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7224), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [209353] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12457), 1,
      sym__layout_semicolon,
    ACTIONS(12459), 1,
      sym__layout_end,
    STATE(5937), 1,
      aux_sym___block_repeat2,
  [209366] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12461), 1,
      sym__layout_semicolon,
    ACTIONS(12463), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209379] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12465), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209392] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12467), 1,
      sym__layout_end,
    STATE(5939), 1,
      aux_sym___layout_block_repeat1,
  [209405] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12469), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209418] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12471), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [209431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7212), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [209440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7180), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [209449] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12473), 1,
      sym__layout_semicolon,
    ACTIONS(12475), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209462] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12477), 1,
      sym__layout_semicolon,
    ACTIONS(12479), 1,
      sym__layout_end,
    STATE(5943), 1,
      aux_sym___block_repeat2,
  [209475] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12481), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209488] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12483), 1,
      sym__layout_semicolon,
    ACTIONS(12485), 1,
      sym__layout_end,
    STATE(5951), 1,
      aux_sym___block_repeat2,
  [209501] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12487), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [209514] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12489), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209527] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12491), 1,
      sym__layout_semicolon,
    ACTIONS(12493), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209540] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12495), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209553] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12497), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209566] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12499), 1,
      sym__layout_semicolon,
    ACTIONS(12501), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209579] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12503), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209592] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12505), 1,
      sym__layout_end,
    STATE(5944), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209605] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12507), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209618] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12509), 1,
      sym__layout_end,
    STATE(5970), 1,
      aux_sym___layout_block_repeat1,
  [209631] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12511), 1,
      sym__layout_semicolon,
    ACTIONS(12513), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209644] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12515), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [209657] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12517), 1,
      sym__layout_end,
    STATE(5989), 1,
      aux_sym_rewrite_block_repeat1,
  [209670] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12519), 1,
      sym__layout_end,
    STATE(6069), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209683] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12521), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [209696] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12523), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209709] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12525), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209722] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12527), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209735] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12529), 1,
      sym__layout_semicolon,
    ACTIONS(12531), 1,
      sym__layout_end,
    STATE(6076), 1,
      aux_sym___block_repeat2,
  [209748] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12533), 1,
      sym__layout_end,
    STATE(6088), 1,
      aux_sym___layout_block_repeat1,
  [209761] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12535), 1,
      sym__layout_semicolon,
    ACTIONS(12538), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [209774] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12540), 1,
      sym__layout_end,
    STATE(5957), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209787] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12542), 1,
      sym__layout_semicolon,
    ACTIONS(12544), 1,
      sym__layout_end,
    STATE(5976), 1,
      aux_sym___block_repeat2,
  [209800] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12546), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209813] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12548), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [209826] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12550), 1,
      sym__layout_end,
    STATE(5903), 1,
      aux_sym___layout_block_repeat1,
  [209839] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12552), 1,
      anon_sym_RBRACK,
    STATE(5945), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209852] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12554), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [209865] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6394), 1,
      sym_with,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4663), 1,
      sym_arrow_symbol,
  [209878] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12556), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209891] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12558), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209904] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12560), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [209917] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12562), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [209930] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12564), 1,
      sym__layout_end,
    STATE(6002), 1,
      aux_sym___layout_block_repeat1,
  [209943] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12566), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [209956] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12568), 1,
      sym__layout_semicolon,
    ACTIONS(12570), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [209969] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12572), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [209982] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12574), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [209995] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12576), 1,
      anon_sym_COMMA,
    ACTIONS(12579), 1,
      anon_sym_RBRACE,
    STATE(5979), 1,
      aux_sym__effect_block_repeat1,
  [210008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12581), 1,
      sym__layout_semicolon,
    ACTIONS(12583), 1,
      sym__layout_end,
    STATE(5898), 1,
      aux_sym___block_repeat2,
  [210021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(6399), 1,
      sym_record_field,
    STATE(6527), 1,
      sym_wordy_id,
  [210034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12585), 1,
      sym__layout_semicolon,
    ACTIONS(12588), 1,
      sym__layout_end,
    STATE(5982), 1,
      aux_sym__record_fields_block_repeat1,
  [210047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12590), 1,
      sym__layout_semicolon,
    ACTIONS(12592), 1,
      sym__layout_end,
    STATE(5987), 1,
      aux_sym___block_repeat2,
  [210060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(12594), 1,
      anon_sym_RBRACK,
    STATE(6024), 1,
      aux_sym_literal_list_pattern_repeat1,
  [210073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12596), 1,
      sym__layout_end,
    STATE(6131), 1,
      aux_sym_rewrite_block_repeat1,
  [210086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12598), 1,
      sym__layout_end,
    STATE(5978), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12600), 1,
      sym__layout_semicolon,
    ACTIONS(12602), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12604), 1,
      sym__layout_semicolon,
    ACTIONS(12606), 1,
      sym__layout_end,
    STATE(5992), 1,
      aux_sym___block_repeat2,
  [210125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12608), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [210138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12610), 1,
      sym__layout_semicolon,
    ACTIONS(12612), 1,
      sym__layout_end,
    STATE(5991), 1,
      aux_sym__ebody_repeat2,
  [210151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12614), 1,
      sym__layout_semicolon,
    ACTIONS(12617), 1,
      sym__layout_end,
    STATE(5991), 1,
      aux_sym__ebody_repeat2,
  [210164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12619), 1,
      sym__layout_semicolon,
    ACTIONS(12621), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12623), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [210190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12625), 1,
      sym__layout_end,
    STATE(5901), 1,
      aux_sym_rewrite_block_repeat1,
  [210203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12627), 1,
      sym__layout_end,
    STATE(5947), 1,
      aux_sym___layout_block_repeat1,
  [210216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12629), 1,
      sym__layout_semicolon,
    ACTIONS(12631), 1,
      sym__layout_end,
    STATE(5946), 1,
      aux_sym___block_repeat2,
  [210229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12633), 1,
      sym__layout_semicolon,
    ACTIONS(12635), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12637), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [210255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12639), 1,
      sym__layout_end,
    STATE(6105), 1,
      aux_sym___layout_block_repeat1,
  [210268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12641), 1,
      sym__layout_end,
    STATE(5952), 1,
      aux_sym_rewrite_block_repeat1,
  [210281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12643), 1,
      sym__layout_end,
    STATE(6040), 1,
      aux_sym___layout_block_repeat1,
  [210294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12645), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [210307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12647), 1,
      anon_sym_use,
    STATE(5498), 1,
      sym_use,
    STATE(7048), 1,
      sym_use_clause,
  [210320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12649), 1,
      sym__layout_semicolon,
    ACTIONS(12651), 1,
      sym__layout_end,
    STATE(5927), 1,
      aux_sym___block_repeat2,
  [210333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12653), 1,
      sym__layout_end,
    STATE(5783), 1,
      aux_sym_rewrite_block_repeat1,
  [210346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12655), 1,
      sym__layout_semicolon,
    ACTIONS(12657), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210359] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7148), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [210368] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12659), 1,
      sym__layout_semicolon,
    ACTIONS(12661), 1,
      sym__layout_end,
    STATE(6018), 1,
      aux_sym___block_repeat2,
  [210381] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12663), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210394] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12665), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [210407] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12667), 1,
      sym__layout_semicolon,
    ACTIONS(12669), 1,
      sym__layout_end,
    STATE(6139), 1,
      aux_sym___block_repeat2,
  [210420] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12671), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [210433] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12673), 1,
      sym__layout_end,
    STATE(6042), 1,
      aux_sym___layout_block_repeat1,
  [210446] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12675), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7140), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [210468] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12677), 1,
      sym_type_argument,
    ACTIONS(12680), 1,
      sym_kw_equals,
    STATE(6016), 1,
      aux_sym_type_constructor_repeat1,
  [210481] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12682), 1,
      sym__layout_end,
    STATE(5971), 1,
      aux_sym___layout_block_repeat1,
  [210494] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12684), 1,
      sym__layout_semicolon,
    ACTIONS(12686), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210507] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12688), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [210520] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(6224), 1,
      sym_constructor,
    STATE(7002), 1,
      sym_wordy_id,
  [210533] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12690), 1,
      sym__layout_end,
    STATE(6014), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210546] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12692), 1,
      sym__layout_semicolon,
    ACTIONS(12694), 1,
      sym__layout_end,
    STATE(6204), 1,
      aux_sym___block_repeat2,
  [210559] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12696), 1,
      sym__layout_semicolon,
    ACTIONS(12698), 1,
      sym__layout_end,
    STATE(6027), 1,
      aux_sym___block_repeat2,
  [210572] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(12700), 1,
      anon_sym_RBRACK,
    STATE(6065), 1,
      aux_sym_literal_list_pattern_repeat1,
  [210585] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12702), 1,
      sym__layout_end,
    STATE(6044), 1,
      aux_sym__pattern_rhs_repeat1,
  [210598] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12704), 1,
      anon_sym_COMMA,
    ACTIONS(12707), 1,
      sym__layout_end,
    STATE(6026), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [210611] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12709), 1,
      sym__layout_semicolon,
    ACTIONS(12711), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210624] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12713), 1,
      sym__layout_semicolon,
    ACTIONS(12715), 1,
      sym__layout_end,
    STATE(6032), 1,
      aux_sym___block_repeat2,
  [210637] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12717), 1,
      anon_sym_RBRACK,
    STATE(6061), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210650] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12719), 1,
      sym__layout_semicolon,
    ACTIONS(12721), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210663] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12723), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210676] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12725), 1,
      sym__layout_semicolon,
    ACTIONS(12727), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210689] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12729), 1,
      sym__layout_semicolon,
    ACTIONS(12731), 1,
      sym__layout_end,
    STATE(6047), 1,
      aux_sym___block_repeat2,
  [210702] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12733), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [210715] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12735), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [210728] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12737), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [210741] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12739), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210754] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11588), 1,
      anon_sym_RBRACE,
    ACTIONS(12741), 1,
      anon_sym_COMMA,
    STATE(6165), 1,
      aux_sym__record_fields_inline_repeat1,
  [210767] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12743), 1,
      sym__layout_end,
    STATE(6037), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210780] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12745), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [210793] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12747), 1,
      sym__layout_end,
    STATE(6052), 1,
      aux_sym___layout_block_repeat1,
  [210806] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12749), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [210819] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12751), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [210832] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12753), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [210845] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12755), 1,
      sym__layout_semicolon,
    ACTIONS(12757), 1,
      sym__layout_end,
    STATE(6030), 1,
      aux_sym___block_repeat2,
  [210858] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12759), 1,
      sym__layout_semicolon,
    ACTIONS(12761), 1,
      sym__layout_end,
    STATE(6054), 1,
      aux_sym___block_repeat2,
  [210871] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12763), 1,
      sym__layout_semicolon,
    ACTIONS(12765), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210884] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12767), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [210897] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12769), 1,
      anon_sym_RBRACK,
    STATE(6031), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210910] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12771), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [210923] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12773), 1,
      sym__layout_semicolon,
    ACTIONS(12775), 1,
      sym__layout_end,
    STATE(6057), 1,
      aux_sym___block_repeat2,
  [210936] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12777), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [210949] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12779), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [210962] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12781), 1,
      sym__layout_semicolon,
    ACTIONS(12783), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [210975] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12785), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [210988] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12787), 1,
      sym__layout_semicolon,
    ACTIONS(12789), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211001] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12791), 1,
      sym__layout_semicolon,
    ACTIONS(12793), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211014] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12795), 1,
      sym__layout_semicolon,
    ACTIONS(12797), 1,
      sym__layout_end,
    STATE(6062), 1,
      aux_sym___block_repeat2,
  [211027] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12799), 1,
      sym__layout_end,
    STATE(6053), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211040] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9597), 1,
      sym__layout_end,
    ACTIONS(10747), 1,
      aux_sym_immediate_hash_token1,
    STATE(6616), 1,
      sym_imm_hash_qualifier,
  [211053] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12801), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211066] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12803), 1,
      sym__layout_semicolon,
    ACTIONS(12805), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211079] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12807), 1,
      sym__layout_semicolon,
    ACTIONS(12809), 1,
      sym__layout_end,
    STATE(6067), 1,
      aux_sym___block_repeat2,
  [211092] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12811), 1,
      sym__layout_semicolon,
    ACTIONS(12813), 1,
      sym__layout_end,
    STATE(5997), 1,
      aux_sym___block_repeat2,
  [211105] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12815), 1,
      anon_sym_COMMA,
    ACTIONS(12818), 1,
      anon_sym_RBRACK,
    STATE(6065), 1,
      aux_sym_literal_list_pattern_repeat1,
  [211118] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12820), 1,
      sym__layout_end,
    STATE(6034), 1,
      aux_sym___layout_block_repeat1,
  [211131] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12822), 1,
      sym__layout_semicolon,
    ACTIONS(12824), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211144] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12826), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211157] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12828), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211170] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12830), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [211183] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12832), 1,
      anon_sym_COMMA,
    ACTIONS(12835), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211196] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12837), 1,
      sym__layout_end,
    STATE(6100), 1,
      aux_sym___layout_block_repeat1,
  [211209] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12839), 1,
      anon_sym_RBRACK,
    STATE(6009), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5739), 3,
      sym_type_argument,
      anon_sym_COLON,
      sym_kw_equals,
  [211231] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12841), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211244] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12843), 1,
      sym__layout_semicolon,
    ACTIONS(12845), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211257] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12847), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211270] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12849), 1,
      sym__layout_end,
    STATE(6118), 1,
      aux_sym_rewrite_block_repeat1,
  [211283] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12851), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [211296] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12853), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211309] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12855), 1,
      sym__layout_semicolon,
    ACTIONS(12857), 1,
      sym__layout_end,
    STATE(6130), 1,
      aux_sym___block_repeat2,
  [211322] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12859), 1,
      sym__layout_end,
    STATE(5958), 1,
      aux_sym___layout_block_repeat1,
  [211335] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12861), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [211348] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12863), 1,
      sym__layout_end,
    STATE(6075), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211361] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12865), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [211374] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7114), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [211383] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12647), 1,
      anon_sym_use,
    STATE(4667), 1,
      sym_use_clause,
    STATE(5434), 1,
      sym_use,
  [211396] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12867), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211409] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12869), 1,
      sym__layout_end,
    STATE(6207), 1,
      aux_sym___layout_block_repeat1,
  [211422] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12871), 1,
      sym__layout_semicolon,
    ACTIONS(12873), 1,
      sym__layout_end,
    STATE(6056), 1,
      aux_sym___block_repeat2,
  [211435] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12875), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [211448] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12877), 1,
      sym__layout_end,
    STATE(6111), 1,
      aux_sym___layout_block_repeat1,
  [211461] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12879), 1,
      sym__layout_semicolon,
    ACTIONS(12881), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211474] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11408), 1,
      anon_sym_COMMA,
    ACTIONS(12883), 1,
      anon_sym_RBRACE,
    STATE(5979), 1,
      aux_sym__effect_block_repeat1,
  [211487] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12885), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [211500] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12887), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211513] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7490), 3,
      sym__layout_end,
      anon_sym_COMMA,
      sym_with,
  [211522] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12889), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [211535] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12891), 1,
      sym__layout_end,
    STATE(6080), 1,
      aux_sym___layout_block_repeat1,
  [211548] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12893), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211561] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12895), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211574] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12897), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [211587] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12899), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211600] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12901), 1,
      sym__layout_end,
    STATE(6103), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211613] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12903), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211626] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11706), 1,
      anon_sym_RBRACE,
    ACTIONS(12905), 1,
      anon_sym_COMMA,
    STATE(6106), 1,
      aux_sym__record_fields_inline_repeat1,
  [211639] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12908), 1,
      sym__layout_end,
    STATE(6173), 1,
      aux_sym___layout_block_repeat1,
  [211652] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7486), 3,
      sym__layout_end,
      anon_sym_COMMA,
      sym_with,
  [211661] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12910), 1,
      sym__layout_end,
    STATE(6145), 1,
      aux_sym___layout_block_repeat1,
  [211674] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12835), 1,
      sym__layout_end,
    ACTIONS(12912), 1,
      anon_sym_COMMA,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211687] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12915), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211700] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12917), 1,
      sym__layout_end,
    STATE(5735), 1,
      aux_sym__pattern_rhs_repeat1,
  [211713] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12919), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [211726] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12921), 1,
      sym__layout_semicolon,
    ACTIONS(12923), 1,
      sym__layout_end,
    STATE(6093), 1,
      aux_sym___block_repeat2,
  [211739] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12925), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [211752] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12927), 1,
      sym__layout_semicolon,
    ACTIONS(12929), 1,
      sym__layout_end,
    STATE(5982), 1,
      aux_sym__record_fields_block_repeat1,
  [211765] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12931), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [211778] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12933), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [211791] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(12937), 1,
      sym__layout_end,
    STATE(6219), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [211804] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12939), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211817] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12941), 1,
      sym__layout_end,
    STATE(6120), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211830] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(12943), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211843] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(12945), 1,
      sym__layout_end,
    STATE(6095), 1,
      aux_sym__pattern_rhs_repeat1,
  [211856] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12947), 1,
      sym__layout_end,
    STATE(6151), 1,
      aux_sym___layout_block_repeat1,
  [211869] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12949), 1,
      sym__layout_semicolon,
    ACTIONS(12951), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211882] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12953), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [211895] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12955), 1,
      sym__layout_end,
    STATE(6096), 1,
      aux_sym___layout_block_repeat1,
  [211908] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12957), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [211921] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12959), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [211934] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12961), 1,
      sym__layout_semicolon,
    ACTIONS(12963), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [211947] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12965), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [211960] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(12967), 1,
      sym__layout_end,
    STATE(6158), 1,
      aux_sym_rewrite_block_repeat1,
  [211973] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12969), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [211986] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12971), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [211999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7090), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [212008] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12973), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212021] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12975), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [212034] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12977), 1,
      sym__layout_end,
    STATE(6101), 1,
      aux_sym___layout_block_repeat1,
  [212047] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12979), 1,
      sym__layout_semicolon,
    ACTIONS(12981), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212060] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12983), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212073] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(12985), 1,
      sym__layout_end,
    STATE(6133), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212086] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12987), 1,
      sym__layout_semicolon,
    ACTIONS(12989), 1,
      sym__layout_end,
    STATE(6159), 1,
      aux_sym___block_repeat2,
  [212099] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(12991), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212112] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(12993), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [212125] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(12995), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212138] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11578), 1,
      anon_sym_RPAREN,
    ACTIONS(12997), 1,
      anon_sym_COMMA,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212151] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(13000), 1,
      anon_sym_RBRACK,
    STATE(6214), 1,
      aux_sym_literal_list_pattern_repeat1,
  [212164] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(5040), 1,
      sym_constructor,
    STATE(6548), 1,
      sym_wordy_id,
  [212177] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13002), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [212190] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(6183), 1,
      sym_constructor,
    STATE(7002), 1,
      sym_wordy_id,
  [212203] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13004), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212216] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13006), 1,
      sym__layout_end,
    STATE(6169), 1,
      aux_sym___layout_block_repeat1,
  [212229] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13008), 1,
      sym__layout_semicolon,
    ACTIONS(13010), 1,
      sym__layout_end,
    STATE(6125), 1,
      aux_sym___block_repeat2,
  [212242] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13012), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212255] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(13014), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212268] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13016), 1,
      sym__layout_end,
    STATE(6154), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212281] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13018), 1,
      sym__layout_end,
    STATE(6068), 1,
      aux_sym___layout_block_repeat1,
  [212294] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(13020), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [212307] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13022), 1,
      sym__layout_semicolon,
    ACTIONS(13024), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212320] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13026), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [212333] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(13028), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212346] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12927), 1,
      sym__layout_semicolon,
    ACTIONS(13030), 1,
      sym__layout_end,
    STATE(6116), 1,
      aux_sym__record_fields_block_repeat1,
  [212359] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(13032), 1,
      sym_symboly_id,
    STATE(6405), 1,
      sym__symboly_definition_name,
  [212372] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13034), 1,
      sym__layout_end,
    STATE(6218), 1,
      aux_sym___layout_block_repeat1,
  [212385] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11414), 1,
      anon_sym_RBRACE,
    ACTIONS(13036), 1,
      anon_sym_COMMA,
    STATE(6106), 1,
      aux_sym__record_fields_inline_repeat1,
  [212398] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(13038), 1,
      sym__layout_end,
    STATE(6026), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [212411] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13040), 1,
      sym__layout_end,
    STATE(6179), 1,
      aux_sym___layout_block_repeat1,
  [212424] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13042), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [212437] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13044), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212450] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(13046), 1,
      sym__layout_end,
    STATE(6166), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [212463] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13048), 1,
      sym__layout_end,
    STATE(6186), 1,
      aux_sym___layout_block_repeat1,
  [212476] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13050), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212489] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13052), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212502] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(13054), 1,
      sym__layout_end,
    STATE(6192), 1,
      aux_sym__pattern_rhs_repeat1,
  [212515] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13056), 1,
      sym__layout_end,
    STATE(6172), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212528] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13058), 1,
      sym__layout_end,
    STATE(6227), 1,
      aux_sym___layout_block_repeat1,
  [212541] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(13060), 1,
      sym_symboly_id,
    STATE(6262), 1,
      sym__symboly_definition_name,
  [212554] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13062), 1,
      sym__layout_semicolon,
    ACTIONS(13064), 1,
      sym__layout_end,
    STATE(6193), 1,
      aux_sym___block_repeat2,
  [212567] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13066), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212580] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(13068), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212593] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13070), 1,
      sym__layout_semicolon,
    ACTIONS(13072), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212606] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13074), 1,
      sym__layout_end,
    STATE(6199), 1,
      aux_sym___layout_block_repeat1,
  [212619] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12610), 1,
      sym__layout_semicolon,
    ACTIONS(13076), 1,
      sym__layout_end,
    STATE(5990), 1,
      aux_sym__ebody_repeat2,
  [212632] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      sym_with,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4690), 1,
      sym_type_signature_colon,
  [212645] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6720), 1,
      sym_rewrite_arrow,
    ACTIONS(11378), 1,
      anon_sym_COLON,
    STATE(4717), 1,
      sym_type_signature_colon,
  [212658] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13078), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212671] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(13080), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [212684] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13082), 1,
      sym__layout_semicolon,
    ACTIONS(13084), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212697] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13086), 1,
      sym__layout_end,
    STATE(6134), 1,
      aux_sym___layout_block_repeat1,
  [212710] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13088), 1,
      sym__layout_start,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [212721] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13090), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212734] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(13092), 1,
      sym__layout_end,
    STATE(5961), 1,
      aux_sym__pattern_rhs_repeat1,
  [212747] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13094), 1,
      sym__layout_semicolon,
    ACTIONS(13096), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212760] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13098), 1,
      sym__layout_end,
    STATE(6201), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212773] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10858), 1,
      sym_path,
    ACTIONS(13100), 1,
      sym_symboly_id,
    STATE(6477), 1,
      sym__symboly_definition_name,
  [212786] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13102), 1,
      sym__layout_semicolon,
    ACTIONS(13104), 1,
      sym__layout_end,
    STATE(6200), 1,
      aux_sym___block_repeat2,
  [212799] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12610), 1,
      sym__layout_semicolon,
    ACTIONS(13076), 1,
      sym__layout_end,
    STATE(5991), 1,
      aux_sym__ebody_repeat2,
  [212812] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13106), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [212825] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13108), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212838] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13110), 1,
      sym__layout_semicolon,
    ACTIONS(13112), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212851] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12365), 1,
      anon_sym_COMMA,
    ACTIONS(13114), 1,
      sym__layout_end,
    STATE(6110), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [212864] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11313), 1,
      aux_sym_wordy_id_token1,
    STATE(6508), 1,
      sym_constructor,
    STATE(7002), 1,
      sym_wordy_id,
  [212877] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11328), 1,
      anon_sym_COMMA,
    ACTIONS(13116), 1,
      anon_sym_RPAREN,
    STATE(6146), 1,
      aux_sym_tuple_or_parenthesized_type_repeat1,
  [212890] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13118), 1,
      sym__layout_semicolon,
    ACTIONS(13120), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212903] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13122), 1,
      sym__layout_semicolon,
    ACTIONS(13124), 1,
      sym__layout_end,
    STATE(6006), 1,
      aux_sym___block_repeat2,
  [212916] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13126), 1,
      sym__layout_end,
    STATE(5975), 1,
      aux_sym___layout_block_repeat1,
  [212929] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13128), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [212942] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13130), 1,
      sym__layout_semicolon,
    ACTIONS(13132), 1,
      sym__layout_end,
    STATE(6188), 1,
      aux_sym___block_repeat2,
  [212955] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(13134), 1,
      sym__layout_end,
    STATE(6217), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [212968] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13136), 1,
      sym__layout_semicolon,
    ACTIONS(13139), 1,
      sym__layout_end,
    STATE(6210), 1,
      aux_sym___block_repeat2,
  [212981] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13141), 1,
      sym__layout_end,
    STATE(4708), 1,
      sym_arrow_symbol,
  [212994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7118), 3,
      anon_sym_then,
      anon_sym_else,
      sym_with,
  [213003] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13143), 1,
      sym__layout_end,
    STATE(6077), 1,
      aux_sym___layout_block_repeat1,
  [213016] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12035), 1,
      anon_sym_COMMA,
    ACTIONS(13145), 1,
      anon_sym_RBRACK,
    STATE(6065), 1,
      aux_sym_literal_list_pattern_repeat1,
  [213029] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12011), 1,
      sym__layout_semicolon,
    ACTIONS(13147), 1,
      sym__layout_end,
    STATE(6043), 1,
      aux_sym__pattern_rhs_repeat1,
  [213042] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(13149), 1,
      anon_sym_RBRACK,
    STATE(6221), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [213055] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(13151), 1,
      sym__layout_end,
    STATE(6026), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [213068] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13153), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [213081] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12935), 1,
      anon_sym_COMMA,
    ACTIONS(13155), 1,
      sym__layout_end,
    STATE(6026), 1,
      aux_sym_parenthesized_or_tuple_pattern_repeat1,
  [213094] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13157), 1,
      sym__layout_semicolon,
    ACTIONS(13160), 1,
      sym__layout_end,
    STATE(6220), 1,
      aux_sym_rewrite_block_repeat1,
  [213107] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11845), 1,
      anon_sym_COMMA,
    ACTIONS(13162), 1,
      anon_sym_RBRACK,
    STATE(6071), 1,
      aux_sym_tuple_or_parenthesized_repeat1,
  [213120] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13164), 1,
      sym__layout_end,
    STATE(6191), 1,
      aux_sym___layout_block_repeat1,
  [213133] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13166), 1,
      sym__layout_end,
    STATE(6136), 1,
      aux_sym___layout_block_repeat1,
  [213146] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12610), 1,
      sym__layout_semicolon,
    ACTIONS(13168), 1,
      sym__layout_end,
    STATE(6197), 1,
      aux_sym__ebody_repeat2,
  [213159] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13170), 1,
      sym__layout_semicolon,
    ACTIONS(13172), 1,
      sym__layout_end,
    STATE(6181), 1,
      aux_sym___block_repeat2,
  [213172] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11875), 1,
      sym__layout_semicolon,
    ACTIONS(13174), 1,
      sym__layout_end,
    STATE(6187), 1,
      aux_sym_rewrite_block_repeat1,
  [213185] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11841), 1,
      sym__layout_semicolon,
    ACTIONS(13176), 1,
      sym__layout_end,
    STATE(5567), 1,
      aux_sym___layout_block_repeat1,
  [213198] = 4,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    ACTIONS(13178), 1,
      anon_sym_RBRACK,
    STATE(4676), 1,
      sym_arrow_symbol,
  [213211] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4679), 1,
      sym_arrow_symbol,
  [213221] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13180), 1,
      sym__layout_semicolon,
    STATE(6507), 1,
      aux_sym___block_repeat1,
  [213231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11903), 2,
      sym_symboly_id,
      sym_path,
  [213239] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13182), 1,
      sym_type_kw,
    ACTIONS(13184), 1,
      sym_ability,
  [213249] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13186), 1,
      sym_imm_wordy_id,
    ACTIONS(13188), 1,
      sym_symboly_id,
  [213259] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7079), 1,
      sym_kw_then,
  [213269] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7077), 1,
      sym_kw_then,
  [213279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7075), 1,
      sym_kw_then,
  [213289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7073), 1,
      sym_kw_then,
  [213299] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7071), 1,
      sym_kw_then,
  [213309] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13160), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213317] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13192), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213327] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7069), 1,
      sym_kw_then,
  [213337] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13194), 1,
      sym_imm_wordy_id,
  [213347] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13196), 1,
      sym__layout_semicolon,
    STATE(6240), 1,
      aux_sym___block_repeat1,
  [213357] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7067), 1,
      sym_kw_then,
  [213367] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7065), 1,
      sym_kw_then,
  [213377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7063), 1,
      sym_kw_then,
  [213387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7061), 1,
      sym_kw_then,
  [213397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7059), 1,
      sym_kw_then,
  [213407] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7057), 1,
      sym_kw_then,
  [213417] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4711), 1,
      sym_arrow_symbol,
  [213427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7055), 1,
      sym_kw_then,
  [213437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7053), 1,
      sym_kw_then,
  [213447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13198), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213455] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(7051), 1,
      sym_kw_then,
  [213465] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(5804), 1,
      sym_guarded_block,
  [213475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13202), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213483] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4680), 1,
      sym_arrow_symbol,
  [213493] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13204), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13207), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(10671), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213519] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13209), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13211), 1,
      anon_sym_RPAREN,
    STATE(5626), 1,
      sym_close_parens,
  [213537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13213), 1,
      sym_imm_wordy_id,
  [213547] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5909), 2,
      sym_type_argument,
      sym_kw_equals,
  [213555] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13215), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213563] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4708), 1,
      sym_arrow_symbol,
  [213573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13217), 2,
      sym_type_argument,
      sym_kw_equals,
  [213581] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13219), 1,
      sym_imm_wordy_id,
    ACTIONS(13221), 1,
      sym_symboly_id,
  [213591] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213599] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4663), 1,
      sym_arrow_symbol,
  [213609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13225), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213617] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13227), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213627] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13229), 1,
      sym__layout_semicolon,
    STATE(6272), 1,
      aux_sym___block_repeat1,
  [213637] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13231), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213647] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13225), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213655] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13233), 1,
      sym__layout_semicolon,
    STATE(6274), 1,
      aux_sym___block_repeat1,
  [213665] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13235), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4664), 1,
      sym_arrow_symbol,
  [213685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13237), 1,
      sym__layout_semicolon,
    STATE(6277), 1,
      aux_sym___block_repeat1,
  [213695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13239), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213703] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13241), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13243), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213719] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6693), 1,
      sym_kw_else,
  [213729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13247), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13249), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13251), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13253), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213763] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13255), 1,
      sym__layout_semicolon,
    STATE(6286), 1,
      aux_sym___block_repeat1,
  [213773] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13257), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213781] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13259), 1,
      sym_with,
    ACTIONS(13261), 1,
      sym__layout_end,
  [213791] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6025), 1,
      sym_guarded_block,
  [213801] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6664), 1,
      sym_kw_else,
  [213811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13263), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13265), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213827] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13267), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13269), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213843] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13271), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213853] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13273), 1,
      sym__layout_semicolon,
    STATE(6297), 1,
      aux_sym___block_repeat1,
  [213863] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13275), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213871] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13277), 1,
      sym__layout_semicolon,
    STATE(6302), 1,
      aux_sym___block_repeat1,
  [213881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13279), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213889] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13281), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213899] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13283), 1,
      sym_with,
    ACTIONS(13285), 1,
      sym__layout_end,
  [213909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13287), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13289), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213925] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13291), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [213933] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6635), 1,
      sym_kw_else,
  [213943] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13293), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [213953] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13295), 1,
      sym__layout_semicolon,
    STATE(6308), 1,
      aux_sym___block_repeat1,
  [213963] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13297), 1,
      sym_with,
    ACTIONS(13299), 1,
      sym__layout_end,
  [213973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13239), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [213981] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6606), 1,
      sym_kw_else,
  [213991] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13301), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214001] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13303), 1,
      sym__layout_semicolon,
    STATE(6313), 1,
      aux_sym___block_repeat1,
  [214011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13305), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214019] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13307), 1,
      sym_with,
    ACTIONS(13309), 1,
      sym__layout_end,
  [214029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13311), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214037] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13313), 1,
      sym_imm_wordy_id,
  [214047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13315), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214055] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6583), 1,
      sym_kw_else,
  [214065] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13317), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13319), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2291), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214091] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13321), 1,
      sym__layout_semicolon,
    STATE(6321), 1,
      aux_sym___block_repeat1,
  [214101] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13323), 1,
      sym_with,
    ACTIONS(13325), 1,
      sym__layout_end,
  [214111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13327), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13329), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214127] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6561), 1,
      sym_kw_else,
  [214137] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6174), 1,
      sym_guarded_block,
  [214147] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13331), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214157] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13333), 1,
      sym__layout_semicolon,
    STATE(6330), 1,
      aux_sym___block_repeat1,
  [214167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13335), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214175] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13337), 1,
      sym_with,
    ACTIONS(13339), 1,
      sym__layout_end,
  [214185] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13329), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214193] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13341), 1,
      sym__layout_semicolon,
    STATE(6337), 1,
      aux_sym___block_repeat1,
  [214203] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6541), 1,
      sym_kw_else,
  [214213] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13343), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214223] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13345), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214233] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13347), 1,
      sym__layout_semicolon,
    STATE(6338), 1,
      aux_sym___block_repeat1,
  [214243] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13349), 1,
      sym_with,
    ACTIONS(13351), 1,
      sym__layout_end,
  [214253] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13239), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214261] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4678), 1,
      sym_arrow_symbol,
  [214271] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13353), 1,
      sym_imm_wordy_id,
  [214281] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6603), 1,
      sym_kw_else,
  [214291] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13355), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214301] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13357), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214311] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4686), 1,
      sym_arrow_symbol,
  [214321] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13359), 1,
      sym__layout_semicolon,
    STATE(6346), 1,
      aux_sym___block_repeat1,
  [214331] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13361), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214339] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13363), 1,
      sym_with,
    ACTIONS(13365), 1,
      sym__layout_end,
  [214349] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6707), 1,
      sym_kw_else,
  [214359] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13367), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13239), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214377] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4713), 1,
      sym_arrow_symbol,
  [214387] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13369), 1,
      sym__layout_semicolon,
    STATE(6352), 1,
      aux_sym___block_repeat1,
  [214397] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13371), 1,
      sym_with,
    ACTIONS(13373), 1,
      sym__layout_end,
  [214407] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13375), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214415] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214423] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214431] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6756), 1,
      sym_kw_else,
  [214441] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6123), 1,
      sym_guarded_block,
  [214451] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13377), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5982), 2,
      sym_where,
      aux_sym_wordy_id_token1,
  [214469] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4707), 1,
      sym_arrow_symbol,
  [214479] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13379), 2,
      sym__layout_end,
      anon_sym_COMMA,
  [214487] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13381), 1,
      sym__layout_semicolon,
    STATE(6362), 1,
      aux_sym___block_repeat1,
  [214497] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13383), 1,
      sym__layout_semicolon,
    STATE(6369), 1,
      aux_sym___block_repeat1,
  [214507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13385), 1,
      sym_with,
    ACTIONS(13387), 1,
      sym__layout_end,
  [214517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13389), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214527] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2307), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214535] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6817), 1,
      sym_kw_else,
  [214545] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13391), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214555] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13393), 1,
      sym__layout_semicolon,
    STATE(6372), 1,
      aux_sym___block_repeat1,
  [214565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13395), 1,
      sym_with,
    ACTIONS(13397), 1,
      sym__layout_end,
  [214575] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13399), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214583] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13401), 1,
      sym_imm_wordy_id,
    ACTIONS(13403), 1,
      sym_imm_symboly_id,
  [214593] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6869), 1,
      sym_kw_else,
  [214603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13405), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13407), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214621] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13409), 1,
      sym_imm_wordy_id,
  [214631] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13411), 1,
      sym__layout_semicolon,
    STATE(6378), 1,
      aux_sym___block_repeat1,
  [214641] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13413), 1,
      sym_with,
    ACTIONS(13415), 1,
      sym__layout_end,
  [214651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13417), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214659] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13399), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214667] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13419), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214675] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6913), 1,
      sym_kw_else,
  [214685] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13421), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214695] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2299), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214703] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13423), 1,
      sym__layout_semicolon,
    STATE(6387), 1,
      aux_sym___block_repeat1,
  [214713] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13425), 1,
      sym_with,
    ACTIONS(13427), 1,
      sym__layout_end,
  [214723] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214731] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(5887), 1,
      sym_guarded_block,
  [214741] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6969), 1,
      sym_kw_else,
  [214751] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13429), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214761] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4658), 1,
      sym_arrow_symbol,
  [214771] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13223), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214779] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214787] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13431), 1,
      sym__layout_semicolon,
    STATE(6400), 1,
      aux_sym___block_repeat1,
  [214797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11706), 2,
      anon_sym_COMMA,
      anon_sym_RBRACE,
  [214805] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13433), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214815] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13435), 1,
      sym__layout_semicolon,
    STATE(6394), 1,
      aux_sym___block_repeat1,
  [214825] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13437), 1,
      sym_with,
    ACTIONS(13439), 1,
      sym__layout_end,
  [214835] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2325), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214843] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13441), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214851] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13443), 1,
      anon_sym_RPAREN,
    STATE(5588), 1,
      sym_close_parens,
  [214861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13441), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214869] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13445), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214877] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13447), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214885] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13449), 1,
      anon_sym_RPAREN,
    STATE(5404), 1,
      sym_close_parens,
  [214895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13451), 2,
      sym_kw_equals,
      aux_sym_wordy_id_token1,
  [214903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13453), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214911] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13403), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [214919] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2319), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [214927] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13221), 1,
      sym_symboly_id,
    ACTIONS(13455), 1,
      sym_imm_wordy_id,
  [214937] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(7105), 1,
      sym_kw_else,
  [214947] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13457), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214957] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6215), 1,
      sym_guarded_block,
  [214967] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13459), 1,
      sym__layout_semicolon,
    STATE(6416), 1,
      aux_sym___block_repeat1,
  [214977] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13461), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [214987] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4694), 1,
      sym_arrow_symbol,
  [214997] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13463), 1,
      sym_imm_wordy_id,
  [215007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13465), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215015] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6112), 1,
      sym_guarded_block,
  [215025] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13467), 1,
      sym__layout_semicolon,
    STATE(6419), 1,
      aux_sym___block_repeat1,
  [215035] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13469), 1,
      sym_with,
    ACTIONS(13471), 1,
      sym__layout_end,
  [215045] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13473), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13465), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215061] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4682), 1,
      sym_arrow_symbol,
  [215071] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13475), 1,
      sym__layout_semicolon,
    STATE(6431), 1,
      aux_sym___block_repeat1,
  [215081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2281), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215089] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13477), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215099] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13479), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215109] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13481), 1,
      sym__layout_semicolon,
    STATE(6432), 1,
      aux_sym___block_repeat1,
  [215119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2275), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13483), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215135] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13485), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215143] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13485), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215151] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13487), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215161] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13489), 1,
      sym__layout_semicolon,
    STATE(6438), 1,
      aux_sym___block_repeat1,
  [215171] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4703), 1,
      sym_arrow_symbol,
  [215181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5911), 2,
      sym_where,
      aux_sym_wordy_id_token1,
  [215189] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4691), 1,
      sym_arrow_symbol,
  [215199] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13491), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215207] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13493), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215217] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13495), 1,
      sym__layout_semicolon,
    STATE(6444), 1,
      aux_sym___block_repeat1,
  [215227] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4659), 1,
      sym_arrow_symbol,
  [215237] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4705), 1,
      sym_arrow_symbol,
  [215247] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13497), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215255] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13499), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11592), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
  [215271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13501), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215279] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13503), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215289] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13505), 1,
      sym__layout_semicolon,
    STATE(6452), 1,
      aux_sym___block_repeat1,
  [215299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13379), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [215307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11590), 2,
      anon_sym_DASH_GT,
      sym_kw_equals,
  [215315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(2129), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215323] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13507), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215333] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13509), 1,
      sym__layout_semicolon,
    STATE(6460), 1,
      aux_sym___block_repeat1,
  [215343] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13511), 1,
      sym__layout_semicolon,
    STATE(6457), 1,
      aux_sym___block_repeat1,
  [215353] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13513), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215363] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4688), 1,
      sym_arrow_symbol,
  [215373] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13515), 1,
      sym_imm_wordy_id,
  [215383] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13517), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215393] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13519), 1,
      sym__layout_semicolon,
    STATE(6463), 1,
      aux_sym___block_repeat1,
  [215403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13521), 2,
      anon_sym_COMMA,
      anon_sym_RBRACK,
  [215411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13523), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(5980), 2,
      sym_type_argument,
      sym_kw_equals,
  [215427] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13525), 1,
      sym_imm_wordy_id,
  [215437] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4681), 1,
      sym_arrow_symbol,
  [215447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13527), 2,
      sym_where,
      aux_sym_wordy_id_token1,
  [215455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13529), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215463] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13531), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215471] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13533), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215481] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13535), 1,
      sym__layout_semicolon,
    STATE(6473), 1,
      aux_sym___block_repeat1,
  [215491] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13537), 2,
      anon_sym_DOT,
      aux_sym_wordy_id_token1,
  [215499] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13539), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215507] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13541), 1,
      anon_sym_RPAREN,
    STATE(6450), 1,
      sym_close_parens,
  [215517] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13543), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215527] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13545), 1,
      sym__layout_semicolon,
    STATE(6478), 1,
      aux_sym___block_repeat1,
  [215537] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11450), 1,
      anon_sym_DASH_GT,
    STATE(6581), 1,
      sym_arrow_symbol,
  [215547] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13547), 1,
      sym_imm_wordy_id,
  [215557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13549), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215565] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4672), 1,
      sym_arrow_symbol,
  [215575] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4662), 1,
      sym_arrow_symbol,
  [215585] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13551), 1,
      sym_imm_wordy_id,
  [215595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13553), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215603] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13555), 1,
      sym__layout_semicolon,
    STATE(6489), 1,
      aux_sym___block_repeat1,
  [215613] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13200), 1,
      sym_pipe,
    STATE(6511), 1,
      sym_guarded_block,
  [215623] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13557), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215633] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13559), 1,
      sym_imm_wordy_id,
  [215643] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13561), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215653] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13221), 1,
      sym_symboly_id,
    ACTIONS(13563), 1,
      sym_imm_wordy_id,
  [215663] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13565), 1,
      sym__layout_semicolon,
    STATE(6491), 1,
      aux_sym___block_repeat1,
  [215673] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13567), 2,
      sym__layout_end,
      anon_sym_COMMA,
  [215681] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4700), 1,
      sym_arrow_symbol,
  [215691] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13569), 1,
      sym__layout_semicolon,
    STATE(6498), 1,
      aux_sym___block_repeat1,
  [215701] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4670), 1,
      sym_arrow_symbol,
  [215711] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13571), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12588), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215729] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13573), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215737] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13575), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215745] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13577), 1,
      sym_imm_wordy_id,
  [215755] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13579), 1,
      sym_imm_wordy_id,
  [215765] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13581), 1,
      sym_imm_wordy_id,
  [215775] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4676), 1,
      sym_arrow_symbol,
  [215785] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13583), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215793] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13585), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12617), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215811] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13587), 1,
      sym__layout_semicolon,
    STATE(6512), 1,
      aux_sym___block_repeat1,
  [215821] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
    ACTIONS(13589), 1,
      sym_imm_wordy_id,
  [215831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12538), 2,
      sym__layout_semicolon,
      sym__layout_end,
  [215839] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13591), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215849] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13245), 1,
      anon_sym_else,
    STATE(6633), 1,
      sym_kw_else,
  [215859] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13593), 1,
      sym_with,
    ACTIONS(13595), 1,
      sym__layout_end,
  [215869] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13597), 1,
      sym__layout_semicolon,
    STATE(6345), 1,
      aux_sym___block_repeat1,
  [215879] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13599), 1,
      sym__layout_semicolon,
    STATE(6518), 1,
      aux_sym___block_repeat1,
  [215889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13601), 2,
      sym_imm_wordy_id,
      sym_imm_symboly_id,
  [215897] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13603), 1,
      sym__layout_semicolon,
    STATE(6258), 1,
      aux_sym___block_repeat1,
  [215907] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13190), 1,
      anon_sym_then,
    STATE(6899), 1,
      sym_kw_then,
  [215917] = 3,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11326), 1,
      anon_sym_DASH_GT,
    STATE(4673), 1,
      sym_arrow_symbol,
  [215927] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13605), 1,
      sym_with,
  [215934] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6941), 1,
      sym_with,
  [215941] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13607), 1,
      sym__layout_start,
  [215948] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13609), 1,
      anon_sym_RBRACE,
  [215955] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13611), 1,
      anon_sym_DASH_GT,
  [215962] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      sym_with,
  [215969] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13613), 1,
      anon_sym_COLON,
  [215976] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13615), 1,
      sym_with,
  [215983] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13617), 1,
      sym_with,
  [215990] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13619), 1,
      sym__layout_end,
  [215997] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13621), 1,
      anon_sym_RBRACE,
  [216004] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13623), 1,
      sym__layout_start,
  [216011] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13625), 1,
      sym_imm_wordy_id,
  [216018] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13627), 1,
      sym_with,
  [216025] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13629), 1,
      sym__layout_start,
  [216032] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13631), 1,
      anon_sym_RBRACK,
  [216039] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9597), 1,
      sym__layout_end,
  [216046] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13633), 1,
      anon_sym_RPAREN,
  [216053] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13635), 1,
      sym__layout_start,
  [216060] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7446), 1,
      sym_with,
  [216067] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13637), 1,
      sym__layout_start,
  [216074] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13639), 1,
      sym__layout_start,
  [216081] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13641), 1,
      sym__layout_start,
  [216088] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13577), 1,
      sym_imm_wordy_id,
  [216095] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13643), 1,
      sym__layout_start,
  [216102] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13645), 1,
      anon_sym_RPAREN,
  [216109] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13647), 1,
      anon_sym_DASH_GT,
  [216116] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13649), 1,
      anon_sym_COLON,
  [216123] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13651), 1,
      anon_sym_RPAREN,
  [216130] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(129), 1,
      sym_with,
  [216137] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13653), 1,
      anon_sym_RBRACK,
  [216144] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13655), 1,
      sym__layout_end,
  [216151] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13657), 1,
      anon_sym_RBRACE,
  [216158] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13659), 1,
      sym_rewrite_arrow,
  [216165] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13661), 1,
      sym__layout_start,
  [216172] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13663), 1,
      anon_sym_RPAREN,
  [216179] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13665), 1,
      sym__layout_start,
  [216186] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13667), 1,
      anon_sym_RPAREN,
  [216193] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13669), 1,
      sym__layout_start,
  [216200] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13671), 1,
      sym_with,
  [216207] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13673), 1,
      sym__layout_start,
  [216214] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13675), 1,
      sym__layout_start,
  [216221] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13677), 1,
      sym__layout_start,
  [216228] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13188), 1,
      sym_symboly_id,
  [216235] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13679), 1,
      sym__layout_start,
  [216242] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13681), 1,
      anon_sym_RPAREN,
  [216249] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13683), 1,
      anon_sym_DASH_GT,
  [216256] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13685), 1,
      anon_sym_RBRACE,
  [216263] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13687), 1,
      sym_imm_wordy_id,
  [216270] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13689), 1,
      sym_imm_wordy_id,
  [216277] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13691), 1,
      sym__layout_end,
  [216284] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13693), 1,
      anon_sym_RBRACE,
  [216291] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13695), 1,
      anon_sym_RBRACK,
  [216298] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13697), 1,
      sym__layout_start,
  [216305] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13699), 1,
      anon_sym_RBRACE,
  [216312] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13701), 1,
      sym__layout_start,
  [216319] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13703), 1,
      sym_imm_wordy_id,
  [216326] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13705), 1,
      sym__layout_start,
  [216333] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13707), 1,
      anon_sym_RPAREN,
  [216340] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13709), 1,
      anon_sym_RPAREN,
  [216347] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13711), 1,
      sym__layout_start,
  [216354] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13713), 1,
      sym__layout_start,
  [216361] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13715), 1,
      sym__layout_start,
  [216368] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13717), 1,
      sym__layout_start,
  [216375] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13719), 1,
      sym__layout_start,
  [216382] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13721), 1,
      anon_sym_RPAREN,
  [216389] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13723), 1,
      sym__layout_start,
  [216396] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13725), 1,
      sym__layout_start,
  [216403] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13727), 1,
      anon_sym_DASH_GT,
  [216410] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13729), 1,
      anon_sym_RPAREN,
  [216417] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13731), 1,
      sym__layout_start,
  [216424] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13733), 1,
      anon_sym_RPAREN,
  [216431] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13735), 1,
      sym__layout_end,
  [216438] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13563), 1,
      sym_imm_wordy_id,
  [216445] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13737), 1,
      sym__layout_start,
  [216452] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(83), 1,
      sym_with,
  [216459] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13739), 1,
      anon_sym_RPAREN,
  [216466] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13741), 1,
      sym__layout_start,
  [216473] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13743), 1,
      sym_with,
  [216480] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13745), 1,
      sym_with,
  [216487] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13747), 1,
      anon_sym_RPAREN,
  [216494] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13749), 1,
      sym__layout_start,
  [216501] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13751), 1,
      sym__layout_start,
  [216508] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13753), 1,
      anon_sym_RPAREN,
  [216515] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13755), 1,
      sym__layout_start,
  [216522] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13757), 1,
      sym__layout_start,
  [216529] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13759), 1,
      sym__layout_start,
  [216536] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13761), 1,
      sym__layout_start,
  [216543] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13763), 1,
      anon_sym_RPAREN,
  [216550] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13581), 1,
      sym_imm_wordy_id,
  [216557] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13765), 1,
      sym__layout_start,
  [216564] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13767), 1,
      sym__layout_start,
  [216571] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13769), 1,
      anon_sym_DASH_GT,
  [216578] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13771), 1,
      anon_sym_RPAREN,
  [216585] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13773), 1,
      anon_sym_RPAREN,
  [216592] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(9979), 1,
      sym__layout_end,
  [216599] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13775), 1,
      sym__layout_start,
  [216606] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13777), 1,
      sym_imm_wordy_id,
  [216613] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13779), 1,
      sym__layout_start,
  [216620] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13781), 1,
      sym__layout_end,
  [216627] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13783), 1,
      sym_kw_equals,
  [216634] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13785), 1,
      sym_with,
  [216641] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13787), 1,
      sym__layout_start,
  [216648] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13789), 1,
      sym__layout_end,
  [216655] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13791), 1,
      anon_sym_RPAREN,
  [216662] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13793), 1,
      sym__layout_start,
  [216669] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13795), 1,
      sym__layout_start,
  [216676] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13797), 1,
      sym__layout_start,
  [216683] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13799), 1,
      sym__layout_start,
  [216690] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13801), 1,
      sym_with,
  [216697] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13803), 1,
      sym__layout_start,
  [216704] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13805), 1,
      anon_sym_RPAREN,
  [216711] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13807), 1,
      sym__layout_start,
  [216718] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13809), 1,
      anon_sym_DASH_GT,
  [216725] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13811), 1,
      sym__layout_start,
  [216732] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13813), 1,
      sym__layout_start,
  [216739] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13815), 1,
      sym__layout_start,
  [216746] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13817), 1,
      anon_sym_RBRACK,
  [216753] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13455), 1,
      sym_imm_wordy_id,
  [216760] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13819), 1,
      sym__layout_start,
  [216767] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13821), 1,
      anon_sym_RBRACE,
  [216774] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13823), 1,
      anon_sym_DASH_GT,
  [216781] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13825), 1,
      sym__layout_start,
  [216788] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13827), 1,
      sym__layout_start,
  [216795] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13829), 1,
      anon_sym_RBRACE,
  [216802] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13831), 1,
      sym_imm_wordy_id,
  [216809] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13833), 1,
      anon_sym_RPAREN,
  [216816] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13835), 1,
      sym__layout_end,
  [216823] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13837), 1,
      sym__layout_end,
  [216830] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13839), 1,
      anon_sym_RPAREN,
  [216837] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13841), 1,
      anon_sym_RBRACE,
  [216844] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13843), 1,
      sym__layout_start,
  [216851] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6945), 1,
      sym_with,
  [216858] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13845), 1,
      anon_sym_DASH_GT,
  [216865] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13847), 1,
      sym_imm_wordy_id,
  [216872] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13849), 1,
      sym__layout_start,
  [216879] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(141), 1,
      sym_with,
  [216886] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13851), 1,
      sym_with,
  [216893] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13353), 1,
      sym_imm_wordy_id,
  [216900] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13853), 1,
      sym__layout_start,
  [216907] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13855), 1,
      sym__layout_end,
  [216914] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13857), 1,
      anon_sym_RBRACK,
  [216921] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13859), 1,
      anon_sym_RBRACK,
  [216928] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13861), 1,
      sym__layout_start,
  [216935] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13863), 1,
      sym__layout_start,
  [216942] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13865), 1,
      sym__layout_start,
  [216949] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13867), 1,
      anon_sym_RPAREN,
  [216956] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13869), 1,
      anon_sym_RPAREN,
  [216963] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13871), 1,
      sym__layout_start,
  [216970] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13873), 1,
      anon_sym_RPAREN,
  [216977] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13875), 1,
      anon_sym_DASH_GT,
  [216984] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13877), 1,
      anon_sym_RBRACE,
  [216991] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13879), 1,
      sym__layout_end,
  [216998] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13881), 1,
      anon_sym_RPAREN,
  [217005] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13551), 1,
      sym_imm_wordy_id,
  [217012] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13883), 1,
      anon_sym_RPAREN,
  [217019] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13885), 1,
      sym__layout_start,
  [217026] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13887), 1,
      sym__layout_end,
  [217033] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13889), 1,
      anon_sym_RBRACE,
  [217040] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13891), 1,
      sym_kw_equals,
  [217047] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13893), 1,
      sym__layout_start,
  [217054] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6949), 1,
      sym_with,
  [217061] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13525), 1,
      sym_imm_wordy_id,
  [217068] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13895), 1,
      anon_sym_DASH_GT,
  [217075] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13897), 1,
      sym__layout_start,
  [217082] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13899), 1,
      anon_sym_RBRACE,
  [217089] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13901), 1,
      anon_sym_RPAREN,
  [217096] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13903), 1,
      sym_imm_wordy_id,
  [217103] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13905), 1,
      sym__layout_start,
  [217110] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13907), 1,
      sym__layout_start,
  [217117] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13909), 1,
      sym_imm_wordy_id,
  [217124] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13911), 1,
      anon_sym_RPAREN,
  [217131] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13913), 1,
      sym__layout_start,
  [217138] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13915), 1,
      sym__layout_start,
  [217145] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13917), 1,
      sym__layout_start,
  [217152] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13919), 1,
      sym__layout_start,
  [217159] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13921), 1,
      sym__layout_start,
  [217166] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13923), 1,
      anon_sym_DASH_GT,
  [217173] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13925), 1,
      anon_sym_RPAREN,
  [217180] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13927), 1,
      anon_sym_RPAREN,
  [217187] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13929), 1,
      anon_sym_RBRACK,
  [217194] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13931), 1,
      sym__layout_end,
  [217201] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(153), 1,
      sym_with,
  [217208] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13933), 1,
      sym__layout_start,
  [217215] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13935), 1,
      sym_with,
  [217222] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(167), 1,
      sym_with,
  [217229] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13937), 1,
      sym__layout_start,
  [217236] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13939), 1,
      sym_kw_equals,
  [217243] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13579), 1,
      sym_imm_wordy_id,
  [217250] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13941), 1,
      sym__layout_start,
  [217257] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7228), 1,
      sym_with,
  [217264] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13943), 1,
      sym__layout_end,
  [217271] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13945), 1,
      sym__layout_start,
  [217278] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13947), 1,
      anon_sym_DASH_GT,
  [217285] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13949), 1,
      sym__layout_start,
  [217292] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13951), 1,
      anon_sym_RBRACK,
  [217299] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13953), 1,
      sym__layout_end,
  [217306] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13955), 1,
      sym__layout_start,
  [217313] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7286), 1,
      sym_with,
  [217320] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6953), 1,
      sym_with,
  [217327] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13957), 1,
      anon_sym_RPAREN,
  [217334] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7110), 1,
      sym_with,
  [217341] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13959), 1,
      sym__layout_start,
  [217348] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6984), 1,
      sym_with,
  [217355] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13961), 1,
      sym_imm_wordy_id,
  [217362] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13963), 1,
      sym__layout_start,
  [217369] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13965), 1,
      anon_sym_DASH_GT,
  [217376] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13967), 1,
      anon_sym_RPAREN,
  [217383] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13969), 1,
      sym__layout_start,
  [217390] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13971), 1,
      sym__layout_end,
  [217397] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13973), 1,
      sym__layout_start,
  [217404] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(173), 1,
      sym_with,
  [217411] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13975), 1,
      anon_sym_RBRACE,
  [217418] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13977), 1,
      sym__layout_end,
  [217425] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13515), 1,
      sym_imm_wordy_id,
  [217432] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13979), 1,
      anon_sym_RBRACE,
  [217439] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13981), 1,
      anon_sym_RBRACK,
  [217446] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13983), 1,
      anon_sym_DASH_GT,
  [217453] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13985), 1,
      anon_sym_RPAREN,
  [217460] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13987), 1,
      anon_sym_RBRACE,
  [217467] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13989), 1,
      sym__layout_start,
  [217474] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13991), 1,
      anon_sym_RBRACE,
  [217481] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13993), 1,
      anon_sym_RBRACK,
  [217488] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13995), 1,
      anon_sym_DASH_GT,
  [217495] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13997), 1,
      sym_with,
  [217502] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13999), 1,
      anon_sym_DASH_GT,
  [217509] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14001), 1,
      sym__layout_start,
  [217516] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14003), 1,
      anon_sym_RPAREN,
  [217523] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14005), 1,
      sym__layout_start,
  [217530] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14007), 1,
      sym__layout_start,
  [217537] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14009), 1,
      sym__layout_start,
  [217544] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14011), 1,
      sym__layout_start,
  [217551] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14013), 1,
      sym_imm_wordy_id,
  [217558] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14015), 1,
      anon_sym_DASH_GT,
  [217565] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14017), 1,
      anon_sym_RPAREN,
  [217572] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14019), 1,
      sym__layout_start,
  [217579] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14021), 1,
      sym__layout_start,
  [217586] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6937), 1,
      sym_with,
  [217593] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14023), 1,
      anon_sym_RPAREN,
  [217600] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14025), 1,
      anon_sym_DASH_GT,
  [217607] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14027), 1,
      anon_sym_RPAREN,
  [217614] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14029), 1,
      anon_sym_RPAREN,
  [217621] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14031), 1,
      anon_sym_RPAREN,
  [217628] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14033), 1,
      anon_sym_DASH_GT,
  [217635] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14035), 1,
      anon_sym_RBRACK,
  [217642] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14037), 1,
      anon_sym_RPAREN,
  [217649] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6988), 1,
      sym_with,
  [217656] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14039), 1,
      anon_sym_DASH_GT,
  [217663] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14041), 1,
      anon_sym_DASH_GT,
  [217670] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14043), 1,
      anon_sym_DASH_GT,
  [217677] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14045), 1,
      sym_kw_equals,
  [217684] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14047), 1,
      anon_sym_RPAREN,
  [217691] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14049), 1,
      sym__layout_start,
  [217698] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14051), 1,
      sym__layout_start,
  [217705] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14053), 1,
      sym__layout_start,
  [217712] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14055), 1,
      sym__layout_start,
  [217719] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14057), 1,
      sym_kw_equals,
  [217726] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14059), 1,
      sym_imm_wordy_id,
  [217733] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14061), 1,
      anon_sym_RPAREN,
  [217740] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14063), 1,
      sym__layout_start,
  [217747] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14065), 1,
      sym_with,
  [217754] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14067), 1,
      anon_sym_RBRACE,
  [217761] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14069), 1,
      sym__layout_start,
  [217768] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14071), 1,
      sym__layout_start,
  [217775] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14073), 1,
      anon_sym_RPAREN,
  [217782] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14075), 1,
      sym_with,
  [217789] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14077), 1,
      anon_sym_RBRACE,
  [217796] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14079), 1,
      sym__layout_start,
  [217803] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14081), 1,
      sym__layout_start,
  [217810] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11905), 1,
      sym__layout_start,
  [217817] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14083), 1,
      anon_sym_DASH_GT,
  [217824] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14085), 1,
      sym__layout_end,
  [217831] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14087), 1,
      sym_with,
  [217838] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14089), 1,
      anon_sym_RBRACK,
  [217845] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13463), 1,
      sym_imm_wordy_id,
  [217852] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14091), 1,
      sym_imm_wordy_id,
  [217859] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14093), 1,
      sym_imm_wordy_id,
  [217866] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14095), 1,
      anon_sym_RBRACK,
  [217873] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13559), 1,
      sym_imm_wordy_id,
  [217880] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(11492), 1,
      sym_kw_equals,
  [217887] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14097), 1,
      sym_imm_wordy_id,
  [217894] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14099), 1,
      sym_imm_wordy_id,
  [217901] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14101), 1,
      anon_sym_RPAREN,
  [217908] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14103), 1,
      anon_sym_RBRACK,
  [217915] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14105), 1,
      sym_imm_symboly_id,
  [217922] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14107), 1,
      sym_imm_wordy_id,
  [217929] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14109), 1,
      anon_sym_DASH_GT,
  [217936] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14111), 1,
      sym__layout_start,
  [217943] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14113), 1,
      sym_kw_equals,
  [217950] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14115), 1,
      sym__layout_start,
  [217957] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14117), 1,
      sym__layout_start,
  [217964] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14119), 1,
      sym__layout_start,
  [217971] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14121), 1,
      sym__layout_start,
  [217978] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14123), 1,
      sym_kw_equals,
  [217985] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14125), 1,
      sym__layout_start,
  [217992] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14127), 1,
      sym__layout_start,
  [217999] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14129), 1,
      sym__layout_start,
  [218006] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14131), 1,
      sym_with,
  [218013] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14133), 1,
      sym__layout_start,
  [218020] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13589), 1,
      sym_imm_wordy_id,
  [218027] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7056), 1,
      sym_with,
  [218034] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13194), 1,
      sym_imm_wordy_id,
  [218041] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14135), 1,
      sym__layout_start,
  [218048] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14137), 1,
      sym_kw_equals,
  [218055] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14139), 1,
      anon_sym_RBRACK,
  [218062] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14141), 1,
      sym__layout_start,
  [218069] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14143), 1,
      sym__layout_start,
  [218076] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14145), 1,
      sym__layout_start,
  [218083] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14147), 1,
      sym_kw_equals,
  [218090] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14149), 1,
      sym__layout_start,
  [218097] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14151), 1,
      anon_sym_RBRACE,
  [218104] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14153), 1,
      anon_sym_RBRACK,
  [218111] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14155), 1,
      sym_with,
  [218118] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14157), 1,
      sym_imm_wordy_id,
  [218125] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14159), 1,
      sym__layout_start,
  [218132] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12127), 1,
      sym__layout_start,
  [218139] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14161), 1,
      sym_kw_equals,
  [218146] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14163), 1,
      sym_rewrite_arrow,
  [218153] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14165), 1,
      sym__layout_start,
  [218160] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14167), 1,
      sym__layout_start,
  [218167] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14169), 1,
      sym_with,
  [218174] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14171), 1,
      sym_kw_equals,
  [218181] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14173), 1,
      sym__layout_end,
  [218188] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13547), 1,
      sym_imm_wordy_id,
  [218195] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14175), 1,
      anon_sym_RPAREN,
  [218202] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14177), 1,
      sym_with,
  [218209] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14179), 1,
      sym_with,
  [218216] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14181), 1,
      anon_sym_RPAREN,
  [218223] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12117), 1,
      sym__layout_start,
  [218230] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14183), 1,
      sym_kw_equals,
  [218237] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14185), 1,
      anon_sym_DASH_GT,
  [218244] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14187), 1,
      sym__layout_start,
  [218251] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14189), 1,
      sym__layout_start,
  [218258] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14191), 1,
      anon_sym_RPAREN,
  [218265] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14193), 1,
      sym_kw_equals,
  [218272] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14195), 1,
      anon_sym_RBRACK,
  [218279] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14197), 1,
      anon_sym_RBRACE,
  [218286] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14199), 1,
      anon_sym_RPAREN,
  [218293] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14201), 1,
      sym_with,
  [218300] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14203), 1,
      sym_rewrite_arrow,
  [218307] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14205), 1,
      sym__layout_start,
  [218314] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12071), 1,
      sym__layout_start,
  [218321] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14207), 1,
      sym_kw_equals,
  [218328] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14209), 1,
      anon_sym_RBRACE,
  [218335] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14211), 1,
      sym__layout_start,
  [218342] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14213), 1,
      sym__layout_start,
  [218349] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14215), 1,
      sym__layout_start,
  [218356] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14217), 1,
      sym_kw_equals,
  [218363] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14219), 1,
      sym__layout_start,
  [218370] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7060), 1,
      sym_with,
  [218377] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14221), 1,
      sym__layout_start,
  [218384] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14223), 1,
      sym_with,
  [218391] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14225), 1,
      anon_sym_RBRACE,
  [218398] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14227), 1,
      sym__layout_start,
  [218405] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14229), 1,
      sym__layout_start,
  [218412] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14231), 1,
      sym_kw_equals,
  [218419] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14233), 1,
      sym__layout_start,
  [218426] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14235), 1,
      sym__layout_start,
  [218433] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14237), 1,
      sym__layout_start,
  [218440] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14239), 1,
      anon_sym_RBRACE,
  [218447] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14241), 1,
      sym_kw_equals,
  [218454] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14243), 1,
      sym_imm_wordy_id,
  [218461] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14245), 1,
      sym__layout_start,
  [218468] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14247), 1,
      anon_sym_RBRACK,
  [218475] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14249), 1,
      sym_with,
  [218482] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14251), 1,
      sym__layout_end,
  [218489] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14253), 1,
      anon_sym_RBRACE,
  [218496] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12107), 1,
      sym__layout_start,
  [218503] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14255), 1,
      sym_kw_equals,
  [218510] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14257), 1,
      anon_sym_RPAREN,
  [218517] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14259), 1,
      sym__layout_start,
  [218524] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14261), 1,
      sym__layout_start,
  [218531] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14263), 1,
      anon_sym_RPAREN,
  [218538] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14265), 1,
      sym_kw_equals,
  [218545] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14267), 1,
      anon_sym_RBRACK,
  [218552] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14269), 1,
      sym_imm_wordy_id,
  [218559] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14271), 1,
      sym__layout_start,
  [218566] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14273), 1,
      sym_with,
  [218573] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14275), 1,
      sym__layout_start,
  [218580] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14277), 1,
      anon_sym_DASH_GT,
  [218587] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12103), 1,
      sym__layout_start,
  [218594] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14279), 1,
      sym_kw_equals,
  [218601] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14281), 1,
      sym__layout_start,
  [218608] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14283), 1,
      sym__layout_start,
  [218615] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14285), 1,
      sym__layout_start,
  [218622] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14287), 1,
      anon_sym_RPAREN,
  [218629] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14289), 1,
      sym_kw_equals,
  [218636] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14291), 1,
      sym__layout_start,
  [218643] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14293), 1,
      sym__layout_start,
  [218650] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14295), 1,
      sym_imm_wordy_id,
  [218657] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14297), 1,
      sym_with,
  [218664] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14299), 1,
      sym_imm_wordy_id,
  [218671] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14301), 1,
      sym__layout_start,
  [218678] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12087), 1,
      sym__layout_start,
  [218685] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14303), 1,
      sym_kw_equals,
  [218692] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14305), 1,
      anon_sym_RPAREN,
  [218699] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14307), 1,
      sym__layout_start,
  [218706] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14309), 1,
      sym__layout_start,
  [218713] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14311), 1,
      anon_sym_RPAREN,
  [218720] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14313), 1,
      sym_kw_equals,
  [218727] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14315), 1,
      sym__layout_start,
  [218734] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14317), 1,
      anon_sym_RPAREN,
  [218741] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14319), 1,
      anon_sym_RPAREN,
  [218748] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14321), 1,
      sym_with,
  [218755] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14323), 1,
      anon_sym_RBRACE,
  [218762] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14325), 1,
      sym__layout_start,
  [218769] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12065), 1,
      sym__layout_start,
  [218776] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14327), 1,
      sym_kw_equals,
  [218783] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14329), 1,
      sym__layout_start,
  [218790] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14331), 1,
      sym__layout_start,
  [218797] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14333), 1,
      sym__layout_start,
  [218804] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14335), 1,
      sym_kw_equals,
  [218811] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14337), 1,
      sym_imm_wordy_id,
  [218818] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14339), 1,
      sym_imm_wordy_id,
  [218825] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14341), 1,
      sym__layout_start,
  [218832] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14343), 1,
      sym_with,
  [218839] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14345), 1,
      anon_sym_RPAREN,
  [218846] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14347), 1,
      sym__layout_end,
  [218853] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14349), 1,
      sym__layout_start,
  [218860] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14351), 1,
      sym_kw_equals,
  [218867] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14353), 1,
      sym__layout_start,
  [218874] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14355), 1,
      sym__layout_start,
  [218881] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14357), 1,
      sym_imm_wordy_id,
  [218888] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14359), 1,
      sym_kw_equals,
  [218895] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14361), 1,
      sym_imm_wordy_id,
  [218902] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14363), 1,
      sym_imm_wordy_id,
  [218909] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14365), 1,
      sym_with,
  [218916] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14367), 1,
      sym_with,
  [218923] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12165), 1,
      sym__layout_start,
  [218930] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14369), 1,
      anon_sym_DASH_GT,
  [218937] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12043), 1,
      sym__layout_start,
  [218944] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14371), 1,
      sym_kw_equals,
  [218951] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14373), 1,
      sym__layout_start,
  [218958] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14375), 1,
      sym__layout_start,
  [218965] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14377), 1,
      anon_sym_RBRACE,
  [218972] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14379), 1,
      sym_kw_equals,
  [218979] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14381), 1,
      sym__layout_start,
  [218986] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14383), 1,
      anon_sym_RBRACE,
  [218993] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13313), 1,
      sym_imm_wordy_id,
  [219000] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14385), 1,
      sym_with,
  [219007] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14387), 1,
      sym_imm_wordy_id,
  [219014] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14389), 1,
      sym__layout_start,
  [219021] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14391), 1,
      sym_kw_equals,
  [219028] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14393), 1,
      sym__layout_start,
  [219035] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14395), 1,
      sym__layout_start,
  [219042] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14397), 1,
      sym__layout_start,
  [219049] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14399), 1,
      sym_kw_equals,
  [219056] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14401), 1,
      anon_sym_RPAREN,
  [219063] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14403), 1,
      sym__layout_start,
  [219070] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14405), 1,
      anon_sym_RPAREN,
  [219077] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14407), 1,
      sym_with,
  [219084] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14409), 1,
      sym__layout_end,
  [219091] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14411), 1,
      sym__layout_start,
  [219098] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14413), 1,
      sym_kw_equals,
  [219105] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14415), 1,
      sym__layout_start,
  [219112] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14417), 1,
      sym__layout_start,
  [219119] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14419), 1,
      sym_imm_wordy_id,
  [219126] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14421), 1,
      sym_kw_equals,
  [219133] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14423), 1,
      sym__layout_start,
  [219140] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14425), 1,
      sym__layout_start,
  [219147] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14427), 1,
      sym_imm_wordy_id,
  [219154] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14429), 1,
      sym_with,
  [219161] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7290), 1,
      sym_with,
  [219168] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14431), 1,
      sym__layout_start,
  [219175] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14433), 1,
      sym_kw_equals,
  [219182] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14435), 1,
      sym__layout_end,
  [219189] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14437), 1,
      sym_kw_equals,
  [219196] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14439), 1,
      sym__layout_start,
  [219203] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14441), 1,
      anon_sym_RBRACK,
  [219210] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14443), 1,
      sym__layout_start,
  [219217] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14445), 1,
      sym_kw_equals,
  [219224] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14447), 1,
      sym_kw_equals,
  [219231] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14449), 1,
      sym__layout_start,
  [219238] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14451), 1,
      sym__layout_start,
  [219245] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14453), 1,
      anon_sym_DASH_GT,
  [219252] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14455), 1,
      sym_kw_equals,
  [219259] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14457), 1,
      sym_kw_equals,
  [219266] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14459), 1,
      anon_sym_DASH_GT,
  [219273] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14461), 1,
      anon_sym_RPAREN,
  [219280] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(12213), 1,
      sym__layout_start,
  [219287] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14463), 1,
      sym_kw_equals,
  [219294] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14465), 1,
      anon_sym_COLON,
  [219301] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14467), 1,
      sym_kw_equals,
  [219308] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14469), 1,
      sym__layout_start,
  [219315] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14471), 1,
      sym_kw_equals,
  [219322] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(6992), 1,
      sym_with,
  [219329] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7027), 1,
      sym_with,
  [219336] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14473), 1,
      anon_sym_RPAREN,
  [219343] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14475), 1,
      sym__layout_semicolon,
  [219350] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14477), 1,
      sym__layout_start,
  [219357] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14479), 1,
      sym__layout_start,
  [219364] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14481), 1,
      sym__layout_start,
  [219371] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14483), 1,
      sym__layout_start,
  [219378] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14485), 1,
      anon_sym_RPAREN,
  [219385] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14487), 1,
      anon_sym_RBRACK,
  [219392] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14489), 1,
      anon_sym_RPAREN,
  [219399] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14491), 1,
      anon_sym_RPAREN,
  [219406] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14493), 1,
      sym__layout_start,
  [219413] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14495), 1,
      anon_sym_RPAREN,
  [219420] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14497), 1,
      sym__layout_start,
  [219427] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14499), 1,
      sym__layout_start,
  [219434] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14501), 1,
      sym__layout_start,
  [219441] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14503), 1,
      sym_kw_equals,
  [219448] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14505), 1,
      anon_sym_RPAREN,
  [219455] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14507), 1,
      sym__layout_end,
  [219462] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14509), 1,
      sym__layout_start,
  [219469] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14511), 1,
      anon_sym_COLON,
  [219476] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14513), 1,
      sym_with,
  [219483] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13213), 1,
      sym_imm_wordy_id,
  [219490] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14515), 1,
      sym__layout_start,
  [219497] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14517), 1,
      anon_sym_RBRACE,
  [219504] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7031), 1,
      sym_with,
  [219511] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14519), 1,
      anon_sym_RPAREN,
  [219518] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14521), 1,
      sym_imm_wordy_id,
  [219525] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14523), 1,
      sym__layout_start,
  [219532] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14525), 1,
      anon_sym_RBRACE,
  [219539] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14527), 1,
      sym_imm_wordy_id,
  [219546] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14529), 1,
      sym__layout_start,
  [219553] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14531), 1,
      sym__layout_start,
  [219560] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14533), 1,
      sym__layout_start,
  [219567] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14535), 1,
      sym__layout_start,
  [219574] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14537), 1,
      sym__layout_start,
  [219581] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14539), 1,
      sym_imm_wordy_id,
  [219588] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14541), 1,
      anon_sym_RPAREN,
  [219595] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14543), 1,
      anon_sym_RPAREN,
  [219602] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14545), 1,
      anon_sym_RPAREN,
  [219609] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14547), 1,
      sym_imm_wordy_id,
  [219616] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14549), 1,
      sym__layout_semicolon,
  [219623] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14551), 1,
      anon_sym_RBRACK,
  [219630] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14553), 1,
      sym__layout_start,
  [219637] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14555), 1,
      sym__layout_start,
  [219644] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14557), 1,
      sym__layout_start,
  [219651] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14559), 1,
      sym__layout_start,
  [219658] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14561), 1,
      sym__layout_start,
  [219665] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14563), 1,
      sym__layout_start,
  [219672] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14565), 1,
      sym__layout_start,
  [219679] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14567), 1,
      sym__layout_start,
  [219686] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14569), 1,
      sym__layout_start,
  [219693] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14571), 1,
      sym__layout_start,
  [219700] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14573), 1,
      sym__layout_start,
  [219707] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14575), 1,
      sym__layout_start,
  [219714] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14577), 1,
      sym__layout_start,
  [219721] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14579), 1,
      sym__layout_start,
  [219728] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14581), 1,
      sym__layout_start,
  [219735] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14583), 1,
      sym__layout_start,
  [219742] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14585), 1,
      sym__layout_start,
  [219749] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14587), 1,
      sym__layout_start,
  [219756] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14589), 1,
      sym__layout_start,
  [219763] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14591), 1,
      sym__layout_start,
  [219770] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14593), 1,
      sym__layout_start,
  [219777] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14595), 1,
      sym__layout_start,
  [219784] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14597), 1,
      sym__layout_start,
  [219791] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14599), 1,
      sym__layout_start,
  [219798] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14601), 1,
      sym__layout_start,
  [219805] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14603), 1,
      sym__layout_start,
  [219812] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14605), 1,
      sym__layout_start,
  [219819] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14607), 1,
      sym__layout_start,
  [219826] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14609), 1,
      sym__layout_start,
  [219833] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14611), 1,
      sym__layout_start,
  [219840] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14613), 1,
      sym__layout_start,
  [219847] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14615), 1,
      sym__layout_start,
  [219854] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14617), 1,
      sym__layout_start,
  [219861] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14619), 1,
      anon_sym_RBRACK,
  [219868] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13409), 1,
      sym_imm_wordy_id,
  [219875] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14621), 1,
      sym__layout_start,
  [219882] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14623), 1,
      sym__layout_end,
  [219889] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14625), 1,
      sym__layout_end,
  [219896] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14627), 1,
      sym_with,
  [219903] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14629), 1,
      sym__layout_end,
  [219910] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14631), 1,
      anon_sym_RPAREN,
  [219917] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      sym_with,
  [219924] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7301), 1,
      sym_with,
  [219931] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(7315), 1,
      sym_with,
  [219938] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14633), 1,
      anon_sym_RPAREN,
  [219945] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14635), 1,
      sym_kw_equals,
  [219952] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14637), 1,
      anon_sym_RBRACK,
  [219959] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      sym_kw_equals,
  [219966] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14639), 1,
      sym_kw_equals,
  [219973] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14641), 1,
      sym_kw_equals,
  [219980] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14643), 1,
      anon_sym_RBRACE,
  [219987] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14645), 1,
      anon_sym_RPAREN,
  [219994] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14647), 1,
      ts_builtin_sym_end,
  [220001] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14649), 1,
      sym_imm_wordy_id,
  [220008] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14651), 1,
      anon_sym_RPAREN,
  [220015] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14653), 1,
      sym__layout_start,
  [220022] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14655), 1,
      anon_sym_RBRACE,
  [220029] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14657), 1,
      sym_with,
  [220036] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(13186), 1,
      sym_imm_wordy_id,
  [220043] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14659), 1,
      sym__layout_start,
  [220050] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14661), 1,
      sym__layout_start,
  [220057] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14663), 1,
      sym__layout_start,
  [220064] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14665), 1,
      sym__layout_start,
  [220071] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14667), 1,
      sym__layout_start,
  [220078] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14669), 1,
      sym__layout_start,
  [220085] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14671), 1,
      sym__layout_start,
  [220092] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14673), 1,
      sym__layout_start,
  [220099] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14675), 1,
      sym__layout_start,
  [220106] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14677), 1,
      sym__layout_start,
  [220113] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14679), 1,
      sym__layout_start,
  [220120] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14681), 1,
      sym__layout_start,
  [220127] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14683), 1,
      sym__layout_start,
  [220134] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14685), 1,
      sym__layout_start,
  [220141] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14687), 1,
      sym__layout_start,
  [220148] = 2,
    ACTIONS(3), 1,
      sym_comment,
    ACTIONS(14689), 1,
      sym__layout_start,
};

static const uint32_t ts_small_parse_table_map[] = {
  [SMALL_STATE(1345)] = 0,
  [SMALL_STATE(1346)] = 135,
  [SMALL_STATE(1347)] = 270,
  [SMALL_STATE(1348)] = 405,
  [SMALL_STATE(1349)] = 540,
  [SMALL_STATE(1350)] = 675,
  [SMALL_STATE(1351)] = 810,
  [SMALL_STATE(1352)] = 945,
  [SMALL_STATE(1353)] = 1080,
  [SMALL_STATE(1354)] = 1214,
  [SMALL_STATE(1355)] = 1348,
  [SMALL_STATE(1356)] = 1482,
  [SMALL_STATE(1357)] = 1616,
  [SMALL_STATE(1358)] = 1750,
  [SMALL_STATE(1359)] = 1884,
  [SMALL_STATE(1360)] = 1977,
  [SMALL_STATE(1361)] = 2114,
  [SMALL_STATE(1362)] = 2207,
  [SMALL_STATE(1363)] = 2300,
  [SMALL_STATE(1364)] = 2392,
  [SMALL_STATE(1365)] = 2484,
  [SMALL_STATE(1366)] = 2576,
  [SMALL_STATE(1367)] = 2704,
  [SMALL_STATE(1368)] = 2832,
  [SMALL_STATE(1369)] = 2960,
  [SMALL_STATE(1370)] = 3088,
  [SMALL_STATE(1371)] = 3216,
  [SMALL_STATE(1372)] = 3344,
  [SMALL_STATE(1373)] = 3434,
  [SMALL_STATE(1374)] = 3562,
  [SMALL_STATE(1375)] = 3690,
  [SMALL_STATE(1376)] = 3818,
  [SMALL_STATE(1377)] = 3946,
  [SMALL_STATE(1378)] = 4074,
  [SMALL_STATE(1379)] = 4202,
  [SMALL_STATE(1380)] = 4330,
  [SMALL_STATE(1381)] = 4458,
  [SMALL_STATE(1382)] = 4586,
  [SMALL_STATE(1383)] = 4714,
  [SMALL_STATE(1384)] = 4842,
  [SMALL_STATE(1385)] = 4970,
  [SMALL_STATE(1386)] = 5098,
  [SMALL_STATE(1387)] = 5226,
  [SMALL_STATE(1388)] = 5354,
  [SMALL_STATE(1389)] = 5444,
  [SMALL_STATE(1390)] = 5572,
  [SMALL_STATE(1391)] = 5700,
  [SMALL_STATE(1392)] = 5828,
  [SMALL_STATE(1393)] = 5956,
  [SMALL_STATE(1394)] = 6084,
  [SMALL_STATE(1395)] = 6212,
  [SMALL_STATE(1396)] = 6302,
  [SMALL_STATE(1397)] = 6430,
  [SMALL_STATE(1398)] = 6558,
  [SMALL_STATE(1399)] = 6686,
  [SMALL_STATE(1400)] = 6814,
  [SMALL_STATE(1401)] = 6942,
  [SMALL_STATE(1402)] = 7067,
  [SMALL_STATE(1403)] = 7192,
  [SMALL_STATE(1404)] = 7317,
  [SMALL_STATE(1405)] = 7442,
  [SMALL_STATE(1406)] = 7567,
  [SMALL_STATE(1407)] = 7692,
  [SMALL_STATE(1408)] = 7781,
  [SMALL_STATE(1409)] = 7906,
  [SMALL_STATE(1410)] = 8031,
  [SMALL_STATE(1411)] = 8156,
  [SMALL_STATE(1412)] = 8245,
  [SMALL_STATE(1413)] = 8370,
  [SMALL_STATE(1414)] = 8495,
  [SMALL_STATE(1415)] = 8620,
  [SMALL_STATE(1416)] = 8745,
  [SMALL_STATE(1417)] = 8870,
  [SMALL_STATE(1418)] = 8995,
  [SMALL_STATE(1419)] = 9120,
  [SMALL_STATE(1420)] = 9245,
  [SMALL_STATE(1421)] = 9370,
  [SMALL_STATE(1422)] = 9495,
  [SMALL_STATE(1423)] = 9620,
  [SMALL_STATE(1424)] = 9745,
  [SMALL_STATE(1425)] = 9870,
  [SMALL_STATE(1426)] = 9995,
  [SMALL_STATE(1427)] = 10120,
  [SMALL_STATE(1428)] = 10245,
  [SMALL_STATE(1429)] = 10370,
  [SMALL_STATE(1430)] = 10495,
  [SMALL_STATE(1431)] = 10620,
  [SMALL_STATE(1432)] = 10709,
  [SMALL_STATE(1433)] = 10834,
  [SMALL_STATE(1434)] = 10959,
  [SMALL_STATE(1435)] = 11084,
  [SMALL_STATE(1436)] = 11209,
  [SMALL_STATE(1437)] = 11334,
  [SMALL_STATE(1438)] = 11459,
  [SMALL_STATE(1439)] = 11584,
  [SMALL_STATE(1440)] = 11709,
  [SMALL_STATE(1441)] = 11834,
  [SMALL_STATE(1442)] = 11959,
  [SMALL_STATE(1443)] = 12044,
  [SMALL_STATE(1444)] = 12129,
  [SMALL_STATE(1445)] = 12214,
  [SMALL_STATE(1446)] = 12298,
  [SMALL_STATE(1447)] = 12366,
  [SMALL_STATE(1448)] = 12434,
  [SMALL_STATE(1449)] = 12494,
  [SMALL_STATE(1450)] = 12558,
  [SMALL_STATE(1451)] = 12626,
  [SMALL_STATE(1452)] = 12710,
  [SMALL_STATE(1453)] = 12782,
  [SMALL_STATE(1454)] = 12866,
  [SMALL_STATE(1455)] = 12938,
  [SMALL_STATE(1456)] = 13002,
  [SMALL_STATE(1457)] = 13086,
  [SMALL_STATE(1458)] = 13170,
  [SMALL_STATE(1459)] = 13234,
  [SMALL_STATE(1460)] = 13302,
  [SMALL_STATE(1461)] = 13386,
  [SMALL_STATE(1462)] = 13451,
  [SMALL_STATE(1463)] = 13514,
  [SMALL_STATE(1464)] = 13573,
  [SMALL_STATE(1465)] = 13644,
  [SMALL_STATE(1466)] = 13727,
  [SMALL_STATE(1467)] = 13790,
  [SMALL_STATE(1468)] = 13851,
  [SMALL_STATE(1469)] = 13916,
  [SMALL_STATE(1470)] = 13977,
  [SMALL_STATE(1471)] = 14048,
  [SMALL_STATE(1472)] = 14131,
  [SMALL_STATE(1473)] = 14190,
  [SMALL_STATE(1474)] = 14253,
  [SMALL_STATE(1475)] = 14336,
  [SMALL_STATE(1476)] = 14418,
  [SMALL_STATE(1477)] = 14500,
  [SMALL_STATE(1478)] = 14558,
  [SMALL_STATE(1479)] = 14640,
  [SMALL_STATE(1480)] = 14698,
  [SMALL_STATE(1481)] = 14780,
  [SMALL_STATE(1482)] = 14848,
  [SMALL_STATE(1483)] = 14906,
  [SMALL_STATE(1484)] = 14988,
  [SMALL_STATE(1485)] = 15048,
  [SMALL_STATE(1486)] = 15110,
  [SMALL_STATE(1487)] = 15192,
  [SMALL_STATE(1488)] = 15250,
  [SMALL_STATE(1489)] = 15312,
  [SMALL_STATE(1490)] = 15370,
  [SMALL_STATE(1491)] = 15428,
  [SMALL_STATE(1492)] = 15486,
  [SMALL_STATE(1493)] = 15568,
  [SMALL_STATE(1494)] = 15650,
  [SMALL_STATE(1495)] = 15708,
  [SMALL_STATE(1496)] = 15766,
  [SMALL_STATE(1497)] = 15824,
  [SMALL_STATE(1498)] = 15906,
  [SMALL_STATE(1499)] = 15988,
  [SMALL_STATE(1500)] = 16046,
  [SMALL_STATE(1501)] = 16104,
  [SMALL_STATE(1502)] = 16162,
  [SMALL_STATE(1503)] = 16222,
  [SMALL_STATE(1504)] = 16280,
  [SMALL_STATE(1505)] = 16348,
  [SMALL_STATE(1506)] = 16406,
  [SMALL_STATE(1507)] = 16488,
  [SMALL_STATE(1508)] = 16570,
  [SMALL_STATE(1509)] = 16635,
  [SMALL_STATE(1510)] = 16716,
  [SMALL_STATE(1511)] = 16777,
  [SMALL_STATE(1512)] = 16834,
  [SMALL_STATE(1513)] = 16895,
  [SMALL_STATE(1514)] = 16956,
  [SMALL_STATE(1515)] = 17017,
  [SMALL_STATE(1516)] = 17074,
  [SMALL_STATE(1517)] = 17155,
  [SMALL_STATE(1518)] = 17236,
  [SMALL_STATE(1519)] = 17301,
  [SMALL_STATE(1520)] = 17382,
  [SMALL_STATE(1521)] = 17439,
  [SMALL_STATE(1522)] = 17496,
  [SMALL_STATE(1523)] = 17577,
  [SMALL_STATE(1524)] = 17642,
  [SMALL_STATE(1525)] = 17703,
  [SMALL_STATE(1526)] = 17772,
  [SMALL_STATE(1527)] = 17833,
  [SMALL_STATE(1528)] = 17914,
  [SMALL_STATE(1529)] = 17983,
  [SMALL_STATE(1530)] = 18040,
  [SMALL_STATE(1531)] = 18097,
  [SMALL_STATE(1532)] = 18158,
  [SMALL_STATE(1533)] = 18215,
  [SMALL_STATE(1534)] = 18272,
  [SMALL_STATE(1535)] = 18329,
  [SMALL_STATE(1536)] = 18390,
  [SMALL_STATE(1537)] = 18447,
  [SMALL_STATE(1538)] = 18512,
  [SMALL_STATE(1539)] = 18569,
  [SMALL_STATE(1540)] = 18626,
  [SMALL_STATE(1541)] = 18683,
  [SMALL_STATE(1542)] = 18744,
  [SMALL_STATE(1543)] = 18808,
  [SMALL_STATE(1544)] = 18866,
  [SMALL_STATE(1545)] = 18934,
  [SMALL_STATE(1546)] = 19002,
  [SMALL_STATE(1547)] = 19062,
  [SMALL_STATE(1548)] = 19122,
  [SMALL_STATE(1549)] = 19186,
  [SMALL_STATE(1550)] = 19242,
  [SMALL_STATE(1551)] = 19298,
  [SMALL_STATE(1552)] = 19358,
  [SMALL_STATE(1553)] = 19414,
  [SMALL_STATE(1554)] = 19478,
  [SMALL_STATE(1555)] = 19558,
  [SMALL_STATE(1556)] = 19614,
  [SMALL_STATE(1557)] = 19670,
  [SMALL_STATE(1558)] = 19726,
  [SMALL_STATE(1559)] = 19790,
  [SMALL_STATE(1560)] = 19848,
  [SMALL_STATE(1561)] = 19904,
  [SMALL_STATE(1562)] = 19968,
  [SMALL_STATE(1563)] = 20032,
  [SMALL_STATE(1564)] = 20090,
  [SMALL_STATE(1565)] = 20154,
  [SMALL_STATE(1566)] = 20218,
  [SMALL_STATE(1567)] = 20276,
  [SMALL_STATE(1568)] = 20340,
  [SMALL_STATE(1569)] = 20404,
  [SMALL_STATE(1570)] = 20464,
  [SMALL_STATE(1571)] = 20528,
  [SMALL_STATE(1572)] = 20592,
  [SMALL_STATE(1573)] = 20656,
  [SMALL_STATE(1574)] = 20720,
  [SMALL_STATE(1575)] = 20780,
  [SMALL_STATE(1576)] = 20840,
  [SMALL_STATE(1577)] = 20904,
  [SMALL_STATE(1578)] = 20960,
  [SMALL_STATE(1579)] = 21024,
  [SMALL_STATE(1580)] = 21080,
  [SMALL_STATE(1581)] = 21140,
  [SMALL_STATE(1582)] = 21196,
  [SMALL_STATE(1583)] = 21256,
  [SMALL_STATE(1584)] = 21316,
  [SMALL_STATE(1585)] = 21372,
  [SMALL_STATE(1586)] = 21428,
  [SMALL_STATE(1587)] = 21486,
  [SMALL_STATE(1588)] = 21546,
  [SMALL_STATE(1589)] = 21608,
  [SMALL_STATE(1590)] = 21670,
  [SMALL_STATE(1591)] = 21734,
  [SMALL_STATE(1592)] = 21792,
  [SMALL_STATE(1593)] = 21872,
  [SMALL_STATE(1594)] = 21934,
  [SMALL_STATE(1595)] = 21994,
  [SMALL_STATE(1596)] = 22058,
  [SMALL_STATE(1597)] = 22122,
  [SMALL_STATE(1598)] = 22184,
  [SMALL_STATE(1599)] = 22246,
  [SMALL_STATE(1600)] = 22326,
  [SMALL_STATE(1601)] = 22388,
  [SMALL_STATE(1602)] = 22444,
  [SMALL_STATE(1603)] = 22504,
  [SMALL_STATE(1604)] = 22568,
  [SMALL_STATE(1605)] = 22630,
  [SMALL_STATE(1606)] = 22690,
  [SMALL_STATE(1607)] = 22752,
  [SMALL_STATE(1608)] = 22814,
  [SMALL_STATE(1609)] = 22877,
  [SMALL_STATE(1610)] = 22932,
  [SMALL_STATE(1611)] = 22989,
  [SMALL_STATE(1612)] = 23044,
  [SMALL_STATE(1613)] = 23101,
  [SMALL_STATE(1614)] = 23156,
  [SMALL_STATE(1615)] = 23211,
  [SMALL_STATE(1616)] = 23266,
  [SMALL_STATE(1617)] = 23321,
  [SMALL_STATE(1618)] = 23376,
  [SMALL_STATE(1619)] = 23431,
  [SMALL_STATE(1620)] = 23486,
  [SMALL_STATE(1621)] = 23541,
  [SMALL_STATE(1622)] = 23596,
  [SMALL_STATE(1623)] = 23675,
  [SMALL_STATE(1624)] = 23730,
  [SMALL_STATE(1625)] = 23785,
  [SMALL_STATE(1626)] = 23840,
  [SMALL_STATE(1627)] = 23895,
  [SMALL_STATE(1628)] = 23974,
  [SMALL_STATE(1629)] = 24037,
  [SMALL_STATE(1630)] = 24092,
  [SMALL_STATE(1631)] = 24147,
  [SMALL_STATE(1632)] = 24202,
  [SMALL_STATE(1633)] = 24261,
  [SMALL_STATE(1634)] = 24340,
  [SMALL_STATE(1635)] = 24395,
  [SMALL_STATE(1636)] = 24450,
  [SMALL_STATE(1637)] = 24505,
  [SMALL_STATE(1638)] = 24566,
  [SMALL_STATE(1639)] = 24627,
  [SMALL_STATE(1640)] = 24682,
  [SMALL_STATE(1641)] = 24743,
  [SMALL_STATE(1642)] = 24800,
  [SMALL_STATE(1643)] = 24861,
  [SMALL_STATE(1644)] = 24922,
  [SMALL_STATE(1645)] = 24977,
  [SMALL_STATE(1646)] = 25038,
  [SMALL_STATE(1647)] = 25093,
  [SMALL_STATE(1648)] = 25148,
  [SMALL_STATE(1649)] = 25211,
  [SMALL_STATE(1650)] = 25274,
  [SMALL_STATE(1651)] = 25329,
  [SMALL_STATE(1652)] = 25384,
  [SMALL_STATE(1653)] = 25439,
  [SMALL_STATE(1654)] = 25502,
  [SMALL_STATE(1655)] = 25557,
  [SMALL_STATE(1656)] = 25620,
  [SMALL_STATE(1657)] = 25679,
  [SMALL_STATE(1658)] = 25734,
  [SMALL_STATE(1659)] = 25789,
  [SMALL_STATE(1660)] = 25844,
  [SMALL_STATE(1661)] = 25899,
  [SMALL_STATE(1662)] = 25956,
  [SMALL_STATE(1663)] = 26011,
  [SMALL_STATE(1664)] = 26066,
  [SMALL_STATE(1665)] = 26121,
  [SMALL_STATE(1666)] = 26176,
  [SMALL_STATE(1667)] = 26231,
  [SMALL_STATE(1668)] = 26286,
  [SMALL_STATE(1669)] = 26341,
  [SMALL_STATE(1670)] = 26404,
  [SMALL_STATE(1671)] = 26459,
  [SMALL_STATE(1672)] = 26514,
  [SMALL_STATE(1673)] = 26571,
  [SMALL_STATE(1674)] = 26626,
  [SMALL_STATE(1675)] = 26689,
  [SMALL_STATE(1676)] = 26744,
  [SMALL_STATE(1677)] = 26807,
  [SMALL_STATE(1678)] = 26862,
  [SMALL_STATE(1679)] = 26917,
  [SMALL_STATE(1680)] = 26972,
  [SMALL_STATE(1681)] = 27027,
  [SMALL_STATE(1682)] = 27082,
  [SMALL_STATE(1683)] = 27139,
  [SMALL_STATE(1684)] = 27196,
  [SMALL_STATE(1685)] = 27251,
  [SMALL_STATE(1686)] = 27306,
  [SMALL_STATE(1687)] = 27361,
  [SMALL_STATE(1688)] = 27416,
  [SMALL_STATE(1689)] = 27471,
  [SMALL_STATE(1690)] = 27526,
  [SMALL_STATE(1691)] = 27581,
  [SMALL_STATE(1692)] = 27644,
  [SMALL_STATE(1693)] = 27707,
  [SMALL_STATE(1694)] = 27770,
  [SMALL_STATE(1695)] = 27833,
  [SMALL_STATE(1696)] = 27888,
  [SMALL_STATE(1697)] = 27943,
  [SMALL_STATE(1698)] = 27998,
  [SMALL_STATE(1699)] = 28053,
  [SMALL_STATE(1700)] = 28108,
  [SMALL_STATE(1701)] = 28163,
  [SMALL_STATE(1702)] = 28218,
  [SMALL_STATE(1703)] = 28273,
  [SMALL_STATE(1704)] = 28328,
  [SMALL_STATE(1705)] = 28391,
  [SMALL_STATE(1706)] = 28446,
  [SMALL_STATE(1707)] = 28501,
  [SMALL_STATE(1708)] = 28556,
  [SMALL_STATE(1709)] = 28611,
  [SMALL_STATE(1710)] = 28670,
  [SMALL_STATE(1711)] = 28725,
  [SMALL_STATE(1712)] = 28780,
  [SMALL_STATE(1713)] = 28835,
  [SMALL_STATE(1714)] = 28890,
  [SMALL_STATE(1715)] = 28945,
  [SMALL_STATE(1716)] = 29000,
  [SMALL_STATE(1717)] = 29063,
  [SMALL_STATE(1718)] = 29122,
  [SMALL_STATE(1719)] = 29177,
  [SMALL_STATE(1720)] = 29232,
  [SMALL_STATE(1721)] = 29287,
  [SMALL_STATE(1722)] = 29342,
  [SMALL_STATE(1723)] = 29401,
  [SMALL_STATE(1724)] = 29462,
  [SMALL_STATE(1725)] = 29517,
  [SMALL_STATE(1726)] = 29572,
  [SMALL_STATE(1727)] = 29635,
  [SMALL_STATE(1728)] = 29690,
  [SMALL_STATE(1729)] = 29745,
  [SMALL_STATE(1730)] = 29808,
  [SMALL_STATE(1731)] = 29863,
  [SMALL_STATE(1732)] = 29918,
  [SMALL_STATE(1733)] = 29973,
  [SMALL_STATE(1734)] = 30028,
  [SMALL_STATE(1735)] = 30083,
  [SMALL_STATE(1736)] = 30138,
  [SMALL_STATE(1737)] = 30193,
  [SMALL_STATE(1738)] = 30254,
  [SMALL_STATE(1739)] = 30309,
  [SMALL_STATE(1740)] = 30364,
  [SMALL_STATE(1741)] = 30419,
  [SMALL_STATE(1742)] = 30474,
  [SMALL_STATE(1743)] = 30529,
  [SMALL_STATE(1744)] = 30588,
  [SMALL_STATE(1745)] = 30649,
  [SMALL_STATE(1746)] = 30704,
  [SMALL_STATE(1747)] = 30759,
  [SMALL_STATE(1748)] = 30820,
  [SMALL_STATE(1749)] = 30875,
  [SMALL_STATE(1750)] = 30936,
  [SMALL_STATE(1751)] = 30993,
  [SMALL_STATE(1752)] = 31048,
  [SMALL_STATE(1753)] = 31103,
  [SMALL_STATE(1754)] = 31158,
  [SMALL_STATE(1755)] = 31213,
  [SMALL_STATE(1756)] = 31268,
  [SMALL_STATE(1757)] = 31329,
  [SMALL_STATE(1758)] = 31384,
  [SMALL_STATE(1759)] = 31439,
  [SMALL_STATE(1760)] = 31494,
  [SMALL_STATE(1761)] = 31549,
  [SMALL_STATE(1762)] = 31604,
  [SMALL_STATE(1763)] = 31659,
  [SMALL_STATE(1764)] = 31714,
  [SMALL_STATE(1765)] = 31769,
  [SMALL_STATE(1766)] = 31824,
  [SMALL_STATE(1767)] = 31879,
  [SMALL_STATE(1768)] = 31934,
  [SMALL_STATE(1769)] = 31989,
  [SMALL_STATE(1770)] = 32046,
  [SMALL_STATE(1771)] = 32101,
  [SMALL_STATE(1772)] = 32156,
  [SMALL_STATE(1773)] = 32211,
  [SMALL_STATE(1774)] = 32266,
  [SMALL_STATE(1775)] = 32321,
  [SMALL_STATE(1776)] = 32376,
  [SMALL_STATE(1777)] = 32431,
  [SMALL_STATE(1778)] = 32486,
  [SMALL_STATE(1779)] = 32541,
  [SMALL_STATE(1780)] = 32596,
  [SMALL_STATE(1781)] = 32651,
  [SMALL_STATE(1782)] = 32706,
  [SMALL_STATE(1783)] = 32761,
  [SMALL_STATE(1784)] = 32816,
  [SMALL_STATE(1785)] = 32871,
  [SMALL_STATE(1786)] = 32934,
  [SMALL_STATE(1787)] = 32997,
  [SMALL_STATE(1788)] = 33052,
  [SMALL_STATE(1789)] = 33107,
  [SMALL_STATE(1790)] = 33162,
  [SMALL_STATE(1791)] = 33217,
  [SMALL_STATE(1792)] = 33272,
  [SMALL_STATE(1793)] = 33327,
  [SMALL_STATE(1794)] = 33390,
  [SMALL_STATE(1795)] = 33445,
  [SMALL_STATE(1796)] = 33506,
  [SMALL_STATE(1797)] = 33561,
  [SMALL_STATE(1798)] = 33616,
  [SMALL_STATE(1799)] = 33671,
  [SMALL_STATE(1800)] = 33726,
  [SMALL_STATE(1801)] = 33781,
  [SMALL_STATE(1802)] = 33836,
  [SMALL_STATE(1803)] = 33891,
  [SMALL_STATE(1804)] = 33946,
  [SMALL_STATE(1805)] = 34001,
  [SMALL_STATE(1806)] = 34056,
  [SMALL_STATE(1807)] = 34111,
  [SMALL_STATE(1808)] = 34165,
  [SMALL_STATE(1809)] = 34219,
  [SMALL_STATE(1810)] = 34273,
  [SMALL_STATE(1811)] = 34327,
  [SMALL_STATE(1812)] = 34381,
  [SMALL_STATE(1813)] = 34435,
  [SMALL_STATE(1814)] = 34489,
  [SMALL_STATE(1815)] = 34543,
  [SMALL_STATE(1816)] = 34597,
  [SMALL_STATE(1817)] = 34651,
  [SMALL_STATE(1818)] = 34705,
  [SMALL_STATE(1819)] = 34759,
  [SMALL_STATE(1820)] = 34813,
  [SMALL_STATE(1821)] = 34867,
  [SMALL_STATE(1822)] = 34921,
  [SMALL_STATE(1823)] = 34975,
  [SMALL_STATE(1824)] = 35029,
  [SMALL_STATE(1825)] = 35083,
  [SMALL_STATE(1826)] = 35137,
  [SMALL_STATE(1827)] = 35191,
  [SMALL_STATE(1828)] = 35245,
  [SMALL_STATE(1829)] = 35299,
  [SMALL_STATE(1830)] = 35353,
  [SMALL_STATE(1831)] = 35407,
  [SMALL_STATE(1832)] = 35461,
  [SMALL_STATE(1833)] = 35515,
  [SMALL_STATE(1834)] = 35569,
  [SMALL_STATE(1835)] = 35623,
  [SMALL_STATE(1836)] = 35677,
  [SMALL_STATE(1837)] = 35731,
  [SMALL_STATE(1838)] = 35785,
  [SMALL_STATE(1839)] = 35839,
  [SMALL_STATE(1840)] = 35893,
  [SMALL_STATE(1841)] = 35947,
  [SMALL_STATE(1842)] = 36001,
  [SMALL_STATE(1843)] = 36055,
  [SMALL_STATE(1844)] = 36109,
  [SMALL_STATE(1845)] = 36163,
  [SMALL_STATE(1846)] = 36217,
  [SMALL_STATE(1847)] = 36283,
  [SMALL_STATE(1848)] = 36337,
  [SMALL_STATE(1849)] = 36391,
  [SMALL_STATE(1850)] = 36445,
  [SMALL_STATE(1851)] = 36499,
  [SMALL_STATE(1852)] = 36553,
  [SMALL_STATE(1853)] = 36607,
  [SMALL_STATE(1854)] = 36661,
  [SMALL_STATE(1855)] = 36715,
  [SMALL_STATE(1856)] = 36773,
  [SMALL_STATE(1857)] = 36827,
  [SMALL_STATE(1858)] = 36881,
  [SMALL_STATE(1859)] = 36935,
  [SMALL_STATE(1860)] = 36989,
  [SMALL_STATE(1861)] = 37043,
  [SMALL_STATE(1862)] = 37097,
  [SMALL_STATE(1863)] = 37151,
  [SMALL_STATE(1864)] = 37205,
  [SMALL_STATE(1865)] = 37259,
  [SMALL_STATE(1866)] = 37313,
  [SMALL_STATE(1867)] = 37367,
  [SMALL_STATE(1868)] = 37431,
  [SMALL_STATE(1869)] = 37485,
  [SMALL_STATE(1870)] = 37539,
  [SMALL_STATE(1871)] = 37593,
  [SMALL_STATE(1872)] = 37647,
  [SMALL_STATE(1873)] = 37701,
  [SMALL_STATE(1874)] = 37755,
  [SMALL_STATE(1875)] = 37809,
  [SMALL_STATE(1876)] = 37863,
  [SMALL_STATE(1877)] = 37917,
  [SMALL_STATE(1878)] = 37971,
  [SMALL_STATE(1879)] = 38025,
  [SMALL_STATE(1880)] = 38079,
  [SMALL_STATE(1881)] = 38133,
  [SMALL_STATE(1882)] = 38187,
  [SMALL_STATE(1883)] = 38241,
  [SMALL_STATE(1884)] = 38295,
  [SMALL_STATE(1885)] = 38349,
  [SMALL_STATE(1886)] = 38403,
  [SMALL_STATE(1887)] = 38457,
  [SMALL_STATE(1888)] = 38511,
  [SMALL_STATE(1889)] = 38565,
  [SMALL_STATE(1890)] = 38619,
  [SMALL_STATE(1891)] = 38673,
  [SMALL_STATE(1892)] = 38727,
  [SMALL_STATE(1893)] = 38781,
  [SMALL_STATE(1894)] = 38835,
  [SMALL_STATE(1895)] = 38889,
  [SMALL_STATE(1896)] = 38943,
  [SMALL_STATE(1897)] = 38997,
  [SMALL_STATE(1898)] = 39051,
  [SMALL_STATE(1899)] = 39105,
  [SMALL_STATE(1900)] = 39159,
  [SMALL_STATE(1901)] = 39213,
  [SMALL_STATE(1902)] = 39267,
  [SMALL_STATE(1903)] = 39321,
  [SMALL_STATE(1904)] = 39375,
  [SMALL_STATE(1905)] = 39429,
  [SMALL_STATE(1906)] = 39483,
  [SMALL_STATE(1907)] = 39537,
  [SMALL_STATE(1908)] = 39591,
  [SMALL_STATE(1909)] = 39645,
  [SMALL_STATE(1910)] = 39699,
  [SMALL_STATE(1911)] = 39753,
  [SMALL_STATE(1912)] = 39807,
  [SMALL_STATE(1913)] = 39861,
  [SMALL_STATE(1914)] = 39915,
  [SMALL_STATE(1915)] = 39971,
  [SMALL_STATE(1916)] = 40025,
  [SMALL_STATE(1917)] = 40079,
  [SMALL_STATE(1918)] = 40139,
  [SMALL_STATE(1919)] = 40199,
  [SMALL_STATE(1920)] = 40253,
  [SMALL_STATE(1921)] = 40313,
  [SMALL_STATE(1922)] = 40367,
  [SMALL_STATE(1923)] = 40421,
  [SMALL_STATE(1924)] = 40475,
  [SMALL_STATE(1925)] = 40533,
  [SMALL_STATE(1926)] = 40587,
  [SMALL_STATE(1927)] = 40641,
  [SMALL_STATE(1928)] = 40695,
  [SMALL_STATE(1929)] = 40749,
  [SMALL_STATE(1930)] = 40803,
  [SMALL_STATE(1931)] = 40863,
  [SMALL_STATE(1932)] = 40917,
  [SMALL_STATE(1933)] = 40971,
  [SMALL_STATE(1934)] = 41025,
  [SMALL_STATE(1935)] = 41079,
  [SMALL_STATE(1936)] = 41133,
  [SMALL_STATE(1937)] = 41187,
  [SMALL_STATE(1938)] = 41241,
  [SMALL_STATE(1939)] = 41295,
  [SMALL_STATE(1940)] = 41349,
  [SMALL_STATE(1941)] = 41403,
  [SMALL_STATE(1942)] = 41461,
  [SMALL_STATE(1943)] = 41521,
  [SMALL_STATE(1944)] = 41579,
  [SMALL_STATE(1945)] = 41637,
  [SMALL_STATE(1946)] = 41691,
  [SMALL_STATE(1947)] = 41745,
  [SMALL_STATE(1948)] = 41799,
  [SMALL_STATE(1949)] = 41853,
  [SMALL_STATE(1950)] = 41907,
  [SMALL_STATE(1951)] = 41967,
  [SMALL_STATE(1952)] = 42021,
  [SMALL_STATE(1953)] = 42075,
  [SMALL_STATE(1954)] = 42131,
  [SMALL_STATE(1955)] = 42185,
  [SMALL_STATE(1956)] = 42239,
  [SMALL_STATE(1957)] = 42297,
  [SMALL_STATE(1958)] = 42353,
  [SMALL_STATE(1959)] = 42408,
  [SMALL_STATE(1960)] = 42463,
  [SMALL_STATE(1961)] = 42520,
  [SMALL_STATE(1962)] = 42573,
  [SMALL_STATE(1963)] = 42628,
  [SMALL_STATE(1964)] = 42681,
  [SMALL_STATE(1965)] = 42734,
  [SMALL_STATE(1966)] = 42791,
  [SMALL_STATE(1967)] = 42848,
  [SMALL_STATE(1968)] = 42905,
  [SMALL_STATE(1969)] = 42960,
  [SMALL_STATE(1970)] = 43013,
  [SMALL_STATE(1971)] = 43068,
  [SMALL_STATE(1972)] = 43125,
  [SMALL_STATE(1973)] = 43178,
  [SMALL_STATE(1974)] = 43231,
  [SMALL_STATE(1975)] = 43284,
  [SMALL_STATE(1976)] = 43337,
  [SMALL_STATE(1977)] = 43394,
  [SMALL_STATE(1978)] = 43447,
  [SMALL_STATE(1979)] = 43502,
  [SMALL_STATE(1980)] = 43555,
  [SMALL_STATE(1981)] = 43610,
  [SMALL_STATE(1982)] = 43663,
  [SMALL_STATE(1983)] = 43716,
  [SMALL_STATE(1984)] = 43769,
  [SMALL_STATE(1985)] = 43821,
  [SMALL_STATE(1986)] = 43873,
  [SMALL_STATE(1987)] = 43925,
  [SMALL_STATE(1988)] = 43979,
  [SMALL_STATE(1989)] = 44031,
  [SMALL_STATE(1990)] = 44083,
  [SMALL_STATE(1991)] = 44135,
  [SMALL_STATE(1992)] = 44187,
  [SMALL_STATE(1993)] = 44241,
  [SMALL_STATE(1994)] = 44293,
  [SMALL_STATE(1995)] = 44345,
  [SMALL_STATE(1996)] = 44397,
  [SMALL_STATE(1997)] = 44449,
  [SMALL_STATE(1998)] = 44501,
  [SMALL_STATE(1999)] = 44561,
  [SMALL_STATE(2000)] = 44613,
  [SMALL_STATE(2001)] = 44669,
  [SMALL_STATE(2002)] = 44721,
  [SMALL_STATE(2003)] = 44781,
  [SMALL_STATE(2004)] = 44833,
  [SMALL_STATE(2005)] = 44885,
  [SMALL_STATE(2006)] = 44939,
  [SMALL_STATE(2007)] = 44991,
  [SMALL_STATE(2008)] = 45043,
  [SMALL_STATE(2009)] = 45095,
  [SMALL_STATE(2010)] = 45147,
  [SMALL_STATE(2011)] = 45199,
  [SMALL_STATE(2012)] = 45251,
  [SMALL_STATE(2013)] = 45303,
  [SMALL_STATE(2014)] = 45355,
  [SMALL_STATE(2015)] = 45407,
  [SMALL_STATE(2016)] = 45459,
  [SMALL_STATE(2017)] = 45511,
  [SMALL_STATE(2018)] = 45563,
  [SMALL_STATE(2019)] = 45615,
  [SMALL_STATE(2020)] = 45667,
  [SMALL_STATE(2021)] = 45719,
  [SMALL_STATE(2022)] = 45771,
  [SMALL_STATE(2023)] = 45823,
  [SMALL_STATE(2024)] = 45875,
  [SMALL_STATE(2025)] = 45927,
  [SMALL_STATE(2026)] = 45981,
  [SMALL_STATE(2027)] = 46033,
  [SMALL_STATE(2028)] = 46085,
  [SMALL_STATE(2029)] = 46137,
  [SMALL_STATE(2030)] = 46189,
  [SMALL_STATE(2031)] = 46241,
  [SMALL_STATE(2032)] = 46293,
  [SMALL_STATE(2033)] = 46345,
  [SMALL_STATE(2034)] = 46397,
  [SMALL_STATE(2035)] = 46449,
  [SMALL_STATE(2036)] = 46501,
  [SMALL_STATE(2037)] = 46553,
  [SMALL_STATE(2038)] = 46605,
  [SMALL_STATE(2039)] = 46657,
  [SMALL_STATE(2040)] = 46709,
  [SMALL_STATE(2041)] = 46761,
  [SMALL_STATE(2042)] = 46813,
  [SMALL_STATE(2043)] = 46865,
  [SMALL_STATE(2044)] = 46917,
  [SMALL_STATE(2045)] = 46969,
  [SMALL_STATE(2046)] = 47021,
  [SMALL_STATE(2047)] = 47073,
  [SMALL_STATE(2048)] = 47125,
  [SMALL_STATE(2049)] = 47177,
  [SMALL_STATE(2050)] = 47229,
  [SMALL_STATE(2051)] = 47281,
  [SMALL_STATE(2052)] = 47333,
  [SMALL_STATE(2053)] = 47385,
  [SMALL_STATE(2054)] = 47439,
  [SMALL_STATE(2055)] = 47491,
  [SMALL_STATE(2056)] = 47543,
  [SMALL_STATE(2057)] = 47595,
  [SMALL_STATE(2058)] = 47647,
  [SMALL_STATE(2059)] = 47699,
  [SMALL_STATE(2060)] = 47751,
  [SMALL_STATE(2061)] = 47803,
  [SMALL_STATE(2062)] = 47855,
  [SMALL_STATE(2063)] = 47907,
  [SMALL_STATE(2064)] = 47959,
  [SMALL_STATE(2065)] = 48011,
  [SMALL_STATE(2066)] = 48063,
  [SMALL_STATE(2067)] = 48115,
  [SMALL_STATE(2068)] = 48167,
  [SMALL_STATE(2069)] = 48219,
  [SMALL_STATE(2070)] = 48271,
  [SMALL_STATE(2071)] = 48323,
  [SMALL_STATE(2072)] = 48375,
  [SMALL_STATE(2073)] = 48427,
  [SMALL_STATE(2074)] = 48479,
  [SMALL_STATE(2075)] = 48531,
  [SMALL_STATE(2076)] = 48583,
  [SMALL_STATE(2077)] = 48635,
  [SMALL_STATE(2078)] = 48687,
  [SMALL_STATE(2079)] = 48739,
  [SMALL_STATE(2080)] = 48795,
  [SMALL_STATE(2081)] = 48847,
  [SMALL_STATE(2082)] = 48911,
  [SMALL_STATE(2083)] = 48963,
  [SMALL_STATE(2084)] = 49015,
  [SMALL_STATE(2085)] = 49067,
  [SMALL_STATE(2086)] = 49119,
  [SMALL_STATE(2087)] = 49171,
  [SMALL_STATE(2088)] = 49223,
  [SMALL_STATE(2089)] = 49275,
  [SMALL_STATE(2090)] = 49327,
  [SMALL_STATE(2091)] = 49379,
  [SMALL_STATE(2092)] = 49435,
  [SMALL_STATE(2093)] = 49487,
  [SMALL_STATE(2094)] = 49539,
  [SMALL_STATE(2095)] = 49591,
  [SMALL_STATE(2096)] = 49643,
  [SMALL_STATE(2097)] = 49695,
  [SMALL_STATE(2098)] = 49747,
  [SMALL_STATE(2099)] = 49801,
  [SMALL_STATE(2100)] = 49853,
  [SMALL_STATE(2101)] = 49917,
  [SMALL_STATE(2102)] = 49969,
  [SMALL_STATE(2103)] = 50021,
  [SMALL_STATE(2104)] = 50073,
  [SMALL_STATE(2105)] = 50125,
  [SMALL_STATE(2106)] = 50177,
  [SMALL_STATE(2107)] = 50229,
  [SMALL_STATE(2108)] = 50281,
  [SMALL_STATE(2109)] = 50333,
  [SMALL_STATE(2110)] = 50385,
  [SMALL_STATE(2111)] = 50437,
  [SMALL_STATE(2112)] = 50489,
  [SMALL_STATE(2113)] = 50541,
  [SMALL_STATE(2114)] = 50593,
  [SMALL_STATE(2115)] = 50645,
  [SMALL_STATE(2116)] = 50697,
  [SMALL_STATE(2117)] = 50749,
  [SMALL_STATE(2118)] = 50801,
  [SMALL_STATE(2119)] = 50853,
  [SMALL_STATE(2120)] = 50907,
  [SMALL_STATE(2121)] = 50959,
  [SMALL_STATE(2122)] = 51011,
  [SMALL_STATE(2123)] = 51063,
  [SMALL_STATE(2124)] = 51115,
  [SMALL_STATE(2125)] = 51166,
  [SMALL_STATE(2126)] = 51217,
  [SMALL_STATE(2127)] = 51268,
  [SMALL_STATE(2128)] = 51319,
  [SMALL_STATE(2129)] = 51370,
  [SMALL_STATE(2130)] = 51433,
  [SMALL_STATE(2131)] = 51484,
  [SMALL_STATE(2132)] = 51535,
  [SMALL_STATE(2133)] = 51586,
  [SMALL_STATE(2134)] = 51637,
  [SMALL_STATE(2135)] = 51688,
  [SMALL_STATE(2136)] = 51739,
  [SMALL_STATE(2137)] = 51790,
  [SMALL_STATE(2138)] = 51841,
  [SMALL_STATE(2139)] = 51904,
  [SMALL_STATE(2140)] = 51955,
  [SMALL_STATE(2141)] = 52006,
  [SMALL_STATE(2142)] = 52057,
  [SMALL_STATE(2143)] = 52108,
  [SMALL_STATE(2144)] = 52159,
  [SMALL_STATE(2145)] = 52210,
  [SMALL_STATE(2146)] = 52261,
  [SMALL_STATE(2147)] = 52312,
  [SMALL_STATE(2148)] = 52363,
  [SMALL_STATE(2149)] = 52414,
  [SMALL_STATE(2150)] = 52465,
  [SMALL_STATE(2151)] = 52516,
  [SMALL_STATE(2152)] = 52571,
  [SMALL_STATE(2153)] = 52622,
  [SMALL_STATE(2154)] = 52673,
  [SMALL_STATE(2155)] = 52724,
  [SMALL_STATE(2156)] = 52775,
  [SMALL_STATE(2157)] = 52826,
  [SMALL_STATE(2158)] = 52877,
  [SMALL_STATE(2159)] = 52928,
  [SMALL_STATE(2160)] = 52979,
  [SMALL_STATE(2161)] = 53030,
  [SMALL_STATE(2162)] = 53081,
  [SMALL_STATE(2163)] = 53132,
  [SMALL_STATE(2164)] = 53183,
  [SMALL_STATE(2165)] = 53234,
  [SMALL_STATE(2166)] = 53289,
  [SMALL_STATE(2167)] = 53340,
  [SMALL_STATE(2168)] = 53391,
  [SMALL_STATE(2169)] = 53442,
  [SMALL_STATE(2170)] = 53501,
  [SMALL_STATE(2171)] = 53552,
  [SMALL_STATE(2172)] = 53603,
  [SMALL_STATE(2173)] = 53662,
  [SMALL_STATE(2174)] = 53713,
  [SMALL_STATE(2175)] = 53764,
  [SMALL_STATE(2176)] = 53815,
  [SMALL_STATE(2177)] = 53866,
  [SMALL_STATE(2178)] = 53917,
  [SMALL_STATE(2179)] = 53968,
  [SMALL_STATE(2180)] = 54031,
  [SMALL_STATE(2181)] = 54082,
  [SMALL_STATE(2182)] = 54133,
  [SMALL_STATE(2183)] = 54184,
  [SMALL_STATE(2184)] = 54235,
  [SMALL_STATE(2185)] = 54286,
  [SMALL_STATE(2186)] = 54337,
  [SMALL_STATE(2187)] = 54388,
  [SMALL_STATE(2188)] = 54439,
  [SMALL_STATE(2189)] = 54490,
  [SMALL_STATE(2190)] = 54553,
  [SMALL_STATE(2191)] = 54604,
  [SMALL_STATE(2192)] = 54655,
  [SMALL_STATE(2193)] = 54718,
  [SMALL_STATE(2194)] = 54769,
  [SMALL_STATE(2195)] = 54820,
  [SMALL_STATE(2196)] = 54871,
  [SMALL_STATE(2197)] = 54922,
  [SMALL_STATE(2198)] = 54973,
  [SMALL_STATE(2199)] = 55024,
  [SMALL_STATE(2200)] = 55081,
  [SMALL_STATE(2201)] = 55132,
  [SMALL_STATE(2202)] = 55183,
  [SMALL_STATE(2203)] = 55234,
  [SMALL_STATE(2204)] = 55293,
  [SMALL_STATE(2205)] = 55344,
  [SMALL_STATE(2206)] = 55395,
  [SMALL_STATE(2207)] = 55446,
  [SMALL_STATE(2208)] = 55505,
  [SMALL_STATE(2209)] = 55556,
  [SMALL_STATE(2210)] = 55607,
  [SMALL_STATE(2211)] = 55658,
  [SMALL_STATE(2212)] = 55709,
  [SMALL_STATE(2213)] = 55760,
  [SMALL_STATE(2214)] = 55811,
  [SMALL_STATE(2215)] = 55862,
  [SMALL_STATE(2216)] = 55913,
  [SMALL_STATE(2217)] = 55964,
  [SMALL_STATE(2218)] = 56019,
  [SMALL_STATE(2219)] = 56070,
  [SMALL_STATE(2220)] = 56121,
  [SMALL_STATE(2221)] = 56176,
  [SMALL_STATE(2222)] = 56227,
  [SMALL_STATE(2223)] = 56278,
  [SMALL_STATE(2224)] = 56329,
  [SMALL_STATE(2225)] = 56380,
  [SMALL_STATE(2226)] = 56431,
  [SMALL_STATE(2227)] = 56482,
  [SMALL_STATE(2228)] = 56533,
  [SMALL_STATE(2229)] = 56584,
  [SMALL_STATE(2230)] = 56635,
  [SMALL_STATE(2231)] = 56686,
  [SMALL_STATE(2232)] = 56737,
  [SMALL_STATE(2233)] = 56788,
  [SMALL_STATE(2234)] = 56843,
  [SMALL_STATE(2235)] = 56894,
  [SMALL_STATE(2236)] = 56945,
  [SMALL_STATE(2237)] = 56996,
  [SMALL_STATE(2238)] = 57047,
  [SMALL_STATE(2239)] = 57098,
  [SMALL_STATE(2240)] = 57149,
  [SMALL_STATE(2241)] = 57208,
  [SMALL_STATE(2242)] = 57267,
  [SMALL_STATE(2243)] = 57318,
  [SMALL_STATE(2244)] = 57369,
  [SMALL_STATE(2245)] = 57426,
  [SMALL_STATE(2246)] = 57477,
  [SMALL_STATE(2247)] = 57532,
  [SMALL_STATE(2248)] = 57595,
  [SMALL_STATE(2249)] = 57646,
  [SMALL_STATE(2250)] = 57697,
  [SMALL_STATE(2251)] = 57748,
  [SMALL_STATE(2252)] = 57801,
  [SMALL_STATE(2253)] = 57852,
  [SMALL_STATE(2254)] = 57907,
  [SMALL_STATE(2255)] = 57958,
  [SMALL_STATE(2256)] = 58009,
  [SMALL_STATE(2257)] = 58062,
  [SMALL_STATE(2258)] = 58113,
  [SMALL_STATE(2259)] = 58164,
  [SMALL_STATE(2260)] = 58215,
  [SMALL_STATE(2261)] = 58266,
  [SMALL_STATE(2262)] = 58321,
  [SMALL_STATE(2263)] = 58372,
  [SMALL_STATE(2264)] = 58423,
  [SMALL_STATE(2265)] = 58474,
  [SMALL_STATE(2266)] = 58525,
  [SMALL_STATE(2267)] = 58587,
  [SMALL_STATE(2268)] = 58643,
  [SMALL_STATE(2269)] = 58693,
  [SMALL_STATE(2270)] = 58743,
  [SMALL_STATE(2271)] = 58793,
  [SMALL_STATE(2272)] = 58847,
  [SMALL_STATE(2273)] = 58905,
  [SMALL_STATE(2274)] = 58967,
  [SMALL_STATE(2275)] = 59017,
  [SMALL_STATE(2276)] = 59079,
  [SMALL_STATE(2277)] = 59129,
  [SMALL_STATE(2278)] = 59191,
  [SMALL_STATE(2279)] = 59241,
  [SMALL_STATE(2280)] = 59295,
  [SMALL_STATE(2281)] = 59351,
  [SMALL_STATE(2282)] = 59401,
  [SMALL_STATE(2283)] = 59451,
  [SMALL_STATE(2284)] = 59503,
  [SMALL_STATE(2285)] = 59553,
  [SMALL_STATE(2286)] = 59607,
  [SMALL_STATE(2287)] = 59657,
  [SMALL_STATE(2288)] = 59713,
  [SMALL_STATE(2289)] = 59767,
  [SMALL_STATE(2290)] = 59825,
  [SMALL_STATE(2291)] = 59883,
  [SMALL_STATE(2292)] = 59937,
  [SMALL_STATE(2293)] = 59989,
  [SMALL_STATE(2294)] = 60043,
  [SMALL_STATE(2295)] = 60093,
  [SMALL_STATE(2296)] = 60145,
  [SMALL_STATE(2297)] = 60201,
  [SMALL_STATE(2298)] = 60253,
  [SMALL_STATE(2299)] = 60303,
  [SMALL_STATE(2300)] = 60353,
  [SMALL_STATE(2301)] = 60443,
  [SMALL_STATE(2302)] = 60501,
  [SMALL_STATE(2303)] = 60559,
  [SMALL_STATE(2304)] = 60609,
  [SMALL_STATE(2305)] = 60659,
  [SMALL_STATE(2306)] = 60709,
  [SMALL_STATE(2307)] = 60767,
  [SMALL_STATE(2308)] = 60823,
  [SMALL_STATE(2309)] = 60879,
  [SMALL_STATE(2310)] = 60940,
  [SMALL_STATE(2311)] = 61001,
  [SMALL_STATE(2312)] = 61050,
  [SMALL_STATE(2313)] = 61099,
  [SMALL_STATE(2314)] = 61148,
  [SMALL_STATE(2315)] = 61209,
  [SMALL_STATE(2316)] = 61262,
  [SMALL_STATE(2317)] = 61315,
  [SMALL_STATE(2318)] = 61364,
  [SMALL_STATE(2319)] = 61421,
  [SMALL_STATE(2320)] = 61470,
  [SMALL_STATE(2321)] = 61523,
  [SMALL_STATE(2322)] = 61584,
  [SMALL_STATE(2323)] = 61633,
  [SMALL_STATE(2324)] = 61684,
  [SMALL_STATE(2325)] = 61737,
  [SMALL_STATE(2326)] = 61798,
  [SMALL_STATE(2327)] = 61847,
  [SMALL_STATE(2328)] = 61900,
  [SMALL_STATE(2329)] = 61949,
  [SMALL_STATE(2330)] = 62002,
  [SMALL_STATE(2331)] = 62059,
  [SMALL_STATE(2332)] = 62108,
  [SMALL_STATE(2333)] = 62161,
  [SMALL_STATE(2334)] = 62210,
  [SMALL_STATE(2335)] = 62267,
  [SMALL_STATE(2336)] = 62316,
  [SMALL_STATE(2337)] = 62367,
  [SMALL_STATE(2338)] = 62416,
  [SMALL_STATE(2339)] = 62465,
  [SMALL_STATE(2340)] = 62514,
  [SMALL_STATE(2341)] = 62571,
  [SMALL_STATE(2342)] = 62624,
  [SMALL_STATE(2343)] = 62673,
  [SMALL_STATE(2344)] = 62722,
  [SMALL_STATE(2345)] = 62775,
  [SMALL_STATE(2346)] = 62830,
  [SMALL_STATE(2347)] = 62883,
  [SMALL_STATE(2348)] = 62932,
  [SMALL_STATE(2349)] = 62985,
  [SMALL_STATE(2350)] = 63038,
  [SMALL_STATE(2351)] = 63091,
  [SMALL_STATE(2352)] = 63144,
  [SMALL_STATE(2353)] = 63193,
  [SMALL_STATE(2354)] = 63242,
  [SMALL_STATE(2355)] = 63297,
  [SMALL_STATE(2356)] = 63346,
  [SMALL_STATE(2357)] = 63395,
  [SMALL_STATE(2358)] = 63448,
  [SMALL_STATE(2359)] = 63497,
  [SMALL_STATE(2360)] = 63546,
  [SMALL_STATE(2361)] = 63599,
  [SMALL_STATE(2362)] = 63652,
  [SMALL_STATE(2363)] = 63701,
  [SMALL_STATE(2364)] = 63750,
  [SMALL_STATE(2365)] = 63801,
  [SMALL_STATE(2366)] = 63858,
  [SMALL_STATE(2367)] = 63915,
  [SMALL_STATE(2368)] = 63964,
  [SMALL_STATE(2369)] = 64017,
  [SMALL_STATE(2370)] = 64070,
  [SMALL_STATE(2371)] = 64123,
  [SMALL_STATE(2372)] = 64174,
  [SMALL_STATE(2373)] = 64223,
  [SMALL_STATE(2374)] = 64274,
  [SMALL_STATE(2375)] = 64323,
  [SMALL_STATE(2376)] = 64372,
  [SMALL_STATE(2377)] = 64433,
  [SMALL_STATE(2378)] = 64482,
  [SMALL_STATE(2379)] = 64531,
  [SMALL_STATE(2380)] = 64584,
  [SMALL_STATE(2381)] = 64645,
  [SMALL_STATE(2382)] = 64698,
  [SMALL_STATE(2383)] = 64747,
  [SMALL_STATE(2384)] = 64800,
  [SMALL_STATE(2385)] = 64849,
  [SMALL_STATE(2386)] = 64898,
  [SMALL_STATE(2387)] = 64947,
  [SMALL_STATE(2388)] = 64996,
  [SMALL_STATE(2389)] = 65057,
  [SMALL_STATE(2390)] = 65110,
  [SMALL_STATE(2391)] = 65159,
  [SMALL_STATE(2392)] = 65209,
  [SMALL_STATE(2393)] = 65257,
  [SMALL_STATE(2394)] = 65305,
  [SMALL_STATE(2395)] = 65353,
  [SMALL_STATE(2396)] = 65401,
  [SMALL_STATE(2397)] = 65449,
  [SMALL_STATE(2398)] = 65503,
  [SMALL_STATE(2399)] = 65551,
  [SMALL_STATE(2400)] = 65599,
  [SMALL_STATE(2401)] = 65647,
  [SMALL_STATE(2402)] = 65695,
  [SMALL_STATE(2403)] = 65743,
  [SMALL_STATE(2404)] = 65791,
  [SMALL_STATE(2405)] = 65839,
  [SMALL_STATE(2406)] = 65887,
  [SMALL_STATE(2407)] = 65935,
  [SMALL_STATE(2408)] = 65983,
  [SMALL_STATE(2409)] = 66031,
  [SMALL_STATE(2410)] = 66083,
  [SMALL_STATE(2411)] = 66131,
  [SMALL_STATE(2412)] = 66179,
  [SMALL_STATE(2413)] = 66227,
  [SMALL_STATE(2414)] = 66275,
  [SMALL_STATE(2415)] = 66335,
  [SMALL_STATE(2416)] = 66383,
  [SMALL_STATE(2417)] = 66443,
  [SMALL_STATE(2418)] = 66491,
  [SMALL_STATE(2419)] = 66539,
  [SMALL_STATE(2420)] = 66587,
  [SMALL_STATE(2421)] = 66635,
  [SMALL_STATE(2422)] = 66683,
  [SMALL_STATE(2423)] = 66731,
  [SMALL_STATE(2424)] = 66779,
  [SMALL_STATE(2425)] = 66827,
  [SMALL_STATE(2426)] = 66875,
  [SMALL_STATE(2427)] = 66923,
  [SMALL_STATE(2428)] = 66971,
  [SMALL_STATE(2429)] = 67019,
  [SMALL_STATE(2430)] = 67067,
  [SMALL_STATE(2431)] = 67115,
  [SMALL_STATE(2432)] = 67163,
  [SMALL_STATE(2433)] = 67215,
  [SMALL_STATE(2434)] = 67267,
  [SMALL_STATE(2435)] = 67315,
  [SMALL_STATE(2436)] = 67363,
  [SMALL_STATE(2437)] = 67411,
  [SMALL_STATE(2438)] = 67459,
  [SMALL_STATE(2439)] = 67507,
  [SMALL_STATE(2440)] = 67555,
  [SMALL_STATE(2441)] = 67603,
  [SMALL_STATE(2442)] = 67651,
  [SMALL_STATE(2443)] = 67699,
  [SMALL_STATE(2444)] = 67751,
  [SMALL_STATE(2445)] = 67803,
  [SMALL_STATE(2446)] = 67851,
  [SMALL_STATE(2447)] = 67899,
  [SMALL_STATE(2448)] = 67947,
  [SMALL_STATE(2449)] = 67995,
  [SMALL_STATE(2450)] = 68043,
  [SMALL_STATE(2451)] = 68091,
  [SMALL_STATE(2452)] = 68139,
  [SMALL_STATE(2453)] = 68187,
  [SMALL_STATE(2454)] = 68235,
  [SMALL_STATE(2455)] = 68283,
  [SMALL_STATE(2456)] = 68335,
  [SMALL_STATE(2457)] = 68383,
  [SMALL_STATE(2458)] = 68431,
  [SMALL_STATE(2459)] = 68483,
  [SMALL_STATE(2460)] = 68531,
  [SMALL_STATE(2461)] = 68579,
  [SMALL_STATE(2462)] = 68627,
  [SMALL_STATE(2463)] = 68675,
  [SMALL_STATE(2464)] = 68723,
  [SMALL_STATE(2465)] = 68771,
  [SMALL_STATE(2466)] = 68819,
  [SMALL_STATE(2467)] = 68871,
  [SMALL_STATE(2468)] = 68921,
  [SMALL_STATE(2469)] = 68969,
  [SMALL_STATE(2470)] = 69017,
  [SMALL_STATE(2471)] = 69065,
  [SMALL_STATE(2472)] = 69125,
  [SMALL_STATE(2473)] = 69179,
  [SMALL_STATE(2474)] = 69227,
  [SMALL_STATE(2475)] = 69275,
  [SMALL_STATE(2476)] = 69323,
  [SMALL_STATE(2477)] = 69371,
  [SMALL_STATE(2478)] = 69423,
  [SMALL_STATE(2479)] = 69473,
  [SMALL_STATE(2480)] = 69521,
  [SMALL_STATE(2481)] = 69569,
  [SMALL_STATE(2482)] = 69617,
  [SMALL_STATE(2483)] = 69669,
  [SMALL_STATE(2484)] = 69723,
  [SMALL_STATE(2485)] = 69777,
  [SMALL_STATE(2486)] = 69825,
  [SMALL_STATE(2487)] = 69875,
  [SMALL_STATE(2488)] = 69923,
  [SMALL_STATE(2489)] = 69971,
  [SMALL_STATE(2490)] = 70019,
  [SMALL_STATE(2491)] = 70067,
  [SMALL_STATE(2492)] = 70119,
  [SMALL_STATE(2493)] = 70167,
  [SMALL_STATE(2494)] = 70215,
  [SMALL_STATE(2495)] = 70263,
  [SMALL_STATE(2496)] = 70311,
  [SMALL_STATE(2497)] = 70359,
  [SMALL_STATE(2498)] = 70407,
  [SMALL_STATE(2499)] = 70455,
  [SMALL_STATE(2500)] = 70503,
  [SMALL_STATE(2501)] = 70553,
  [SMALL_STATE(2502)] = 70601,
  [SMALL_STATE(2503)] = 70649,
  [SMALL_STATE(2504)] = 70697,
  [SMALL_STATE(2505)] = 70745,
  [SMALL_STATE(2506)] = 70793,
  [SMALL_STATE(2507)] = 70841,
  [SMALL_STATE(2508)] = 70891,
  [SMALL_STATE(2509)] = 70939,
  [SMALL_STATE(2510)] = 70987,
  [SMALL_STATE(2511)] = 71035,
  [SMALL_STATE(2512)] = 71085,
  [SMALL_STATE(2513)] = 71133,
  [SMALL_STATE(2514)] = 71181,
  [SMALL_STATE(2515)] = 71229,
  [SMALL_STATE(2516)] = 71277,
  [SMALL_STATE(2517)] = 71325,
  [SMALL_STATE(2518)] = 71373,
  [SMALL_STATE(2519)] = 71421,
  [SMALL_STATE(2520)] = 71469,
  [SMALL_STATE(2521)] = 71517,
  [SMALL_STATE(2522)] = 71565,
  [SMALL_STATE(2523)] = 71613,
  [SMALL_STATE(2524)] = 71663,
  [SMALL_STATE(2525)] = 71711,
  [SMALL_STATE(2526)] = 71767,
  [SMALL_STATE(2527)] = 71815,
  [SMALL_STATE(2528)] = 71863,
  [SMALL_STATE(2529)] = 71919,
  [SMALL_STATE(2530)] = 71967,
  [SMALL_STATE(2531)] = 72015,
  [SMALL_STATE(2532)] = 72063,
  [SMALL_STATE(2533)] = 72117,
  [SMALL_STATE(2534)] = 72165,
  [SMALL_STATE(2535)] = 72213,
  [SMALL_STATE(2536)] = 72261,
  [SMALL_STATE(2537)] = 72309,
  [SMALL_STATE(2538)] = 72365,
  [SMALL_STATE(2539)] = 72417,
  [SMALL_STATE(2540)] = 72469,
  [SMALL_STATE(2541)] = 72517,
  [SMALL_STATE(2542)] = 72565,
  [SMALL_STATE(2543)] = 72621,
  [SMALL_STATE(2544)] = 72671,
  [SMALL_STATE(2545)] = 72719,
  [SMALL_STATE(2546)] = 72773,
  [SMALL_STATE(2547)] = 72821,
  [SMALL_STATE(2548)] = 72869,
  [SMALL_STATE(2549)] = 72921,
  [SMALL_STATE(2550)] = 72969,
  [SMALL_STATE(2551)] = 73025,
  [SMALL_STATE(2552)] = 73073,
  [SMALL_STATE(2553)] = 73121,
  [SMALL_STATE(2554)] = 73173,
  [SMALL_STATE(2555)] = 73221,
  [SMALL_STATE(2556)] = 73277,
  [SMALL_STATE(2557)] = 73333,
  [SMALL_STATE(2558)] = 73389,
  [SMALL_STATE(2559)] = 73437,
  [SMALL_STATE(2560)] = 73485,
  [SMALL_STATE(2561)] = 73533,
  [SMALL_STATE(2562)] = 73581,
  [SMALL_STATE(2563)] = 73635,
  [SMALL_STATE(2564)] = 73691,
  [SMALL_STATE(2565)] = 73741,
  [SMALL_STATE(2566)] = 73795,
  [SMALL_STATE(2567)] = 73843,
  [SMALL_STATE(2568)] = 73895,
  [SMALL_STATE(2569)] = 73951,
  [SMALL_STATE(2570)] = 74011,
  [SMALL_STATE(2571)] = 74061,
  [SMALL_STATE(2572)] = 74115,
  [SMALL_STATE(2573)] = 74171,
  [SMALL_STATE(2574)] = 74225,
  [SMALL_STATE(2575)] = 74279,
  [SMALL_STATE(2576)] = 74329,
  [SMALL_STATE(2577)] = 74379,
  [SMALL_STATE(2578)] = 74433,
  [SMALL_STATE(2579)] = 74485,
  [SMALL_STATE(2580)] = 74533,
  [SMALL_STATE(2581)] = 74585,
  [SMALL_STATE(2582)] = 74641,
  [SMALL_STATE(2583)] = 74691,
  [SMALL_STATE(2584)] = 74739,
  [SMALL_STATE(2585)] = 74795,
  [SMALL_STATE(2586)] = 74847,
  [SMALL_STATE(2587)] = 74895,
  [SMALL_STATE(2588)] = 74951,
  [SMALL_STATE(2589)] = 75007,
  [SMALL_STATE(2590)] = 75067,
  [SMALL_STATE(2591)] = 75123,
  [SMALL_STATE(2592)] = 75175,
  [SMALL_STATE(2593)] = 75229,
  [SMALL_STATE(2594)] = 75279,
  [SMALL_STATE(2595)] = 75335,
  [SMALL_STATE(2596)] = 75391,
  [SMALL_STATE(2597)] = 75439,
  [SMALL_STATE(2598)] = 75495,
  [SMALL_STATE(2599)] = 75551,
  [SMALL_STATE(2600)] = 75611,
  [SMALL_STATE(2601)] = 75663,
  [SMALL_STATE(2602)] = 75719,
  [SMALL_STATE(2603)] = 75769,
  [SMALL_STATE(2604)] = 75825,
  [SMALL_STATE(2605)] = 75873,
  [SMALL_STATE(2606)] = 75925,
  [SMALL_STATE(2607)] = 75973,
  [SMALL_STATE(2608)] = 76021,
  [SMALL_STATE(2609)] = 76069,
  [SMALL_STATE(2610)] = 76117,
  [SMALL_STATE(2611)] = 76165,
  [SMALL_STATE(2612)] = 76213,
  [SMALL_STATE(2613)] = 76261,
  [SMALL_STATE(2614)] = 76309,
  [SMALL_STATE(2615)] = 76357,
  [SMALL_STATE(2616)] = 76405,
  [SMALL_STATE(2617)] = 76453,
  [SMALL_STATE(2618)] = 76509,
  [SMALL_STATE(2619)] = 76565,
  [SMALL_STATE(2620)] = 76613,
  [SMALL_STATE(2621)] = 76661,
  [SMALL_STATE(2622)] = 76717,
  [SMALL_STATE(2623)] = 76773,
  [SMALL_STATE(2624)] = 76820,
  [SMALL_STATE(2625)] = 76873,
  [SMALL_STATE(2626)] = 76928,
  [SMALL_STATE(2627)] = 76983,
  [SMALL_STATE(2628)] = 77038,
  [SMALL_STATE(2629)] = 77091,
  [SMALL_STATE(2630)] = 77146,
  [SMALL_STATE(2631)] = 77201,
  [SMALL_STATE(2632)] = 77256,
  [SMALL_STATE(2633)] = 77311,
  [SMALL_STATE(2634)] = 77358,
  [SMALL_STATE(2635)] = 77411,
  [SMALL_STATE(2636)] = 77458,
  [SMALL_STATE(2637)] = 77513,
  [SMALL_STATE(2638)] = 77568,
  [SMALL_STATE(2639)] = 77623,
  [SMALL_STATE(2640)] = 77674,
  [SMALL_STATE(2641)] = 77729,
  [SMALL_STATE(2642)] = 77784,
  [SMALL_STATE(2643)] = 77839,
  [SMALL_STATE(2644)] = 77892,
  [SMALL_STATE(2645)] = 77943,
  [SMALL_STATE(2646)] = 77998,
  [SMALL_STATE(2647)] = 78051,
  [SMALL_STATE(2648)] = 78104,
  [SMALL_STATE(2649)] = 78159,
  [SMALL_STATE(2650)] = 78214,
  [SMALL_STATE(2651)] = 78267,
  [SMALL_STATE(2652)] = 78322,
  [SMALL_STATE(2653)] = 78377,
  [SMALL_STATE(2654)] = 78432,
  [SMALL_STATE(2655)] = 78487,
  [SMALL_STATE(2656)] = 78538,
  [SMALL_STATE(2657)] = 78593,
  [SMALL_STATE(2658)] = 78640,
  [SMALL_STATE(2659)] = 78687,
  [SMALL_STATE(2660)] = 78734,
  [SMALL_STATE(2661)] = 78789,
  [SMALL_STATE(2662)] = 78836,
  [SMALL_STATE(2663)] = 78885,
  [SMALL_STATE(2664)] = 78932,
  [SMALL_STATE(2665)] = 78987,
  [SMALL_STATE(2666)] = 79042,
  [SMALL_STATE(2667)] = 79091,
  [SMALL_STATE(2668)] = 79146,
  [SMALL_STATE(2669)] = 79193,
  [SMALL_STATE(2670)] = 79242,
  [SMALL_STATE(2671)] = 79293,
  [SMALL_STATE(2672)] = 79340,
  [SMALL_STATE(2673)] = 79387,
  [SMALL_STATE(2674)] = 79434,
  [SMALL_STATE(2675)] = 79489,
  [SMALL_STATE(2676)] = 79542,
  [SMALL_STATE(2677)] = 79597,
  [SMALL_STATE(2678)] = 79644,
  [SMALL_STATE(2679)] = 79691,
  [SMALL_STATE(2680)] = 79744,
  [SMALL_STATE(2681)] = 79791,
  [SMALL_STATE(2682)] = 79846,
  [SMALL_STATE(2683)] = 79893,
  [SMALL_STATE(2684)] = 79940,
  [SMALL_STATE(2685)] = 79987,
  [SMALL_STATE(2686)] = 80042,
  [SMALL_STATE(2687)] = 80097,
  [SMALL_STATE(2688)] = 80144,
  [SMALL_STATE(2689)] = 80199,
  [SMALL_STATE(2690)] = 80246,
  [SMALL_STATE(2691)] = 80295,
  [SMALL_STATE(2692)] = 80342,
  [SMALL_STATE(2693)] = 80393,
  [SMALL_STATE(2694)] = 80444,
  [SMALL_STATE(2695)] = 80499,
  [SMALL_STATE(2696)] = 80554,
  [SMALL_STATE(2697)] = 80613,
  [SMALL_STATE(2698)] = 80668,
  [SMALL_STATE(2699)] = 80723,
  [SMALL_STATE(2700)] = 80776,
  [SMALL_STATE(2701)] = 80823,
  [SMALL_STATE(2702)] = 80876,
  [SMALL_STATE(2703)] = 80931,
  [SMALL_STATE(2704)] = 80978,
  [SMALL_STATE(2705)] = 81033,
  [SMALL_STATE(2706)] = 81086,
  [SMALL_STATE(2707)] = 81141,
  [SMALL_STATE(2708)] = 81188,
  [SMALL_STATE(2709)] = 81235,
  [SMALL_STATE(2710)] = 81282,
  [SMALL_STATE(2711)] = 81337,
  [SMALL_STATE(2712)] = 81388,
  [SMALL_STATE(2713)] = 81435,
  [SMALL_STATE(2714)] = 81494,
  [SMALL_STATE(2715)] = 81541,
  [SMALL_STATE(2716)] = 81594,
  [SMALL_STATE(2717)] = 81649,
  [SMALL_STATE(2718)] = 81696,
  [SMALL_STATE(2719)] = 81749,
  [SMALL_STATE(2720)] = 81796,
  [SMALL_STATE(2721)] = 81847,
  [SMALL_STATE(2722)] = 81902,
  [SMALL_STATE(2723)] = 81957,
  [SMALL_STATE(2724)] = 82012,
  [SMALL_STATE(2725)] = 82063,
  [SMALL_STATE(2726)] = 82118,
  [SMALL_STATE(2727)] = 82165,
  [SMALL_STATE(2728)] = 82214,
  [SMALL_STATE(2729)] = 82269,
  [SMALL_STATE(2730)] = 82318,
  [SMALL_STATE(2731)] = 82365,
  [SMALL_STATE(2732)] = 82420,
  [SMALL_STATE(2733)] = 82467,
  [SMALL_STATE(2734)] = 82514,
  [SMALL_STATE(2735)] = 82567,
  [SMALL_STATE(2736)] = 82614,
  [SMALL_STATE(2737)] = 82661,
  [SMALL_STATE(2738)] = 82708,
  [SMALL_STATE(2739)] = 82763,
  [SMALL_STATE(2740)] = 82810,
  [SMALL_STATE(2741)] = 82857,
  [SMALL_STATE(2742)] = 82904,
  [SMALL_STATE(2743)] = 82957,
  [SMALL_STATE(2744)] = 83004,
  [SMALL_STATE(2745)] = 83051,
  [SMALL_STATE(2746)] = 83098,
  [SMALL_STATE(2747)] = 83149,
  [SMALL_STATE(2748)] = 83198,
  [SMALL_STATE(2749)] = 83245,
  [SMALL_STATE(2750)] = 83300,
  [SMALL_STATE(2751)] = 83351,
  [SMALL_STATE(2752)] = 83402,
  [SMALL_STATE(2753)] = 83453,
  [SMALL_STATE(2754)] = 83508,
  [SMALL_STATE(2755)] = 83557,
  [SMALL_STATE(2756)] = 83604,
  [SMALL_STATE(2757)] = 83651,
  [SMALL_STATE(2758)] = 83698,
  [SMALL_STATE(2759)] = 83751,
  [SMALL_STATE(2760)] = 83804,
  [SMALL_STATE(2761)] = 83857,
  [SMALL_STATE(2762)] = 83912,
  [SMALL_STATE(2763)] = 83961,
  [SMALL_STATE(2764)] = 84014,
  [SMALL_STATE(2765)] = 84073,
  [SMALL_STATE(2766)] = 84124,
  [SMALL_STATE(2767)] = 84175,
  [SMALL_STATE(2768)] = 84222,
  [SMALL_STATE(2769)] = 84269,
  [SMALL_STATE(2770)] = 84320,
  [SMALL_STATE(2771)] = 84373,
  [SMALL_STATE(2772)] = 84424,
  [SMALL_STATE(2773)] = 84471,
  [SMALL_STATE(2774)] = 84518,
  [SMALL_STATE(2775)] = 84569,
  [SMALL_STATE(2776)] = 84618,
  [SMALL_STATE(2777)] = 84669,
  [SMALL_STATE(2778)] = 84722,
  [SMALL_STATE(2779)] = 84769,
  [SMALL_STATE(2780)] = 84816,
  [SMALL_STATE(2781)] = 84867,
  [SMALL_STATE(2782)] = 84916,
  [SMALL_STATE(2783)] = 84963,
  [SMALL_STATE(2784)] = 85010,
  [SMALL_STATE(2785)] = 85057,
  [SMALL_STATE(2786)] = 85110,
  [SMALL_STATE(2787)] = 85157,
  [SMALL_STATE(2788)] = 85212,
  [SMALL_STATE(2789)] = 85263,
  [SMALL_STATE(2790)] = 85310,
  [SMALL_STATE(2791)] = 85361,
  [SMALL_STATE(2792)] = 85408,
  [SMALL_STATE(2793)] = 85455,
  [SMALL_STATE(2794)] = 85510,
  [SMALL_STATE(2795)] = 85561,
  [SMALL_STATE(2796)] = 85608,
  [SMALL_STATE(2797)] = 85663,
  [SMALL_STATE(2798)] = 85718,
  [SMALL_STATE(2799)] = 85769,
  [SMALL_STATE(2800)] = 85822,
  [SMALL_STATE(2801)] = 85875,
  [SMALL_STATE(2802)] = 85926,
  [SMALL_STATE(2803)] = 85985,
  [SMALL_STATE(2804)] = 86036,
  [SMALL_STATE(2805)] = 86083,
  [SMALL_STATE(2806)] = 86136,
  [SMALL_STATE(2807)] = 86183,
  [SMALL_STATE(2808)] = 86236,
  [SMALL_STATE(2809)] = 86289,
  [SMALL_STATE(2810)] = 86336,
  [SMALL_STATE(2811)] = 86389,
  [SMALL_STATE(2812)] = 86440,
  [SMALL_STATE(2813)] = 86487,
  [SMALL_STATE(2814)] = 86538,
  [SMALL_STATE(2815)] = 86585,
  [SMALL_STATE(2816)] = 86638,
  [SMALL_STATE(2817)] = 86685,
  [SMALL_STATE(2818)] = 86732,
  [SMALL_STATE(2819)] = 86779,
  [SMALL_STATE(2820)] = 86826,
  [SMALL_STATE(2821)] = 86881,
  [SMALL_STATE(2822)] = 86932,
  [SMALL_STATE(2823)] = 86979,
  [SMALL_STATE(2824)] = 87032,
  [SMALL_STATE(2825)] = 87079,
  [SMALL_STATE(2826)] = 87134,
  [SMALL_STATE(2827)] = 87189,
  [SMALL_STATE(2828)] = 87244,
  [SMALL_STATE(2829)] = 87297,
  [SMALL_STATE(2830)] = 87352,
  [SMALL_STATE(2831)] = 87407,
  [SMALL_STATE(2832)] = 87462,
  [SMALL_STATE(2833)] = 87509,
  [SMALL_STATE(2834)] = 87564,
  [SMALL_STATE(2835)] = 87619,
  [SMALL_STATE(2836)] = 87674,
  [SMALL_STATE(2837)] = 87729,
  [SMALL_STATE(2838)] = 87784,
  [SMALL_STATE(2839)] = 87839,
  [SMALL_STATE(2840)] = 87886,
  [SMALL_STATE(2841)] = 87937,
  [SMALL_STATE(2842)] = 87988,
  [SMALL_STATE(2843)] = 88035,
  [SMALL_STATE(2844)] = 88090,
  [SMALL_STATE(2845)] = 88139,
  [SMALL_STATE(2846)] = 88188,
  [SMALL_STATE(2847)] = 88241,
  [SMALL_STATE(2848)] = 88296,
  [SMALL_STATE(2849)] = 88351,
  [SMALL_STATE(2850)] = 88402,
  [SMALL_STATE(2851)] = 88457,
  [SMALL_STATE(2852)] = 88512,
  [SMALL_STATE(2853)] = 88559,
  [SMALL_STATE(2854)] = 88606,
  [SMALL_STATE(2855)] = 88653,
  [SMALL_STATE(2856)] = 88700,
  [SMALL_STATE(2857)] = 88747,
  [SMALL_STATE(2858)] = 88802,
  [SMALL_STATE(2859)] = 88857,
  [SMALL_STATE(2860)] = 88904,
  [SMALL_STATE(2861)] = 88951,
  [SMALL_STATE(2862)] = 88998,
  [SMALL_STATE(2863)] = 89045,
  [SMALL_STATE(2864)] = 89100,
  [SMALL_STATE(2865)] = 89155,
  [SMALL_STATE(2866)] = 89210,
  [SMALL_STATE(2867)] = 89261,
  [SMALL_STATE(2868)] = 89308,
  [SMALL_STATE(2869)] = 89363,
  [SMALL_STATE(2870)] = 89418,
  [SMALL_STATE(2871)] = 89465,
  [SMALL_STATE(2872)] = 89512,
  [SMALL_STATE(2873)] = 89559,
  [SMALL_STATE(2874)] = 89606,
  [SMALL_STATE(2875)] = 89653,
  [SMALL_STATE(2876)] = 89700,
  [SMALL_STATE(2877)] = 89747,
  [SMALL_STATE(2878)] = 89796,
  [SMALL_STATE(2879)] = 89843,
  [SMALL_STATE(2880)] = 89890,
  [SMALL_STATE(2881)] = 89945,
  [SMALL_STATE(2882)] = 89992,
  [SMALL_STATE(2883)] = 90047,
  [SMALL_STATE(2884)] = 90094,
  [SMALL_STATE(2885)] = 90141,
  [SMALL_STATE(2886)] = 90188,
  [SMALL_STATE(2887)] = 90243,
  [SMALL_STATE(2888)] = 90298,
  [SMALL_STATE(2889)] = 90353,
  [SMALL_STATE(2890)] = 90399,
  [SMALL_STATE(2891)] = 90449,
  [SMALL_STATE(2892)] = 90495,
  [SMALL_STATE(2893)] = 90547,
  [SMALL_STATE(2894)] = 90599,
  [SMALL_STATE(2895)] = 90649,
  [SMALL_STATE(2896)] = 90695,
  [SMALL_STATE(2897)] = 90741,
  [SMALL_STATE(2898)] = 90787,
  [SMALL_STATE(2899)] = 90841,
  [SMALL_STATE(2900)] = 90893,
  [SMALL_STATE(2901)] = 90945,
  [SMALL_STATE(2902)] = 90991,
  [SMALL_STATE(2903)] = 91037,
  [SMALL_STATE(2904)] = 91087,
  [SMALL_STATE(2905)] = 91139,
  [SMALL_STATE(2906)] = 91185,
  [SMALL_STATE(2907)] = 91231,
  [SMALL_STATE(2908)] = 91279,
  [SMALL_STATE(2909)] = 91329,
  [SMALL_STATE(2910)] = 91375,
  [SMALL_STATE(2911)] = 91427,
  [SMALL_STATE(2912)] = 91473,
  [SMALL_STATE(2913)] = 91525,
  [SMALL_STATE(2914)] = 91571,
  [SMALL_STATE(2915)] = 91617,
  [SMALL_STATE(2916)] = 91669,
  [SMALL_STATE(2917)] = 91721,
  [SMALL_STATE(2918)] = 91767,
  [SMALL_STATE(2919)] = 91813,
  [SMALL_STATE(2920)] = 91859,
  [SMALL_STATE(2921)] = 91905,
  [SMALL_STATE(2922)] = 91951,
  [SMALL_STATE(2923)] = 91997,
  [SMALL_STATE(2924)] = 92043,
  [SMALL_STATE(2925)] = 92089,
  [SMALL_STATE(2926)] = 92141,
  [SMALL_STATE(2927)] = 92187,
  [SMALL_STATE(2928)] = 92233,
  [SMALL_STATE(2929)] = 92285,
  [SMALL_STATE(2930)] = 92331,
  [SMALL_STATE(2931)] = 92383,
  [SMALL_STATE(2932)] = 92429,
  [SMALL_STATE(2933)] = 92481,
  [SMALL_STATE(2934)] = 92533,
  [SMALL_STATE(2935)] = 92579,
  [SMALL_STATE(2936)] = 92625,
  [SMALL_STATE(2937)] = 92671,
  [SMALL_STATE(2938)] = 92723,
  [SMALL_STATE(2939)] = 92769,
  [SMALL_STATE(2940)] = 92817,
  [SMALL_STATE(2941)] = 92869,
  [SMALL_STATE(2942)] = 92915,
  [SMALL_STATE(2943)] = 92961,
  [SMALL_STATE(2944)] = 93007,
  [SMALL_STATE(2945)] = 93053,
  [SMALL_STATE(2946)] = 93099,
  [SMALL_STATE(2947)] = 93145,
  [SMALL_STATE(2948)] = 93191,
  [SMALL_STATE(2949)] = 93237,
  [SMALL_STATE(2950)] = 93287,
  [SMALL_STATE(2951)] = 93333,
  [SMALL_STATE(2952)] = 93379,
  [SMALL_STATE(2953)] = 93425,
  [SMALL_STATE(2954)] = 93471,
  [SMALL_STATE(2955)] = 93517,
  [SMALL_STATE(2956)] = 93563,
  [SMALL_STATE(2957)] = 93615,
  [SMALL_STATE(2958)] = 93663,
  [SMALL_STATE(2959)] = 93709,
  [SMALL_STATE(2960)] = 93759,
  [SMALL_STATE(2961)] = 93805,
  [SMALL_STATE(2962)] = 93851,
  [SMALL_STATE(2963)] = 93897,
  [SMALL_STATE(2964)] = 93943,
  [SMALL_STATE(2965)] = 93989,
  [SMALL_STATE(2966)] = 94037,
  [SMALL_STATE(2967)] = 94089,
  [SMALL_STATE(2968)] = 94135,
  [SMALL_STATE(2969)] = 94187,
  [SMALL_STATE(2970)] = 94233,
  [SMALL_STATE(2971)] = 94285,
  [SMALL_STATE(2972)] = 94337,
  [SMALL_STATE(2973)] = 94383,
  [SMALL_STATE(2974)] = 94429,
  [SMALL_STATE(2975)] = 94475,
  [SMALL_STATE(2976)] = 94529,
  [SMALL_STATE(2977)] = 94575,
  [SMALL_STATE(2978)] = 94627,
  [SMALL_STATE(2979)] = 94673,
  [SMALL_STATE(2980)] = 94719,
  [SMALL_STATE(2981)] = 94771,
  [SMALL_STATE(2982)] = 94817,
  [SMALL_STATE(2983)] = 94871,
  [SMALL_STATE(2984)] = 94917,
  [SMALL_STATE(2985)] = 94963,
  [SMALL_STATE(2986)] = 95009,
  [SMALL_STATE(2987)] = 95055,
  [SMALL_STATE(2988)] = 95101,
  [SMALL_STATE(2989)] = 95149,
  [SMALL_STATE(2990)] = 95195,
  [SMALL_STATE(2991)] = 95241,
  [SMALL_STATE(2992)] = 95287,
  [SMALL_STATE(2993)] = 95333,
  [SMALL_STATE(2994)] = 95379,
  [SMALL_STATE(2995)] = 95425,
  [SMALL_STATE(2996)] = 95473,
  [SMALL_STATE(2997)] = 95521,
  [SMALL_STATE(2998)] = 95567,
  [SMALL_STATE(2999)] = 95617,
  [SMALL_STATE(3000)] = 95663,
  [SMALL_STATE(3001)] = 95709,
  [SMALL_STATE(3002)] = 95755,
  [SMALL_STATE(3003)] = 95803,
  [SMALL_STATE(3004)] = 95853,
  [SMALL_STATE(3005)] = 95901,
  [SMALL_STATE(3006)] = 95949,
  [SMALL_STATE(3007)] = 95995,
  [SMALL_STATE(3008)] = 96041,
  [SMALL_STATE(3009)] = 96087,
  [SMALL_STATE(3010)] = 96141,
  [SMALL_STATE(3011)] = 96195,
  [SMALL_STATE(3012)] = 96249,
  [SMALL_STATE(3013)] = 96303,
  [SMALL_STATE(3014)] = 96349,
  [SMALL_STATE(3015)] = 96399,
  [SMALL_STATE(3016)] = 96445,
  [SMALL_STATE(3017)] = 96499,
  [SMALL_STATE(3018)] = 96545,
  [SMALL_STATE(3019)] = 96591,
  [SMALL_STATE(3020)] = 96637,
  [SMALL_STATE(3021)] = 96683,
  [SMALL_STATE(3022)] = 96729,
  [SMALL_STATE(3023)] = 96775,
  [SMALL_STATE(3024)] = 96821,
  [SMALL_STATE(3025)] = 96873,
  [SMALL_STATE(3026)] = 96925,
  [SMALL_STATE(3027)] = 96971,
  [SMALL_STATE(3028)] = 97017,
  [SMALL_STATE(3029)] = 97071,
  [SMALL_STATE(3030)] = 97117,
  [SMALL_STATE(3031)] = 97171,
  [SMALL_STATE(3032)] = 97219,
  [SMALL_STATE(3033)] = 97265,
  [SMALL_STATE(3034)] = 97311,
  [SMALL_STATE(3035)] = 97357,
  [SMALL_STATE(3036)] = 97403,
  [SMALL_STATE(3037)] = 97449,
  [SMALL_STATE(3038)] = 97495,
  [SMALL_STATE(3039)] = 97549,
  [SMALL_STATE(3040)] = 97603,
  [SMALL_STATE(3041)] = 97657,
  [SMALL_STATE(3042)] = 97711,
  [SMALL_STATE(3043)] = 97757,
  [SMALL_STATE(3044)] = 97803,
  [SMALL_STATE(3045)] = 97857,
  [SMALL_STATE(3046)] = 97903,
  [SMALL_STATE(3047)] = 97949,
  [SMALL_STATE(3048)] = 97995,
  [SMALL_STATE(3049)] = 98049,
  [SMALL_STATE(3050)] = 98103,
  [SMALL_STATE(3051)] = 98149,
  [SMALL_STATE(3052)] = 98195,
  [SMALL_STATE(3053)] = 98241,
  [SMALL_STATE(3054)] = 98291,
  [SMALL_STATE(3055)] = 98337,
  [SMALL_STATE(3056)] = 98383,
  [SMALL_STATE(3057)] = 98435,
  [SMALL_STATE(3058)] = 98481,
  [SMALL_STATE(3059)] = 98531,
  [SMALL_STATE(3060)] = 98577,
  [SMALL_STATE(3061)] = 98629,
  [SMALL_STATE(3062)] = 98675,
  [SMALL_STATE(3063)] = 98721,
  [SMALL_STATE(3064)] = 98767,
  [SMALL_STATE(3065)] = 98813,
  [SMALL_STATE(3066)] = 98863,
  [SMALL_STATE(3067)] = 98909,
  [SMALL_STATE(3068)] = 98955,
  [SMALL_STATE(3069)] = 99001,
  [SMALL_STATE(3070)] = 99053,
  [SMALL_STATE(3071)] = 99099,
  [SMALL_STATE(3072)] = 99145,
  [SMALL_STATE(3073)] = 99191,
  [SMALL_STATE(3074)] = 99237,
  [SMALL_STATE(3075)] = 99287,
  [SMALL_STATE(3076)] = 99333,
  [SMALL_STATE(3077)] = 99379,
  [SMALL_STATE(3078)] = 99431,
  [SMALL_STATE(3079)] = 99481,
  [SMALL_STATE(3080)] = 99533,
  [SMALL_STATE(3081)] = 99579,
  [SMALL_STATE(3082)] = 99625,
  [SMALL_STATE(3083)] = 99671,
  [SMALL_STATE(3084)] = 99723,
  [SMALL_STATE(3085)] = 99769,
  [SMALL_STATE(3086)] = 99823,
  [SMALL_STATE(3087)] = 99869,
  [SMALL_STATE(3088)] = 99915,
  [SMALL_STATE(3089)] = 99961,
  [SMALL_STATE(3090)] = 100007,
  [SMALL_STATE(3091)] = 100053,
  [SMALL_STATE(3092)] = 100099,
  [SMALL_STATE(3093)] = 100145,
  [SMALL_STATE(3094)] = 100195,
  [SMALL_STATE(3095)] = 100247,
  [SMALL_STATE(3096)] = 100293,
  [SMALL_STATE(3097)] = 100339,
  [SMALL_STATE(3098)] = 100393,
  [SMALL_STATE(3099)] = 100445,
  [SMALL_STATE(3100)] = 100491,
  [SMALL_STATE(3101)] = 100543,
  [SMALL_STATE(3102)] = 100593,
  [SMALL_STATE(3103)] = 100639,
  [SMALL_STATE(3104)] = 100689,
  [SMALL_STATE(3105)] = 100735,
  [SMALL_STATE(3106)] = 100785,
  [SMALL_STATE(3107)] = 100833,
  [SMALL_STATE(3108)] = 100885,
  [SMALL_STATE(3109)] = 100937,
  [SMALL_STATE(3110)] = 100983,
  [SMALL_STATE(3111)] = 101029,
  [SMALL_STATE(3112)] = 101075,
  [SMALL_STATE(3113)] = 101129,
  [SMALL_STATE(3114)] = 101175,
  [SMALL_STATE(3115)] = 101227,
  [SMALL_STATE(3116)] = 101273,
  [SMALL_STATE(3117)] = 101325,
  [SMALL_STATE(3118)] = 101377,
  [SMALL_STATE(3119)] = 101423,
  [SMALL_STATE(3120)] = 101473,
  [SMALL_STATE(3121)] = 101519,
  [SMALL_STATE(3122)] = 101565,
  [SMALL_STATE(3123)] = 101617,
  [SMALL_STATE(3124)] = 101663,
  [SMALL_STATE(3125)] = 101709,
  [SMALL_STATE(3126)] = 101755,
  [SMALL_STATE(3127)] = 101801,
  [SMALL_STATE(3128)] = 101847,
  [SMALL_STATE(3129)] = 101893,
  [SMALL_STATE(3130)] = 101939,
  [SMALL_STATE(3131)] = 101985,
  [SMALL_STATE(3132)] = 102031,
  [SMALL_STATE(3133)] = 102077,
  [SMALL_STATE(3134)] = 102123,
  [SMALL_STATE(3135)] = 102169,
  [SMALL_STATE(3136)] = 102215,
  [SMALL_STATE(3137)] = 102263,
  [SMALL_STATE(3138)] = 102309,
  [SMALL_STATE(3139)] = 102355,
  [SMALL_STATE(3140)] = 102401,
  [SMALL_STATE(3141)] = 102447,
  [SMALL_STATE(3142)] = 102493,
  [SMALL_STATE(3143)] = 102539,
  [SMALL_STATE(3144)] = 102585,
  [SMALL_STATE(3145)] = 102631,
  [SMALL_STATE(3146)] = 102677,
  [SMALL_STATE(3147)] = 102725,
  [SMALL_STATE(3148)] = 102775,
  [SMALL_STATE(3149)] = 102825,
  [SMALL_STATE(3150)] = 102875,
  [SMALL_STATE(3151)] = 102921,
  [SMALL_STATE(3152)] = 102967,
  [SMALL_STATE(3153)] = 103013,
  [SMALL_STATE(3154)] = 103059,
  [SMALL_STATE(3155)] = 103105,
  [SMALL_STATE(3156)] = 103151,
  [SMALL_STATE(3157)] = 103197,
  [SMALL_STATE(3158)] = 103243,
  [SMALL_STATE(3159)] = 103289,
  [SMALL_STATE(3160)] = 103335,
  [SMALL_STATE(3161)] = 103383,
  [SMALL_STATE(3162)] = 103429,
  [SMALL_STATE(3163)] = 103475,
  [SMALL_STATE(3164)] = 103521,
  [SMALL_STATE(3165)] = 103567,
  [SMALL_STATE(3166)] = 103613,
  [SMALL_STATE(3167)] = 103659,
  [SMALL_STATE(3168)] = 103705,
  [SMALL_STATE(3169)] = 103751,
  [SMALL_STATE(3170)] = 103797,
  [SMALL_STATE(3171)] = 103843,
  [SMALL_STATE(3172)] = 103889,
  [SMALL_STATE(3173)] = 103935,
  [SMALL_STATE(3174)] = 103981,
  [SMALL_STATE(3175)] = 104035,
  [SMALL_STATE(3176)] = 104081,
  [SMALL_STATE(3177)] = 104127,
  [SMALL_STATE(3178)] = 104173,
  [SMALL_STATE(3179)] = 104219,
  [SMALL_STATE(3180)] = 104273,
  [SMALL_STATE(3181)] = 104327,
  [SMALL_STATE(3182)] = 104373,
  [SMALL_STATE(3183)] = 104427,
  [SMALL_STATE(3184)] = 104473,
  [SMALL_STATE(3185)] = 104527,
  [SMALL_STATE(3186)] = 104573,
  [SMALL_STATE(3187)] = 104619,
  [SMALL_STATE(3188)] = 104665,
  [SMALL_STATE(3189)] = 104711,
  [SMALL_STATE(3190)] = 104757,
  [SMALL_STATE(3191)] = 104803,
  [SMALL_STATE(3192)] = 104855,
  [SMALL_STATE(3193)] = 104901,
  [SMALL_STATE(3194)] = 104947,
  [SMALL_STATE(3195)] = 104993,
  [SMALL_STATE(3196)] = 105039,
  [SMALL_STATE(3197)] = 105085,
  [SMALL_STATE(3198)] = 105131,
  [SMALL_STATE(3199)] = 105177,
  [SMALL_STATE(3200)] = 105223,
  [SMALL_STATE(3201)] = 105269,
  [SMALL_STATE(3202)] = 105323,
  [SMALL_STATE(3203)] = 105369,
  [SMALL_STATE(3204)] = 105415,
  [SMALL_STATE(3205)] = 105461,
  [SMALL_STATE(3206)] = 105507,
  [SMALL_STATE(3207)] = 105553,
  [SMALL_STATE(3208)] = 105599,
  [SMALL_STATE(3209)] = 105651,
  [SMALL_STATE(3210)] = 105697,
  [SMALL_STATE(3211)] = 105743,
  [SMALL_STATE(3212)] = 105789,
  [SMALL_STATE(3213)] = 105835,
  [SMALL_STATE(3214)] = 105881,
  [SMALL_STATE(3215)] = 105929,
  [SMALL_STATE(3216)] = 105975,
  [SMALL_STATE(3217)] = 106021,
  [SMALL_STATE(3218)] = 106075,
  [SMALL_STATE(3219)] = 106121,
  [SMALL_STATE(3220)] = 106167,
  [SMALL_STATE(3221)] = 106213,
  [SMALL_STATE(3222)] = 106259,
  [SMALL_STATE(3223)] = 106305,
  [SMALL_STATE(3224)] = 106351,
  [SMALL_STATE(3225)] = 106397,
  [SMALL_STATE(3226)] = 106443,
  [SMALL_STATE(3227)] = 106495,
  [SMALL_STATE(3228)] = 106541,
  [SMALL_STATE(3229)] = 106591,
  [SMALL_STATE(3230)] = 106645,
  [SMALL_STATE(3231)] = 106699,
  [SMALL_STATE(3232)] = 106745,
  [SMALL_STATE(3233)] = 106799,
  [SMALL_STATE(3234)] = 106845,
  [SMALL_STATE(3235)] = 106891,
  [SMALL_STATE(3236)] = 106937,
  [SMALL_STATE(3237)] = 106983,
  [SMALL_STATE(3238)] = 107029,
  [SMALL_STATE(3239)] = 107075,
  [SMALL_STATE(3240)] = 107121,
  [SMALL_STATE(3241)] = 107167,
  [SMALL_STATE(3242)] = 107213,
  [SMALL_STATE(3243)] = 107265,
  [SMALL_STATE(3244)] = 107313,
  [SMALL_STATE(3245)] = 107363,
  [SMALL_STATE(3246)] = 107411,
  [SMALL_STATE(3247)] = 107457,
  [SMALL_STATE(3248)] = 107503,
  [SMALL_STATE(3249)] = 107549,
  [SMALL_STATE(3250)] = 107601,
  [SMALL_STATE(3251)] = 107653,
  [SMALL_STATE(3252)] = 107699,
  [SMALL_STATE(3253)] = 107745,
  [SMALL_STATE(3254)] = 107791,
  [SMALL_STATE(3255)] = 107837,
  [SMALL_STATE(3256)] = 107883,
  [SMALL_STATE(3257)] = 107929,
  [SMALL_STATE(3258)] = 107975,
  [SMALL_STATE(3259)] = 108021,
  [SMALL_STATE(3260)] = 108067,
  [SMALL_STATE(3261)] = 108113,
  [SMALL_STATE(3262)] = 108163,
  [SMALL_STATE(3263)] = 108209,
  [SMALL_STATE(3264)] = 108255,
  [SMALL_STATE(3265)] = 108301,
  [SMALL_STATE(3266)] = 108347,
  [SMALL_STATE(3267)] = 108395,
  [SMALL_STATE(3268)] = 108441,
  [SMALL_STATE(3269)] = 108487,
  [SMALL_STATE(3270)] = 108533,
  [SMALL_STATE(3271)] = 108579,
  [SMALL_STATE(3272)] = 108625,
  [SMALL_STATE(3273)] = 108671,
  [SMALL_STATE(3274)] = 108717,
  [SMALL_STATE(3275)] = 108771,
  [SMALL_STATE(3276)] = 108825,
  [SMALL_STATE(3277)] = 108875,
  [SMALL_STATE(3278)] = 108921,
  [SMALL_STATE(3279)] = 108967,
  [SMALL_STATE(3280)] = 109013,
  [SMALL_STATE(3281)] = 109059,
  [SMALL_STATE(3282)] = 109105,
  [SMALL_STATE(3283)] = 109151,
  [SMALL_STATE(3284)] = 109205,
  [SMALL_STATE(3285)] = 109251,
  [SMALL_STATE(3286)] = 109297,
  [SMALL_STATE(3287)] = 109343,
  [SMALL_STATE(3288)] = 109389,
  [SMALL_STATE(3289)] = 109435,
  [SMALL_STATE(3290)] = 109481,
  [SMALL_STATE(3291)] = 109529,
  [SMALL_STATE(3292)] = 109575,
  [SMALL_STATE(3293)] = 109621,
  [SMALL_STATE(3294)] = 109667,
  [SMALL_STATE(3295)] = 109721,
  [SMALL_STATE(3296)] = 109775,
  [SMALL_STATE(3297)] = 109821,
  [SMALL_STATE(3298)] = 109867,
  [SMALL_STATE(3299)] = 109913,
  [SMALL_STATE(3300)] = 109967,
  [SMALL_STATE(3301)] = 110013,
  [SMALL_STATE(3302)] = 110059,
  [SMALL_STATE(3303)] = 110105,
  [SMALL_STATE(3304)] = 110151,
  [SMALL_STATE(3305)] = 110205,
  [SMALL_STATE(3306)] = 110251,
  [SMALL_STATE(3307)] = 110297,
  [SMALL_STATE(3308)] = 110351,
  [SMALL_STATE(3309)] = 110397,
  [SMALL_STATE(3310)] = 110443,
  [SMALL_STATE(3311)] = 110489,
  [SMALL_STATE(3312)] = 110535,
  [SMALL_STATE(3313)] = 110581,
  [SMALL_STATE(3314)] = 110629,
  [SMALL_STATE(3315)] = 110675,
  [SMALL_STATE(3316)] = 110729,
  [SMALL_STATE(3317)] = 110783,
  [SMALL_STATE(3318)] = 110829,
  [SMALL_STATE(3319)] = 110874,
  [SMALL_STATE(3320)] = 110919,
  [SMALL_STATE(3321)] = 110964,
  [SMALL_STATE(3322)] = 111009,
  [SMALL_STATE(3323)] = 111054,
  [SMALL_STATE(3324)] = 111099,
  [SMALL_STATE(3325)] = 111144,
  [SMALL_STATE(3326)] = 111189,
  [SMALL_STATE(3327)] = 111234,
  [SMALL_STATE(3328)] = 111279,
  [SMALL_STATE(3329)] = 111324,
  [SMALL_STATE(3330)] = 111369,
  [SMALL_STATE(3331)] = 111414,
  [SMALL_STATE(3332)] = 111459,
  [SMALL_STATE(3333)] = 111504,
  [SMALL_STATE(3334)] = 111549,
  [SMALL_STATE(3335)] = 111594,
  [SMALL_STATE(3336)] = 111639,
  [SMALL_STATE(3337)] = 111684,
  [SMALL_STATE(3338)] = 111729,
  [SMALL_STATE(3339)] = 111774,
  [SMALL_STATE(3340)] = 111819,
  [SMALL_STATE(3341)] = 111864,
  [SMALL_STATE(3342)] = 111909,
  [SMALL_STATE(3343)] = 111954,
  [SMALL_STATE(3344)] = 111999,
  [SMALL_STATE(3345)] = 112044,
  [SMALL_STATE(3346)] = 112089,
  [SMALL_STATE(3347)] = 112134,
  [SMALL_STATE(3348)] = 112179,
  [SMALL_STATE(3349)] = 112224,
  [SMALL_STATE(3350)] = 112269,
  [SMALL_STATE(3351)] = 112314,
  [SMALL_STATE(3352)] = 112359,
  [SMALL_STATE(3353)] = 112404,
  [SMALL_STATE(3354)] = 112449,
  [SMALL_STATE(3355)] = 112494,
  [SMALL_STATE(3356)] = 112539,
  [SMALL_STATE(3357)] = 112584,
  [SMALL_STATE(3358)] = 112629,
  [SMALL_STATE(3359)] = 112674,
  [SMALL_STATE(3360)] = 112719,
  [SMALL_STATE(3361)] = 112764,
  [SMALL_STATE(3362)] = 112809,
  [SMALL_STATE(3363)] = 112854,
  [SMALL_STATE(3364)] = 112899,
  [SMALL_STATE(3365)] = 112944,
  [SMALL_STATE(3366)] = 112989,
  [SMALL_STATE(3367)] = 113034,
  [SMALL_STATE(3368)] = 113079,
  [SMALL_STATE(3369)] = 113124,
  [SMALL_STATE(3370)] = 113169,
  [SMALL_STATE(3371)] = 113214,
  [SMALL_STATE(3372)] = 113259,
  [SMALL_STATE(3373)] = 113306,
  [SMALL_STATE(3374)] = 113351,
  [SMALL_STATE(3375)] = 113398,
  [SMALL_STATE(3376)] = 113443,
  [SMALL_STATE(3377)] = 113488,
  [SMALL_STATE(3378)] = 113535,
  [SMALL_STATE(3379)] = 113580,
  [SMALL_STATE(3380)] = 113625,
  [SMALL_STATE(3381)] = 113670,
  [SMALL_STATE(3382)] = 113715,
  [SMALL_STATE(3383)] = 113760,
  [SMALL_STATE(3384)] = 113805,
  [SMALL_STATE(3385)] = 113850,
  [SMALL_STATE(3386)] = 113895,
  [SMALL_STATE(3387)] = 113940,
  [SMALL_STATE(3388)] = 113985,
  [SMALL_STATE(3389)] = 114030,
  [SMALL_STATE(3390)] = 114075,
  [SMALL_STATE(3391)] = 114120,
  [SMALL_STATE(3392)] = 114165,
  [SMALL_STATE(3393)] = 114210,
  [SMALL_STATE(3394)] = 114255,
  [SMALL_STATE(3395)] = 114300,
  [SMALL_STATE(3396)] = 114345,
  [SMALL_STATE(3397)] = 114390,
  [SMALL_STATE(3398)] = 114435,
  [SMALL_STATE(3399)] = 114484,
  [SMALL_STATE(3400)] = 114533,
  [SMALL_STATE(3401)] = 114582,
  [SMALL_STATE(3402)] = 114627,
  [SMALL_STATE(3403)] = 114672,
  [SMALL_STATE(3404)] = 114717,
  [SMALL_STATE(3405)] = 114762,
  [SMALL_STATE(3406)] = 114807,
  [SMALL_STATE(3407)] = 114856,
  [SMALL_STATE(3408)] = 114901,
  [SMALL_STATE(3409)] = 114950,
  [SMALL_STATE(3410)] = 114995,
  [SMALL_STATE(3411)] = 115040,
  [SMALL_STATE(3412)] = 115085,
  [SMALL_STATE(3413)] = 115130,
  [SMALL_STATE(3414)] = 115179,
  [SMALL_STATE(3415)] = 115224,
  [SMALL_STATE(3416)] = 115271,
  [SMALL_STATE(3417)] = 115316,
  [SMALL_STATE(3418)] = 115361,
  [SMALL_STATE(3419)] = 115406,
  [SMALL_STATE(3420)] = 115451,
  [SMALL_STATE(3421)] = 115496,
  [SMALL_STATE(3422)] = 115541,
  [SMALL_STATE(3423)] = 115586,
  [SMALL_STATE(3424)] = 115631,
  [SMALL_STATE(3425)] = 115676,
  [SMALL_STATE(3426)] = 115721,
  [SMALL_STATE(3427)] = 115766,
  [SMALL_STATE(3428)] = 115811,
  [SMALL_STATE(3429)] = 115856,
  [SMALL_STATE(3430)] = 115901,
  [SMALL_STATE(3431)] = 115946,
  [SMALL_STATE(3432)] = 115995,
  [SMALL_STATE(3433)] = 116040,
  [SMALL_STATE(3434)] = 116085,
  [SMALL_STATE(3435)] = 116130,
  [SMALL_STATE(3436)] = 116175,
  [SMALL_STATE(3437)] = 116220,
  [SMALL_STATE(3438)] = 116265,
  [SMALL_STATE(3439)] = 116310,
  [SMALL_STATE(3440)] = 116355,
  [SMALL_STATE(3441)] = 116400,
  [SMALL_STATE(3442)] = 116445,
  [SMALL_STATE(3443)] = 116490,
  [SMALL_STATE(3444)] = 116535,
  [SMALL_STATE(3445)] = 116582,
  [SMALL_STATE(3446)] = 116627,
  [SMALL_STATE(3447)] = 116672,
  [SMALL_STATE(3448)] = 116717,
  [SMALL_STATE(3449)] = 116762,
  [SMALL_STATE(3450)] = 116807,
  [SMALL_STATE(3451)] = 116852,
  [SMALL_STATE(3452)] = 116897,
  [SMALL_STATE(3453)] = 116942,
  [SMALL_STATE(3454)] = 116987,
  [SMALL_STATE(3455)] = 117032,
  [SMALL_STATE(3456)] = 117077,
  [SMALL_STATE(3457)] = 117122,
  [SMALL_STATE(3458)] = 117167,
  [SMALL_STATE(3459)] = 117212,
  [SMALL_STATE(3460)] = 117257,
  [SMALL_STATE(3461)] = 117302,
  [SMALL_STATE(3462)] = 117347,
  [SMALL_STATE(3463)] = 117392,
  [SMALL_STATE(3464)] = 117437,
  [SMALL_STATE(3465)] = 117482,
  [SMALL_STATE(3466)] = 117527,
  [SMALL_STATE(3467)] = 117572,
  [SMALL_STATE(3468)] = 117617,
  [SMALL_STATE(3469)] = 117662,
  [SMALL_STATE(3470)] = 117707,
  [SMALL_STATE(3471)] = 117752,
  [SMALL_STATE(3472)] = 117797,
  [SMALL_STATE(3473)] = 117842,
  [SMALL_STATE(3474)] = 117887,
  [SMALL_STATE(3475)] = 117932,
  [SMALL_STATE(3476)] = 117977,
  [SMALL_STATE(3477)] = 118022,
  [SMALL_STATE(3478)] = 118067,
  [SMALL_STATE(3479)] = 118112,
  [SMALL_STATE(3480)] = 118157,
  [SMALL_STATE(3481)] = 118202,
  [SMALL_STATE(3482)] = 118247,
  [SMALL_STATE(3483)] = 118292,
  [SMALL_STATE(3484)] = 118337,
  [SMALL_STATE(3485)] = 118382,
  [SMALL_STATE(3486)] = 118427,
  [SMALL_STATE(3487)] = 118472,
  [SMALL_STATE(3488)] = 118517,
  [SMALL_STATE(3489)] = 118562,
  [SMALL_STATE(3490)] = 118607,
  [SMALL_STATE(3491)] = 118652,
  [SMALL_STATE(3492)] = 118697,
  [SMALL_STATE(3493)] = 118742,
  [SMALL_STATE(3494)] = 118787,
  [SMALL_STATE(3495)] = 118832,
  [SMALL_STATE(3496)] = 118877,
  [SMALL_STATE(3497)] = 118922,
  [SMALL_STATE(3498)] = 118967,
  [SMALL_STATE(3499)] = 119012,
  [SMALL_STATE(3500)] = 119057,
  [SMALL_STATE(3501)] = 119102,
  [SMALL_STATE(3502)] = 119147,
  [SMALL_STATE(3503)] = 119192,
  [SMALL_STATE(3504)] = 119237,
  [SMALL_STATE(3505)] = 119282,
  [SMALL_STATE(3506)] = 119327,
  [SMALL_STATE(3507)] = 119372,
  [SMALL_STATE(3508)] = 119417,
  [SMALL_STATE(3509)] = 119462,
  [SMALL_STATE(3510)] = 119507,
  [SMALL_STATE(3511)] = 119552,
  [SMALL_STATE(3512)] = 119597,
  [SMALL_STATE(3513)] = 119642,
  [SMALL_STATE(3514)] = 119687,
  [SMALL_STATE(3515)] = 119732,
  [SMALL_STATE(3516)] = 119777,
  [SMALL_STATE(3517)] = 119822,
  [SMALL_STATE(3518)] = 119867,
  [SMALL_STATE(3519)] = 119912,
  [SMALL_STATE(3520)] = 119957,
  [SMALL_STATE(3521)] = 120002,
  [SMALL_STATE(3522)] = 120047,
  [SMALL_STATE(3523)] = 120092,
  [SMALL_STATE(3524)] = 120137,
  [SMALL_STATE(3525)] = 120182,
  [SMALL_STATE(3526)] = 120227,
  [SMALL_STATE(3527)] = 120272,
  [SMALL_STATE(3528)] = 120317,
  [SMALL_STATE(3529)] = 120362,
  [SMALL_STATE(3530)] = 120407,
  [SMALL_STATE(3531)] = 120452,
  [SMALL_STATE(3532)] = 120497,
  [SMALL_STATE(3533)] = 120542,
  [SMALL_STATE(3534)] = 120587,
  [SMALL_STATE(3535)] = 120632,
  [SMALL_STATE(3536)] = 120677,
  [SMALL_STATE(3537)] = 120722,
  [SMALL_STATE(3538)] = 120767,
  [SMALL_STATE(3539)] = 120812,
  [SMALL_STATE(3540)] = 120857,
  [SMALL_STATE(3541)] = 120902,
  [SMALL_STATE(3542)] = 120947,
  [SMALL_STATE(3543)] = 120992,
  [SMALL_STATE(3544)] = 121037,
  [SMALL_STATE(3545)] = 121082,
  [SMALL_STATE(3546)] = 121127,
  [SMALL_STATE(3547)] = 121178,
  [SMALL_STATE(3548)] = 121223,
  [SMALL_STATE(3549)] = 121268,
  [SMALL_STATE(3550)] = 121313,
  [SMALL_STATE(3551)] = 121358,
  [SMALL_STATE(3552)] = 121403,
  [SMALL_STATE(3553)] = 121448,
  [SMALL_STATE(3554)] = 121499,
  [SMALL_STATE(3555)] = 121550,
  [SMALL_STATE(3556)] = 121595,
  [SMALL_STATE(3557)] = 121640,
  [SMALL_STATE(3558)] = 121691,
  [SMALL_STATE(3559)] = 121736,
  [SMALL_STATE(3560)] = 121781,
  [SMALL_STATE(3561)] = 121826,
  [SMALL_STATE(3562)] = 121873,
  [SMALL_STATE(3563)] = 121924,
  [SMALL_STATE(3564)] = 121969,
  [SMALL_STATE(3565)] = 122014,
  [SMALL_STATE(3566)] = 122059,
  [SMALL_STATE(3567)] = 122106,
  [SMALL_STATE(3568)] = 122151,
  [SMALL_STATE(3569)] = 122196,
  [SMALL_STATE(3570)] = 122241,
  [SMALL_STATE(3571)] = 122286,
  [SMALL_STATE(3572)] = 122331,
  [SMALL_STATE(3573)] = 122376,
  [SMALL_STATE(3574)] = 122425,
  [SMALL_STATE(3575)] = 122470,
  [SMALL_STATE(3576)] = 122515,
  [SMALL_STATE(3577)] = 122566,
  [SMALL_STATE(3578)] = 122611,
  [SMALL_STATE(3579)] = 122656,
  [SMALL_STATE(3580)] = 122701,
  [SMALL_STATE(3581)] = 122746,
  [SMALL_STATE(3582)] = 122791,
  [SMALL_STATE(3583)] = 122836,
  [SMALL_STATE(3584)] = 122881,
  [SMALL_STATE(3585)] = 122926,
  [SMALL_STATE(3586)] = 122971,
  [SMALL_STATE(3587)] = 123016,
  [SMALL_STATE(3588)] = 123061,
  [SMALL_STATE(3589)] = 123106,
  [SMALL_STATE(3590)] = 123151,
  [SMALL_STATE(3591)] = 123196,
  [SMALL_STATE(3592)] = 123241,
  [SMALL_STATE(3593)] = 123286,
  [SMALL_STATE(3594)] = 123331,
  [SMALL_STATE(3595)] = 123376,
  [SMALL_STATE(3596)] = 123421,
  [SMALL_STATE(3597)] = 123470,
  [SMALL_STATE(3598)] = 123515,
  [SMALL_STATE(3599)] = 123560,
  [SMALL_STATE(3600)] = 123609,
  [SMALL_STATE(3601)] = 123654,
  [SMALL_STATE(3602)] = 123703,
  [SMALL_STATE(3603)] = 123748,
  [SMALL_STATE(3604)] = 123795,
  [SMALL_STATE(3605)] = 123840,
  [SMALL_STATE(3606)] = 123891,
  [SMALL_STATE(3607)] = 123942,
  [SMALL_STATE(3608)] = 123987,
  [SMALL_STATE(3609)] = 124032,
  [SMALL_STATE(3610)] = 124079,
  [SMALL_STATE(3611)] = 124124,
  [SMALL_STATE(3612)] = 124169,
  [SMALL_STATE(3613)] = 124214,
  [SMALL_STATE(3614)] = 124263,
  [SMALL_STATE(3615)] = 124308,
  [SMALL_STATE(3616)] = 124353,
  [SMALL_STATE(3617)] = 124398,
  [SMALL_STATE(3618)] = 124443,
  [SMALL_STATE(3619)] = 124488,
  [SMALL_STATE(3620)] = 124533,
  [SMALL_STATE(3621)] = 124584,
  [SMALL_STATE(3622)] = 124629,
  [SMALL_STATE(3623)] = 124676,
  [SMALL_STATE(3624)] = 124721,
  [SMALL_STATE(3625)] = 124766,
  [SMALL_STATE(3626)] = 124813,
  [SMALL_STATE(3627)] = 124858,
  [SMALL_STATE(3628)] = 124903,
  [SMALL_STATE(3629)] = 124948,
  [SMALL_STATE(3630)] = 124993,
  [SMALL_STATE(3631)] = 125038,
  [SMALL_STATE(3632)] = 125083,
  [SMALL_STATE(3633)] = 125128,
  [SMALL_STATE(3634)] = 125173,
  [SMALL_STATE(3635)] = 125218,
  [SMALL_STATE(3636)] = 125269,
  [SMALL_STATE(3637)] = 125314,
  [SMALL_STATE(3638)] = 125365,
  [SMALL_STATE(3639)] = 125414,
  [SMALL_STATE(3640)] = 125465,
  [SMALL_STATE(3641)] = 125510,
  [SMALL_STATE(3642)] = 125555,
  [SMALL_STATE(3643)] = 125600,
  [SMALL_STATE(3644)] = 125645,
  [SMALL_STATE(3645)] = 125690,
  [SMALL_STATE(3646)] = 125735,
  [SMALL_STATE(3647)] = 125786,
  [SMALL_STATE(3648)] = 125837,
  [SMALL_STATE(3649)] = 125884,
  [SMALL_STATE(3650)] = 125931,
  [SMALL_STATE(3651)] = 125976,
  [SMALL_STATE(3652)] = 126021,
  [SMALL_STATE(3653)] = 126072,
  [SMALL_STATE(3654)] = 126117,
  [SMALL_STATE(3655)] = 126162,
  [SMALL_STATE(3656)] = 126207,
  [SMALL_STATE(3657)] = 126252,
  [SMALL_STATE(3658)] = 126303,
  [SMALL_STATE(3659)] = 126348,
  [SMALL_STATE(3660)] = 126393,
  [SMALL_STATE(3661)] = 126444,
  [SMALL_STATE(3662)] = 126489,
  [SMALL_STATE(3663)] = 126540,
  [SMALL_STATE(3664)] = 126585,
  [SMALL_STATE(3665)] = 126630,
  [SMALL_STATE(3666)] = 126675,
  [SMALL_STATE(3667)] = 126726,
  [SMALL_STATE(3668)] = 126771,
  [SMALL_STATE(3669)] = 126816,
  [SMALL_STATE(3670)] = 126861,
  [SMALL_STATE(3671)] = 126906,
  [SMALL_STATE(3672)] = 126951,
  [SMALL_STATE(3673)] = 126998,
  [SMALL_STATE(3674)] = 127043,
  [SMALL_STATE(3675)] = 127088,
  [SMALL_STATE(3676)] = 127133,
  [SMALL_STATE(3677)] = 127178,
  [SMALL_STATE(3678)] = 127223,
  [SMALL_STATE(3679)] = 127268,
  [SMALL_STATE(3680)] = 127313,
  [SMALL_STATE(3681)] = 127358,
  [SMALL_STATE(3682)] = 127403,
  [SMALL_STATE(3683)] = 127448,
  [SMALL_STATE(3684)] = 127493,
  [SMALL_STATE(3685)] = 127538,
  [SMALL_STATE(3686)] = 127583,
  [SMALL_STATE(3687)] = 127628,
  [SMALL_STATE(3688)] = 127673,
  [SMALL_STATE(3689)] = 127718,
  [SMALL_STATE(3690)] = 127763,
  [SMALL_STATE(3691)] = 127808,
  [SMALL_STATE(3692)] = 127853,
  [SMALL_STATE(3693)] = 127898,
  [SMALL_STATE(3694)] = 127943,
  [SMALL_STATE(3695)] = 127988,
  [SMALL_STATE(3696)] = 128033,
  [SMALL_STATE(3697)] = 128078,
  [SMALL_STATE(3698)] = 128123,
  [SMALL_STATE(3699)] = 128168,
  [SMALL_STATE(3700)] = 128213,
  [SMALL_STATE(3701)] = 128258,
  [SMALL_STATE(3702)] = 128311,
  [SMALL_STATE(3703)] = 128356,
  [SMALL_STATE(3704)] = 128401,
  [SMALL_STATE(3705)] = 128446,
  [SMALL_STATE(3706)] = 128491,
  [SMALL_STATE(3707)] = 128536,
  [SMALL_STATE(3708)] = 128581,
  [SMALL_STATE(3709)] = 128626,
  [SMALL_STATE(3710)] = 128671,
  [SMALL_STATE(3711)] = 128716,
  [SMALL_STATE(3712)] = 128761,
  [SMALL_STATE(3713)] = 128806,
  [SMALL_STATE(3714)] = 128851,
  [SMALL_STATE(3715)] = 128904,
  [SMALL_STATE(3716)] = 128949,
  [SMALL_STATE(3717)] = 128994,
  [SMALL_STATE(3718)] = 129039,
  [SMALL_STATE(3719)] = 129084,
  [SMALL_STATE(3720)] = 129129,
  [SMALL_STATE(3721)] = 129174,
  [SMALL_STATE(3722)] = 129219,
  [SMALL_STATE(3723)] = 129264,
  [SMALL_STATE(3724)] = 129317,
  [SMALL_STATE(3725)] = 129362,
  [SMALL_STATE(3726)] = 129407,
  [SMALL_STATE(3727)] = 129452,
  [SMALL_STATE(3728)] = 129501,
  [SMALL_STATE(3729)] = 129546,
  [SMALL_STATE(3730)] = 129591,
  [SMALL_STATE(3731)] = 129636,
  [SMALL_STATE(3732)] = 129683,
  [SMALL_STATE(3733)] = 129728,
  [SMALL_STATE(3734)] = 129773,
  [SMALL_STATE(3735)] = 129818,
  [SMALL_STATE(3736)] = 129871,
  [SMALL_STATE(3737)] = 129916,
  [SMALL_STATE(3738)] = 129961,
  [SMALL_STATE(3739)] = 130006,
  [SMALL_STATE(3740)] = 130051,
  [SMALL_STATE(3741)] = 130096,
  [SMALL_STATE(3742)] = 130141,
  [SMALL_STATE(3743)] = 130186,
  [SMALL_STATE(3744)] = 130231,
  [SMALL_STATE(3745)] = 130284,
  [SMALL_STATE(3746)] = 130337,
  [SMALL_STATE(3747)] = 130390,
  [SMALL_STATE(3748)] = 130435,
  [SMALL_STATE(3749)] = 130480,
  [SMALL_STATE(3750)] = 130525,
  [SMALL_STATE(3751)] = 130572,
  [SMALL_STATE(3752)] = 130617,
  [SMALL_STATE(3753)] = 130662,
  [SMALL_STATE(3754)] = 130707,
  [SMALL_STATE(3755)] = 130752,
  [SMALL_STATE(3756)] = 130797,
  [SMALL_STATE(3757)] = 130842,
  [SMALL_STATE(3758)] = 130887,
  [SMALL_STATE(3759)] = 130932,
  [SMALL_STATE(3760)] = 130977,
  [SMALL_STATE(3761)] = 131024,
  [SMALL_STATE(3762)] = 131071,
  [SMALL_STATE(3763)] = 131116,
  [SMALL_STATE(3764)] = 131161,
  [SMALL_STATE(3765)] = 131206,
  [SMALL_STATE(3766)] = 131251,
  [SMALL_STATE(3767)] = 131296,
  [SMALL_STATE(3768)] = 131341,
  [SMALL_STATE(3769)] = 131386,
  [SMALL_STATE(3770)] = 131431,
  [SMALL_STATE(3771)] = 131484,
  [SMALL_STATE(3772)] = 131529,
  [SMALL_STATE(3773)] = 131582,
  [SMALL_STATE(3774)] = 131627,
  [SMALL_STATE(3775)] = 131676,
  [SMALL_STATE(3776)] = 131725,
  [SMALL_STATE(3777)] = 131770,
  [SMALL_STATE(3778)] = 131815,
  [SMALL_STATE(3779)] = 131860,
  [SMALL_STATE(3780)] = 131905,
  [SMALL_STATE(3781)] = 131950,
  [SMALL_STATE(3782)] = 132003,
  [SMALL_STATE(3783)] = 132048,
  [SMALL_STATE(3784)] = 132093,
  [SMALL_STATE(3785)] = 132137,
  [SMALL_STATE(3786)] = 132181,
  [SMALL_STATE(3787)] = 132225,
  [SMALL_STATE(3788)] = 132269,
  [SMALL_STATE(3789)] = 132313,
  [SMALL_STATE(3790)] = 132357,
  [SMALL_STATE(3791)] = 132401,
  [SMALL_STATE(3792)] = 132445,
  [SMALL_STATE(3793)] = 132489,
  [SMALL_STATE(3794)] = 132533,
  [SMALL_STATE(3795)] = 132581,
  [SMALL_STATE(3796)] = 132625,
  [SMALL_STATE(3797)] = 132671,
  [SMALL_STATE(3798)] = 132719,
  [SMALL_STATE(3799)] = 132763,
  [SMALL_STATE(3800)] = 132807,
  [SMALL_STATE(3801)] = 132851,
  [SMALL_STATE(3802)] = 132895,
  [SMALL_STATE(3803)] = 132939,
  [SMALL_STATE(3804)] = 132985,
  [SMALL_STATE(3805)] = 133033,
  [SMALL_STATE(3806)] = 133077,
  [SMALL_STATE(3807)] = 133121,
  [SMALL_STATE(3808)] = 133165,
  [SMALL_STATE(3809)] = 133209,
  [SMALL_STATE(3810)] = 133293,
  [SMALL_STATE(3811)] = 133337,
  [SMALL_STATE(3812)] = 133381,
  [SMALL_STATE(3813)] = 133425,
  [SMALL_STATE(3814)] = 133469,
  [SMALL_STATE(3815)] = 133513,
  [SMALL_STATE(3816)] = 133557,
  [SMALL_STATE(3817)] = 133601,
  [SMALL_STATE(3818)] = 133645,
  [SMALL_STATE(3819)] = 133689,
  [SMALL_STATE(3820)] = 133733,
  [SMALL_STATE(3821)] = 133777,
  [SMALL_STATE(3822)] = 133821,
  [SMALL_STATE(3823)] = 133865,
  [SMALL_STATE(3824)] = 133911,
  [SMALL_STATE(3825)] = 133955,
  [SMALL_STATE(3826)] = 133999,
  [SMALL_STATE(3827)] = 134043,
  [SMALL_STATE(3828)] = 134087,
  [SMALL_STATE(3829)] = 134131,
  [SMALL_STATE(3830)] = 134175,
  [SMALL_STATE(3831)] = 134219,
  [SMALL_STATE(3832)] = 134263,
  [SMALL_STATE(3833)] = 134307,
  [SMALL_STATE(3834)] = 134351,
  [SMALL_STATE(3835)] = 134395,
  [SMALL_STATE(3836)] = 134439,
  [SMALL_STATE(3837)] = 134483,
  [SMALL_STATE(3838)] = 134527,
  [SMALL_STATE(3839)] = 134571,
  [SMALL_STATE(3840)] = 134615,
  [SMALL_STATE(3841)] = 134659,
  [SMALL_STATE(3842)] = 134703,
  [SMALL_STATE(3843)] = 134747,
  [SMALL_STATE(3844)] = 134791,
  [SMALL_STATE(3845)] = 134835,
  [SMALL_STATE(3846)] = 134879,
  [SMALL_STATE(3847)] = 134923,
  [SMALL_STATE(3848)] = 134967,
  [SMALL_STATE(3849)] = 135011,
  [SMALL_STATE(3850)] = 135055,
  [SMALL_STATE(3851)] = 135099,
  [SMALL_STATE(3852)] = 135143,
  [SMALL_STATE(3853)] = 135187,
  [SMALL_STATE(3854)] = 135235,
  [SMALL_STATE(3855)] = 135279,
  [SMALL_STATE(3856)] = 135323,
  [SMALL_STATE(3857)] = 135367,
  [SMALL_STATE(3858)] = 135411,
  [SMALL_STATE(3859)] = 135455,
  [SMALL_STATE(3860)] = 135499,
  [SMALL_STATE(3861)] = 135543,
  [SMALL_STATE(3862)] = 135587,
  [SMALL_STATE(3863)] = 135631,
  [SMALL_STATE(3864)] = 135675,
  [SMALL_STATE(3865)] = 135719,
  [SMALL_STATE(3866)] = 135763,
  [SMALL_STATE(3867)] = 135807,
  [SMALL_STATE(3868)] = 135851,
  [SMALL_STATE(3869)] = 135895,
  [SMALL_STATE(3870)] = 135939,
  [SMALL_STATE(3871)] = 135983,
  [SMALL_STATE(3872)] = 136027,
  [SMALL_STATE(3873)] = 136071,
  [SMALL_STATE(3874)] = 136115,
  [SMALL_STATE(3875)] = 136159,
  [SMALL_STATE(3876)] = 136203,
  [SMALL_STATE(3877)] = 136247,
  [SMALL_STATE(3878)] = 136291,
  [SMALL_STATE(3879)] = 136335,
  [SMALL_STATE(3880)] = 136379,
  [SMALL_STATE(3881)] = 136423,
  [SMALL_STATE(3882)] = 136467,
  [SMALL_STATE(3883)] = 136511,
  [SMALL_STATE(3884)] = 136555,
  [SMALL_STATE(3885)] = 136599,
  [SMALL_STATE(3886)] = 136643,
  [SMALL_STATE(3887)] = 136687,
  [SMALL_STATE(3888)] = 136731,
  [SMALL_STATE(3889)] = 136775,
  [SMALL_STATE(3890)] = 136819,
  [SMALL_STATE(3891)] = 136863,
  [SMALL_STATE(3892)] = 136907,
  [SMALL_STATE(3893)] = 136951,
  [SMALL_STATE(3894)] = 136995,
  [SMALL_STATE(3895)] = 137039,
  [SMALL_STATE(3896)] = 137083,
  [SMALL_STATE(3897)] = 137127,
  [SMALL_STATE(3898)] = 137173,
  [SMALL_STATE(3899)] = 137217,
  [SMALL_STATE(3900)] = 137263,
  [SMALL_STATE(3901)] = 137309,
  [SMALL_STATE(3902)] = 137353,
  [SMALL_STATE(3903)] = 137399,
  [SMALL_STATE(3904)] = 137443,
  [SMALL_STATE(3905)] = 137487,
  [SMALL_STATE(3906)] = 137533,
  [SMALL_STATE(3907)] = 137577,
  [SMALL_STATE(3908)] = 137621,
  [SMALL_STATE(3909)] = 137665,
  [SMALL_STATE(3910)] = 137709,
  [SMALL_STATE(3911)] = 137753,
  [SMALL_STATE(3912)] = 137797,
  [SMALL_STATE(3913)] = 137841,
  [SMALL_STATE(3914)] = 137885,
  [SMALL_STATE(3915)] = 137929,
  [SMALL_STATE(3916)] = 137973,
  [SMALL_STATE(3917)] = 138017,
  [SMALL_STATE(3918)] = 138061,
  [SMALL_STATE(3919)] = 138105,
  [SMALL_STATE(3920)] = 138149,
  [SMALL_STATE(3921)] = 138197,
  [SMALL_STATE(3922)] = 138241,
  [SMALL_STATE(3923)] = 138285,
  [SMALL_STATE(3924)] = 138331,
  [SMALL_STATE(3925)] = 138375,
  [SMALL_STATE(3926)] = 138419,
  [SMALL_STATE(3927)] = 138463,
  [SMALL_STATE(3928)] = 138507,
  [SMALL_STATE(3929)] = 138551,
  [SMALL_STATE(3930)] = 138595,
  [SMALL_STATE(3931)] = 138641,
  [SMALL_STATE(3932)] = 138685,
  [SMALL_STATE(3933)] = 138729,
  [SMALL_STATE(3934)] = 138773,
  [SMALL_STATE(3935)] = 138817,
  [SMALL_STATE(3936)] = 138861,
  [SMALL_STATE(3937)] = 138905,
  [SMALL_STATE(3938)] = 138949,
  [SMALL_STATE(3939)] = 138993,
  [SMALL_STATE(3940)] = 139037,
  [SMALL_STATE(3941)] = 139081,
  [SMALL_STATE(3942)] = 139125,
  [SMALL_STATE(3943)] = 139169,
  [SMALL_STATE(3944)] = 139213,
  [SMALL_STATE(3945)] = 139267,
  [SMALL_STATE(3946)] = 139311,
  [SMALL_STATE(3947)] = 139355,
  [SMALL_STATE(3948)] = 139399,
  [SMALL_STATE(3949)] = 139445,
  [SMALL_STATE(3950)] = 139489,
  [SMALL_STATE(3951)] = 139533,
  [SMALL_STATE(3952)] = 139579,
  [SMALL_STATE(3953)] = 139623,
  [SMALL_STATE(3954)] = 139667,
  [SMALL_STATE(3955)] = 139711,
  [SMALL_STATE(3956)] = 139755,
  [SMALL_STATE(3957)] = 139799,
  [SMALL_STATE(3958)] = 139843,
  [SMALL_STATE(3959)] = 139887,
  [SMALL_STATE(3960)] = 139931,
  [SMALL_STATE(3961)] = 139975,
  [SMALL_STATE(3962)] = 140021,
  [SMALL_STATE(3963)] = 140065,
  [SMALL_STATE(3964)] = 140109,
  [SMALL_STATE(3965)] = 140155,
  [SMALL_STATE(3966)] = 140199,
  [SMALL_STATE(3967)] = 140243,
  [SMALL_STATE(3968)] = 140287,
  [SMALL_STATE(3969)] = 140331,
  [SMALL_STATE(3970)] = 140375,
  [SMALL_STATE(3971)] = 140419,
  [SMALL_STATE(3972)] = 140463,
  [SMALL_STATE(3973)] = 140507,
  [SMALL_STATE(3974)] = 140551,
  [SMALL_STATE(3975)] = 140595,
  [SMALL_STATE(3976)] = 140639,
  [SMALL_STATE(3977)] = 140683,
  [SMALL_STATE(3978)] = 140727,
  [SMALL_STATE(3979)] = 140771,
  [SMALL_STATE(3980)] = 140815,
  [SMALL_STATE(3981)] = 140859,
  [SMALL_STATE(3982)] = 140903,
  [SMALL_STATE(3983)] = 140947,
  [SMALL_STATE(3984)] = 140991,
  [SMALL_STATE(3985)] = 141035,
  [SMALL_STATE(3986)] = 141079,
  [SMALL_STATE(3987)] = 141123,
  [SMALL_STATE(3988)] = 141167,
  [SMALL_STATE(3989)] = 141211,
  [SMALL_STATE(3990)] = 141257,
  [SMALL_STATE(3991)] = 141301,
  [SMALL_STATE(3992)] = 141345,
  [SMALL_STATE(3993)] = 141389,
  [SMALL_STATE(3994)] = 141433,
  [SMALL_STATE(3995)] = 141477,
  [SMALL_STATE(3996)] = 141521,
  [SMALL_STATE(3997)] = 141565,
  [SMALL_STATE(3998)] = 141609,
  [SMALL_STATE(3999)] = 141653,
  [SMALL_STATE(4000)] = 141697,
  [SMALL_STATE(4001)] = 141741,
  [SMALL_STATE(4002)] = 141785,
  [SMALL_STATE(4003)] = 141829,
  [SMALL_STATE(4004)] = 141873,
  [SMALL_STATE(4005)] = 141917,
  [SMALL_STATE(4006)] = 141961,
  [SMALL_STATE(4007)] = 142005,
  [SMALL_STATE(4008)] = 142051,
  [SMALL_STATE(4009)] = 142095,
  [SMALL_STATE(4010)] = 142139,
  [SMALL_STATE(4011)] = 142183,
  [SMALL_STATE(4012)] = 142227,
  [SMALL_STATE(4013)] = 142273,
  [SMALL_STATE(4014)] = 142317,
  [SMALL_STATE(4015)] = 142361,
  [SMALL_STATE(4016)] = 142405,
  [SMALL_STATE(4017)] = 142449,
  [SMALL_STATE(4018)] = 142497,
  [SMALL_STATE(4019)] = 142541,
  [SMALL_STATE(4020)] = 142585,
  [SMALL_STATE(4021)] = 142629,
  [SMALL_STATE(4022)] = 142673,
  [SMALL_STATE(4023)] = 142727,
  [SMALL_STATE(4024)] = 142771,
  [SMALL_STATE(4025)] = 142815,
  [SMALL_STATE(4026)] = 142859,
  [SMALL_STATE(4027)] = 142903,
  [SMALL_STATE(4028)] = 142951,
  [SMALL_STATE(4029)] = 142995,
  [SMALL_STATE(4030)] = 143043,
  [SMALL_STATE(4031)] = 143087,
  [SMALL_STATE(4032)] = 143131,
  [SMALL_STATE(4033)] = 143177,
  [SMALL_STATE(4034)] = 143221,
  [SMALL_STATE(4035)] = 143269,
  [SMALL_STATE(4036)] = 143317,
  [SMALL_STATE(4037)] = 143361,
  [SMALL_STATE(4038)] = 143405,
  [SMALL_STATE(4039)] = 143449,
  [SMALL_STATE(4040)] = 143493,
  [SMALL_STATE(4041)] = 143537,
  [SMALL_STATE(4042)] = 143581,
  [SMALL_STATE(4043)] = 143635,
  [SMALL_STATE(4044)] = 143679,
  [SMALL_STATE(4045)] = 143725,
  [SMALL_STATE(4046)] = 143769,
  [SMALL_STATE(4047)] = 143813,
  [SMALL_STATE(4048)] = 143857,
  [SMALL_STATE(4049)] = 143901,
  [SMALL_STATE(4050)] = 143945,
  [SMALL_STATE(4051)] = 143989,
  [SMALL_STATE(4052)] = 144033,
  [SMALL_STATE(4053)] = 144077,
  [SMALL_STATE(4054)] = 144123,
  [SMALL_STATE(4055)] = 144167,
  [SMALL_STATE(4056)] = 144211,
  [SMALL_STATE(4057)] = 144255,
  [SMALL_STATE(4058)] = 144299,
  [SMALL_STATE(4059)] = 144343,
  [SMALL_STATE(4060)] = 144387,
  [SMALL_STATE(4061)] = 144431,
  [SMALL_STATE(4062)] = 144475,
  [SMALL_STATE(4063)] = 144523,
  [SMALL_STATE(4064)] = 144567,
  [SMALL_STATE(4065)] = 144615,
  [SMALL_STATE(4066)] = 144659,
  [SMALL_STATE(4067)] = 144703,
  [SMALL_STATE(4068)] = 144747,
  [SMALL_STATE(4069)] = 144791,
  [SMALL_STATE(4070)] = 144835,
  [SMALL_STATE(4071)] = 144879,
  [SMALL_STATE(4072)] = 144923,
  [SMALL_STATE(4073)] = 144967,
  [SMALL_STATE(4074)] = 145011,
  [SMALL_STATE(4075)] = 145055,
  [SMALL_STATE(4076)] = 145099,
  [SMALL_STATE(4077)] = 145143,
  [SMALL_STATE(4078)] = 145187,
  [SMALL_STATE(4079)] = 145231,
  [SMALL_STATE(4080)] = 145275,
  [SMALL_STATE(4081)] = 145319,
  [SMALL_STATE(4082)] = 145363,
  [SMALL_STATE(4083)] = 145406,
  [SMALL_STATE(4084)] = 145449,
  [SMALL_STATE(4085)] = 145530,
  [SMALL_STATE(4086)] = 145573,
  [SMALL_STATE(4087)] = 145616,
  [SMALL_STATE(4088)] = 145697,
  [SMALL_STATE(4089)] = 145778,
  [SMALL_STATE(4090)] = 145859,
  [SMALL_STATE(4091)] = 145940,
  [SMALL_STATE(4092)] = 145983,
  [SMALL_STATE(4093)] = 146026,
  [SMALL_STATE(4094)] = 146069,
  [SMALL_STATE(4095)] = 146112,
  [SMALL_STATE(4096)] = 146155,
  [SMALL_STATE(4097)] = 146198,
  [SMALL_STATE(4098)] = 146241,
  [SMALL_STATE(4099)] = 146284,
  [SMALL_STATE(4100)] = 146327,
  [SMALL_STATE(4101)] = 146370,
  [SMALL_STATE(4102)] = 146413,
  [SMALL_STATE(4103)] = 146494,
  [SMALL_STATE(4104)] = 146575,
  [SMALL_STATE(4105)] = 146656,
  [SMALL_STATE(4106)] = 146699,
  [SMALL_STATE(4107)] = 146742,
  [SMALL_STATE(4108)] = 146785,
  [SMALL_STATE(4109)] = 146828,
  [SMALL_STATE(4110)] = 146871,
  [SMALL_STATE(4111)] = 146914,
  [SMALL_STATE(4112)] = 146957,
  [SMALL_STATE(4113)] = 147000,
  [SMALL_STATE(4114)] = 147043,
  [SMALL_STATE(4115)] = 147086,
  [SMALL_STATE(4116)] = 147129,
  [SMALL_STATE(4117)] = 147172,
  [SMALL_STATE(4118)] = 147215,
  [SMALL_STATE(4119)] = 147258,
  [SMALL_STATE(4120)] = 147301,
  [SMALL_STATE(4121)] = 147344,
  [SMALL_STATE(4122)] = 147387,
  [SMALL_STATE(4123)] = 147430,
  [SMALL_STATE(4124)] = 147473,
  [SMALL_STATE(4125)] = 147516,
  [SMALL_STATE(4126)] = 147559,
  [SMALL_STATE(4127)] = 147602,
  [SMALL_STATE(4128)] = 147683,
  [SMALL_STATE(4129)] = 147726,
  [SMALL_STATE(4130)] = 147769,
  [SMALL_STATE(4131)] = 147812,
  [SMALL_STATE(4132)] = 147855,
  [SMALL_STATE(4133)] = 147898,
  [SMALL_STATE(4134)] = 147941,
  [SMALL_STATE(4135)] = 147984,
  [SMALL_STATE(4136)] = 148027,
  [SMALL_STATE(4137)] = 148070,
  [SMALL_STATE(4138)] = 148113,
  [SMALL_STATE(4139)] = 148156,
  [SMALL_STATE(4140)] = 148199,
  [SMALL_STATE(4141)] = 148242,
  [SMALL_STATE(4142)] = 148323,
  [SMALL_STATE(4143)] = 148404,
  [SMALL_STATE(4144)] = 148447,
  [SMALL_STATE(4145)] = 148490,
  [SMALL_STATE(4146)] = 148533,
  [SMALL_STATE(4147)] = 148576,
  [SMALL_STATE(4148)] = 148619,
  [SMALL_STATE(4149)] = 148662,
  [SMALL_STATE(4150)] = 148705,
  [SMALL_STATE(4151)] = 148748,
  [SMALL_STATE(4152)] = 148829,
  [SMALL_STATE(4153)] = 148872,
  [SMALL_STATE(4154)] = 148915,
  [SMALL_STATE(4155)] = 148958,
  [SMALL_STATE(4156)] = 149001,
  [SMALL_STATE(4157)] = 149082,
  [SMALL_STATE(4158)] = 149127,
  [SMALL_STATE(4159)] = 149170,
  [SMALL_STATE(4160)] = 149251,
  [SMALL_STATE(4161)] = 149294,
  [SMALL_STATE(4162)] = 149337,
  [SMALL_STATE(4163)] = 149380,
  [SMALL_STATE(4164)] = 149423,
  [SMALL_STATE(4165)] = 149466,
  [SMALL_STATE(4166)] = 149509,
  [SMALL_STATE(4167)] = 149590,
  [SMALL_STATE(4168)] = 149633,
  [SMALL_STATE(4169)] = 149714,
  [SMALL_STATE(4170)] = 149795,
  [SMALL_STATE(4171)] = 149838,
  [SMALL_STATE(4172)] = 149881,
  [SMALL_STATE(4173)] = 149960,
  [SMALL_STATE(4174)] = 150041,
  [SMALL_STATE(4175)] = 150122,
  [SMALL_STATE(4176)] = 150165,
  [SMALL_STATE(4177)] = 150208,
  [SMALL_STATE(4178)] = 150251,
  [SMALL_STATE(4179)] = 150332,
  [SMALL_STATE(4180)] = 150413,
  [SMALL_STATE(4181)] = 150494,
  [SMALL_STATE(4182)] = 150537,
  [SMALL_STATE(4183)] = 150580,
  [SMALL_STATE(4184)] = 150623,
  [SMALL_STATE(4185)] = 150666,
  [SMALL_STATE(4186)] = 150747,
  [SMALL_STATE(4187)] = 150828,
  [SMALL_STATE(4188)] = 150909,
  [SMALL_STATE(4189)] = 150952,
  [SMALL_STATE(4190)] = 150995,
  [SMALL_STATE(4191)] = 151038,
  [SMALL_STATE(4192)] = 151081,
  [SMALL_STATE(4193)] = 151124,
  [SMALL_STATE(4194)] = 151205,
  [SMALL_STATE(4195)] = 151248,
  [SMALL_STATE(4196)] = 151329,
  [SMALL_STATE(4197)] = 151372,
  [SMALL_STATE(4198)] = 151417,
  [SMALL_STATE(4199)] = 151460,
  [SMALL_STATE(4200)] = 151503,
  [SMALL_STATE(4201)] = 151546,
  [SMALL_STATE(4202)] = 151589,
  [SMALL_STATE(4203)] = 151632,
  [SMALL_STATE(4204)] = 151677,
  [SMALL_STATE(4205)] = 151720,
  [SMALL_STATE(4206)] = 151763,
  [SMALL_STATE(4207)] = 151806,
  [SMALL_STATE(4208)] = 151849,
  [SMALL_STATE(4209)] = 151894,
  [SMALL_STATE(4210)] = 151937,
  [SMALL_STATE(4211)] = 151980,
  [SMALL_STATE(4212)] = 152023,
  [SMALL_STATE(4213)] = 152066,
  [SMALL_STATE(4214)] = 152109,
  [SMALL_STATE(4215)] = 152152,
  [SMALL_STATE(4216)] = 152195,
  [SMALL_STATE(4217)] = 152238,
  [SMALL_STATE(4218)] = 152281,
  [SMALL_STATE(4219)] = 152362,
  [SMALL_STATE(4220)] = 152443,
  [SMALL_STATE(4221)] = 152486,
  [SMALL_STATE(4222)] = 152567,
  [SMALL_STATE(4223)] = 152610,
  [SMALL_STATE(4224)] = 152653,
  [SMALL_STATE(4225)] = 152696,
  [SMALL_STATE(4226)] = 152739,
  [SMALL_STATE(4227)] = 152782,
  [SMALL_STATE(4228)] = 152825,
  [SMALL_STATE(4229)] = 152868,
  [SMALL_STATE(4230)] = 152911,
  [SMALL_STATE(4231)] = 152954,
  [SMALL_STATE(4232)] = 152997,
  [SMALL_STATE(4233)] = 153040,
  [SMALL_STATE(4234)] = 153083,
  [SMALL_STATE(4235)] = 153126,
  [SMALL_STATE(4236)] = 153169,
  [SMALL_STATE(4237)] = 153212,
  [SMALL_STATE(4238)] = 153293,
  [SMALL_STATE(4239)] = 153336,
  [SMALL_STATE(4240)] = 153417,
  [SMALL_STATE(4241)] = 153498,
  [SMALL_STATE(4242)] = 153579,
  [SMALL_STATE(4243)] = 153622,
  [SMALL_STATE(4244)] = 153667,
  [SMALL_STATE(4245)] = 153710,
  [SMALL_STATE(4246)] = 153753,
  [SMALL_STATE(4247)] = 153796,
  [SMALL_STATE(4248)] = 153877,
  [SMALL_STATE(4249)] = 153920,
  [SMALL_STATE(4250)] = 153963,
  [SMALL_STATE(4251)] = 154008,
  [SMALL_STATE(4252)] = 154051,
  [SMALL_STATE(4253)] = 154094,
  [SMALL_STATE(4254)] = 154173,
  [SMALL_STATE(4255)] = 154252,
  [SMALL_STATE(4256)] = 154295,
  [SMALL_STATE(4257)] = 154338,
  [SMALL_STATE(4258)] = 154381,
  [SMALL_STATE(4259)] = 154462,
  [SMALL_STATE(4260)] = 154505,
  [SMALL_STATE(4261)] = 154548,
  [SMALL_STATE(4262)] = 154629,
  [SMALL_STATE(4263)] = 154672,
  [SMALL_STATE(4264)] = 154715,
  [SMALL_STATE(4265)] = 154760,
  [SMALL_STATE(4266)] = 154803,
  [SMALL_STATE(4267)] = 154846,
  [SMALL_STATE(4268)] = 154889,
  [SMALL_STATE(4269)] = 154934,
  [SMALL_STATE(4270)] = 154977,
  [SMALL_STATE(4271)] = 155020,
  [SMALL_STATE(4272)] = 155063,
  [SMALL_STATE(4273)] = 155106,
  [SMALL_STATE(4274)] = 155149,
  [SMALL_STATE(4275)] = 155192,
  [SMALL_STATE(4276)] = 155235,
  [SMALL_STATE(4277)] = 155278,
  [SMALL_STATE(4278)] = 155321,
  [SMALL_STATE(4279)] = 155364,
  [SMALL_STATE(4280)] = 155407,
  [SMALL_STATE(4281)] = 155450,
  [SMALL_STATE(4282)] = 155493,
  [SMALL_STATE(4283)] = 155536,
  [SMALL_STATE(4284)] = 155579,
  [SMALL_STATE(4285)] = 155622,
  [SMALL_STATE(4286)] = 155665,
  [SMALL_STATE(4287)] = 155708,
  [SMALL_STATE(4288)] = 155789,
  [SMALL_STATE(4289)] = 155832,
  [SMALL_STATE(4290)] = 155911,
  [SMALL_STATE(4291)] = 155990,
  [SMALL_STATE(4292)] = 156033,
  [SMALL_STATE(4293)] = 156076,
  [SMALL_STATE(4294)] = 156157,
  [SMALL_STATE(4295)] = 156202,
  [SMALL_STATE(4296)] = 156245,
  [SMALL_STATE(4297)] = 156288,
  [SMALL_STATE(4298)] = 156331,
  [SMALL_STATE(4299)] = 156374,
  [SMALL_STATE(4300)] = 156417,
  [SMALL_STATE(4301)] = 156498,
  [SMALL_STATE(4302)] = 156541,
  [SMALL_STATE(4303)] = 156620,
  [SMALL_STATE(4304)] = 156663,
  [SMALL_STATE(4305)] = 156706,
  [SMALL_STATE(4306)] = 156749,
  [SMALL_STATE(4307)] = 156792,
  [SMALL_STATE(4308)] = 156837,
  [SMALL_STATE(4309)] = 156880,
  [SMALL_STATE(4310)] = 156923,
  [SMALL_STATE(4311)] = 156966,
  [SMALL_STATE(4312)] = 157009,
  [SMALL_STATE(4313)] = 157052,
  [SMALL_STATE(4314)] = 157095,
  [SMALL_STATE(4315)] = 157138,
  [SMALL_STATE(4316)] = 157181,
  [SMALL_STATE(4317)] = 157224,
  [SMALL_STATE(4318)] = 157267,
  [SMALL_STATE(4319)] = 157310,
  [SMALL_STATE(4320)] = 157353,
  [SMALL_STATE(4321)] = 157398,
  [SMALL_STATE(4322)] = 157441,
  [SMALL_STATE(4323)] = 157484,
  [SMALL_STATE(4324)] = 157527,
  [SMALL_STATE(4325)] = 157570,
  [SMALL_STATE(4326)] = 157613,
  [SMALL_STATE(4327)] = 157656,
  [SMALL_STATE(4328)] = 157699,
  [SMALL_STATE(4329)] = 157742,
  [SMALL_STATE(4330)] = 157785,
  [SMALL_STATE(4331)] = 157828,
  [SMALL_STATE(4332)] = 157871,
  [SMALL_STATE(4333)] = 157914,
  [SMALL_STATE(4334)] = 157957,
  [SMALL_STATE(4335)] = 158000,
  [SMALL_STATE(4336)] = 158081,
  [SMALL_STATE(4337)] = 158162,
  [SMALL_STATE(4338)] = 158205,
  [SMALL_STATE(4339)] = 158248,
  [SMALL_STATE(4340)] = 158291,
  [SMALL_STATE(4341)] = 158372,
  [SMALL_STATE(4342)] = 158415,
  [SMALL_STATE(4343)] = 158458,
  [SMALL_STATE(4344)] = 158501,
  [SMALL_STATE(4345)] = 158582,
  [SMALL_STATE(4346)] = 158625,
  [SMALL_STATE(4347)] = 158668,
  [SMALL_STATE(4348)] = 158711,
  [SMALL_STATE(4349)] = 158754,
  [SMALL_STATE(4350)] = 158797,
  [SMALL_STATE(4351)] = 158840,
  [SMALL_STATE(4352)] = 158883,
  [SMALL_STATE(4353)] = 158926,
  [SMALL_STATE(4354)] = 158969,
  [SMALL_STATE(4355)] = 159050,
  [SMALL_STATE(4356)] = 159093,
  [SMALL_STATE(4357)] = 159136,
  [SMALL_STATE(4358)] = 159179,
  [SMALL_STATE(4359)] = 159222,
  [SMALL_STATE(4360)] = 159265,
  [SMALL_STATE(4361)] = 159308,
  [SMALL_STATE(4362)] = 159351,
  [SMALL_STATE(4363)] = 159394,
  [SMALL_STATE(4364)] = 159437,
  [SMALL_STATE(4365)] = 159480,
  [SMALL_STATE(4366)] = 159523,
  [SMALL_STATE(4367)] = 159566,
  [SMALL_STATE(4368)] = 159609,
  [SMALL_STATE(4369)] = 159652,
  [SMALL_STATE(4370)] = 159695,
  [SMALL_STATE(4371)] = 159738,
  [SMALL_STATE(4372)] = 159781,
  [SMALL_STATE(4373)] = 159824,
  [SMALL_STATE(4374)] = 159867,
  [SMALL_STATE(4375)] = 159910,
  [SMALL_STATE(4376)] = 159953,
  [SMALL_STATE(4377)] = 160034,
  [SMALL_STATE(4378)] = 160077,
  [SMALL_STATE(4379)] = 160120,
  [SMALL_STATE(4380)] = 160163,
  [SMALL_STATE(4381)] = 160206,
  [SMALL_STATE(4382)] = 160251,
  [SMALL_STATE(4383)] = 160294,
  [SMALL_STATE(4384)] = 160337,
  [SMALL_STATE(4385)] = 160418,
  [SMALL_STATE(4386)] = 160499,
  [SMALL_STATE(4387)] = 160544,
  [SMALL_STATE(4388)] = 160587,
  [SMALL_STATE(4389)] = 160630,
  [SMALL_STATE(4390)] = 160673,
  [SMALL_STATE(4391)] = 160716,
  [SMALL_STATE(4392)] = 160759,
  [SMALL_STATE(4393)] = 160802,
  [SMALL_STATE(4394)] = 160845,
  [SMALL_STATE(4395)] = 160888,
  [SMALL_STATE(4396)] = 160930,
  [SMALL_STATE(4397)] = 160972,
  [SMALL_STATE(4398)] = 161014,
  [SMALL_STATE(4399)] = 161056,
  [SMALL_STATE(4400)] = 161098,
  [SMALL_STATE(4401)] = 161140,
  [SMALL_STATE(4402)] = 161182,
  [SMALL_STATE(4403)] = 161224,
  [SMALL_STATE(4404)] = 161266,
  [SMALL_STATE(4405)] = 161308,
  [SMALL_STATE(4406)] = 161350,
  [SMALL_STATE(4407)] = 161392,
  [SMALL_STATE(4408)] = 161434,
  [SMALL_STATE(4409)] = 161476,
  [SMALL_STATE(4410)] = 161518,
  [SMALL_STATE(4411)] = 161560,
  [SMALL_STATE(4412)] = 161602,
  [SMALL_STATE(4413)] = 161644,
  [SMALL_STATE(4414)] = 161686,
  [SMALL_STATE(4415)] = 161728,
  [SMALL_STATE(4416)] = 161770,
  [SMALL_STATE(4417)] = 161812,
  [SMALL_STATE(4418)] = 161854,
  [SMALL_STATE(4419)] = 161896,
  [SMALL_STATE(4420)] = 161938,
  [SMALL_STATE(4421)] = 161980,
  [SMALL_STATE(4422)] = 162022,
  [SMALL_STATE(4423)] = 162064,
  [SMALL_STATE(4424)] = 162106,
  [SMALL_STATE(4425)] = 162148,
  [SMALL_STATE(4426)] = 162190,
  [SMALL_STATE(4427)] = 162232,
  [SMALL_STATE(4428)] = 162274,
  [SMALL_STATE(4429)] = 162316,
  [SMALL_STATE(4430)] = 162358,
  [SMALL_STATE(4431)] = 162400,
  [SMALL_STATE(4432)] = 162442,
  [SMALL_STATE(4433)] = 162484,
  [SMALL_STATE(4434)] = 162526,
  [SMALL_STATE(4435)] = 162568,
  [SMALL_STATE(4436)] = 162610,
  [SMALL_STATE(4437)] = 162652,
  [SMALL_STATE(4438)] = 162694,
  [SMALL_STATE(4439)] = 162736,
  [SMALL_STATE(4440)] = 162778,
  [SMALL_STATE(4441)] = 162820,
  [SMALL_STATE(4442)] = 162862,
  [SMALL_STATE(4443)] = 162904,
  [SMALL_STATE(4444)] = 162946,
  [SMALL_STATE(4445)] = 162988,
  [SMALL_STATE(4446)] = 163030,
  [SMALL_STATE(4447)] = 163072,
  [SMALL_STATE(4448)] = 163114,
  [SMALL_STATE(4449)] = 163156,
  [SMALL_STATE(4450)] = 163198,
  [SMALL_STATE(4451)] = 163240,
  [SMALL_STATE(4452)] = 163282,
  [SMALL_STATE(4453)] = 163324,
  [SMALL_STATE(4454)] = 163366,
  [SMALL_STATE(4455)] = 163408,
  [SMALL_STATE(4456)] = 163450,
  [SMALL_STATE(4457)] = 163492,
  [SMALL_STATE(4458)] = 163534,
  [SMALL_STATE(4459)] = 163612,
  [SMALL_STATE(4460)] = 163654,
  [SMALL_STATE(4461)] = 163696,
  [SMALL_STATE(4462)] = 163774,
  [SMALL_STATE(4463)] = 163816,
  [SMALL_STATE(4464)] = 163858,
  [SMALL_STATE(4465)] = 163900,
  [SMALL_STATE(4466)] = 163942,
  [SMALL_STATE(4467)] = 163984,
  [SMALL_STATE(4468)] = 164026,
  [SMALL_STATE(4469)] = 164068,
  [SMALL_STATE(4470)] = 164110,
  [SMALL_STATE(4471)] = 164152,
  [SMALL_STATE(4472)] = 164194,
  [SMALL_STATE(4473)] = 164236,
  [SMALL_STATE(4474)] = 164278,
  [SMALL_STATE(4475)] = 164320,
  [SMALL_STATE(4476)] = 164362,
  [SMALL_STATE(4477)] = 164404,
  [SMALL_STATE(4478)] = 164446,
  [SMALL_STATE(4479)] = 164488,
  [SMALL_STATE(4480)] = 164530,
  [SMALL_STATE(4481)] = 164572,
  [SMALL_STATE(4482)] = 164614,
  [SMALL_STATE(4483)] = 164656,
  [SMALL_STATE(4484)] = 164734,
  [SMALL_STATE(4485)] = 164812,
  [SMALL_STATE(4486)] = 164854,
  [SMALL_STATE(4487)] = 164896,
  [SMALL_STATE(4488)] = 164938,
  [SMALL_STATE(4489)] = 164980,
  [SMALL_STATE(4490)] = 165058,
  [SMALL_STATE(4491)] = 165100,
  [SMALL_STATE(4492)] = 165142,
  [SMALL_STATE(4493)] = 165184,
  [SMALL_STATE(4494)] = 165226,
  [SMALL_STATE(4495)] = 165268,
  [SMALL_STATE(4496)] = 165310,
  [SMALL_STATE(4497)] = 165352,
  [SMALL_STATE(4498)] = 165394,
  [SMALL_STATE(4499)] = 165436,
  [SMALL_STATE(4500)] = 165478,
  [SMALL_STATE(4501)] = 165520,
  [SMALL_STATE(4502)] = 165562,
  [SMALL_STATE(4503)] = 165604,
  [SMALL_STATE(4504)] = 165646,
  [SMALL_STATE(4505)] = 165688,
  [SMALL_STATE(4506)] = 165730,
  [SMALL_STATE(4507)] = 165796,
  [SMALL_STATE(4508)] = 165838,
  [SMALL_STATE(4509)] = 165880,
  [SMALL_STATE(4510)] = 165922,
  [SMALL_STATE(4511)] = 165964,
  [SMALL_STATE(4512)] = 166006,
  [SMALL_STATE(4513)] = 166048,
  [SMALL_STATE(4514)] = 166090,
  [SMALL_STATE(4515)] = 166132,
  [SMALL_STATE(4516)] = 166210,
  [SMALL_STATE(4517)] = 166252,
  [SMALL_STATE(4518)] = 166294,
  [SMALL_STATE(4519)] = 166336,
  [SMALL_STATE(4520)] = 166378,
  [SMALL_STATE(4521)] = 166420,
  [SMALL_STATE(4522)] = 166462,
  [SMALL_STATE(4523)] = 166504,
  [SMALL_STATE(4524)] = 166546,
  [SMALL_STATE(4525)] = 166588,
  [SMALL_STATE(4526)] = 166630,
  [SMALL_STATE(4527)] = 166672,
  [SMALL_STATE(4528)] = 166714,
  [SMALL_STATE(4529)] = 166756,
  [SMALL_STATE(4530)] = 166798,
  [SMALL_STATE(4531)] = 166840,
  [SMALL_STATE(4532)] = 166882,
  [SMALL_STATE(4533)] = 166924,
  [SMALL_STATE(4534)] = 166966,
  [SMALL_STATE(4535)] = 167008,
  [SMALL_STATE(4536)] = 167050,
  [SMALL_STATE(4537)] = 167092,
  [SMALL_STATE(4538)] = 167134,
  [SMALL_STATE(4539)] = 167176,
  [SMALL_STATE(4540)] = 167218,
  [SMALL_STATE(4541)] = 167260,
  [SMALL_STATE(4542)] = 167302,
  [SMALL_STATE(4543)] = 167344,
  [SMALL_STATE(4544)] = 167386,
  [SMALL_STATE(4545)] = 167428,
  [SMALL_STATE(4546)] = 167470,
  [SMALL_STATE(4547)] = 167512,
  [SMALL_STATE(4548)] = 167554,
  [SMALL_STATE(4549)] = 167596,
  [SMALL_STATE(4550)] = 167638,
  [SMALL_STATE(4551)] = 167680,
  [SMALL_STATE(4552)] = 167722,
  [SMALL_STATE(4553)] = 167764,
  [SMALL_STATE(4554)] = 167806,
  [SMALL_STATE(4555)] = 167848,
  [SMALL_STATE(4556)] = 167890,
  [SMALL_STATE(4557)] = 167932,
  [SMALL_STATE(4558)] = 168010,
  [SMALL_STATE(4559)] = 168052,
  [SMALL_STATE(4560)] = 168094,
  [SMALL_STATE(4561)] = 168136,
  [SMALL_STATE(4562)] = 168178,
  [SMALL_STATE(4563)] = 168220,
  [SMALL_STATE(4564)] = 168262,
  [SMALL_STATE(4565)] = 168328,
  [SMALL_STATE(4566)] = 168370,
  [SMALL_STATE(4567)] = 168412,
  [SMALL_STATE(4568)] = 168454,
  [SMALL_STATE(4569)] = 168532,
  [SMALL_STATE(4570)] = 168574,
  [SMALL_STATE(4571)] = 168652,
  [SMALL_STATE(4572)] = 168730,
  [SMALL_STATE(4573)] = 168796,
  [SMALL_STATE(4574)] = 168838,
  [SMALL_STATE(4575)] = 168880,
  [SMALL_STATE(4576)] = 168922,
  [SMALL_STATE(4577)] = 168964,
  [SMALL_STATE(4578)] = 169006,
  [SMALL_STATE(4579)] = 169048,
  [SMALL_STATE(4580)] = 169090,
  [SMALL_STATE(4581)] = 169132,
  [SMALL_STATE(4582)] = 169174,
  [SMALL_STATE(4583)] = 169216,
  [SMALL_STATE(4584)] = 169258,
  [SMALL_STATE(4585)] = 169300,
  [SMALL_STATE(4586)] = 169342,
  [SMALL_STATE(4587)] = 169384,
  [SMALL_STATE(4588)] = 169426,
  [SMALL_STATE(4589)] = 169468,
  [SMALL_STATE(4590)] = 169510,
  [SMALL_STATE(4591)] = 169552,
  [SMALL_STATE(4592)] = 169594,
  [SMALL_STATE(4593)] = 169636,
  [SMALL_STATE(4594)] = 169678,
  [SMALL_STATE(4595)] = 169720,
  [SMALL_STATE(4596)] = 169762,
  [SMALL_STATE(4597)] = 169804,
  [SMALL_STATE(4598)] = 169846,
  [SMALL_STATE(4599)] = 169888,
  [SMALL_STATE(4600)] = 169930,
  [SMALL_STATE(4601)] = 169972,
  [SMALL_STATE(4602)] = 170014,
  [SMALL_STATE(4603)] = 170056,
  [SMALL_STATE(4604)] = 170098,
  [SMALL_STATE(4605)] = 170140,
  [SMALL_STATE(4606)] = 170182,
  [SMALL_STATE(4607)] = 170224,
  [SMALL_STATE(4608)] = 170266,
  [SMALL_STATE(4609)] = 170308,
  [SMALL_STATE(4610)] = 170350,
  [SMALL_STATE(4611)] = 170392,
  [SMALL_STATE(4612)] = 170434,
  [SMALL_STATE(4613)] = 170476,
  [SMALL_STATE(4614)] = 170518,
  [SMALL_STATE(4615)] = 170560,
  [SMALL_STATE(4616)] = 170602,
  [SMALL_STATE(4617)] = 170644,
  [SMALL_STATE(4618)] = 170686,
  [SMALL_STATE(4619)] = 170728,
  [SMALL_STATE(4620)] = 170770,
  [SMALL_STATE(4621)] = 170812,
  [SMALL_STATE(4622)] = 170856,
  [SMALL_STATE(4623)] = 170898,
  [SMALL_STATE(4624)] = 170940,
  [SMALL_STATE(4625)] = 170982,
  [SMALL_STATE(4626)] = 171024,
  [SMALL_STATE(4627)] = 171066,
  [SMALL_STATE(4628)] = 171108,
  [SMALL_STATE(4629)] = 171150,
  [SMALL_STATE(4630)] = 171192,
  [SMALL_STATE(4631)] = 171234,
  [SMALL_STATE(4632)] = 171276,
  [SMALL_STATE(4633)] = 171318,
  [SMALL_STATE(4634)] = 171360,
  [SMALL_STATE(4635)] = 171402,
  [SMALL_STATE(4636)] = 171444,
  [SMALL_STATE(4637)] = 171486,
  [SMALL_STATE(4638)] = 171528,
  [SMALL_STATE(4639)] = 171570,
  [SMALL_STATE(4640)] = 171612,
  [SMALL_STATE(4641)] = 171654,
  [SMALL_STATE(4642)] = 171699,
  [SMALL_STATE(4643)] = 171744,
  [SMALL_STATE(4644)] = 171789,
  [SMALL_STATE(4645)] = 171864,
  [SMALL_STATE(4646)] = 171939,
  [SMALL_STATE(4647)] = 172014,
  [SMALL_STATE(4648)] = 172055,
  [SMALL_STATE(4649)] = 172130,
  [SMALL_STATE(4650)] = 172213,
  [SMALL_STATE(4651)] = 172288,
  [SMALL_STATE(4652)] = 172363,
  [SMALL_STATE(4653)] = 172404,
  [SMALL_STATE(4654)] = 172445,
  [SMALL_STATE(4655)] = 172490,
  [SMALL_STATE(4656)] = 172573,
  [SMALL_STATE(4657)] = 172645,
  [SMALL_STATE(4658)] = 172721,
  [SMALL_STATE(4659)] = 172795,
  [SMALL_STATE(4660)] = 172869,
  [SMALL_STATE(4661)] = 172941,
  [SMALL_STATE(4662)] = 173017,
  [SMALL_STATE(4663)] = 173091,
  [SMALL_STATE(4664)] = 173165,
  [SMALL_STATE(4665)] = 173239,
  [SMALL_STATE(4666)] = 173315,
  [SMALL_STATE(4667)] = 173391,
  [SMALL_STATE(4668)] = 173431,
  [SMALL_STATE(4669)] = 173507,
  [SMALL_STATE(4670)] = 173583,
  [SMALL_STATE(4671)] = 173657,
  [SMALL_STATE(4672)] = 173733,
  [SMALL_STATE(4673)] = 173807,
  [SMALL_STATE(4674)] = 173881,
  [SMALL_STATE(4675)] = 173957,
  [SMALL_STATE(4676)] = 174033,
  [SMALL_STATE(4677)] = 174107,
  [SMALL_STATE(4678)] = 174183,
  [SMALL_STATE(4679)] = 174257,
  [SMALL_STATE(4680)] = 174331,
  [SMALL_STATE(4681)] = 174405,
  [SMALL_STATE(4682)] = 174479,
  [SMALL_STATE(4683)] = 174553,
  [SMALL_STATE(4684)] = 174631,
  [SMALL_STATE(4685)] = 174707,
  [SMALL_STATE(4686)] = 174783,
  [SMALL_STATE(4687)] = 174857,
  [SMALL_STATE(4688)] = 174899,
  [SMALL_STATE(4689)] = 174973,
  [SMALL_STATE(4690)] = 175051,
  [SMALL_STATE(4691)] = 175127,
  [SMALL_STATE(4692)] = 175201,
  [SMALL_STATE(4693)] = 175277,
  [SMALL_STATE(4694)] = 175353,
  [SMALL_STATE(4695)] = 175427,
  [SMALL_STATE(4696)] = 175503,
  [SMALL_STATE(4697)] = 175579,
  [SMALL_STATE(4698)] = 175655,
  [SMALL_STATE(4699)] = 175731,
  [SMALL_STATE(4700)] = 175807,
  [SMALL_STATE(4701)] = 175881,
  [SMALL_STATE(4702)] = 175953,
  [SMALL_STATE(4703)] = 176029,
  [SMALL_STATE(4704)] = 176103,
  [SMALL_STATE(4705)] = 176177,
  [SMALL_STATE(4706)] = 176251,
  [SMALL_STATE(4707)] = 176325,
  [SMALL_STATE(4708)] = 176399,
  [SMALL_STATE(4709)] = 176473,
  [SMALL_STATE(4710)] = 176547,
  [SMALL_STATE(4711)] = 176621,
  [SMALL_STATE(4712)] = 176695,
  [SMALL_STATE(4713)] = 176771,
  [SMALL_STATE(4714)] = 176845,
  [SMALL_STATE(4715)] = 176921,
  [SMALL_STATE(4716)] = 176997,
  [SMALL_STATE(4717)] = 177073,
  [SMALL_STATE(4718)] = 177149,
  [SMALL_STATE(4719)] = 177190,
  [SMALL_STATE(4720)] = 177229,
  [SMALL_STATE(4721)] = 177268,
  [SMALL_STATE(4722)] = 177307,
  [SMALL_STATE(4723)] = 177346,
  [SMALL_STATE(4724)] = 177418,
  [SMALL_STATE(4725)] = 177490,
  [SMALL_STATE(4726)] = 177562,
  [SMALL_STATE(4727)] = 177634,
  [SMALL_STATE(4728)] = 177706,
  [SMALL_STATE(4729)] = 177778,
  [SMALL_STATE(4730)] = 177850,
  [SMALL_STATE(4731)] = 177922,
  [SMALL_STATE(4732)] = 177994,
  [SMALL_STATE(4733)] = 178066,
  [SMALL_STATE(4734)] = 178138,
  [SMALL_STATE(4735)] = 178210,
  [SMALL_STATE(4736)] = 178282,
  [SMALL_STATE(4737)] = 178354,
  [SMALL_STATE(4738)] = 178392,
  [SMALL_STATE(4739)] = 178464,
  [SMALL_STATE(4740)] = 178536,
  [SMALL_STATE(4741)] = 178608,
  [SMALL_STATE(4742)] = 178680,
  [SMALL_STATE(4743)] = 178752,
  [SMALL_STATE(4744)] = 178824,
  [SMALL_STATE(4745)] = 178896,
  [SMALL_STATE(4746)] = 178968,
  [SMALL_STATE(4747)] = 179040,
  [SMALL_STATE(4748)] = 179112,
  [SMALL_STATE(4749)] = 179184,
  [SMALL_STATE(4750)] = 179253,
  [SMALL_STATE(4751)] = 179322,
  [SMALL_STATE(4752)] = 179391,
  [SMALL_STATE(4753)] = 179460,
  [SMALL_STATE(4754)] = 179529,
  [SMALL_STATE(4755)] = 179590,
  [SMALL_STATE(4756)] = 179659,
  [SMALL_STATE(4757)] = 179728,
  [SMALL_STATE(4758)] = 179797,
  [SMALL_STATE(4759)] = 179866,
  [SMALL_STATE(4760)] = 179935,
  [SMALL_STATE(4761)] = 179996,
  [SMALL_STATE(4762)] = 180065,
  [SMALL_STATE(4763)] = 180134,
  [SMALL_STATE(4764)] = 180203,
  [SMALL_STATE(4765)] = 180272,
  [SMALL_STATE(4766)] = 180341,
  [SMALL_STATE(4767)] = 180410,
  [SMALL_STATE(4768)] = 180479,
  [SMALL_STATE(4769)] = 180548,
  [SMALL_STATE(4770)] = 180609,
  [SMALL_STATE(4771)] = 180678,
  [SMALL_STATE(4772)] = 180739,
  [SMALL_STATE(4773)] = 180808,
  [SMALL_STATE(4774)] = 180869,
  [SMALL_STATE(4775)] = 180930,
  [SMALL_STATE(4776)] = 180999,
  [SMALL_STATE(4777)] = 181068,
  [SMALL_STATE(4778)] = 181137,
  [SMALL_STATE(4779)] = 181206,
  [SMALL_STATE(4780)] = 181272,
  [SMALL_STATE(4781)] = 181338,
  [SMALL_STATE(4782)] = 181404,
  [SMALL_STATE(4783)] = 181470,
  [SMALL_STATE(4784)] = 181536,
  [SMALL_STATE(4785)] = 181602,
  [SMALL_STATE(4786)] = 181668,
  [SMALL_STATE(4787)] = 181734,
  [SMALL_STATE(4788)] = 181800,
  [SMALL_STATE(4789)] = 181866,
  [SMALL_STATE(4790)] = 181932,
  [SMALL_STATE(4791)] = 181998,
  [SMALL_STATE(4792)] = 182064,
  [SMALL_STATE(4793)] = 182130,
  [SMALL_STATE(4794)] = 182196,
  [SMALL_STATE(4795)] = 182262,
  [SMALL_STATE(4796)] = 182328,
  [SMALL_STATE(4797)] = 182394,
  [SMALL_STATE(4798)] = 182460,
  [SMALL_STATE(4799)] = 182526,
  [SMALL_STATE(4800)] = 182592,
  [SMALL_STATE(4801)] = 182658,
  [SMALL_STATE(4802)] = 182724,
  [SMALL_STATE(4803)] = 182790,
  [SMALL_STATE(4804)] = 182856,
  [SMALL_STATE(4805)] = 182922,
  [SMALL_STATE(4806)] = 182988,
  [SMALL_STATE(4807)] = 183054,
  [SMALL_STATE(4808)] = 183120,
  [SMALL_STATE(4809)] = 183186,
  [SMALL_STATE(4810)] = 183252,
  [SMALL_STATE(4811)] = 183318,
  [SMALL_STATE(4812)] = 183384,
  [SMALL_STATE(4813)] = 183450,
  [SMALL_STATE(4814)] = 183516,
  [SMALL_STATE(4815)] = 183582,
  [SMALL_STATE(4816)] = 183648,
  [SMALL_STATE(4817)] = 183714,
  [SMALL_STATE(4818)] = 183780,
  [SMALL_STATE(4819)] = 183846,
  [SMALL_STATE(4820)] = 183912,
  [SMALL_STATE(4821)] = 183978,
  [SMALL_STATE(4822)] = 184044,
  [SMALL_STATE(4823)] = 184110,
  [SMALL_STATE(4824)] = 184176,
  [SMALL_STATE(4825)] = 184242,
  [SMALL_STATE(4826)] = 184308,
  [SMALL_STATE(4827)] = 184374,
  [SMALL_STATE(4828)] = 184440,
  [SMALL_STATE(4829)] = 184506,
  [SMALL_STATE(4830)] = 184572,
  [SMALL_STATE(4831)] = 184638,
  [SMALL_STATE(4832)] = 184704,
  [SMALL_STATE(4833)] = 184770,
  [SMALL_STATE(4834)] = 184836,
  [SMALL_STATE(4835)] = 184902,
  [SMALL_STATE(4836)] = 184968,
  [SMALL_STATE(4837)] = 185034,
  [SMALL_STATE(4838)] = 185100,
  [SMALL_STATE(4839)] = 185166,
  [SMALL_STATE(4840)] = 185232,
  [SMALL_STATE(4841)] = 185298,
  [SMALL_STATE(4842)] = 185364,
  [SMALL_STATE(4843)] = 185430,
  [SMALL_STATE(4844)] = 185496,
  [SMALL_STATE(4845)] = 185562,
  [SMALL_STATE(4846)] = 185628,
  [SMALL_STATE(4847)] = 185694,
  [SMALL_STATE(4848)] = 185760,
  [SMALL_STATE(4849)] = 185826,
  [SMALL_STATE(4850)] = 185892,
  [SMALL_STATE(4851)] = 185958,
  [SMALL_STATE(4852)] = 186024,
  [SMALL_STATE(4853)] = 186090,
  [SMALL_STATE(4854)] = 186156,
  [SMALL_STATE(4855)] = 186222,
  [SMALL_STATE(4856)] = 186288,
  [SMALL_STATE(4857)] = 186354,
  [SMALL_STATE(4858)] = 186420,
  [SMALL_STATE(4859)] = 186479,
  [SMALL_STATE(4860)] = 186536,
  [SMALL_STATE(4861)] = 186593,
  [SMALL_STATE(4862)] = 186630,
  [SMALL_STATE(4863)] = 186685,
  [SMALL_STATE(4864)] = 186742,
  [SMALL_STATE(4865)] = 186797,
  [SMALL_STATE(4866)] = 186834,
  [SMALL_STATE(4867)] = 186891,
  [SMALL_STATE(4868)] = 186928,
  [SMALL_STATE(4869)] = 186985,
  [SMALL_STATE(4870)] = 187040,
  [SMALL_STATE(4871)] = 187098,
  [SMALL_STATE(4872)] = 187156,
  [SMALL_STATE(4873)] = 187214,
  [SMALL_STATE(4874)] = 187272,
  [SMALL_STATE(4875)] = 187330,
  [SMALL_STATE(4876)] = 187388,
  [SMALL_STATE(4877)] = 187420,
  [SMALL_STATE(4878)] = 187474,
  [SMALL_STATE(4879)] = 187532,
  [SMALL_STATE(4880)] = 187564,
  [SMALL_STATE(4881)] = 187618,
  [SMALL_STATE(4882)] = 187676,
  [SMALL_STATE(4883)] = 187734,
  [SMALL_STATE(4884)] = 187792,
  [SMALL_STATE(4885)] = 187826,
  [SMALL_STATE(4886)] = 187884,
  [SMALL_STATE(4887)] = 187938,
  [SMALL_STATE(4888)] = 187996,
  [SMALL_STATE(4889)] = 188054,
  [SMALL_STATE(4890)] = 188112,
  [SMALL_STATE(4891)] = 188168,
  [SMALL_STATE(4892)] = 188224,
  [SMALL_STATE(4893)] = 188282,
  [SMALL_STATE(4894)] = 188316,
  [SMALL_STATE(4895)] = 188374,
  [SMALL_STATE(4896)] = 188432,
  [SMALL_STATE(4897)] = 188490,
  [SMALL_STATE(4898)] = 188548,
  [SMALL_STATE(4899)] = 188604,
  [SMALL_STATE(4900)] = 188662,
  [SMALL_STATE(4901)] = 188720,
  [SMALL_STATE(4902)] = 188778,
  [SMALL_STATE(4903)] = 188836,
  [SMALL_STATE(4904)] = 188894,
  [SMALL_STATE(4905)] = 188926,
  [SMALL_STATE(4906)] = 188984,
  [SMALL_STATE(4907)] = 189039,
  [SMALL_STATE(4908)] = 189092,
  [SMALL_STATE(4909)] = 189135,
  [SMALL_STATE(4910)] = 189190,
  [SMALL_STATE(4911)] = 189221,
  [SMALL_STATE(4912)] = 189252,
  [SMALL_STATE(4913)] = 189305,
  [SMALL_STATE(4914)] = 189336,
  [SMALL_STATE(4915)] = 189367,
  [SMALL_STATE(4916)] = 189422,
  [SMALL_STATE(4917)] = 189453,
  [SMALL_STATE(4918)] = 189508,
  [SMALL_STATE(4919)] = 189563,
  [SMALL_STATE(4920)] = 189594,
  [SMALL_STATE(4921)] = 189625,
  [SMALL_STATE(4922)] = 189656,
  [SMALL_STATE(4923)] = 189711,
  [SMALL_STATE(4924)] = 189742,
  [SMALL_STATE(4925)] = 189795,
  [SMALL_STATE(4926)] = 189826,
  [SMALL_STATE(4927)] = 189857,
  [SMALL_STATE(4928)] = 189900,
  [SMALL_STATE(4929)] = 189931,
  [SMALL_STATE(4930)] = 189984,
  [SMALL_STATE(4931)] = 190036,
  [SMALL_STATE(4932)] = 190078,
  [SMALL_STATE(4933)] = 190130,
  [SMALL_STATE(4934)] = 190182,
  [SMALL_STATE(4935)] = 190234,
  [SMALL_STATE(4936)] = 190286,
  [SMALL_STATE(4937)] = 190328,
  [SMALL_STATE(4938)] = 190380,
  [SMALL_STATE(4939)] = 190417,
  [SMALL_STATE(4940)] = 190454,
  [SMALL_STATE(4941)] = 190505,
  [SMALL_STATE(4942)] = 190542,
  [SMALL_STATE(4943)] = 190571,
  [SMALL_STATE(4944)] = 190622,
  [SMALL_STATE(4945)] = 190651,
  [SMALL_STATE(4946)] = 190679,
  [SMALL_STATE(4947)] = 190709,
  [SMALL_STATE(4948)] = 190737,
  [SMALL_STATE(4949)] = 190767,
  [SMALL_STATE(4950)] = 190795,
  [SMALL_STATE(4951)] = 190822,
  [SMALL_STATE(4952)] = 190849,
  [SMALL_STATE(4953)] = 190876,
  [SMALL_STATE(4954)] = 190903,
  [SMALL_STATE(4955)] = 190930,
  [SMALL_STATE(4956)] = 190957,
  [SMALL_STATE(4957)] = 190984,
  [SMALL_STATE(4958)] = 191011,
  [SMALL_STATE(4959)] = 191038,
  [SMALL_STATE(4960)] = 191065,
  [SMALL_STATE(4961)] = 191092,
  [SMALL_STATE(4962)] = 191119,
  [SMALL_STATE(4963)] = 191146,
  [SMALL_STATE(4964)] = 191173,
  [SMALL_STATE(4965)] = 191200,
  [SMALL_STATE(4966)] = 191227,
  [SMALL_STATE(4967)] = 191256,
  [SMALL_STATE(4968)] = 191283,
  [SMALL_STATE(4969)] = 191310,
  [SMALL_STATE(4970)] = 191337,
  [SMALL_STATE(4971)] = 191364,
  [SMALL_STATE(4972)] = 191390,
  [SMALL_STATE(4973)] = 191436,
  [SMALL_STATE(4974)] = 191462,
  [SMALL_STATE(4975)] = 191508,
  [SMALL_STATE(4976)] = 191534,
  [SMALL_STATE(4977)] = 191580,
  [SMALL_STATE(4978)] = 191606,
  [SMALL_STATE(4979)] = 191632,
  [SMALL_STATE(4980)] = 191658,
  [SMALL_STATE(4981)] = 191704,
  [SMALL_STATE(4982)] = 191750,
  [SMALL_STATE(4983)] = 191796,
  [SMALL_STATE(4984)] = 191842,
  [SMALL_STATE(4985)] = 191888,
  [SMALL_STATE(4986)] = 191914,
  [SMALL_STATE(4987)] = 191960,
  [SMALL_STATE(4988)] = 191986,
  [SMALL_STATE(4989)] = 192032,
  [SMALL_STATE(4990)] = 192078,
  [SMALL_STATE(4991)] = 192124,
  [SMALL_STATE(4992)] = 192170,
  [SMALL_STATE(4993)] = 192216,
  [SMALL_STATE(4994)] = 192262,
  [SMALL_STATE(4995)] = 192308,
  [SMALL_STATE(4996)] = 192354,
  [SMALL_STATE(4997)] = 192400,
  [SMALL_STATE(4998)] = 192446,
  [SMALL_STATE(4999)] = 192492,
  [SMALL_STATE(5000)] = 192538,
  [SMALL_STATE(5001)] = 192572,
  [SMALL_STATE(5002)] = 192602,
  [SMALL_STATE(5003)] = 192648,
  [SMALL_STATE(5004)] = 192694,
  [SMALL_STATE(5005)] = 192720,
  [SMALL_STATE(5006)] = 192746,
  [SMALL_STATE(5007)] = 192782,
  [SMALL_STATE(5008)] = 192818,
  [SMALL_STATE(5009)] = 192864,
  [SMALL_STATE(5010)] = 192910,
  [SMALL_STATE(5011)] = 192956,
  [SMALL_STATE(5012)] = 192982,
  [SMALL_STATE(5013)] = 193018,
  [SMALL_STATE(5014)] = 193064,
  [SMALL_STATE(5015)] = 193089,
  [SMALL_STATE(5016)] = 193118,
  [SMALL_STATE(5017)] = 193143,
  [SMALL_STATE(5018)] = 193168,
  [SMALL_STATE(5019)] = 193197,
  [SMALL_STATE(5020)] = 193224,
  [SMALL_STATE(5021)] = 193249,
  [SMALL_STATE(5022)] = 193277,
  [SMALL_STATE(5023)] = 193305,
  [SMALL_STATE(5024)] = 193329,
  [SMALL_STATE(5025)] = 193357,
  [SMALL_STATE(5026)] = 193385,
  [SMALL_STATE(5027)] = 193411,
  [SMALL_STATE(5028)] = 193439,
  [SMALL_STATE(5029)] = 193467,
  [SMALL_STATE(5030)] = 193495,
  [SMALL_STATE(5031)] = 193523,
  [SMALL_STATE(5032)] = 193549,
  [SMALL_STATE(5033)] = 193575,
  [SMALL_STATE(5034)] = 193603,
  [SMALL_STATE(5035)] = 193631,
  [SMALL_STATE(5036)] = 193659,
  [SMALL_STATE(5037)] = 193687,
  [SMALL_STATE(5038)] = 193713,
  [SMALL_STATE(5039)] = 193736,
  [SMALL_STATE(5040)] = 193763,
  [SMALL_STATE(5041)] = 193786,
  [SMALL_STATE(5042)] = 193813,
  [SMALL_STATE(5043)] = 193836,
  [SMALL_STATE(5044)] = 193859,
  [SMALL_STATE(5045)] = 193882,
  [SMALL_STATE(5046)] = 193905,
  [SMALL_STATE(5047)] = 193928,
  [SMALL_STATE(5048)] = 193951,
  [SMALL_STATE(5049)] = 193974,
  [SMALL_STATE(5050)] = 194001,
  [SMALL_STATE(5051)] = 194024,
  [SMALL_STATE(5052)] = 194049,
  [SMALL_STATE(5053)] = 194072,
  [SMALL_STATE(5054)] = 194099,
  [SMALL_STATE(5055)] = 194126,
  [SMALL_STATE(5056)] = 194151,
  [SMALL_STATE(5057)] = 194174,
  [SMALL_STATE(5058)] = 194197,
  [SMALL_STATE(5059)] = 194224,
  [SMALL_STATE(5060)] = 194247,
  [SMALL_STATE(5061)] = 194269,
  [SMALL_STATE(5062)] = 194291,
  [SMALL_STATE(5063)] = 194315,
  [SMALL_STATE(5064)] = 194337,
  [SMALL_STATE(5065)] = 194359,
  [SMALL_STATE(5066)] = 194381,
  [SMALL_STATE(5067)] = 194403,
  [SMALL_STATE(5068)] = 194423,
  [SMALL_STATE(5069)] = 194445,
  [SMALL_STATE(5070)] = 194467,
  [SMALL_STATE(5071)] = 194489,
  [SMALL_STATE(5072)] = 194511,
  [SMALL_STATE(5073)] = 194531,
  [SMALL_STATE(5074)] = 194553,
  [SMALL_STATE(5075)] = 194575,
  [SMALL_STATE(5076)] = 194597,
  [SMALL_STATE(5077)] = 194619,
  [SMALL_STATE(5078)] = 194639,
  [SMALL_STATE(5079)] = 194661,
  [SMALL_STATE(5080)] = 194687,
  [SMALL_STATE(5081)] = 194709,
  [SMALL_STATE(5082)] = 194731,
  [SMALL_STATE(5083)] = 194753,
  [SMALL_STATE(5084)] = 194779,
  [SMALL_STATE(5085)] = 194805,
  [SMALL_STATE(5086)] = 194827,
  [SMALL_STATE(5087)] = 194849,
  [SMALL_STATE(5088)] = 194871,
  [SMALL_STATE(5089)] = 194893,
  [SMALL_STATE(5090)] = 194913,
  [SMALL_STATE(5091)] = 194935,
  [SMALL_STATE(5092)] = 194955,
  [SMALL_STATE(5093)] = 194977,
  [SMALL_STATE(5094)] = 194999,
  [SMALL_STATE(5095)] = 195021,
  [SMALL_STATE(5096)] = 195045,
  [SMALL_STATE(5097)] = 195067,
  [SMALL_STATE(5098)] = 195089,
  [SMALL_STATE(5099)] = 195111,
  [SMALL_STATE(5100)] = 195133,
  [SMALL_STATE(5101)] = 195155,
  [SMALL_STATE(5102)] = 195177,
  [SMALL_STATE(5103)] = 195197,
  [SMALL_STATE(5104)] = 195219,
  [SMALL_STATE(5105)] = 195241,
  [SMALL_STATE(5106)] = 195263,
  [SMALL_STATE(5107)] = 195283,
  [SMALL_STATE(5108)] = 195305,
  [SMALL_STATE(5109)] = 195327,
  [SMALL_STATE(5110)] = 195347,
  [SMALL_STATE(5111)] = 195369,
  [SMALL_STATE(5112)] = 195395,
  [SMALL_STATE(5113)] = 195415,
  [SMALL_STATE(5114)] = 195437,
  [SMALL_STATE(5115)] = 195463,
  [SMALL_STATE(5116)] = 195483,
  [SMALL_STATE(5117)] = 195507,
  [SMALL_STATE(5118)] = 195529,
  [SMALL_STATE(5119)] = 195551,
  [SMALL_STATE(5120)] = 195573,
  [SMALL_STATE(5121)] = 195593,
  [SMALL_STATE(5122)] = 195615,
  [SMALL_STATE(5123)] = 195637,
  [SMALL_STATE(5124)] = 195659,
  [SMALL_STATE(5125)] = 195685,
  [SMALL_STATE(5126)] = 195707,
  [SMALL_STATE(5127)] = 195727,
  [SMALL_STATE(5128)] = 195749,
  [SMALL_STATE(5129)] = 195773,
  [SMALL_STATE(5130)] = 195795,
  [SMALL_STATE(5131)] = 195816,
  [SMALL_STATE(5132)] = 195837,
  [SMALL_STATE(5133)] = 195858,
  [SMALL_STATE(5134)] = 195879,
  [SMALL_STATE(5135)] = 195900,
  [SMALL_STATE(5136)] = 195921,
  [SMALL_STATE(5137)] = 195944,
  [SMALL_STATE(5138)] = 195965,
  [SMALL_STATE(5139)] = 195986,
  [SMALL_STATE(5140)] = 196007,
  [SMALL_STATE(5141)] = 196028,
  [SMALL_STATE(5142)] = 196053,
  [SMALL_STATE(5143)] = 196074,
  [SMALL_STATE(5144)] = 196095,
  [SMALL_STATE(5145)] = 196116,
  [SMALL_STATE(5146)] = 196137,
  [SMALL_STATE(5147)] = 196158,
  [SMALL_STATE(5148)] = 196181,
  [SMALL_STATE(5149)] = 196202,
  [SMALL_STATE(5150)] = 196223,
  [SMALL_STATE(5151)] = 196244,
  [SMALL_STATE(5152)] = 196265,
  [SMALL_STATE(5153)] = 196298,
  [SMALL_STATE(5154)] = 196337,
  [SMALL_STATE(5155)] = 196358,
  [SMALL_STATE(5156)] = 196391,
  [SMALL_STATE(5157)] = 196424,
  [SMALL_STATE(5158)] = 196447,
  [SMALL_STATE(5159)] = 196470,
  [SMALL_STATE(5160)] = 196493,
  [SMALL_STATE(5161)] = 196516,
  [SMALL_STATE(5162)] = 196537,
  [SMALL_STATE(5163)] = 196562,
  [SMALL_STATE(5164)] = 196583,
  [SMALL_STATE(5165)] = 196606,
  [SMALL_STATE(5166)] = 196629,
  [SMALL_STATE(5167)] = 196650,
  [SMALL_STATE(5168)] = 196683,
  [SMALL_STATE(5169)] = 196704,
  [SMALL_STATE(5170)] = 196725,
  [SMALL_STATE(5171)] = 196748,
  [SMALL_STATE(5172)] = 196771,
  [SMALL_STATE(5173)] = 196792,
  [SMALL_STATE(5174)] = 196813,
  [SMALL_STATE(5175)] = 196833,
  [SMALL_STATE(5176)] = 196865,
  [SMALL_STATE(5177)] = 196885,
  [SMALL_STATE(5178)] = 196917,
  [SMALL_STATE(5179)] = 196949,
  [SMALL_STATE(5180)] = 196969,
  [SMALL_STATE(5181)] = 196989,
  [SMALL_STATE(5182)] = 197009,
  [SMALL_STATE(5183)] = 197029,
  [SMALL_STATE(5184)] = 197049,
  [SMALL_STATE(5185)] = 197081,
  [SMALL_STATE(5186)] = 197111,
  [SMALL_STATE(5187)] = 197131,
  [SMALL_STATE(5188)] = 197151,
  [SMALL_STATE(5189)] = 197171,
  [SMALL_STATE(5190)] = 197191,
  [SMALL_STATE(5191)] = 197211,
  [SMALL_STATE(5192)] = 197231,
  [SMALL_STATE(5193)] = 197251,
  [SMALL_STATE(5194)] = 197281,
  [SMALL_STATE(5195)] = 197299,
  [SMALL_STATE(5196)] = 197319,
  [SMALL_STATE(5197)] = 197339,
  [SMALL_STATE(5198)] = 197359,
  [SMALL_STATE(5199)] = 197379,
  [SMALL_STATE(5200)] = 197411,
  [SMALL_STATE(5201)] = 197431,
  [SMALL_STATE(5202)] = 197449,
  [SMALL_STATE(5203)] = 197469,
  [SMALL_STATE(5204)] = 197489,
  [SMALL_STATE(5205)] = 197509,
  [SMALL_STATE(5206)] = 197541,
  [SMALL_STATE(5207)] = 197561,
  [SMALL_STATE(5208)] = 197581,
  [SMALL_STATE(5209)] = 197601,
  [SMALL_STATE(5210)] = 197621,
  [SMALL_STATE(5211)] = 197653,
  [SMALL_STATE(5212)] = 197673,
  [SMALL_STATE(5213)] = 197693,
  [SMALL_STATE(5214)] = 197713,
  [SMALL_STATE(5215)] = 197733,
  [SMALL_STATE(5216)] = 197753,
  [SMALL_STATE(5217)] = 197785,
  [SMALL_STATE(5218)] = 197805,
  [SMALL_STATE(5219)] = 197825,
  [SMALL_STATE(5220)] = 197858,
  [SMALL_STATE(5221)] = 197875,
  [SMALL_STATE(5222)] = 197892,
  [SMALL_STATE(5223)] = 197909,
  [SMALL_STATE(5224)] = 197942,
  [SMALL_STATE(5225)] = 197975,
  [SMALL_STATE(5226)] = 197992,
  [SMALL_STATE(5227)] = 198009,
  [SMALL_STATE(5228)] = 198026,
  [SMALL_STATE(5229)] = 198059,
  [SMALL_STATE(5230)] = 198092,
  [SMALL_STATE(5231)] = 198109,
  [SMALL_STATE(5232)] = 198138,
  [SMALL_STATE(5233)] = 198171,
  [SMALL_STATE(5234)] = 198204,
  [SMALL_STATE(5235)] = 198237,
  [SMALL_STATE(5236)] = 198254,
  [SMALL_STATE(5237)] = 198287,
  [SMALL_STATE(5238)] = 198304,
  [SMALL_STATE(5239)] = 198337,
  [SMALL_STATE(5240)] = 198354,
  [SMALL_STATE(5241)] = 198371,
  [SMALL_STATE(5242)] = 198404,
  [SMALL_STATE(5243)] = 198437,
  [SMALL_STATE(5244)] = 198454,
  [SMALL_STATE(5245)] = 198483,
  [SMALL_STATE(5246)] = 198500,
  [SMALL_STATE(5247)] = 198533,
  [SMALL_STATE(5248)] = 198550,
  [SMALL_STATE(5249)] = 198567,
  [SMALL_STATE(5250)] = 198596,
  [SMALL_STATE(5251)] = 198613,
  [SMALL_STATE(5252)] = 198630,
  [SMALL_STATE(5253)] = 198647,
  [SMALL_STATE(5254)] = 198664,
  [SMALL_STATE(5255)] = 198693,
  [SMALL_STATE(5256)] = 198726,
  [SMALL_STATE(5257)] = 198743,
  [SMALL_STATE(5258)] = 198776,
  [SMALL_STATE(5259)] = 198793,
  [SMALL_STATE(5260)] = 198810,
  [SMALL_STATE(5261)] = 198827,
  [SMALL_STATE(5262)] = 198860,
  [SMALL_STATE(5263)] = 198877,
  [SMALL_STATE(5264)] = 198894,
  [SMALL_STATE(5265)] = 198911,
  [SMALL_STATE(5266)] = 198944,
  [SMALL_STATE(5267)] = 198977,
  [SMALL_STATE(5268)] = 199010,
  [SMALL_STATE(5269)] = 199044,
  [SMALL_STATE(5270)] = 199078,
  [SMALL_STATE(5271)] = 199112,
  [SMALL_STATE(5272)] = 199146,
  [SMALL_STATE(5273)] = 199174,
  [SMALL_STATE(5274)] = 199208,
  [SMALL_STATE(5275)] = 199242,
  [SMALL_STATE(5276)] = 199276,
  [SMALL_STATE(5277)] = 199310,
  [SMALL_STATE(5278)] = 199344,
  [SMALL_STATE(5279)] = 199378,
  [SMALL_STATE(5280)] = 199406,
  [SMALL_STATE(5281)] = 199440,
  [SMALL_STATE(5282)] = 199474,
  [SMALL_STATE(5283)] = 199508,
  [SMALL_STATE(5284)] = 199542,
  [SMALL_STATE(5285)] = 199576,
  [SMALL_STATE(5286)] = 199604,
  [SMALL_STATE(5287)] = 199632,
  [SMALL_STATE(5288)] = 199666,
  [SMALL_STATE(5289)] = 199700,
  [SMALL_STATE(5290)] = 199734,
  [SMALL_STATE(5291)] = 199768,
  [SMALL_STATE(5292)] = 199802,
  [SMALL_STATE(5293)] = 199836,
  [SMALL_STATE(5294)] = 199870,
  [SMALL_STATE(5295)] = 199904,
  [SMALL_STATE(5296)] = 199933,
  [SMALL_STATE(5297)] = 199962,
  [SMALL_STATE(5298)] = 199991,
  [SMALL_STATE(5299)] = 200020,
  [SMALL_STATE(5300)] = 200049,
  [SMALL_STATE(5301)] = 200078,
  [SMALL_STATE(5302)] = 200107,
  [SMALL_STATE(5303)] = 200132,
  [SMALL_STATE(5304)] = 200161,
  [SMALL_STATE(5305)] = 200190,
  [SMALL_STATE(5306)] = 200215,
  [SMALL_STATE(5307)] = 200244,
  [SMALL_STATE(5308)] = 200273,
  [SMALL_STATE(5309)] = 200302,
  [SMALL_STATE(5310)] = 200331,
  [SMALL_STATE(5311)] = 200360,
  [SMALL_STATE(5312)] = 200389,
  [SMALL_STATE(5313)] = 200418,
  [SMALL_STATE(5314)] = 200447,
  [SMALL_STATE(5315)] = 200476,
  [SMALL_STATE(5316)] = 200505,
  [SMALL_STATE(5317)] = 200534,
  [SMALL_STATE(5318)] = 200563,
  [SMALL_STATE(5319)] = 200592,
  [SMALL_STATE(5320)] = 200621,
  [SMALL_STATE(5321)] = 200650,
  [SMALL_STATE(5322)] = 200679,
  [SMALL_STATE(5323)] = 200708,
  [SMALL_STATE(5324)] = 200737,
  [SMALL_STATE(5325)] = 200766,
  [SMALL_STATE(5326)] = 200797,
  [SMALL_STATE(5327)] = 200826,
  [SMALL_STATE(5328)] = 200855,
  [SMALL_STATE(5329)] = 200884,
  [SMALL_STATE(5330)] = 200913,
  [SMALL_STATE(5331)] = 200929,
  [SMALL_STATE(5332)] = 200948,
  [SMALL_STATE(5333)] = 200963,
  [SMALL_STATE(5334)] = 200982,
  [SMALL_STATE(5335)] = 201001,
  [SMALL_STATE(5336)] = 201014,
  [SMALL_STATE(5337)] = 201033,
  [SMALL_STATE(5338)] = 201052,
  [SMALL_STATE(5339)] = 201071,
  [SMALL_STATE(5340)] = 201090,
  [SMALL_STATE(5341)] = 201103,
  [SMALL_STATE(5342)] = 201122,
  [SMALL_STATE(5343)] = 201141,
  [SMALL_STATE(5344)] = 201160,
  [SMALL_STATE(5345)] = 201183,
  [SMALL_STATE(5346)] = 201202,
  [SMALL_STATE(5347)] = 201221,
  [SMALL_STATE(5348)] = 201236,
  [SMALL_STATE(5349)] = 201261,
  [SMALL_STATE(5350)] = 201280,
  [SMALL_STATE(5351)] = 201301,
  [SMALL_STATE(5352)] = 201320,
  [SMALL_STATE(5353)] = 201339,
  [SMALL_STATE(5354)] = 201358,
  [SMALL_STATE(5355)] = 201377,
  [SMALL_STATE(5356)] = 201396,
  [SMALL_STATE(5357)] = 201415,
  [SMALL_STATE(5358)] = 201438,
  [SMALL_STATE(5359)] = 201463,
  [SMALL_STATE(5360)] = 201488,
  [SMALL_STATE(5361)] = 201507,
  [SMALL_STATE(5362)] = 201520,
  [SMALL_STATE(5363)] = 201539,
  [SMALL_STATE(5364)] = 201552,
  [SMALL_STATE(5365)] = 201571,
  [SMALL_STATE(5366)] = 201590,
  [SMALL_STATE(5367)] = 201613,
  [SMALL_STATE(5368)] = 201632,
  [SMALL_STATE(5369)] = 201651,
  [SMALL_STATE(5370)] = 201670,
  [SMALL_STATE(5371)] = 201686,
  [SMALL_STATE(5372)] = 201702,
  [SMALL_STATE(5373)] = 201718,
  [SMALL_STATE(5374)] = 201734,
  [SMALL_STATE(5375)] = 201750,
  [SMALL_STATE(5376)] = 201766,
  [SMALL_STATE(5377)] = 201778,
  [SMALL_STATE(5378)] = 201800,
  [SMALL_STATE(5379)] = 201816,
  [SMALL_STATE(5380)] = 201832,
  [SMALL_STATE(5381)] = 201854,
  [SMALL_STATE(5382)] = 201870,
  [SMALL_STATE(5383)] = 201886,
  [SMALL_STATE(5384)] = 201902,
  [SMALL_STATE(5385)] = 201918,
  [SMALL_STATE(5386)] = 201934,
  [SMALL_STATE(5387)] = 201950,
  [SMALL_STATE(5388)] = 201966,
  [SMALL_STATE(5389)] = 201982,
  [SMALL_STATE(5390)] = 201998,
  [SMALL_STATE(5391)] = 202014,
  [SMALL_STATE(5392)] = 202030,
  [SMALL_STATE(5393)] = 202044,
  [SMALL_STATE(5394)] = 202060,
  [SMALL_STATE(5395)] = 202076,
  [SMALL_STATE(5396)] = 202092,
  [SMALL_STATE(5397)] = 202108,
  [SMALL_STATE(5398)] = 202124,
  [SMALL_STATE(5399)] = 202136,
  [SMALL_STATE(5400)] = 202152,
  [SMALL_STATE(5401)] = 202168,
  [SMALL_STATE(5402)] = 202180,
  [SMALL_STATE(5403)] = 202196,
  [SMALL_STATE(5404)] = 202212,
  [SMALL_STATE(5405)] = 202224,
  [SMALL_STATE(5406)] = 202238,
  [SMALL_STATE(5407)] = 202250,
  [SMALL_STATE(5408)] = 202266,
  [SMALL_STATE(5409)] = 202282,
  [SMALL_STATE(5410)] = 202298,
  [SMALL_STATE(5411)] = 202314,
  [SMALL_STATE(5412)] = 202330,
  [SMALL_STATE(5413)] = 202346,
  [SMALL_STATE(5414)] = 202362,
  [SMALL_STATE(5415)] = 202374,
  [SMALL_STATE(5416)] = 202390,
  [SMALL_STATE(5417)] = 202406,
  [SMALL_STATE(5418)] = 202422,
  [SMALL_STATE(5419)] = 202438,
  [SMALL_STATE(5420)] = 202454,
  [SMALL_STATE(5421)] = 202470,
  [SMALL_STATE(5422)] = 202486,
  [SMALL_STATE(5423)] = 202502,
  [SMALL_STATE(5424)] = 202522,
  [SMALL_STATE(5425)] = 202537,
  [SMALL_STATE(5426)] = 202552,
  [SMALL_STATE(5427)] = 202567,
  [SMALL_STATE(5428)] = 202584,
  [SMALL_STATE(5429)] = 202603,
  [SMALL_STATE(5430)] = 202614,
  [SMALL_STATE(5431)] = 202629,
  [SMALL_STATE(5432)] = 202648,
  [SMALL_STATE(5433)] = 202663,
  [SMALL_STATE(5434)] = 202682,
  [SMALL_STATE(5435)] = 202701,
  [SMALL_STATE(5436)] = 202716,
  [SMALL_STATE(5437)] = 202731,
  [SMALL_STATE(5438)] = 202746,
  [SMALL_STATE(5439)] = 202761,
  [SMALL_STATE(5440)] = 202772,
  [SMALL_STATE(5441)] = 202787,
  [SMALL_STATE(5442)] = 202806,
  [SMALL_STATE(5443)] = 202825,
  [SMALL_STATE(5444)] = 202836,
  [SMALL_STATE(5445)] = 202851,
  [SMALL_STATE(5446)] = 202866,
  [SMALL_STATE(5447)] = 202881,
  [SMALL_STATE(5448)] = 202896,
  [SMALL_STATE(5449)] = 202911,
  [SMALL_STATE(5450)] = 202926,
  [SMALL_STATE(5451)] = 202941,
  [SMALL_STATE(5452)] = 202960,
  [SMALL_STATE(5453)] = 202975,
  [SMALL_STATE(5454)] = 202990,
  [SMALL_STATE(5455)] = 203005,
  [SMALL_STATE(5456)] = 203024,
  [SMALL_STATE(5457)] = 203039,
  [SMALL_STATE(5458)] = 203054,
  [SMALL_STATE(5459)] = 203073,
  [SMALL_STATE(5460)] = 203088,
  [SMALL_STATE(5461)] = 203107,
  [SMALL_STATE(5462)] = 203126,
  [SMALL_STATE(5463)] = 203141,
  [SMALL_STATE(5464)] = 203156,
  [SMALL_STATE(5465)] = 203175,
  [SMALL_STATE(5466)] = 203190,
  [SMALL_STATE(5467)] = 203209,
  [SMALL_STATE(5468)] = 203224,
  [SMALL_STATE(5469)] = 203239,
  [SMALL_STATE(5470)] = 203258,
  [SMALL_STATE(5471)] = 203277,
  [SMALL_STATE(5472)] = 203292,
  [SMALL_STATE(5473)] = 203307,
  [SMALL_STATE(5474)] = 203322,
  [SMALL_STATE(5475)] = 203337,
  [SMALL_STATE(5476)] = 203352,
  [SMALL_STATE(5477)] = 203371,
  [SMALL_STATE(5478)] = 203386,
  [SMALL_STATE(5479)] = 203405,
  [SMALL_STATE(5480)] = 203420,
  [SMALL_STATE(5481)] = 203435,
  [SMALL_STATE(5482)] = 203454,
  [SMALL_STATE(5483)] = 203469,
  [SMALL_STATE(5484)] = 203488,
  [SMALL_STATE(5485)] = 203507,
  [SMALL_STATE(5486)] = 203526,
  [SMALL_STATE(5487)] = 203537,
  [SMALL_STATE(5488)] = 203552,
  [SMALL_STATE(5489)] = 203567,
  [SMALL_STATE(5490)] = 203582,
  [SMALL_STATE(5491)] = 203593,
  [SMALL_STATE(5492)] = 203612,
  [SMALL_STATE(5493)] = 203631,
  [SMALL_STATE(5494)] = 203650,
  [SMALL_STATE(5495)] = 203667,
  [SMALL_STATE(5496)] = 203682,
  [SMALL_STATE(5497)] = 203697,
  [SMALL_STATE(5498)] = 203716,
  [SMALL_STATE(5499)] = 203735,
  [SMALL_STATE(5500)] = 203750,
  [SMALL_STATE(5501)] = 203769,
  [SMALL_STATE(5502)] = 203788,
  [SMALL_STATE(5503)] = 203803,
  [SMALL_STATE(5504)] = 203822,
  [SMALL_STATE(5505)] = 203837,
  [SMALL_STATE(5506)] = 203852,
  [SMALL_STATE(5507)] = 203869,
  [SMALL_STATE(5508)] = 203884,
  [SMALL_STATE(5509)] = 203899,
  [SMALL_STATE(5510)] = 203909,
  [SMALL_STATE(5511)] = 203921,
  [SMALL_STATE(5512)] = 203931,
  [SMALL_STATE(5513)] = 203947,
  [SMALL_STATE(5514)] = 203957,
  [SMALL_STATE(5515)] = 203971,
  [SMALL_STATE(5516)] = 203983,
  [SMALL_STATE(5517)] = 203999,
  [SMALL_STATE(5518)] = 204015,
  [SMALL_STATE(5519)] = 204031,
  [SMALL_STATE(5520)] = 204047,
  [SMALL_STATE(5521)] = 204057,
  [SMALL_STATE(5522)] = 204073,
  [SMALL_STATE(5523)] = 204089,
  [SMALL_STATE(5524)] = 204105,
  [SMALL_STATE(5525)] = 204121,
  [SMALL_STATE(5526)] = 204137,
  [SMALL_STATE(5527)] = 204147,
  [SMALL_STATE(5528)] = 204163,
  [SMALL_STATE(5529)] = 204175,
  [SMALL_STATE(5530)] = 204191,
  [SMALL_STATE(5531)] = 204207,
  [SMALL_STATE(5532)] = 204223,
  [SMALL_STATE(5533)] = 204239,
  [SMALL_STATE(5534)] = 204253,
  [SMALL_STATE(5535)] = 204269,
  [SMALL_STATE(5536)] = 204279,
  [SMALL_STATE(5537)] = 204293,
  [SMALL_STATE(5538)] = 204303,
  [SMALL_STATE(5539)] = 204319,
  [SMALL_STATE(5540)] = 204329,
  [SMALL_STATE(5541)] = 204339,
  [SMALL_STATE(5542)] = 204349,
  [SMALL_STATE(5543)] = 204359,
  [SMALL_STATE(5544)] = 204369,
  [SMALL_STATE(5545)] = 204379,
  [SMALL_STATE(5546)] = 204389,
  [SMALL_STATE(5547)] = 204399,
  [SMALL_STATE(5548)] = 204409,
  [SMALL_STATE(5549)] = 204419,
  [SMALL_STATE(5550)] = 204429,
  [SMALL_STATE(5551)] = 204439,
  [SMALL_STATE(5552)] = 204451,
  [SMALL_STATE(5553)] = 204461,
  [SMALL_STATE(5554)] = 204477,
  [SMALL_STATE(5555)] = 204493,
  [SMALL_STATE(5556)] = 204509,
  [SMALL_STATE(5557)] = 204525,
  [SMALL_STATE(5558)] = 204535,
  [SMALL_STATE(5559)] = 204545,
  [SMALL_STATE(5560)] = 204555,
  [SMALL_STATE(5561)] = 204571,
  [SMALL_STATE(5562)] = 204587,
  [SMALL_STATE(5563)] = 204601,
  [SMALL_STATE(5564)] = 204611,
  [SMALL_STATE(5565)] = 204623,
  [SMALL_STATE(5566)] = 204637,
  [SMALL_STATE(5567)] = 204647,
  [SMALL_STATE(5568)] = 204661,
  [SMALL_STATE(5569)] = 204677,
  [SMALL_STATE(5570)] = 204691,
  [SMALL_STATE(5571)] = 204701,
  [SMALL_STATE(5572)] = 204717,
  [SMALL_STATE(5573)] = 204733,
  [SMALL_STATE(5574)] = 204749,
  [SMALL_STATE(5575)] = 204763,
  [SMALL_STATE(5576)] = 204779,
  [SMALL_STATE(5577)] = 204793,
  [SMALL_STATE(5578)] = 204807,
  [SMALL_STATE(5579)] = 204817,
  [SMALL_STATE(5580)] = 204831,
  [SMALL_STATE(5581)] = 204843,
  [SMALL_STATE(5582)] = 204859,
  [SMALL_STATE(5583)] = 204873,
  [SMALL_STATE(5584)] = 204889,
  [SMALL_STATE(5585)] = 204901,
  [SMALL_STATE(5586)] = 204917,
  [SMALL_STATE(5587)] = 204931,
  [SMALL_STATE(5588)] = 204941,
  [SMALL_STATE(5589)] = 204953,
  [SMALL_STATE(5590)] = 204963,
  [SMALL_STATE(5591)] = 204979,
  [SMALL_STATE(5592)] = 204989,
  [SMALL_STATE(5593)] = 204999,
  [SMALL_STATE(5594)] = 205009,
  [SMALL_STATE(5595)] = 205019,
  [SMALL_STATE(5596)] = 205029,
  [SMALL_STATE(5597)] = 205039,
  [SMALL_STATE(5598)] = 205049,
  [SMALL_STATE(5599)] = 205059,
  [SMALL_STATE(5600)] = 205073,
  [SMALL_STATE(5601)] = 205083,
  [SMALL_STATE(5602)] = 205093,
  [SMALL_STATE(5603)] = 205109,
  [SMALL_STATE(5604)] = 205125,
  [SMALL_STATE(5605)] = 205135,
  [SMALL_STATE(5606)] = 205151,
  [SMALL_STATE(5607)] = 205161,
  [SMALL_STATE(5608)] = 205177,
  [SMALL_STATE(5609)] = 205193,
  [SMALL_STATE(5610)] = 205209,
  [SMALL_STATE(5611)] = 205225,
  [SMALL_STATE(5612)] = 205239,
  [SMALL_STATE(5613)] = 205255,
  [SMALL_STATE(5614)] = 205271,
  [SMALL_STATE(5615)] = 205285,
  [SMALL_STATE(5616)] = 205301,
  [SMALL_STATE(5617)] = 205317,
  [SMALL_STATE(5618)] = 205333,
  [SMALL_STATE(5619)] = 205349,
  [SMALL_STATE(5620)] = 205359,
  [SMALL_STATE(5621)] = 205375,
  [SMALL_STATE(5622)] = 205391,
  [SMALL_STATE(5623)] = 205407,
  [SMALL_STATE(5624)] = 205423,
  [SMALL_STATE(5625)] = 205439,
  [SMALL_STATE(5626)] = 205455,
  [SMALL_STATE(5627)] = 205465,
  [SMALL_STATE(5628)] = 205481,
  [SMALL_STATE(5629)] = 205491,
  [SMALL_STATE(5630)] = 205507,
  [SMALL_STATE(5631)] = 205517,
  [SMALL_STATE(5632)] = 205531,
  [SMALL_STATE(5633)] = 205547,
  [SMALL_STATE(5634)] = 205563,
  [SMALL_STATE(5635)] = 205579,
  [SMALL_STATE(5636)] = 205595,
  [SMALL_STATE(5637)] = 205611,
  [SMALL_STATE(5638)] = 205625,
  [SMALL_STATE(5639)] = 205637,
  [SMALL_STATE(5640)] = 205653,
  [SMALL_STATE(5641)] = 205663,
  [SMALL_STATE(5642)] = 205679,
  [SMALL_STATE(5643)] = 205695,
  [SMALL_STATE(5644)] = 205705,
  [SMALL_STATE(5645)] = 205721,
  [SMALL_STATE(5646)] = 205737,
  [SMALL_STATE(5647)] = 205753,
  [SMALL_STATE(5648)] = 205767,
  [SMALL_STATE(5649)] = 205783,
  [SMALL_STATE(5650)] = 205799,
  [SMALL_STATE(5651)] = 205815,
  [SMALL_STATE(5652)] = 205831,
  [SMALL_STATE(5653)] = 205847,
  [SMALL_STATE(5654)] = 205863,
  [SMALL_STATE(5655)] = 205879,
  [SMALL_STATE(5656)] = 205895,
  [SMALL_STATE(5657)] = 205911,
  [SMALL_STATE(5658)] = 205927,
  [SMALL_STATE(5659)] = 205943,
  [SMALL_STATE(5660)] = 205959,
  [SMALL_STATE(5661)] = 205971,
  [SMALL_STATE(5662)] = 205981,
  [SMALL_STATE(5663)] = 205997,
  [SMALL_STATE(5664)] = 206013,
  [SMALL_STATE(5665)] = 206025,
  [SMALL_STATE(5666)] = 206041,
  [SMALL_STATE(5667)] = 206053,
  [SMALL_STATE(5668)] = 206066,
  [SMALL_STATE(5669)] = 206079,
  [SMALL_STATE(5670)] = 206092,
  [SMALL_STATE(5671)] = 206101,
  [SMALL_STATE(5672)] = 206114,
  [SMALL_STATE(5673)] = 206127,
  [SMALL_STATE(5674)] = 206140,
  [SMALL_STATE(5675)] = 206153,
  [SMALL_STATE(5676)] = 206166,
  [SMALL_STATE(5677)] = 206179,
  [SMALL_STATE(5678)] = 206188,
  [SMALL_STATE(5679)] = 206201,
  [SMALL_STATE(5680)] = 206212,
  [SMALL_STATE(5681)] = 206221,
  [SMALL_STATE(5682)] = 206234,
  [SMALL_STATE(5683)] = 206247,
  [SMALL_STATE(5684)] = 206260,
  [SMALL_STATE(5685)] = 206273,
  [SMALL_STATE(5686)] = 206286,
  [SMALL_STATE(5687)] = 206299,
  [SMALL_STATE(5688)] = 206312,
  [SMALL_STATE(5689)] = 206321,
  [SMALL_STATE(5690)] = 206334,
  [SMALL_STATE(5691)] = 206347,
  [SMALL_STATE(5692)] = 206356,
  [SMALL_STATE(5693)] = 206369,
  [SMALL_STATE(5694)] = 206382,
  [SMALL_STATE(5695)] = 206395,
  [SMALL_STATE(5696)] = 206408,
  [SMALL_STATE(5697)] = 206419,
  [SMALL_STATE(5698)] = 206432,
  [SMALL_STATE(5699)] = 206445,
  [SMALL_STATE(5700)] = 206458,
  [SMALL_STATE(5701)] = 206471,
  [SMALL_STATE(5702)] = 206484,
  [SMALL_STATE(5703)] = 206497,
  [SMALL_STATE(5704)] = 206510,
  [SMALL_STATE(5705)] = 206523,
  [SMALL_STATE(5706)] = 206536,
  [SMALL_STATE(5707)] = 206549,
  [SMALL_STATE(5708)] = 206562,
  [SMALL_STATE(5709)] = 206575,
  [SMALL_STATE(5710)] = 206588,
  [SMALL_STATE(5711)] = 206601,
  [SMALL_STATE(5712)] = 206614,
  [SMALL_STATE(5713)] = 206627,
  [SMALL_STATE(5714)] = 206640,
  [SMALL_STATE(5715)] = 206653,
  [SMALL_STATE(5716)] = 206666,
  [SMALL_STATE(5717)] = 206679,
  [SMALL_STATE(5718)] = 206692,
  [SMALL_STATE(5719)] = 206705,
  [SMALL_STATE(5720)] = 206718,
  [SMALL_STATE(5721)] = 206731,
  [SMALL_STATE(5722)] = 206744,
  [SMALL_STATE(5723)] = 206757,
  [SMALL_STATE(5724)] = 206770,
  [SMALL_STATE(5725)] = 206783,
  [SMALL_STATE(5726)] = 206796,
  [SMALL_STATE(5727)] = 206809,
  [SMALL_STATE(5728)] = 206822,
  [SMALL_STATE(5729)] = 206835,
  [SMALL_STATE(5730)] = 206848,
  [SMALL_STATE(5731)] = 206861,
  [SMALL_STATE(5732)] = 206874,
  [SMALL_STATE(5733)] = 206887,
  [SMALL_STATE(5734)] = 206898,
  [SMALL_STATE(5735)] = 206911,
  [SMALL_STATE(5736)] = 206924,
  [SMALL_STATE(5737)] = 206935,
  [SMALL_STATE(5738)] = 206946,
  [SMALL_STATE(5739)] = 206959,
  [SMALL_STATE(5740)] = 206972,
  [SMALL_STATE(5741)] = 206985,
  [SMALL_STATE(5742)] = 206998,
  [SMALL_STATE(5743)] = 207009,
  [SMALL_STATE(5744)] = 207022,
  [SMALL_STATE(5745)] = 207035,
  [SMALL_STATE(5746)] = 207046,
  [SMALL_STATE(5747)] = 207059,
  [SMALL_STATE(5748)] = 207070,
  [SMALL_STATE(5749)] = 207083,
  [SMALL_STATE(5750)] = 207096,
  [SMALL_STATE(5751)] = 207107,
  [SMALL_STATE(5752)] = 207118,
  [SMALL_STATE(5753)] = 207129,
  [SMALL_STATE(5754)] = 207142,
  [SMALL_STATE(5755)] = 207155,
  [SMALL_STATE(5756)] = 207168,
  [SMALL_STATE(5757)] = 207181,
  [SMALL_STATE(5758)] = 207194,
  [SMALL_STATE(5759)] = 207207,
  [SMALL_STATE(5760)] = 207218,
  [SMALL_STATE(5761)] = 207231,
  [SMALL_STATE(5762)] = 207242,
  [SMALL_STATE(5763)] = 207253,
  [SMALL_STATE(5764)] = 207266,
  [SMALL_STATE(5765)] = 207277,
  [SMALL_STATE(5766)] = 207290,
  [SMALL_STATE(5767)] = 207303,
  [SMALL_STATE(5768)] = 207316,
  [SMALL_STATE(5769)] = 207327,
  [SMALL_STATE(5770)] = 207340,
  [SMALL_STATE(5771)] = 207353,
  [SMALL_STATE(5772)] = 207366,
  [SMALL_STATE(5773)] = 207377,
  [SMALL_STATE(5774)] = 207390,
  [SMALL_STATE(5775)] = 207403,
  [SMALL_STATE(5776)] = 207414,
  [SMALL_STATE(5777)] = 207425,
  [SMALL_STATE(5778)] = 207436,
  [SMALL_STATE(5779)] = 207449,
  [SMALL_STATE(5780)] = 207462,
  [SMALL_STATE(5781)] = 207475,
  [SMALL_STATE(5782)] = 207486,
  [SMALL_STATE(5783)] = 207497,
  [SMALL_STATE(5784)] = 207510,
  [SMALL_STATE(5785)] = 207521,
  [SMALL_STATE(5786)] = 207534,
  [SMALL_STATE(5787)] = 207545,
  [SMALL_STATE(5788)] = 207558,
  [SMALL_STATE(5789)] = 207571,
  [SMALL_STATE(5790)] = 207584,
  [SMALL_STATE(5791)] = 207597,
  [SMALL_STATE(5792)] = 207610,
  [SMALL_STATE(5793)] = 207623,
  [SMALL_STATE(5794)] = 207636,
  [SMALL_STATE(5795)] = 207649,
  [SMALL_STATE(5796)] = 207662,
  [SMALL_STATE(5797)] = 207675,
  [SMALL_STATE(5798)] = 207688,
  [SMALL_STATE(5799)] = 207699,
  [SMALL_STATE(5800)] = 207712,
  [SMALL_STATE(5801)] = 207723,
  [SMALL_STATE(5802)] = 207736,
  [SMALL_STATE(5803)] = 207749,
  [SMALL_STATE(5804)] = 207762,
  [SMALL_STATE(5805)] = 207775,
  [SMALL_STATE(5806)] = 207788,
  [SMALL_STATE(5807)] = 207801,
  [SMALL_STATE(5808)] = 207814,
  [SMALL_STATE(5809)] = 207827,
  [SMALL_STATE(5810)] = 207840,
  [SMALL_STATE(5811)] = 207853,
  [SMALL_STATE(5812)] = 207866,
  [SMALL_STATE(5813)] = 207879,
  [SMALL_STATE(5814)] = 207892,
  [SMALL_STATE(5815)] = 207905,
  [SMALL_STATE(5816)] = 207918,
  [SMALL_STATE(5817)] = 207931,
  [SMALL_STATE(5818)] = 207944,
  [SMALL_STATE(5819)] = 207957,
  [SMALL_STATE(5820)] = 207968,
  [SMALL_STATE(5821)] = 207979,
  [SMALL_STATE(5822)] = 207992,
  [SMALL_STATE(5823)] = 208005,
  [SMALL_STATE(5824)] = 208018,
  [SMALL_STATE(5825)] = 208031,
  [SMALL_STATE(5826)] = 208044,
  [SMALL_STATE(5827)] = 208057,
  [SMALL_STATE(5828)] = 208070,
  [SMALL_STATE(5829)] = 208083,
  [SMALL_STATE(5830)] = 208096,
  [SMALL_STATE(5831)] = 208109,
  [SMALL_STATE(5832)] = 208122,
  [SMALL_STATE(5833)] = 208135,
  [SMALL_STATE(5834)] = 208148,
  [SMALL_STATE(5835)] = 208161,
  [SMALL_STATE(5836)] = 208174,
  [SMALL_STATE(5837)] = 208187,
  [SMALL_STATE(5838)] = 208200,
  [SMALL_STATE(5839)] = 208213,
  [SMALL_STATE(5840)] = 208226,
  [SMALL_STATE(5841)] = 208239,
  [SMALL_STATE(5842)] = 208252,
  [SMALL_STATE(5843)] = 208265,
  [SMALL_STATE(5844)] = 208278,
  [SMALL_STATE(5845)] = 208291,
  [SMALL_STATE(5846)] = 208304,
  [SMALL_STATE(5847)] = 208317,
  [SMALL_STATE(5848)] = 208330,
  [SMALL_STATE(5849)] = 208343,
  [SMALL_STATE(5850)] = 208356,
  [SMALL_STATE(5851)] = 208369,
  [SMALL_STATE(5852)] = 208382,
  [SMALL_STATE(5853)] = 208395,
  [SMALL_STATE(5854)] = 208408,
  [SMALL_STATE(5855)] = 208421,
  [SMALL_STATE(5856)] = 208432,
  [SMALL_STATE(5857)] = 208445,
  [SMALL_STATE(5858)] = 208458,
  [SMALL_STATE(5859)] = 208467,
  [SMALL_STATE(5860)] = 208480,
  [SMALL_STATE(5861)] = 208493,
  [SMALL_STATE(5862)] = 208506,
  [SMALL_STATE(5863)] = 208519,
  [SMALL_STATE(5864)] = 208532,
  [SMALL_STATE(5865)] = 208545,
  [SMALL_STATE(5866)] = 208558,
  [SMALL_STATE(5867)] = 208571,
  [SMALL_STATE(5868)] = 208584,
  [SMALL_STATE(5869)] = 208597,
  [SMALL_STATE(5870)] = 208606,
  [SMALL_STATE(5871)] = 208615,
  [SMALL_STATE(5872)] = 208628,
  [SMALL_STATE(5873)] = 208641,
  [SMALL_STATE(5874)] = 208654,
  [SMALL_STATE(5875)] = 208667,
  [SMALL_STATE(5876)] = 208680,
  [SMALL_STATE(5877)] = 208693,
  [SMALL_STATE(5878)] = 208706,
  [SMALL_STATE(5879)] = 208719,
  [SMALL_STATE(5880)] = 208732,
  [SMALL_STATE(5881)] = 208745,
  [SMALL_STATE(5882)] = 208758,
  [SMALL_STATE(5883)] = 208771,
  [SMALL_STATE(5884)] = 208784,
  [SMALL_STATE(5885)] = 208797,
  [SMALL_STATE(5886)] = 208810,
  [SMALL_STATE(5887)] = 208823,
  [SMALL_STATE(5888)] = 208836,
  [SMALL_STATE(5889)] = 208849,
  [SMALL_STATE(5890)] = 208862,
  [SMALL_STATE(5891)] = 208875,
  [SMALL_STATE(5892)] = 208884,
  [SMALL_STATE(5893)] = 208897,
  [SMALL_STATE(5894)] = 208910,
  [SMALL_STATE(5895)] = 208923,
  [SMALL_STATE(5896)] = 208932,
  [SMALL_STATE(5897)] = 208941,
  [SMALL_STATE(5898)] = 208954,
  [SMALL_STATE(5899)] = 208967,
  [SMALL_STATE(5900)] = 208980,
  [SMALL_STATE(5901)] = 208993,
  [SMALL_STATE(5902)] = 209006,
  [SMALL_STATE(5903)] = 209019,
  [SMALL_STATE(5904)] = 209032,
  [SMALL_STATE(5905)] = 209045,
  [SMALL_STATE(5906)] = 209058,
  [SMALL_STATE(5907)] = 209071,
  [SMALL_STATE(5908)] = 209084,
  [SMALL_STATE(5909)] = 209097,
  [SMALL_STATE(5910)] = 209110,
  [SMALL_STATE(5911)] = 209123,
  [SMALL_STATE(5912)] = 209136,
  [SMALL_STATE(5913)] = 209149,
  [SMALL_STATE(5914)] = 209162,
  [SMALL_STATE(5915)] = 209175,
  [SMALL_STATE(5916)] = 209188,
  [SMALL_STATE(5917)] = 209201,
  [SMALL_STATE(5918)] = 209214,
  [SMALL_STATE(5919)] = 209227,
  [SMALL_STATE(5920)] = 209240,
  [SMALL_STATE(5921)] = 209253,
  [SMALL_STATE(5922)] = 209266,
  [SMALL_STATE(5923)] = 209279,
  [SMALL_STATE(5924)] = 209292,
  [SMALL_STATE(5925)] = 209305,
  [SMALL_STATE(5926)] = 209318,
  [SMALL_STATE(5927)] = 209331,
  [SMALL_STATE(5928)] = 209344,
  [SMALL_STATE(5929)] = 209353,
  [SMALL_STATE(5930)] = 209366,
  [SMALL_STATE(5931)] = 209379,
  [SMALL_STATE(5932)] = 209392,
  [SMALL_STATE(5933)] = 209405,
  [SMALL_STATE(5934)] = 209418,
  [SMALL_STATE(5935)] = 209431,
  [SMALL_STATE(5936)] = 209440,
  [SMALL_STATE(5937)] = 209449,
  [SMALL_STATE(5938)] = 209462,
  [SMALL_STATE(5939)] = 209475,
  [SMALL_STATE(5940)] = 209488,
  [SMALL_STATE(5941)] = 209501,
  [SMALL_STATE(5942)] = 209514,
  [SMALL_STATE(5943)] = 209527,
  [SMALL_STATE(5944)] = 209540,
  [SMALL_STATE(5945)] = 209553,
  [SMALL_STATE(5946)] = 209566,
  [SMALL_STATE(5947)] = 209579,
  [SMALL_STATE(5948)] = 209592,
  [SMALL_STATE(5949)] = 209605,
  [SMALL_STATE(5950)] = 209618,
  [SMALL_STATE(5951)] = 209631,
  [SMALL_STATE(5952)] = 209644,
  [SMALL_STATE(5953)] = 209657,
  [SMALL_STATE(5954)] = 209670,
  [SMALL_STATE(5955)] = 209683,
  [SMALL_STATE(5956)] = 209696,
  [SMALL_STATE(5957)] = 209709,
  [SMALL_STATE(5958)] = 209722,
  [SMALL_STATE(5959)] = 209735,
  [SMALL_STATE(5960)] = 209748,
  [SMALL_STATE(5961)] = 209761,
  [SMALL_STATE(5962)] = 209774,
  [SMALL_STATE(5963)] = 209787,
  [SMALL_STATE(5964)] = 209800,
  [SMALL_STATE(5965)] = 209813,
  [SMALL_STATE(5966)] = 209826,
  [SMALL_STATE(5967)] = 209839,
  [SMALL_STATE(5968)] = 209852,
  [SMALL_STATE(5969)] = 209865,
  [SMALL_STATE(5970)] = 209878,
  [SMALL_STATE(5971)] = 209891,
  [SMALL_STATE(5972)] = 209904,
  [SMALL_STATE(5973)] = 209917,
  [SMALL_STATE(5974)] = 209930,
  [SMALL_STATE(5975)] = 209943,
  [SMALL_STATE(5976)] = 209956,
  [SMALL_STATE(5977)] = 209969,
  [SMALL_STATE(5978)] = 209982,
  [SMALL_STATE(5979)] = 209995,
  [SMALL_STATE(5980)] = 210008,
  [SMALL_STATE(5981)] = 210021,
  [SMALL_STATE(5982)] = 210034,
  [SMALL_STATE(5983)] = 210047,
  [SMALL_STATE(5984)] = 210060,
  [SMALL_STATE(5985)] = 210073,
  [SMALL_STATE(5986)] = 210086,
  [SMALL_STATE(5987)] = 210099,
  [SMALL_STATE(5988)] = 210112,
  [SMALL_STATE(5989)] = 210125,
  [SMALL_STATE(5990)] = 210138,
  [SMALL_STATE(5991)] = 210151,
  [SMALL_STATE(5992)] = 210164,
  [SMALL_STATE(5993)] = 210177,
  [SMALL_STATE(5994)] = 210190,
  [SMALL_STATE(5995)] = 210203,
  [SMALL_STATE(5996)] = 210216,
  [SMALL_STATE(5997)] = 210229,
  [SMALL_STATE(5998)] = 210242,
  [SMALL_STATE(5999)] = 210255,
  [SMALL_STATE(6000)] = 210268,
  [SMALL_STATE(6001)] = 210281,
  [SMALL_STATE(6002)] = 210294,
  [SMALL_STATE(6003)] = 210307,
  [SMALL_STATE(6004)] = 210320,
  [SMALL_STATE(6005)] = 210333,
  [SMALL_STATE(6006)] = 210346,
  [SMALL_STATE(6007)] = 210359,
  [SMALL_STATE(6008)] = 210368,
  [SMALL_STATE(6009)] = 210381,
  [SMALL_STATE(6010)] = 210394,
  [SMALL_STATE(6011)] = 210407,
  [SMALL_STATE(6012)] = 210420,
  [SMALL_STATE(6013)] = 210433,
  [SMALL_STATE(6014)] = 210446,
  [SMALL_STATE(6015)] = 210459,
  [SMALL_STATE(6016)] = 210468,
  [SMALL_STATE(6017)] = 210481,
  [SMALL_STATE(6018)] = 210494,
  [SMALL_STATE(6019)] = 210507,
  [SMALL_STATE(6020)] = 210520,
  [SMALL_STATE(6021)] = 210533,
  [SMALL_STATE(6022)] = 210546,
  [SMALL_STATE(6023)] = 210559,
  [SMALL_STATE(6024)] = 210572,
  [SMALL_STATE(6025)] = 210585,
  [SMALL_STATE(6026)] = 210598,
  [SMALL_STATE(6027)] = 210611,
  [SMALL_STATE(6028)] = 210624,
  [SMALL_STATE(6029)] = 210637,
  [SMALL_STATE(6030)] = 210650,
  [SMALL_STATE(6031)] = 210663,
  [SMALL_STATE(6032)] = 210676,
  [SMALL_STATE(6033)] = 210689,
  [SMALL_STATE(6034)] = 210702,
  [SMALL_STATE(6035)] = 210715,
  [SMALL_STATE(6036)] = 210728,
  [SMALL_STATE(6037)] = 210741,
  [SMALL_STATE(6038)] = 210754,
  [SMALL_STATE(6039)] = 210767,
  [SMALL_STATE(6040)] = 210780,
  [SMALL_STATE(6041)] = 210793,
  [SMALL_STATE(6042)] = 210806,
  [SMALL_STATE(6043)] = 210819,
  [SMALL_STATE(6044)] = 210832,
  [SMALL_STATE(6045)] = 210845,
  [SMALL_STATE(6046)] = 210858,
  [SMALL_STATE(6047)] = 210871,
  [SMALL_STATE(6048)] = 210884,
  [SMALL_STATE(6049)] = 210897,
  [SMALL_STATE(6050)] = 210910,
  [SMALL_STATE(6051)] = 210923,
  [SMALL_STATE(6052)] = 210936,
  [SMALL_STATE(6053)] = 210949,
  [SMALL_STATE(6054)] = 210962,
  [SMALL_STATE(6055)] = 210975,
  [SMALL_STATE(6056)] = 210988,
  [SMALL_STATE(6057)] = 211001,
  [SMALL_STATE(6058)] = 211014,
  [SMALL_STATE(6059)] = 211027,
  [SMALL_STATE(6060)] = 211040,
  [SMALL_STATE(6061)] = 211053,
  [SMALL_STATE(6062)] = 211066,
  [SMALL_STATE(6063)] = 211079,
  [SMALL_STATE(6064)] = 211092,
  [SMALL_STATE(6065)] = 211105,
  [SMALL_STATE(6066)] = 211118,
  [SMALL_STATE(6067)] = 211131,
  [SMALL_STATE(6068)] = 211144,
  [SMALL_STATE(6069)] = 211157,
  [SMALL_STATE(6070)] = 211170,
  [SMALL_STATE(6071)] = 211183,
  [SMALL_STATE(6072)] = 211196,
  [SMALL_STATE(6073)] = 211209,
  [SMALL_STATE(6074)] = 211222,
  [SMALL_STATE(6075)] = 211231,
  [SMALL_STATE(6076)] = 211244,
  [SMALL_STATE(6077)] = 211257,
  [SMALL_STATE(6078)] = 211270,
  [SMALL_STATE(6079)] = 211283,
  [SMALL_STATE(6080)] = 211296,
  [SMALL_STATE(6081)] = 211309,
  [SMALL_STATE(6082)] = 211322,
  [SMALL_STATE(6083)] = 211335,
  [SMALL_STATE(6084)] = 211348,
  [SMALL_STATE(6085)] = 211361,
  [SMALL_STATE(6086)] = 211374,
  [SMALL_STATE(6087)] = 211383,
  [SMALL_STATE(6088)] = 211396,
  [SMALL_STATE(6089)] = 211409,
  [SMALL_STATE(6090)] = 211422,
  [SMALL_STATE(6091)] = 211435,
  [SMALL_STATE(6092)] = 211448,
  [SMALL_STATE(6093)] = 211461,
  [SMALL_STATE(6094)] = 211474,
  [SMALL_STATE(6095)] = 211487,
  [SMALL_STATE(6096)] = 211500,
  [SMALL_STATE(6097)] = 211513,
  [SMALL_STATE(6098)] = 211522,
  [SMALL_STATE(6099)] = 211535,
  [SMALL_STATE(6100)] = 211548,
  [SMALL_STATE(6101)] = 211561,
  [SMALL_STATE(6102)] = 211574,
  [SMALL_STATE(6103)] = 211587,
  [SMALL_STATE(6104)] = 211600,
  [SMALL_STATE(6105)] = 211613,
  [SMALL_STATE(6106)] = 211626,
  [SMALL_STATE(6107)] = 211639,
  [SMALL_STATE(6108)] = 211652,
  [SMALL_STATE(6109)] = 211661,
  [SMALL_STATE(6110)] = 211674,
  [SMALL_STATE(6111)] = 211687,
  [SMALL_STATE(6112)] = 211700,
  [SMALL_STATE(6113)] = 211713,
  [SMALL_STATE(6114)] = 211726,
  [SMALL_STATE(6115)] = 211739,
  [SMALL_STATE(6116)] = 211752,
  [SMALL_STATE(6117)] = 211765,
  [SMALL_STATE(6118)] = 211778,
  [SMALL_STATE(6119)] = 211791,
  [SMALL_STATE(6120)] = 211804,
  [SMALL_STATE(6121)] = 211817,
  [SMALL_STATE(6122)] = 211830,
  [SMALL_STATE(6123)] = 211843,
  [SMALL_STATE(6124)] = 211856,
  [SMALL_STATE(6125)] = 211869,
  [SMALL_STATE(6126)] = 211882,
  [SMALL_STATE(6127)] = 211895,
  [SMALL_STATE(6128)] = 211908,
  [SMALL_STATE(6129)] = 211921,
  [SMALL_STATE(6130)] = 211934,
  [SMALL_STATE(6131)] = 211947,
  [SMALL_STATE(6132)] = 211960,
  [SMALL_STATE(6133)] = 211973,
  [SMALL_STATE(6134)] = 211986,
  [SMALL_STATE(6135)] = 211999,
  [SMALL_STATE(6136)] = 212008,
  [SMALL_STATE(6137)] = 212021,
  [SMALL_STATE(6138)] = 212034,
  [SMALL_STATE(6139)] = 212047,
  [SMALL_STATE(6140)] = 212060,
  [SMALL_STATE(6141)] = 212073,
  [SMALL_STATE(6142)] = 212086,
  [SMALL_STATE(6143)] = 212099,
  [SMALL_STATE(6144)] = 212112,
  [SMALL_STATE(6145)] = 212125,
  [SMALL_STATE(6146)] = 212138,
  [SMALL_STATE(6147)] = 212151,
  [SMALL_STATE(6148)] = 212164,
  [SMALL_STATE(6149)] = 212177,
  [SMALL_STATE(6150)] = 212190,
  [SMALL_STATE(6151)] = 212203,
  [SMALL_STATE(6152)] = 212216,
  [SMALL_STATE(6153)] = 212229,
  [SMALL_STATE(6154)] = 212242,
  [SMALL_STATE(6155)] = 212255,
  [SMALL_STATE(6156)] = 212268,
  [SMALL_STATE(6157)] = 212281,
  [SMALL_STATE(6158)] = 212294,
  [SMALL_STATE(6159)] = 212307,
  [SMALL_STATE(6160)] = 212320,
  [SMALL_STATE(6161)] = 212333,
  [SMALL_STATE(6162)] = 212346,
  [SMALL_STATE(6163)] = 212359,
  [SMALL_STATE(6164)] = 212372,
  [SMALL_STATE(6165)] = 212385,
  [SMALL_STATE(6166)] = 212398,
  [SMALL_STATE(6167)] = 212411,
  [SMALL_STATE(6168)] = 212424,
  [SMALL_STATE(6169)] = 212437,
  [SMALL_STATE(6170)] = 212450,
  [SMALL_STATE(6171)] = 212463,
  [SMALL_STATE(6172)] = 212476,
  [SMALL_STATE(6173)] = 212489,
  [SMALL_STATE(6174)] = 212502,
  [SMALL_STATE(6175)] = 212515,
  [SMALL_STATE(6176)] = 212528,
  [SMALL_STATE(6177)] = 212541,
  [SMALL_STATE(6178)] = 212554,
  [SMALL_STATE(6179)] = 212567,
  [SMALL_STATE(6180)] = 212580,
  [SMALL_STATE(6181)] = 212593,
  [SMALL_STATE(6182)] = 212606,
  [SMALL_STATE(6183)] = 212619,
  [SMALL_STATE(6184)] = 212632,
  [SMALL_STATE(6185)] = 212645,
  [SMALL_STATE(6186)] = 212658,
  [SMALL_STATE(6187)] = 212671,
  [SMALL_STATE(6188)] = 212684,
  [SMALL_STATE(6189)] = 212697,
  [SMALL_STATE(6190)] = 212710,
  [SMALL_STATE(6191)] = 212721,
  [SMALL_STATE(6192)] = 212734,
  [SMALL_STATE(6193)] = 212747,
  [SMALL_STATE(6194)] = 212760,
  [SMALL_STATE(6195)] = 212773,
  [SMALL_STATE(6196)] = 212786,
  [SMALL_STATE(6197)] = 212799,
  [SMALL_STATE(6198)] = 212812,
  [SMALL_STATE(6199)] = 212825,
  [SMALL_STATE(6200)] = 212838,
  [SMALL_STATE(6201)] = 212851,
  [SMALL_STATE(6202)] = 212864,
  [SMALL_STATE(6203)] = 212877,
  [SMALL_STATE(6204)] = 212890,
  [SMALL_STATE(6205)] = 212903,
  [SMALL_STATE(6206)] = 212916,
  [SMALL_STATE(6207)] = 212929,
  [SMALL_STATE(6208)] = 212942,
  [SMALL_STATE(6209)] = 212955,
  [SMALL_STATE(6210)] = 212968,
  [SMALL_STATE(6211)] = 212981,
  [SMALL_STATE(6212)] = 212994,
  [SMALL_STATE(6213)] = 213003,
  [SMALL_STATE(6214)] = 213016,
  [SMALL_STATE(6215)] = 213029,
  [SMALL_STATE(6216)] = 213042,
  [SMALL_STATE(6217)] = 213055,
  [SMALL_STATE(6218)] = 213068,
  [SMALL_STATE(6219)] = 213081,
  [SMALL_STATE(6220)] = 213094,
  [SMALL_STATE(6221)] = 213107,
  [SMALL_STATE(6222)] = 213120,
  [SMALL_STATE(6223)] = 213133,
  [SMALL_STATE(6224)] = 213146,
  [SMALL_STATE(6225)] = 213159,
  [SMALL_STATE(6226)] = 213172,
  [SMALL_STATE(6227)] = 213185,
  [SMALL_STATE(6228)] = 213198,
  [SMALL_STATE(6229)] = 213211,
  [SMALL_STATE(6230)] = 213221,
  [SMALL_STATE(6231)] = 213231,
  [SMALL_STATE(6232)] = 213239,
  [SMALL_STATE(6233)] = 213249,
  [SMALL_STATE(6234)] = 213259,
  [SMALL_STATE(6235)] = 213269,
  [SMALL_STATE(6236)] = 213279,
  [SMALL_STATE(6237)] = 213289,
  [SMALL_STATE(6238)] = 213299,
  [SMALL_STATE(6239)] = 213309,
  [SMALL_STATE(6240)] = 213317,
  [SMALL_STATE(6241)] = 213327,
  [SMALL_STATE(6242)] = 213337,
  [SMALL_STATE(6243)] = 213347,
  [SMALL_STATE(6244)] = 213357,
  [SMALL_STATE(6245)] = 213367,
  [SMALL_STATE(6246)] = 213377,
  [SMALL_STATE(6247)] = 213387,
  [SMALL_STATE(6248)] = 213397,
  [SMALL_STATE(6249)] = 213407,
  [SMALL_STATE(6250)] = 213417,
  [SMALL_STATE(6251)] = 213427,
  [SMALL_STATE(6252)] = 213437,
  [SMALL_STATE(6253)] = 213447,
  [SMALL_STATE(6254)] = 213455,
  [SMALL_STATE(6255)] = 213465,
  [SMALL_STATE(6256)] = 213475,
  [SMALL_STATE(6257)] = 213483,
  [SMALL_STATE(6258)] = 213493,
  [SMALL_STATE(6259)] = 213503,
  [SMALL_STATE(6260)] = 213511,
  [SMALL_STATE(6261)] = 213519,
  [SMALL_STATE(6262)] = 213527,
  [SMALL_STATE(6263)] = 213537,
  [SMALL_STATE(6264)] = 213547,
  [SMALL_STATE(6265)] = 213555,
  [SMALL_STATE(6266)] = 213563,
  [SMALL_STATE(6267)] = 213573,
  [SMALL_STATE(6268)] = 213581,
  [SMALL_STATE(6269)] = 213591,
  [SMALL_STATE(6270)] = 213599,
  [SMALL_STATE(6271)] = 213609,
  [SMALL_STATE(6272)] = 213617,
  [SMALL_STATE(6273)] = 213627,
  [SMALL_STATE(6274)] = 213637,
  [SMALL_STATE(6275)] = 213647,
  [SMALL_STATE(6276)] = 213655,
  [SMALL_STATE(6277)] = 213665,
  [SMALL_STATE(6278)] = 213675,
  [SMALL_STATE(6279)] = 213685,
  [SMALL_STATE(6280)] = 213695,
  [SMALL_STATE(6281)] = 213703,
  [SMALL_STATE(6282)] = 213711,
  [SMALL_STATE(6283)] = 213719,
  [SMALL_STATE(6284)] = 213729,
  [SMALL_STATE(6285)] = 213737,
  [SMALL_STATE(6286)] = 213745,
  [SMALL_STATE(6287)] = 213755,
  [SMALL_STATE(6288)] = 213763,
  [SMALL_STATE(6289)] = 213773,
  [SMALL_STATE(6290)] = 213781,
  [SMALL_STATE(6291)] = 213791,
  [SMALL_STATE(6292)] = 213801,
  [SMALL_STATE(6293)] = 213811,
  [SMALL_STATE(6294)] = 213819,
  [SMALL_STATE(6295)] = 213827,
  [SMALL_STATE(6296)] = 213835,
  [SMALL_STATE(6297)] = 213843,
  [SMALL_STATE(6298)] = 213853,
  [SMALL_STATE(6299)] = 213863,
  [SMALL_STATE(6300)] = 213871,
  [SMALL_STATE(6301)] = 213881,
  [SMALL_STATE(6302)] = 213889,
  [SMALL_STATE(6303)] = 213899,
  [SMALL_STATE(6304)] = 213909,
  [SMALL_STATE(6305)] = 213917,
  [SMALL_STATE(6306)] = 213925,
  [SMALL_STATE(6307)] = 213933,
  [SMALL_STATE(6308)] = 213943,
  [SMALL_STATE(6309)] = 213953,
  [SMALL_STATE(6310)] = 213963,
  [SMALL_STATE(6311)] = 213973,
  [SMALL_STATE(6312)] = 213981,
  [SMALL_STATE(6313)] = 213991,
  [SMALL_STATE(6314)] = 214001,
  [SMALL_STATE(6315)] = 214011,
  [SMALL_STATE(6316)] = 214019,
  [SMALL_STATE(6317)] = 214029,
  [SMALL_STATE(6318)] = 214037,
  [SMALL_STATE(6319)] = 214047,
  [SMALL_STATE(6320)] = 214055,
  [SMALL_STATE(6321)] = 214065,
  [SMALL_STATE(6322)] = 214075,
  [SMALL_STATE(6323)] = 214083,
  [SMALL_STATE(6324)] = 214091,
  [SMALL_STATE(6325)] = 214101,
  [SMALL_STATE(6326)] = 214111,
  [SMALL_STATE(6327)] = 214119,
  [SMALL_STATE(6328)] = 214127,
  [SMALL_STATE(6329)] = 214137,
  [SMALL_STATE(6330)] = 214147,
  [SMALL_STATE(6331)] = 214157,
  [SMALL_STATE(6332)] = 214167,
  [SMALL_STATE(6333)] = 214175,
  [SMALL_STATE(6334)] = 214185,
  [SMALL_STATE(6335)] = 214193,
  [SMALL_STATE(6336)] = 214203,
  [SMALL_STATE(6337)] = 214213,
  [SMALL_STATE(6338)] = 214223,
  [SMALL_STATE(6339)] = 214233,
  [SMALL_STATE(6340)] = 214243,
  [SMALL_STATE(6341)] = 214253,
  [SMALL_STATE(6342)] = 214261,
  [SMALL_STATE(6343)] = 214271,
  [SMALL_STATE(6344)] = 214281,
  [SMALL_STATE(6345)] = 214291,
  [SMALL_STATE(6346)] = 214301,
  [SMALL_STATE(6347)] = 214311,
  [SMALL_STATE(6348)] = 214321,
  [SMALL_STATE(6349)] = 214331,
  [SMALL_STATE(6350)] = 214339,
  [SMALL_STATE(6351)] = 214349,
  [SMALL_STATE(6352)] = 214359,
  [SMALL_STATE(6353)] = 214369,
  [SMALL_STATE(6354)] = 214377,
  [SMALL_STATE(6355)] = 214387,
  [SMALL_STATE(6356)] = 214397,
  [SMALL_STATE(6357)] = 214407,
  [SMALL_STATE(6358)] = 214415,
  [SMALL_STATE(6359)] = 214423,
  [SMALL_STATE(6360)] = 214431,
  [SMALL_STATE(6361)] = 214441,
  [SMALL_STATE(6362)] = 214451,
  [SMALL_STATE(6363)] = 214461,
  [SMALL_STATE(6364)] = 214469,
  [SMALL_STATE(6365)] = 214479,
  [SMALL_STATE(6366)] = 214487,
  [SMALL_STATE(6367)] = 214497,
  [SMALL_STATE(6368)] = 214507,
  [SMALL_STATE(6369)] = 214517,
  [SMALL_STATE(6370)] = 214527,
  [SMALL_STATE(6371)] = 214535,
  [SMALL_STATE(6372)] = 214545,
  [SMALL_STATE(6373)] = 214555,
  [SMALL_STATE(6374)] = 214565,
  [SMALL_STATE(6375)] = 214575,
  [SMALL_STATE(6376)] = 214583,
  [SMALL_STATE(6377)] = 214593,
  [SMALL_STATE(6378)] = 214603,
  [SMALL_STATE(6379)] = 214613,
  [SMALL_STATE(6380)] = 214621,
  [SMALL_STATE(6381)] = 214631,
  [SMALL_STATE(6382)] = 214641,
  [SMALL_STATE(6383)] = 214651,
  [SMALL_STATE(6384)] = 214659,
  [SMALL_STATE(6385)] = 214667,
  [SMALL_STATE(6386)] = 214675,
  [SMALL_STATE(6387)] = 214685,
  [SMALL_STATE(6388)] = 214695,
  [SMALL_STATE(6389)] = 214703,
  [SMALL_STATE(6390)] = 214713,
  [SMALL_STATE(6391)] = 214723,
  [SMALL_STATE(6392)] = 214731,
  [SMALL_STATE(6393)] = 214741,
  [SMALL_STATE(6394)] = 214751,
  [SMALL_STATE(6395)] = 214761,
  [SMALL_STATE(6396)] = 214771,
  [SMALL_STATE(6397)] = 214779,
  [SMALL_STATE(6398)] = 214787,
  [SMALL_STATE(6399)] = 214797,
  [SMALL_STATE(6400)] = 214805,
  [SMALL_STATE(6401)] = 214815,
  [SMALL_STATE(6402)] = 214825,
  [SMALL_STATE(6403)] = 214835,
  [SMALL_STATE(6404)] = 214843,
  [SMALL_STATE(6405)] = 214851,
  [SMALL_STATE(6406)] = 214861,
  [SMALL_STATE(6407)] = 214869,
  [SMALL_STATE(6408)] = 214877,
  [SMALL_STATE(6409)] = 214885,
  [SMALL_STATE(6410)] = 214895,
  [SMALL_STATE(6411)] = 214903,
  [SMALL_STATE(6412)] = 214911,
  [SMALL_STATE(6413)] = 214919,
  [SMALL_STATE(6414)] = 214927,
  [SMALL_STATE(6415)] = 214937,
  [SMALL_STATE(6416)] = 214947,
  [SMALL_STATE(6417)] = 214957,
  [SMALL_STATE(6418)] = 214967,
  [SMALL_STATE(6419)] = 214977,
  [SMALL_STATE(6420)] = 214987,
  [SMALL_STATE(6421)] = 214997,
  [SMALL_STATE(6422)] = 215007,
  [SMALL_STATE(6423)] = 215015,
  [SMALL_STATE(6424)] = 215025,
  [SMALL_STATE(6425)] = 215035,
  [SMALL_STATE(6426)] = 215045,
  [SMALL_STATE(6427)] = 215053,
  [SMALL_STATE(6428)] = 215061,
  [SMALL_STATE(6429)] = 215071,
  [SMALL_STATE(6430)] = 215081,
  [SMALL_STATE(6431)] = 215089,
  [SMALL_STATE(6432)] = 215099,
  [SMALL_STATE(6433)] = 215109,
  [SMALL_STATE(6434)] = 215119,
  [SMALL_STATE(6435)] = 215127,
  [SMALL_STATE(6436)] = 215135,
  [SMALL_STATE(6437)] = 215143,
  [SMALL_STATE(6438)] = 215151,
  [SMALL_STATE(6439)] = 215161,
  [SMALL_STATE(6440)] = 215171,
  [SMALL_STATE(6441)] = 215181,
  [SMALL_STATE(6442)] = 215189,
  [SMALL_STATE(6443)] = 215199,
  [SMALL_STATE(6444)] = 215207,
  [SMALL_STATE(6445)] = 215217,
  [SMALL_STATE(6446)] = 215227,
  [SMALL_STATE(6447)] = 215237,
  [SMALL_STATE(6448)] = 215247,
  [SMALL_STATE(6449)] = 215255,
  [SMALL_STATE(6450)] = 215263,
  [SMALL_STATE(6451)] = 215271,
  [SMALL_STATE(6452)] = 215279,
  [SMALL_STATE(6453)] = 215289,
  [SMALL_STATE(6454)] = 215299,
  [SMALL_STATE(6455)] = 215307,
  [SMALL_STATE(6456)] = 215315,
  [SMALL_STATE(6457)] = 215323,
  [SMALL_STATE(6458)] = 215333,
  [SMALL_STATE(6459)] = 215343,
  [SMALL_STATE(6460)] = 215353,
  [SMALL_STATE(6461)] = 215363,
  [SMALL_STATE(6462)] = 215373,
  [SMALL_STATE(6463)] = 215383,
  [SMALL_STATE(6464)] = 215393,
  [SMALL_STATE(6465)] = 215403,
  [SMALL_STATE(6466)] = 215411,
  [SMALL_STATE(6467)] = 215419,
  [SMALL_STATE(6468)] = 215427,
  [SMALL_STATE(6469)] = 215437,
  [SMALL_STATE(6470)] = 215447,
  [SMALL_STATE(6471)] = 215455,
  [SMALL_STATE(6472)] = 215463,
  [SMALL_STATE(6473)] = 215471,
  [SMALL_STATE(6474)] = 215481,
  [SMALL_STATE(6475)] = 215491,
  [SMALL_STATE(6476)] = 215499,
  [SMALL_STATE(6477)] = 215507,
  [SMALL_STATE(6478)] = 215517,
  [SMALL_STATE(6479)] = 215527,
  [SMALL_STATE(6480)] = 215537,
  [SMALL_STATE(6481)] = 215547,
  [SMALL_STATE(6482)] = 215557,
  [SMALL_STATE(6483)] = 215565,
  [SMALL_STATE(6484)] = 215575,
  [SMALL_STATE(6485)] = 215585,
  [SMALL_STATE(6486)] = 215595,
  [SMALL_STATE(6487)] = 215603,
  [SMALL_STATE(6488)] = 215613,
  [SMALL_STATE(6489)] = 215623,
  [SMALL_STATE(6490)] = 215633,
  [SMALL_STATE(6491)] = 215643,
  [SMALL_STATE(6492)] = 215653,
  [SMALL_STATE(6493)] = 215663,
  [SMALL_STATE(6494)] = 215673,
  [SMALL_STATE(6495)] = 215681,
  [SMALL_STATE(6496)] = 215691,
  [SMALL_STATE(6497)] = 215701,
  [SMALL_STATE(6498)] = 215711,
  [SMALL_STATE(6499)] = 215721,
  [SMALL_STATE(6500)] = 215729,
  [SMALL_STATE(6501)] = 215737,
  [SMALL_STATE(6502)] = 215745,
  [SMALL_STATE(6503)] = 215755,
  [SMALL_STATE(6504)] = 215765,
  [SMALL_STATE(6505)] = 215775,
  [SMALL_STATE(6506)] = 215785,
  [SMALL_STATE(6507)] = 215793,
  [SMALL_STATE(6508)] = 215803,
  [SMALL_STATE(6509)] = 215811,
  [SMALL_STATE(6510)] = 215821,
  [SMALL_STATE(6511)] = 215831,
  [SMALL_STATE(6512)] = 215839,
  [SMALL_STATE(6513)] = 215849,
  [SMALL_STATE(6514)] = 215859,
  [SMALL_STATE(6515)] = 215869,
  [SMALL_STATE(6516)] = 215879,
  [SMALL_STATE(6517)] = 215889,
  [SMALL_STATE(6518)] = 215897,
  [SMALL_STATE(6519)] = 215907,
  [SMALL_STATE(6520)] = 215917,
  [SMALL_STATE(6521)] = 215927,
  [SMALL_STATE(6522)] = 215934,
  [SMALL_STATE(6523)] = 215941,
  [SMALL_STATE(6524)] = 215948,
  [SMALL_STATE(6525)] = 215955,
  [SMALL_STATE(6526)] = 215962,
  [SMALL_STATE(6527)] = 215969,
  [SMALL_STATE(6528)] = 215976,
  [SMALL_STATE(6529)] = 215983,
  [SMALL_STATE(6530)] = 215990,
  [SMALL_STATE(6531)] = 215997,
  [SMALL_STATE(6532)] = 216004,
  [SMALL_STATE(6533)] = 216011,
  [SMALL_STATE(6534)] = 216018,
  [SMALL_STATE(6535)] = 216025,
  [SMALL_STATE(6536)] = 216032,
  [SMALL_STATE(6537)] = 216039,
  [SMALL_STATE(6538)] = 216046,
  [SMALL_STATE(6539)] = 216053,
  [SMALL_STATE(6540)] = 216060,
  [SMALL_STATE(6541)] = 216067,
  [SMALL_STATE(6542)] = 216074,
  [SMALL_STATE(6543)] = 216081,
  [SMALL_STATE(6544)] = 216088,
  [SMALL_STATE(6545)] = 216095,
  [SMALL_STATE(6546)] = 216102,
  [SMALL_STATE(6547)] = 216109,
  [SMALL_STATE(6548)] = 216116,
  [SMALL_STATE(6549)] = 216123,
  [SMALL_STATE(6550)] = 216130,
  [SMALL_STATE(6551)] = 216137,
  [SMALL_STATE(6552)] = 216144,
  [SMALL_STATE(6553)] = 216151,
  [SMALL_STATE(6554)] = 216158,
  [SMALL_STATE(6555)] = 216165,
  [SMALL_STATE(6556)] = 216172,
  [SMALL_STATE(6557)] = 216179,
  [SMALL_STATE(6558)] = 216186,
  [SMALL_STATE(6559)] = 216193,
  [SMALL_STATE(6560)] = 216200,
  [SMALL_STATE(6561)] = 216207,
  [SMALL_STATE(6562)] = 216214,
  [SMALL_STATE(6563)] = 216221,
  [SMALL_STATE(6564)] = 216228,
  [SMALL_STATE(6565)] = 216235,
  [SMALL_STATE(6566)] = 216242,
  [SMALL_STATE(6567)] = 216249,
  [SMALL_STATE(6568)] = 216256,
  [SMALL_STATE(6569)] = 216263,
  [SMALL_STATE(6570)] = 216270,
  [SMALL_STATE(6571)] = 216277,
  [SMALL_STATE(6572)] = 216284,
  [SMALL_STATE(6573)] = 216291,
  [SMALL_STATE(6574)] = 216298,
  [SMALL_STATE(6575)] = 216305,
  [SMALL_STATE(6576)] = 216312,
  [SMALL_STATE(6577)] = 216319,
  [SMALL_STATE(6578)] = 216326,
  [SMALL_STATE(6579)] = 216333,
  [SMALL_STATE(6580)] = 216340,
  [SMALL_STATE(6581)] = 216347,
  [SMALL_STATE(6582)] = 216354,
  [SMALL_STATE(6583)] = 216361,
  [SMALL_STATE(6584)] = 216368,
  [SMALL_STATE(6585)] = 216375,
  [SMALL_STATE(6586)] = 216382,
  [SMALL_STATE(6587)] = 216389,
  [SMALL_STATE(6588)] = 216396,
  [SMALL_STATE(6589)] = 216403,
  [SMALL_STATE(6590)] = 216410,
  [SMALL_STATE(6591)] = 216417,
  [SMALL_STATE(6592)] = 216424,
  [SMALL_STATE(6593)] = 216431,
  [SMALL_STATE(6594)] = 216438,
  [SMALL_STATE(6595)] = 216445,
  [SMALL_STATE(6596)] = 216452,
  [SMALL_STATE(6597)] = 216459,
  [SMALL_STATE(6598)] = 216466,
  [SMALL_STATE(6599)] = 216473,
  [SMALL_STATE(6600)] = 216480,
  [SMALL_STATE(6601)] = 216487,
  [SMALL_STATE(6602)] = 216494,
  [SMALL_STATE(6603)] = 216501,
  [SMALL_STATE(6604)] = 216508,
  [SMALL_STATE(6605)] = 216515,
  [SMALL_STATE(6606)] = 216522,
  [SMALL_STATE(6607)] = 216529,
  [SMALL_STATE(6608)] = 216536,
  [SMALL_STATE(6609)] = 216543,
  [SMALL_STATE(6610)] = 216550,
  [SMALL_STATE(6611)] = 216557,
  [SMALL_STATE(6612)] = 216564,
  [SMALL_STATE(6613)] = 216571,
  [SMALL_STATE(6614)] = 216578,
  [SMALL_STATE(6615)] = 216585,
  [SMALL_STATE(6616)] = 216592,
  [SMALL_STATE(6617)] = 216599,
  [SMALL_STATE(6618)] = 216606,
  [SMALL_STATE(6619)] = 216613,
  [SMALL_STATE(6620)] = 216620,
  [SMALL_STATE(6621)] = 216627,
  [SMALL_STATE(6622)] = 216634,
  [SMALL_STATE(6623)] = 216641,
  [SMALL_STATE(6624)] = 216648,
  [SMALL_STATE(6625)] = 216655,
  [SMALL_STATE(6626)] = 216662,
  [SMALL_STATE(6627)] = 216669,
  [SMALL_STATE(6628)] = 216676,
  [SMALL_STATE(6629)] = 216683,
  [SMALL_STATE(6630)] = 216690,
  [SMALL_STATE(6631)] = 216697,
  [SMALL_STATE(6632)] = 216704,
  [SMALL_STATE(6633)] = 216711,
  [SMALL_STATE(6634)] = 216718,
  [SMALL_STATE(6635)] = 216725,
  [SMALL_STATE(6636)] = 216732,
  [SMALL_STATE(6637)] = 216739,
  [SMALL_STATE(6638)] = 216746,
  [SMALL_STATE(6639)] = 216753,
  [SMALL_STATE(6640)] = 216760,
  [SMALL_STATE(6641)] = 216767,
  [SMALL_STATE(6642)] = 216774,
  [SMALL_STATE(6643)] = 216781,
  [SMALL_STATE(6644)] = 216788,
  [SMALL_STATE(6645)] = 216795,
  [SMALL_STATE(6646)] = 216802,
  [SMALL_STATE(6647)] = 216809,
  [SMALL_STATE(6648)] = 216816,
  [SMALL_STATE(6649)] = 216823,
  [SMALL_STATE(6650)] = 216830,
  [SMALL_STATE(6651)] = 216837,
  [SMALL_STATE(6652)] = 216844,
  [SMALL_STATE(6653)] = 216851,
  [SMALL_STATE(6654)] = 216858,
  [SMALL_STATE(6655)] = 216865,
  [SMALL_STATE(6656)] = 216872,
  [SMALL_STATE(6657)] = 216879,
  [SMALL_STATE(6658)] = 216886,
  [SMALL_STATE(6659)] = 216893,
  [SMALL_STATE(6660)] = 216900,
  [SMALL_STATE(6661)] = 216907,
  [SMALL_STATE(6662)] = 216914,
  [SMALL_STATE(6663)] = 216921,
  [SMALL_STATE(6664)] = 216928,
  [SMALL_STATE(6665)] = 216935,
  [SMALL_STATE(6666)] = 216942,
  [SMALL_STATE(6667)] = 216949,
  [SMALL_STATE(6668)] = 216956,
  [SMALL_STATE(6669)] = 216963,
  [SMALL_STATE(6670)] = 216970,
  [SMALL_STATE(6671)] = 216977,
  [SMALL_STATE(6672)] = 216984,
  [SMALL_STATE(6673)] = 216991,
  [SMALL_STATE(6674)] = 216998,
  [SMALL_STATE(6675)] = 217005,
  [SMALL_STATE(6676)] = 217012,
  [SMALL_STATE(6677)] = 217019,
  [SMALL_STATE(6678)] = 217026,
  [SMALL_STATE(6679)] = 217033,
  [SMALL_STATE(6680)] = 217040,
  [SMALL_STATE(6681)] = 217047,
  [SMALL_STATE(6682)] = 217054,
  [SMALL_STATE(6683)] = 217061,
  [SMALL_STATE(6684)] = 217068,
  [SMALL_STATE(6685)] = 217075,
  [SMALL_STATE(6686)] = 217082,
  [SMALL_STATE(6687)] = 217089,
  [SMALL_STATE(6688)] = 217096,
  [SMALL_STATE(6689)] = 217103,
  [SMALL_STATE(6690)] = 217110,
  [SMALL_STATE(6691)] = 217117,
  [SMALL_STATE(6692)] = 217124,
  [SMALL_STATE(6693)] = 217131,
  [SMALL_STATE(6694)] = 217138,
  [SMALL_STATE(6695)] = 217145,
  [SMALL_STATE(6696)] = 217152,
  [SMALL_STATE(6697)] = 217159,
  [SMALL_STATE(6698)] = 217166,
  [SMALL_STATE(6699)] = 217173,
  [SMALL_STATE(6700)] = 217180,
  [SMALL_STATE(6701)] = 217187,
  [SMALL_STATE(6702)] = 217194,
  [SMALL_STATE(6703)] = 217201,
  [SMALL_STATE(6704)] = 217208,
  [SMALL_STATE(6705)] = 217215,
  [SMALL_STATE(6706)] = 217222,
  [SMALL_STATE(6707)] = 217229,
  [SMALL_STATE(6708)] = 217236,
  [SMALL_STATE(6709)] = 217243,
  [SMALL_STATE(6710)] = 217250,
  [SMALL_STATE(6711)] = 217257,
  [SMALL_STATE(6712)] = 217264,
  [SMALL_STATE(6713)] = 217271,
  [SMALL_STATE(6714)] = 217278,
  [SMALL_STATE(6715)] = 217285,
  [SMALL_STATE(6716)] = 217292,
  [SMALL_STATE(6717)] = 217299,
  [SMALL_STATE(6718)] = 217306,
  [SMALL_STATE(6719)] = 217313,
  [SMALL_STATE(6720)] = 217320,
  [SMALL_STATE(6721)] = 217327,
  [SMALL_STATE(6722)] = 217334,
  [SMALL_STATE(6723)] = 217341,
  [SMALL_STATE(6724)] = 217348,
  [SMALL_STATE(6725)] = 217355,
  [SMALL_STATE(6726)] = 217362,
  [SMALL_STATE(6727)] = 217369,
  [SMALL_STATE(6728)] = 217376,
  [SMALL_STATE(6729)] = 217383,
  [SMALL_STATE(6730)] = 217390,
  [SMALL_STATE(6731)] = 217397,
  [SMALL_STATE(6732)] = 217404,
  [SMALL_STATE(6733)] = 217411,
  [SMALL_STATE(6734)] = 217418,
  [SMALL_STATE(6735)] = 217425,
  [SMALL_STATE(6736)] = 217432,
  [SMALL_STATE(6737)] = 217439,
  [SMALL_STATE(6738)] = 217446,
  [SMALL_STATE(6739)] = 217453,
  [SMALL_STATE(6740)] = 217460,
  [SMALL_STATE(6741)] = 217467,
  [SMALL_STATE(6742)] = 217474,
  [SMALL_STATE(6743)] = 217481,
  [SMALL_STATE(6744)] = 217488,
  [SMALL_STATE(6745)] = 217495,
  [SMALL_STATE(6746)] = 217502,
  [SMALL_STATE(6747)] = 217509,
  [SMALL_STATE(6748)] = 217516,
  [SMALL_STATE(6749)] = 217523,
  [SMALL_STATE(6750)] = 217530,
  [SMALL_STATE(6751)] = 217537,
  [SMALL_STATE(6752)] = 217544,
  [SMALL_STATE(6753)] = 217551,
  [SMALL_STATE(6754)] = 217558,
  [SMALL_STATE(6755)] = 217565,
  [SMALL_STATE(6756)] = 217572,
  [SMALL_STATE(6757)] = 217579,
  [SMALL_STATE(6758)] = 217586,
  [SMALL_STATE(6759)] = 217593,
  [SMALL_STATE(6760)] = 217600,
  [SMALL_STATE(6761)] = 217607,
  [SMALL_STATE(6762)] = 217614,
  [SMALL_STATE(6763)] = 217621,
  [SMALL_STATE(6764)] = 217628,
  [SMALL_STATE(6765)] = 217635,
  [SMALL_STATE(6766)] = 217642,
  [SMALL_STATE(6767)] = 217649,
  [SMALL_STATE(6768)] = 217656,
  [SMALL_STATE(6769)] = 217663,
  [SMALL_STATE(6770)] = 217670,
  [SMALL_STATE(6771)] = 217677,
  [SMALL_STATE(6772)] = 217684,
  [SMALL_STATE(6773)] = 217691,
  [SMALL_STATE(6774)] = 217698,
  [SMALL_STATE(6775)] = 217705,
  [SMALL_STATE(6776)] = 217712,
  [SMALL_STATE(6777)] = 217719,
  [SMALL_STATE(6778)] = 217726,
  [SMALL_STATE(6779)] = 217733,
  [SMALL_STATE(6780)] = 217740,
  [SMALL_STATE(6781)] = 217747,
  [SMALL_STATE(6782)] = 217754,
  [SMALL_STATE(6783)] = 217761,
  [SMALL_STATE(6784)] = 217768,
  [SMALL_STATE(6785)] = 217775,
  [SMALL_STATE(6786)] = 217782,
  [SMALL_STATE(6787)] = 217789,
  [SMALL_STATE(6788)] = 217796,
  [SMALL_STATE(6789)] = 217803,
  [SMALL_STATE(6790)] = 217810,
  [SMALL_STATE(6791)] = 217817,
  [SMALL_STATE(6792)] = 217824,
  [SMALL_STATE(6793)] = 217831,
  [SMALL_STATE(6794)] = 217838,
  [SMALL_STATE(6795)] = 217845,
  [SMALL_STATE(6796)] = 217852,
  [SMALL_STATE(6797)] = 217859,
  [SMALL_STATE(6798)] = 217866,
  [SMALL_STATE(6799)] = 217873,
  [SMALL_STATE(6800)] = 217880,
  [SMALL_STATE(6801)] = 217887,
  [SMALL_STATE(6802)] = 217894,
  [SMALL_STATE(6803)] = 217901,
  [SMALL_STATE(6804)] = 217908,
  [SMALL_STATE(6805)] = 217915,
  [SMALL_STATE(6806)] = 217922,
  [SMALL_STATE(6807)] = 217929,
  [SMALL_STATE(6808)] = 217936,
  [SMALL_STATE(6809)] = 217943,
  [SMALL_STATE(6810)] = 217950,
  [SMALL_STATE(6811)] = 217957,
  [SMALL_STATE(6812)] = 217964,
  [SMALL_STATE(6813)] = 217971,
  [SMALL_STATE(6814)] = 217978,
  [SMALL_STATE(6815)] = 217985,
  [SMALL_STATE(6816)] = 217992,
  [SMALL_STATE(6817)] = 217999,
  [SMALL_STATE(6818)] = 218006,
  [SMALL_STATE(6819)] = 218013,
  [SMALL_STATE(6820)] = 218020,
  [SMALL_STATE(6821)] = 218027,
  [SMALL_STATE(6822)] = 218034,
  [SMALL_STATE(6823)] = 218041,
  [SMALL_STATE(6824)] = 218048,
  [SMALL_STATE(6825)] = 218055,
  [SMALL_STATE(6826)] = 218062,
  [SMALL_STATE(6827)] = 218069,
  [SMALL_STATE(6828)] = 218076,
  [SMALL_STATE(6829)] = 218083,
  [SMALL_STATE(6830)] = 218090,
  [SMALL_STATE(6831)] = 218097,
  [SMALL_STATE(6832)] = 218104,
  [SMALL_STATE(6833)] = 218111,
  [SMALL_STATE(6834)] = 218118,
  [SMALL_STATE(6835)] = 218125,
  [SMALL_STATE(6836)] = 218132,
  [SMALL_STATE(6837)] = 218139,
  [SMALL_STATE(6838)] = 218146,
  [SMALL_STATE(6839)] = 218153,
  [SMALL_STATE(6840)] = 218160,
  [SMALL_STATE(6841)] = 218167,
  [SMALL_STATE(6842)] = 218174,
  [SMALL_STATE(6843)] = 218181,
  [SMALL_STATE(6844)] = 218188,
  [SMALL_STATE(6845)] = 218195,
  [SMALL_STATE(6846)] = 218202,
  [SMALL_STATE(6847)] = 218209,
  [SMALL_STATE(6848)] = 218216,
  [SMALL_STATE(6849)] = 218223,
  [SMALL_STATE(6850)] = 218230,
  [SMALL_STATE(6851)] = 218237,
  [SMALL_STATE(6852)] = 218244,
  [SMALL_STATE(6853)] = 218251,
  [SMALL_STATE(6854)] = 218258,
  [SMALL_STATE(6855)] = 218265,
  [SMALL_STATE(6856)] = 218272,
  [SMALL_STATE(6857)] = 218279,
  [SMALL_STATE(6858)] = 218286,
  [SMALL_STATE(6859)] = 218293,
  [SMALL_STATE(6860)] = 218300,
  [SMALL_STATE(6861)] = 218307,
  [SMALL_STATE(6862)] = 218314,
  [SMALL_STATE(6863)] = 218321,
  [SMALL_STATE(6864)] = 218328,
  [SMALL_STATE(6865)] = 218335,
  [SMALL_STATE(6866)] = 218342,
  [SMALL_STATE(6867)] = 218349,
  [SMALL_STATE(6868)] = 218356,
  [SMALL_STATE(6869)] = 218363,
  [SMALL_STATE(6870)] = 218370,
  [SMALL_STATE(6871)] = 218377,
  [SMALL_STATE(6872)] = 218384,
  [SMALL_STATE(6873)] = 218391,
  [SMALL_STATE(6874)] = 218398,
  [SMALL_STATE(6875)] = 218405,
  [SMALL_STATE(6876)] = 218412,
  [SMALL_STATE(6877)] = 218419,
  [SMALL_STATE(6878)] = 218426,
  [SMALL_STATE(6879)] = 218433,
  [SMALL_STATE(6880)] = 218440,
  [SMALL_STATE(6881)] = 218447,
  [SMALL_STATE(6882)] = 218454,
  [SMALL_STATE(6883)] = 218461,
  [SMALL_STATE(6884)] = 218468,
  [SMALL_STATE(6885)] = 218475,
  [SMALL_STATE(6886)] = 218482,
  [SMALL_STATE(6887)] = 218489,
  [SMALL_STATE(6888)] = 218496,
  [SMALL_STATE(6889)] = 218503,
  [SMALL_STATE(6890)] = 218510,
  [SMALL_STATE(6891)] = 218517,
  [SMALL_STATE(6892)] = 218524,
  [SMALL_STATE(6893)] = 218531,
  [SMALL_STATE(6894)] = 218538,
  [SMALL_STATE(6895)] = 218545,
  [SMALL_STATE(6896)] = 218552,
  [SMALL_STATE(6897)] = 218559,
  [SMALL_STATE(6898)] = 218566,
  [SMALL_STATE(6899)] = 218573,
  [SMALL_STATE(6900)] = 218580,
  [SMALL_STATE(6901)] = 218587,
  [SMALL_STATE(6902)] = 218594,
  [SMALL_STATE(6903)] = 218601,
  [SMALL_STATE(6904)] = 218608,
  [SMALL_STATE(6905)] = 218615,
  [SMALL_STATE(6906)] = 218622,
  [SMALL_STATE(6907)] = 218629,
  [SMALL_STATE(6908)] = 218636,
  [SMALL_STATE(6909)] = 218643,
  [SMALL_STATE(6910)] = 218650,
  [SMALL_STATE(6911)] = 218657,
  [SMALL_STATE(6912)] = 218664,
  [SMALL_STATE(6913)] = 218671,
  [SMALL_STATE(6914)] = 218678,
  [SMALL_STATE(6915)] = 218685,
  [SMALL_STATE(6916)] = 218692,
  [SMALL_STATE(6917)] = 218699,
  [SMALL_STATE(6918)] = 218706,
  [SMALL_STATE(6919)] = 218713,
  [SMALL_STATE(6920)] = 218720,
  [SMALL_STATE(6921)] = 218727,
  [SMALL_STATE(6922)] = 218734,
  [SMALL_STATE(6923)] = 218741,
  [SMALL_STATE(6924)] = 218748,
  [SMALL_STATE(6925)] = 218755,
  [SMALL_STATE(6926)] = 218762,
  [SMALL_STATE(6927)] = 218769,
  [SMALL_STATE(6928)] = 218776,
  [SMALL_STATE(6929)] = 218783,
  [SMALL_STATE(6930)] = 218790,
  [SMALL_STATE(6931)] = 218797,
  [SMALL_STATE(6932)] = 218804,
  [SMALL_STATE(6933)] = 218811,
  [SMALL_STATE(6934)] = 218818,
  [SMALL_STATE(6935)] = 218825,
  [SMALL_STATE(6936)] = 218832,
  [SMALL_STATE(6937)] = 218839,
  [SMALL_STATE(6938)] = 218846,
  [SMALL_STATE(6939)] = 218853,
  [SMALL_STATE(6940)] = 218860,
  [SMALL_STATE(6941)] = 218867,
  [SMALL_STATE(6942)] = 218874,
  [SMALL_STATE(6943)] = 218881,
  [SMALL_STATE(6944)] = 218888,
  [SMALL_STATE(6945)] = 218895,
  [SMALL_STATE(6946)] = 218902,
  [SMALL_STATE(6947)] = 218909,
  [SMALL_STATE(6948)] = 218916,
  [SMALL_STATE(6949)] = 218923,
  [SMALL_STATE(6950)] = 218930,
  [SMALL_STATE(6951)] = 218937,
  [SMALL_STATE(6952)] = 218944,
  [SMALL_STATE(6953)] = 218951,
  [SMALL_STATE(6954)] = 218958,
  [SMALL_STATE(6955)] = 218965,
  [SMALL_STATE(6956)] = 218972,
  [SMALL_STATE(6957)] = 218979,
  [SMALL_STATE(6958)] = 218986,
  [SMALL_STATE(6959)] = 218993,
  [SMALL_STATE(6960)] = 219000,
  [SMALL_STATE(6961)] = 219007,
  [SMALL_STATE(6962)] = 219014,
  [SMALL_STATE(6963)] = 219021,
  [SMALL_STATE(6964)] = 219028,
  [SMALL_STATE(6965)] = 219035,
  [SMALL_STATE(6966)] = 219042,
  [SMALL_STATE(6967)] = 219049,
  [SMALL_STATE(6968)] = 219056,
  [SMALL_STATE(6969)] = 219063,
  [SMALL_STATE(6970)] = 219070,
  [SMALL_STATE(6971)] = 219077,
  [SMALL_STATE(6972)] = 219084,
  [SMALL_STATE(6973)] = 219091,
  [SMALL_STATE(6974)] = 219098,
  [SMALL_STATE(6975)] = 219105,
  [SMALL_STATE(6976)] = 219112,
  [SMALL_STATE(6977)] = 219119,
  [SMALL_STATE(6978)] = 219126,
  [SMALL_STATE(6979)] = 219133,
  [SMALL_STATE(6980)] = 219140,
  [SMALL_STATE(6981)] = 219147,
  [SMALL_STATE(6982)] = 219154,
  [SMALL_STATE(6983)] = 219161,
  [SMALL_STATE(6984)] = 219168,
  [SMALL_STATE(6985)] = 219175,
  [SMALL_STATE(6986)] = 219182,
  [SMALL_STATE(6987)] = 219189,
  [SMALL_STATE(6988)] = 219196,
  [SMALL_STATE(6989)] = 219203,
  [SMALL_STATE(6990)] = 219210,
  [SMALL_STATE(6991)] = 219217,
  [SMALL_STATE(6992)] = 219224,
  [SMALL_STATE(6993)] = 219231,
  [SMALL_STATE(6994)] = 219238,
  [SMALL_STATE(6995)] = 219245,
  [SMALL_STATE(6996)] = 219252,
  [SMALL_STATE(6997)] = 219259,
  [SMALL_STATE(6998)] = 219266,
  [SMALL_STATE(6999)] = 219273,
  [SMALL_STATE(7000)] = 219280,
  [SMALL_STATE(7001)] = 219287,
  [SMALL_STATE(7002)] = 219294,
  [SMALL_STATE(7003)] = 219301,
  [SMALL_STATE(7004)] = 219308,
  [SMALL_STATE(7005)] = 219315,
  [SMALL_STATE(7006)] = 219322,
  [SMALL_STATE(7007)] = 219329,
  [SMALL_STATE(7008)] = 219336,
  [SMALL_STATE(7009)] = 219343,
  [SMALL_STATE(7010)] = 219350,
  [SMALL_STATE(7011)] = 219357,
  [SMALL_STATE(7012)] = 219364,
  [SMALL_STATE(7013)] = 219371,
  [SMALL_STATE(7014)] = 219378,
  [SMALL_STATE(7015)] = 219385,
  [SMALL_STATE(7016)] = 219392,
  [SMALL_STATE(7017)] = 219399,
  [SMALL_STATE(7018)] = 219406,
  [SMALL_STATE(7019)] = 219413,
  [SMALL_STATE(7020)] = 219420,
  [SMALL_STATE(7021)] = 219427,
  [SMALL_STATE(7022)] = 219434,
  [SMALL_STATE(7023)] = 219441,
  [SMALL_STATE(7024)] = 219448,
  [SMALL_STATE(7025)] = 219455,
  [SMALL_STATE(7026)] = 219462,
  [SMALL_STATE(7027)] = 219469,
  [SMALL_STATE(7028)] = 219476,
  [SMALL_STATE(7029)] = 219483,
  [SMALL_STATE(7030)] = 219490,
  [SMALL_STATE(7031)] = 219497,
  [SMALL_STATE(7032)] = 219504,
  [SMALL_STATE(7033)] = 219511,
  [SMALL_STATE(7034)] = 219518,
  [SMALL_STATE(7035)] = 219525,
  [SMALL_STATE(7036)] = 219532,
  [SMALL_STATE(7037)] = 219539,
  [SMALL_STATE(7038)] = 219546,
  [SMALL_STATE(7039)] = 219553,
  [SMALL_STATE(7040)] = 219560,
  [SMALL_STATE(7041)] = 219567,
  [SMALL_STATE(7042)] = 219574,
  [SMALL_STATE(7043)] = 219581,
  [SMALL_STATE(7044)] = 219588,
  [SMALL_STATE(7045)] = 219595,
  [SMALL_STATE(7046)] = 219602,
  [SMALL_STATE(7047)] = 219609,
  [SMALL_STATE(7048)] = 219616,
  [SMALL_STATE(7049)] = 219623,
  [SMALL_STATE(7050)] = 219630,
  [SMALL_STATE(7051)] = 219637,
  [SMALL_STATE(7052)] = 219644,
  [SMALL_STATE(7053)] = 219651,
  [SMALL_STATE(7054)] = 219658,
  [SMALL_STATE(7055)] = 219665,
  [SMALL_STATE(7056)] = 219672,
  [SMALL_STATE(7057)] = 219679,
  [SMALL_STATE(7058)] = 219686,
  [SMALL_STATE(7059)] = 219693,
  [SMALL_STATE(7060)] = 219700,
  [SMALL_STATE(7061)] = 219707,
  [SMALL_STATE(7062)] = 219714,
  [SMALL_STATE(7063)] = 219721,
  [SMALL_STATE(7064)] = 219728,
  [SMALL_STATE(7065)] = 219735,
  [SMALL_STATE(7066)] = 219742,
  [SMALL_STATE(7067)] = 219749,
  [SMALL_STATE(7068)] = 219756,
  [SMALL_STATE(7069)] = 219763,
  [SMALL_STATE(7070)] = 219770,
  [SMALL_STATE(7071)] = 219777,
  [SMALL_STATE(7072)] = 219784,
  [SMALL_STATE(7073)] = 219791,
  [SMALL_STATE(7074)] = 219798,
  [SMALL_STATE(7075)] = 219805,
  [SMALL_STATE(7076)] = 219812,
  [SMALL_STATE(7077)] = 219819,
  [SMALL_STATE(7078)] = 219826,
  [SMALL_STATE(7079)] = 219833,
  [SMALL_STATE(7080)] = 219840,
  [SMALL_STATE(7081)] = 219847,
  [SMALL_STATE(7082)] = 219854,
  [SMALL_STATE(7083)] = 219861,
  [SMALL_STATE(7084)] = 219868,
  [SMALL_STATE(7085)] = 219875,
  [SMALL_STATE(7086)] = 219882,
  [SMALL_STATE(7087)] = 219889,
  [SMALL_STATE(7088)] = 219896,
  [SMALL_STATE(7089)] = 219903,
  [SMALL_STATE(7090)] = 219910,
  [SMALL_STATE(7091)] = 219917,
  [SMALL_STATE(7092)] = 219924,
  [SMALL_STATE(7093)] = 219931,
  [SMALL_STATE(7094)] = 219938,
  [SMALL_STATE(7095)] = 219945,
  [SMALL_STATE(7096)] = 219952,
  [SMALL_STATE(7097)] = 219959,
  [SMALL_STATE(7098)] = 219966,
  [SMALL_STATE(7099)] = 219973,
  [SMALL_STATE(7100)] = 219980,
  [SMALL_STATE(7101)] = 219987,
  [SMALL_STATE(7102)] = 219994,
  [SMALL_STATE(7103)] = 220001,
  [SMALL_STATE(7104)] = 220008,
  [SMALL_STATE(7105)] = 220015,
  [SMALL_STATE(7106)] = 220022,
  [SMALL_STATE(7107)] = 220029,
  [SMALL_STATE(7108)] = 220036,
  [SMALL_STATE(7109)] = 220043,
  [SMALL_STATE(7110)] = 220050,
  [SMALL_STATE(7111)] = 220057,
  [SMALL_STATE(7112)] = 220064,
  [SMALL_STATE(7113)] = 220071,
  [SMALL_STATE(7114)] = 220078,
  [SMALL_STATE(7115)] = 220085,
  [SMALL_STATE(7116)] = 220092,
  [SMALL_STATE(7117)] = 220099,
  [SMALL_STATE(7118)] = 220106,
  [SMALL_STATE(7119)] = 220113,
  [SMALL_STATE(7120)] = 220120,
  [SMALL_STATE(7121)] = 220127,
  [SMALL_STATE(7122)] = 220134,
  [SMALL_STATE(7123)] = 220141,
  [SMALL_STATE(7124)] = 220148,
};

static const TSParseActionEntry ts_parse_actions[] = {
  [0] = {.entry = {.count = 0, .reusable = false}},
  [1] = {.entry = {.count = 1, .reusable = false}}, RECOVER(),
  [3] = {.entry = {.count = 1, .reusable = true}}, SHIFT_EXTRA(),
  [5] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unison, 0, 0, 0),
  [7] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6231),
  [9] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5670),
  [11] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5348),
  [13] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6232),
  [15] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5377),
  [17] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5429),
  [19] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7103),
  [21] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1192),
  [23] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4655),
  [25] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1187),
  [27] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7009),
  [29] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 8, 0, 41),
  [31] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1732),
  [33] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5453),
  [35] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5407),
  [37] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1665),
  [39] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1663),
  [41] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5752),
  [43] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 8, 0, 41),
  [45] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1234),
  [47] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7042),
  [49] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1420),
  [51] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1418),
  [53] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6562),
  [55] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6941),
  [57] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7072),
  [59] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6585),
  [61] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5329),
  [63] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5321),
  [65] = {.entry = {.count = 1, .reusable = false}}, SHIFT(921),
  [67] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6942),
  [69] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1448),
  [71] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6569),
  [73] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1449),
  [75] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1557),
  [77] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1664),
  [79] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1557),
  [81] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1732),
  [83] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 3, 0, 10),
  [85] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 3, 0, 10),
  [87] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1616),
  [89] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 29),
  [91] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 29),
  [93] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1746),
  [95] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 5, 0, 25),
  [97] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 5, 0, 25),
  [99] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1766),
  [101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1767),
  [103] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 5, 0, 24),
  [105] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 5, 0, 24),
  [107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1773),
  [109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1774),
  [111] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 4, 0, 18),
  [113] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 4, 0, 18),
  [115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1802),
  [117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1803),
  [119] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 30),
  [121] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 30),
  [123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1730),
  [125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1724),
  [127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1718),
  [129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 2, 0, 4),
  [131] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 2, 0, 4),
  [133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1613),
  [135] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 7, 0, 35),
  [137] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 7, 0, 35),
  [139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1700),
  [141] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 4, 0, 18),
  [143] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 4, 0, 18),
  [145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1618),
  [147] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 7, 0, 36),
  [149] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 7, 0, 36),
  [151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1699),
  [153] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 5, 0, 24),
  [155] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 5, 0, 24),
  [157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1621),
  [159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1695),
  [161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1679),
  [163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1678),
  [165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1731),
  [167] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 5, 0, 25),
  [169] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 5, 0, 25),
  [171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1623),
  [173] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 6, 0, 30),
  [175] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 6, 0, 30),
  [177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1625),
  [179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1666),
  [181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1745),
  [183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1702),
  [185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1857),
  [187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5489),
  [189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5378),
  [191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1830),
  [193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1833),
  [195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5819),
  [197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1237),
  [199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1401),
  [201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1404),
  [203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6773),
  [205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6839),
  [207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7056),
  [209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6908),
  [211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5320),
  [213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5319),
  [215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(903),
  [217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6840),
  [219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6806),
  [221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1462),
  [223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1800),
  [225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1814),
  [227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1800),
  [229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1857),
  [231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1816),
  [233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1858),
  [235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1839),
  [237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1843),
  [239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1848),
  [241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1929),
  [243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1831),
  [245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1932),
  [247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1827),
  [249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1913),
  [251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1911),
  [253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1933),
  [255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1931),
  [257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1886),
  [259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1809),
  [261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1869),
  [263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1937),
  [265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1808),
  [267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1813),
  [269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1852),
  [271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1811),
  [273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1825),
  [275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1819),
  [277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1853),
  [279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1939),
  [281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2085),
  [283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2010),
  [285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2043),
  [287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2047),
  [289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2048),
  [291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2026),
  [293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2045),
  [295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2068),
  [297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2018),
  [299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2060),
  [301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2112),
  [303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2073),
  [305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2037),
  [307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2044),
  [309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2082),
  [311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2016),
  [313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2038),
  [315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2105),
  [317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2106),
  [319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2116),
  [321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2024),
  [323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2022),
  [325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2011),
  [327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2114),
  [329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2097),
  [331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2021),
  [333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2225),
  [335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2159),
  [337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2227),
  [339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2154),
  [341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2158),
  [343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2162),
  [345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2196),
  [347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2150),
  [349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2218),
  [351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2222),
  [353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2185),
  [355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2168),
  [357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2228),
  [359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2193),
  [361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2164),
  [363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2140),
  [365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2183),
  [367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2175),
  [369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2133),
  [371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2176),
  [373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2136),
  [375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2139),
  [377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2171),
  [379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2147),
  [381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2145),
  [383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2146),
  [385] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2392),
  [387] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5444),
  [389] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5420),
  [391] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2437),
  [393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2438),
  [395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5784),
  [397] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1235),
  [399] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1433),
  [401] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1430),
  [403] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6752),
  [405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6891),
  [407] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7064),
  [409] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6695),
  [411] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5298),
  [413] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5314),
  [415] = {.entry = {.count = 1, .reusable = false}}, SHIFT(911),
  [417] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6892),
  [419] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2096),
  [421] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6753),
  [423] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2079),
  [425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2384),
  [427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2395),
  [429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2384),
  [431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2392),
  [433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2529),
  [435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2413),
  [437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2412),
  [439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2411),
  [441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2410),
  [443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2488),
  [445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2501),
  [447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2461),
  [449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2396),
  [451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2465),
  [453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2426),
  [455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2417),
  [457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2418),
  [459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2490),
  [461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2454),
  [463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2460),
  [465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2487),
  [467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2446),
  [469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2497),
  [471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2498),
  [473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2527),
  [475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2445),
  [477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2518),
  [479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2468),
  [481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2425),
  [483] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2948),
  [485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5477),
  [487] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5385),
  [489] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3052),
  [491] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3055),
  [493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5745),
  [495] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1229),
  [497] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1402),
  [499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1438),
  [501] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6636),
  [503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6975),
  [505] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7078),
  [507] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6666),
  [509] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5323),
  [511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5309),
  [513] = {.entry = {.count = 1, .reusable = false}}, SHIFT(931),
  [515] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6976),
  [517] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2224),
  [519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6796),
  [521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2151),
  [523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2707),
  [525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3076),
  [527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2707),
  [529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2948),
  [531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1440),
  [533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1435),
  [535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6694),
  [537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(937),
  [539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6946),
  [541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3132),
  [543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3183),
  [545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3211),
  [547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3109),
  [549] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3092),
  [551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3205),
  [553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5456),
  [555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5422),
  [557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3140),
  [559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3141),
  [561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5764),
  [563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1228),
  [565] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1424),
  [567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1427),
  [569] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6584),
  [571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6953),
  [573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7074),
  [575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6608),
  [577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5300),
  [579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5304),
  [581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(927),
  [583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6954),
  [585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2174),
  [587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6691),
  [589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2233),
  [591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2824),
  [593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3176),
  [595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2824),
  [597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3205),
  [599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3177),
  [601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3090),
  [603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3188),
  [605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3154),
  [607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3088),
  [609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3189),
  [611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3195),
  [613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3196),
  [615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3197),
  [617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3202),
  [619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3237),
  [621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3124),
  [623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3128),
  [625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3086),
  [627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3240),
  [629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3251),
  [631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3252),
  [633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3156),
  [635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3262),
  [637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2943),
  [639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2944),
  [641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3263),
  [643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2961),
  [645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2962),
  [647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3303),
  [649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3302),
  [651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3298),
  [653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2969),
  [655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2976),
  [657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3018),
  [659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3297),
  [661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3023),
  [663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3027),
  [665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3314),
  [667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3280),
  [669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3279),
  [671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3277),
  [673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3175),
  [675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3033),
  [677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3264),
  [679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3238),
  [681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3236),
  [683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3172),
  [685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3042),
  [687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3043),
  [689] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3640),
  [691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5432),
  [693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5388),
  [695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3498),
  [697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3497),
  [699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5776),
  [701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1238),
  [703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1426),
  [705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1425),
  [707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6696),
  [709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6904),
  [711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7066),
  [713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6605),
  [715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5303),
  [717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5324),
  [719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(913),
  [721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6905),
  [723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6577),
  [725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2285),
  [727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2973),
  [729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3752),
  [731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2973),
  [733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3640),
  [735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2624),
  [737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3861),
  [739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5482),
  [741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5421),
  [743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2817),
  [745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2818),
  [747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5781),
  [749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(464),
  [751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7022),
  [753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5360),
  [755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1416),
  [757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1408),
  [759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6966),
  [761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6826),
  [763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7054),
  [765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6962),
  [767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5296),
  [769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5310),
  [771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(899),
  [773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6827),
  [775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1975),
  [777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5738),
  [779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6268),
  [781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2324),
  [783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2635),
  [785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6558),
  [787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2635),
  [789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3861),
  [791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3394),
  [793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3393),
  [795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3340),
  [797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3342),
  [799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3402),
  [801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6848),
  [803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3405),
  [805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3427),
  [807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3437),
  [809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3442),
  [811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3445),
  [813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7101),
  [815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3560),
  [817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3457),
  [819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3473),
  [821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7019),
  [823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3527),
  [825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5475),
  [827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5396),
  [829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3538),
  [831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3537),
  [833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5798),
  [835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1246),
  [837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1428),
  [839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1441),
  [841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6665),
  [843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6852),
  [845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7058),
  [847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6861),
  [849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5299),
  [851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5301),
  [853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(935),
  [855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6853),
  [857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6912),
  [859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2383),
  [861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3256),
  [863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3320),
  [865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3256),
  [867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3527),
  [869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3458),
  [871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3485),
  [873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6919),
  [875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6625),
  [877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3486),
  [879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3476),
  [881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3487),
  [883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3489),
  [885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3491),
  [887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3500),
  [889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6923),
  [891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3556),
  [893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3506),
  [895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3509),
  [897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3552),
  [899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3545),
  [901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3543),
  [903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3765),
  [905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3764),
  [907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3756),
  [909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3755),
  [911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3751),
  [913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3749),
  [915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3483),
  [917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3493),
  [919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3740),
  [921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3730),
  [923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3495),
  [925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3508),
  [927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3782),
  [929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6674),
  [931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3728),
  [933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3540),
  [935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3722),
  [937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3720),
  [939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3718),
  [941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3360),
  [943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3709),
  [945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3708),
  [947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6614),
  [949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3706),
  [951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3705),
  [953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3691),
  [955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3690),
  [957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3359),
  [959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7090),
  [961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3392),
  [963] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_app_or_boolean_op, 1, 0, 4),
  [965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6914),
  [967] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_app_or_boolean_op, 1, 0, 4),
  [969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1369),
  [971] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4641),
  [973] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6318),
  [975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6772),
  [977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3373),
  [979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6755),
  [981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3353),
  [983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3352),
  [985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3371),
  [987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3368),
  [989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3570),
  [991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6667),
  [993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3367),
  [995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6538),
  [997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3350),
  [999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3391),
  [1001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3349),
  [1003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3578),
  [1005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6609),
  [1007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6615),
  [1009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3348),
  [1011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3583),
  [1013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3587),
  [1015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3346),
  [1017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3588),
  [1019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3321),
  [1021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3590),
  [1023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3327),
  [1025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3325),
  [1027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3332),
  [1029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3330),
  [1031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4255),
  [1033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4057),
  [1035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3983),
  [1037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4363),
  [1039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4361),
  [1041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4210),
  [1043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4357),
  [1045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1405),
  [1047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1406),
  [1049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6909),
  [1051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(905),
  [1053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7047),
  [1055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4227),
  [1057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4233),
  [1059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4245),
  [1061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4246),
  [1063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3819),
  [1065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4217),
  [1067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3978),
  [1069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4216),
  [1071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4207),
  [1073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3975),
  [1075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3826),
  [1077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4206),
  [1079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4205),
  [1081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4202),
  [1083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4200),
  [1085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4199),
  [1087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4369),
  [1089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4192),
  [1091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4191),
  [1093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4375),
  [1095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3968),
  [1097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3818),
  [1099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4223),
  [1101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4160),
  [1103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3986),
  [1105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3963),
  [1107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3959),
  [1109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3871),
  [1111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4158),
  [1113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3815),
  [1115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3955),
  [1117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3984),
  [1119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4225),
  [1121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4152),
  [1123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4226),
  [1125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4052),
  [1127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4150),
  [1129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4148),
  [1131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4147),
  [1133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3936),
  [1135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3935),
  [1137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3784),
  [1139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3870),
  [1141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3894),
  [1143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3895),
  [1145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3901),
  [1147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3910),
  [1149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3946),
  [1151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3949),
  [1153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3952),
  [1155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3953),
  [1157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3956),
  [1159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3957),
  [1161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4146),
  [1163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4383),
  [1165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4083),
  [1167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4244),
  [1169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3991),
  [1171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4145),
  [1173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4004),
  [1175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4005),
  [1177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4008),
  [1179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4009),
  [1181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4015),
  [1183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4256),
  [1185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4134),
  [1187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4260),
  [1189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4016),
  [1191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4133),
  [1193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4131),
  [1195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6808),
  [1197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1384),
  [1199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1494),
  [1201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6242),
  [1203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4130),
  [1205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3976),
  [1207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3977),
  [1209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3980),
  [1211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4128),
  [1213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3981),
  [1215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4167),
  [1217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4119),
  [1219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4023),
  [1221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4118),
  [1223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3990),
  [1225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4116),
  [1227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3993),
  [1229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4112),
  [1231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4100),
  [1233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4099),
  [1235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4047),
  [1237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4006),
  [1239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4024),
  [1241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4291),
  [1243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3847),
  [1245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4281),
  [1247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4003),
  [1249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4038),
  [1251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4041),
  [1253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4040),
  [1255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4222),
  [1257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2670),
  [1259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3525),
  [1261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5465),
  [1263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5408),
  [1265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2708),
  [1267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2708),
  [1269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2714),
  [1271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3525),
  [1273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5761),
  [1275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(499),
  [1277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2823),
  [1279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7011),
  [1281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5342),
  [1283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1434),
  [1285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1439),
  [1287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6988),
  [1289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6774),
  [1291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7050),
  [1293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6990),
  [1295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5316),
  [1297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5317),
  [1299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(912),
  [1301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6775),
  [1303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1961),
  [1305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6618),
  [1307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2381),
  [1309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2732),
  [1311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4518),
  [1313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4447),
  [1315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4446),
  [1317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4444),
  [1319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4522),
  [1321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4523),
  [1323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4588),
  [1325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4590),
  [1327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4592),
  [1329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4595),
  [1331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4596),
  [1333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4598),
  [1335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4443),
  [1337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4441),
  [1339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4503),
  [1341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4502),
  [1343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4577),
  [1345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4440),
  [1347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4434),
  [1349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4474),
  [1351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4459),
  [1353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4432),
  [1355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4456),
  [1357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4431),
  [1359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4423),
  [1361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4460),
  [1363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4579),
  [1365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4580),
  [1367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4583),
  [1369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4422),
  [1371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4585),
  [1373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4453),
  [1375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4519),
  [1377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4455),
  [1379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2639),
  [1381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4468),
  [1383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4534),
  [1385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4535),
  [1387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4396),
  [1389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4550),
  [1391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4537),
  [1393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4538),
  [1395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4553),
  [1397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4559),
  [1399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4554),
  [1401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4540),
  [1403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4454),
  [1405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4541),
  [1407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4603),
  [1409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4547),
  [1411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4548),
  [1413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4549),
  [1415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4467),
  [1417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5396),
  [1419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3538),
  [1421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5798),
  [1423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1246),
  [1425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1405),
  [1427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6853),
  [1429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2383),
  [1431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5420),
  [1433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2437),
  [1435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5784),
  [1437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1235),
  [1439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1440),
  [1441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6892),
  [1443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2079),
  [1445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5422),
  [1447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3140),
  [1449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5764),
  [1451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1228),
  [1453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1424),
  [1455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6954),
  [1457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2233),
  [1459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5378),
  [1461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1830),
  [1463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5819),
  [1465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1237),
  [1467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1401),
  [1469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6840),
  [1471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1462),
  [1473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1428),
  [1475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1433),
  [1477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5388),
  [1479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3498),
  [1481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5776),
  [1483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1238),
  [1485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1426),
  [1487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6905),
  [1489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2285),
  [1491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5385),
  [1493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3052),
  [1495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5745),
  [1497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1229),
  [1499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1402),
  [1501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6976),
  [1503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2151),
  [1505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5407),
  [1507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1665),
  [1509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5752),
  [1511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1234),
  [1513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1420),
  [1515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6942),
  [1517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1449),
  [1519] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2056),
  [1521] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5508),
  [1523] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5371),
  [1525] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2004),
  [1527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2003),
  [1529] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6849),
  [1531] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1230),
  [1533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1417),
  [1535] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1412),
  [1537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6816),
  [1539] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6878),
  [1541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7062),
  [1543] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6751),
  [1545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1370),
  [1547] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5312),
  [1549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5297),
  [1551] = {.entry = {.count = 1, .reusable = false}}, SHIFT(910),
  [1553] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6879),
  [1555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1536),
  [1557] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6485),
  [1559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1524),
  [1561] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1981),
  [1563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1981),
  [1565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2056),
  [1567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1390),
  [1569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5543),
  [1571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(687),
  [1573] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2200),
  [1575] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5435),
  [1577] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5412),
  [1579] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2263),
  [1581] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2131),
  [1583] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6790),
  [1585] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1248),
  [1587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1421),
  [1589] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1422),
  [1591] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7041),
  [1593] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7040),
  [1595] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7039),
  [1597] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7038),
  [1599] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1376),
  [1601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5295),
  [1603] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5318),
  [1605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(957),
  [1607] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7035),
  [1609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1701),
  [1611] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6462),
  [1613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1580),
  [1615] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1986),
  [1617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1986),
  [1619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2200),
  [1621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(626),
  [1623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(632),
  [1625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(629),
  [1627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(788),
  [1629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(637),
  [1631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(651),
  [1633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(624),
  [1635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(645),
  [1637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(650),
  [1639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(666),
  [1641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(664),
  [1643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(675),
  [1645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(706),
  [1647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(674),
  [1649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(671),
  [1651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(679),
  [1653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(694),
  [1655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1380),
  [1657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(692),
  [1659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(698),
  [1661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(702),
  [1663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(794),
  [1665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(707),
  [1667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(710),
  [1669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(781),
  [1671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(713),
  [1673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(665),
  [1675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(715),
  [1677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(719),
  [1679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(787),
  [1681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(728),
  [1683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(731),
  [1685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(739),
  [1687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(744),
  [1689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(740),
  [1691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(732),
  [1693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(748),
  [1695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(754),
  [1697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(759),
  [1699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(765),
  [1701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(768),
  [1703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(775),
  [1705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(779),
  [1707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(872),
  [1709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(777),
  [1711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(785),
  [1713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5549),
  [1715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(884),
  [1717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(792),
  [1719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(742),
  [1721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(796),
  [1723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(824),
  [1725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(804),
  [1727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(822),
  [1729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(809),
  [1731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(836),
  [1733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(814),
  [1735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(818),
  [1737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(820),
  [1739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(840),
  [1741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(827),
  [1743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(873),
  [1745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5540),
  [1747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(832),
  [1749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(841),
  [1751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(846),
  [1753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(853),
  [1755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(892),
  [1757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(852),
  [1759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(859),
  [1761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5542),
  [1763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(864),
  [1765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5547),
  [1767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(876),
  [1769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5545),
  [1771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(882),
  [1773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(737),
  [1775] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10),
  [1777] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1732),
  [1780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5453),
  [1783] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5407),
  [1786] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1665),
  [1789] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1663),
  [1792] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6914),
  [1795] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10),
  [1797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1234),
  [1800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7042),
  [1803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1420),
  [1806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1418),
  [1809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6562),
  [1812] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6941),
  [1815] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7072),
  [1818] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6585),
  [1821] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5329),
  [1824] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5321),
  [1827] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(921),
  [1830] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6942),
  [1833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1448),
  [1836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6959),
  [1839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1449),
  [1842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1557),
  [1845] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1557),
  [1848] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1732),
  [1851] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5),
  [1853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1732),
  [1856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5453),
  [1859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5407),
  [1862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1665),
  [1865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1663),
  [1868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6914),
  [1871] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5),
  [1873] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1234),
  [1876] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7042),
  [1879] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1420),
  [1882] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1418),
  [1885] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6562),
  [1888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6941),
  [1891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7072),
  [1894] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6585),
  [1897] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5329),
  [1900] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5321),
  [1903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(921),
  [1906] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6942),
  [1909] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1448),
  [1912] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6959),
  [1915] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1449),
  [1918] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1557),
  [1921] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1557),
  [1924] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1732),
  [1927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1174),
  [1929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4402),
  [1931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5472),
  [1933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5394),
  [1935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4625),
  [1937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4625),
  [1939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4626),
  [1941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4402),
  [1943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5733),
  [1945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1243),
  [1947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1415),
  [1949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1414),
  [1951] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6607),
  [1953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6964),
  [1955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7076),
  [1957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6637),
  [1959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5327),
  [1961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5328),
  [1963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(928),
  [1965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6965),
  [1967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2375),
  [1969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6934),
  [1971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3074),
  [1973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4355),
  [1975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1178),
  [1977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6653),
  [1979] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4471),
  [1981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5499),
  [1983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5417),
  [1985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4462),
  [1987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4462),
  [1989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4463),
  [1991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4471),
  [1993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5855),
  [1995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1231),
  [1997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1419),
  [1999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1423),
  [2001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7020),
  [2003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6811),
  [2005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7052),
  [2007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7018),
  [2009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5308),
  [2011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5306),
  [2013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(898),
  [2015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6812),
  [2017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2608),
  [2019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6646),
  [2021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2750),
  [2023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4170),
  [2025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1169),
  [2027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5496),
  [2029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5419),
  [2031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3896),
  [2033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3896),
  [2035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3892),
  [2037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5750),
  [2039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1239),
  [2041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1416),
  [2043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6827),
  [2045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2377),
  [2047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6533),
  [2049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2316),
  [2051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3739),
  [2053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1155),
  [2055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6682),
  [2057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1158),
  [2059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5371),
  [2061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2004),
  [2063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5742),
  [2065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1230),
  [2067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1417),
  [2069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6879),
  [2071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6834),
  [2073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1524),
  [2075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1157),
  [2077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6720),
  [2079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6724),
  [2081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4182),
  [2083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5445),
  [2085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5386),
  [2087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4310),
  [2089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4310),
  [2091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4308),
  [2093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4182),
  [2095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5736),
  [2097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1251),
  [2099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1437),
  [2101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1436),
  [2103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6542),
  [2105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6929),
  [2107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7070),
  [2109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6563),
  [2111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5313),
  [2113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5311),
  [2115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(919),
  [2117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6930),
  [2119] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2514),
  [2121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6896),
  [2123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2605),
  [2125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3813),
  [2127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1143),
  [2129] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 6, 0, 29),
  [2131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6437),
  [2133] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4347),
  [2135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5438),
  [2137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5370),
  [2139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4359),
  [2141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4359),
  [2143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4360),
  [2145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4347),
  [2147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5737),
  [2149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1244),
  [2151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1410),
  [2153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1413),
  [2155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6612),
  [2157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6917),
  [2159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7068),
  [2161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6543),
  [2163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5315),
  [2165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5307),
  [2167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(917),
  [2169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6918),
  [2171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6882),
  [2173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2409),
  [2175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4031),
  [2177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1168),
  [2179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6436),
  [2181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5412),
  [2183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2263),
  [2185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6190),
  [2187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1248),
  [2189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1421),
  [2191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7035),
  [2193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7034),
  [2195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1580),
  [2197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1161),
  [2199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5436),
  [2201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5400),
  [2203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3541),
  [2205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3541),
  [2207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3535),
  [2209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5772),
  [2211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1241),
  [2213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7043),
  [2215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2348),
  [2217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3131),
  [2219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1163),
  [2221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1173),
  [2223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3863),
  [2225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5449),
  [2227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5387),
  [2229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3832),
  [2231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3832),
  [2233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3852),
  [2235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3863),
  [2237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5747),
  [2239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1240),
  [2241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1432),
  [2243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1429),
  [2245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6867),
  [2247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6865),
  [2249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7060),
  [2251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6815),
  [2253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5326),
  [2255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5322),
  [2257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(906),
  [2259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6866),
  [2261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2378),
  [2263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6725),
  [2265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2332),
  [2267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3369),
  [2269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1151),
  [2271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1145),
  [2273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6767),
  [2275] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 7, 0, 35),
  [2277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6427),
  [2279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6422),
  [2281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 7, 0, 36),
  [2283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6406),
  [2285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6404),
  [2287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1171),
  [2289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6758),
  [2291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 10, 0, 49),
  [2293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6271),
  [2295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1164),
  [2297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6275),
  [2299] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 9, 0, 47),
  [2301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6280),
  [2303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6311),
  [2305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1167),
  [2307] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 9, 0, 48),
  [2309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6327),
  [2311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6334),
  [2313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6341),
  [2315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1176),
  [2317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6353),
  [2319] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 8, 0, 46),
  [2321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6269),
  [2323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6359),
  [2325] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 8, 0, 41),
  [2327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6375),
  [2329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6384),
  [2331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1409),
  [2333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1403),
  [2335] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6710),
  [2337] = {.entry = {.count = 1, .reusable = false}}, SHIFT(941),
  [2339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6961),
  [2341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6391),
  [2343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6396),
  [2345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2109),
  [2347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3632),
  [2349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3357),
  [2351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3356),
  [2353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3331),
  [2355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4510),
  [2357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3335),
  [2359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1865),
  [2361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1866),
  [2363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3383),
  [2365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3661),
  [2367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1898),
  [2369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3864),
  [2371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3828),
  [2373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3663),
  [2375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3580),
  [2377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3827),
  [2379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1899),
  [2381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3808),
  [2383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2104),
  [2385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5065),
  [2387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3788),
  [2389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5096),
  [2391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5103),
  [2393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2424),
  [2395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5936),
  [2397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2422),
  [2399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2421),
  [2401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2406),
  [2403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1784),
  [2405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1817),
  [2407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2394),
  [2409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4063),
  [2411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4078),
  [2413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3581),
  [2415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1781),
  [2417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5119),
  [2419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3787),
  [2421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1720),
  [2423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1714),
  [2425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2428),
  [2427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4072),
  [2429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4071),
  [2431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3572),
  [2433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3611),
  [2435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4326),
  [2437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4372),
  [2439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5081),
  [2441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4371),
  [2443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3365),
  [2445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2236),
  [2447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2243),
  [2449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5104),
  [2451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2080),
  [2453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3822),
  [2455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3831),
  [2457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2255),
  [2459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3840),
  [2461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2254),
  [2463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3693),
  [2465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3695),
  [2467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1840),
  [2469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4322),
  [2471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3862),
  [2473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2074),
  [2475] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1857),
  [2478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5489),
  [2481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5378),
  [2484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1830),
  [2487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1833),
  [2490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6808),
  [2493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1237),
  [2496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1401),
  [2499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1404),
  [2502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6773),
  [2505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6839),
  [2508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7056),
  [2511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6908),
  [2514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5320),
  [2517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5319),
  [2520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(903),
  [2523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6840),
  [2526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1494),
  [2529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6822),
  [2532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1462),
  [2535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1800),
  [2538] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1800),
  [2541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1857),
  [2544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4318),
  [2546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3879),
  [2548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4314),
  [2550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4312),
  [2552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4311),
  [2554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3884),
  [2556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5511),
  [2558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4303),
  [2560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5597),
  [2562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4295),
  [2564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5596),
  [2566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4362),
  [2568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5896),
  [2570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4379),
  [2572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4610),
  [2574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4614),
  [2576] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1857),
  [2579] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5489),
  [2582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5378),
  [2585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1830),
  [2588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1833),
  [2591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6808),
  [2594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1237),
  [2597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1401),
  [2600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1404),
  [2603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6773),
  [2606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6839),
  [2609] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7056),
  [2612] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6908),
  [2615] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5320),
  [2618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5319),
  [2621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(903),
  [2624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6840),
  [2627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1494),
  [2630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6822),
  [2633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1462),
  [2636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1800),
  [2639] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1800),
  [2642] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1857),
  [2645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4617),
  [2647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5593),
  [2649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1703),
  [2651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4620),
  [2653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4622),
  [2655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4624),
  [2657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3037),
  [2659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3035),
  [2661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4073),
  [2663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5591),
  [2665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4613),
  [2667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1871),
  [2669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4612),
  [2671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3022),
  [2673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2065),
  [2675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5587),
  [2677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1690),
  [2679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4599),
  [2681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4632),
  [2683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1890),
  [2685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1891),
  [2687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3438),
  [2689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4389),
  [2691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1688),
  [2693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3239),
  [2695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3235),
  [2697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1658),
  [2699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4126),
  [2701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3586),
  [2703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4125),
  [2705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4076),
  [2707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4511),
  [2709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3440),
  [2711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4364),
  [2713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1651),
  [2715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4108),
  [2717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4394),
  [2719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4082),
  [2721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3020),
  [2723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3013),
  [2725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1902),
  [2727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4509),
  [2729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3007),
  [2731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4513),
  [2733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4514),
  [2735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4530),
  [2737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3564),
  [2739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4532),
  [2741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2050),
  [2743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3697),
  [2745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3698),
  [2747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4545),
  [2749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3725),
  [2751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3726),
  [2753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5895),
  [2755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1670),
  [2757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4494),
  [2759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3000),
  [2761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2214),
  [2763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4065),
  [2765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3281),
  [2767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4488),
  [2769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2030),
  [2771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3143),
  [2773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3225),
  [2775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3153),
  [2777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3456),
  [2779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2041),
  [2781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3465),
  [2783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4066),
  [2785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3617),
  [2787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3123),
  [2789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2561),
  [2791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2560),
  [2793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4313),
  [2795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2897),
  [2797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2534),
  [2799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2533),
  [2801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2155),
  [2803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6015),
  [2805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6086),
  [2807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2237),
  [2809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2211),
  [2811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2059),
  [2813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2210),
  [2815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2194),
  [2817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2066),
  [2819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5869),
  [2821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3623),
  [2823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2991),
  [2825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2990),
  [2827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6540),
  [2829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6526),
  [2831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2978),
  [2833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3634),
  [2835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3626),
  [2837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3198),
  [2839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3631),
  [2841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7091),
  [2843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7092),
  [2845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3199),
  [2847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2056),
  [2850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5508),
  [2853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5371),
  [2856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2004),
  [2859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2003),
  [2862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6849),
  [2865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1230),
  [2868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1417),
  [2871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1412),
  [2874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6816),
  [2877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6878),
  [2880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7062),
  [2883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6751),
  [2886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5312),
  [2889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5297),
  [2892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(910),
  [2895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6879),
  [2898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1536),
  [2901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6675),
  [2904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1524),
  [2907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1981),
  [2910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1981),
  [2913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2056),
  [2916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2056),
  [2919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5508),
  [2922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5371),
  [2925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2004),
  [2928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2003),
  [2931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6849),
  [2934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1230),
  [2937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1417),
  [2940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1412),
  [2943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6816),
  [2946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6878),
  [2949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7062),
  [2952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6751),
  [2955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5312),
  [2958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5297),
  [2961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(910),
  [2964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6879),
  [2967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1536),
  [2970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6675),
  [2973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1524),
  [2976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1981),
  [2979] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1981),
  [2982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2056),
  [2985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6862),
  [2987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1396),
  [2989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6490),
  [2991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2200),
  [2994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5435),
  [2997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5412),
  [3000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2263),
  [3003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2131),
  [3006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6790),
  [3009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1248),
  [3012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1421),
  [3015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1422),
  [3018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7041),
  [3021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7040),
  [3024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7039),
  [3027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7038),
  [3030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5295),
  [3033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5318),
  [3036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(957),
  [3039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7035),
  [3042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1701),
  [3045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6735),
  [3048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1580),
  [3051] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1986),
  [3054] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1986),
  [3057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2200),
  [3060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5696),
  [3062] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6927),
  [3064] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1373),
  [3066] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6421),
  [3068] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6790),
  [3071] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1701),
  [3074] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6735),
  [3077] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2200),
  [3080] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2200),
  [3083] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5435),
  [3086] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5412),
  [3089] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2263),
  [3092] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2131),
  [3095] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1248),
  [3098] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1421),
  [3101] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1422),
  [3104] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7041),
  [3107] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7040),
  [3110] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7039),
  [3113] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7038),
  [3116] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5295),
  [3119] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5318),
  [3122] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(957),
  [3125] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7035),
  [3128] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1580),
  [3131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1986),
  [3134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1986),
  [3137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1399),
  [3139] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6951),
  [3141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1400),
  [3143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6504),
  [3145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6875),
  [3147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1371),
  [3149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2311),
  [3151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6502),
  [3153] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1383),
  [3155] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1393),
  [3157] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6823),
  [3159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1392),
  [3161] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2544),
  [3163] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6510),
  [3165] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5419),
  [3167] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5800),
  [3169] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1239),
  [3171] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6492),
  [3173] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2316),
  [3175] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3739),
  [3177] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1382),
  [3179] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5387),
  [3181] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6836),
  [3183] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1240),
  [3185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1432),
  [3187] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1366),
  [3189] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6866),
  [3191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6343),
  [3193] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2332),
  [3195] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3369),
  [3197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6949),
  [3199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1375),
  [3201] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6380),
  [3203] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1394),
  [3205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5400),
  [3207] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7000),
  [3209] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1241),
  [3211] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1434),
  [3213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1397),
  [3215] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6775),
  [3217] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6263),
  [3219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2348),
  [3221] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3131),
  [3223] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1398),
  [3225] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1368),
  [3227] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1379),
  [3229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1389),
  [3231] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5370),
  [3233] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6888),
  [3235] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1244),
  [3237] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1410),
  [3239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1381),
  [3241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6918),
  [3243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6503),
  [3245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2409),
  [3247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4031),
  [3249] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1387),
  [3251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1409),
  [3253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1391),
  [3255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5386),
  [3257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6901),
  [3259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1251),
  [3261] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1437),
  [3263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1385),
  [3265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6930),
  [3267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6233),
  [3269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2605),
  [3271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3813),
  [3273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1377),
  [3275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5820),
  [3277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3212),
  [3279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7037),
  [3281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2936),
  [3283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2063),
  [3285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4477),
  [3287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5417),
  [3289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6994),
  [3291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1231),
  [3293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1419),
  [3295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1386),
  [3297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6812),
  [3299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3152),
  [3301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6481),
  [3303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2750),
  [3305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4170),
  [3307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5394),
  [3309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6939),
  [3311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1243),
  [3313] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1415),
  [3315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1378),
  [3317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6965),
  [3319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3362),
  [3321] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6468),
  [3323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3074),
  [3325] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4355),
  [3327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1736),
  [3329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2609),
  [3331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2392),
  [3334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5444),
  [3337] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5420),
  [3340] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2437),
  [3343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2438),
  [3346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6862),
  [3349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1235),
  [3352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1433),
  [3355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1430),
  [3358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6752),
  [3361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6891),
  [3364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7064),
  [3367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6695),
  [3370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5298),
  [3373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5314),
  [3376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(911),
  [3379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6892),
  [3382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2096),
  [3385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6799),
  [3388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2079),
  [3391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2384),
  [3394] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2384),
  [3397] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2392),
  [3400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1864),
  [3402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3644),
  [3404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3849),
  [3406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3869),
  [3408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3519),
  [3410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1374),
  [3412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4404),
  [3414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4368),
  [3416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1367),
  [3418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3518),
  [3420] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2392),
  [3423] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5444),
  [3426] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5420),
  [3429] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2437),
  [3432] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2438),
  [3435] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6862),
  [3438] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1235),
  [3441] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1433),
  [3444] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1430),
  [3447] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6752),
  [3450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6891),
  [3453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7064),
  [3456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6695),
  [3459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5298),
  [3462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5314),
  [3465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(911),
  [3468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6892),
  [3471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2096),
  [3474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6799),
  [3477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2079),
  [3480] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2384),
  [3483] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2384),
  [3486] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2392),
  [3489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2163),
  [3491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5775),
  [3493] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6570),
  [3495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4177),
  [3497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5786),
  [3499] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6688),
  [3501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5762),
  [3503] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6943),
  [3505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2948),
  [3508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5477),
  [3511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5385),
  [3514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3052),
  [3517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3055),
  [3520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6951),
  [3523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1229),
  [3526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1402),
  [3529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1438),
  [3532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6636),
  [3535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6975),
  [3538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7078),
  [3541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6666),
  [3544] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5323),
  [3547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5309),
  [3550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(931),
  [3553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6976),
  [3556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2224),
  [3559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6610),
  [3562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2151),
  [3565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2707),
  [3568] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2707),
  [3571] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2948),
  [3574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5759),
  [3576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6778),
  [3578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1440),
  [3581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1435),
  [3584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6694),
  [3587] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(937),
  [3590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5782),
  [3592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6802),
  [3594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1440),
  [3597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1435),
  [3600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6694),
  [3603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(937),
  [3606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5751),
  [3608] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6933),
  [3610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5777),
  [3612] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6910),
  [3614] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6945),
  [3616] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6797),
  [3618] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2948),
  [3621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5477),
  [3624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5385),
  [3627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3052),
  [3630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3055),
  [3633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6951),
  [3636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1229),
  [3639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1402),
  [3642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1438),
  [3645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6636),
  [3648] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6975),
  [3651] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7078),
  [3654] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6666),
  [3657] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5323),
  [3660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5309),
  [3663] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(931),
  [3666] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6976),
  [3669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2224),
  [3672] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6610),
  [3675] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2151),
  [3678] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2707),
  [3681] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2707),
  [3684] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2948),
  [3687] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3205),
  [3690] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5456),
  [3693] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5422),
  [3696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3140),
  [3699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3141),
  [3702] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6927),
  [3705] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1228),
  [3708] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1424),
  [3711] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1427),
  [3714] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6584),
  [3717] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6953),
  [3720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7074),
  [3723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6608),
  [3726] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5300),
  [3729] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5304),
  [3732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(927),
  [3735] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6954),
  [3738] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2174),
  [3741] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6795),
  [3744] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2233),
  [3747] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2824),
  [3750] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2824),
  [3753] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3205),
  [3756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5800),
  [3758] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6594),
  [3760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3205),
  [3763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5456),
  [3766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5422),
  [3769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3140),
  [3772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3141),
  [3775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6927),
  [3778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1228),
  [3781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1424),
  [3784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1427),
  [3787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6584),
  [3790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6953),
  [3793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7074),
  [3796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6608),
  [3799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5300),
  [3802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5304),
  [3805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(927),
  [3808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6954),
  [3811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2174),
  [3814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6795),
  [3817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2233),
  [3820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2824),
  [3823] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2824),
  [3826] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3205),
  [3829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5768),
  [3831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6977),
  [3833] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3527),
  [3836] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5475),
  [3839] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5396),
  [3842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3538),
  [3845] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3537),
  [3848] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6823),
  [3851] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1246),
  [3854] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1428),
  [3857] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1441),
  [3860] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6665),
  [3863] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6852),
  [3866] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7058),
  [3869] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6861),
  [3872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5299),
  [3875] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5301),
  [3878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(935),
  [3881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6853),
  [3884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2544),
  [3887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6820),
  [3890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2383),
  [3893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3256),
  [3896] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3256),
  [3899] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3527),
  [3902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3527),
  [3905] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5475),
  [3908] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5396),
  [3911] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3538),
  [3914] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3537),
  [3917] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6823),
  [3920] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1246),
  [3923] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1428),
  [3926] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1441),
  [3929] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6665),
  [3932] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6852),
  [3935] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7058),
  [3938] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6861),
  [3941] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5299),
  [3944] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5301),
  [3947] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(935),
  [3950] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6853),
  [3953] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2544),
  [3956] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6820),
  [3959] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2383),
  [3962] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3256),
  [3965] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3256),
  [3968] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3527),
  [3971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3640),
  [3974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5432),
  [3977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5388),
  [3980] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3498),
  [3983] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3497),
  [3986] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6875),
  [3989] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1238),
  [3992] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1426),
  [3995] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1425),
  [3998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6696),
  [4001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6904),
  [4004] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7066),
  [4007] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6605),
  [4010] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5303),
  [4013] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5324),
  [4016] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(913),
  [4019] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6905),
  [4022] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2311),
  [4025] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6544),
  [4028] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2285),
  [4031] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2973),
  [4034] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2973),
  [4037] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3640),
  [4040] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3640),
  [4043] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5432),
  [4046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5388),
  [4049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3498),
  [4052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3497),
  [4055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6875),
  [4058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1238),
  [4061] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1426),
  [4064] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1425),
  [4067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6696),
  [4070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6904),
  [4073] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7066),
  [4076] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6605),
  [4079] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5303),
  [4082] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5324),
  [4085] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(913),
  [4088] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6905),
  [4091] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2311),
  [4094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6544),
  [4097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2285),
  [4100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2973),
  [4103] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2973),
  [4106] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3640),
  [4109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6659),
  [4112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1405),
  [4115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1406),
  [4118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6909),
  [4121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(905),
  [4124] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7084),
  [4127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1405),
  [4130] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1406),
  [4133] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6909),
  [4136] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(905),
  [4139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3525),
  [4142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5436),
  [4145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5400),
  [4148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3541),
  [4151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3535),
  [4154] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7000),
  [4157] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1241),
  [4160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1434),
  [4163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1439),
  [4166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6988),
  [4169] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6774),
  [4172] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7050),
  [4175] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6990),
  [4178] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5316),
  [4181] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5317),
  [4184] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(912),
  [4187] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6775),
  [4190] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2375),
  [4193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7029),
  [4196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2348),
  [4199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3131),
  [4202] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3131),
  [4205] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3525),
  [4208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3525),
  [4211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5436),
  [4214] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5400),
  [4217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3541),
  [4220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3535),
  [4223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7000),
  [4226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1241),
  [4229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1434),
  [4232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1439),
  [4235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6988),
  [4238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6774),
  [4241] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7050),
  [4244] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6990),
  [4247] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5316),
  [4250] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5317),
  [4253] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(912),
  [4256] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6775),
  [4259] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2375),
  [4262] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7029),
  [4265] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2348),
  [4268] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3131),
  [4271] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3131),
  [4274] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3525),
  [4277] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3861),
  [4280] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5496),
  [4283] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5419),
  [4286] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3896),
  [4289] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3892),
  [4292] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6949),
  [4295] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1239),
  [4298] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1416),
  [4301] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1408),
  [4304] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6966),
  [4307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6826),
  [4310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7054),
  [4313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6962),
  [4316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5296),
  [4319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5310),
  [4322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(899),
  [4325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6827),
  [4328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2377),
  [4331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2316),
  [4334] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3739),
  [4337] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3739),
  [4340] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3861),
  [4343] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3863),
  [4346] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5449),
  [4349] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5387),
  [4352] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3832),
  [4355] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3852),
  [4358] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6836),
  [4361] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1240),
  [4364] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1432),
  [4367] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1429),
  [4370] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6867),
  [4373] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6865),
  [4376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7060),
  [4379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6815),
  [4382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5326),
  [4385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5322),
  [4388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(906),
  [4391] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6866),
  [4394] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2378),
  [4397] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2332),
  [4400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3369),
  [4403] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3369),
  [4406] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3863),
  [4409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3863),
  [4412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5449),
  [4415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5387),
  [4418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3832),
  [4421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3852),
  [4424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6836),
  [4427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1240),
  [4430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1432),
  [4433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1429),
  [4436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6867),
  [4439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6865),
  [4442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7060),
  [4445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6815),
  [4448] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5326),
  [4451] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5322),
  [4454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(906),
  [4457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6866),
  [4460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2378),
  [4463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6659),
  [4466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2332),
  [4469] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3369),
  [4472] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3369),
  [4475] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3863),
  [4478] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3861),
  [4481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5496),
  [4484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5419),
  [4487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3896),
  [4490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3892),
  [4493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6949),
  [4496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1239),
  [4499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1416),
  [4502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1408),
  [4505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6966),
  [4508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6826),
  [4511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7054),
  [4514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6962),
  [4517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5296),
  [4520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5310),
  [4523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(899),
  [4526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6827),
  [4529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2377),
  [4532] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7084),
  [4535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2316),
  [4538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3739),
  [4541] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3739),
  [4544] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3861),
  [4547] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4182),
  [4550] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5445),
  [4553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5386),
  [4556] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4310),
  [4559] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4308),
  [4562] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6901),
  [4565] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1251),
  [4568] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1437),
  [4571] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1436),
  [4574] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6542),
  [4577] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6929),
  [4580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7070),
  [4583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6563),
  [4586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5313),
  [4589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5311),
  [4592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(919),
  [4595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6930),
  [4598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2514),
  [4601] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7108),
  [4604] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2605),
  [4607] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3813),
  [4610] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3813),
  [4613] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4182),
  [4616] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4182),
  [4619] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5445),
  [4622] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5386),
  [4625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4310),
  [4628] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4308),
  [4631] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6901),
  [4634] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1251),
  [4637] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1437),
  [4640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1436),
  [4643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6542),
  [4646] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6929),
  [4649] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7070),
  [4652] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6563),
  [4655] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5313),
  [4658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5311),
  [4661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(919),
  [4664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6930),
  [4667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2514),
  [4670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7108),
  [4673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2605),
  [4676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3813),
  [4679] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3813),
  [4682] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4182),
  [4685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6709),
  [4688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1409),
  [4691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1403),
  [4694] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6710),
  [4697] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(941),
  [4700] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4347),
  [4703] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5438),
  [4706] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5370),
  [4709] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4359),
  [4712] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4360),
  [4715] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6888),
  [4718] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1244),
  [4721] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1410),
  [4724] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1413),
  [4727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6612),
  [4730] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6917),
  [4733] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7068),
  [4736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6543),
  [4739] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5315),
  [4742] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5307),
  [4745] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(917),
  [4748] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6918),
  [4751] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2608),
  [4754] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6709),
  [4757] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2409),
  [4760] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4031),
  [4763] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4031),
  [4766] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4347),
  [4769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4347),
  [4772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5438),
  [4775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5370),
  [4778] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4359),
  [4781] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4360),
  [4784] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6888),
  [4787] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1244),
  [4790] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1410),
  [4793] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1413),
  [4796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6612),
  [4799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6917),
  [4802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7068),
  [4805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6543),
  [4808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5315),
  [4811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5307),
  [4814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(917),
  [4817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6918),
  [4820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2608),
  [4823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2409),
  [4826] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4031),
  [4829] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4031),
  [4832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4347),
  [4835] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1409),
  [4838] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1403),
  [4841] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6710),
  [4844] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(941),
  [4847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4402),
  [4850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5472),
  [4853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5394),
  [4856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4625),
  [4859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4626),
  [4862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6939),
  [4865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1243),
  [4868] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1415),
  [4871] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1414),
  [4874] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6607),
  [4877] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6964),
  [4880] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7076),
  [4883] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6637),
  [4886] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5327),
  [4889] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5328),
  [4892] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(928),
  [4895] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6965),
  [4898] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3362),
  [4901] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6683),
  [4904] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3074),
  [4907] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4355),
  [4910] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4355),
  [4913] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4402),
  [4916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6844),
  [4919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4402),
  [4922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5472),
  [4925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5394),
  [4928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4625),
  [4931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4626),
  [4934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6939),
  [4937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1243),
  [4940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1415),
  [4943] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1414),
  [4946] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6607),
  [4949] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6964),
  [4952] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7076),
  [4955] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6637),
  [4958] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5327),
  [4961] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5328),
  [4964] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(928),
  [4967] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6965),
  [4970] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3362),
  [4973] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6683),
  [4976] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3074),
  [4979] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4355),
  [4982] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4355),
  [4985] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4402),
  [4988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4471),
  [4991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5499),
  [4994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5417),
  [4997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4462),
  [5000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4463),
  [5003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6994),
  [5006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1231),
  [5009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1419),
  [5012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(1423),
  [5015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7020),
  [5018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6811),
  [5021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7052),
  [5024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(7018),
  [5027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5308),
  [5030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(5306),
  [5033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(898),
  [5036] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(6812),
  [5039] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(3152),
  [5042] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(2750),
  [5045] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4170),
  [5048] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4170),
  [5051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 5), SHIFT(4471),
  [5054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4471),
  [5057] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5499),
  [5060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5417),
  [5063] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4462),
  [5066] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4463),
  [5069] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6994),
  [5072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1231),
  [5075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1419),
  [5078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(1423),
  [5081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7020),
  [5084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6811),
  [5087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7052),
  [5090] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(7018),
  [5093] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5308),
  [5096] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(5306),
  [5099] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(898),
  [5102] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6812),
  [5105] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(3152),
  [5108] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(6844),
  [5111] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(2750),
  [5114] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4170),
  [5117] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4170),
  [5120] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__term4, 2, 0, 10), SHIFT_REPEAT(4471),
  [5123] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 2, 0, 0),
  [5125] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0),
  [5127] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1503),
  [5129] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4818),
  [5132] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4750),
  [5135] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4744),
  [5137] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1448),
  [5140] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1463),
  [5143] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6294),
  [5146] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1449),
  [5149] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1361),
  [5152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6939),
  [5154] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6654),
  [5156] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6683),
  [5158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0),
  [5160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0),
  [5162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1503),
  [5165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4818),
  [5168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4750),
  [5171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4744),
  [5174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1448),
  [5177] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1463),
  [5180] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6294),
  [5183] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1449),
  [5186] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1361),
  [5189] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type2, 1, 0, 0),
  [5191] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0),
  [5193] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4818),
  [5196] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4750),
  [5199] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1448),
  [5202] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1463),
  [5205] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6294),
  [5208] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1449),
  [5211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1359),
  [5214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1511),
  [5216] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4819),
  [5219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4755),
  [5222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4729),
  [5224] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1494),
  [5227] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1487),
  [5230] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6326),
  [5233] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1462),
  [5236] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1365),
  [5239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4819),
  [5242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4755),
  [5245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1494),
  [5248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1487),
  [5251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6326),
  [5254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1462),
  [5257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1363),
  [5260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1511),
  [5263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4819),
  [5266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4755),
  [5269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4729),
  [5272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1494),
  [5275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1487),
  [5278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6326),
  [5281] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1462),
  [5284] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1365),
  [5287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6836),
  [5289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6659),
  [5291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7000),
  [5293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7029),
  [5295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6914),
  [5297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6959),
  [5299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6849),
  [5301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6675),
  [5303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6875),
  [5305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6544),
  [5307] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1759),
  [5310] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4800),
  [5313] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4751),
  [5316] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4733),
  [5319] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1536),
  [5322] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1552),
  [5325] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6285),
  [5328] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1524),
  [5331] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1372),
  [5334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6927),
  [5336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6795),
  [5338] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6994),
  [5340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6844),
  [5342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6949),
  [5344] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7084),
  [5346] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6790),
  [5348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6735),
  [5350] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6901),
  [5352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7108),
  [5354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6823),
  [5356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6820),
  [5358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6888),
  [5360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6709),
  [5362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6808),
  [5364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6822),
  [5366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1759),
  [5368] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4800),
  [5371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4751),
  [5374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4733),
  [5376] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1536),
  [5379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1552),
  [5382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6285),
  [5385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1524),
  [5388] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1395),
  [5391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6862),
  [5393] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6799),
  [5395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4800),
  [5398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4751),
  [5401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1536),
  [5404] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1552),
  [5407] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6285),
  [5410] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1524),
  [5413] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1372),
  [5416] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6951),
  [5418] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6610),
  [5420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1874),
  [5422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1874),
  [5424] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2929),
  [5426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2929),
  [5428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3510),
  [5430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3510),
  [5432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1875),
  [5434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1875),
  [5436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3517),
  [5438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3517),
  [5440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3516),
  [5442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3516),
  [5444] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1868),
  [5446] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4853),
  [5449] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4763),
  [5452] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4728),
  [5454] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1701),
  [5457] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1689),
  [5460] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6306),
  [5463] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1580),
  [5466] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1431),
  [5469] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3837),
  [5471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3837),
  [5473] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3511),
  [5475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3511),
  [5477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4382),
  [5479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4382),
  [5481] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1868),
  [5484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4853),
  [5487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4763),
  [5490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4728),
  [5493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1701),
  [5496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1689),
  [5499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6306),
  [5502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1580),
  [5505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1411),
  [5508] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2069),
  [5510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2069),
  [5512] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4387),
  [5514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4387),
  [5516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4406),
  [5518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4406),
  [5520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4405),
  [5522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4405),
  [5524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3843),
  [5526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3843),
  [5528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2067),
  [5530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2067),
  [5532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1742),
  [5534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1742),
  [5536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4479),
  [5538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4479),
  [5540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1741),
  [5542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1741),
  [5544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2188),
  [5546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2188),
  [5548] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2198),
  [5550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2198),
  [5552] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4480),
  [5554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4480),
  [5556] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3216),
  [5558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3216),
  [5560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3653),
  [5562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3653),
  [5564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3651),
  [5566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3651),
  [5568] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3218),
  [5570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3218),
  [5572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3874),
  [5574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3874),
  [5576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2611),
  [5578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2611),
  [5580] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4853),
  [5583] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4763),
  [5586] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1701),
  [5589] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1689),
  [5592] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6306),
  [5595] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1580),
  [5598] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1411),
  [5601] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3872),
  [5603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3872),
  [5605] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2612),
  [5607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2612),
  [5609] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4171),
  [5611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4171),
  [5613] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4139),
  [5615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4139),
  [5617] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2926),
  [5619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2926),
  [5621] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2278),
  [5624] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4828),
  [5627] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4756),
  [5630] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4727),
  [5633] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2096),
  [5636] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2262),
  [5639] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6317),
  [5642] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2079),
  [5645] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1442),
  [5648] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2278),
  [5650] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4828),
  [5653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4756),
  [5656] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4727),
  [5658] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2096),
  [5661] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2262),
  [5664] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6317),
  [5667] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2079),
  [5670] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1442),
  [5673] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4828),
  [5676] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4756),
  [5679] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2096),
  [5682] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2262),
  [5685] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6317),
  [5688] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2079),
  [5691] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1443),
  [5694] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2338),
  [5696] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4844),
  [5699] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4752),
  [5702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4735),
  [5704] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2224),
  [5707] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2268),
  [5710] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6287),
  [5713] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2151),
  [5716] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1456),
  [5719] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_wordy_id, 2, 0, 0),
  [5721] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wordy_definition_name, 2, 0, 0),
  [5723] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_wordy_id, 2, 0, 0),
  [5725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1473),
  [5727] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__hq_qualified_wordy_id, 2, 0, 0), REDUCE(sym__wordy_definition_name, 2, 0, 0),
  [5730] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_wordy_id, 1, 0, 0),
  [5732] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__wordy_definition_name, 1, 0, 0),
  [5734] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_wordy_id, 1, 0, 0),
  [5736] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__hq_qualified_wordy_id, 1, 0, 0), REDUCE(sym__wordy_definition_name, 1, 0, 0),
  [5739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_wordy_id, 1, 0, 0),
  [5741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_wordy_id, 1, 0, 0),
  [5743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_qualifier, 1, 0, 0),
  [5745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_qualifier, 1, 0, 0),
  [5747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1467),
  [5749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1499),
  [5751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1458),
  [5753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2362),
  [5755] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4825),
  [5758] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4775),
  [5761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4746),
  [5763] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2174),
  [5766] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2284),
  [5769] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6299),
  [5772] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2233),
  [5775] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1453),
  [5778] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10),
  [5780] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10),
  [5782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1369),
  [5785] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(4641),
  [5788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(6564),
  [5791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4825),
  [5794] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4775),
  [5797] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2174),
  [5800] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2284),
  [5803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6299),
  [5806] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2233),
  [5809] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1460),
  [5812] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_app_or_boolean_op, 2, 0, 10),
  [5814] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix_app_or_boolean_op, 2, 0, 10),
  [5816] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6564),
  [5818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_qualified, 1, 0, 0),
  [5820] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_qualified, 1, 0, 0),
  [5822] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4844),
  [5825] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4752),
  [5828] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2224),
  [5831] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2268),
  [5834] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6287),
  [5837] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2151),
  [5840] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1457),
  [5843] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2338),
  [5846] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4844),
  [5849] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4752),
  [5852] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4735),
  [5855] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2224),
  [5858] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2268),
  [5861] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6287),
  [5864] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2151),
  [5867] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1457),
  [5870] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imm_hash_qualifier, 1, 0, 11),
  [5872] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_imm_hash_qualifier, 1, 0, 11),
  [5874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1469),
  [5876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1495),
  [5878] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2362),
  [5881] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4825),
  [5884] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4775),
  [5887] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4746),
  [5890] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2174),
  [5893] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2284),
  [5896] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6299),
  [5899] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2233),
  [5902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1460),
  [5905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1502),
  [5907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1515),
  [5909] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 1, 0, 0),
  [5911] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 1, 0, 0),
  [5913] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1384),
  [5916] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2476),
  [5919] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4843),
  [5922] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4762),
  [5925] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4726),
  [5928] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2311),
  [5931] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2386),
  [5934] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6315),
  [5937] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2285),
  [5940] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1465),
  [5943] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_qualifier, 2, 0, 0),
  [5945] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_qualifier, 2, 0, 0),
  [5947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1500),
  [5949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imm_hash_qualifier, 2, 0, 11),
  [5951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_imm_hash_qualifier, 2, 0, 11),
  [5953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1489),
  [5955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2476),
  [5957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4843),
  [5960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4762),
  [5963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4726),
  [5965] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2311),
  [5968] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2386),
  [5971] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6315),
  [5974] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2285),
  [5977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1474),
  [5980] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__identifier, 2, 0, 0),
  [5982] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__identifier, 2, 0, 0),
  [5984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1484),
  [5986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1529),
  [5988] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4843),
  [5991] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4762),
  [5994] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2311),
  [5997] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2386),
  [6000] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6315),
  [6003] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2285),
  [6006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1465),
  [6009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2735),
  [6012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4811),
  [6015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4765),
  [6018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4739),
  [6021] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2378),
  [6024] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2451),
  [6027] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6289),
  [6030] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2332),
  [6033] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1475),
  [6036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2856),
  [6038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4851),
  [6041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4768),
  [6044] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4732),
  [6046] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2375),
  [6049] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2504),
  [6052] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6304),
  [6055] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2348),
  [6058] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1506),
  [6061] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_type, 5, 0, 0),
  [6063] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_type, 5, 0, 0),
  [6065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2735),
  [6067] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4811),
  [6070] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4765),
  [6073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4739),
  [6075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2378),
  [6078] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2451),
  [6081] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6289),
  [6084] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2332),
  [6087] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1475),
  [6090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__effect_list, 3, 0, 0),
  [6092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__effect_list, 3, 0, 0),
  [6094] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2633),
  [6097] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4815),
  [6100] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4749),
  [6103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4740),
  [6106] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2377),
  [6109] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2457),
  [6112] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6293),
  [6115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2316),
  [6118] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1480),
  [6121] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3816),
  [6123] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term_leaf, 1, 0, 0),
  [6125] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4771),
  [6127] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term_leaf, 1, 0, 0),
  [6129] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2782),
  [6131] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4779),
  [6134] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4772),
  [6137] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4734),
  [6139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2544),
  [6142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2494),
  [6145] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6301),
  [6148] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2383),
  [6151] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1498),
  [6154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1520),
  [6156] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4851),
  [6159] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4768),
  [6162] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2375),
  [6165] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2504),
  [6168] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6304),
  [6171] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2348),
  [6174] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1476),
  [6177] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_imm_hash_qualifier, 3, 0, 11),
  [6179] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_imm_hash_qualifier, 3, 0, 11),
  [6181] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_sequence_type, 3, 0, 0),
  [6183] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_sequence_type, 3, 0, 0),
  [6185] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__effect_list, 2, 0, 0),
  [6187] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__effect_list, 2, 0, 0),
  [6189] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4811),
  [6192] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4765),
  [6195] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2378),
  [6198] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2451),
  [6201] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6289),
  [6204] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2332),
  [6207] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1478),
  [6210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2633),
  [6212] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4815),
  [6215] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4749),
  [6218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4740),
  [6220] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2377),
  [6223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2457),
  [6226] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6293),
  [6229] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2316),
  [6232] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1480),
  [6235] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hash_qualified, 2, 0, 0),
  [6237] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hash_qualified, 2, 0, 0),
  [6239] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4815),
  [6242] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4749),
  [6245] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2377),
  [6248] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2457),
  [6251] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6293),
  [6254] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2316),
  [6257] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1493),
  [6260] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4779),
  [6263] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4772),
  [6266] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2544),
  [6269] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2494),
  [6272] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6301),
  [6275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2383),
  [6278] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1507),
  [6281] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_hash_qualifier, 3, 0, 0),
  [6283] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_hash_qualifier, 3, 0, 0),
  [6285] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_or_parenthesized_type, 3, 0, 0),
  [6287] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_or_parenthesized_type, 3, 0, 0),
  [6289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1540),
  [6291] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unit, 1, 0, 0),
  [6293] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_unit, 1, 0, 0),
  [6295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3492),
  [6297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7011),
  [6299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4773),
  [6301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_or_parenthesized_type, 4, 0, 0),
  [6303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_or_parenthesized_type, 4, 0, 0),
  [6305] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2856),
  [6308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4851),
  [6311] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4768),
  [6314] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4732),
  [6317] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2375),
  [6320] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2504),
  [6323] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6304),
  [6326] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2348),
  [6329] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1506),
  [6332] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2782),
  [6335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4779),
  [6338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4772),
  [6341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4734),
  [6344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2544),
  [6347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2494),
  [6350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6301),
  [6353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2383),
  [6356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1507),
  [6359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1583),
  [6361] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3015),
  [6363] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4795),
  [6366] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4764),
  [6369] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4730),
  [6371] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2608),
  [6374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2745),
  [6377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6284),
  [6380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2409),
  [6383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1516),
  [6386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1563),
  [6388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1748),
  [6390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1586),
  [6392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1639),
  [6394] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__computation_type, 1, 0, 0),
  [6396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5201),
  [6398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__computation_type, 1, 0, 0),
  [6400] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4795),
  [6403] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4764),
  [6406] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2608),
  [6409] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2745),
  [6412] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6284),
  [6415] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2409),
  [6418] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1517),
  [6421] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3015),
  [6424] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4795),
  [6427] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4764),
  [6430] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4730),
  [6433] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2608),
  [6436] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2745),
  [6439] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6284),
  [6442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2409),
  [6445] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1517),
  [6448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1512),
  [6450] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3173),
  [6453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4792),
  [6456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4758),
  [6459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4723),
  [6462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2514),
  [6465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2743),
  [6468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6282),
  [6471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2605),
  [6474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1519),
  [6477] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3173),
  [6479] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4792),
  [6482] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4758),
  [6485] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4723),
  [6487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2514),
  [6490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2743),
  [6493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6282),
  [6496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2605),
  [6499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1519),
  [6502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1591),
  [6504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1644),
  [6506] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1370),
  [6509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1541),
  [6511] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4792),
  [6514] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4758),
  [6517] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2514),
  [6520] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2743),
  [6523] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6282),
  [6526] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2605),
  [6529] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1522),
  [6532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1559),
  [6534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1757),
  [6536] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 3, 0, 18),
  [6538] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 3, 0, 18),
  [6540] = {.entry = {.count = 1, .reusable = false}}, SHIFT(71),
  [6542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(72),
  [6544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2115),
  [6546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_type, 2, 0, 0),
  [6548] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__value_type, 1, 0, 0), REDUCE(sym__value_type, 2, 0, 0),
  [6551] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_type, 2, 0, 0),
  [6553] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1380),
  [6556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1750),
  [6558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1836),
  [6560] = {.entry = {.count = 1, .reusable = false}}, SHIFT(9),
  [6562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(10),
  [6564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1794),
  [6566] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_wordy_id, 3, 0, 0),
  [6568] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_wordy_id, 3, 0, 0),
  [6570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1547),
  [6572] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 7, 0, 41),
  [6574] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 7, 0, 41),
  [6576] = {.entry = {.count = 1, .reusable = false}}, SHIFT(55),
  [6578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(76),
  [6580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2020),
  [6582] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3424),
  [6585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4808),
  [6588] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4776),
  [6591] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4748),
  [6594] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3152),
  [6597] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3054),
  [6600] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6296),
  [6603] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(2750),
  [6606] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1554),
  [6609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_prefix_term, 5, 0, 0),
  [6611] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_prefix_term, 5, 0, 0),
  [6613] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_prefix_term, 1, 0, 0),
  [6615] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_prefix_term, 1, 0, 0),
  [6617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 4, 0, 24),
  [6619] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 4, 0, 24),
  [6621] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7),
  [6623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(8),
  [6625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1801),
  [6627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1775),
  [6629] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 4, 0, 25),
  [6631] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 4, 0, 25),
  [6633] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5),
  [6635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6),
  [6637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1798),
  [6639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 35),
  [6641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 35),
  [6643] = {.entry = {.count = 1, .reusable = false}}, SHIFT(69),
  [6645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(62),
  [6647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2036),
  [6649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1755),
  [6651] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 36),
  [6653] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 36),
  [6655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(79),
  [6657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(75),
  [6659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2040),
  [6661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(74),
  [6663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(59),
  [6665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2046),
  [6667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1777),
  [6669] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 5, 0, 29),
  [6671] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 5, 0, 29),
  [6673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(26),
  [6675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4),
  [6677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1770),
  [6679] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 5, 0, 30),
  [6681] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 5, 0, 30),
  [6683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(11),
  [6685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(22),
  [6687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1765),
  [6689] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0),
  [6691] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0),
  [6693] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4484),
  [6696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(66),
  [6698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(70),
  [6700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2061),
  [6702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(56),
  [6704] = {.entry = {.count = 1, .reusable = true}}, SHIFT(67),
  [6706] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2064),
  [6708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(57),
  [6710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(58),
  [6712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2075),
  [6714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(13),
  [6716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(12),
  [6718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1763),
  [6720] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term3, 1, 0, 4),
  [6722] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term3, 1, 0, 4),
  [6724] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5194),
  [6726] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_cases, 2, 0, 0),
  [6728] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_cases, 2, 0, 0),
  [6730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4484),
  [6732] = {.entry = {.count = 1, .reusable = false}}, SHIFT(61),
  [6734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(65),
  [6736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2099),
  [6738] = {.entry = {.count = 1, .reusable = false}}, SHIFT(68),
  [6740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(54),
  [6742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2103),
  [6744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1641),
  [6746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1947),
  [6748] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delayed, 2, 0, 0),
  [6750] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delayed, 2, 0, 0),
  [6752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1682),
  [6754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1885),
  [6756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1661),
  [6758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1934),
  [6760] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__arrow, 3, 0, 0),
  [6762] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__arrow, 3, 0, 0),
  [6764] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__effect, 2, 0, 0),
  [6766] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__effect, 2, 0, 0),
  [6768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1631),
  [6770] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 1, 0, 4),
  [6772] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 1, 0, 4),
  [6774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(14),
  [6776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1611),
  [6778] = {.entry = {.count = 1, .reusable = false}}, SHIFT(15),
  [6780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(27),
  [6782] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1735),
  [6784] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1636),
  [6786] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3424),
  [6788] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4808),
  [6791] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4776),
  [6794] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4748),
  [6796] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(3152),
  [6799] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(3054),
  [6802] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6296),
  [6805] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(2750),
  [6808] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1554),
  [6811] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 5, 0, 30),
  [6813] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 5, 0, 30),
  [6815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(24),
  [6817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1624),
  [6819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2),
  [6821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(25),
  [6823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1685),
  [6825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(21),
  [6827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(20),
  [6829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1715),
  [6831] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 4, 0, 25),
  [6833] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 4, 0, 25),
  [6835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(23),
  [6837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1620),
  [6839] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 4, 0, 24),
  [6841] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 4, 0, 24),
  [6843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(18),
  [6845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1619),
  [6847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4808),
  [6850] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4776),
  [6853] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(3152),
  [6856] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(3054),
  [6859] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6296),
  [6862] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(2750),
  [6865] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1592),
  [6868] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10),
  [6870] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10),
  [6872] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1152),
  [6875] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1152),
  [6878] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__value_type, 1, 0, 0),
  [6880] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__value_type, 1, 0, 0),
  [6882] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_cases, 1, 0, 0),
  [6884] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_cases, 1, 0, 0),
  [6886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(19),
  [6888] = {.entry = {.count = 1, .reusable = true}}, SHIFT(17),
  [6890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1728),
  [6892] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 2, 0, 10),
  [6894] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 2, 0, 10),
  [6896] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3),
  [6898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1615),
  [6900] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10),
  [6902] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10),
  [6904] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1149),
  [6907] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 3, 0, 18),
  [6909] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 3, 0, 18),
  [6911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(16),
  [6913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1617),
  [6915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(46),
  [6917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(30),
  [6919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1815),
  [6921] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 7, 0, 35),
  [6923] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 7, 0, 35),
  [6925] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_with, 6, 0, 37),
  [6927] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_with, 6, 0, 37),
  [6929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1706),
  [6931] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_with, 7, 0, 37),
  [6933] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_with, 7, 0, 37),
  [6935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1673),
  [6937] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 3, 0, 4),
  [6939] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 3, 0, 4),
  [6941] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 3, 0, 5),
  [6943] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 3, 0, 5),
  [6945] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 4, 0, 10),
  [6947] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 4, 0, 10),
  [6949] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 5, 0, 18),
  [6951] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 5, 0, 18),
  [6953] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 6, 0, 24),
  [6955] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 6, 0, 24),
  [6957] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4069),
  [6960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4789),
  [6963] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4759),
  [6966] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4725),
  [6969] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3362),
  [6972] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3341),
  [6975] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6281),
  [6978] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(3074),
  [6981] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(1622),
  [6984] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 6, 0, 25),
  [6986] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 6, 0, 25),
  [6988] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___layout_block, 7, 0, 30),
  [6990] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___layout_block, 7, 0, 30),
  [6992] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding, 1, 0, 0),
  [6994] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binding, 1, 0, 0),
  [6996] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4069),
  [6998] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4789),
  [7001] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4759),
  [7004] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4725),
  [7006] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(3362),
  [7009] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(3341),
  [7012] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6281),
  [7015] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(3074),
  [7018] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(1633),
  [7021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(91),
  [7023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(83),
  [7025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2143),
  [7027] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block_term, 1, 0, 4),
  [7029] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block_term, 1, 0, 4),
  [7031] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__binding, 2, 0, 0),
  [7033] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__binding, 2, 0, 0),
  [7035] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4789),
  [7038] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4759),
  [7041] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(3362),
  [7044] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(3341),
  [7047] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6281),
  [7050] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(3074),
  [7053] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(1622),
  [7056] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_function, 3, 0, 20),
  [7058] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_function, 3, 0, 20),
  [7060] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_term_definition2, 4, 0, 22),
  [7062] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_term_definition2, 4, 0, 22),
  [7064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(78),
  [7066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2107),
  [7068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(77),
  [7070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2123),
  [7072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(73),
  [7074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2113),
  [7076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1938),
  [7078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(64),
  [7080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2090),
  [7082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(63),
  [7084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2049),
  [7086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(60),
  [7088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1984),
  [7090] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 2, 0, 4),
  [7092] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 2, 0, 4),
  [7094] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_text, 3, 0, 0),
  [7096] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_text, 3, 0, 0),
  [7098] = {.entry = {.count = 1, .reusable = false}}, SHIFT(103),
  [7100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(104),
  [7102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2152),
  [7104] = {.entry = {.count = 1, .reusable = false}}, SHIFT(101),
  [7106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(100),
  [7108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2170),
  [7110] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 1, 0, 4),
  [7112] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 1, 0, 4),
  [7114] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 3, 0, 4),
  [7116] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 3, 0, 4),
  [7118] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 3, 0, 10),
  [7120] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 3, 0, 10),
  [7122] = {.entry = {.count = 1, .reusable = false}}, SHIFT(98),
  [7124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(97),
  [7126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2181),
  [7128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_text, 2, 0, 0),
  [7130] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_text, 2, 0, 0),
  [7132] = {.entry = {.count = 1, .reusable = false}}, SHIFT(89),
  [7134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(90),
  [7136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2141),
  [7138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4557),
  [7140] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 4, 0, 10),
  [7142] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 4, 0, 10),
  [7144] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_if, 9, 0, 44),
  [7146] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_if, 9, 0, 44),
  [7148] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 4, 0, 18),
  [7150] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 4, 0, 18),
  [7152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1862),
  [7154] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 5),
  [7156] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 5),
  [7158] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_boolean, 1, 0, 0),
  [7160] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_boolean, 1, 0, 0),
  [7162] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 9, 0, 41),
  [7164] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 9, 0, 41),
  [7166] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_char, 1, 0, 0),
  [7168] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_char, 1, 0, 0),
  [7170] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 5),
  [7172] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 5),
  [7174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(38),
  [7176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(39),
  [7178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1863),
  [7180] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 5, 0, 18),
  [7182] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 5, 0, 18),
  [7184] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__match_with, 8, 0, 37),
  [7186] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__match_with, 8, 0, 37),
  [7188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(42),
  [7190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(44),
  [7192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1832),
  [7194] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lam_case, 4, 0, 0),
  [7196] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lam_case, 4, 0, 0),
  [7198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(52),
  [7200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(48),
  [7202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1812),
  [7204] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 8, 0, 41),
  [7206] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 8, 0, 41),
  [7208] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 8, 0, 35),
  [7210] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 8, 0, 35),
  [7212] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 5, 0, 24),
  [7214] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 5, 0, 24),
  [7216] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1870),
  [7218] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lam_case, 3, 0, 0),
  [7220] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__lam_case, 3, 0, 0),
  [7222] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1675),
  [7224] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 5, 0, 25),
  [7226] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 5, 0, 25),
  [7228] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 4),
  [7230] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 4),
  [7232] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_pattern, 2, 0, 5),
  [7234] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_pattern, 2, 0, 5),
  [7236] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 6, 0, 24),
  [7238] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 6, 0, 24),
  [7240] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 6, 0, 25),
  [7242] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 6, 0, 25),
  [7244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(51),
  [7246] = {.entry = {.count = 1, .reusable = true}}, SHIFT(29),
  [7248] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1926),
  [7250] = {.entry = {.count = 1, .reusable = false}}, SHIFT(86),
  [7252] = {.entry = {.count = 1, .reusable = true}}, SHIFT(85),
  [7254] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2213),
  [7256] = {.entry = {.count = 1, .reusable = false}}, SHIFT(28),
  [7258] = {.entry = {.count = 1, .reusable = true}}, SHIFT(47),
  [7260] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1928),
  [7262] = {.entry = {.count = 1, .reusable = false}}, SHIFT(49),
  [7264] = {.entry = {.count = 1, .reusable = true}}, SHIFT(43),
  [7266] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1936),
  [7268] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 8, 0, 36),
  [7270] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 8, 0, 36),
  [7272] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 6, 0, 30),
  [7274] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 6, 0, 30),
  [7276] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym___block, 7, 0, 30),
  [7278] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym___block, 7, 0, 30),
  [7280] = {.entry = {.count = 1, .reusable = false}}, SHIFT(105),
  [7282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(88),
  [7284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2186),
  [7286] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__statement, 1, 0, 3),
  [7288] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__statement, 1, 0, 3),
  [7290] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_destructuring_bind, 4, 0, 25),
  [7292] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_destructuring_bind, 4, 0, 25),
  [7294] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 7, 0, 36),
  [7296] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 7, 0, 36),
  [7298] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1150),
  [7301] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 4, 0, 5),
  [7303] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 4, 0, 5),
  [7305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(36),
  [7307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(40),
  [7309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1849),
  [7311] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 7, 0, 29),
  [7313] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 7, 0, 29),
  [7315] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 4, 0, 32),
  [7317] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 4, 0, 32),
  [7319] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4557),
  [7322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(33),
  [7324] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1850),
  [7326] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__keyword_block, 1, 0, 4),
  [7328] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__keyword_block, 1, 0, 4),
  [7330] = {.entry = {.count = 1, .reusable = false}}, SHIFT(45),
  [7332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(53),
  [7334] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1935),
  [7336] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_matching, 1, 0, 4),
  [7338] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_matching, 1, 0, 4),
  [7340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(41),
  [7342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(34),
  [7344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1906),
  [7346] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 7, 0, 30),
  [7348] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 7, 0, 30),
  [7350] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__term4, 1, 0, 4),
  [7352] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__term4, 1, 0, 4),
  [7354] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term_leaf, 1, 0, 4),
  [7356] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term_leaf, 1, 0, 4),
  [7358] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list, 2, 0, 9),
  [7360] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list, 2, 0, 9),
  [7362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(32),
  [7364] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1847),
  [7366] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term, 1, 0, 4),
  [7368] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term, 1, 0, 4),
  [7370] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term2, 1, 0, 4),
  [7372] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term2, 1, 0, 4),
  [7374] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_quote, 2, 0, 5),
  [7376] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_quote, 2, 0, 5),
  [7378] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_bang, 2, 0, 5),
  [7380] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_bang, 2, 0, 5),
  [7382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(31),
  [7384] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1842),
  [7386] = {.entry = {.count = 1, .reusable = true}}, SHIFT(35),
  [7388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1835),
  [7390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(37),
  [7392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1834),
  [7394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1826),
  [7396] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_termlink, 2, 0, 0),
  [7398] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_termlink, 2, 0, 0),
  [7400] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_rhs, 3, 0, 0),
  [7402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_rhs, 3, 0, 0),
  [7404] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_rhs, 3, 0, 18),
  [7406] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_rhs, 3, 0, 18),
  [7408] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_typelink, 2, 0, 0),
  [7410] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_typelink, 2, 0, 0),
  [7412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(50),
  [7414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1810),
  [7416] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 6, 0, 29),
  [7418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 6, 0, 29),
  [7420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 6, 0, 30),
  [7422] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 6, 0, 30),
  [7424] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 25),
  [7426] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 25),
  [7428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1881),
  [7430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 6, 0, 24),
  [7432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 6, 0, 24),
  [7434] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_force, 2, 0, 12),
  [7436] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_force, 2, 0, 12),
  [7438] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_or_parenthesized, 6, 0, 24),
  [7440] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_or_parenthesized, 6, 0, 24),
  [7442] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list, 3, 0, 17),
  [7444] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list, 3, 0, 17),
  [7446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__block, 5, 0, 32),
  [7448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__block, 5, 0, 32),
  [7450] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_block, 5, 0, 0),
  [7452] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rewrite_block, 5, 0, 0),
  [7454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_rhs, 4, 0, 0),
  [7456] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_rhs, 4, 0, 0),
  [7458] = {.entry = {.count = 1, .reusable = false}}, SHIFT(84),
  [7460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(81),
  [7462] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2226),
  [7464] = {.entry = {.count = 1, .reusable = false}}, SHIFT(102),
  [7466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(99),
  [7468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2216),
  [7470] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_or_parenthesized, 4, 0, 0),
  [7472] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_or_parenthesized, 4, 0, 0),
  [7474] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 5, 0, 25),
  [7476] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 5, 0, 25),
  [7478] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 5, 0, 24),
  [7480] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 5, 0, 24),
  [7482] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list, 4, 0, 23),
  [7484] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list, 4, 0, 23),
  [7486] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__term3, 3, 0, 4),
  [7488] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__term3, 3, 0, 4),
  [7490] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_function2, 3, 0, 20),
  [7492] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_function2, 3, 0, 20),
  [7494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(96),
  [7496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(93),
  [7498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2221),
  [7500] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1172),
  [7503] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1172),
  [7506] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_exp_let, 4, 0, 18),
  [7508] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_exp_let, 4, 0, 18),
  [7510] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_delay_block, 5, 0, 18),
  [7512] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_delay_block, 5, 0, 18),
  [7514] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_tuple_or_parenthesized, 5, 0, 18),
  [7516] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_tuple_or_parenthesized, 5, 0, 18),
  [7518] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_block, 4, 0, 0),
  [7520] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_rewrite_block, 4, 0, 0),
  [7522] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_handler, 4, 0, 27),
  [7524] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_handler, 4, 0, 27),
  [7526] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__pattern_leaf, 1, 0, 19),
  [7528] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4912),
  [7530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2349),
  [7532] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_leaf, 1, 0, 19),
  [7534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1944),
  [7536] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4929),
  [7538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2389),
  [7540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1909),
  [7542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(87),
  [7544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2142),
  [7546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(92),
  [7548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2206),
  [7550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(80),
  [7552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2173),
  [7554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1959),
  [7556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2087),
  [7558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(94),
  [7560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2187),
  [7562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(95),
  [7564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2202),
  [7566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1968),
  [7568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2019),
  [7570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(82),
  [7572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2242),
  [7574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1844),
  [7576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1895),
  [7578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2014),
  [7580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2078),
  [7582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2084),
  [7584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1971),
  [7586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2017),
  [7588] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2028),
  [7590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2053),
  [7592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2245),
  [7594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1987),
  [7596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2257),
  [7598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2118),
  [7600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2252),
  [7602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2000),
  [7604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2251),
  [7606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2269),
  [7608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2127),
  [7610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2180),
  [7612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2191),
  [7614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2256),
  [7616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2286),
  [7618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2249),
  [7620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1396),
  [7623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2153),
  [7625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1399),
  [7628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2297),
  [7630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2333),
  [7632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2295),
  [7634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2313),
  [7636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2220),
  [7638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2279),
  [7640] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1400),
  [7643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2165),
  [7645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2283),
  [7647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2372),
  [7649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2292),
  [7651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2328),
  [7653] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1373),
  [7656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2274),
  [7658] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2299),
  [7660] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1371),
  [7663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2323),
  [7665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2521),
  [7667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2379),
  [7669] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1392),
  [7672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2364),
  [7674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2586),
  [7676] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2374),
  [7678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2373),
  [7680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2464),
  [7682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2271),
  [7684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2371),
  [7686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2531),
  [7688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2343),
  [7690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2312),
  [7692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2317),
  [7694] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 2, 0, 0),
  [7696] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4916),
  [7698] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4787),
  [7700] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4778),
  [7702] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5423),
  [7704] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4881),
  [7706] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 2, 0, 0),
  [7708] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6475),
  [7710] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4904),
  [7712] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4879),
  [7714] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6259),
  [7716] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4865),
  [7718] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4572),
  [7720] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1382),
  [7723] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1394),
  [7726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2486),
  [7728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2784),
  [7730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2369),
  [7732] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1398),
  [7735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2520),
  [7737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2523),
  [7739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2867),
  [7741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2575),
  [7743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2726),
  [7745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2344),
  [7747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2602),
  [7749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2658),
  [7751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2327),
  [7753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2604),
  [7755] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4483),
  [7758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2478),
  [7760] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2779),
  [7762] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2582),
  [7764] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2717),
  [7766] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2570),
  [7768] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2736),
  [7770] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4483),
  [7772] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2583),
  [7774] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2593),
  [7776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2683),
  [7778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2524),
  [7780] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2456),
  [7782] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1368),
  [7785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2391),
  [7787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2872),
  [7789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2511),
  [7791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2816),
  [7793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2467),
  [7795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2773),
  [7797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2507),
  [7799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2806),
  [7801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2879),
  [7803] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1181),
  [7806] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1181),
  [7809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2762),
  [7811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3082),
  [7813] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1391),
  [7816] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2747),
  [7818] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3125),
  [7820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2754),
  [7822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3115),
  [7824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2539),
  [7826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2548),
  [7828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2783),
  [7830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2775),
  [7832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3072),
  [7834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2772),
  [7836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2781),
  [7838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2967),
  [7840] = {.entry = {.count = 1, .reusable = true}}, SHIFT(129),
  [7842] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2519),
  [7844] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2791),
  [7846] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2804),
  [7848] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2809),
  [7850] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2814),
  [7852] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2794),
  [7854] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2844),
  [7856] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2941),
  [7858] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2551),
  [7860] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2727),
  [7862] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2984),
  [7864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(222),
  [7866] = {.entry = {.count = 1, .reusable = true}}, SHIFT(221),
  [7868] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3407),
  [7870] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2443),
  [7872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(127),
  [7874] = {.entry = {.count = 1, .reusable = true}}, SHIFT(107),
  [7876] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2554),
  [7878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(125),
  [7880] = {.entry = {.count = 1, .reusable = true}}, SHIFT(126),
  [7882] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2522),
  [7884] = {.entry = {.count = 1, .reusable = true}}, SHIFT(113),
  [7886] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2513),
  [7888] = {.entry = {.count = 1, .reusable = false}}, SHIFT(123),
  [7890] = {.entry = {.count = 1, .reusable = true}}, SHIFT(120),
  [7892] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2512),
  [7894] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2403),
  [7896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(121),
  [7898] = {.entry = {.count = 1, .reusable = true}}, SHIFT(122),
  [7900] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2495),
  [7902] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1387),
  [7905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2680),
  [7907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(114),
  [7909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2462),
  [7911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(128),
  [7913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(124),
  [7915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2485),
  [7917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(116),
  [7919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2469),
  [7921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(130),
  [7923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2470),
  [7925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2819),
  [7927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2420),
  [7929] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1175),
  [7932] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2477),
  [7934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(110),
  [7936] = {.entry = {.count = 1, .reusable = true}}, SHIFT(111),
  [7938] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2448),
  [7940] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2689),
  [7942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(108),
  [7944] = {.entry = {.count = 1, .reusable = true}}, SHIFT(109),
  [7946] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2393),
  [7948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(119),
  [7950] = {.entry = {.count = 1, .reusable = true}}, SHIFT(118),
  [7952] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2398),
  [7954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(242),
  [7956] = {.entry = {.count = 1, .reusable = true}}, SHIFT(241),
  [7958] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3490),
  [7960] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1385),
  [7963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(213),
  [7965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(212),
  [7967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3451),
  [7969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(112),
  [7971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2492),
  [7973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2661),
  [7975] = {.entry = {.count = 1, .reusable = false}}, SHIFT(215),
  [7977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(214),
  [7979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3339),
  [7981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(218),
  [7983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(216),
  [7985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3336),
  [7987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(117),
  [7989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(131),
  [7991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2415),
  [7993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(115),
  [7995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(106),
  [7997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2480),
  [7999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(220),
  [8001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(219),
  [8003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3343),
  [8005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2678),
  [8007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2666),
  [8009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3194),
  [8011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(238),
  [8013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(237),
  [8015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3467),
  [8017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(229),
  [8019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(225),
  [8021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3409),
  [8023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(236),
  [8025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(235),
  [8027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3453),
  [8029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(233),
  [8031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(230),
  [8033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3439),
  [8035] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__number, 1, 0, 0),
  [8037] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__literal_pattern, 1, 0, 0), REDUCE(sym__number, 1, 0, 0),
  [8040] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__literal_pattern, 1, 0, 0),
  [8042] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__literal_pattern, 1, 0, 0), REDUCE(sym__number, 1, 0, 0),
  [8045] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__number, 1, 0, 0),
  [8047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(454),
  [8049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(441),
  [8051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4013),
  [8053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(189),
  [8055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(190),
  [8057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3285),
  [8059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(191),
  [8061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(195),
  [8063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3282),
  [8065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(226),
  [8067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3466),
  [8069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(158),
  [8071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(165),
  [8073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(155),
  [8075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(157),
  [8077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(150),
  [8079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(152),
  [8081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(146),
  [8083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(147),
  [8085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(252),
  [8087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3478),
  [8089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(143),
  [8091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(145),
  [8093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(199),
  [8095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(200),
  [8097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3265),
  [8099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(140),
  [8101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(142),
  [8103] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym_literal_list_pattern, 2, 0, 0), REDUCE(sym_literal_list, 2, 0, 9),
  [8106] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list_pattern, 2, 0, 0),
  [8108] = {.entry = {.count = 1, .reusable = false}}, SHIFT(424),
  [8110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(419),
  [8112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3992),
  [8114] = {.entry = {.count = 1, .reusable = false}}, SHIFT(415),
  [8116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(414),
  [8118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3985),
  [8120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(453),
  [8122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(458),
  [8124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3987),
  [8126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3266),
  [8128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3778),
  [8130] = {.entry = {.count = 1, .reusable = false}}, SHIFT(413),
  [8132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(412),
  [8134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3982),
  [8136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(253),
  [8138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3484),
  [8140] = {.entry = {.count = 1, .reusable = true}}, SHIFT(256),
  [8142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3488),
  [8144] = {.entry = {.count = 1, .reusable = false}}, SHIFT(446),
  [8146] = {.entry = {.count = 1, .reusable = true}}, SHIFT(444),
  [8148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3958),
  [8150] = {.entry = {.count = 1, .reusable = false}}, SHIFT(438),
  [8152] = {.entry = {.count = 1, .reusable = true}}, SHIFT(434),
  [8154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3954),
  [8156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(257),
  [8158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3496),
  [8160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(433),
  [8162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(432),
  [8164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3950),
  [8166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(138),
  [8168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(139),
  [8170] = {.entry = {.count = 1, .reusable = false}}, SHIFT(397),
  [8172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(394),
  [8174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3915),
  [8176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(393),
  [8178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(392),
  [8180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3912),
  [8182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4489),
  [8185] = {.entry = {.count = 1, .reusable = false}}, SHIFT(183),
  [8187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(186),
  [8189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3300),
  [8191] = {.entry = {.count = 1, .reusable = false}}, SHIFT(391),
  [8193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(390),
  [8195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3898),
  [8197] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3233),
  [8199] = {.entry = {.count = 1, .reusable = false}}, SHIFT(388),
  [8201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(387),
  [8203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3880),
  [8205] = {.entry = {.count = 1, .reusable = false}}, SHIFT(386),
  [8207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(385),
  [8209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3875),
  [8211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3165),
  [8213] = {.entry = {.count = 1, .reusable = false}}, SHIFT(409),
  [8215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(344),
  [8217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3970),
  [8219] = {.entry = {.count = 1, .reusable = false}}, SHIFT(356),
  [8221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(309),
  [8223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3969),
  [8225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(141),
  [8227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3133),
  [8229] = {.entry = {.count = 1, .reusable = false}}, SHIFT(326),
  [8231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(323),
  [8233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4224),
  [8235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(234),
  [8237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3474),
  [8239] = {.entry = {.count = 1, .reusable = false}}, SHIFT(180),
  [8241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(181),
  [8243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3305),
  [8245] = {.entry = {.count = 1, .reusable = false}}, SHIFT(321),
  [8247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(324),
  [8249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3962),
  [8251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(384),
  [8253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(380),
  [8255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3835),
  [8257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(136),
  [8259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(137),
  [8261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4489),
  [8263] = {.entry = {.count = 1, .reusable = false}}, SHIFT(340),
  [8265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(346),
  [8267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3937),
  [8269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(348),
  [8271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(355),
  [8273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4043),
  [8275] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1374),
  [8278] = {.entry = {.count = 1, .reusable = false}}, SHIFT(457),
  [8280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(455),
  [8282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4328),
  [8284] = {.entry = {.count = 1, .reusable = false}}, SHIFT(420),
  [8286] = {.entry = {.count = 1, .reusable = true}}, SHIFT(423),
  [8288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4278),
  [8290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(168),
  [8292] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3159),
  [8294] = {.entry = {.count = 1, .reusable = true}}, SHIFT(182),
  [8296] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3161),
  [8298] = {.entry = {.count = 1, .reusable = false}}, SHIFT(406),
  [8300] = {.entry = {.count = 1, .reusable = true}}, SHIFT(407),
  [8302] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4277),
  [8304] = {.entry = {.count = 1, .reusable = false}}, SHIFT(134),
  [8306] = {.entry = {.count = 1, .reusable = true}}, SHIFT(135),
  [8308] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1147),
  [8311] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1147),
  [8314] = {.entry = {.count = 1, .reusable = false}}, SHIFT(148),
  [8316] = {.entry = {.count = 1, .reusable = true}}, SHIFT(133),
  [8318] = {.entry = {.count = 1, .reusable = false}}, SHIFT(358),
  [8320] = {.entry = {.count = 1, .reusable = true}}, SHIFT(364),
  [8322] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4248),
  [8324] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1177),
  [8327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(202),
  [8329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3178),
  [8331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(463),
  [8333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(342),
  [8335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4236),
  [8337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(198),
  [8339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3081),
  [8341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(322),
  [8343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(320),
  [8345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4234),
  [8347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(374),
  [8349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(375),
  [8351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3914),
  [8353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(173),
  [8355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(174),
  [8357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3254),
  [8359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(171),
  [8361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(172),
  [8363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3246),
  [8365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2979),
  [8367] = {.entry = {.count = 1, .reusable = false}}, SHIFT(330),
  [8369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(329),
  [8371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4220),
  [8373] = {.entry = {.count = 1, .reusable = false}}, SHIFT(332),
  [8375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(331),
  [8377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4215),
  [8379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(144),
  [8381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3209),
  [8383] = {.entry = {.count = 1, .reusable = false}}, SHIFT(338),
  [8385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(336),
  [8387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4201),
  [8389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(201),
  [8391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3309),
  [8393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3126),
  [8395] = {.entry = {.count = 1, .reusable = false}}, SHIFT(175),
  [8397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(179),
  [8399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3308),
  [8401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3004),
  [8403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3779),
  [8405] = {.entry = {.count = 1, .reusable = false}}, SHIFT(167),
  [8407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(170),
  [8409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3234),
  [8411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3118),
  [8413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(204),
  [8415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3272),
  [8417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(149),
  [8419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3317),
  [8421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(206),
  [8423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3247),
  [8425] = {.entry = {.count = 1, .reusable = false}}, SHIFT(163),
  [8427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(164),
  [8429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3192),
  [8431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3063),
  [8433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(207),
  [8435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3061),
  [8437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2798),
  [8439] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1159),
  [8442] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1170),
  [8445] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1170),
  [8448] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2774),
  [8450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3031),
  [8452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3670),
  [8454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3073),
  [8456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(205),
  [8458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3248),
  [8460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3067),
  [8462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(448),
  [8464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(450),
  [8466] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4091),
  [8468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4458),
  [8470] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2996),
  [8472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3773),
  [8474] = {.entry = {.count = 1, .reusable = false}}, SHIFT(445),
  [8476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(447),
  [8478] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4101),
  [8480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(440),
  [8482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(443),
  [8484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4105),
  [8486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3002),
  [8488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3414),
  [8490] = {.entry = {.count = 1, .reusable = true}}, SHIFT(153),
  [8492] = {.entry = {.count = 1, .reusable = true}}, SHIFT(154),
  [8494] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1378),
  [8497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2995),
  [8499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3419),
  [8501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(159),
  [8503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(160),
  [8505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(161),
  [8507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(162),
  [8509] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1165),
  [8512] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1156),
  [8515] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1156),
  [8518] = {.entry = {.count = 1, .reusable = false}}, SHIFT(169),
  [8520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(178),
  [8522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3026),
  [8524] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym_literal_list_pattern, 2, 0, 0), REDUCE(sym_literal_list, 2, 0, 9),
  [8527] = {.entry = {.count = 1, .reusable = false}}, SHIFT(428),
  [8529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(431),
  [8531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4120),
  [8533] = {.entry = {.count = 1, .reusable = false}}, SHIFT(400),
  [8535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(399),
  [8537] = {.entry = {.count = 1, .reusable = false}}, SHIFT(398),
  [8539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(396),
  [8541] = {.entry = {.count = 1, .reusable = false}}, SHIFT(395),
  [8543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(383),
  [8545] = {.entry = {.count = 1, .reusable = false}}, SHIFT(381),
  [8547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(371),
  [8549] = {.entry = {.count = 1, .reusable = false}}, SHIFT(422),
  [8551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(427),
  [8553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4121),
  [8555] = {.entry = {.count = 1, .reusable = false}}, SHIFT(366),
  [8557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(362),
  [8559] = {.entry = {.count = 1, .reusable = false}}, SHIFT(360),
  [8561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(359),
  [8563] = {.entry = {.count = 1, .reusable = false}}, SHIFT(357),
  [8565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(351),
  [8567] = {.entry = {.count = 1, .reusable = false}}, SHIFT(349),
  [8569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(347),
  [8571] = {.entry = {.count = 1, .reusable = false}}, SHIFT(335),
  [8573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(334),
  [8575] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4458),
  [8578] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3005),
  [8580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3680),
  [8582] = {.entry = {.count = 1, .reusable = false}}, SHIFT(328),
  [8584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(327),
  [8586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2985),
  [8588] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2909),
  [8590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(404),
  [8592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(410),
  [8594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4129),
  [8596] = {.entry = {.count = 1, .reusable = false}}, SHIFT(436),
  [8598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(439),
  [8600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4117),
  [8602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2841),
  [8604] = {.entry = {.count = 1, .reusable = false}}, SHIFT(363),
  [8606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(367),
  [8608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4135),
  [8610] = {.entry = {.count = 1, .reusable = false}}, SHIFT(368),
  [8612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(373),
  [8614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4132),
  [8616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3078),
  [8618] = {.entry = {.count = 1, .reusable = false}}, SHIFT(185),
  [8620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(184),
  [8622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2913),
  [8624] = {.entry = {.count = 1, .reusable = false}}, SHIFT(188),
  [8626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(187),
  [8628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2946),
  [8630] = {.entry = {.count = 1, .reusable = false}}, SHIFT(193),
  [8632] = {.entry = {.count = 1, .reusable = true}}, SHIFT(192),
  [8634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2951),
  [8636] = {.entry = {.count = 1, .reusable = false}}, SHIFT(343),
  [8638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(353),
  [8640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4149),
  [8642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2957),
  [8644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3536),
  [8646] = {.entry = {.count = 1, .reusable = false}}, SHIFT(196),
  [8648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(194),
  [8650] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2964),
  [8652] = {.entry = {.count = 1, .reusable = false}}, SHIFT(203),
  [8654] = {.entry = {.count = 1, .reusable = true}}, SHIFT(197),
  [8656] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2981),
  [8658] = {.entry = {.count = 1, .reusable = false}}, SHIFT(209),
  [8660] = {.entry = {.count = 1, .reusable = true}}, SHIFT(208),
  [8662] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2983),
  [8664] = {.entry = {.count = 1, .reusable = false}}, SHIFT(177),
  [8666] = {.entry = {.count = 1, .reusable = true}}, SHIFT(176),
  [8668] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3096),
  [8670] = {.entry = {.count = 1, .reusable = false}}, SHIFT(151),
  [8672] = {.entry = {.count = 1, .reusable = true}}, SHIFT(132),
  [8674] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3046),
  [8676] = {.entry = {.count = 1, .reusable = false}}, SHIFT(156),
  [8678] = {.entry = {.count = 1, .reusable = true}}, SHIFT(166),
  [8680] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3036),
  [8682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4568),
  [8684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(316),
  [8686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4228),
  [8688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(224),
  [8690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3472),
  [8692] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1162),
  [8695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(246),
  [8697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(247),
  [8699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3754),
  [8701] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1179),
  [8704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1179),
  [8707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(405),
  [8709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4390),
  [8711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(307),
  [8713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4249),
  [8715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3268),
  [8717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(339),
  [8719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4380),
  [8721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(354),
  [8723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3817),
  [8725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(318),
  [8727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4238),
  [8729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(240),
  [8731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3559),
  [8733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(341),
  [8735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3824),
  [8737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(319),
  [8739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3825),
  [8741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(325),
  [8743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3841),
  [8745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(292),
  [8747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3571),
  [8749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(456),
  [8751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3867),
  [8753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3213),
  [8755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(429),
  [8757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(333),
  [8759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4373),
  [8761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3547),
  [8763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4515),
  [8765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3185),
  [8767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(243),
  [8769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3555),
  [8771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(310),
  [8773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4366),
  [8775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(311),
  [8777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4365),
  [8779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(509),
  [8781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(507),
  [8783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4561),
  [8785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(317),
  [8787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4306),
  [8789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(313),
  [8791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4358),
  [8793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(479),
  [8795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(480),
  [8797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4492),
  [8799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3416),
  [8801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3766),
  [8803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3412),
  [8805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3777),
  [8807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3675),
  [8809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(290),
  [8811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(276),
  [8813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3429),
  [8815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(283),
  [8817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(279),
  [8819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3389),
  [8821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(287),
  [8823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(284),
  [8825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3388),
  [8827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(306),
  [8829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(305),
  [8831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3370),
  [8833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(504),
  [8835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(516),
  [8837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4539),
  [8839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(244),
  [8841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3549),
  [8843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(245),
  [8845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3548),
  [8847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(303),
  [8849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(304),
  [8851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3366),
  [8853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(515),
  [8855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(514),
  [8857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4536),
  [8859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3686),
  [8861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(497),
  [8863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(465),
  [8865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4504),
  [8867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(301),
  [8869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(228),
  [8871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3364),
  [8873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(295),
  [8875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(299),
  [8877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3328),
  [8879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(289),
  [8881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(291),
  [8883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3759),
  [8885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(470),
  [8887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(469),
  [8889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4505),
  [8891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(281),
  [8893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(282),
  [8895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3322),
  [8897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(266),
  [8899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(274),
  [8901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3397),
  [8903] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1146),
  [8906] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1146),
  [8909] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1144),
  [8912] = {.entry = {.count = 1, .reusable = true}}, SHIFT(285),
  [8914] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3567),
  [8916] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4515),
  [8919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(297),
  [8921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3579),
  [8923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3374),
  [8925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3856),
  [8927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(261),
  [8929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3542),
  [8931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3372),
  [8933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3846),
  [8935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(426),
  [8937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(312),
  [8939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4194),
  [8941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(506),
  [8943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(505),
  [8945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4524),
  [8947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3649),
  [8949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4030),
  [8951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(421),
  [8953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(500),
  [8955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(517),
  [8957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4457),
  [8959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(418),
  [8961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(417),
  [8963] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__match_cases_repeat1, 2, 0, 0), SHIFT_REPEAT(4568),
  [8966] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3415),
  [8968] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3913),
  [8970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3665),
  [8972] = {.entry = {.count = 1, .reusable = true}}, SHIFT(298),
  [8974] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3584),
  [8976] = {.entry = {.count = 1, .reusable = true}}, SHIFT(352),
  [8978] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3881),
  [8980] = {.entry = {.count = 1, .reusable = false}}, SHIFT(512),
  [8982] = {.entry = {.count = 1, .reusable = true}}, SHIFT(510),
  [8984] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4525),
  [8986] = {.entry = {.count = 1, .reusable = true}}, SHIFT(300),
  [8988] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3585),
  [8990] = {.entry = {.count = 1, .reusable = true}}, SHIFT(302),
  [8992] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3589),
  [8994] = {.entry = {.count = 1, .reusable = true}}, SHIFT(416),
  [8996] = {.entry = {.count = 1, .reusable = true}}, SHIFT(308),
  [8998] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4067),
  [9000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3614),
  [9002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3731),
  [9004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3908),
  [9006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3750),
  [9008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3873),
  [9010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3434),
  [9012] = {.entry = {.count = 1, .reusable = false}}, SHIFT(490),
  [9014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(485),
  [9016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4448),
  [9018] = {.entry = {.count = 1, .reusable = false}}, SHIFT(487),
  [9020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(498),
  [9022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4445),
  [9024] = {.entry = {.count = 1, .reusable = false}}, SHIFT(511),
  [9026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(496),
  [9028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4442),
  [9030] = {.entry = {.count = 1, .reusable = false}}, SHIFT(466),
  [9032] = {.entry = {.count = 1, .reusable = true}}, SHIFT(467),
  [9034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4436),
  [9036] = {.entry = {.count = 1, .reusable = false}}, SHIFT(468),
  [9038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(477),
  [9040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4435),
  [9042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(315),
  [9044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4212),
  [9046] = {.entry = {.count = 1, .reusable = false}}, SHIFT(478),
  [9048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(482),
  [9050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4433),
  [9052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(365),
  [9054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4055),
  [9056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3113),
  [9058] = {.entry = {.count = 1, .reusable = false}}, SHIFT(483),
  [9060] = {.entry = {.count = 1, .reusable = true}}, SHIFT(484),
  [9062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4425),
  [9064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(451),
  [9066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4051),
  [9068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3149),
  [9070] = {.entry = {.count = 1, .reusable = false}}, SHIFT(486),
  [9072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(488),
  [9074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4424),
  [9076] = {.entry = {.count = 1, .reusable = false}}, SHIFT(502),
  [9078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(501),
  [9080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4520),
  [9082] = {.entry = {.count = 1, .reusable = false}}, SHIFT(489),
  [9084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(494),
  [9086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4415),
  [9088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(460),
  [9090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4046),
  [9092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2920),
  [9094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3507),
  [9096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(462),
  [9098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4045),
  [9100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(459),
  [9102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4039),
  [9104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3769),
  [9106] = {.entry = {.count = 1, .reusable = false}}, SHIFT(272),
  [9108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(273),
  [9110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3681),
  [9112] = {.entry = {.count = 1, .reusable = false}}, SHIFT(270),
  [9114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(271),
  [9116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3692),
  [9118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3093),
  [9120] = {.entry = {.count = 1, .reusable = false}}, SHIFT(267),
  [9122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(268),
  [9124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3696),
  [9126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3504),
  [9128] = {.entry = {.count = 1, .reusable = false}}, SHIFT(264),
  [9130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(265),
  [9132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3707),
  [9134] = {.entry = {.count = 1, .reusable = false}}, SHIFT(260),
  [9136] = {.entry = {.count = 1, .reusable = true}}, SHIFT(263),
  [9138] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3710),
  [9140] = {.entry = {.count = 1, .reusable = false}}, SHIFT(255),
  [9142] = {.entry = {.count = 1, .reusable = true}}, SHIFT(258),
  [9144] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3712),
  [9146] = {.entry = {.count = 1, .reusable = false}}, SHIFT(503),
  [9148] = {.entry = {.count = 1, .reusable = true}}, SHIFT(508),
  [9150] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4552),
  [9152] = {.entry = {.count = 1, .reusable = false}}, SHIFT(251),
  [9154] = {.entry = {.count = 1, .reusable = true}}, SHIFT(254),
  [9156] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3721),
  [9158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3075),
  [9160] = {.entry = {.count = 1, .reusable = false}}, SHIFT(210),
  [9162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(250),
  [9164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3729),
  [9166] = {.entry = {.count = 1, .reusable = false}}, SHIFT(248),
  [9168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(249),
  [9170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3732),
  [9172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3842),
  [9174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3848),
  [9176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3882),
  [9178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3899),
  [9180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4298),
  [9182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3900),
  [9184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4292),
  [9186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3902),
  [9188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4285),
  [9190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3905),
  [9192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4279),
  [9194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3932),
  [9196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(403),
  [9198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(402),
  [9200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(401),
  [9202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(389),
  [9204] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3355),
  [9206] = {.entry = {.count = 1, .reusable = true}}, SHIFT(361),
  [9208] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3318),
  [9210] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3400),
  [9212] = {.entry = {.count = 1, .reusable = true}}, SHIFT(345),
  [9214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1153),
  [9217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3683),
  [9219] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1154),
  [9222] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1154),
  [9225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(513),
  [9227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4606),
  [9229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(495),
  [9231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4602),
  [9233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3737),
  [9235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3758),
  [9237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(493),
  [9239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4584),
  [9241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(492),
  [9243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4582),
  [9245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(491),
  [9247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4395),
  [9249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(481),
  [9251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4578),
  [9253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(471),
  [9255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4587),
  [9257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3421),
  [9259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4036),
  [9261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(472),
  [9263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4589),
  [9265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(473),
  [9267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4591),
  [9269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(474),
  [9271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4593),
  [9273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(475),
  [9275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4594),
  [9277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(476),
  [9279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4597),
  [9281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(411),
  [9283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(408),
  [9285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(372),
  [9287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(435),
  [9289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(376),
  [9291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(337),
  [9293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3398),
  [9295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3921),
  [9297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(350),
  [9299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(314),
  [9301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(425),
  [9303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(452),
  [9305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(461),
  [9307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(449),
  [9309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(442),
  [9311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(437),
  [9313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3857),
  [9315] = {.entry = {.count = 1, .reusable = false}}, SHIFT(382),
  [9317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(379),
  [9319] = {.entry = {.count = 1, .reusable = false}}, SHIFT(378),
  [9321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(377),
  [9323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(370),
  [9325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(369),
  [9327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4386),
  [9329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4560),
  [9331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4020),
  [9333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4381),
  [9335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4400),
  [9337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4001),
  [9339] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5221),
  [9341] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4807),
  [9343] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4770),
  [9345] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4738),
  [9347] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4892),
  [9349] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5138),
  [9351] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5181),
  [9353] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6376),
  [9355] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5164),
  [9357] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4930),
  [9359] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4392),
  [9361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4155),
  [9363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4299),
  [9365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4296),
  [9367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4286),
  [9369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4283),
  [9371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4250),
  [9373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4412),
  [9375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4115),
  [9377] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0),
  [9379] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4647),
  [9382] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(4652),
  [9385] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6500),
  [9388] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0),
  [9390] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3919),
  [9392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4196),
  [9394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4209),
  [9396] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3839),
  [9398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4093),
  [9400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4315),
  [9402] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_clause, 3, 0, 6),
  [9404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4647),
  [9406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4652),
  [9408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6500),
  [9410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_clause, 3, 0, 6),
  [9412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4203),
  [9414] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4428),
  [9416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4143),
  [9418] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use_clause, 2, 0, 6),
  [9420] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_use_clause, 2, 0, 6),
  [9422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3967),
  [9424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3998),
  [9426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3794),
  [9428] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3920),
  [9430] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5353),
  [9432] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5446),
  [9434] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5395),
  [9436] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4975),
  [9438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4975),
  [9440] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5011),
  [9442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6591),
  [9444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4570),
  [9446] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6588),
  [9448] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5353),
  [9450] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4945),
  [9452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6639),
  [9454] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5041),
  [9456] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5140),
  [9458] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4497),
  [9460] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5360),
  [9462] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5462),
  [9464] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5418),
  [9466] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4969),
  [9468] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4969),
  [9470] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4964),
  [9472] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7021),
  [9474] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4571),
  [9476] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7022),
  [9478] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4944),
  [9480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4485),
  [9482] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4411),
  [9484] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4546),
  [9486] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4417),
  [9488] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4420),
  [9490] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5418),
  [9492] = {.entry = {.count = 1, .reusable = false}}, SHIFT(7021),
  [9494] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4571),
  [9496] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6414),
  [9498] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5041),
  [9500] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5140),
  [9502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4556),
  [9504] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4409),
  [9506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4452),
  [9508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4466),
  [9510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4399),
  [9512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4397),
  [9514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5342),
  [9516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5504),
  [9518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5373),
  [9520] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4957),
  [9522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4957),
  [9524] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4956),
  [9526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7010),
  [9528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4461),
  [9530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4963),
  [9532] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4942),
  [9534] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4916),
  [9537] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4787),
  [9540] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4778),
  [9543] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4745),
  [9546] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4904),
  [9549] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4879),
  [9552] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6259),
  [9555] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4865),
  [9558] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4506),
  [9561] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4787),
  [9564] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4745),
  [9566] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4904),
  [9569] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6259),
  [9572] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4506),
  [9574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4987),
  [9576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4962),
  [9578] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4787),
  [9581] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4904),
  [9584] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6259),
  [9587] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4564),
  [9589] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_symboly_id, 1, 0, 0),
  [9591] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_symboly_id, 1, 0, 0),
  [9593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4654),
  [9595] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_symboly_id, 2, 0, 0),
  [9597] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_symboly_id, 2, 0, 0),
  [9599] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_guarded_block_repeat1, 2, 0, 0),
  [9601] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat1, 2, 0, 0),
  [9603] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat1, 2, 0, 0), SHIFT_REPEAT(6087),
  [9606] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0),
  [9608] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(6231),
  [9611] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(5670),
  [9614] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(5348),
  [9617] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(6232),
  [9620] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(5377),
  [9623] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(5429),
  [9626] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(7103),
  [9629] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(1192),
  [9632] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(4649),
  [9635] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(1187),
  [9638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_unison_repeat1, 2, 0, 0), SHIFT_REPEAT(7009),
  [9641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4687),
  [9643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4719),
  [9645] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_unison, 1, 0, 0),
  [9647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4649),
  [9649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5486),
  [9651] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5486),
  [9653] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4844),
  [9655] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4752),
  [9657] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4899),
  [9659] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2268),
  [9661] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6287),
  [9663] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1445),
  [9665] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4800),
  [9667] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4751),
  [9669] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4875),
  [9671] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1552),
  [9673] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6285),
  [9675] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1388),
  [9677] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4828),
  [9679] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4756),
  [9681] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4885),
  [9683] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2262),
  [9685] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6317),
  [9687] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1444),
  [9689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5443),
  [9691] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5443),
  [9693] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4779),
  [9695] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4772),
  [9697] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4883),
  [9699] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2494),
  [9701] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6301),
  [9703] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1483),
  [9705] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4815),
  [9707] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4749),
  [9709] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4887),
  [9711] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2457),
  [9713] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6293),
  [9715] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1497),
  [9717] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5239),
  [9719] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4781),
  [9721] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4761),
  [9723] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4870),
  [9725] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5183),
  [9727] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5206),
  [9729] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6349),
  [9731] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5157),
  [9733] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4933),
  [9735] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5120),
  [9737] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4847),
  [9739] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4777),
  [9741] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4888),
  [9743] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5023),
  [9745] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5057),
  [9747] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6472),
  [9749] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5026),
  [9751] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4943),
  [9753] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4825),
  [9755] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4775),
  [9757] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4901),
  [9759] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2284),
  [9761] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6299),
  [9763] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1451),
  [9765] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4808),
  [9767] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4776),
  [9769] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4903),
  [9771] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3054),
  [9773] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6296),
  [9775] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1599),
  [9777] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4853),
  [9779] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4763),
  [9781] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4902),
  [9783] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1689),
  [9785] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6306),
  [9787] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1407),
  [9789] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5196),
  [9791] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4798),
  [9793] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4767),
  [9795] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4894),
  [9797] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5144),
  [9799] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5172),
  [9801] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6466),
  [9803] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5114),
  [9805] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4918),
  [9807] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4818),
  [9809] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4750),
  [9811] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4905),
  [9813] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1463),
  [9815] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6294),
  [9817] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1362),
  [9819] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5121),
  [9821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4809),
  [9823] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4753),
  [9825] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4896),
  [9827] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5048),
  [9829] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5043),
  [9831] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6332),
  [9833] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5024),
  [9835] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4868),
  [9837] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5173),
  [9839] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4857),
  [9841] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4757),
  [9843] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4873),
  [9845] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5093),
  [9847] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5070),
  [9849] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6295),
  [9851] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5049),
  [9853] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4898),
  [9855] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4897),
  [9857] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4862),
  [9859] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4789),
  [9861] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4759),
  [9863] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4900),
  [9865] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3341),
  [9867] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6281),
  [9869] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1627),
  [9871] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4851),
  [9873] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4768),
  [9875] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4874),
  [9877] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2504),
  [9879] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6304),
  [9881] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1486),
  [9883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4811),
  [9885] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4765),
  [9887] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4872),
  [9889] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2451),
  [9891] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6289),
  [9893] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1492),
  [9895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4721),
  [9897] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4819),
  [9899] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4755),
  [9901] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4889),
  [9903] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1487),
  [9905] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6326),
  [9907] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1364),
  [9909] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4843),
  [9911] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4762),
  [9913] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4895),
  [9915] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2386),
  [9917] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6315),
  [9919] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1471),
  [9921] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4795),
  [9923] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4764),
  [9925] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4878),
  [9927] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2745),
  [9929] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6284),
  [9931] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1509),
  [9933] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5191),
  [9935] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4801),
  [9937] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4766),
  [9939] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4871),
  [9941] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5135),
  [9943] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5131),
  [9945] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6517),
  [9947] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5083),
  [9949] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4915),
  [9951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5490),
  [9953] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5490),
  [9955] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4792),
  [9957] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4758),
  [9959] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4882),
  [9961] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2743),
  [9963] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6282),
  [9965] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1527),
  [9967] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4794),
  [9969] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6412),
  [9971] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix, 1, 0, 0),
  [9973] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix, 1, 0, 0),
  [9975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4737),
  [9977] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__hq_qualified_symboly_id, 3, 0, 0),
  [9979] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__hq_qualified_symboly_id, 3, 0, 0),
  [9981] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3138),
  [9983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5215),
  [9985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4080),
  [9987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2517),
  [9989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2305),
  [9991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1882),
  [9993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1533),
  [9995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3273),
  [9997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5226),
  [9999] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2873),
  [10001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1772),
  [10003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2767),
  [10005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2353),
  [10007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5214),
  [10009] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__infix, 2, 0, 0),
  [10011] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix, 2, 0, 0),
  [10013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5109),
  [10015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2812),
  [10017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2673),
  [10019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5247),
  [10021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5098),
  [10023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1491),
  [10025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4928),
  [10027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2385),
  [10029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5133),
  [10031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3461),
  [10033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4841),
  [10035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4842),
  [10037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4831),
  [10039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4836),
  [10041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4849),
  [10043] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0),
  [10045] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4754),
  [10048] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5446),
  [10051] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5395),
  [10054] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4975),
  [10057] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4975),
  [10060] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5011),
  [10063] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(6813),
  [10066] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4570),
  [10069] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(6588),
  [10072] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4754),
  [10075] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4945),
  [10078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4854),
  [10080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4814),
  [10082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4845),
  [10084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4826),
  [10086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4824),
  [10088] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_constructor, 2, 0, 26),
  [10090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4754),
  [10092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6813),
  [10094] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4754),
  [10096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4838),
  [10098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4790),
  [10100] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4803),
  [10102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4827),
  [10104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4839),
  [10106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4833),
  [10108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4832),
  [10110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4806),
  [10112] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4769),
  [10115] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5462),
  [10118] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5418),
  [10121] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4969),
  [10124] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4969),
  [10127] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4964),
  [10130] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(7012),
  [10133] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4571),
  [10136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(7022),
  [10139] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4769),
  [10142] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4944),
  [10145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4810),
  [10147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4769),
  [10149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7012),
  [10151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4769),
  [10153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4852),
  [10155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4774),
  [10157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6784),
  [10159] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4774),
  [10161] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4774),
  [10164] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5504),
  [10167] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(5373),
  [10170] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4957),
  [10173] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4957),
  [10176] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4956),
  [10179] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(6784),
  [10182] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4461),
  [10185] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(7011),
  [10188] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4774),
  [10191] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(4942),
  [10194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4855),
  [10196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4848),
  [10198] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4784),
  [10200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4846),
  [10202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5001),
  [10204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5001),
  [10206] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0),
  [10208] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4859),
  [10211] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(5504),
  [10214] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(5373),
  [10217] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4957),
  [10220] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4957),
  [10223] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4956),
  [10226] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(6784),
  [10229] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4461),
  [10232] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(7011),
  [10235] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4859),
  [10238] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_effect_bind_repeat1, 2, 0, 0), SHIFT_REPEAT(4942),
  [10241] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4743),
  [10243] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4863),
  [10245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4867),
  [10247] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4864),
  [10249] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5121),
  [10252] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4809),
  [10255] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4753),
  [10258] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4743),
  [10261] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5048),
  [10264] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5043),
  [10267] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6332),
  [10270] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5024),
  [10273] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4863),
  [10276] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4869),
  [10278] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4893),
  [10280] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4919),
  [10282] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4650),
  [10284] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4859),
  [10286] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4859),
  [10288] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4884),
  [10290] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4921),
  [10292] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4860),
  [10294] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5120),
  [10297] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4847),
  [10300] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4777),
  [10303] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4738),
  [10306] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5023),
  [10309] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5057),
  [10312] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6472),
  [10315] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5026),
  [10318] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4869),
  [10321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4760),
  [10323] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4760),
  [10325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4773),
  [10327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4911),
  [10329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4771),
  [10331] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4747),
  [10333] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4891),
  [10335] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5173),
  [10338] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4857),
  [10341] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4757),
  [10344] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4747),
  [10347] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5093),
  [10350] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5070),
  [10353] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6295),
  [10356] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5049),
  [10359] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4891),
  [10362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4925),
  [10364] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4890),
  [10366] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4724),
  [10368] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4909),
  [10370] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4970),
  [10372] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4970),
  [10374] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1390),
  [10377] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5191),
  [10380] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4801),
  [10383] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4766),
  [10386] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4724),
  [10389] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5135),
  [10392] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5131),
  [10395] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6517),
  [10398] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5083),
  [10401] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4909),
  [10404] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4958),
  [10406] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4958),
  [10408] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4906),
  [10410] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4736),
  [10412] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4922),
  [10414] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4917),
  [10416] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5196),
  [10419] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4798),
  [10422] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4767),
  [10425] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4736),
  [10428] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5144),
  [10431] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5172),
  [10434] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6466),
  [10437] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5114),
  [10440] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4922),
  [10443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4979),
  [10445] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4979),
  [10447] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5330),
  [10449] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4731),
  [10451] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4937),
  [10453] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5239),
  [10456] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4781),
  [10459] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4761),
  [10462] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4741),
  [10465] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5183),
  [10468] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5206),
  [10471] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6349),
  [10474] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5157),
  [10477] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4932),
  [10480] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4741),
  [10482] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4935),
  [10484] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5221),
  [10487] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4794),
  [10490] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4770),
  [10493] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4731),
  [10496] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5138),
  [10499] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5181),
  [10502] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(6412),
  [10505] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(5164),
  [10508] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type2_repeat1, 2, 0, 0), SHIFT_REPEAT(4934),
  [10511] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4932),
  [10513] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1376),
  [10516] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4934),
  [10518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4929),
  [10520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5058),
  [10522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4924),
  [10524] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(4847),
  [10527] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(5023),
  [10530] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 2, 0, 0), SHIFT(6472),
  [10533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4912),
  [10535] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(4847),
  [10538] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(5023),
  [10541] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type2, 1, 0, 0), SHIFT(6472),
  [10544] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4940),
  [10546] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_or_tuple_pattern, 5, 0, 39),
  [10548] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_or_tuple_pattern, 5, 0, 39),
  [10550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4907),
  [10552] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_parenthesized_or_tuple_pattern, 6, 0, 42),
  [10554] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_parenthesized_or_tuple_pattern, 6, 0, 42),
  [10556] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list_pattern, 4, 0, 0),
  [10558] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list_pattern, 4, 0, 0),
  [10560] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effect_pattern, 5, 0, 0),
  [10562] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_effect_pattern, 5, 0, 0),
  [10564] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_var_or_as, 3, 0, 31),
  [10566] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_var_or_as, 3, 0, 31),
  [10568] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list_pattern, 2, 0, 0),
  [10570] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_literal_list_pattern, 3, 0, 0),
  [10572] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_literal_list_pattern, 3, 0, 0),
  [10574] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_rhs, 1, 0, 0),
  [10576] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_rhs, 1, 0, 0),
  [10578] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4742),
  [10580] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_effect_bind_repeat1, 1, 0, 0),
  [10582] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 1, 0, 0), REDUCE(aux_sym_effect_bind_repeat1, 1, 0, 0),
  [10585] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__pattern_constructor_repeat1, 1, 0, 0), REDUCE(aux_sym_effect_bind_repeat1, 1, 0, 0),
  [10588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_constructor_repeat1, 1, 0, 0),
  [10590] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5047),
  [10592] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5046),
  [10594] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6476),
  [10596] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5047),
  [10599] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5046),
  [10602] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6476),
  [10605] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__type_rhs_repeat1, 2, 0, 0),
  [10607] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__type_rhs_repeat1, 2, 0, 0),
  [10609] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ebody, 4, 0, 21),
  [10611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6148),
  [10613] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ebody, 4, 0, 21),
  [10615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5034),
  [10617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5051),
  [10619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5085),
  [10621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5044),
  [10623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5089),
  [10625] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__type_rhs_repeat1, 2, 0, 0), SHIFT_REPEAT(4742),
  [10628] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ebody, 5, 0, 21),
  [10630] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ebody, 5, 0, 21),
  [10632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_rhs, 2, 0, 0),
  [10634] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type_rhs, 2, 0, 0),
  [10636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5037),
  [10638] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__type1, 1, 0, 0), REDUCE(sym_constructor, 3, 0, 33),
  [10641] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__type1, 1, 0, 0),
  [10643] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__type1, 1, 0, 0), REDUCE(sym_constructor, 3, 0, 33),
  [10646] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5055),
  [10648] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5064),
  [10650] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ebody_repeat3, 2, 0, 0),
  [10652] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ebody_repeat3, 2, 0, 0), SHIFT_REPEAT(6148),
  [10655] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ebody_repeat3, 2, 0, 0),
  [10657] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ebody, 3, 0, 21),
  [10659] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ebody, 3, 0, 21),
  [10661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5045),
  [10663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5091),
  [10665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5053),
  [10667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5062),
  [10669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5143),
  [10671] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_constructor, 3, 0, 33),
  [10673] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_constructor, 3, 0, 33),
  [10675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5067),
  [10677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5126),
  [10679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5116),
  [10681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5145),
  [10683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5073),
  [10685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5095),
  [10687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5130),
  [10689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5061),
  [10691] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record, 3, 0, 0),
  [10693] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_record, 3, 0, 0),
  [10695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5128),
  [10697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5142),
  [10699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5149),
  [10701] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_test_watch_expression, 2, 0, 5),
  [10703] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_test_watch_expression, 2, 0, 5),
  [10705] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ebody, 7, 0, 21),
  [10707] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ebody, 7, 0, 21),
  [10709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5171),
  [10711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5179),
  [10713] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__ebody, 6, 0, 21),
  [10715] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__ebody, 6, 0, 21),
  [10717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5158),
  [10719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5190),
  [10721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5165),
  [10723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5182),
  [10725] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_declaration, 3, 0, 0),
  [10727] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_declaration, 3, 0, 0),
  [10729] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effect_declaration, 3, 0, 0),
  [10731] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_effect_declaration, 3, 0, 0),
  [10733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5166),
  [10735] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding, 3, 0, 0),
  [10737] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binding, 3, 0, 0),
  [10739] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_binding, 1, 0, 0),
  [10741] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_binding, 1, 0, 0),
  [10743] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_watch_expression, 2, 0, 5),
  [10745] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_watch_expression, 2, 0, 5),
  [10747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5084),
  [10749] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__watch_expression, 1, 0, 4),
  [10751] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__watch_expression, 1, 0, 4),
  [10753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5159),
  [10755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5176),
  [10757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5151),
  [10759] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effect_declaration, 2, 0, 0),
  [10761] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_effect_declaration, 2, 0, 0),
  [10763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5079),
  [10765] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__watch_expression, 1, 0, 3),
  [10767] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__watch_expression, 1, 0, 3),
  [10769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5134),
  [10771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5147),
  [10773] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__identifier, 1, 0, 0), REDUCE(sym__wordy_definition_name, 1, 0, 0),
  [10776] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5192),
  [10778] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5262),
  [10780] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1383),
  [10783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5204),
  [10785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5263),
  [10787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5174),
  [10789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5200),
  [10791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5207),
  [10793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5222),
  [10795] = {.entry = {.count = 2, .reusable = false}}, REDUCE(sym__identifier, 2, 0, 0), REDUCE(sym__wordy_definition_name, 2, 0, 0),
  [10798] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5209),
  [10800] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5248),
  [10802] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5203),
  [10804] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1393),
  [10807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5160),
  [10809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5180),
  [10811] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1366),
  [10814] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1375),
  [10817] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1379),
  [10820] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1389),
  [10823] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1397),
  [10826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5235),
  [10828] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_signature_colon, 1, 0, 0),
  [10830] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_arrow_symbol, 1, 0, 0),
  [10832] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5245),
  [10834] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5230),
  [10836] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5237),
  [10838] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6981),
  [10840] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 3, 0, 0),
  [10842] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1381),
  [10845] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_forall, 2, 0, 0),
  [10847] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1377),
  [10850] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1293),
  [10852] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_lhs, 1, 0, 2),
  [10854] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5688),
  [10856] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5350),
  [10858] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6805),
  [10860] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1285),
  [10862] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1283),
  [10864] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1276),
  [10866] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1282),
  [10868] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1266),
  [10870] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1279),
  [10872] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1289),
  [10874] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1253),
  [10876] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1297),
  [10878] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1274),
  [10880] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1269),
  [10882] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1264),
  [10884] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1281),
  [10886] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1265),
  [10888] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1386),
  [10891] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__infix_app_or_boolean_op_repeat1, 2, 0, 10), SHIFT_REPEAT(1367),
  [10894] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1295),
  [10896] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1255),
  [10898] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1296),
  [10900] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1263),
  [10902] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1284),
  [10904] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1294),
  [10906] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1259),
  [10908] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1271),
  [10910] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2088),
  [10912] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2089),
  [10914] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6407),
  [10916] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1976),
  [10918] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2212),
  [10920] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3669),
  [10922] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3594),
  [10924] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6501),
  [10926] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3105),
  [10928] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3836),
  [10930] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1964),
  [10932] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1963),
  [10934] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6411),
  [10936] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1924),
  [10938] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2072),
  [10940] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2342),
  [10942] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2339),
  [10944] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6486),
  [10946] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2291),
  [10948] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2620),
  [10950] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2922),
  [10952] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2958),
  [10954] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6448),
  [10956] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2644),
  [10958] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3514),
  [10960] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2739),
  [10962] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2756),
  [10964] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6357),
  [10966] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2482),
  [10968] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3220),
  [10970] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3513),
  [10972] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rewrite_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6231),
  [10975] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_rewrite_type_repeat1, 2, 0, 0),
  [10977] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_rewrite_type_repeat1, 2, 0, 0), SHIFT_REPEAT(5660),
  [10980] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rewrite_type_repeat1, 2, 0, 0), SHIFT_REPEAT(6801),
  [10983] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3111),
  [10985] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2891),
  [10987] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6506),
  [10989] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2803),
  [10991] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3658),
  [10993] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3221),
  [10995] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4715),
  [10997] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5660),
  [10999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6801),
  [11001] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4232),
  [11003] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4162),
  [11005] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6435),
  [11007] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4029),
  [11009] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4481),
  [11011] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3791),
  [11013] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4010),
  [11015] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6451),
  [11017] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3408),
  [11019] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4391),
  [11021] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4495),
  [11023] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2733),
  [11025] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2859),
  [11027] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6319),
  [11029] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2444),
  [11031] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2923),
  [11033] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4068),
  [11035] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3799),
  [11037] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4049),
  [11039] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6426),
  [11041] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3399),
  [11043] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4164),
  [11045] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2071),
  [11047] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4165),
  [11049] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2619),
  [11051] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4329),
  [11053] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3193),
  [11055] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3068),
  [11057] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6408),
  [11059] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2866),
  [11061] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3505),
  [11063] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3503),
  [11065] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2215),
  [11067] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1713),
  [11069] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1764),
  [11071] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6449),
  [11073] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1582),
  [11075] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1828),
  [11077] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1877),
  [11079] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1560),
  [11081] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1577),
  [11083] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6383),
  [11085] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1510),
  [11087] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1754),
  [11089] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3502),
  [11091] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3494),
  [11093] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6256),
  [11095] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3148),
  [11097] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3877),
  [11099] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2924),
  [11101] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3659),
  [11103] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3876),
  [11105] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4350),
  [11107] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4198),
  [11109] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6322),
  [11111] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3797),
  [11113] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4407),
  [11115] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4408),
  [11117] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1751),
  [11119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1250),
  [11121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1249),
  [11123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3809),
  [11125] = {.entry = {.count = 2, .reusable = true}}, REDUCE(sym__value_type, 1, 0, 0), REDUCE(sym__value_type, 2, 0, 0),
  [11128] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_root, 2, 0, 0),
  [11130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4656),
  [11132] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_root_repeat1, 2, 0, 0),
  [11134] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_root_repeat1, 2, 0, 0), SHIFT_REPEAT(4660),
  [11137] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__pattern_root, 1, 0, 0),
  [11139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4660),
  [11141] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5664),
  [11143] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5666),
  [11145] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6305),
  [11147] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6074),
  [11149] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6264),
  [11151] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6265),
  [11153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6655),
  [11155] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_root_repeat1, 2, 0, 0), SHIFT_REPEAT(4701),
  [11158] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4701),
  [11160] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5664),
  [11163] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(5666),
  [11166] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_use_clause_repeat1, 2, 0, 0), SHIFT_REPEAT(6305),
  [11169] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_root_repeat1, 2, 0, 0), SHIFT_REPEAT(4656),
  [11172] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5372),
  [11174] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4367),
  [11176] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5374),
  [11178] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2001),
  [11180] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5397),
  [11182] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4374),
  [11184] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5382),
  [11186] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4960),
  [11188] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1995),
  [11190] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1884),
  [11192] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6441),
  [11194] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6261),
  [11196] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5375),
  [11198] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1861),
  [11200] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4977),
  [11202] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3095),
  [11204] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4961),
  [11206] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3441),
  [11208] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3885),
  [11210] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5381),
  [11212] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3071),
  [11214] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5393),
  [11216] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4280),
  [11218] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5384),
  [11220] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3868),
  [11222] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5383),
  [11224] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3479),
  [11226] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3482),
  [11228] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4629),
  [11230] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2197),
  [11232] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4259),
  [11234] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5390),
  [11236] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4627),
  [11238] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5379),
  [11240] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4973),
  [11242] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5399),
  [11244] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3521),
  [11246] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_literal_text_repeat2, 2, 0, 0), SHIFT_REPEAT(5397),
  [11249] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_literal_text_repeat2, 2, 0, 0),
  [11251] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3475),
  [11253] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5389),
  [11255] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3520),
  [11257] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2737),
  [11259] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3157),
  [11261] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__prefix_definition_name, 3, 0, 0),
  [11263] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_close_parens, 1, 0, 0),
  [11265] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5416),
  [11267] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1654),
  [11269] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5402),
  [11271] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2719),
  [11273] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4486),
  [11275] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2481),
  [11277] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2861),
  [11279] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5391),
  [11281] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2130),
  [11283] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3820),
  [11285] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4968),
  [11287] = {.entry = {.count = 1, .reusable = false}}, SHIFT(1647),
  [11289] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5409),
  [11291] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4476),
  [11293] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5415),
  [11295] = {.entry = {.count = 1, .reusable = false}}, SHIFT(4953),
  [11297] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5413),
  [11299] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3850),
  [11301] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5410),
  [11303] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2452),
  [11305] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5411),
  [11307] = {.entry = {.count = 1, .reusable = false}}, SHIFT(2832),
  [11309] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5403),
  [11311] = {.entry = {.count = 1, .reusable = false}}, SHIFT(3142),
  [11313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6074),
  [11315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5497),
  [11317] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5425),
  [11319] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym_literal_text_repeat1, 2, 0, 0),
  [11321] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym_literal_text_repeat1, 2, 0, 0), SHIFT_REPEAT(5425),
  [11324] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_inline, 3, 0, 0),
  [11326] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5201),
  [11328] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4783),
  [11330] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2768),
  [11332] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5110),
  [11334] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5426),
  [11336] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5450),
  [11338] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5437),
  [11340] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5440),
  [11342] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2337),
  [11344] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5102),
  [11346] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5447),
  [11348] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5448),
  [11350] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5452),
  [11352] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5424),
  [11354] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3459),
  [11356] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5454),
  [11358] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5146),
  [11360] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5457),
  [11362] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1501),
  [11364] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_record_field, 3, 0, 34),
  [11366] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2878),
  [11368] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5256),
  [11370] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5463),
  [11372] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2657),
  [11374] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5468),
  [11376] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2515),
  [11378] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5194),
  [11380] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1530),
  [11382] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2778),
  [11384] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5473),
  [11386] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5471),
  [11388] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2347),
  [11390] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5479),
  [11392] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5212),
  [11394] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1768),
  [11396] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5474),
  [11398] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3190),
  [11400] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3144),
  [11402] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4081),
  [11404] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5487),
  [11406] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2303),
  [11408] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4830),
  [11410] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__effect_inline, 1, 0, 28),
  [11412] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5218),
  [11414] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_inline, 2, 0, 0),
  [11416] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5495),
  [11418] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6955),
  [11420] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5502),
  [11422] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1876),
  [11424] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4910),
  [11426] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5258),
  [11428] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5505),
  [11430] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_signature, 3, 0, 14),
  [11432] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_type_signature, 3, 0, 14),
  [11434] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5507),
  [11436] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1109),
  [11438] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1104),
  [11440] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1991),
  [11442] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5252),
  [11444] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5688),
  [11446] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__symboly_definition_name, 2, 0, 0),
  [11448] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym__symboly_definition_name, 2, 0, 0),
  [11450] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6643),
  [11452] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6291),
  [11454] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__prefix_lhs_repeat1, 2, 0, 16),
  [11456] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__prefix_lhs_repeat1, 2, 0, 16), SHIFT_REPEAT(5688),
  [11459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(973),
  [11461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(969),
  [11463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3643),
  [11465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6020),
  [11467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6417),
  [11469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1141),
  [11471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1140),
  [11473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6522),
  [11475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1019),
  [11477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1018),
  [11479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3664),
  [11481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(838),
  [11483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5558),
  [11485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6150),
  [11487] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ebody_repeat1, 2, 0, 0),
  [11489] = {.entry = {.count = 2, .reusable = false}}, REDUCE(aux_sym__ebody_repeat1, 2, 0, 0), SHIFT_REPEAT(5330),
  [11492] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__wordy_definition_name, 2, 0, 0),
  [11494] = {.entry = {.count = 1, .reusable = true}}, SHIFT(877),
  [11496] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5548),
  [11498] = {.entry = {.count = 1, .reusable = true}}, SHIFT(890),
  [11500] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5546),
  [11502] = {.entry = {.count = 1, .reusable = true}}, SHIFT(885),
  [11504] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5520),
  [11506] = {.entry = {.count = 1, .reusable = true}}, SHIFT(874),
  [11508] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5544),
  [11510] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5220),
  [11512] = {.entry = {.count = 1, .reusable = true}}, SHIFT(833),
  [11514] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5541),
  [11516] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1094),
  [11518] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1095),
  [11520] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3747),
  [11522] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1091),
  [11524] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1092),
  [11526] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3724),
  [11528] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1133),
  [11530] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1134),
  [11532] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7093),
  [11534] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6329),
  [11536] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1059),
  [11538] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1060),
  [11540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4581),
  [11542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1052),
  [11544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1054),
  [11546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4600),
  [11548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5427),
  [11550] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_forall_repeat1, 2, 0, 0),
  [11552] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_forall_repeat1, 2, 0, 0), SHIFT_REPEAT(5688),
  [11555] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1148),
  [11558] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5525),
  [11560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6361),
  [11562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(936),
  [11564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6550),
  [11566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1000),
  [11568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1001),
  [11570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4033),
  [11572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(991),
  [11574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(992),
  [11576] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4074),
  [11578] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_type_repeat1, 2, 0, 0),
  [11580] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1050),
  [11582] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1072),
  [11584] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3785),
  [11586] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5494),
  [11588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_inline, 1, 0, 0),
  [11590] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_close_parens, 1, 0, 0),
  [11592] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_definition_name, 3, 0, 0),
  [11594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1114),
  [11596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1115),
  [11598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2535),
  [11600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(897),
  [11602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6596),
  [11604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6392),
  [11606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(970),
  [11608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(976),
  [11610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1919),
  [11612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1101),
  [11614] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1111),
  [11616] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4079),
  [11618] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1118),
  [11620] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1119),
  [11622] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2510),
  [11624] = {.entry = {.count = 1, .reusable = true}}, SHIFT(867),
  [11626] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1077),
  [11628] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1079),
  [11630] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4094),
  [11632] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__effect_block_repeat1, 2, 0, 40),
  [11634] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1066),
  [11636] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1067),
  [11638] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3200),
  [11640] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1128),
  [11642] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1125),
  [11644] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2042),
  [11646] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_guarded_block_repeat2, 2, 0, 10), SHIFT_REPEAT(1166),
  [11649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1142),
  [11651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1138),
  [11653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3186),
  [11655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(966),
  [11657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(967),
  [11659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1897),
  [11661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(901),
  [11663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6657),
  [11665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(871),
  [11667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(617),
  [11669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1073),
  [11671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(964),
  [11673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4496),
  [11675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(908),
  [11677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6703),
  [11679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(909),
  [11681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6706),
  [11683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(880),
  [11685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1069),
  [11687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1071),
  [11689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4109),
  [11691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1098),
  [11693] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1103),
  [11695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4482),
  [11697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(918),
  [11699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(915),
  [11701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6456),
  [11703] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_fields_inline_repeat1, 2, 0, 0), SHIFT_REPEAT(5834),
  [11706] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_fields_inline_repeat1, 2, 0, 0),
  [11708] = {.entry = {.count = 1, .reusable = true}}, SHIFT(889),
  [11710] = {.entry = {.count = 1, .reusable = true}}, SHIFT(926),
  [11712] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6732),
  [11714] = {.entry = {.count = 1, .reusable = true}}, SHIFT(930),
  [11716] = {.entry = {.count = 1, .reusable = true}}, SHIFT(929),
  [11718] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6434),
  [11720] = {.entry = {.count = 1, .reusable = true}}, SHIFT(933),
  [11722] = {.entry = {.count = 1, .reusable = true}}, SHIFT(932),
  [11724] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6430),
  [11726] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1081),
  [11728] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1080),
  [11730] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3034),
  [11732] = {.entry = {.count = 1, .reusable = true}}, SHIFT(956),
  [11734] = {.entry = {.count = 1, .reusable = true}}, SHIFT(958),
  [11736] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6413),
  [11738] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1049),
  [11740] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1048),
  [11742] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3047),
  [11744] = {.entry = {.count = 1, .reusable = true}}, SHIFT(950),
  [11746] = {.entry = {.count = 1, .reusable = true}}, SHIFT(951),
  [11748] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6397),
  [11750] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__prefix_lhs, 2, 0, 8),
  [11752] = {.entry = {.count = 1, .reusable = true}}, SHIFT(947),
  [11754] = {.entry = {.count = 1, .reusable = true}}, SHIFT(949),
  [11756] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6388),
  [11758] = {.entry = {.count = 1, .reusable = true}}, SHIFT(790),
  [11760] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___layout_block_repeat1, 2, 0, 10), SHIFT_REPEAT(1180),
  [11763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(945),
  [11765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(946),
  [11767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6370),
  [11769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(942),
  [11771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(943),
  [11773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6358),
  [11775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(938),
  [11777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(940),
  [11779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6323),
  [11781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(988),
  [11783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(994),
  [11785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1721),
  [11787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(952),
  [11789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(954),
  [11791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6403),
  [11793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1009),
  [11795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1010),
  [11797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2260),
  [11799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(997),
  [11801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(998),
  [11803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1614),
  [11805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1015),
  [11807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1017),
  [11809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2234),
  [11811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6423),
  [11813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1074),
  [11815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1063),
  [11817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3420),
  [11819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6255),
  [11821] = {.entry = {.count = 1, .reusable = false}}, SHIFT(5519),
  [11823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1028),
  [11825] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1029),
  [11827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4301),
  [11829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1110),
  [11831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1108),
  [11833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3446),
  [11835] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1034),
  [11837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1036),
  [11839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4288),
  [11841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1148),
  [11843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4438),
  [11845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1256),
  [11847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3821),
  [11849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1779),
  [11851] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_use, 1, 0, 0),
  [11853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3973),
  [11855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3972),
  [11857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2475),
  [11859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2474),
  [11861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3971),
  [11863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2473),
  [11865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1790),
  [11867] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type1, 1, 0, 0),
  [11869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1797),
  [11871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1137),
  [11873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3624),
  [11875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5339),
  [11877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1805),
  [11879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1030),
  [11881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3911),
  [11883] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6409),
  [11885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2623),
  [11887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5078),
  [11889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2400),
  [11891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2401),
  [11893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1120),
  [11895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2125),
  [11897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1789),
  [11899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1788),
  [11901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3940),
  [11903] = {.entry = {.count = 1, .reusable = false}}, REDUCE(sym_open_parens, 1, 0, 0),
  [11905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1218),
  [11907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1123),
  [11909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2157),
  [11911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2402),
  [11913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1782),
  [11915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1097),
  [11917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1660),
  [11919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1026),
  [11921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3883),
  [11923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2757),
  [11925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3477),
  [11927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5885),
  [11929] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_constructor, 1, 0, 0),
  [11931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3452),
  [11933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1762),
  [11935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1761),
  [11937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1760),
  [11939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(961),
  [11941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3345),
  [11943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3939),
  [11945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3938),
  [11947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1139),
  [11949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3627),
  [11951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1022),
  [11953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3878),
  [11955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(960),
  [11957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3630),
  [11959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1710),
  [11961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1708),
  [11963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1609),
  [11965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3448),
  [11967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2419),
  [11969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1136),
  [11971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3633),
  [11973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1016),
  [11975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3858),
  [11977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1014),
  [11979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3854),
  [11981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1677),
  [11983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5105),
  [11985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3995),
  [11987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3410),
  [11989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1013),
  [11991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3830),
  [11993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1011),
  [11995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5101),
  [11997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5106),
  [11999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1100),
  [12001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2148),
  [12003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3996),
  [12005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3924),
  [12007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(278),
  [12009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3997),
  [12011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6488),
  [12013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3104),
  [12015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(211),
  [12017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(286),
  [12019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3918),
  [12021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3241),
  [12023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(269),
  [12025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3904),
  [12027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3334),
  [12029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(259),
  [12031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3471),
  [12033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(231),
  [12035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4644),
  [12037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4967),
  [12039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3260),
  [12041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(217),
  [12043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1212),
  [12045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(223),
  [12047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3267),
  [12049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1044),
  [12051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1698),
  [12053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3271),
  [12055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(996),
  [12057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3916),
  [12059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1124),
  [12061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2235),
  [12063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2387),
  [12065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1198),
  [12067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3326),
  [12069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(227),
  [12071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1207),
  [12073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1006),
  [12075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5108),
  [12077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(239),
  [12079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3287),
  [12081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3288),
  [12083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1126),
  [12085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2230),
  [12087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1206),
  [12089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5077),
  [12091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4154),
  [12093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3293),
  [12095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(262),
  [12097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(980),
  [12099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3790),
  [12101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2319),
  [12103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1209),
  [12105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(280),
  [12107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1199),
  [12109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3310),
  [12111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3311),
  [12113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3312),
  [12115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(296),
  [12117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1208),
  [12119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2093),
  [12121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(294),
  [12123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(977),
  [12125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3789),
  [12127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1216),
  [12129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3231),
  [12131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3219),
  [12133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3215),
  [12135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3422),
  [12137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3423),
  [12139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1058),
  [12141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1684),
  [12143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(975),
  [12145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3810),
  [12147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(972),
  [12149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3811),
  [12151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3187),
  [12153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3425),
  [12155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1065),
  [12157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1681),
  [12159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(288),
  [12161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(971),
  [12163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3829),
  [12165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1200),
  [12167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4950),
  [12169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3886),
  [12171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4019),
  [12173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2613),
  [12175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1127),
  [12177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2208),
  [12179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3668),
  [12181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(995),
  [12183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5074),
  [12185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2281),
  [12187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3468),
  [12189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4138),
  [12191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4137),
  [12193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4410),
  [12195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2232),
  [12197] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1130),
  [12199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3621),
  [12201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1008),
  [12203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3358),
  [12205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3469),
  [12207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3470),
  [12209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2579),
  [12211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(275),
  [12213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1205),
  [12215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4414),
  [12217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3354),
  [12219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6895),
  [12221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4136),
  [12223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4416),
  [12225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2502),
  [12227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4419),
  [12229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1055),
  [12231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3045),
  [12233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6856),
  [12235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3460),
  [12237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(963),
  [12239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3333),
  [12241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(982),
  [12243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5125),
  [12245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(981),
  [12247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5129),
  [12249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6832),
  [12251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3501),
  [12253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4426),
  [12255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4427),
  [12257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(979),
  [12259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5092),
  [12261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6794),
  [12263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3674),
  [12265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3682),
  [12267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4429),
  [12269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3685),
  [12271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1084),
  [12273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3021),
  [12275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3480),
  [12277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6737),
  [12279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1117),
  [12281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2972),
  [12283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2516),
  [12285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4437),
  [12287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6663),
  [12289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4439),
  [12291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(962),
  [12293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3337),
  [12295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2505),
  [12297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(232),
  [12299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6551),
  [12301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1099),
  [12303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3006),
  [12305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4449),
  [12307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4450),
  [12309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4451),
  [12311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1783),
  [12313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4124),
  [12315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4123),
  [12317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1131),
  [12319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2999),
  [12321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1132),
  [12323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2997),
  [12325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4465),
  [12327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2506),
  [12329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1135),
  [12331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2986),
  [12333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4122),
  [12335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6573),
  [12337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3329),
  [12339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2092),
  [12341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3324),
  [12343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3699),
  [12345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3323),
  [12347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3700),
  [12349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3702),
  [12351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1113),
  [12353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2927),
  [12355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6638),
  [12357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2540),
  [12359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2901),
  [12361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6016),
  [12363] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_constructor, 2, 0, 0),
  [12365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1298),
  [12367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6650),
  [12369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1752),
  [12371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6670),
  [12373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2304),
  [12375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2854),
  [12377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3713),
  [12379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2896),
  [12381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3347),
  [12383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2914),
  [12385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1068),
  [12387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1652),
  [12389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2938),
  [12391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1023),
  [12393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2070),
  [12395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4110),
  [12397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5150),
  [12399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3351),
  [12401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3715),
  [12403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3716),
  [12405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1112),
  [12407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3616),
  [12409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3363),
  [12411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1107),
  [12413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3127),
  [12415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2953),
  [12417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2954),
  [12419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2547),
  [12421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6716),
  [12423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4107),
  [12425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3733),
  [12427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2955),
  [12429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6739),
  [12431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(959),
  [12433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2077),
  [12435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5154),
  [12437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3734),
  [12439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3736),
  [12441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6761),
  [12443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2992),
  [12445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2993),
  [12447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2994),
  [12449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2552),
  [12451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4487),
  [12453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1129),
  [12455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5891),
  [12457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(978),
  [12459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2039),
  [12461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1106),
  [12463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3155),
  [12465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3057),
  [12467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3059),
  [12469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3064),
  [12471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5250),
  [12473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1012),
  [12475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2102),
  [12477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1056),
  [12479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2101),
  [12481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3110),
  [12483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1105),
  [12485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3170),
  [12487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6825),
  [12489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3757),
  [12491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1090),
  [12493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2062),
  [12495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6854),
  [12497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2558),
  [12499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(965),
  [12501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3376),
  [12503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4106),
  [12505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6893),
  [12507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4491),
  [12509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4493),
  [12511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1102),
  [12513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3306),
  [12515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3384),
  [12517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4500),
  [12519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6692),
  [12521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7015),
  [12523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2144),
  [12525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7024),
  [12527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2149),
  [12529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(985),
  [12531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2408),
  [12533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2178),
  [12535] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__pattern_rhs_repeat1, 2, 0, 0), SHIFT_REPEAT(6488),
  [12538] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__pattern_rhs_repeat1, 2, 0, 0),
  [12540] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7045),
  [12542] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1078),
  [12544] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4331),
  [12546] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2111),
  [12548] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1490),
  [12550] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3386),
  [12552] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2596),
  [12554] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5259),
  [12556] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4507),
  [12558] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3387),
  [12560] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6765),
  [12562] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2875),
  [12564] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4508),
  [12566] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2128),
  [12568] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1064),
  [12570] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4393),
  [12572] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1505),
  [12574] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6687),
  [12576] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__effect_block_repeat1, 2, 0, 0), SHIFT_REPEAT(4830),
  [12579] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__effect_block_repeat1, 2, 0, 0),
  [12581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1076),
  [12583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1646),
  [12585] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_fields_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5583),
  [12588] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__record_fields_block_repeat1, 2, 0, 0),
  [12590] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1038),
  [12592] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4388),
  [12594] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4965),
  [12596] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2238),
  [12598] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6763),
  [12600] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1005),
  [12602] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4378),
  [12604] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1007),
  [12606] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4377),
  [12608] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4516),
  [12610] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6202),
  [12612] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5068),
  [12614] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__ebody_repeat2, 2, 0, 0), SHIFT_REPEAT(6202),
  [12617] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__ebody_repeat2, 2, 0, 0),
  [12619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1075),
  [12621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4370),
  [12623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5253),
  [12625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4096),
  [12627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4092),
  [12629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(968),
  [12631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3401),
  [12633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1020),
  [12635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1818),
  [12637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5243),
  [12639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2117),
  [12641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3411),
  [12643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4526),
  [12645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4527),
  [12647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5670),
  [12649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1096),
  [12651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5928),
  [12653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2121),
  [12655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1037),
  [12657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5935),
  [12659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1004),
  [12661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4332),
  [12663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4086),
  [12665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2659),
  [12667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1122),
  [12669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6135),
  [12671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7083),
  [12673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4528),
  [12675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6937),
  [12677] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_type_constructor_repeat1, 2, 0, 0), SHIFT_REPEAT(6016),
  [12680] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_type_constructor_repeat1, 2, 0, 0),
  [12682] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3426),
  [12684] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1021),
  [12686] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4325),
  [12688] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2682),
  [12690] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6748),
  [12692] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1088),
  [12694] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3558),
  [12696] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1025),
  [12698] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4321),
  [12700] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4959),
  [12702] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3676),
  [12704] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_parenthesized_or_tuple_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(4646),
  [12707] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_or_tuple_pattern_repeat1, 2, 0, 0),
  [12709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1027),
  [12711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4317),
  [12713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1116),
  [12715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4316),
  [12717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4339),
  [12719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1070),
  [12721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3582),
  [12723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3430),
  [12725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1032),
  [12727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4309),
  [12729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1053),
  [12731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1845),
  [12733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2015),
  [12735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6662),
  [12737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4926),
  [12739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6676),
  [12741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5561),
  [12743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6728),
  [12745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4542),
  [12747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4543),
  [12749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4544),
  [12751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1912),
  [12753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3719),
  [12755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(993),
  [12757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3577),
  [12759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1039),
  [12761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4609),
  [12763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1061),
  [12765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1872),
  [12767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2789),
  [12769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3455),
  [12771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7049),
  [12773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1062),
  [12775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1873),
  [12777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4555),
  [12779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6999),
  [12781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1040),
  [12783] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4611),
  [12785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2874),
  [12787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(974),
  [12789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3574),
  [12791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1082),
  [12793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1892),
  [12795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1042),
  [12797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4615),
  [12799] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6699),
  [12801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4188),
  [12803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1045),
  [12805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4618),
  [12807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1046),
  [12809] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4619),
  [12811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(989),
  [12813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1900),
  [12815] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_literal_list_pattern_repeat1, 2, 0, 0), SHIFT_REPEAT(4644),
  [12818] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_list_pattern_repeat1, 2, 0, 0),
  [12820] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2033),
  [12822] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1047),
  [12824] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4623),
  [12826] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2034),
  [12828] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7046),
  [12830] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6743),
  [12832] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_repeat1, 2, 0, 10), SHIFT_REPEAT(1256),
  [12835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_repeat1, 2, 0, 10),
  [12837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4319),
  [12839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4140),
  [12841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7033),
  [12843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(983),
  [12845] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2423),
  [12847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2132),
  [12849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4304),
  [12851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2352),
  [12853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1893),
  [12855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1093),
  [12857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4563),
  [12859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2134),
  [12861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2355),
  [12863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6779),
  [12865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1880),
  [12867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2223),
  [12869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2229),
  [12871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1002),
  [12873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3569),
  [12875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7096),
  [12877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2051),
  [12879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(986),
  [12881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2407),
  [12883] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__effect_inline, 2, 0, 28),
  [12885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3301),
  [12887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1841),
  [12889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1771),
  [12891] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1838),
  [12893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4276),
  [12895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1837),
  [12897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1776),
  [12899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7104),
  [12901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7014),
  [12903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2095),
  [12905] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym__record_fields_inline_repeat1, 2, 0, 0), SHIFT_REPEAT(5981),
  [12908] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4267),
  [12910] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2094),
  [12912] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_repeat1, 2, 0, 10), SHIFT_REPEAT(1298),
  [12915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2031),
  [12917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2919),
  [12919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3227),
  [12921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(987),
  [12923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2404),
  [12925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6701),
  [12927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5583),
  [12929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6572),
  [12931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3269),
  [12933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4266),
  [12935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4646),
  [12937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7094),
  [12939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6647),
  [12941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6579),
  [12943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3834),
  [12945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3284),
  [12947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3838),
  [12949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1083),
  [12951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4512),
  [12953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3139),
  [12955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1949),
  [12957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6804),
  [12959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3134),
  [12961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1089),
  [12963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4558),
  [12965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2258),
  [12967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3845),
  [12969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6906),
  [12971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1915),
  [12973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4235),
  [12975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4077),
  [12977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1916),
  [12979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1121),
  [12981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6212),
  [12983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4060),
  [12985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7017),
  [12987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1057),
  [12989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5570),
  [12991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1896),
  [12993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5211),
  [12995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2052),
  [12997] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_type_repeat1, 2, 0, 0), SHIFT_REPEAT(4783),
  [13000] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4985),
  [13002] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6989),
  [13004] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3888),
  [13006] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3889),
  [13008] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1085),
  [13010] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4521),
  [13012] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6968),
  [13014] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4923),
  [13016] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6916),
  [13018] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1985),
  [13020] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3891),
  [13022] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1051),
  [13024] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5589),
  [13026] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6884),
  [13028] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5186),
  [13030] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6857),
  [13032] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6405),
  [13034] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4231),
  [13036] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5585),
  [13038] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6604),
  [13040] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3927),
  [13042] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6536),
  [13044] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3928),
  [13046] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6549),
  [13048] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3931),
  [13050] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6566),
  [13052] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4230),
  [13054] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3711),
  [13056] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6590),
  [13058] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4229),
  [13060] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6262),
  [13062] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1043),
  [13064] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5592),
  [13066] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3960),
  [13068] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5217),
  [13070] = {.entry = {.count = 1, .reusable = true}}, SHIFT(990),
  [13072] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2427),
  [13074] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3965),
  [13076] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5080),
  [13078] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3966),
  [13080] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1945),
  [13082] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1086),
  [13084] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4529),
  [13086] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1954),
  [13088] = {.entry = {.count = 1, .reusable = true}}, SHIFT(293),
  [13090] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1955),
  [13092] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3694),
  [13094] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1035),
  [13096] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5594),
  [13098] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6858),
  [13100] = {.entry = {.count = 1, .reusable = false}}, SHIFT(6477),
  [13102] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1033),
  [13104] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5595),
  [13106] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5189),
  [13108] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3994),
  [13110] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1031),
  [13112] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5598),
  [13114] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6845),
  [13116] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1538),
  [13118] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1003),
  [13120] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3565),
  [13122] = {.entry = {.count = 1, .reusable = true}}, SHIFT(984),
  [13124] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6007),
  [13126] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2239),
  [13128] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2250),
  [13130] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1087),
  [13132] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4531),
  [13134] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6803),
  [13136] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___block_repeat2, 2, 0, 10), SHIFT_REPEAT(1160),
  [13139] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___block_repeat2, 2, 0, 10),
  [13141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6798),
  [13143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2265),
  [13145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5004),
  [13147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1951),
  [13149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1888),
  [13151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6766),
  [13153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4214),
  [13155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6546),
  [13157] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym_rewrite_block_repeat1, 2, 0, 0), SHIFT_REPEAT(5339),
  [13160] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_rewrite_block_repeat1, 2, 0, 0),
  [13162] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1905),
  [13164] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1908),
  [13166] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4213),
  [13168] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5082),
  [13170] = {.entry = {.count = 1, .reusable = true}}, SHIFT(999),
  [13172] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2436),
  [13174] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1879),
  [13176] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4211),
  [13178] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1532),
  [13180] = {.entry = {.count = 1, .reusable = true}}, SHIFT(648),
  [13182] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5359),
  [13184] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5380),
  [13186] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3053),
  [13188] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4642),
  [13190] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6897),
  [13192] = {.entry = {.count = 1, .reusable = true}}, SHIFT(623),
  [13194] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1535),
  [13196] = {.entry = {.count = 1, .reusable = true}}, SHIFT(641),
  [13198] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___block_repeat2, 2, 0, 5),
  [13200] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1360),
  [13202] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3464),
  [13204] = {.entry = {.count = 2, .reusable = true}}, REDUCE(aux_sym___block_repeat1, 2, 0, 0), SHIFT_REPEAT(6003),
  [13207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4876),
  [13209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6363),
  [13211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5628),
  [13213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2585),
  [13215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6467),
  [13217] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_type_name, 1, 0, 0),
  [13219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2267),
  [13221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6060),
  [13223] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 9, 0, 46),
  [13225] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 11, 0, 49),
  [13227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(621),
  [13229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(633),
  [13231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(654),
  [13233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(655),
  [13235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(657),
  [13237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(658),
  [13239] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 10, 0, 47),
  [13241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3344),
  [13243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2741),
  [13245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6629),
  [13247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2744),
  [13249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1555),
  [13251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(660),
  [13253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2270),
  [13255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(668),
  [13257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2449),
  [13259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6685),
  [13261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6982),
  [13263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2453),
  [13265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1472),
  [13267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5069),
  [13269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3066),
  [13271] = {.entry = {.count = 1, .reusable = true}}, SHIFT(686),
  [13273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(690),
  [13275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2276),
  [13277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(860),
  [13279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2493),
  [13281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(861),
  [13283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6656),
  [13285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6971),
  [13287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2503),
  [13289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5551),
  [13291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1711),
  [13293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(697),
  [13295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(699),
  [13297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6627),
  [13299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6960),
  [13301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(708),
  [13303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(711),
  [13305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2390),
  [13307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6598),
  [13309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6948),
  [13311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2219),
  [13313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1488),
  [13315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2855),
  [13317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(727),
  [13319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4204),
  [13321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(729),
  [13323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6578),
  [13325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6936),
  [13327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1482),
  [13329] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 10, 0, 48),
  [13331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(738),
  [13333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(741),
  [13335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5052),
  [13337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6557),
  [13339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6924),
  [13341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(716),
  [13343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(683),
  [13345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(753),
  [13347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(755),
  [13349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6535),
  [13351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6911),
  [13353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2813),
  [13355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(825),
  [13357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(764),
  [13359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(766),
  [13361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5202),
  [13363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6626),
  [13365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6898),
  [13367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(774),
  [13369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(776),
  [13371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6723),
  [13373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6885),
  [13375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2795),
  [13377] = {.entry = {.count = 1, .reusable = true}}, SHIFT(791),
  [13379] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_tuple_or_parenthesized_repeat1, 2, 0, 5),
  [13381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(870),
  [13383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(627),
  [13385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6783),
  [13387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6872),
  [13389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(639),
  [13391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(803),
  [13393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(805),
  [13395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6830),
  [13397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6859),
  [13399] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 9, 0, 41),
  [13401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5162),
  [13403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5198),
  [13405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(813),
  [13407] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_case, 2, 0, 5),
  [13409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2724),
  [13411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(816),
  [13413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6877),
  [13415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6846),
  [13417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1579),
  [13419] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_term, 2, 0, 5),
  [13421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(831),
  [13423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(835),
  [13425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6931),
  [13427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6833),
  [13429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(851),
  [13431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(636),
  [13433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(640),
  [13435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(856),
  [13437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6980),
  [13439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6818),
  [13441] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 8, 0, 36),
  [13443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5584),
  [13445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2122),
  [13447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3032),
  [13449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5406),
  [13451] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym__prefix_lhs_repeat1, 1, 0, 7),
  [13453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1977),
  [13455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5054),
  [13457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(886),
  [13459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(888),
  [13461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(891),
  [13463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2315),
  [13465] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 8, 0, 35),
  [13467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(866),
  [13469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7080),
  [13471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6781),
  [13473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4056),
  [13475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(869),
  [13477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(879),
  [13479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(763),
  [13481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(761),
  [13483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4153),
  [13485] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guarded_block, 7, 0, 29),
  [13487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(756),
  [13489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(726),
  [13491] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_type, 8, 0, 45),
  [13493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(696),
  [13495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(691),
  [13497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2917),
  [13499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1758),
  [13501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4018),
  [13503] = {.entry = {.count = 1, .reusable = true}}, SHIFT(682),
  [13505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(663),
  [13507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(659),
  [13509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(857),
  [13511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(688),
  [13513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(855),
  [13515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1956),
  [13517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(854),
  [13519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(850),
  [13521] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_literal_list_pattern_repeat1, 2, 0, 38),
  [13523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5169),
  [13525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3596),
  [13527] = {.entry = {.count = 1, .reusable = false}}, REDUCE(aux_sym__ebody_repeat1, 1, 0, 13),
  [13529] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_rewrite_type, 6, 0, 0),
  [13531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5050),
  [13533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(649),
  [13535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(747),
  [13537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kw_forall, 1, 0, 0),
  [13539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5059),
  [13541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6455),
  [13543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(620),
  [13545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(622),
  [13547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3774),
  [13549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__rewrite_term_like, 4, 0, 43),
  [13551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1743),
  [13553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2326),
  [13555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(815),
  [13557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(807),
  [13559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2217),
  [13561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(661),
  [13563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2545),
  [13565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(667),
  [13567] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym_parenthesized_or_tuple_pattern_repeat1, 2, 0, 38),
  [13569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(736),
  [13571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(734),
  [13573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4653),
  [13575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3600),
  [13577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2600),
  [13579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2908),
  [13581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2361),
  [13583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2963),
  [13585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(865),
  [13587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(703),
  [13589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2491),
  [13591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(701),
  [13593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6750),
  [13595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6745),
  [13597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(823),
  [13599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(772),
  [13601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5137),
  [13603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(769),
  [13605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(923),
  [13607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(583),
  [13609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4955),
  [13611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1313),
  [13613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4786),
  [13615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(955),
  [13617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(953),
  [13619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6597),
  [13621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5056),
  [13623] = {.entry = {.count = 1, .reusable = true}}, SHIFT(587),
  [13625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2334),
  [13627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(916),
  [13629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4300),
  [13631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5227),
  [13633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3433),
  [13635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4293),
  [13637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(589),
  [13639] = {.entry = {.count = 1, .reusable = true}}, SHIFT(758),
  [13641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4261),
  [13643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(590),
  [13645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4949),
  [13647] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1331),
  [13649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4683),
  [13651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4954),
  [13653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2687),
  [13655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6762),
  [13657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2684),
  [13659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6628),
  [13661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(593),
  [13663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4327),
  [13665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4237),
  [13667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4085),
  [13669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4221),
  [13671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(902),
  [13673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(594),
  [13675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(725),
  [13677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4219),
  [13679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(595),
  [13681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4517),
  [13683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1316),
  [13685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5240),
  [13687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1450),
  [13689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2785),
  [13691] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6601),
  [13693] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_block, 4, 0, 0),
  [13695] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1477),
  [13697] = {.entry = {.count = 1, .reusable = true}}, SHIFT(598),
  [13699] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1479),
  [13701] = {.entry = {.count = 1, .reusable = true}}, SHIFT(544),
  [13703] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2241),
  [13705] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4186),
  [13707] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3396),
  [13709] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3164),
  [13711] = {.entry = {.count = 1, .reusable = true}}, SHIFT(834),
  [13713] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4185),
  [13715] = {.entry = {.count = 1, .reusable = true}}, SHIFT(605),
  [13717] = {.entry = {.count = 1, .reusable = true}}, SHIFT(685),
  [13719] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4178),
  [13721] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4176),
  [13723] = {.entry = {.count = 1, .reusable = true}}, SHIFT(607),
  [13725] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4172),
  [13727] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1310),
  [13729] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4501),
  [13731] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4302),
  [13733] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2668),
  [13735] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7044),
  [13737] = {.entry = {.count = 1, .reusable = true}}, SHIFT(608),
  [13739] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2335),
  [13741] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4169),
  [13743] = {.entry = {.count = 1, .reusable = true}}, SHIFT(907),
  [13745] = {.entry = {.count = 1, .reusable = true}}, SHIFT(925),
  [13747] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2902),
  [13749] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4168),
  [13751] = {.entry = {.count = 1, .reusable = true}}, SHIFT(571),
  [13753] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4951),
  [13755] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4376),
  [13757] = {.entry = {.count = 1, .reusable = true}}, SHIFT(613),
  [13759] = {.entry = {.count = 1, .reusable = true}}, SHIFT(652),
  [13761] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4127),
  [13763] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2156),
  [13765] = {.entry = {.count = 1, .reusable = true}}, SHIFT(615),
  [13767] = {.entry = {.count = 1, .reusable = true}}, SHIFT(798),
  [13769] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1325),
  [13771] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2110),
  [13773] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2559),
  [13775] = {.entry = {.count = 1, .reusable = true}}, SHIFT(535),
  [13777] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2287),
  [13779] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4384),
  [13781] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6890),
  [13783] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__infix_lhs, 3, 0, 15),
  [13785] = {.entry = {.count = 1, .reusable = true}}, SHIFT(914),
  [13787] = {.entry = {.count = 1, .reusable = true}}, SHIFT(616),
  [13789] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6471),
  [13791] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4490),
  [13793] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4385),
  [13795] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4103),
  [13797] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4684),
  [13799] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kw_else, 1, 0, 0),
  [13801] = {.entry = {.count = 1, .reusable = true}}, SHIFT(944),
  [13803] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4102),
  [13805] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2822),
  [13807] = {.entry = {.count = 1, .reusable = true}}, SHIFT(572),
  [13809] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1, 0, 4),
  [13811] = {.entry = {.count = 1, .reusable = true}}, SHIFT(604),
  [13813] = {.entry = {.count = 1, .reusable = true}}, SHIFT(848),
  [13815] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4090),
  [13817] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5132),
  [13819] = {.entry = {.count = 1, .reusable = true}}, SHIFT(614),
  [13821] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5251),
  [13823] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1312),
  [13825] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_arrow_symbol, 1, 0, 0),
  [13827] = {.entry = {.count = 1, .reusable = true}}, SHIFT(569),
  [13829] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2881),
  [13831] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2525),
  [13833] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3375),
  [13835] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effect_bind, 4, 0, 0),
  [13837] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6759),
  [13839] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2960),
  [13841] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5148),
  [13843] = {.entry = {.count = 1, .reusable = true}}, SHIFT(602),
  [13845] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_guard, 1, 0, 0),
  [13847] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6800),
  [13849] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4089),
  [13851] = {.entry = {.count = 1, .reusable = true}}, SHIFT(904),
  [13853] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4087),
  [13855] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6700),
  [13857] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2566),
  [13859] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2883),
  [13861] = {.entry = {.count = 1, .reusable = true}}, SHIFT(585),
  [13863] = {.entry = {.count = 1, .reusable = true}}, SHIFT(799),
  [13865] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4239),
  [13867] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4330),
  [13869] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2842),
  [13871] = {.entry = {.count = 1, .reusable = true}}, SHIFT(574),
  [13873] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2942),
  [13875] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1322),
  [13877] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4978),
  [13879] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6721),
  [13881] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2895),
  [13883] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3703),
  [13885] = {.entry = {.count = 1, .reusable = true}}, SHIFT(563),
  [13887] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6668),
  [13889] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2541),
  [13891] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_lhs, 3, 0, 0),
  [13893] = {.entry = {.count = 1, .reusable = true}}, SHIFT(565),
  [13895] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1302),
  [13897] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4141),
  [13899] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2853),
  [13901] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4111),
  [13903] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2484),
  [13905] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4142),
  [13907] = {.entry = {.count = 1, .reusable = true}}, SHIFT(564),
  [13909] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2203),
  [13911] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2264),
  [13913] = {.entry = {.count = 1, .reusable = true}}, SHIFT(540),
  [13915] = {.entry = {.count = 1, .reusable = true}}, SHIFT(868),
  [13917] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4240),
  [13919] = {.entry = {.count = 1, .reusable = true}}, SHIFT(839),
  [13921] = {.entry = {.count = 1, .reusable = true}}, SHIFT(534),
  [13923] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1308),
  [13925] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2530),
  [13927] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1973),
  [13929] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5225),
  [13931] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6592),
  [13933] = {.entry = {.count = 1, .reusable = true}}, SHIFT(526),
  [13935] = {.entry = {.count = 1, .reusable = true}}, SHIFT(920),
  [13937] = {.entry = {.count = 1, .reusable = true}}, SHIFT(548),
  [13939] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6576),
  [13941] = {.entry = {.count = 1, .reusable = true}}, SHIFT(630),
  [13943] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6443),
  [13945] = {.entry = {.count = 1, .reusable = true}}, SHIFT(550),
  [13947] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1330),
  [13949] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4258),
  [13951] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3499),
  [13953] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6556),
  [13955] = {.entry = {.count = 1, .reusable = true}}, SHIFT(561),
  [13957] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1994),
  [13959] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4241),
  [13961] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2366),
  [13963] = {.entry = {.count = 1, .reusable = true}}, SHIFT(596),
  [13965] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1305),
  [13967] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3689),
  [13969] = {.entry = {.count = 1, .reusable = true}}, SHIFT(552),
  [13971] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6632),
  [13973] = {.entry = {.count = 1, .reusable = true}}, SHIFT(536),
  [13975] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2282),
  [13977] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6785),
  [13979] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2356),
  [13981] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2359),
  [13983] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1300),
  [13985] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4430),
  [13987] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4914),
  [13989] = {.entry = {.count = 1, .reusable = true}}, SHIFT(570),
  [13991] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3481),
  [13993] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1521),
  [13995] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1318),
  [13997] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7082),
  [13999] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1306),
  [14001] = {.entry = {.count = 1, .reusable = true}}, SHIFT(533),
  [14003] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4297),
  [14005] = {.entry = {.count = 1, .reusable = true}}, SHIFT(567),
  [14007] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4174),
  [14009] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4218),
  [14011] = {.entry = {.count = 1, .reusable = true}}, SHIFT(887),
  [14013] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1998),
  [14015] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1309),
  [14017] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3673),
  [14019] = {.entry = {.count = 1, .reusable = true}}, SHIFT(525),
  [14021] = {.entry = {.count = 1, .reusable = true}}, SHIFT(521),
  [14023] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1556),
  [14025] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1317),
  [14027] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4421),
  [14029] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2712),
  [14031] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4097),
  [14033] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1320),
  [14035] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2839),
  [14037] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4971),
  [14039] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1321),
  [14041] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1323),
  [14043] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1326),
  [14045] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6993),
  [14047] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4413),
  [14049] = {.entry = {.count = 1, .reusable = true}}, SHIFT(773),
  [14051] = {.entry = {.count = 1, .reusable = true}}, SHIFT(789),
  [14053] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5367),
  [14055] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4180),
  [14057] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7026),
  [14059] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2307),
  [14061] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2108),
  [14063] = {.entry = {.count = 1, .reusable = true}}, SHIFT(523),
  [14065] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7085),
  [14067] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4952),
  [14069] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4179),
  [14071] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4648),
  [14073] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5168),
  [14075] = {.entry = {.count = 1, .reusable = true}}, SHIFT(896),
  [14077] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1796),
  [14079] = {.entry = {.count = 1, .reusable = true}}, SHIFT(537),
  [14081] = {.entry = {.count = 1, .reusable = true}}, SHIFT(530),
  [14083] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1314),
  [14085] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7016),
  [14087] = {.entry = {.count = 1, .reusable = true}}, SHIFT(939),
  [14089] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1780),
  [14091] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2240),
  [14093] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2244),
  [14095] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5072),
  [14097] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5528),
  [14099] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1606),
  [14101] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5005),
  [14103] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5197),
  [14105] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5515),
  [14107] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1446),
  [14109] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1299),
  [14111] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1213),
  [14113] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7004),
  [14115] = {.entry = {.count = 1, .reusable = true}}, SHIFT(542),
  [14117] = {.entry = {.count = 1, .reusable = true}}, SHIFT(863),
  [14119] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5354),
  [14121] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4645),
  [14123] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6984),
  [14125] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4104),
  [14127] = {.entry = {.count = 1, .reusable = true}}, SHIFT(653),
  [14129] = {.entry = {.count = 1, .reusable = true}}, SHIFT(547),
  [14131] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6973),
  [14133] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4088),
  [14135] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1215),
  [14137] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6957),
  [14139] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2382),
  [14141] = {.entry = {.count = 1, .reusable = true}}, SHIFT(844),
  [14143] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5349),
  [14145] = {.entry = {.count = 1, .reusable = true}}, SHIFT(549),
  [14147] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6935),
  [14149] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4084),
  [14151] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3258),
  [14153] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3257),
  [14155] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6921),
  [14157] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1537),
  [14159] = {.entry = {.count = 1, .reusable = true}}, SHIFT(551),
  [14161] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6903),
  [14163] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6677),
  [14165] = {.entry = {.count = 1, .reusable = true}}, SHIFT(821),
  [14167] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5343),
  [14169] = {.entry = {.count = 1, .reusable = true}}, SHIFT(924),
  [14171] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6883),
  [14173] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6580),
  [14175] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3338),
  [14177] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6871),
  [14179] = {.entry = {.count = 1, .reusable = true}}, SHIFT(900),
  [14181] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3833),
  [14183] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6729),
  [14185] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1329),
  [14187] = {.entry = {.count = 1, .reusable = true}}, SHIFT(811),
  [14189] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5334),
  [14191] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3296),
  [14193] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6835),
  [14195] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3121),
  [14197] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_block, 3, 0, 0),
  [14199] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3395),
  [14201] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6819),
  [14203] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7109),
  [14205] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4151),
  [14207] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6810),
  [14209] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2331),
  [14211] = {.entry = {.count = 1, .reusable = true}}, SHIFT(801),
  [14213] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5333),
  [14215] = {.entry = {.count = 1, .reusable = true}}, SHIFT(625),
  [14217] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6788),
  [14219] = {.entry = {.count = 1, .reusable = true}}, SHIFT(553),
  [14221] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4159),
  [14223] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6776),
  [14225] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3130),
  [14227] = {.entry = {.count = 1, .reusable = true}}, SHIFT(555),
  [14229] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1204),
  [14231] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6747),
  [14233] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4166),
  [14235] = {.entry = {.count = 1, .reusable = true}}, SHIFT(783),
  [14237] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5351),
  [14239] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5115),
  [14241] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6617),
  [14243] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2542),
  [14245] = {.entry = {.count = 1, .reusable = true}}, SHIFT(566),
  [14247] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4920),
  [14249] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6715),
  [14251] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7008),
  [14253] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4059),
  [14255] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6690),
  [14257] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3786),
  [14259] = {.entry = {.count = 1, .reusable = true}}, SHIFT(771),
  [14261] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5355),
  [14263] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3278),
  [14265] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6644),
  [14267] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4058),
  [14269] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2537),
  [14271] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kw_then, 1, 0, 0),
  [14273] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6619),
  [14275] = {.entry = {.count = 1, .reusable = true}}, SHIFT(527),
  [14277] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1327),
  [14279] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6523),
  [14281] = {.entry = {.count = 1, .reusable = true}}, SHIFT(519),
  [14283] = {.entry = {.count = 1, .reusable = true}}, SHIFT(762),
  [14285] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5331),
  [14287] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1940),
  [14289] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6532),
  [14291] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4173),
  [14293] = {.entry = {.count = 1, .reusable = true}}, SHIFT(656),
  [14295] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2846),
  [14297] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6539),
  [14299] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2289),
  [14301] = {.entry = {.count = 1, .reusable = true}}, SHIFT(586),
  [14303] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6545),
  [14305] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3851),
  [14307] = {.entry = {.count = 1, .reusable = true}}, SHIFT(750),
  [14309] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5368),
  [14311] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3903),
  [14313] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6555),
  [14315] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4187),
  [14317] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3763),
  [14319] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3259),
  [14321] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6559),
  [14323] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5208),
  [14325] = {.entry = {.count = 1, .reusable = true}}, SHIFT(575),
  [14327] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6565),
  [14329] = {.entry = {.count = 1, .reusable = true}}, SHIFT(735),
  [14331] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5362),
  [14333] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4193),
  [14335] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6574),
  [14337] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2280),
  [14339] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2857),
  [14341] = {.entry = {.count = 1, .reusable = true}}, SHIFT(568),
  [14343] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6582),
  [14345] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4262),
  [14347] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6922),
  [14349] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1210),
  [14351] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6587),
  [14353] = {.entry = {.count = 1, .reusable = true}}, SHIFT(724),
  [14355] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5346),
  [14357] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2345),
  [14359] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6595),
  [14361] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2971),
  [14363] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2301),
  [14365] = {.entry = {.count = 1, .reusable = true}}, SHIFT(948),
  [14367] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6602),
  [14369] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1324),
  [14371] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6611),
  [14373] = {.entry = {.count = 1, .reusable = true}}, SHIFT(705),
  [14375] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5345),
  [14377] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__record_fields_block, 2, 0, 0),
  [14379] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6623),
  [14381] = {.entry = {.count = 1, .reusable = true}}, SHIFT(539),
  [14383] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5188),
  [14385] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6631),
  [14387] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2793),
  [14389] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4195),
  [14391] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6640),
  [14393] = {.entry = {.count = 1, .reusable = true}}, SHIFT(695),
  [14395] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5337),
  [14397] = {.entry = {.count = 1, .reusable = true}}, SHIFT(751),
  [14399] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6652),
  [14401] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3893),
  [14403] = {.entry = {.count = 1, .reusable = true}}, SHIFT(582),
  [14405] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3210),
  [14407] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6660),
  [14409] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6524),
  [14411] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4335),
  [14413] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6669),
  [14415] = {.entry = {.count = 1, .reusable = true}}, SHIFT(677),
  [14417] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5365),
  [14419] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1461),
  [14421] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6681),
  [14423] = {.entry = {.count = 1, .reusable = true}}, SHIFT(584),
  [14425] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4340),
  [14427] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5661),
  [14429] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6689),
  [14431] = {.entry = {.count = 1, .reusable = true}}, SHIFT(591),
  [14433] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6697),
  [14435] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6586),
  [14437] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6704),
  [14439] = {.entry = {.count = 1, .reusable = true}}, SHIFT(681),
  [14441] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5213),
  [14443] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4344),
  [14445] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6713),
  [14447] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6718),
  [14449] = {.entry = {.count = 1, .reusable = true}}, SHIFT(562),
  [14451] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1221),
  [14453] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1303),
  [14455] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6726),
  [14457] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6731),
  [14459] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1301),
  [14461] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2499),
  [14463] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6741),
  [14465] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4689),
  [14467] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6749),
  [14469] = {.entry = {.count = 1, .reusable = true}}, SHIFT(592),
  [14471] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6757),
  [14473] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1667),
  [14475] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5153),
  [14477] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4253),
  [14479] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4254),
  [14481] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4651),
  [14483] = {.entry = {.count = 1, .reusable = true}}, SHIFT(610),
  [14485] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3934),
  [14487] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2740),
  [14489] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3436),
  [14491] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1927),
  [14493] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4354),
  [14495] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3454),
  [14497] = {.entry = {.count = 1, .reusable = true}}, SHIFT(843),
  [14499] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4289),
  [14501] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4290),
  [14503] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__type_lhs, 2, 0, 0),
  [14505] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1778),
  [14507] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6970),
  [14509] = {.entry = {.count = 1, .reusable = true}}, SHIFT(532),
  [14511] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4837),
  [14513] = {.entry = {.count = 1, .reusable = true}}, SHIFT(922),
  [14515] = {.entry = {.count = 1, .reusable = true}}, SHIFT(581),
  [14517] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2755),
  [14519] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2086),
  [14521] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1508),
  [14523] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5336),
  [14525] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1539),
  [14527] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2577),
  [14529] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4336),
  [14531] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1252),
  [14533] = {.entry = {.count = 1, .reusable = true}}, SHIFT(642),
  [14535] = {.entry = {.count = 1, .reusable = true}}, SHIFT(638),
  [14537] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_kw_if, 1, 0, 0),
  [14539] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2318),
  [14541] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3909),
  [14543] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1804),
  [14545] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2137),
  [14547] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2272),
  [14549] = {.entry = {.count = 1, .reusable = true}}, REDUCE(aux_sym___block_repeat1, 2, 0, 0),
  [14551] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2294),
  [14553] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1267),
  [14555] = {.entry = {.count = 1, .reusable = true}}, SHIFT(538),
  [14557] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1270),
  [14559] = {.entry = {.count = 1, .reusable = true}}, SHIFT(541),
  [14561] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1273),
  [14563] = {.entry = {.count = 1, .reusable = true}}, SHIFT(545),
  [14565] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1277),
  [14567] = {.entry = {.count = 1, .reusable = true}}, SHIFT(546),
  [14569] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1287),
  [14571] = {.entry = {.count = 1, .reusable = true}}, SHIFT(576),
  [14573] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1291),
  [14575] = {.entry = {.count = 1, .reusable = true}}, SHIFT(580),
  [14577] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1292),
  [14579] = {.entry = {.count = 1, .reusable = true}}, SHIFT(573),
  [14581] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1290),
  [14583] = {.entry = {.count = 1, .reusable = true}}, SHIFT(518),
  [14585] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1272),
  [14587] = {.entry = {.count = 1, .reusable = true}}, SHIFT(520),
  [14589] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1268),
  [14591] = {.entry = {.count = 1, .reusable = true}}, SHIFT(522),
  [14593] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1261),
  [14595] = {.entry = {.count = 1, .reusable = true}}, SHIFT(524),
  [14597] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1257),
  [14599] = {.entry = {.count = 1, .reusable = true}}, SHIFT(529),
  [14601] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1275),
  [14603] = {.entry = {.count = 1, .reusable = true}}, SHIFT(543),
  [14605] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1262),
  [14607] = {.entry = {.count = 1, .reusable = true}}, SHIFT(554),
  [14609] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1288),
  [14611] = {.entry = {.count = 1, .reusable = true}}, SHIFT(556),
  [14613] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4287),
  [14615] = {.entry = {.count = 1, .reusable = true}}, SHIFT(531),
  [14617] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4156),
  [14619] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1907),
  [14621] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4247),
  [14623] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym_effect_pure, 1, 0, 0),
  [14625] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6672),
  [14627] = {.entry = {.count = 1, .reusable = true}}, SHIFT(934),
  [14629] = {.entry = {.count = 1, .reusable = true}}, SHIFT(6782),
  [14631] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1903),
  [14633] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4947),
  [14635] = {.entry = {.count = 1, .reusable = true}}, SHIFT(2300),
  [14637] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5087),
  [14639] = {.entry = {.count = 1, .reusable = true}}, REDUCE(sym__lhs, 1, 0, 1),
  [14641] = {.entry = {.count = 1, .reusable = true}}, SHIFT(7013),
  [14643] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5063),
  [14645] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1787),
  [14647] = {.entry = {.count = 1, .reusable = true}},  ACCEPT_INPUT(),
  [14649] = {.entry = {.count = 1, .reusable = true}}, SHIFT(5439),
  [14651] = {.entry = {.count = 1, .reusable = true}}, SHIFT(3945),
  [14653] = {.entry = {.count = 1, .reusable = true}}, SHIFT(528),
  [14655] = {.entry = {.count = 1, .reusable = true}}, SHIFT(1807),
  [14657] = {.entry = {.count = 1, .reusable = true}}, SHIFT(895),
  [14659] = {.entry = {.count = 1, .reusable = true}}, SHIFT(4693),
  [14661] = {.entry = {.count = 1, .reusable = true}}, SHIFT(557),
  [14663] = {.entry = {.count = 1, .reusable = true}}, SHIFT(558),
  [14665] = {.entry = {.count = 1, .reusable = true}}, SHIFT(559),
  [14667] = {.entry = {.count = 1, .reusable = true}}, SHIFT(560),
  [14669] = {.entry = {.count = 1, .reusable = true}}, SHIFT(577),
  [14671] = {.entry = {.count = 1, .reusable = true}}, SHIFT(578),
  [14673] = {.entry = {.count = 1, .reusable = true}}, SHIFT(588),
  [14675] = {.entry = {.count = 1, .reusable = true}}, SHIFT(597),
  [14677] = {.entry = {.count = 1, .reusable = true}}, SHIFT(599),
  [14679] = {.entry = {.count = 1, .reusable = true}}, SHIFT(600),
  [14681] = {.entry = {.count = 1, .reusable = true}}, SHIFT(601),
  [14683] = {.entry = {.count = 1, .reusable = true}}, SHIFT(603),
  [14685] = {.entry = {.count = 1, .reusable = true}}, SHIFT(606),
  [14687] = {.entry = {.count = 1, .reusable = true}}, SHIFT(609),
  [14689] = {.entry = {.count = 1, .reusable = true}}, SHIFT(611),
};

enum ts_external_scanner_symbol_identifiers {
  ts_external_token__layout_semicolon = 0,
  ts_external_token__layout_start = 1,
  ts_external_token__layout_end = 2,
  ts_external_token__dot = 3,
  ts_external_token__where = 4,
  ts_external_token__varsym = 5,
  ts_external_token_comment = 6,
  ts_external_token_fold = 7,
  ts_external_token__comma = 8,
  ts_external_token__in = 9,
  ts_external_token__indent = 10,
  ts_external_token__empty = 11,
  ts_external_token_DEPRECATED_operator = 12,
  ts_external_token__parenthesized_operator = 13,
  ts_external_token__watch_start = 14,
  ts_external_token__start_before_arrow = 15,
  ts_external_token_hash_cid = 16,
  ts_external_token_doc_block = 17,
  ts_external_token__guard_layout_start = 18,
  ts_external_token__destructuring_bind_start = 19,
  ts_external_token_DUMMY = 20,
};

static const TSSymbol ts_external_scanner_symbol_map[EXTERNAL_TOKEN_COUNT] = {
  [ts_external_token__layout_semicolon] = sym__layout_semicolon,
  [ts_external_token__layout_start] = sym__layout_start,
  [ts_external_token__layout_end] = sym__layout_end,
  [ts_external_token__dot] = sym__dot,
  [ts_external_token__where] = sym__where,
  [ts_external_token__varsym] = sym__varsym,
  [ts_external_token_comment] = sym_comment,
  [ts_external_token_fold] = sym_fold,
  [ts_external_token__comma] = sym__comma,
  [ts_external_token__in] = sym__in,
  [ts_external_token__indent] = sym__indent,
  [ts_external_token__empty] = sym__empty,
  [ts_external_token_DEPRECATED_operator] = sym_DEPRECATED_operator,
  [ts_external_token__parenthesized_operator] = sym__parenthesized_operator,
  [ts_external_token__watch_start] = sym__watch_start,
  [ts_external_token__start_before_arrow] = sym__start_before_arrow,
  [ts_external_token_hash_cid] = sym_hash_cid,
  [ts_external_token_doc_block] = sym_doc_block,
  [ts_external_token__guard_layout_start] = sym__guard_layout_start,
  [ts_external_token__destructuring_bind_start] = sym__destructuring_bind_start,
  [ts_external_token_DUMMY] = sym_DUMMY,
};

static const bool ts_external_scanner_states[38][EXTERNAL_TOKEN_COUNT] = {
  [1] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_start] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token__where] = true,
    [ts_external_token__varsym] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__comma] = true,
    [ts_external_token__in] = true,
    [ts_external_token__indent] = true,
    [ts_external_token__empty] = true,
    [ts_external_token_DEPRECATED_operator] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token__start_before_arrow] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
    [ts_external_token__guard_layout_start] = true,
    [ts_external_token__destructuring_bind_start] = true,
    [ts_external_token_DUMMY] = true,
  },
  [2] = {
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_doc_block] = true,
  },
  [3] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_doc_block] = true,
  },
  [4] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_doc_block] = true,
  },
  [5] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_doc_block] = true,
  },
  [6] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_doc_block] = true,
  },
  [7] = {
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_doc_block] = true,
  },
  [8] = {
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_doc_block] = true,
  },
  [9] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_doc_block] = true,
  },
  [10] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_doc_block] = true,
  },
  [11] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [12] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [13] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [14] = {
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [15] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [16] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [17] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [18] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [19] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [20] = {
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [21] = {
    [ts_external_token_comment] = true,
  },
  [22] = {
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
  },
  [23] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [24] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
    [ts_external_token__parenthesized_operator] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [25] = {
    [ts_external_token__layout_start] = true,
    [ts_external_token_comment] = true,
  },
  [26] = {
    [ts_external_token_comment] = true,
    [ts_external_token__guard_layout_start] = true,
  },
  [27] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
  },
  [28] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
  },
  [29] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [30] = {
    [ts_external_token_comment] = true,
    [ts_external_token_fold] = true,
    [ts_external_token__watch_start] = true,
    [ts_external_token_hash_cid] = true,
    [ts_external_token_doc_block] = true,
  },
  [31] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [32] = {
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [33] = {
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [34] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [35] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token__dot] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [36] = {
    [ts_external_token__layout_end] = true,
    [ts_external_token_comment] = true,
    [ts_external_token_hash_cid] = true,
  },
  [37] = {
    [ts_external_token__layout_semicolon] = true,
    [ts_external_token_comment] = true,
  },
};

#ifdef __cplusplus
extern "C" {
#endif
void *tree_sitter_unison_external_scanner_create(void);
void tree_sitter_unison_external_scanner_destroy(void *);
bool tree_sitter_unison_external_scanner_scan(void *, TSLexer *, const bool *);
unsigned tree_sitter_unison_external_scanner_serialize(void *, char *);
void tree_sitter_unison_external_scanner_deserialize(void *, const char *, unsigned);

#ifdef TREE_SITTER_HIDE_SYMBOLS
#define TS_PUBLIC
#elif defined(_WIN32)
#define TS_PUBLIC __declspec(dllexport)
#else
#define TS_PUBLIC __attribute__((visibility("default")))
#endif

TS_PUBLIC const TSLanguage *tree_sitter_unison(void) {
  static const TSLanguage language = {
    .version = LANGUAGE_VERSION,
    .symbol_count = SYMBOL_COUNT,
    .alias_count = ALIAS_COUNT,
    .token_count = TOKEN_COUNT,
    .external_token_count = EXTERNAL_TOKEN_COUNT,
    .state_count = STATE_COUNT,
    .large_state_count = LARGE_STATE_COUNT,
    .production_id_count = PRODUCTION_ID_COUNT,
    .field_count = FIELD_COUNT,
    .max_alias_sequence_length = MAX_ALIAS_SEQUENCE_LENGTH,
    .parse_table = &ts_parse_table[0][0],
    .small_parse_table = ts_small_parse_table,
    .small_parse_table_map = ts_small_parse_table_map,
    .parse_actions = ts_parse_actions,
    .symbol_names = ts_symbol_names,
    .field_names = ts_field_names,
    .field_map_slices = ts_field_map_slices,
    .field_map_entries = ts_field_map_entries,
    .symbol_metadata = ts_symbol_metadata,
    .public_symbol_map = ts_symbol_map,
    .alias_map = ts_non_terminal_alias_map,
    .alias_sequences = &ts_alias_sequences[0][0],
    .lex_modes = ts_lex_modes,
    .lex_fn = ts_lex,
    .external_scanner = {
      &ts_external_scanner_states[0][0],
      ts_external_scanner_symbol_map,
      tree_sitter_unison_external_scanner_create,
      tree_sitter_unison_external_scanner_destroy,
      tree_sitter_unison_external_scanner_scan,
      tree_sitter_unison_external_scanner_serialize,
      tree_sitter_unison_external_scanner_deserialize,
    },
    .primary_state_ids = ts_primary_state_ids,
  };
  return &language;
}
#ifdef __cplusplus
}
#endif
